/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/arrays","vs/base/common/strings","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/arraysFind","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/assert","vs/base/common/map","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/codiconsUtil","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],se=function(O){for(var t=[],i=0,F=O.length;i<F;i++)t[i]=ie[O[i]];return t};const ze=this,Ge=typeof global=="object"?global:{};var ge;(function(O){O.global=ze;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof O.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}O.Environment=t})(ge||(ge={}));var ge;(function(O){class t{constructor(f,j,h){this.type=f,this.detail=j,this.timestamp=h}}O.LoaderEvent=t;class i{constructor(f){this._events=[new t(1,"",f)]}record(f,j){this._events.push(new t(f,j,O.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}O.LoaderEventRecorder=i;class F{record(f,j){}getEvents(){return[]}}F.INSTANCE=new F,O.NullLoaderEventRecorder=F})(ge||(ge={}));var ge;(function(O){class t{static fileUriToFilePath(F,y){if(y=decodeURI(y).replace(/%23/g,"#"),F){if(/^file:\/\/\//.test(y))return y.substr(8);if(/^file:\/\//.test(y))return y.substr(5)}else if(/^file:\/\//.test(y))return y.substr(7);return y}static startsWith(F,y){return F.length>=y.length&&F.substr(0,y.length)===y}static endsWith(F,y){return F.length>=y.length&&F.substr(F.length-y.length)===y}static containsQueryString(F){return/^[^\#]*\?/gi.test(F)}static isAbsolutePath(F){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(F)}static forEachProperty(F,y){if(F){let f;for(f in F)F.hasOwnProperty(f)&&y(f,F[f])}}static isEmpty(F){let y=!0;return t.forEachProperty(F,()=>{y=!1}),y}static recursiveClone(F){if(!F||typeof F!="object"||F instanceof RegExp||!Array.isArray(F)&&Object.getPrototypeOf(F)!==Object.prototype)return F;let y=Array.isArray(F)?[]:{};return t.forEachProperty(F,(f,j)=>{j&&typeof j=="object"?y[f]=t.recursiveClone(j):y[f]=j}),y}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(F){return t.startsWith(F,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=O.global.performance&&typeof O.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?O.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,O.Utilities=t})(ge||(ge={}));var ge;(function(O){function t(y){if(y instanceof Error)return y;const f=new Error(y.message||String(y)||"Unknown Error");return y.stack&&(f.stack=y.stack),f}O.ensureError=t;class i{static validateConfigurationOptions(f){function j(h){if(h.phase==="loading"){console.error('Loading "'+h.moduleId+'" failed'),console.error(h),console.error("Here are the modules that depend on it:"),console.error(h.neededBy);return}if(h.phase==="factory"){console.error('The factory function of "'+h.moduleId+'" has thrown an exception'),console.error(h),console.error("Here are the modules that depend on it:"),console.error(h.neededBy);return}}if(f=f||{},typeof f.baseUrl!="string"&&(f.baseUrl=""),typeof f.isBuild!="boolean"&&(f.isBuild=!1),typeof f.paths!="object"&&(f.paths={}),typeof f.config!="object"&&(f.config={}),typeof f.catchError>"u"&&(f.catchError=!1),typeof f.recordStats>"u"&&(f.recordStats=!1),typeof f.urlArgs!="string"&&(f.urlArgs=""),typeof f.onError!="function"&&(f.onError=j),Array.isArray(f.ignoreDuplicateModules)||(f.ignoreDuplicateModules=[]),f.baseUrl.length>0&&(O.Utilities.endsWith(f.baseUrl,"/")||(f.baseUrl+="/")),typeof f.cspNonce!="string"&&(f.cspNonce=""),typeof f.preferScriptTags>"u"&&(f.preferScriptTags=!1),f.nodeCachedData&&typeof f.nodeCachedData=="object"&&(typeof f.nodeCachedData.seed!="string"&&(f.nodeCachedData.seed="seed"),(typeof f.nodeCachedData.writeDelay!="number"||f.nodeCachedData.writeDelay<0)&&(f.nodeCachedData.writeDelay=1e3*7),!f.nodeCachedData.path||typeof f.nodeCachedData.path!="string")){const h=t(new Error("INVALID cached data configuration, 'path' MUST be set"));h.phase="configuration",f.onError(h),f.nodeCachedData=void 0}return f}static mergeConfigurationOptions(f=null,j=null){let h=O.Utilities.recursiveClone(j||{});return O.Utilities.forEachProperty(f,(o,s)=>{o==="ignoreDuplicateModules"&&typeof h.ignoreDuplicateModules<"u"?h.ignoreDuplicateModules=h.ignoreDuplicateModules.concat(s):o==="paths"&&typeof h.paths<"u"?O.Utilities.forEachProperty(s,(c,p)=>h.paths[c]=p):o==="config"&&typeof h.config<"u"?O.Utilities.forEachProperty(s,(c,p)=>h.config[c]=p):h[o]=O.Utilities.recursiveClone(s)}),i.validateConfigurationOptions(h)}}O.ConfigurationOptionsUtil=i;class F{constructor(f,j){if(this._env=f,this.options=i.mergeConfigurationOptions(j),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let h=this.options.nodeRequire.main.filename,o=Math.max(h.lastIndexOf("/"),h.lastIndexOf("\\"));this.options.baseUrl=h.substring(0,o+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let f=0;f<this.options.ignoreDuplicateModules.length;f++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[f]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],O.Utilities.forEachProperty(this.options.paths,(f,j)=>{Array.isArray(j)?this.sortedPathsRules.push({from:f,to:j}):this.sortedPathsRules.push({from:f,to:[j]})}),this.sortedPathsRules.sort((f,j)=>j.from.length-f.from.length)}cloneAndMerge(f){return new F(this._env,i.mergeConfigurationOptions(f,this.options))}getOptionsLiteral(){return this.options}_applyPaths(f){let j;for(let h=0,o=this.sortedPathsRules.length;h<o;h++)if(j=this.sortedPathsRules[h],O.Utilities.startsWith(f,j.from)){let s=[];for(let c=0,p=j.to.length;c<p;c++)s.push(j.to[c]+f.substr(j.from.length));return s}return[f]}_addUrlArgsToUrl(f){return O.Utilities.containsQueryString(f)?f+"&"+this.options.urlArgs:f+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(f){return this.options.urlArgs?this._addUrlArgsToUrl(f):f}_addUrlArgsIfNecessaryToUrls(f){if(this.options.urlArgs)for(let j=0,h=f.length;j<h;j++)f[j]=this._addUrlArgsToUrl(f[j]);return f}moduleIdToPaths(f){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(f))return this.isBuild()?["empty:"]:["node|"+f];let j=f,h;if(!O.Utilities.endsWith(j,".js")&&!O.Utilities.isAbsolutePath(j)){h=this._applyPaths(j);for(let o=0,s=h.length;o<s;o++)this.isBuild()&&h[o]==="empty:"||(O.Utilities.isAbsolutePath(h[o])||(h[o]=this.options.baseUrl+h[o]),!O.Utilities.endsWith(h[o],".js")&&!O.Utilities.containsQueryString(h[o])&&(h[o]=h[o]+".js"))}else!O.Utilities.endsWith(j,".js")&&!O.Utilities.containsQueryString(j)&&(j=j+".js"),h=[j];return this._addUrlArgsIfNecessaryToUrls(h)}requireToUrl(f){let j=f;return O.Utilities.isAbsolutePath(j)||(j=this._applyPaths(j)[0],O.Utilities.isAbsolutePath(j)||(j=this.options.baseUrl+j)),this._addUrlArgsIfNecessaryToUrl(j)}isBuild(){return this.options.isBuild}shouldInvokeFactory(f){return!!(!this.options.isBuild||O.Utilities.isAnonymousModule(f)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[f])}isDuplicateMessageIgnoredFor(f){return this.ignoreDuplicateModulesMap.hasOwnProperty(f)}getConfigForModule(f){if(this.options.config)return this.options.config[f]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(f){this.options.onError(f)}}O.Configuration=F})(ge||(ge={}));var ge;(function(O){class t{constructor(s){this._env=s,this._scriptLoader=null,this._callbackMap={}}load(s,c,p,g){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new y;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=s.getConfig().getOptionsLiteral();e?this._scriptLoader=new i:this._scriptLoader=new f(this._env)}else this._env.isNode?this._scriptLoader=new f(this._env):this._scriptLoader=new i;let m={callback:p,errorback:g};if(this._callbackMap.hasOwnProperty(c)){this._callbackMap[c].push(m);return}this._callbackMap[c]=[m],this._scriptLoader.load(s,c,()=>this.triggerCallback(c),e=>this.triggerErrorback(c,e))}triggerCallback(s){let c=this._callbackMap[s];delete this._callbackMap[s];for(let p=0;p<c.length;p++)c[p].callback()}triggerErrorback(s,c){let p=this._callbackMap[s];delete this._callbackMap[s];for(let g=0;g<p.length;g++)p[g].errorback(c)}}class i{attachListeners(s,c,p){let g=()=>{s.removeEventListener("load",m),s.removeEventListener("error",e)},m=v=>{g(),c()},e=v=>{g(),p(v)};s.addEventListener("load",m),s.addEventListener("error",e)}load(s,c,p,g){if(/^node\|/.test(c)){let m=s.getConfig().getOptionsLiteral(),e=j(s.getRecorder(),m.nodeRequire||O.global.nodeRequire),v=c.split("|"),E=null;try{E=e(v[1])}catch(L){g(L);return}s.enqueueDefineAnonymousModule([],()=>E),p()}else{let m=document.createElement("script");m.setAttribute("async","async"),m.setAttribute("type","text/javascript"),this.attachListeners(m,p,g);const{trustedTypesPolicy:e}=s.getConfig().getOptionsLiteral();e&&(c=e.createScriptURL(c)),m.setAttribute("src",c);const{cspNonce:v}=s.getConfig().getOptionsLiteral();v&&m.setAttribute("nonce",v),document.getElementsByTagName("head")[0].appendChild(m)}}}function F(o){const{trustedTypesPolicy:s}=o.getConfig().getOptionsLiteral();try{return(s?self.eval(s.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class y{constructor(){this._cachedCanUseEval=null}_canUseEval(s){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=F(s)),this._cachedCanUseEval}load(s,c,p,g){if(/^node\|/.test(c)){const m=s.getConfig().getOptionsLiteral(),e=j(s.getRecorder(),m.nodeRequire||O.global.nodeRequire),v=c.split("|");let E=null;try{E=e(v[1])}catch(L){g(L);return}s.enqueueDefineAnonymousModule([],function(){return E}),p()}else{const{trustedTypesPolicy:m}=s.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(c)&&c.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(s)){fetch(c).then(v=>{if(v.status!==200)throw new Error(v.statusText);return v.text()}).then(v=>{v=`${v}
//# sourceURL=${c}`,(m?self.eval(m.createScript("",v)):new Function(v)).call(self),p()}).then(void 0,g);return}try{m&&(c=m.createScriptURL(c)),importScripts(c),p()}catch(v){g(v)}}}}class f{constructor(s){this._env=s,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(s){this._didInitialize||(this._didInitialize=!0,this._fs=s("fs"),this._vm=s("vm"),this._path=s("path"),this._crypto=s("crypto"))}_initNodeRequire(s,c){const{nodeCachedData:p}=c.getConfig().getOptionsLiteral();if(!p||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const g=this,m=s("module");function e(v){const E=v.constructor;let L=function(b){try{return v.require(b)}finally{}};return L.resolve=function(b,a){return E._resolveFilename(b,v,!1,a)},L.resolve.paths=function(b){return E._resolveLookupPaths(b,v)},L.main=process.mainModule,L.extensions=E._extensions,L.cache=E._cache,L}m.prototype._compile=function(v,E){const L=m.wrap(v.replace(/^#!.*/,"")),$=c.getRecorder(),b=g._getCachedDataPath(p,E),a={filename:E};let l;try{const C=g._fs.readFileSync(b);l=C.slice(0,16),a.cachedData=C.slice(16),$.record(60,b)}catch{$.record(61,b)}const r=new g._vm.Script(L,a),u=r.runInThisContext(a),N=g._path.dirname(E),d=e(this),w=[this.exports,d,this,E,N,process,Ge,Buffer],A=u.apply(this.exports,w);return g._handleCachedData(r,L,b,!a.cachedData,c),g._verifyCachedData(r,L,b,l,c),A}}load(s,c,p,g){const m=s.getConfig().getOptionsLiteral(),e=j(s.getRecorder(),m.nodeRequire||O.global.nodeRequire),v=m.nodeInstrumenter||function(L){return L};this._init(e),this._initNodeRequire(e,s);let E=s.getRecorder();if(/^node\|/.test(c)){let L=c.split("|"),$=null;try{$=e(L[1])}catch(b){g(b);return}s.enqueueDefineAnonymousModule([],()=>$),p()}else{c=O.Utilities.fileUriToFilePath(this._env.isWindows,c);const L=this._path.normalize(c),$=this._getElectronRendererScriptPathOrUri(L),b=!!m.nodeCachedData,a=b?this._getCachedDataPath(m.nodeCachedData,c):void 0;this._readSourceAndCachedData(L,a,E,(l,r,u,N)=>{if(l){g(l);return}let d;r.charCodeAt(0)===f._BOM?d=f._PREFIX+r.substring(1)+f._SUFFIX:d=f._PREFIX+r+f._SUFFIX,d=v(d,L);const w={filename:$,cachedData:u},A=this._createAndEvalScript(s,d,w,p,g);this._handleCachedData(A,d,a,b&&!u,s),this._verifyCachedData(A,d,a,N,s)})}}_createAndEvalScript(s,c,p,g,m){const e=s.getRecorder();e.record(31,p.filename);const v=new this._vm.Script(c,p),E=v.runInThisContext(p),L=s.getGlobalAMDDefineFunc();let $=!1;const b=function(){return $=!0,L.apply(null,arguments)};return b.amd=L.amd,E.call(O.global,s.getGlobalAMDRequireFunc(),b,p.filename,this._path.dirname(p.filename)),e.record(32,p.filename),$?g():m(new Error(`Didn't receive define call in ${p.filename}!`)),v}_getElectronRendererScriptPathOrUri(s){if(!this._env.isElectronRenderer)return s;let c=s.match(/^([a-z])\:(.*)/i);return c?`file:///${(c[1].toUpperCase()+":"+c[2]).replace(/\\/g,"/")}`:`file://${s}`}_getCachedDataPath(s,c){const p=this._crypto.createHash("md5").update(c,"utf8").update(s.seed,"utf8").update(process.arch,"").digest("hex"),g=this._path.basename(c).replace(/\.js$/,"");return this._path.join(s.path,`${g}-${p}.code`)}_handleCachedData(s,c,p,g,m){s.cachedDataRejected?this._fs.unlink(p,e=>{m.getRecorder().record(62,p),this._createAndWriteCachedData(s,c,p,m),e&&m.getConfig().onError(e)}):g&&this._createAndWriteCachedData(s,c,p,m)}_createAndWriteCachedData(s,c,p,g){let m=Math.ceil(g.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,v=0,E;const L=()=>{setTimeout(()=>{E||(E=this._crypto.createHash("md5").update(c,"utf8").digest());const $=s.createCachedData();if(!($.length===0||$.length===e||v>=5)){if($.length<e){L();return}e=$.length,this._fs.writeFile(p,Buffer.concat([E,$]),b=>{b&&g.getConfig().onError(b),g.getRecorder().record(63,p),L()})}},m*Math.pow(4,v++))};L()}_readSourceAndCachedData(s,c,p,g){if(!c)this._fs.readFile(s,{encoding:"utf8"},g);else{let m,e,v,E=2;const L=$=>{$?g($):--E===0&&g(void 0,m,e,v)};this._fs.readFile(s,{encoding:"utf8"},($,b)=>{m=b,L($)}),this._fs.readFile(c,($,b)=>{!$&&b&&b.length>0?(v=b.slice(0,16),e=b.slice(16),p.record(60,c)):p.record(61,c),L()})}}_verifyCachedData(s,c,p,g,m){g&&(s.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(c,"utf8").digest();g.equals(e)||(m.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${p}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(p,v=>{v&&m.getConfig().onError(v)}))},Math.ceil(5e3*(1+Math.random()))))}}f._BOM=65279,f._PREFIX="(function (require, define, __filename, __dirname) { ",f._SUFFIX=`
});`;function j(o,s){if(s.__$__isRecorded)return s;const c=function(g){o.record(33,g);try{return s(g)}finally{o.record(34,g)}};return c.__$__isRecorded=!0,c}O.ensureRecordedNodeRequire=j;function h(o){return new t(o)}O.createScriptLoader=h})(ge||(ge={}));var ge;(function(O){class t{constructor(o){let s=o.lastIndexOf("/");s!==-1?this.fromModulePath=o.substr(0,s+1):this.fromModulePath=""}static _normalizeModuleId(o){let s=o,c;for(c=/\/\.\//;c.test(s);)s=s.replace(c,"/");for(s=s.replace(/^\.\//g,""),c=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;c.test(s);)s=s.replace(c,"/");return s=s.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),s}resolveModule(o){let s=o;return O.Utilities.isAbsolutePath(s)||(O.Utilities.startsWith(s,"./")||O.Utilities.startsWith(s,"../"))&&(s=t._normalizeModuleId(this.fromModulePath+s)),s}}t.ROOT=new t(""),O.ModuleIdResolver=t;class i{constructor(o,s,c,p,g,m){this.id=o,this.strId=s,this.dependencies=c,this._callback=p,this._errorback=g,this.moduleIdResolver=m,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(o,s){try{return{returnedValue:o.apply(O.global,s),producedError:null}}catch(c){return{returnedValue:null,producedError:c}}}static _invokeFactory(o,s,c,p){return o.shouldInvokeFactory(s)?o.shouldCatchError()?this._safeInvokeFunction(c,p):{returnedValue:c.apply(O.global,p),producedError:null}:{returnedValue:null,producedError:null}}complete(o,s,c,p){this._isComplete=!0;let g=null;if(this._callback)if(typeof this._callback=="function"){o.record(21,this.strId);let m=i._invokeFactory(s,this.strId,this._callback,c);g=m.producedError,o.record(22,this.strId),!g&&typeof m.returnedValue<"u"&&(!this.exportsPassedIn||O.Utilities.isEmpty(this.exports))&&(this.exports=m.returnedValue)}else this.exports=this._callback;if(g){let m=O.ensureError(g);m.phase="factory",m.moduleId=this.strId,m.neededBy=p(this.id),this.error=m,s.onError(m)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(o){return this._isComplete=!0,this.error=o,this._errorback?(this._errorback(o),!0):!1}isComplete(){return this._isComplete}}O.Module=i;class F{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(o){let s=this._strModuleIdToIntModuleId.get(o);return typeof s>"u"&&(s=this._nextId++,this._strModuleIdToIntModuleId.set(o,s),this._intModuleIdToStrModuleId[s]=o),s}getStrModuleId(o){return this._intModuleIdToStrModuleId[o]}}class y{constructor(o){this.id=o}}y.EXPORTS=new y(0),y.MODULE=new y(1),y.REQUIRE=new y(2),O.RegularDependency=y;class f{constructor(o,s,c){this.id=o,this.pluginId=s,this.pluginParam=c}}O.PluginDependency=f;class j{constructor(o,s,c,p,g=0){this._env=o,this._scriptLoader=s,this._loaderAvailableTimestamp=g,this._defineFunc=c,this._requireFunc=p,this._moduleIdProvider=new F,this._config=new O.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new j(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(o,s){let c=m=>m.replace(/\\/g,"/"),p=c(o),g=s.split(/\n/);for(let m=0;m<g.length;m++){let e=g[m].match(/(.*):(\d+):(\d+)\)?$/);if(e){let v=e[1],E=e[2],L=e[3],$=Math.max(v.lastIndexOf(" ")+1,v.lastIndexOf("(")+1);if(v=v.substr($),v=c(v),v===p){let b={line:parseInt(E,10),col:parseInt(L,10)};return b.line===1&&(b.col-=53),b}}}throw new Error("Could not correlate define call site for needle "+o)}getBuildInfo(){if(!this._config.isBuild())return null;let o=[],s=0;for(let c=0,p=this._modules2.length;c<p;c++){let g=this._modules2[c];if(!g)continue;let m=this._buildInfoPath[g.id]||null,e=this._buildInfoDefineStack[g.id]||null,v=this._buildInfoDependencies[g.id];o[s++]={id:g.strId,path:m,defineLocation:m&&e?j._findRelevantLocationInStack(m,e):null,dependencies:v,shim:null,exports:g.exports}}return o}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new O.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=O.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(o,s){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let c=null;this._config.isBuild()&&(c=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:c,dependencies:o,callback:s}}defineModule(o,s,c,p,g,m=new t(o)){let e=this._moduleIdProvider.getModuleId(o);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(o)||console.warn("Duplicate definition of module '"+o+"'");return}let v=new i(e,o,this._normalizeDependencies(s,m),c,p,m);this._modules2[e]=v,this._config.isBuild()&&(this._buildInfoDefineStack[e]=g,this._buildInfoDependencies[e]=(v.dependencies||[]).map(E=>this._moduleIdProvider.getStrModuleId(E.id))),this._resolve(v)}_normalizeDependency(o,s){if(o==="exports")return y.EXPORTS;if(o==="module")return y.MODULE;if(o==="require")return y.REQUIRE;let c=o.indexOf("!");if(c>=0){let p=s.resolveModule(o.substr(0,c)),g=s.resolveModule(o.substr(c+1)),m=this._moduleIdProvider.getModuleId(p+"!"+g),e=this._moduleIdProvider.getModuleId(p);return new f(m,e,g)}return new y(this._moduleIdProvider.getModuleId(s.resolveModule(o)))}_normalizeDependencies(o,s){let c=[],p=0;for(let g=0,m=o.length;g<m;g++)c[p++]=this._normalizeDependency(o[g],s);return c}_relativeRequire(o,s,c,p){if(typeof s=="string")return this.synchronousRequire(s,o);this.defineModule(O.Utilities.generateAnonymousModule(),s,c,p,null,o)}synchronousRequire(o,s=new t(o)){let c=this._normalizeDependency(o,s),p=this._modules2[c.id];if(!p)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This is the first mention of this module!");if(!p.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+o+"'. This module has not been resolved completely yet.");if(p.error)throw p.error;return p.exports}configure(o,s){let c=this._config.shouldRecordStats();s?this._config=new O.Configuration(this._env,o):this._config=this._config.cloneAndMerge(o),this._config.shouldRecordStats()&&!c&&(this._recorder=null)}getConfig(){return this._config}_onLoad(o){if(this._currentAnonymousDefineCall!==null){let s=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(o),s.dependencies,s.callback,null,s.stack)}}_createLoadError(o,s){let c=this._moduleIdProvider.getStrModuleId(o),p=(this._inverseDependencies2[o]||[]).map(m=>this._moduleIdProvider.getStrModuleId(m));const g=O.ensureError(s);return g.phase="loading",g.moduleId=c,g.neededBy=p,g}_onLoadError(o,s){const c=this._createLoadError(o,s);this._modules2[o]||(this._modules2[o]=new i(o,this._moduleIdProvider.getStrModuleId(o),[],()=>{},null,null));let p=[];for(let e=0,v=this._moduleIdProvider.getMaxModuleId();e<v;e++)p[e]=!1;let g=!1,m=[];for(m.push(o),p[o]=!0;m.length>0;){let e=m.shift(),v=this._modules2[e];v&&(g=v.onDependencyError(c)||g);let E=this._inverseDependencies2[e];if(E)for(let L=0,$=E.length;L<$;L++){let b=E[L];p[b]||(m.push(b),p[b]=!0)}}g||this._config.onError(c)}_hasDependencyPath(o,s){let c=this._modules2[o];if(!c)return!1;let p=[];for(let m=0,e=this._moduleIdProvider.getMaxModuleId();m<e;m++)p[m]=!1;let g=[];for(g.push(c),p[o]=!0;g.length>0;){let e=g.shift().dependencies;if(e)for(let v=0,E=e.length;v<E;v++){let L=e[v];if(L.id===s)return!0;let $=this._modules2[L.id];$&&!p[L.id]&&(p[L.id]=!0,g.push($))}}return!1}_findCyclePath(o,s,c){if(o===s||c===50)return[o];let p=this._modules2[o];if(!p)return null;let g=p.dependencies;if(g)for(let m=0,e=g.length;m<e;m++){let v=this._findCyclePath(g[m].id,s,c+1);if(v!==null)return v.push(o),v}return null}_createRequire(o){let s=(c,p,g)=>this._relativeRequire(o,c,p,g);return s.toUrl=c=>this._config.requireToUrl(o.resolveModule(c)),s.getStats=()=>this.getLoaderEvents(),s.hasDependencyCycle=()=>this._hasDependencyCycle,s.config=(c,p=!1)=>{this.configure(c,p)},s.__$__nodeRequire=O.global.nodeRequire,s}_loadModule(o){if(this._modules2[o]||this._knownModules2[o])return;this._knownModules2[o]=!0;let s=this._moduleIdProvider.getStrModuleId(o),c=this._config.moduleIdToPaths(s),p=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(s.indexOf("/")===-1||p.test(s))&&c.push("node|"+s);let g=-1,m=e=>{if(g++,g>=c.length)this._onLoadError(o,e);else{let v=c[g],E=this.getRecorder();if(this._config.isBuild()&&v==="empty:"){this._buildInfoPath[o]=v,this.defineModule(this._moduleIdProvider.getStrModuleId(o),[],null,null,null),this._onLoad(o);return}E.record(10,v),this._scriptLoader.load(this,v,()=>{this._config.isBuild()&&(this._buildInfoPath[o]=v),E.record(11,v),this._onLoad(o)},L=>{E.record(12,v),m(L)})}};m(null)}_loadPluginDependency(o,s){if(this._modules2[s.id]||this._knownModules2[s.id])return;this._knownModules2[s.id]=!0;let c=p=>{this.defineModule(this._moduleIdProvider.getStrModuleId(s.id),[],p,null,null)};c.error=p=>{this._config.onError(this._createLoadError(s.id,p))},o.load(s.pluginParam,this._createRequire(t.ROOT),c,this._config.getOptionsLiteral())}_resolve(o){let s=o.dependencies;if(s)for(let c=0,p=s.length;c<p;c++){let g=s[c];if(g===y.EXPORTS){o.exportsPassedIn=!0,o.unresolvedDependenciesCount--;continue}if(g===y.MODULE){o.unresolvedDependenciesCount--;continue}if(g===y.REQUIRE){o.unresolvedDependenciesCount--;continue}let m=this._modules2[g.id];if(m&&m.isComplete()){if(m.error){o.onDependencyError(m.error);return}o.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(g.id,o.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(g.id)+"' and '"+this._moduleIdProvider.getStrModuleId(o.id)+"'. The cyclic path follows:");let e=this._findCyclePath(g.id,o.id,0)||[];e.reverse(),e.push(g.id),console.warn(e.map(v=>this._moduleIdProvider.getStrModuleId(v)).join(` => 
`)),o.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[g.id]=this._inverseDependencies2[g.id]||[],this._inverseDependencies2[g.id].push(o.id),g instanceof f){let e=this._modules2[g.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,g);continue}let v=this._inversePluginDependencies2.get(g.pluginId);v||(v=[],this._inversePluginDependencies2.set(g.pluginId,v)),v.push(g),this._loadModule(g.pluginId);continue}this._loadModule(g.id)}o.unresolvedDependenciesCount===0&&this._onModuleComplete(o)}_onModuleComplete(o){let s=this.getRecorder();if(o.isComplete())return;let c=o.dependencies,p=[];if(c)for(let v=0,E=c.length;v<E;v++){let L=c[v];if(L===y.EXPORTS){p[v]=o.exports;continue}if(L===y.MODULE){p[v]={id:o.strId,config:()=>this._config.getConfigForModule(o.strId)};continue}if(L===y.REQUIRE){p[v]=this._createRequire(o.moduleIdResolver);continue}let $=this._modules2[L.id];if($){p[v]=$.exports;continue}p[v]=null}const g=v=>(this._inverseDependencies2[v]||[]).map(E=>this._moduleIdProvider.getStrModuleId(E));o.complete(s,this._config,p,g);let m=this._inverseDependencies2[o.id];if(this._inverseDependencies2[o.id]=null,m)for(let v=0,E=m.length;v<E;v++){let L=m[v],$=this._modules2[L];$.unresolvedDependenciesCount--,$.unresolvedDependenciesCount===0&&this._onModuleComplete($)}let e=this._inversePluginDependencies2.get(o.id);if(e){this._inversePluginDependencies2.delete(o.id);for(let v=0,E=e.length;v<E;v++)this._loadPluginDependency(o.exports,e[v])}}}O.ModuleManager=j})(ge||(ge={}));var re,ge;(function(O){const t=new O.Environment;let i=null;const F=function(h,o,s){typeof h!="string"&&(s=o,o=h,h=null),(typeof o!="object"||!Array.isArray(o))&&(s=o,o=null),o||(o=["require","exports","module"]),h?i.defineModule(h,o,s,null,null):i.enqueueDefineAnonymousModule(o,s)};F.amd={jQuery:!0};const y=function(h,o=!1){i.configure(h,o)},f=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){y(arguments[0]);return}if(typeof arguments[0]=="string")return i.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){i.defineModule(O.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};f.config=y,f.getConfig=function(){return i.getConfig().getOptionsLiteral()},f.reset=function(){i=i.reset()},f.getBuildInfo=function(){return i.getBuildInfo()},f.getStats=function(){return i.getLoaderEvents()},f.define=F;function j(){if(typeof O.global.require<"u"||typeof require<"u"){const h=O.global.require||require;if(typeof h=="function"&&typeof h.resolve=="function"){const o=O.ensureRecordedNodeRequire(i.getRecorder(),h);O.global.nodeRequire=o,f.nodeRequire=o,f.__$__nodeRequire=o}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=f:(t.isElectronRenderer||(O.global.define=F),O.global.require=f)}O.init=j,(typeof O.global.define!="function"||!O.global.define.amd)&&(i=new O.ModuleManager(t,O.createScriptLoader(t),F,f,O.Utilities.getHighPerformanceTimestamp()),typeof O.global.require<"u"&&typeof O.global.require!="function"&&f.config(O.global.require),re=function(){return F.apply(null,arguments)},re.amd=F.amd,typeof doNotInitLoader>"u"&&j())})(ge||(ge={})),re(ie[71],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=i;function i(h,o,s,c){if(c=c||{},(c["vs/css"]||{}).disabled){s({});return}const g=o.toUrl(h+".css");F(h,g,()=>{s({})},m=>{typeof s.error=="function"&&s.error("Could not find "+g+".")})}function F(h,o,s,c){if(y(h,o)){s();return}f(h,o,s,c)}function y(h,o){const s=window.document.getElementsByTagName("link");for(let c=0,p=s.length;c<p;c++){const g=s[c].getAttribute("data-name"),m=s[c].getAttribute("href");if(g===h||m===o)return!0}return!1}function f(h,o,s,c){const p=document.createElement("link");p.setAttribute("rel","stylesheet"),p.setAttribute("type","text/css"),p.setAttribute("data-name",h),j(h,p,s,c),p.setAttribute("href",o),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild(p)}function j(h,o,s,c){const p=()=>{o.removeEventListener("load",g),o.removeEventListener("error",m)},g=e=>{p(),s()},m=e=>{p(),c(e)};o.addEventListener("load",g),o.addEventListener("error",m)}}),re("vs/nls",["require","exports"],function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localize=c,t.localize2=p,t.getConfiguredDefaultLocale=g,t.setPseudoTranslation=m,t.create=e,t.load=v;let i=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const F="i-default";function y(E,L){let $;return L.length===0?$=E:$=E.replace(/\{(\d+)\}/g,(b,a)=>{const l=a[0],r=L[l];let u=b;return typeof r=="string"?u=r:(typeof r=="number"||typeof r=="boolean"||r===void 0||r===null)&&(u=String(r)),u}),i&&($="\uFF3B"+$.replace(/[aouei]/g,"$&$&")+"\uFF3D"),$}function f(E,L){let $=E[L];return $||($=E["*"],$)?$:null}function j(E){return E.charAt(E.length-1)==="/"?E:E+"/"}async function h(E,L,$){const b=j(E)+j(L)+"vscode/"+j($),a=await fetch(b);if(a.ok)return await a.json();throw new Error(`${a.status} - ${a.statusText}`)}function o(E){return function(L,$){const b=Array.prototype.slice.call(arguments,2);return y(E[L],b)}}function s(E){return(L,$,...b)=>({value:y(E[L],b),original:y($,b)})}function c(E,L,...$){return y(L,$)}function p(E,L,...$){const b=y(L,$);return{value:b,original:b}}function g(E){}function m(E){i=E}function e(E,L){return{localize:o(L[E]),localize2:s(L[E]),getConfiguredDefaultLocale:L.getConfiguredDefaultLocale??($=>{})}}function v(E,L,$,b){const a=b["vs/nls"]??{};if(!E||E.length===0)return $({localize:c,localize2:p,getConfiguredDefaultLocale:()=>a.availableLanguages?.["*"]});const l=a.availableLanguages?f(a.availableLanguages,E):null,r=l===null||l===F;let u=".nls";r||(u=u+"."+l);const N=d=>{Array.isArray(d)?(d.localize=o(d),d.localize2=s(d)):(d.localize=o(d[E]),d.localize2=s(d[E])),d.getConfiguredDefaultLocale=()=>a.availableLanguages?.["*"],$(d)};typeof a.loadBundle=="function"?a.loadBundle(E,l,(d,w)=>{d?L([E+".nls"],N):N(w)}):a.translationServiceUrl&&!r?(async()=>{try{const d=await h(a.translationServiceUrl,l,E);return N(d)}catch(d){if(!l.includes("-"))return console.error(d),L([E+".nls"],N);try{const w=l.split("-")[0],A=await h(a.translationServiceUrl,w,E);return a.availableLanguages??={},a.availableLanguages["*"]=w,N(A)}catch(w){return console.error(w),L([E+".nls"],N)}}})():L([E+u],N,d=>{if(u===".nls"){console.error("Failed trying to load default language strings",d);return}console.error(`Failed to load message bundle for language ${l}. Falling back to the default language:`,d),L([E+".nls"],N)})}}),function(){const O=globalThis.MonacoEnvironment,t=O&&O.baseUrl?O.baseUrl:"../../../";function i(c,p){if(O?.createTrustedTypesPolicy)try{return O.createTrustedTypesPolicy(c,p)}catch(g){console.warn(g);return}try{return self.trustedTypes?.createPolicy(c,p)}catch(g){console.warn(g);return}}const F=i("amdLoader",{createScriptURL:c=>c,createScript:(c,...p)=>{const g=p.slice(0,-1).join(","),m=p.pop().toString();return`(function anonymous(${g}) { ${m}
})`}});function y(){try{return(F?globalThis.eval(F.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function f(){return new Promise((c,p)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return c();const g=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(g)&&g.substring(0,globalThis.origin.length)!==globalThis.origin)&&y()){fetch(g).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${g}`,(F?globalThis.eval(F.createScript("",e)):new Function(e)).call(globalThis),c()}).then(void 0,p);return}F?importScripts(F.createScriptURL(g)):importScripts(g),c()})}function j(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:F,amdModulesPattern:/^vs\//})}function h(c){f().then(()=>{j(),require([c],function(p){setTimeout(function(){const g=p.create((m,e)=>{globalThis.postMessage(m,e)},null);for(globalThis.onmessage=m=>g.onmessage(m.data,m.ports);s.length>0;){const m=s.shift();g.onmessage(m.data,m.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&j();let o=!0;const s=[];globalThis.onmessage=c=>{if(!o){s.push(c);return}o=!1,h(c.data)}}(),re(ie[9],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mb=void 0,t.$fb=i,t.$gb=F,t.$hb=y,t.$ib=f,t.$jb=j,t.$kb=h,t.$lb=o,t.$nb=c,t.$ob=p,t.$pb=g,t.$qb=m,t.$rb=e;function i(v,E,L){const $=F(v,E);if($!==-1)return v[$]}function F(v,E,L=v.length-1){for(let $=L;$>=0;$--){const b=v[$];if(E(b))return $}return-1}function y(v,E){const L=f(v,E);return L===-1?void 0:v[L]}function f(v,E,L=0,$=v.length){let b=L,a=$;for(;b<a;){const l=Math.floor((b+a)/2);E(v[l])?b=l+1:a=l}return b-1}function j(v,E){const L=h(v,E);return L===v.length?void 0:v[L]}function h(v,E,L=0,$=v.length){let b=L,a=$;for(;b<a;){const l=Math.floor((b+a)/2);E(v[l])?a=l:b=l+1}return b}function o(v,E,L=0,$=v.length){const b=h(v,E,L,$);return b===v.length?-1:b}class s{static{this.assertInvariants=!1}constructor(E){this.e=E,this.c=0}findLastMonotonous(E){if(s.assertInvariants){if(this.d){for(const $ of this.e)if(this.d($)&&!E($))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=E}const L=f(this.e,E,this.c);return this.c=L+1,L===-1?void 0:this.e[L]}}t.$mb=s;function c(v,E){if(v.length===0)return;let L=v[0];for(let $=1;$<v.length;$++){const b=v[$];E(b,L)>0&&(L=b)}return L}function p(v,E){if(v.length===0)return;let L=v[0];for(let $=1;$<v.length;$++){const b=v[$];E(b,L)>=0&&(L=b)}return L}function g(v,E){return c(v,(L,$)=>-E(L,$))}function m(v,E){if(v.length===0)return-1;let L=0;for(let $=1;$<v.length;$++){const b=v[$];E(b,v[L])>0&&(L=$)}return L}function e(v,E){for(const L of v){const $=E(L);if($!==void 0)return $}}}),re(ie[35],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$K=i,t.$L=F,t.$M=y,t.$N=f;function i(j,h){const o=Object.create(null);for(const s of j){const c=h(s);let p=o[c];p||(p=o[c]=[]),p.push(s)}return o}function F(j,h){const o=[],s=[];for(const c of j)h.has(c)||o.push(c);for(const c of h)j.has(c)||s.push(c);return{removed:o,added:s}}function y(j,h){const o=[],s=[];for(const[c,p]of j)h.has(c)||o.push(p);for(const[c,p]of h)j.has(c)||s.push(p);return{removed:o,added:s}}function f(j,h){const o=new Set;for(const s of h)j.has(s)&&o.add(s);return o}}),re(ie[36],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gt=t.$Ft=t.$Et=t.$Dt=void 0;function i(h,o){const s=Math.pow(10,o);return Math.round(h*s)/s}class F{constructor(o,s,c,p=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,o))|0,this.g=Math.min(255,Math.max(0,s))|0,this.b=Math.min(255,Math.max(0,c))|0,this.a=i(Math.max(Math.min(1,p),0),3)}static equals(o,s){return o.r===s.r&&o.g===s.g&&o.b===s.b&&o.a===s.a}}t.$Dt=F;class y{constructor(o,s,c,p){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,o),0)|0,this.s=i(Math.max(Math.min(1,s),0),3),this.l=i(Math.max(Math.min(1,c),0),3),this.a=i(Math.max(Math.min(1,p),0),3)}static equals(o,s){return o.h===s.h&&o.s===s.s&&o.l===s.l&&o.a===s.a}static fromRGBA(o){const s=o.r/255,c=o.g/255,p=o.b/255,g=o.a,m=Math.max(s,c,p),e=Math.min(s,c,p);let v=0,E=0;const L=(e+m)/2,$=m-e;if($>0){switch(E=Math.min(L<=.5?$/(2*L):$/(2-2*L),1),m){case s:v=(c-p)/$+(c<p?6:0);break;case c:v=(p-s)/$+2;break;case p:v=(s-c)/$+4;break}v*=60,v=Math.round(v)}return new y(v,E,L,g)}static i(o,s,c){return c<0&&(c+=1),c>1&&(c-=1),c<1/6?o+(s-o)*6*c:c<1/2?s:c<2/3?o+(s-o)*(2/3-c)*6:o}static toRGBA(o){const s=o.h/360,{s:c,l:p,a:g}=o;let m,e,v;if(c===0)m=e=v=p;else{const E=p<.5?p*(1+c):p+c-p*c,L=2*p-E;m=y.i(L,E,s+1/3),e=y.i(L,E,s),v=y.i(L,E,s-1/3)}return new F(Math.round(m*255),Math.round(e*255),Math.round(v*255),g)}}t.$Et=y;class f{constructor(o,s,c,p){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,o),0)|0,this.s=i(Math.max(Math.min(1,s),0),3),this.v=i(Math.max(Math.min(1,c),0),3),this.a=i(Math.max(Math.min(1,p),0),3)}static equals(o,s){return o.h===s.h&&o.s===s.s&&o.v===s.v&&o.a===s.a}static fromRGBA(o){const s=o.r/255,c=o.g/255,p=o.b/255,g=Math.max(s,c,p),m=Math.min(s,c,p),e=g-m,v=g===0?0:e/g;let E;return e===0?E=0:g===s?E=((c-p)/e%6+6)%6:g===c?E=(p-s)/e+2:E=(s-c)/e+4,new f(Math.round(E*60),v,g,o.a)}static toRGBA(o){const{h:s,s:c,v:p,a:g}=o,m=p*c,e=m*(1-Math.abs(s/60%2-1)),v=p-m;let[E,L,$]=[0,0,0];return s<60?(E=m,L=e):s<120?(E=e,L=m):s<180?(L=m,$=e):s<240?(L=e,$=m):s<300?(E=e,$=m):s<=360&&(E=m,$=e),E=Math.round((E+v)*255),L=Math.round((L+v)*255),$=Math.round(($+v)*255),new F(E,L,$,g)}}t.$Ft=f;class j{static fromHex(o){return j.Format.CSS.parseHex(o)||j.red}static equals(o,s){return!o&&!s?!0:!o||!s?!1:o.equals(s)}get hsla(){return this.i?this.i:y.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:f.fromRGBA(this.rgba)}constructor(o){if(o)if(o instanceof F)this.rgba=o;else if(o instanceof y)this.i=o,this.rgba=y.toRGBA(o);else if(o instanceof f)this.j=o,this.rgba=f.toRGBA(o);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(o){return!!o&&F.equals(this.rgba,o.rgba)&&y.equals(this.hsla,o.hsla)&&f.equals(this.hsva,o.hsva)}getRelativeLuminance(){const o=j.k(this.rgba.r),s=j.k(this.rgba.g),c=j.k(this.rgba.b),p=.2126*o+.7152*s+.0722*c;return i(p,4)}static k(o){const s=o/255;return s<=.03928?s/12.92:Math.pow((s+.055)/1.055,2.4)}getContrastRatio(o){const s=this.getRelativeLuminance(),c=o.getRelativeLuminance();return s>c?(s+.05)/(c+.05):(c+.05)/(s+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(o){const s=this.getRelativeLuminance(),c=o.getRelativeLuminance();return s>c}isDarkerThan(o){const s=this.getRelativeLuminance(),c=o.getRelativeLuminance();return s<c}lighten(o){return new j(new y(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*o,this.hsla.a))}darken(o){return new j(new y(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*o,this.hsla.a))}transparent(o){const{r:s,g:c,b:p,a:g}=this.rgba;return new j(new F(s,c,p,g*o))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new j(new F(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(o){const s=o.rgba,c=this.rgba.a,p=s.a,g=c+p*(1-c);if(g<1e-6)return j.transparent;const m=this.rgba.r*c/g+s.r*p*(1-c)/g,e=this.rgba.g*c/g+s.g*p*(1-c)/g,v=this.rgba.b*c/g+s.b*p*(1-c)/g;return new j(new F(m,e,v,g))}makeOpaque(o){if(this.isOpaque()||o.rgba.a!==1)return this;const{r:s,g:c,b:p,a:g}=this.rgba;return new j(new F(o.rgba.r-g*(o.rgba.r-s),o.rgba.g-g*(o.rgba.g-c),o.rgba.b-g*(o.rgba.b-p),1))}flatten(...o){const s=o.reduceRight((c,p)=>j.o(p,c));return j.o(this,s)}static o(o,s){const c=1-o.rgba.a;return new j(new F(c*s.rgba.r+o.rgba.a*o.rgba.r,c*s.rgba.g+o.rgba.a*o.rgba.g,c*s.rgba.b+o.rgba.a*o.rgba.b))}toString(){return this.u||(this.u=j.Format.CSS.format(this)),this.u}static getLighterColor(o,s,c){if(o.isLighterThan(s))return o;c=c||.5;const p=o.getRelativeLuminance(),g=s.getRelativeLuminance();return c=c*(g-p)/g,o.lighten(c)}static getDarkerColor(o,s,c){if(o.isDarkerThan(s))return o;c=c||.5;const p=o.getRelativeLuminance(),g=s.getRelativeLuminance();return c=c*(p-g)/p,o.darken(c)}static{this.white=new j(new F(255,255,255,1))}static{this.black=new j(new F(0,0,0,1))}static{this.red=new j(new F(255,0,0,1))}static{this.blue=new j(new F(0,0,255,1))}static{this.green=new j(new F(0,255,0,1))}static{this.cyan=new j(new F(0,255,255,1))}static{this.lightgrey=new j(new F(211,211,211,1))}static{this.transparent=new j(new F(0,0,0,0))}}t.$Gt=j,function(h){let o;(function(s){let c;(function(p){function g(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:h.Format.CSS.formatRGBA(r)}p.formatRGB=g;function m(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}p.formatRGBA=m;function e(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:h.Format.CSS.formatHSLA(r)}p.formatHSL=e;function v(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}p.formatHSLA=v;function E(r){const u=r.toString(16);return u.length!==2?"0"+u:u}function L(r){return`#${E(r.rgba.r)}${E(r.rgba.g)}${E(r.rgba.b)}`}p.formatHex=L;function $(r,u=!1){return u&&r.rgba.a===1?h.Format.CSS.formatHex(r):`#${E(r.rgba.r)}${E(r.rgba.g)}${E(r.rgba.b)}${E(Math.round(r.rgba.a*255))}`}p.formatHexA=$;function b(r){return r.isOpaque()?h.Format.CSS.formatHex(r):h.Format.CSS.formatRGBA(r)}p.format=b;function a(r){const u=r.length;if(u===0||r.charCodeAt(0)!==35)return null;if(u===7){const N=16*l(r.charCodeAt(1))+l(r.charCodeAt(2)),d=16*l(r.charCodeAt(3))+l(r.charCodeAt(4)),w=16*l(r.charCodeAt(5))+l(r.charCodeAt(6));return new h(new F(N,d,w,1))}if(u===9){const N=16*l(r.charCodeAt(1))+l(r.charCodeAt(2)),d=16*l(r.charCodeAt(3))+l(r.charCodeAt(4)),w=16*l(r.charCodeAt(5))+l(r.charCodeAt(6)),A=16*l(r.charCodeAt(7))+l(r.charCodeAt(8));return new h(new F(N,d,w,A/255))}if(u===4){const N=l(r.charCodeAt(1)),d=l(r.charCodeAt(2)),w=l(r.charCodeAt(3));return new h(new F(16*N+N,16*d+d,16*w+w))}if(u===5){const N=l(r.charCodeAt(1)),d=l(r.charCodeAt(2)),w=l(r.charCodeAt(3)),A=l(r.charCodeAt(4));return new h(new F(16*N+N,16*d+d,16*w+w,(16*A+A)/255))}return null}p.parseHex=a;function l(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(c=s.CSS||(s.CSS={}))})(o=h.Format||(h.Format={}))}(j||(t.$Gt=j={}))}),re(ie[37],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ft=void 0;class i{constructor(y,f,j,h){this.originalStart=y,this.originalLength=f,this.modifiedStart=j,this.modifiedLength=h}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$ft=i}),re(ie[3],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$9=t.$5=t.$X=t.$W=void 0,t.setUnexpectedErrorHandler=F,t.$Z=y,t.$1=f,t.$2=j,t.$3=h,t.$4=s,t.$6=p,t.$7=g,t.$8=m,t.$0=v;class i{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?b.isErrorNoTelemetry(r)?new b(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(u=>{u(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}t.$W=i,t.$X=new i;function F(l){t.$X.setUnexpectedErrorHandler(l)}function y(l){if(!l||typeof l!="object")return!1;const r=l;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}function f(l){s(l)||t.$X.onUnexpectedError(l)}function j(l){s(l)||t.$X.onUnexpectedExternalError(l)}function h(l){if(l instanceof Error){const{name:r,message:u}=l,N=l.stacktrace||l.stack;return{$isError:!0,name:r,message:u,stack:N,noTelemetry:b.isErrorNoTelemetry(l)}}return l}const o="Canceled";function s(l){return l instanceof c?!0:l instanceof Error&&l.name===o&&l.message===o}class c extends Error{constructor(){super(o),this.name=this.message}}t.$5=c;function p(){const l=new Error(o);return l.name=l.message,l}function g(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}function m(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}class e extends TypeError{constructor(r){super(r?`${r} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function v(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}class E extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}t.$$=E;class L extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}t.$_=L;class $ extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=$;class b extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof b)return r;const u=new b;return u.message=r.message,u.stack=r.stack,u}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}t.$bb=b;class a extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,a.prototype)}}t.$cb=a}),re(ie[6],se([0,1,3,9]),function(O,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bc=t.$ac=t.$_b=t.$0b=t.$9b=t.CompareResult=void 0,t.$sb=y,t.$tb=f,t.$ub=j,t.$vb=h,t.$wb=o,t.$xb=s,t.$yb=c,t.$zb=p,t.$Ab=g,t.$Bb=m,t.$Cb=e,t.$Db=v,t.$Eb=E,t.top=L,t.$Gb=$,t.$Hb=a,t.$Ib=l,t.$Jb=r,t.$Kb=u,t.$Lb=N,t.$Mb=d,t.$Nb=w,t.$Ob=A,t.$Pb=C,t.$Qb=M,t.$Rb=T,t.$Sb=S,t.$Tb=k,t.$Ub=R,t.$Vb=x,t.$Wb=I,t.$Xb=G,t.$Yb=K,t.$Zb=_,t.$1b=X,t.$2b=Q,t.$3b=P,t.$4b=H,t.$5b=ue,t.$6b=oe,t.$7b=ve,t.$8b=Le,t.$$b=xe;function y(B,W=0){return B[B.length-(1+W)]}function f(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}function j(B,W,V=(J,ee)=>J===ee){if(B===W)return!0;if(!B||!W||B.length!==W.length)return!1;for(let J=0,ee=B.length;J<ee;J++)if(!V(B[J],W[J]))return!1;return!0}function h(B,W){const V=B.length-1;W<V&&(B[W]=B[V]),B.pop()}function o(B,W,V){return s(B.length,J=>V(B[J],W))}function s(B,W){let V=0,J=B-1;for(;V<=J;){const ee=(V+J)/2|0,Z=W(ee);if(Z<0)V=ee+1;else if(Z>0)J=ee-1;else return ee}return-(V+1)}function c(B,W,V){if(B=B|0,B>=W.length)throw new TypeError("invalid index");const J=W[Math.floor(W.length*Math.random())],ee=[],Z=[],Y=[];for(const ne of W){const te=V(ne,J);te<0?ee.push(ne):te>0?Z.push(ne):Y.push(ne)}return B<ee.length?c(B,ee,V):B<ee.length+Y.length?Y[0]:c(B-(ee.length+Y.length),Z,V)}function p(B,W){const V=[];let J;for(const ee of B.slice(0).sort(W))!J||W(J[0],ee)!==0?(J=[ee],V.push(J)):J.push(ee);return V}function*g(B,W){let V,J;for(const ee of B)J!==void 0&&W(J,ee)?V.push(ee):(V&&(yield V),V=[ee]),J=ee;V&&(yield V)}function m(B,W){for(let V=0;V<=B.length;V++)W(V===0?void 0:B[V-1],V===B.length?void 0:B[V])}function e(B,W){for(let V=0;V<B.length;V++)W(V===0?void 0:B[V-1],B[V],V+1===B.length?void 0:B[V+1])}function v(B,W,V){const J=[];function ee(ne,te,le){if(te===0&&le.length===0)return;const fe=J[J.length-1];fe&&fe.start+fe.deleteCount===ne?(fe.deleteCount+=te,fe.toInsert.push(...le)):J.push({start:ne,deleteCount:te,toInsert:le})}let Z=0,Y=0;for(;;){if(Z===B.length){ee(Z,0,W.slice(Y));break}if(Y===W.length){ee(Z,B.length-Z,[]);break}const ne=B[Z],te=W[Y],le=V(ne,te);le===0?(Z+=1,Y+=1):le<0?(ee(Z,1,[]),Z+=1):le>0&&(ee(Z,0,[te]),Y+=1)}return J}function E(B,W,V){const J=v(B,W,V),ee=[],Z=[];for(const Y of J)ee.push(...B.slice(Y.start,Y.start+Y.deleteCount)),Z.push(...Y.toInsert);return{removed:ee,added:Z}}function L(B,W,V){if(V===0)return[];const J=B.slice(0,V).sort(W);return b(B,W,J,V,B.length),J}function $(B,W,V,J,ee){return V===0?Promise.resolve([]):new Promise((Z,Y)=>{(async()=>{const ne=B.length,te=B.slice(0,V).sort(W);for(let le=V,fe=Math.min(V+J,ne);le<ne;le=fe,fe=Math.min(fe+J,ne)){if(le>V&&await new Promise(ce=>setTimeout(ce)),ee&&ee.isCancellationRequested)throw new i.$5;b(B,W,te,le,fe)}return te})().then(Z,Y)})}function b(B,W,V,J,ee){for(const Z=V.length;J<ee;J++){const Y=B[J];if(W(Y,V[Z-1])<0){V.pop();const ne=(0,F.$kb)(V,te=>W(Y,te)<0);V.splice(ne,0,Y)}}}function a(B){return B.filter(W=>!!W)}function l(B){let W=0;for(let V=0;V<B.length;V++)B[V]&&(B[W]=B[V],W+=1);B.length=W}function r(B,W,V){B.splice(V,0,B.splice(W,1)[0])}function u(B){return!Array.isArray(B)||B.length===0}function N(B){return Array.isArray(B)&&B.length>0}function d(B,W=V=>V){const V=new Set;return B.filter(J=>{const ee=W(J);return V.has(ee)?!1:(V.add(ee),!0)})}function w(B){const W=new Set;return V=>{const J=B(V);return W.has(J)?!1:(W.add(J),!0)}}function A(B,W){return B.length>0?B[0]:W}function C(B,W){return B.length>0?B[B.length-1]:W}function M(B,W,V=(J,ee)=>J===ee){let J=0;for(let ee=0,Z=Math.min(B.length,W.length);ee<Z&&V(B[ee],W[ee]);ee++)J++;return J}function T(B){return[].concat(...B)}function S(B,W){let V=typeof W=="number"?B:0;typeof W=="number"?V=B:(V=0,W=B);const J=[];if(V<=W)for(let ee=V;ee<W;ee++)J.push(ee);else for(let ee=V;ee>W;ee--)J.push(ee);return J}function k(B,W,V){return B.reduce((J,ee)=>(J[W(ee)]=V?V(ee):ee,J),Object.create(null))}function R(B,W){return B.push(W),()=>x(B,W)}function x(B,W){const V=B.indexOf(W);if(V>-1)return B.splice(V,1),W}function I(B,W,V){const J=B.slice(0,W),ee=B.slice(W);return J.concat(V,ee)}function G(B,W){let V;if(typeof W=="number"){let J=W;V=()=>{const ee=Math.sin(J++)*179426549;return ee-Math.floor(ee)}}else V=Math.random;for(let J=B.length-1;J>0;J-=1){const ee=Math.floor(V()*(J+1)),Z=B[J];B[J]=B[ee],B[ee]=Z}}function K(B,W){const V=B.indexOf(W);V>-1&&(B.splice(V,1),B.unshift(W))}function _(B,W){const V=B.indexOf(W);V>-1&&(B.splice(V,1),B.push(W))}function X(B,W){for(const V of W)B.push(V)}function Q(B,W){return Array.isArray(B)?B.map(W):W(B)}function P(B){return Array.isArray(B)?B:[B]}function H(B){return B[Math.floor(Math.random()*B.length)]}function ue(B,W,V){const J=n(B,W),ee=B.length,Z=V.length;B.length=ee+Z;for(let Y=ee-1;Y>=J;Y--)B[Y+Z]=B[Y];for(let Y=0;Y<Z;Y++)B[Y+J]=V[Y]}function oe(B,W,V,J){const ee=n(B,W);let Z=B.splice(ee,V);return Z===void 0&&(Z=[]),ue(B,ee,J),Z}function n(B,W){return W<0?Math.max(W+B.length,0):Math.min(W,B.length)}var $e;(function(B){function W(Z){return Z<0}B.isLessThan=W;function V(Z){return Z<=0}B.isLessThanOrEqual=V;function J(Z){return Z>0}B.isGreaterThan=J;function ee(Z){return Z===0}B.isNeitherLessOrGreaterThan=ee,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})($e||(t.CompareResult=$e={}));function ve(B,W){return(V,J)=>W(B(V),B(J))}function Le(...B){return(W,V)=>{for(const J of B){const ee=J(W,V);if(!$e.isNeitherLessOrGreaterThan(ee))return ee}return $e.neitherLessOrGreaterThan}}const ke=(B,W)=>B-W;t.$9b=ke;const pe=(B,W)=>(0,t.$9b)(B?1:0,W?1:0);t.$0b=pe;function xe(B){return(W,V)=>-B(W,V)}class Ie{constructor(W){this.g=W,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(W){let V=this.c;for(;V<this.g.length&&W(this.g[V]);)V++;const J=V===this.c?null:this.g.slice(this.c,V);return this.c=V,J}takeFromEndWhile(W){let V=this.d;for(;V>=0&&W(this.g[V]);)V--;const J=V===this.d?null:this.g.slice(V+1,this.d+1);return this.d=V,J}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const W=this.g[this.c];return this.c++,W}removeLast(){const W=this.g[this.d];return this.d--,W}takeCount(W){const V=this.g.slice(this.c,this.c+W);return this.c+=W,V}}t.$_b=Ie;class Ce{static{this.empty=new Ce(W=>{})}constructor(W){this.iterate=W}forEach(W){this.iterate(V=>(W(V),!0))}toArray(){const W=[];return this.iterate(V=>(W.push(V),!0)),W}filter(W){return new Ce(V=>this.iterate(J=>W(J)?V(J):!0))}map(W){return new Ce(V=>this.iterate(J=>V(W(J))))}some(W){let V=!1;return this.iterate(J=>(V=W(J),!V)),V}findFirst(W){let V;return this.iterate(J=>W(J)?(V=J,!1):!0),V}findLast(W){let V;return this.iterate(J=>(W(J)&&(V=J),!0)),V}findLastMaxBy(W){let V,J=!0;return this.iterate(ee=>((J||$e.isGreaterThan(W(ee,V)))&&(J=!1,V=ee),!0)),V}}t.$ac=Ce;class ye{constructor(W){this.c=W}static createSortPermutation(W,V){const J=Array.from(W.keys()).sort((ee,Z)=>V(W[ee],W[Z]));return new ye(J)}apply(W){return W.map((V,J)=>W[this.c[J]])}inverse(){const W=this.c.slice();for(let V=0;V<this.c.length;V++)W[this.c[V]]=V;return new ye(W)}}t.$bc=ye}),re(ie[13],se([0,1,3]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=F,t.$0c=y,t.$$c=f,t.$_c=j,t.$ad=h,t.$bd=o;function F(s,c){if(!s)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}function y(s,c="Unreachable"){throw new Error(c)}function f(s){if(!s)throw new i.$cb("Assertion Failed")}function j(s){s||(0,i.$1)(new i.$cb("Soft Assertion Failed"))}function h(s){if(!s()){debugger;s(),(0,i.$1)(new i.$cb("Assertion Failed"))}}function o(s,c){let p=0;for(;p<s.length-1;){const g=s[p],m=s[p+1];if(!c(g,m))return!1;p++}return!0}}),re(ie[20],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=i;function i(F,y){const f=this;let j=!1,h;return function(){if(j)return h;if(j=!0,y)try{h=F.apply(f,arguments)}finally{y()}else h=F.apply(f,arguments);return h}}}),re(ie[21],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(F){function y(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}F.is=y;const f=Object.freeze([]);function j(){return f}F.empty=j;function*h(r){yield r}F.single=h;function o(r){return y(r)?r:h(r)}F.wrap=o;function s(r){return r||f}F.from=s;function*c(r){for(let u=r.length-1;u>=0;u--)yield r[u]}F.reverse=c;function p(r){return!r||r[Symbol.iterator]().next().done===!0}F.isEmpty=p;function g(r){return r[Symbol.iterator]().next().value}F.first=g;function m(r,u){for(const N of r)if(u(N))return!0;return!1}F.some=m;function e(r,u){for(const N of r)if(u(N))return N}F.find=e;function*v(r,u){for(const N of r)u(N)&&(yield N)}F.filter=v;function*E(r,u){let N=0;for(const d of r)yield u(d,N++)}F.map=E;function*L(...r){for(const u of r)yield*u}F.concat=L;function $(r,u,N){let d=N;for(const w of r)d=u(d,w);return d}F.reduce=$;function*b(r,u,N=r.length){for(u<0&&(u+=r.length),N<0?N+=r.length:N>r.length&&(N=r.length);u<N;u++)yield r[u]}F.slice=b;function a(r,u=Number.POSITIVE_INFINITY){const N=[];if(u===0)return[N,r];const d=r[Symbol.iterator]();for(let w=0;w<u;w++){const A=d.next();if(A.done)return[N,F.empty()];N.push(A.value)}return[N,{[Symbol.iterator](){return d}}]}F.consume=a;async function l(r){const u=[];for await(const N of r)u.push(N);return Promise.resolve(u)}F.asyncToArray=l})(i||(t.Iterable=i={}))}),re(ie[38],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.$nr=t.$mr=t.$lr=t.$kr=t.$jr=t.ScanCode=t.KeyCode=void 0,t.$or=m;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var F;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(F||(t.ScanCode=F={}));class y{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(v,E){this._keyCodeToStr[v]=E,this._strToKeyCode[E.toLowerCase()]=v}keyCodeToStr(v){return this._keyCodeToStr[v]}strToKeyCode(v){return this._strToKeyCode[v.toLowerCase()]||0}}const f=new y,j=new y,h=new y;t.$jr=new Array(230),t.$kr={};const o=[],s=Object.create(null),c=Object.create(null);t.$lr={lowerCaseToEnum:e=>c[e]||0,toEnum:e=>s[e]||0,toString:e=>o[e]||"None"},t.$mr=[],t.$nr=[];for(let e=0;e<=193;e++)t.$mr[e]=-1;for(let e=0;e<=132;e++)t.$nr[e]=-1;(function(){const e="",v=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],E=[],L=[];for(const $ of v){const[b,a,l,r,u,N,d,w,A]=$;if(L[a]||(L[a]=!0,o[a]=l,s[l]=a,c[l.toLowerCase()]=a,b&&(t.$mr[a]=r,r!==0&&r!==3&&r!==5&&r!==4&&r!==6&&r!==57&&(t.$nr[r]=a))),!E[r]){if(E[r]=!0,!u)throw new Error(`String representation missing for key code ${r} around scan code ${l}`);f.define(r,u),j.define(r,w||u),h.define(r,A||w||u)}N&&(t.$jr[N]=r),d&&(t.$kr[d]=r)}t.$nr[3]=46})();var p;(function(e){function v(l){return f.keyCodeToStr(l)}e.toString=v;function E(l){return f.strToKeyCode(l)}e.fromString=E;function L(l){return j.keyCodeToStr(l)}e.toUserSettingsUS=L;function $(l){return h.keyCodeToStr(l)}e.toUserSettingsGeneral=$;function b(l){return j.strToKeyCode(l)||h.strToKeyCode(l)}e.fromUserSettings=b;function a(l){if(l>=98&&l<=113)return null;switch(l){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return f.keyCodeToStr(l)}e.toElectronAccelerator=a})(p||(t.KeyCodeUtils=p={}));var g;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(g||(t.KeyMod=g={}));function m(e,v){const E=(v&65535)<<16>>>0;return(e|E)>>>0}}),re(ie[39],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class i{constructor(y){this.d=y,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(y){this.c=y}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=i}),re(ie[22],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(f){this.element=f,this.next=i.Undefined,this.prev=i.Undefined}}class F{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let f=this.a;for(;f!==i.Undefined;){const j=f.next;f.prev=i.Undefined,f.next=i.Undefined,f=j}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(f){return this.d(f,!1)}push(f){return this.d(f,!0)}d(f,j){const h=new i(f);if(this.a===i.Undefined)this.a=h,this.b=h;else if(j){const s=this.b;this.b=h,h.prev=s,s.next=h}else{const s=this.a;this.a=h,h.next=s,s.prev=h}this.c+=1;let o=!1;return()=>{o||(o=!0,this.e(h))}}shift(){if(this.a!==i.Undefined){const f=this.a.element;return this.e(this.a),f}}pop(){if(this.b!==i.Undefined){const f=this.b.element;return this.e(this.b),f}}e(f){if(f.prev!==i.Undefined&&f.next!==i.Undefined){const j=f.prev;j.next=f.next,f.next.prev=j}else f.prev===i.Undefined&&f.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):f.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):f.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let f=this.a;for(;f!==i.Undefined;)yield f.element,f=f.next}}t.$5c=F}),re(ie[14],se([0,1]),function(O,t){"use strict";var i,F,y;Object.defineProperty(t,"__esModule",{value:!0}),t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.Touch=t.$Cc=t.$Bc=void 0,t.$yc=f,t.$zc=j,t.$Ac=h,t.$Ic=$;function f(b,a,l){let r=b.get(a);return r===void 0&&(r=l,b.set(a,r)),r}function j(b){const a=[];return b.forEach((l,r)=>{a.push(`${r} => ${l}`)}),`Map(${b.size}) {${a.join(", ")}}`}function h(b){const a=[];return b.forEach(l=>{a.push(l)}),`Set(${b.size}) {${a.join(", ")}}`}class o{constructor(a,l){this.uri=a,this.value=l}}function s(b){return Array.isArray(b)}class c{static{this.c=a=>a.toString()}constructor(a,l){if(this[i]="ResourceMap",a instanceof c)this.d=new Map(a.d),this.e=l??c.c;else if(s(a)){this.d=new Map,this.e=l??c.c;for(const[r,u]of a)this.set(r,u)}else this.d=new Map,this.e=a??c.c}set(a,l){return this.d.set(this.e(a),new o(a,l)),this}get(a){return this.d.get(this.e(a))?.value}has(a){return this.d.has(this.e(a))}get size(){return this.d.size}clear(){this.d.clear()}delete(a){return this.d.delete(this.e(a))}forEach(a,l){typeof l<"u"&&(a=a.bind(l));for(const[r,u]of this.d)a(u.value,u.uri,this)}*values(){for(const a of this.d.values())yield a.value}*keys(){for(const a of this.d.values())yield a.uri}*entries(){for(const a of this.d.values())yield[a.uri,a.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.d)yield[a.uri,a.value]}}t.$Bc=c;class p{constructor(a,l){this[F]="ResourceSet",!a||typeof a=="function"?this.c=new c(a):(this.c=new c(l),a.forEach(this.add,this))}get size(){return this.c.size}add(a){return this.c.set(a,a),this}clear(){this.c.clear()}delete(a){return this.c.delete(a)}forEach(a,l){this.c.forEach((r,u)=>a.call(l,u,u,this))}has(a){return this.c.has(a)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Cc=p;var g;(function(b){b[b.None=0]="None",b[b.AsOld=1]="AsOld",b[b.AsNew=2]="AsNew"})(g||(t.Touch=g={}));class m{constructor(){this[y]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(a){return this.c.has(a)}get(a,l=0){const r=this.c.get(a);if(r)return l!==0&&this.l(r,l),r.value}set(a,l,r=0){let u=this.c.get(a);if(u)u.value=l,r!==0&&this.l(u,r);else{switch(u={key:a,value:l,next:void 0,previous:void 0},r){case 0:this.j(u);break;case 1:this.i(u);break;case 2:this.j(u);break;default:this.j(u);break}this.c.set(a,u),this.f++}return this}delete(a){return!!this.remove(a)}remove(a){const l=this.c.get(a);if(l)return this.c.delete(a),this.k(l),this.f--,l.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const a=this.d;return this.c.delete(a.key),this.k(a),this.f--,a.value}forEach(a,l){const r=this.g;let u=this.d;for(;u;){if(l?a.bind(l)(u.value,u.key,this):a(u.value,u.key,this),this.g!==r)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const a=this,l=this.g;let r=this.d;const u={[Symbol.iterator](){return u},next(){if(a.g!==l)throw new Error("LinkedMap got modified during iteration.");if(r){const N={value:r.key,done:!1};return r=r.next,N}else return{value:void 0,done:!0}}};return u}values(){const a=this,l=this.g;let r=this.d;const u={[Symbol.iterator](){return u},next(){if(a.g!==l)throw new Error("LinkedMap got modified during iteration.");if(r){const N={value:r.value,done:!1};return r=r.next,N}else return{value:void 0,done:!0}}};return u}entries(){const a=this,l=this.g;let r=this.d;const u={[Symbol.iterator](){return u},next(){if(a.g!==l)throw new Error("LinkedMap got modified during iteration.");if(r){const N={value:[r.key,r.value],done:!1};return r=r.next,N}else return{value:void 0,done:!0}}};return u}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(a){if(a>=this.size)return;if(a===0){this.clear();return}let l=this.d,r=this.size;for(;l&&r>a;)this.c.delete(l.key),l=l.next,r--;this.d=l,this.f=r,l&&(l.previous=void 0),this.g++}i(a){if(!this.d&&!this.e)this.e=a;else if(this.d)a.next=this.d,this.d.previous=a;else throw new Error("Invalid list");this.d=a,this.g++}j(a){if(!this.d&&!this.e)this.d=a;else if(this.e)a.previous=this.e,this.e.next=a;else throw new Error("Invalid list");this.e=a,this.g++}k(a){if(a===this.d&&a===this.e)this.d=void 0,this.e=void 0;else if(a===this.d){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this.d=a.next}else if(a===this.e){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this.e=a.previous}else{const l=a.next,r=a.previous;if(!l||!r)throw new Error("Invalid list");l.previous=r,r.next=l}a.next=void 0,a.previous=void 0,this.g++}l(a,l){if(!this.d||!this.e)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(a===this.d)return;const r=a.next,u=a.previous;a===this.e?(u.next=void 0,this.e=u):(r.previous=u,u.next=r),a.previous=void 0,a.next=this.d,this.d.previous=a,this.d=a,this.g++}else if(l===2){if(a===this.e)return;const r=a.next,u=a.previous;a===this.d?(r.previous=void 0,this.d=r):(r.previous=u,u.next=r),a.next=void 0,a.previous=this.e,this.e.next=a,this.e=a,this.g++}}}toJSON(){const a=[];return this.forEach((l,r)=>{a.push([r,l])}),a}fromJSON(a){this.clear();for(const[l,r]of a)this.set(l,r)}}t.$Dc=m;class e extends m{constructor(a,l=1){super(),this.m=a,this.n=Math.min(Math.max(0,l),1)}get limit(){return this.m}set limit(a){this.m=a,this.o()}get ratio(){return this.n}set ratio(a){this.n=Math.min(Math.max(0,a),1),this.o()}get(a,l=2){return super.get(a,l)}peek(a){return super.get(a,0)}set(a,l){return super.set(a,l,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}t.$Ec=e;class v{constructor(){this.c=new Map}add(a){return this.c.set(a,(this.c.get(a)||0)+1),this}delete(a){let l=this.c.get(a)||0;return l===0?!1:(l--,l===0?this.c.delete(a):this.c.set(a,l),!0)}has(a){return this.c.has(a)}}t.$Fc=v;class E{constructor(a){if(this.c=new Map,this.d=new Map,a)for(const[l,r]of a)this.set(l,r)}clear(){this.c.clear(),this.d.clear()}set(a,l){this.c.set(a,l),this.d.set(l,a)}get(a){return this.c.get(a)}getKey(a){return this.d.get(a)}delete(a){const l=this.c.get(a);return l===void 0?!1:(this.c.delete(a),this.d.delete(l),!0)}forEach(a,l){this.c.forEach((r,u)=>{a.call(l,r,u,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Gc=E;class L{constructor(){this.c=new Map}add(a,l){let r=this.c.get(a);r||(r=new Set,this.c.set(a,r)),r.add(l)}delete(a,l){const r=this.c.get(a);r&&(r.delete(l),r.size===0&&this.c.delete(a))}forEach(a,l){const r=this.c.get(a);r&&r.forEach(l)}get(a){const l=this.c.get(a);return l||new Set}}t.$Hc=L;function $(b,a){if(b===a)return!0;if(b.size!==a.size)return!1;for(const[l,r]of b)if(!a.has(l)||a.get(l)!==r)return!1;for(const[l]of a)if(!b.has(l))return!1;return!0}}),re(ie[10],se([0,1,6,35,14,20,21]),function(O,t,i,F,y,f,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Jc=void 0,t.$Kc=c,t.$Lc=p,t.$Mc=g,t.$Nc=v,t.$Oc=E,t.$Pc=L,t.$Qc=$,t.$Rc=b,t.$Sc=a,t.$3c=T;const h=!1;let o=null;class s{constructor(){this.b=new Map}static{this.a=0}c(R){let x=this.b.get(R);return x||(x={parent:null,source:null,isSingleton:!1,value:R,idx:s.a++},this.b.set(R,x)),x}trackDisposable(R){const x=this.c(R);x.source||(x.source=new Error().stack)}setParent(R,x){const I=this.c(R);I.parent=x}markAsDisposed(R){this.b.delete(R)}markAsSingleton(R){this.c(R).isSingleton=!0}f(R,x){const I=x.get(R);if(I)return I;const G=R.parent?this.f(this.c(R.parent),x):R;return x.set(R,G),G}getTrackedDisposables(){const R=new Map;return[...this.b.entries()].filter(([,I])=>I.source!==null&&!this.f(I,R).isSingleton).flatMap(([I])=>I)}computeLeakingDisposables(R=10,x){let I;if(x)I=x;else{const Q=new Map,P=[...this.b.values()].filter(ue=>ue.source!==null&&!this.f(ue,Q).isSingleton);if(P.length===0)return;const H=new Set(P.map(ue=>ue.value));if(I=P.filter(ue=>!(ue.parent&&H.has(ue.parent))),I.length===0)throw new Error("There are cyclic diposable chains!")}if(!I)return;function G(Q){function P(ue,oe){for(;ue.length>0&&oe.some(n=>typeof n=="string"?n===ue[0]:ue[0].match(n));)ue.shift()}const H=Q.source.split(`
`).map(ue=>ue.trim().replace("at ","")).filter(ue=>ue!=="");return P(H,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),H.reverse()}const K=new y.$Hc;for(const Q of I){const P=G(Q);for(let H=0;H<=P.length;H++)K.add(P.slice(0,H).join(`
`),Q)}I.sort((0,i.$7b)(Q=>Q.idx,i.$9b));let _="",X=0;for(const Q of I.slice(0,R)){X++;const P=G(Q),H=[];for(let ue=0;ue<P.length;ue++){let oe=P[ue];oe=`(shared with ${K.get(P.slice(0,ue+1).join(`
`)).size}/${I.length} leaks) at ${oe}`;const $e=K.get(P.slice(0,ue).join(`
`)),ve=(0,F.$K)([...$e].map(Le=>G(Le)[ue]),Le=>Le);delete ve[P[ue]];for(const[Le,ke]of Object.entries(ve))H.unshift(`    - stacktraces of ${ke.length} other leaks continue with ${Le}`);H.unshift(oe)}_+=`


==================== Leaking disposable ${X}/${I.length}: ${Q.value.constructor.name} ====================
${H.join(`
`)}
============================================================

`}return I.length>R&&(_+=`


... and ${I.length-R} more leaking disposables

`),{leaks:I,details:_}}}t.$Jc=s;function c(k){o=k}if(h){const k="__is_disposable_tracked__";c(new class{trackDisposable(R){const x=new Error("Potentially leaked disposable").stack;setTimeout(()=>{R[k]||console.log(x)},3e3)}setParent(R,x){if(R&&R!==r.None)try{R[k]=!0}catch{}}markAsDisposed(R){if(R&&R!==r.None)try{R[k]=!0}catch{}}markAsSingleton(R){}})}function p(k){return o?.trackDisposable(k),k}function g(k){o?.markAsDisposed(k)}function m(k,R){o?.setParent(k,R)}function e(k,R){if(o)for(const x of k)o.setParent(x,R)}function v(k){return o?.markAsSingleton(k),k}function E(k){return typeof k.dispose=="function"&&k.dispose.length===0}function L(k){if(j.Iterable.is(k)){const R=[];for(const x of k)if(x)try{x.dispose()}catch(I){R.push(I)}if(R.length===1)throw R[0];if(R.length>1)throw new AggregateError(R,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}function $(k){for(const R of k)E(R)&&R.dispose();return[]}function b(...k){const R=a(()=>L(k));return e(k,R),R}function a(k){const R=p({dispose:(0,f.$db)(()=>{g(R),k()})});return R}class l{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,p(this)}dispose(){this.g||(g(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{L(this.f)}finally{this.f.clear()}}add(R){if(!R)return R;if(R===this)throw new Error("Cannot register a disposable on itself!");return m(R,this),this.g?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(R),R}delete(R){if(R){if(R===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(R),R.dispose()}}deleteAndLeak(R){R&&this.f.has(R)&&(this.f.delete(R),m(R,null))}}t.$Tc=l;class r{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new l,p(this),m(this.q,this)}dispose(){g(this),this.q.dispose()}B(R){if(R===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(R)}}t.$Uc=r;class u{constructor(){this.b=!1,p(this)}get value(){return this.b?void 0:this.a}set value(R){this.b||R===this.a||(this.a?.dispose(),R&&m(R,this),this.a=R)}clear(){this.value=void 0}dispose(){this.b=!0,g(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const R=this.a;return this.a=void 0,R&&m(R,null),R}}t.$Vc=u;class N{constructor(R){this.a=new u,this.b=!1,this.a.value=R}get value(){return this.a.value}set value(R){this.b||R===this.a.value||(this.a.value=R)}dispose(){this.b=!0,this.a.dispose()}}t.$Wc=N;class d{constructor(R){this.b=R,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Xc=d;class w{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,p(this)}set(R){let x=R;return this.unset=()=>x=void 0,this.isset=()=>x!==void 0,this.dispose=()=>{x&&(x(),x=void 0,g(this))},this}}t.$Yc=w;class A{constructor(){this.a=new Map}acquire(R,...x){let I=this.a.get(R);I||(I={counter:0,object:this.b(R,...x)},this.a.set(R,I));const{object:G}=I,K=(0,f.$db)(()=>{--I.counter===0&&(this.c(R,I.object),this.a.delete(R))});return I.counter++,{object:G,dispose:K}}}t.$Zc=A;class C{constructor(R){this.a=R}async acquire(R,...x){const I=this.a.acquire(R,...x);try{return{object:await I.object,dispose:()=>I.dispose()}}catch(G){throw I.dispose(),G}}}t.$1c=C;class M{constructor(R){this.object=R}dispose(){}}t.$2c=M;function T(k){const R=new l;try{k(R)}finally{R.dispose()}}class S{constructor(){this.a=new Map,this.b=!1,p(this)}dispose(){g(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{L(this.a.values())}finally{this.a.clear()}}has(R){return this.a.has(R)}get size(){return this.a.size}get(R){return this.a.get(R)}set(R,x,I=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),I||this.a.get(R)?.dispose(),this.a.set(R,x)}deleteAndDispose(R){this.a.get(R)?.dispose(),this.a.delete(R)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$4c=S}),re(ie[23],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3d=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(f){return new F(f)}constructor(f){this.c=i&&f===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$3d=F}),re(ie[11],se([0,1,3,20,10,22,23]),function(O,t,i,F,y,f,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$de=t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$5d=t.Event=void 0,t.$6d=m;const h=!1,o=!1,s=!1;var c;(function(k){k.None=()=>y.$Uc.None;function R(Z){if(s){const{onDidAddListener:Y}=Z,ne=v.create();let te=0;Z.onDidAddListener=()=>{++te===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ne.print()),Y?.()}}}function x(Z,Y){return oe(Z,()=>{},0,void 0,!0,void 0,Y)}k.defer=x;function I(Z){return(Y,ne=null,te)=>{let le=!1,fe;return fe=Z(ce=>{if(!le)return fe?fe.dispose():le=!0,Y.call(ne,ce)},null,te),le&&fe.dispose(),fe}}k.once=I;function G(Z,Y,ne){return H((te,le=null,fe)=>Z(ce=>te.call(le,Y(ce)),null,fe),ne)}k.map=G;function K(Z,Y,ne){return H((te,le=null,fe)=>Z(ce=>{Y(ce),te.call(le,ce)},null,fe),ne)}k.forEach=K;function _(Z,Y,ne){return H((te,le=null,fe)=>Z(ce=>Y(ce)&&te.call(le,ce),null,fe),ne)}k.filter=_;function X(Z){return Z}k.signal=X;function Q(...Z){return(Y,ne=null,te)=>{const le=(0,y.$Rc)(...Z.map(fe=>fe(ce=>Y.call(ne,ce))));return ue(le,te)}}k.any=Q;function P(Z,Y,ne,te){let le=ne;return G(Z,fe=>(le=Y(le,fe),le),te)}k.reduce=P;function H(Z,Y){let ne;const te={onWillAddFirstListener(){ne=Z(le.fire,le)},onDidRemoveLastListener(){ne?.dispose()}};Y||R(te);const le=new l(te);return Y?.add(le),le.event}function ue(Z,Y){return Y instanceof Array?Y.push(Z):Y&&Y.add(Z),Z}function oe(Z,Y,ne=100,te=!1,le=!1,fe,ce){let de,me,Fe,De=0,Pe;const Ne={leakWarningThreshold:fe,onWillAddFirstListener(){de=Z(Oe=>{De++,me=Y(me,Oe),te&&!Fe&&(Te.fire(me),me=void 0),Pe=()=>{const Ve=me;me=void 0,Fe=void 0,(!te||De>1)&&Te.fire(Ve),De=0},typeof ne=="number"?(clearTimeout(Fe),Fe=setTimeout(Pe,ne)):Fe===void 0&&(Fe=0,queueMicrotask(Pe))})},onWillRemoveListener(){le&&De>0&&Pe?.()},onDidRemoveLastListener(){Pe=void 0,de.dispose()}};ce||R(Ne);const Te=new l(Ne);return ce?.add(Te),Te.event}k.debounce=oe;function n(Z,Y=0,ne){return k.debounce(Z,(te,le)=>te?(te.push(le),te):[le],Y,void 0,!0,void 0,ne)}k.accumulate=n;function $e(Z,Y=(te,le)=>te===le,ne){let te=!0,le;return _(Z,fe=>{const ce=te||!Y(fe,le);return te=!1,le=fe,ce},ne)}k.latch=$e;function ve(Z,Y,ne){return[k.filter(Z,Y,ne),k.filter(Z,te=>!Y(te),ne)]}k.split=ve;function Le(Z,Y=!1,ne=[],te){let le=ne.slice(),fe=Z(me=>{le?le.push(me):de.fire(me)});te&&te.add(fe);const ce=()=>{le?.forEach(me=>de.fire(me)),le=null},de=new l({onWillAddFirstListener(){fe||(fe=Z(me=>de.fire(me)),te&&te.add(fe))},onDidAddFirstListener(){le&&(Y?setTimeout(ce):ce())},onDidRemoveLastListener(){fe&&fe.dispose(),fe=null}});return te&&te.add(de),de.event}k.buffer=Le;function ke(Z,Y){return(te,le,fe)=>{const ce=Y(new xe);return Z(function(de){const me=ce.evaluate(de);me!==pe&&te.call(le,me)},void 0,fe)}}k.chain=ke;const pe=Symbol("HaltChainable");class xe{constructor(){this.f=[]}map(Y){return this.f.push(Y),this}forEach(Y){return this.f.push(ne=>(Y(ne),ne)),this}filter(Y){return this.f.push(ne=>Y(ne)?ne:pe),this}reduce(Y,ne){let te=ne;return this.f.push(le=>(te=Y(te,le),te)),this}latch(Y=(ne,te)=>ne===te){let ne=!0,te;return this.f.push(le=>{const fe=ne||!Y(le,te);return ne=!1,te=le,fe?le:pe}),this}evaluate(Y){for(const ne of this.f)if(Y=ne(Y),Y===pe)break;return Y}}function Ie(Z,Y,ne=te=>te){const te=(...de)=>ce.fire(ne(...de)),le=()=>Z.on(Y,te),fe=()=>Z.removeListener(Y,te),ce=new l({onWillAddFirstListener:le,onDidRemoveLastListener:fe});return ce.event}k.fromNodeEventEmitter=Ie;function Ce(Z,Y,ne=te=>te){const te=(...de)=>ce.fire(ne(...de)),le=()=>Z.addEventListener(Y,te),fe=()=>Z.removeEventListener(Y,te),ce=new l({onWillAddFirstListener:le,onDidRemoveLastListener:fe});return ce.event}k.fromDOMEventEmitter=Ce;function ye(Z){return new Promise(Y=>I(Z)(Y))}k.toPromise=ye;function B(Z){const Y=new l;return Z.then(ne=>{Y.fire(ne)},()=>{Y.fire(void 0)}).finally(()=>{Y.dispose()}),Y.event}k.fromPromise=B;function W(Z,Y,ne){return Y(ne),Z(te=>Y(te))}k.runAndSubscribe=W;class V{constructor(Y,ne){this._observable=Y,this.f=0,this.g=!1;const te={onWillAddFirstListener:()=>{Y.addObserver(this)},onDidRemoveLastListener:()=>{Y.removeObserver(this)}};ne||R(te),this.emitter=new l(te),ne&&ne.add(this.emitter)}beginUpdate(Y){this.f++}handlePossibleChange(Y){}handleChange(Y,ne){this.g=!0}endUpdate(Y){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function J(Z,Y){return new V(Z,Y).emitter.event}k.fromObservable=J;function ee(Z){return(Y,ne,te)=>{let le=0,fe=!1;const ce={beginUpdate(){le++},endUpdate(){le--,le===0&&(Z.reportChanges(),fe&&(fe=!1,Y.call(ne)))},handlePossibleChange(){},handleChange(){fe=!0}};Z.addObserver(ce),Z.reportChanges();const de={dispose(){Z.removeObserver(ce)}};return te instanceof y.$Tc?te.add(de):Array.isArray(te)&&te.push(de),de}}k.fromObservableLight=ee})(c||(t.Event=c={}));class p{static{this.all=new Set}static{this.f=0}constructor(R){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${R}_${p.f++}`,p.all.add(this)}start(R){this.g=new j.$3d,this.listenerCount=R}stop(){if(this.g){const R=this.g.elapsed();this.durations.push(R),this.elapsedOverall+=R,this.invocationCount+=1,this.g=void 0}}}t.$5d=p;let g=-1;function m(k){const R=g;return g=k,{dispose(){g=R}}}class e{constructor(R,x=Math.random().toString(18).slice(2,5)){this.threshold=R,this.name=x,this.g=0}dispose(){this.f?.clear()}check(R,x){const I=this.threshold;if(I<=0||x<I)return;this.f||(this.f=new Map);const G=this.f.get(R.value)||0;if(this.f.set(R.value,G+1),this.g-=1,this.g<=0){this.g=I*.5;let K,_=0;for(const[X,Q]of this.f)(!K||_<Q)&&(K=X,_=Q);console.warn(`[${this.name}] potential listener LEAK detected, having ${x} listeners already. MOST frequent listener (${_}):`),console.warn(K)}return()=>{const K=this.f.get(R.value)||0;this.f.set(R.value,K-1)}}}class v{static create(){return new v(new Error().stack??"")}constructor(R){this.value=R}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let E=0;class L{constructor(R){this.value=R,this.id=E++}}const $=2,b=(k,R)=>{if(k instanceof L)R(k);else for(let x=0;x<k.length;x++){const I=k[x];I&&R(I)}},a=h?new FinalizationRegistry(k=>{typeof k=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(k))}):void 0;class l{constructor(R){this.w=0,this.f=R,this.g=g>0||this.f?.leakWarningThreshold?new e(this.f?.leakWarningThreshold??g):void 0,this.j=this.f?._profName?new p(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(o){const R=this.t;queueMicrotask(()=>{b(R,x=>x.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(R,x,I)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),y.$Uc.None;if(this.m)return y.$Uc.None;x&&(R=R.bind(x));const G=new L(R);let K,_;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(G.stack=v.create(),K=this.g.check(G.stack,this.w+1)),o&&(G.stack=_??v.create()),this.t?this.t instanceof L?(this.u??=new u,this.t=[this.t,G]):this.t.push(G):(this.f?.onWillAddFirstListener?.(this),this.t=G,this.f?.onDidAddFirstListener?.(this)),this.w++;const X=(0,y.$Sc)(()=>{a?.unregister(X),K?.(),this.x(G)});if(I instanceof y.$Tc?I.add(X):Array.isArray(I)&&I.push(X),a){const Q=new Error().stack.split(`
`).slice(2).join(`
`).trim();a.register(X,Q,X)}return X},this.q}x(R){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const x=this.t,I=x.indexOf(R);if(I===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,x[I]=void 0;const G=this.u.current===this;if(this.w*$<=x.length){let K=0;for(let _=0;_<x.length;_++)x[_]?x[K++]=x[_]:G&&(this.u.end--,K<this.u.i&&this.u.i--);x.length=K}}y(R,x){if(!R)return;const I=this.f?.onListenerError||i.$1;if(!I){R.value(x);return}try{R.value(x)}catch(G){I(G)}}z(R){const x=R.current.t;for(;R.i<R.end;)this.y(x[R.i++],R.value);R.reset()}fire(R){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof L)this.y(this.t,R);else{const x=this.u;x.enqueue(this,R,this.t.length),this.z(x)}this.j?.stop()}hasListeners(){return this.w>0}}t.$7d=l;const r=()=>new u;t.$8d=r;class u{constructor(){this.i=-1,this.end=0}enqueue(R,x,I){this.i=0,this.end=I,this.current=R,this.value=x}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class N extends l{async fireAsync(R,x,I){if(this.t)for(this.h||(this.h=new f.$5c),b(this.t,G=>this.h.push([G.value,R]));this.h.size>0&&!x.isCancellationRequested;){const[G,K]=this.h.shift(),_=[],X={...K,token:x,waitUntil:Q=>{if(Object.isFrozen(_))throw new Error("waitUntil can NOT be called asynchronous");I&&(Q=I(Q,G)),_.push(Q)}};try{G(X)}catch(Q){(0,i.$1)(Q);continue}Object.freeze(_),await Promise.allSettled(_).then(Q=>{for(const P of Q)P.status==="rejected"&&(0,i.$1)(P.reason)})}}}t.$9d=N;class d extends l{get isPaused(){return this.h!==0}constructor(R){super(R),this.h=0,this.s=new f.$5c,this.A=R?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const R=Array.from(this.s);this.s.clear(),super.fire(this.A(R))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(R){this.w&&(this.h!==0?this.s.push(R):super.fire(R))}}t.$0d=d;class w extends d{constructor(R){super(R),this.k=R.delay??100}fire(R){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(R)}}t.$$d=w;class A extends l{constructor(R){super(R),this.h=[],this.k=R?.merge}fire(R){this.hasListeners()&&(this.h.push(R),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(x=>super.fire(x)),this.h=[]}))}}t.$_d=A;class C{constructor(){this.g=!1,this.h=[],this.f=new l({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(R){const x={event:R,listener:null};this.h.push(x),this.g&&this.m(x);const I=()=>{this.g&&this.o(x);const G=this.h.indexOf(x);this.h.splice(G,1)};return(0,y.$Sc)((0,F.$db)(I))}j(){this.g=!0,this.h.forEach(R=>this.m(R))}k(){this.g=!1,this.h.forEach(R=>this.o(R))}m(R){R.listener=R.event(x=>this.f.fire(x))}o(R){R.listener?.dispose(),R.listener=null}dispose(){this.f.dispose();for(const R of this.h)R.listener?.dispose();this.h=[]}}t.$ae=C;class M{constructor(R,x,I,G){this.f=new y.$Tc;const K=this.f.add(new C),_=this.f.add(new y.$4c);function X(Q){_.set(Q,K.add(G(Q)))}for(const Q of R)X(Q);this.f.add(x(Q=>{X(Q)})),this.f.add(I(Q=>{_.deleteAndDispose(Q)})),this.event=K.event}dispose(){this.f.dispose()}}t.$be=M;class T{constructor(){this.f=[]}wrapEvent(R){return(x,I,G)=>R(K=>{const _=this.f[this.f.length-1];_?_.push(()=>x.call(I,K)):x.call(I,K)},void 0,G)}bufferEvents(R){const x=[];this.f.push(x);const I=R();return this.f.pop(),x.forEach(G=>G()),I}}t.$ce=T;class S{constructor(){this.f=!1,this.g=c.None,this.h=y.$Uc.None,this.j=new l({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(R){this.g=R,this.f&&(this.h.dispose(),this.h=R(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$de=S}),re(ie[24],se([0,1,11]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ee=t.CancellationToken=void 0;const F=Object.freeze(function(h,o){const s=setTimeout(h.bind(o),0);return{dispose(){clearTimeout(s)}}});var y;(function(h){function o(s){return s===h.None||s===h.Cancelled||s instanceof f?!0:!s||typeof s!="object"?!1:typeof s.isCancellationRequested=="boolean"&&typeof s.onCancellationRequested=="function"}h.isCancellationToken=o,h.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),h.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(y||(t.CancellationToken=y={}));class f{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?F:(this.b||(this.b=new i.$7d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class j{constructor(o){this.f=void 0,this.g=void 0,this.g=o&&o.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new f),this.f}cancel(){this.f?this.f instanceof f&&this.f.cancel():this.f=y.Cancelled}dispose(o=!1){o&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof f&&this.f.dispose():this.f=y.None}}t.$ee=j}),re(ie[40],se([0,1,24]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Re=t.$Qe=t.$Pe=void 0;class F{constructor(h){this.b=h,this.a=null}get(){if(this.a)return this.a;const h=new i.$ee,o=this.b(h.token);return this.a={promise:o,dispose:()=>{this.a=null,h.cancel(),h.dispose()}},this.a}}t.$Pe=F;class y{constructor(h){this.c=h,this.a=void 0,this.b=void 0}get(h){const o=JSON.stringify(h);return this.b!==o&&(this.b=o,this.a=this.c(h)),this.a}}t.$Qe=y;class f{get cachedValues(){return this.a}constructor(h){this.b=h,this.a=new Map}get(h){if(this.a.has(h))return this.a.get(h);const o=this.b(h);return this.a.set(h,o),o}}t.$Re=f}),re(ie[7],se([0,1,40,39]),function(O,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uf=t.$Tf=t.$Sf=t.GraphemeBreakType=t.$If=t.$Bf=t.$uf=t.$tf=void 0,t.$Ue=y,t.$Ve=j,t.$We=o,t.$Xe=s,t.$Ye=c,t.$Ze=p,t.$1e=g,t.$2e=m,t.$3e=e,t.$4e=v,t.$5e=E,t.$6e=L,t.$7e=$,t.$8e=b,t.$9e=a,t.$0e=l,t.$$e=r,t.$_e=u,t.$af=N,t.$bf=d,t.$cf=w,t.$df=A,t.$ef=C,t.$ff=M,t.$gf=T,t.$hf=S,t.$if=k,t.$jf=R,t.$kf=x,t.$lf=I,t.$mf=G,t.$nf=K,t.$of=_,t.$pf=X,t.$qf=Q,t.$rf=P,t.$sf=H,t.$vf=$e,t.$wf=ve,t.$xf=Le,t.$yf=ke,t.$zf=Ie,t.$Af=ye,t.$Cf=B,t.$Df=W,t.$Ef=V,t.$Ff=J,t.$Gf=Z,t.$Hf=Y,t.$Jf=ne,t.$Kf=te,t.$Lf=le,t.$Mf=fe,t.$Nf=ce,t.$Of=de,t.$Pf=me,t.$Qf=Fe,t.$Rf=Oe;function y(D){return!D||typeof D!="string"?!0:D.trim().length===0}const f=/{(\d+)}/g;function j(D,...q){return q.length===0?D:D.replace(f,function(z,U){const ae=parseInt(U,10);return isNaN(ae)||ae<0||ae>=q.length?z:q[ae]})}const h=/{([^}]+)}/g;function o(D,q){return Object.keys(q).length===0?D:D.replace(h,(z,U)=>q[U]??z)}function s(D){return D.replace(/[<>"'&]/g,q=>{switch(q){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return q})}function c(D){return D.replace(/[<>&]/g,function(q){switch(q){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return q}})}function p(D){return D.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function g(D,q){let z=0;const U=q.charCodeAt(0);for(let ae=D.length-1;ae>=0;ae--)D.charCodeAt(ae)===U&&z++;return z}function m(D,q,z="\u2026"){return D.length<=q?D:`${D.substr(0,q)}${z}`}function e(D,q,z="\u2026"){if(D.length<=q)return D;const U=Math.ceil(q/2)-z.length/2,ae=Math.floor(q/2)-z.length/2;return`${D.substr(0,U)}${z}${D.substr(D.length-ae)}`}function v(D,q=" "){const z=E(D,q);return L(z,q)}function E(D,q){if(!D||!q)return D;const z=q.length;if(z===0||D.length===0)return D;let U=0;for(;D.indexOf(q,U)===U;)U=U+z;return D.substring(U)}function L(D,q){if(!D||!q)return D;const z=q.length,U=D.length;if(z===0||U===0)return D;let ae=U,he=-1;for(;he=D.lastIndexOf(q,ae-1),!(he===-1||he+z!==ae);){if(he===0)return"";ae=he}return D.substring(0,ae)}function $(D){return D.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function b(D){return D.replace(/\*/g,"")}function a(D,q,z={}){if(!D)throw new Error("Cannot create regex from empty string");q||(D=p(D)),z.wholeWord&&(/\B/.test(D.charAt(0))||(D="\\b"+D),/\B/.test(D.charAt(D.length-1))||(D=D+"\\b"));let U="";return z.global&&(U+="g"),z.matchCase||(U+="i"),z.multiline&&(U+="m"),z.unicode&&(U+="u"),new RegExp(D,U)}function l(D){return D.source==="^"||D.source==="^$"||D.source==="$"||D.source==="^\\s*$"?!1:!!(D.exec("")&&D.lastIndex===0)}function r(D){return D.split(/\r\n|\r|\n/)}function u(D){const q=[],z=D.split(/(\r\n|\r|\n)/);for(let U=0;U<Math.ceil(z.length/2);U++)q.push(z[2*U]+(z[2*U+1]??""));return q}function N(D){for(let q=0,z=D.length;q<z;q++){const U=D.charCodeAt(q);if(U!==32&&U!==9)return q}return-1}function d(D,q=0,z=D.length){for(let U=q;U<z;U++){const ae=D.charCodeAt(U);if(ae!==32&&ae!==9)return D.substring(q,U)}return D.substring(q,z)}function w(D,q=D.length-1){for(let z=q;z>=0;z--){const U=D.charCodeAt(z);if(U!==32&&U!==9)return z}return-1}function A(D,q,z){const U=[];let ae=0;for(const he of D.matchAll(q)){if(U.push(D.slice(ae,he.index)),he.index===void 0)throw new Error("match.index should be defined");ae=he.index+he[0].length,U.push(z(he[0],...he.slice(1),he.index,D,he.groups))}return U.push(D.slice(ae)),Promise.all(U).then(he=>he.join(""))}function C(D,q){return D<q?-1:D>q?1:0}function M(D,q,z=0,U=D.length,ae=0,he=q.length){for(;z<U&&ae<he;z++,ae++){const je=D.charCodeAt(z),Ee=q.charCodeAt(ae);if(je<Ee)return-1;if(je>Ee)return 1}const be=U-z,Re=he-ae;return be<Re?-1:be>Re?1:0}function T(D,q){return S(D,q,0,D.length,0,q.length)}function S(D,q,z=0,U=D.length,ae=0,he=q.length){for(;z<U&&ae<he;z++,ae++){let je=D.charCodeAt(z),Ee=q.charCodeAt(ae);if(je===Ee)continue;if(je>=128||Ee>=128)return M(D.toLowerCase(),q.toLowerCase(),z,U,ae,he);R(je)&&(je-=32),R(Ee)&&(Ee-=32);const we=je-Ee;if(we!==0)return we}const be=U-z,Re=he-ae;return be<Re?-1:be>Re?1:0}function k(D){return D>=48&&D<=57}function R(D){return D>=97&&D<=122}function x(D){return D>=65&&D<=90}function I(D,q){return D.length===q.length&&S(D,q)===0}function G(D,q){const z=q.length;return q.length>D.length?!1:S(D,q,0,z)===0}function K(D,q){const z=Math.min(D.length,q.length);let U;for(U=0;U<z;U++)if(D.charCodeAt(U)!==q.charCodeAt(U))return U;return z}function _(D,q){const z=Math.min(D.length,q.length);let U;const ae=D.length-1,he=q.length-1;for(U=0;U<z;U++)if(D.charCodeAt(ae-U)!==q.charCodeAt(he-U))return U;return z}function X(D){return 55296<=D&&D<=56319}function Q(D){return 56320<=D&&D<=57343}function P(D,q){return(D-55296<<10)+(q-56320)+65536}function H(D,q,z){const U=D.charCodeAt(z);if(X(U)&&z+1<q){const ae=D.charCodeAt(z+1);if(Q(ae))return P(U,ae)}return U}function ue(D,q){const z=D.charCodeAt(q-1);if(Q(z)&&q>1){const U=D.charCodeAt(q-2);if(X(U))return P(U,z)}return z}class oe{get offset(){return this.e}constructor(q,z=0){this.c=q,this.d=q.length,this.e=z}setOffset(q){this.e=q}prevCodePoint(){const q=ue(this.c,this.e);return this.e-=q>=65536?2:1,q}nextCodePoint(){const q=H(this.c,this.d,this.e);return this.e+=q>=65536?2:1,q}eol(){return this.e>=this.d}}t.$tf=oe;class n{get offset(){return this.c.offset}constructor(q,z=0){this.c=new oe(q,z)}nextGraphemeLength(){const q=Ne.getInstance(),z=this.c,U=z.offset;let ae=q.getGraphemeBreakType(z.nextCodePoint());for(;!z.eol();){const he=z.offset,be=q.getGraphemeBreakType(z.nextCodePoint());if(De(ae,be)){z.setOffset(he);break}ae=be}return z.offset-U}prevGraphemeLength(){const q=Ne.getInstance(),z=this.c,U=z.offset;let ae=q.getGraphemeBreakType(z.prevCodePoint());for(;z.offset>0;){const he=z.offset,be=q.getGraphemeBreakType(z.prevCodePoint());if(De(be,ae)){z.setOffset(he);break}ae=be}return U-z.offset}eol(){return this.c.eol()}}t.$uf=n;function $e(D,q){return new n(D,q).nextGraphemeLength()}function ve(D,q){return new n(D,q).prevGraphemeLength()}function Le(D,q){q>0&&Q(D.charCodeAt(q))&&q--;const z=q+$e(D,q);return[z-ve(D,z),z]}function ke(D){const q=new n(D);let z=0;for(;!q.eol();)z++,q.nextGraphemeLength();return z}let pe;function xe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ie(D){return pe||(pe=xe()),pe.test(D)}const Ce=/^[\t\n\r\x20-\x7E]*$/;function ye(D){return Ce.test(D)}t.$Bf=/[\u2028\u2029]/;function B(D){return t.$Bf.test(D)}function W(D){return D>=11904&&D<=55215||D>=63744&&D<=64255||D>=65281&&D<=65374}function V(D){return D>=127462&&D<=127487||D===8986||D===8987||D===9200||D===9203||D>=9728&&D<=10175||D===11088||D===11093||D>=127744&&D<=128591||D>=128640&&D<=128764||D>=128992&&D<=129008||D>=129280&&D<=129535||D>=129648&&D<=129782}function J(D,q,z=""){const U=D.trimStart();if(U.length<q)return U;const ae=/\b/g;let he=0;for(;ae.test(U)&&!(U.length-ae.lastIndex<q);)he=ae.lastIndex,ae.lastIndex+=1;return he===0?U:z+U.substring(he).trimStart()}const ee=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Z(D){let q=0;for(const z of D.matchAll(ee))q!==z.index&&(yield{isCode:!1,str:D.substring(q,z.index)}),yield{isCode:!0,str:z[0]},q=z.index+z[0].length;q!==D.length&&(yield{isCode:!1,str:D.substring(q)})}function Y(D){return D&&(D=D.replace(ee,"")),D}t.$If="\uFEFF";function ne(D){return!!(D&&D.length>0&&D.charCodeAt(0)===65279)}function te(D){return ne(D)?D.substr(1):D}function le(D,q){if(!D||!q||D.length<q.length)return!1;const z=q.length,U=D.toLowerCase();let ae=0,he=-1;for(;ae<z;){const be=U.indexOf(q[ae],he+1);if(be<0)return!1;he=be,ae++}return!0}function fe(D,q=!1){return D?(q&&(D=D.replace(/\\./g,"")),D.toLowerCase()!==D):!1}function ce(D){return D.charAt(0).toUpperCase()+D.slice(1)}function de(D,q=1){if(q===0)return"";let z=-1;do z=D.indexOf(`
`,z+1),q--;while(q>0&&z>=0);return z===-1?D:(D[z-1]==="\r"&&z--,D.substr(0,z))}function me(D){return D=D%(2*26),D<26?String.fromCharCode(97+D):String.fromCharCode(65+D-26)}function Fe(D){return Ne.getInstance().getGraphemeBreakType(D)}function De(D,q){return D===0?q!==5&&q!==7:D===2&&q===3?!1:D===4||D===2||D===3||q===4||q===2||q===3?!0:!(D===8&&(q===8||q===9||q===11||q===12)||(D===11||D===9)&&(q===9||q===10)||(D===12||D===10)&&q===10||q===5||q===13||q===7||D===1||D===13&&q===14||D===6&&q===6)}var Pe;(function(D){D[D.Other=0]="Other",D[D.Prepend=1]="Prepend",D[D.CR=2]="CR",D[D.LF=3]="LF",D[D.Control=4]="Control",D[D.Extend=5]="Extend",D[D.Regional_Indicator=6]="Regional_Indicator",D[D.SpacingMark=7]="SpacingMark",D[D.L=8]="L",D[D.V=9]="V",D[D.T=10]="T",D[D.LV=11]="LV",D[D.LVT=12]="LVT",D[D.ZWJ=13]="ZWJ",D[D.Extended_Pictographic=14]="Extended_Pictographic"})(Pe||(t.GraphemeBreakType=Pe={}));class Ne{static{this.c=null}static getInstance(){return Ne.c||(Ne.c=new Ne),Ne.c}constructor(){this.d=Te()}getGraphemeBreakType(q){if(q<32)return q===10?3:q===13?2:4;if(q<127)return 0;const z=this.d,U=z.length/3;let ae=1;for(;ae<=U;)if(q<z[3*ae])ae=2*ae;else if(q>z[3*ae+1])ae=2*ae+1;else return z[3*ae+2];return 0}}function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Oe(D,q){if(D===0)return 0;const z=Ve(D,q);if(z!==void 0)return z;const U=new oe(q,D);return U.prevCodePoint(),U.offset}function Ve(D,q){const z=new oe(q,D);let U=z.prevCodePoint();for(;Xe(U)||U===65039||U===8419;){if(z.offset===0)return;U=z.prevCodePoint()}if(!V(U))return;let ae=z.offset;return ae>0&&z.prevCodePoint()===8205&&(ae=z.offset),ae}function Xe(D){return 127995<=D&&D<=127999}var He;(function(D){D[D.zwj=8205]="zwj",D[D.emojiVariantSelector=65039]="emojiVariantSelector",D[D.enclosingKeyCap=8419]="enclosingKeyCap"})(He||(He={})),t.$Sf="\xA0";class Se{static{this.c=new F.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$Qe(q=>{function z(we){const Me=new Map;for(let Ae=0;Ae<we.length;Ae+=2)Me.set(we[Ae],we[Ae+1]);return Me}function U(we,Me){const Ae=new Map(we);for(const[Be,We]of Me)Ae.set(Be,We);return Ae}function ae(we,Me){if(!we)return Me;const Ae=new Map;for(const[Be,We]of we)Me.has(Be)&&Ae.set(Be,We);return Ae}const he=this.c.value;let be=q.filter(we=>!we.startsWith("_")&&we in he);be.length===0&&(be=["_default"]);let Re;for(const we of be){const Me=z(he[we]);Re=ae(Re,Me)}const je=z(he._common),Ee=U(je,Re);return new Se(Ee)})}static getInstance(q){return Se.d.get(Array.from(q))}static{this.e=new F.$V(()=>Object.keys(Se.c.value).filter(q=>!q.startsWith("_")))}static getLocales(){return Se.e.value}constructor(q){this.f=q}isAmbiguous(q){return this.f.has(q)}getPrimaryConfusable(q){return this.f.get(q)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$Tf=Se;class qe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(qe.c())),this.d}static isInvisibleCharacter(q){return qe.e().has(q)}static get codePoints(){return qe.e()}}t.$Uf=qe}),re(ie[41],se([0,1,7]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cj=t.$aj=void 0,t.$9i=F,t.$0i=y,t.$$i=f,t.$_i=h,t.$bj=v;function F(L){return y(L,0)}function y(L,$){switch(typeof L){case"object":return L===null?f(349,$):Array.isArray(L)?o(L,$):s(L,$);case"string":return h(L,$);case"boolean":return j(L,$);case"number":return f(L,$);case"undefined":return f(937,$);default:return f(617,$)}}function f(L,$){return($<<5)-$+L|0}function j(L,$){return f(L?433:863,$)}function h(L,$){$=f(149417,$);for(let b=0,a=L.length;b<a;b++)$=f(L.charCodeAt(b),$);return $}function o(L,$){return $=f(104579,$),L.reduce((b,a)=>y(a,b),$)}function s(L,$){return $=f(181387,$),Object.keys(L).sort().reduce((b,a)=>(b=h(a,b),y(L[a],b)),$)}class c{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=y($,this.g),this.g}}t.$aj=c;var p;(function(L){L[L.BLOCK_SIZE=64]="BLOCK_SIZE",L[L.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(p||(p={}));function g(L,$,b=32){const a=b-$,l=~((1<<a)-1);return(L<<$|(l&L)>>>a)>>>0}function m(L,$=0,b=L.byteLength,a=0){for(let l=0;l<b;l++)L[$+l]=a}function e(L,$,b="0"){for(;L.length<$;)L=b+L;return L}function v(L,$=32){return L instanceof ArrayBuffer?Array.from(new Uint8Array(L)).map(b=>b.toString(16).padStart(2,"0")).join(""):e((L>>>0).toString(16),$/4)}class E{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const b=$.length;if(b===0)return;const a=this.p;let l=this.r,r=this.u,u,N;for(r!==0?(u=r,N=-1,r=0):(u=$.charCodeAt(0),N=0);;){let d=u;if(i.$pf(u))if(N+1<b){const w=$.charCodeAt(N+1);i.$qf(w)?(N++,d=i.$rf(u,w)):d=65533}else{r=u;break}else i.$qf(u)&&(d=65533);if(l=this.w(a,l,d),N++,N<b)u=$.charCodeAt(N);else break}this.r=l,this.u=r}w($,b,a){return a<128?$[b++]=a:a<2048?($[b++]=192|(a&1984)>>>6,$[b++]=128|(a&63)>>>0):a<65536?($[b++]=224|(a&61440)>>>12,$[b++]=128|(a&4032)>>>6,$[b++]=128|(a&63)>>>0):($[b++]=240|(a&1835008)>>>18,$[b++]=128|(a&258048)>>>12,$[b++]=128|(a&4032)>>>6,$[b++]=128|(a&63)>>>0),b>=64&&(this.y(),b-=64,this.t+=64,$[0]=$[64],$[1]=$[65],$[2]=$[66]),b}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=E.g,b=this.q;for(let C=0;C<64;C+=4)$.setUint32(C,b.getUint32(C,!1),!1);for(let C=64;C<320;C+=4)$.setUint32(C,g($.getUint32(C-12,!1)^$.getUint32(C-32,!1)^$.getUint32(C-56,!1)^$.getUint32(C-64,!1),1),!1);let a=this.h,l=this.l,r=this.m,u=this.n,N=this.o,d,w,A;for(let C=0;C<80;C++)C<20?(d=l&r|~l&u,w=1518500249):C<40?(d=l^r^u,w=1859775393):C<60?(d=l&r|l&u|r&u,w=2400959708):(d=l^r^u,w=3395469782),A=g(a,5)+d+N+w+$.getUint32(C*4,!1)&4294967295,N=u,u=r,r=g(l,30),l=a,a=A;this.h=this.h+a&4294967295,this.l=this.l+l&4294967295,this.m=this.m+r&4294967295,this.n=this.n+u&4294967295,this.o=this.o+N&4294967295}}t.$cj=E}),re(ie[25],se([0,1,37,41]),function(O,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$it=t.$gt=void 0,t.$ht=f;class y{constructor(g){this.a=g}getElements(){const g=this.a,m=new Int32Array(g.length);for(let e=0,v=g.length;e<v;e++)m[e]=g.charCodeAt(e);return m}}t.$gt=y;function f(p,g,m){return new c(new y(p),new y(g)).ComputeDiff(m).changes}class j{static Assert(g,m){if(!g)throw new Error(m)}}class h{static Copy(g,m,e,v,E){for(let L=0;L<E;L++)e[v+L]=g[m+L]}static Copy2(g,m,e,v,E){for(let L=0;L<E;L++)e[v+L]=g[m+L]}}var o;(function(p){p[p.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(o||(o={}));class s{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new i.$ft(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(g,m){this.b=Math.min(this.b,g),this.c=Math.min(this.c,m),this.d++}AddModifiedElement(g,m){this.b=Math.min(this.b,g),this.c=Math.min(this.c,m),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class c{constructor(g,m,e=null){this.a=e,this.b=g,this.c=m;const[v,E,L]=c.o(g),[$,b,a]=c.o(m);this.d=L&&a,this.e=v,this.f=E,this.g=$,this.h=b,this.k=[],this.m=[]}static n(g){return g.length>0&&typeof g[0]=="string"}static o(g){const m=g.getElements();if(c.n(m)){const e=new Int32Array(m.length);for(let v=0,E=m.length;v<E;v++)e[v]=(0,F.$_i)(m[v],0);return[m,e,!0]}return m instanceof Int32Array?[[],m,!1]:[[],new Int32Array(m),!1]}p(g,m){return this.f[g]!==this.h[m]?!1:this.d?this.e[g]===this.g[m]:!0}q(g,m){if(!this.p(g,m))return!1;const e=c.r(this.b,g),v=c.r(this.c,m);return e===v}static r(g,m){return typeof g.getStrictElement=="function"?g.getStrictElement(m):null}s(g,m){return this.f[g]!==this.f[m]?!1:this.d?this.e[g]===this.e[m]:!0}u(g,m){return this.h[g]!==this.h[m]?!1:this.d?this.g[g]===this.g[m]:!0}ComputeDiff(g){return this.v(0,this.f.length-1,0,this.h.length-1,g)}v(g,m,e,v,E){const L=[!1];let $=this.w(g,m,e,v,L);return E&&($=this.z($)),{quitEarly:L[0],changes:$}}w(g,m,e,v,E){for(E[0]=!1;g<=m&&e<=v&&this.p(g,e);)g++,e++;for(;m>=g&&v>=e&&this.p(m,v);)m--,v--;if(g>m||e>v){let r;return e<=v?(j.Assert(g===m+1,"originalStart should only be one more than originalEnd"),r=[new i.$ft(g,0,e,v-e+1)]):g<=m?(j.Assert(e===v+1,"modifiedStart should only be one more than modifiedEnd"),r=[new i.$ft(g,m-g+1,e,0)]):(j.Assert(g===m+1,"originalStart should only be one more than originalEnd"),j.Assert(e===v+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const L=[0],$=[0],b=this.y(g,m,e,v,L,$,E),a=L[0],l=$[0];if(b!==null)return b;if(!E[0]){const r=this.w(g,a,e,l,E);let u=[];return E[0]?u=[new i.$ft(a+1,m-(a+1)+1,l+1,v-(l+1)+1)]:u=this.w(a+1,m,l+1,v,E),this.H(r,u)}return[new i.$ft(g,m-g+1,e,v-e+1)]}x(g,m,e,v,E,L,$,b,a,l,r,u,N,d,w,A,C,M){let T=null,S=null,k=new s,R=m,x=e,I=N[0]-A[0]-v,G=-1073741824,K=this.k.length-1;do{const _=I+g;_===R||_<x&&a[_-1]<a[_+1]?(r=a[_+1],d=r-I-v,r<G&&k.MarkNextChange(),G=r,k.AddModifiedElement(r+1,d),I=_+1-g):(r=a[_-1]+1,d=r-I-v,r<G&&k.MarkNextChange(),G=r-1,k.AddOriginalElement(r,d+1),I=_-1-g),K>=0&&(a=this.k[K],g=a[0],R=1,x=a.length-1)}while(--K>=-1);if(T=k.getReverseChanges(),M[0]){let _=N[0]+1,X=A[0]+1;if(T!==null&&T.length>0){const Q=T[T.length-1];_=Math.max(_,Q.getOriginalEnd()),X=Math.max(X,Q.getModifiedEnd())}S=[new i.$ft(_,u-_+1,X,w-X+1)]}else{k=new s,R=L,x=$,I=N[0]-A[0]-b,G=1073741824,K=C?this.m.length-1:this.m.length-2;do{const _=I+E;_===R||_<x&&l[_-1]>=l[_+1]?(r=l[_+1]-1,d=r-I-b,r>G&&k.MarkNextChange(),G=r+1,k.AddOriginalElement(r+1,d+1),I=_+1-E):(r=l[_-1],d=r-I-b,r>G&&k.MarkNextChange(),G=r,k.AddModifiedElement(r+1,d+1),I=_-1-E),K>=0&&(l=this.m[K],E=l[0],R=1,x=l.length-1)}while(--K>=-1);S=k.getChanges()}return this.H(T,S)}y(g,m,e,v,E,L,$){let b=0,a=0,l=0,r=0,u=0,N=0;g--,e--,E[0]=0,L[0]=0,this.k=[],this.m=[];const d=m-g+(v-e),w=d+1,A=new Int32Array(w),C=new Int32Array(w),M=v-e,T=m-g,S=g-e,k=m-v,x=(T-M)%2===0;A[M]=g,C[T]=m,$[0]=!1;for(let I=1;I<=d/2+1;I++){let G=0,K=0;l=this.J(M-I,I,M,w),r=this.J(M+I,I,M,w);for(let X=l;X<=r;X+=2){X===l||X<r&&A[X-1]<A[X+1]?b=A[X+1]:b=A[X-1]+1,a=b-(X-M)-S;const Q=b;for(;b<m&&a<v&&this.p(b+1,a+1);)b++,a++;if(A[X]=b,b+a>G+K&&(G=b,K=a),!x&&Math.abs(X-T)<=I-1&&b>=C[X])return E[0]=b,L[0]=a,Q<=C[X]&&1447>0&&I<=1448?this.x(M,l,r,S,T,u,N,k,A,C,b,m,E,a,v,L,x,$):null}const _=(G-g+(K-e)-I)/2;if(this.a!==null&&!this.a(G,_))return $[0]=!0,E[0]=G,L[0]=K,_>0&&1447>0&&I<=1448?this.x(M,l,r,S,T,u,N,k,A,C,b,m,E,a,v,L,x,$):(g++,e++,[new i.$ft(g,m-g+1,e,v-e+1)]);u=this.J(T-I,I,T,w),N=this.J(T+I,I,T,w);for(let X=u;X<=N;X+=2){X===u||X<N&&C[X-1]>=C[X+1]?b=C[X+1]-1:b=C[X-1],a=b-(X-T)-k;const Q=b;for(;b>g&&a>e&&this.p(b,a);)b--,a--;if(C[X]=b,x&&Math.abs(X-M)<=I&&b<=A[X])return E[0]=b,L[0]=a,Q>=A[X]&&1447>0&&I<=1448?this.x(M,l,r,S,T,u,N,k,A,C,b,m,E,a,v,L,x,$):null}if(I<=1447){let X=new Int32Array(r-l+2);X[0]=M-l+1,h.Copy2(A,l,X,1,r-l+1),this.k.push(X),X=new Int32Array(N-u+2),X[0]=T-u+1,h.Copy2(C,u,X,1,N-u+1),this.m.push(X)}}return this.x(M,l,r,S,T,u,N,k,A,C,b,m,E,a,v,L,x,$)}z(g){for(let m=0;m<g.length;m++){const e=g[m],v=m<g.length-1?g[m+1].originalStart:this.f.length,E=m<g.length-1?g[m+1].modifiedStart:this.h.length,L=e.originalLength>0,$=e.modifiedLength>0;for(;e.originalStart+e.originalLength<v&&e.modifiedStart+e.modifiedLength<E&&(!L||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!$||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const a=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!a)break;e.originalStart++,e.modifiedStart++}const b=[null];if(m<g.length-1&&this.I(g[m],g[m+1],b)){g[m]=b[0],g.splice(m+1,1),m--;continue}}for(let m=g.length-1;m>=0;m--){const e=g[m];let v=0,E=0;if(m>0){const r=g[m-1];v=r.originalStart+r.originalLength,E=r.modifiedStart+r.modifiedLength}const L=e.originalLength>0,$=e.modifiedLength>0;let b=0,a=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let r=1;;r++){const u=e.originalStart-r,N=e.modifiedStart-r;if(u<v||N<E||L&&!this.s(u,u+e.originalLength)||$&&!this.u(N,N+e.modifiedLength))break;const w=(u===v&&N===E?5:0)+this.G(u,e.originalLength,N,e.modifiedLength);w>a&&(a=w,b=r)}e.originalStart-=b,e.modifiedStart-=b;const l=[null];if(m>0&&this.I(g[m-1],g[m],l)){g[m-1]=l[0],g.splice(m,1),m++;continue}}if(this.d)for(let m=1,e=g.length;m<e;m++){const v=g[m-1],E=g[m],L=E.originalStart-v.originalStart-v.originalLength,$=v.originalStart,b=E.originalStart+E.originalLength,a=b-$,l=v.modifiedStart,r=E.modifiedStart+E.modifiedLength,u=r-l;if(L<5&&a<20&&u<20){const N=this.A($,a,l,u,L);if(N){const[d,w]=N;(d!==v.originalStart+v.originalLength||w!==v.modifiedStart+v.modifiedLength)&&(v.originalLength=d-v.originalStart,v.modifiedLength=w-v.modifiedStart,E.originalStart=d+L,E.modifiedStart=w+L,E.originalLength=b-E.originalStart,E.modifiedLength=r-E.modifiedStart)}}}return g}A(g,m,e,v,E){if(m<E||v<E)return null;const L=g+m-E+1,$=e+v-E+1;let b=0,a=0,l=0;for(let r=g;r<L;r++)for(let u=e;u<$;u++){const N=this.B(r,u,E);N>0&&N>b&&(b=N,a=r,l=u)}return b>0?[a,l]:null}B(g,m,e){let v=0;for(let E=0;E<e;E++){if(!this.p(g+E,m+E))return 0;v+=this.e[g+E].length}return v}C(g){return g<=0||g>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[g])}D(g,m){if(this.C(g)||this.C(g-1))return!0;if(m>0){const e=g+m;if(this.C(e-1)||this.C(e))return!0}return!1}E(g){return g<=0||g>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[g])}F(g,m){if(this.E(g)||this.E(g-1))return!0;if(m>0){const e=g+m;if(this.E(e-1)||this.E(e))return!0}return!1}G(g,m,e,v){const E=this.D(g,m)?1:0,L=this.F(e,v)?1:0;return E+L}H(g,m){const e=[];if(g.length===0||m.length===0)return m.length>0?m:g;if(this.I(g[g.length-1],m[0],e)){const v=new Array(g.length+m.length-1);return h.Copy(g,0,v,0,g.length-1),v[g.length-1]=e[0],h.Copy(m,1,v,g.length,m.length-1),v}else{const v=new Array(g.length+m.length);return h.Copy(g,0,v,0,g.length),h.Copy(m,0,v,g.length,m.length),v}}I(g,m,e){if(j.Assert(g.originalStart<=m.originalStart,"Left change is not less than or equal to right change"),j.Assert(g.modifiedStart<=m.modifiedStart,"Left change is not less than or equal to right change"),g.originalStart+g.originalLength>=m.originalStart||g.modifiedStart+g.modifiedLength>=m.modifiedStart){const v=g.originalStart;let E=g.originalLength;const L=g.modifiedStart;let $=g.modifiedLength;return g.originalStart+g.originalLength>=m.originalStart&&(E=m.originalStart+m.originalLength-g.originalStart),g.modifiedStart+g.modifiedLength>=m.modifiedStart&&($=m.modifiedStart+m.modifiedLength-g.modifiedStart),e[0]=new i.$ft(v,E,L,$),!0}else return e[0]=null,!1}J(g,m,e,v){if(g>=0&&g<v)return g;const E=e,L=v-e-1,$=m%2===0;if(g<0){const b=E%2===0;return $===b?0:1}else{const b=L%2===0;return $===b?v-1:v-2}}}t.$it=c}),re(ie[26],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vf=i,t.$Wf=F,t.$Xf=y,t.$Yf=f,t.$Zf=j,t.$1f=h,t.$2f=o,t.$3f=s,t.$4f=c,t.$5f=p,t.$6f=g,t.$7f=m,t.$8f=e,t.$9f=E,t.$0f=L,t.$$f=$,t.$_f=b,t.$ag=a;function i(l){return typeof l=="string"}function F(l){return Array.isArray(l)&&l.every(r=>i(r))}function y(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}function f(l){const r=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof r}function j(l){return typeof l=="number"&&!isNaN(l)}function h(l){return!!l&&typeof l[Symbol.iterator]=="function"}function o(l){return l===!0||l===!1}function s(l){return typeof l>"u"}function c(l){return!p(l)}function p(l){return s(l)||l===null}function g(l,r){if(!l)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}function m(l){if(p(l))throw new Error("Assertion Failed: argument is undefined or null");return l}function e(...l){const r=[];for(let u=0;u<l.length;u++){const N=l[u];if(p(N))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);r.push(N)}return r}const v=Object.prototype.hasOwnProperty;function E(l){if(!y(l))return!1;for(const r in l)if(v.call(l,r))return!1;return!0}function L(l){return typeof l=="function"}function $(...l){return l.length>0&&l.every(L)}function b(l,r){const u=Math.min(l.length,r.length);for(let N=0;N<u;N++)a(l[N],r[N])}function a(l,r){if(i(r)){if(typeof l!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(L(r)){try{if(l instanceof r)return}catch{}if(!p(l)&&l.constructor===r||r.length===1&&r.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),re(ie[27],se([0,1,26]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Cj=y,t.$Dj=f;const F=Object.create(null);function y(j,h){if((0,i.$Vf)(h)){const o=F[h];if(o===void 0)throw new Error(`${j} references an unknown codicon: ${h}`);h=o}return F[j]=h,{id:j}}function f(){return F}}),re(ie[42],se([0,1,27]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ej=void 0,t.$Ej={add:(0,i.$Cj)("add",6e4),plus:(0,i.$Cj)("plus",6e4),gistNew:(0,i.$Cj)("gist-new",6e4),repoCreate:(0,i.$Cj)("repo-create",6e4),lightbulb:(0,i.$Cj)("lightbulb",60001),lightBulb:(0,i.$Cj)("light-bulb",60001),repo:(0,i.$Cj)("repo",60002),repoDelete:(0,i.$Cj)("repo-delete",60002),gistFork:(0,i.$Cj)("gist-fork",60003),repoForked:(0,i.$Cj)("repo-forked",60003),gitPullRequest:(0,i.$Cj)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$Cj)("git-pull-request-abandoned",60004),recordKeys:(0,i.$Cj)("record-keys",60005),keyboard:(0,i.$Cj)("keyboard",60005),tag:(0,i.$Cj)("tag",60006),gitPullRequestLabel:(0,i.$Cj)("git-pull-request-label",60006),tagAdd:(0,i.$Cj)("tag-add",60006),tagRemove:(0,i.$Cj)("tag-remove",60006),person:(0,i.$Cj)("person",60007),personFollow:(0,i.$Cj)("person-follow",60007),personOutline:(0,i.$Cj)("person-outline",60007),personFilled:(0,i.$Cj)("person-filled",60007),gitBranch:(0,i.$Cj)("git-branch",60008),gitBranchCreate:(0,i.$Cj)("git-branch-create",60008),gitBranchDelete:(0,i.$Cj)("git-branch-delete",60008),sourceControl:(0,i.$Cj)("source-control",60008),mirror:(0,i.$Cj)("mirror",60009),mirrorPublic:(0,i.$Cj)("mirror-public",60009),star:(0,i.$Cj)("star",60010),starAdd:(0,i.$Cj)("star-add",60010),starDelete:(0,i.$Cj)("star-delete",60010),starEmpty:(0,i.$Cj)("star-empty",60010),comment:(0,i.$Cj)("comment",60011),commentAdd:(0,i.$Cj)("comment-add",60011),alert:(0,i.$Cj)("alert",60012),warning:(0,i.$Cj)("warning",60012),search:(0,i.$Cj)("search",60013),searchSave:(0,i.$Cj)("search-save",60013),logOut:(0,i.$Cj)("log-out",60014),signOut:(0,i.$Cj)("sign-out",60014),logIn:(0,i.$Cj)("log-in",60015),signIn:(0,i.$Cj)("sign-in",60015),eye:(0,i.$Cj)("eye",60016),eyeUnwatch:(0,i.$Cj)("eye-unwatch",60016),eyeWatch:(0,i.$Cj)("eye-watch",60016),circleFilled:(0,i.$Cj)("circle-filled",60017),primitiveDot:(0,i.$Cj)("primitive-dot",60017),closeDirty:(0,i.$Cj)("close-dirty",60017),debugBreakpoint:(0,i.$Cj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$Cj)("debug-breakpoint-disabled",60017),debugHint:(0,i.$Cj)("debug-hint",60017),terminalDecorationSuccess:(0,i.$Cj)("terminal-decoration-success",60017),primitiveSquare:(0,i.$Cj)("primitive-square",60018),edit:(0,i.$Cj)("edit",60019),pencil:(0,i.$Cj)("pencil",60019),info:(0,i.$Cj)("info",60020),issueOpened:(0,i.$Cj)("issue-opened",60020),gistPrivate:(0,i.$Cj)("gist-private",60021),gitForkPrivate:(0,i.$Cj)("git-fork-private",60021),lock:(0,i.$Cj)("lock",60021),mirrorPrivate:(0,i.$Cj)("mirror-private",60021),close:(0,i.$Cj)("close",60022),removeClose:(0,i.$Cj)("remove-close",60022),x:(0,i.$Cj)("x",60022),repoSync:(0,i.$Cj)("repo-sync",60023),sync:(0,i.$Cj)("sync",60023),clone:(0,i.$Cj)("clone",60024),desktopDownload:(0,i.$Cj)("desktop-download",60024),beaker:(0,i.$Cj)("beaker",60025),microscope:(0,i.$Cj)("microscope",60025),vm:(0,i.$Cj)("vm",60026),deviceDesktop:(0,i.$Cj)("device-desktop",60026),file:(0,i.$Cj)("file",60027),fileText:(0,i.$Cj)("file-text",60027),more:(0,i.$Cj)("more",60028),ellipsis:(0,i.$Cj)("ellipsis",60028),kebabHorizontal:(0,i.$Cj)("kebab-horizontal",60028),mailReply:(0,i.$Cj)("mail-reply",60029),reply:(0,i.$Cj)("reply",60029),organization:(0,i.$Cj)("organization",60030),organizationFilled:(0,i.$Cj)("organization-filled",60030),organizationOutline:(0,i.$Cj)("organization-outline",60030),newFile:(0,i.$Cj)("new-file",60031),fileAdd:(0,i.$Cj)("file-add",60031),newFolder:(0,i.$Cj)("new-folder",60032),fileDirectoryCreate:(0,i.$Cj)("file-directory-create",60032),trash:(0,i.$Cj)("trash",60033),trashcan:(0,i.$Cj)("trashcan",60033),history:(0,i.$Cj)("history",60034),clock:(0,i.$Cj)("clock",60034),folder:(0,i.$Cj)("folder",60035),fileDirectory:(0,i.$Cj)("file-directory",60035),symbolFolder:(0,i.$Cj)("symbol-folder",60035),logoGithub:(0,i.$Cj)("logo-github",60036),markGithub:(0,i.$Cj)("mark-github",60036),github:(0,i.$Cj)("github",60036),terminal:(0,i.$Cj)("terminal",60037),console:(0,i.$Cj)("console",60037),repl:(0,i.$Cj)("repl",60037),zap:(0,i.$Cj)("zap",60038),symbolEvent:(0,i.$Cj)("symbol-event",60038),error:(0,i.$Cj)("error",60039),stop:(0,i.$Cj)("stop",60039),variable:(0,i.$Cj)("variable",60040),symbolVariable:(0,i.$Cj)("symbol-variable",60040),array:(0,i.$Cj)("array",60042),symbolArray:(0,i.$Cj)("symbol-array",60042),symbolModule:(0,i.$Cj)("symbol-module",60043),symbolPackage:(0,i.$Cj)("symbol-package",60043),symbolNamespace:(0,i.$Cj)("symbol-namespace",60043),symbolObject:(0,i.$Cj)("symbol-object",60043),symbolMethod:(0,i.$Cj)("symbol-method",60044),symbolFunction:(0,i.$Cj)("symbol-function",60044),symbolConstructor:(0,i.$Cj)("symbol-constructor",60044),symbolBoolean:(0,i.$Cj)("symbol-boolean",60047),symbolNull:(0,i.$Cj)("symbol-null",60047),symbolNumeric:(0,i.$Cj)("symbol-numeric",60048),symbolNumber:(0,i.$Cj)("symbol-number",60048),symbolStructure:(0,i.$Cj)("symbol-structure",60049),symbolStruct:(0,i.$Cj)("symbol-struct",60049),symbolParameter:(0,i.$Cj)("symbol-parameter",60050),symbolTypeParameter:(0,i.$Cj)("symbol-type-parameter",60050),symbolKey:(0,i.$Cj)("symbol-key",60051),symbolText:(0,i.$Cj)("symbol-text",60051),symbolReference:(0,i.$Cj)("symbol-reference",60052),goToFile:(0,i.$Cj)("go-to-file",60052),symbolEnum:(0,i.$Cj)("symbol-enum",60053),symbolValue:(0,i.$Cj)("symbol-value",60053),symbolRuler:(0,i.$Cj)("symbol-ruler",60054),symbolUnit:(0,i.$Cj)("symbol-unit",60054),activateBreakpoints:(0,i.$Cj)("activate-breakpoints",60055),archive:(0,i.$Cj)("archive",60056),arrowBoth:(0,i.$Cj)("arrow-both",60057),arrowDown:(0,i.$Cj)("arrow-down",60058),arrowLeft:(0,i.$Cj)("arrow-left",60059),arrowRight:(0,i.$Cj)("arrow-right",60060),arrowSmallDown:(0,i.$Cj)("arrow-small-down",60061),arrowSmallLeft:(0,i.$Cj)("arrow-small-left",60062),arrowSmallRight:(0,i.$Cj)("arrow-small-right",60063),arrowSmallUp:(0,i.$Cj)("arrow-small-up",60064),arrowUp:(0,i.$Cj)("arrow-up",60065),bell:(0,i.$Cj)("bell",60066),bold:(0,i.$Cj)("bold",60067),book:(0,i.$Cj)("book",60068),bookmark:(0,i.$Cj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$Cj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$Cj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$Cj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$Cj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$Cj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$Cj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$Cj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$Cj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$Cj)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$Cj)("briefcase",60076),broadcast:(0,i.$Cj)("broadcast",60077),browser:(0,i.$Cj)("browser",60078),bug:(0,i.$Cj)("bug",60079),calendar:(0,i.$Cj)("calendar",60080),caseSensitive:(0,i.$Cj)("case-sensitive",60081),check:(0,i.$Cj)("check",60082),checklist:(0,i.$Cj)("checklist",60083),chevronDown:(0,i.$Cj)("chevron-down",60084),chevronLeft:(0,i.$Cj)("chevron-left",60085),chevronRight:(0,i.$Cj)("chevron-right",60086),chevronUp:(0,i.$Cj)("chevron-up",60087),chromeClose:(0,i.$Cj)("chrome-close",60088),chromeMaximize:(0,i.$Cj)("chrome-maximize",60089),chromeMinimize:(0,i.$Cj)("chrome-minimize",60090),chromeRestore:(0,i.$Cj)("chrome-restore",60091),circleOutline:(0,i.$Cj)("circle-outline",60092),circle:(0,i.$Cj)("circle",60092),debugBreakpointUnverified:(0,i.$Cj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$Cj)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$Cj)("circle-slash",60093),circuitBoard:(0,i.$Cj)("circuit-board",60094),clearAll:(0,i.$Cj)("clear-all",60095),clippy:(0,i.$Cj)("clippy",60096),closeAll:(0,i.$Cj)("close-all",60097),cloudDownload:(0,i.$Cj)("cloud-download",60098),cloudUpload:(0,i.$Cj)("cloud-upload",60099),code:(0,i.$Cj)("code",60100),collapseAll:(0,i.$Cj)("collapse-all",60101),colorMode:(0,i.$Cj)("color-mode",60102),commentDiscussion:(0,i.$Cj)("comment-discussion",60103),creditCard:(0,i.$Cj)("credit-card",60105),dash:(0,i.$Cj)("dash",60108),dashboard:(0,i.$Cj)("dashboard",60109),database:(0,i.$Cj)("database",60110),debugContinue:(0,i.$Cj)("debug-continue",60111),debugDisconnect:(0,i.$Cj)("debug-disconnect",60112),debugPause:(0,i.$Cj)("debug-pause",60113),debugRestart:(0,i.$Cj)("debug-restart",60114),debugStart:(0,i.$Cj)("debug-start",60115),debugStepInto:(0,i.$Cj)("debug-step-into",60116),debugStepOut:(0,i.$Cj)("debug-step-out",60117),debugStepOver:(0,i.$Cj)("debug-step-over",60118),debugStop:(0,i.$Cj)("debug-stop",60119),debug:(0,i.$Cj)("debug",60120),deviceCameraVideo:(0,i.$Cj)("device-camera-video",60121),deviceCamera:(0,i.$Cj)("device-camera",60122),deviceMobile:(0,i.$Cj)("device-mobile",60123),diffAdded:(0,i.$Cj)("diff-added",60124),diffIgnored:(0,i.$Cj)("diff-ignored",60125),diffModified:(0,i.$Cj)("diff-modified",60126),diffRemoved:(0,i.$Cj)("diff-removed",60127),diffRenamed:(0,i.$Cj)("diff-renamed",60128),diff:(0,i.$Cj)("diff",60129),diffSidebyside:(0,i.$Cj)("diff-sidebyside",60129),discard:(0,i.$Cj)("discard",60130),editorLayout:(0,i.$Cj)("editor-layout",60131),emptyWindow:(0,i.$Cj)("empty-window",60132),exclude:(0,i.$Cj)("exclude",60133),extensions:(0,i.$Cj)("extensions",60134),eyeClosed:(0,i.$Cj)("eye-closed",60135),fileBinary:(0,i.$Cj)("file-binary",60136),fileCode:(0,i.$Cj)("file-code",60137),fileMedia:(0,i.$Cj)("file-media",60138),filePdf:(0,i.$Cj)("file-pdf",60139),fileSubmodule:(0,i.$Cj)("file-submodule",60140),fileSymlinkDirectory:(0,i.$Cj)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$Cj)("file-symlink-file",60142),fileZip:(0,i.$Cj)("file-zip",60143),files:(0,i.$Cj)("files",60144),filter:(0,i.$Cj)("filter",60145),flame:(0,i.$Cj)("flame",60146),foldDown:(0,i.$Cj)("fold-down",60147),foldUp:(0,i.$Cj)("fold-up",60148),fold:(0,i.$Cj)("fold",60149),folderActive:(0,i.$Cj)("folder-active",60150),folderOpened:(0,i.$Cj)("folder-opened",60151),gear:(0,i.$Cj)("gear",60152),gift:(0,i.$Cj)("gift",60153),gistSecret:(0,i.$Cj)("gist-secret",60154),gist:(0,i.$Cj)("gist",60155),gitCommit:(0,i.$Cj)("git-commit",60156),gitCompare:(0,i.$Cj)("git-compare",60157),compareChanges:(0,i.$Cj)("compare-changes",60157),gitMerge:(0,i.$Cj)("git-merge",60158),githubAction:(0,i.$Cj)("github-action",60159),githubAlt:(0,i.$Cj)("github-alt",60160),globe:(0,i.$Cj)("globe",60161),grabber:(0,i.$Cj)("grabber",60162),graph:(0,i.$Cj)("graph",60163),gripper:(0,i.$Cj)("gripper",60164),heart:(0,i.$Cj)("heart",60165),home:(0,i.$Cj)("home",60166),horizontalRule:(0,i.$Cj)("horizontal-rule",60167),hubot:(0,i.$Cj)("hubot",60168),inbox:(0,i.$Cj)("inbox",60169),issueReopened:(0,i.$Cj)("issue-reopened",60171),issues:(0,i.$Cj)("issues",60172),italic:(0,i.$Cj)("italic",60173),jersey:(0,i.$Cj)("jersey",60174),json:(0,i.$Cj)("json",60175),kebabVertical:(0,i.$Cj)("kebab-vertical",60176),key:(0,i.$Cj)("key",60177),law:(0,i.$Cj)("law",60178),lightbulbAutofix:(0,i.$Cj)("lightbulb-autofix",60179),linkExternal:(0,i.$Cj)("link-external",60180),link:(0,i.$Cj)("link",60181),listOrdered:(0,i.$Cj)("list-ordered",60182),listUnordered:(0,i.$Cj)("list-unordered",60183),liveShare:(0,i.$Cj)("live-share",60184),loading:(0,i.$Cj)("loading",60185),location:(0,i.$Cj)("location",60186),mailRead:(0,i.$Cj)("mail-read",60187),mail:(0,i.$Cj)("mail",60188),markdown:(0,i.$Cj)("markdown",60189),megaphone:(0,i.$Cj)("megaphone",60190),mention:(0,i.$Cj)("mention",60191),milestone:(0,i.$Cj)("milestone",60192),gitPullRequestMilestone:(0,i.$Cj)("git-pull-request-milestone",60192),mortarBoard:(0,i.$Cj)("mortar-board",60193),move:(0,i.$Cj)("move",60194),multipleWindows:(0,i.$Cj)("multiple-windows",60195),mute:(0,i.$Cj)("mute",60196),noNewline:(0,i.$Cj)("no-newline",60197),note:(0,i.$Cj)("note",60198),octoface:(0,i.$Cj)("octoface",60199),openPreview:(0,i.$Cj)("open-preview",60200),package:(0,i.$Cj)("package",60201),paintcan:(0,i.$Cj)("paintcan",60202),pin:(0,i.$Cj)("pin",60203),play:(0,i.$Cj)("play",60204),run:(0,i.$Cj)("run",60204),plug:(0,i.$Cj)("plug",60205),preserveCase:(0,i.$Cj)("preserve-case",60206),preview:(0,i.$Cj)("preview",60207),project:(0,i.$Cj)("project",60208),pulse:(0,i.$Cj)("pulse",60209),question:(0,i.$Cj)("question",60210),quote:(0,i.$Cj)("quote",60211),radioTower:(0,i.$Cj)("radio-tower",60212),reactions:(0,i.$Cj)("reactions",60213),references:(0,i.$Cj)("references",60214),refresh:(0,i.$Cj)("refresh",60215),regex:(0,i.$Cj)("regex",60216),remoteExplorer:(0,i.$Cj)("remote-explorer",60217),remote:(0,i.$Cj)("remote",60218),remove:(0,i.$Cj)("remove",60219),replaceAll:(0,i.$Cj)("replace-all",60220),replace:(0,i.$Cj)("replace",60221),repoClone:(0,i.$Cj)("repo-clone",60222),repoForcePush:(0,i.$Cj)("repo-force-push",60223),repoPull:(0,i.$Cj)("repo-pull",60224),repoPush:(0,i.$Cj)("repo-push",60225),report:(0,i.$Cj)("report",60226),requestChanges:(0,i.$Cj)("request-changes",60227),rocket:(0,i.$Cj)("rocket",60228),rootFolderOpened:(0,i.$Cj)("root-folder-opened",60229),rootFolder:(0,i.$Cj)("root-folder",60230),rss:(0,i.$Cj)("rss",60231),ruby:(0,i.$Cj)("ruby",60232),saveAll:(0,i.$Cj)("save-all",60233),saveAs:(0,i.$Cj)("save-as",60234),save:(0,i.$Cj)("save",60235),screenFull:(0,i.$Cj)("screen-full",60236),screenNormal:(0,i.$Cj)("screen-normal",60237),searchStop:(0,i.$Cj)("search-stop",60238),server:(0,i.$Cj)("server",60240),settingsGear:(0,i.$Cj)("settings-gear",60241),settings:(0,i.$Cj)("settings",60242),shield:(0,i.$Cj)("shield",60243),smiley:(0,i.$Cj)("smiley",60244),sortPrecedence:(0,i.$Cj)("sort-precedence",60245),splitHorizontal:(0,i.$Cj)("split-horizontal",60246),splitVertical:(0,i.$Cj)("split-vertical",60247),squirrel:(0,i.$Cj)("squirrel",60248),starFull:(0,i.$Cj)("star-full",60249),starHalf:(0,i.$Cj)("star-half",60250),symbolClass:(0,i.$Cj)("symbol-class",60251),symbolColor:(0,i.$Cj)("symbol-color",60252),symbolConstant:(0,i.$Cj)("symbol-constant",60253),symbolEnumMember:(0,i.$Cj)("symbol-enum-member",60254),symbolField:(0,i.$Cj)("symbol-field",60255),symbolFile:(0,i.$Cj)("symbol-file",60256),symbolInterface:(0,i.$Cj)("symbol-interface",60257),symbolKeyword:(0,i.$Cj)("symbol-keyword",60258),symbolMisc:(0,i.$Cj)("symbol-misc",60259),symbolOperator:(0,i.$Cj)("symbol-operator",60260),symbolProperty:(0,i.$Cj)("symbol-property",60261),wrench:(0,i.$Cj)("wrench",60261),wrenchSubaction:(0,i.$Cj)("wrench-subaction",60261),symbolSnippet:(0,i.$Cj)("symbol-snippet",60262),tasklist:(0,i.$Cj)("tasklist",60263),telescope:(0,i.$Cj)("telescope",60264),textSize:(0,i.$Cj)("text-size",60265),threeBars:(0,i.$Cj)("three-bars",60266),thumbsdown:(0,i.$Cj)("thumbsdown",60267),thumbsup:(0,i.$Cj)("thumbsup",60268),tools:(0,i.$Cj)("tools",60269),triangleDown:(0,i.$Cj)("triangle-down",60270),triangleLeft:(0,i.$Cj)("triangle-left",60271),triangleRight:(0,i.$Cj)("triangle-right",60272),triangleUp:(0,i.$Cj)("triangle-up",60273),twitter:(0,i.$Cj)("twitter",60274),unfold:(0,i.$Cj)("unfold",60275),unlock:(0,i.$Cj)("unlock",60276),unmute:(0,i.$Cj)("unmute",60277),unverified:(0,i.$Cj)("unverified",60278),verified:(0,i.$Cj)("verified",60279),versions:(0,i.$Cj)("versions",60280),vmActive:(0,i.$Cj)("vm-active",60281),vmOutline:(0,i.$Cj)("vm-outline",60282),vmRunning:(0,i.$Cj)("vm-running",60283),watch:(0,i.$Cj)("watch",60284),whitespace:(0,i.$Cj)("whitespace",60285),wholeWord:(0,i.$Cj)("whole-word",60286),window:(0,i.$Cj)("window",60287),wordWrap:(0,i.$Cj)("word-wrap",60288),zoomIn:(0,i.$Cj)("zoom-in",60289),zoomOut:(0,i.$Cj)("zoom-out",60290),listFilter:(0,i.$Cj)("list-filter",60291),listFlat:(0,i.$Cj)("list-flat",60292),listSelection:(0,i.$Cj)("list-selection",60293),selection:(0,i.$Cj)("selection",60293),listTree:(0,i.$Cj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$Cj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$Cj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$Cj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$Cj)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$Cj)("circle-small-filled",60298),debugStackframeDot:(0,i.$Cj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$Cj)("terminal-decoration-mark",60298),debugStackframe:(0,i.$Cj)("debug-stackframe",60299),debugStackframeFocused:(0,i.$Cj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$Cj)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$Cj)("symbol-string",60301),debugReverseContinue:(0,i.$Cj)("debug-reverse-continue",60302),debugStepBack:(0,i.$Cj)("debug-step-back",60303),debugRestartFrame:(0,i.$Cj)("debug-restart-frame",60304),debugAlt:(0,i.$Cj)("debug-alt",60305),callIncoming:(0,i.$Cj)("call-incoming",60306),callOutgoing:(0,i.$Cj)("call-outgoing",60307),menu:(0,i.$Cj)("menu",60308),expandAll:(0,i.$Cj)("expand-all",60309),feedback:(0,i.$Cj)("feedback",60310),gitPullRequestReviewer:(0,i.$Cj)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$Cj)("group-by-ref-type",60311),ungroupByRefType:(0,i.$Cj)("ungroup-by-ref-type",60312),account:(0,i.$Cj)("account",60313),gitPullRequestAssignee:(0,i.$Cj)("git-pull-request-assignee",60313),bellDot:(0,i.$Cj)("bell-dot",60314),debugConsole:(0,i.$Cj)("debug-console",60315),library:(0,i.$Cj)("library",60316),output:(0,i.$Cj)("output",60317),runAll:(0,i.$Cj)("run-all",60318),syncIgnored:(0,i.$Cj)("sync-ignored",60319),pinned:(0,i.$Cj)("pinned",60320),githubInverted:(0,i.$Cj)("github-inverted",60321),serverProcess:(0,i.$Cj)("server-process",60322),serverEnvironment:(0,i.$Cj)("server-environment",60323),pass:(0,i.$Cj)("pass",60324),issueClosed:(0,i.$Cj)("issue-closed",60324),stopCircle:(0,i.$Cj)("stop-circle",60325),playCircle:(0,i.$Cj)("play-circle",60326),record:(0,i.$Cj)("record",60327),debugAltSmall:(0,i.$Cj)("debug-alt-small",60328),vmConnect:(0,i.$Cj)("vm-connect",60329),cloud:(0,i.$Cj)("cloud",60330),merge:(0,i.$Cj)("merge",60331),export:(0,i.$Cj)("export",60332),graphLeft:(0,i.$Cj)("graph-left",60333),magnet:(0,i.$Cj)("magnet",60334),notebook:(0,i.$Cj)("notebook",60335),redo:(0,i.$Cj)("redo",60336),checkAll:(0,i.$Cj)("check-all",60337),pinnedDirty:(0,i.$Cj)("pinned-dirty",60338),passFilled:(0,i.$Cj)("pass-filled",60339),circleLargeFilled:(0,i.$Cj)("circle-large-filled",60340),circleLarge:(0,i.$Cj)("circle-large",60341),circleLargeOutline:(0,i.$Cj)("circle-large-outline",60341),combine:(0,i.$Cj)("combine",60342),gather:(0,i.$Cj)("gather",60342),table:(0,i.$Cj)("table",60343),variableGroup:(0,i.$Cj)("variable-group",60344),typeHierarchy:(0,i.$Cj)("type-hierarchy",60345),typeHierarchySub:(0,i.$Cj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$Cj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$Cj)("git-pull-request-create",60348),runAbove:(0,i.$Cj)("run-above",60349),runBelow:(0,i.$Cj)("run-below",60350),notebookTemplate:(0,i.$Cj)("notebook-template",60351),debugRerun:(0,i.$Cj)("debug-rerun",60352),workspaceTrusted:(0,i.$Cj)("workspace-trusted",60353),workspaceUntrusted:(0,i.$Cj)("workspace-untrusted",60354),workspaceUnknown:(0,i.$Cj)("workspace-unknown",60355),terminalCmd:(0,i.$Cj)("terminal-cmd",60356),terminalDebian:(0,i.$Cj)("terminal-debian",60357),terminalLinux:(0,i.$Cj)("terminal-linux",60358),terminalPowershell:(0,i.$Cj)("terminal-powershell",60359),terminalTmux:(0,i.$Cj)("terminal-tmux",60360),terminalUbuntu:(0,i.$Cj)("terminal-ubuntu",60361),terminalBash:(0,i.$Cj)("terminal-bash",60362),arrowSwap:(0,i.$Cj)("arrow-swap",60363),copy:(0,i.$Cj)("copy",60364),personAdd:(0,i.$Cj)("person-add",60365),filterFilled:(0,i.$Cj)("filter-filled",60366),wand:(0,i.$Cj)("wand",60367),debugLineByLine:(0,i.$Cj)("debug-line-by-line",60368),inspect:(0,i.$Cj)("inspect",60369),layers:(0,i.$Cj)("layers",60370),layersDot:(0,i.$Cj)("layers-dot",60371),layersActive:(0,i.$Cj)("layers-active",60372),compass:(0,i.$Cj)("compass",60373),compassDot:(0,i.$Cj)("compass-dot",60374),compassActive:(0,i.$Cj)("compass-active",60375),azure:(0,i.$Cj)("azure",60376),issueDraft:(0,i.$Cj)("issue-draft",60377),gitPullRequestClosed:(0,i.$Cj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$Cj)("git-pull-request-draft",60379),debugAll:(0,i.$Cj)("debug-all",60380),debugCoverage:(0,i.$Cj)("debug-coverage",60381),runErrors:(0,i.$Cj)("run-errors",60382),folderLibrary:(0,i.$Cj)("folder-library",60383),debugContinueSmall:(0,i.$Cj)("debug-continue-small",60384),beakerStop:(0,i.$Cj)("beaker-stop",60385),graphLine:(0,i.$Cj)("graph-line",60386),graphScatter:(0,i.$Cj)("graph-scatter",60387),pieChart:(0,i.$Cj)("pie-chart",60388),bracket:(0,i.$Cj)("bracket",60175),bracketDot:(0,i.$Cj)("bracket-dot",60389),bracketError:(0,i.$Cj)("bracket-error",60390),lockSmall:(0,i.$Cj)("lock-small",60391),azureDevops:(0,i.$Cj)("azure-devops",60392),verifiedFilled:(0,i.$Cj)("verified-filled",60393),newline:(0,i.$Cj)("newline",60394),layout:(0,i.$Cj)("layout",60395),layoutActivitybarLeft:(0,i.$Cj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$Cj)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$Cj)("layout-panel-left",60398),layoutPanelCenter:(0,i.$Cj)("layout-panel-center",60399),layoutPanelJustify:(0,i.$Cj)("layout-panel-justify",60400),layoutPanelRight:(0,i.$Cj)("layout-panel-right",60401),layoutPanel:(0,i.$Cj)("layout-panel",60402),layoutSidebarLeft:(0,i.$Cj)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$Cj)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$Cj)("layout-statusbar",60405),layoutMenubar:(0,i.$Cj)("layout-menubar",60406),layoutCentered:(0,i.$Cj)("layout-centered",60407),target:(0,i.$Cj)("target",60408),indent:(0,i.$Cj)("indent",60409),recordSmall:(0,i.$Cj)("record-small",60410),errorSmall:(0,i.$Cj)("error-small",60411),terminalDecorationError:(0,i.$Cj)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$Cj)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$Cj)("arrow-circle-left",60413),arrowCircleRight:(0,i.$Cj)("arrow-circle-right",60414),arrowCircleUp:(0,i.$Cj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$Cj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$Cj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$Cj)("layout-sidebar-left-off",60418),blank:(0,i.$Cj)("blank",60419),heartFilled:(0,i.$Cj)("heart-filled",60420),map:(0,i.$Cj)("map",60421),mapFilled:(0,i.$Cj)("map-filled",60422),circleSmall:(0,i.$Cj)("circle-small",60423),bellSlash:(0,i.$Cj)("bell-slash",60424),bellSlashDot:(0,i.$Cj)("bell-slash-dot",60425),commentUnresolved:(0,i.$Cj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$Cj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$Cj)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$Cj)("search-fuzzy",60429),commentDraft:(0,i.$Cj)("comment-draft",60430),send:(0,i.$Cj)("send",60431),sparkle:(0,i.$Cj)("sparkle",60432),insert:(0,i.$Cj)("insert",60433),mic:(0,i.$Cj)("mic",60434),thumbsdownFilled:(0,i.$Cj)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$Cj)("thumbsup-filled",60436),coffee:(0,i.$Cj)("coffee",60437),snake:(0,i.$Cj)("snake",60438),game:(0,i.$Cj)("game",60439),vr:(0,i.$Cj)("vr",60440),chip:(0,i.$Cj)("chip",60441),piano:(0,i.$Cj)("piano",60442),music:(0,i.$Cj)("music",60443),micFilled:(0,i.$Cj)("mic-filled",60444),repoFetch:(0,i.$Cj)("repo-fetch",60445),copilot:(0,i.$Cj)("copilot",60446),lightbulbSparkle:(0,i.$Cj)("lightbulb-sparkle",60447),robot:(0,i.$Cj)("robot",60448),sparkleFilled:(0,i.$Cj)("sparkle-filled",60449),diffSingle:(0,i.$Cj)("diff-single",60450),diffMultiple:(0,i.$Cj)("diff-multiple",60451),surroundWith:(0,i.$Cj)("surround-with",60452),share:(0,i.$Cj)("share",60453),gitStash:(0,i.$Cj)("git-stash",60454),gitStashApply:(0,i.$Cj)("git-stash-apply",60455),gitStashPop:(0,i.$Cj)("git-stash-pop",60456),vscode:(0,i.$Cj)("vscode",60457),vscodeInsiders:(0,i.$Cj)("vscode-insiders",60458),codeOss:(0,i.$Cj)("code-oss",60459),runCoverage:(0,i.$Cj)("run-coverage",60460),runAllCoverage:(0,i.$Cj)("run-all-coverage",60461),coverage:(0,i.$Cj)("coverage",60462),githubProject:(0,i.$Cj)("github-project",60463)}}),re(ie[43],se([0,1,27,42]),function(O,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hj=t.$Gj=void 0,t.$Fj=y;function y(){return Object.values(t.$Hj)}t.$Gj={dialogError:(0,i.$Cj)("dialog-error","error"),dialogWarning:(0,i.$Cj)("dialog-warning","warning"),dialogInfo:(0,i.$Cj)("dialog-info","info"),dialogClose:(0,i.$Cj)("dialog-close","close"),treeItemExpanded:(0,i.$Cj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$Cj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$Cj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$Cj)("tree-filter-clear","close"),treeItemLoading:(0,i.$Cj)("tree-item-loading","loading"),menuSelection:(0,i.$Cj)("menu-selection","check"),menuSubmenu:(0,i.$Cj)("menu-submenu","chevron-right"),menuBarMore:(0,i.$Cj)("menubar-more","more"),scrollbarButtonLeft:(0,i.$Cj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$Cj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$Cj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$Cj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$Cj)("toolbar-more","more"),quickInputBack:(0,i.$Cj)("quick-input-back","arrow-left"),dropDownButton:(0,i.$Cj)("drop-down-button",60084),symbolCustomColor:(0,i.$Cj)("symbol-customcolor",60252),exportIcon:(0,i.$Cj)("export",60332),workspaceUnspecified:(0,i.$Cj)("workspace-unspecified",60355),newLine:(0,i.$Cj)("newline",60394),thumbsDownFilled:(0,i.$Cj)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$Cj)("thumbsup-filled",60436),gitFetch:(0,i.$Cj)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$Cj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$Cj)("debug-breakpoint-pending",60377)},t.$Hj={...F.$Ej,...t.$Gj}}),re(ie[15],se([0,1,26]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$On=F,t.$Pn=y,t.$Qn=j,t.$Rn=o,t.$Sn=s,t.$Tn=c,t.$Un=p,t.$Vn=g,t.$Wn=m,t.$Xn=e,t.$Yn=v,t.$Zn=E;function F(L){if(!L||typeof L!="object"||L instanceof RegExp)return L;const $=Array.isArray(L)?[]:{};return Object.entries(L).forEach(([b,a])=>{$[b]=a&&typeof a=="object"?F(a):a}),$}function y(L){if(!L||typeof L!="object")return L;const $=[L];for(;$.length>0;){const b=$.shift();Object.freeze(b);for(const a in b)if(f.call(b,a)){const l=b[a];typeof l=="object"&&!Object.isFrozen(l)&&!(0,i.$Yf)(l)&&$.push(l)}}return L}const f=Object.prototype.hasOwnProperty;function j(L,$){return h(L,$,new Set)}function h(L,$,b){if((0,i.$5f)(L))return L;const a=$(L);if(typeof a<"u")return a;if(Array.isArray(L)){const l=[];for(const r of L)l.push(h(r,$,b));return l}if((0,i.$Xf)(L)){if(b.has(L))throw new Error("Cannot clone recursive data-structure");b.add(L);const l={};for(const r in L)f.call(L,r)&&(l[r]=h(L[r],$,b));return b.delete(L),l}return L}function o(L,$,b=!0){return(0,i.$Xf)(L)?((0,i.$Xf)($)&&Object.keys($).forEach(a=>{a in L?b&&((0,i.$Xf)(L[a])&&(0,i.$Xf)($[a])?o(L[a],$[a],b):L[a]=$[a]):L[a]=$[a]}),L):$}function s(L,$){if(L===$)return!0;if(L==null||$===null||$===void 0||typeof L!=typeof $||typeof L!="object"||Array.isArray(L)!==Array.isArray($))return!1;let b,a;if(Array.isArray(L)){if(L.length!==$.length)return!1;for(b=0;b<L.length;b++)if(!s(L[b],$[b]))return!1}else{const l=[];for(a in L)l.push(a);l.sort();const r=[];for(a in $)r.push(a);if(r.sort(),!s(l,r))return!1;for(b=0;b<l.length;b++)if(!s(L[l[b]],$[l[b]]))return!1}return!0}function c(L){const $=new Set;return JSON.stringify(L,(b,a)=>{if((0,i.$Xf)(a)||Array.isArray(a)){if($.has(a))return"[Circular]";$.add(a)}return a})}function p(L,$){const b=Object.create(null);return!L||!$||Object.keys($).forEach(l=>{const r=L[l],u=$[l];s(r,u)||(b[l]=u)}),b}function g(L,$){const b=$.toLowerCase(),a=Object.keys(L).find(l=>l.toLowerCase()===b);return a?L[a]:L[$]}function m(L,$){const b=Object.create(null);for(const[a,l]of Object.entries(L))$(a,l)&&(b[a]=l);return b}function e(L){let $=[];for(;Object.prototype!==L;)$=$.concat(Object.getOwnPropertyNames(L)),L=Object.getPrototypeOf(L);return $}function v(L){const $=[];for(const b of e(L))typeof L[b]=="function"&&$.push(b);return $}function E(L,$){const b=l=>function(){const r=Array.prototype.slice.call(arguments,0);return $(l,r)},a={};for(const l of L)a[l]=b(l);return a}}),re(ie[28],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Constants=void 0,t.$Se=F,t.$Te=y;var i;(function(f){f[f.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",f[f.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",f[f.MAX_UINT_8=255]="MAX_UINT_8",f[f.MAX_UINT_16=65535]="MAX_UINT_16",f[f.MAX_UINT_32=4294967295]="MAX_UINT_32",f[f.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(i||(t.Constants=i={}));function F(f){return f<0?0:f>255?255:f|0}function y(f){return f<0?0:f>4294967295?4294967295:f|0}}),re(ie[29],se([0,1,28]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$At=t.$zt=void 0;class F{constructor(h){const o=(0,i.$Se)(h);this.c=o,this.a=F.d(o),this.b=new Map}static d(h){const o=new Uint8Array(256);return o.fill(h),o}set(h,o){const s=(0,i.$Se)(o);h>=0&&h<256?this.a[h]=s:this.b.set(h,s)}get(h){return h>=0&&h<256?this.a[h]:this.b.get(h)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$zt=F;var y;(function(j){j[j.False=0]="False",j[j.True=1]="True"})(y||(y={}));class f{constructor(){this.a=new F(0)}add(h){this.a.set(h,1)}has(h){return this.a.get(h)===1}clear(){return this.a.clear()}}t.$At=f}),re(ie[4],se([0,1,3]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kt=t.$jt=void 0;class F{static addRange(j,h){let o=0;for(;o<h.length&&h[o].endExclusive<j.start;)o++;let s=o;for(;s<h.length&&h[s].start<=j.endExclusive;)s++;if(o===s)h.splice(o,0,j);else{const c=Math.min(j.start,h[o].start),p=Math.max(j.endExclusive,h[s-1].endExclusive);h.splice(o,s-o,new F(c,p))}}static tryCreate(j,h){if(!(j>h))return new F(j,h)}static ofLength(j){return new F(0,j)}static ofStartAndLength(j,h){return new F(j,j+h)}constructor(j,h){if(this.start=j,this.endExclusive=h,j>h)throw new i.$cb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(j){return new F(this.start+j,this.endExclusive+j)}deltaStart(j){return new F(this.start+j,this.endExclusive)}deltaEnd(j){return new F(this.start,this.endExclusive+j)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(j){return this.start===j.start&&this.endExclusive===j.endExclusive}containsRange(j){return this.start<=j.start&&j.endExclusive<=this.endExclusive}contains(j){return this.start<=j&&j<this.endExclusive}join(j){return new F(Math.min(this.start,j.start),Math.max(this.endExclusive,j.endExclusive))}intersect(j){const h=Math.max(this.start,j.start),o=Math.min(this.endExclusive,j.endExclusive);if(h<=o)return new F(h,o)}intersects(j){const h=Math.max(this.start,j.start),o=Math.min(this.endExclusive,j.endExclusive);return h<o}intersectsOrTouches(j){const h=Math.max(this.start,j.start),o=Math.min(this.endExclusive,j.endExclusive);return h<=o}isBefore(j){return this.endExclusive<=j.start}isAfter(j){return this.start>=j.endExclusive}slice(j){return j.slice(this.start,this.endExclusive)}substring(j){return j.substring(this.start,this.endExclusive)}clip(j){if(this.isEmpty)throw new i.$cb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,j))}clipCyclic(j){if(this.isEmpty)throw new i.$cb(`Invalid clipping range: ${this.toString()}`);return j<this.start?this.endExclusive-(this.start-j)%this.length:j>=this.endExclusive?this.start+(j-this.start)%this.length:j}map(j){const h=[];for(let o=this.start;o<this.endExclusive;o++)h.push(j(o));return h}forEach(j){for(let h=this.start;h<this.endExclusive;h++)j(h)}}t.$jt=F;class y{constructor(){this.a=[]}addRange(j){let h=0;for(;h<this.a.length&&this.a[h].endExclusive<j.start;)h++;let o=h;for(;o<this.a.length&&this.a[o].start<=j.endExclusive;)o++;if(h===o)this.a.splice(h,0,j);else{const s=Math.min(j.start,this.a[h].start),c=Math.max(j.endExclusive,this.a[o-1].endExclusive);this.a.splice(h,o-h,new F(s,c))}}toString(){return this.a.map(j=>j.toString()).join(", ")}intersectsStrict(j){let h=0;for(;h<this.a.length&&this.a[h].endExclusive<=j.start;)h++;return h<this.a.length&&this.a[h].start<j.endExclusive}intersectWithRange(j){const h=new y;for(const o of this.a){const s=o.intersect(j);s&&h.addRange(s)}return h}intersectWithRangeLength(j){return this.intersectWithRange(j).length}get length(){return this.a.reduce((j,h)=>j+h.length,0)}}t.$kt=y}),re(ie[5],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bt=void 0;class i{constructor(y,f){this.lineNumber=y,this.column=f}with(y=this.lineNumber,f=this.column){return y===this.lineNumber&&f===this.column?this:new i(y,f)}delta(y=0,f=0){return this.with(this.lineNumber+y,this.column+f)}equals(y){return i.equals(this,y)}static equals(y,f){return!y&&!f?!0:!!y&&!!f&&y.lineNumber===f.lineNumber&&y.column===f.column}isBefore(y){return i.isBefore(this,y)}static isBefore(y,f){return y.lineNumber<f.lineNumber?!0:f.lineNumber<y.lineNumber?!1:y.column<f.column}isBeforeOrEqual(y){return i.isBeforeOrEqual(this,y)}static isBeforeOrEqual(y,f){return y.lineNumber<f.lineNumber?!0:f.lineNumber<y.lineNumber?!1:y.column<=f.column}static compare(y,f){const j=y.lineNumber|0,h=f.lineNumber|0;if(j===h){const o=y.column|0,s=f.column|0;return o-s}return j-h}clone(){return new i(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(y){return new i(y.lineNumber,y.column)}static isIPosition(y){return y&&typeof y.lineNumber=="number"&&typeof y.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}t.$bt=i}),re(ie[2],se([0,1,5]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ct=void 0;class F{constructor(f,j,h,o){f>h||f===h&&j>o?(this.startLineNumber=h,this.startColumn=o,this.endLineNumber=f,this.endColumn=j):(this.startLineNumber=f,this.startColumn=j,this.endLineNumber=h,this.endColumn=o)}isEmpty(){return F.isEmpty(this)}static isEmpty(f){return f.startLineNumber===f.endLineNumber&&f.startColumn===f.endColumn}containsPosition(f){return F.containsPosition(this,f)}static containsPosition(f,j){return!(j.lineNumber<f.startLineNumber||j.lineNumber>f.endLineNumber||j.lineNumber===f.startLineNumber&&j.column<f.startColumn||j.lineNumber===f.endLineNumber&&j.column>f.endColumn)}static strictContainsPosition(f,j){return!(j.lineNumber<f.startLineNumber||j.lineNumber>f.endLineNumber||j.lineNumber===f.startLineNumber&&j.column<=f.startColumn||j.lineNumber===f.endLineNumber&&j.column>=f.endColumn)}containsRange(f){return F.containsRange(this,f)}static containsRange(f,j){return!(j.startLineNumber<f.startLineNumber||j.endLineNumber<f.startLineNumber||j.startLineNumber>f.endLineNumber||j.endLineNumber>f.endLineNumber||j.startLineNumber===f.startLineNumber&&j.startColumn<f.startColumn||j.endLineNumber===f.endLineNumber&&j.endColumn>f.endColumn)}strictContainsRange(f){return F.strictContainsRange(this,f)}static strictContainsRange(f,j){return!(j.startLineNumber<f.startLineNumber||j.endLineNumber<f.startLineNumber||j.startLineNumber>f.endLineNumber||j.endLineNumber>f.endLineNumber||j.startLineNumber===f.startLineNumber&&j.startColumn<=f.startColumn||j.endLineNumber===f.endLineNumber&&j.endColumn>=f.endColumn)}plusRange(f){return F.plusRange(this,f)}static plusRange(f,j){let h,o,s,c;return j.startLineNumber<f.startLineNumber?(h=j.startLineNumber,o=j.startColumn):j.startLineNumber===f.startLineNumber?(h=j.startLineNumber,o=Math.min(j.startColumn,f.startColumn)):(h=f.startLineNumber,o=f.startColumn),j.endLineNumber>f.endLineNumber?(s=j.endLineNumber,c=j.endColumn):j.endLineNumber===f.endLineNumber?(s=j.endLineNumber,c=Math.max(j.endColumn,f.endColumn)):(s=f.endLineNumber,c=f.endColumn),new F(h,o,s,c)}intersectRanges(f){return F.intersectRanges(this,f)}static intersectRanges(f,j){let h=f.startLineNumber,o=f.startColumn,s=f.endLineNumber,c=f.endColumn;const p=j.startLineNumber,g=j.startColumn,m=j.endLineNumber,e=j.endColumn;return h<p?(h=p,o=g):h===p&&(o=Math.max(o,g)),s>m?(s=m,c=e):s===m&&(c=Math.min(c,e)),h>s||h===s&&o>c?null:new F(h,o,s,c)}equalsRange(f){return F.equalsRange(this,f)}static equalsRange(f,j){return!f&&!j?!0:!!f&&!!j&&f.startLineNumber===j.startLineNumber&&f.startColumn===j.startColumn&&f.endLineNumber===j.endLineNumber&&f.endColumn===j.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(f){return new i.$bt(f.endLineNumber,f.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(f){return new i.$bt(f.startLineNumber,f.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(f,j){return new F(this.startLineNumber,this.startColumn,f,j)}setStartPosition(f,j){return new F(f,j,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(f){return new F(f.startLineNumber,f.startColumn,f.startLineNumber,f.startColumn)}collapseToEnd(){return F.collapseToEnd(this)}static collapseToEnd(f){return new F(f.endLineNumber,f.endColumn,f.endLineNumber,f.endColumn)}delta(f){return new F(this.startLineNumber+f,this.startColumn,this.endLineNumber+f,this.endColumn)}static fromPositions(f,j=f){return new F(f.lineNumber,f.column,j.lineNumber,j.column)}static lift(f){return f?new F(f.startLineNumber,f.startColumn,f.endLineNumber,f.endColumn):null}static isIRange(f){return f&&typeof f.startLineNumber=="number"&&typeof f.startColumn=="number"&&typeof f.endLineNumber=="number"&&typeof f.endColumn=="number"}static areIntersectingOrTouching(f,j){return!(f.endLineNumber<j.startLineNumber||f.endLineNumber===j.startLineNumber&&f.endColumn<j.startColumn||j.endLineNumber<f.startLineNumber||j.endLineNumber===f.startLineNumber&&j.endColumn<f.startColumn)}static areIntersecting(f,j){return!(f.endLineNumber<j.startLineNumber||f.endLineNumber===j.startLineNumber&&f.endColumn<=j.startColumn||j.endLineNumber<f.startLineNumber||j.endLineNumber===f.startLineNumber&&j.endColumn<=f.startColumn)}static compareRangesUsingStarts(f,j){if(f&&j){const s=f.startLineNumber|0,c=j.startLineNumber|0;if(s===c){const p=f.startColumn|0,g=j.startColumn|0;if(p===g){const m=f.endLineNumber|0,e=j.endLineNumber|0;if(m===e){const v=f.endColumn|0,E=j.endColumn|0;return v-E}return m-e}return p-g}return s-c}return(f?1:0)-(j?1:0)}static compareRangesUsingEnds(f,j){return f.endLineNumber===j.endLineNumber?f.endColumn===j.endColumn?f.startLineNumber===j.startLineNumber?f.startColumn-j.startColumn:f.startLineNumber-j.startLineNumber:f.endColumn-j.endColumn:f.endLineNumber-j.endLineNumber}static spansMultipleLines(f){return f.endLineNumber>f.startLineNumber}toJSON(){return this}}t.$ct=F}),re(ie[44],se([0,1,2]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dt=void 0;class F{static insert(f,j){return{range:new i.$ct(f.lineNumber,f.column,f.lineNumber,f.column),text:j,forceMoveMarkers:!0}}static delete(f){return{range:f,text:null}}static replace(f,j){return{range:f,text:j}}static replaceMove(f,j){return{range:f,text:j,forceMoveMarkers:!0}}}t.$dt=F}),re(ie[12],se([0,1,3,4,2,9]),function(O,t,i,F,y,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mt=t.$lt=void 0;class j{static fromRange(s){return new j(s.startLineNumber,s.endLineNumber)}static fromRangeInclusive(s){return new j(s.startLineNumber,s.endLineNumber+1)}static subtract(s,c){return c?s.startLineNumber<c.startLineNumber&&c.endLineNumberExclusive<s.endLineNumberExclusive?[new j(s.startLineNumber,c.startLineNumber),new j(c.endLineNumberExclusive,s.endLineNumberExclusive)]:c.startLineNumber<=s.startLineNumber&&s.endLineNumberExclusive<=c.endLineNumberExclusive?[]:c.endLineNumberExclusive<s.endLineNumberExclusive?[new j(Math.max(c.endLineNumberExclusive,s.startLineNumber),s.endLineNumberExclusive)]:[new j(s.startLineNumber,Math.min(c.startLineNumber,s.endLineNumberExclusive))]:[s]}static joinMany(s){if(s.length===0)return[];let c=new h(s[0].slice());for(let p=1;p<s.length;p++)c=c.getUnion(new h(s[p].slice()));return c.ranges}static join(s){if(s.length===0)throw new i.$cb("lineRanges cannot be empty");let c=s[0].startLineNumber,p=s[0].endLineNumberExclusive;for(let g=1;g<s.length;g++)c=Math.min(c,s[g].startLineNumber),p=Math.max(p,s[g].endLineNumberExclusive);return new j(c,p)}static ofLength(s,c){return new j(s,s+c)}static deserialize(s){return new j(s[0],s[1])}constructor(s,c){if(s>c)throw new i.$cb(`startLineNumber ${s} cannot be after endLineNumberExclusive ${c}`);this.startLineNumber=s,this.endLineNumberExclusive=c}contains(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(s){return new j(this.startLineNumber+s,this.endLineNumberExclusive+s)}deltaLength(s){return new j(this.startLineNumber,this.endLineNumberExclusive+s)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(s){return new j(Math.min(this.startLineNumber,s.startLineNumber),Math.max(this.endLineNumberExclusive,s.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(s){const c=Math.max(this.startLineNumber,s.startLineNumber),p=Math.min(this.endLineNumberExclusive,s.endLineNumberExclusive);if(c<=p)return new j(c,p)}intersectsStrict(s){return this.startLineNumber<s.endLineNumberExclusive&&s.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(s){return this.startLineNumber<=s.endLineNumberExclusive&&s.startLineNumber<=this.endLineNumberExclusive}equals(s){return this.startLineNumber===s.startLineNumber&&this.endLineNumberExclusive===s.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new y.$ct(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new y.$ct(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(s){const c=[];for(let p=this.startLineNumber;p<this.endLineNumberExclusive;p++)c.push(s(p));return c}forEach(s){for(let c=this.startLineNumber;c<this.endLineNumberExclusive;c++)s(c)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}toOffsetRange(){return new F.$jt(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.$lt=j;class h{constructor(s=[]){this.c=s}get ranges(){return this.c}addRange(s){if(s.length===0)return;const c=(0,f.$kb)(this.c,g=>g.endLineNumberExclusive>=s.startLineNumber),p=(0,f.$ib)(this.c,g=>g.startLineNumber<=s.endLineNumberExclusive)+1;if(c===p)this.c.splice(c,0,s);else if(c===p-1){const g=this.c[c];this.c[c]=g.join(s)}else{const g=this.c[c].join(this.c[p-1]).join(s);this.c.splice(c,p-c,g)}}contains(s){const c=(0,f.$hb)(this.c,p=>p.startLineNumber<=s);return!!c&&c.endLineNumberExclusive>s}intersects(s){const c=(0,f.$hb)(this.c,p=>p.startLineNumber<s.endLineNumberExclusive);return!!c&&c.endLineNumberExclusive>s.startLineNumber}getUnion(s){if(this.c.length===0)return s;if(s.c.length===0)return this;const c=[];let p=0,g=0,m=null;for(;p<this.c.length||g<s.c.length;){let e=null;if(p<this.c.length&&g<s.c.length){const v=this.c[p],E=s.c[g];v.startLineNumber<E.startLineNumber?(e=v,p++):(e=E,g++)}else p<this.c.length?(e=this.c[p],p++):(e=s.c[g],g++);m===null?m=e:m.endLineNumberExclusive>=e.startLineNumber?m=new j(m.startLineNumber,Math.max(m.endLineNumberExclusive,e.endLineNumberExclusive)):(c.push(m),m=e)}return m!==null&&c.push(m),new h(c)}subtractFrom(s){const c=(0,f.$kb)(this.c,e=>e.endLineNumberExclusive>=s.startLineNumber),p=(0,f.$ib)(this.c,e=>e.startLineNumber<=s.endLineNumberExclusive)+1;if(c===p)return new h([s]);const g=[];let m=s.startLineNumber;for(let e=c;e<p;e++){const v=this.c[e];v.startLineNumber>m&&g.push(new j(m,v.startLineNumber)),m=v.endLineNumberExclusive}return m<s.endLineNumberExclusive&&g.push(new j(m,s.endLineNumberExclusive)),new h(g)}toString(){return this.c.map(s=>s.toString()).join(", ")}getIntersection(s){const c=[];let p=0,g=0;for(;p<this.c.length&&g<s.c.length;){const m=this.c[p],e=s.c[g],v=m.intersect(e);v&&!v.isEmpty&&c.push(v),m.endLineNumberExclusive<e.endLineNumberExclusive?p++:g++}return new h(c)}getWithDelta(s){return new h(this.c.map(c=>c.delta(s)))}}t.$mt=h}),re(ie[45],se([0,1,5,2]),function(O,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$et=t.SelectionDirection=void 0;var y;(function(j){j[j.LTR=0]="LTR",j[j.RTL=1]="RTL"})(y||(t.SelectionDirection=y={}));class f extends F.$ct{constructor(h,o,s,c){super(h,o,s,c),this.selectionStartLineNumber=h,this.selectionStartColumn=o,this.positionLineNumber=s,this.positionColumn=c}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(h){return f.selectionsEqual(this,h)}static selectionsEqual(h,o){return h.selectionStartLineNumber===o.selectionStartLineNumber&&h.selectionStartColumn===o.selectionStartColumn&&h.positionLineNumber===o.positionLineNumber&&h.positionColumn===o.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(h,o){return this.getDirection()===0?new f(this.startLineNumber,this.startColumn,h,o):new f(h,o,this.startLineNumber,this.startColumn)}getPosition(){return new i.$bt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new i.$bt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(h,o){return this.getDirection()===0?new f(h,o,this.endLineNumber,this.endColumn):new f(this.endLineNumber,this.endColumn,h,o)}static fromPositions(h,o=h){return new f(h.lineNumber,h.column,o.lineNumber,o.column)}static fromRange(h,o){return o===0?new f(h.startLineNumber,h.startColumn,h.endLineNumber,h.endColumn):new f(h.endLineNumber,h.endColumn,h.startLineNumber,h.startColumn)}static liftSelection(h){return new f(h.selectionStartLineNumber,h.selectionStartColumn,h.positionLineNumber,h.positionColumn)}static selectionsArrEqual(h,o){if(h&&!o||!h&&o)return!1;if(!h&&!o)return!0;if(h.length!==o.length)return!1;for(let s=0,c=h.length;s<c;s++)if(!this.selectionsEqual(h[s],o[s]))return!1;return!0}static isISelection(h){return h&&typeof h.selectionStartLineNumber=="number"&&typeof h.selectionStartColumn=="number"&&typeof h.positionLineNumber=="number"&&typeof h.positionColumn=="number"}static createWithDirection(h,o,s,c,p){return p===0?new f(h,o,s,c):new f(s,c,h,o)}}t.$et=f}),re(ie[46],se([0,1,14,29]),function(O,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bt=t.WordCharacterClass=void 0,t.$Ct=h;var y;(function(o){o[o.Regular=0]="Regular",o[o.Whitespace=1]="Whitespace",o[o.WordSeparator=2]="WordSeparator"})(y||(t.WordCharacterClass=y={}));class f extends F.$zt{constructor(s,c){super(0),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=c,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let p=0,g=s.length;p<g;p++)this.set(s.charCodeAt(p),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(s,c){let p=null;for(const g of this.h(s)){if(g.index>c)break;p=g}return p}findNextIntlWordAtOrAfterOffset(s,c){for(const p of this.h(s))if(!(p.index<c))return p;return null}h(s){return this.e?this.f===s?this.g:(this.f=s,this.g=this.j(this.e.segment(s)),this.g):[]}j(s){const c=[];for(const p of s)this.k(p)&&c.push(p);return c}k(s){return!!s.isWordLike}}t.$Bt=f;const j=new i.$Ec(10);function h(o,s){const c=`${o}/${s.join(",")}`;let p=j.get(c);return p||(p=new f(o,s),j.set(c,p)),p}}),re(ie[30],se([0,1,21,10,22]),function(O,t,i,F,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Os=t.$Ns=void 0,t.$Ps=j,t.$Qs=o,t.$Rs=s,t.$Ns="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function f(p=""){let g="(-?\\d*\\.\\d\\w*)|([^";for(const m of t.$Ns)p.indexOf(m)>=0||(g+="\\"+m);return g+="\\s]+)",new RegExp(g,"g")}t.$Os=f();function j(p){let g=t.$Os;if(p&&p instanceof RegExp)if(p.global)g=p;else{let m="g";p.ignoreCase&&(m+="i"),p.multiline&&(m+="m"),p.unicode&&(m+="u"),g=new RegExp(p.source,m)}return g.lastIndex=0,g}const h=new y.$5c;h.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function o(p){const g=h.unshift(p);return(0,F.$Sc)(g)}function s(p,g,m,e,v){if(g=j(g),v||(v=i.Iterable.first(h)),m.length>v.maxLen){let a=p-v.maxLen/2;return a<0?a=0:e+=a,m=m.substring(a,p+v.maxLen/2),s(p,g,m,e,v)}const E=Date.now(),L=p-1-e;let $=-1,b=null;for(let a=1;!(Date.now()-E>=v.timeBudget);a++){const l=L-v.windowSize*a;g.lastIndex=Math.max(0,l);const r=c(g,m,L,$);if(!r&&b||(b=r,l<=0))break;$=l}if(b){const a={word:b[0],startColumn:e+1+b.index,endColumn:e+1+b.index+b[0].length};return g.lastIndex=0,a}return null}function c(p,g,m,e){let v;for(;v=p.exec(g);){const E=v.index||0;if(E<=m&&p.lastIndex>=m)return v;if(e>0&&E>e)return null}return null}}),re(ie[8],se([0,1,6,3,4]),function(O,t,i,F,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$x2=t.$w2=t.$v2=t.$u2=t.$t2=void 0;class f{static trivial(p,g){return new f([new j(y.$jt.ofLength(p.length),y.$jt.ofLength(g.length))],!1)}static trivialTimedOut(p,g){return new f([new j(y.$jt.ofLength(p.length),y.$jt.ofLength(g.length))],!0)}constructor(p,g){this.diffs=p,this.hitTimeout=g}}t.$t2=f;class j{static invert(p,g){const m=[];return(0,i.$Bb)(p,(e,v)=>{m.push(j.fromOffsetPairs(e?e.getEndExclusives():h.zero,v?v.getStarts():new h(g,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+g)))}),m}static fromOffsetPairs(p,g){return new j(new y.$jt(p.offset1,g.offset1),new y.$jt(p.offset2,g.offset2))}constructor(p,g){this.seq1Range=p,this.seq2Range=g}swap(){return new j(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(p){return new j(this.seq1Range.join(p.seq1Range),this.seq2Range.join(p.seq2Range))}delta(p){return p===0?this:new j(this.seq1Range.delta(p),this.seq2Range.delta(p))}deltaStart(p){return p===0?this:new j(this.seq1Range.deltaStart(p),this.seq2Range.deltaStart(p))}deltaEnd(p){return p===0?this:new j(this.seq1Range.deltaEnd(p),this.seq2Range.deltaEnd(p))}intersectsOrTouches(p){return this.seq1Range.intersectsOrTouches(p.seq1Range)||this.seq2Range.intersectsOrTouches(p.seq2Range)}intersect(p){const g=this.seq1Range.intersect(p.seq1Range),m=this.seq2Range.intersect(p.seq2Range);if(!(!g||!m))return new j(g,m)}getStarts(){return new h(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new h(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.$u2=j;class h{static{this.zero=new h(0,0)}static{this.max=new h(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor(p,g){this.offset1=p,this.offset2=g}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(p){return p===0?this:new h(this.offset1+p,this.offset2+p)}equals(p){return this.offset1===p.offset1&&this.offset2===p.offset2}}t.$v2=h;class o{static{this.instance=new o}isValid(){return!0}}t.$w2=o;class s{constructor(p){if(this.e=p,this.c=Date.now(),this.d=!0,p<=0)throw new F.$cb("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}t.$x2=s}),re(ie[31],se([0,1,4,8]),function(O,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$C2=void 0;class y{compute(s,c,p=F.$w2.instance){if(s.length===0||c.length===0)return F.$t2.trivial(s,c);const g=s,m=c;function e(u,N){for(;u<g.length&&N<m.length&&g.getElement(u)===m.getElement(N);)u++,N++;return u}let v=0;const E=new j;E.set(0,e(0,0));const L=new h;L.set(0,E.get(0)===0?null:new f(null,0,0,E.get(0)));let $=0;e:for(;;){if(v++,!p.isValid())return F.$t2.trivialTimedOut(g,m);const u=-Math.min(v,m.length+v%2),N=Math.min(v,g.length+v%2);for($=u;$<=N;$+=2){let d=0;const w=$===N?-1:E.get($+1),A=$===u?-1:E.get($-1)+1;d++;const C=Math.min(Math.max(w,A),g.length),M=C-$;if(d++,C>g.length||M>m.length)continue;const T=e(C,M);E.set($,T);const S=C===w?L.get($+1):L.get($-1);if(L.set($,T!==C?new f(S,C,M,T-C):S),E.get($)===g.length&&E.get($)-$===m.length)break e}}let b=L.get($);const a=[];let l=g.length,r=m.length;for(;;){const u=b?b.x+b.length:0,N=b?b.y+b.length:0;if((u!==l||N!==r)&&a.push(new F.$u2(new i.$jt(u,l),new i.$jt(N,r))),!b)break;l=b.x,r=b.y,b=b.prev}return a.reverse(),new F.$t2(a,!1)}}t.$C2=y;class f{constructor(s,c,p,g){this.prev=s,this.x=c,this.y=p,this.length=g}}class j{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,c){if(s<0){if(s=-s-1,s>=this.b.length){const p=this.b;this.b=new Int32Array(p.length*2),this.b.set(p)}this.b[s]=c}else{if(s>=this.a.length){const p=this.a;this.a=new Int32Array(p.length*2),this.a.set(p)}this.a[s]=c}}}class h{constructor(){this.a=[],this.b=[]}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,c){s<0?(s=-s-1,this.b[s]=c):this.a[s]=c}}}),re(ie[47],se([0,1,6,4,8]),function(O,t,i,F,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$G2=f,t.$H2=s,t.$I2=c,t.$J2=g,t.$K2=m;function f(e,v,E){let L=E;return L=j(e,v,L),L=j(e,v,L),L=h(e,v,L),L}function j(e,v,E){if(E.length===0)return E;const L=[];L.push(E[0]);for(let b=1;b<E.length;b++){const a=L[L.length-1];let l=E[b];if(l.seq1Range.isEmpty||l.seq2Range.isEmpty){const r=l.seq1Range.start-a.seq1Range.endExclusive;let u;for(u=1;u<=r&&!(e.getElement(l.seq1Range.start-u)!==e.getElement(l.seq1Range.endExclusive-u)||v.getElement(l.seq2Range.start-u)!==v.getElement(l.seq2Range.endExclusive-u));u++);if(u--,u===r){L[L.length-1]=new y.$u2(new F.$jt(a.seq1Range.start,l.seq1Range.endExclusive-r),new F.$jt(a.seq2Range.start,l.seq2Range.endExclusive-r));continue}l=l.delta(-u)}L.push(l)}const $=[];for(let b=0;b<L.length-1;b++){const a=L[b+1];let l=L[b];if(l.seq1Range.isEmpty||l.seq2Range.isEmpty){const r=a.seq1Range.start-l.seq1Range.endExclusive;let u;for(u=0;u<r&&!(!e.isStronglyEqual(l.seq1Range.start+u,l.seq1Range.endExclusive+u)||!v.isStronglyEqual(l.seq2Range.start+u,l.seq2Range.endExclusive+u));u++);if(u===r){L[b+1]=new y.$u2(new F.$jt(l.seq1Range.start+r,a.seq1Range.endExclusive),new F.$jt(l.seq2Range.start+r,a.seq2Range.endExclusive));continue}u>0&&(l=l.delta(u))}$.push(l)}return L.length>0&&$.push(L[L.length-1]),$}function h(e,v,E){if(!e.getBoundaryScore||!v.getBoundaryScore)return E;for(let L=0;L<E.length;L++){const $=L>0?E[L-1]:void 0,b=E[L],a=L+1<E.length?E[L+1]:void 0,l=new F.$jt($?$.seq1Range.endExclusive+1:0,a?a.seq1Range.start-1:e.length),r=new F.$jt($?$.seq2Range.endExclusive+1:0,a?a.seq2Range.start-1:v.length);b.seq1Range.isEmpty?E[L]=o(b,e,v,l,r):b.seq2Range.isEmpty&&(E[L]=o(b.swap(),v,e,r,l).swap())}return E}function o(e,v,E,L,$){let a=1;for(;e.seq1Range.start-a>=L.start&&e.seq2Range.start-a>=$.start&&E.isStronglyEqual(e.seq2Range.start-a,e.seq2Range.endExclusive-a)&&a<100;)a++;a--;let l=0;for(;e.seq1Range.start+l<L.endExclusive&&e.seq2Range.endExclusive+l<$.endExclusive&&E.isStronglyEqual(e.seq2Range.start+l,e.seq2Range.endExclusive+l)&&l<100;)l++;if(a===0&&l===0)return e;let r=0,u=-1;for(let N=-a;N<=l;N++){const d=e.seq2Range.start+N,w=e.seq2Range.endExclusive+N,A=e.seq1Range.start+N,C=v.getBoundaryScore(A)+E.getBoundaryScore(d)+E.getBoundaryScore(w);C>u&&(u=C,r=N)}return e.delta(r)}function s(e,v,E){const L=[];for(const $ of E){const b=L[L.length-1];if(!b){L.push($);continue}$.seq1Range.start-b.seq1Range.endExclusive<=2||$.seq2Range.start-b.seq2Range.endExclusive<=2?L[L.length-1]=new y.$u2(b.seq1Range.join($.seq1Range),b.seq2Range.join($.seq2Range)):L.push($)}return L}function c(e,v,E){const L=y.$u2.invert(E,e.length),$=[];let b=new y.$v2(0,0);function a(r,u){if(r.offset1<b.offset1||r.offset2<b.offset2)return;const N=e.findWordContaining(r.offset1),d=v.findWordContaining(r.offset2);if(!N||!d)return;let w=new y.$u2(N,d);const A=w.intersect(u);let C=A.seq1Range.length,M=A.seq2Range.length;for(;L.length>0;){const T=L[0];if(!(T.seq1Range.intersects(w.seq1Range)||T.seq2Range.intersects(w.seq2Range)))break;const k=e.findWordContaining(T.seq1Range.start),R=v.findWordContaining(T.seq2Range.start),x=new y.$u2(k,R),I=x.intersect(T);if(C+=I.seq1Range.length,M+=I.seq2Range.length,w=w.join(x),w.seq1Range.endExclusive>=T.seq1Range.endExclusive)L.shift();else break}C+M<(w.seq1Range.length+w.seq2Range.length)*2/3&&$.push(w),b=w.getEndExclusives()}for(;L.length>0;){const r=L.shift();r.seq1Range.isEmpty||(a(r.getStarts(),r),a(r.getEndExclusives().delta(-1),r))}return p(E,$)}function p(e,v){const E=[];for(;e.length>0||v.length>0;){const L=e[0],$=v[0];let b;L&&(!$||L.seq1Range.start<$.seq1Range.start)?b=e.shift():b=v.shift(),E.length>0&&E[E.length-1].seq1Range.endExclusive>=b.seq1Range.start?E[E.length-1]=E[E.length-1].join(b):E.push(b)}return E}function g(e,v,E){let L=E;if(L.length===0)return L;let $=0,b;do{b=!1;const a=[L[0]];for(let l=1;l<L.length;l++){let N=function(w,A){const C=new F.$jt(u.seq1Range.endExclusive,r.seq1Range.start);return e.getText(C).replace(/\s/g,"").length<=4&&(w.seq1Range.length+w.seq2Range.length>5||A.seq1Range.length+A.seq2Range.length>5)};const r=L[l],u=a[a.length-1];N(u,r)?(b=!0,a[a.length-1]=a[a.length-1].join(r)):a.push(r)}L=a}while($++<10&&b);return L}function m(e,v,E){let L=E;if(L.length===0)return L;let $=0,b;do{b=!1;const l=[L[0]];for(let r=1;r<L.length;r++){let d=function(A,C){const M=new F.$jt(N.seq1Range.endExclusive,u.seq1Range.start);if(e.countLinesIn(M)>5||M.length>500)return!1;const S=e.getText(M).trim();if(S.length>20||S.split(/\r\n|\r|\n/).length>1)return!1;const k=e.countLinesIn(A.seq1Range),R=A.seq1Range.length,x=v.countLinesIn(A.seq2Range),I=A.seq2Range.length,G=e.countLinesIn(C.seq1Range),K=C.seq1Range.length,_=v.countLinesIn(C.seq2Range),X=C.seq2Range.length,Q=2*40+50;function P(H){return Math.min(H,Q)}return Math.pow(Math.pow(P(k*40+R),1.5)+Math.pow(P(x*40+I),1.5),1.5)+Math.pow(Math.pow(P(G*40+K),1.5)+Math.pow(P(_*40+X),1.5),1.5)>(Q**1.5)**1.5*1.3};const u=L[r],N=l[l.length-1];d(N,u)?(b=!0,l[l.length-1]=l[l.length-1].join(u)):l.push(u)}L=l}while($++<10&&b);const a=[];return(0,i.$Cb)(L,(l,r,u)=>{let N=r;function d(S){return S.length>0&&S.trim().length<=3&&r.seq1Range.length+r.seq2Range.length>100}const w=e.extendToFullLines(r.seq1Range),A=e.getText(new F.$jt(w.start,r.seq1Range.start));d(A)&&(N=N.deltaStart(-A.length));const C=e.getText(new F.$jt(r.seq1Range.endExclusive,w.endExclusive));d(C)&&(N=N.deltaEnd(C.length));const M=y.$u2.fromOffsetPairs(l?l.getEndExclusives():y.$v2.zero,u?u.getStarts():y.$v2.max),T=N.intersect(M);a.length>0&&T.getStarts().equals(a[a.length-1].getEndExclusives())?a[a.length-1]=a[a.length-1].join(T):a.push(T)}),a}}),re(ie[48],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$F2=void 0;class i{constructor(f,j){this.a=f,this.b=j}getElement(f){return this.a[f]}get length(){return this.a.length}getBoundaryScore(f){const j=f===0?0:F(this.b[f-1]),h=f===this.b.length?0:F(this.b[f]);return 1e3-(j+h)}getText(f){return this.b.slice(f.start,f.endExclusive).join(`
`)}isStronglyEqual(f,j){return this.b[f]===this.b[j]}}t.$F2=i;function F(y){let f=0;for(;f<y.length&&(y.charCodeAt(f)===32||y.charCodeAt(f)===9);)f++;return f}}),re(ie[16],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$A2=t.$y2=void 0,t.$z2=F;class i{constructor(j,h){this.width=j,this.height=h,this.a=[],this.a=new Array(j*h)}get(j,h){return this.a[j+h*this.width]}set(j,h,o){this.a[j+h*this.width]=o}}t.$y2=i;function F(f){return f===32||f===9}class y{static{this.a=new Map}static b(j){let h=this.a.get(j);return h===void 0&&(h=this.a.size,this.a.set(j,h)),h}constructor(j,h,o){this.range=j,this.lines=h,this.source=o,this.d=[];let s=0;for(let c=j.startLineNumber-1;c<j.endLineNumberExclusive-1;c++){const p=h[c];for(let m=0;m<p.length;m++){s++;const e=p[m],v=y.b(e);this.d[v]=(this.d[v]||0)+1}s++;const g=y.b(`
`);this.d[g]=(this.d[g]||0)+1}this.c=s}computeSimilarity(j){let h=0;const o=Math.max(this.d.length,j.d.length);for(let s=0;s<o;s++)h+=Math.abs((this.d[s]??0)-(j.d[s]??0));return 1-h/(this.c+j.c)}}t.$A2=y}),re(ie[49],se([0,1,4,8,16]),function(O,t,i,F,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$B2=void 0;class f{compute(h,o,s=F.$w2.instance,c){if(h.length===0||o.length===0)return F.$t2.trivial(h,o);const p=new y.$y2(h.length,o.length),g=new y.$y2(h.length,o.length),m=new y.$y2(h.length,o.length);for(let a=0;a<h.length;a++)for(let l=0;l<o.length;l++){if(!s.isValid())return F.$t2.trivialTimedOut(h,o);const r=a===0?0:p.get(a-1,l),u=l===0?0:p.get(a,l-1);let N;h.getElement(a)===o.getElement(l)?(a===0||l===0?N=0:N=p.get(a-1,l-1),a>0&&l>0&&g.get(a-1,l-1)===3&&(N+=m.get(a-1,l-1)),N+=c?c(a,l):1):N=-1;const d=Math.max(r,u,N);if(d===N){const w=a>0&&l>0?m.get(a-1,l-1):0;m.set(a,l,w+1),g.set(a,l,3)}else d===r?(m.set(a,l,0),g.set(a,l,1)):d===u&&(m.set(a,l,0),g.set(a,l,2));p.set(a,l,d)}const e=[];let v=h.length,E=o.length;function L(a,l){(a+1!==v||l+1!==E)&&e.push(new F.$u2(new i.$jt(a+1,v),new i.$jt(l+1,E))),v=a,E=l}let $=h.length-1,b=o.length-1;for(;$>=0&&b>=0;)g.get($,b)===3?(L($,b),$--,b--):g.get($,b)===1?$--:b--;return L(-1,-1),e.reverse(),new F.$t2(e,!1)}}t.$B2=f}),re(ie[32],se([0,1,9,4,5,2,16]),function(O,t,i,F,y,f,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$D2=void 0;class h{constructor(e,v,E){this.lines=e,this.considerWhitespaceChanges=E,this.b=[],this.c=[],this.d=[];let L=!1;v.start>0&&v.endExclusive>=e.length&&(v=new F.$jt(v.start-1,v.endExclusive),L=!0),this.lineRange=v,this.c[0]=0;for(let $=this.lineRange.start;$<this.lineRange.endExclusive;$++){let b=e[$],a=0;if(L)a=b.length,b="",L=!1;else if(!E){const l=b.trimStart();a=b.length-l.length,b=l.trimEnd()}this.d.push(a);for(let l=0;l<b.length;l++)this.b.push(b.charCodeAt(l));$<e.length-1&&(this.b.push(10),this.c[$-this.lineRange.start+1]=this.b.length)}this.d.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new F.$jt(0,this.length))}getText(e){return this.b.slice(e.start,e.endExclusive).map(v=>String.fromCharCode(v)).join("")}getElement(e){return this.b[e]}get length(){return this.b.length}getBoundaryScore(e){const v=g(e>0?this.b[e-1]:-1),E=g(e<this.b.length?this.b[e]:-1);if(v===7&&E===8)return 0;if(v===8)return 150;let L=0;return v!==E&&(L+=10,v===0&&E===1&&(L+=1)),L+=p(v),L+=p(E),L}translateOffset(e){if(this.lineRange.isEmpty)return new y.$bt(this.lineRange.start+1,1);const v=(0,i.$ib)(this.c,E=>E<=e);return new y.$bt(this.lineRange.start+v+1,e-this.c[v]+this.d[v]+1)}translateRange(e){return f.$ct.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.b.length||!o(this.b[e]))return;let v=e;for(;v>0&&o(this.b[v-1]);)v--;let E=e;for(;E<this.b.length&&o(this.b[E]);)E++;return new F.$jt(v,E)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,v){return this.b[e]===this.b[v]}extendToFullLines(e){const v=(0,i.$hb)(this.c,L=>L<=e.start)??0,E=(0,i.$jb)(this.c,L=>e.endExclusive<=L)??this.b.length;return new F.$jt(v,E)}}t.$D2=h;function o(m){return m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57}var s;(function(m){m[m.WordLower=0]="WordLower",m[m.WordUpper=1]="WordUpper",m[m.WordNumber=2]="WordNumber",m[m.End=3]="End",m[m.Other=4]="Other",m[m.Separator=5]="Separator",m[m.Space=6]="Space",m[m.LineBreakCR=7]="LineBreakCR",m[m.LineBreakLF=8]="LineBreakLF"})(s||(s={}));const c={0:0,1:0,2:0,3:10,4:2,5:30,6:3,7:10,8:10};function p(m){return c[m]}function g(m){return m===10?8:m===13?7:(0,j.$z2)(m)?6:m>=97&&m<=122?0:m>=65&&m<=90?1:m>=48&&m<=57?2:m===-1?3:m===44||m===59?5:4}}),re(ie[33],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rt=t.$qt=void 0;class i{constructor(f,j,h){this.changes=f,this.moves=j,this.hitTimeout=h}}t.$qt=i;class F{constructor(f,j){this.lineRangeMapping=f,this.changes=j}flip(){return new F(this.lineRangeMapping.flip(),this.changes.map(f=>f.flip()))}}t.$rt=F}),re(ie[17],se([0,1,12]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pt=t.$ot=t.$nt=void 0;class F{static inverse(h,o,s){const c=[];let p=1,g=1;for(const e of h){const v=new F(new i.$lt(p,e.original.startLineNumber),new i.$lt(g,e.modified.startLineNumber));v.modified.isEmpty||c.push(v),p=e.original.endLineNumberExclusive,g=e.modified.endLineNumberExclusive}const m=new F(new i.$lt(p,o+1),new i.$lt(g,s+1));return m.modified.isEmpty||c.push(m),c}static clip(h,o,s){const c=[];for(const p of h){const g=p.original.intersect(o),m=p.modified.intersect(s);g&&!g.isEmpty&&m&&!m.isEmpty&&c.push(new F(g,m))}return c}constructor(h,o){this.original=h,this.modified=o}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new F(this.modified,this.original)}join(h){return new F(this.original.join(h.original),this.modified.join(h.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}}t.$nt=F;class y extends F{static fromRangeMappings(h){const o=i.$lt.join(h.map(c=>i.$lt.fromRangeInclusive(c.originalRange))),s=i.$lt.join(h.map(c=>i.$lt.fromRangeInclusive(c.modifiedRange)));return new y(o,s,h)}constructor(h,o,s){super(h,o),this.innerChanges=s}flip(){return new y(this.modified,this.original,this.innerChanges?.map(h=>h.flip()))}}t.$ot=y;class f{constructor(h,o){this.originalRange=h,this.modifiedRange=o}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new f(this.modifiedRange,this.originalRange)}}t.$pt=f}),re(ie[50],se([0,1,8,17,6,9,14,12,4,32,16,31]),function(O,t,i,F,y,f,j,h,o,s,c,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$E2=g;function g(b,a,l,r,u,N){let{moves:d,excludedChanges:w}=e(b,a,l,N);if(!N.isValid())return[];const A=b.filter(M=>!w.has(M)),C=v(A,r,u,a,l,N);return(0,y.$1b)(d,C),d=L(d),d=d.filter(M=>{const T=M.original.toOffsetRange().slice(a).map(k=>k.trim());return T.join(`
`).length>=15&&m(T,k=>k.length>=2)>=2}),d=$(b,d),d}function m(b,a){let l=0;for(const r of b)a(r)&&l++;return l}function e(b,a,l,r){const u=[],N=b.filter(A=>A.modified.isEmpty&&A.original.length>=3).map(A=>new c.$A2(A.original,a,A)),d=new Set(b.filter(A=>A.original.isEmpty&&A.modified.length>=3).map(A=>new c.$A2(A.modified,l,A))),w=new Set;for(const A of N){let C=-1,M;for(const T of d){const S=A.computeSimilarity(T);S>C&&(C=S,M=T)}if(C>.9&&M&&(d.delete(M),u.push(new F.$nt(A.range,M.range)),w.add(A.source),w.add(M.source)),!r.isValid())return{moves:u,excludedChanges:w}}return{moves:u,excludedChanges:w}}function v(b,a,l,r,u,N){const d=[],w=new j.$Hc;for(const S of b)for(let k=S.original.startLineNumber;k<S.original.endLineNumberExclusive-2;k++){const R=`${a[k-1]}:${a[k+1-1]}:${a[k+2-1]}`;w.add(R,{range:new h.$lt(k,k+3)})}const A=[];b.sort((0,y.$7b)(S=>S.modified.startLineNumber,y.$9b));for(const S of b){let k=[];for(let R=S.modified.startLineNumber;R<S.modified.endLineNumberExclusive-2;R++){const x=`${l[R-1]}:${l[R+1-1]}:${l[R+2-1]}`,I=new h.$lt(R,R+3),G=[];w.forEach(x,({range:K})=>{for(const X of k)if(X.originalLineRange.endLineNumberExclusive+1===K.endLineNumberExclusive&&X.modifiedLineRange.endLineNumberExclusive+1===I.endLineNumberExclusive){X.originalLineRange=new h.$lt(X.originalLineRange.startLineNumber,K.endLineNumberExclusive),X.modifiedLineRange=new h.$lt(X.modifiedLineRange.startLineNumber,I.endLineNumberExclusive),G.push(X);return}const _={modifiedLineRange:I,originalLineRange:K};A.push(_),G.push(_)}),k=G}if(!N.isValid())return[]}A.sort((0,y.$$b)((0,y.$7b)(S=>S.modifiedLineRange.length,y.$9b)));const C=new h.$mt,M=new h.$mt;for(const S of A){const k=S.modifiedLineRange.startLineNumber-S.originalLineRange.startLineNumber,R=C.subtractFrom(S.modifiedLineRange),x=M.subtractFrom(S.originalLineRange).getWithDelta(k),I=R.getIntersection(x);for(const G of I.ranges){if(G.length<3)continue;const K=G,_=G.delta(-k);d.push(new F.$nt(_,K)),C.addRange(K),M.addRange(_)}}d.sort((0,y.$7b)(S=>S.original.startLineNumber,y.$9b));const T=new f.$mb(b);for(let S=0;S<d.length;S++){const k=d[S],R=T.findLastMonotonous(P=>P.original.startLineNumber<=k.original.startLineNumber),x=(0,f.$hb)(b,P=>P.modified.startLineNumber<=k.modified.startLineNumber),I=Math.max(k.original.startLineNumber-R.original.startLineNumber,k.modified.startLineNumber-x.modified.startLineNumber),G=T.findLastMonotonous(P=>P.original.startLineNumber<k.original.endLineNumberExclusive),K=(0,f.$hb)(b,P=>P.modified.startLineNumber<k.modified.endLineNumberExclusive),_=Math.max(G.original.endLineNumberExclusive-k.original.endLineNumberExclusive,K.modified.endLineNumberExclusive-k.modified.endLineNumberExclusive);let X;for(X=0;X<I;X++){const P=k.original.startLineNumber-X-1,H=k.modified.startLineNumber-X-1;if(P>r.length||H>u.length||C.contains(H)||M.contains(P)||!E(r[P-1],u[H-1],N))break}X>0&&(M.addRange(new h.$lt(k.original.startLineNumber-X,k.original.startLineNumber)),C.addRange(new h.$lt(k.modified.startLineNumber-X,k.modified.startLineNumber)));let Q;for(Q=0;Q<_;Q++){const P=k.original.endLineNumberExclusive+Q,H=k.modified.endLineNumberExclusive+Q;if(P>r.length||H>u.length||C.contains(H)||M.contains(P)||!E(r[P-1],u[H-1],N))break}Q>0&&(M.addRange(new h.$lt(k.original.endLineNumberExclusive,k.original.endLineNumberExclusive+Q)),C.addRange(new h.$lt(k.modified.endLineNumberExclusive,k.modified.endLineNumberExclusive+Q))),(X>0||Q>0)&&(d[S]=new F.$nt(new h.$lt(k.original.startLineNumber-X,k.original.endLineNumberExclusive+Q),new h.$lt(k.modified.startLineNumber-X,k.modified.endLineNumberExclusive+Q)))}return d}function E(b,a,l){if(b.trim()===a.trim())return!0;if(b.length>300&&a.length>300)return!1;const u=new p.$C2().compute(new s.$D2([b],new o.$jt(0,1),!1),new s.$D2([a],new o.$jt(0,1),!1),l);let N=0;const d=i.$u2.invert(u.diffs,b.length);for(const M of d)M.seq1Range.forEach(T=>{(0,c.$z2)(b.charCodeAt(T))||N++});function w(M){let T=0;for(let S=0;S<b.length;S++)(0,c.$z2)(M.charCodeAt(S))||T++;return T}const A=w(b.length>a.length?b:a);return N/A>.6&&A>10}function L(b){if(b.length===0)return b;b.sort((0,y.$7b)(l=>l.original.startLineNumber,y.$9b));const a=[b[0]];for(let l=1;l<b.length;l++){const r=a[a.length-1],u=b[l],N=u.original.startLineNumber-r.original.endLineNumberExclusive,d=u.modified.startLineNumber-r.modified.endLineNumberExclusive;if(N>=0&&d>=0&&N+d<=2){a[a.length-1]=r.join(u);continue}a.push(u)}return a}function $(b,a){const l=new f.$mb(b);return a=a.filter(r=>{const u=l.findLastMonotonous(w=>w.original.startLineNumber<r.original.endLineNumberExclusive)||new F.$nt(new h.$lt(1,1),new h.$lt(1,1)),N=(0,f.$hb)(b,w=>w.modified.startLineNumber<r.modified.endLineNumberExclusive);return u!==N}),a}}),re(ie[51],se([0,1,6,13,12,4,2,8,49,31,50,47,48,32,33,17]),function(O,t,i,F,y,f,j,h,o,s,c,p,g,m,e,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$L2=void 0,t.$M2=L,t.$N2=$;class E{constructor(){this.e=new o.$B2,this.f=new s.$C2}computeDiff(a,l,r){if(a.length<=1&&(0,i.$ub)(a,l,(Q,P)=>Q===P))return new e.$qt([],[],!1);if(a.length===1&&a[0].length===0||l.length===1&&l[0].length===0)return new e.$qt([new v.$ot(new y.$lt(1,a.length+1),new y.$lt(1,l.length+1),[new v.$pt(new j.$ct(1,1,a.length,a[0].length+1),new j.$ct(1,1,l.length,l[0].length+1))])],[],!1);const u=r.maxComputationTimeMs===0?h.$w2.instance:new h.$x2(r.maxComputationTimeMs),N=!r.ignoreTrimWhitespace,d=new Map;function w(Q){let P=d.get(Q);return P===void 0&&(P=d.size,d.set(Q,P)),P}const A=a.map(Q=>w(Q.trim())),C=l.map(Q=>w(Q.trim())),M=new g.$F2(A,a),T=new g.$F2(C,l),S=M.length+T.length<1700?this.e.compute(M,T,u,(Q,P)=>a[Q]===l[P]?l[P].length===0?.1:1+Math.log(1+l[P].length):.99):this.f.compute(M,T);let k=S.diffs,R=S.hitTimeout;k=(0,p.$G2)(M,T,k),k=(0,p.$J2)(M,T,k);const x=[],I=Q=>{if(N)for(let P=0;P<Q;P++){const H=G+P,ue=K+P;if(a[H]!==l[ue]){const oe=this.j(a,l,new h.$u2(new f.$jt(H,H+1),new f.$jt(ue,ue+1)),u,N);for(const n of oe.mappings)x.push(n);oe.hitTimeout&&(R=!0)}}};let G=0,K=0;for(const Q of k){(0,F.$ad)(()=>Q.seq1Range.start-G===Q.seq2Range.start-K);const P=Q.seq1Range.start-G;I(P),G=Q.seq1Range.endExclusive,K=Q.seq2Range.endExclusive;const H=this.j(a,l,Q,u,N);H.hitTimeout&&(R=!0);for(const ue of H.mappings)x.push(ue)}I(a.length-G);const _=L(x,a,l);let X=[];return r.computeMoves&&(X=this.h(_,a,l,A,C,u,N)),(0,F.$ad)(()=>{function Q(H,ue){if(H.lineNumber<1||H.lineNumber>ue.length)return!1;const oe=ue[H.lineNumber-1];return!(H.column<1||H.column>oe.length+1)}function P(H,ue){return!(H.startLineNumber<1||H.startLineNumber>ue.length+1||H.endLineNumberExclusive<1||H.endLineNumberExclusive>ue.length+1)}for(const H of _){if(!H.innerChanges)return!1;for(const ue of H.innerChanges)if(!(Q(ue.modifiedRange.getStartPosition(),l)&&Q(ue.modifiedRange.getEndPosition(),l)&&Q(ue.originalRange.getStartPosition(),a)&&Q(ue.originalRange.getEndPosition(),a)))return!1;if(!P(H.modified,l)||!P(H.original,a))return!1}return!0}),new e.$qt(_,X,R)}h(a,l,r,u,N,d,w){return(0,c.$E2)(a,l,r,u,N,d).map(M=>{const T=this.j(l,r,new h.$u2(M.original.toOffsetRange(),M.modified.toOffsetRange()),d,w),S=L(T.mappings,l,r,!0);return new e.$rt(M,S)})}j(a,l,r,u,N){const d=new m.$D2(a,r.seq1Range,N),w=new m.$D2(l,r.seq2Range,N),A=d.length+w.length<500?this.e.compute(d,w,u):this.f.compute(d,w,u);let C=A.diffs;return C=(0,p.$G2)(d,w,C),C=(0,p.$I2)(d,w,C),C=(0,p.$H2)(d,w,C),C=(0,p.$K2)(d,w,C),{mappings:C.map(T=>new v.$pt(d.translateRange(T.seq1Range),w.translateRange(T.seq2Range))),hitTimeout:A.hitTimeout}}}t.$L2=E;function L(b,a,l,r=!1){const u=[];for(const N of(0,i.$Ab)(b.map(d=>$(d,a,l)),(d,w)=>d.original.overlapOrTouch(w.original)||d.modified.overlapOrTouch(w.modified))){const d=N[0],w=N[N.length-1];u.push(new v.$ot(d.original.join(w.original),d.modified.join(w.modified),N.map(A=>A.innerChanges[0])))}return(0,F.$ad)(()=>!r&&u.length>0&&(u[0].modified.startLineNumber!==u[0].original.startLineNumber||l.length-u[u.length-1].modified.endLineNumberExclusive!==a.length-u[u.length-1].original.endLineNumberExclusive)?!1:(0,F.$bd)(u,(N,d)=>d.original.startLineNumber-N.original.endLineNumberExclusive===d.modified.startLineNumber-N.modified.endLineNumberExclusive&&N.original.endLineNumberExclusive<d.original.startLineNumber&&N.modified.endLineNumberExclusive<d.modified.startLineNumber)),u}function $(b,a,l){let r=0,u=0;b.modifiedRange.endColumn===1&&b.originalRange.endColumn===1&&b.originalRange.startLineNumber+r<=b.originalRange.endLineNumber&&b.modifiedRange.startLineNumber+r<=b.modifiedRange.endLineNumber&&(u=-1),b.modifiedRange.startColumn-1>=l[b.modifiedRange.startLineNumber-1].length&&b.originalRange.startColumn-1>=a[b.originalRange.startLineNumber-1].length&&b.originalRange.startLineNumber<=b.originalRange.endLineNumber+u&&b.modifiedRange.startLineNumber<=b.modifiedRange.endLineNumber+u&&(r=1);const N=new y.$lt(b.originalRange.startLineNumber+r,b.originalRange.endLineNumber+1+u),d=new y.$lt(b.modifiedRange.startLineNumber+r,b.modifiedRange.endLineNumber+1+u);return new v.$ot(N,d,[b])}}),re(ie[34],se([0,1,25,33,17,7,2,13,12]),function(O,t,i,F,y,f,j,h,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tt=t.$st=void 0;const s=3;class c{computeDiff(r,u,N){const w=new L(r,u,{maxComputationTime:N.maxComputationTimeMs,shouldIgnoreTrimWhitespace:N.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),A=[];let C=null;for(const M of w.changes){let T;M.originalEndLineNumber===0?T=new o.$lt(M.originalStartLineNumber+1,M.originalStartLineNumber+1):T=new o.$lt(M.originalStartLineNumber,M.originalEndLineNumber+1);let S;M.modifiedEndLineNumber===0?S=new o.$lt(M.modifiedStartLineNumber+1,M.modifiedStartLineNumber+1):S=new o.$lt(M.modifiedStartLineNumber,M.modifiedEndLineNumber+1);let k=new y.$ot(T,S,M.charChanges?.map(R=>new y.$pt(new j.$ct(R.originalStartLineNumber,R.originalStartColumn,R.originalEndLineNumber,R.originalEndColumn),new j.$ct(R.modifiedStartLineNumber,R.modifiedStartColumn,R.modifiedEndLineNumber,R.modifiedEndColumn))));C&&(C.modified.endLineNumberExclusive===k.modified.startLineNumber||C.original.endLineNumberExclusive===k.original.startLineNumber)&&(k=new y.$ot(C.original.join(k.original),C.modified.join(k.modified),C.innerChanges&&k.innerChanges?C.innerChanges.concat(k.innerChanges):void 0),A.pop()),A.push(k),C=k}return(0,h.$ad)(()=>(0,h.$bd)(A,(M,T)=>T.original.startLineNumber-M.original.endLineNumberExclusive===T.modified.startLineNumber-M.modified.endLineNumberExclusive&&M.original.endLineNumberExclusive<T.original.startLineNumber&&M.modified.endLineNumberExclusive<T.modified.startLineNumber)),new F.$qt(A,[],w.quitEarly)}}t.$st=c;function p(l,r,u,N){return new i.$it(l,r,u).ComputeDiff(N)}class g{constructor(r){const u=[],N=[];for(let d=0,w=r.length;d<w;d++)u[d]=$(r[d],1),N[d]=b(r[d],1);this.lines=r,this.a=u,this.b=N}getElements(){const r=[];for(let u=0,N=this.lines.length;u<N;u++)r[u]=this.lines[u].substring(this.a[u]-1,this.b[u]-1);return r}getStrictElement(r){return this.lines[r]}getStartLineNumber(r){return r+1}getEndLineNumber(r){return r+1}createCharSequence(r,u,N){const d=[],w=[],A=[];let C=0;for(let M=u;M<=N;M++){const T=this.lines[M],S=r?this.a[M]:1,k=r?this.b[M]:T.length+1;for(let R=S;R<k;R++)d[C]=T.charCodeAt(R-1),w[C]=M+1,A[C]=R,C++;!r&&M<N&&(d[C]=10,w[C]=M+1,A[C]=T.length+1,C++)}return new m(d,w,A)}}class m{constructor(r,u,N){this.a=r,this.b=u,this.d=N}toString(){return"["+this.a.map((r,u)=>(r===10?"\\n":String.fromCharCode(r))+`-(${this.b[u]},${this.d[u]})`).join(", ")+"]"}e(r,u){if(r<0||r>=u.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(r){return r>0&&r===this.b.length?this.getEndLineNumber(r-1):(this.e(r,this.b),this.b[r])}getEndLineNumber(r){return r===-1?this.getStartLineNumber(r+1):(this.e(r,this.b),this.a[r]===10?this.b[r]+1:this.b[r])}getStartColumn(r){return r>0&&r===this.d.length?this.getEndColumn(r-1):(this.e(r,this.d),this.d[r])}getEndColumn(r){return r===-1?this.getStartColumn(r+1):(this.e(r,this.d),this.a[r]===10?1:this.d[r]+1)}}class e{constructor(r,u,N,d,w,A,C,M){this.originalStartLineNumber=r,this.originalStartColumn=u,this.originalEndLineNumber=N,this.originalEndColumn=d,this.modifiedStartLineNumber=w,this.modifiedStartColumn=A,this.modifiedEndLineNumber=C,this.modifiedEndColumn=M}static createFromDiffChange(r,u,N){const d=u.getStartLineNumber(r.originalStart),w=u.getStartColumn(r.originalStart),A=u.getEndLineNumber(r.originalStart+r.originalLength-1),C=u.getEndColumn(r.originalStart+r.originalLength-1),M=N.getStartLineNumber(r.modifiedStart),T=N.getStartColumn(r.modifiedStart),S=N.getEndLineNumber(r.modifiedStart+r.modifiedLength-1),k=N.getEndColumn(r.modifiedStart+r.modifiedLength-1);return new e(d,w,A,C,M,T,S,k)}}function v(l){if(l.length<=1)return l;const r=[l[0]];let u=r[0];for(let N=1,d=l.length;N<d;N++){const w=l[N],A=w.originalStart-(u.originalStart+u.originalLength),C=w.modifiedStart-(u.modifiedStart+u.modifiedLength);Math.min(A,C)<s?(u.originalLength=w.originalStart+w.originalLength-u.originalStart,u.modifiedLength=w.modifiedStart+w.modifiedLength-u.modifiedStart):(r.push(w),u=w)}return r}class E{constructor(r,u,N,d,w){this.originalStartLineNumber=r,this.originalEndLineNumber=u,this.modifiedStartLineNumber=N,this.modifiedEndLineNumber=d,this.charChanges=w}static createFromDiffResult(r,u,N,d,w,A,C){let M,T,S,k,R;if(u.originalLength===0?(M=N.getStartLineNumber(u.originalStart)-1,T=0):(M=N.getStartLineNumber(u.originalStart),T=N.getEndLineNumber(u.originalStart+u.originalLength-1)),u.modifiedLength===0?(S=d.getStartLineNumber(u.modifiedStart)-1,k=0):(S=d.getStartLineNumber(u.modifiedStart),k=d.getEndLineNumber(u.modifiedStart+u.modifiedLength-1)),A&&u.originalLength>0&&u.originalLength<20&&u.modifiedLength>0&&u.modifiedLength<20&&w()){const x=N.createCharSequence(r,u.originalStart,u.originalStart+u.originalLength-1),I=d.createCharSequence(r,u.modifiedStart,u.modifiedStart+u.modifiedLength-1);if(x.getElements().length>0&&I.getElements().length>0){let G=p(x,I,w,!0).changes;C&&(G=v(G)),R=[];for(let K=0,_=G.length;K<_;K++)R.push(e.createFromDiffChange(G[K],x,I))}}return new E(M,T,S,k,R)}}class L{constructor(r,u,N){this.a=N.shouldComputeCharChanges,this.b=N.shouldPostProcessCharChanges,this.d=N.shouldIgnoreTrimWhitespace,this.e=N.shouldMakePrettyDiff,this.f=r,this.g=u,this.h=new g(r),this.j=new g(u),this.k=a(N.maxComputationTime),this.l=a(N.maxComputationTime===0?0:Math.min(N.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const r=p(this.h,this.j,this.k,this.e),u=r.changes,N=r.quitEarly;if(this.d){const C=[];for(let M=0,T=u.length;M<T;M++)C.push(E.createFromDiffResult(this.d,u[M],this.h,this.j,this.l,this.a,this.b));return{quitEarly:N,changes:C}}const d=[];let w=0,A=0;for(let C=-1,M=u.length;C<M;C++){const T=C+1<M?u[C+1]:null,S=T?T.originalStart:this.f.length,k=T?T.modifiedStart:this.g.length;for(;w<S&&A<k;){const R=this.f[w],x=this.g[A];if(R!==x){{let I=$(R,1),G=$(x,1);for(;I>1&&G>1;){const K=R.charCodeAt(I-2),_=x.charCodeAt(G-2);if(K!==_)break;I--,G--}(I>1||G>1)&&this.m(d,w+1,1,I,A+1,1,G)}{let I=b(R,1),G=b(x,1);const K=R.length+1,_=x.length+1;for(;I<K&&G<_;){const X=R.charCodeAt(I-1),Q=R.charCodeAt(G-1);if(X!==Q)break;I++,G++}(I<K||G<_)&&this.m(d,w+1,I,K,A+1,G,_)}}w++,A++}T&&(d.push(E.createFromDiffResult(this.d,T,this.h,this.j,this.l,this.a,this.b)),w+=T.originalLength,A+=T.modifiedLength)}return{quitEarly:N,changes:d}}m(r,u,N,d,w,A,C){if(this.n(r,u,N,d,w,A,C))return;let M;this.a&&(M=[new e(u,N,u,d,w,A,w,C)]),r.push(new E(u,u,w,w,M))}n(r,u,N,d,w,A,C){const M=r.length;if(M===0)return!1;const T=r[M-1];return T.originalEndLineNumber===0||T.modifiedEndLineNumber===0?!1:T.originalEndLineNumber===u&&T.modifiedEndLineNumber===w?(this.a&&T.charChanges&&T.charChanges.push(new e(u,N,u,d,w,A,w,C)),!0):T.originalEndLineNumber+1===u&&T.modifiedEndLineNumber+1===w?(T.originalEndLineNumber=u,T.modifiedEndLineNumber=w,this.a&&T.charChanges&&T.charChanges.push(new e(u,N,u,d,w,A,w,C)),!0):!1}}t.$tt=L;function $(l,r){const u=f.$af(l);return u===-1?r:u+1}function b(l,r){const u=f.$cf(l);return u===-1?r:u+2}function a(l){if(l===0)return()=>!0;const r=Date.now();return()=>Date.now()-r<l}}),re(ie[52],se([0,1,34,51]),function(O,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$O2=void 0,t.$O2={getLegacy:()=>new i.$st,getDefault:()=>new F.$L2}}),re(ie[53],se([0,1,36]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$P2=p;function F(g){const m=[];for(const e of g){const v=Number(e);(v||v===0&&e.replace(/\s/g,"")!=="")&&m.push(v)}return m}function y(g,m,e,v){return{red:g/255,blue:e/255,green:m/255,alpha:v}}function f(g,m){const e=m.index,v=m[0].length;if(!e)return;const E=g.positionAt(e);return{startLineNumber:E.lineNumber,startColumn:E.column,endLineNumber:E.lineNumber,endColumn:E.column+v}}function j(g,m){if(!g)return;const e=i.$Gt.Format.CSS.parseHex(m);if(e)return{range:g,color:y(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function h(g,m,e){if(!g||m.length!==1)return;const E=m[0].values(),L=F(E);return{range:g,color:y(L[0],L[1],L[2],e?L[3]:1)}}function o(g,m,e){if(!g||m.length!==1)return;const E=m[0].values(),L=F(E),$=new i.$Gt(new i.$Et(L[0],L[1]/100,L[2]/100,e?L[3]:1));return{range:g,color:y($.rgba.r,$.rgba.g,$.rgba.b,$.rgba.a)}}function s(g,m){return typeof g=="string"?[...g.matchAll(m)]:g.findMatches(m)}function c(g){const m=[],v=s(g,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(v.length>0)for(const E of v){const L=E.filter(l=>l!==void 0),$=L[1],b=L[2];if(!b)continue;let a;if($==="rgb"){const l=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;a=h(f(g,E),s(b,l),!1)}else if($==="rgba"){const l=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;a=h(f(g,E),s(b,l),!0)}else if($==="hsl"){const l=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;a=o(f(g,E),s(b,l),!1)}else if($==="hsla"){const l=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;a=o(f(g,E),s(b,l),!0)}else $==="#"&&(a=j(f(g,E),$+b));a&&m.push(a)}return m}function p(g){return!g||typeof g.getValue!="function"||typeof g.positionAt!="function"?[]:c(g)}}),re(ie[54],se([0,1,29]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$o2=t.$n2=t.State=void 0,t.$p2=g;var F;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(F||(t.State=F={}));class y{constructor(e,v,E){const L=new Uint8Array(e*v);for(let $=0,b=e*v;$<b;$++)L[$]=E;this.a=L,this.rows=e,this.cols=v}get(e,v){return this.a[e*this.cols+v]}set(e,v,E){this.a[e*this.cols+v]=E}}class f{constructor(e){let v=0,E=0;for(let $=0,b=e.length;$<b;$++){const[a,l,r]=e[$];l>v&&(v=l),a>E&&(E=a),r>E&&(E=r)}v++,E++;const L=new y(E,v,0);for(let $=0,b=e.length;$<b;$++){const[a,l,r]=e[$];L.set(a,l,r)}this.a=L,this.b=v}nextState(e,v){return v<0||v>=this.b?0:this.a.get(e,v)}}t.$n2=f;let j=null;function h(){return j===null&&(j=new f([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),j}var o;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(o||(o={}));let s=null;function c(){if(s===null){s=new i.$zt(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<m.length;v++)s.set(m.charCodeAt(v),1);const e=".,;:";for(let v=0;v<e.length;v++)s.set(e.charCodeAt(v),2)}return s}class p{static a(e,v,E,L,$){let b=$-1;do{const a=v.charCodeAt(b);if(e.get(a)!==2)break;b--}while(b>L);if(L>0){const a=v.charCodeAt(L-1),l=v.charCodeAt(b);(a===40&&l===41||a===91&&l===93||a===123&&l===125)&&b--}return{range:{startLineNumber:E,startColumn:L+1,endLineNumber:E,endColumn:b+2},url:v.substring(L,b+1)}}static computeLinks(e,v=h()){const E=c(),L=[];for(let $=1,b=e.getLineCount();$<=b;$++){const a=e.getLineContent($),l=a.length;let r=0,u=0,N=0,d=1,w=!1,A=!1,C=!1,M=!1;for(;r<l;){let T=!1;const S=a.charCodeAt(r);if(d===13){let k;switch(S){case 40:w=!0,k=0;break;case 41:k=w?0:1;break;case 91:C=!0,A=!0,k=0;break;case 93:C=!1,k=A?0:1;break;case 123:M=!0,k=0;break;case 125:k=M?0:1;break;case 39:case 34:case 96:N===S?k=1:N===39||N===34||N===96?k=0:k=1;break;case 42:k=N===42?1:0;break;case 124:k=N===124?1:0;break;case 32:k=C?0:1;break;default:k=E.get(S)}k===1&&(L.push(p.a(E,a,$,u,r)),T=!0)}else if(d===12){let k;S===91?(A=!0,k=0):k=E.get(S),k===1?T=!0:d=13}else d=v.nextState(d,S),d===0&&(T=!0);T&&(d=1,w=!1,A=!1,M=!1,u=r+1,N=S),r++}d===13&&L.push(p.a(E,a,$,u,l))}return L}}t.$o2=p;function g(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:p.computeLinks(m)}}),re(ie[55],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$q2=void 0;class i{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new i}navigateValueSet(y,f,j,h,o){if(y&&f){const s=this.a(f,o);if(s)return{range:y,value:s}}if(j&&h){const s=this.a(h,o);if(s)return{range:j,value:s}}return null}a(y,f){const j=this.b(y,f);return j!==null?j:this.d(y,f)}b(y,f){const j=Math.pow(10,y.length-(y.lastIndexOf(".")+1));let h=Number(y);const o=parseFloat(y);return!isNaN(h)&&!isNaN(o)&&h===o?h===0&&!f?null:(h=Math.floor(h*j),h+=f?j:-j,String(h/j)):null}d(y,f){return this.e(this.c,y,f)}e(y,f,j){let h=null;for(let o=0,s=y.length;h===null&&o<s;o++)h=this.f(y[o],f,j);return h}f(y,f,j){let h=y.indexOf(f);return h>=0?(h+=j?1:-1,h<0?h=y.length-1:h%=y.length,y[h]):null}}t.$q2=i}),re(ie[56],se([0,1,15]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Av=t.$zv=t.$yv=t.ModelConstants=t.PositionAffinity=t.TrackedRangeStickiness=t.$wv=t.$vv=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0,t.$xv=m,t.$Bv=b;var F;(function(a){a[a.Left=1]="Left",a[a.Center=2]="Center",a[a.Right=4]="Right",a[a.Full=7]="Full"})(F||(t.OverviewRulerLane=F={}));var y;(function(a){a[a.Left=1]="Left",a[a.Center=2]="Center",a[a.Right=3]="Right"})(y||(t.GlyphMarginLane=y={}));var f;(function(a){a[a.Inline=1]="Inline",a[a.Gutter=2]="Gutter"})(f||(t.MinimapPosition=f={}));var j;(function(a){a[a.Both=0]="Both",a[a.Right=1]="Right",a[a.Left=2]="Left",a[a.None=3]="None"})(j||(t.InjectedTextCursorStops=j={}));var h;(function(a){a[a.TextDefined=0]="TextDefined",a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(h||(t.EndOfLinePreference=h={}));var o;(function(a){a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(o||(t.DefaultEndOfLine=o={}));var s;(function(a){a[a.LF=0]="LF",a[a.CRLF=1]="CRLF"})(s||(t.EndOfLineSequence=s={}));class c{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(l){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,l.tabSize|0),l.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,l.indentSize|0),this.a=!1),this.insertSpaces=!!l.insertSpaces,this.defaultEOL=l.defaultEOL|0,this.trimAutoWhitespace=!!l.trimAutoWhitespace,this.bracketPairColorizationOptions=l.bracketPairColorizationOptions}equals(l){return this.tabSize===l.tabSize&&this.a===l.a&&this.indentSize===l.indentSize&&this.insertSpaces===l.insertSpaces&&this.defaultEOL===l.defaultEOL&&this.trimAutoWhitespace===l.trimAutoWhitespace&&(0,i.$Sn)(this.bracketPairColorizationOptions,l.bracketPairColorizationOptions)}createChangeEvent(l){return{tabSize:this.tabSize!==l.tabSize,indentSize:this.indentSize!==l.indentSize,insertSpaces:this.insertSpaces!==l.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==l.trimAutoWhitespace}}}t.$vv=c;class p{constructor(l,r){this._findMatchBrand=void 0,this.range=l,this.matches=r}}t.$wv=p;var g;(function(a){a[a.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",a[a.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",a[a.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",a[a.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(g||(t.TrackedRangeStickiness=g={}));function m(a){return a&&typeof a.read=="function"}var e;(function(a){a[a.Left=0]="Left",a[a.Right=1]="Right",a[a.None=2]="None",a[a.LeftOfInjectedText=3]="LeftOfInjectedText",a[a.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var v;(function(a){a[a.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v||(t.ModelConstants=v={}));class E{constructor(l,r,u,N,d,w){this.identifier=l,this.range=r,this.text=u,this.forceMoveMarkers=N,this.isAutoWhitespaceEdit=d,this._isTracked=w}}t.$yv=E;class L{constructor(l,r,u){this.regex=l,this.wordSeparators=r,this.simpleSearch=u}}t.$zv=L;class ${constructor(l,r,u){this.reverseEdits=l,this.changes=r,this.trimAutoWhitespaceLineNumbers=u}}t.$Av=$;function b(a){return!a.isTooLargeForSyncing()&&!a.isForSimpleWidget}}),re(ie[57],se([0,1,6,28]),function(O,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gv=t.$Fv=t.$Ev=void 0;class y{constructor(o){this.a=o,this.b=new Uint32Array(o.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(o,s){o=(0,F.$Te)(o);const c=this.a,p=this.b,g=s.length;return g===0?!1:(this.a=new Uint32Array(c.length+g),this.a.set(c.subarray(0,o),0),this.a.set(c.subarray(o),o+g),this.a.set(s,o),o-1<this.c[0]&&(this.c[0]=o-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(p.subarray(0,this.c[0]+1)),!0)}setValue(o,s){return o=(0,F.$Te)(o),s=(0,F.$Te)(s),this.a[o]===s?!1:(this.a[o]=s,o-1<this.c[0]&&(this.c[0]=o-1),!0)}removeValues(o,s){o=(0,F.$Te)(o),s=(0,F.$Te)(s);const c=this.a,p=this.b;if(o>=c.length)return!1;const g=c.length-o;return s>=g&&(s=g),s===0?!1:(this.a=new Uint32Array(c.length-s),this.a.set(c.subarray(0,o),0),this.a.set(c.subarray(o+s),o),this.b=new Uint32Array(this.a.length),o-1<this.c[0]&&(this.c[0]=o-1),this.c[0]>=0&&this.b.set(p.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(o){return o<0?0:(o=(0,F.$Te)(o),this.d(o))}d(o){if(o<=this.c[0])return this.b[o];let s=this.c[0]+1;s===0&&(this.b[0]=this.a[0],s++),o>=this.a.length&&(o=this.a.length-1);for(let c=s;c<=o;c++)this.b[c]=this.b[c-1]+this.a[c];return this.c[0]=Math.max(this.c[0],o),this.b[o]}getIndexOf(o){o=Math.floor(o),this.getTotalSum();let s=0,c=this.a.length-1,p=0,g=0,m=0;for(;s<=c;)if(p=s+(c-s)/2|0,g=this.b[p],m=g-this.a[p],o<m)c=p-1;else if(o>=g)s=p+1;else break;return new j(p,o-m)}}t.$Ev=y;class f{constructor(o){this.a=o,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(o){return this.g(),o===0?0:this.d[o-1]}getIndexOf(o){this.g();const s=this.e[o],c=s>0?this.d[s-1]:0;return new j(s,o-c)}removeValues(o,s){this.a.splice(o,s),this.f(o)}insertValues(o,s){this.a=(0,i.$Wb)(this.a,o,s),this.f(o)}f(o){this.b=!1,this.c=Math.min(this.c,o-1)}g(){if(!this.b){for(let o=this.c+1,s=this.a.length;o<s;o++){const c=this.a[o],p=o>0?this.d[o-1]:0;this.d[o]=p+c;for(let g=0;g<c;g++)this.e[p+g]=o}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(o,s){this.a[o]!==s&&(this.a[o]=s,this.f(o))}}t.$Fv=f;class j{constructor(o,s){this.index=o,this.remainder=s,this._prefixSumIndexOfResultBrand=void 0,this.index=o,this.remainder=s}}t.$Gv=j}),re(ie[58],se([0,1,7,5,57]),function(O,t,i,F,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hv=void 0;class f{constructor(h,o,s,c){this.d=h,this.f=o,this.g=s,this.h=c,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(h){h.eol&&h.eol!==this.g&&(this.g=h.eol,this.j=null);const o=h.changes;for(const s of o)this.o(s.range),this.p(new F.$bt(s.range.startLineNumber,s.range.startColumn),s.text);this.h=h.versionId,this.k=null}l(){if(!this.j){const h=this.g.length,o=this.f.length,s=new Uint32Array(o);for(let c=0;c<o;c++)s[c]=this.f[c].length+h;this.j=new y.$Ev(s)}}n(h,o){this.f[h]=o,this.j&&this.j.setValue(h,this.f[h].length+this.g.length)}o(h){if(h.startLineNumber===h.endLineNumber){if(h.startColumn===h.endColumn)return;this.n(h.startLineNumber-1,this.f[h.startLineNumber-1].substring(0,h.startColumn-1)+this.f[h.startLineNumber-1].substring(h.endColumn-1));return}this.n(h.startLineNumber-1,this.f[h.startLineNumber-1].substring(0,h.startColumn-1)+this.f[h.endLineNumber-1].substring(h.endColumn-1)),this.f.splice(h.startLineNumber,h.endLineNumber-h.startLineNumber),this.j&&this.j.removeValues(h.startLineNumber,h.endLineNumber-h.startLineNumber)}p(h,o){if(o.length===0)return;const s=(0,i.$$e)(o);if(s.length===1){this.n(h.lineNumber-1,this.f[h.lineNumber-1].substring(0,h.column-1)+s[0]+this.f[h.lineNumber-1].substring(h.column-1));return}s[s.length-1]+=this.f[h.lineNumber-1].substring(h.column-1),this.n(h.lineNumber-1,this.f[h.lineNumber-1].substring(0,h.column-1)+s[0]);const c=new Uint32Array(s.length-1);for(let p=1;p<s.length;p++)this.f.splice(h.lineNumber+p-1,0,s[p]),c[p-1]=s[p].length+this.g.length;this.j&&this.j.insertValues(h.lineNumber,c)}}t.$Hv=f}),re(ie[59],se([0,1,7,46,5,2,56]),function(O,t,i,F,y,f,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tC=t.$rC=t.$oC=void 0,t.$pC=s,t.$qC=c,t.$sC=v;const h=999;class o{constructor($,b,a,l){this.searchString=$,this.isRegex=b,this.matchCase=a,this.wordSeparators=l}parseSearchRequest(){if(this.searchString==="")return null;let $;this.isRegex?$=s(this.searchString):$=this.searchString.indexOf(`
`)>=0;let b=null;try{b=i.$9e(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:$,global:!0,unicode:!0})}catch{return null}if(!b)return null;let a=!this.isRegex&&!$;return a&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(a=this.matchCase),new j.$zv(b,this.wordSeparators?(0,F.$Ct)(this.wordSeparators,[]):null,a?this.searchString:null)}}t.$oC=o;function s(L){if(!L||L.length===0)return!1;for(let $=0,b=L.length;$<b;$++){const a=L.charCodeAt($);if(a===10)return!0;if(a===92){if($++,$>=b)break;const l=L.charCodeAt($);if(l===110||l===114||l===87)return!0}}return!1}function c(L,$,b){if(!b)return new j.$wv(L,null);const a=[];for(let l=0,r=$.length;l<r;l++)a[l]=$[l];return new j.$wv(L,a)}class p{constructor($){const b=[];let a=0;for(let l=0,r=$.length;l<r;l++)$.charCodeAt(l)===10&&(b[a++]=l);this.a=b}findLineFeedCountBeforeOffset($){const b=this.a;let a=0,l=b.length-1;if(l===-1||$<=b[0])return 0;for(;a<l;){const r=a+((l-a)/2>>0);b[r]>=$?l=r-1:b[r+1]>=$?(a=r,l=r):a=r+1}return a+1}}class g{static findMatches($,b,a,l,r){const u=b.parseSearchRequest();return u?u.regex.multiline?this.b($,a,new E(u.wordSeparators,u.regex),l,r):this.c($,a,u,l,r):[]}static a($,b,a,l,r,u){let N,d=0;l?(d=l.findLineFeedCountBeforeOffset(r),N=b+r+d):N=b+r;let w;if(l){const T=l.findLineFeedCountBeforeOffset(r+u.length)-d;w=N+u.length+T}else w=N+u.length;const A=$.getPositionAt(N),C=$.getPositionAt(w);return new f.$ct(A.lineNumber,A.column,C.lineNumber,C.column)}static b($,b,a,l,r){const u=$.getOffsetAt(b.getStartPosition()),N=$.getValueInRange(b,1),d=$.getEOL()===`\r
`?new p(N):null,w=[];let A=0,C;for(a.reset(0);C=a.next(N);)if(w[A++]=c(this.a($,u,N,d,C.index,C[0]),C,l),A>=r)return w;return w}static c($,b,a,l,r){const u=[];let N=0;if(b.startLineNumber===b.endLineNumber){const w=$.getLineContent(b.startLineNumber).substring(b.startColumn-1,b.endColumn-1);return N=this.d(a,w,b.startLineNumber,b.startColumn-1,N,u,l,r),u}const d=$.getLineContent(b.startLineNumber).substring(b.startColumn-1);N=this.d(a,d,b.startLineNumber,b.startColumn-1,N,u,l,r);for(let w=b.startLineNumber+1;w<b.endLineNumber&&N<r;w++)N=this.d(a,$.getLineContent(w),w,0,N,u,l,r);if(N<r){const w=$.getLineContent(b.endLineNumber).substring(0,b.endColumn-1);N=this.d(a,w,b.endLineNumber,0,N,u,l,r)}return u}static d($,b,a,l,r,u,N,d){const w=$.wordSeparators;if(!N&&$.simpleSearch){const M=$.simpleSearch,T=M.length,S=b.length;let k=-T;for(;(k=b.indexOf(M,k+T))!==-1;)if((!w||v(w,b,S,k,T))&&(u[r++]=new j.$wv(new f.$ct(a,k+1+l,a,k+1+T+l),null),r>=d))return r;return r}const A=new E($.wordSeparators,$.regex);let C;A.reset(0);do if(C=A.next(b),C&&(u[r++]=c(new f.$ct(a,C.index+1+l,a,C.index+1+C[0].length+l),C,N),r>=d))return r;while(C);return r}static findNextMatch($,b,a,l){const r=b.parseSearchRequest();if(!r)return null;const u=new E(r.wordSeparators,r.regex);return r.regex.multiline?this.e($,a,u,l):this.f($,a,u,l)}static e($,b,a,l){const r=new y.$bt(b.lineNumber,1),u=$.getOffsetAt(r),N=$.getLineCount(),d=$.getValueInRange(new f.$ct(r.lineNumber,r.column,N,$.getLineMaxColumn(N)),1),w=$.getEOL()===`\r
`?new p(d):null;a.reset(b.column-1);const A=a.next(d);return A?c(this.a($,u,d,w,A.index,A[0]),A,l):b.lineNumber!==1||b.column!==1?this.e($,new y.$bt(1,1),a,l):null}static f($,b,a,l){const r=$.getLineCount(),u=b.lineNumber,N=$.getLineContent(u),d=this.g(a,N,u,b.column,l);if(d)return d;for(let w=1;w<=r;w++){const A=(u+w-1)%r,C=$.getLineContent(A+1),M=this.g(a,C,A+1,1,l);if(M)return M}return null}static g($,b,a,l,r){$.reset(l-1);const u=$.next(b);return u?c(new f.$ct(a,u.index+1,a,u.index+1+u[0].length),u,r):null}static findPreviousMatch($,b,a,l){const r=b.parseSearchRequest();if(!r)return null;const u=new E(r.wordSeparators,r.regex);return r.regex.multiline?this.h($,a,u,l):this.j($,a,u,l)}static h($,b,a,l){const r=this.b($,new f.$ct(1,1,b.lineNumber,b.column),a,l,10*h);if(r.length>0)return r[r.length-1];const u=$.getLineCount();return b.lineNumber!==u||b.column!==$.getLineMaxColumn(u)?this.h($,new y.$bt(u,$.getLineMaxColumn(u)),a,l):null}static j($,b,a,l){const r=$.getLineCount(),u=b.lineNumber,N=$.getLineContent(u).substring(0,b.column-1),d=this.k(a,N,u,l);if(d)return d;for(let w=1;w<=r;w++){const A=(r+u-w-1)%r,C=$.getLineContent(A+1),M=this.k(a,C,A+1,l);if(M)return M}return null}static k($,b,a,l){let r=null,u;for($.reset(0);u=$.next(b);)r=c(new f.$ct(a,u.index+1,a,u.index+1+u[0].length),u,l);return r}}t.$rC=g;function m(L,$,b,a,l){if(a===0)return!0;const r=$.charCodeAt(a-1);if(L.get(r)!==0||r===13||r===10)return!0;if(l>0){const u=$.charCodeAt(a);if(L.get(u)!==0)return!0}return!1}function e(L,$,b,a,l){if(a+l===b)return!0;const r=$.charCodeAt(a+l);if(L.get(r)!==0||r===13||r===10)return!0;if(l>0){const u=$.charCodeAt(a+l-1);if(L.get(u)!==0)return!0}return!1}function v(L,$,b,a,l){return m(L,$,b,a,l)&&e(L,$,b,a,l)}class E{constructor($,b){this._wordSeparators=$,this.a=b,this.b=-1,this.c=0}reset($){this.a.lastIndex=$,this.b=-1,this.c=0}next($){const b=$.length;let a;do{if(this.b+this.c===b||(a=this.a.exec($),!a))return null;const l=a.index,r=a[0].length;if(l===this.b&&r===this.c){if(r===0){i.$sf($,b,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=l,this.c=r,!this._wordSeparators||v(this._wordSeparators,$,b,l,r))return a}while(a);return null}}t.$tC=E}),re(ie[60],se([0,1,2,59,7,13,30]),function(O,t,i,F,y,f,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$m2=void 0;class h{static computeUnicodeHighlights(e,v,E){const L=E?E.startLineNumber:1,$=E?E.endLineNumber:e.getLineCount(),b=new c(v),a=b.getCandidateCodePoints();let l;a==="allNonBasicAscii"?l=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):l=new RegExp(`${o(Array.from(a))}`,"g");const r=new F.$tC(null,l),u=[];let N=!1,d,w=0,A=0,C=0;e:for(let M=L,T=$;M<=T;M++){const S=e.getLineContent(M),k=S.length;r.reset(0);do if(d=r.next(S),d){let R=d.index,x=d.index+d[0].length;if(R>0){const _=S.charCodeAt(R-1);y.$pf(_)&&R--}if(x+1<k){const _=S.charCodeAt(x-1);y.$pf(_)&&x++}const I=S.substring(R,x);let G=(0,j.$Rs)(R+1,j.$Os,S,0);G&&G.endColumn<=R+1&&(G=null);const K=b.shouldHighlightNonBasicASCII(I,G?G.word:null);if(K!==0){if(K===3?w++:K===2?A++:K===1?C++:(0,f.$0c)(K),u.length>=1e3){N=!0;break e}u.push(new i.$ct(M,R+1,M,x+1))}}while(d)}return{ranges:u,hasMore:N,ambiguousCharacterCount:w,invisibleCharacterCount:A,nonBasicAsciiCharacterCount:C}}static computeUnicodeHighlightReason(e,v){const E=new c(v);switch(E.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const $=e.codePointAt(0),b=E.ambiguousCharacters.getPrimaryConfusable($),a=y.$Tf.getLocales().filter(l=>!y.$Tf.getInstance(new Set([...v.allowedLocales,l])).isAmbiguous($));return{kind:0,confusableWith:String.fromCodePoint(b),notAmbiguousInLocales:a}}case 1:return{kind:2}}}}t.$m2=h;function o(m,e){return`[${y.$Ze(m.map(E=>String.fromCodePoint(E)).join(""))}]`}var s;(function(m){m[m.Ambiguous=0]="Ambiguous",m[m.Invisible=1]="Invisible",m[m.NonBasicAscii=2]="NonBasicAscii"})(s||(t.UnicodeHighlighterReasonKind=s={}));class c{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=y.$Tf.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const v of y.$Uf.codePoints)p(String.fromCodePoint(v))||e.add(v);if(this.b.ambiguousCharacters)for(const v of this.ambiguousCharacters.getConfusableCodePoints())e.add(v);for(const v of this.a)e.delete(v);return e}shouldHighlightNonBasicASCII(e,v){const E=e.codePointAt(0);if(this.a.has(E))return 0;if(this.b.nonBasicASCII)return 1;let L=!1,$=!1;if(v)for(const b of v){const a=b.codePointAt(0),l=y.$Af(b);L=L||l,!l&&!this.ambiguousCharacters.isAmbiguous(a)&&!y.$Uf.isInvisibleCharacter(a)&&($=!0)}return!L&&$?0:this.b.invisibleCharacters&&!p(e)&&y.$Uf.isInvisibleCharacter(E)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(E)?3:0}}function p(m){return m===" "||m===`
`||m==="	"}var g;(function(m){m[m.None=0]="None",m[m.NonBasicASCII=1]="NonBasicASCII",m[m.Invisible=2]="Invisible",m[m.Ambiguous=3]="Ambiguous"})(g||(g={}))}),re(ie[61],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.ShowLightbulbIconMode=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.PartialAcceptTriggerKind=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.NewSymbolNameTag=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineEditTriggerKind=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var i;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(i||(t.AccessibilitySupport=i={}));var F;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(F||(t.CodeActionTriggerType=F={}));var y;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(y||(t.CompletionItemInsertTextRule=y={}));var f;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(f||(t.CompletionItemKind=f={}));var j;(function(n){n[n.Deprecated=1]="Deprecated"})(j||(t.CompletionItemTag=j={}));var h;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(h||(t.CompletionTriggerKind=h={}));var o;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(o||(t.ContentWidgetPositionPreference=o={}));var s;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(s||(t.CursorChangeReason=s={}));var c;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(c||(t.DefaultEndOfLine=c={}));var p;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(p||(t.DocumentHighlightKind=p={}));var g;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(g||(t.EditorAutoIndentStrategy=g={}));var m;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.ariaRequired=5]="ariaRequired",n[n.autoClosingBrackets=6]="autoClosingBrackets",n[n.autoClosingComments=7]="autoClosingComments",n[n.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=9]="autoClosingDelete",n[n.autoClosingOvertype=10]="autoClosingOvertype",n[n.autoClosingQuotes=11]="autoClosingQuotes",n[n.autoIndent=12]="autoIndent",n[n.automaticLayout=13]="automaticLayout",n[n.autoSurround=14]="autoSurround",n[n.bracketPairColorization=15]="bracketPairColorization",n[n.guides=16]="guides",n[n.codeLens=17]="codeLens",n[n.codeLensFontFamily=18]="codeLensFontFamily",n[n.codeLensFontSize=19]="codeLensFontSize",n[n.colorDecorators=20]="colorDecorators",n[n.colorDecoratorsLimit=21]="colorDecoratorsLimit",n[n.columnSelection=22]="columnSelection",n[n.comments=23]="comments",n[n.contextmenu=24]="contextmenu",n[n.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",n[n.cursorBlinking=26]="cursorBlinking",n[n.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",n[n.cursorStyle=28]="cursorStyle",n[n.cursorSurroundingLines=29]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",n[n.cursorWidth=31]="cursorWidth",n[n.disableLayerHinting=32]="disableLayerHinting",n[n.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",n[n.domReadOnly=34]="domReadOnly",n[n.dragAndDrop=35]="dragAndDrop",n[n.dropIntoEditor=36]="dropIntoEditor",n[n.emptySelectionClipboard=37]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",n[n.extraEditorClassName=39]="extraEditorClassName",n[n.fastScrollSensitivity=40]="fastScrollSensitivity",n[n.find=41]="find",n[n.fixedOverflowWidgets=42]="fixedOverflowWidgets",n[n.folding=43]="folding",n[n.foldingStrategy=44]="foldingStrategy",n[n.foldingHighlight=45]="foldingHighlight",n[n.foldingImportsByDefault=46]="foldingImportsByDefault",n[n.foldingMaximumRegions=47]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=49]="fontFamily",n[n.fontInfo=50]="fontInfo",n[n.fontLigatures=51]="fontLigatures",n[n.fontSize=52]="fontSize",n[n.fontWeight=53]="fontWeight",n[n.fontVariations=54]="fontVariations",n[n.formatOnPaste=55]="formatOnPaste",n[n.formatOnType=56]="formatOnType",n[n.glyphMargin=57]="glyphMargin",n[n.gotoLocation=58]="gotoLocation",n[n.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",n[n.hover=60]="hover",n[n.inDiffEditor=61]="inDiffEditor",n[n.inlineSuggest=62]="inlineSuggest",n[n.inlineEdit=63]="inlineEdit",n[n.letterSpacing=64]="letterSpacing",n[n.lightbulb=65]="lightbulb",n[n.lineDecorationsWidth=66]="lineDecorationsWidth",n[n.lineHeight=67]="lineHeight",n[n.lineNumbers=68]="lineNumbers",n[n.lineNumbersMinChars=69]="lineNumbersMinChars",n[n.linkedEditing=70]="linkedEditing",n[n.links=71]="links",n[n.matchBrackets=72]="matchBrackets",n[n.minimap=73]="minimap",n[n.mouseStyle=74]="mouseStyle",n[n.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=76]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",n[n.multiCursorModifier=78]="multiCursorModifier",n[n.multiCursorPaste=79]="multiCursorPaste",n[n.multiCursorLimit=80]="multiCursorLimit",n[n.occurrencesHighlight=81]="occurrencesHighlight",n[n.overviewRulerBorder=82]="overviewRulerBorder",n[n.overviewRulerLanes=83]="overviewRulerLanes",n[n.padding=84]="padding",n[n.pasteAs=85]="pasteAs",n[n.parameterHints=86]="parameterHints",n[n.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",n[n.quickSuggestions=89]="quickSuggestions",n[n.quickSuggestionsDelay=90]="quickSuggestionsDelay",n[n.readOnly=91]="readOnly",n[n.readOnlyMessage=92]="readOnlyMessage",n[n.renameOnType=93]="renameOnType",n[n.renderControlCharacters=94]="renderControlCharacters",n[n.renderFinalNewline=95]="renderFinalNewline",n[n.renderLineHighlight=96]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=98]="renderValidationDecorations",n[n.renderWhitespace=99]="renderWhitespace",n[n.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",n[n.roundedSelection=101]="roundedSelection",n[n.rulers=102]="rulers",n[n.scrollbar=103]="scrollbar",n[n.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=105]="scrollBeyondLastLine",n[n.scrollPredominantAxis=106]="scrollPredominantAxis",n[n.selectionClipboard=107]="selectionClipboard",n[n.selectionHighlight=108]="selectionHighlight",n[n.selectOnLineNumbers=109]="selectOnLineNumbers",n[n.showFoldingControls=110]="showFoldingControls",n[n.showUnused=111]="showUnused",n[n.snippetSuggestions=112]="snippetSuggestions",n[n.smartSelect=113]="smartSelect",n[n.smoothScrolling=114]="smoothScrolling",n[n.stickyScroll=115]="stickyScroll",n[n.stickyTabStops=116]="stickyTabStops",n[n.stopRenderingLineAfter=117]="stopRenderingLineAfter",n[n.suggest=118]="suggest",n[n.suggestFontSize=119]="suggestFontSize",n[n.suggestLineHeight=120]="suggestLineHeight",n[n.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",n[n.suggestSelection=122]="suggestSelection",n[n.tabCompletion=123]="tabCompletion",n[n.tabIndex=124]="tabIndex",n[n.unicodeHighlighting=125]="unicodeHighlighting",n[n.unusualLineTerminators=126]="unusualLineTerminators",n[n.useShadowDOM=127]="useShadowDOM",n[n.useTabStops=128]="useTabStops",n[n.wordBreak=129]="wordBreak",n[n.wordSegmenterLocales=130]="wordSegmenterLocales",n[n.wordSeparators=131]="wordSeparators",n[n.wordWrap=132]="wordWrap",n[n.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=135]="wordWrapColumn",n[n.wordWrapOverride1=136]="wordWrapOverride1",n[n.wordWrapOverride2=137]="wordWrapOverride2",n[n.wrappingIndent=138]="wrappingIndent",n[n.wrappingStrategy=139]="wrappingStrategy",n[n.showDeprecated=140]="showDeprecated",n[n.inlayHints=141]="inlayHints",n[n.editorClassName=142]="editorClassName",n[n.pixelRatio=143]="pixelRatio",n[n.tabFocusMode=144]="tabFocusMode",n[n.layoutInfo=145]="layoutInfo",n[n.wrappingInfo=146]="wrappingInfo",n[n.defaultColorDecorators=147]="defaultColorDecorators",n[n.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",n[n.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(m||(t.EditorOption=m={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var v;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(v||(t.EndOfLineSequence=v={}));var E;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=3]="Right"})(E||(t.GlyphMarginLane=E={}));var L;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(L||(t.IndentAction=L={}));var $;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})($||(t.InjectedTextCursorStops=$={}));var b;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(b||(t.InlayHintKind=b={}));var a;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(a||(t.InlineCompletionTriggerKind=a={}));var l;(function(n){n[n.Invoke=0]="Invoke",n[n.Automatic=1]="Automatic"})(l||(t.InlineEditTriggerKind=l={}));var r;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.F20=78]="F20",n[n.F21=79]="F21",n[n.F22=80]="F22",n[n.F23=81]="F23",n[n.F24=82]="F24",n[n.NumLock=83]="NumLock",n[n.ScrollLock=84]="ScrollLock",n[n.Semicolon=85]="Semicolon",n[n.Equal=86]="Equal",n[n.Comma=87]="Comma",n[n.Minus=88]="Minus",n[n.Period=89]="Period",n[n.Slash=90]="Slash",n[n.Backquote=91]="Backquote",n[n.BracketLeft=92]="BracketLeft",n[n.Backslash=93]="Backslash",n[n.BracketRight=94]="BracketRight",n[n.Quote=95]="Quote",n[n.OEM_8=96]="OEM_8",n[n.IntlBackslash=97]="IntlBackslash",n[n.Numpad0=98]="Numpad0",n[n.Numpad1=99]="Numpad1",n[n.Numpad2=100]="Numpad2",n[n.Numpad3=101]="Numpad3",n[n.Numpad4=102]="Numpad4",n[n.Numpad5=103]="Numpad5",n[n.Numpad6=104]="Numpad6",n[n.Numpad7=105]="Numpad7",n[n.Numpad8=106]="Numpad8",n[n.Numpad9=107]="Numpad9",n[n.NumpadMultiply=108]="NumpadMultiply",n[n.NumpadAdd=109]="NumpadAdd",n[n.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=111]="NumpadSubtract",n[n.NumpadDecimal=112]="NumpadDecimal",n[n.NumpadDivide=113]="NumpadDivide",n[n.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",n[n.ABNT_C1=115]="ABNT_C1",n[n.ABNT_C2=116]="ABNT_C2",n[n.AudioVolumeMute=117]="AudioVolumeMute",n[n.AudioVolumeUp=118]="AudioVolumeUp",n[n.AudioVolumeDown=119]="AudioVolumeDown",n[n.BrowserSearch=120]="BrowserSearch",n[n.BrowserHome=121]="BrowserHome",n[n.BrowserBack=122]="BrowserBack",n[n.BrowserForward=123]="BrowserForward",n[n.MediaTrackNext=124]="MediaTrackNext",n[n.MediaTrackPrevious=125]="MediaTrackPrevious",n[n.MediaStop=126]="MediaStop",n[n.MediaPlayPause=127]="MediaPlayPause",n[n.LaunchMediaPlayer=128]="LaunchMediaPlayer",n[n.LaunchMail=129]="LaunchMail",n[n.LaunchApp2=130]="LaunchApp2",n[n.Clear=131]="Clear",n[n.MAX_VALUE=132]="MAX_VALUE"})(r||(t.KeyCode=r={}));var u;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(u||(t.MarkerSeverity=u={}));var N;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(N||(t.MarkerTag=N={}));var d;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(d||(t.MinimapPosition=d={}));var w;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(w||(t.MouseTargetType=w={}));var A;(function(n){n[n.AIGenerated=1]="AIGenerated"})(A||(t.NewSymbolNameTag=A={}));var C;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(C||(t.OverlayWidgetPositionPreference=C={}));var M;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(M||(t.OverviewRulerLane=M={}));var T;(function(n){n[n.Word=0]="Word",n[n.Line=1]="Line",n[n.Suggest=2]="Suggest"})(T||(t.PartialAcceptTriggerKind=T={}));var S;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(S||(t.PositionAffinity=S={}));var k;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(k||(t.RenderLineNumbersType=k={}));var R;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(R||(t.RenderMinimap=R={}));var x;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(x||(t.ScrollType=x={}));var I;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(I||(t.ScrollbarVisibility=I={}));var G;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(G||(t.SelectionDirection=G={}));var K;(function(n){n.Off="off",n.OnCode="onCode",n.On="on"})(K||(t.ShowLightbulbIconMode=K={}));var _;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(_||(t.SignatureHelpTriggerKind=_={}));var X;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(X||(t.SymbolKind=X={}));var Q;(function(n){n[n.Deprecated=1]="Deprecated"})(Q||(t.SymbolTag=Q={}));var P;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(P||(t.TextEditorCursorBlinkingStyle=P={}));var H;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(H||(t.TextEditorCursorStyle=H={}));var ue;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(ue||(t.TrackedRangeStickiness=ue={}));var oe;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(oe||(t.WrappingIndent=oe={}))}),re(ie[62],se([0,1,11,10]),function(O,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nt=void 0;class y{constructor(){this.a=new Map,this.b=new Map,this.c=new i.$7d,this.onDidChange=this.c.event,this.d=null}handleChange(h){this.c.fire({changedLanguages:h,changedColorMap:!1})}register(h,o){return this.a.set(h,o),this.handleChange([h]),(0,F.$Sc)(()=>{this.a.get(h)===o&&(this.a.delete(h),this.handleChange([h]))})}get(h){return this.a.get(h)||null}registerFactory(h,o){this.b.get(h)?.dispose();const s=new f(this,h,o);return this.b.set(h,s),(0,F.$Sc)(()=>{const c=this.b.get(h);!c||c!==s||(this.b.delete(h),c.dispose())})}async getOrCreate(h){const o=this.get(h);if(o)return o;const s=this.b.get(h);return!s||s.isResolved?null:(await s.resolve(),this.get(h))}isResolved(h){if(this.get(h))return!0;const s=this.b.get(h);return!!(!s||s.isResolved)}setColorMap(h){this.d=h,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.$Nt=y;class f extends F.$Uc{get isResolved(){return this.c}constructor(h,o,s){super(),this.f=h,this.g=o,this.h=s,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const h=await this.h.tokenizationSupport;this.c=!0,h&&!this.a&&this.B(this.f.register(this.g,h))}}}),re(ie[63],se([64,65]),function(O,t){return O.create("vs/base/common/platform",t)}),re(ie[18],se([0,1,63]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$g=void 0,t.$h=u,t.$D=M,t.$J=T,t.$g="en";let F=!1,y=!1,f=!1,j=!1,h=!1,o=!1,s=!1,c=!1,p=!1,g=!1,m,e=t.$g,v=t.$g,E,L;const $=globalThis;let b;typeof $.vscode<"u"&&typeof $.vscode.process<"u"?b=$.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(b=process);const a=typeof b?.versions?.electron=="string",l=a&&b?.type==="renderer";if(typeof b=="object"){F=b.platform==="win32",y=b.platform==="darwin",f=b.platform==="linux",j=f&&!!b.env.SNAP&&!!b.env.SNAP_REVISION,s=a,p=!!b.env.CI||!!b.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=t.$g,e=t.$g;const S=b.env.VSCODE_NLS_CONFIG;if(S)try{const k=JSON.parse(S),R=k.availableLanguages["*"];m=k.locale,v=k.osLocale,e=R||t.$g,E=k._translationsConfigFile}catch{}h=!0}else typeof navigator=="object"&&!l?(L=navigator.userAgent,F=L.indexOf("Windows")>=0,y=L.indexOf("Macintosh")>=0,c=(L.indexOf("Macintosh")>=0||L.indexOf("iPad")>=0||L.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,f=L.indexOf("Linux")>=0,g=L?.indexOf("Mobi")>=0,o=!0,m=i.getConfiguredDefaultLocale(i.localize(0,null))||t.$g,e=m,v=navigator.language):console.error("Unable to resolve platform.");var r;(function(S){S[S.Web=0]="Web",S[S.Mac=1]="Mac",S[S.Linux=2]="Linux",S[S.Windows=3]="Windows"})(r||(t.Platform=r={}));function u(S){switch(S){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let N=0;y?N=1:F?N=3:f&&(N=2),t.$i=F,t.$j=y,t.$k=f,t.$l=j,t.$m=h,t.$n=s,t.$o=o,t.$p=o&&typeof $.importScripts=="function",t.$q=t.$p?$.origin:void 0,t.$r=c,t.$s=g,t.$t=p,t.$u=N,t.$v=L,t.$w=e;var d;(function(S){function k(){return t.$w}S.value=k;function R(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}S.isDefaultVariant=R;function x(){return t.$w==="en"}S.isDefault=x})(d||(t.Language=d={})),t.$x=m,t.$y=v,t.$z=E,t.$A=typeof $.postMessage=="function"&&!$.importScripts,t.$B=(()=>{if(t.$A){const S=[];$.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let x=0,I=S.length;x<I;x++){const G=S[x];if(G.id===R.data.vscodeScheduleAsyncWork){S.splice(x,1),G.callback();return}}});let k=0;return R=>{const x=++k;S.push({id:x,callback:R}),$.postMessage({vscodeScheduleAsyncWork:x},"*")}}return S=>setTimeout(S)})();var w;(function(S){S[S.Windows=1]="Windows",S[S.Macintosh=2]="Macintosh",S[S.Linux=3]="Linux"})(w||(t.OperatingSystem=w={})),t.OS=y||c?2:F?1:3;let A=!0,C=!1;function M(){if(!C){C=!0;const S=new Uint8Array(2);S[0]=1,S[1]=2,A=new Uint16Array(S.buffer)[0]===513}return A}t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function T(S){return parseFloat(S)>=20}}),re(ie[66],se([0,1,18]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fc=t.$ec=t.env=t.cwd=void 0;let F;const y=globalThis.vscode;if(typeof y<"u"&&typeof y.process<"u"){const f=y.process;F={get platform(){return f.platform},get arch(){return f.arch},get env(){return f.env},cwd(){return f.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=F.cwd,t.env=F.env,t.$ec=F.platform,t.$fc=F.arch}),re(ie[67],se([0,1,66]),function(O,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uc=t.sep=t.$sc=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=void 0;const F=65,y=97,f=90,j=122,h=46,o=47,s=92,c=58,p=63;class g extends Error{constructor(u,N,d){let w;typeof N=="string"&&N.indexOf("not ")===0?(w="must not be",N=N.replace(/^not /,"")):w="must be";const A=u.indexOf(".")!==-1?"property":"argument";let C=`The "${u}" ${A} ${w} of type ${N}`;C+=`. Received type ${typeof d}`,super(C),this.code="ERR_INVALID_ARG_TYPE"}}function m(r,u){if(r===null||typeof r!="object")throw new g(u,"Object",r)}function e(r,u){if(typeof r!="string")throw new g(u,"string",r)}const v=i.$ec==="win32";function E(r){return r===o||r===s}function L(r){return r===o}function $(r){return r>=F&&r<=f||r>=y&&r<=j}function b(r,u,N,d){let w="",A=0,C=-1,M=0,T=0;for(let S=0;S<=r.length;++S){if(S<r.length)T=r.charCodeAt(S);else{if(d(T))break;T=o}if(d(T)){if(!(C===S-1||M===1))if(M===2){if(w.length<2||A!==2||w.charCodeAt(w.length-1)!==h||w.charCodeAt(w.length-2)!==h){if(w.length>2){const k=w.lastIndexOf(N);k===-1?(w="",A=0):(w=w.slice(0,k),A=w.length-1-w.lastIndexOf(N)),C=S,M=0;continue}else if(w.length!==0){w="",A=0,C=S,M=0;continue}}u&&(w+=w.length>0?`${N}..`:"..",A=2)}else w.length>0?w+=`${N}${r.slice(C+1,S)}`:w=r.slice(C+1,S),A=S-C-1;C=S,M=0}else T===h&&M!==-1?++M:M=-1}return w}function a(r,u){m(u,"pathObject");const N=u.dir||u.root,d=u.base||`${u.name||""}${u.ext||""}`;return N?N===u.root?`${N}${d}`:`${N}${r}${d}`:d}t.$gc={resolve(...r){let u="",N="",d=!1;for(let w=r.length-1;w>=-1;w--){let A;if(w>=0){if(A=r[w],e(A,"path"),A.length===0)continue}else u.length===0?A=i.cwd():(A=i.env[`=${u}`]||i.cwd(),(A===void 0||A.slice(0,2).toLowerCase()!==u.toLowerCase()&&A.charCodeAt(2)===s)&&(A=`${u}\\`));const C=A.length;let M=0,T="",S=!1;const k=A.charCodeAt(0);if(C===1)E(k)&&(M=1,S=!0);else if(E(k))if(S=!0,E(A.charCodeAt(1))){let R=2,x=R;for(;R<C&&!E(A.charCodeAt(R));)R++;if(R<C&&R!==x){const I=A.slice(x,R);for(x=R;R<C&&E(A.charCodeAt(R));)R++;if(R<C&&R!==x){for(x=R;R<C&&!E(A.charCodeAt(R));)R++;(R===C||R!==x)&&(T=`\\\\${I}\\${A.slice(x,R)}`,M=R)}}}else M=1;else $(k)&&A.charCodeAt(1)===c&&(T=A.slice(0,2),M=2,C>2&&E(A.charCodeAt(2))&&(S=!0,M=3));if(T.length>0)if(u.length>0){if(T.toLowerCase()!==u.toLowerCase())continue}else u=T;if(d){if(u.length>0)break}else if(N=`${A.slice(M)}\\${N}`,d=S,S&&u.length>0)break}return N=b(N,!d,"\\",E),d?`${u}\\${N}`:`${u}${N}`||"."},normalize(r){e(r,"path");const u=r.length;if(u===0)return".";let N=0,d,w=!1;const A=r.charCodeAt(0);if(u===1)return L(A)?"\\":r;if(E(A))if(w=!0,E(r.charCodeAt(1))){let M=2,T=M;for(;M<u&&!E(r.charCodeAt(M));)M++;if(M<u&&M!==T){const S=r.slice(T,M);for(T=M;M<u&&E(r.charCodeAt(M));)M++;if(M<u&&M!==T){for(T=M;M<u&&!E(r.charCodeAt(M));)M++;if(M===u)return`\\\\${S}\\${r.slice(T)}\\`;M!==T&&(d=`\\\\${S}\\${r.slice(T,M)}`,N=M)}}}else N=1;else $(A)&&r.charCodeAt(1)===c&&(d=r.slice(0,2),N=2,u>2&&E(r.charCodeAt(2))&&(w=!0,N=3));let C=N<u?b(r.slice(N),!w,"\\",E):"";return C.length===0&&!w&&(C="."),C.length>0&&E(r.charCodeAt(u-1))&&(C+="\\"),d===void 0?w?`\\${C}`:C:w?`${d}\\${C}`:`${d}${C}`},isAbsolute(r){e(r,"path");const u=r.length;if(u===0)return!1;const N=r.charCodeAt(0);return E(N)||u>2&&$(N)&&r.charCodeAt(1)===c&&E(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let u,N;for(let A=0;A<r.length;++A){const C=r[A];e(C,"path"),C.length>0&&(u===void 0?u=N=C:u+=`\\${C}`)}if(u===void 0)return".";let d=!0,w=0;if(typeof N=="string"&&E(N.charCodeAt(0))){++w;const A=N.length;A>1&&E(N.charCodeAt(1))&&(++w,A>2&&(E(N.charCodeAt(2))?++w:d=!1))}if(d){for(;w<u.length&&E(u.charCodeAt(w));)w++;w>=2&&(u=`\\${u.slice(w)}`)}return t.$gc.normalize(u)},relative(r,u){if(e(r,"from"),e(u,"to"),r===u)return"";const N=t.$gc.resolve(r),d=t.$gc.resolve(u);if(N===d||(r=N.toLowerCase(),u=d.toLowerCase(),r===u))return"";let w=0;for(;w<r.length&&r.charCodeAt(w)===s;)w++;let A=r.length;for(;A-1>w&&r.charCodeAt(A-1)===s;)A--;const C=A-w;let M=0;for(;M<u.length&&u.charCodeAt(M)===s;)M++;let T=u.length;for(;T-1>M&&u.charCodeAt(T-1)===s;)T--;const S=T-M,k=C<S?C:S;let R=-1,x=0;for(;x<k;x++){const G=r.charCodeAt(w+x);if(G!==u.charCodeAt(M+x))break;G===s&&(R=x)}if(x!==k){if(R===-1)return d}else{if(S>k){if(u.charCodeAt(M+x)===s)return d.slice(M+x+1);if(x===2)return d.slice(M+x)}C>k&&(r.charCodeAt(w+x)===s?R=x:x===2&&(R=3)),R===-1&&(R=0)}let I="";for(x=w+R+1;x<=A;++x)(x===A||r.charCodeAt(x)===s)&&(I+=I.length===0?"..":"\\..");return M+=R,I.length>0?`${I}${d.slice(M,T)}`:(d.charCodeAt(M)===s&&++M,d.slice(M,T))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const u=t.$gc.resolve(r);if(u.length<=2)return r;if(u.charCodeAt(0)===s){if(u.charCodeAt(1)===s){const N=u.charCodeAt(2);if(N!==p&&N!==h)return`\\\\?\\UNC\\${u.slice(2)}`}}else if($(u.charCodeAt(0))&&u.charCodeAt(1)===c&&u.charCodeAt(2)===s)return`\\\\?\\${u}`;return r},dirname(r){e(r,"path");const u=r.length;if(u===0)return".";let N=-1,d=0;const w=r.charCodeAt(0);if(u===1)return E(w)?r:".";if(E(w)){if(N=d=1,E(r.charCodeAt(1))){let M=2,T=M;for(;M<u&&!E(r.charCodeAt(M));)M++;if(M<u&&M!==T){for(T=M;M<u&&E(r.charCodeAt(M));)M++;if(M<u&&M!==T){for(T=M;M<u&&!E(r.charCodeAt(M));)M++;if(M===u)return r;M!==T&&(N=d=M+1)}}}}else $(w)&&r.charCodeAt(1)===c&&(N=u>2&&E(r.charCodeAt(2))?3:2,d=N);let A=-1,C=!0;for(let M=u-1;M>=d;--M)if(E(r.charCodeAt(M))){if(!C){A=M;break}}else C=!1;if(A===-1){if(N===-1)return".";A=N}return r.slice(0,A)},basename(r,u){u!==void 0&&e(u,"ext"),e(r,"path");let N=0,d=-1,w=!0,A;if(r.length>=2&&$(r.charCodeAt(0))&&r.charCodeAt(1)===c&&(N=2),u!==void 0&&u.length>0&&u.length<=r.length){if(u===r)return"";let C=u.length-1,M=-1;for(A=r.length-1;A>=N;--A){const T=r.charCodeAt(A);if(E(T)){if(!w){N=A+1;break}}else M===-1&&(w=!1,M=A+1),C>=0&&(T===u.charCodeAt(C)?--C===-1&&(d=A):(C=-1,d=M))}return N===d?d=M:d===-1&&(d=r.length),r.slice(N,d)}for(A=r.length-1;A>=N;--A)if(E(r.charCodeAt(A))){if(!w){N=A+1;break}}else d===-1&&(w=!1,d=A+1);return d===-1?"":r.slice(N,d)},extname(r){e(r,"path");let u=0,N=-1,d=0,w=-1,A=!0,C=0;r.length>=2&&r.charCodeAt(1)===c&&$(r.charCodeAt(0))&&(u=d=2);for(let M=r.length-1;M>=u;--M){const T=r.charCodeAt(M);if(E(T)){if(!A){d=M+1;break}continue}w===-1&&(A=!1,w=M+1),T===h?N===-1?N=M:C!==1&&(C=1):N!==-1&&(C=-1)}return N===-1||w===-1||C===0||C===1&&N===w-1&&N===d+1?"":r.slice(N,w)},format:a.bind(null,"\\"),parse(r){e(r,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return u;const N=r.length;let d=0,w=r.charCodeAt(0);if(N===1)return E(w)?(u.root=u.dir=r,u):(u.base=u.name=r,u);if(E(w)){if(d=1,E(r.charCodeAt(1))){let R=2,x=R;for(;R<N&&!E(r.charCodeAt(R));)R++;if(R<N&&R!==x){for(x=R;R<N&&E(r.charCodeAt(R));)R++;if(R<N&&R!==x){for(x=R;R<N&&!E(r.charCodeAt(R));)R++;R===N?d=R:R!==x&&(d=R+1)}}}}else if($(w)&&r.charCodeAt(1)===c){if(N<=2)return u.root=u.dir=r,u;if(d=2,E(r.charCodeAt(2))){if(N===3)return u.root=u.dir=r,u;d=3}}d>0&&(u.root=r.slice(0,d));let A=-1,C=d,M=-1,T=!0,S=r.length-1,k=0;for(;S>=d;--S){if(w=r.charCodeAt(S),E(w)){if(!T){C=S+1;break}continue}M===-1&&(T=!1,M=S+1),w===h?A===-1?A=S:k!==1&&(k=1):A!==-1&&(k=-1)}return M!==-1&&(A===-1||k===0||k===1&&A===M-1&&A===C+1?u.base=u.name=r.slice(C,M):(u.name=r.slice(C,A),u.base=r.slice(C,M),u.ext=r.slice(A,M))),C>0&&C!==d?u.dir=r.slice(0,C-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null};const l=(()=>{if(v){const r=/\\/g;return()=>{const u=i.cwd().replace(r,"/");return u.slice(u.indexOf("/"))}}return()=>i.cwd()})();t.$hc={resolve(...r){let u="",N=!1;for(let d=r.length-1;d>=-1&&!N;d--){const w=d>=0?r[d]:l();e(w,"path"),w.length!==0&&(u=`${w}/${u}`,N=w.charCodeAt(0)===o)}return u=b(u,!N,"/",L),N?`/${u}`:u.length>0?u:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const u=r.charCodeAt(0)===o,N=r.charCodeAt(r.length-1)===o;return r=b(r,!u,"/",L),r.length===0?u?"/":N?"./":".":(N&&(r+="/"),u?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===o},join(...r){if(r.length===0)return".";let u;for(let N=0;N<r.length;++N){const d=r[N];e(d,"path"),d.length>0&&(u===void 0?u=d:u+=`/${d}`)}return u===void 0?".":t.$hc.normalize(u)},relative(r,u){if(e(r,"from"),e(u,"to"),r===u||(r=t.$hc.resolve(r),u=t.$hc.resolve(u),r===u))return"";const N=1,d=r.length,w=d-N,A=1,C=u.length-A,M=w<C?w:C;let T=-1,S=0;for(;S<M;S++){const R=r.charCodeAt(N+S);if(R!==u.charCodeAt(A+S))break;R===o&&(T=S)}if(S===M)if(C>M){if(u.charCodeAt(A+S)===o)return u.slice(A+S+1);if(S===0)return u.slice(A+S)}else w>M&&(r.charCodeAt(N+S)===o?T=S:S===0&&(T=0));let k="";for(S=N+T+1;S<=d;++S)(S===d||r.charCodeAt(S)===o)&&(k+=k.length===0?"..":"/..");return`${k}${u.slice(A+T)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const u=r.charCodeAt(0)===o;let N=-1,d=!0;for(let w=r.length-1;w>=1;--w)if(r.charCodeAt(w)===o){if(!d){N=w;break}}else d=!1;return N===-1?u?"/":".":u&&N===1?"//":r.slice(0,N)},basename(r,u){u!==void 0&&e(u,"ext"),e(r,"path");let N=0,d=-1,w=!0,A;if(u!==void 0&&u.length>0&&u.length<=r.length){if(u===r)return"";let C=u.length-1,M=-1;for(A=r.length-1;A>=0;--A){const T=r.charCodeAt(A);if(T===o){if(!w){N=A+1;break}}else M===-1&&(w=!1,M=A+1),C>=0&&(T===u.charCodeAt(C)?--C===-1&&(d=A):(C=-1,d=M))}return N===d?d=M:d===-1&&(d=r.length),r.slice(N,d)}for(A=r.length-1;A>=0;--A)if(r.charCodeAt(A)===o){if(!w){N=A+1;break}}else d===-1&&(w=!1,d=A+1);return d===-1?"":r.slice(N,d)},extname(r){e(r,"path");let u=-1,N=0,d=-1,w=!0,A=0;for(let C=r.length-1;C>=0;--C){const M=r.charCodeAt(C);if(M===o){if(!w){N=C+1;break}continue}d===-1&&(w=!1,d=C+1),M===h?u===-1?u=C:A!==1&&(A=1):u!==-1&&(A=-1)}return u===-1||d===-1||A===0||A===1&&u===d-1&&u===N+1?"":r.slice(u,d)},format:a.bind(null,"/"),parse(r){e(r,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return u;const N=r.charCodeAt(0)===o;let d;N?(u.root="/",d=1):d=0;let w=-1,A=0,C=-1,M=!0,T=r.length-1,S=0;for(;T>=d;--T){const k=r.charCodeAt(T);if(k===o){if(!M){A=T+1;break}continue}C===-1&&(M=!1,C=T+1),k===h?w===-1?w=T:S!==1&&(S=1):w!==-1&&(S=-1)}if(C!==-1){const k=A===0&&N?1:A;w===-1||S===0||S===1&&w===C-1&&w===A+1?u.base=u.name=r.slice(k,C):(u.name=r.slice(k,w),u.base=r.slice(k,C),u.ext=r.slice(w,C))}return A>0?u.dir=r.slice(0,A-1):N&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},t.$hc.win32=t.$gc.win32=t.$gc,t.$hc.posix=t.$gc.posix=t.$hc,t.$ic=v?t.$gc.normalize:t.$hc.normalize,t.$jc=v?t.$gc.isAbsolute:t.$hc.isAbsolute,t.$kc=v?t.$gc.join:t.$hc.join,t.$lc=v?t.$gc.resolve:t.$hc.resolve,t.$mc=v?t.$gc.relative:t.$hc.relative,t.$nc=v?t.$gc.dirname:t.$hc.dirname,t.$oc=v?t.$gc.basename:t.$hc.basename,t.$pc=v?t.$gc.extname:t.$hc.extname,t.$qc=v?t.$gc.format:t.$hc.format,t.$rc=v?t.$gc.parse:t.$hc.parse,t.$sc=v?t.$gc.toNamespacedPath:t.$hc.toNamespacedPath,t.sep=v?t.$gc.sep:t.$hc.sep,t.$uc=v?t.$gc.delimiter:t.$hc.delimiter}),re(ie[19],se([0,1,67,18]),function(O,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.$wc=e,t.$xc=a;const y=/^\w[\w\d+.-]*$/,f=/^\//,j=/^\/\//;function h(d,w){if(!d.scheme&&w)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!y.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!f.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(j.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function o(d,w){return!d&&!w?"file":d}function s(d,w){switch(d){case"https":case"http":case"file":w?w[0]!==p&&(w=p+w):w=p;break}return w}const c="",p="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(w){return w instanceof m?!0:w?typeof w.authority=="string"&&typeof w.fragment=="string"&&typeof w.path=="string"&&typeof w.query=="string"&&typeof w.scheme=="string"&&typeof w.fsPath=="string"&&typeof w.with=="function"&&typeof w.toString=="function":!1}constructor(w,A,C,M,T,S=!1){typeof w=="object"?(this.scheme=w.scheme||c,this.authority=w.authority||c,this.path=w.path||c,this.query=w.query||c,this.fragment=w.fragment||c):(this.scheme=o(w,S),this.authority=A||c,this.path=s(this.scheme,C||c),this.query=M||c,this.fragment=T||c,h(this,S))}get fsPath(){return a(this,!1)}with(w){if(!w)return this;let{scheme:A,authority:C,path:M,query:T,fragment:S}=w;return A===void 0?A=this.scheme:A===null&&(A=c),C===void 0?C=this.authority:C===null&&(C=c),M===void 0?M=this.path:M===null&&(M=c),T===void 0?T=this.query:T===null&&(T=c),S===void 0?S=this.fragment:S===null&&(S=c),A===this.scheme&&C===this.authority&&M===this.path&&T===this.query&&S===this.fragment?this:new E(A,C,M,T,S)}static parse(w,A=!1){const C=g.exec(w);return C?new E(C[2]||c,N(C[4]||c),N(C[5]||c),N(C[7]||c),N(C[9]||c),A):new E(c,c,c,c,c)}static file(w){let A=c;if(F.$i&&(w=w.replace(/\\/g,p)),w[0]===p&&w[1]===p){const C=w.indexOf(p,2);C===-1?(A=w.substring(2),w=p):(A=w.substring(2,C),w=w.substring(C)||p)}return new E("file",A,w,c,c)}static from(w,A){return new E(w.scheme,w.authority,w.path,w.query,w.fragment,A)}static joinPath(w,...A){if(!w.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let C;return F.$i&&w.scheme==="file"?C=m.file(i.$gc.join(a(w,!0),...A)).path:C=i.$hc.join(w.path,...A),w.with({path:C})}toString(w=!1){return l(this,w)}toJSON(){return this}static revive(w){if(w){if(w instanceof m)return w;{const A=new E(w);return A._formatted=w.external??null,A._fsPath=w._sep===v?w.fsPath??null:null,A}}else return w}}t.URI=m;function e(d){return!d||typeof d!="object"?!1:typeof d.scheme=="string"&&(typeof d.authority=="string"||typeof d.authority>"u")&&(typeof d.path=="string"||typeof d.path>"u")&&(typeof d.query=="string"||typeof d.query>"u")&&(typeof d.fragment=="string"||typeof d.fragment>"u")}const v=F.$i?1:void 0;class E extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(w=!1){return w?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const w={$mid:1};return this._fsPath&&(w.fsPath=this._fsPath,w._sep=v),this._formatted&&(w.external=this._formatted),this.path&&(w.path=this.path),this.scheme&&(w.scheme=this.scheme),this.authority&&(w.authority=this.authority),this.query&&(w.query=this.query),this.fragment&&(w.fragment=this.fragment),w}}const L={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function $(d,w,A){let C,M=-1;for(let T=0;T<d.length;T++){const S=d.charCodeAt(T);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||w&&S===47||A&&S===91||A&&S===93||A&&S===58)M!==-1&&(C+=encodeURIComponent(d.substring(M,T)),M=-1),C!==void 0&&(C+=d.charAt(T));else{C===void 0&&(C=d.substr(0,T));const k=L[S];k!==void 0?(M!==-1&&(C+=encodeURIComponent(d.substring(M,T)),M=-1),C+=k):M===-1&&(M=T)}}return M!==-1&&(C+=encodeURIComponent(d.substring(M))),C!==void 0?C:d}function b(d){let w;for(let A=0;A<d.length;A++){const C=d.charCodeAt(A);C===35||C===63?(w===void 0&&(w=d.substr(0,A)),w+=L[C]):w!==void 0&&(w+=d[A])}return w!==void 0?w:d}function a(d,w){let A;return d.authority&&d.path.length>1&&d.scheme==="file"?A=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===47&&(d.path.charCodeAt(1)>=65&&d.path.charCodeAt(1)<=90||d.path.charCodeAt(1)>=97&&d.path.charCodeAt(1)<=122)&&d.path.charCodeAt(2)===58?w?A=d.path.substr(1):A=d.path[1].toLowerCase()+d.path.substr(2):A=d.path,F.$i&&(A=A.replace(/\//g,"\\")),A}function l(d,w){const A=w?b:$;let C="",{scheme:M,authority:T,path:S,query:k,fragment:R}=d;if(M&&(C+=M,C+=":"),(T||M==="file")&&(C+=p,C+=p),T){let x=T.indexOf("@");if(x!==-1){const I=T.substr(0,x);T=T.substr(x+1),x=I.lastIndexOf(":"),x===-1?C+=A(I,!1,!1):(C+=A(I.substr(0,x),!1,!1),C+=":",C+=A(I.substr(x+1),!1,!0)),C+="@"}T=T.toLowerCase(),x=T.lastIndexOf(":"),x===-1?C+=A(T,!1,!0):(C+=A(T.substr(0,x),!1,!0),C+=T.substr(x))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const x=S.charCodeAt(1);x>=65&&x<=90&&(S=`/${String.fromCharCode(x+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const x=S.charCodeAt(0);x>=65&&x<=90&&(S=`${String.fromCharCode(x+32)}:${S.substr(2)}`)}C+=A(S,!0,!1)}return k&&(C+="?",C+=A(k,!1,!1)),R&&(C+="#",C+=w?R:$(R,!1,!1)),C}function r(d){try{return decodeURIComponent(d)}catch{return d.length>3?d.substr(0,3)+r(d.substr(3)):d}}const u=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function N(d){return d.match(u)?d.replace(u,w=>r(w)):d}}),re(ie[72],se([0,1,3,11,10,15,18,7]),function(O,t,i,F,y,f,j,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SimpleWorkerServer=t.SimpleWorkerClient=void 0,t.logOnceWebWorkerWarning=c,t.create=u;const o="$initialize";let s=!1;function c(N){j.$o&&(s||(s=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(N.message))}var p;(function(N){N[N.Request=0]="Request",N[N.Reply=1]="Reply",N[N.SubscribeEvent=2]="SubscribeEvent",N[N.Event=3]="Event",N[N.UnsubscribeEvent=4]="UnsubscribeEvent"})(p||(p={}));class g{constructor(d,w,A,C){this.vsWorker=d,this.req=w,this.method=A,this.args=C,this.type=0}}class m{constructor(d,w,A,C){this.vsWorker=d,this.seq=w,this.res=A,this.err=C,this.type=1}}class e{constructor(d,w,A,C){this.vsWorker=d,this.req=w,this.eventName=A,this.arg=C,this.type=2}}class v{constructor(d,w,A){this.vsWorker=d,this.req=w,this.event=A,this.type=3}}class E{constructor(d,w){this.vsWorker=d,this.req=w,this.type=4}}class L{constructor(d){this.a=-1,this.g=d,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(d){this.a=d}sendMessage(d,w){const A=String(++this.b);return new Promise((C,M)=>{this.c[A]={resolve:C,reject:M},this.o(new g(this.a,A,d,w))})}listen(d,w){let A=null;const C=new F.$7d({onWillAddFirstListener:()=>{A=String(++this.b),this.d.set(A,C),this.o(new e(this.a,A,d,w))},onDidRemoveLastListener:()=>{this.d.delete(A),this.o(new E(this.a,A)),A=null}});return C.event}handleMessage(d){!d||!d.vsWorker||this.a!==-1&&d.vsWorker!==this.a||this.h(d)}h(d){switch(d.type){case 1:return this.j(d);case 0:return this.k(d);case 2:return this.l(d);case 3:return this.m(d);case 4:return this.n(d)}}j(d){if(!this.c[d.seq]){console.warn("Got reply to unknown seq");return}const w=this.c[d.seq];if(delete this.c[d.seq],d.err){let A=d.err;d.err.$isError&&(A=new Error,A.name=d.err.name,A.message=d.err.message,A.stack=d.err.stack),w.reject(A);return}w.resolve(d.res)}k(d){const w=d.req;this.g.handleMessage(d.method,d.args).then(C=>{this.o(new m(this.a,w,C,void 0))},C=>{C.detail instanceof Error&&(C.detail=(0,i.$3)(C.detail)),this.o(new m(this.a,w,void 0,(0,i.$3)(C)))})}l(d){const w=d.req,A=this.g.handleEvent(d.eventName,d.arg)(C=>{this.o(new v(this.a,w,C))});this.f.set(w,A)}m(d){if(!this.d.has(d.req)){console.warn("Got event for unknown req");return}this.d.get(d.req).fire(d.event)}n(d){if(!this.f.has(d.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(d.req).dispose(),this.f.delete(d.req)}o(d){const w=[];if(d.type===0)for(let A=0;A<d.args.length;A++)d.args[A]instanceof ArrayBuffer&&w.push(d.args[A]);else d.type===1&&d.res instanceof ArrayBuffer&&w.push(d.res);this.g.sendMessage(d,w)}}class $ extends y.$Uc{constructor(d,w,A){super();let C=null;this.a=this.B(d.create("vs/base/common/worker/simpleWorker",x=>{this.c.handleMessage(x)},x=>{C?.(x)})),this.c=new L({sendMessage:(x,I)=>{this.a.postMessage(x,I)},handleMessage:(x,I)=>{if(typeof A[x]!="function")return Promise.reject(new Error("Missing method "+x+" on main thread host."));try{return Promise.resolve(A[x].apply(A,I))}catch(G){return Promise.reject(G)}},handleEvent:(x,I)=>{if(a(x)){const G=A[x].call(A,I);if(typeof G!="function")throw new Error(`Missing dynamic event ${x} on main thread host.`);return G}if(b(x)){const G=A[x];if(typeof G!="function")throw new Error(`Missing event ${x} on main thread host.`);return G}throw new Error(`Malformed event name ${x}`)}}),this.c.setWorkerId(this.a.getId());let M=null;const T=globalThis.require;typeof T<"u"&&typeof T.getConfig=="function"?M=T.getConfig():typeof globalThis.requirejs<"u"&&(M=globalThis.requirejs.s.contexts._.config);const S=(0,f.$Yn)(A);this.b=this.c.sendMessage(o,[this.a.getId(),JSON.parse(JSON.stringify(M)),w,S]);const k=(x,I)=>this.g(x,I),R=(x,I)=>this.c.listen(x,I);this.f=new Promise((x,I)=>{C=I,this.b.then(G=>{x(l(G,k,R))},G=>{I(G),this.h("Worker failed to load "+w,G)})})}getProxyObject(){return this.f}g(d,w){return new Promise((A,C)=>{this.b.then(()=>{this.c.sendMessage(d,w).then(A,C)},C)})}h(d,w){console.error(d),console.info(w)}}t.SimpleWorkerClient=$;function b(N){return N[0]==="o"&&N[1]==="n"&&h.$kf(N.charCodeAt(2))}function a(N){return/^onDynamic/.test(N)&&h.$kf(N.charCodeAt(9))}function l(N,d,w){const A=T=>function(){const S=Array.prototype.slice.call(arguments,0);return d(T,S)},C=T=>function(S){return w(T,S)},M={};for(const T of N){if(a(T)){M[T]=C(T);continue}if(b(T)){M[T]=w(T,void 0);continue}M[T]=A(T)}return M}class r{constructor(d,w){this.a=w,this.b=null,this.c=new L({sendMessage:(A,C)=>{d(A,C)},handleMessage:(A,C)=>this.d(A,C),handleEvent:(A,C)=>this.f(A,C)})}onmessage(d){this.c.handleMessage(d)}d(d,w){if(d===o)return this.g(w[0],w[1],w[2],w[3]);if(!this.b||typeof this.b[d]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+d));try{return Promise.resolve(this.b[d].apply(this.b,w))}catch(A){return Promise.reject(A)}}f(d,w){if(!this.b)throw new Error("Missing requestHandler");if(a(d)){const A=this.b[d].call(this.b,w);if(typeof A!="function")throw new Error(`Missing dynamic event ${d} on request handler.`);return A}if(b(d)){const A=this.b[d];if(typeof A!="function")throw new Error(`Missing event ${d} on request handler.`);return A}throw new Error(`Malformed event name ${d}`)}g(d,w,A,C){this.c.setWorkerId(d);const S=l(C,(k,R)=>this.c.sendMessage(k,R),(k,R)=>this.c.listen(k,R));return this.a?(this.b=this.a(S),Promise.resolve((0,f.$Yn)(this.b))):(w&&(typeof w.baseUrl<"u"&&delete w.baseUrl,typeof w.paths<"u"&&typeof w.paths.vs<"u"&&delete w.paths.vs,typeof w.trustedTypesPolicy<"u"&&delete w.trustedTypesPolicy,w.catchError=!0,globalThis.require.config(w)),new Promise((k,R)=>{(globalThis.require||O)([A],I=>{if(this.b=I.create(S),!this.b){R(new Error("No RequestHandler!"));return}k((0,f.$Yn)(this.b))},R)}))}}t.SimpleWorkerServer=r;function u(N){return new r(N,null)}}),re(ie[68],se([64,65]),function(O,t){return O.create("vs/editor/common/languages",t)}),re(ie[69],se([0,1,43,19,44,2,62,68]),function(O,t,i,F,y,f,j,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InlineEditTriggerKind=t.ExternalUriOpenerPriority=t.$9t=t.$8t=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadApplicability=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.NewSymbolNameTag=t.$7t=t.$6t=t.SymbolKinds=t.SymbolTag=t.$4t=t.SymbolKind=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.DocumentPasteTriggerKind=t.CodeActionTriggerType=t.$2t=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.PartialAcceptTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.$1t=t.$Zt=t.$Yt=void 0,t.$3t=u,t.$5t=d;class o{constructor(H,ue,oe){this.offset=H,this.type=ue,this.language=oe,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$Yt=o;class s{constructor(H,ue){this.tokens=H,this.endState=ue,this._tokenizationResultBrand=void 0}}t.$Zt=s;class c{constructor(H,ue){this.tokens=H,this.endState=ue,this._encodedTokenizationResultBrand=void 0}}t.$1t=c;var p;(function(P){P[P.Method=0]="Method",P[P.Function=1]="Function",P[P.Constructor=2]="Constructor",P[P.Field=3]="Field",P[P.Variable=4]="Variable",P[P.Class=5]="Class",P[P.Struct=6]="Struct",P[P.Interface=7]="Interface",P[P.Module=8]="Module",P[P.Property=9]="Property",P[P.Event=10]="Event",P[P.Operator=11]="Operator",P[P.Unit=12]="Unit",P[P.Value=13]="Value",P[P.Constant=14]="Constant",P[P.Enum=15]="Enum",P[P.EnumMember=16]="EnumMember",P[P.Keyword=17]="Keyword",P[P.Text=18]="Text",P[P.Color=19]="Color",P[P.File=20]="File",P[P.Reference=21]="Reference",P[P.Customcolor=22]="Customcolor",P[P.Folder=23]="Folder",P[P.TypeParameter=24]="TypeParameter",P[P.User=25]="User",P[P.Issue=26]="Issue",P[P.Snippet=27]="Snippet"})(p||(t.CompletionItemKind=p={}));var g;(function(P){const H=new Map;H.set(0,i.$Hj.symbolMethod),H.set(1,i.$Hj.symbolFunction),H.set(2,i.$Hj.symbolConstructor),H.set(3,i.$Hj.symbolField),H.set(4,i.$Hj.symbolVariable),H.set(5,i.$Hj.symbolClass),H.set(6,i.$Hj.symbolStruct),H.set(7,i.$Hj.symbolInterface),H.set(8,i.$Hj.symbolModule),H.set(9,i.$Hj.symbolProperty),H.set(10,i.$Hj.symbolEvent),H.set(11,i.$Hj.symbolOperator),H.set(12,i.$Hj.symbolUnit),H.set(13,i.$Hj.symbolValue),H.set(15,i.$Hj.symbolEnum),H.set(14,i.$Hj.symbolConstant),H.set(15,i.$Hj.symbolEnum),H.set(16,i.$Hj.symbolEnumMember),H.set(17,i.$Hj.symbolKeyword),H.set(27,i.$Hj.symbolSnippet),H.set(18,i.$Hj.symbolText),H.set(19,i.$Hj.symbolColor),H.set(20,i.$Hj.symbolFile),H.set(21,i.$Hj.symbolReference),H.set(22,i.$Hj.symbolCustomColor),H.set(23,i.$Hj.symbolFolder),H.set(24,i.$Hj.symbolTypeParameter),H.set(25,i.$Hj.account),H.set(26,i.$Hj.issues);function ue($e){let ve=H.get($e);return ve||(console.info("No codicon found for CompletionItemKind "+$e),ve=i.$Hj.symbolProperty),ve}P.toIcon=ue;const oe=new Map;oe.set("method",0),oe.set("function",1),oe.set("constructor",2),oe.set("field",3),oe.set("variable",4),oe.set("class",5),oe.set("struct",6),oe.set("interface",7),oe.set("module",8),oe.set("property",9),oe.set("event",10),oe.set("operator",11),oe.set("unit",12),oe.set("value",13),oe.set("constant",14),oe.set("enum",15),oe.set("enum-member",16),oe.set("enumMember",16),oe.set("keyword",17),oe.set("snippet",27),oe.set("text",18),oe.set("color",19),oe.set("file",20),oe.set("reference",21),oe.set("customcolor",22),oe.set("folder",23),oe.set("type-parameter",24),oe.set("typeParameter",24),oe.set("account",25),oe.set("issue",26);function n($e,ve){let Le=oe.get($e);return typeof Le>"u"&&!ve&&(Le=9),Le}P.fromString=n})(g||(t.CompletionItemKinds=g={}));var m;(function(P){P[P.Deprecated=1]="Deprecated"})(m||(t.CompletionItemTag=m={}));var e;(function(P){P[P.None=0]="None",P[P.KeepWhitespace=1]="KeepWhitespace",P[P.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var v;(function(P){P[P.Word=0]="Word",P[P.Line=1]="Line",P[P.Suggest=2]="Suggest"})(v||(t.PartialAcceptTriggerKind=v={}));var E;(function(P){P[P.Invoke=0]="Invoke",P[P.TriggerCharacter=1]="TriggerCharacter",P[P.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(E||(t.CompletionTriggerKind=E={}));var L;(function(P){P[P.Automatic=0]="Automatic",P[P.Explicit=1]="Explicit"})(L||(t.InlineCompletionTriggerKind=L={}));class ${constructor(H,ue,oe,n){this.range=H,this.text=ue,this.completionKind=oe,this.isSnippetText=n}equals(H){return f.$ct.lift(this.range).equalsRange(H.range)&&this.text===H.text&&this.completionKind===H.completionKind&&this.isSnippetText===H.isSnippetText}}t.$2t=$;var b;(function(P){P[P.Invoke=1]="Invoke",P[P.Auto=2]="Auto"})(b||(t.CodeActionTriggerType=b={}));var a;(function(P){P[P.Automatic=0]="Automatic",P[P.PasteAs=1]="PasteAs"})(a||(t.DocumentPasteTriggerKind=a={}));var l;(function(P){P[P.Invoke=1]="Invoke",P[P.TriggerCharacter=2]="TriggerCharacter",P[P.ContentChange=3]="ContentChange"})(l||(t.SignatureHelpTriggerKind=l={}));var r;(function(P){P[P.Text=0]="Text",P[P.Read=1]="Read",P[P.Write=2]="Write"})(r||(t.DocumentHighlightKind=r={}));function u(P){return P&&F.URI.isUri(P.uri)&&f.$ct.isIRange(P.range)&&(f.$ct.isIRange(P.originSelectionRange)||f.$ct.isIRange(P.targetSelectionRange))}var N;(function(P){P[P.File=0]="File",P[P.Module=1]="Module",P[P.Namespace=2]="Namespace",P[P.Package=3]="Package",P[P.Class=4]="Class",P[P.Method=5]="Method",P[P.Property=6]="Property",P[P.Field=7]="Field",P[P.Constructor=8]="Constructor",P[P.Enum=9]="Enum",P[P.Interface=10]="Interface",P[P.Function=11]="Function",P[P.Variable=12]="Variable",P[P.Constant=13]="Constant",P[P.String=14]="String",P[P.Number=15]="Number",P[P.Boolean=16]="Boolean",P[P.Array=17]="Array",P[P.Object=18]="Object",P[P.Key=19]="Key",P[P.Null=20]="Null",P[P.EnumMember=21]="EnumMember",P[P.Struct=22]="Struct",P[P.Event=23]="Event",P[P.Operator=24]="Operator",P[P.TypeParameter=25]="TypeParameter"})(N||(t.SymbolKind=N={})),t.$4t={17:(0,h.localize)(0,null),16:(0,h.localize)(1,null),4:(0,h.localize)(2,null),13:(0,h.localize)(3,null),8:(0,h.localize)(4,null),9:(0,h.localize)(5,null),21:(0,h.localize)(6,null),23:(0,h.localize)(7,null),7:(0,h.localize)(8,null),0:(0,h.localize)(9,null),11:(0,h.localize)(10,null),10:(0,h.localize)(11,null),19:(0,h.localize)(12,null),5:(0,h.localize)(13,null),1:(0,h.localize)(14,null),2:(0,h.localize)(15,null),20:(0,h.localize)(16,null),15:(0,h.localize)(17,null),18:(0,h.localize)(18,null),24:(0,h.localize)(19,null),3:(0,h.localize)(20,null),6:(0,h.localize)(21,null),14:(0,h.localize)(22,null),22:(0,h.localize)(23,null),25:(0,h.localize)(24,null),12:(0,h.localize)(25,null)};function d(P,H){return(0,h.localize)(26,null,P,t.$4t[H])}var w;(function(P){P[P.Deprecated=1]="Deprecated"})(w||(t.SymbolTag=w={}));var A;(function(P){const H=new Map;H.set(0,i.$Hj.symbolFile),H.set(1,i.$Hj.symbolModule),H.set(2,i.$Hj.symbolNamespace),H.set(3,i.$Hj.symbolPackage),H.set(4,i.$Hj.symbolClass),H.set(5,i.$Hj.symbolMethod),H.set(6,i.$Hj.symbolProperty),H.set(7,i.$Hj.symbolField),H.set(8,i.$Hj.symbolConstructor),H.set(9,i.$Hj.symbolEnum),H.set(10,i.$Hj.symbolInterface),H.set(11,i.$Hj.symbolFunction),H.set(12,i.$Hj.symbolVariable),H.set(13,i.$Hj.symbolConstant),H.set(14,i.$Hj.symbolString),H.set(15,i.$Hj.symbolNumber),H.set(16,i.$Hj.symbolBoolean),H.set(17,i.$Hj.symbolArray),H.set(18,i.$Hj.symbolObject),H.set(19,i.$Hj.symbolKey),H.set(20,i.$Hj.symbolNull),H.set(21,i.$Hj.symbolEnumMember),H.set(22,i.$Hj.symbolStruct),H.set(23,i.$Hj.symbolEvent),H.set(24,i.$Hj.symbolOperator),H.set(25,i.$Hj.symbolTypeParameter);function ue(oe){let n=H.get(oe);return n||(console.info("No codicon found for SymbolKind "+oe),n=i.$Hj.symbolProperty),n}P.toIcon=ue})(A||(t.SymbolKinds=A={}));class C{static asEditOperation(H){return y.$dt.replace(f.$ct.lift(H.range),H.text)}}t.$6t=C;class M{static{this.Comment=new M("comment")}static{this.Imports=new M("imports")}static{this.Region=new M("region")}static fromValue(H){switch(H){case"comment":return M.Comment;case"imports":return M.Imports;case"region":return M.Region}return new M(H)}constructor(H){this.value=H}}t.$7t=M;var T;(function(P){P[P.AIGenerated=1]="AIGenerated"})(T||(t.NewSymbolNameTag=T={}));var S;(function(P){function H(ue){return!ue||typeof ue!="object"?!1:typeof ue.id=="string"&&typeof ue.title=="string"}P.is=H})(S||(t.Command=S={}));var k;(function(P){P[P.Collapsed=0]="Collapsed",P[P.Expanded=1]="Expanded"})(k||(t.CommentThreadCollapsibleState=k={}));var R;(function(P){P[P.Unresolved=0]="Unresolved",P[P.Resolved=1]="Resolved"})(R||(t.CommentThreadState=R={}));var x;(function(P){P[P.Current=0]="Current",P[P.Outdated=1]="Outdated"})(x||(t.CommentThreadApplicability=x={}));var I;(function(P){P[P.Editing=0]="Editing",P[P.Preview=1]="Preview"})(I||(t.CommentMode=I={}));var G;(function(P){P[P.Published=0]="Published",P[P.Draft=1]="Draft"})(G||(t.CommentState=G={}));var K;(function(P){P[P.Type=1]="Type",P[P.Parameter=2]="Parameter"})(K||(t.InlayHintKind=K={}));class _{constructor(H){this.b=H,this.a=null}dispose(){this.a&&this.a.then(H=>{H&&H.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$8t=_,t.$9t=new j.$Nt;var X;(function(P){P[P.None=0]="None",P[P.Option=1]="Option",P[P.Default=2]="Default",P[P.Preferred=3]="Preferred"})(X||(t.ExternalUriOpenerPriority=X={}));var Q;(function(P){P[P.Invoke=0]="Invoke",P[P.Automatic=1]="Automatic"})(Q||(t.InlineEditTriggerKind=Q={}))}),re(ie[70],se([0,1,24,11,38,19,5,2,45,69,61]),function(O,t,i,F,y,f,j,h,o,s,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$r2=void 0,t.$s2=g;class p{static{this.CtrlCmd=2048}static{this.Shift=1024}static{this.Alt=512}static{this.WinCtrl=256}static chord(e,v){return(0,y.$or)(e,v)}}t.$r2=p;function g(){return{editor:void 0,languages:void 0,CancellationTokenSource:i.$ee,Emitter:F.$7d,KeyCode:c.KeyCode,KeyMod:p,Position:j.$bt,Range:h.$ct,Selection:o.$et,SelectionDirection:c.SelectionDirection,MarkerSeverity:c.MarkerSeverity,MarkerTag:c.MarkerTag,Uri:f.URI,Token:s.$Yt}}}),re(ie[73],se([0,1,25,19,5,2,58,30,54,55,70,23,60,34,52,15,3,53]),function(O,t,i,F,y,f,j,h,o,s,c,p,g,m,e,v,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditorSimpleWorker=void 0,t.create=a;class $ extends j.$Hv{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(r){const u=[];for(let N=0;N<this.f.length;N++){const d=this.f[N],w=this.offsetAt(new y.$bt(N+1,1)),A=d.matchAll(r);for(const C of A)(C.index||C.index===0)&&(C.index=C.index+w),u.push(C)}return u}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(r){return this.f[r-1]}getWordAtPosition(r,u){const N=(0,h.$Rs)(r.column,(0,h.$Ps)(u),this.f[r.lineNumber-1],0);return N?new f.$ct(r.lineNumber,N.startColumn,r.lineNumber,N.endColumn):null}getWordUntilPosition(r,u){const N=this.getWordAtPosition(r,u);return N?{word:this.f[r.lineNumber-1].substring(N.startColumn-1,r.column-1),startColumn:N.startColumn,endColumn:r.column}:{word:"",startColumn:r.column,endColumn:r.column}}words(r){const u=this.f,N=this.q.bind(this);let d=0,w="",A=0,C=[];return{*[Symbol.iterator](){for(;;)if(A<C.length){const M=w.substring(C[A].start,C[A].end);A+=1,yield M}else if(d<u.length)w=u[d],C=N(w,r),A=0,d+=1;else break}}}getLineWords(r,u){const N=this.f[r-1],d=this.q(N,u),w=[];for(const A of d)w.push({word:N.substring(A.start,A.end),startColumn:A.start+1,endColumn:A.end+1});return w}q(r,u){const N=[];let d;for(u.lastIndex=0;(d=u.exec(r))&&d[0].length!==0;)N.push({start:d.index,end:d.index+d[0].length});return N}getValueInRange(r){if(r=this.r(r),r.startLineNumber===r.endLineNumber)return this.f[r.startLineNumber-1].substring(r.startColumn-1,r.endColumn-1);const u=this.g,N=r.startLineNumber-1,d=r.endLineNumber-1,w=[];w.push(this.f[N].substring(r.startColumn-1));for(let A=N+1;A<d;A++)w.push(this.f[A]);return w.push(this.f[d].substring(0,r.endColumn-1)),w.join(u)}offsetAt(r){return r=this.s(r),this.l(),this.j.getPrefixSum(r.lineNumber-2)+(r.column-1)}positionAt(r){r=Math.floor(r),r=Math.max(0,r),this.l();const u=this.j.getIndexOf(r),N=this.f[u.index].length;return{lineNumber:1+u.index,column:1+Math.min(u.remainder,N)}}r(r){const u=this.s({lineNumber:r.startLineNumber,column:r.startColumn}),N=this.s({lineNumber:r.endLineNumber,column:r.endColumn});return u.lineNumber!==r.startLineNumber||u.column!==r.startColumn||N.lineNumber!==r.endLineNumber||N.column!==r.endColumn?{startLineNumber:u.lineNumber,startColumn:u.column,endLineNumber:N.lineNumber,endColumn:N.column}:r}s(r){if(!y.$bt.isIPosition(r))throw new Error("bad position");let{lineNumber:u,column:N}=r,d=!1;if(u<1)u=1,N=1,d=!0;else if(u>this.f.length)u=this.f.length,N=this.f[u-1].length+1,d=!0;else{const w=this.f[u-1].length+1;N<1?(N=1,d=!0):N>w&&(N=w,d=!0)}return d?{lineNumber:u,column:N}:r}}class b{constructor(r,u){this.d=r,this.f=Object.create(null),this.g=u,this.h=null}dispose(){this.f=Object.create(null)}j(r){return this.f[r]}k(){const r=[];return Object.keys(this.f).forEach(u=>r.push(this.f[u])),r}acceptNewModel(r){this.f[r.url]=new $(F.URI.parse(r.url),r.lines,r.EOL,r.versionId)}acceptModelChanged(r,u){if(!this.f[r])return;this.f[r].onEvents(u)}acceptRemovedModel(r){this.f[r]&&delete this.f[r]}async computeUnicodeHighlights(r,u,N){const d=this.j(r);return d?g.$m2.computeUnicodeHighlights(d,u,N):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(r,u,N,d){const w=this.j(r),A=this.j(u);return!w||!A?null:b.l(w,A,N,d)}static l(r,u,N,d){const w=d==="advanced"?e.$O2.getDefault():e.$O2.getLegacy(),A=r.getLinesContent(),C=u.getLinesContent(),M=w.computeDiff(A,C,N),T=M.changes.length>0?!1:this.n(r,u);function S(k){return k.map(R=>[R.original.startLineNumber,R.original.endLineNumberExclusive,R.modified.startLineNumber,R.modified.endLineNumberExclusive,R.innerChanges?.map(x=>[x.originalRange.startLineNumber,x.originalRange.startColumn,x.originalRange.endLineNumber,x.originalRange.endColumn,x.modifiedRange.startLineNumber,x.modifiedRange.startColumn,x.modifiedRange.endLineNumber,x.modifiedRange.endColumn])])}return{identical:T,quitEarly:M.hitTimeout,changes:S(M.changes),moves:M.moves.map(k=>[k.lineRangeMapping.original.startLineNumber,k.lineRangeMapping.original.endLineNumberExclusive,k.lineRangeMapping.modified.startLineNumber,k.lineRangeMapping.modified.endLineNumberExclusive,S(k.changes)])}}static n(r,u){const N=r.getLineCount(),d=u.getLineCount();if(N!==d)return!1;for(let w=1;w<=N;w++){const A=r.getLineContent(w),C=u.getLineContent(w);if(A!==C)return!1}return!0}async computeDirtyDiff(r,u,N){const d=this.j(r),w=this.j(u);if(!d||!w)return null;const A=d.getLinesContent(),C=w.getLinesContent();return new m.$tt(A,C,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:N,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this.o=1e5}async computeMoreMinimalEdits(r,u,N){const d=this.j(r);if(!d)return u;const w=[];let A;u=u.slice(0).sort((M,T)=>{if(M.range&&T.range)return f.$ct.compareRangesUsingStarts(M.range,T.range);const S=M.range?0:1,k=T.range?0:1;return S-k});let C=0;for(let M=1;M<u.length;M++)f.$ct.getEndPosition(u[C].range).equals(f.$ct.getStartPosition(u[M].range))?(u[C].range=f.$ct.fromPositions(f.$ct.getStartPosition(u[C].range),f.$ct.getEndPosition(u[M].range)),u[C].text+=u[M].text):(C++,u[C]=u[M]);u.length=C+1;for(let{range:M,text:T,eol:S}of u){if(typeof S=="number"&&(A=S),f.$ct.isEmpty(M)&&!T)continue;const k=d.getValueInRange(M);if(T=T.replace(/\r\n|\n|\r/g,d.eol),k===T)continue;if(Math.max(T.length,k.length)>b.o){w.push({range:M,text:T});continue}const R=(0,i.$ht)(k,T,N),x=d.offsetAt(f.$ct.lift(M).getStartPosition());for(const I of R){const G=d.positionAt(x+I.originalStart),K=d.positionAt(x+I.originalStart+I.originalLength),_={text:T.substr(I.modifiedStart,I.modifiedLength),range:{startLineNumber:G.lineNumber,startColumn:G.column,endLineNumber:K.lineNumber,endColumn:K.column}};d.getValueInRange(_.range)!==_.text&&w.push(_)}}return typeof A=="number"&&w.push({eol:A,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),w}computeHumanReadableDiff(r,u,N){const d=this.j(r);if(!d)return u;const w=[];let A;u=u.slice(0).sort((C,M)=>{if(C.range&&M.range)return f.$ct.compareRangesUsingStarts(C.range,M.range);const T=C.range?0:1,S=M.range?0:1;return T-S});for(let{range:C,text:M,eol:T}of u){let G=function(_,X){return new y.$bt(_.lineNumber+X.lineNumber-1,X.lineNumber===1?_.column+X.column-1:X.column)},K=function(_,X){const Q=[];for(let P=X.startLineNumber;P<=X.endLineNumber;P++){const H=_[P-1];P===X.startLineNumber&&P===X.endLineNumber?Q.push(H.substring(X.startColumn-1,X.endColumn-1)):P===X.startLineNumber?Q.push(H.substring(X.startColumn-1)):P===X.endLineNumber?Q.push(H.substring(0,X.endColumn-1)):Q.push(H)}return Q};if(typeof T=="number"&&(A=T),f.$ct.isEmpty(C)&&!M)continue;const S=d.getValueInRange(C);if(M=M.replace(/\r\n|\n|\r/g,d.eol),S===M)continue;if(Math.max(M.length,S.length)>b.o){w.push({range:C,text:M});continue}const k=S.split(/\r\n|\n|\r/),R=M.split(/\r\n|\n|\r/),x=e.$O2.getDefault().computeDiff(k,R,N),I=f.$ct.lift(C).getStartPosition();for(const _ of x.changes)if(_.innerChanges)for(const X of _.innerChanges)w.push({range:f.$ct.fromPositions(G(I,X.originalRange.getStartPosition()),G(I,X.originalRange.getEndPosition())),text:K(R,X.modifiedRange).join(d.eol)});else throw new E.$cb("The experimental diff algorithm always produces inner changes")}return typeof A=="number"&&w.push({eol:A,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),w}async computeLinks(r){const u=this.j(r);return u?(0,o.$p2)(u):null}async computeDefaultDocumentColors(r){const u=this.j(r);return u?(0,L.$P2)(u):null}static{this.p=1e4}async textualSuggest(r,u,N,d){const w=new p.$3d,A=new RegExp(N,d),C=new Set;e:for(const M of r){const T=this.j(M);if(T){for(const S of T.words(A))if(!(S===u||!isNaN(Number(S)))&&(C.add(S),C.size>b.p))break e}}return{words:Array.from(C),duration:w.elapsed()}}async computeWordRanges(r,u,N,d){const w=this.j(r);if(!w)return Object.create(null);const A=new RegExp(N,d),C=Object.create(null);for(let M=u.startLineNumber;M<u.endLineNumber;M++){const T=w.getLineWords(M,A);for(const S of T){if(!isNaN(Number(S.word)))continue;let k=C[S.word];k||(k=[],C[S.word]=k),k.push({startLineNumber:M,startColumn:S.startColumn,endLineNumber:M,endColumn:S.endColumn})}}return C}async navigateValueSet(r,u,N,d,w){const A=this.j(r);if(!A)return null;const C=new RegExp(d,w);u.startColumn===u.endColumn&&(u={startLineNumber:u.startLineNumber,startColumn:u.startColumn,endLineNumber:u.endLineNumber,endColumn:u.endColumn+1});const M=A.getValueInRange(u),T=A.getWordAtPosition({lineNumber:u.startLineNumber,column:u.startColumn},C);if(!T)return null;const S=A.getValueInRange(T);return s.$q2.INSTANCE.navigateValueSet(u,M,T,S,N)}loadForeignModule(r,u,N){const d=(C,M)=>this.d.fhr(C,M),A={host:(0,v.$Zn)(N,d),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(A,u),Promise.resolve((0,v.$Yn)(this.h))):new Promise((C,M)=>{O([r],T=>{this.h=T.create(A,u),C((0,v.$Yn)(this.h))},M)})}fmr(r,u){if(!this.h||typeof this.h[r]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+r));try{return Promise.resolve(this.h[r].apply(this.h,u))}catch(N){return Promise.reject(N)}}}t.EditorSimpleWorker=b;function a(l){return new b(l,null)}typeof importScripts=="function"&&(globalThis.monaco=(0,c.$s2)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9ccb0fa738a2f7a1c5328800c9fe18f4dd5b4f8a/core/vs/base/worker/workerMain.js.map
