/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/platform/log/common/log","vs/nls","vs/base/common/errors","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/base/common/json","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","fs","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/base/common/extpath","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],re=function(J){for(var e=[],j=0,R=J.length;j<R;j++)e[j]=ne[J[j]];return e};define(ne[71],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class j{static get(){const k=new Map,A=new Map,D=new Map,E=new Map;function u($,b){$.has(b.detail)||$.set(b.detail,-b.timestamp)}function a($,b){const O=$.get(b.detail);O&&(O>=0||$.set(b.detail,O+b.timestamp))}let w=[];typeof J=="function"&&typeof J.getStats=="function"&&(w=J.getStats().slice(0).sort(($,b)=>$.timestamp-b.timestamp));for(const $ of w)switch($.type){case 10:u(k,$);break;case 11:case 12:a(k,$);break;case 21:u(A,$);break;case 22:a(A,$);break;case 33:u(D,$);break;case 34:a(D,$);break;case 31:u(E,$);break;case 32:a(E,$);break}let v=0;D.forEach($=>v+=$);function d($){const b=[];return $.forEach((O,m)=>b.push([m,O])),b}return{amdLoad:d(k),amdInvoke:d(A),nodeRequire:d(D),nodeEval:d(E),nodeRequireTotal:v}}static toMarkdownTable(k,A){let D="";const E=[];return k.forEach((u,a)=>{E[a]=u.length}),A.forEach(u=>{u.forEach((a,w)=>{typeof a>"u"&&(a=u[w]="-");const v=a.toString().length;E[w]=Math.max(v,E[w])})}),k.forEach((u,a)=>{D+=`| ${u+" ".repeat(E[a]-u.toString().length)} `}),D+=`|
`,k.forEach((u,a)=>{D+=`| ${"-".repeat(E[a])} `}),D+=`|
`,A.forEach(u=>{u.forEach((a,w)=>{typeof a<"u"&&(D+=`| ${a+" ".repeat(E[w]-a.toString().length)} `)}),D+=`|
`}),D}}e.$U=j}),define(ne[54],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=R,e.$Nh=k,e.$Oh=A;function j(D){return(E,u,a)=>{let w=null,v=null;if(typeof a.value=="function"?(w="value",v=a.value):typeof a.get=="function"&&(w="get",v=a.get),!v)throw new Error("not supported");a[w]=D(v,u)}}function R(D,E,u){let a=null,w=null;if(typeof u.value=="function"?(a="value",w=u.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(a="get",w=u.get),!w)throw new Error("not supported");const v=`$memoize$${E}`;u[a]=function(...d){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:w.apply(this,d)}),this[v]}}function k(D,E,u){return j((a,w)=>{const v=`$debounce$${w}`,d=`$debounce$result$${w}`;return function(...$){this[d]||(this[d]=u?u():void 0),clearTimeout(this[v]),E&&(this[d]=E(this[d],...$),$=[this[d]]),this[v]=setTimeout(()=>{a.apply(this,$),this[d]=u?u():void 0},D)}})}function A(D,E,u){return j((a,w)=>{const v=`$throttle$timer$${w}`,d=`$throttle$result$${w}`,$=`$throttle$lastRun$${w}`,b=`$throttle$pending$${w}`;return function(...O){if(this[d]||(this[d]=u?u():void 0),(this[$]===null||this[$]===void 0)&&(this[$]=-Number.MAX_VALUE),E&&(this[d]=E(this[d],...O)),this[b])return;const m=this[$]+D;m<=Date.now()?(this[$]=Date.now(),a.apply(this,[this[d]]),this[d]=u?u():void 0):(this[b]=!0,this[v]=setTimeout(()=>{this[b]=!1,this[$]=Date.now(),a.apply(this,[this[d]]),this[d]=u?u():void 0},m-Date.now()))}})}}),define(ne[72],re([0,1,8]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=R,e.$0c=k,e.$$c=A,e.$_c=D,e.$ad=E,e.$bd=u;function R(a,w){if(!a)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}function k(a,w="Unreachable"){throw new Error(w)}function A(a){if(!a)throw new j.$cb("Assertion Failed")}function D(a){a||(0,j.$1)(new j.$cb("Soft Assertion Failed"))}function E(a){if(!a()){debugger;a(),(0,j.$1)(new j.$cb("Assertion Failed"))}}function u(a,w){let v=0;for(;v<a.length-1;){const d=a[v],$=a[v+1];if(!w(d,$))return!1;v++}return!0}}),define(ne[38],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$tn=D,e.$un=v,e.$vn=d,e.$wn=$,e.$xn=b,e.$yn=O,e.$zn=m,e.$An=c,e.$Bn=y,e.$Cn=p,e.$Dn=h,e.$En=g;var j;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(j||(e.ScanError=j={}));var R;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k||(e.ParseErrorCode=k={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function D(i,r=!1){let t=0;const n=i.length;let s="",o=0,l=16,P=0;function I(ie){let ue=0,he=0;for(;ue<ie;){const ce=i.charCodeAt(t);if(ce>=48&&ce<=57)he=he*16+ce-48;else if(ce>=65&&ce<=70)he=he*16+ce-65+10;else if(ce>=97&&ce<=102)he=he*16+ce-97+10;else break;t++,ue++}return ue<ie&&(he=-1),he}function L(ie){t=ie,s="",o=0,l=16,P=0}function z(){const ie=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&a(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&a(i.charCodeAt(t)))for(t++;t<i.length&&a(i.charCodeAt(t));)t++;else return P=3,i.substring(ie,t);let ue=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&a(i.charCodeAt(t))){for(t++;t<i.length&&a(i.charCodeAt(t));)t++;ue=t}else P=3;return i.substring(ie,ue)}function U(){let ie="",ue=t;for(;;){if(t>=n){ie+=i.substring(ue,t),P=2;break}const he=i.charCodeAt(t);if(he===34){ie+=i.substring(ue,t),t++;break}if(he===92){if(ie+=i.substring(ue,t),t++,t>=n){P=2;break}switch(i.charCodeAt(t++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:{const B=I(4);B>=0?ie+=String.fromCharCode(B):P=4;break}default:P=5}ue=t;continue}if(he>=0&&he<=31)if(u(he)){ie+=i.substring(ue,t),P=2;break}else P=6;t++}return ie}function V(){if(s="",P=0,o=t,t>=n)return o=n,l=17;let ie=i.charCodeAt(t);if(E(ie)){do t++,s+=String.fromCharCode(ie),ie=i.charCodeAt(t);while(E(ie));return l=15}if(u(ie))return t++,s+=String.fromCharCode(ie),ie===13&&i.charCodeAt(t)===10&&(t++,s+=`
`),l=14;switch(ie){case 123:return t++,l=1;case 125:return t++,l=2;case 91:return t++,l=3;case 93:return t++,l=4;case 58:return t++,l=6;case 44:return t++,l=5;case 34:return t++,s=U(),l=10;case 47:{const ue=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<n&&!u(i.charCodeAt(t));)t++;return s=i.substring(ue,t),l=12}if(i.charCodeAt(t+1)===42){t+=2;const he=n-1;let ce=!1;for(;t<he;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,ce=!0;break}t++}return ce||(t++,P=1),s=i.substring(ue,t),l=13}return s+=String.fromCharCode(ie),t++,l=16}case 45:if(s+=String.fromCharCode(ie),t++,t===n||!a(i.charCodeAt(t)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=z(),l=11;default:for(;t<n&&X(ie);)t++,ie=i.charCodeAt(t);if(o!==t){switch(s=i.substring(o,t),s){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return s+=String.fromCharCode(ie),t++,l=16}}function X(ie){if(E(ie)||u(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let ie;do ie=V();while(ie>=12&&ie<=15);return ie}return{setPosition:L,getPosition:()=>t,scan:r?se:V,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>t-o,getTokenError:()=>P}}function E(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function u(i){return i===10||i===13||i===8232||i===8233}function a(i){return i>=48&&i<=57}var w;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(w||(w={}));function v(i,r){const t=[],n=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function P(I,L,z,U){o.value=I,o.offset=L,o.length=z,o.type=U,o.colonOffset=void 0,s=o}try{p(i,{onObjectBegin:(I,L)=>{if(r<=I)throw n;s=void 0,l=r>I,t.push("")},onObjectProperty:(I,L,z)=>{if(r<L||(P(I,L,z,"property"),t[t.length-1]=I,r<=L+z))throw n},onObjectEnd:(I,L)=>{if(r<=I)throw n;s=void 0,t.pop()},onArrayBegin:(I,L)=>{if(r<=I)throw n;s=void 0,t.push(0)},onArrayEnd:(I,L)=>{if(r<=I)throw n;s=void 0,t.pop()},onLiteralValue:(I,L,z)=>{if(r<L||(P(I,L,z,g(I)),r<=L+z))throw n},onSeparator:(I,L,z)=>{if(r<=L)throw n;if(I===":"&&s&&s.type==="property")s.colonOffset=L,l=!1,s=void 0;else if(I===","){const U=t[t.length-1];typeof U=="number"?t[t.length-1]=U+1:(l=!0,t[t.length-1]=""),s=void 0}}})}catch(I){if(I!==n)throw I}return{path:t,previousNode:s,isAtPropertyKey:l,matches:I=>{let L=0;for(let z=0;L<I.length&&z<t.length;z++)if(I[L]===t[z]||I[L]==="*")L++;else if(I[L]!=="**")return!1;return L===I.length}}}function d(i,r=[],t=A.DEFAULT){let n=null,s=[];const o=[];function l(I){Array.isArray(s)?s.push(I):n!==null&&(s[n]=I)}return p(i,{onObjectBegin:()=>{const I={};l(I),o.push(s),s=I,n=null},onObjectProperty:I=>{n=I},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const I=[];l(I),o.push(s),s=I,n=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:l,onError:(I,L,z)=>{r.push({error:I,offset:L,length:z})}},t),s[0]}function $(i,r=[],t=A.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(I){n.type==="property"&&(n.length=I-n.offset,n=n.parent)}function o(I){return n.children.push(I),I}p(i,{onObjectBegin:I=>{n=o({type:"object",offset:I,length:-1,parent:n,children:[]})},onObjectProperty:(I,L,z)=>{n=o({type:"property",offset:L,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:I,offset:L,length:z,parent:n})},onObjectEnd:(I,L)=>{n.length=I+L-n.offset,n=n.parent,s(I+L)},onArrayBegin:(I,L)=>{n=o({type:"array",offset:I,length:-1,parent:n,children:[]})},onArrayEnd:(I,L)=>{n.length=I+L-n.offset,n=n.parent,s(I+L)},onLiteralValue:(I,L,z)=>{o({type:g(I),offset:L,length:z,parent:n,value:I}),s(L+z)},onSeparator:(I,L,z)=>{n.type==="property"&&(I===":"?n.colonOffset=L:I===","&&s(L))},onError:(I,L,z)=>{r.push({error:I,offset:L,length:z})}},t);const P=n.children[0];return P&&delete P.parent,P}function b(i,r){if(!i)return;let t=i;for(const n of r)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const o of t.children)if(Array.isArray(o.children)&&o.children[0].value===n){t=o.children[1],s=!0;break}if(!s)return}else{const s=n;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}function O(i){if(!i.parent||!i.parent.children)return[];const r=O(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;r.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&r.push(t)}return r}function m(i){switch(i.type){case"array":return i.children.map(m);case"object":{const r=Object.create(null);for(const t of i.children){const n=t.children[1];n&&(r[t.children[0].value]=m(n))}return r}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function c(i,r,t=!1){return r>=i.offset&&r<i.offset+i.length||t&&r===i.offset+i.length}function y(i,r,t=!1){if(c(i,r,t)){const n=i.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=r;s++){const o=y(n[s],r,t);if(o)return o}return i}}function p(i,r,t=A.DEFAULT){const n=D(i,!1);function s(Y){return Y?()=>Y(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(Y){return Y?_=>Y(_,n.getTokenOffset(),n.getTokenLength()):()=>!0}const l=s(r.onObjectBegin),P=o(r.onObjectProperty),I=s(r.onObjectEnd),L=s(r.onArrayBegin),z=s(r.onArrayEnd),U=o(r.onLiteralValue),V=o(r.onSeparator),X=s(r.onComment),se=o(r.onError),ie=t&&t.disallowComments,ue=t&&t.allowTrailingComma;function he(){for(;;){const Y=n.scan();switch(n.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:ie||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(Y){case 12:case 13:ie?ce(10):X();break;case 16:ce(1);break;case 15:case 14:break;default:return Y}}}function ce(Y,_=[],M=[]){if(se(Y),_.length+M.length>0){let F=n.getToken();for(;F!==17;){if(_.indexOf(F)!==-1){he();break}else if(M.indexOf(F)!==-1)break;F=he()}}}function B(Y){const _=n.getTokenValue();return Y?U(_):P(_),he(),!0}function Z(){switch(n.getToken()){case 11:{let Y=0;try{Y=JSON.parse(n.getTokenValue()),typeof Y!="number"&&(ce(2),Y=0)}catch{ce(2)}U(Y);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return he(),!0}function q(){return n.getToken()!==10?(ce(3,[],[2,5]),!1):(B(!1),n.getToken()===6?(V(":"),he(),Q()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function T(){l(),he();let Y=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(Y||ce(4,[],[]),V(","),he(),n.getToken()===2&&ue)break}else Y&&ce(6,[],[]);q()||ce(4,[],[2,5]),Y=!0}return I(),n.getToken()!==2?ce(7,[2],[]):he(),!0}function W(){L(),he();let Y=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(Y||ce(4,[],[]),V(","),he(),n.getToken()===4&&ue)break}else Y&&ce(6,[],[]);Q()||ce(4,[],[4,5]),Y=!0}return z(),n.getToken()!==4?ce(8,[4],[]):he(),!0}function Q(){switch(n.getToken()){case 3:return W();case 1:return T();case 10:return B(!0);default:return Z()}}return he(),n.getToken()===17?t.allowEmptyContent?!0:(ce(4,[],[]),!1):Q()?(n.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}function h(i,r){const t=D(i),n=[];let s,o=0,l;do switch(l=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:o!==l&&n.push(i.substring(o,l)),r!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,r)),o=t.getPosition();break}while(s!==17);return n.join("")}function g(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(ne[73],re([0,1,38]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=R,e.$Gn=k,e.$Hn=E,e.$In=u;function R(a,w,v){let d,$,b,O,m;if(w){for(O=w.offset,m=O+w.length,b=O;b>0&&!u(a,b-1);)b--;let l=m;for(;l<a.length&&!u(a,l);)l++;$=a.substring(b,l),d=D($,v)}else $=a,d=0,b=0,O=0,m=a.length;const c=E(v,a);let y=!1,p=0,h;v.insertSpaces?h=A(" ",v.tabSize||4):h="	";const g=(0,j.$tn)($,!1);let i=!1;function r(){return c+A(h,d+p)}function t(){let l=g.scan();for(y=!1;l===15||l===14;)y=y||l===14,l=g.scan();return i=l===16||g.getTokenError()!==0,l}const n=[];function s(l,P,I){!i&&P<m&&I>O&&a.substring(P,I)!==l&&n.push({offset:P,length:I-P,content:l})}let o=t();if(o!==17){const l=g.getTokenOffset()+b,P=A(h,d);s(P,b,l)}for(;o!==17;){let l=g.getTokenOffset()+g.getTokenLength()+b,P=t(),I="";for(;!y&&(P===12||P===13);){const z=g.getTokenOffset()+b;s(" ",l,z),l=g.getTokenOffset()+g.getTokenLength()+b,I=P===12?r():"",P=t()}if(P===2)o!==1&&(p--,I=r());else if(P===4)o!==3&&(p--,I=r());else{switch(o){case 3:case 1:p++,I=r();break;case 5:case 12:I=r();break;case 13:y?I=r():I=" ";break;case 6:I=" ";break;case 10:if(P===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:P===12||P===13?I=" ":P!==5&&P!==17&&(i=!0);break;case 16:i=!0;break}y&&(P===12||P===13)&&(I=r())}const L=g.getTokenOffset()+b;s(I,l,L),o=P}return n}function k(a,w){const v=JSON.stringify(a,void 0,w.insertSpaces?w.tabSize||4:"	");return w.eol!==void 0?v.replace(/\r\n|\r|\n/g,w.eol):v}function A(a,w){let v="";for(let d=0;d<w;d++)v+=a;return v}function D(a,w){let v=0,d=0;const $=w.tabSize||4;for(;v<a.length;){const b=a.charAt(v);if(b===" ")d++;else if(b==="	")d+=$;else break;v++}return Math.floor(d/$)}function E(a,w){for(let v=0;v<w.length;v++){const d=w.charAt(v);if(d==="\r")return v+1<w.length&&w.charAt(v+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return a&&a.eol||`
`}function u(a,w){return`\r
`.indexOf(a.charAt(w))!==-1}}),define(ne[74],re([0,1,38,73]),function(J,e,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=k,e.$Kn=A,e.$Ln=D,e.$Mn=E,e.$Nn=u;function k(a,w,v){return A(a,w,void 0,v)}function A(a,w,v,d,$){const b=w.slice(),O=[],m=(0,j.$wn)(a,O);let c,y;for(;b.length>0&&(y=b.pop(),c=(0,j.$xn)(m,b),c===void 0&&v!==void 0);)typeof y=="string"?v={[y]:v}:v=[v];if(c)if(c.type==="object"&&typeof y=="string"&&Array.isArray(c.children)){const p=(0,j.$xn)(c,[y]);if(p!==void 0)if(v===void 0){if(!p.parent)throw new Error("Malformed AST");const h=c.children.indexOf(p.parent);let g,i=p.parent.offset+p.parent.length;if(h>0){const r=c.children[h-1];g=r.offset+r.length}else g=c.offset+1,c.children.length>1&&(i=c.children[1].offset);return D(a,{offset:g,length:i-g,content:""},d)}else return D(a,{offset:p.offset,length:p.length,content:JSON.stringify(v)},d);else{if(v===void 0)return[];const h=`${JSON.stringify(y)}: ${JSON.stringify(v)}`,g=$?$(c.children.map(r=>r.children[0].value)):c.children.length;let i;if(g>0){const r=c.children[g-1];i={offset:r.offset+r.length,length:0,content:","+h}}else c.children.length===0?i={offset:c.offset+1,length:0,content:h}:i={offset:c.offset+1,length:0,content:h+","};return D(a,i,d)}}else if(c.type==="array"&&typeof y=="number"&&Array.isArray(c.children))if(v!==void 0){const p=`${JSON.stringify(v)}`;let h;if(c.children.length===0||y===0)h={offset:c.offset+1,length:0,content:c.children.length===0?p:p+","};else{const g=y===-1||y>c.children.length?c.children.length:y,i=c.children[g-1];h={offset:i.offset+i.length,length:0,content:","+p}}return D(a,h,d)}else{const p=y,h=c.children[p];let g;if(c.children.length===1)g={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===p){const i=c.children[p-1],r=i.offset+i.length,t=c.offset+c.length;g={offset:r,length:t-2-r,content:""}}else g={offset:h.offset,length:c.children[p+1].offset-h.offset,content:""};return D(a,g,d)}else throw new Error(`Can not add ${typeof y!="number"?"index":"property"} to parent of type ${c.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return D(a,{offset:m?m.offset:0,length:m?m.length:0,content:JSON.stringify(v)},d)}}function D(a,w,v){let d=E(a,w),$=w.offset,b=w.offset+w.content.length;if(w.length===0||w.content.length===0){for(;$>0&&!(0,R.$In)(d,$-1);)$--;for(;b<d.length&&!(0,R.$In)(d,b);)b++}const O=(0,R.$Fn)(d,{offset:$,length:b-$},v);for(let c=O.length-1;c>=0;c--){const y=O[c];d=E(d,y),$=Math.min($,y.offset),b=Math.max(b,y.offset+y.length),b+=y.content.length-y.length}const m=a.length-(d.length-b)-$;return[{offset:$,length:m,content:d.substring($,b)}]}function E(a,w){return a.substring(0,w.offset)+w.content+a.substring(w.offset+w.length)}function u(a,w){const v=w.slice(0).sort(($,b)=>{const O=$.offset-b.offset;return O===0?$.length-b.length:O});let d=a.length;for(let $=v.length-1;$>=0;$--){const b=v[$];if(b.offset+b.length<=d)a=E(a,b);else throw new Error("Overlapping edit");d=b.offset}return a}}),define(ne[75],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=e.$pm=void 0,e.$nm=j,e.rot=R;function j(E,u,a){return Math.min(Math.max(E,u),a)}function R(E,u){return(u+E%u)%u}class k{constructor(){this.a=0}getNext(){return this.a++}}e.$pm=k;class A{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$qm=A;class D{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const a=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$rm=D}),function(){function J(k){const A=[];typeof k=="number"&&A.push("code/timeOrigin",k);function D(u){A.push(u,Date.now())}function E(){const u=[];for(let a=0;a<A.length;a+=2)u.push({name:A[a],startTime:A[a+1]});return u}return{mark:D,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const D of performance.getEntriesByType("mark"))A.push({name:D.name,startTime:Math.round(k+D.startTime)});return A}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function j(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return j(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=j(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=j(R))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var j=e();for(var R in j)(typeof exports=="object"?exports:J)[R]=j[R]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function j(R){if(e[R])return e[R].exports;var k=e[R]={i:R,l:!1,exports:{}};return J[R].call(k.exports,k,k.exports,j),k.l=!0,k.exports}return j.m=J,j.c=e,j.d=function(R,k,A){j.o(R,k)||Object.defineProperty(R,k,{enumerable:!0,get:A})},j.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},j.t=function(R,k){if(1&k&&(R=j(R)),8&k||4&k&&typeof R=="object"&&R&&R.__esModule)return R;var A=Object.create(null);if(j.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:R}),2&k&&typeof R!="string")for(var D in R)j.d(A,D,function(E){return R[E]}.bind(null,D));return A},j.n=function(R){var k=R&&R.__esModule?function(){return R.default}:function(){return R};return j.d(k,"a",k),k},j.o=function(R,k){return Object.prototype.hasOwnProperty.call(R,k)},j.p="",j(j.s=0)}([function(J,e,j){(function(R){var k;e=J.exports=M,k=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var H=Array.prototype.slice.call(arguments,0);H.unshift("SEMVER"),console.log.apply(console,H)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],u=e.src=[],a=0,w=a++;u[w]="0|[1-9]\\d*";var v=a++;u[v]="[0-9]+";var d=a++;u[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var $=a++;u[$]="("+u[w]+")\\.("+u[w]+")\\.("+u[w]+")";var b=a++;u[b]="("+u[v]+")\\.("+u[v]+")\\.("+u[v]+")";var O=a++;u[O]="(?:"+u[w]+"|"+u[d]+")";var m=a++;u[m]="(?:"+u[v]+"|"+u[d]+")";var c=a++;u[c]="(?:-("+u[O]+"(?:\\."+u[O]+")*))";var y=a++;u[y]="(?:-?("+u[m]+"(?:\\."+u[m]+")*))";var p=a++;u[p]="[0-9A-Za-z-]+";var h=a++;u[h]="(?:\\+("+u[p]+"(?:\\."+u[p]+")*))";var g=a++,i="v?"+u[$]+u[c]+"?"+u[h]+"?";u[g]="^"+i+"$";var r="[v=\\s]*"+u[b]+u[y]+"?"+u[h]+"?",t=a++;u[t]="^"+r+"$";var n=a++;u[n]="((?:<|>)?=?)";var s=a++;u[s]=u[v]+"|x|X|\\*";var o=a++;u[o]=u[w]+"|x|X|\\*";var l=a++;u[l]="[v=\\s]*("+u[o]+")(?:\\.("+u[o]+")(?:\\.("+u[o]+")(?:"+u[c]+")?"+u[h]+"?)?)?";var P=a++;u[P]="[v=\\s]*("+u[s]+")(?:\\.("+u[s]+")(?:\\.("+u[s]+")(?:"+u[y]+")?"+u[h]+"?)?)?";var I=a++;u[I]="^"+u[n]+"\\s*"+u[l]+"$";var L=a++;u[L]="^"+u[n]+"\\s*"+u[P]+"$";var z=a++;u[z]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=a++;u[U]="(?:~>?)";var V=a++;u[V]="(\\s*)"+u[U]+"\\s+",E[V]=new RegExp(u[V],"g");var X=a++;u[X]="^"+u[U]+u[l]+"$";var se=a++;u[se]="^"+u[U]+u[P]+"$";var ie=a++;u[ie]="(?:\\^)";var ue=a++;u[ue]="(\\s*)"+u[ie]+"\\s+",E[ue]=new RegExp(u[ue],"g");var he=a++;u[he]="^"+u[ie]+u[l]+"$";var ce=a++;u[ce]="^"+u[ie]+u[P]+"$";var B=a++;u[B]="^"+u[n]+"\\s*("+r+")$|^$";var Z=a++;u[Z]="^"+u[n]+"\\s*("+i+")$|^$";var q=a++;u[q]="(\\s*)"+u[n]+"\\s*("+r+"|"+u[l]+")",E[q]=new RegExp(u[q],"g");var T=a++;u[T]="^\\s*("+u[l]+")\\s+-\\s+("+u[l]+")\\s*$";var W=a++;u[W]="^\\s*("+u[P]+")\\s+-\\s+("+u[P]+")\\s*$";var Q=a++;u[Q]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)k(Y,u[Y]),E[Y]||(E[Y]=new RegExp(u[Y]));function _(H,K){if(H instanceof M)return H;if(typeof H!="string"||H.length>A||!(K?E[t]:E[g]).test(H))return null;try{return new M(H,K)}catch{return null}}function M(H,K){if(H instanceof M){if(H.loose===K)return H;H=H.version}else if(typeof H!="string")throw new TypeError("Invalid Version: "+H);if(H.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof M))return new M(H,K);k("SemVer",H,K),this.loose=K;var ee=H.trim().match(K?E[t]:E[g]);if(!ee)throw new TypeError("Invalid Version: "+H);if(this.raw=H,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var ve=+ge;if(ve>=0&&ve<D)return ve}return ge}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=_,e.valid=function(H,K){var ee=_(H,K);return ee?ee.version:null},e.clean=function(H,K){var ee=_(H.trim().replace(/^[=v]+/,""),K);return ee?ee.version:null},e.SemVer=M,M.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},M.prototype.toString=function(){return this.version},M.prototype.compare=function(H){return k("SemVer.compare",this.version,this.loose,H),H instanceof M||(H=new M(H,this.loose)),this.compareMain(H)||this.comparePre(H)},M.prototype.compareMain=function(H){return H instanceof M||(H=new M(H,this.loose)),f(this.major,H.major)||f(this.minor,H.minor)||f(this.patch,H.patch)},M.prototype.comparePre=function(H){if(H instanceof M||(H=new M(H,this.loose)),this.prerelease.length&&!H.prerelease.length)return-1;if(!this.prerelease.length&&H.prerelease.length)return 1;if(!this.prerelease.length&&!H.prerelease.length)return 0;var K=0;do{var ee=this.prerelease[K],ge=H.prerelease[K];if(k("prerelease compare",K,ee,ge),ee===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(ee===void 0)return-1;if(ee!==ge)return f(ee,ge)}while(++K)},M.prototype.inc=function(H,K){switch(H){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+H)}return this.format(),this.raw=this.version,this},e.inc=function(H,K,ee,ge){typeof ee=="string"&&(ge=ee,ee=void 0);try{return new M(H,ee).inc(K,ge).version}catch{return null}},e.diff=function(H,K){if(x(H,K))return null;var ee=_(H),ge=_(K);if(ee.prerelease.length||ge.prerelease.length){for(var ve in ee)if((ve==="major"||ve==="minor"||ve==="patch")&&ee[ve]!==ge[ve])return"pre"+ve;return"prerelease"}for(var ve in ee)if((ve==="major"||ve==="minor"||ve==="patch")&&ee[ve]!==ge[ve])return ve},e.compareIdentifiers=f;var F=/^[0-9]+$/;function f(H,K){var ee=F.test(H),ge=F.test(K);return ee&&ge&&(H=+H,K=+K),ee&&!ge?-1:ge&&!ee?1:H<K?-1:H>K?1:0}function S(H,K,ee){return new M(H,ee).compare(new M(K,ee))}function N(H,K,ee){return S(H,K,ee)>0}function C(H,K,ee){return S(H,K,ee)<0}function x(H,K,ee){return S(H,K,ee)===0}function G(H,K,ee){return S(H,K,ee)!==0}function te(H,K,ee){return S(H,K,ee)>=0}function ae(H,K,ee){return S(H,K,ee)<=0}function le(H,K,ee,ge){var ve;switch(K){case"===":typeof H=="object"&&(H=H.version),typeof ee=="object"&&(ee=ee.version),ve=H===ee;break;case"!==":typeof H=="object"&&(H=H.version),typeof ee=="object"&&(ee=ee.version),ve=H!==ee;break;case"":case"=":case"==":ve=x(H,ee,ge);break;case"!=":ve=G(H,ee,ge);break;case">":ve=N(H,ee,ge);break;case">=":ve=te(H,ee,ge);break;case"<":ve=C(H,ee,ge);break;case"<=":ve=ae(H,ee,ge);break;default:throw new TypeError("Invalid operator: "+K)}return ve}function pe(H,K){if(H instanceof pe){if(H.loose===K)return H;H=H.value}if(!(this instanceof pe))return new pe(H,K);k("comparator",H,K),this.loose=K,this.parse(H),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(H,K){return f(K,H)},e.major=function(H,K){return new M(H,K).major},e.minor=function(H,K){return new M(H,K).minor},e.patch=function(H,K){return new M(H,K).patch},e.compare=S,e.compareLoose=function(H,K){return S(H,K,!0)},e.rcompare=function(H,K,ee){return S(K,H,ee)},e.sort=function(H,K){return H.sort(function(ee,ge){return e.compare(ee,ge,K)})},e.rsort=function(H,K){return H.sort(function(ee,ge){return e.rcompare(ee,ge,K)})},e.gt=N,e.lt=C,e.eq=x,e.neq=G,e.gte=te,e.lte=ae,e.cmp=le,e.Comparator=pe;var ye={};function fe(H,K){if(H instanceof fe)return H.loose===K?H:new fe(H.raw,K);if(H instanceof pe)return new fe(H.value,K);if(!(this instanceof fe))return new fe(H,K);if(this.loose=K,this.raw=H,this.set=H.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+H);this.format()}function me(H){return!H||H.toLowerCase()==="x"||H==="*"}function de(H,K,ee,ge,ve,De,Pe,Le,Oe,Ae,Me,je,Ne){return((K=me(ee)?"":me(ge)?">="+ee+".0.0":me(ve)?">="+ee+"."+ge+".0":">="+K)+" "+(Le=me(Oe)?"":me(Ae)?"<"+(+Oe+1)+".0.0":me(Me)?"<"+Oe+"."+(+Ae+1)+".0":je?"<="+Oe+"."+Ae+"."+Me+"-"+je:"<="+Le)).trim()}function we(H,K){for(var ee=0;ee<H.length;ee++)if(!H[ee].test(K))return!1;if(K.prerelease.length){for(ee=0;ee<H.length;ee++)if(k(H[ee].semver),H[ee].semver!==ye&&H[ee].semver.prerelease.length>0){var ge=H[ee].semver;if(ge.major===K.major&&ge.minor===K.minor&&ge.patch===K.patch)return!0}return!1}return!0}function Ee(H,K,ee){try{K=new fe(K,ee)}catch{return!1}return K.test(H)}function ke(H,K,ee,ge){var ve,De,Pe,Le,Oe;switch(H=new M(H,ge),K=new fe(K,ge),ee){case">":ve=N,De=ae,Pe=C,Le=">",Oe=">=";break;case"<":ve=C,De=te,Pe=N,Le="<",Oe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ee(H,K,ge))return!1;for(var Ae=0;Ae<K.set.length;++Ae){var Me=K.set[Ae],je=null,Ne=null;if(Me.forEach(function(ze){ze.semver===ye&&(ze=new pe(">=0.0.0")),je=je||ze,Ne=Ne||ze,ve(ze.semver,je.semver,ge)?je=ze:Pe(ze.semver,Ne.semver,ge)&&(Ne=ze)}),je.operator===Le||je.operator===Oe||(!Ne.operator||Ne.operator===Le)&&De(H,Ne.semver)||Ne.operator===Oe&&Pe(H,Ne.semver))return!1}return!0}pe.prototype.parse=function(H){var K=this.loose?E[B]:E[Z],ee=H.match(K);if(!ee)throw new TypeError("Invalid comparator: "+H);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new M(ee[2],this.loose):this.semver=ye},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(H){return k("Comparator.test",H,this.loose),this.semver===ye||(typeof H=="string"&&(H=new M(H,this.loose)),le(H,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(H,K){if(!(H instanceof pe))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new fe(H.value,K),Ee(this.value,ee,K);if(H.operator==="")return ee=new fe(this.value,K),Ee(H.semver,ee,K);var ge=!(this.operator!==">="&&this.operator!==">"||H.operator!==">="&&H.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||H.operator!=="<="&&H.operator!=="<"),De=this.semver.version===H.semver.version,Pe=!(this.operator!==">="&&this.operator!=="<="||H.operator!==">="&&H.operator!=="<="),Le=le(this.semver,"<",H.semver,K)&&(this.operator===">="||this.operator===">")&&(H.operator==="<="||H.operator==="<"),Oe=le(this.semver,">",H.semver,K)&&(this.operator==="<="||this.operator==="<")&&(H.operator===">="||H.operator===">");return ge||ve||De&&Pe||Le||Oe},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(H){return H.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(H){var K=this.loose;H=H.trim(),k("range",H,K);var ee=K?E[W]:E[T];H=H.replace(ee,de),k("hyphen replace",H),H=H.replace(E[q],"$1$2$3"),k("comparator trim",H,E[q]),H=(H=(H=H.replace(E[V],"$1~")).replace(E[ue],"$1^")).split(/\s+/).join(" ");var ge=K?E[B]:E[Z],ve=H.split(" ").map(function(De){return function(Pe,Le){return k("comp",Pe),Pe=function(Oe,Ae){return Oe.trim().split(/\s+/).map(function(Me){return function(je,Ne){k("caret",je,Ne);var ze=Ne?E[ce]:E[he];return je.replace(ze,function(Fe,be,Se,Ie,Re){var Ue;return k("caret",je,Fe,be,Se,Ie,Re),me(be)?Ue="":me(Se)?Ue=">="+be+".0.0 <"+(+be+1)+".0.0":me(Ie)?Ue=be==="0"?">="+be+"."+Se+".0 <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+".0 <"+(+be+1)+".0.0":Re?(k("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Ue=be==="0"?Se==="0"?">="+be+"."+Se+"."+Ie+Re+" <"+be+"."+Se+"."+(+Ie+1):">="+be+"."+Se+"."+Ie+Re+" <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+"."+Ie+Re+" <"+(+be+1)+".0.0"):(k("no pr"),Ue=be==="0"?Se==="0"?">="+be+"."+Se+"."+Ie+" <"+be+"."+Se+"."+(+Ie+1):">="+be+"."+Se+"."+Ie+" <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+"."+Ie+" <"+(+be+1)+".0.0"),k("caret return",Ue),Ue})}(Me,Ae)}).join(" ")}(Pe,Le),k("caret",Pe),Pe=function(Oe,Ae){return Oe.trim().split(/\s+/).map(function(Me){return function(je,Ne){var ze=Ne?E[se]:E[X];return je.replace(ze,function(Fe,be,Se,Ie,Re){var Ue;return k("tilde",je,Fe,be,Se,Ie,Re),me(be)?Ue="":me(Se)?Ue=">="+be+".0.0 <"+(+be+1)+".0.0":me(Ie)?Ue=">="+be+"."+Se+".0 <"+be+"."+(+Se+1)+".0":Re?(k("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Ue=">="+be+"."+Se+"."+Ie+Re+" <"+be+"."+(+Se+1)+".0"):Ue=">="+be+"."+Se+"."+Ie+" <"+be+"."+(+Se+1)+".0",k("tilde return",Ue),Ue})}(Me,Ae)}).join(" ")}(Pe,Le),k("tildes",Pe),Pe=function(Oe,Ae){return k("replaceXRanges",Oe,Ae),Oe.split(/\s+/).map(function(Me){return function(je,Ne){je=je.trim();var ze=Ne?E[L]:E[I];return je.replace(ze,function(Fe,be,Se,Ie,Re,Ue){k("xRange",je,Fe,be,Se,Ie,Re,Ue);var qe=me(Se),Ce=qe||me(Ie),Te=Ce||me(Re);return be==="="&&Te&&(be=""),qe?Fe=be===">"||be==="<"?"<0.0.0":"*":be&&Te?(Ce&&(Ie=0),Te&&(Re=0),be===">"?(be=">=",Ce?(Se=+Se+1,Ie=0,Re=0):Te&&(Ie=+Ie+1,Re=0)):be==="<="&&(be="<",Ce?Se=+Se+1:Ie=+Ie+1),Fe=be+Se+"."+Ie+"."+Re):Ce?Fe=">="+Se+".0.0 <"+(+Se+1)+".0.0":Te&&(Fe=">="+Se+"."+Ie+".0 <"+Se+"."+(+Ie+1)+".0"),k("xRange return",Fe),Fe})}(Me,Ae)}).join(" ")}(Pe,Le),k("xrange",Pe),Pe=function(Oe,Ae){return k("replaceStars",Oe,Ae),Oe.trim().replace(E[Q],"")}(Pe,Le),k("stars",Pe),Pe}(De,K)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(De){return!!De.match(ge)})),ve=ve.map(function(De){return new pe(De,K)})},fe.prototype.intersects=function(H,K){if(!(H instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(ge){return H.set.some(function(ve){return ve.every(function(De){return ge.intersects(De,K)})})})})},e.toComparators=function(H,K){return new fe(H,K).set.map(function(ee){return ee.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(H){if(!H)return!1;typeof H=="string"&&(H=new M(H,this.loose));for(var K=0;K<this.set.length;K++)if(we(this.set[K],H))return!0;return!1},e.satisfies=Ee,e.maxSatisfying=function(H,K,ee){var ge=null,ve=null;try{var De=new fe(K,ee)}catch{return null}return H.forEach(function(Pe){De.test(Pe)&&(ge&&ve.compare(Pe)!==-1||(ve=new M(ge=Pe,ee)))}),ge},e.minSatisfying=function(H,K,ee){var ge=null,ve=null;try{var De=new fe(K,ee)}catch{return null}return H.forEach(function(Pe){De.test(Pe)&&(ge&&ve.compare(Pe)!==1||(ve=new M(ge=Pe,ee)))}),ge},e.validRange=function(H,K){try{return new fe(H,K).range||"*"}catch{return null}},e.ltr=function(H,K,ee){return ke(H,K,"<",ee)},e.gtr=function(H,K,ee){return ke(H,K,">",ee)},e.outside=ke,e.prerelease=function(H,K){var ee=_(H,K);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(H,K,ee){return H=new fe(H,ee),K=new fe(K,ee),H.intersects(K)},e.coerce=function(H){if(H instanceof M)return H;if(typeof H!="string")return null;var K=H.match(E[z]);return K==null?null:_((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,j(1))},function(J,e){var j,R,k=J.exports={};function A(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function E(m){if(j===setTimeout)return setTimeout(m,0);if((j===A||!j)&&setTimeout)return j=setTimeout,setTimeout(m,0);try{return j(m,0)}catch{try{return j.call(null,m,0)}catch{return j.call(this,m,0)}}}(function(){try{j=typeof setTimeout=="function"?setTimeout:A}catch{j=A}try{R=typeof clearTimeout=="function"?clearTimeout:D}catch{R=D}})();var u,a=[],w=!1,v=-1;function d(){w&&u&&(w=!1,u.length?a=u.concat(a):v=-1,a.length&&$())}function $(){if(!w){var m=E(d);w=!0;for(var c=a.length;c;){for(u=a,a=[];++v<c;)u&&u[v].run();v=-1,c=a.length}u=null,w=!1,function(y){if(R===clearTimeout)return clearTimeout(y);if((R===D||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(y);try{R(y)}catch{try{return R.call(null,y)}catch{return R.call(this,y)}}}(m)}}function b(m,c){this.fun=m,this.array=c}function O(){}k.nextTick=function(m){var c=new Array(arguments.length-1);if(arguments.length>1)for(var y=1;y<arguments.length;y++)c[y-1]=arguments[y];a.push(new b(m,c)),a.length!==1||w||E($)},b.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=O,k.addListener=O,k.once=O,k.off=O,k.removeListener=O,k.removeAllListeners=O,k.emit=O,k.prependListener=O,k.prependOnceListener=O,k.listeners=function(m){return[]},k.binding=function(m){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(m){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ne[76],re([0,1]),function(J,e){"use strict";var j;Object.defineProperty(e,"__esModule",{value:!0}),e.$is=void 0;class R{constructor(E,u,a){this.level=E,this.key=u,this.value=a,this.forward=[]}}const k=void 0;class A{constructor(E,u=2**16){this.comparator=E,this[j]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new R(this.c,k,k)}get size(){return this.f}clear(){this.e=new R(this.c,k,k),this.f=0}has(E){return!!A.g(this,E,this.comparator)}get(E){return A.g(this,E,this.comparator)?.value}set(E,u){return A.h(this,E,u,this.comparator)&&(this.f+=1),this}delete(E){const u=A.k(this,E,this.comparator);return u&&(this.f-=1),u}forEach(E,u){let a=this.e.forward[0];for(;a;)E.call(u,a.value,a.key,this),a=a.forward[0]}[(j=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this.e.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this.e.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this.e.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",u=this.e.forward[0];for(;u;)E+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return E}static g(E,u,a){let w=E.e;for(let v=E.d-1;v>=0;v--)for(;w.forward[v]&&a(w.forward[v].key,u)<0;)w=w.forward[v];if(w=w.forward[0],w&&a(w.key,u)===0)return w}static h(E,u,a,w){const v=[];let d=E.e;for(let $=E.d-1;$>=0;$--){for(;d.forward[$]&&w(d.forward[$].key,u)<0;)d=d.forward[$];v[$]=d}if(d=d.forward[0],d&&w(d.key,u)===0)return d.value=a,!1;{const $=A.j(E);if($>E.d){for(let b=E.d;b<$;b++)v[b]=E.e;E.d=$}d=new R($,u,a);for(let b=0;b<$;b++)d.forward[b]=v[b].forward[b],v[b].forward[b]=d;return!0}}static j(E,u=.5){let a=1;for(;Math.random()<u&&a<E.c;)a+=1;return a}static k(E,u,a){const w=[];let v=E.e;for(let d=E.d-1;d>=0;d--){for(;v.forward[d]&&a(v.forward[d].key,u)<0;)v=v.forward[d];w[d]=v}if(v=v.forward[0],!v||a(v.key,u)!==0)return!1;for(let d=0;d<E.d&&w[d].forward[d]===v;d++)w[d].forward[d]=v.forward[d];for(;E.d>0&&E.e.forward[E.d-1]===k;)E.d-=1;return!0}}e.$is=A}),define(ne[46],re([0,1,8,2]),function(J,e,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=k,e.$ge=A,e.$he=D,e.$ie=E,e.$je=a,e.$ke=w,e.$le=v,e.$me=d,e.$ne=$,e.$oe=b,e.$pe=O,e.$qe=m,e.$re=c,e.$se=y,e.$te=p;function k(h){const g=h;return g?typeof g.read=="function":!1}function A(h){const g=h;return g?[g.on,g.pause,g.resume,g.destroy].every(i=>typeof i=="function"):!1}function D(h){const g=h;return g?A(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}function E(h,g){return new u(h,g)}class u{constructor(g,i){this.e=g,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(i=>i(g))}h(g){this.c.error.length===0?(0,j.$1)(g):this.c.error.slice(0).forEach(i=>i(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,i){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(g,i){if(this.a.destroyed)return;let r;switch(g){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(i);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(h,g){const i=[];let r;for(;(r=h.read())!==null;)i.push(r);return g(i)}function w(h,g,i){const r=[];let t;for(;(t=h.read())!==null&&r.length<i;)r.push(t);return t===null&&r.length>0?g(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const n=t;return t=void 0,n}return h.read()}}}function v(h,g){return new Promise((i,r)=>{const t=[];d(h,{onData:n=>{g&&t.push(n)},onError:n=>{g?r(n):i(void 0)},onEnd:()=>{i(g?g(t):void 0)}})})}function d(h,g,i){h.on("error",r=>{i?.isCancellationRequested||g.onError(r)}),h.on("end",()=>{i?.isCancellationRequested||g.onEnd()}),h.on("data",r=>{i?.isCancellationRequested||g.onData(r)})}function $(h,g){return new Promise((i,r)=>{const t=new R.$Tc,n=[],s=P=>{if(n.push(P),n.length>g)return t.dispose(),h.pause(),i({stream:h,buffer:n,ended:!1})},o=P=>(t.dispose(),r(P)),l=()=>(t.dispose(),i({stream:h,buffer:n,ended:!0}));t.add((0,R.$Sc)(()=>h.removeListener("error",o))),h.on("error",o),t.add((0,R.$Sc)(()=>h.removeListener("end",l))),h.on("end",l),t.add((0,R.$Sc)(()=>h.removeListener("data",s))),h.on("data",s)})}function b(h,g){const i=E(g);return i.end(h),i}function O(){const h=E(()=>{throw new Error("not supported")});return h.end(),h}function m(h){let g=!1;return{read:()=>g?null:(g=!0,h)}}function c(h,g,i){const r=E(i);return d(h,{onData:t=>r.write(g.data(t)),onError:t=>r.error(g.error?g.error(t):t),onEnd:()=>r.end()}),r}function y(h,g,i){let r=!1;return{read:()=>{const t=g.read();return r?t:(r=!0,t!==null?i([h,t]):h)}}}function p(h,g,i){let r=!1;const t=E(i);return d(g,{onData:n=>r?t.write(n):(r=!0,t.write(i([h,n]))),onError:n=>t.error(n),onEnd:()=>{r||(r=!0,t.write(h)),t.end()}}),t}}),define(ne[14],re([0,1,169,46]),function(J,e,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=void 0,e.$ve=a,e.$we=w,e.$xe=v,e.$ye=d,e.$ze=$,e.$Ae=b,e.$Be=O,e.$Ce=m,e.$De=c,e.$Ee=y,e.$Fe=p,e.$Ge=h,e.$He=g,e.$Ie=i,e.$Je=r,e.$Ke=t,e.$Le=n,e.$Me=s,e.$Ne=o,e.$Oe=I;const k=typeof Buffer<"u",A=new j.$V(()=>new Uint8Array(256));let D,E;class u{static alloc(z){return k?new u(Buffer.allocUnsafe(z)):new u(new Uint8Array(z))}static wrap(z){return k&&!Buffer.isBuffer(z)&&(z=Buffer.from(z.buffer,z.byteOffset,z.byteLength)),new u(z)}static fromString(z,U){return!(U?.dontUseNodeBuffer||!1)&&k?new u(Buffer.from(z)):(D||(D=new TextEncoder),new u(D.encode(z)))}static fromByteArray(z){const U=u.alloc(z.length);for(let V=0,X=z.length;V<X;V++)U.buffer[V]=z[V];return U}static concat(z,U){if(typeof U>"u"){U=0;for(let se=0,ie=z.length;se<ie;se++)U+=z[se].byteLength}const V=u.alloc(U);let X=0;for(let se=0,ie=z.length;se<ie;se++){const ue=z[se];V.set(ue,X),X+=ue.byteLength}return V}constructor(z){this.buffer=z,this.byteLength=this.buffer.byteLength}clone(){const z=u.alloc(this.byteLength);return z.set(this),z}toString(){return k?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice(z,U){return new u(this.buffer.subarray(z,U))}set(z,U){if(z instanceof u)this.buffer.set(z.buffer,U);else if(z instanceof Uint8Array)this.buffer.set(z,U);else if(z instanceof ArrayBuffer)this.buffer.set(new Uint8Array(z),U);else if(ArrayBuffer.isView(z))this.buffer.set(new Uint8Array(z.buffer,z.byteOffset,z.byteLength),U);else throw new Error("Unknown argument 'array'")}readUInt32BE(z){return d(this.buffer,z)}writeUInt32BE(z,U){$(this.buffer,z,U)}readUInt32LE(z){return b(this.buffer,z)}writeUInt32LE(z,U){O(this.buffer,z,U)}readUInt8(z){return m(this.buffer,z)}writeUInt8(z,U){c(this.buffer,z,U)}indexOf(z,U=0){return a(this.buffer,z instanceof u?z.buffer:z,U)}}e.$ue=u;function a(L,z,U=0){const V=z.byteLength,X=L.byteLength;if(V===0)return 0;if(V===1)return L.indexOf(z[0]);if(V>X-U)return-1;const se=A.value;se.fill(z.length);for(let ce=0;ce<z.length;ce++)se[z[ce]]=z.length-ce-1;let ie=U+z.length-1,ue=ie,he=-1;for(;ie<X;)if(L[ie]===z[ue]){if(ue===0){he=ie;break}ie--,ue--}else ie+=Math.max(z.length-ue,se[L[ie]]),ue=z.length-1;return he}function w(L,z){return L[z+0]<<0>>>0|L[z+1]<<8>>>0}function v(L,z,U){L[U+0]=z&255,z=z>>>8,L[U+1]=z&255}function d(L,z){return L[z]*2**24+L[z+1]*2**16+L[z+2]*2**8+L[z+3]}function $(L,z,U){L[U+3]=z,z=z>>>8,L[U+2]=z,z=z>>>8,L[U+1]=z,z=z>>>8,L[U]=z}function b(L,z){return L[z+0]<<0>>>0|L[z+1]<<8>>>0|L[z+2]<<16>>>0|L[z+3]<<24>>>0}function O(L,z,U){L[U+0]=z&255,z=z>>>8,L[U+1]=z&255,z=z>>>8,L[U+2]=z&255,z=z>>>8,L[U+3]=z&255}function m(L,z){return L[z]}function c(L,z,U){L[U]=z}function y(L){return R.$je(L,z=>u.concat(z))}function p(L){return R.$qe(L)}function h(L){return R.$le(L,z=>u.concat(z))}async function g(L){return L.ended?u.concat(L.buffer):u.concat([...L.buffer,await h(L.stream)])}function i(L){return R.$oe(L,z=>u.concat(z))}function r(L){return R.$re(L,{data:z=>typeof z=="string"?u.fromString(z):u.wrap(z)},z=>u.concat(z))}function t(L){return R.$ie(z=>u.concat(z),L)}function n(L,z){return R.$se(L,z,U=>u.concat(U))}function s(L,z){return R.$te(L,z,U=>u.concat(U))}function o(L){let z=0,U=0,V=0;const X=new Uint8Array(Math.floor(L.length/4*3)),se=ue=>{switch(U){case 3:X[V++]=z|ue,U=0;break;case 2:X[V++]=z|ue>>>2,z=ue<<6,U=3;break;case 1:X[V++]=z|ue>>>4,z=ue<<4,U=2;break;default:z=ue<<2,U=1}};for(let ue=0;ue<L.length;ue++){const he=L.charCodeAt(ue);if(he>=65&&he<=90)se(he-65);else if(he>=97&&he<=122)se(he-97+26);else if(he>=48&&he<=57)se(he-48+52);else if(he===43||he===45)se(62);else if(he===47||he===95)se(63);else{if(he===61)break;throw new SyntaxError(`Unexpected base64 character ${L[ue]}`)}}const ie=V;for(;U>0;)se(0);return u.wrap(X).slice(0,ie)}const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:L},z=!0,U=!1){const V=U?P:l;let X="";const se=L.byteLength%3;let ie=0;for(;ie<L.byteLength-se;ie+=3){const ue=L[ie+0],he=L[ie+1],ce=L[ie+2];X+=V[ue>>>2],X+=V[(ue<<4|he>>>4)&63],X+=V[(he<<2|ce>>>6)&63],X+=V[ce&63]}if(se===1){const ue=L[ie+0];X+=V[ue>>>2],X+=V[ue<<4&63],z&&(X+="==")}else if(se===2){const ue=L[ie+0],he=L[ie+1];X+=V[ue>>>2],X+=V[(ue<<4|he>>>4)&63],X+=V[he<<2&63],z&&(X+="=")}return X}}),define(ne[43],re([0,1,30]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.$aj=void 0,e.$9i=R,e.$0i=k,e.$$i=A,e.$_i=E,e.$bj=O;function R(c){return k(c,0)}function k(c,y){switch(typeof c){case"object":return c===null?A(349,y):Array.isArray(c)?u(c,y):a(c,y);case"string":return E(c,y);case"boolean":return D(c,y);case"number":return A(c,y);case"undefined":return A(937,y);default:return A(617,y)}}function A(c,y){return(y<<5)-y+c|0}function D(c,y){return A(c?433:863,y)}function E(c,y){y=A(149417,y);for(let p=0,h=c.length;p<h;p++)y=A(c.charCodeAt(p),y);return y}function u(c,y){return y=A(104579,y),c.reduce((p,h)=>k(h,p),y)}function a(c,y){return y=A(181387,y),Object.keys(c).sort().reduce((p,h)=>(p=E(h,p),k(c[h],p)),y)}class w{constructor(){this.g=0}get value(){return this.g}hash(y){return this.g=k(y,this.g),this.g}}e.$aj=w;var v;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function d(c,y,p=32){const h=p-y,g=~((1<<h)-1);return(c<<y|(g&c)>>>h)>>>0}function $(c,y=0,p=c.byteLength,h=0){for(let g=0;g<p;g++)c[y+g]=h}function b(c,y,p="0"){for(;c.length<y;)c=p+c;return c}function O(c,y=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(p=>p.toString(16).padStart(2,"0")).join(""):b((c>>>0).toString(16),y/4)}class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(y){const p=y.length;if(p===0)return;const h=this.p;let g=this.r,i=this.u,r,t;for(i!==0?(r=i,t=-1,i=0):(r=y.charCodeAt(0),t=0);;){let n=r;if(j.$pf(r))if(t+1<p){const s=y.charCodeAt(t+1);j.$qf(s)?(t++,n=j.$rf(r,s)):n=65533}else{i=r;break}else j.$qf(r)&&(n=65533);if(g=this.w(h,g,n),t++,t<p)r=y.charCodeAt(t);else break}this.r=g,this.u=i}w(y,p,h){return h<128?y[p++]=h:h<2048?(y[p++]=192|(h&1984)>>>6,y[p++]=128|(h&63)>>>0):h<65536?(y[p++]=224|(h&61440)>>>12,y[p++]=128|(h&4032)>>>6,y[p++]=128|(h&63)>>>0):(y[p++]=240|(h&1835008)>>>18,y[p++]=128|(h&258048)>>>12,y[p++]=128|(h&4032)>>>6,y[p++]=128|(h&63)>>>0),p>=64&&(this.y(),p-=64,this.t+=64,y[0]=y[64],y[1]=y[65],y[2]=y[66]),p}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),O(this.h)+O(this.l)+O(this.m)+O(this.n)+O(this.o)}x(){this.p[this.r++]=128,$(this.p,this.r),this.r>56&&(this.y(),$(this.p));const y=8*this.t;this.q.setUint32(56,Math.floor(y/4294967296),!1),this.q.setUint32(60,y%4294967296,!1),this.y()}y(){const y=m.g,p=this.q;for(let l=0;l<64;l+=4)y.setUint32(l,p.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)y.setUint32(l,d(y.getUint32(l-12,!1)^y.getUint32(l-32,!1)^y.getUint32(l-56,!1)^y.getUint32(l-64,!1),1),!1);let h=this.h,g=this.l,i=this.m,r=this.n,t=this.o,n,s,o;for(let l=0;l<80;l++)l<20?(n=g&i|~g&r,s=1518500249):l<40?(n=g^i^r,s=1859775393):l<60?(n=g&i|g&r|i&r,s=2400959708):(n=g^i^r,s=3395469782),o=d(h,5)+n+t+s+y.getUint32(l*4,!1)&4294967295,t=r,r=i,i=d(g,30),g=h,h=o;this.h=this.h+h&4294967295,this.l=this.l+g&4294967295,this.m=this.m+i&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}e.$cj=m}),define(ne[55],re([0,1,30]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(R||(R={})),function(k){const A="error",D="warning",E="warn",u="info",a="ignore";function w(d){return d?j.$lf(A,d)?k.Error:j.$lf(D,d)||j.$lf(E,d)?k.Warning:j.$lf(u,d)?k.Info:k.Ignore:k.Ignore}k.fromValue=w;function v(d){switch(d){case k.Error:return A;case k.Warning:return D;case k.Info:return u;default:return a}}k.toString=v}(R||(R={})),e.default=R}),define(ne[27],re([0,1,3]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=R,e.$Pn=k,e.$Qn=D,e.$Rn=u,e.$Sn=a,e.$Tn=w,e.$Un=v,e.$Vn=d,e.$Wn=$,e.$Xn=b,e.$Yn=O,e.$Zn=m;function R(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const y=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([p,h])=>{y[p]=h&&typeof h=="object"?R(h):h}),y}function k(c){if(!c||typeof c!="object")return c;const y=[c];for(;y.length>0;){const p=y.shift();Object.freeze(p);for(const h in p)if(A.call(p,h)){const g=p[h];typeof g=="object"&&!Object.isFrozen(g)&&!(0,j.$Yf)(g)&&y.push(g)}}return c}const A=Object.prototype.hasOwnProperty;function D(c,y){return E(c,y,new Set)}function E(c,y,p){if((0,j.$5f)(c))return c;const h=y(c);if(typeof h<"u")return h;if(Array.isArray(c)){const g=[];for(const i of c)g.push(E(i,y,p));return g}if((0,j.$Xf)(c)){if(p.has(c))throw new Error("Cannot clone recursive data-structure");p.add(c);const g={};for(const i in c)A.call(c,i)&&(g[i]=E(c[i],y,p));return p.delete(c),g}return c}function u(c,y,p=!0){return(0,j.$Xf)(c)?((0,j.$Xf)(y)&&Object.keys(y).forEach(h=>{h in c?p&&((0,j.$Xf)(c[h])&&(0,j.$Xf)(y[h])?u(c[h],y[h],p):c[h]=y[h]):c[h]=y[h]}),c):y}function a(c,y){if(c===y)return!0;if(c==null||y===null||y===void 0||typeof c!=typeof y||typeof c!="object"||Array.isArray(c)!==Array.isArray(y))return!1;let p,h;if(Array.isArray(c)){if(c.length!==y.length)return!1;for(p=0;p<c.length;p++)if(!a(c[p],y[p]))return!1}else{const g=[];for(h in c)g.push(h);g.sort();const i=[];for(h in y)i.push(h);if(i.sort(),!a(g,i))return!1;for(p=0;p<g.length;p++)if(!a(c[g[p]],y[g[p]]))return!1}return!0}function w(c){const y=new Set;return JSON.stringify(c,(p,h)=>{if((0,j.$Xf)(h)||Array.isArray(h)){if(y.has(h))return"[Circular]";y.add(h)}return h})}function v(c,y){const p=Object.create(null);return!c||!y||Object.keys(y).forEach(g=>{const i=c[g],r=y[g];a(i,r)||(p[g]=r)}),p}function d(c,y){const p=y.toLowerCase(),h=Object.keys(c).find(g=>g.toLowerCase()===p);return h?c[h]:c[y]}function $(c,y){const p=Object.create(null);for(const[h,g]of Object.entries(c))y(h,g)&&(p[h]=g);return p}function b(c){let y=[];for(;Object.prototype!==c;)y=y.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return y}function O(c){const y=[];for(const p of b(c))typeof c[p]=="function"&&y.push(p);return y}function m(c,y){const p=g=>function(){const i=Array.prototype.slice.call(arguments,0);return y(g,i)},h={};for(const g of c)h[g]=p(g);return h}}),define(ne[28],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=void 0,e.$Dg=R;const j=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(k){return j.test(k)}e.$Eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(E){for(let u=0;u<E.length;u++)E[u]=Math.floor(Math.random()*256);return E};const A=new Uint8Array(16),D=[];for(let E=0;E<256;E++)D.push(E.toString(16).padStart(2,"0"));return function(){k(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let u=0,a="";return a+=D[A[u++]],a+=D[A[u++]],a+=D[A[u++]],a+=D[A[u++]],a+="-",a+=D[A[u++]],a+=D[A[u++]],a+="-",a+=D[A[u++]],a+=D[A[u++]],a+="-",a+=D[A[u++]],a+=D[A[u++]],a+="-",a+=D[A[u++]],a+=D[A[u++]],a+=D[A[u++]],a+=D[A[u++]],a+=D[A[u++]],a+=D[A[u++]],a}}()}),define(ne[77],re([0,1,33]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=A;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(D){const E=D.replace(/\-/g,":").toLowerCase();return!R.has(E)}function A(){const D=(0,j.networkInterfaces)();for(const E in D){const u=D[E];if(u){for(const{mac:a}of u)if(k(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ne[78],re([7,4]),function(J,e){return J.create("vs/base/common/date",e)}),define(ne[79],re([0,1,78]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=a,e.$Om=w,e.$Pm=v;const R=60,k=R*60,A=k*24,D=A*7,E=A*30,u=A*365;function a(d,$,b,O){typeof d!="number"&&(d=d.getTime());const m=Math.round((new Date().getTime()-d)/1e3);if(m<-30)return(0,j.localize)(0,null,a(new Date().getTime()+m*1e3,!1));if(!O&&m<30)return(0,j.localize)(1,null);let c;return m<R?(c=m,$?c===1?b?(0,j.localize)(2,null,c):(0,j.localize)(3,null,c):b?(0,j.localize)(4,null,c):(0,j.localize)(5,null,c):c===1?b?(0,j.localize)(6,null,c):(0,j.localize)(7,null,c):b?(0,j.localize)(8,null,c):(0,j.localize)(9,null,c)):m<k?(c=Math.floor(m/R),$?c===1?b?(0,j.localize)(10,null,c):(0,j.localize)(11,null,c):b?(0,j.localize)(12,null,c):(0,j.localize)(13,null,c):c===1?b?(0,j.localize)(14,null,c):(0,j.localize)(15,null,c):b?(0,j.localize)(16,null,c):(0,j.localize)(17,null,c)):m<A?(c=Math.floor(m/k),$?c===1?b?(0,j.localize)(18,null,c):(0,j.localize)(19,null,c):b?(0,j.localize)(20,null,c):(0,j.localize)(21,null,c):c===1?b?(0,j.localize)(22,null,c):(0,j.localize)(23,null,c):b?(0,j.localize)(24,null,c):(0,j.localize)(25,null,c)):m<D?(c=Math.floor(m/A),$?c===1?(0,j.localize)(26,null,c):(0,j.localize)(27,null,c):c===1?(0,j.localize)(28,null,c):(0,j.localize)(29,null,c)):m<E?(c=Math.floor(m/D),$?c===1?b?(0,j.localize)(30,null,c):(0,j.localize)(31,null,c):b?(0,j.localize)(32,null,c):(0,j.localize)(33,null,c):c===1?b?(0,j.localize)(34,null,c):(0,j.localize)(35,null,c):b?(0,j.localize)(36,null,c):(0,j.localize)(37,null,c)):m<u?(c=Math.floor(m/E),$?c===1?b?(0,j.localize)(38,null,c):(0,j.localize)(39,null,c):b?(0,j.localize)(40,null,c):(0,j.localize)(41,null,c):c===1?b?(0,j.localize)(42,null,c):(0,j.localize)(43,null,c):b?(0,j.localize)(44,null,c):(0,j.localize)(45,null,c)):(c=Math.floor(m/u),$?c===1?b?(0,j.localize)(46,null,c):(0,j.localize)(47,null,c):b?(0,j.localize)(48,null,c):(0,j.localize)(49,null,c):c===1?b?(0,j.localize)(50,null,c):(0,j.localize)(51,null,c):b?(0,j.localize)(52,null,c):(0,j.localize)(53,null,c))}function w(d,$){const b=Math.abs(d/1e3);return b<1?$?(0,j.localize)(54,null,d):(0,j.localize)(55,null,d):b<R?$?(0,j.localize)(56,null,Math.round(d)/1e3):(0,j.localize)(57,null,Math.round(d)/1e3):b<k?$?(0,j.localize)(58,null,Math.round(d/(1e3*R))):(0,j.localize)(59,null,Math.round(d/(1e3*R))):b<A?$?(0,j.localize)(60,null,Math.round(d/(1e3*k))):(0,j.localize)(61,null,Math.round(d/(1e3*k))):(0,j.localize)(62,null,Math.round(d/(1e3*A)))}function v(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ne[80],re([7,4]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ne[34],re([0,1,19,3,80]),function(J,e,j,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6i=u,e.$7i=a,e.$8i=w;function A(v,d){return d&&(v.stack||v.stacktrace)?k.localize(0,null,E(v),D(v.stack)||D(v.stacktrace)):E(v)}function D(v){return Array.isArray(v)?v.join(`
`):v}function E(v){return v.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${v.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?k.localize(1,null,v.message):v.message||k.localize(2,null)}function u(v=null,d=!1){if(!v)return k.localize(3,null);if(Array.isArray(v)){const $=j.$Hb(v),b=u($[0],d);return $.length>1?k.localize(4,null,b,$.length):b}if(R.$Vf(v))return v;if(v.detail){const $=v.detail;if($.error)return A($.error,d);if($.exception)return A($.exception,d)}return v.stack?A(v,d):v.message?v.message:k.localize(5,null)}function a(v){const d=v;return d instanceof Error&&Array.isArray(d.actions)}function w(v,d){let $;return typeof v=="string"?$=new Error(v):$=v,$.actions=d,$}}),define(ne[81],re([7,4]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(ne[82],re([0,1,81]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=R;function R(k){switch(k){case 1:return(0,j.localize)(0,null);case 2:return(0,j.localize)(1,null);case 3:return(0,j.localize)(2,null);case 4:return(0,j.localize)(3,null);case 5:return(0,j.localize)(4,null);case 6:return(0,j.localize)(5,null);case 7:return(0,j.localize)(6,null);case 8:return(0,j.localize)(7,null);case 9:return(0,j.localize)(8,null);default:return""}}}),define(ne[56],re([0,1,12]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$$l=A,e.$_l=D;var R;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(R||(e.Source=R={}));var k;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(k||(e.TerminateResponseCode=k={}));function A(E,...u){const a=u.reduce((d,$)=>(d[$]=!0,d),{}),w=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(d=>!a[d]).forEach(d=>{for(let $=0;$<w.length;$++)if(d.search(w[$])!==-1){delete E[d];break}})}function D(E){E&&(delete E.DEBUG,j.$j&&delete E.DYLD_LIBRARY_PATH,j.$k&&delete E.LD_PRELOAD)}}),define(ne[83],re([0,1,11]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=R,e.$Gq=k,e.$Hq=A,e.log=E;function R(a){const w=a;return w&&typeof w.type=="string"&&typeof w.severity=="string"}function k(a){const w=[];let v;try{const d=JSON.parse(a.arguments),$=d[d.length-1];$&&$.__$stack&&(d.pop(),v=$.__$stack),w.push(...d)}catch{w.push("Unable to log remote console arguments",a.arguments)}return{args:w,stack:v}}function A(a){if(typeof a!="string")return A(k(a).stack);const w=a;if(w){const v=D(w),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(d&&d.length===4)return{uri:j.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}function D(a){if(!a)return a;const w=a.indexOf(`
`);return w===-1?a:a.substring(0,w)}function E(a,w){const{args:v,stack:d}=k(a),$=typeof v[0]=="string"&&v.length===1;let b=D(d);b&&(b=`(${b.trim()})`);let O=[];if(typeof v[0]=="string"?b&&$?O=[`%c[${w}] %c${v[0]} %c${b}`,u("blue"),u(""),u("grey")]:O=[`%c[${w}] %c${v[0]}`,u("blue"),u(""),...v.slice(1)]:O=[`%c[${w}]%`,u("blue"),...v],b&&!$&&O.push(b),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,O)}function u(a){return`color: ${a}`}}),define(ne[47],re([0,1,14,11]),function(J,e,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=k,e.$Qh=A,e.$Rh=E;function k(u){return JSON.stringify(u,D)}function A(u){let a=JSON.parse(u);return a=E(a),a}function D(u,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function E(u,a=0){if(!u||a>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return R.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof j.$ue||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let w=0;w<u.length;++w)u[w]=E(u[w],a+1);else for(const w in u)Object.hasOwnProperty.call(u,w)&&(u[w]=E(u[w],a+1))}return u}}),define(ne[84],re([0,1,71,15,12,11]),function(J,e,j,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FD=w;class D{constructor(d,$,b){this.id=d,this.dependencies=$,this.callback=b}}class E{static{this.INSTANCE=new E}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(d,$,b)=>{typeof d!="string"&&(b=$,$=d,d=null),(typeof $!="object"||!Array.isArray($))&&(b=$,$=null),this.c.push(new D(d,$,b))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith("vscode-file://vscode-app"))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}})))}async load(d){this.g();const $=await(this.a?this.i(d):this.b?this.h(d):this.j(d));if(!$)throw new Error(`Did not receive a define call from script ${d}`);if(Array.isArray($.dependencies)&&$.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${$.dependencies.join(", ")}`);return typeof $.callback=="function"?$.callback([]):$.callback}h(d){return new Promise(($,b)=>{const O=document.createElement("script");O.setAttribute("async","async"),O.setAttribute("type","text/javascript");const m=()=>{O.removeEventListener("load",c),O.removeEventListener("error",y)},c=p=>{m(),$(this.c.pop())},y=p=>{m(),b(p)};O.addEventListener("load",c),O.addEventListener("error",y),this.f&&(d=this.f.createScriptURL(d)),O.setAttribute("src",d),window.document.getElementsByTagName("head")[0].appendChild(O)})}i(d){return new Promise(($,b)=>{try{this.f&&(d=this.f.createScriptURL(d)),importScripts(d),$(this.c.pop())}catch(O){b(O)}})}async j(d){try{const $=globalThis._VSCODE_NODE_MODULES.fs,b=globalThis._VSCODE_NODE_MODULES.vm,O=globalThis._VSCODE_NODE_MODULES.module,m=A.URI.parse(d).fsPath,c=$.readFileSync(m).toString(),y=O.wrap(c.replace(/^#!.*/,""));return new b.Script(y).runInThisContext().apply(),this.c.pop()}catch($){throw $}}}const u=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function w(v,d,$){if(j.$T){$===void 0&&($=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[v]&&(v=a[v]);const b=`${v}/${d}`;if(u.has(b))return u.get(b);let O;if(/^\w[\w\d+.-]*:\/\//.test(b))O=b;else{const p=`${$&&!k.$o?R.$zg:R.$yg}/${b}`;O=R.$Cg.asBrowserUri(p).toString(!0)}const m=E.INSTANCE.load(O);return u.set(b,m),m}else return await new Promise((b,O)=>{J([v],b,O)})}}),define(ne[85],re([0,1,33,48,28,77,12]),function(J,e,j,R,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=void 0,e.$rn=u,e.$sn=v,e.$qn=new class{c(d){return this.a||(this.a=R.$oi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(d)}value(){if(this.b===void 0){let d=0,$=0;const b=(0,j.networkInterfaces)();for(const O in b){const m=b[O];if(m)for(const{mac:c,internal:y}of m)y||($+=1,this.c(c.toUpperCase())&&(d+=1))}this.b=$>0?d/$:0}return this.b}};let E;async function u(d){return E||(E=(async()=>await a(d)||k.$Eg())()),E}async function a(d){try{const $=await new Promise((O,m)=>{J(["crypto"],O,m)}),b=(0,A.$pn)();return $.createHash("sha256").update(b,"utf8").digest("hex")}catch($){d($);return}}const w="Software\\Microsoft\\SQMClient";async function v(d){if(D.$i){const $=await new Promise((b,O)=>{J(["@vscode/windows-registry"],b,O)});try{return $.GetStringRegKey("HKEY_LOCAL_MACHINE",w,"MachineId")||""}catch(b){return d(b),""}}return""}}),define(ne[86],re([0,1,33,16,24]),function(J,e,j,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=y,e.$0l=p;const A=/^\d+$/,D=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var u;(function(h){h[h.x64=0]="x64",h[h.x86=1]="x86",h[h.ARM=2]="ARM"})(u||(u={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let w;process.env.PROCESSOR_ARCHITEW6432?w=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?w=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?w=1:w=0;class v{constructor(g,i,r){this.exePath=g,this.displayName=i,this.a=r}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function d({useAlternateBitness:h=!1}={}){return h?a===0?process.env["ProgramFiles(x86)"]||null:w===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function $({useAlternateBitness:h=!1,findPreview:g=!1}={}){const i=d({useAlternateBitness:h});if(!i)return null;const r=R.$kc(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(r))return null;let t=-1,n=null;for(const l of await k.Promises.readdir(r)){let P=-1;if(g){const L=l.indexOf("-");if(L<0)continue;const z=l.substring(0,L);if(!A.test(z)||l.substring(L+1)!=="preview")continue;P=parseInt(z,10)}else{if(!A.test(l))continue;P=parseInt(l,10)}if(P<=t)continue;const I=R.$kc(r,l,"pwsh.exe");await k.SymlinkSupport.existsFile(I)&&(n=I,t=P)}if(!n)return null;const s=i.includes("x86")?" (x86)":"",o=g?" Preview":"";return new v(n,`PowerShell${o}${s}`,!0)}async function b({findPreview:h}={}){if(!process.env.LOCALAPPDATA)return null;const g=R.$kc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(g))return null;const{pwshMsixDirRegex:i,pwshMsixName:r}=h?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const t of await k.Promises.readdir(g))if(i.test(t)){const n=R.$kc(g,t,"pwsh.exe");return new v(n,r)}return null}function O(){const h=R.$kc(j.homedir(),".dotnet","tools","pwsh.exe");return new v(h,".NET Core PowerShell Global Tool")}function m(){const h=R.$kc(process.env.windir,a===1&&w!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(h,"Windows PowerShell",!0)}async function*c(){let h=await $();h&&(yield h),h=await $({useAlternateBitness:!0}),h&&(yield h),h=await b(),h&&(yield h),h=O(),h&&(yield h),h=await $({findPreview:!0}),h&&(yield h),h=await b({findPreview:!0}),h&&(yield h),h=await $({useAlternateBitness:!0,findPreview:!0}),h&&(yield h),h=m(),h&&(yield h)}async function*y(){for await(const h of c())await h.exists()&&(yield h)}async function p(){for await(const h of y())return h;return null}}),define(ne[57],re([0,1,16,12,35,56,3,24]),function(J,e,j,R,k,A,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$am=u,e.$bm=a,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function u(v=k.env){return v.comspec||"cmd.exe"}function a(v){let d=[],$=!1;const b=function(O){if($){d.push(O);return}(!v.send(O,c=>{if(c&&console.error(c),$=!1,d.length>0){const y=d.slice(0);d=[],y.forEach(p=>b(p))}})||R.$i)&&($=!0)};return{send:b}}var w;(function(v){async function d($,b,O){if(j.$jc($))return $;if(b===void 0&&(b=k.cwd()),j.$nc($)!=="."||(O===void 0&&D.$Vf(k.env.PATH)&&(O=k.env.PATH.split(j.$uc)),O===void 0||O.length===0))return j.$kc(b,$);async function c(y){if(await E.Promises.exists(y)){let p;try{p=await E.Promises.stat(y)}catch(h){h.message.startsWith("EACCES")&&(p=await E.Promises.lstat(y))}return p?!p.isDirectory():!1}return!1}for(const y of O){let p;if(j.$jc(y)?p=j.$kc(y,$):p=j.$kc(b,y,$),await c(p))return p;let h=p+".com";if(await c(h)||(h=p+".exe",await c(h)))return h}return j.$kc(b,$)}v.findExecutable=d})(w||(e.win32=w={}))}),define(ne[87],re([0,1,33,12,86,57]),function(J,e,j,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cm=D;async function D(v,d){return v===1?R.$i?w():A.$am(d):u(v,d)}let E=null;function u(v,d){if(R.$k&&v===2||R.$j&&v===3)return"/bin/bash";if(!E){let $;if(R.$i)$="/bin/bash";else{if($=d.SHELL,!$)try{$=(0,j.userInfo)().shell}catch{}$||($="sh"),$==="/bin/false"&&($="/bin/bash")}E=$}return E}let a=null;async function w(){return a||(a=(await(0,k.$0l)()).exePath),a}});var $e=this&&this.__decorate||function(J,e,j,R){var k=arguments.length,A=k<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,j):R,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(J,e,j,R);else for(var E=J.length-1;E>=0;E--)(D=J[E])&&(A=(k<3?D(A):k>3?D(e,j,A):D(e,j))||A);return k>3&&A&&Object.defineProperty(e,j,A),A};define(ne[58],re([0,1,19,9,14,20,54,8,5,2,47,30,3]),function(J,e,j,R,k,A,D,E,u,a,w,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.ProxyChannel=e.$3h=e.$Zh=e.$Yh=e.$Xh=e.RequestInitiator=e.$Wh=e.$Th=e.$Sh=void 0,e.$Uh=o,e.$Vh=l,e.$1h=V,e.$2h=X;var $;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})($||($={}));function b(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var O;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(O||(O={}));function m(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(c||(c={}));function y(q){let T=0;for(let W=0;;W+=7){const Q=q.read(1);if(T|=(Q.buffer[0]&127)<<W,!(Q.buffer[0]&128))return T}}const p=t(0);function h(q,T){if(T===0){q.write(p);return}let W=0;for(let Y=T;Y!==0;Y=Y>>>7)W++;const Q=k.$ue.alloc(W);for(let Y=0;T!==0;Y++)Q.buffer[Y]=T&127,T=T>>>7,T>0&&(Q.buffer[Y]|=128);q.write(Q)}class g{constructor(T){this.b=T,this.a=0}read(T){const W=this.b.slice(this.a,this.a+T);return this.a+=W.byteLength,W}}e.$Sh=g;class i{constructor(){this.a=[]}get buffer(){return k.$ue.concat(this.a)}write(T){this.a.push(T)}}e.$Th=i;var r;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(r||(r={}));function t(q){const T=k.$ue.alloc(1);return T.writeUInt8(q,0),T}const n={Undefined:t(r.Undefined),String:t(r.String),Buffer:t(r.Buffer),VSBuffer:t(r.VSBuffer),Array:t(r.Array),Object:t(r.Object),Uint:t(r.Int)},s=typeof Buffer<"u";function o(q,T){if(typeof T>"u")q.write(n.Undefined);else if(typeof T=="string"){const W=k.$ue.fromString(T);q.write(n.String),h(q,W.byteLength),q.write(W)}else if(s&&Buffer.isBuffer(T)){const W=k.$ue.wrap(T);q.write(n.Buffer),h(q,W.byteLength),q.write(W)}else if(T instanceof k.$ue)q.write(n.VSBuffer),h(q,T.byteLength),q.write(T);else if(Array.isArray(T)){q.write(n.Array),h(q,T.length);for(const W of T)o(q,W)}else if(typeof T=="number"&&(T|0)===T)q.write(n.Uint),h(q,T);else{const W=k.$ue.fromString(JSON.stringify(T));q.write(n.Object),h(q,W.byteLength),q.write(W)}}function l(q){switch(q.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return q.read(y(q)).toString();case r.Buffer:return q.read(y(q)).buffer;case r.VSBuffer:return q.read(y(q));case r.Array:{const W=y(q),Q=[];for(let Y=0;Y<W;Y++)Q.push(l(q));return Q}case r.Object:return JSON.parse(q.read(y(q)).toString());case r.Int:return y(q)}}class P{constructor(T,W,Q=null,Y=1e3){this.h=T,this.j=W,this.k=Q,this.l=Y,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(_=>this.q(_)),this.m({type:200})}registerChannel(T,W){this.b.set(T,W),setTimeout(()=>this.w(T),0)}m(T){switch(T.type){case 200:{const W=this.o([T.type]);this.k?.logOutgoing(W,0,1,m(T.type));return}case 201:case 202:case 204:case 203:{const W=this.o([T.type,T.id],T.data);this.k?.logOutgoing(W,T.id,1,m(T.type),T.data);return}}}o(T,W=void 0){const Q=new i;return o(Q,T),o(Q,W),this.p(Q.buffer)}p(T){try{return this.h.send(T),T.byteLength}catch{return 0}}q(T){const W=new g(T),Q=l(W),Y=l(W),_=Q[0];switch(_){case 100:return this.k?.logIncoming(T.byteLength,Q[1],1,`${b(_)}: ${Q[2]}.${Q[3]}`,Y),this.s({type:_,id:Q[1],channelName:Q[2],name:Q[3],arg:Y});case 102:return this.k?.logIncoming(T.byteLength,Q[1],1,`${b(_)}: ${Q[2]}.${Q[3]}`,Y),this.t({type:_,id:Q[1],channelName:Q[2],name:Q[3],arg:Y});case 101:return this.k?.logIncoming(T.byteLength,Q[1],1,`${b(_)}`),this.u({type:_,id:Q[1]});case 103:return this.k?.logIncoming(T.byteLength,Q[1],1,`${b(_)}`),this.u({type:_,id:Q[1]})}}s(T){const W=this.b.get(T.channelName);if(!W){this.v(T);return}const Q=new A.$ee;let Y;try{Y=W.call(this.j,T.name,T.arg,Q.token)}catch(F){Y=Promise.reject(F)}const _=T.id;Y.then(F=>{this.m({id:_,data:F,type:201})},F=>{F instanceof Error?this.m({id:_,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.m({id:_,data:F,type:203})}).finally(()=>{M.dispose(),this.d.delete(T.id)});const M=(0,a.$Sc)(()=>Q.cancel());this.d.set(T.id,M)}t(T){const W=this.b.get(T.channelName);if(!W){this.v(T);return}const Q=T.id,_=W.listen(this.j,T.name,T.arg)(M=>this.m({id:Q,data:M,type:204}));this.d.set(T.id,_)}u(T){const W=this.d.get(T.id);W&&(W.dispose(),this.d.delete(T.id))}v(T){let W=this.g.get(T.channelName);W||(W=[],this.g.set(T.channelName,W));const Q=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.m({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);W.push({request:T,timeoutTimer:Q})}w(T){const W=this.g.get(T);if(W){for(const Q of W)switch(clearTimeout(Q.timeoutTimer),Q.request.type){case 100:this.s(Q.request);break;case 102:this.t(Q.request);break}this.g.delete(T)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Pc)(this.d.values()),this.d.clear()}}e.$Wh=P;var I;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class L{constructor(T,W=null){this.l=T,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$7d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Q=>this.s(Q)),this.j=W}getChannel(T){const W=this;return{call(Q,Y,_){return W.a?Promise.reject(new E.$5):W.m(T,Q,Y,_)},listen(Q,Y){return W.a?u.Event.None:W.o(T,Q,Y)}}}m(T,W,Q,Y=A.CancellationToken.None){const _=this.g++,F={id:_,type:100,channelName:T,name:W,arg:Q};if(Y.isCancellationRequested)return Promise.reject(new E.$5);let f;return new Promise((N,C)=>{if(Y.isCancellationRequested)return C(new E.$5);const x=()=>{const le=pe=>{switch(pe.type){case 201:this.f.delete(_),N(pe.data);break;case 202:{this.f.delete(_);const ye=new Error(pe.data.message);ye.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,ye.name=pe.data.name,C(ye);break}case 203:this.f.delete(_),C(pe.data);break}};this.f.set(_,le),this.p(F)};let G=null;this.b===c.Idle?x():(G=(0,R.$8g)(le=>this.u()),G.then(()=>{G=null,x()}));const te=()=>{G?(G.cancel(),G=null):this.p({id:_,type:101}),C(new E.$5)},ae=Y.onCancellationRequested(te);f=(0,a.$Rc)((0,a.$Sc)(te),ae),this.d.add(f)}).finally(()=>{f.dispose(),this.d.delete(f)})}o(T,W,Q){const Y=this.g++,M={id:Y,type:102,channelName:T,name:W,arg:Q};let F=null;const f=new u.$7d({onWillAddFirstListener:()=>{F=(0,R.$8g)(N=>this.u()),F.then(()=>{F=null,this.d.add(f),this.p(M)})},onDidRemoveLastListener:()=>{F?(F.cancel(),F=null):(this.d.delete(f),this.p({id:Y,type:103}))}}),S=N=>f.fire(N.data);return this.f.set(Y,S),f.event}p(T){switch(T.type){case 100:case 102:{const W=this.q([T.type,T.id,T.channelName,T.name],T.arg);this.j?.logOutgoing(W,T.id,0,`${b(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const W=this.q([T.type,T.id]);this.j?.logOutgoing(W,T.id,0,b(T.type));return}}}q(T,W=void 0){const Q=new i;return o(Q,T),o(Q,W),this.r(Q.buffer)}r(T){try{return this.l.send(T),T.byteLength}catch{return 0}}s(T){const W=new g(T),Q=l(W),Y=l(W),_=Q[0];switch(_){case 200:return this.j?.logIncoming(T.byteLength,0,0,m(_)),this.t({type:Q[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(T.byteLength,Q[1],0,m(_),Y),this.t({type:Q[0],id:Q[1],data:Y})}}t(T){if(T.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(T.id)?.(T)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Pc)(this.d.values()),this.d.clear()}}e.$Xh=L,$e([D.$Mh],L.prototype,"onDidInitializePromise",null);class z{get connections(){const T=[];return this.f.forEach(W=>T.push(W)),T}constructor(T,W,Q){this.a=new Map,this.f=new Set,this.g=new u.$7d,this.onDidAddConnection=this.g.event,this.h=new u.$7d,this.onDidRemoveConnection=this.h.event,this.j=new a.$Tc,this.j.add(T(({protocol:Y,onDidClientDisconnect:_})=>{const M=u.Event.once(Y.onMessage);this.j.add(M(F=>{const f=new g(F),S=l(f),N=new P(Y,S,W,Q),C=new L(Y,W);this.a.forEach((G,te)=>N.registerChannel(te,G));const x={channelServer:N,channelClient:C,ctx:S};this.f.add(x),this.g.fire(x),this.j.add(_(()=>{N.dispose(),C.dispose(),this.f.delete(x),this.h.fire(x)}))}))}))}getChannel(T,W){const Q=this;return{call(Y,_,M){let F;if((0,d.$0f)(W)){const S=(0,j.$4b)(Q.connections.filter(W));F=S?Promise.resolve(S):u.Event.toPromise(u.Event.filter(Q.onDidAddConnection,W))}else F=W.routeCall(Q,Y,_);const f=F.then(S=>S.channelClient.getChannel(T));return V(f).call(Y,_,M)},listen(Y,_){if((0,d.$0f)(W))return Q.k(T,W,Y,_);const M=W.routeEvent(Q,Y,_).then(F=>F.channelClient.getChannel(T));return V(M).listen(Y,_)}}}k(T,W,Q,Y){const _=this;let M;const F=new u.$7d({onWillAddFirstListener:()=>{M=new a.$Tc;const f=new u.$ae,S=new Map,N=x=>{const te=x.channelClient.getChannel(T).listen(Q,Y),ae=f.add(te);S.set(x,ae)},C=x=>{const G=S.get(x);G&&(G.dispose(),S.delete(x))};_.connections.filter(W).forEach(N),u.Event.filter(_.onDidAddConnection,W)(N,void 0,M),_.onDidRemoveConnection(C,void 0,M),f.event(F.fire,F,M),M.add(f)},onDidRemoveLastListener:()=>{M?.dispose(),M=void 0}});return F.event}registerChannel(T,W){this.a.set(T,W);for(const Q of this.f)Q.channelServer.registerChannel(T,W)}dispose(){this.j.dispose();for(const T of this.f)T.channelClient.dispose(),T.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Yh=z;class U{constructor(T,W,Q=null){const Y=new i;o(Y,W),T.send(Y.buffer),this.a=new L(T,Q),this.d=new P(T,W,Q)}getChannel(T){return this.a.getChannel(T)}registerChannel(T,W){this.d.registerChannel(T,W)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Zh=U;function V(q){return{call(T,W,Q){return q.then(Y=>Y.call(T,W,Q))},listen(T,W){const Q=new u.$de;return q.then(Y=>Q.input=Y.listen(T,W)),Q.event}}}function X(q){let T=!1;return{call(W,Q,Y){return T?q.call(W,Q,Y):(0,R.$jh)(0).then(()=>T=!0).then(()=>q.call(W,Q,Y))},listen(W,Q){if(T)return q.listen(W,Q);const Y=new u.$de;return(0,R.$jh)(0).then(()=>T=!0).then(()=>Y.input=q.listen(W,Q)),Y.event}}}class se{constructor(T){this.a=T}routeCall(T){return this.b(T)}routeEvent(T){return this.b(T)}async b(T){for(const W of T.connections)if(await Promise.resolve(this.a(W.ctx)))return Promise.resolve(W);return await u.Event.toPromise(T.onDidAddConnection),await this.b(T)}}e.$3h=se;var ie;(function(q){function T(_,M,F){const f=_,S=F&&F.disableMarshalling,N=new Map;for(const C in f)Q(C)&&N.set(C,u.Event.buffer(f[C],!0,void 0,M));return new class{listen(C,x,G){const te=N.get(x);if(te)return te;const ae=f[x];if(typeof ae=="function"){if(Y(x))return ae.call(f,G);if(Q(x))return N.set(x,u.Event.buffer(f[x],!0,void 0,M)),N.get(x)}throw new E.$bb(`Event not found: ${x}`)}call(C,x,G){const te=f[x];if(typeof te=="function"){if(!S&&Array.isArray(G))for(let le=0;le<G.length;le++)G[le]=(0,w.$Rh)(G[le]);let ae=te.apply(f,G);return ae instanceof Promise||(ae=Promise.resolve(ae)),ae}throw new E.$bb(`Method not found: ${x}`)}}}q.fromService=T;function W(_,M){const F=M&&M.disableMarshalling;return new Proxy({},{get(f,S){if(typeof S=="string")return M?.properties?.has(S)?M.properties.get(S):Y(S)?function(N){return _.listen(S,N)}:Q(S)?_.listen(S):async function(...N){let C;M&&!(0,d.$5f)(M.context)?C=[M.context,...N]:C=N;const x=await _.call(S,C);return F?x:(0,w.$Rh)(x)};throw new E.$bb(`Property not found: ${String(S)}`)}})}q.toService=W;function Q(_){return _[0]==="o"&&_[1]==="n"&&v.$kf(_.charCodeAt(2))}function Y(_){return/^onDynamic/.test(_)&&v.$kf(_.charCodeAt(9))}})(ie||(e.ProxyChannel=ie={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function he(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const T=q.toString();if(T!=="[object Object]")return T}return q}function ce(q){return Array.isArray(q)?q.map(he):he(q)}function B(q,T,W,Q,Y,_,M){M=ce(M);const F=ue[Y],f=F[Q%F.length];let S=[`%c[${q}]%c[${String(T).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(Q).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${f}`];/\($/.test(_)?(S=S.concat(M),S.push(")")):S.push(M),console.log.apply(console,S)}class Z{constructor(T,W){this.d=T,this.f=W,this.a=0,this.b=0}logOutgoing(T,W,Q,Y,_){this.b+=T,B(this.d,this.b,T,W,Q,Y,_)}logIncoming(T,W,Q,Y,_){this.a+=T,B(this.f,this.a,T,W,Q,Y,_)}}e.$4h=Z}),define(ne[88],re([0,1,59,9,14,20,83,8,5,2,27,57,56,58]),function(J,e,j,R,k,A,D,E,u,a,w,v,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Jq=void 0;class b extends $.$Wh{constructor(c){super({send:y=>{try{process.send?.(y.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",y=>k.$ue.wrap(Buffer.from(y,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$Jq=b;class O{constructor(c,y){this.i=c,this.j=y,this.c=new Set,this.g=new Map,this.h=new u.$7d,this.onDidProcessExit=this.h.event;const p=y&&y.timeout?y.timeout:6e4;this.b=new R.$fh(p),this.d=null,this.f=null}getChannel(c){const y=this;return{call(p,h,g){return y.k(c,p,h,g)},listen(p,h){return y.l(c,p,h)}}}k(c,y,p,h=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(E.$6());this.b.cancel();const g=this.n(c),i=(0,R.$8g)(n=>g.call(y,p,n)),r=h.onCancellationRequested(()=>i.cancel()),t=(0,a.$Sc)(()=>i.cancel());return this.c.add(t),i.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(c,y,p){if(!this.b)return u.Event.None;this.b.cancel();let h;const g=new u.$7d({onWillAddFirstListener:()=>{h=this.n(c).listen(y,p)(g.fire,g),this.c.add(h)},onDidRemoveLastListener:()=>{this.c.delete(h),h.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return g.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],y=Object.create(null);y.env={...(0,w.$On)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(y.env={...y.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(y.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(y.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(y.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),y.execArgv===void 0&&(y.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,d.$_l)(y.env),this.d=(0,j.fork)(this.i,c,y);const p=new u.$7d,g=u.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,D.$Fq)(o)){(0,D.log)(o,`IPC Library: ${this.j.serverName}`);return}p.fire(k.$ue.wrap(Buffer.from(o,"base64")))}),i=this.j.useQueue?(0,v.$bm)(this.d):this.d,r=o=>this.d&&this.d.connected&&i.send(o.buffer.toString("base64")),t=p.event,n={send:r,onMessage:t};this.f=new $.$Xh(n);const s=()=>this.o();process.once("exit",s),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,l)=>{process.removeListener("exit",s),g.dispose(),this.c.forEach(P=>(0,a.$Pc)(P)),this.c.clear(),o!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:l})})}return this.f}n(c){let y=this.g.get(c);return y||(y=this.m.getChannel(c),this.g.set(c,y)),y}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Kq=O}),define(ne[89],re([0,1,9,5,2,47,3]),function(J,e,j,R,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Ip=e.StorageState=e.StorageHint=void 0,e.$Hp=u;var E;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(E||(e.StorageHint=E={}));function u(d){const $=d;return $?.changed instanceof Map||$?.deleted instanceof Set}var a;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(a||(e.StorageState=a={}));class w extends k.$Uc{static{this.a=100}constructor($,b=Object.create(null)){super(),this.r=$,this.s=b,this.b=this.B(new R.$0d),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new j.$gh(w.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal($=>this.u($)))}u($){this.b.pause();try{$.changed?.forEach((b,O)=>this.w(O,b)),$.deleted?.forEach(b=>this.w(b,void 0))}finally{this.b.resume()}}w($,b){if(this.c===a.Closed)return;let O=!1;(0,D.$5f)(b)?O=this.f.delete($):this.f.get($)!==b&&(this.f.set($,b),O=!0),O&&this.b.fire({key:$,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get($,b){const O=this.f.get($);return(0,D.$5f)(O)?b:O}getBoolean($,b){const O=this.get($);return(0,D.$5f)(O)?b:O==="true"}getNumber($,b){const O=this.get($);return(0,D.$5f)(O)?b:parseInt(O,10)}getObject($,b){const O=this.get($);return(0,D.$5f)(O)?b:(0,A.$Qh)(O)}async set($,b,O=!1){if(this.c===a.Closed)return;if((0,D.$5f)(b))return this.delete($,O);const m=(0,D.$Xf)(b)||Array.isArray(b)?(0,A.$Ph)(b):String(b);if(this.f.get($)!==m)return this.f.set($,m),this.j.set($,m),this.h.delete($),this.b.fire({key:$,external:O}),this.D()}async delete($,b=!1){if(!(this.c===a.Closed||!this.f.delete($)))return this.h.has($)||this.h.add($),this.j.delete($),this.b.fire({key:$,external:b}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const $={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems($).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush($){if(this.z)return this.D($)}async D($){return this.s.hint===E.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),$)}async whenFlushed(){if(this.z)return new Promise($=>this.n.push($))}isInMemory(){return this.s.hint===E.STORAGE_IN_MEMORY}}e.$Ip=w;class v{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems($){$.insert?.forEach((b,O)=>this.a.set(O,b)),$.delete?.forEach(b=>this.a.delete(b))}async optimize(){}async close(){}}e.$Jp=v}),define(ne[90],re([7,4]),function(J,e){return J.create("vs/base/node/zip",e)}),define(ne[49],re([0,1,60,9,16,3,24,90]),function(J,e,j,R,k,A,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=void 0,e.zip=m,e.$7p=c,e.$8p=p,e.$4p="end of central directory record signature not found";const u=new RegExp(e.$4p);class a extends Error{constructor(g,i){let r=i.message;switch(g){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=g,this.cause=i}}e.$5p=a;function w(h){const g=h.externalFileAttributes>>16||33188;return[448,56,7].map(i=>g&i).reduce((i,r)=>i+r,g&61440)}function v(h){if(h instanceof a)return h;let g;return u.test(h.message)&&(g="CorruptZip"),new a(g,h)}function d(h,g,i,r,t,n){const s=k.$nc(g),o=k.$kc(r,s);if(!o.startsWith(r))return Promise.reject(new Error(E.localize(0,null,g)));const l=k.$kc(r,g);let P;return n.onCancellationRequested(()=>{P?.destroy()}),Promise.resolve(D.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((I,L)=>{if(!n.isCancellationRequested)try{P=(0,j.createWriteStream)(l,{mode:i}),P.once("close",()=>I()),P.once("error",L),h.once("error",L),h.pipe(P)}catch(z){L(z)}}))}function $(h,g,i,r){let t=(0,R.$8g)(()=>Promise.resolve()),n=0;const s=r.onCancellationRequested(()=>{t.cancel(),h.close()});return new Promise((o,l)=>{const P=new R.$dh,I=L=>{L.isCancellationRequested||(n++,h.readEntry())};h.once("error",l),h.once("close",()=>t.then(()=>{r.isCancellationRequested||h.entryCount===n?o():l(new a("Incomplete",new Error(E.localize(1,null,n,h.entryCount))))},l)),h.readEntry(),h.on("entry",L=>{if(r.isCancellationRequested)return;if(!i.sourcePathRegex.test(L.fileName)){I(r);return}const z=L.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(z)){const X=k.$kc(g,z);t=(0,R.$8g)(se=>D.Promises.mkdir(X,{recursive:!0}).then(()=>I(se)).then(void 0,l));return}const U=O(h,L),V=w(L);t=(0,R.$8g)(X=>P.queue(()=>U.then(se=>d(se,z,V,g,i,X).then(()=>I(X)))).then(null,l))})}).finally(()=>s.dispose())}async function b(h,g=!1){const{open:i}=await new Promise((r,t)=>{J(["yauzl"],r,t)});return new Promise((r,t)=>{i(h,g?{lazyEntries:!0}:void 0,(n,s)=>{n?t(v(n)):r((0,A.$7f)(s))})})}function O(h,g){return new Promise((i,r)=>{h.openReadStream(g,(t,n)=>{t?r(v(t)):i((0,A.$7f)(n))})})}async function m(h,g){const{ZipFile:i}=await new Promise((r,t)=>{J(["yazl"],r,t)});return new Promise((r,t)=>{const n=new i;g.forEach(o=>{o.contents?n.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&n.addFile(o.localPath,o.path)}),n.end();const s=(0,j.createWriteStream)(h);n.outputStream.pipe(s),n.outputStream.once("error",t),s.once("error",t),s.once("finish",()=>r(h))})}function c(h,g,i={},r){const t=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let n=b(h,!0);return i.overwrite&&(n=n.then(s=>D.Promises.rm(g).then(()=>s))),n.then(s=>$(s,g,{sourcePathRegex:t},r))}function y(h,g){return b(h).then(i=>new Promise((r,t)=>{i.on("entry",n=>{n.fileName===g&&O(i,n).then(s=>r(s),s=>t(s))}),i.once("close",()=>t(new Error(E.localize(2,null,g))))}))}function p(h,g){return y(h,g).then(i=>new Promise((r,t)=>{const n=[];i.once("error",t),i.on("data",s=>n.push(s)),i.on("end",()=>r(Buffer.concat(n)))}))}}),define(ne[91],re([7,4]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[92],re([7,4]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(ne[93],re([7,4]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(ne[94],re([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[95],re([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[96],re([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ne[97],re([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[98],re([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[99],re([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[100],re([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[101],re([7,4]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[102],re([7,4]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ne[103],re([7,4]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ne[104],re([7,4]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[105],re([7,4]),function(J,e){return J.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[106],re([7,4]),function(J,e){return J.create("vs/platform/log/common/log",e)}),define(ne[107],re([7,4]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ne[108],re([7,4]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(ne[109],re([7,4]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[110],re([7,4]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[111],re([7,4]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(ne[112],re([0,1,8,93]),function(J,e,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dj=e.TokenType=void 0;var k;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(k||(e.TokenType=k={}));function A(...a){switch(a.length){case 1:return(0,R.localize)(0,null,a[0]);case 2:return(0,R.localize)(1,null,a[0],a[1]);case 3:return(0,R.localize)(2,null,a[0],a[1],a[2]);default:return}}const D=(0,R.localize)(3,null),E=(0,R.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(w){switch(w.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return w.isTripleEq?"===":"==";case 4:return w.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return w.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return w.lexeme;case 18:return w.lexeme;case 19:return w.lexeme;case 20:return"EOF";default:throw(0,j.$8)(`unhandled token type: ${JSON.stringify(w)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(w=>w.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(w){return this.c=w,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const v=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:v})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const v=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:v})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(w){return this.r()||this.c.charCodeAt(this.e)!==w?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(w){this.f.push({type:w,offset:this.d})}l(w){const v=this.d,d=this.c.substring(this.d,this.e),$={type:19,offset:this.d,lexeme:d};this.g.push({offset:v,lexeme:d,additionalInfo:w}),this.f.push($)}n(){this.m.lastIndex=this.d;const w=this.m.exec(this.c);if(w){this.e=this.d+w[0].length;const v=this.c.substring(this.d,this.e),d=u.b.get(v);d?this.k(d):this.f.push({type:17,lexeme:v,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(D);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let w=this.e,v=!1,d=!1;for(;;){if(w>=this.c.length){this.e=w,this.l(E);return}const b=this.c.charCodeAt(w);if(v)v=!1;else if(b===47&&!d){w++;break}else b===91?d=!0:b===92?v=!0:b===93&&(d=!1);w++}for(;w<this.c.length&&u.a.has(this.c.charCodeAt(w));)w++;this.e=w;const $=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:$,offset:this.d})}r(){return this.e>=this.c.length}}e.$dj=u}),define(ne[113],re([0,1,79,54,15,16,35,17,11]),function(J,e,j,R,k,A,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=e.$Qm=void 0,e.$Sm=w,e.$Tm=v,e.$Qm=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,A.$nc)(k.$Cg.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,A.$kc)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,E.$Vg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:k.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,E.$Vg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const $=(0,j.$Pm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$kc)(this.userDataPath,"logs",$)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.$Vg)(u.URI.file((0,A.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.$Vg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.$Vg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.$Vg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const $=D.env.VSCODE_PORTABLE;return $?u.URI.file((0,A.$kc)($,"argv.json")):(0,E.$Vg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,A.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const $=this.args["builtin-extensions-dir"];return $?(0,A.$lc)($):(0,A.$ic)((0,A.$kc)(k.$Cg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const $=this.args["extensions-download-dir"];return $?u.URI.file((0,A.$lc)($)):u.URI.file((0,A.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const $=this.args["extensions-dir"];if($)return(0,A.$lc)($);const b=D.env.VSCODE_EXTENSIONS;if(b)return b;const O=D.env.VSCODE_PORTABLE;return O?(0,A.$kc)(O,"extensions"):(0,E.$Vg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const $=this.args.extensionDevelopmentPath;if(Array.isArray($))return $.map(b=>/^[^:/?#]+?:\/\//.test(b)?u.URI.parse(b):u.URI.file((0,A.$ic)(b)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map($=>$==="ui"||$==="workspace"||$==="web"?$:"workspace")}get extensionTestsLocationURI(){const $=this.args.extensionTestsPath;if($)return/^[^:/?#]+?:\/\//.test($)?u.URI.parse($):u.URI.file((0,A.$ic)($))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const $=this.args["disable-extension"];if($){if(typeof $=="string")return[$];if(Array.isArray($)&&$.length>0)return $}return!1}get debugExtensionHost(){return w(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find($=>!e.$Qm.test($))}get extensionLogLevel(){const $=[];for(const b of this.args.log||[]){const O=e.$Qm.exec(b);O&&O[1]&&O[2]&&$.push([O[1],O[2]])}return $.length?$:void 0}get serviceMachineIdResource(){return(0,E.$Vg)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const $=D.env.VSCODE_PORTABLE;return $?u.URI.file((0,A.$kc)($,"policy.json")):(0,E.$Vg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn($){this.args.continueOn=$}get args(){return this.a}constructor($,b,O){this.a=$,this.b=b,this.c=O,this.editSessionId=this.args.editSessionId}}e.$Rm=a,$e([R.$Mh],a.prototype,"appRoot",null),$e([R.$Mh],a.prototype,"userHome",null),$e([R.$Mh],a.prototype,"userDataPath",null),$e([R.$Mh],a.prototype,"appSettingsHome",null),$e([R.$Mh],a.prototype,"tmpDir",null),$e([R.$Mh],a.prototype,"cacheHome",null),$e([R.$Mh],a.prototype,"stateResource",null),$e([R.$Mh],a.prototype,"userRoamingDataHome",null),$e([R.$Mh],a.prototype,"userDataSyncHome",null),$e([R.$Mh],a.prototype,"sync",null),$e([R.$Mh],a.prototype,"machineSettingsResource",null),$e([R.$Mh],a.prototype,"workspaceStorageHome",null),$e([R.$Mh],a.prototype,"localHistoryHome",null),$e([R.$Mh],a.prototype,"keyboardLayoutResource",null),$e([R.$Mh],a.prototype,"argvResource",null),$e([R.$Mh],a.prototype,"isExtensionDevelopment",null),$e([R.$Mh],a.prototype,"untitledWorkspacesHome",null),$e([R.$Mh],a.prototype,"builtinExtensionsPath",null),$e([R.$Mh],a.prototype,"extensionsPath",null),$e([R.$Mh],a.prototype,"extensionDevelopmentLocationURI",null),$e([R.$Mh],a.prototype,"extensionDevelopmentKind",null),$e([R.$Mh],a.prototype,"extensionTestsLocationURI",null),$e([R.$Mh],a.prototype,"debugExtensionHost",null),$e([R.$Mh],a.prototype,"logLevel",null),$e([R.$Mh],a.prototype,"extensionLogLevel",null),$e([R.$Mh],a.prototype,"serviceMachineIdResource",null),$e([R.$Mh],a.prototype,"disableTelemetry",null),$e([R.$Mh],a.prototype,"disableWorkspaceTrust",null),$e([R.$Mh],a.prototype,"useInMemorySecretStorage",null),$e([R.$Mh],a.prototype,"policyFile",null);function w(d,$){return v(d["inspect-extensions"],d["inspect-brk-extensions"],5870,$,d.debugId,d.extensionEnvironment)}function v(d,$,b,O,m,c){const p=Number($||d)||(O?null:b),h=p?!!$:!1;let g;if(c)try{g=JSON.parse(c)}catch{}return{port:p,break:h,debugId:m,env:g}}}),function(){"use strict";function J(e,j,R){function k(D,E){const u=A(D,E),a=[u];return e.isAbsolute(u)||a.unshift(R),e.resolve(...a)}function A(D,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,E);const w=D["user-data-dir"];if(w)return w;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(v,"AppData","Roaming")}break;case"darwin":a=e.join(j.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(j.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,E)}return{getUserDataPath:k}}if(typeof define=="function")define(ne[114],re([170,33,35]),function(e,j,R){return J(e,j,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),j=require("os");module.exports=J(e,j,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[115],re([0,1,33,113,114]),function(J,e,j,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=void 0,e.$Vm=D,e.$Wm=E;class A extends R.$Rm{constructor(a,w){super(a,{homeDir:(0,j.homedir)(),tmpDir:(0,j.tmpdir)(),userDataDir:(0,k.getUserDataPath)(a,w.nameShort)},w)}}e.$Um=A;function D(u,a){return(0,R.$Tm)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,a,u.extensionEnvironment)}function E(u,a){return(0,R.$Tm)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,a,u.extensionEnvironment)}}),define(ne[116],re([0,1,3,97]),function(J,e,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=k;function k(D,E,u,a){try{A(D,E,u,a)}catch(w){D.error(w?.message??w)}return E}function A(D,E,u,a){const w=(v,d,$)=>{const b=v[d];if((0,j.$Vf)(b)){const O=b,m=O.length;if(m>1&&O[0]==="%"&&O[m-1]==="%"){const c=O.substr(1,m-2);let y=u[c];y===void 0&&a&&(y=a[c]);const p=typeof y=="string"?y:y?.message,h=a?.[c],g=typeof h=="string"?h:h?.message;if(!p){g||D.warn(`[${E.name}]: ${(0,R.localize)(0,null,c)}`);return}if($&&(d==="title"||d==="category")&&g&&g!==p){const i={value:p,original:g};v[d]=i}else v[d]=p}}else if((0,j.$Xf)(b))for(const O in b)b.hasOwnProperty(O)&&(O==="commands"?w(b,O,!0):w(b,O,$));else if(Array.isArray(b))for(let O=0;O<b.length;O++)w(b,O,$)};for(const v in E)E.hasOwnProperty(v)&&w(E,v)}}),define(ne[117],re([0,1,49,100]),function(J,e,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=k;function k(A){return(0,j.$8p)(A,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}}),define(ne[50],re([0,1,17,55,101,44]),function(J,e,j,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=u,e.$tp=a,e.$up=w,e.$vp=v,e.$wp=d,e.$xp=$,e.$yp=b;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function u(c){return c=c.trim(),c==="*"||D.test(c)}function a(c){if(!u(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const y=c.match(D);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}function w(c){if(!c)return null;const y=c.majorBase,p=c.majorMustEqual,h=c.minorBase;let g=c.minorMustEqual;const i=c.patchBase;let r=c.patchMustEqual;c.hasCaret&&(y===0||(g=!1),r=!1);let t=0;if(c.preRelease){const n=E.exec(c.preRelease);if(n){const[,s,o,l]=n;t=Date.UTC(Number(s),Number(o)-1,Number(l))}}return{majorBase:y,majorMustEqual:p,minorBase:h,minorMustEqual:g,patchBase:i,patchMustEqual:r,isMinimum:c.hasGreaterEquals,notBefore:t}}function v(c,y,p){let h;typeof c=="string"?h=w(a(c)):h=c;let g;y instanceof Date?g=y.getTime():typeof y=="string"&&(g=new Date(y).getTime());let i;if(typeof p=="string"?i=w(a(p)):i=p,!h||!i)return!1;const r=h.majorBase,t=h.minorBase,n=h.patchBase;let s=i.majorBase,o=i.minorBase,l=i.patchBase;const P=i.notBefore;let I=i.majorMustEqual,L=i.minorMustEqual,z=i.patchMustEqual;return i.isMinimum?r>s?!0:r<s?!1:t>o?!0:t<o||g&&g<P?!1:n>=l:(r===1&&s===0&&(!I||!L||!z)&&(s=1,o=0,l=0,I=!0,L=!1,z=!1),r<s?!1:r>s?!I:t<o?!1:t>o?!L:n<l?!1:n>l?!z:!(g&&g<P))}function d(c,y,p,h,g){const i=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return i.push([R.default.Error,k.localize(0,null)]),i;if(typeof h.name!="string")return i.push([R.default.Error,k.localize(1,null,"name")]),i;if(typeof h.version!="string")return i.push([R.default.Error,k.localize(2,null,"version")]),i;if(!h.engines)return i.push([R.default.Error,k.localize(3,null,"engines")]),i;if(typeof h.engines.vscode!="string")return i.push([R.default.Error,k.localize(4,null,"engines.vscode")]),i;if(typeof h.extensionDependencies<"u"&&!m(h.extensionDependencies))return i.push([R.default.Error,k.localize(5,null,"extensionDependencies")]),i;if(typeof h.activationEvents<"u"){if(!m(h.activationEvents))return i.push([R.default.Error,k.localize(6,null,"activationEvents")]),i;if(typeof h.main>"u"&&typeof h.browser>"u")return i.push([R.default.Error,k.localize(7,null,"activationEvents","main","browser")]),i}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&i.push([R.default.Warning,k.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return i.push([R.default.Error,k.localize(9,null,"main")]),i;{const n=(0,j.$Vg)(p,h.main);(0,j.$Pg)(n,p)||i.push([R.default.Warning,k.localize(10,null,n.path,p.path)])}}if(typeof h.browser<"u"){if(typeof h.browser!="string")return i.push([R.default.Error,k.localize(11,null,"browser")]),i;{const n=(0,j.$Vg)(p,h.browser);(0,j.$Pg)(n,p)||i.push([R.default.Warning,k.localize(12,null,n.path,p.path)])}}if(!A.valid(h.version))return i.push([R.default.Error,k.localize(13,null)]),i;const r=[];if(!$(c,y,h,g,r))for(const n of r)i.push([R.default.Error,n]);return i}function $(c,y,p,h,g){return h||typeof p.main>"u"&&typeof p.browser>"u"?!0:O(c,y,p.engines.vscode,g)}function b(c,y,p){return c==="*"||O(y,p,c)}function O(c,y,p,h=[]){const g=w(a(p));if(!g)return h.push(k.localize(14,null,p)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return h.push(k.localize(15,null,p)),!1}else if(!g.majorMustEqual)return h.push(k.localize(16,null,p)),!1;return v(c,y,g)?!0:(h.push(k.localize(17,null,c,p)),!1)}function m(c){if(!Array.isArray(c))return!1;for(let y=0,p=c.length;y<p;y++)if(typeof c[y]!="string")return!1;return!0}}),define(ne[118],re([0,1,14,28]),function(J,e,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=k;async function k(A,D,E){let u=E&&E.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const w=(await D.readFile(A.serviceMachineIdResource)).value.toString();u=(0,R.$Dg)(w)?w:null}catch{u=null}if(!u){u=(0,R.$Eg)();try{await D.writeFile(A.serviceMachineIdResource,j.$ue.fromString(u))}catch{}}return E?.store("storage.serviceMachineId",u,-1,1),u}}),define(ne[51],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=void 0;class j{constructor(k,A=[],D=!1){this.ctor=k,this.staticArguments=A,this.supportsDelayedInstantiation=D}}e.$fi=j}),define(ne[119],re([0,1,51]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$gs=A,e.$hs=D;const R=[];var k;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(k||(e.InstantiationType=k={}));function A(E,u,a){u instanceof j.$fi||(u=new j.$fi(u,[],!!a)),R.push([E,u])}function D(){return R}}),define(ne[120],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=void 0;class j{constructor(A,D){this.key=A,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.$Wq=j;class R{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const D of this.a.values())D.outgoing.size===0&&A.push(D);return A}insertEdge(A,D){const E=this.lookupOrInsertNode(A),u=this.lookupOrInsertNode(D);E.outgoing.set(u.key,u),u.incoming.set(E.key,E)}removeNode(A){const D=this.b(A);this.a.delete(D);for(const E of this.a.values())E.outgoing.delete(D),E.incoming.delete(D)}lookupOrInsertNode(A){const D=this.b(A);let E=this.a.get(D);return E||(E=new j(D,A),this.a.set(D,E)),E}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[D,E]of this.a)A.push(`${D}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,D]of this.a){const E=new Set([A]),u=this.c(D,E);if(u)return u}}c(A,D){for(const[E,u]of A.outgoing){if(D.has(E))return[...D,E].join(" -> ");D.add(E);const a=this.c(u,D);if(a)return a;D.delete(E)}}}e.$Xq=R}),define(ne[29],re([0,1,3,11,10]),function(J,e,j,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Oi=void 0,e.$Pi=A,e.$Qi=D,e.$Ri=u,e.$Si=a,e.$Ti=w,e.$Ui=v,e.$Vi=d,e.$Wi=b,e.$Xi=O,e.$Yi=m,e.$Oi=(0,k.$ii)("configurationService");function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof R.URI)}function D(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof R.URI)}var E;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(E||(e.ConfigurationTarget=E={}));function u(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function a(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}function w(c,y){const p=Object.create(null);for(const h in c)v(p,h,c[h],y);return p}function v(c,y,p,h){const g=y.split("."),i=g.pop();let r=c;for(let t=0;t<g.length;t++){const n=g[t];let s=r[n];switch(typeof s){case"undefined":s=r[n]=Object.create(null);break;case"object":break;default:h(`Ignoring ${y} as ${g.slice(0,t+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[i]=p}catch{h(`Ignoring ${y} as ${g.join(".")} is ${JSON.stringify(r)}`)}else h(`Ignoring ${y} as ${g.join(".")} is ${JSON.stringify(r)}`)}function d(c,y){const p=y.split(".");$(c,p)}function $(c,y){const p=y.shift();if(y.length===0){delete c[p];return}if(Object.keys(c).indexOf(p)!==-1){const h=c[p];typeof h=="object"&&!Array.isArray(h)&&($(h,y),Object.keys(h).length===0&&delete c[p])}}function b(c,y,p){function h(r,t){let n=r;for(const s of t){if(typeof n!="object"||n===null)return;n=n[s]}return n}const g=y.split("."),i=h(c,g);return typeof i>"u"?p:i}function O(c,y,p){Object.keys(y).forEach(h=>{h!=="__proto__"&&(h in c?j.$Xf(c[h])&&j.$Xf(y[h])?O(c[h],y[h],p):p&&(c[h]=y[h]):c[h]=y[h])})}function m(c){return c.replace(/[\[\]]/g,"")}}),define(ne[121],re([0,1,12,30,112,10,92,8]),function(J,e,j,R,k,A,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$gj=e.$fj=e.ContextKeyExprType=void 0,e.$ej=a,e.$hj=r,e.$ij=t,e.$Bj=Y;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",j.$j),u.set("isLinux",j.$k),u.set("isWindows",j.$i),u.set("isWeb",j.$o),u.set("isMacNative",j.$j&&!j.$o),u.set("isEdge",j.$H),u.set("isFirefox",j.$F),u.set("isChrome",j.$E),u.set("isSafari",j.$G);function a(F,f){if(u.get(F)!==void 0)throw(0,E.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(F,f)}const w=Object.prototype.hasOwnProperty;var v;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(v||(e.ContextKeyExprType=v={}));const d={regexParsingWithErrorRecovery:!0},$=(0,D.localize)(0,null),b=(0,D.localize)(1,null),O=(0,D.localize)(2,null),m=(0,D.localize)(3,null),c=(0,D.localize)(4,null),y=(0,D.localize)(5,null),p=(0,D.localize)(6,null),h=(0,D.localize)(7,null);class g{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(f=d){this.k=f,this.d=new k.$dj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(f){if(f===""){this.h.push({message:$,offset:0,lexeme:"",additionalInfo:b});return}this.f=this.d.reset(f).scan(),this.g=0,this.h=[];try{const S=this.l();if(!this.E()){const N=this.D(),C=N.type===17?y:void 0;throw this.h.push({message:c,offset:N.offset,lexeme:k.$dj.getLexeme(N),additionalInfo:C}),g.c}return S}catch(S){if(S!==g.c)throw S;return}}l(){return this.m()}m(){const f=[this.o()];for(;this.y(16);){const S=this.o();f.push(S)}return f.length===1?f[0]:i.or(...f)}o(){const f=[this.s()];for(;this.y(15);){const S=this.s();f.push(S)}return f.length===1?f[0]:i.and(...f)}s(){if(this.y(2)){const f=this.D();switch(f.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const S=this.l();return this.A(1,m),S?.negate()}case 17:return this.z(),U.create(f.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",f)}}return this.t()}t(){const f=this.D();switch(f.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const S=this.l();return this.A(1,m),S}case 17:{const S=f.lexeme;if(this.z(),this.y(9)){const C=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),C.type!==10)throw this.B("REGEX",C);const x=C.lexeme,G=x.lastIndexOf("/"),te=G===x.length-1?void 0:this.w(x.substring(G+1));let ae;try{ae=new RegExp(x.substring(1,G),te)}catch{throw this.B("REGEX",C)}return he.create(S,ae)}switch(C.type){case 10:case 19:{const x=[C.lexeme];this.z();let G=this.D(),te=0;for(let fe=0;fe<C.lexeme.length;fe++)C.lexeme.charCodeAt(fe)===40?te++:C.lexeme.charCodeAt(fe)===41&&te--;for(;!this.E()&&G.type!==15&&G.type!==16;){switch(G.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let fe=0;fe<G.lexeme.length;fe++)G.lexeme.charCodeAt(fe)===40?te++:C.lexeme.charCodeAt(fe)===41&&te--}if(te<0)break;x.push(k.$dj.getLexeme(G)),this.z(),G=this.D()}const ae=x.join(""),le=ae.lastIndexOf("/"),pe=le===ae.length-1?void 0:this.w(ae.substring(le+1));let ye;try{ye=new RegExp(ae.substring(1,le),pe)}catch{throw this.B("REGEX",C)}return i.regex(S,ye)}case 18:{const x=C.lexeme;this.z();let G=null;if(!(0,R.$Ue)(x)){const te=x.indexOf("/"),ae=x.lastIndexOf("/");if(te!==ae&&te>=0){const le=x.slice(te+1,ae),pe=x[ae+1]==="i"?"i":"";try{G=new RegExp(le,pe)}catch{throw this.B("REGEX",C)}}}if(G===null)throw this.B("REGEX",C);return he.create(S,G)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,O);const C=this.u();return i.notIn(S,C)}switch(this.D().type){case 3:{this.z();const C=this.u();if(this.x().type===18)return i.equals(S,C);switch(C){case"true":return i.has(S);case"false":return i.not(S);default:return i.equals(S,C)}}case 4:{this.z();const C=this.u();if(this.x().type===18)return i.notEquals(S,C);switch(C){case"true":return i.not(S);case"false":return i.has(S);default:return i.notEquals(S,C)}}case 5:return this.z(),ie.create(S,this.u());case 6:return this.z(),ue.create(S,this.u());case 7:return this.z(),X.create(S,this.u());case 8:return this.z(),se.create(S,this.u());case 13:return this.z(),i.in(S,this.u());default:return i.has(S)}}case 20:throw this.h.push({message:p,offset:f.offset,lexeme:"",additionalInfo:h}),g.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const f=this.D();switch(f.type){case 17:case 18:return this.z(),f.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(f){return f.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(f){return this.C(f)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(f,S){if(this.C(f))return this.z();throw this.B(S,this.D())}B(f,S,N){const C=(0,D.localize)(8,null,f,k.$dj.getLexeme(S)),x=S.offset,G=k.$dj.getLexeme(S);return this.h.push({message:C,offset:x,lexeme:G,additionalInfo:N}),g.c}C(f){return this.D().type===f}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$fj=g;class i{static false(){return s.INSTANCE}static true(){return o.INSTANCE}static has(f){return l.create(f)}static equals(f,S){return P.create(f,S)}static notEquals(f,S){return z.create(f,S)}static regex(f,S){return he.create(f,S)}static in(f,S){return I.create(f,S)}static notIn(f,S){return L.create(f,S)}static not(f){return U.create(f)}static and(...f){return Z.create(f,null,!0)}static or(...f){return q.create(f,null,!0)}static greater(f,S){return X.create(f,S)}static greaterEquals(f,S){return se.create(f,S)}static smaller(f,S){return ie.create(f,S)}static smallerEquals(f,S){return ue.create(f,S)}static{this.c=new g({regexParsingWithErrorRecovery:!1})}static deserialize(f){return f==null?void 0:this.c.parse(f)}}e.$gj=i;function r(F){const f=new g({regexParsingWithErrorRecovery:!1});return F.map(S=>(f.parse(S),f.lexingErrors.length>0?f.lexingErrors.map(N=>({errorMessage:N.additionalInfo?(0,D.localize)(9,null,N.additionalInfo):(0,D.localize)(10,null),offset:N.offset,length:N.lexeme.length})):f.parsingErrors.length>0?f.parsingErrors.map(N=>({errorMessage:N.additionalInfo?`${N.message}. ${N.additionalInfo}`:N.message,offset:N.offset,length:N.lexeme.length})):[]))}function t(F,f){const S=F?F.substituteConstants():void 0,N=f?f.substituteConstants():void 0;return!S&&!N?!0:!S||!N?!1:S.equals(N)}function n(F,f){return F.cmp(f)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}substituteConstants(){return this}evaluate(f){return!1}serialize(){return"false"}keys(){return[]}map(f){return this}negate(){return o.INSTANCE}}e.$jj=s;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}substituteConstants(){return this}evaluate(f){return!0}serialize(){return"true"}keys(){return[]}map(f){return this}negate(){return s.INSTANCE}}e.$kj=o;class l{static create(f,S=null){const N=u.get(f);return typeof N=="boolean"?N?o.INSTANCE:s.INSTANCE:new l(f,S)}constructor(f,S){this.key=f,this.c=S,this.type=2}cmp(f){return f.type!==this.type?this.type-f.type:W(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}substituteConstants(){const f=u.get(this.key);return typeof f=="boolean"?f?o.INSTANCE:s.INSTANCE:this}evaluate(f){return!!f.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(f){return f.mapDefined(this.key)}negate(){return this.c||(this.c=U.create(this.key,this)),this.c}}e.$lj=l;class P{static create(f,S,N=null){if(typeof S=="boolean")return S?l.create(f,N):U.create(f,N);const C=u.get(f);return typeof C=="boolean"?S===(C?"true":"false")?o.INSTANCE:s.INSTANCE:new P(f,S,N)}constructor(f,S,N){this.c=f,this.d=S,this.f=N,this.type=4}cmp(f){return f.type!==this.type?this.type-f.type:Q(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){const f=u.get(this.c);if(typeof f=="boolean"){const S=f?"true":"false";return this.d===S?o.INSTANCE:s.INSTANCE}return this}evaluate(f){return f.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(f){return f.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$mj=P;class I{static create(f,S){return new I(f,S)}constructor(f,S){this.d=f,this.f=S,this.type=10,this.c=null}cmp(f){return f.type!==this.type?this.type-f.type:Q(this.d,this.f,f.d,f.f)}equals(f){return f.type===this.type?this.d===f.d&&this.f===f.f:!1}substituteConstants(){return this}evaluate(f){const S=f.getValue(this.f),N=f.getValue(this.d);return Array.isArray(S)?S.includes(N):typeof N=="string"&&typeof S=="object"&&S!==null?w.call(S,N):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(f){return f.mapIn(this.d,this.f)}negate(){return this.c||(this.c=L.create(this.d,this.f)),this.c}}e.$nj=I;class L{static create(f,S){return new L(f,S)}constructor(f,S){this.d=f,this.f=S,this.type=11,this.c=I.create(f,S)}cmp(f){return f.type!==this.type?this.type-f.type:this.c.cmp(f.c)}equals(f){return f.type===this.type?this.c.equals(f.c):!1}substituteConstants(){return this}evaluate(f){return!this.c.evaluate(f)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(f){return f.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$oj=L;class z{static create(f,S,N=null){if(typeof S=="boolean")return S?U.create(f,N):l.create(f,N);const C=u.get(f);return typeof C=="boolean"?S===(C?"true":"false")?s.INSTANCE:o.INSTANCE:new z(f,S,N)}constructor(f,S,N){this.c=f,this.d=S,this.f=N,this.type=5}cmp(f){return f.type!==this.type?this.type-f.type:Q(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){const f=u.get(this.c);if(typeof f=="boolean"){const S=f?"true":"false";return this.d===S?s.INSTANCE:o.INSTANCE}return this}evaluate(f){return f.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(f){return f.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$pj=z;class U{static create(f,S=null){const N=u.get(f);return typeof N=="boolean"?N?s.INSTANCE:o.INSTANCE:new U(f,S)}constructor(f,S){this.c=f,this.d=S,this.type=3}cmp(f){return f.type!==this.type?this.type-f.type:W(this.c,f.c)}equals(f){return f.type===this.type?this.c===f.c:!1}substituteConstants(){const f=u.get(this.c);return typeof f=="boolean"?f?s.INSTANCE:o.INSTANCE:this}evaluate(f){return!f.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(f){return f.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$qj=U;function V(F,f){if(typeof F=="string"){const S=parseFloat(F);isNaN(S)||(F=S)}return typeof F=="string"||typeof F=="number"?f(F):s.INSTANCE}class X{static create(f,S,N=null){return V(S,C=>new X(f,C,N))}constructor(f,S,N){this.c=f,this.d=S,this.f=N,this.type=12}cmp(f){return f.type!==this.type?this.type-f.type:Q(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(f){return f.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$rj=X;class se{static create(f,S,N=null){return V(S,C=>new se(f,C,N))}constructor(f,S,N){this.c=f,this.d=S,this.f=N,this.type=13}cmp(f){return f.type!==this.type?this.type-f.type:Q(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(f){return f.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ie.create(this.c,this.d,this)),this.f}}e.$sj=se;class ie{static create(f,S,N=null){return V(S,C=>new ie(f,C,N))}constructor(f,S,N){this.c=f,this.d=S,this.f=N,this.type=14}cmp(f){return f.type!==this.type?this.type-f.type:Q(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(f){return f.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=se.create(this.c,this.d,this)),this.f}}e.$tj=ie;class ue{static create(f,S,N=null){return V(S,C=>new ue(f,C,N))}constructor(f,S,N){this.c=f,this.d=S,this.f=N,this.type=15}cmp(f){return f.type!==this.type?this.type-f.type:Q(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(f){return f.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=X.create(this.c,this.d,this)),this.f}}e.$uj=ue;class he{static create(f,S){return new he(f,S)}constructor(f,S){this.d=f,this.f=S,this.type=7,this.c=null}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.d<f.d)return-1;if(this.d>f.d)return 1;const S=this.f?this.f.source:"",N=f.f?f.f.source:"";return S<N?-1:S>N?1:0}equals(f){if(f.type===this.type){const S=this.f?this.f.source:"",N=f.f?f.f.source:"";return this.d===f.d&&S===N}return!1}substituteConstants(){return this}evaluate(f){const S=f.getValue(this.d);return this.f?this.f.test(S):!1}serialize(){const f=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${f}`}keys(){return[this.d]}map(f){return f.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ce.create(this)),this.c}}e.$vj=he;class ce{static create(f){return new ce(f)}constructor(f){this.c=f,this.type=8}cmp(f){return f.type!==this.type?this.type-f.type:this.c.cmp(f.c)}equals(f){return f.type===this.type?this.c.equals(f.c):!1}substituteConstants(){return this}evaluate(f){return!this.c.evaluate(f)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(f){return new ce(this.c.map(f))}negate(){return this.c}}e.$wj=ce;function B(F){let f=null;for(let S=0,N=F.length;S<N;S++){const C=F[S].substituteConstants();if(F[S]!==C&&f===null){f=[];for(let x=0;x<S;x++)f[x]=F[x]}f!==null&&(f[S]=C)}return f===null?F:f}class Z{static create(f,S,N){return Z.d(f,S,N)}constructor(f,S){this.expr=f,this.c=S,this.type=6}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let S=0,N=this.expr.length;S<N;S++){const C=n(this.expr[S],f.expr[S]);if(C!==0)return C}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let S=0,N=this.expr.length;S<N;S++)if(!this.expr[S].equals(f.expr[S]))return!1;return!0}return!1}substituteConstants(){const f=B(this.expr);return f===this.expr?this:Z.create(f,this.c,!1)}evaluate(f){for(let S=0,N=this.expr.length;S<N;S++)if(!this.expr[S].evaluate(f))return!1;return!0}static d(f,S,N){const C=[];let x=!1;for(const G of f)if(G){if(G.type===1){x=!0;continue}if(G.type===0)return s.INSTANCE;if(G.type===6){C.push(...G.expr);continue}C.push(G)}if(C.length===0&&x)return o.INSTANCE;if(C.length!==0){if(C.length===1)return C[0];C.sort(n);for(let G=1;G<C.length;G++)C[G-1].equals(C[G])&&(C.splice(G,1),G--);if(C.length===1)return C[0];for(;C.length>1;){const G=C[C.length-1];if(G.type!==9)break;C.pop();const te=C.pop(),ae=C.length===0,le=q.create(G.expr.map(pe=>Z.create([pe,te],null,N)),null,ae);le&&(C.push(le),C.sort(n))}if(C.length===1)return C[0];if(N){for(let G=0;G<C.length;G++)for(let te=G+1;te<C.length;te++)if(C[G].negate().equals(C[te]))return s.INSTANCE;if(C.length===1)return C[0]}return new Z(C,S)}}serialize(){return this.expr.map(f=>f.serialize()).join(" && ")}keys(){const f=[];for(const S of this.expr)f.push(...S.keys());return f}map(f){return new Z(this.expr.map(S=>S.map(f)),null)}negate(){if(!this.c){const f=[];for(const S of this.expr)f.push(S.negate());this.c=q.create(f,this,!0)}return this.c}}e.$xj=Z;class q{static create(f,S,N){return q.d(f,S,N)}constructor(f,S){this.expr=f,this.c=S,this.type=9}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let S=0,N=this.expr.length;S<N;S++){const C=n(this.expr[S],f.expr[S]);if(C!==0)return C}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let S=0,N=this.expr.length;S<N;S++)if(!this.expr[S].equals(f.expr[S]))return!1;return!0}return!1}substituteConstants(){const f=B(this.expr);return f===this.expr?this:q.create(f,this.c,!1)}evaluate(f){for(let S=0,N=this.expr.length;S<N;S++)if(this.expr[S].evaluate(f))return!0;return!1}static d(f,S,N){let C=[],x=!1;if(f){for(let G=0,te=f.length;G<te;G++){const ae=f[G];if(ae){if(ae.type===0){x=!0;continue}if(ae.type===1)return o.INSTANCE;if(ae.type===9){C=C.concat(ae.expr);continue}C.push(ae)}}if(C.length===0&&x)return s.INSTANCE;C.sort(n)}if(C.length!==0){if(C.length===1)return C[0];for(let G=1;G<C.length;G++)C[G-1].equals(C[G])&&(C.splice(G,1),G--);if(C.length===1)return C[0];if(N){for(let G=0;G<C.length;G++)for(let te=G+1;te<C.length;te++)if(C[G].negate().equals(C[te]))return o.INSTANCE;if(C.length===1)return C[0]}return new q(C,S)}}serialize(){return this.expr.map(f=>f.serialize()).join(" || ")}keys(){const f=[];for(const S of this.expr)f.push(...S.keys());return f}map(f){return new q(this.expr.map(S=>S.map(f)),null)}negate(){if(!this.c){const f=[];for(const S of this.expr)f.push(S.negate());for(;f.length>1;){const S=f.shift(),N=f.shift(),C=[];for(const x of M(S))for(const G of M(N))C.push(Z.create([x,G],null,!1));f.unshift(q.create(C,null,!1))}this.c=q.create(f,this,!0)}return this.c}}e.$yj=q;class T extends l{static{this.d=[]}static all(){return T.d.values()}constructor(f,S,N){super(f,null),this.f=S,typeof N=="object"?T.d.push({...N,key:f}):N!==!0&&T.d.push({key:f,description:N,type:S!=null?typeof S:void 0})}bindTo(f){return f.createKey(this.key,this.f)}getValue(f){return f.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(f){return P.create(this.key,f)}notEqualsTo(f){return z.create(this.key,f)}}e.$zj=T,e.$Aj=(0,A.$ii)("contextKeyService");function W(F,f){return F<f?-1:F>f?1:0}function Q(F,f,S,N){return F<S?-1:F>S?1:f<N?-1:f>N?1:0}function Y(F,f){if(F.type===0||f.type===1)return!0;if(F.type===9)return f.type===9?_(F.expr,f.expr):!1;if(f.type===9){for(const S of f.expr)if(Y(F,S))return!0;return!1}if(F.type===6){if(f.type===6)return _(f.expr,F.expr);for(const S of F.expr)if(Y(S,f))return!0;return!1}return F.equals(f)}function _(F,f){let S=0,N=0;for(;S<F.length&&N<f.length;){const C=F[S].cmp(f[N]);if(C<0)return!1;C===0&&S++,N++}return S===F.length}function M(F){return F.type===9?F.expr:[F]}}),define(ne[61],re([0,1,10]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=void 0,e.$wo=(0,j.$ii)("downloadService")}),define(ne[18],re([0,1,10]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=void 0,e.$pi=(0,j.$ii)("environmentService"),e.$qi=(0,j.$ji)(e.$pi)}),define(ne[21],re([0,1,95,10]),function(J,e,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.ExtensionGalleryErrorCode=e.$So=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Ro=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=void 0,e.$Lo=k,e.$Mo=A,e.$No=D,e.$Oo=E,e.$Po=u,e.$Qo=a,e.$Fo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Go=new RegExp(e.$Fo),e.$Ho="__web_extension",e.$Io="skipWalkthrough",e.$Jo="extensionsSync",e.$Ko="dependecyOrPackExtensionInstall";function k(p){switch(p){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function A(p){switch(p){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function D(p,h){switch(p){case 3:return h==="x64"?"win32-x64":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function E(p,h){return h==="web"&&!p.includes("web")}function u(p,h,g){return E(h,g)?!1:p==="undefined"||p==="universal"?!0:p==="unknown"?!1:p===g}function a(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}var w;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=10]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(w||(e.SortBy=w={}));var v;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var d;(function(p){p.Install="install",p.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var $;(function(p){p[p.None=1]="None",p[p.Install=2]="Install",p[p.Update=3]="Update",p[p.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$Ro=(0,R.$ii)("extensionGalleryService");var b;(function(p){p.Unsupported="Unsupported",p.Deprecated="Deprecated",p.Malicious="Malicious",p.Incompatible="Incompatible",p.IncompatibleTargetPlatform="IncompatibleTargetPlatform",p.ReleaseVersionNotFound="ReleaseVersionNotFound",p.Invalid="Invalid",p.Download="Download",p.DownloadSignature="DownloadSignature",p.UpdateMetadata="UpdateMetadata",p.Extract="Extract",p.Scanning="Scanning",p.Delete="Delete",p.Rename="Rename",p.CorruptZip="CorruptZip",p.IncompleteZip="IncompleteZip",p.Signature="Signature",p.NotAllowed="NotAllowed",p.Gallery="Gallery",p.Unknown="Unknown",p.Internal="Internal"})(b||(e.ExtensionManagementErrorCode=b={}));var O;(function(p){p.UnknownError="UnknownError",p.PackageIsInvalidZip="PackageIsInvalidZip",p.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(O||(e.ExtensionSignaturetErrorCode=O={}));class m extends Error{constructor(h,g){super(h),this.code=g,this.name=g}}e.$So=m;var c;(function(p){p.Timeout="Timeout",p.Cancelled="Cancelled",p.Failed="Failed"})(c||(e.ExtensionGalleryErrorCode=c={}));class y extends Error{constructor(h,g){super(h),this.code=g,this.name=g}}e.$To=y,e.$Uo=(0,R.$ii)("extensionManagementService"),e.$Vo="extensionsIdentifiers/disabled",e.$Wo="extensionsIdentifiers/enabled",e.$Xo=(0,R.$ii)("IGlobalExtensionEnablementService"),e.$Yo=(0,R.$ii)("IExtensionTipsService"),e.$Zo=(0,j.localize2)(0,"Extensions"),e.$1o=(0,j.localize2)(1,"Preferences")}),define(ne[62],re([0,1,14,8,103,13]),function(J,e,j,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=D;async function D(w,v,d,$,b,O){let m;try{await E(w,v,d,$,b,O)}catch(c){m=c}finally{m&&b.errorTransformer&&(m=b.errorTransformer(m)),typeof m<"u"&&d.error(m),d.end()}}async function E(w,v,d,$,b,O){u(O);const m=await w.open(v,{create:!1});try{u(O);let c=0,y=0,p=b&&typeof b.length=="number"?b.length:void 0,h=j.$ue.alloc(Math.min(b.bufferSize,typeof p=="number"?p:b.bufferSize)),g=b&&typeof b.position=="number"?b.position:0,i=0;do y=await w.read(m,g,h.buffer,i,h.byteLength-i),g+=y,i+=y,c+=y,typeof p=="number"&&(p-=y),i===h.byteLength&&(await d.write($(h)),h=j.$ue.alloc(Math.min(b.bufferSize,typeof p=="number"?p:b.bufferSize)),i=0);while(y>0&&(typeof p!="number"||p>0)&&u(O)&&a(c,b));if(i>0){let r=i;typeof p=="number"&&(r=Math.min(i,p)),d.write($(h.slice(0,r)))}}catch(c){throw(0,A.$3k)(c)}finally{await w.close(m)}}function u(w){if(w.isCancellationRequested)throw(0,R.$6)();return!0}function a(w,v){if(typeof v?.limits?.size=="number"&&w>v.limits.size)throw(0,A.$2k)((0,k.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ne[122],re([0,1,60,2,52,5,11]),function(J,e,j,R,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;class E extends R.$Uc{constructor(){super(),this.a=this.B(new A.$7d),this.onDidChangeFile=this.a.event,this.b=this.B(new A.$7d),this.onDidLogMessage=this.b.event,this.c=this.B(new A.$7d),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new R.$4c),this.m=5007,this.B(this.f(a=>this.n(a)))}n(a){this.r(a)&&this.t(a)}r(a){return(0,k.$vq)(a)}async watch(a){this.h.clear(),this.g.clear();for(const w of a)this.r(w)?this.h.set(w.correlationId,w):this.g.add(w);for(const[w]of this.j)this.h.has(w)||this.j.deleteAndDispose(w);return this.s()}s(){return this.D([...this.g,...Array.from(this.h.values()).filter(a=>!this.j.has(a.correlationId))])}t(a){if(this.j.has(a.correlationId))return;const w=new R.$Tc;this.j.set(a.correlationId,w),this.w(a,w),this.s()}u(a){this.j.deleteAndDispose(a.correlationId),this.s()}w(a,w){const v=D.URI.file(a.path),d=this;let $=!1;const b=(O,m)=>{if(w.isDisposed)return;const c=this.y(O),y=this.y(m),p=$;if($=c,!c&&(y||p)){this.F(`fs.watchFile() detected ${a.path} exists again, resuming watcher (correlationId: ${a.correlationId})`);const h={resource:v,type:1,cId:a.correlationId};d.a.fire([h]),this.z(h,a),this.u(a)}};this.F(`starting fs.watchFile() on ${a.path} (correlationId: ${a.correlationId})`);try{(0,j.watchFile)(a.path,{persistent:!1,interval:this.m},b)}catch(O){this.G(`fs.watchFile() failed with error ${O} on path ${a.path} (correlationId: ${a.correlationId})`)}w.add((0,R.$Sc)(()=>{this.F(`stopping fs.watchFile() on ${a.path} (correlationId: ${a.correlationId})`);try{(0,j.unwatchFile)(a.path,b)}catch(O){this.G(`fs.unwatchFile() failed with error ${O} on path ${a.path} (correlationId: ${a.correlationId})`)}}))}y(a){return a.ctimeMs===0&&a.ino===0}async stop(){this.j.clearAndDisposeAll()}z(a,w){const v=` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`;this.F(typeof w.correlationId=="number"?`${v} (correlationId: ${w.correlationId})`:v)}C(a){return`${a.path} (excludes: ${a.excludes.length>0?a.excludes:"<none>"}, includes: ${a.includes&&a.includes.length>0?JSON.stringify(a.includes):"<all>"}, correlationId: ${typeof a.correlationId=="number"?a.correlationId:"<none>"})`}}e.$Mq=E}),define(ne[123],re([0,1,5,171,122,12,172,124]),function(J,e,j,R,k,A,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;class u extends k.$Mq{constructor(){super(...arguments),this.onDidError=j.Event.None,this.H=new Set,this.I=!1}async D(w){w=this.O(w);const v=[],d=new Set(Array.from(this.H));for(const $ of w){const b=this.L($);b&&(0,R.$gk)(b.request.excludes,$.excludes)&&(0,R.$gk)(b.request.includes,$.includes)?d.delete(b):v.push($)}v.length&&this.F(`Request to start watching: ${v.map($=>this.C($)).join(",")}`),d.size&&this.F(`Request to stop watching: ${Array.from(d).map($=>this.C($.request)).join(",")}`);for(const $ of d)this.N($);for(const $ of v)this.M($)}L(w){for(const v of this.H)if(typeof w.correlationId=="number"||typeof v.request.correlationId=="number"){if(v.request.correlationId===w.correlationId)return v}else if((0,E.$hg)(v.request.path,w.path,!A.$k))return v}M(w){const v=new D.$Rq(w,$=>this.a.fire($),()=>this.c.fire(w),$=>this.b.fire($),this.I),d={request:w,instance:v};this.H.add(d)}async stop(){await super.stop();for(const w of this.H)this.N(w)}N(w){this.F("stopping file watcher",w),this.H.delete(w),w.instance.dispose()}O(w){const v=new Map;for(const d of w){const $=A.$k?d.path:d.path.toLowerCase();let b=v.get(d.correlationId);b||(b=new Map,v.set(d.correlationId,b)),b.has($)&&this.F(`ignoring a request for watching who's path is already watched: ${this.C(d)}`),b.set($,d)}return Array.from(v.values()).map(d=>Array.from(d.values())).flat()}async setVerboseLogging(w){this.I=w;for(const v of this.H)v.instance.setVerboseLogging(w)}F(w,v){this.I&&this.b.fire({type:"trace",message:this.R(w,v)})}G(w){this.b.fire({type:"warn",message:this.R(w)})}R(w,v){return v?`[File Watcher (node.js)] ${w} (${this.C(v.request)})`:`[File Watcher (node.js)] ${w}`}}e.$Tq=u}),define(ne[125],re([0,1,52,123]),function(J,e,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class k extends j.$yq{constructor(D,E,u){super(D,E,u),this.s()}r(D){return D.add(new R.$Tq)}}e.$Uq=k}),define(ne[126],re([0,1,15,58,88,52]),function(J,e,j,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=void 0;class D extends A.$zq{constructor(u,a,w){super(u,a,w),this.s()}r(u){const a=u.add(new k.$Kq(j.$Cg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(a.onDidProcessExit(({code:w,signal:v})=>this.t(`terminated by itself with code ${w}, signal: ${v}`))),R.ProxyChannel.toService((0,R.$2h)(a.getChannel("watcher")))}}e.$Lq=D}),define(ne[63],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=void 0;class j{constructor(...k){this.a=new Map;for(const[A,D]of k)this.set(A,D)}set(k,A){const D=this.a.get(k);return this.a.set(k,A),D}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.$gi=j}),define(ne[127],re([0,1,9,8,2,51,120,10,63,173]),function(J,e,j,R,k,A,D,E,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=void 0;const w=!1;class v extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class d{constructor(m=new u.$gi,c=!1,y,p=w){this.f=m,this.g=c,this.h=y,this.i=p,this.o=new Set,this.f.set(E.$hi,this),this._globalGraph=p?y?._globalGraph??new D.$Xq(h=>h):void 0}createChild(m){return new d(m,this.g,this,this.i)}invokeFunction(m,...c){const y=b.traceInvocation(this.i,m);let p=!1;try{return m({get:g=>{if(p)throw(0,R.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(g,y);if(!i)throw new Error(`[invokeFunction] unknown service '${g}'`);return i}},...c)}finally{p=!0,y.stop()}}createInstance(m,...c){let y,p;return m instanceof A.$fi?(y=b.traceCreation(this.i,m.ctor),p=this.j(m.ctor,m.staticArguments.concat(c),y)):(y=b.traceCreation(this.i,m),p=this.j(m,c,y)),y.stop(),p}j(m,c=[],y){const p=E._util.getServiceDependencies(m).sort((i,r)=>i.index-r.index),h=[];for(const i of p){const r=this.m(i.id,y);r||this.u(`[createInstance] ${m.name} depends on UNKNOWN service ${i.id}.`,!1),h.push(r)}const g=p.length>0?p[0].index:c.length;if(c.length!==g){console.trace(`[createInstance] First service dependency of ${m.name} at position ${g+1} conflicts with ${c.length} static arguments`);const i=g-c.length;i>0?c=c.concat(new Array(i)):c=c.slice(0,g)}return Reflect.construct(m,c.concat(h))}k(m,c){if(this.f.get(m)instanceof A.$fi)this.f.set(m,c);else if(this.h)this.h.k(m,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(m){const c=this.f.get(m);return!c&&this.h?this.h.l(m):c}m(m,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const y=this.l(m);return y instanceof A.$fi?this.q(m,y,c.branch(m,!0)):(c.branch(m,!1),y)}q(m,c,y){if(this.o.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.o.add(m);try{return this.r(m,c,y)}finally{this.o.delete(m)}}r(m,c,y){const p=new D.$Xq(i=>i.id.toString());let h=0;const g=[{id:m,desc:c,_trace:y}];for(;g.length;){const i=g.pop();if(p.lookupOrInsertNode(i),h++>1e3)throw new v(p);for(const r of E._util.getServiceDependencies(i.desc.ctor)){const t=this.l(r.id);if(t||this.u(`[createInstance] ${m} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(r.id)),t instanceof A.$fi){const n={id:r.id,desc:t,_trace:i._trace.branch(r.id,!0)};p.insertEdge(i,n),g.push(n)}}}for(;;){const i=p.roots();if(i.length===0){if(!p.isEmpty())throw new v(p);break}for(const{data:r}of i){if(this.l(r.id)instanceof A.$fi){const n=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,n)}p.removeNode(r)}}return this.l(m)}s(m,c,y=[],p,h){if(this.f.get(m)instanceof A.$fi)return this.t(m,c,y,p,h);if(this.h)return this.h.s(m,c,y,p,h);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(m,c,y=[],p,h){if(p){const g=new d(void 0,this.g,this,this.i);g.c=String(m);const i=new Map,r=new j.$Bh(()=>{const t=g.j(c,y,h);for(const[n,s]of i){const o=t[n];if(typeof o=="function")for(const l of s)l.disposable=o.apply(t,l.listener)}return i.clear(),t});return new Proxy(Object.create(null),{get(t,n){if(!r.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let l=i.get(n);return l||(l=new a.$5c,i.set(n,l)),(I,L,z)=>{if(r.isInitialized)return r.value[n](I,L,z);{const U={listener:[I,L,z],disposable:void 0},V=l.push(U);return(0,k.$Sc)(()=>{V(),U.disposable?.dispose()})}}}if(n in t)return t[n];const s=r.value;let o=s[n];return typeof o!="function"||(o=o.bind(s),t[n]=o),o},set(t,n,s){return r.value[n]=s,!0},getPrototypeOf(t){return c.prototype}})}else return this.j(c,y,h)}u(m,c){if(c&&console.warn(m),this.g)throw new Error(m)}}e.$Yq=d;var $;(function(O){O[O.None=0]="None",O[O.Creation=1]="Creation",O[O.Invocation=2]="Invocation",O[O.Branch=3]="Branch"})($||($={}));class b{static{this.all=new Set}static{this.c=new class extends b{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,c){return m?new b(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):b.c}static traceCreation(m,c){return m?new b(1,c.name):b.c}static{this.f=0}constructor(m,c){this.type=m,this.name=c,this.g=Date.now(),this.h=[]}branch(m,c){const y=new b(3,m.toString());return this.h.push([m,c,y]),y}stop(){const m=Date.now()-this.g;b.f+=m;let c=!1;function y(h,g){const i=[],r=new Array(h+1).join("	");for(const[t,n,s]of g.h)if(n&&s){c=!0,i.push(`${r}CREATES -> ${t}`);const o=y(h+1,s);o&&i.push(o)}else i.push(`${r}uses -> ${t}`);return i.join(`
`)}const p=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${b.f.toFixed(2)}ms)`];(m>2||c)&&b.all.add(p.join(`
`))}}e.$Zq=b});var oe=this&&this.__param||function(J,e){return function(j,R){e(j,R,J)}};define(ne[64],re([0,1,20,2,12,105,21,10]),function(J,e,j,R,k,A,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=e.$Br=void 0,e.$Ar=u;function u(w){return w.tags.find(v=>v.startsWith("lp-"))?.split("lp-")[1]}e.$Br=(0,E.$ii)("languagePackService");let a=class extends R.$Uc{constructor(v){super(),this.c=v}async getAvailableLanguages(){const v=new j.$ee;setTimeout(()=>v.cancel(),1e3);let d;try{d=await this.c.query({text:'category:"language packs"',pageSize:20},v.token)}catch{return[]}const b=d.firstPage.filter(O=>O.properties.localizedLanguages?.length&&O.tags.some(m=>m.startsWith("lp-"))).map(O=>{const m=O.properties.localizedLanguages?.[0],c=u(O);return{...this.f(c,m,O),extensionId:O.identifier.id,galleryExtension:O}});return b.push(this.f("en","English")),b}f(v,d,$){const b=d??v;let O;if(b!==v&&(O=`(${v})`),v.toLowerCase()===k.$w.toLowerCase()&&(O??="",O+=(0,A.localize)(0,null)),$?.installCount){O??="";const m=$.installCount;let c;m>1e6?c=`${Math.floor(m/1e5)/10}M`:m>1e3?c=`${Math.floor(m/1e3)}K`:c=String(m),O+=` $(cloud-download) ${c}`}return{id:v,label:b,description:O}}};e.$Cr=a,e.$Cr=a=$e([oe(0,D.$Ro)],a)}),define(ne[6],re([0,1,106,34,5,43,2,31,12,17,3,11,121,10]),function(J,e,j,R,k,A,D,E,u,a,w,v,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Rj=e.LogLevel=e.$Pj=e.$Oj=void 0,e.$Qj=O,e.log=c,e.$3j=l,e.$4j=P,e.$5j=I,e.$6j=L,e.$Oj=(0,$.$ii)("logService"),e.$Pj=(0,$.$ii)("loggerService");function b(){return new Date().toISOString()}function O(z){return(0,w.$Zf)(z)}var m;(function(z){z[z.Off=0]="Off",z[z.Trace=1]="Trace",z[z.Debug=2]="Debug",z[z.Info=3]="Info",z[z.Warning=4]="Warning",z[z.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$Rj=m.Info;function c(z,U,V){switch(U){case m.Trace:z.trace(V);break;case m.Debug:z.debug(V);break;case m.Info:z.info(V);break;case m.Warning:z.warn(V);break;case m.Error:z.error(V);break;case m.Off:break;default:throw new Error(`Invalid log level ${U}`)}}function y(z,U=!1){let V="";for(let X=0;X<z.length;X++){let se=z[X];if(se instanceof Error&&(se=(0,R.$6i)(se,U)),typeof se=="object")try{se=JSON.stringify(se)}catch{}V+=(X>0?" ":"")+se}return V}class p extends D.$Uc{constructor(){super(...arguments),this.b=e.$Rj,this.c=this.B(new k.$7d),this.onDidChangeLogLevel=this.c.event}setLevel(U){this.b!==U&&(this.b=U,this.c.fire(this.b))}getLevel(){return this.b}f(U){return this.b!==m.Off&&this.b<=U}}e.$Tj=p;class h extends p{constructor(U){super(),this.h=U}f(U){return this.h||super.f(U)}trace(U,...V){this.f(m.Trace)&&this.g(m.Trace,y([U,...V],!0))}debug(U,...V){this.f(m.Debug)&&this.g(m.Debug,y([U,...V]))}info(U,...V){this.f(m.Info)&&this.g(m.Info,y([U,...V]))}warn(U,...V){this.f(m.Warning)&&this.g(m.Warning,y([U,...V]))}error(U,...V){if(this.f(m.Error))if(U instanceof Error){const X=Array.prototype.slice.call(arguments);X[0]=U.stack,this.g(m.Error,y(X))}else this.g(m.Error,y([U,...V]))}flush(){}}e.$Uj=h;class g extends p{constructor(U=e.$Rj){super(),this.setLevel(U),this.g=!u.$i}trace(U,...V){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,U,...V):console.log(`[main ${b()}]`,U,...V))}debug(U,...V){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,U,...V):console.log(`[main ${b()}]`,U,...V))}info(U,...V){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,U,...V):console.log(`[main ${b()}]`,U,...V))}warn(U,...V){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,U,...V):console.warn(`[main ${b()}]`,U,...V))}error(U,...V){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,U,...V):console.error(`[main ${b()}]`,U,...V))}flush(){}}e.$Vj=g;class i extends p{constructor(U=e.$Rj,V=!0){super(),this.g=V,this.setLevel(U)}trace(U,...V){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",U,...V):console.log(U,...V))}debug(U,...V){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",U,...V):console.log(U,...V))}info(U,...V){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",U,...V):console.log(U,...V))}warn(U,...V){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",U,...V):console.log(U,...V))}error(U,...V){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",U,...V):console.error(U,...V))}flush(){}}e.$Wj=i;class r extends p{constructor(U,V=e.$Rj){super(),this.g=U,this.setLevel(V)}trace(U,...V){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(U),...V])}debug(U,...V){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(U),...V])}info(U,...V){this.f(m.Info)&&this.g.log(m.Info,[this.h(U),...V])}warn(U,...V){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(U),...V])}error(U,...V){this.f(m.Error)&&this.g.log(m.Error,[this.h(U),...V])}h(U){return typeof U=="string"?U:(0,R.$6i)(U,this.f(m.Trace))}flush(){}}e.$Xj=r;class t extends p{constructor(U){super(),this.g=U,U.length&&this.setLevel(U[0].getLevel())}setLevel(U){for(const V of this.g)V.setLevel(U);super.setLevel(U)}trace(U,...V){for(const X of this.g)X.trace(U,...V)}debug(U,...V){for(const X of this.g)X.debug(U,...V)}info(U,...V){for(const X of this.g)X.info(U,...V)}warn(U,...V){for(const X of this.g)X.warn(U,...V)}error(U,...V){for(const X of this.g)X.error(U,...V)}flush(){for(const U of this.g)U.flush()}dispose(){for(const U of this.g)U.dispose();super.dispose()}}e.$Yj=t;class n extends D.$Uc{constructor(U,V,X){if(super(),this.h=U,this.j=V,this.b=new E.$Bc,this.c=this.B(new k.$7d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new k.$7d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new k.$7d),this.onDidChangeVisibility=this.g.event,X)for(const se of X)this.b.set(se.resource,{logger:void 0,info:se})}m(U){return(0,w.$Vf)(U)?[...this.b.values()].find(V=>V.info.id===U):this.b.get(U)}getLogger(U){return this.m(U)?.logger}createLogger(U,V){const X=this.n(U),se=(0,w.$Vf)(U)?U:V?.id??(0,A.$9i)(X.toString()).toString(16);let ie=this.b.get(X)?.logger;const ue=V?.logLevel==="always"?m.Trace:V?.logLevel;ie||(ie=this.s(X,ue??this.getLogLevel(X)??this.h,{...V,id:se}));const he={logger:ie,info:{resource:X,id:se,logLevel:ue,name:V?.name,hidden:V?.hidden,extensionId:V?.extensionId,when:V?.when}};return this.registerLogger(he.info),this.b.set(X,he),ie}n(U){return(0,w.$Vf)(U)?(0,a.$Vg)(this.j,`${U}.log`):U}setLogLevel(U,V){if(v.URI.isUri(U)){const X=U,se=V,ie=this.b.get(X);ie&&se!==ie.info.logLevel&&(ie.info.logLevel=se===this.h?void 0:se,ie.logger?.setLevel(se),this.b.set(ie.info.resource,ie),this.f.fire([X,se]))}else{this.h=U;for(const[X,se]of this.b.entries())this.b.get(X)?.info.logLevel===void 0&&se.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(U,V){const X=this.m(U);X&&V!==!X.info.hidden&&(X.info.hidden=!V,this.b.set(X.info.resource,X),this.g.fire([X.info.resource,V]))}getLogLevel(U){let V;return U&&(V=this.b.get(U)?.info.logLevel),V??this.h}registerLogger(U){const V=this.b.get(U.resource);V?V.info.hidden!==U.hidden&&this.setVisibility(U.resource,!U.hidden):(this.b.set(U.resource,{info:U,logger:void 0}),this.c.fire({added:[U],removed:[]}))}deregisterLogger(U){const V=this.b.get(U);V&&(V.logger&&V.logger.dispose(),this.b.delete(U),this.c.fire({added:[],removed:[V.info]}))}*getRegisteredLoggers(){for(const U of this.b.values())yield U.info}getRegisteredLogger(U){return this.b.get(U)?.info}dispose(){this.b.forEach(U=>U.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Zj=n;class s{constructor(){this.onDidChangeLogLevel=new k.$7d().event}setLevel(U){}getLevel(){return m.Info}trace(U,...V){}debug(U,...V){}info(U,...V){}warn(U,...V){}error(U,...V){}critical(U,...V){}dispose(){}flush(){}}e.$1j=s;class o extends s{}e.$2j=o;function l(z){if(z.verbose)return m.Trace;if(typeof z.logLevel=="string"){const U=L(z.logLevel.toLowerCase());if(U!==void 0)return U}return e.$Rj}function P(z){switch(z){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function I(z){switch(z){case m.Trace:return{original:"Trace",value:j.localize(0,null)};case m.Debug:return{original:"Debug",value:j.localize(1,null)};case m.Info:return{original:"Info",value:j.localize(2,null)};case m.Warning:return{original:"Warning",value:j.localize(3,null)};case m.Error:return{original:"Error",value:j.localize(4,null)};case m.Off:return{original:"Off",value:j.localize(5,null)}}}function L(z){switch(z){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$7j=new d.$zj("logLevel",P(m.Info))}),define(ne[65],re([0,1,8,10,6]),function(J,e,j,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=void 0,e.$Xp=(0,R.$ii)("IExtensionSignatureVerificationService");let A=class{constructor(E){this.b=E}c(){return this.a||(this.a=new Promise((E,u)=>J(["@vscode/vsce-sign"],async a=>E(a),u))),this.a}async verify(E,u,a){let w;try{w=await this.c()}catch(v){return this.b.error("Could not load vsce-sign module",(0,j.$0)(v)),!1}return w.verify(E,u,a)}};e.$Yp=A,e.$Yp=A=$e([oe(0,k.$Oj)],A)}),define(ne[128],re([0,1,19,9,8,5,2,16,52,6]),function(J,e,j,R,k,A,D,E,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=void 0;class w extends D.$Uc{constructor(d,$){super(),this.a=d,this.b=$,this.c=this.B(new A.$7d),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$7d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new R.$gh(0)),this.w=[],this.y=this.B(new R.$gh(0))}watch(d,$){return $.recursive||this.b?.watcher?.forceUniversal?this.n(d,$):this.z(d,$)}n(d,$){const b={path:this.H(d),excludes:$.excludes,includes:$.includes,recursive:$.recursive,correlationId:$.correlationId},O=(0,j.$Ub)(this.j,b);return this.r(),(0,D.$Sc)(()=>{O(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(d=>(0,k.$1)(d))}s(){this.h||(this.h=this.B(this.t($=>this.c.fire((0,u.$Aq)($)),$=>this.G($),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)})));const d=this.b?.watcher?.recursive?.usePolling;if(d===!0)for(const $ of this.j)(0,u.$wq)($)&&($.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const $ of this.j)(0,u.$wq)($)&&d.includes($.path)&&($.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(d,$){const b={path:this.H(d),excludes:$.excludes,includes:$.includes,recursive:!1,correlationId:$.correlationId},O=(0,j.$Ub)(this.w,b);return this.C(),(0,D.$Sc)(()=>{O(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(d=>(0,k.$1)(d))}D(){return this.u||(this.u=this.B(this.F(d=>this.c.fire((0,u.$Aq)(d)),d=>this.G(d),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)}))),this.u.watch(this.w)}G(d){d.type==="error"&&this.g.fire(d.message),this.a[d.type](d.message)}H(d){return(0,E.$ic)(d.fsPath)}}e.$Eq=w}),define(ne[129],re([0,1,19,9,14,20,5,43,66,2,48,15,130,17,46,102,13,62,6,8]),function(J,e,j,R,k,A,D,E,u,a,w,v,d,$,b,O,m,c,y,p){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=void 0;let g=class extends a.$Uc{static{h=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new D.$7d),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$7d),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$7d),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new D.$7d),this.onDidRunOperation=this.r.event,this.X=this.B(new D.$7d),this.Y=this.B(new D.$7d),this.onDidFilesChange=this.Y.event,this.Z=this.B(new D.$7d),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new R.$rh)}registerProvider(r,t){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${r}`);const n=new a.$Tc;return this.h.set(r,t),this.c.fire({added:!0,scheme:r,provider:t}),n.add(t.onDidChangeFile(s=>{const o=new m.$8k(s,!this.S(t));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof t.onDidWatchError=="function"&&n.add(t.onDidWatchError(s=>this.Z.fire(new Error(s)))),n.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:r}))),(0,a.$Sc)(()=>{this.c.fire({added:!1,scheme:r,provider:t}),this.h.delete(r),(0,a.$Pc)(n)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const t=[];this.f.fire({scheme:r,join(n){t.push(n)}}),!this.h.has(r)&&await R.Promises.settled(t)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,t){const n=this.h.get(r.scheme);return!!(n&&n.capabilities&t)}listCapabilities(){return u.Iterable.map(this.h,([r,t])=>({scheme:r,capabilities:t.capabilities}))}async j(r){if(!(0,$.$Zg)(r))throw new m.$0k((0,O.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const t=this.h.get(r.scheme);if(!t){const n=new p.$bb;throw n.message=(0,O.localize)(1,null,r.toString()),n}return t}async m(r){const t=await this.j(r);if((0,m.$Uk)(t)||(0,m.$Rk)(t)||(0,m.$Vk)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const t=await this.j(r);if((0,m.$Uk)(t)||(0,m.$Rk)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,t){try{return await this.s(r,t)}catch(n){throw(0,m.$5k)(n)===m.FileSystemProviderErrorCode.FileNotFound?new m.$0k((0,O.localize)(2,null,this.sb(r)),1):(0,m.$3k)(n)}}async s(r,t){const n=await this.j(r),s=this.S(n),o=t?.resolveTo,l=t?.resolveSingleChildDescendants,P=t?.resolveMetadata,I=await n.stat(r);let L;return this.t(n,r,I,void 0,!!P,(z,U)=>(L||(L=w.$oi.forUris(()=>!s),L.set(r,!0),o&&L.fill(!0,o)),L.get(z.resource)||L.findSuperstr(z.resource.with({query:null,fragment:null}))?!0:z.isDirectory&&l?U===1:!1))}async t(r,t,n,s,o,l){const{providerExtUri:P}=this.R(r),I={resource:t,name:P.basename(t),isFile:(n.type&m.FileType.File)!==0,isDirectory:(n.type&m.FileType.Directory)!==0,isSymbolicLink:(n.type&m.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&m.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((n.permissions??0)&m.FilePermission.Locked),etag:(0,m.$il)({mtime:n.mtime,size:n.size}),children:void 0};if(I.isDirectory&&l(I,s)){try{const L=await r.readdir(t),z=await R.Promises.settled(L.map(async([U,V])=>{try{const X=P.joinPath(t,U),se=o?await r.stat(X):{type:V};return await this.t(r,X,se,L.length,o,l)}catch(X){return this.b.trace(X),null}}));I.children=(0,j.$Hb)(z)}catch(L){this.b.trace(L),I.children=[]}return I}return I}async resolveAll(r){return R.Promises.settled(r.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(r){const t=await this.j(r),n=await t.stat(r);return this.t(t,r,n,void 0,!0,()=>!1)}async exists(r){const t=await this.j(r);try{return!!await t.stat(r)}catch{return!1}}async canCreateFile(r,t){try{await this.u(r,t)}catch(n){return n}return!0}async u(r,t){if(!t?.overwrite&&await this.exists(r))throw new m.$0k((0,O.localize)(3,null,this.sb(r)),3,t)}async createFile(r,t=k.$ue.fromString(""),n){await this.u(r,n);const s=await this.writeFile(r,t);return this.r.fire(new m.$7k(r,0,s)),s}async writeFile(r,t,n){const s=this.qb(await this.n(r),r),{providerExtUri:o}=this.R(s);let l=n;if((0,m.$Xk)(s)&&!l?.atomic){const P=s.enforceAtomicWriteFile?.(r);P&&(l={...n,atomic:P})}try{await this.w(s,r,l)||await this.U(s,o.dirname(r));let I;if((0,m.$Rk)(s)&&!(t instanceof k.$ue))if((0,b.$ge)(t)){const L=await(0,b.$ne)(t,3);L.ended?I=k.$ue.concat(L.buffer):I=L}else I=(0,b.$ke)(t,L=>k.$ue.concat(L),3);else I=t;!(0,m.$Uk)(s)||(0,m.$Rk)(s)&&I instanceof k.$ue||(0,m.$Rk)(s)&&(0,m.$Xk)(s)&&l?.atomic?await this.hb(s,r,l,I):await this.db(s,r,l,I instanceof k.$ue?(0,k.$Fe)(I):I),this.r.fire(new m.$7k(r,4))}catch(P){throw new m.$0k((0,O.localize)(4,null,this.sb(r),(0,m.$3k)(P).toString()),(0,m.$6k)(P),l)}return this.resolve(r,{resolveMetadata:!0})}async w(r,t,n){const s=!!n?.unlock;if(s&&!(r.capabilities&8192))throw new Error((0,O.localize)(5,null,this.sb(t)));if(!!n?.atomic){if(!(r.capabilities&32768))throw new Error((0,O.localize)(6,null,this.sb(t)));if(!(r.capabilities&2))throw new Error((0,O.localize)(7,null,this.sb(t)));if(s)throw new Error((0,O.localize)(8,null,this.sb(t)))}let l;try{l=await r.stat(t)}catch{return}if(l.type&m.FileType.Directory)throw new m.$0k((0,O.localize)(9,null,this.sb(t)),0,n);if(this.rb(t,l),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==m.$hl&&typeof l.mtime=="number"&&typeof l.size=="number"&&n.mtime<l.mtime&&n.etag!==(0,m.$il)({mtime:n.mtime,size:l.size}))throw new m.$0k((0,O.localize)(10,null),3,n);return l}async readFile(r,t,n){const s=await this.m(r);return t?.atomic?this.z(s,r,t,n):this.C(s,r,t,n)}async z(r,t,n,s){return new Promise((o,l)=>{this.cb.queueFor(t,async()=>{try{const P=await this.C(r,t,n,s);o(P)}catch(P){l(P)}},this.R(r).providerExtUri)})}async C(r,t,n,s){const o=await this.D(r,t,{...n,preferUnbuffered:!0},s);return{...o,value:await(0,k.$Ge)(o.value)}}async readFileStream(r,t,n){const s=await this.m(r);return this.D(s,r,t,n)}async D(r,t,n,s){const o=new A.$ee(s);let l=n;(0,m.$Wk)(r)&&r.enforceAtomicReadFile?.(t)&&(l={...n,atomic:!0});const P=this.J(t,l).then(L=>L,L=>{throw o.dispose(!0),L});let I;try{return typeof l?.etag=="string"&&l.etag!==m.$hl&&await P,l?.atomic&&(0,m.$Wk)(r)||!((0,m.$Uk)(r)||(0,m.$Vk)(r))||(0,m.$Rk)(r)&&l?.preferUnbuffered?I=this.I(r,t,l):(0,m.$Vk)(r)?I=this.G(r,t,o.token,l):I=this.H(r,t,o.token,l),I.on("end",()=>o.dispose()),I.on("error",()=>o.dispose()),{...await P,value:I}}catch(L){throw I&&await(0,b.$le)(I),this.F(L,t,l)}}F(r,t,n){const s=(0,O.localize)(11,null,this.sb(t),(0,m.$3k)(r).toString());return r instanceof m.$_k?new m.$_k(s,r.stat,n):r instanceof m.$$k?new m.$$k(s,r.fileOperationResult,r.size,r.options):new m.$0k(s,(0,m.$6k)(r),n)}G(r,t,n,s=Object.create(null)){const o=r.readFileStream(t,s,n);return(0,b.$re)(o,{data:l=>l instanceof k.$ue?l:k.$ue.wrap(l),error:l=>this.F(l,t,s)},l=>k.$ue.concat(l))}H(r,t,n,s=Object.create(null)){const o=(0,k.$Ke)();return(0,c.$tq)(r,t,o,l=>l,{...s,bufferSize:this.a,errorTransformer:l=>this.F(l,t,s)},n),o}I(r,t,n){const s=(0,b.$ie)(o=>k.$ue.concat(o));return(async()=>{try{let o;n?.atomic&&(0,m.$Wk)(r)?o=await r.readFile(t,{atomic:!0}):o=await r.readFile(t),typeof n?.position=="number"&&(o=o.slice(n.position)),typeof n?.length=="number"&&(o=o.slice(0,n.length)),this.L(t,o.byteLength,n),s.end(k.$ue.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async J(r,t){const n=await this.resolve(r,{resolveMetadata:!0});if(n.isDirectory)throw new m.$0k((0,O.localize)(12,null,this.sb(r)),0,t);if(typeof t?.etag=="string"&&t.etag!==m.$hl&&t.etag===n.etag)throw new m.$_k((0,O.localize)(13,null),n,t);return this.L(r,n.size,t),n}L(r,t,n){if(typeof n?.limits?.size=="number"&&t>n.limits.size)throw new m.$$k((0,O.localize)(14,null,this.sb(r)),7,t,n)}async canMove(r,t,n){return this.M(r,t,"move",n)}async canCopy(r,t,n){return this.M(r,t,"copy",n)}async M(r,t,n,s){if(r.toString()!==t.toString())try{const o=n==="move"?this.qb(await this.n(r),r):await this.m(r),l=this.qb(await this.n(t),t);await this.Q(o,r,l,t,n,s)}catch(o){return o}return!0}async move(r,t,n){const s=this.qb(await this.n(r),r),o=this.qb(await this.n(t),t),l=await this.N(s,r,o,t,"move",!!n),P=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new m.$7k(r,l==="move"?2:3,P)),P}async copy(r,t,n){const s=await this.m(r),o=this.qb(await this.n(t),t),l=await this.N(s,r,o,t,"copy",!!n),P=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new m.$7k(r,l==="copy"?3:2,P)),P}async N(r,t,n,s,o,l){if(t.toString()===s.toString())return o;const{exists:P,isSameResourceWithDifferentPathCase:I}=await this.Q(r,t,n,s,o,l);if(P&&!I&&l&&await this.del(s,{recursive:!0}),await this.U(n,this.R(n).providerExtUri.dirname(s)),o==="copy"){if(r===n&&(0,m.$Sk)(r))await r.copy(t,s,{overwrite:l});else{const L=await this.resolve(t);L.isDirectory?await this.P(r,L,n,s):await this.O(r,t,n,s)}return o}else return r===n?(await r.rename(t,s,{overwrite:l}),o):(await this.N(r,t,n,s,"copy",l),await this.del(t,{recursive:!0}),"copy")}async O(r,t,n,s){if((0,m.$Uk)(r)&&(0,m.$Uk)(n))return this.jb(r,t,n,s);if((0,m.$Uk)(r)&&(0,m.$Rk)(n))return this.pb(r,t,n,s);if((0,m.$Rk)(r)&&(0,m.$Uk)(n))return this.nb(r,t,n,s);if((0,m.$Rk)(r)&&(0,m.$Rk)(n))return this.lb(r,t,n,s)}async P(r,t,n,s){await n.mkdir(s),Array.isArray(t.children)&&await R.Promises.settled(t.children.map(async o=>{const l=this.R(n).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.P(r,await this.resolve(o.resource),n,l):this.O(r,o.resource,n,l)}))}async Q(r,t,n,s,o,l){let P=!1;if(r===n){const{providerExtUri:L,isPathCaseSensitive:z}=this.R(r);if(z||(P=L.isEqual(t,s)),P&&o==="copy")throw new Error((0,O.localize)(15,null,this.sb(t),this.sb(s)));if(!P&&L.isEqualOrParent(s,t))throw new Error((0,O.localize)(16,null,this.sb(t),this.sb(s)))}const I=await this.exists(s);if(I&&!P){if(!l)throw new m.$0k((0,O.localize)(17,null,this.sb(t),this.sb(s)),4);if(r===n){const{providerExtUri:L}=this.R(r);if(L.isEqualOrParent(t,s))throw new Error((0,O.localize)(18,null,this.sb(t),this.sb(s)))}}return{exists:I,isSameResourceWithDifferentPathCase:P}}R(r){const t=this.S(r);return{providerExtUri:t?$.$Lg:$.$Ng,isPathCaseSensitive:t}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const t=this.qb(await this.j(r),r);await this.U(t,r);const n=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new m.$7k(r,0,n)),n}async U(r,t){const n=[],{providerExtUri:s}=this.R(r);for(;!s.isEqual(t,s.dirname(t));)try{if(!((await r.stat(t)).type&m.FileType.Directory))throw new Error((0,O.localize)(19,null,this.sb(t)));break}catch(o){if((0,m.$5k)(o)!==m.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(s.basename(t)),t=s.dirname(t)}for(let o=n.length-1;o>=0;o--){t=s.joinPath(t,n[o]);try{await r.mkdir(t)}catch(l){if((0,m.$5k)(l)!==m.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(r,t){try{await this.W(r,t)}catch(n){return n}return!0}async W(r,t){const n=this.qb(await this.j(r),r),s=!!t?.useTrash;if(s&&!(n.capabilities&4096))throw new Error((0,O.localize)(20,null,this.sb(r)));const o=t?.atomic;if(o&&!(n.capabilities&65536))throw new Error((0,O.localize)(21,null,this.sb(r)));if(s&&o)throw new Error((0,O.localize)(22,null,this.sb(r)));let l;try{l=await n.stat(r)}catch{}if(l)this.rb(r,l);else throw new m.$0k((0,O.localize)(23,null,this.sb(r)),1);if(!!!t?.recursive){const I=await this.resolve(r);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,O.localize)(24,null,this.sb(r)))}return n}async del(r,t){const n=await this.W(r,t);let s=t;if((0,m.$Yk)(n)&&!s?.atomic){const I=n.enforceAtomicDelete?.(r);I&&(s={...t,atomic:I})}const o=!!s?.useTrash,l=!!s?.recursive,P=s?.atomic??!1;await n.delete(r,{recursive:l,useTrash:o,atomic:P}),this.r.fire(new m.$7k(r,1))}async cloneFile(r,t){const n=await this.j(r),s=this.qb(await this.n(t),t);if(!(n===s&&this.R(n).providerExtUri.isEqual(r,t)))return n===s&&(0,m.$Tk)(n)?n.cloneFile(r,t):(await this.U(s,this.R(s).providerExtUri.dirname(t)),n===s&&(0,m.$Sk)(n)?this.cb.queueFor(r,()=>n.copy(r,t,{overwrite:!0}),this.R(n).providerExtUri):this.cb.queueFor(r,()=>this.O(n,r,s,t),this.R(n).providerExtUri))}static{this.ab=0}createWatcher(r,t){return this.watch(r,{...t,correlationId:h.ab++})}watch(r,t={recursive:!1,excludes:[]}){const n=new a.$Tc;let s=!1,o=()=>{s=!0};n.add((0,a.$Sc)(()=>o())),(async()=>{try{const P=await this.bb(r,t);s?(0,a.$Pc)(P):o=()=>(0,a.$Pc)(P)}catch(P){this.b.error(P)}})();const l=t.correlationId;if(typeof l=="number"){const P=n.add(new D.$7d);return n.add(this.X.event(L=>{L.correlates(l)&&P.fire(L)})),{onDidChange:P.event,dispose:()=>n.dispose()}}return n}async bb(r,t){const n=await this.j(r),s=(0,E.$9i)([this.R(n).providerExtUri.getComparisonKey(r),t]);let o=this.$.get(s);return o||(o={count:0,disposable:n.watch(r,t)},this.$.set(s,o)),o.count+=1,(0,a.$Sc)(()=>{o&&(o.count--,o.count===0&&((0,a.$Pc)(o.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,a.$Pc)(r.disposable);this.$.clear()}async db(r,t,n,s){return this.cb.queueFor(t,async()=>{const o=await r.open(t,{create:!0,unlock:n?.unlock??!1});try{(0,b.$ge)(s)||(0,b.$he)(s)?await this.eb(r,o,s):await this.fb(r,o,s)}catch(l){throw(0,m.$3k)(l)}finally{await r.close(o)}},this.R(r).providerExtUri)}async eb(r,t,n){let s=0,o;if((0,b.$he)(n)){if(n.buffer.length>0){const l=k.$ue.concat(n.buffer);await this.gb(r,t,l,l.byteLength,s,0),s+=l.byteLength}if(n.ended)return;o=n.stream}else o=n;return new Promise((l,P)=>{(0,b.$me)(o,{onData:async I=>{o.pause();try{await this.gb(r,t,I,I.byteLength,s,0)}catch(L){return P(L)}s+=I.byteLength,setTimeout(()=>o.resume())},onError:I=>P(I),onEnd:()=>l()})})}async fb(r,t,n){let s=0,o;for(;(o=n.read())!==null;)await this.gb(r,t,o,o.byteLength,s,0),s+=o.byteLength}async gb(r,t,n,s,o,l){let P=0;for(;P<s;){const I=await r.write(t,o+P,n.buffer,l+P,s-P);P+=I}}async hb(r,t,n,s){return this.cb.queueFor(t,()=>this.ib(r,t,n,s),this.R(r).providerExtUri)}async ib(r,t,n,s){let o;s instanceof k.$ue?o=s:(0,b.$ge)(s)?o=await(0,k.$Ge)(s):(0,b.$he)(s)?o=await(0,k.$He)(s):o=(0,k.$Ee)(s),await r.writeFile(t,o.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async jb(r,t,n,s){return this.cb.queueFor(s,()=>this.kb(r,t,n,s),this.R(n).providerExtUri)}async kb(r,t,n,s){let o,l;try{o=await r.open(t,{create:!1}),l=await n.open(s,{create:!0,unlock:!1});const P=k.$ue.alloc(this.a);let I=0,L=0,z=0;do z=await r.read(o,I,P.buffer,L,P.byteLength-L),await this.gb(n,l,P,z,I,L),I+=z,L+=z,L===P.byteLength&&(L=0);while(z>0)}catch(P){throw(0,m.$3k)(P)}finally{await R.Promises.settled([typeof o=="number"?r.close(o):Promise.resolve(),typeof l=="number"?n.close(l):Promise.resolve()])}}async lb(r,t,n,s){return this.cb.queueFor(s,()=>this.mb(r,t,n,s),this.R(n).providerExtUri)}async mb(r,t,n,s){return n.writeFile(s,await r.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,t,n,s){return this.cb.queueFor(s,()=>this.ob(r,t,n,s),this.R(n).providerExtUri)}async ob(r,t,n,s){const o=await n.open(s,{create:!0,unlock:!1});try{const l=await r.readFile(t);await this.gb(n,o,k.$ue.wrap(l),l.byteLength,0,0)}catch(l){throw(0,m.$3k)(l)}finally{await n.close(o)}}async pb(r,t,n,s){const o=await(0,k.$Ge)(this.H(r,t,A.CancellationToken.None));await this.hb(n,s,void 0,o)}qb(r,t){if(r.capabilities&2048)throw new m.$0k((0,O.localize)(25,null,this.sb(t)),6);return r}rb(r,t){if((t.permissions??0)&m.FilePermission.Readonly)throw new m.$0k((0,O.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===v.Schemas.file?r.fsPath:r.toString(!0)}};e.$uq=g,e.$uq=g=h=$e([oe(0,y.$Oj)],g)}),define(ne[131],re([0,1,60,174,9,31,14,5,124,2,16,12,17,46,24,104,13,62,128,34,126,125]),function(J,e,j,R,k,A,D,E,u,a,w,v,d,$,b,O,m,c,y,p,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0,(()=>{try{(0,R.gracefulify)(j)}catch(r){console.error(`Error enabling graceful-fs: ${(0,p.$6i)(r)}`)}})();class i extends y.$Eq{static{this.I=!1}constructor(t,n){super(t,n),this.onDidChangeCapabilities=E.Event.None,this.N=new A.$Bc(s=>d.$Mg.getComparisonKey(s)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,v.$k&&(this.J|=1024)),this.J}async stat(t){try{const{stat:n,symbolicLink:s}=await b.SymlinkSupport.stat(this.H(t));return{type:this.M(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:m.FilePermission.Locked}}catch(n){throw this.fb(n)}}async L(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const n=await b.Promises.readdir(this.H(t),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async o=>{try{let l;o.isSymbolicLink()?l=(await this.stat((0,d.$Vg)(t,o.name))).type:l=this.M(o),s.push([o.name,l])}catch(l){this.a.trace(l)}})),s}catch(n){throw this.fb(n)}}M(t,n){let s;return n?.dangling?s=m.FileType.Unknown:t.isFile()?s=m.FileType.File:t.isDirectory()?s=m.FileType.Directory:s=m.FileType.Unknown,n&&(s|=m.FileType.SymbolicLink),s}async O(t){const n=this.H(t);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.N.get(t);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const o=new k.$hh;return this.N.set(t,o),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,a.$Sc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.N.get(t)===o&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.N.delete(t)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),o.open()})}async readFile(t,n){let s;try{n?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(t)})`),s=await this.O(t));const o=this.H(t);return await b.Promises.readFile(o)}catch(o){throw this.fb(o)}finally{s?.dispose()}}P(t){i.I&&this.a.trace(t)}readFileStream(t,n,s){const o=(0,$.$ie)(l=>D.$ue.concat(l.map(P=>D.$ue.wrap(P))).buffer);return(0,c.$tq)(this,t,o,l=>l.buffer,{...n,bufferSize:256*1024},s),o}async writeFile(t,n,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.Q(t)?this.R(t,(0,d.$Vg)((0,d.$Ug)(t),`${(0,d.$Sg)(t)}${s.atomic.postfix}`),n,s):this.S(t,n,s)}async Q(t){try{const n=this.H(t),{symbolicLink:s}=await b.SymlinkSupport.stat(n);if(s)return!1}catch{}return!0}async R(t,n,s,o){const l=new a.$Tc;try{l.add(await this.O(t)),l.add(await this.O(n)),await this.S(n,s,o,!0);try{await this.rename(n,t,{overwrite:!0})}catch(P){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw P}}finally{l.dispose()}}async S(t,n,s,o){let l;try{const P=this.H(t);if(!s.create||!s.overwrite){if(await b.Promises.exists(P)){if(!s.overwrite)throw(0,m.$2k)((0,O.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,m.$2k)((0,O.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(t,{create:!0,unlock:s.unlock},o),await this.write(l,0,n,0,n.byteLength)}catch(P){throw await this.gb(t,P)}finally{typeof l=="number"&&await this.close(l)}}static{this.Y=!0}static configureFlushOnWrite(t){i.Y=t}async open(t,n,s){const o=this.H(t);let l;(0,m.$Pk)(n)&&!s&&(l=await this.O(t));let P;try{if((0,m.$Pk)(n)&&n.unlock)try{const{stat:L}=await b.SymlinkSupport.stat(o);L.mode&128||await b.Promises.chmod(o,L.mode|128)}catch(L){L.code!=="ENOENT"&&this.a.trace(L)}let I;if((0,m.$Pk)(n)){if(v.$i)try{await b.Promises.truncate(o,0),I="r+"}catch(L){L.code!=="ENOENT"&&this.a.trace(L)}I||(I="w")}else I="r";P=await b.Promises.open(o,I)}catch(I){throw l?.dispose(),(0,m.$Pk)(n)?await this.gb(t,I):this.fb(I)}if(this.U.set(P,0),(0,m.$Pk)(n)&&this.X.set(P,t),l){const I=this.W.get(P);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${P} (${o})`),this.W.set(P,l),I&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${P} (${o})`),I.dispose())}return P}async close(t){const n=this.W.get(t);try{if(this.U.delete(t),this.X.delete(t)&&i.Y)try{await b.Promises.fdatasync(t)}catch(s){i.configureFlushOnWrite(!1),this.a.error(s)}return await b.Promises.close(t)}catch(s){throw this.fb(s)}finally{n&&(this.W.get(t)===n&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.W.delete(t)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,s,o,l){const P=this.Z(t,n);let I=null;try{I=(await b.Promises.read(t,s,o,l,P)).bytesRead}catch(L){throw this.fb(L)}finally{this.$(t,P,I)}return I}Z(t,n){return n===this.U.get(t)?null:n}$(t,n,s){const o=this.U.get(t);typeof o=="number"&&(typeof n=="number"||(typeof s=="number"?this.U.set(t,o+s):this.U.delete(t)))}async write(t,n,s,o,l){return(0,k.$Ch)(()=>this.ab(t,n,s,o,l),100,3)}async ab(t,n,s,o,l){const P=this.Z(t,n);let I=null;try{I=(await b.Promises.write(t,s,o,l,P)).bytesWritten}catch(L){throw await this.gb(this.X.get(t),L)}finally{this.$(t,P,I)}return I}async mkdir(t){try{await b.Promises.mkdir(this.H(t))}catch(n){throw this.fb(n)}}async delete(t,n){try{const s=this.H(t);if(n.recursive){let o;n?.atomic!==!1&&n.atomic.postfix&&(o=(0,w.$kc)((0,w.$nc)(s),`${(0,w.$oc)(s)}${n.atomic.postfix}`)),await b.Promises.rm(s,b.RimRafMode.MOVE,o)}else try{await b.Promises.unlink(s)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let l=!1;try{const{stat:P,symbolicLink:I}=await b.SymlinkSupport.stat(s);l=P.isDirectory()&&!I}catch{}if(l)await b.Promises.rmdir(s);else throw o}else throw o}}catch(s){throw this.fb(s)}}async rename(t,n,s){const o=this.H(t),l=this.H(n);if(o!==l)try{await this.bb(t,n,"move",s.overwrite),await b.Promises.rename(o,l)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,O.localize)(2,null,(0,w.$oc)(o),(0,w.$oc)((0,w.$nc)(l)),P.toString()))),this.fb(P)}}async copy(t,n,s){const o=this.H(t),l=this.H(n);if(o!==l)try{await this.bb(t,n,"copy",s.overwrite),await b.Promises.copy(o,l,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,O.localize)(3,null,(0,w.$oc)(o),(0,w.$oc)((0,w.$nc)(l)),P.toString()))),this.fb(P)}}async bb(t,n,s,o){const l=this.H(t),P=this.H(n);let I=!1;if(!!(this.capabilities&1024)||(I=(0,u.$hg)(l,P,!0)),I){if(s==="copy")throw(0,m.$2k)((0,O.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const z=await this.L(t);if(!z)throw(0,m.$2k)((0,O.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const U=await this.L(n);if(U){if(!o)throw(0,m.$2k)((0,O.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);z.type&m.FileType.File&&U.type&m.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,n){return this.cb(t,n,!1)}async cb(t,n,s){const o=this.H(t),l=this.H(n),P=!!(this.capabilities&1024);if((0,u.$hg)(o,l,!P))return;const I=new a.$Tc;try{I.add(await this.O(t)),I.add(await this.O(n)),s&&await b.Promises.mkdir((0,w.$nc)(l),{recursive:!0}),await b.Promises.copyFile(o,l)}catch(L){if(L.code==="ENOENT"&&!s)return this.cb(t,n,!0);throw this.fb(L)}finally{I.dispose()}}t(t,n,s){return new h.$Lq(o=>t(o),o=>n(o),s)}F(t,n,s){return new g.$Uq(o=>t(o),o=>n(o),s)}fb(t){if(t instanceof m.$1k)return t;let n=t,s;switch(t.code){case"ENOENT":s=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=m.FileSystemProviderErrorCode.Unknown;break;default:s=m.FileSystemProviderErrorCode.Unknown}return(0,m.$2k)(n,s)}async gb(t,n){let s=this.fb(n);if(t&&s.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await b.SymlinkSupport.stat(this.H(t));o.mode&128||(s=(0,m.$2k)(n,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return s}}e.$Vq=i}),define(ne[132],re([0,1,2,6]),function(J,e,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4P=void 0;class k extends j.$Uc{constructor(D,E=[]){super(),this.a=new R.$Yj([D,...E]),this.B(D.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...E){this.a.trace(D,...E)}debug(D,...E){this.a.debug(D,...E)}info(D,...E){this.a.info(D,...E)}warn(D,...E){this.a.warn(D,...E)}error(D,...E){this.a.error(D,...E)}flush(){this.a.flush()}}e.$4P=k}),define(ne[133],re([0,1,13,6]),function(J,e,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SP=void 0;var k;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(k||(k={}));async function A(a,w,v,d,$){try{const b=await new Promise((m,c)=>{J(["@vscode/spdlog"],m,c)});b.setFlushOn(k.Trace);const O=await b.createAsyncRotatingLogger(a,w,v,d);return $?O.clearFormatters():O.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),O}catch(b){console.error(b)}return null}function D(a,w,v){switch(w){case R.LogLevel.Trace:a.trace(v);break;case R.LogLevel.Debug:a.debug(v);break;case R.LogLevel.Info:a.info(v);break;case R.LogLevel.Warning:a.warn(v);break;case R.LogLevel.Error:a.error(v);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${w}`)}}function E(a,w){switch(w){case R.LogLevel.Trace:a.setLevel(k.Trace);break;case R.LogLevel.Debug:a.setLevel(k.Debug);break;case R.LogLevel.Info:a.setLevel(k.Info);break;case R.LogLevel.Warning:a.setLevel(k.Warning);break;case R.LogLevel.Error:a.setLevel(k.Error);break;case R.LogLevel.Off:a.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${w}`)}}class u extends R.$Uj{constructor(w,v,d,$,b){super(),this.m=[],this.setLevel(b),this.n=this.s(w,v,d,$),this.B(this.onDidChangeLogLevel(O=>{this.r&&E(this.r,O)}))}async s(w,v,d,$){const b=d?6:1,O=30/b*j.$kl.MB,m=await A(w,v,O,b,$);if(m){this.r=m,E(this.r,this.getLevel());for(const{level:c,message:y}of this.m)D(this.r,c,y);this.m=[]}}g(w,v){this.r?D(this.r,w,v):this.getLevel()<=w&&this.m.push({level:w,message:v})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$SP=u}),define(ne[134],re([0,1,28,6,133]),function(J,e,j,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TP=void 0;class A extends R.$Zj{s(E,u,a){return new k.$SP((0,j.$Eg)(),E.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,u)}}e.$TP=A}),define(ne[39],re([0,1,5,66,2,10]),function(J,e,j,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=e.$4n=e.$3n=void 0,e.$3n=(0,A.$ii)("policy");class D extends k.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new j.$7d),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const w=Object.keys(this.f).length;return this.f={...a,...this.f},w!==Object.keys(this.f).length&&await this.j(a),R.Iterable.reduce(this.g.entries(),(v,[d,$])=>({...v,[d]:$}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(a,[w,v])=>({...a,[w]:{definition:v,value:this.g.get(w)}}),{})}}e.$4n=D;class E{constructor(){this.onDidChange=j.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$5n=E}),define(ne[135],re([0,1,9,5,66,3,13,6,39]),function(J,e,j,R,k,A,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rbc=void 0;function a(v,d){const $=[];for(const b of new Set(k.Iterable.concat(v.keys(),d.keys())))v.get(b)!==d.get(b)&&$.push(b);return $}let w=class extends u.$4n{constructor(d,$,b){super(),this.m=d,this.n=$,this.s=b,this.c=this.B(new j.$gh(500));const O=R.Event.filter($.onDidFilesChange,m=>m.affects(d));this.B($.watch(d)),this.B(O(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const d=new Map;try{const $=await this.n.readFile(this.m),b=JSON.parse($.value.toString());if(!(0,A.$Xf)(b))throw new Error("Policy file isn't a JSON object");for(const O of Object.keys(b))this.f[O]&&d.set(O,b[O])}catch($){$.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",$)}return d}async w(){const d=await this.u(),$=a(this.g,d);this.g=d,$.length>0&&this.h.fire($)}};e.$Rbc=w,e.$Rbc=w=$e([oe(1,D.$Ok),oe(2,E.$Oj)],w)}),define(ne[136],re([0,1,39,9,2,6]),function(J,e,j,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qbc=void 0;let D=class extends j.$4n{constructor(u,a){super(),this.m=u,this.n=a,this.a=new R.$ch,this.b=this.B(new k.$Vc)}async j(u){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(u).length} policy definitions`);const{createWatcher:a}=await new Promise((w,v)=>{J(["@vscode/policy-watcher"],w,v)});await this.a.queue(()=>new Promise((w,v)=>{try{this.b.value=a(this.n,u,d=>{this.t(d),w()})}catch(d){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),v(d)}}))}t(u){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(u)}`);for(const a in u){const w=u[a];w===void 0?this.g.delete(a):this.g.set(a,w)}this.h.fire(Object.keys(u))}};e.$Qbc=D,e.$Qbc=D=$e([oe(0,A.$Oj)],D)}),define(ne[32],re([0,1,10]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=e.$8j=void 0,e.$8j=(0,j.$ii)("productService"),e.$9j="vscode://schemas/vscode-product"}),define(ne[36],re([0,1,72,3]),function(J,e,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=void 0;class k{constructor(){this.a=new Map}add(D,E){j.ok(R.$Vf(D)),j.ok(R.$Xf(E)),j.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,E)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$1n=new k}),define(ne[137],re([0,1,5,36]),function(J,e,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=void 0,e.$2n={JSONContribution:"base.contributions.json"};function k(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class A{constructor(){this.b=new j.$7d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,a){this.a[k(u)]=a,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const D=new A;R.$1n.add(e.$2n.JSONContribution,D)}),define(ne[40],re([0,1,19,5,3,91,29,137,36]),function(J,e,j,R,k,A,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.ConfigurationScope=e.$6n=e.EditPresentationTypes=void 0,e.$eo=O,e.$fo=m,e.$go=c,e.$ho=p,e.$io=h;var a;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$6n={Configuration:"base.contributions.configuration"};var w;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(w||(e.ConfigurationScope=w={})),e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n={properties:{},patternProperties:{}},e.$$n={properties:{},patternProperties:{}},e.$_n={properties:{},patternProperties:{}},e.$ao="vscode://schemas/settings/resourceLanguage",e.$bo="vscode://schemas/settings/configurationDefaults";const v=u.$1n.as(E.$2n.JSONContribution);class d{constructor(){this.h=new Set,this.i=new R.$7d,this.onDidSchemaChange=this.i.event,this.j=new R.$7d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.$ao,this.g),this.v()}registerConfiguration(i,r=!0){this.registerConfigurations([i],r)}registerConfigurations(i,r=!0){const t=new Set;this.n(i,r,t),v.registerSchema(e.$ao,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(i){const r=new Set;this.o(i,r),v.registerSchema(e.$ao,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:i,remove:r}){const t=new Set;this.o(r,t),this.n(i,!1,t),v.registerSchema(e.$ao,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(i){const r=new Set;this.k(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(i,r){const t=[];for(const{overrides:n,source:s}of i)for(const o in n)if(r.add(o),e.$do.test(o)){const l=this.a.get(o),P=l?.valuesSources??new Map;if(s)for(const U of Object.keys(n[o]))P.set(U,s);const I={...l?.value||{},...n[o]};this.a.set(o,{source:s,value:I,valuesSources:P});const L=(0,D.$Yi)(o),z={type:"object",default:I,description:A.localize(1,null,L),$ref:e.$ao,defaultDefaultValue:I,source:k.$Vf(s)?void 0:s,defaultValueSource:s};t.push(...O(o)),this.d[o]=z,this.b.properties[o]=z}else{this.a.set(o,{value:n[o],source:s});const l=this.d[o];l&&(this.w(o,l),this.r(o,l))}this.m(t)}deregisterDefaultConfigurations(i){const r=new Set;this.l(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(i,r){for(const{overrides:t,source:n}of i)for(const s in t){const o=this.a.get(s),l=k.$Vf(n)?n:n?.id,P=k.$Vf(o?.source)?o?.source:o?.source?.id;if(l===P)if(r.add(s),this.a.delete(s),e.$do.test(s))delete this.d[s],delete this.b.properties[s];else{const I=this.d[s];I&&(this.w(s,I),this.r(s,I))}}this.u()}deltaConfiguration(i){let r=!1;const t=new Set;i.removedDefaults&&(this.l(i.removedDefaults,t),r=!0),i.addedDefaults&&(this.k(i.addedDefaults,t),r=!0),i.removedConfigurations&&this.o(i.removedConfigurations,t),i.addedConfigurations&&this.n(i.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const r of i)this.h.add(r);this.u()}n(i,r,t){i.forEach(n=>{this.p(n,r,n.extensionInfo,n.restrictedProperties,void 0,t),this.c.push(n),this.q(n)})}o(i,r){const t=n=>{if(n.properties)for(const s in n.properties){r.add(s);const o=this.d[s];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[s],this.s(s,n.properties[s])}n.allOf?.forEach(s=>t(s))};for(const n of i){t(n);const s=this.c.indexOf(n);s!==-1&&this.c.splice(s,1)}}p(i,r=!0,t,n,s=3,o){s=k.$5f(i.scope)?s:i.scope;const l=i.properties;if(l)for(const I in l){const L=l[I];if(r&&p(I,L)){delete l[I];continue}if(L.source=t,L.defaultDefaultValue=l[I].default,this.w(I,L),e.$do.test(I)?L.scope=void 0:(L.scope=k.$5f(L.scope)?s:L.scope,L.restricted=k.$5f(L.restricted)?!!n?.includes(I):L.restricted),l[I].hasOwnProperty("included")&&!l[I].included){this.f[I]=l[I],delete l[I];continue}else this.d[I]=l[I],l[I].policy?.name&&this.e.set(l[I].policy.name,I);!l[I].deprecationMessage&&l[I].markdownDeprecationMessage&&(l[I].deprecationMessage=l[I].markdownDeprecationMessage),o.add(I)}const P=i.allOf;if(P)for(const I of P)this.p(I,r,t,n,s,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const r=t=>{const n=t.properties;if(n)for(const o in n)this.r(o,n[o]);t.allOf?.forEach(r)};r(i)}r(i,r){switch(e.$7n.properties[i]=r,r.scope){case 1:e.$8n.properties[i]=r;break;case 2:e.$9n.properties[i]=r;break;case 6:e.$0n.properties[i]=r;break;case 3:e.$$n.properties[i]=r;break;case 4:e.$_n.properties[i]=r;break;case 5:e.$_n.properties[i]=r,this.g.properties[i]=r;break}}s(i,r){switch(delete e.$7n.properties[i],r.scope){case 1:delete e.$8n.properties[i];break;case 2:delete e.$9n.properties[i];break;case 6:delete e.$0n.properties[i];break;case 3:delete e.$$n.properties[i];break;case 4:case 5:delete e.$_n.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const r=`[${i}]`,t={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$ao};this.w(r,t),e.$7n.properties[r]=t,e.$8n.properties[r]=t,e.$9n.properties[r]=t,e.$0n.properties[r]=t,e.$$n.properties[r]=t,e.$_n.properties[r]=t}}v(){const i={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$ao};e.$7n.patternProperties[e.$co]=i,e.$8n.patternProperties[e.$co]=i,e.$9n.patternProperties[e.$co]=i,e.$0n.patternProperties[e.$co]=i,e.$$n.patternProperties[e.$co]=i,e.$_n.patternProperties[e.$co]=i,this.i.fire()}w(i,r){const t=this.a.get(i);let n=t?.value,s=t?.source;k.$3f(n)&&(n=r.defaultDefaultValue,s=void 0),k.$3f(n)&&(n=c(r.type)),r.default=n,r.defaultValueSource=s}}const $="\\[([^\\]]+)\\]",b=new RegExp($,"g");e.$co=`^(${$})+$`,e.$do=new RegExp(e.$co);function O(g){const i=[];if(e.$do.test(g)){let r=b.exec(g);for(;r?.length;){const t=r[1].trim();t&&i.push(t),r=b.exec(g)}}return(0,j.$Mb)(i)}function m(g){return g.reduce((i,r)=>`${i}[${r}]`,"")}function c(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const y=new d;u.$1n.add(e.$6n.Configuration,y);function p(g,i){return g.trim()?e.$do.test(g)?A.localize(7,null,g):y.getConfigurationProperties()[g]!==void 0?A.localize(8,null,g):i.policy?.name&&y.getPolicyConfigurations().get(i.policy?.name)!==void 0?A.localize(9,null,g,i.policy?.name,y.getPolicyConfigurations().get(i.policy?.name)):null:A.localize(6,null)}function h(){const g=[],i=y.getConfigurationProperties();for(const r of Object.keys(i))g.push([r,i[r].scope]);return g.push(["launch",4]),g.push(["task",4]),g}}),define(ne[67],re([0,1,19,5,38,2,31,27,3,11,29,40,36]),function(J,e,j,R,k,A,D,E,u,a,w,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$mo=e.$lo=e.$ko=e.$jo=void 0,e.$no=p;function $(r){return Object.isFrozen(r)?r:E.$Pn(r)}class b{constructor(t={},n=[],s=[],o){this.b=t,this.c=n,this.d=s,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(n=>{if(n instanceof b)return n;const s=new O("");return s.parseRaw(n),s.configurationModel});this.f=t.reduce((n,s)=>s===n?s:n.merge(s),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,w.$Wi)(this.contents,t):this.contents}inspect(t,n){const s=this;return{get value(){return $(s.rawConfiguration.getValue(t))},get override(){return n?$(s.rawConfiguration.getOverrideValue(t,n)):void 0},get merged(){return $(n?s.rawConfiguration.override(n).getValue(t):s.rawConfiguration.getValue(t))},get overrides(){const o=[];for(const{contents:l,identifiers:P,keys:I}of s.rawConfiguration.overrides){const L=new b(l,I).getValue(t);L!==void 0&&o.push({identifiers:P,value:L})}return o.length?$(o):void 0}}}getOverrideValue(t,n){const s=this.i(n);return s?t?(0,w.$Wi)(s,t):s:void 0}getKeysForOverrideIdentifier(t){const n=[];for(const s of this.overrides)s.identifiers.includes(t)&&n.push(...s.keys);return j.$Mb(n)}getAllOverrideIdentifiers(){const t=[];for(const n of this.overrides)t.push(...n.identifiers);return j.$Mb(t)}override(t){let n=this.a.get(t);return n||(n=this.g(t),this.a.set(t,n)),n}merge(...t){const n=E.$On(this.contents),s=E.$On(this.overrides),o=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const P of t)if(l.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.h(n,P.contents);for(const I of P.overrides){const[L]=s.filter(z=>j.$ub(z.identifiers,I.identifiers));L?(this.h(L.contents,I.contents),L.keys.push(...I.keys),L.keys=j.$Mb(L.keys)):s.push(E.$On(I))}for(const I of P.keys)o.indexOf(I)===-1&&o.push(I)}return new b(n,o,s,l.every(P=>P instanceof b)?void 0:l)}g(t){const n=this.i(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const s={};for(const o of j.$Mb([...Object.keys(this.contents),...Object.keys(n)])){let l=this.contents[o];const P=n[o];P&&(typeof l=="object"&&typeof P=="object"?(l=E.$On(l),this.h(l,P)):l=P),s[o]=l}return new b(s,this.keys,this.overrides)}h(t,n){for(const s of Object.keys(n)){if(s in t&&u.$Xf(t[s])&&u.$Xf(n[s])){this.h(t[s],n[s]);continue}t[s]=E.$On(n[s])}}i(t){let n=null,s=null;const o=l=>{l&&(s?this.h(s,l):s=E.$On(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===t?n=l.contents:l.identifiers.includes(t)&&o(l.contents);return o(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,n){this.j(t,n,!0)}setValue(t,n){this.j(t,n,!1)}removeValue(t){const n=this.keys.indexOf(t);n!==-1&&(this.keys.splice(n,1),(0,w.$Vi)(this.contents,t),v.$do.test(t)&&this.overrides.splice(this.overrides.findIndex(s=>j.$ub(s.identifiers,(0,v.$eo)(t))),1))}j(t,n,s){(0,w.$Ui)(this.contents,t,n,o=>console.error(o)),s=s||this.keys.indexOf(t)===-1,s&&this.keys.push(t),v.$do.test(t)&&this.overrides.push({identifiers:(0,v.$eo)(t),keys:Object.keys(this.contents[t]),contents:(0,w.$Ti)(this.contents[t],o=>console.error(o))})}}e.$jo=b;class O{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new b}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,n){if(!u.$5f(t)){const s=this.g(t);this.parseRaw(s,n)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,n){this.a=t;const{contents:s,keys:o,overrides:l,restricted:P,hasExcludedProperties:I}=this.h(t,n);this.b=new b(s,o,l,I?[t]:void 0),this.c=P||[]}g(t){let n={},s=null,o=[];const l=[],P=[];function I(z){Array.isArray(o)?o.push(z):s!==null&&(o[s]=z)}const L={onObjectBegin:()=>{const z={};I(z),l.push(o),o=z,s=null},onObjectProperty:z=>{s=z},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const z=[];I(z),l.push(o),o=z,s=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:I,onError:(z,U,V)=>{P.push({error:z,offset:U,length:V})}};if(t)try{k.$Cn(t,L),n=o[0]||{}}catch(z){console.error(`Error while parsing settings file ${this.f}: ${z}`),this.d=[z]}return n}h(t,n){const s=d.$1n.as(v.$6n.Configuration).getConfigurationProperties(),o=this.i(t,s,!0,n);t=o.raw;const l=(0,w.$Ti)(t,L=>console.error(`Conflict in settings file ${this.f}: ${L}`)),P=Object.keys(t),I=this.j(t,L=>console.error(`Conflict in settings file ${this.f}: ${L}`));return{contents:l,keys:P,overrides:I,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(t,n,s,o){let l=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:l};const P={},I=[];for(const L in t)if(v.$do.test(L)&&s){const z=this.i(t[L],n,!1,o);P[L]=z.raw,l=l||z.hasExcludedProperties,I.push(...z.restricted)}else{const z=n[L],U=z?typeof z.scope<"u"?z.scope:3:void 0;z?.restricted&&I.push(L),!o.exclude?.includes(L)&&(o.include?.includes(L)||(U===void 0||o.scopes===void 0||o.scopes.includes(U))&&!(o.skipRestricted&&z?.restricted))?P[L]=t[L]:l=!0}return{raw:P,restricted:I,hasExcludedProperties:l}}j(t,n){const s=[];for(const o of Object.keys(t))if(v.$do.test(o)){const l={};for(const P in t[o])l[P]=t[o][P];s.push({identifiers:(0,v.$eo)(o),keys:Object.keys(l),contents:(0,w.$Ti)(l,n)})}return s}}e.$ko=O;class m extends A.$Uc{constructor(t,n,s,o){super(),this.c=t,this.f=n,this.g=o,this.b=this.B(new R.$7d),this.onDidChange=this.b.event,this.a=new O(this.c.toString()),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&s.isEqual(l.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new b}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$lo=m;class c{constructor(t,n,s,o,l,P,I,L,z,U,V,X,se){this.a=t,this.b=n,this.c=s,this.overrideIdentifiers=o,this.d=l,this.f=P,this.g=I,this.h=L,this.i=z,this.j=U,this.k=V,this.l=X,this.m=se}get value(){return $(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class y{constructor(t,n,s,o,l=new b,P=new b,I=new D.$Bc,L=new b,z=new D.$Bc){this.c=t,this.d=n,this.f=s,this.g=o,this.h=l,this.i=P,this.j=I,this.l=L,this.m=z,this.a=null,this.b=new D.$Bc,this.n=null}getValue(t,n,s){return this.p(t,n,s).getValue(t)}updateValue(t,n,s={}){let o;s.resource?(o=this.m.get(s.resource),o||(o=new b,this.m.set(s.resource,o))):o=this.l,n===void 0?o.removeValue(t):o.setValue(t,n),s.resource||(this.a=null)}inspect(t,n,s){const o=this.p(t,n,s),l=this.t(n.resource,s),P=n.resource?this.m.get(n.resource)||this.l:this.l,I=new Set;for(const L of o.overrides)for(const z of L.identifiers)o.getOverrideValue(t,z)!==void 0&&I.add(z);return new c(t,n,o.getValue(t),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,l||void 0,P)}keys(t){const n=this.t(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,n){this.j.set(t,n),this.b.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=[];if(!n){const{added:o,updated:l,removed:P}=g(this.c,t);n=[...o,...l,...P]}for(const o of n)for(const l of(0,v.$eo)(o)){const P=this.c.getKeysForOverrideIdentifier(l),I=t.getKeysForOverrideIdentifier(l),L=[...I.filter(z=>P.indexOf(z)===-1),...P.filter(z=>I.indexOf(z)===-1),...P.filter(z=>!E.$Sn(this.c.override(l).getValue(z),t.override(l).getValue(z)))];s.push([l,L])}return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdatePolicyConfiguration(t){const{added:n,updated:s,removed:o}=g(this.d,t),l=[...n,...s,...o];return l.length&&this.updatePolicyConfiguration(t),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.applicationConfiguration,t),P=[...n,...s,...o];return P.length&&this.updateApplicationConfiguration(t),{keys:P,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.localUserConfiguration,t),P=[...n,...s,...o];return P.length&&this.updateLocalUserConfiguration(t),{keys:P,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.remoteUserConfiguration,t),P=[...n,...s,...o];return P.length&&this.updateRemoteUserConfiguration(t),{keys:P,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.workspaceConfiguration,t),P=[...n,...s,...o];return P.length&&this.updateWorkspaceConfiguration(t),{keys:P,overrides:l}}compareAndUpdateFolderConfiguration(t,n){const s=this.folderConfigurations.get(t),{added:o,updated:l,removed:P,overrides:I}=g(s,n),L=[...o,...l,...P];return(L.length||!s)&&this.updateFolderConfiguration(t,n),{keys:L,overrides:I}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:o,removed:l,overrides:P}=g(n,void 0);return{keys:[...s,...o,...l],overrides:P}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(t,n,s){let o=this.q(n,s);return n.overrideIdentifier&&(o=o.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(o=o.merge(this.d)),o}q({resource:t},n){let s=this.r();if(n&&t){const o=n.getFolder(t);o&&(s=this.s(o.uri)||s);const l=this.m.get(t);l&&(s=s.merge(l))}return s}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(t){let n=this.b.get(t);if(!n){const s=this.r(),o=this.j.get(t);o?(n=s.merge(o),this.b.set(t,n)):n=s}return n}t(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,n)=>{const{contents:s,overrides:o,keys:l}=this.j.get(n);return t.push([n,{contents:s,overrides:o,keys:l}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(n=>t.add(n)),this.userConfiguration.keys.forEach(n=>t.add(n)),this.i.keys.forEach(n=>t.add(n)),this.j.forEach(n=>n.keys.forEach(s=>t.add(s))),[...t.values()]}u(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(s=>t.add(s))),[...t.values()]}v(t){const n=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.i.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o))),[...n.values()]}static parse(t){const n=this.w(t.defaults),s=this.w(t.policy),o=this.w(t.application),l=this.w(t.user),P=this.w(t.workspace),I=t.folders.reduce((L,z)=>(L.set(a.URI.revive(z[0]),this.w(z[1])),L),new D.$Bc);return new y(n,s,o,l,new b,P,I,new b,new D.$Bc)}static w(t){return new b(t.contents,t.keys,t.overrides)}}e.$mo=y;function p(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,n=new Map;for(const o of r)o.keys.forEach(l=>t.add(l)),o.overrides.forEach(([l,P])=>{const I=(0,D.$yc)(n,l,new Set);P.forEach(L=>I.add(L))});const s=[];return n.forEach((o,l)=>s.push([l,[...o.values()]])),{keys:[...t.values()],overrides:s}}class h{constructor(t,n,s,o){this.change=t,this.f=n,this.g=s,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const l of t.keys)this.affectedKeys.add(l);for(const[,l]of t.overrides)for(const P of l)this.affectedKeys.add(P);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=y.parse(this.f.data)),this.i}affectsConfiguration(t,n){const s=this.a+t,o=this.d.indexOf(s);if(o<0)return!1;const l=o+s.length;if(l>=this.d.length)return!1;const P=this.d.charCodeAt(l);if(P!==this.b&&P!==this.c)return!1;if(n){const I=this.previousConfiguration?this.previousConfiguration.getValue(t,n,this.f?.workspace):void 0,L=this.g.getValue(t,n,this.h);return!E.$Sn(I,L)}return!0}}e.$oo=h;function g(r,t){const{added:n,removed:s,updated:o}=i(t?.rawConfiguration,r?.rawConfiguration),l=[],P=r?.getAllOverrideIdentifiers()||[],I=t?.getAllOverrideIdentifiers()||[];if(t){const L=I.filter(z=>!P.includes(z));for(const z of L)l.push([z,t.getKeysForOverrideIdentifier(z)])}if(r){const L=P.filter(z=>!I.includes(z));for(const z of L)l.push([z,r.getKeysForOverrideIdentifier(z)])}if(t&&r){for(const L of P)if(I.includes(L)){const z=i({contents:r.getOverrideValue(void 0,L)||{},keys:r.getKeysForOverrideIdentifier(L)},{contents:t.getOverrideValue(void 0,L)||{},keys:t.getKeysForOverrideIdentifier(L)});l.push([L,[...z.added,...z.removed,...z.updated]])}}return{added:n,removed:s,updated:o,overrides:l}}function i(r,t){const n=r?t?r.keys.filter(l=>t.keys.indexOf(l)===-1):[...r.keys]:[],s=t?r?t.keys.filter(l=>r.keys.indexOf(l)===-1):[...t.keys]:[],o=[];if(r&&t){for(const l of t.keys)if(r.keys.indexOf(l)!==-1){const P=(0,w.$Wi)(t.contents,l),I=(0,w.$Wi)(r.contents,l);E.$Sn(P,I)||o.push(l)}}return{added:n,removed:s,updated:o}}}),define(ne[138],re([0,1,19,5,2,27,3,67,40,6,39,36]),function(J,e,j,R,k,A,D,E,u,a,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=e.$qo=e.$po=void 0;class d extends k.$Uc{constructor(){super(...arguments),this.a=this.B(new R.$7d),this.onDidChangeConfiguration=this.a.event,this.b=new E.$jo}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(v.$1n.as(u.$6n.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:c})=>this.c(Array.from(m),c))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(m,c){this.h(m,v.$1n.as(u.$6n.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:m})}f(){return{}}g(){this.b=new E.$jo;const m=v.$1n.as(u.$6n.Configuration).getConfigurationProperties();this.h(Object.keys(m),m)}h(m,c){const y=this.f();for(const p of m){const h=y[p],g=c[p];h!==void 0?this.b.addValue(p,h):g?this.b.addValue(p,g.default):this.b.removeValue(p)}}}e.$po=d;class ${constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new E.$jo}async initialize(){return this.configurationModel}}e.$qo=$;let b=class extends k.$Uc{get configurationModel(){return this.b}constructor(m,c,y){super(),this.c=m,this.f=c,this.g=y,this.a=this.B(new R.$7d),this.onDidChangeConfiguration=this.a.event,this.b=new E.$jo}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(m=>this.j(m))),this.B(this.c.onDidChangeConfiguration(async({properties:m})=>this.m(await this.h(m),!0))),this.b}async h(m){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",m);const c={},y=[],p=v.$1n.as(u.$6n.Configuration).getConfigurationProperties();for(const h of m){const g=p[h];if(!g){y.push(h);continue}if(g.policy){if(g.type!=="string"&&g.type!=="number"){this.g.warn(`Policy ${g.policy.name} has unsupported type ${g.type}`);continue}y.push(h),c[g.policy.name]={type:g.type}}}return(0,D.$9f)(c)||await this.f.updatePolicyDefinitions(c),y}j(m){this.g.trace("PolicyConfiguration#onDidChangePolicies",m);const c=v.$1n.as(u.$6n.Configuration).getPolicyConfigurations(),y=(0,j.$Hb)(m.map(p=>c.get(p)));this.m(y,!0)}m(m,c){this.g.trace("PolicyConfiguration#update",m);const y=v.$1n.as(u.$6n.Configuration).getConfigurationProperties(),p=[],h=this.b.isEmpty();for(const g of m){const i=y[g]?.policy?.name;if(i){const r=this.f.getPolicyValue(i);(h?r!==void 0:!(0,A.$Sn)(this.b.getValue(g),r))&&p.push([g,r])}else this.b.getValue(g)!==void 0&&p.push([g,void 0])}if(p.length){this.g.trace("PolicyConfiguration#changed",p);const g=this.b;this.b=new E.$jo;for(const i of g.keys)this.b.setValue(i,g.getValue(i));for(const[i,r]of p)r===void 0?this.b.removeValue(i):this.b.setValue(i,r);c&&this.a.fire(this.b)}}};e.$ro=b,e.$ro=b=$e([oe(1,w.$3n),oe(2,a.$Oj)],b)}),define(ne[139],re([0,1,19,9,14,5,38,74,2,27,12,17,29,67,40,138,39]),function(J,e,j,R,k,A,D,E,u,a,w,v,d,$,b,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=void 0;class c extends u.$Uc{constructor(h,g,i,r){super(),this.m=h,this.h=this.B(new A.$7d),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new O.$po),this.c=i instanceof m.$5n?new O.$qo:this.B(new O.$ro(this.b,i,r)),this.f=this.B(new $.$lo(this.m,{},v.$Mg,g)),this.a=new $.$mo(this.b.configurationModel,this.c.configurationModel,new $.$jo,new $.$jo),this.j=new y(h,g,this),this.g=this.B(new R.$uh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:t,properties:n})=>this.r(t,n))),this.B(this.c.onDidChangeConfiguration(t=>this.s(t))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[h,g,i]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new $.$mo(h,g,new $.$jo,i)}getConfigurationData(){return this.a.toData()}getValue(h,g){const i=typeof h=="string"?h:void 0,r=(0,d.$Pi)(h)?h:(0,d.$Pi)(g)?g:{};return this.a.getValue(i,r,void 0)}async updateValue(h,g,i,r,t){const n=(0,d.$Qi)(i)?i:(0,d.$Pi)(i)?{resource:i.resource,overrideIdentifiers:i.overrideIdentifier?[i.overrideIdentifier]:void 0}:void 0,s=n?r:i;if(s!==void 0&&s!==3&&s!==2)throw new Error(`Unable to write ${h} to target ${s}.`);n?.overrideIdentifiers&&(n.overrideIdentifiers=(0,j.$Mb)(n.overrideIdentifiers),n.overrideIdentifiers=n.overrideIdentifiers.length?n.overrideIdentifiers:void 0);const o=this.inspect(h,{resource:n?.resource,overrideIdentifier:n?.overrideIdentifiers?n.overrideIdentifiers[0]:void 0});if(o.policyValue!==void 0)throw new Error(`Unable to write ${h} because it is configured in system policy.`);if((0,a.$Sn)(g,o.defaultValue)&&(g=void 0),n?.overrideIdentifiers?.length&&n.overrideIdentifiers.length>1){const P=n.overrideIdentifiers.sort(),I=this.a.localUserConfiguration.overrides.find(L=>(0,j.$ub)([...L.identifiers].sort(),P));I&&(n.overrideIdentifiers=I.identifiers)}const l=n?.overrideIdentifiers?.length?[(0,b.$fo)(n.overrideIdentifiers),h]:[h];await this.j.write(l,g),await this.reloadConfiguration()}inspect(h,g={}){return this.a.inspect(h,g,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const h=await this.f.loadConfiguration();this.n(h)}n(h){const g=this.a.toData(),i=this.a.compareAndUpdateLocalUserConfiguration(h);this.t(i,g,2)}r(h,g){const i=this.a.toData(),r=this.a.compareAndUpdateDefaultConfiguration(h,g);this.t(r,i,7)}s(h){const g=this.a.toData(),i=this.a.compareAndUpdatePolicyConfiguration(h);this.t(i,g,7)}t(h,g,i){const r=new $.$oo(h,{data:g},this.a);r.source=i,this.h.fire(r)}}e.$so=c;class y{constructor(h,g,i){this.b=h,this.c=g,this.d=i,this.a=new R.$ph}write(h,g){return this.a.queue(()=>this.e(h,g))}async e(h,g){let i;try{i=(await this.c.readFile(this.b)).value.toString()}catch(n){if(n.fileOperationResult===1)i="{}";else throw n}const r=[];if((0,D.$vn)(i,r,{allowTrailingComma:!0,allowEmptyContent:!0}),r.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const t=this.f(i,h,g);i=(0,E.$Nn)(i,t),await this.c.writeFile(this.b,k.$ue.fromString(i))}f(h,g,i){const{tabSize:r,insertSpaces:t,eol:n}=this.h;if(!g.length){const s=JSON.stringify(i,null,t?" ".repeat(r):"	");return[{content:s,length:s.length,offset:0}]}return(0,E.$Kn)(h,g,i,{tabSize:r,insertSpaces:t,eol:n})}get h(){if(!this.g){let h=w.OS===3||w.OS===2?`
`:`\r
`;const g=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});g&&typeof g=="string"&&g!=="auto"&&(h=g),this.g={eol:h,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ne[68],re([0,1,15]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=R,e.$um=k,e.$vm=A,e.$wm=D;function R(u){return u.scheme===j.Schemas.vscodeRemote?u.authority:void 0}function k(u){if(!u)return;const a=u.indexOf("+");return a<0?u:u.substr(0,a)}function A(u){const{host:a,port:w}=E(u);if(typeof w>"u")throw new Error(`Invalid remote authority: ${u}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:w}}function D(u,a){let{host:w,port:v}=E(u);return typeof v>"u"&&(v=a),{host:w,port:v}}function E(u){const a=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const w=u.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const v=u.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:u,port:void 0}}}),define(ne[37],re([0,1,30,10,68]),function(J,e,j,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Km=e.$Fm=e.$Em=e.$Dm=e.TargetPlatform=e.ExtensionType=e.$Cm=e.$Am=e.$zm=e.$ym=e.$xm=void 0,e.$Bm=A,e.$Gm=v,e.$Hm=d,e.$Im=$,e.$Jm=b,e.$xm="extensions.user.cache",e.$ym="extensions.builtin.cache",e.$zm="undefined_publisher",e.$Am=["ui","workspace","web"];function A(O){if(typeof O=="object"&&O!==null&&O.supported!==!0)return O.description}e.$Cm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var D;(function(O){O[O.System=0]="System",O[O.User=1]="User"})(D||(e.ExtensionType=D={}));var E;(function(O){O.WIN32_X64="win32-x64",O.WIN32_ARM64="win32-arm64",O.LINUX_X64="linux-x64",O.LINUX_ARM64="linux-arm64",O.LINUX_ARMHF="linux-armhf",O.ALPINE_X64="alpine-x64",O.ALPINE_ARM64="alpine-arm64",O.DARWIN_X64="darwin-x64",O.DARWIN_ARM64="darwin-arm64",O.WEB="web",O.UNIVERSAL="universal",O.UNKNOWN="unknown",O.UNDEFINED="undefined"})(E||(e.TargetPlatform=E={}));class u{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,c){if(typeof m>"u"||m===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof m=="string"||typeof c=="string"){const y=typeof m=="string"?m:m.value,p=typeof c=="string"?c:c.value;return j.$lf(y,p)}return m._lower===c._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$Dm=u;class a{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const c of m)this.add(c)}add(m){this.c.add(u.toKey(m))}delete(m){return this.c.delete(u.toKey(m))}has(m){return this.c.has(u.toKey(m))}}e.$Em=a;class w{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete(u.toKey(m))}get(m){return this.c.get(u.toKey(m))}has(m){return this.c.has(u.toKey(m))}set(m,c){this.c.set(u.toKey(m),c)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Fm=w;function v(O){return d(O)}function d(O){return O.contributes&&O.contributes.localizations?O.contributes.localizations.length>0:!1}function $(O){return O.contributes&&O.contributes.authentication?O.contributes.authentication.length>0:!1}function b(O,m){if(m){const c=`onResolveRemoteAuthority:${(0,k.$um)(m)}`;return!!O.activationEvents?.includes(c)}return!1}e.$Km=(0,R.$ii)("IBuiltinExtensionsScannerService")}),define(ne[140],re([0,1,2,37,13]),function(J,e,j,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0;class A extends j.$Uc{constructor(E,u,a,w,v){super(),this.a=E,this.b=u,this.c=a,this.f=v,this.B(w.onDidInstallExtensions(d=>this.g(d))),this.B(w.onDidUninstallExtension(d=>this.h(d)))}g(E){for(const u of E)u.local&&this.invalidate(u.profileLocation)}h(E){E.error||this.invalidate(E.profileLocation)}async invalidate(E){if(E)for(const u of this.a.profiles)this.c.extUri.isEqual(u.extensionsResource,E)&&await this.j(u);else await this.j(this.a.defaultProfile)}async j(E){try{await this.b.del(this.c.extUri.joinPath(E.cacheHome,R.$xm))}catch(u){(0,k.$6k)(u)!==1&&this.f.error(u)}}}e.$nq=A}),define(ne[45],re([0,1,14,8,2,107,40,10,6,36]),function(J,e,j,R,k,A,D,E,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=void 0,e.$Bp=d,e.$Cp=$,e.$Dp=b,e.$Ep=O,e.$Fp=m,e.$Gp=c,e.$zp=(0,E.$ii)("requestService");class w{constructor(g){this.b=g}toJSON(){if(!this.a){const g=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?g[i]="*****":g[i]=this.b[i];this.a=g}return this.a}}class v extends k.$Uc{constructor(g){super(),this.b=0,this.a=g.createLogger("network",{name:(0,A.localize)(0,null),when:u.$7j.isEqualTo((0,u.$4j)(u.LogLevel.Trace)).serialize()})}async c(g,i,r){const t=`${g} #${++this.b}: ${i.url}`;this.a.trace(`${t} - begin`,i.type,new w(i.headers??{}));try{const n=await r();return this.a.trace(`${t} - end`,i.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${t} - error`,i.type,(0,R.$0)(n)),n}}}e.$Ap=v;function d(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}function $(h){return h.res.statusCode===204}async function b(h){return $(h)?null:(await(0,j.$Ge)(h.stream)).toString()}async function O(h){if(!d(h))throw new Error("Server returned "+h.res.statusCode);return b(h)}async function m(h){if(!d(h))throw new Error("Server returned "+h.res.statusCode);if($(h))return null;const i=(await(0,j.$Ge)(h.stream)).toString();try{return JSON.parse(i)}catch(r){throw r.message+=`:
`+i,r}}function c(h){p(h)}let y;function p(h){const g=a.$1n.as(D.$6n.Configuration),i=y;y={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},g.updateConfigurations({add:[y],remove:i?[i]:[]})}p(1)}),define(ne[141],re([0,1,20,15,13,45]),function(J,e,j,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gQ=void 0;let D=class{constructor(u,a){this.a=u,this.b=a}async download(u,a,w=j.CancellationToken.None){if(u.scheme===R.Schemas.file||u.scheme===R.Schemas.vscodeRemote){await this.b.copy(u,a);return}const v={type:"GET",url:u.toString(!0)},d=await this.a.request(v,w);if(d.res.statusCode===200)await this.b.writeFile(a,d.stream);else{const $=await(0,A.$Ep)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${$}`)}}};e.$gQ=D,e.$gQ=D=$e([oe(0,A.$zp),oe(1,k.$Ok)],D)}),define(ne[142],re([0,1,143,3]),function(J,e,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gr=A;function k(D,E){return D.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:D.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function A(D,E,u={}){const a=(0,j.parse)(D),w=u.proxyUrl||k(a,E);if(!w)return null;const v=(0,j.parse)(w);if(!/^https?:$/.test(v.protocol||""))return null;const d={host:v.hostname||"",port:(v.port?+v.port:0)||(v.protocol==="https"?443:80),auth:v.auth,rejectUnauthorized:(0,R.$2f)(u.strictSSL)?u.strictSSL:!0};return a.protocol==="http:"?new(await new Promise(($,b)=>{J(["http-proxy-agent"],$,b)})).HttpProxyAgent(w,d):new(await new Promise(($,b)=>{J(["https-proxy-agent"],$,b)})).HttpsProxyAgent(w,d)}}),define(ne[144],re([0,1,59,16,108,20,34,8,12,28,87,175,9,75]),function(J,e,j,R,k,A,D,E,u,a,w,v,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=O;let b;async function O(c,y,p,h){return p["force-disable-user-env"]?(y.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$i?(y.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.$mm)(h)&&!p["force-user-env"]?(y.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.$mm)(h)?y.trace("resolveShellEnv(): running (--force-user-env)"):y.trace("resolveShellEnv(): running (macOS/Linux)"),b||(b=d.Promises.withAsyncBody(async(g,i)=>{const r=new A.$ee;let t=1e4;const n=c.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(t=(0,$.$nm)(n,1,120)*1e3);const s=setTimeout(()=>{r.dispose(!0),i(new Error((0,k.localize)(0,null)))},t);try{g(await m(y,r.token))}catch(o){!(0,E.$4)(o)&&!r.token.isCancellationRequested?i(new Error((0,k.localize)(1,null,(0,D.$6i)(o)))):g({})}finally{clearTimeout(s),r.dispose()}})),b)}async function m(c,y){const p=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",p);const h=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",h);const g=(0,a.$Eg)().replace(/-/g,"").substr(0,12),i=new RegExp(g+"({.*})"+g),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};c.trace("getUnixShellEnvironment#env",r);const t=await(0,w.$cm)(u.OS,r);return c.trace("getUnixShellEnvironment#shell",t),new Promise((n,s)=>{if(y.isCancellationRequested)return s(new E.$5);const o=(0,R.$oc)(t);let l,P;const I="";/^pwsh(-preview)?$/.test(o)?(l=`& '${process.execPath}' ${I} -p '''${g}'' + JSON.stringify(process.env) + ''${g}'''`,P=["-Login","-Command"]):o==="nu"?(l=`^'${process.execPath}' ${I} -p '"${g}" + JSON.stringify(process.env) + "${g}"'`,P=["-i","-l","-c"]):o==="xonsh"?(l=`import os, json; print("${g}", json.dumps(dict(os.environ)), "${g}")`,P=["-i","-l","-c"]):(l=`'${process.execPath}' ${I} -p '"${g}" + JSON.stringify(process.env) + "${g}"'`,o==="tcsh"||o==="csh"?P=["-ic"]:P=["-i","-l","-c"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),l);const L=(0,j.spawn)(t,[...P,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});y.onCancellationRequested(()=>(L.kill(),s(new E.$5))),L.on("error",V=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,D.$6i)(V)),s(V)});const z=[];L.stdout.on("data",V=>z.push(V));const U=[];L.stderr.on("data",V=>U.push(V)),L.on("close",(V,X)=>{const se=Buffer.concat(z).toString("utf8");c.trace("getUnixShellEnvironment#raw",se);const ie=Buffer.concat(U).toString("utf8");if(ie.trim()&&c.trace("getUnixShellEnvironment#stderr",ie),V||X)return s(new Error((0,k.localize)(2,null,V,X)));const ue=i.exec(se),he=ue?ue[1]:"{}";try{const ce=JSON.parse(he);p?ce.ELECTRON_RUN_AS_NODE=p:delete ce.ELECTRON_RUN_AS_NODE,h?ce.ELECTRON_NO_ATTACH_CONSOLE=h:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",ce),n(ce)}catch(ce){c.error("getUnixShellEnvironment#errorCaught",(0,D.$6i)(ce)),s(ce)}})})}}),define(ne[145],re([0,1,10]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VP=e.$UP=void 0,e.$UP=(0,j.$ii)("stateReadService"),e.$VP=(0,j.$ii)("stateService")}),define(ne[69],re([0,1,9,14,2,3,18,13,6]),function(J,e,j,R,k,A,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YP=e.$XP=e.$WP=e.SaveStrategy=void 0;var a;(function($){$[$.IMMEDIATE=0]="IMMEDIATE",$[$.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class w extends k.$Uc{constructor(b,O,m,c){super(),this.h=b,this.j=O,this.m=m,this.n=c,this.a=Object.create(null),this.b="",this.c=this.B(new j.$gh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(b){b.fileOperationResult!==1&&this.m.error(b)}}getItem(b,O){const m=this.a[b];return(0,A.$5f)(m)?O:m}setItem(b,O){this.setItems([{key:b,data:O}])}setItems(b){let O=!1;for(const{key:m,data:c}of b)this.a[m]!==c&&((0,A.$5f)(c)?(0,A.$3f)(this.a[m])||(this.a[m]=void 0,O=!0):(this.a[m]=c,O=!0));O&&this.s()}removeItem(b){(0,A.$3f)(this.a[b])||(this.a[b]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const b=JSON.stringify(this.a,null,4);if(b!==this.b)try{await this.n.writeFile(this.h,R.$ue.fromString(b),{atomic:{postfix:".vsctmp"}}),this.b=b}catch(O){this.m.error(O)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$WP=w;let v=class extends k.$Uc{constructor(b,O,m,c){super(),this.a=this.B(new w(O.stateResource,b,m,c))}async init(){await this.a.init()}getItem(b,O){return this.a.getItem(b,O)}};e.$XP=v,e.$XP=v=$e([oe(1,D.$pi),oe(2,u.$Oj),oe(3,E.$Ok)],v);class d extends v{setItem(b,O){this.a.setItem(b,O)}setItems(b){this.a.setItems(b)}removeItem(b){this.a.removeItem(b)}close(){return this.a.close()}}e.$YP=d}),define(ne[70],re([0,1,12,35,28]),function(J,e,j,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=D,e.$3o=E;function A(u){if(j.$u===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function D(u,a,w,v,d,$,b,O,m){const c=Object.create(null);c["common.machineId"]=$,c["common.sqmId"]=b,c.sessionID=(0,k.$Eg)()+Date.now(),c.commitHash=v,c.version=d,c["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,j.$h)(j.$u),c["common.nodePlatform"]=R.$ec,c["common.nodeArch"]=w,c["common.product"]=m||"desktop",O&&(c["common.msftInternal"]=O);let y=0;const p=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-p,enumerable:!0},"common.sequence":{get:()=>y++,enumerable:!0}}),j.$l&&(c["common.snap"]="true");const h=A(a);return h&&(c["common.platformDetail"]=h),c}function E(u){const a=R.env.USERDNSDOMAIN;if(!a)return!1;const w=a.toLowerCase();return u.some(v=>w===v)}}),define(ne[25],re([0,1,10]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=void 0,e.$Nl=(0,j.$ii)("telemetryService"),e.$Ol=(0,j.$ii)("customEndpointTelemetryService"),e.$Pl="telemetry.currentSessionDate",e.$Ql="telemetry.firstSessionDate",e.$Rl="telemetry.lastSessionDate",e.$Sl="telemetry.machineId",e.$Tl="telemetry.sqmId",e.$Ul="telemetry",e.$Vl="telemetry.telemetryLevel",e.$Wl="telemetry.enableCrashReporter",e.$Xl="telemetry.enableTelemetry";var R;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var k;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(k||(e.TelemetryConfiguration=k={}))}),define(ne[41],re([0,1,27,3,68,70,25]),function(J,e,j,R,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=void 0,e.$$o=w,e.$_o=v,e.$ap=d,e.$bp=$,e.$cp=O,e.$dp=c,e.$ep=y,e.$fp=g;class E{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$4o=E;class u{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$5o=u,e.$6o=new u;class a{async publicLog(r,t,n){}async publicLogError(r,t,n){}}e.$7o=a,e.$8o="telemetry",e.$9o="extensionTelemetryLog",e.$0o={log:()=>null,flush:()=>Promise.resolve(null)};function w(i,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!i.enableTelemetry)}function v(i,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function d(i){const r=i.getValue(D.$Vl),t=i.getValue(D.$Wl);if(i.getValue(D.$Xl)===!1||t===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function $(i){const r={},t={},n={};m(i,n);for(let s in n){s=s.length>150?s.substr(s.length-149):s;const o=n[s];typeof o=="number"?t[s]=o:typeof o=="boolean"?t[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),r[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(r[s]=o)}return{properties:r,measurements:t}}const b=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function O(i){if(!i)return"none";const r=(0,k.$um)(i);return b.has(r)?r:"other"}function m(i,r,t=0,n){if(i)for(const s of Object.getOwnPropertyNames(i)){const o=i[s],l=n?n+s:s;Array.isArray(o)?r[l]=(0,j.$Tn)(o):o instanceof Date?r[l]=o.toISOString():(0,R.$Xf)(o)?t<2?m(o,r,t+1,l+"."):r[l]=(0,j.$Tn)(o):r[l]=o}}function c(i,r){const t=i.msftInternalDomains||[],n=r.getValue("telemetry.internalTesting");return(0,A.$3o)(t)||n}function y(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function p(i,r){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let t=i;const n=[];for(const P of r)for(;;){const I=P.exec(i);if(!I)break;n.push([I.index,P.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(t="";;){const P=o.exec(i);if(!P)break;const I=n.some(([L,z])=>P.index<z&&L<o.lastIndex);!s.test(P[0])&&!I&&(t+=i.substring(l,P.index)+"<REDACTED: user-file-path>",l=o.lastIndex)}return l<i.length&&(t+=i.substr(l)),t}function h(i){if(!i)return i;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const t of r)if(t.regex.test(i))return`<REDACTED: ${t.label}>`;return i}function g(i,r){return(0,j.$Qn)(i,t=>{if(t instanceof E||Object.hasOwnProperty.call(t,"isTrustedTelemetryValue"))return t.value;if(typeof t=="string"){let n=t.replaceAll("%20"," ");n=p(n,r);for(const s of r)n=n.replace(s,"");return n=h(n),n}})}}),define(ne[26],re([0,1,30,21,37,12,11,8,35,41]),function(J,e,j,R,k,A,D,E,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$hp=void 0,e.$gp=w,e.$ip=b,e.$jp=O,e.$kp=m,e.$lp=c,e.$mp=y,e.$np=p,e.$op=h,e.$qp=g,e.$rp=r;function w(t,n){return t.uuid&&n.uuid?t.uuid===n.uuid:t.id===n.id?!0:(0,j.$gf)(t.id,n.id)===0}const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(n){const s=n.manifest?n.manifest.version:n.version,o=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new d(n.identifier,s,o)}static parse(n){const s=v.exec(n);return s&&s[1]&&s[2]?new d({id:s[1]},s[2],s[4]||void 0):null}constructor(n,s,o="undefined"){this.version=s,this.targetPlatform=o,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof d?w(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$hp=d;const $=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function b(t){const n=$.exec(t);return n&&n[1]?[m(n[1]),n[2]]:[m(t),void 0]}function O(t,n){return`${t}.${n}`}function m(t){return t.toLowerCase()}function c(t,n){return m(O(t??k.$zm,n))}function y(t,n){const s=[],o=l=>{for(const P of s)if(P.some(I=>w(n(I),n(l))))return P;return null};for(const l of t){const P=o(l);P?P.push(l):s.push([l])}return s}function p(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}function h(t){return{id:new a.$4o(t.identifier.id),name:new a.$4o(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$pp=new k.$Dm("pprice.better-merge");function g(t,n){const s=[],o=n.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const l=o.shift();if(l&&s.every(P=>!w(P.identifier,{id:l}))){const P=t.filter(I=>w(I.identifier,{id:l}));P.length===1&&(s.push(P[0]),o.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function i(t,n){if(!A.$k)return!1;let s;try{s=(await t.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await t.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){n.debug("Error while getting the os-release file.",(0,E.$0)(l))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(t,n){const s=await i(t,n),o=(0,R.$No)(s?"alpine":A.$u,u.$fc);return n.debug("ComputeTargetPlatform:",o),o}}),define(ne[146],re([0,1,20,8,15,17,44,11,96,21,26,37]),function(J,e,j,R,k,A,D,E,u,a,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;const d=O=>(0,u.localize)(0,null,O),$=(0,u.localize)(1,null,"ms-dotnettools.csharp");let b=class{constructor(m,c,y){this.a=m,this.b=c,this.d=y}get f(){}async listExtensions(m,c,y){let p=await this.b.getInstalled(1,y);const h=v.$Cm.map(i=>i.toLowerCase());if(c&&c!==""){if(h.indexOf(c.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}p=p.filter(i=>i.manifest.categories?i.manifest.categories.map(t=>t.toLowerCase()).indexOf(c.toLowerCase())>-1:!1)}else if(c===""){this.a.info("Possible Categories: "),h.forEach(i=>{this.a.info(i)});return}this.f&&this.a.info((0,u.localize)(2,null,this.f)),p=p.sort((i,r)=>i.identifier.id.localeCompare(r.identifier.id));let g;for(const i of p)g!==i.identifier.id&&(g=i.identifier.id,this.a.info(m?`${g}@${i.manifest.version}`:g))}async installExtensions(m,c,y,p){const h=[];try{m.length&&this.a.info(this.f?(0,u.localize)(3,null,this.f):(0,u.localize)(4,null));const g=[],i=[],r=(n,s,o)=>{i.push({id:n,version:s!=="prerelease"?s:void 0,installOptions:{...y,isBuiltin:o,installPreReleaseVersion:s==="prerelease"||y.installPreReleaseVersion}})};for(const n of m)if(n instanceof E.URI)g.push({vsix:n,installOptions:y});else{const[s,o]=(0,w.$ip)(n);r(s,o,!1)}for(const n of c)if(n instanceof E.URI)g.push({vsix:n,installOptions:{...y,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,o]=(0,w.$ip)(n);r(s,o,!0)}const t=await this.b.getInstalled(1,y.profileLocation);if(g.length&&await Promise.all(g.map(async({vsix:n,installOptions:s})=>{try{await this.h(n,s,p,t)}catch(o){this.a.error(o),h.push(n.toString())}})),i.length){const n=await this.g(i,t,p);h.push(...n)}}catch(g){throw this.a.error((0,u.localize)(5,null,(0,R.$0)(g))),g}if(h.length)throw new Error((0,u.localize)(6,null,h.join(", ")))}async updateExtensions(m){const c=await this.b.getInstalled(1,m),y=[];for(const i of c)i.identifier.uuid&&y.push({...i.identifier,preRelease:i.preRelease});this.a.trace((0,u.localize)(7,null,y.length));const p=await this.d.getExtensions(y,{compatible:!0},j.CancellationToken.None),h=[];for(const i of p)for(const r of c)(0,w.$gp)(r.identifier,i.identifier)&&(0,D.gt)(i.version,r.manifest.version)&&h.push({extension:i,options:{operation:3,installPreReleaseVersion:r.isPreReleaseVersion}});if(!h.length){this.a.info((0,u.localize)(8,null));return}this.a.info((0,u.localize)(9,null,h.map(i=>i.extension.identifier.id).join(", ")));const g=await this.b.installGalleryExtensions(h);for(const i of g)i.error?this.a.error((0,u.localize)(10,null,i.identifier.id,(0,R.$0)(i.error))):this.a.info((0,u.localize)(11,null,i.identifier.id,i.local?.manifest.version))}async g(m,c,y){if(m=m.filter(({id:i,version:r})=>{const t=c.find(n=>(0,w.$gp)(n.identifier,{id:i}));if(t){if(!y&&(!r||r==="prerelease"&&t.preRelease))return this.a.info((0,u.localize)(12,null,i,t.manifest.version,i)),!1;if(r&&t.manifest.version===r)return this.a.info((0,u.localize)(13,null,`${i}@${r}`)),!1}return!0}),!m.length)return[];const p=[],h=[],g=await this.j(m);if(await Promise.all(m.map(async({id:i,version:r,installOptions:t})=>{const n=g.get(i.toLowerCase());if(!n){this.a.error(`${d(r?`${i}@${r}`:i)}
${$}`),p.push(i);return}try{const o=await this.d.getManifest(n,j.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),p.push(i);return}const s=c.find(o=>(0,w.$gp)(o.identifier,n.identifier));if(s){if(n.version===s.manifest.version){this.a.info((0,u.localize)(14,null,r?`${i}@${r}`:i));return}this.a.info((0,u.localize)(15,null,i,n.version))}t.isBuiltin?this.a.info(r?(0,u.localize)(16,null,i,r):(0,u.localize)(17,null,i)):this.a.info(r?(0,u.localize)(18,null,i,r):(0,u.localize)(19,null,i)),h.push({extension:n,options:{...t,installGivenVersion:!!r}})})),h.length){const i=await this.b.installGalleryExtensions(h);for(const r of i)r.error?(this.a.error((0,u.localize)(20,null,r.identifier.id,(0,R.$0)(r.error))),p.push(r.identifier.id)):this.a.info((0,u.localize)(21,null,r.identifier.id,r.local?.manifest.version))}return p}async h(m,c,y,p){const h=await this.b.getManifest(m);if(!h)throw new Error("Invalid vsix");if(await this.l(h,y,c.profileLocation,p))try{await this.b.install(m,c),this.a.info((0,u.localize)(22,null,(0,A.$Sg)(m)))}catch(i){if((0,R.$4)(i))this.a.info((0,u.localize)(23,null,(0,A.$Sg)(m)));else throw i}}async j(m){const c=new Map,y=m.some(g=>g.installOptions.installPreReleaseVersion),p=await this.b.getTargetPlatform(),h=[];for(const g of m)a.$Go.test(g.id)&&h.push({...g,preRelease:y});if(h.length){const g=await this.d.getExtensions(h,{targetPlatform:p},j.CancellationToken.None);for(const i of g)c.set(i.identifier.id.toLowerCase(),i)}return c}k(m){return!0}async l(m,c,y,p){if(!c){const h={id:(0,w.$lp)(m.publisher,m.name)},g=p.find(i=>(0,w.$gp)(h,i.identifier)&&(0,D.gt)(i.manifest.version,m.version));if(g)return this.a.info((0,u.localize)(24,null,g.identifier.id,g.manifest.version,m.version)),!1}return this.k(m)}async uninstallExtensions(m,c,y){const p=async g=>{if(g instanceof E.URI){const i=await this.b.getManifest(g);return(0,w.$jp)(i.publisher,i.name)}return g},h=[];for(const g of m){const i=await p(g),t=(await this.b.getInstalled(void 0,y)).filter(n=>(0,w.$gp)(n.identifier,{id:i}));if(!t.length)throw new Error(`${this.m(i)}
${$}`);if(t.some(n=>n.type===0)){this.a.info((0,u.localize)(25,null,i));return}if(!c&&t.some(n=>n.isBuiltin)){this.a.info((0,u.localize)(26,null,i));return}this.a.info((0,u.localize)(27,null,i));for(const n of t)await this.b.uninstall(n,{profileLocation:y}),h.push(n);this.f?this.a.info((0,u.localize)(28,null,i,this.f)):this.a.info((0,u.localize)(29,null,i))}}async locateExtension(m){const c=await this.b.getInstalled();m.forEach(y=>{c.forEach(p=>{if(p.identifier.id===y&&p.location.scheme===k.Schemas.file){this.a.info(p.location.fsPath);return}})})}m(m){return this.f?(0,u.localize)(30,null,m,this.f):(0,u.localize)(31,null,m)}};e.$Zp=b,e.$Zp=b=$e([oe(1,a.$Uo),oe(2,a.$Ro)],b)}),define(ne[147],re([0,1,9,8,2,15,17,44,3,28,24,49,29,18,21,26,65,13,6]),function(J,e,j,R,k,A,D,E,u,a,w,v,d,$,b,O,m,c,y){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=void 0;let h=class extends k.$Uc{static{p=this}static{this.c=".sigzip"}constructor(i,r,t,n,s,o){super(),this.h=r,this.j=t,this.m=n,this.n=s,this.r=o,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(i,r,t){await this.g;const n=(0,D.$Vg)(this.extensionsDownloadDir,this.z(i));try{await this.w(i,n,o=>this.j.download(i,o,r))}catch(o){throw new b.$So(o.message,b.ExtensionManagementErrorCode.Download)}let s=!1;if(t&&this.t(i)){const o=await this.u(i);try{s=await this.n.verify(n.fsPath,o.fsPath,this.r.getLevel()===y.LogLevel.Trace)}catch(l){const P=l;if(s=P.code,P.output&&this.r.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${P.output}`),s===b.ExtensionSignaturetErrorCode.PackageIsInvalidZip||s===b.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(n)}catch(I){this.r.error(I)}throw new b.$So(v.$4p,b.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(o)}catch(l){this.r.error(l)}}}return s===!0?this.r.info(`Extension signature is verified: ${i.identifier.id}`):s===!1?this.r.info(`Extension signature verification is not done: ${i.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${s}': ${i.identifier.id}`),{location:n,verificationStatus:s}}t(i){if(!i.isSigned)return this.r.info(`Extension is not signed: ${i.identifier.id}`),!1;const r=this.m.getValue("extensions.verifySignature");return(0,u.$2f)(r)?r:!0}async u(i){await this.g;const r=(0,D.$Vg)(this.extensionsDownloadDir,`${this.z(i)}${p.c}`);try{await this.w(i,r,t=>this.j.downloadSignatureArchive(i,t))}catch(t){throw new b.$So(t.message,b.ExtensionManagementErrorCode.DownloadSignature)}return r}async w(i,r,t){if(await this.h.exists(r))return;if(r.scheme!==A.Schemas.file){await t(r);return}const n=(0,D.$Vg)(this.extensionsDownloadDir,`.${(0,a.$Eg)()}`);await this.h.exists(n)||await t(n);try{await w.Promises.rename(n.fsPath,r.fsPath,2*60*1e3)}catch(s){try{await this.h.del(n)}catch{}if(s.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,r.path);else throw this.r.info(`Rename failed because of ${(0,R.$0)(s)}. Deleted the file from downloaded location`,n.path),s}}async delete(i){await this.g,await this.h.del(i)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const r=[],t=[],n=[];for(const l of i.children)if(l.name.endsWith(p.c))n.push(l.resource);else{const P=O.$hp.parse(l.name);P&&t.push([P,l])}const s=(0,O.$mp)(t,([l])=>l),o=[];for(const l of s)l.sort((P,I)=>E.rcompare(P[0].version,I[0].version)),r.push(...l.slice(1).map(P=>P[1].resource)),o.push(l[0][1]);o.sort((l,P)=>l.mtime-P.mtime),r.push(...o.slice(0,Math.max(0,o.length-this.f)).map(l=>l.resource)),r.push(...n),await j.Promises.settled(r.map(l=>(this.r.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(i){this.r.error(i)}}z(i){return this.f?O.$hp.create(i).toString().toLowerCase():(0,a.$Eg)()}};e.$kq=h,e.$kq=h=p=$e([oe(0,$.$qi),oe(1,c.$Ok),oe(2,b.$Ro),oe(3,d.$Oi),oe(4,m.$Xp),oe(5,y.$Oj)],h)}),define(ne[148],re([0,1,5,2,31,26,37]),function(J,e,j,R,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=void 0;class E extends R.$Uc{constructor(a,w,v,d,$,b,O){super(),this.f=a,this.g=w,this.h=v,this.j=d,this.m=$,this.n=b,this.r=O,this.a=this.B(new j.$7d),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new R.$4c),this.s().then(null,m=>O.error(m))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(a=>this.u(a.added))),this.B(this.j.onAddExtensions(a=>this.w(a))),this.B(this.j.onDidAddExtensions(a=>this.y(a))),this.B(this.j.onRemoveExtensions(a=>this.z(a))),this.B(this.j.onDidRemoveExtensions(a=>this.C(a))),this.B(this.n.onDidFilesChange(a=>this.D(a)))}async u(a){try{a.length&&await Promise.all(a.map(w=>(this.c.set(w.id,(0,R.$Rc)(this.n.watch(this.m.extUri.dirname(w.extensionsResource)),this.n.watch(w.extensionsResource))),this.G(w.extensionsResource))))}catch(w){throw this.r.error(w),w}}async w(a){for(const w of a.extensions)this.I(this.L(w.identifier,w.version),a.profileLocation)}async y(a){for(const w of a.extensions){const v=this.L(w.identifier,w.version);a.error?this.J(v,a.profileLocation):this.I(v,a.profileLocation)}}async z(a){for(const w of a.extensions)this.J(this.L(w.identifier,w.version),a.profileLocation)}async C(a){const w=[],v=[];for(const d of a.extensions){const $=this.L(d.identifier,d.version);a.error?this.I($,a.profileLocation):(this.J($,a.profileLocation),this.b.has($)||(this.r.debug("Extension is removed from all profiles",d.identifier.id,d.version),v.push(this.f.scanInstalledExtensionAtLocation(d.location).then(b=>{b?w.push(b):this.r.info("Extension not found at the location",d.location.toString())},b=>this.r.error(b)))))}try{await Promise.all(v),w.length&&await this.H(w)}catch(d){this.r.error(d)}}D(a){for(const w of this.h.profiles)a.contains(w.extensionsResource,0,1)&&this.F(w.extensionsResource)}async F(a){const w=[],v=[],d=await this.j.scanProfileExtensions(a),$=new Set,b=new Set;for(const[O,m]of this.b)m.has(a)&&b.add(O);for(const O of d){const m=this.L(O.identifier,O.version);$.add(m),b.has(m)||(w.push(O.identifier),this.I(m,a))}for(const O of b)if(!$.has(O)){const m=this.M(O);m&&(v.push(m.identifier),this.J(O,a))}(w.length||v.length)&&this.a.fire({added:w.length?{extensions:w,profileLocation:a}:void 0,removed:v.length?{extensions:v,profileLocation:a}:void 0})}async G(a){const w=await this.j.scanProfileExtensions(a);for(const v of w)this.I(this.L(v.identifier,v.version),a)}async H(a){a||(a=(await this.f.scanAllUserInstalledExtensions()).filter(v=>!this.b.has(this.L(v.identifier,v.manifest.version)))),a.length&&await this.f.markAsUninstalled(...a)}I(a,w){let v=this.b.get(a);v||this.b.set(a,v=new k.$Cc(d=>this.m.extUri.getComparisonKey(d))),v.add(w)}J(a,w){const v=this.b.get(a);v&&v.delete(w),v?.size||this.b.delete(a)}L(a,w){return`${D.$Dm.toKey(a.id)}@${w}`}M(a){const[w,v]=(0,A.$ip)(a);return v?{identifier:{id:w},version:v}:void 0}}e.$oq=E}),define(ne[149],re([0,1,118,41]),function(J,e,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=k;async function k(A,D,E,u,a,w,v){const d={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${D.nameShort})`};if((0,R.$$o)(D,E)&&(0,R.$ap)(u)===3){const $=await(0,j.$Sp)(E,a,w);d["X-Market-User-Id"]=$,d["VSCode-SessionId"]=v.machineId||$}return d}}),define(ne[150],re([0,1,176,19,9,2,15,16,24,18,21,26,6,64,11]),function(J,e,j,R,k,A,D,E,u,a,w,v,d,$,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=void 0;let O=class extends $.$Cr{constructor(p,h,g,i){super(g),this.h=p,this.j=i,this.g=this.B(new m(h,i)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri(p,h){const i=(await this.g.getLanguagePacks())[h];if(!i){this.j.warn(`No language pack found for ${h}`);return}const r=i.translations[p];return r?b.URI.file(r):void 0}async getInstalledLanguages(){const p=await this.g.getLanguagePacks(),h=Object.keys(p).map(g=>{const i=p[g];return{...this.f(g,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return h.push(this.f("en","English")),h.sort((g,i)=>g.label.localeCompare(i.label)),h}async m(p){p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",p.identifier.id),await this.update())}async n(p){const h=await this.g.getLanguagePacks();Object.keys(h).some(g=>h[g]&&h[g].extensions.some(i=>(0,v.$gp)(i.extensionIdentifier,p.identifier)))&&(this.j.info("Removing language packs from the extension",p.identifier.id),await this.update())}async update(){const[p,h]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),g=await this.g.update(h);return!(0,R.$ub)(Object.keys(p),Object.keys(g))}};e.$Dr=O,e.$Dr=O=$e([oe(0,w.$Uo),oe(1,a.$qi),oe(2,w.$Ro),oe(3,d.$Oj)],O);let m=class extends A.$Uc{constructor(p,h){super(),this.j=h,this.c={},this.f=(0,E.$kc)(p.userDataPath,"languagepacks.json"),this.g=new k.$ph}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(p){return this.s(h=>{Object.keys(h).forEach(g=>delete h[g]),this.m(h,...p)}).then(()=>this.c)}m(p,...h){for(const g of h)g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&this.n(p,g);Object.keys(p).forEach(g=>this.r(p[g]))}n(p,h){const g=h.identifier,i=h.manifest.contributes&&h.manifest.contributes.localizations?h.manifest.contributes.localizations:[];for(const r of i)if(h.location.scheme===D.Schemas.file&&c(r)){let t=p[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},p[r.languageId]=t);const n=t.extensions.filter(s=>(0,v.$gp)(s.extensionIdentifier,g))[0];n?n.version=h.manifest.version:t.extensions.push({extensionIdentifier:g,version:h.manifest.version});for(const s of r.translations)t.translations[s.id]=(0,E.$kc)(h.location.fsPath,s.path)}}r(p){if(p){const h=(0,j.createHash)("md5");for(const g of p.extensions)h.update(g.extensionIdentifier.uuid||g.extensionIdentifier.id).update(g.version);p.hash=h.digest("hex")}}s(p=()=>null){return this.g.queue(()=>{let h=null;return u.Promises.readFile(this.f,"utf8").then(void 0,g=>g.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(g)).then(g=>{try{return JSON.parse(g)}catch{return{}}}).then(g=>(h=p(g),g)).then(g=>{for(const r of Object.keys(g))g[r]||delete g[r];this.c=g,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),u.Promises.writeFile(this.f,i)}).then(()=>h,g=>this.j.error(g))})}};m=$e([oe(0,a.$qi),oe(1,d.$Oj)],m);function c(y){if(typeof y.languageId!="string"||!Array.isArray(y.translations)||y.translations.length===0)return!1;for(const p of y.translations)if(typeof p.id!="string"||typeof p.path!="string")return!1;return!(y.languageName&&typeof y.languageName!="string"||y.localizedLanguageName&&typeof y.localizedLanguageName!="string")}}),define(ne[151],re([0,1,84,8,27,41]),function(J,e,j,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QP=void 0;const D="https://mobile.events.data.microsoft.com/OneCollector/1.0",E="https://mobile.events.data.microsoft.com/ping";async function u(w,v,d){const $=await(0,j.$FD)("@microsoft/1ds-core-js","dist/ms.core.js"),b=await(0,j.$FD)("@microsoft/1ds-post-js","dist/ms.post.js"),O=new $.AppInsightsCore,m=new b.PostChannel,c={instrumentationKey:w,endpointUrl:D,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[m]]};if(d){c.extensionConfig={};const y={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:d};c.extensionConfig[m.identifier]=y}return O.initialize(c,[]),O.addTelemetryInitializer(y=>{y.ext=y.ext??{},y.ext.web=y.ext.web??{},y.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',v&&(y.ext.utc=y.ext.utc??{},y.ext.utc.flags=8462029)}),O}class a{constructor(v,d,$,b,O){this.e=v,this.f=d,this.g=$,this.h=O,this.c=D,this.d=E,this.g||(this.g={}),typeof b=="function"?this.a=b():this.a=b,this.b=null}i(v){if(this.a){if(typeof this.a!="string"){v(this.a);return}this.b||(this.b=u(this.a,this.e,this.h)),this.b.then(d=>{v(d)},d=>{(0,R.$1)(d),console.error(d)})}}log(v,d){if(!this.a)return;d=(0,k.$Rn)(d,this.g),d=(0,A.$bp)(d);const $=this.f+"/"+v;try{this.i(b=>{b.pluginVersionString=d?.properties.version??"Unknown",b.track({name:$,baseData:{name:$,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this.a?new Promise(v=>{this.i(d=>{d.unload(!0,()=>{this.a=void 0,v(void 0)})})}):Promise.resolve(void 0)}}e.$QP=a}),define(ne[152],re([0,1,2,27,12,30,109,29,40,153,32,36,25,41]),function(J,e,j,R,k,A,D,E,u,a,w,v,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jr=void 0;let b=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(c,y,p){this.k=y,this.l=p,this.d={},this.i=new j.$Tc,this.j=[],this.b=c.appenders,this.c=c.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const h of this.f)this.j.push(new RegExp((0,A.$Ze)(h),"gi")),h.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$Ze)(h.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(h=>{(h.affectsConfiguration(d.$Vl)||h.affectsConfiguration(d.$Xl)||h.affectsConfiguration(d.$Wl))&&this.m()}))}setExperimentProperty(c,y){this.d[c]=y}m(){let c=(0,$.$ap)(this.k);const y=this.l.enabledTelemetryLevels;if(y){this.h=this.sendErrorTelemetry?y.error:!1;const p=y.usage?3:y.error?2:0;c=Math.min(c,p)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(c,y,p){this.g<y||(p=(0,R.$Rn)(p,this.d),p=(0,$.$fp)(p,this.j),p=(0,R.$Rn)(p,this.c),this.b.forEach(h=>h.log(c,p)))}publicLog(c,y){this.n(c,3,y)}publicLog2(c,y){this.publicLog(c,y)}publicLogError(c,y){this.h&&this.n(c,2,y)}publicLogError2(c,y){this.publicLogError(c,y)}};e.$Jr=b,e.$Jr=b=$e([oe(1,E.$Oi),oe(2,w.$8j)],b);function O(){const m=(0,D.localize)(0,null,a.default.nameLong),c=a.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),y=k.$o?"":(0,D.localize)(3,null),p=(0,D.localize)(4,null),h=(0,D.localize)(5,null),g=(0,D.localize)(6,null),i=(0,D.localize)(7,null),r=`
|       | ${p} | ${h} | ${g} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,D.localize)(8,null);return`
${m} ${c} ${y}

&nbsp;

${i}
${r}

&nbsp;

${t}
`}v.$1n.as(u.$6n.Configuration).registerConfiguration({id:d.$Ul,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[d.$Vl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:O(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.$1n.as(u.$6n.Configuration).registerConfiguration({id:d.$Ul,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[d.$Xl]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,D.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,D.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${d.$Vl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[154],re([0,1,14,20,177,151]),function(J,e,j,R,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RP=void 0;async function D(w,v){const d=await v.request(w,R.CancellationToken.None),$=(await(0,j.$Ge)(d.stream)).toString(),b=d.res.statusCode??200;return{headers:d.res.headers,statusCode:b,responseData:$}}async function E(w){const v={method:w.type,headers:w.headers};return new Promise(($,b)=>{const O=k.request(w.url??"",v,m=>{m.on("data",function(c){$({headers:m.headers,statusCode:m.statusCode??200,responseData:c.toString()})}),m.on("error",function(c){b(c)})});O.write(w.data,m=>{m&&b(m)}),O.end()})}async function u(w,v,d){const $=typeof v.data=="string"?v.data:new TextDecoder().decode(v.data),b={type:"POST",headers:{...v.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(v.data).toString()},url:v.urlString,data:$};try{const O=w?await D(b,w):await E(b);d(O.statusCode,O.headers,O.responseData)}catch{d(0,{})}}class a extends A.$QP{constructor(v,d,$,b,O){const m={sendPOST:(c,y)=>{u(v,c,y)}};super(d,$,b,O,m)}}e.$RP=a}),define(ne[155],re([0,1,16,24]),function(J,e,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=k;async function k(A,D){const E=Object.create(null),u=(w,v)=>{const d=JSON.parse(w);E[v]=d};if(D){const w=[],v=await R.Promises.readdir(D);for(const $ of v)try{(await R.Promises.stat((0,j.$kc)(D,$))).isDirectory()&&w.push($)}catch{}const d=[];for(const $ of w)(await R.Promises.readdir((0,j.$kc)(D,$))).filter(O=>O==="telemetry.json").length===1&&d.push($);for(const $ of d){const b=(await R.Promises.readFile((0,j.$kc)(D,$,"telemetry.json"))).toString();u(b,$)}}let a=(await R.Promises.readFile((0,j.$kc)(A,"telemetry-core.json"))).toString();return u(a,"vscode-core"),a=(await R.Promises.readFile((0,j.$kc)(A,"telemetry-extensions.json"))).toString(),u(a,"vscode-extensions"),JSON.stringify(E,null,4)}}),define(ne[156],re([0,1,12,85,25]),function(J,e,j,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ubc=A,e.$vbc=D;async function A(E,u){let a=E.getItem(k.$Sl);return(typeof a!="string"||j.$j&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,R.$rn)(u.error.bind(u))),a}async function D(E,u){let a=E.getItem(k.$Tl);return typeof a!="string"&&(a=await(0,R.$sn)(u.error.bind(u))),a}}),define(ne[22],re([0,1,10]),function(J,e,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ml=void 0,e.$ml=(0,j.$ii)("IUriIdentityService")}),define(ne[157],re([0,1,22,119,13,17,76,5,2]),function(J,e,j,R,k,A,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=void 0;class a{static{this._clock=0}constructor(d){this.uri=d,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let w=class{constructor(d){this.g=d,this.c=new u.$Tc,this.f=2**16;const $=new Map,b=O=>{let m=$.get(O.scheme);return m===void 0&&(m=d.hasProvider(O)&&!this.g.hasCapability(O,1024),$.set(O.scheme,m)),m};this.c.add(E.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(O=>{$.delete(O.scheme)})),this.extUri=new A.$Kg(b),this.d=new D.$is((O,m)=>this.extUri.compare(O,m,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,A.$Wg)(d));const $=this.d.get(d);return $?$.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new a(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((b,O)=>b[1].time<O[1].time?1:b[1].time>O[1].time?-1:0);a._clock=0,this.d.clear();const $=this.f*.5;for(let b=0;b<$;b++)this.d.set(d[b][0],d[b][1].touch())}};e.$js=w,e.$js=w=$e([oe(0,k.$Ok)],w),(0,R.$gs)(j.$ml,w,1)}),define(ne[158],re([0,1,5,2,13,48,31]),function(J,e,j,R,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sbc=void 0;class E extends R.$Uc{constructor(a,w,v,d,$,b){super(),this.f=a,this.g=w,this.h=v,this.j=d,this.m=$,this.n=b,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new j.$7d),this.onDidChangeFile=this.a.event,this.b=A.$oi.forUris(()=>!(this.capabilities&1024)),this.c=new D.$Cc(O=>this.m.extUri.getComparisonKey(this.t(O))),this.r(),this.B(d.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(O=>this.s(O)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,w){return this.g.open(this.t(a),w)}close(a){return this.g.close(a)}read(a,w,v,d,$){return this.g.read(a,w,v,d,$)}write(a,w,v,d,$){return this.g.write(a,w,v,d,$)}watch(a,w){this.b.set(a,a);const v=this.g.watch(this.t(a),w);return(0,R.$Sc)(()=>{this.b.delete(a),v.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,w,v){return this.g.rename(this.t(a),this.t(w),v)}readFile(a,w){return this.g.readFile(this.t(a),w)}readFileStream(a,w,v){return this.g.readFileStream(this.t(a),w,v)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,w,v){return this.g.writeFile(this.t(a),w,v)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,w){return this.g.delete(this.t(a),w)}copy(a,w,v){if((0,k.$Sk)(this.g))return this.g.copy(this.t(a),this.t(w),v);throw new Error("copy not supported")}cloneFile(a,w){if((0,k.$Tk)(this.g))return this.g.cloneFile(this.t(a),this.t(w));throw new Error("clone not supported")}s(a){const w=[];for(const v of a){if(v.resource.scheme!==this.f)continue;const d=this.u(v.resource);this.b.findSubstr(d)&&w.push({resource:d,type:v.type,cId:v.cId})}w.length&&(this.n.debug("User data changed"),this.a.fire(w))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$Sbc=E}),define(ne[159],re([0,1,111,16,48,17,11,10,15]),function(J,e,j,R,k,A,D,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Ci=e.$Bi=e.WorkbenchState=e.$vi=e.$ui=e.$ri=void 0,e.$si=a,e.$ti=w,e.$wi=v,e.$xi=d,e.$yi=$,e.$zi=O,e.$Ai=m,e.$Di=p,e.$Ii=h,e.$Ji=g,e.$Li=i,e.$Mi=r,e.$Ni=t,e.$ri=(0,E.$ii)("contextService");function a(n){const s=n;return typeof s?.id=="string"&&D.URI.isUri(s.uri)}function w(n){return typeof n?.id=="string"&&!a(n)&&!d(n)}e.$ui={id:"ext-dev"},e.$vi={id:"empty-window"};function v(n,s){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,R.$oc)(n)}:s?e.$ui:e.$vi;const o=n;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function d(n){const s=n;return typeof s?.id=="string"&&D.URI.isUri(s.configPath)}function $(n){const s=n;if(s?.uri)return{id:s.id,uri:D.URI.revive(s.uri)};const o=n;if(o?.configPath)return{id:o.id,configPath:D.URI.revive(o.configPath)};if(n?.id)return{id:n.id}}var b;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(b||(e.WorkbenchState=b={}));function O(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function m(n){const s=n;return!!(s&&typeof s=="object"&&D.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class c{constructor(s,o,l,P,I){this.h=s,this.j=l,this.k=P,this.l=I,this.c=k.$oi.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=k.$oi.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Bi=c;class y{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,A.$Vg)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ci=y;function p(n){return new y({uri:n,index:0,name:(0,A.$Rg)(n)},{uri:n.toString()})}e.$Ei="code-workspace",e.$Fi=`.${e.$Ei}`,e.$Gi=[{name:(0,j.localize)(0,null),extensions:[e.$Ei]}],e.$Hi="workspace.json";function h(n,s){return A.$Mg.isEqualOrParent(n,s.untitledWorkspacesHome)}function g(n){let s;return D.URI.isUri(n)?s=n:s=n.configuration,s?.scheme===u.Schemas.tmp}e.$Ki="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(n){return n.id===e.$Ki}function r(n,s){return!h(n,s)&&!g(n)}function t(n){return(typeof n=="string"?(0,R.$pc)(n):(0,A.$Tg)(n))===e.$Fi}}),define(ne[23],re([0,1,43,5,2,17,11,110,18,13,10,6,159,31,22,9,28,30,3]),function(J,e,j,R,k,A,D,E,u,a,w,v,d,$,b,O,m,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$rl=e.$ol=e.ProfileResourceType=void 0,e.$nl=h,e.$pl=g,e.$ql=i;var p;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(p||(e.ProfileResourceType=p={}));function h(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&D.URI.isUri(s.location)&&D.URI.isUri(s.globalStorageHome)&&D.URI.isUri(s.settingsResource)&&D.URI.isUri(s.keybindingsResource)&&D.URI.isUri(s.tasksResource)&&D.URI.isUri(s.snippetsHome)&&D.URI.isUri(s.extensionsResource))}e.$ol=(0,w.$ii)("IUserDataProfilesService");function g(n,s){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:D.URI.revive(n.location).with({scheme:s}),globalStorageHome:D.URI.revive(n.globalStorageHome).with({scheme:s}),settingsResource:D.URI.revive(n.settingsResource).with({scheme:s}),keybindingsResource:D.URI.revive(n.keybindingsResource).with({scheme:s}),tasksResource:D.URI.revive(n.tasksResource).with({scheme:s}),snippetsHome:D.URI.revive(n.snippetsHome).with({scheme:s}),extensionsResource:D.URI.revive(n.extensionsResource).with({scheme:s}),cacheHome:D.URI.revive(n.cacheHome).with({scheme:s}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}function i(n,s,o,l,P,I){return{id:n,name:s,location:o,isDefault:!1,shortName:P?.shortName,icon:P?.icon,globalStorageHome:I&&P?.useDefaultFlags?.globalState?I.globalStorageHome:(0,A.$Vg)(o,"globalStorage"),settingsResource:I&&P?.useDefaultFlags?.settings?I.settingsResource:(0,A.$Vg)(o,"settings.json"),keybindingsResource:I&&P?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,A.$Vg)(o,"keybindings.json"),tasksResource:I&&P?.useDefaultFlags?.tasks?I.tasksResource:(0,A.$Vg)(o,"tasks.json"),snippetsHome:I&&P?.useDefaultFlags?.snippets?I.snippetsHome:(0,A.$Vg)(o,"snippets"),extensionsResource:I&&P?.useDefaultFlags?.extensions?I.extensionsResource:(0,A.$Vg)(o,"extensions.json"),cacheHome:(0,A.$Vg)(l,n),useDefaultFlags:P?.useDefaultFlags,isTransient:P?.transient}}let r=class extends k.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,o,l,P){super(),this.t=s,this.u=o,this.w=l,this.y=P,this.f=!0,this.h=this.B(new R.$7d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new R.$7d),this.onWillCreateProfile=this.j.event,this.m=this.B(new R.$7d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new R.$7d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new $.$Bc,emptyWindows:new Map},this.profilesHome=(0,A.$Vg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$Vg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),o=[s];if(this.f)try{for(const I of this.O()){if(!I.name||!(0,y.$Vf)(I.name)||!I.location){this.y.warn("Skipping the invalid stored profile",I.location||I.name);continue}o.push(i((0,A.$Sg)(I.location),I.name,I.location,this.g,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},s))}}catch(I){this.y.error(I)}const l=new $.$Bc,P=new Map;if(o.length)try{const I=this.Q();if(I.workspaces)for(const[L,z]of Object.entries(I.workspaces)){const U=D.URI.parse(L),V=o.find(X=>X.id===z);V&&l.set(U,V)}if(I.emptyWindows)for(const[L,z]of Object.entries(I.emptyWindows)){const U=o.find(V=>V.id===z);U&&P.set(L,U)}}catch(I){this.y.error(I)}this.z={profiles:o,workspaces:l,emptyWindows:P}}return this.z}D(){const s=i("__default__profile__",(0,E.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",l=new RegExp(`${(0,c.$Ze)(o)}\\s(\\d+)`);let P=0;for(const L of this.profiles){const z=l.exec(L.name),U=z?parseInt(z[1]):0;P=U>P?U:P}const I=`${o} ${P+1}`;return this.createProfile((0,j.$9i)((0,m.$Eg)()).toString(16),I,{transient:!0},s)}async createNamedProfile(s,o,l){return this.createProfile((0,j.$9i)((0,m.$Eg)()).toString(16),s,o,l)}async createProfile(s,o,l,P){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.F(s,o,l);return P&&await this.setProfileForWorkspace(P,I),I}async F(s,o,l){if(!(0,y.$Vf)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let P=this.r.get(o);return P||(P=(async()=>{try{const I=this.profiles.find(U=>U.name===o||U.id===s);if(I)return I;const L=i(s,o,(0,A.$Vg)(this.profilesHome,s),this.g,l,this.defaultProfile);await this.u.createFolder(L.location);const z=[];return this.j.fire({profile:L,join(U){z.push(U)}}),await O.Promises.settled(z),this.I([L],[],[]),L}finally{this.r.delete(o)}})(),this.r.set(o,P)),P}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(P=>P.id===s.id);if(!l)throw new Error(`Profile '${s.name}' does not exist`);return l=i(l.id,o.name??l.name,l.location,this.g,{shortName:o.shortName??l.shortName,icon:o.icon===null?void 0:o.icon??l.icon,transient:o.transient??l.isTransient,useDefaultFlags:o.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(P=>P.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const l=[];this.m.fire({profile:o,join(P){l.push(P)}});try{await Promise.allSettled(l)}catch(P){this.y.error(P)}for(const P of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(P)?.id&&this.C.emptyWindows.delete(P);for(const P of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(P)?.id&&this.C.workspaces.delete(P);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(P){(0,a.$6k)(P)!==1&&this.y.error(P)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(P=>P.id===o.id);if(!l)throw new Error(`Profile '${o.name}' does not exist`);this.L(s,l)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.G(s);return D.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(s){return(0,d.$si)(s)?s.uri:(0,d.$xi)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location)))}I(s,o,l){const P=[...this.profiles,...s],I=[];this.s.profiles=[];for(let L of P)L.isDefault||o.some(z=>L.id===z.id)||(L=l.find(z=>L.id===z.id)??L,L.isTransient?this.s.profiles.push(L):I.push({location:L.location,name:L.name,shortName:L.shortName,icon:L.icon,useDefaultFlags:L.useDefaultFlags}));this.P(I),this.z=void 0,this.J(s,o,l)}J(s,o,l){this.h.fire({added:s,removed:o,updated:l,all:this.profiles})}L(s,o,l){l=o?.isTransient?!0:l,l||this.L(s,void 0,!0);const P=this.G(s),I=l?this.s:this.C;D.URI.isUri(P)?(I.workspaces.delete(P),o&&I.workspaces.set(P,o)):(I.emptyWindows.delete(P),o&&I.emptyWindows.set(P,o)),l||this.M()}M(){const s={};for(const[l,P]of this.C.workspaces.entries())s[l.toString()]=P.id;const o={};for(const[l,P]of this.C.emptyWindows.entries())o[l.toString()]=P.id;this.R({workspaces:s,emptyWindows:o}),this.z=void 0}N(s){const o={},l=this.D();if(s.workspaces)for(const[I,L]of Object.entries(s.workspaces)){const z=D.URI.parse(L);o[I]=this.w.extUri.isEqual(z,l.location)?l.id:this.w.extUri.basename(z)}const P={};if(s.emptyWindows)for(const[I,L]of Object.entries(s.emptyWindows)){const z=D.URI.parse(L);P[I]=this.w.extUri.isEqual(z,l.location)?l.id:this.w.extUri.basename(z)}return{workspaces:o,emptyWindows:P}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$rl=r,e.$rl=r=$e([oe(0,u.$pi),oe(1,a.$Ok),oe(2,b.$ml),oe(3,v.$Oj)],r);class t extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$sl=t}),define(ne[160],re([0,1,19,9,20,8,5,2,12,3,11,94,21,26,37,6,32,25,22,23]),function(J,e,j,R,k,A,D,E,u,a,w,v,d,$,b,O,m,c,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$9p=void 0,e.$0p=g,e.$$p=i;let h=class extends E.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(s,o,l,P,I,L){super(),this.z=s,this.C=o,this.D=l,this.F=P,this.G=I,this.H=L,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new D.$7d),this.s=this.B(new D.$7d),this.t=this.B(new D.$7d),this.u=this.B(new D.$7d),this.w=this.B(new D.$7d),this.y=[],this.B((0,E.$Sc)(()=>{this.j.forEach(({task:z})=>z.cancel()),this.m.forEach(z=>z.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(s){const o=await this.getTargetPlatform();return s.allTargetPlatforms.some(l=>(0,d.$Po)(l,s.allTargetPlatforms,o))}async installFromGallery(s,o={}){try{const P=(await this.installGalleryExtensions([{extension:s,options:o}])).find(({identifier:I})=>(0,$.$gp)(I,s.identifier));if(P?.local)return P?.local;throw P?.error?P.error:new d.$So(`Unknown error while installing extension ${s.identifier.id}`,d.ExtensionManagementErrorCode.Unknown)}catch(l){throw i(l)}}async installGalleryExtensions(s){if(!this.z.isEnabled())throw new d.$So(v.localize(0,null),d.ExtensionManagementErrorCode.NotAllowed);const o=[],l=[];await Promise.allSettled(s.map(async({extension:P,options:I})=>{try{const L=await this.N(P,!!I?.installGivenVersion,!!I?.installPreReleaseVersion,I.productVersion??{version:this.G.version,date:this.G.date});l.push({...L,options:I})}catch(L){o.push({identifier:P.identifier,operation:2,source:P,error:L})}})),l.length&&o.push(...await this.I(l));for(const P of o)P.error&&(this.F.error("Failed to install extension.",P.identifier.id),this.F.error(P.error),P.source&&!w.URI.isUri(P.source)&&r(this.C,"extensionGallery:install",{extensionData:(0,$.$op)(P.source),error:P.error}));return o}async uninstall(s,o={}){return this.F.trace("ExtensionManagementService#uninstall",s.identifier.id),this.P(s,o)}async toggleAppliationScope(s,o){if((0,b.$Gm)(s.manifest)||s.isBuiltin)return s;if(s.isApplicationScoped){let l=await this.updateMetadata(s,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)||(l=await this.$(s,this.H.defaultProfile.extensionsResource,o));for(const P of this.H.profiles){const I=(await this.getInstalled(1,P.extensionsResource)).find(L=>(0,$.$gp)(L.identifier,s.identifier));I?this.w.fire(I):this.u.fire({identifier:s.identifier,profileLocation:P.extensionsResource})}return l}else{const l=this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(s,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(s,o,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.W(),this.h=s),this.g}registerParticipant(s){this.y.push(s)}async I(s){const o=[],l=new Map,P=[],I=[],L=(U,V)=>`${$.$hp.create(U).toString()}-${V.toString()}`,z=(U,V,X)=>{const se=this.Y(U,V,X),ie=w.URI.isUri(V)?V.path:`${V.identifier.id.toLowerCase()}-${X.profileLocation.toString()}`;l.set(ie,{task:se,manifest:U}),this.n.fire({identifier:se.identifier,source:V,profileLocation:X.profileLocation}),this.F.info("Installing extension:",se.identifier.id),w.URI.isUri(V)||this.j.set(L(V,X.profileLocation),{task:se,waitingTasks:[]})};try{for(const{manifest:U,extension:V,options:X}of s){const se=X.isApplicationScoped||X.isBuiltin||(0,b.$Gm)(U),ie={...X,installOnlyNewlyAddedFromExtensionPack:X.installOnlyNewlyAddedFromExtensionPack??!w.URI.isUri(V),isApplicationScoped:se,profileLocation:se?this.H.defaultProfile.extensionsResource:X.profileLocation??this.X(),productVersion:X.productVersion??{version:this.G.version,date:this.G.date}},ue=w.URI.isUri(V)?void 0:this.j.get(L(V,ie.profileLocation));ue?(this.F.info("Extension is already requested to install",ue.task.identifier.id),P.push(ue.task.waitUntilTaskIsFinished())):z(U,V,ie)}await Promise.all([...l.values()].map(async({task:U,manifest:V})=>{if(U.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",U.identifier.id);else try{const X=await this.M(U.identifier,V,!!U.options.installOnlyNewlyAddedFromExtensionPack,!!U.options.installPreReleaseVersion,U.options.profileLocation,U.options.productVersion),se=await this.getInstalled(void 0,U.options.profileLocation,U.options.productVersion),ie={...U.options,donotIncludePackAndDependencies:!0,context:{...U.options.context,[d.$Ko]:!0}};for(const{gallery:ue,manifest:he}of(0,j.$Mb)(X,({gallery:ce})=>ce.identifier.id)){if(l.has(`${ue.identifier.id.toLowerCase()}-${ie.profileLocation.toString()}`))continue;const ce=this.j.get(L(ue,ie.profileLocation));if(ce){if(this.J(U,ce.task)){const B=ce.task.identifier;this.F.info("Waiting for already requested installing extension",B.id,U.identifier.id),ce.waitingTasks.push(U),P.push(D.Event.toPromise(D.Event.filter(this.onDidInstallExtensions,Z=>Z.some(q=>(0,$.$gp)(q.identifier,B)))).then(Z=>{if(this.F.info("Finished waiting for already requested installing extension",B.id,U.identifier.id),!Z.find(T=>(0,$.$gp)(T.identifier,B))?.local)throw new Error(`Extension ${B.id} is not installed`)}))}}else se.some(({identifier:B})=>(0,$.$gp)(B,ue.identifier))||z(he,ue,ie)}}catch(X){if(w.URI.isUri(U.source))(0,j.$Lb)(V.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",U.identifier.id,X.message),(0,j.$Lb)(V.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",U.identifier.id,X.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",U.identifier.id),X}})),await this.L([...l.values()].map(async({task:U})=>{const V=new Date().getTime();try{const X=await U.run();if(await this.L(this.y.map(se=>se.postInstall(X,U.source,U.options,k.CancellationToken.None))),!w.URI.isUri(U.source)){const se=U.operation===3,ie=se?void 0:(new Date().getTime()-U.source.lastUpdated)/1e3;if(r(this.C,se?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,$.$op)(U.source),verificationStatus:U.verificationStatus,duration:new Date().getTime()-V,durationSinceUpdate:ie}),u.$o&&U.operation!==3)try{await this.z.reportStatistic(X.manifest.publisher,X.manifest.name,X.manifest.version,"install")}catch{}}I.push({local:X,identifier:U.identifier,operation:U.operation,source:U.source,context:U.options.context,profileLocation:U.profileLocation,applicationScoped:X.isApplicationScoped})}catch(X){throw this.F.error("Error while installing the extension",U.identifier.id,(0,A.$0)(X)),X}})),P.length&&await this.L(P);for(const U of I)this.F.info("Extension installed successfully:",U.identifier.id),o.push(U);return o}catch(U){I.length&&await Promise.allSettled(I.map(async({local:V,profileLocation:X})=>{try{await this.Z(V,{versionOnly:!0,profileLocation:X}).run(),this.F.info("Rollback: Uninstalled extension",V.identifier.id)}catch(se){this.F.warn("Rollback: Error while uninstalling extension",V.identifier.id,(0,A.$0)(se))}}));for(const{task:V}of l.values())V.cancel(),o.push({identifier:V.identifier,operation:2,source:V.source,context:V.options.context,profileLocation:V.profileLocation,error:U});throw U}finally{for(const{task:U}of l.values())U.source&&!w.URI.isUri(U.source)&&this.j.delete(L(U.source,U.profileLocation));o.length&&this.s.fire(o)}}J(s,o){for(const[,{task:l,waitingTasks:P}]of this.j.entries())if(l===s&&(P.includes(o)||P.some(I=>this.J(I,o)))||l===o&&P[0]&&!this.J(s,P[0]))return!1;return!0}async L(s){const o=[],l=[],P=await Promise.allSettled(s);for(const I of P)I.status==="fulfilled"?o.push(I.value):l.push(I.reason);if(l.length)throw g(l);return o}async M(s,o,l,P,I,L){if(!this.z.isEnabled())return[];const z=await this.getInstalled(void 0,I,L),U=[],V=[],X=async(se,ie)=>{U.push(se);const ue=ie.extensionDependencies||[],he=[...ue];if(ie.extensionPack){const ce=l?z.find(B=>(0,$.$gp)(B.identifier,se)):void 0;for(const B of ie.extensionPack)ce&&ce.manifest.extensionPack&&ce.manifest.extensionPack.some(Z=>(0,$.$gp)({id:Z},{id:B}))||he.every(Z=>!(0,$.$gp)({id:Z},{id:B}))&&he.push(B)}if(he.length){const ce=he.filter(B=>U.every(Z=>!(0,$.$gp)(Z,{id:B})));if(ce.length){const B=await this.z.getExtensions(ce.map(Z=>({id:Z,preRelease:P})),k.CancellationToken.None);for(const Z of B){if(U.find(W=>(0,$.$gp)(W,Z.identifier)))continue;const q=ue.some(W=>(0,$.$gp)({id:W},Z.identifier));let T;try{T=await this.N(Z,!1,P,L)}catch(W){if(q)throw W;this.F.info("Skipping the packed extension as it cannot be installed",Z.identifier.id,(0,A.$0)(W));continue}V.push({gallery:T.extension,manifest:T.manifest}),await X(T.extension.identifier,T.manifest)}}}};return await X(s,o),V}async N(s,o,l,P){let I;const L=await this.getExtensionsControlManifest();if(L.malicious.some(V=>(0,$.$gp)(s.identifier,V)))throw new d.$So(v.localize(1,null,s.identifier.id),d.ExtensionManagementErrorCode.Malicious);const z=L.deprecated[s.identifier.id.toLowerCase()];if(z?.extension?.autoMigrate){if(this.F.info(`The '${s.identifier.id}' extension is deprecated, fetching the compatible '${z.extension.id}' extension instead.`),I=(await this.z.getExtensions([{id:z.extension.id,preRelease:z.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:P},k.CancellationToken.None))[0],!I)throw new d.$So(v.localize(2,null,s.identifier.id,z.extension.id),d.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(s)){const V=await this.getTargetPlatform();throw new d.$So(v.localize(3,null,s.identifier.id,this.G.nameLong,(0,d.$Lo)(V)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(I=await this.O(s,o,l,P),!I)throw!l&&s.properties.isPreReleaseVersion&&(await this.z.getExtensions([s.identifier],k.CancellationToken.None))[0]?new d.$So(v.localize(4,null,s.displayName??s.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.$So(v.localize(5,null,s.identifier.id,this.G.nameLong,this.G.version),d.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",I.identifier.id);const U=await this.z.getManifest(I,k.CancellationToken.None);if(U===null)throw new d.$So(`Missing manifest for extension ${I.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(U.version!==I.version)throw new d.$So(`Cannot install '${I.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:I,manifest:U}}async O(s,o,l,P){const I=await this.getTargetPlatform();let L=null;return!o&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==l&&(L=(await this.z.getExtensions([{...s.identifier,preRelease:l}],{targetPlatform:I,compatible:!0,productVersion:P},k.CancellationToken.None))[0]||null),!L&&await this.z.isExtensionCompatible(s,l,I,P)&&(L=s),L||(o?L=(await this.z.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:I,compatible:!0,productVersion:P},k.CancellationToken.None))[0]||null:L=await this.z.getCompatibleExtension(s,l,I,P)),L}async P(s,o){const l={...o,profileLocation:s.isApplicationScoped?this.H.defaultProfile.extensionsResource:o.profileLocation??this.X()},P=X=>`${X.id.toLowerCase()}${l.versionOnly?`-${s.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,I=this.m.get(P(s.identifier));if(I)return this.F.info("Extensions is already requested to uninstall",s.identifier.id),I.waitUntilTaskIsFinished();const L=X=>{const se=this.Z(X,l);return this.m.set(P(se.extension.identifier),se),l.profileLocation?this.F.info("Uninstalling extension from the profile:",`${X.identifier.id}@${X.manifest.version}`,l.profileLocation.toString()):this.F.info("Uninstalling extension:",`${X.identifier.id}@${X.manifest.version}`),this.t.fire({identifier:X.identifier,profileLocation:l.profileLocation,applicationScoped:X.isApplicationScoped}),se},z=(X,se)=>{se?l.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${X.identifier.id}@${X.manifest.version}`,l.profileLocation.toString(),se.message):this.F.error("Failed to uninstall extension:",`${X.identifier.id}@${X.manifest.version}`,se.message):l.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${X.identifier.id}@${X.manifest.version}`,l.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${X.identifier.id}@${X.manifest.version}`),r(this.C,"extensionGallery:uninstall",{extensionData:(0,$.$np)(X),error:se}),this.u.fire({identifier:X.identifier,error:se?.code,profileLocation:l.profileLocation,applicationScoped:X.isApplicationScoped})},U=[],V=[];try{U.push(L(s));const X=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const se=this.S(s,X);for(const ie of se)this.m.has(P(ie.identifier))?this.F.info("Extensions is already requested to uninstall",ie.identifier.id):U.push(L(ie))}l.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.Q(U.map(se=>se.extension),X,s),await this.L(U.map(async se=>{try{if(await se.run(),await this.L(this.y.map(ie=>ie.postUninstall(se.extension,l,k.CancellationToken.None))),se.extension.identifier.uuid)try{await this.z.reportStatistic(se.extension.manifest.publisher,se.extension.manifest.name,se.extension.manifest.version,"uninstall")}catch{}z(se.extension)}catch(ie){const ue=ie instanceof d.$So?ie:new d.$So((0,A.$0)(ie),d.ExtensionManagementErrorCode.Internal);throw z(se.extension,ue),ue}finally{V.push(se)}}))}catch(X){const se=X instanceof d.$So?X:new d.$So((0,A.$0)(X),d.ExtensionManagementErrorCode.Internal);for(const ie of U){try{ie.cancel()}catch{}V.includes(ie)||z(ie.extension,se)}throw se}finally{for(const X of U)this.m.delete(P(X.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",X.extension.identifier.id)}}Q(s,o,l){for(const P of s){const I=this.U(P,o);if(I.length){const L=I.filter(z=>!s.some(U=>(0,$.$gp)(U.identifier,z.identifier)));if(L.length)throw new Error(this.R(P,L,l))}}}R(s,o,l){return l===s?o.length===1?v.localize(6,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?v.localize(7,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):v.localize(8,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?v.localize(9,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?v.localize(10,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):v.localize(11,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}S(s,o,l=[]){if(l.indexOf(s)!==-1)return[];l.push(s);const P=s.manifest.extensionPack?s.manifest.extensionPack:[];if(P.length){const I=o.filter(z=>!z.isBuiltin&&P.some(U=>(0,$.$gp)({id:U},z.identifier))),L=[];for(const z of I)L.push(...this.S(z,o,l));return[...I,...L]}return[]}U(s,o){return o.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(P=>(0,$.$gp)({id:P},s.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(s){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,A.$0)(s)),{malicious:[],deprecated:{},search:[]}}}};e.$9p=h,e.$9p=h=$e([oe(0,d.$Ro),oe(1,c.$Nl),oe(2,y.$ml),oe(3,O.$Oj),oe(4,m.$8j),oe(5,p.$ol)],h);function g(n){const s=Array.isArray(n)?n:[n];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((o,l)=>new Error(`${o.message}${o.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}function i(n){if(n instanceof d.$So)return n;if(n instanceof d.$To){const o=new d.$So(n.message,d.ExtensionManagementErrorCode.Gallery);return o.stack=n.stack,o}const s=new d.$So(n.message,d.ExtensionManagementErrorCode.Internal);return s.stack=n.stack,s}function r(n,s,{extensionData:o,verificationStatus:l,duration:P,error:I,durationSinceUpdate:L}){let z,U;(0,a.$4f)(l)&&(l===!0?l="Verified":(l===!1||(z=d.ExtensionManagementErrorCode.Signature,U=l),l="Unverified")),I&&(I instanceof d.$So||I instanceof d.$To?(z=I.code,I.code===d.ExtensionManagementErrorCode.Signature&&(U=I.message)):z=d.ExtensionManagementErrorCode.Internal),n.publicLog(s,{...o,verificationStatus:l,success:!I,duration:P,errorcode:z,errorcodeDetail:U,durationSinceUpdate:L})}class t{constructor(){this.d=new R.$hh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,R.$8g)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,R.$8g)(s=>new Promise((o,l)=>{const P=s.onCancellationRequested(()=>{P.dispose(),l(new A.$5)})})),this.d.open()),this.g.cancel()}}e.$_p=t}),define(ne[42],re([0,1,9,14,2,5,31,11,21,26,13,10,6,23,22,3,8,25]),function(J,e,j,R,k,A,D,E,u,a,w,v,d,$,b,O,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=e.$aq=e.ExtensionsProfileScanningErrorCode=void 0;var y;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(y||(e.ExtensionsProfileScanningErrorCode=y={}));class p extends Error{constructor(t,n){super(t),this.code=n}}e.$aq=p,e.$bq=(0,v.$ii)("IExtensionsProfileScannerService");let h=class extends k.$Uc{constructor(t,n,s,o,l,P){super(),this.j=t,this.m=n,this.n=s,this.r=o,this.s=l,this.t=P,this.b=this.B(new A.$7d),this.onAddExtensions=this.b.event,this.c=this.B(new A.$7d),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$7d),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$7d),this.onDidRemoveExtensions=this.g.event,this.h=new D.$Bc}scanProfileExtensions(t,n){return this.u(t,void 0,n)}async addExtensionsToProfile(t,n,s){const o=[],l=[];try{return await this.u(n,P=>{const I=[];if(s)I.push(...P);else for(const L of P)t.some(([z])=>(0,a.$gp)(z.identifier,L.identifier)&&z.manifest.version!==L.version)?o.push(L):I.push(L);for(const[L,z]of t){const U=I.findIndex(X=>(0,a.$gp)(X.identifier,L.identifier)&&X.version===L.manifest.version),V={identifier:L.identifier,version:L.manifest.version,location:L.location,metadata:z};U===-1?(l.push(V),I.push(V)):I.splice(U,1,V)}return l.length&&this.b.fire({extensions:l,profileLocation:n}),o.length&&this.f.fire({extensions:o,profileLocation:n}),I}),l.length&&this.c.fire({extensions:l,profileLocation:n}),o.length&&this.g.fire({extensions:o,profileLocation:n}),l}catch(P){throw l.length&&this.c.fire({extensions:l,error:P,profileLocation:n}),o.length&&this.g.fire({extensions:o,error:P,profileLocation:n}),P}}async updateMetadata(t,n){const s=[];return await this.u(n,o=>{const l=[];for(const P of o){const I=t.find(([L])=>(0,a.$gp)(L.identifier,P.identifier)&&L.manifest.version===P.version);I&&(P.metadata={...P.metadata,...I[1]},s.push(P)),l.push(P)}return l}),s}async removeExtensionFromProfile(t,n){const s=[];try{await this.u(n,o=>{const l=[];for(const P of o)(0,a.$gp)(P.identifier,t.identifier)?s.push(P):l.push(P);return s.length&&this.f.fire({extensions:s,profileLocation:n}),l}),s.length&&this.g.fire({extensions:s,profileLocation:n})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:n}),o}}async u(t,n,s){return this.F(t).queue(async()=>{let o=[],l;try{const P=await this.m.readFile(t);l=JSON.parse(P.value.toString().trim()||"[]")}catch(P){if((0,w.$6k)(P)!==1)throw P;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&s?.bailOutWhenFileNotFound)throw new p((0,m.$0)(P),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.w(t);let P=!1;for(const I of l){g(I)||this.w(t);let L;if((0,O.$Vf)(I.relativeLocation)&&I.relativeLocation)L=this.z(I.relativeLocation);else if((0,O.$Vf)(I.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${I.location}`);continue}else{L=E.URI.revive(I.location);const z=this.y(L);z&&(P=!0,I.relativeLocation=z)}(0,O.$3f)(I.metadata?.hasPreReleaseVersion)&&I.metadata?.preRelease&&(P=!0,I.metadata.hasPreReleaseVersion=!0),o.push({identifier:I.identifier,location:L,version:I.version,metadata:I.metadata})}P&&await this.m.writeFile(t,R.$ue.fromString(JSON.stringify(l)))}if(n){o=n(o);const P=o.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.y(I.location),metadata:I.metadata}));await this.m.writeFile(t,R.$ue.fromString(JSON.stringify(P)))}return o})}w(t){const n=new p(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),n=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(t)).value.toString()}catch(l){if((0,w.$6k)(l)===1)return;throw l}this.t.info("Migrating extensions from old default profile location",t.toString());let o;try{const l=JSON.parse(s);Array.isArray(l)&&l.every(P=>g(P))?o=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,R.$ue.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,w.$6k)(l)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(t)}catch(l){(0,w.$6k)(l)!==1&&this.t.error(l)}try{await this.m.del(n)}catch(l){(0,w.$6k)(l)!==1&&this.t.error(l)}return o})()),this.C}F(t){let n=this.h.get(t);return n||(n=new j.$ph,this.h.set(t,n)),n}};e.$cq=h,e.$cq=h=$e([oe(1,w.$Ok),oe(2,$.$ol),oe(3,b.$ml),oe(4,c.$Nl),oe(5,d.$Oj)],h);function g(r){return(0,O.$Xf)(r)&&(0,u.$Qo)(r.identifier)&&(i(r.location)||(0,O.$Vf)(r.location)&&r.location)&&((0,O.$3f)(r.relativeLocation)||(0,O.$Vf)(r.relativeLocation))&&r.version&&(0,O.$Vf)(r.version)}function i(r){return r?(0,O.$Vf)(r.path)&&(0,O.$Vf)(r.scheme):!1}}),define(ne[53],re([0,1,19,9,27,14,8,38,82,2,15,16,12,17,44,55,3,11,98,18,26,37,50,13,10,6,32,5,47,42,23,22,116]),function(J,e,j,R,k,A,D,E,u,a,w,v,d,$,b,O,m,c,y,p,h,g,i,r,t,n,s,o,l,P,I,L,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$hq=e.$gq=e.$fq=e.Translations=void 0,e.$iq=ue;var U;(function(ce){function B(Z,q){if(Z===q)return!0;const T=Object.keys(Z),W=new Set;for(const Q of Object.keys(q))W.add(Q);if(T.length!==W.size)return!1;for(const Q of T){if(Z[Q]!==q[Q])return!1;W.delete(Q)}return W.size===0}ce.equals=B})(U||(e.Translations=U={})),e.$fq=(0,t.$ii)("IExtensionsScannerService");let V=class extends a.$Uc{constructor(B,Z,q,T,W,Q,Y,_,M,F,f,S){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=Z,this.r=q,this.s=T,this.t=W,this.u=Q,this.w=Y,this.y=_,this.z=M,this.C=F,this.D=f,this.F=S,this.g=this.B(new o.$7d),this.onDidChangeCache=this.g.event,this.h=(0,$.$Vg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ie,this.s,this.h)),this.m=this.B(this.F.createInstance(ie,this.s,this.h)),this.n=this.B(this.F.createInstance(se,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,h.$rp)(this.w,this.y)),this.G}async scanAllExtensions(B,Z,q){const[T,W]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(Z)]),Q=q?await this.scanExtensionsUnderDevelopment(B,[...T,...W]):[];return this.L(T,W,Q,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const Z=[];Z.push(this.M(!!B.useCache,B.language)),Z.push(this.N(B.language,!!B.checkControlFile));const[q,T]=await Promise.all(Z);return this.J([...q,...T],0,B,!1)}async scanUserExtensions(B){const Z=B.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Z);const q=this.D.extUri.isEqual(B.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,T=await this.P(Z,!!B.profileLocation,1,!B.includeUninstalled,B.language,!0,q,B.productVersion??this.R()),W=B.useCache&&!T.devMode&&T.excludeObsolete?this.m:this.n;let Q;try{Q=await W.scanExtensions(T)}catch(Y){if(Y instanceof P.$aq&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),Q=await W.scanExtensions(T);else throw Y}return Q=await this.J(Q,1,B,!0),this.y.trace("Scanned user extensions:",Q.length),Q}async scanExtensionsUnderDevelopment(B,Z){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const q=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(T=>T.scheme===w.Schemas.file).map(async T=>{const W=await this.P(T,!1,1,!0,B.language,!1,void 0,B.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(W)).map(Y=>(Y.type=Z.find(_=>(0,h.$gp)(_.identifier,Y.identifier))?.type??Y.type,this.n.validate(Y,W)))}))).flat();return this.J(q,"development",B,!0)}return[]}async scanExistingExtension(B,Z,q){const T=await this.P(B,!1,Z,!0,q.language,!0,void 0,q.productVersion??this.R()),W=await this.n.scanExtension(T);return!W||!q.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(B,Z,q){const T=await this.P(B,!1,Z,!0,q.language,!0,void 0,q.productVersion??this.R()),W=await this.n.scanOneOrMultipleExtensions(T);return this.J(W,Z,q,!0)}async scanMultipleExtensions(B,Z,q){const T=[];return await Promise.all(B.map(async W=>{const Q=await this.scanOneOrMultipleExtensions(W,Z,q);T.push(...Q)})),this.J(T,Z,q,!0)}async scanMetadata(B){const Z=(0,$.$Vg)(B,"package.json"),q=(await this.w.readFile(Z)).value.toString();return JSON.parse(q).__metadata}async updateMetadata(B,Z){const q=(0,$.$Vg)(B,"package.json"),T=(await this.w.readFile(q)).value.toString(),W=JSON.parse(T);Z.isMachineScoped===!1&&delete Z.isMachineScoped,Z.isBuiltin===!1&&delete Z.isBuiltin,W.__metadata={...W.__metadata,...Z},await this.w.writeFile((0,$.$Vg)(B,"package.json"),A.$ue.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(B){if(B instanceof P.$aq&&B.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw B}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const B=await this.scanUserExtensions({includeInvalid:!0});if(B.length)await this.u.addExtensionsToProfile(B.map(Z=>[Z,Z.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$ue.fromString(JSON.stringify([])))}catch(Z){(0,r.$6k)(Z)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$0)(Z))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(B){this.y.error(B)}finally{this.H=void 0}})()),this.H}async J(B,Z,q,T){return q.includeAllVersions||(B=this.L(Z===0?B:void 0,Z===1?B:void 0,Z==="development"?B:void 0,await this.getTargetPlatform(),T)),q.includeInvalid||(B=B.filter(W=>W.isValid)),B.sort((W,Q)=>{const Y=v.$oc(W.location.fsPath),_=v.$oc(Q.location.fsPath);return Y<_?-1:Y>_?1:0})}L(B,Z,q,T,W){const Q=(_,M,F)=>{if(_.isValid&&!M.isValid)return!1;if(_.isValid===M.isValid){if(W&&b.gt(_.manifest.version,M.manifest.version))return this.y.debug(`Skipping extension ${M.location.path} with lower version ${M.manifest.version} in favour of ${_.location.path} with version ${_.manifest.version}`),!1;if(b.eq(_.manifest.version,M.manifest.version)){if(_.type===0)return this.y.debug(`Skipping extension ${M.location.path} in favour of system extension ${_.location.path} with same version`),!1;if(_.targetPlatform===T)return this.y.debug(`Skipping extension ${M.location.path} from different target platform ${M.targetPlatform}`),!1}}return F?this.y.warn(`Overwriting user extension ${_.location.path} with ${M.location.path}.`):this.y.debug(`Overwriting user extension ${_.location.path} with ${M.location.path}.`),!0},Y=new g.$Fm;return B?.forEach(_=>{const M=Y.get(_.identifier.id);(!M||Q(M,_,!1))&&Y.set(_.identifier.id,_)}),Z?.forEach(_=>{const M=Y.get(_.identifier.id);if(!M&&B&&_.type===0){this.y.debug(`Skipping obsolete system extension ${_.location.path}.`);return}(!M||Q(M,_,!1))&&Y.set(_.identifier.id,_)}),q?.forEach(_=>{const M=Y.get(_.identifier.id);(!M||Q(M,_,!0))&&Y.set(_.identifier.id,_),Y.set(_.identifier.id,_)}),[...Y.values()]}async M(B,Z){this.y.trace("Started scanning system extensions");const q=await this.P(this.systemExtensionsLocation,!1,0,!0,Z,!0,void 0,this.R()),W=await(B&&!q.devMode?this.j:this.n).scanExtensions(q);return this.y.trace("Scanned system extensions:",W.length),W}async N(B,Z){const q=this.z.isBuilt?[]:this.C.builtInExtensions;if(!q?.length)return[];this.y.trace("Started scanning dev system extensions");const T=Z?await this.O():{},W=[],Q=c.URI.file(v.$ic(v.$kc(w.$Cg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const _ of q){const M=T[_.name]||"marketplace";switch(M){case"disabled":break;case"marketplace":W.push((0,$.$Vg)(Q,_.name));break;default:W.push(c.URI.file(M));break}}const Y=await Promise.all(W.map(async _=>this.n.scanExtension(await this.P(_,!1,0,!0,B,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",Y.length),(0,j.$Hb)(Y)}async O(){try{const B=await this.w.readFile(this.r);return JSON.parse(B.value.toString())}catch{return{}}}async P(B,Z,q,T,W,Q,Y,_){const M=await this.f(W??d.$w),F=await this.Q(B),f=Z&&!this.D.extUri.isEqual(B,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,S=f?await this.Q(f):void 0;return new X(B,F,f,S,Z,Y,q,T,Q,_.version,_.date,this.C.commit,!this.z.isBuilt,W,M)}async Q(B){try{const Z=await this.w.stat(B);if(typeof Z.mtime=="number")return Z.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$gq=V,e.$gq=V=$e([oe(4,I.$ol),oe(5,P.$bq),oe(6,r.$Ok),oe(7,n.$Oj),oe(8,p.$pi),oe(9,s.$8j),oe(10,L.$ml),oe(11,t.$hi)],V);class X{constructor(B,Z,q,T,W,Q,Y,_,M,F,f,S,N,C,x){this.location=B,this.mtime=Z,this.applicationExtensionslocation=q,this.applicationExtensionslocationMtime=T,this.profile=W,this.profileScanOptions=Q,this.type=Y,this.excludeObsolete=_,this.validate=M,this.productVersion=F,this.productDate=f,this.productCommit=S,this.devMode=N,this.language=C,this.translations=x}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,Z){return(0,$.$Og)(B.location,Z.location)&&B.mtime===Z.mtime&&(0,$.$Og)(B.applicationExtensionslocation,Z.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===Z.applicationExtensionslocationMtime&&B.profile===Z.profile&&k.$Sn(B.profileScanOptions,Z.profileScanOptions)&&B.type===Z.type&&B.excludeObsolete===Z.excludeObsolete&&B.validate===Z.validate&&B.productVersion===Z.productVersion&&B.productDate===Z.productDate&&B.productCommit===Z.productCommit&&B.devMode===Z.devMode&&B.language===Z.language&&U.equals(B.translations,Z.translations)}}e.$hq=X;let se=class extends a.$Uc{constructor(B,Z,q,T,W){super(),this.f=B,this.g=Z,this.h=q,this.j=T,this.m=W}async scanExtensions(B){const Z=B.profile?await this.r(B):await this.n(B);let q={};if(B.excludeObsolete&&B.type===1)try{const T=(await this.j.readFile(this.f)).value.toString();q=JSON.parse(T)}catch{}return(0,m.$9f)(q)?Z:Z.filter(T=>!q[h.$hp.create(T).toString()])}async n(B){const Z=await this.j.resolve(B.location);if(!Z.children?.length)return[];const q=await Promise.all(Z.children.map(async T=>{if(!T.isDirectory||B.type===1&&(0,$.$Sg)(T.resource).indexOf(".")===0)return null;const W=new X(T.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(W)}));return(0,j.$Hb)(q).sort((T,W)=>T.location.path<W.location.path?-1:1)}async r(B){let Z=await this.s(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.h.extUri.isEqual(B.location,B.applicationExtensionslocation)){Z=Z.filter(T=>!T.metadata?.isApplicationScoped);const q=await this.s(B.applicationExtensionslocation,T=>!!T.metadata?.isBuiltin||!!T.metadata?.isApplicationScoped,B);Z.push(...q)}return Z}async s(B,Z,q){const T=await this.g.scanProfileExtensions(B,q.profileScanOptions);if(!T.length)return[];const W=await Promise.all(T.map(async Q=>{if(Z(Q)){const Y=new X(Q.location,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(Y,Q.metadata)}return null}));return(0,j.$Hb)(W)}async scanOneOrMultipleExtensions(B){try{if(await this.j.exists((0,$.$Vg)(B.location,"package.json"))){const Z=await this.scanExtension(B);return Z?[Z]:[]}else return await this.scanExtensions(B)}catch(Z){return this.m.error(`Error scanning extensions at ${B.location.path}:`,(0,D.$0)(Z)),[]}}async scanExtension(B,Z){try{let q=await this.scanExtensionManifest(B.location);if(q){q.publisher||(q.publisher=g.$zm),Z=Z??q.__metadata,delete q.__metadata;const T=(0,h.$lp)(q.publisher,q.name),W=Z?.id?{id:T,uuid:Z.id}:{id:T},Q=Z?.isSystem?0:B.type,Y=Q===0||!!Z?.isBuiltin;q=await this.t(B.location,q,X.createNlsConfiguration(B));const _={type:Q,identifier:W,manifest:q,location:B.location,isBuiltin:Y,targetPlatform:Z?.targetPlatform??"undefined",metadata:Z,isValid:!0,validations:[]};return B.validate?this.validate(_,B):_}}catch(q){B.type!==0&&this.m.error(q)}return null}validate(B,Z){let q=!0;const T=(0,i.$wp)(Z.productVersion,Z.productDate,Z.location,B.manifest,B.isBuiltin);for(const[W,Q]of T)W===O.default.Error&&(q=!1,this.m.error(this.z(Z.location,Q)));return B.isValid=q,B.validations=T,B}async scanExtensionManifest(B){const Z=(0,$.$Vg)(B,"package.json");let q;try{q=(await this.j.readFile(Z)).value.toString()}catch(W){return(0,r.$6k)(W)!==1&&this.m.error(this.z(B,(0,y.localize)(0,null,Z.path,W.message))),null}let T;try{T=JSON.parse(q)}catch{const Q=[];(0,E.$vn)(q,Q);for(const Y of Q)this.m.error(this.z(B,(0,y.localize)(1,null,Z.path,Y.offset,Y.length,(0,u.$dq)(Y.error))));return null}return(0,E.$En)(T)!=="object"?(this.m.error(this.z(B,(0,y.localize)(2,null,Z.path))),null):T}async t(B,Z,q){const T=await this.u(B,Z,q);if(T)try{const W=[],Q=await this.w(T.default,W);if(W.length>0)return W.forEach(_=>{this.m.error(this.z(B,(0,y.localize)(3,null,T.default?.path,(0,u.$dq)(_.error))))}),Z;if((0,E.$En)(T)!=="object")return this.m.error(this.z(B,(0,y.localize)(4,null,T.default?.path))),Z;const Y=T.values||Object.create(null);return(0,z.$eq)(this.m,Z,Y,Q)}catch{}return Z}async u(B,Z,q){const T=(0,$.$Vg)(B,"package.nls.json"),W=(M,F)=>{F.forEach(f=>{this.m.error(this.z(B,(0,y.localize)(5,null,M?.path,(0,u.$dq)(f.error))))})},Q=M=>{this.m.error(this.z(B,(0,y.localize)(6,null,M?.path)))},Y=`${Z.publisher}.${Z.name}`,_=q.translations[Y];if(_)try{const M=c.URI.file(_),F=(await this.j.readFile(M)).value.toString(),f=[],S=(0,E.$vn)(F,f);return f.length>0?(W(M,f),{values:void 0,default:T}):(0,E.$En)(S)!=="object"?(Q(M),{values:void 0,default:T}):{values:S.contents?S.contents.package:void 0,default:T}}catch{return{values:void 0,default:T}}else{if(!await this.j.exists(T))return;let F;try{F=await this.y(B,q)}catch{return}if(!F.localized)return{values:void 0,default:F.original};try{const f=(await this.j.readFile(F.localized)).value.toString(),S=[],N=(0,E.$vn)(f,S);return S.length>0?(W(F.localized,S),{values:void 0,default:F.original}):(0,E.$En)(N)!=="object"?(Q(F.localized),{values:void 0,default:F.original}):{values:N,default:F.original}}catch{return{values:void 0,default:F.original}}}}async w(B,Z){if(B)try{const q=(await this.j.readFile(B)).value.toString();return(0,E.$vn)(q,Z)}catch{}}y(B,Z){return new Promise((q,T)=>{const W=Q=>{const Y=(0,$.$Vg)(B,`package.nls.${Q}.json`);this.j.exists(Y).then(_=>{_&&q({localized:Y,original:(0,$.$Vg)(B,"package.nls.json")});const M=Q.lastIndexOf("-");M===-1?q({localized:(0,$.$Vg)(B,"package.nls.json"),original:null}):(Q=Q.substring(0,M),W(Q))})};if(Z.devMode||Z.pseudo||!Z.language)return q({localized:(0,$.$Vg)(B,"package.nls.json"),original:null});W(Z.language)})}z(B,Z){return`[${B.path}]: ${Z}`}};se=$e([oe(1,P.$bq),oe(2,L.$ml),oe(3,r.$Ok),oe(4,n.$Oj)],se);let ie=class extends se{constructor(B,Z,q,T,W,Q,Y){super(Z,T,W,Q,Y),this.G=B,this.H=q,this.D=this.B(new R.$gh(3e3)),this.F=this.B(new o.$7d),this.onDidChangeCache=this.F.event}async scanExtensions(B){const Z=this.M(B),q=await this.I(Z);if(this.C=B,q&&q.input&&X.equals(q.input,this.C))return this.m.debug("Using cached extensions scan result",B.location.toString()),this.D.trigger(()=>this.L()),q.result.map(W=>(W.location=c.URI.revive(W.location),W));const T=await super.scanExtensions(B);return await this.J(Z,{input:B,result:T}),T}async I(B){try{const Z=await this.j.readFile(B),q=JSON.parse(Z.value.toString());return{result:q.result,input:(0,l.$Rh)(q.input)}}catch(Z){this.m.debug("Error while reading the extension cache file:",B.path,(0,D.$0)(Z))}return null}async J(B,Z){try{await this.j.writeFile(B,A.$ue.fromString(JSON.stringify(Z)))}catch(q){this.m.debug("Error while writing the extension cache file:",B.path,(0,D.$0)(q))}}async L(){if(!this.C)return;const B=this.M(this.C),Z=await this.I(B);if(!Z)return;const q=Z.result,T=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!k.$Sn(T,q))try{this.m.info("Invalidating Cache",q,T),await this.j.del(B),this.F.fire()}catch(W){this.m.error(W)}}M(B){const Z=this.N(B);return this.h.extUri.joinPath(Z.cacheHome,B.type===0?g.$ym:g.$xm)}N(B){return B.type===0?this.H.defaultProfile:B.profile?this.h.extUri.isEqual(B.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Z=>this.h.extUri.isEqual(B.location,Z.extensionsResource))??this.G:this.H.defaultProfile}};ie=$e([oe(2,I.$ol),oe(3,P.$bq),oe(4,L.$ml),oe(5,r.$Ok),oe(6,n.$Oj)],ie);function ue(ce,B){const Z=(0,h.$jp)(ce.manifest.publisher,ce.manifest.name);return{id:Z,identifier:new g.$Dm(Z),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:B,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,...ce.manifest}}class he extends V{constructor(B,Z,q,T,W,Q,Y,_,M,F,f,S){super(B,Z,(0,$.$Vg)(q,".vscode-oss-dev","extensions","control.json"),T,W,Q,Y,_,M,F,f,S),this.S=(async()=>{if(d.$z)try{const N=await this.w.readFile(c.URI.file(d.$z));return JSON.parse(N.value.toString())}catch{}return Object.create(null)})()}f(B){return this.S}}e.$jq=he}),define(ne[161],re([0,1,59,9,34,5,2,15,16,24,6,23]),function(J,e,j,R,k,A,D,E,u,a,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=void 0;let d=class extends D.$Uc{constructor(b,O){super(),this.b=b,this.f=O,this.a=new R.$oh(5)}async postUninstall(b){const O=this.g(b,"uninstall");O&&(this.f.info(b.identifier.id,b.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(O.script,"uninstall",O.args,!0,b),this.f.info("Finished running post uninstall script",b.identifier.id,b.manifest.version)}catch(m){this.f.error("Failed to run post uninstall script",b.identifier.id,b.manifest.version),this.f.error(m)}}));try{await a.Promises.rm(this.m(b))}catch(m){this.f.error("Error while removing extension storage path",b.identifier.id),this.f.error(m)}}g(b,O){const m=`vscode:${O}`;if(b.location.scheme===E.Schemas.file&&b.manifest&&b.manifest.scripts&&typeof b.manifest.scripts[m]=="string"){const c=b.manifest.scripts[m].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.f.warn(b.identifier.id,b.manifest.version,`${m} should be a node script`),null):{script:(0,u.$kc)(b.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}h(b,O,m,c,y){return new Promise((p,h)=>{const g=this.j(b,O,m,y);let i;const r=t=>{i&&(clearTimeout(i),i=null),t?h(t):p(void 0)};g.on("error",t=>{r((0,k.$6i)(t)||"Unknown")}),g.on("exit",(t,n)=>{r(t?`post-${O} process exited with code ${t}`:void 0)}),c&&(i=setTimeout(()=>{i=null,g.kill(),h("timed out")},5e3))})}j(b,O,m,c){const y={silent:!0,execArgv:void 0},p=(0,j.fork)(b,[`--type=extension-post-${O}`,...m],y);p.stdout.setEncoding("utf8"),p.stderr.setEncoding("utf8");const h=A.Event.fromNodeEventEmitter(p.stdout,"data"),g=A.Event.fromNodeEventEmitter(p.stderr,"data");h(t=>this.f.info(c.identifier.id,c.manifest.version,`post-${O}`,t)),g(t=>this.f.error(c.identifier.id,c.manifest.version,`post-${O}`,t));const i=A.Event.any(A.Event.map(h,t=>({data:`%c${t}`,format:[""]})),A.Event.map(g,t=>({data:`%c${t}`,format:["color: red"]})));return A.Event.debounce(i,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(c.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),p}m(b){return(0,u.$kc)(this.b.defaultProfile.globalStorageHome.fsPath,b.identifier.id.toLowerCase())}};e.$lq=d,e.$lq=d=$e([oe(0,v.$ol),oe(1,w.$Oj)],d)}),define(ne[162],re([0,1,9,14,20,34,8,5,43,2,31,15,16,17,44,3,11,28,24,49,99,61,18,160,21,26,42,53,147,161,117,140,148,50,13,10,6,32,25,22,23]),function(J,e,j,R,k,A,D,E,u,a,w,v,d,$,b,O,m,c,y,p,h,g,i,r,t,n,s,o,l,P,I,L,z,U,V,X,se,ie,ue,he,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$rq=e.$qq=e.$pq=void 0,e.$pq=(0,X.$ji)(t.$Uo);const B=".vsctmp";let Z=class extends r.$9p{constructor(M,F,f,S,N,C,x,G,te,ae,le,pe){super(M,F,le,f,ae,pe),this.eb=N,this.fb=C,this.gb=x,this.hb=te,this.db=new Map,this.qb=new w.$Cc;const ye=this.B(G.createInstance(P.$lq));this.ab=this.B(G.createInstance(q,me=>ye.postUninstall(me))),this.bb=this.B(new L.$nq(pe,te,le,this,this.F)),this.cb=this.B(G.createInstance(l.$kq));const fe=this.B(new z.$oq(this,this.eb,pe,C,le,te,f));this.B(fe.onDidChangeExtensionsByAnotherSource(me=>this.pb(me))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,n.$rp)(this.hb,this.F)),this.ib}async zip(M){this.F.trace("ExtensionManagementService#zip",M.identifier.id);const F=await this.ob(M),f=await(0,p.zip)((0,$.$Vg)(this.cb.extensionsDownloadDir,(0,c.$Eg)()).fsPath,F);return m.URI.file(f)}async unzip(M){return this.F.trace("ExtensionManagementService#unzip",M.toString()),(await this.install(M)).identifier}async getManifest(M){const{location:F,cleanup:f}=await this.kb(M),S=d.$lc(F.fsPath);try{return await(0,I.$mq)(S)}finally{await f()}}getInstalled(M,F=this.H.defaultProfile.extensionsResource,f={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(M??null,F,f)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(M){return this.ab.scanUserExtensionAtLocation(M)}async install(M,F={}){this.F.trace("ExtensionManagementService#install",M.toString());const{location:f,cleanup:S}=await this.kb(M);try{const N=await(0,I.$mq)(d.$lc(f.fsPath)),C=(0,n.$lp)(N.publisher,N.name);if(N.engines&&N.engines.vscode&&!(0,U.$yp)(N.engines.vscode,this.G.version,this.G.date))throw new Error(h.localize(0,null,C,this.G.version));const G=(await this.I([{manifest:N,extension:f,options:F}])).find(({identifier:te})=>(0,n.$gp)(te,{id:C}));if(G?.local)return G.local;throw G?.error?G.error:(0,r.$$p)(new Error(`Unknown error while installing extension ${C}`))}finally{await S()}}async installFromLocation(M,F){this.F.trace("ExtensionManagementService#installFromLocation",M.toString());const f=await this.ab.scanUserExtensionAtLocation(M);if(!f||!f.manifest.name||!f.manifest.version)throw new Error(`Cannot find a valid extension from the location ${M.toString()}`);return await this.tb([[f,{source:"resource"}]],F),this.F.info("Successfully installed extension",f.identifier.id,F.toString()),f}async installExtensionsFromProfile(M,F,f){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",M,F.toString(),f.toString());const S=(await this.getInstalled(1,F)).filter(N=>M.some(C=>(0,n.$gp)(C,N.identifier)));if(S.length){const N=await Promise.all(S.map(C=>this.ab.scanMetadata(C,F)));await this.tb(S.map((C,x)=>[C,N[x]]),f),this.F.info("Successfully installed extensions",S.map(C=>C.identifier.id),f.toString())}return S}async updateMetadata(M,F,f=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",M.identifier.id),F.isPreReleaseVersion&&(F.preRelease=!0,F.hasPreReleaseVersion=!0),F.isMachineScoped===!1&&(F.isMachineScoped=void 0),F.isBuiltin===!1&&(F.isBuiltin=void 0),F.pinned===!1&&(F.pinned=void 0),M=await this.ab.updateMetadata(M,F,f),this.bb.invalidate(f),this.w.fire(M),M}async reinstallFromGallery(M){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",M.identifier.id),!this.z.isEnabled())throw new Error(h.localize(1,null));const F=await this.getTargetPlatform(),[f]=await this.z.getExtensions([{...M.identifier,preRelease:M.preRelease}],{targetPlatform:F,compatible:!0},k.CancellationToken.None);if(!f)throw new Error(h.localize(2,null));await this.ab.setUninstalled(M);try{await this.ab.removeUninstalledExtension(M)}catch(S){throw new Error(h.localize(3,null,(0,A.$6i)(S)))}return this.installFromGallery(f)}$(M,F,f,S){return this.ab.copyExtension(M,F,f,S)}copyExtensions(M,F){return this.ab.copyExtensions(M,F,{version:this.G.version,date:this.G.date})}markAsUninstalled(...M){return this.ab.setUninstalled(...M)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(M){this.F.error(M)}}async download(M,F,f){const{location:S}=await this.cb.download(M,F,!f);return S}async kb(M){if(M.scheme===v.Schemas.file)return{location:M,async cleanup(){}};this.F.trace("Downloading extension from",M.toString());const F=(0,$.$Vg)(this.cb.extensionsDownloadDir,(0,c.$Eg)());return await this.gb.download(M,F),this.F.info("Downloaded extension to",F.toString()),{location:F,cleanup:async()=>{try{await this.hb.del(F)}catch(S){this.F.error(S)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(M,F,f){if(m.URI.isUri(F))return new Q(M,F,f,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const S=n.$hp.create(F).toString();let N=this.db.get(S);return N||(this.db.set(S,N=new W(M,F,f,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F)),N.waitUntilTaskIsFinished().finally(()=>this.db.delete(S))),N}Z(M,F){return new Y(M,F.profileLocation,this.fb)}async ob(M){const F=async S=>{let N=await y.Promises.readdir(S);N=N.map(G=>d.$kc(S,G));const C=await Promise.all(N.map(G=>y.Promises.stat(G)));let x=Promise.resolve([]);return C.forEach((G,te)=>{const ae=N[te];G.isFile()&&(x=x.then(le=>[...le,ae])),G.isDirectory()&&(x=x.then(le=>F(ae).then(pe=>[...le,...pe])))}),x};return(await F(M.location.fsPath)).map(S=>({path:`extension/${d.$mc(M.location.fsPath,S)}`,localPath:S}))}async pb({added:M,removed:F}){if(F){const f=M&&this.D.extUri.isEqual(F.profileLocation,M.profileLocation)?F.extensions.filter(S=>M.extensions.every(N=>!(0,n.$gp)(N,S))):F.extensions;for(const S of f)this.F.info("Extensions removed from another source",S.id,F.profileLocation.toString()),this.u.fire({identifier:S,profileLocation:F.profileLocation})}if(M){const S=(await this.getInstalled(1,M.profileLocation)).filter(N=>M.extensions.some(C=>(0,n.$gp)(C,N.identifier)));this.s.fire(S.map(N=>(this.F.info("Extensions added from another source",N.identifier.id,M.profileLocation.toString()),{identifier:N.identifier,local:N,profileLocation:M.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(F=>this.qb.add(F)));const M=await this.hb.resolve(this.eb.userExtensionsLocation);for(const F of M.children??[])F.isDirectory&&this.qb.add(F.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(F=>this.sb(F)))}async sb(M){if(!M.affects(this.eb.userExtensionsLocation,1))return;const F=[];for(const f of M.rawAdded){if(this.qb.has(f)||!this.D.extUri.isEqual(this.D.extUri.dirname(f),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(f,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(f).startsWith(".")||!(await this.hb.stat(f)).isDirectory)continue;const S=await this.ab.scanUserExtensionAtLocation(f);S&&S.installedTimestamp===void 0&&(this.qb.add(f),F.push(S))}F.length&&(await this.tb(F.map(f=>[f,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",F.map(f=>f.identifier.id)))}async tb(M,F){const f=M.map(S=>S[0]);await this.ub(f),await this.fb.addExtensionsToProfile(M,F),this.s.fire(f.map(S=>({local:S,identifier:S.identifier,operation:1,profileLocation:F})))}async ub(M){const F=await this.ab.getUninstalledExtensions();for(const f of M){const S=n.$hp.create(f);F[S.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",S.id),await this.ab.setInstalled(S),this.F.info("Removed the extension from uninstalled list:",S.id))}}};e.$qq=Z,e.$qq=Z=$e([oe(0,t.$Ro),oe(1,ue.$Nl),oe(2,se.$Oj),oe(3,i.$qi),oe(4,o.$fq),oe(5,s.$bq),oe(6,g.$wo),oe(7,X.$hi),oe(8,V.$Ok),oe(9,ie.$8j),oe(10,he.$ml),oe(11,ce.$ol)],Z);let q=class extends a.$Uc{constructor(M,F,f,S,N,C){super(),this.j=M,this.m=F,this.n=f,this.s=S,this.t=N,this.u=C,this.h=this.B(new E.$7d),this.onExtract=this.h.event,this.c=(0,$.$Vg)(this.n.userExtensionsLocation,".obsolete"),this.g=new j.$ph}async cleanUp(){await this.H(),await this.G()}async scanExtensions(M,F,f){const S={includeInvalid:!0,profileLocation:F,productVersion:f};let N=[];return M===null||M===0?N.push(...await this.n.scanAllExtensions({includeInvalid:!0},S,!1)):M===1&&N.push(...await this.n.scanUserExtensions(S)),N=M!==null?N.filter(C=>C.type===M):N,Promise.all(N.map(C=>this.F(C)))}async scanAllUserExtensions(M){const F=await this.n.scanUserExtensions({includeAllVersions:!M,includeInvalid:!0});return Promise.all(F.map(f=>this.F(f)))}async scanUserExtensionAtLocation(M){try{const F=await this.n.scanExistingExtension(M,1,{includeInvalid:!0});if(F)return await this.F(F)}catch(F){this.u.error(F)}return null}async extractUserExtension(M,F,f,S,N){const C=M.toString(),x=m.URI.file(d.$kc(this.n.userExtensionsLocation.fsPath,`.${(0,c.$Eg)()}`)),G=m.URI.file(d.$kc(this.n.userExtensionsLocation.fsPath,C));let te=await this.m.exists(G);if(te&&S){try{await this.y(M.id,G,"removeExisting")}catch{throw new t.$So(h.localize(4,null,G.fsPath,M.id),t.ExtensionManagementErrorCode.Delete)}te=!1}if(te)await this.n.updateMetadata(G,f);else try{try{this.u.trace(`Started extracting the extension from ${F} to ${G.fsPath}`),await(0,p.$7p)(F,x.fsPath,{sourcePath:"extension",overwrite:!0},N),this.u.info(`Extracted extension to ${G}:`,M.id)}catch(ae){let le=t.ExtensionManagementErrorCode.Extract;throw ae instanceof p.$5p&&(ae.type==="CorruptZip"?le=t.ExtensionManagementErrorCode.CorruptZip:ae.type==="Incomplete"&&(le=t.ExtensionManagementErrorCode.IncompleteZip)),new t.$So(ae.message,le)}await this.n.updateMetadata(x,f);try{this.u.trace(`Started renaming the extension from ${x.fsPath} to ${G.fsPath}`),await this.C(x.fsPath,G.fsPath),this.u.info("Renamed to",G.fsPath)}catch(ae){if(ae.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",M.id);else throw this.u.info(`Rename failed because of ${(0,D.$0)(ae)}. Deleted from extracted location`,x),ae}this.h.fire(G)}catch(ae){try{await this.m.del(x,{recursive:!0})}catch{}throw ae}return this.D(G,1)}async scanMetadata(M,F){return F?(await this.w(M,F))?.metadata:this.n.scanMetadata(M.location)}async w(M,F){return(await this.s.scanProfileExtensions(F)).find(S=>(0,n.$gp)(S.identifier,M.identifier))}async updateMetadata(M,F,f){return f?await this.s.updateMetadata([[M,F]],f):await this.n.updateMetadata(M.location,F),this.D(M.location,M.type,f)}getUninstalledExtensions(){return this.z()}async setUninstalled(...M){const F=M.map(f=>n.$hp.create(f));await this.z(f=>F.forEach(S=>{f[S.toString()]=!0,this.u.info("Marked extension as uninstalled",S.toString())}))}async setInstalled(M){await this.z(F=>delete F[M.toString()])}async removeExtension(M,F){if(this.t.extUri.isEqualOrParent(M.location,this.n.userExtensionsLocation))return this.y(M.identifier.id,M.location,F)}async removeUninstalledExtension(M){await this.removeExtension(M,"uninstalled"),await this.z(F=>delete F[n.$hp.create(M).toString()])}async copyExtension(M,F,f,S){const N=await this.w(M,F),C=await this.w(M,f);if(S={...N?.metadata,...S},C)if(this.t.extUri.isEqual(C.location,M.location))await this.s.updateMetadata([[M,{...C.metadata,...S}]],f);else{const x=await this.D(C.location,M.type,f);await this.s.removeExtensionFromProfile(x,f),await this.s.addExtensionsToProfile([[M,{...C.metadata,...S}]],f)}else await this.s.addExtensionsToProfile([[M,S]],f);return this.D(M.location,M.type,f)}async copyExtensions(M,F,f){const S=await this.scanExtensions(1,M,f),N=await Promise.all(S.filter(C=>!C.isApplicationScoped).map(async C=>[C,await this.scanMetadata(C,M)]));await this.s.addExtensionsToProfile(N,F)}async y(M,F,f){this.u.trace(`Deleting ${f} extension from disk`,M,F.fsPath);const S=this.t.extUri.joinPath(this.t.extUri.dirname(F),`${this.t.extUri.basename(F)}.${(0,u.$9i)((0,c.$Eg)()).toString(16)}${B}`);await this.C(F.fsPath,S.fsPath),await this.m.del(S,{recursive:!0}),this.u.info(`Deleted ${f} extension from disk`,M,F.fsPath)}async z(M){return this.g.queue(async()=>{let F;try{F=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(S){if((0,V.$6k)(S)!==1)throw S}let f={};if(F)try{f=JSON.parse(F)}catch{}return M&&(M(f),Object.keys(f).length?await this.m.writeFile(this.c,R.$ue.fromString(JSON.stringify(f))):await this.m.del(this.c)),f})}async C(M,F){try{await y.Promises.rename(M,F,2*60*1e3)}catch(f){throw new t.$So(f.message||h.localize(5,null,M,F),f.code||t.ExtensionManagementErrorCode.Rename)}}async D(M,F,f){if(f){const N=(await this.n.scanUserExtensions({profileLocation:f})).find(C=>this.t.extUri.isEqual(C.location,M));if(N)return this.F(N)}else{const S=await this.n.scanExistingExtension(M,F,{includeInvalid:!0});if(S)return this.F(S)}throw new Error(h.localize(6,null,M.path))}async F(M){const F=await this.m.resolve(M.location);let f,S;return F.children&&(f=F.children.find(({name:N})=>/^readme(\.txt|\.md|)$/i.test(N))?.resource,S=F.children.find(({name:N})=>/^changelog(\.txt|\.md|)$/i.test(N))?.resource),{identifier:M.identifier,type:M.type,isBuiltin:M.isBuiltin||!!M.metadata?.isBuiltin,location:M.location,manifest:M.manifest,targetPlatform:M.targetPlatform,validations:M.validations,isValid:M.isValid,readmeUrl:f,changelogUrl:S,publisherDisplayName:M.metadata?.publisherDisplayName||null,publisherId:M.metadata?.publisherId||null,isApplicationScoped:!!M.metadata?.isApplicationScoped,isMachineScoped:!!M.metadata?.isMachineScoped,isPreReleaseVersion:!!M.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!M.metadata?.hasPreReleaseVersion,preRelease:!!M.metadata?.preRelease,installedTimestamp:M.metadata?.installedTimestamp,updated:!!M.metadata?.updated,pinned:!!M.metadata?.pinned,isWorkspaceScoped:!1,source:M.metadata?.source??(M.identifier.uuid?"gallery":"vsix")}}async G(){const M=await this.getUninstalledExtensions();if(Object.keys(M).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(M));const F=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),f=new Set;for(const N of F)M[n.$hp.create(N).toString()]||f.add(N.identifier.id.toLowerCase());try{const N=(0,n.$mp)(F,C=>C.identifier);await j.Promises.settled(N.map(async C=>{const x=C.sort((G,te)=>b.rcompare(G.manifest.version,te.manifest.version))[0];f.has(x.identifier.id.toLowerCase())||await this.j(await this.F(x))}))}catch(N){this.u.error(N)}const S=F.filter(N=>N.metadata&&M[n.$hp.create(N).toString()]);await Promise.allSettled(S.map(N=>this.removeUninstalledExtension(N)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let M;try{M=await this.m.resolve(this.n.userExtensionsLocation)}catch(F){(0,V.$6k)(F)!==1&&this.u.error(F);return}if(M?.children)try{await Promise.allSettled(M.children.map(async F=>{if(!(!F.isDirectory||!F.name.endsWith(B))){this.u.trace("Deleting the temporarily deleted folder",F.resource.toString());try{await this.m.del(F.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",F.resource.toString())}catch(f){(0,V.$6k)(f)!==1&&this.u.error(f)}}}))}catch{}}};e.$rq=q,e.$rq=q=$e([oe(1,V.$Ok),oe(2,o.$fq),oe(3,s.$bq),oe(4,he.$ml),oe(5,se.$Oj)],q);class T extends r.$_p{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,O.$3f)(this.options.operation)?this.l:this.options.operation}constructor(M,F,f,S,N,C,x,G,te){super(),this.identifier=M,this.source=F,this.options=f,this.m=S,this.n=N,this.o=C,this.p=x,this.q=G,this.s=te,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(M){const[F,f]=await this.x(M);return this.j=F.isBuiltin||F.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[F,f]],this.j,!F.isValid),F}async u({zipPath:M,key:F,metadata:f},S,N){let C=await this.v(F);return C?C=await this.m.updateMetadata(C,f):(this.s.trace("Extracting extension...",F.id),C=await this.m.extractUserExtension(F,M,f,S,N),this.s.info("Extracting extension completed.",F.id)),C}async v(M){return await this.w(M)?(this.s.trace("Removing the extension from uninstalled list:",M.id),await this.m.setInstalled(M),this.s.info("Removed the extension from uninstalled list:",M.id),(await this.m.scanAllUserExtensions(!0)).find(S=>n.$hp.create(S).equals(M))):void 0}async w(M){return!!(await this.m.getUninstalledExtensions())[M.toString()]}}class W extends T{constructor(M,F,f,S,N,C,x,G,te,ae){super(F.identifier,F,f,N,C,x,G,te,ae),this.y=F,this.z=S}async x(M){let F;try{F=await this.m.scanExtensions(null,this.options.profileLocation,this.options.productVersion)}catch(x){throw new t.$So(x,t.ExtensionManagementErrorCode.Scanning)}const f=F.find(x=>(0,n.$gp)(x.identifier,this.y.identifier));f&&(this.l=3);const S={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||f?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||f?.isMachineScoped,isBuiltin:this.options.isBuiltin||f?.isBuiltin,isSystem:f?.type===0?!0:void 0,updated:!!f,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:f?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??f?.pinned,preRelease:(0,O.$2f)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||f?.preRelease,source:"gallery"};if(f?.manifest.version===this.y.version)try{return[await this.m.updateMetadata(f,S),S]}catch(x){throw new t.$So((0,D.$0)(x),t.ExtensionManagementErrorCode.UpdateMetadata)}const{location:N,verificationStatus:C}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=C,this.B(N.fsPath),[await this.u({zipPath:N.fsPath,key:n.$hp.create(this.y),metadata:S},!1,M),S]}catch(x){try{await this.z.delete(N)}catch(G){this.s.warn("Error while deleting the downloaded file",N.toString(),(0,D.$0)(G))}throw x}}async B(M){try{await(0,I.$mq)(M)}catch(F){throw new t.$So((0,r.$0p)(F).message,t.ExtensionManagementErrorCode.Invalid)}}}e.$sq=W;class Q extends T{constructor(M,F,f,S,N,C,x,G,te,ae){super({id:(0,n.$lp)(M.publisher,M.name)},F,f,N,C,x,G,te,ae),this.y=M,this.z=F,this.A=S}async h(M){const F=await super.h(M);return this.D(F,M),F}async x(M){const F=new n.$hp(this.identifier,this.y.version),S=(await this.m.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(x=>(0,n.$gp)(this.identifier,x.identifier)),N={isApplicationScoped:this.options.isApplicationScoped||S?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||S?.isMachineScoped,isBuiltin:this.options.isBuiltin||S?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??S?.pinned,source:"vsix"};if(S)if(this.l=3,F.equals(new n.$hp(S.identifier,S.manifest.version)))try{await this.m.removeExtension(S,"existing")}catch{throw new Error(h.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&b.gt(S.manifest.version,this.y.version)&&await this.m.setUninstalled(S);else{const x=await this.v(F);if(x)try{await this.m.removeExtension(x,"existing")}catch{throw new Error(h.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:d.$lc(this.z.fsPath),key:F,metadata:N},!0,M),N]}async D(M,F){try{let[f]=await this.A.getExtensions([{id:M.identifier.id,version:M.manifest.version}],F);if(f||([f]=await this.A.getExtensions([{id:M.identifier.id}],F)),f){const S={id:f.identifier.uuid,publisherDisplayName:f.publisherDisplayName,publisherId:f.publisherId,isPreReleaseVersion:f.properties.isPreReleaseVersion,hasPreReleaseVersion:M.hasPreReleaseVersion||f.properties.isPreReleaseVersion,preRelease:f.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(M,S,this.options.profileLocation)}}catch{}}}class Y extends r.$_p{constructor(M,F,f){super(),this.extension=M,this.j=F,this.k=f}async h(M){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ne[163],re([0,1,6,23,22,25,42,13,18,11]),function(J,e,j,R,k,A,D,E,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3P=void 0;let w=class extends D.$cq{constructor(d,$,b,O,m,c){super(a.URI.file(d.extensionsPath),$,b,O,m,c)}};e.$3P=w,e.$3P=w=$e([oe(0,u.$qi),oe(1,E.$Ok),oe(2,R.$ol),oe(3,k.$ml),oe(4,A.$Nl),oe(5,j.$Oj)],w)}),define(ne[164],re([0,1,11,18,42,53,13,10,6,32,22,23]),function(J,e,j,R,k,A,D,E,u,a,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rbc=void 0;let d=class extends A.$jq{constructor(b,O,m,c,y,p,h,g){super(j.URI.file(y.builtinExtensionsPath),j.URI.file(y.extensionsPath),y.userHome,b.defaultProfile,b,O,m,c,y,p,h,g)}};e.$rbc=d,e.$rbc=d=$e([oe(0,v.$ol),oe(1,k.$bq),oe(2,D.$Ok),oe(3,u.$Oj),oe(4,R.$qi),oe(5,a.$8j),oe(6,w.$ml),oe(7,E.$hi)],d)}),define(ne[165],re([0,1,9,5,2,130,3,89,10,23]),function(J,e,j,R,k,A,D,E,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=e.$Op=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Mp=e.$Lp=e.$Kp=void 0,e.$Np=$,e.$Pp=O,e.$Rp=c,e.$Kp="__$__isNewStorageMarker",e.$Lp="__$__targetStorageMarker",e.$Mp=(0,u.$ii)("storageService");var w;(function(y){y[y.NONE=0]="NONE",y[y.SHUTDOWN=1]="SHUTDOWN"})(w||(e.WillSaveStateReason=w={}));var v;(function(y){y[y.APPLICATION=-1]="APPLICATION",y[y.PROFILE=0]="PROFILE",y[y.WORKSPACE=1]="WORKSPACE"})(v||(e.StorageScope=v={}));var d;(function(y){y[y.USER=0]="USER",y[y.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function $(y){const p=y.get(e.$Lp);if(p)try{return JSON.parse(p)}catch{}return Object.create(null)}class b extends k.$Uc{static{this.a=60*1e3}constructor(p={flushInterval:b.a}){super(),this.m=p,this.b=this.B(new R.$0d),this.c=this.B(new R.$0d),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.$7d),this.onWillSaveState=this.f.event,this.h=this.B(new j.$uh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new k.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(p,h,g){return R.Event.filter(this.b.event,i=>i.scope===p&&(h===void 0||i.key===h),g)}n(){this.j.value=(0,j.$yh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,k.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(p,h){const{key:g,external:i}=h;if(g===e.$Lp){switch(p){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:p})}else this.b.fire({scope:p,key:g,target:this.J(p)[g],external:i})}w(p){this.f.fire({reason:p})}get(p,h,g){return this.P(h)?.get(p,g)}getBoolean(p,h,g){return this.P(h)?.getBoolean(p,g)}getNumber(p,h,g){return this.P(h)?.getNumber(p,g)}getObject(p,h,g){return this.P(h)?.getObject(p,g)}storeAll(p,h){this.y(()=>{for(const g of p)this.store(g.key,g.value,g.scope,g.target,h)})}store(p,h,g,i,r=!1){if((0,D.$5f)(h)){this.remove(p,g,r);return}this.y(()=>{this.z(p,g,i),this.P(g)?.set(p,h,r)})}remove(p,h,g=!1){this.y(()=>{this.z(p,h,void 0),this.P(h)?.delete(p,g)})}y(p){this.b.pause(),this.c.pause();try{p()}finally{this.b.resume(),this.c.resume()}}keys(p,h){const g=[],i=this.J(p);for(const r of Object.keys(i))i[r]===h&&g.push(r);return g}z(p,h,g,i=!1){const r=this.J(h);typeof g=="number"?r[p]!==g&&(r[p]=g,this.P(h)?.set(e.$Lp,JSON.stringify(r),i)):typeof r[p]=="number"&&(delete r[p],this.P(h)?.set(e.$Lp,JSON.stringify(r),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(p){switch(p){case-1:return this.I;case 0:return this.G;default:return this.D}}L(p){const h=this.P(p);return h?$(h):Object.create(null)}isNew(p){return this.getBoolean(e.$Kp,p)===!0}async flush(p=w.NONE){this.f.fire({reason:p});const h=this.P(-1),g=this.P(0),i=this.P(1);switch(p){case w.NONE:await j.Promises.settled([h?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case w.SHUTDOWN:await j.Promises.settled([h?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const p=this.P(-1)?.items??new Map,h=this.P(0)?.items??new Map,g=this.P(1)?.items??new Map;return c(p,h,g,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(p){return await this.flush(),this.P(p)?.optimize()}async switch(p,h){return this.w(w.NONE),(0,a.$nl)(p)?this.R(p,h):this.S(p,h)}M(p,h){return!(p.id===h.id||O(h)&&O(p))}N(p,h,g){this.y(()=>{const i=new Set;for(const[r,t]of p)i.add(r),h.get(r)!==t&&this.u(g,{key:r,external:!0});for(const[r]of h.items)i.has(r)||this.u(g,{key:r,external:!0})})}}e.$Op=b;function O(y){return y.isDefault||!!y.useDefaultFlags?.globalState}class m extends b{constructor(){super(),this.U=this.B(new E.$Ip(new E.$Jp,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new E.$Ip(new E.$Jp,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new E.$Ip(new E.$Jp,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(p=>this.u(1,p))),this.B(this.W.onDidChangeStorage(p=>this.u(0,p))),this.B(this.U.onDidChangeStorage(p=>this.u(-1,p)))}P(p){switch(p){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(p){switch(p){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(p){return!1}}e.$Qp=m;async function c(y,p,h,g,i,r){const t=U=>{try{return JSON.parse(U)}catch{return U}},n=new Map,s=new Map;y.forEach((U,V)=>{n.set(V,U),s.set(V,t(U))});const o=new Map,l=new Map;p.forEach((U,V)=>{o.set(V,U),l.set(V,t(U))});const P=new Map,I=new Map;h.forEach((U,V)=>{P.set(V,U),I.set(V,t(U))}),console.group(g!==i?`Storage: Application (path: ${g})`:`Storage: Application & Profile (path: ${g}, default profile)`);const L=[];if(n.forEach((U,V)=>{L.push({key:V,value:U})}),console.table(L),console.groupEnd(),console.log(s),g!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const U=[];o.forEach((V,X)=>{U.push({key:X,value:V})}),console.table(U),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${r})`);const z=[];P.forEach((U,V)=>{z.push({key:V,value:U})}),console.table(z),console.groupEnd(),console.log(I)}}),define(ne[166],re([0,1,19,20,8,12,35,3,11,29,18,21,26,50,13,6,32,45,149,165,25,178]),function(J,e,j,R,k,A,D,E,u,a,w,v,d,$,b,O,m,c,y,p,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=void 0,e.$Up=Q;const i=A.$o?"web":(0,v.$No)(A.$u,D.$fc),r="X-Market-Search-Activity-Id";var t;(function(S){S[S.None=0]="None",S[S.IncludeVersions=1]="IncludeVersions",S[S.IncludeFiles=2]="IncludeFiles",S[S.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",S[S.IncludeSharedAccounts=8]="IncludeSharedAccounts",S[S.IncludeVersionProperties=16]="IncludeVersionProperties",S[S.ExcludeNonValidated=32]="ExcludeNonValidated",S[S.IncludeInstallationTargets=64]="IncludeInstallationTargets",S[S.IncludeAssetUri=128]="IncludeAssetUri",S[S.IncludeStatistics=256]="IncludeStatistics",S[S.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",S[S.Unpublished=4096]="Unpublished",S[S.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function n(...S){return String(S.reduce((N,C)=>N|C,0))}var s;(function(S){S[S.Tag=1]="Tag",S[S.ExtensionId=4]="ExtensionId",S[S.Category=5]="Category",S[S.ExtensionName=7]="ExtensionName",S[S.Target=8]="Target",S[S.Featured=9]="Featured",S[S.SearchText=10]="SearchText",S[S.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},I={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class L{constructor(N=I){this.d=N}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(N,C=this.d.pageSize){return new L({...this.d,pageNumber:N,pageSize:C})}withFilter(N,...C){const x=[...this.d.criteria,...C.length?C.map(G=>({filterType:N,value:G})):[{filterType:N}]];return new L({...this.d,criteria:x})}withSortBy(N){return new L({...this.d,sortBy:N})}withSortOrder(N){return new L({...this.d,sortOrder:N})}withFlags(...N){return new L({...this.d,flags:N.reduce((C,x)=>C|x,0)})}withAssetTypes(...N){return new L({...this.d,assetTypes:N})}withSource(N){return new L({...this.d,source:N})}get raw(){const{criteria:N,pageNumber:C,pageSize:x,sortBy:G,sortOrder:te,flags:ae,assetTypes:le}=this.d;return{filters:[{criteria:N,pageNumber:C,pageSize:x,sortBy:G,sortOrder:te}],assetTypes:le,flags:ae}}get searchText(){const N=this.d.criteria.filter(C=>C.filterType===s.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(N=>String(N.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function z(S,N){const C=(S||[]).filter(x=>x.statisticName===N)[0];return C?C.value:0}function U(S){const N="Microsoft.VisualStudio.Code.Translation.";return S.files.filter(x=>x.assetType.indexOf(N)===0).reduce((x,G)=>{const te=se(S,G.assetType);return te&&x.push([G.assetType.substring(N.length),te]),x},[])}function V(S){if(S.properties){const N=S.properties.filter(G=>G.key===o.Repository),C=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),x=N.filter(G=>C.test(G.value))[0];return x?{uri:x.value,fallbackUri:x.value}:null}return se(S,o.Repository)}function X(S){return{uri:`${S.fallbackAssetUri}/${o.VSIX}?redirect=true${S.targetPlatform?`&targetPlatform=${S.targetPlatform}`:""}`,fallbackUri:`${S.fallbackAssetUri}/${o.VSIX}${S.targetPlatform?`?targetPlatform=${S.targetPlatform}`:""}`}}function se(S,N){return S.files.filter(x=>x.assetType===N)[0]?{uri:`${S.assetUri}/${N}${S.targetPlatform?`?targetPlatform=${S.targetPlatform}`:""}`,fallbackUri:`${S.fallbackAssetUri}/${N}${S.targetPlatform?`?targetPlatform=${S.targetPlatform}`:""}`}:null}function ie(S,N){const C=S.properties?S.properties.filter(G=>G.key===N):[],x=C.length>0&&C[0].value;return x?x.split(",").map(G=>(0,d.$kp)(G)):[]}function ue(S){const N=S.properties?S.properties.filter(C=>C.key===l.Engine):[];return N.length>0&&N[0].value||""}function he(S){const N=S.properties?S.properties.filter(C=>C.key===l.PreRelease):[];return N.length>0&&N[0].value==="true"}function ce(S){const N=S.properties?S.properties.filter(x=>x.key===l.LocalizedLanguages):[],C=N.length>0&&N[0].value||"";return C?C.split(","):[]}function B(S){return S.properties?.find(N=>N.key===l.SponsorLink)?.value}function Z(S){return S.properties?.find(N=>N.key===l.SupportLink)?.value}function q(S){return S.indexOf("preview")!==-1}function T(S){return S.targetPlatform?(0,v.$Mo)(S.targetPlatform):"undefined"}function W(S){const N=(0,j.$Mb)(S.versions.map(T)),C=!!S.tags?.includes(v.$Ho),x=N.indexOf("web");return C?x===-1&&N.push("web"):x!==-1&&N.splice(x,1),N}function Q(S,N){for(let C=0;C<S.length;C++){const x=S[C];if(x.version===S[C-1]?.version){let G=C;if(T(x)===N)for(;G>0&&S[G-1].version===x.version;)G--;G!==C&&(S.splice(C,1),S.splice(G,0,x))}}return S}function Y(S,N,C){S.telemetryData={index:N,querySource:C,queryActivityId:S.queryContext?.[r]}}function _(S,N,C,x){const G=S.versions[0],te={manifest:se(N,o.Manifest),readme:se(N,o.Details),changelog:se(N,o.Changelog),license:se(N,o.License),repository:V(N),download:X(N),icon:se(N,o.Icon),signature:se(N,o.Signature),coreTranslations:U(N)};return{identifier:{id:(0,d.$lp)(S.publisher.publisherName,S.extensionName),uuid:S.extensionId},name:S.extensionName,version:N.version,displayName:S.displayName,publisherId:S.publisher.publisherId,publisher:S.publisher.publisherName,publisherDisplayName:S.publisher.displayName,publisherDomain:S.publisher.domain?{link:S.publisher.domain,verified:!!S.publisher.isDomainVerified}:void 0,publisherSponsorLink:B(G),description:S.shortDescription??"",installCount:z(S.statistics,"install"),rating:z(S.statistics,"averagerating"),ratingCount:z(S.statistics,"ratingcount"),categories:S.categories||[],tags:S.tags||[],releaseDate:Date.parse(S.releaseDate),lastUpdated:Date.parse(S.lastUpdated),allTargetPlatforms:C,assets:te,properties:{dependencies:ie(N,l.Dependency),extensionPack:ie(N,l.ExtensionPack),engine:ue(N),localizedLanguages:ce(N),targetPlatform:T(N),isPreReleaseVersion:he(N)},hasPreReleaseVersion:he(G),hasReleaseVersion:!0,preview:q(S.flags),isSigned:!!te.signature,queryContext:x,supportLink:Z(G)}}let M=class{constructor(N,C,x,G,te,ae,le,pe){this.k=C,this.l=x,this.n=G,this.o=te,this.q=ae,this.u=le,this.w=pe;const ye=le.extensionsGallery,fe=ye?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.d=fe?ye.servicePPEUrl:ye?.serviceUrl,this.g=fe?void 0:ye?.searchUrl,this.h=ye?.controlUrl,this.j=(0,y.$Tp)(le.version,le,this.n,this.w,this.q,N,this.o)}x(N=""){return`${this.d}${N}`}isEnabled(){return!!this.d}async getExtensions(N,C,x){const G=R.CancellationToken.isCancellationToken(C)?{}:C,te=R.CancellationToken.isCancellationToken(C)?C:x,ae=[],le=[],pe=[],ye=[];let fe=!0;for(const we of N){we.uuid?le.push(we.uuid):ae.push(we.id);const Ee=!!(we.version||we.preRelease);pe.push({id:we.id,uuid:we.uuid,includePreRelease:Ee}),we.version&&ye.push({id:we.id,uuid:we.uuid,version:we.version}),fe=fe&&!!we.hasPreRelease&&!Ee}if(!le.length&&!ae.length)return[];let me=new L().withPage(1,N.length);le.length&&(me=me.withFilter(s.ExtensionId,...le)),ae.length&&(me=me.withFilter(s.ExtensionName,...ae)),(G.queryAllVersions||fe)&&(me=me.withFlags(me.flags,t.IncludeVersions)),G.source&&(me=me.withSource(G.source));const{extensions:de}=await this.z(me,{targetPlatform:G.targetPlatform??i,includePreRelease:pe,versions:ye,compatible:!!G.compatible,productVersion:G.productVersion??{version:this.u.version,date:this.u.date}},te);return G.source&&de.forEach((we,Ee)=>Y(we,Ee,G.source)),de}async getCompatibleExtension(N,C,x,G={version:this.u.version,date:this.u.date}){if((0,v.$Oo)(N.allTargetPlatforms,x))return null;if(await this.isExtensionCompatible(N,C,x))return N;const te=new L().withFlags(t.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,N.identifier.uuid),{extensions:ae}=await this.z(te,{targetPlatform:x,compatible:!0,includePreRelease:C,productVersion:G},R.CancellationToken.None);return ae[0]||null}async isExtensionCompatible(N,C,x,G={version:this.u.version,date:this.u.date}){if(!(0,v.$Po)(N.properties.targetPlatform,N.allTargetPlatforms,x)||!C&&N.properties.isPreReleaseVersion)return!1;let te=N.properties.engine;if(!te){const ae=await this.getManifest(N,R.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");te=ae.engines.vscode}return(0,$.$yp)(te,G.version,G.date)}async y(N,C,x,G,te,ae,le={version:this.u.version,date:this.u.date}){if(!(0,v.$Po)(T(C),te,ae)||x!=="any"&&he(C)!==(x==="prerelease"))return!1;if(G)try{const pe=await this.E(N,C);if(!(0,$.$yp)(pe,le.version,le.date))return!1}catch(pe){return this.l.error(`Error while getting the engine for the version ${C.version}.`,(0,k.$0)(pe)),!1}return!0}async query(N,C){let x=N.text||"";const G=N.pageSize??50;let te=new L().withPage(1,G);x?(x=x.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,de)=>(te=te.withFilter(s.Category,de||me),"")),x=x.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,de)=>(te=te.withFilter(s.Tag,de||me),"")),x=x.replace(/\bfeatured(\s+|\b|$)/g,()=>(te=te.withFilter(s.Featured),"")),x=x.trim(),x&&(x=x.length<200?x:x.substring(0,200),te=te.withFilter(s.SearchText,x)),te=te.withSortBy(0)):N.ids?te=te.withFilter(s.ExtensionId,...N.ids):N.names?te=te.withFilter(s.ExtensionName,...N.names):te=te.withSortBy(4),typeof N.sortBy=="number"&&(te=te.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(te=te.withSortOrder(N.sortOrder)),N.source&&(te=te.withSource(N.source));const ae=async(fe,me)=>{const{extensions:de,total:we}=await this.z(fe,{targetPlatform:i,compatible:!1,includePreRelease:!!N.includePreRelease,productVersion:N.productVersion??{version:this.u.version,date:this.u.date}},me);return de.forEach((Ee,ke)=>Y(Ee,(fe.pageNumber-1)*fe.pageSize+ke,N.source)),{extensions:de,total:we}},{extensions:le,total:pe}=await ae(te,C),ye=async(fe,me)=>{if(me.isCancellationRequested)throw new k.$5;const{extensions:de}=await ae(te.withPage(fe+1),me);return de};return{firstPage:le,total:pe,pageSize:te.pageSize,getPage:ye}}async z(N,C,x){const G=N.flags;N.flags&t.IncludeLatestVersionOnly&&N.flags&t.IncludeVersions&&(N=N.withFlags(N.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(N.flags&t.IncludeLatestVersionOnly)&&!(N.flags&t.IncludeVersions)&&(N=N.withFlags(N.flags,t.IncludeLatestVersionOnly)),C.versions?.length&&(N=N.withFlags(N.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),N=N.withFlags(N.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:te,total:ae,context:le}=await this.B(N,x);if(!(N.flags&t.IncludeLatestVersionOnly)){const me=[];for(const de of te){const we=await this.A(de,C,le);we&&me.push(we)}return{extensions:me,total:ae}}const ye=[],fe=new Map;for(let me=0;me<te.length;me++){const de=te[me],we={id:(0,d.$lp)(de.publisher.publisherName,de.extensionName),uuid:de.extensionId},Ee=(0,E.$2f)(C.includePreRelease)?C.includePreRelease:!!C.includePreRelease.find(H=>(0,d.$gp)(H,we))?.includePreRelease;if(C.compatible&&(0,v.$Oo)(W(de),C.targetPlatform))continue;const ke=await this.A(de,C,le);!ke||ke.properties.isPreReleaseVersion&&(!Ee||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==C.targetPlatform&&ke.hasPreReleaseVersion?fe.set(de.extensionId,me):ye.push([me,ke])}if(fe.size){const me=new g.$3d,de=new L().withFlags(G&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,fe.size).withFilter(s.ExtensionId,...fe.keys()),{extensions:we}=await this.z(de,C,x);this.o.publicLog2("galleryService:additionalQuery",{duration:me.elapsed(),count:fe.size});for(const Ee of we){const ke=fe.get(Ee.identifier.uuid);ye.push([ke,Ee])}}return{extensions:ye.sort((me,de)=>me[0]-de[0]).map(([,me])=>me),total:ae}}async A(N,C,x){const G={id:(0,d.$lp)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},te=C.versions?.find(ye=>(0,d.$gp)(ye,G))?.version,ae=(0,E.$2f)(C.includePreRelease)?C.includePreRelease:!!C.includePreRelease.find(ye=>(0,d.$gp)(ye,G))?.includePreRelease,le=W(N),pe=Q(N.versions,C.targetPlatform);if(C.compatible&&(0,v.$Oo)(le,C.targetPlatform))return null;for(let ye=0;ye<pe.length;ye++){const fe=pe[ye];if(!(te&&fe.version!==te)){if(await this.y((0,d.$lp)(N.publisher.publisherName,N.extensionName),fe,ae?"any":"release",C.compatible,le,C.targetPlatform,C.productVersion))return _(N,fe,le,x);if(te&&fe.version===te)return null}}return te||C.compatible?null:_(N,N.versions[0],le)}async B(N,C){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,t.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,n(t.Unpublished));const x=await this.j,G=JSON.stringify(N.raw),te={...x,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(G.length)},ae=new g.$3d;let le,pe,ye=0;try{if(le=await this.k.request({type:"POST",url:this.g&&N.criteria.some(me=>me.filterType===s.SearchText)?this.g:this.x("/extensionquery"),data:G,headers:te},C),le.res.statusCode&&le.res.statusCode>=400&&le.res.statusCode<500)return{galleryExtensions:[],total:ye};const fe=await(0,c.$Fp)(le);if(fe){const me=fe.results[0],de=me.extensions,we=me.resultMetadata&&me.resultMetadata.filter(Ee=>Ee.metadataType==="ResultCount")[0];return ye=we&&we.metadataItems.filter(Ee=>Ee.name==="TotalCount")[0].count||0,{galleryExtensions:de,total:ye,context:{[r]:le.res.headers.activityid}}}return{galleryExtensions:[],total:ye}}catch(fe){const me=(0,k.$4)(fe)?v.ExtensionGalleryErrorCode.Cancelled:(0,k.$0)(fe).startsWith("XHR timeout")?v.ExtensionGalleryErrorCode.Timeout:v.ExtensionGalleryErrorCode.Failed;throw pe=new v.$To((0,k.$0)(fe),me),pe}finally{this.o.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(G.length),duration:ae.elapsed(),success:!!le&&(0,c.$Bp)(le),responseBodySize:le?.res.headers["Content-Length"],statusCode:le?String(le.res.statusCode):void 0,errorCode:pe?.code,count:String(ye)})}}async reportStatistic(N,C,x,G){if(!this.isEnabled())return;const te=A.$o?this.x(`/itemName/${N}.${C}/version/${x}/statType/${G==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${N}/extensions/${C}/${x}/stats?statType=${G}`),ae=A.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.j,Accept:ae};try{await this.k.request({type:"POST",url:te,headers:pe},R.CancellationToken.None)}catch{}}async download(N,C,x){this.l.trace("ExtensionGalleryService#download",N.identifier.id);const G=(0,d.$op)(N),te=new Date().getTime(),ae=me=>this.o.publicLog("galleryService:downloadVSIX",{...G,duration:me}),le=x===2?"install":x===3?"update":"",pe=le?{uri:`${N.assets.download.uri}${u.URI.parse(N.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${N.assets.download.fallbackUri}${u.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:N.assets.download,ye=N.queryContext?.[r]?{[r]:N.queryContext[r]}:void 0,fe=await this.D(N.identifier.id,pe,o.VSIX,ye?{headers:ye}:void 0);await this.q.writeFile(C,fe.stream),ae(new Date().getTime()-te)}async downloadSignatureArchive(N,C){if(!N.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",N.identifier.id);const x=await this.D(N.identifier.id,N.assets.signature,o.Signature);await this.q.writeFile(C,x.stream)}async getReadme(N,C){if(N.assets.readme){const x=await this.D(N.identifier.id,N.assets.readme,o.Details,{},C);return await(0,c.$Ep)(x)||""}return""}async getManifest(N,C){if(N.assets.manifest){const x=await this.D(N.identifier.id,N.assets.manifest,o.Manifest,{},C),G=await(0,c.$Ep)(x);return G?JSON.parse(G):null}return null}async C(N,C,x){const G=se(C,o.Manifest);if(!G)throw new Error("Manifest was not found");const te={"Accept-Encoding":"gzip"},ae=await this.D(N,G,o.Manifest,{headers:te});return await(0,c.$Fp)(ae)}async getCoreTranslation(N,C){const x=N.assets.coreTranslations.filter(G=>G[0]===C.toUpperCase())[0];if(x){const G=await this.D(N.identifier.id,x[1],x[0]),te=await(0,c.$Ep)(G);return te?JSON.parse(te):null}return null}async getChangelog(N,C){if(N.assets.changelog){const x=await this.D(N.identifier.id,N.assets.changelog,o.Changelog,{},C);return await(0,c.$Ep)(x)||""}return""}async getAllCompatibleVersions(N,C,x){let G=new L().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);N.identifier.uuid?G=G.withFilter(s.ExtensionId,N.identifier.uuid):G=G.withFilter(s.ExtensionName,N.identifier.id);const{galleryExtensions:te}=await this.B(G,R.CancellationToken.None);if(!te.length)return[];const ae=W(te[0]);if((0,v.$Oo)(ae,x))return[];const le=[];await Promise.all(te[0].versions.map(async fe=>{try{await this.y(N.identifier.id,fe,C?"any":"release",!0,ae,x)&&le.push(fe)}catch{}}));const pe=[],ye=new Set;for(const fe of Q(le,x))ye.has(fe.version)||(ye.add(fe.version),pe.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:he(fe)}));return pe}async D(N,C,x,G={},te=R.CancellationToken.None){const ae=await this.j,le={type:"GET"},pe={...ae,...G.headers||{}};G={...G,...le,headers:pe};const ye=C.uri,fe=C.fallbackUri,me={...G,url:ye};try{const de=await this.k.request(me,te);if(de.res.statusCode===200)return de;const we=await(0,c.$Ep)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${we}`)}catch(de){if((0,k.$4)(de))throw de;const we=(0,k.$0)(de);this.o.publicLog2("galleryService:cdnFallback",{extension:N,assetType:x,message:we});const Ee={...G,url:fe};return this.k.request(Ee,te)}}async E(N,C){let x=ue(C);if(!x){this.o.publicLog2("galleryService:engineFallback",{extension:N,version:C.version});const G=await this.C(N,C,R.CancellationToken.None);if(!G)throw new Error("Manifest was not found");x=G.engines.vscode}return x}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const N=await this.k.request({type:"GET",url:this.h},R.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const C=await(0,c.$Fp)(N),x=[],G={},te=[];if(C){for(const ae of C.malicious)x.push({id:ae});if(C.migrateToPreRelease)for(const[ae,le]of Object.entries(C.migrateToPreRelease))(!le.engine||(0,$.$yp)(le.engine,this.u.version,this.u.date))&&(G[ae.toLowerCase()]={disallowInstall:!0,extension:{id:le.id,displayName:le.displayName,autoMigrate:{storage:!!le.migrateStorage},preRelease:!0}});if(C.deprecated)for(const[ae,le]of Object.entries(C.deprecated))le&&(G[ae.toLowerCase()]=(0,E.$2f)(le)?{}:le);if(C.search)for(const ae of C.search)te.push(ae)}return{malicious:x,deprecated:G,search:te}}};M=$e([oe(1,c.$zp),oe(2,O.$Oj),oe(3,w.$pi),oe(4,h.$Nl),oe(5,b.$Ok),oe(6,m.$8j),oe(7,a.$Oi)],M);let F=class extends M{constructor(N,C,x,G,te,ae,le,pe){super(N,C,x,G,te,ae,le,pe)}};e.$Vp=F,e.$Vp=F=$e([oe(0,p.$Mp),oe(1,c.$zp),oe(2,O.$Oj),oe(3,w.$pi),oe(4,h.$Nl),oe(5,b.$Ok),oe(6,m.$8j),oe(7,a.$Oi)],F);let f=class extends M{constructor(N,C,x,G,te,ae,le){super(void 0,N,C,x,G,te,ae,le)}};e.$Wp=f,e.$Wp=f=$e([oe(0,c.$zp),oe(1,O.$Oj),oe(2,w.$pi),oe(3,h.$Nl),oe(4,b.$Ok),oe(5,m.$8j),oe(6,a.$Oi)],f)}),define(ne[167],re([0,1,11,18,13,6,145,22,23,3,69]),function(J,e,j,R,k,A,D,E,u,a,w){"use strict";var v,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$2P=e.$1P=e.$ZP=void 0;let $=class extends u.$rl{static{v=this}static{this.a="profileAssociationsMigration"}constructor(c,y,p,h,g){super(p,h,y,g),this.U=c,this.W=p}O(){return this.U.getItem(v.b,[]).map(y=>({...y,location:(0,a.$Vf)(y.location)?this.w.extUri.joinPath(this.profilesHome,y.location):j.URI.revive(y.location)}))}Q(){const c=this.U.getItem(v.c,{});return this.U.getItem(v.a,!1)?c:this.N(c)}S(){return this.w.extUri.joinPath(j.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$ZP=$,e.$ZP=$=v=$e([oe(0,D.$UP),oe(1,E.$ml),oe(2,R.$qi),oe(3,k.$Ok),oe(4,A.$Oj)],$);let b=d=class extends ${constructor(c,y,p,h,g){super(c,y,p,h,g),this.$=c}P(c){c.length?this.$.setItem(d.b,c.map(y=>({...y,location:this.w.extUri.basename(y.location)}))):this.$.removeItem(d.b)}O(){const c=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(c),this.$.setItem("userDataProfilesMigration",!0)),c}R(c){c.emptyWindows||c.workspaces?this.$.setItem(d.c,c):this.$.removeItem(d.c)}Q(){const c="workspaceAndProfileInfo",y=this.$.getItem(c,void 0);if(y){this.$.removeItem(c);const h=y.reduce((g,{workspace:i,profile:r})=>(g[j.URI.revive(i).toString()]=j.URI.revive(r).toString(),g),{});this.$.setItem(d.c,{workspaces:h})}const p=super.Q();return this.$.getItem(d.a,!1)||(this.R(p),this.$.setItem(d.a,!0)),p}};e.$1P=b,e.$1P=b=d=$e([oe(0,D.$VP),oe(1,E.$ml),oe(2,R.$qi),oe(3,k.$Ok),oe(4,A.$Oj)],b);let O=class extends b{constructor(c,y,p,h){super(new w.$YP(0,y,h,p),c,y,p,h)}async init(){return await this.$.init(),super.init()}};e.$2P=O,e.$2P=O=$e([oe(0,E.$ml),oe(1,R.$qi),oe(2,k.$Ok),oe(3,A.$Oj)],O)}),define(ne[168],re([0,1,143,9,14,8,3,29,18,144,6,45,142,179]),function(J,e,j,R,k,A,D,E,u,a,w,v,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=void 0,e.$Ir=m;let b=class extends v.$Ap{constructor(y,p,h,g){super(g),this.m=y,this.n=p,this.r=h,this.s(),this.B(y.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.s()}))}s(){const y=this.m.getValue("http");this.f=y?.proxy,this.g=!!y?.proxyStrictSSL,this.h=y?.proxyAuthorization}async request(y,p){const{f:h,g}=this;let i;try{i=await(0,a.$sm)(this.m,this.r,this.n.args,process.env)}catch(n){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,A.$0)(n)))}const r={...process.env,...i},t=y.agent?y.agent:await(0,d.$Gr)(y.url||"",r,{proxyUrl:h,strictSSL:g});return y.agent=t,y.strictSSL=g,this.h&&(y.headers={...y.headers||{},"Proxy-Authorization":this.h}),this.c(y.isChromiumNetwork?"electron":"node",y,()=>m(y,p))}async resolveProxy(y){}async loadCertificates(){return(await new Promise((p,h)=>{J(["@vscode/proxy-agent"],p,h)})).loadSystemCertificates({log:this.r})}};e.$Hr=b,e.$Hr=b=$e([oe(0,E.$Oi),oe(1,u.$qi),oe(2,w.$Oj),oe(3,w.$Pj)],b);async function O(c){return((0,j.parse)(c.url).protocol==="https:"?await new Promise((h,g)=>{J(["https"],h,g)}):await new Promise((h,g)=>{J(["http"],h,g)})).request}async function m(c,y){return R.Promises.withAsyncBody(async(p,h)=>{const g=(0,j.parse)(c.url),i=c.getRawRequest?c.getRawRequest(c):await O(c),r={hostname:g.hostname,port:g.port?parseInt(g.port):g.protocol==="https:"?443:80,protocol:g.protocol,path:g.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,D.$2f)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(r.auth=c.user+":"+c.password);const t=i(r,n=>{const s=(0,D.$Zf)(c.followRedirects)?c.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&s>0&&n.headers.location)m({...c,url:n.headers.location,followRedirects:s-1},y).then(p,h);else{let o=n;!c.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(o=n.pipe((0,$.createGunzip)())),p({res:n,stream:(0,k.$Je)(o)})}});t.on("error",h),c.timeout&&t.setTimeout(c.timeout),c.isChromiumNetwork&&t.removeHeader("Content-Length"),c.data&&typeof c.data=="string"&&t.write(c.data),t.end(),y.onCancellationRequested(()=>{t.abort(),h(new A.$5)})})}}),define(ne[180],re([0,1,33,9,34,8,2,15,16,12,35,11,24,29,139,61,141,18,115,166,21,65,146,42,53,162,164,13,129,131,51,127,63,64,150,6,135,39,136,153,32,45,168,69,70,25,152,41,154,155,22,157,23,167,156,163,132,134,4,158,181]),function(J,e,j,R,k,A,D,E,u,a,w,v,d,$,b,O,m,c,y,p,h,g,i,r,t,n,s,o,l,P,I,L,z,U,V,X,se,ie,ue,he,ce,B,Z,q,T,W,Q,Y,_,M,F,f,S,N,C,x,G,te,ae,le,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=fe;class ye extends D.$Uc{constructor(de){super(),this.b=de,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[de,we]=await this.f();return de.invokeFunction(async Ee=>{const ke=Ee.get(X.$Oj),H=Ee.get(o.$Ok),K=Ee.get(c.$qi),ee=Ee.get(S.$ol);ke.info("CLI main",this.b),this.h(ke),await this.j(K,H,ee,de),await Promise.all(we.map(ge=>{(0,R.$_g)(ge.flush(),1e3)}))})}async f(){const de=new z.$gi,we={_serviceBrand:void 0,...he.default};de.set(ce.$8j,we);const Ee=new y.$Um(this.b,we);de.set(c.$qi,Ee),await Promise.all([this.g(Ee.appSettingsHome.with({scheme:E.Schemas.file}).fsPath),this.g(Ee.extensionsPath)].map(be=>be?d.Promises.mkdir(be,{recursive:!0}):void 0));const ke=new te.$TP((0,X.$3j)(Ee),Ee.logsHome);de.set(X.$Pj,ke);const H=this.B(ke.createLogger("cli",{name:(0,ae.localize)(0,null)})),K=[];ke.getLogLevel()===X.LogLevel.Trace&&K.push(new X.$Wj(ke.getLogLevel()));const ee=this.B(new G.$4P(H,K));de.set(X.$Oj,ee);const ge=this.B(new l.$uq(ee));de.set(o.$Ok,ge);const ve=this.B(new P.$Vq(ee));ge.registerProvider(E.Schemas.file,ve);const De=new f.$js(ge);de.set(F.$ml,De);const Pe=new q.$XP(1,Ee,ee,ge),Le=new N.$ZP(Pe,De,Ee,ge,ee);de.set(S.$ol,Le),ge.registerProvider(E.Schemas.vscodeUserData,new le.$Sbc(E.Schemas.file,ve,E.Schemas.vscodeUserData,Le,De,ee));const Oe=a.$i&&we.win32RegValueName?this.B(new ue.$Qbc(ee,we.win32RegValueName)):Ee.policyFile?this.B(new se.$Rbc(Ee.policyFile,ge,ee)):new ie.$5n;de.set(ie.$3n,Oe);const Ae=this.B(new b.$so(Le.defaultProfile.settingsResource,ge,Oe,ee));de.set($.$Oi,Ae),await Promise.all([Pe.init(),Ae.initialize()]);let Me;try{Me=await(0,C.$ubc)(Pe,ee)}catch(be){be.code!=="ENOENT"&&ee.error(be)}const je=await(0,C.$vbc)(Pe,ee);Le.init(),de.set(F.$ml,new f.$js(ge));const Ne=new Z.$Hr(Ae,Ee,ee,ke);de.set(B.$zp,Ne),de.set(O.$wo,new I.$fi(m.$gQ,void 0,!0)),de.set(r.$bq,new I.$fi(x.$3P,void 0,!0)),de.set(t.$fq,new I.$fi(s.$rbc,void 0,!0)),de.set(g.$Xp,new I.$fi(g.$Yp,void 0,!0)),de.set(n.$pq,new I.$fi(n.$qq,void 0,!0)),de.set(h.$Ro,new I.$fi(p.$Wp,void 0,!0)),de.set(U.$Br,new I.$fi(V.$Dr,void 0,!1));const ze=[],Fe=(0,Y.$dp)(we,Ae);if((0,Y.$$o)(we,Ee)){we.aiConfig&&we.aiConfig.ariaKey&&ze.push(new _.$RP(Ne,Fe,"monacoworkbench",null,we.aiConfig.ariaKey));const be={appenders:ze,sendErrorTelemetry:!1,commonProperties:(0,T.$2o)((0,j.release)(),(0,j.hostname)(),process.arch,we.commit,we.version,Me,je,Fe),piiPaths:(0,Y.$ep)(Ee)};de.set(W.$Nl,new I.$fi(Q.$Jr,[be],!1))}else de.set(W.$Nl,Y.$6o);return[new L.$Yq(de),ze]}g(de){if(a.$i){const we=(0,pe.getUNCHost)(de);we&&(0,pe.addUNCHostToAllowlist)(we)}return de}h(de){(0,A.setUnexpectedErrorHandler)(we=>{const Ee=(0,k.$6i)(we,!0);Ee&&de.error(`[uncaught exception in CLI]: ${Ee}`)}),process.on("uncaughtException",we=>{(0,A.$Z)(we)||(0,A.$1)(we)}),process.on("unhandledRejection",we=>(0,A.$1)(we))}async j(de,we,Ee,ke){let H;if(de.args.profile&&(H=Ee.profiles.find(ee=>ee.name===de.args.profile),!H))throw new Error(`Profile '${de.args.profile}' not found.`);const K=(H??Ee.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ke.createInstance(i.$Zp,new X.$Wj(X.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,K);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const ee={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:K};return ke.createInstance(i.$Zp,new X.$Wj(X.LogLevel.Info,!1)).installExtensions(this.m(this.b["install-extension"]||[]),this.m(this.b["install-builtin-extension"]||[]),ee,!!this.b.force)}else{if(this.b["uninstall-extension"])return ke.createInstance(i.$Zp,new X.$Wj(X.LogLevel.Info,!1)).uninstallExtensions(this.m(this.b["uninstall-extension"]),!!this.b.force,K);if(this.b["update-extensions"])return ke.createInstance(i.$Zp,new X.$Wj(X.LogLevel.Info,!1)).updateExtensions(K);if(this.b["locate-extension"])return ke.createInstance(i.$Zp,new X.$Wj(X.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,M.$ecc)(de.appRoot,de.extensionsPath))}}m(de){return de.map(we=>/\.vsix$/i.test(we)?v.URI.file((0,u.$jc)(we)?we:(0,u.$kc)((0,w.cwd)(),we)):we)}}async function fe(me){const de=new ye(me);try{await de.run()}finally{de.dispose()}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9ccb0fa738a2f7a1c5328800c9fe18f4dd5b4f8a/core/vs/code/node/cliProcessMain.js.map
