/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/platform/contextkey/common/contextkey","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/prefixTree","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContributionService","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Pe=function($e){for(var e=[],I=0,O=$e.length;I<O;I++)e[I]=Ce[$e[I]];return e};define(Ce[68],Pe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=O,e.$Nh=P,e.$Oh=N;function I(A){return(m,d,k)=>{let F=null,E=null;if(typeof k.value=="function"?(F="value",E=k.value):typeof k.get=="function"&&(F="get",E=k.get),!E)throw new Error("not supported");k[F]=A(E,d)}}function O(A,m,d){let k=null,F=null;if(typeof d.value=="function"?(k="value",F=d.value,F.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(k="get",F=d.get),!F)throw new Error("not supported");const E=`$memoize$${m}`;d[k]=function(...u){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:F.apply(this,u)}),this[E]}}function P(A,m,d){return I((k,F)=>{const E=`$debounce$${F}`,u=`$debounce$result$${F}`;return function(...b){this[u]||(this[u]=d?d():void 0),clearTimeout(this[E]),m&&(this[u]=m(this[u],...b),b=[this[u]]),this[E]=setTimeout(()=>{k.apply(this,b),this[u]=d?d():void 0},A)}})}function N(A,m,d){return I((k,F)=>{const E=`$throttle$timer$${F}`,u=`$throttle$result$${F}`,b=`$throttle$lastRun$${F}`,f=`$throttle$pending$${F}`;return function(...r){if(this[u]||(this[u]=d?d():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),m&&(this[u]=m(this[u],...r)),this[f])return;const o=this[b]+A;o<=Date.now()?(this[b]=Date.now(),k.apply(this,[this[u]]),this[u]=d?d():void 0):(this[f]=!0,this[E]=setTimeout(()=>{this[f]=!1,this[b]=Date.now(),k.apply(this,[this[u]]),this[u]=d?d():void 0},o-Date.now()))}})}}),define(Ce[90],Pe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LO=e.$KO=void 0;class I{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$KO=I,e.$LO=new I("id#")}),define(Ce[122],Pe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$tn=A,e.$un=E,e.$vn=u,e.$wn=b,e.$xn=f,e.$yn=r,e.$zn=o,e.$An=s,e.$Bn=n,e.$Cn=i,e.$Dn=a,e.$En=h;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var N;(function(t){t.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function A(t,v=!1){let c=0;const $=t.length;let w="",p=0,l=16,D=0;function g(q){let M=0,L=0;for(;M<q;){const G=t.charCodeAt(c);if(G>=48&&G<=57)L=L*16+G-48;else if(G>=65&&G<=70)L=L*16+G-65+10;else if(G>=97&&G<=102)L=L*16+G-97+10;else break;c++,M++}return M<q&&(L=-1),L}function S(q){c=q,w="",p=0,l=16,D=0}function y(){const q=c;if(t.charCodeAt(c)===48)c++;else for(c++;c<t.length&&k(t.charCodeAt(c));)c++;if(c<t.length&&t.charCodeAt(c)===46)if(c++,c<t.length&&k(t.charCodeAt(c)))for(c++;c<t.length&&k(t.charCodeAt(c));)c++;else return D=3,t.substring(q,c);let M=c;if(c<t.length&&(t.charCodeAt(c)===69||t.charCodeAt(c)===101))if(c++,(c<t.length&&t.charCodeAt(c)===43||t.charCodeAt(c)===45)&&c++,c<t.length&&k(t.charCodeAt(c))){for(c++;c<t.length&&k(t.charCodeAt(c));)c++;M=c}else D=3;return t.substring(q,M)}function C(){let q="",M=c;for(;;){if(c>=$){q+=t.substring(M,c),D=2;break}const L=t.charCodeAt(c);if(L===34){q+=t.substring(M,c),c++;break}if(L===92){if(q+=t.substring(M,c),c++,c>=$){D=2;break}switch(t.charCodeAt(c++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const ne=g(4);ne>=0?q+=String.fromCharCode(ne):D=4;break}default:D=5}M=c;continue}if(L>=0&&L<=31)if(d(L)){q+=t.substring(M,c),D=2;break}else D=6;c++}return q}function R(){if(w="",D=0,p=c,c>=$)return p=$,l=17;let q=t.charCodeAt(c);if(m(q)){do c++,w+=String.fromCharCode(q),q=t.charCodeAt(c);while(m(q));return l=15}if(d(q))return c++,w+=String.fromCharCode(q),q===13&&t.charCodeAt(c)===10&&(c++,w+=`
`),l=14;switch(q){case 123:return c++,l=1;case 125:return c++,l=2;case 91:return c++,l=3;case 93:return c++,l=4;case 58:return c++,l=6;case 44:return c++,l=5;case 34:return c++,w=C(),l=10;case 47:{const M=c-1;if(t.charCodeAt(c+1)===47){for(c+=2;c<$&&!d(t.charCodeAt(c));)c++;return w=t.substring(M,c),l=12}if(t.charCodeAt(c+1)===42){c+=2;const L=$-1;let G=!1;for(;c<L;){if(t.charCodeAt(c)===42&&t.charCodeAt(c+1)===47){c+=2,G=!0;break}c++}return G||(c++,D=1),w=t.substring(M,c),l=13}return w+=String.fromCharCode(q),c++,l=16}case 45:if(w+=String.fromCharCode(q),c++,c===$||!k(t.charCodeAt(c)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return w+=y(),l=11;default:for(;c<$&&V(q);)c++,q=t.charCodeAt(c);if(p!==c){switch(w=t.substring(p,c),w){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return w+=String.fromCharCode(q),c++,l=16}}function V(q){if(m(q)||d(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let q;do q=R();while(q>=12&&q<=15);return q}return{setPosition:S,getPosition:()=>c,scan:v?U:R,getToken:()=>l,getTokenValue:()=>w,getTokenOffset:()=>p,getTokenLength:()=>c-p,getTokenError:()=>D}}function m(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function d(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var F;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(F||(F={}));function E(t,v){const c=[],$=new Object;let w;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function D(g,S,y,C){p.value=g,p.offset=S,p.length=y,p.type=C,p.colonOffset=void 0,w=p}try{i(t,{onObjectBegin:(g,S)=>{if(v<=g)throw $;w=void 0,l=v>g,c.push("")},onObjectProperty:(g,S,y)=>{if(v<S||(D(g,S,y,"property"),c[c.length-1]=g,v<=S+y))throw $},onObjectEnd:(g,S)=>{if(v<=g)throw $;w=void 0,c.pop()},onArrayBegin:(g,S)=>{if(v<=g)throw $;w=void 0,c.push(0)},onArrayEnd:(g,S)=>{if(v<=g)throw $;w=void 0,c.pop()},onLiteralValue:(g,S,y)=>{if(v<S||(D(g,S,y,h(g)),v<=S+y))throw $},onSeparator:(g,S,y)=>{if(v<=S)throw $;if(g===":"&&w&&w.type==="property")w.colonOffset=S,l=!1,w=void 0;else if(g===","){const C=c[c.length-1];typeof C=="number"?c[c.length-1]=C+1:(l=!0,c[c.length-1]=""),w=void 0}}})}catch(g){if(g!==$)throw g}return{path:c,previousNode:w,isAtPropertyKey:l,matches:g=>{let S=0;for(let y=0;S<g.length&&y<c.length;y++)if(g[S]===c[y]||g[S]==="*")S++;else if(g[S]!=="**")return!1;return S===g.length}}}function u(t,v=[],c=N.DEFAULT){let $=null,w=[];const p=[];function l(g){Array.isArray(w)?w.push(g):$!==null&&(w[$]=g)}return i(t,{onObjectBegin:()=>{const g={};l(g),p.push(w),w=g,$=null},onObjectProperty:g=>{$=g},onObjectEnd:()=>{w=p.pop()},onArrayBegin:()=>{const g=[];l(g),p.push(w),w=g,$=null},onArrayEnd:()=>{w=p.pop()},onLiteralValue:l,onError:(g,S,y)=>{v.push({error:g,offset:S,length:y})}},c),w[0]}function b(t,v=[],c=N.DEFAULT){let $={type:"array",offset:-1,length:-1,children:[],parent:void 0};function w(g){$.type==="property"&&($.length=g-$.offset,$=$.parent)}function p(g){return $.children.push(g),g}i(t,{onObjectBegin:g=>{$=p({type:"object",offset:g,length:-1,parent:$,children:[]})},onObjectProperty:(g,S,y)=>{$=p({type:"property",offset:S,length:-1,parent:$,children:[]}),$.children.push({type:"string",value:g,offset:S,length:y,parent:$})},onObjectEnd:(g,S)=>{$.length=g+S-$.offset,$=$.parent,w(g+S)},onArrayBegin:(g,S)=>{$=p({type:"array",offset:g,length:-1,parent:$,children:[]})},onArrayEnd:(g,S)=>{$.length=g+S-$.offset,$=$.parent,w(g+S)},onLiteralValue:(g,S,y)=>{p({type:h(g),offset:S,length:y,parent:$,value:g}),w(S+y)},onSeparator:(g,S,y)=>{$.type==="property"&&(g===":"?$.colonOffset=S:g===","&&w(S))},onError:(g,S,y)=>{v.push({error:g,offset:S,length:y})}},c);const D=$.children[0];return D&&delete D.parent,D}function f(t,v){if(!t)return;let c=t;for(const $ of v)if(typeof $=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let w=!1;for(const p of c.children)if(Array.isArray(p.children)&&p.children[0].value===$){c=p.children[1],w=!0;break}if(!w)return}else{const w=$;if(c.type!=="array"||w<0||!Array.isArray(c.children)||w>=c.children.length)return;c=c.children[w]}return c}function r(t){if(!t.parent||!t.parent.children)return[];const v=r(t.parent);if(t.parent.type==="property"){const c=t.parent.children[0].value;v.push(c)}else if(t.parent.type==="array"){const c=t.parent.children.indexOf(t);c!==-1&&v.push(c)}return v}function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const v=Object.create(null);for(const c of t.children){const $=c.children[1];$&&(v[c.children[0].value]=o($))}return v}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function s(t,v,c=!1){return v>=t.offset&&v<t.offset+t.length||c&&v===t.offset+t.length}function n(t,v,c=!1){if(s(t,v,c)){const $=t.children;if(Array.isArray($))for(let w=0;w<$.length&&$[w].offset<=v;w++){const p=n($[w],v,c);if(p)return p}return t}}function i(t,v,c=N.DEFAULT){const $=A(t,!1);function w(te){return te?()=>te($.getTokenOffset(),$.getTokenLength()):()=>!0}function p(te){return te?be=>te(be,$.getTokenOffset(),$.getTokenLength()):()=>!0}const l=w(v.onObjectBegin),D=p(v.onObjectProperty),g=w(v.onObjectEnd),S=w(v.onArrayBegin),y=w(v.onArrayEnd),C=p(v.onLiteralValue),R=p(v.onSeparator),V=w(v.onComment),U=p(v.onError),q=c&&c.disallowComments,M=c&&c.allowTrailingComma;function L(){for(;;){const te=$.scan();switch($.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:q||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(te){case 12:case 13:q?G(10):V();break;case 16:G(1);break;case 15:case 14:break;default:return te}}}function G(te,be=[],oe=[]){if(U(te),be.length+oe.length>0){let de=$.getToken();for(;de!==17;){if(be.indexOf(de)!==-1){L();break}else if(oe.indexOf(de)!==-1)break;de=L()}}}function ne(te){const be=$.getTokenValue();return te?C(be):D(be),L(),!0}function he(){switch($.getToken()){case 11:{let te=0;try{te=JSON.parse($.getTokenValue()),typeof te!="number"&&(G(2),te=0)}catch{G(2)}C(te);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return L(),!0}function ye(){return $.getToken()!==10?(G(3,[],[2,5]),!1):(ne(!1),$.getToken()===6?(R(":"),L(),ue()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function Re(){l(),L();let te=!1;for(;$.getToken()!==2&&$.getToken()!==17;){if($.getToken()===5){if(te||G(4,[],[]),R(","),L(),$.getToken()===2&&M)break}else te&&G(6,[],[]);ye()||G(4,[],[2,5]),te=!0}return g(),$.getToken()!==2?G(7,[2],[]):L(),!0}function ge(){S(),L();let te=!1;for(;$.getToken()!==4&&$.getToken()!==17;){if($.getToken()===5){if(te||G(4,[],[]),R(","),L(),$.getToken()===4&&M)break}else te&&G(6,[],[]);ue()||G(4,[],[4,5]),te=!0}return y(),$.getToken()!==4?G(8,[4],[]):L(),!0}function ue(){switch($.getToken()){case 3:return ge();case 1:return Re();case 10:return ne(!0);default:return he()}}return L(),$.getToken()===17?c.allowEmptyContent?!0:(G(4,[],[]),!1):ue()?($.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}function a(t,v){const c=A(t),$=[];let w,p=0,l;do switch(l=c.getPosition(),w=c.scan(),w){case 12:case 13:case 17:p!==l&&$.push(t.substring(p,l)),v!==void 0&&$.push(c.getTokenValue().replace(/[^\r\n]/g,v)),p=c.getPosition();break}while(w!==17);return $.join("")}function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function($e,e){typeof define=="function"&&define.amd?define(Ce[123],Pe([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):($e=typeof globalThis<"u"?globalThis:$e||self,e($e.marked={}))}(this,function($e){"use strict";function e(Se,ve){for(var me=0;me<ve.length;me++){var J=ve[me];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(Se,J.key,J)}}function I(Se,ve,me){return ve&&e(Se.prototype,ve),me&&e(Se,me),Object.defineProperty(Se,"prototype",{writable:!1}),Se}function O(Se,ve){if(Se){if(typeof Se=="string")return P(Se,ve);var me=Object.prototype.toString.call(Se).slice(8,-1);if(me==="Object"&&Se.constructor&&(me=Se.constructor.name),me==="Map"||me==="Set")return Array.from(Se);if(me==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(me))return P(Se,ve)}}function P(Se,ve){(ve==null||ve>Se.length)&&(ve=Se.length);for(var me=0,J=new Array(ve);me<ve;me++)J[me]=Se[me];return J}function N(Se,ve){var me=typeof Symbol<"u"&&Se[Symbol.iterator]||Se["@@iterator"];if(me)return(me=me.call(Se)).next.bind(me);if(Array.isArray(Se)||(me=O(Se))||ve&&Se&&typeof Se.length=="number"){me&&(Se=me);var J=0;return function(){return J>=Se.length?{done:!0}:{done:!1,value:Se[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}$e.defaults=A();function m(Se){$e.defaults=Se}var d=/[&<>"']/,k=/[&<>"']/g,F=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(ve){return u[ve]};function f(Se,ve){if(ve){if(d.test(Se))return Se.replace(k,b)}else if(F.test(Se))return Se.replace(E,b);return Se}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Se){return Se.replace(r,function(ve,me){return me=me.toLowerCase(),me==="colon"?":":me.charAt(0)==="#"?me.charAt(1)==="x"?String.fromCharCode(parseInt(me.substring(2),16)):String.fromCharCode(+me.substring(1)):""})}var s=/(^|[^\[])\^/g;function n(Se,ve){Se=typeof Se=="string"?Se:Se.source,ve=ve||"";var me={replace:function(Y,ce){return ce=ce.source||ce,ce=ce.replace(s,"$1"),Se=Se.replace(Y,ce),me},getRegex:function(){return new RegExp(Se,ve)}};return me}var i=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Se,ve,me){if(Se){var J;try{J=decodeURIComponent(o(me)).replace(i,"").toLowerCase()}catch{return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}ve&&!a.test(me)&&(me=w(ve,me));try{me=encodeURI(me).replace(/%25/g,"%")}catch{return null}return me}var t={},v=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,$=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(Se,ve){t[" "+Se]||(v.test(Se)?t[" "+Se]=Se+"/":t[" "+Se]=g(Se,"/",!0)),Se=t[" "+Se];var me=Se.indexOf(":")===-1;return ve.substring(0,2)==="//"?me?ve:Se.replace(c,"$1")+ve:ve.charAt(0)==="/"?me?ve:Se.replace($,"$1")+ve:Se+ve}var p={exec:function(){}};function l(Se){for(var ve=1,me,J;ve<arguments.length;ve++){me=arguments[ve];for(J in me)Object.prototype.hasOwnProperty.call(me,J)&&(Se[J]=me[J])}return Se}function D(Se,ve){var me=Se.replace(/\|/g,function(ce,fe,Ne){for(var le=!1,Ie=fe;--Ie>=0&&Ne[Ie]==="\\";)le=!le;return le?"|":" |"}),J=me.split(/ \|/),Y=0;if(J[0].trim()||J.shift(),J.length>0&&!J[J.length-1].trim()&&J.pop(),J.length>ve)J.splice(ve);else for(;J.length<ve;)J.push("");for(;Y<J.length;Y++)J[Y]=J[Y].trim().replace(/\\\|/g,"|");return J}function g(Se,ve,me){var J=Se.length;if(J===0)return"";for(var Y=0;Y<J;){var ce=Se.charAt(J-Y-1);if(ce===ve&&!me)Y++;else if(ce!==ve&&me)Y++;else break}return Se.slice(0,J-Y)}function S(Se,ve){if(Se.indexOf(ve[1])===-1)return-1;for(var me=Se.length,J=0,Y=0;Y<me;Y++)if(Se[Y]==="\\")Y++;else if(Se[Y]===ve[0])J++;else if(Se[Y]===ve[1]&&(J--,J<0))return Y;return-1}function y(Se){Se&&Se.sanitize&&!Se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(Se,ve){if(ve<1)return"";for(var me="";ve>1;)ve&1&&(me+=Se),ve>>=1,Se+=Se;return me+Se}function R(Se,ve,me,J){var Y=ve.href,ce=ve.title?f(ve.title):null,fe=Se[1].replace(/\\([\[\]])/g,"$1");if(Se[0].charAt(0)!=="!"){J.state.inLink=!0;var Ne={type:"link",raw:me,href:Y,title:ce,text:fe,tokens:J.inlineTokens(fe)};return J.state.inLink=!1,Ne}return{type:"image",raw:me,href:Y,title:ce,text:f(fe)}}function V(Se,ve){var me=Se.match(/^(\s+)(?:```)/);if(me===null)return ve;var J=me[1];return ve.split(`
`).map(function(Y){var ce=Y.match(/^\s+/);if(ce===null)return Y;var fe=ce[0];return fe.length>=J.length?Y.slice(J.length):Y}).join(`
`)}var U=function(){function Se(me){this.options=me||$e.defaults}var ve=Se.prototype;return ve.space=function(J){var Y=this.rules.block.newline.exec(J);if(Y&&Y[0].length>0)return{type:"space",raw:Y[0]}},ve.code=function(J){var Y=this.rules.block.code.exec(J);if(Y){var ce=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?ce:g(ce,`
`)}}},ve.fences=function(J){var Y=this.rules.block.fences.exec(J);if(Y){var ce=Y[0],fe=V(ce,Y[3]||"");return{type:"code",raw:ce,lang:Y[2]?Y[2].trim():Y[2],text:fe}}},ve.heading=function(J){var Y=this.rules.block.heading.exec(J);if(Y){var ce=Y[2].trim();if(/#$/.test(ce)){var fe=g(ce,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(ce=fe.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:ce,tokens:this.lexer.inline(ce)}}},ve.hr=function(J){var Y=this.rules.block.hr.exec(J);if(Y)return{type:"hr",raw:Y[0]}},ve.blockquote=function(J){var Y=this.rules.block.blockquote.exec(J);if(Y){var ce=Y[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Y[0],tokens:this.lexer.blockTokens(ce,[]),text:ce}}},ve.list=function(J){var Y=this.rules.block.list.exec(J);if(Y){var ce,fe,Ne,le,Ie,Ae,je,z,j,K,H,_,re=Y[1].trim(),Fe=re.length>1,Ve={type:"list",raw:"",ordered:Fe,start:Fe?+re.slice(0,-1):"",loose:!1,items:[]};re=Fe?"\\d{1,9}\\"+re.slice(-1):"\\"+re,this.options.pedantic&&(re=Fe?re:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+re+")((?:[	 ][^\\n]*)?(?:\\n|$))");J&&(_=!1,!(!(Y=Qe.exec(J))||this.rules.block.hr.test(J)));){if(ce=Y[0],J=J.substring(ce.length),z=Y[2].split(`
`,1)[0],j=J.split(`
`,1)[0],this.options.pedantic?(le=2,H=z.trimLeft()):(le=Y[2].search(/[^ ]/),le=le>4?1:le,H=z.slice(le),le+=Y[1].length),Ae=!1,!z&&/^ *$/.test(j)&&(ce+=j+`
`,J=J.substring(j.length+1),_=!0),!_)for(var xe=new RegExp("^ {0,"+Math.min(3,le-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,le-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),at=new RegExp("^ {0,"+Math.min(3,le-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,le-1)+"}#");J&&(K=J.split(`
`,1)[0],z=K,this.options.pedantic&&(z=z.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(at.test(z)||it.test(z)||xe.test(z)||tt.test(J)));){if(z.search(/[^ ]/)>=le||!z.trim())H+=`
`+z.slice(le);else if(!Ae)H+=`
`+z;else break;!Ae&&!z.trim()&&(Ae=!0),ce+=K+`
`,J=J.substring(K.length+1)}Ve.loose||(je?Ve.loose=!0:/\n *\n *$/.test(ce)&&(je=!0)),this.options.gfm&&(fe=/^\[[ xX]\] /.exec(H),fe&&(Ne=fe[0]!=="[ ] ",H=H.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:ce,task:!!fe,checked:Ne,loose:!1,text:H}),Ve.raw+=ce}Ve.items[Ve.items.length-1].raw=ce.trimRight(),Ve.items[Ve.items.length-1].text=H.trimRight(),Ve.raw=Ve.raw.trimRight();var nt=Ve.items.length;for(Ie=0;Ie<nt;Ie++){this.lexer.state.top=!1,Ve.items[Ie].tokens=this.lexer.blockTokens(Ve.items[Ie].text,[]);var ct=Ve.items[Ie].tokens.filter(function(Ue){return Ue.type==="space"}),ft=ct.every(function(Ue){for(var ot=Ue.raw.split(""),X=0,Z=N(ot),pe;!(pe=Z()).done;){var qe=pe.value;if(qe===`
`&&(X+=1),X>1)return!0}return!1});!Ve.loose&&ct.length&&ft&&(Ve.loose=!0,Ve.items[Ie].loose=!0)}return Ve}},ve.html=function(J){var Y=this.rules.block.html.exec(J);if(Y){var ce={type:"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:Y[0]};if(this.options.sanitize){var fe=this.options.sanitizer?this.options.sanitizer(Y[0]):f(Y[0]);ce.type="paragraph",ce.text=fe,ce.tokens=this.lexer.inline(fe)}return ce}},ve.def=function(J){var Y=this.rules.block.def.exec(J);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var ce=Y[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ce,raw:Y[0],href:Y[2],title:Y[3]}}},ve.table=function(J){var Y=this.rules.block.table.exec(J);if(Y){var ce={type:"table",header:D(Y[1]).map(function(je){return{text:je}}),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Y[3]&&Y[3].trim()?Y[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ce.header.length===ce.align.length){ce.raw=Y[0];var fe=ce.align.length,Ne,le,Ie,Ae;for(Ne=0;Ne<fe;Ne++)/^ *-+: *$/.test(ce.align[Ne])?ce.align[Ne]="right":/^ *:-+: *$/.test(ce.align[Ne])?ce.align[Ne]="center":/^ *:-+ *$/.test(ce.align[Ne])?ce.align[Ne]="left":ce.align[Ne]=null;for(fe=ce.rows.length,Ne=0;Ne<fe;Ne++)ce.rows[Ne]=D(ce.rows[Ne],ce.header.length).map(function(je){return{text:je}});for(fe=ce.header.length,le=0;le<fe;le++)ce.header[le].tokens=this.lexer.inline(ce.header[le].text);for(fe=ce.rows.length,le=0;le<fe;le++)for(Ae=ce.rows[le],Ie=0;Ie<Ae.length;Ie++)Ae[Ie].tokens=this.lexer.inline(Ae[Ie].text);return ce}}},ve.lheading=function(J){var Y=this.rules.block.lheading.exec(J);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1],tokens:this.lexer.inline(Y[1])}},ve.paragraph=function(J){var Y=this.rules.block.paragraph.exec(J);if(Y){var ce=Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1];return{type:"paragraph",raw:Y[0],text:ce,tokens:this.lexer.inline(ce)}}},ve.text=function(J){var Y=this.rules.block.text.exec(J);if(Y)return{type:"text",raw:Y[0],text:Y[0],tokens:this.lexer.inline(Y[0])}},ve.escape=function(J){var Y=this.rules.inline.escape.exec(J);if(Y)return{type:"escape",raw:Y[0],text:f(Y[1])}},ve.tag=function(J){var Y=this.rules.inline.tag.exec(J);if(Y)return!this.lexer.state.inLink&&/^<a /i.test(Y[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Y[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):f(Y[0]):Y[0]}},ve.link=function(J){var Y=this.rules.inline.link.exec(J);if(Y){var ce=Y[2].trim();if(!this.options.pedantic&&/^</.test(ce)){if(!/>$/.test(ce))return;var fe=g(ce.slice(0,-1),"\\");if((ce.length-fe.length)%2===0)return}else{var Ne=S(Y[2],"()");if(Ne>-1){var le=Y[0].indexOf("!")===0?5:4,Ie=le+Y[1].length+Ne;Y[2]=Y[2].substring(0,Ne),Y[0]=Y[0].substring(0,Ie).trim(),Y[3]=""}}var Ae=Y[2],je="";if(this.options.pedantic){var z=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);z&&(Ae=z[1],je=z[3])}else je=Y[3]?Y[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(ce)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),R(Y,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:je&&je.replace(this.rules.inline._escapes,"$1")},Y[0],this.lexer)}},ve.reflink=function(J,Y){var ce;if((ce=this.rules.inline.reflink.exec(J))||(ce=this.rules.inline.nolink.exec(J))){var fe=(ce[2]||ce[1]).replace(/\s+/g," ");if(fe=Y[fe.toLowerCase()],!fe||!fe.href){var Ne=ce[0].charAt(0);return{type:"text",raw:Ne,text:Ne}}return R(ce,fe,ce[0],this.lexer)}},ve.emStrong=function(J,Y,ce){ce===void 0&&(ce="");var fe=this.rules.inline.emStrong.lDelim.exec(J);if(fe&&!(fe[3]&&ce.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ne=fe[1]||fe[2]||"";if(!Ne||Ne&&(ce===""||this.rules.inline.punctuation.exec(ce))){var le=fe[0].length-1,Ie,Ae,je=le,z=0,j=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(j.lastIndex=0,Y=Y.slice(-1*J.length+le);(fe=j.exec(Y))!=null;)if(Ie=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!Ie){if(Ae=Ie.length,fe[3]||fe[4]){je+=Ae;continue}else if((fe[5]||fe[6])&&le%3&&!((le+Ae)%3)){z+=Ae;continue}if(je-=Ae,!(je>0)){if(Ae=Math.min(Ae,Ae+je+z),Math.min(le,Ae)%2){var K=J.slice(1,le+fe.index+Ae);return{type:"em",raw:J.slice(0,le+fe.index+Ae+1),text:K,tokens:this.lexer.inlineTokens(K)}}var H=J.slice(2,le+fe.index+Ae-1);return{type:"strong",raw:J.slice(0,le+fe.index+Ae+1),text:H,tokens:this.lexer.inlineTokens(H)}}}}}},ve.codespan=function(J){var Y=this.rules.inline.code.exec(J);if(Y){var ce=Y[2].replace(/\n/g," "),fe=/[^ ]/.test(ce),Ne=/^ /.test(ce)&&/ $/.test(ce);return fe&&Ne&&(ce=ce.substring(1,ce.length-1)),ce=f(ce,!0),{type:"codespan",raw:Y[0],text:ce}}},ve.br=function(J){var Y=this.rules.inline.br.exec(J);if(Y)return{type:"br",raw:Y[0]}},ve.del=function(J){var Y=this.rules.inline.del.exec(J);if(Y)return{type:"del",raw:Y[0],text:Y[2],tokens:this.lexer.inlineTokens(Y[2])}},ve.autolink=function(J,Y){var ce=this.rules.inline.autolink.exec(J);if(ce){var fe,Ne;return ce[2]==="@"?(fe=f(this.options.mangle?Y(ce[1]):ce[1]),Ne="mailto:"+fe):(fe=f(ce[1]),Ne=fe),{type:"link",raw:ce[0],text:fe,href:Ne,tokens:[{type:"text",raw:fe,text:fe}]}}},ve.url=function(J,Y){var ce;if(ce=this.rules.inline.url.exec(J)){var fe,Ne;if(ce[2]==="@")fe=f(this.options.mangle?Y(ce[0]):ce[0]),Ne="mailto:"+fe;else{var le;do le=ce[0],ce[0]=this.rules.inline._backpedal.exec(ce[0])[0];while(le!==ce[0]);fe=f(ce[0]),ce[1]==="www."?Ne="http://"+fe:Ne=fe}return{type:"link",raw:ce[0],text:fe,href:Ne,tokens:[{type:"text",raw:fe,text:fe}]}}},ve.inlineText=function(J,Y){var ce=this.rules.inline.text.exec(J);if(ce){var fe;return this.lexer.state.inRawBlock?fe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):f(ce[0]):ce[0]:fe=f(this.options.smartypants?Y(ce[0]):ce[0]),{type:"text",raw:ce[0],text:fe}}},Se}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:p,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=n(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=n(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=n(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=n(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=n(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=n(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=l({},q),q.gfm=l({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=n(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=n(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=l({},q.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:p,paragraph:n(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var M={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:p,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:p,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};M._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",M.punctuation=n(M.punctuation).replace(/punctuation/g,M._punctuation).getRegex(),M.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,M.escapedEmSt=/\\\*|\\_/g,M._comment=n(q._comment).replace("(?:-->|$)","-->").getRegex(),M.emStrong.lDelim=n(M.emStrong.lDelim).replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimAst=n(M.emStrong.rDelimAst,"g").replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimUnd=n(M.emStrong.rDelimUnd,"g").replace(/punct/g,M._punctuation).getRegex(),M._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,M._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,M._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,M.autolink=n(M.autolink).replace("scheme",M._scheme).replace("email",M._email).getRegex(),M._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,M.tag=n(M.tag).replace("comment",M._comment).replace("attribute",M._attribute).getRegex(),M._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,M._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,M._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,M.link=n(M.link).replace("label",M._label).replace("href",M._href).replace("title",M._title).getRegex(),M.reflink=n(M.reflink).replace("label",M._label).replace("ref",q._label).getRegex(),M.nolink=n(M.nolink).replace("ref",q._label).getRegex(),M.reflinkSearch=n(M.reflinkSearch,"g").replace("reflink",M.reflink).replace("nolink",M.nolink).getRegex(),M.normal=l({},M),M.pedantic=l({},M.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",M._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",M._label).getRegex()}),M.gfm=l({},M.normal,{escape:n(M.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),M.gfm.url=n(M.gfm.url,"i").replace("email",M.gfm._extended_email).getRegex(),M.breaks=l({},M.gfm,{br:n(M.br).replace("{2,}","*").getRegex(),text:n(M.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function L(Se){return Se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function G(Se){var ve="",me,J,Y=Se.length;for(me=0;me<Y;me++)J=Se.charCodeAt(me),Math.random()>.5&&(J="x"+J.toString(16)),ve+="&#"+J+";";return ve}var ne=function(){function Se(me){this.tokens=[],this.tokens.links=Object.create(null),this.options=me||$e.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var J={block:q.normal,inline:M.normal};this.options.pedantic?(J.block=q.pedantic,J.inline=M.pedantic):this.options.gfm&&(J.block=q.gfm,this.options.breaks?J.inline=M.breaks:J.inline=M.gfm),this.tokenizer.rules=J}Se.lex=function(J,Y){var ce=new Se(Y);return ce.lex(J)},Se.lexInline=function(J,Y){var ce=new Se(Y);return ce.inlineTokens(J)};var ve=Se.prototype;return ve.lex=function(J){J=J.replace(/\r\n|\r/g,`
`),this.blockTokens(J,this.tokens);for(var Y;Y=this.inlineQueue.shift();)this.inlineTokens(Y.src,Y.tokens);return this.tokens},ve.blockTokens=function(J,Y){var ce=this;Y===void 0&&(Y=[]),this.options.pedantic?J=J.replace(/\t/g,"    ").replace(/^ +$/gm,""):J=J.replace(/^( *)(\t+)/gm,function(je,z,j){return z+"    ".repeat(j.length)});for(var fe,Ne,le,Ie;J;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(je){return(fe=je.call({lexer:ce},J,Y))?(J=J.substring(fe.raw.length),Y.push(fe),!0):!1}))){if(fe=this.tokenizer.space(J)){J=J.substring(fe.raw.length),fe.raw.length===1&&Y.length>0?Y[Y.length-1].raw+=`
`:Y.push(fe);continue}if(fe=this.tokenizer.code(J)){J=J.substring(fe.raw.length),Ne=Y[Y.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+fe.raw,Ne.text+=`
`+fe.text,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(fe);continue}if(fe=this.tokenizer.fences(J)){J=J.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.heading(J)){J=J.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.hr(J)){J=J.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.blockquote(J)){J=J.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.list(J)){J=J.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.html(J)){J=J.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.def(J)){J=J.substring(fe.raw.length),Ne=Y[Y.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+fe.raw,Ne.text+=`
`+fe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(J)){J=J.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.lheading(J)){J=J.substring(fe.raw.length),Y.push(fe);continue}if(le=J,this.options.extensions&&this.options.extensions.startBlock&&function(){var je=1/0,z=J.slice(1),j=void 0;ce.options.extensions.startBlock.forEach(function(K){j=K.call({lexer:this},z),typeof j=="number"&&j>=0&&(je=Math.min(je,j))}),je<1/0&&je>=0&&(le=J.substring(0,je+1))}(),this.state.top&&(fe=this.tokenizer.paragraph(le))){Ne=Y[Y.length-1],Ie&&Ne.type==="paragraph"?(Ne.raw+=`
`+fe.raw,Ne.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(fe),Ie=le.length!==J.length,J=J.substring(fe.raw.length);continue}if(fe=this.tokenizer.text(J)){J=J.substring(fe.raw.length),Ne=Y[Y.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+fe.raw,Ne.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Y.push(fe);continue}if(J){var Ae="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,Y},ve.inline=function(J,Y){return Y===void 0&&(Y=[]),this.inlineQueue.push({src:J,tokens:Y}),Y},ve.inlineTokens=function(J,Y){var ce=this;Y===void 0&&(Y=[]);var fe,Ne,le,Ie=J,Ae,je,z;if(this.tokens.links){var j=Object.keys(this.tokens.links);if(j.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Ie))!=null;)j.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Ie=Ie.slice(0,Ae.index)+"["+C("a",Ae[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Ie))!=null;)Ie=Ie.slice(0,Ae.index)+"["+C("a",Ae[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Ie))!=null;)Ie=Ie.slice(0,Ae.index)+"++"+Ie.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;)if(je||(z=""),je=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(H){return(fe=H.call({lexer:ce},J,Y))?(J=J.substring(fe.raw.length),Y.push(fe),!0):!1}))){if(fe=this.tokenizer.escape(J)){J=J.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.tag(J)){J=J.substring(fe.raw.length),Ne=Y[Y.length-1],Ne&&fe.type==="text"&&Ne.type==="text"?(Ne.raw+=fe.raw,Ne.text+=fe.text):Y.push(fe);continue}if(fe=this.tokenizer.link(J)){J=J.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(fe.raw.length),Ne=Y[Y.length-1],Ne&&fe.type==="text"&&Ne.type==="text"?(Ne.raw+=fe.raw,Ne.text+=fe.text):Y.push(fe);continue}if(fe=this.tokenizer.emStrong(J,Ie,z)){J=J.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.codespan(J)){J=J.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.br(J)){J=J.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.del(J)){J=J.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.autolink(J,G)){J=J.substring(fe.raw.length),Y.push(fe);continue}if(!this.state.inLink&&(fe=this.tokenizer.url(J,G))){J=J.substring(fe.raw.length),Y.push(fe);continue}if(le=J,this.options.extensions&&this.options.extensions.startInline&&function(){var H=1/0,_=J.slice(1),re=void 0;ce.options.extensions.startInline.forEach(function(Fe){re=Fe.call({lexer:this},_),typeof re=="number"&&re>=0&&(H=Math.min(H,re))}),H<1/0&&H>=0&&(le=J.substring(0,H+1))}(),fe=this.tokenizer.inlineText(le,L)){J=J.substring(fe.raw.length),fe.raw.slice(-1)!=="_"&&(z=fe.raw.slice(-1)),je=!0,Ne=Y[Y.length-1],Ne&&Ne.type==="text"?(Ne.raw+=fe.raw,Ne.text+=fe.text):Y.push(fe);continue}if(J){var K="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return Y},I(Se,null,[{key:"rules",get:function(){return{block:q,inline:M}}}]),Se}(),he=function(){function Se(me){this.options=me||$e.defaults}var ve=Se.prototype;return ve.code=function(J,Y,ce){var fe=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Ne=this.options.highlight(J,fe);Ne!=null&&Ne!==J&&(ce=!0,J=Ne)}return J=J.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+f(fe,!0)+'">'+(ce?J:f(J,!0))+`</code></pre>
`:"<pre><code>"+(ce?J:f(J,!0))+`</code></pre>
`},ve.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},ve.html=function(J){return J},ve.heading=function(J,Y,ce,fe){if(this.options.headerIds){var Ne=this.options.headerPrefix+fe.slug(ce);return"<h"+Y+' id="'+Ne+'">'+J+"</h"+Y+`>
`}return"<h"+Y+">"+J+"</h"+Y+`>
`},ve.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ve.list=function(J,Y,ce){var fe=Y?"ol":"ul",Ne=Y&&ce!==1?' start="'+ce+'"':"";return"<"+fe+Ne+`>
`+J+"</"+fe+`>
`},ve.listitem=function(J){return"<li>"+J+`</li>
`},ve.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ve.paragraph=function(J){return"<p>"+J+`</p>
`},ve.table=function(J,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+Y+`</table>
`},ve.tablerow=function(J){return`<tr>
`+J+`</tr>
`},ve.tablecell=function(J,Y){var ce=Y.header?"th":"td",fe=Y.align?"<"+ce+' align="'+Y.align+'">':"<"+ce+">";return fe+J+("</"+ce+`>
`)},ve.strong=function(J){return"<strong>"+J+"</strong>"},ve.em=function(J){return"<em>"+J+"</em>"},ve.codespan=function(J){return"<code>"+J+"</code>"},ve.br=function(){return this.options.xhtml?"<br/>":"<br>"},ve.del=function(J){return"<del>"+J+"</del>"},ve.link=function(J,Y,ce){if(J=h(this.options.sanitize,this.options.baseUrl,J),J===null)return ce;var fe='<a href="'+f(J)+'"';return Y&&(fe+=' title="'+Y+'"'),fe+=">"+ce+"</a>",fe},ve.image=function(J,Y,ce){if(J=h(this.options.sanitize,this.options.baseUrl,J),J===null)return ce;var fe='<img src="'+J+'" alt="'+ce+'"';return Y&&(fe+=' title="'+Y+'"'),fe+=this.options.xhtml?"/>":">",fe},ve.text=function(J){return J},Se}(),ye=function(){function Se(){}var ve=Se.prototype;return ve.strong=function(J){return J},ve.em=function(J){return J},ve.codespan=function(J){return J},ve.del=function(J){return J},ve.html=function(J){return J},ve.text=function(J){return J},ve.link=function(J,Y,ce){return""+ce},ve.image=function(J,Y,ce){return""+ce},ve.br=function(){return""},Se}(),Re=function(){function Se(){this.seen={}}var ve=Se.prototype;return ve.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ve.getNextSafeSlug=function(J,Y){var ce=J,fe=0;if(this.seen.hasOwnProperty(ce)){fe=this.seen[J];do fe++,ce=J+"-"+fe;while(this.seen.hasOwnProperty(ce))}return Y||(this.seen[J]=fe,this.seen[ce]=0),ce},ve.slug=function(J,Y){Y===void 0&&(Y={});var ce=this.serialize(J);return this.getNextSafeSlug(ce,Y.dryrun)},Se}(),ge=function(){function Se(me){this.options=me||$e.defaults,this.options.renderer=this.options.renderer||new he,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ye,this.slugger=new Re}Se.parse=function(J,Y){var ce=new Se(Y);return ce.parse(J)},Se.parseInline=function(J,Y){var ce=new Se(Y);return ce.parseInline(J)};var ve=Se.prototype;return ve.parse=function(J,Y){Y===void 0&&(Y=!0);var ce="",fe,Ne,le,Ie,Ae,je,z,j,K,H,_,re,Fe,Ve,Qe,xe,tt,at,it,nt=J.length;for(fe=0;fe<nt;fe++){if(H=J[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(it=this.options.extensions.renderers[H.type].call({parser:this},H),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(H.type))){ce+=it||"";continue}switch(H.type){case"space":continue;case"hr":{ce+=this.renderer.hr();continue}case"heading":{ce+=this.renderer.heading(this.parseInline(H.tokens),H.depth,o(this.parseInline(H.tokens,this.textRenderer)),this.slugger);continue}case"code":{ce+=this.renderer.code(H.text,H.lang,H.escaped);continue}case"table":{for(j="",z="",Ie=H.header.length,Ne=0;Ne<Ie;Ne++)z+=this.renderer.tablecell(this.parseInline(H.header[Ne].tokens),{header:!0,align:H.align[Ne]});for(j+=this.renderer.tablerow(z),K="",Ie=H.rows.length,Ne=0;Ne<Ie;Ne++){for(je=H.rows[Ne],z="",Ae=je.length,le=0;le<Ae;le++)z+=this.renderer.tablecell(this.parseInline(je[le].tokens),{header:!1,align:H.align[le]});K+=this.renderer.tablerow(z)}ce+=this.renderer.table(j,K);continue}case"blockquote":{K=this.parse(H.tokens),ce+=this.renderer.blockquote(K);continue}case"list":{for(_=H.ordered,re=H.start,Fe=H.loose,Ie=H.items.length,K="",Ne=0;Ne<Ie;Ne++)Qe=H.items[Ne],xe=Qe.checked,tt=Qe.task,Ve="",Qe.task&&(at=this.renderer.checkbox(xe),Fe?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=at+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=at+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:at}):Ve+=at),Ve+=this.parse(Qe.tokens,Fe),K+=this.renderer.listitem(Ve,tt,xe);ce+=this.renderer.list(K,_,re);continue}case"html":{ce+=this.renderer.html(H.text);continue}case"paragraph":{ce+=this.renderer.paragraph(this.parseInline(H.tokens));continue}case"text":{for(K=H.tokens?this.parseInline(H.tokens):H.text;fe+1<nt&&J[fe+1].type==="text";)H=J[++fe],K+=`
`+(H.tokens?this.parseInline(H.tokens):H.text);ce+=Y?this.renderer.paragraph(K):K;continue}default:{var ct='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(ct);return}else throw new Error(ct)}}}return ce},ve.parseInline=function(J,Y){Y=Y||this.renderer;var ce="",fe,Ne,le,Ie=J.length;for(fe=0;fe<Ie;fe++){if(Ne=J[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ne.type]&&(le=this.options.extensions.renderers[Ne.type].call({parser:this},Ne),le!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ne.type))){ce+=le||"";continue}switch(Ne.type){case"escape":{ce+=Y.text(Ne.text);break}case"html":{ce+=Y.html(Ne.text);break}case"link":{ce+=Y.link(Ne.href,Ne.title,this.parseInline(Ne.tokens,Y));break}case"image":{ce+=Y.image(Ne.href,Ne.title,Ne.text);break}case"strong":{ce+=Y.strong(this.parseInline(Ne.tokens,Y));break}case"em":{ce+=Y.em(this.parseInline(Ne.tokens,Y));break}case"codespan":{ce+=Y.codespan(Ne.text);break}case"br":{ce+=Y.br();break}case"del":{ce+=Y.del(this.parseInline(Ne.tokens,Y));break}case"text":{ce+=Y.text(Ne.text);break}default:{var Ae='Token with "'+Ne.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return ce},Se}();function ue(Se,ve,me){if(typeof Se>"u"||Se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected");if(typeof ve=="function"&&(me=ve,ve=null),ve=l({},ue.defaults,ve||{}),y(ve),me){var J=ve.highlight,Y;try{Y=ne.lex(Se,ve)}catch(Ie){return me(Ie)}var ce=function(Ae){var je;if(!Ae)try{ve.walkTokens&&ue.walkTokens(Y,ve.walkTokens),je=ge.parse(Y,ve)}catch(z){Ae=z}return ve.highlight=J,Ae?me(Ae):me(null,je)};if(!J||J.length<3||(delete ve.highlight,!Y.length))return ce();var fe=0;ue.walkTokens(Y,function(Ie){Ie.type==="code"&&(fe++,setTimeout(function(){J(Ie.text,Ie.lang,function(Ae,je){if(Ae)return ce(Ae);je!=null&&je!==Ie.text&&(Ie.text=je,Ie.escaped=!0),fe--,fe===0&&ce()})},0))}),fe===0&&ce();return}function Ne(Ie){if(Ie.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+f(Ie.message+"",!0)+"</pre>";throw Ie}try{var le=ne.lex(Se,ve);if(ve.walkTokens){if(ve.async)return Promise.all(ue.walkTokens(le,ve.walkTokens)).then(function(){return ge.parse(le,ve)}).catch(Ne);ue.walkTokens(le,ve.walkTokens)}return ge.parse(le,ve)}catch(Ie){Ne(Ie)}}ue.options=ue.setOptions=function(Se){return l(ue.defaults,Se),m(ue.defaults),ue},ue.getDefaults=A,ue.defaults=$e.defaults,ue.use=function(){for(var Se=arguments.length,ve=new Array(Se),me=0;me<Se;me++)ve[me]=arguments[me];var J=l.apply(void 0,[{}].concat(ve)),Y=ue.defaults.extensions||{renderers:{},childTokens:{}},ce;ve.forEach(function(fe){if(fe.extensions&&(ce=!0,fe.extensions.forEach(function(le){if(!le.name)throw new Error("extension name required");if(le.renderer){var Ie=Y.renderers?Y.renderers[le.name]:null;Ie?Y.renderers[le.name]=function(){for(var Ae=arguments.length,je=new Array(Ae),z=0;z<Ae;z++)je[z]=arguments[z];var j=le.renderer.apply(this,je);return j===!1&&(j=Ie.apply(this,je)),j}:Y.renderers[le.name]=le.renderer}if(le.tokenizer){if(!le.level||le.level!=="block"&&le.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Y[le.level]?Y[le.level].unshift(le.tokenizer):Y[le.level]=[le.tokenizer],le.start&&(le.level==="block"?Y.startBlock?Y.startBlock.push(le.start):Y.startBlock=[le.start]:le.level==="inline"&&(Y.startInline?Y.startInline.push(le.start):Y.startInline=[le.start]))}le.childTokens&&(Y.childTokens[le.name]=le.childTokens)})),fe.renderer&&function(){var le=ue.defaults.renderer||new he,Ie=function(z){var j=le[z];le[z]=function(){for(var K=arguments.length,H=new Array(K),_=0;_<K;_++)H[_]=arguments[_];var re=fe.renderer[z].apply(le,H);return re===!1&&(re=j.apply(le,H)),re}};for(var Ae in fe.renderer)Ie(Ae);J.renderer=le}(),fe.tokenizer&&function(){var le=ue.defaults.tokenizer||new U,Ie=function(z){var j=le[z];le[z]=function(){for(var K=arguments.length,H=new Array(K),_=0;_<K;_++)H[_]=arguments[_];var re=fe.tokenizer[z].apply(le,H);return re===!1&&(re=j.apply(le,H)),re}};for(var Ae in fe.tokenizer)Ie(Ae);J.tokenizer=le}(),fe.walkTokens){var Ne=ue.defaults.walkTokens;J.walkTokens=function(le){var Ie=[];return Ie.push(fe.walkTokens.call(this,le)),Ne&&(Ie=Ie.concat(Ne.call(this,le))),Ie}}ce&&(J.extensions=Y),ue.setOptions(J)})},ue.walkTokens=function(Se,ve){for(var me=[],J=function(){var Ne=ce.value;switch(me=me.concat(ve.call(ue,Ne)),Ne.type){case"table":{for(var le=N(Ne.header),Ie;!(Ie=le()).done;){var Ae=Ie.value;me=me.concat(ue.walkTokens(Ae.tokens,ve))}for(var je=N(Ne.rows),z;!(z=je()).done;)for(var j=z.value,K=N(j),H;!(H=K()).done;){var _=H.value;me=me.concat(ue.walkTokens(_.tokens,ve))}break}case"list":{me=me.concat(ue.walkTokens(Ne.items,ve));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[Ne.type]?ue.defaults.extensions.childTokens[Ne.type].forEach(function(re){me=me.concat(ue.walkTokens(Ne[re],ve))}):Ne.tokens&&(me=me.concat(ue.walkTokens(Ne.tokens,ve)))}},Y=N(Se),ce;!(ce=Y()).done;)J();return me},ue.parseInline=function(Se,ve){if(typeof Se>"u"||Se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected");ve=l({},ue.defaults,ve||{}),y(ve);try{var me=ne.lexInline(Se,ve);return ve.walkTokens&&ue.walkTokens(me,ve.walkTokens),ge.parseInline(me,ve)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+f(J.message+"",!0)+"</pre>";throw J}},ue.Parser=ge,ue.parser=ge.parse,ue.Renderer=he,ue.TextRenderer=ye,ue.Lexer=ne,ue.lexer=ne.lex,ue.Tokenizer=U,ue.Slugger=Re,ue.parse=ue;var te=ue.options,be=ue.setOptions,oe=ue.use,de=ue.walkTokens,W=ue.parseInline,ee=ue,ke=ge.parse,Te=ne.lex;$e.Lexer=ne,$e.Parser=ge,$e.Renderer=he,$e.Slugger=Re,$e.TextRenderer=ye,$e.Tokenizer=U,$e.getDefaults=A,$e.lexer=Te,$e.marked=ue,$e.options=te,$e.parse=ee,$e.parseInline=W,$e.parser=ke,$e.setOptions=be,$e.use=oe,$e.walkTokens=de,Object.defineProperty($e,"__esModule",{value:!0})}),define(Ce[124],Pe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=I;function I(r){const o=N(r);if(o&&o.length>0)return new Uint32Array(o)}let O=0;const P=new Uint32Array(10);function N(r){if(O=0,A(r,E,4352),O>0||(A(r,u,4449),O>0)||(A(r,b,4520),O>0)||(A(r,f,12593),O))return P.subarray(0,O);if(r>=44032&&r<=55203){const o=r-44032,s=o%588,n=Math.floor(o/588),i=Math.floor(s/28),a=s%28-1;if(n<E.length?A(n,E,0):4352+n-12593<f.length&&A(4352+n,f,12593),i<u.length?A(i,u,0):4449+i-12593<f.length&&A(4449+i-12593,f,12593),a>=0&&(a<b.length?A(a,b,0):4520+a-12593<f.length&&A(4520+a-12593,f,12593)),O>0)return P.subarray(0,O)}}function A(r,o,s){r>=s&&r<s+o.length&&m(o[r-s])}function m(r){r!==0&&(P[O++]=r&255,r>>8&&(P[O++]=r>>8&255),r>>16&&(P[O++]=r>>16&255))}var d;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(d||(d={}));var k;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(k||(k={}));var F;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(F||(F={}));const E=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),u=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),b=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),f=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Ce[125],Pe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=e.$pm=void 0,e.$nm=I,e.rot=O;function I(m,d,k){return Math.min(Math.max(m,d),k)}function O(m,d){return(d+m%d)%d}class P{constructor(){this.a=0}getNext(){return this.a++}}e.$pm=P;class N{constructor(){this.a=1,this.b=0}update(d){return this.b=this.b+(d-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$qm=N;class A{constructor(d){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(d),this.c.fill(0,0,d)}update(d){const k=this.c[this.d];return this.c[this.d]=d,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=d,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$rm=A}),function(){function $e(P){const N=[];typeof P=="number"&&N.push("code/timeOrigin",P);function A(d){N.push(d,Date.now())}function m(){const d=[];for(let k=0;k<N.length;k+=2)d.push({name:N[k],startTime:N[k+1]});return d}return{mark:A,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$e():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const A of performance.getEntriesByType("mark"))N.push({name:A.name,startTime:Math.round(P+A.startTime)});return N}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $e(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),$e()}function I(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=I(O))}(),define(Ce[126],Pe([1,0,39]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uO=void 0;const O=Symbol("unset");class P{constructor(){this.a=new A,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||I.Iterable.empty()}insert(d,k,F){this.d(d,E=>E._value=k,F)}mutate(d,k){this.d(d,F=>F._value=k(F._value===O?void 0:F._value))}delete(d){const k=this.c(d);if(!k)return;let F=k.length-1;const E=k[F].node._value;if(E!==O){for(this.b--,k[F].node._value=O;F>0;F--){const{node:u,part:b}=k[F];if(u.children?.size||u._value!==O)break;k[F-1].node.children.delete(b)}return E}}*deleteRecursive(d){const k=this.c(d);if(!k)return;const F=k[k.length-1].node;for(let E=k.length-1;E>0;E--){const u=k[E-1];if(u.node.children.delete(k[E].part),u.node.children.size>0||u.node._value!==O)break}for(const E of N(F))E._value!==O&&(this.b--,yield E._value)}find(d){let k=this.a;for(const F of d){const E=k.children?.get(F);if(!E)return;k=E}return k._value===O?void 0:k._value}hasKeyOrParent(d){let k=this.a;for(const F of d){const E=k.children?.get(F);if(!E)return!1;if(E._value!==O)return!0;k=E}return!1}hasKeyOrChildren(d){let k=this.a;for(const F of d){const E=k.children?.get(F);if(!E)return!1;k=E}return!0}hasKey(d){let k=this.a;for(const F of d){const E=k.children?.get(F);if(!E)return!1;k=E}return k._value!==O}c(d){const k=[{part:"",node:this.a}];let F=0;for(const E of d){const u=k[F].node.children?.get(E);if(!u)return;k.push({part:E,node:u}),F++}return k}d(d,k,F){let E=this.a;for(const f of d){if(E.children)if(E.children.has(f))E=E.children.get(f);else{const r=new A;E.children.set(f,r),E=r}else{const r=new A;E.children=new Map([[f,r]]),E=r}F?.(E)}const u=E._value===O?0:1;k(E);const b=E._value===O?0:1;this.b+=b-u}*values(){for(const{_value:d}of N(this.a))d!==O&&(yield d)}}e.$uO=P;function*N(m){const d=[m];for(;d.length>0;){const k=d.pop();if(yield k,k.children)for(const F of k.children.values())d.push(F)}}class A{constructor(){this._value=O}get value(){return this._value===O?void 0:this._value}set value(d){this._value=d===void 0?O:d}}}),function($e,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var O in I)(typeof exports=="object"?exports:$e)[O]=I[O]}}(typeof self<"u"?self:this,function(){return function($e){var e={};function I(O){if(e[O])return e[O].exports;var P=e[O]={i:O,l:!1,exports:{}};return $e[O].call(P.exports,P,P.exports,I),P.l=!0,P.exports}return I.m=$e,I.c=e,I.d=function(O,P,N){I.o(O,P)||Object.defineProperty(O,P,{enumerable:!0,get:N})},I.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},I.t=function(O,P){if(1&P&&(O=I(O)),8&P||4&P&&typeof O=="object"&&O&&O.__esModule)return O;var N=Object.create(null);if(I.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:O}),2&P&&typeof O!="string")for(var A in O)I.d(N,A,function(m){return O[m]}.bind(null,A));return N},I.n=function(O){var P=O&&O.__esModule?function(){return O.default}:function(){return O};return I.d(P,"a",P),P},I.o=function(O,P){return Object.prototype.hasOwnProperty.call(O,P)},I.p="",I(I.s=0)}([function($e,e,I){(function(O){var P;e=$e.exports=oe,P=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],d=e.src=[],k=0,F=k++;d[F]="0|[1-9]\\d*";var E=k++;d[E]="[0-9]+";var u=k++;d[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=k++;d[b]="("+d[F]+")\\.("+d[F]+")\\.("+d[F]+")";var f=k++;d[f]="("+d[E]+")\\.("+d[E]+")\\.("+d[E]+")";var r=k++;d[r]="(?:"+d[F]+"|"+d[u]+")";var o=k++;d[o]="(?:"+d[E]+"|"+d[u]+")";var s=k++;d[s]="(?:-("+d[r]+"(?:\\."+d[r]+")*))";var n=k++;d[n]="(?:-?("+d[o]+"(?:\\."+d[o]+")*))";var i=k++;d[i]="[0-9A-Za-z-]+";var a=k++;d[a]="(?:\\+("+d[i]+"(?:\\."+d[i]+")*))";var h=k++,t="v?"+d[b]+d[s]+"?"+d[a]+"?";d[h]="^"+t+"$";var v="[v=\\s]*"+d[f]+d[n]+"?"+d[a]+"?",c=k++;d[c]="^"+v+"$";var $=k++;d[$]="((?:<|>)?=?)";var w=k++;d[w]=d[E]+"|x|X|\\*";var p=k++;d[p]=d[F]+"|x|X|\\*";var l=k++;d[l]="[v=\\s]*("+d[p]+")(?:\\.("+d[p]+")(?:\\.("+d[p]+")(?:"+d[s]+")?"+d[a]+"?)?)?";var D=k++;d[D]="[v=\\s]*("+d[w]+")(?:\\.("+d[w]+")(?:\\.("+d[w]+")(?:"+d[n]+")?"+d[a]+"?)?)?";var g=k++;d[g]="^"+d[$]+"\\s*"+d[l]+"$";var S=k++;d[S]="^"+d[$]+"\\s*"+d[D]+"$";var y=k++;d[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=k++;d[C]="(?:~>?)";var R=k++;d[R]="(\\s*)"+d[C]+"\\s+",m[R]=new RegExp(d[R],"g");var V=k++;d[V]="^"+d[C]+d[l]+"$";var U=k++;d[U]="^"+d[C]+d[D]+"$";var q=k++;d[q]="(?:\\^)";var M=k++;d[M]="(\\s*)"+d[q]+"\\s+",m[M]=new RegExp(d[M],"g");var L=k++;d[L]="^"+d[q]+d[l]+"$";var G=k++;d[G]="^"+d[q]+d[D]+"$";var ne=k++;d[ne]="^"+d[$]+"\\s*("+v+")$|^$";var he=k++;d[he]="^"+d[$]+"\\s*("+t+")$|^$";var ye=k++;d[ye]="(\\s*)"+d[$]+"\\s*("+v+"|"+d[l]+")",m[ye]=new RegExp(d[ye],"g");var Re=k++;d[Re]="^\\s*("+d[l]+")\\s+-\\s+("+d[l]+")\\s*$";var ge=k++;d[ge]="^\\s*("+d[D]+")\\s+-\\s+("+d[D]+")\\s*$";var ue=k++;d[ue]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)P(te,d[te]),m[te]||(m[te]=new RegExp(d[te]));function be(j,K){if(j instanceof oe)return j;if(typeof j!="string"||j.length>N||!(K?m[c]:m[h]).test(j))return null;try{return new oe(j,K)}catch{return null}}function oe(j,K){if(j instanceof oe){if(j.loose===K)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof oe))return new oe(j,K);P("SemVer",j,K),this.loose=K;var H=j.trim().match(K?m[c]:m[h]);if(!H)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(_){if(/^[0-9]+$/.test(_)){var re=+_;if(re>=0&&re<A)return re}return _}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}e.parse=be,e.valid=function(j,K){var H=be(j,K);return H?H.version:null},e.clean=function(j,K){var H=be(j.trim().replace(/^[=v]+/,""),K);return H?H.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(j){return P("SemVer.compare",this.version,this.loose,j),j instanceof oe||(j=new oe(j,this.loose)),this.compareMain(j)||this.comparePre(j)},oe.prototype.compareMain=function(j){return j instanceof oe||(j=new oe(j,this.loose)),W(this.major,j.major)||W(this.minor,j.minor)||W(this.patch,j.patch)},oe.prototype.comparePre=function(j){if(j instanceof oe||(j=new oe(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var K=0;do{var H=this.prerelease[K],_=j.prerelease[K];if(P("prerelease compare",K,H,_),H===void 0&&_===void 0)return 0;if(_===void 0)return 1;if(H===void 0)return-1;if(H!==_)return W(H,_)}while(++K)},oe.prototype.inc=function(j,K){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},e.inc=function(j,K,H,_){typeof H=="string"&&(_=H,H=void 0);try{return new oe(j,H).inc(K,_).version}catch{return null}},e.diff=function(j,K){if(Se(j,K))return null;var H=be(j),_=be(K);if(H.prerelease.length||_.prerelease.length){for(var re in H)if((re==="major"||re==="minor"||re==="patch")&&H[re]!==_[re])return"pre"+re;return"prerelease"}for(var re in H)if((re==="major"||re==="minor"||re==="patch")&&H[re]!==_[re])return re},e.compareIdentifiers=W;var de=/^[0-9]+$/;function W(j,K){var H=de.test(j),_=de.test(K);return H&&_&&(j=+j,K=+K),H&&!_?-1:_&&!H?1:j<K?-1:j>K?1:0}function ee(j,K,H){return new oe(j,H).compare(new oe(K,H))}function ke(j,K,H){return ee(j,K,H)>0}function Te(j,K,H){return ee(j,K,H)<0}function Se(j,K,H){return ee(j,K,H)===0}function ve(j,K,H){return ee(j,K,H)!==0}function me(j,K,H){return ee(j,K,H)>=0}function J(j,K,H){return ee(j,K,H)<=0}function Y(j,K,H,_){var re;switch(K){case"===":typeof j=="object"&&(j=j.version),typeof H=="object"&&(H=H.version),re=j===H;break;case"!==":typeof j=="object"&&(j=j.version),typeof H=="object"&&(H=H.version),re=j!==H;break;case"":case"=":case"==":re=Se(j,H,_);break;case"!=":re=ve(j,H,_);break;case">":re=ke(j,H,_);break;case">=":re=me(j,H,_);break;case"<":re=Te(j,H,_);break;case"<=":re=J(j,H,_);break;default:throw new TypeError("Invalid operator: "+K)}return re}function ce(j,K){if(j instanceof ce){if(j.loose===K)return j;j=j.value}if(!(this instanceof ce))return new ce(j,K);P("comparator",j,K),this.loose=K,this.parse(j),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(j,K){return W(K,j)},e.major=function(j,K){return new oe(j,K).major},e.minor=function(j,K){return new oe(j,K).minor},e.patch=function(j,K){return new oe(j,K).patch},e.compare=ee,e.compareLoose=function(j,K){return ee(j,K,!0)},e.rcompare=function(j,K,H){return ee(K,j,H)},e.sort=function(j,K){return j.sort(function(H,_){return e.compare(H,_,K)})},e.rsort=function(j,K){return j.sort(function(H,_){return e.rcompare(H,_,K)})},e.gt=ke,e.lt=Te,e.eq=Se,e.neq=ve,e.gte=me,e.lte=J,e.cmp=Y,e.Comparator=ce;var fe={};function Ne(j,K){if(j instanceof Ne)return j.loose===K?j:new Ne(j.raw,K);if(j instanceof ce)return new Ne(j.value,K);if(!(this instanceof Ne))return new Ne(j,K);if(this.loose=K,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function le(j){return!j||j.toLowerCase()==="x"||j==="*"}function Ie(j,K,H,_,re,Fe,Ve,Qe,xe,tt,at,it,nt){return((K=le(H)?"":le(_)?">="+H+".0.0":le(re)?">="+H+"."+_+".0":">="+K)+" "+(Qe=le(xe)?"":le(tt)?"<"+(+xe+1)+".0.0":le(at)?"<"+xe+"."+(+tt+1)+".0":it?"<="+xe+"."+tt+"."+at+"-"+it:"<="+Qe)).trim()}function Ae(j,K){for(var H=0;H<j.length;H++)if(!j[H].test(K))return!1;if(K.prerelease.length){for(H=0;H<j.length;H++)if(P(j[H].semver),j[H].semver!==fe&&j[H].semver.prerelease.length>0){var _=j[H].semver;if(_.major===K.major&&_.minor===K.minor&&_.patch===K.patch)return!0}return!1}return!0}function je(j,K,H){try{K=new Ne(K,H)}catch{return!1}return K.test(j)}function z(j,K,H,_){var re,Fe,Ve,Qe,xe;switch(j=new oe(j,_),K=new Ne(K,_),H){case">":re=ke,Fe=J,Ve=Te,Qe=">",xe=">=";break;case"<":re=Te,Fe=me,Ve=ke,Qe="<",xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(je(j,K,_))return!1;for(var tt=0;tt<K.set.length;++tt){var at=K.set[tt],it=null,nt=null;if(at.forEach(function(ct){ct.semver===fe&&(ct=new ce(">=0.0.0")),it=it||ct,nt=nt||ct,re(ct.semver,it.semver,_)?it=ct:Ve(ct.semver,nt.semver,_)&&(nt=ct)}),it.operator===Qe||it.operator===xe||(!nt.operator||nt.operator===Qe)&&Fe(j,nt.semver)||nt.operator===xe&&Ve(j,nt.semver))return!1}return!0}ce.prototype.parse=function(j){var K=this.loose?m[ne]:m[he],H=j.match(K);if(!H)throw new TypeError("Invalid comparator: "+j);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new oe(H[2],this.loose):this.semver=fe},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(j){return P("Comparator.test",j,this.loose),this.semver===fe||(typeof j=="string"&&(j=new oe(j,this.loose)),Y(j,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(j,K){if(!(j instanceof ce))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new Ne(j.value,K),je(this.value,H,K);if(j.operator==="")return H=new Ne(this.value,K),je(j.semver,H,K);var _=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),re=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),Fe=this.semver.version===j.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),Qe=Y(this.semver,"<",j.semver,K)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),xe=Y(this.semver,">",j.semver,K)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return _||re||Fe&&Ve||Qe||xe},e.Range=Ne,Ne.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},Ne.prototype.toString=function(){return this.range},Ne.prototype.parseRange=function(j){var K=this.loose;j=j.trim(),P("range",j,K);var H=K?m[ge]:m[Re];j=j.replace(H,Ie),P("hyphen replace",j),j=j.replace(m[ye],"$1$2$3"),P("comparator trim",j,m[ye]),j=(j=(j=j.replace(m[R],"$1~")).replace(m[M],"$1^")).split(/\s+/).join(" ");var _=K?m[ne]:m[he],re=j.split(" ").map(function(Fe){return function(Ve,Qe){return P("comp",Ve),Ve=function(xe,tt){return xe.trim().split(/\s+/).map(function(at){return function(it,nt){P("caret",it,nt);var ct=nt?m[G]:m[L];return it.replace(ct,function(ft,Ue,ot,X,Z){var pe;return P("caret",it,ft,Ue,ot,X,Z),le(Ue)?pe="":le(ot)?pe=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":le(X)?pe=Ue==="0"?">="+Ue+"."+ot+".0 <"+Ue+"."+(+ot+1)+".0":">="+Ue+"."+ot+".0 <"+(+Ue+1)+".0.0":Z?(P("replaceCaret pr",Z),Z.charAt(0)!=="-"&&(Z="-"+Z),pe=Ue==="0"?ot==="0"?">="+Ue+"."+ot+"."+X+Z+" <"+Ue+"."+ot+"."+(+X+1):">="+Ue+"."+ot+"."+X+Z+" <"+Ue+"."+(+ot+1)+".0":">="+Ue+"."+ot+"."+X+Z+" <"+(+Ue+1)+".0.0"):(P("no pr"),pe=Ue==="0"?ot==="0"?">="+Ue+"."+ot+"."+X+" <"+Ue+"."+ot+"."+(+X+1):">="+Ue+"."+ot+"."+X+" <"+Ue+"."+(+ot+1)+".0":">="+Ue+"."+ot+"."+X+" <"+(+Ue+1)+".0.0"),P("caret return",pe),pe})}(at,tt)}).join(" ")}(Ve,Qe),P("caret",Ve),Ve=function(xe,tt){return xe.trim().split(/\s+/).map(function(at){return function(it,nt){var ct=nt?m[U]:m[V];return it.replace(ct,function(ft,Ue,ot,X,Z){var pe;return P("tilde",it,ft,Ue,ot,X,Z),le(Ue)?pe="":le(ot)?pe=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":le(X)?pe=">="+Ue+"."+ot+".0 <"+Ue+"."+(+ot+1)+".0":Z?(P("replaceTilde pr",Z),Z.charAt(0)!=="-"&&(Z="-"+Z),pe=">="+Ue+"."+ot+"."+X+Z+" <"+Ue+"."+(+ot+1)+".0"):pe=">="+Ue+"."+ot+"."+X+" <"+Ue+"."+(+ot+1)+".0",P("tilde return",pe),pe})}(at,tt)}).join(" ")}(Ve,Qe),P("tildes",Ve),Ve=function(xe,tt){return P("replaceXRanges",xe,tt),xe.split(/\s+/).map(function(at){return function(it,nt){it=it.trim();var ct=nt?m[S]:m[g];return it.replace(ct,function(ft,Ue,ot,X,Z,pe){P("xRange",it,ft,Ue,ot,X,Z,pe);var qe=le(ot),Ze=qe||le(X),Me=Ze||le(Z);return Ue==="="&&Me&&(Ue=""),qe?ft=Ue===">"||Ue==="<"?"<0.0.0":"*":Ue&&Me?(Ze&&(X=0),Me&&(Z=0),Ue===">"?(Ue=">=",Ze?(ot=+ot+1,X=0,Z=0):Me&&(X=+X+1,Z=0)):Ue==="<="&&(Ue="<",Ze?ot=+ot+1:X=+X+1),ft=Ue+ot+"."+X+"."+Z):Ze?ft=">="+ot+".0.0 <"+(+ot+1)+".0.0":Me&&(ft=">="+ot+"."+X+".0 <"+ot+"."+(+X+1)+".0"),P("xRange return",ft),ft})}(at,tt)}).join(" ")}(Ve,Qe),P("xrange",Ve),Ve=function(xe,tt){return P("replaceStars",xe,tt),xe.trim().replace(m[ue],"")}(Ve,Qe),P("stars",Ve),Ve}(Fe,K)}).join(" ").split(/\s+/);return this.loose&&(re=re.filter(function(Fe){return!!Fe.match(_)})),re=re.map(function(Fe){return new ce(Fe,K)})},Ne.prototype.intersects=function(j,K){if(!(j instanceof Ne))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(_){return j.set.some(function(re){return re.every(function(Fe){return _.intersects(Fe,K)})})})})},e.toComparators=function(j,K){return new Ne(j,K).set.map(function(H){return H.map(function(_){return _.value}).join(" ").trim().split(" ")})},Ne.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new oe(j,this.loose));for(var K=0;K<this.set.length;K++)if(Ae(this.set[K],j))return!0;return!1},e.satisfies=je,e.maxSatisfying=function(j,K,H){var _=null,re=null;try{var Fe=new Ne(K,H)}catch{return null}return j.forEach(function(Ve){Fe.test(Ve)&&(_&&re.compare(Ve)!==-1||(re=new oe(_=Ve,H)))}),_},e.minSatisfying=function(j,K,H){var _=null,re=null;try{var Fe=new Ne(K,H)}catch{return null}return j.forEach(function(Ve){Fe.test(Ve)&&(_&&re.compare(Ve)!==1||(re=new oe(_=Ve,H)))}),_},e.validRange=function(j,K){try{return new Ne(j,K).range||"*"}catch{return null}},e.ltr=function(j,K,H){return z(j,K,"<",H)},e.gtr=function(j,K,H){return z(j,K,">",H)},e.outside=z,e.prerelease=function(j,K){var H=be(j,K);return H&&H.prerelease.length?H.prerelease:null},e.intersects=function(j,K,H){return j=new Ne(j,H),K=new Ne(K,H),j.intersects(K)},e.coerce=function(j){if(j instanceof oe)return j;if(typeof j!="string")return null;var K=j.match(m[y]);return K==null?null:be((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,I(1))},function($e,e){var I,O,P=$e.exports={};function N(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function m(o){if(I===setTimeout)return setTimeout(o,0);if((I===N||!I)&&setTimeout)return I=setTimeout,setTimeout(o,0);try{return I(o,0)}catch{try{return I.call(null,o,0)}catch{return I.call(this,o,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:N}catch{I=N}try{O=typeof clearTimeout=="function"?clearTimeout:A}catch{O=A}})();var d,k=[],F=!1,E=-1;function u(){F&&d&&(F=!1,d.length?k=d.concat(k):E=-1,k.length&&b())}function b(){if(!F){var o=m(u);F=!0;for(var s=k.length;s;){for(d=k,k=[];++E<s;)d&&d[E].run();E=-1,s=k.length}d=null,F=!1,function(n){if(O===clearTimeout)return clearTimeout(n);if((O===A||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(n);try{O(n)}catch{try{return O.call(null,n)}catch{return O.call(this,n)}}}(o)}}function f(o,s){this.fun=o,this.array=s}function r(){}P.nextTick=function(o){var s=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)s[n-1]=arguments[n];k.push(new f(o,s)),k.length!==1||F||m(b)},f.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=r,P.addListener=r,P.once=r,P.off=r,P.removeListener=r,P.removeAllListeners=r,P.emit=r,P.prependListener=r,P.prependOnceListener=r,P.listeners=function(o){return[]},P.binding=function(o){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(o){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Ce[127],Pe([1,0,14,6]),function($e,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=P,e.$ge=N,e.$he=A,e.$ie=m,e.$je=k,e.$ke=F,e.$le=E,e.$me=u,e.$ne=b,e.$oe=f,e.$pe=r,e.$qe=o,e.$re=s,e.$se=n,e.$te=i;function P(a){const h=a;return h?typeof h.read=="function":!1}function N(a){const h=a;return h?[h.on,h.pause,h.resume,h.destroy].every(t=>typeof t=="function"):!1}function A(a){const h=a;return h?N(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}function m(a,h){return new d(a,h)}class d{constructor(h,t){this.e=h,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(t=>t(h))}h(h){this.c.error.length===0?(0,I.$1)(h):this.c.error.slice(0).forEach(t=>t(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,t){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(h,t){if(this.a.destroyed)return;let v;switch(h){case"data":v=this.c.data;break;case"end":v=this.c.end;break;case"error":v=this.c.error;break}if(v){const c=v.indexOf(t);c>=0&&v.splice(c,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(v=>v())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(a,h){const t=[];let v;for(;(v=a.read())!==null;)t.push(v);return h(t)}function F(a,h,t){const v=[];let c;for(;(c=a.read())!==null&&v.length<t;)v.push(c);return c===null&&v.length>0?h(v):{read:()=>{if(v.length>0)return v.shift();if(typeof c<"u"){const $=c;return c=void 0,$}return a.read()}}}function E(a,h){return new Promise((t,v)=>{const c=[];u(a,{onData:$=>{h&&c.push($)},onError:$=>{h?v($):t(void 0)},onEnd:()=>{t(h?h(c):void 0)}})})}function u(a,h,t){a.on("error",v=>{t?.isCancellationRequested||h.onError(v)}),a.on("end",()=>{t?.isCancellationRequested||h.onEnd()}),a.on("data",v=>{t?.isCancellationRequested||h.onData(v)})}function b(a,h){return new Promise((t,v)=>{const c=new O.$Tc,$=[],w=D=>{if($.push(D),$.length>h)return c.dispose(),a.pause(),t({stream:a,buffer:$,ended:!1})},p=D=>(c.dispose(),v(D)),l=()=>(c.dispose(),t({stream:a,buffer:$,ended:!0}));c.add((0,O.$Sc)(()=>a.removeListener("error",p))),a.on("error",p),c.add((0,O.$Sc)(()=>a.removeListener("end",l))),a.on("end",l),c.add((0,O.$Sc)(()=>a.removeListener("data",w))),a.on("data",w)})}function f(a,h){const t=m(h);return t.end(a),t}function r(){const a=m(()=>{throw new Error("not supported")});return a.end(),a}function o(a){let h=!1;return{read:()=>h?null:(h=!0,a)}}function s(a,h,t){const v=m(t);return u(a,{onData:c=>v.write(h.data(c)),onError:c=>v.error(h.error?h.error(c):c),onEnd:()=>v.end()}),v}function n(a,h,t){let v=!1;return{read:()=>{const c=h.read();return v?c:(v=!0,c!==null?t([a,c]):a)}}}function i(a,h,t){let v=!1;const c=m(t);return u(h,{onData:$=>v?c.write($):(v=!0,c.write(t([a,$]))),onError:$=>c.error($),onEnd:()=>{v||(v=!0,c.write(a)),c.end()}}),c}}),define(Ce[23],Pe([1,0,40,127]),function($e,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=void 0,e.$ve=k,e.$we=F,e.$xe=E,e.$ye=u,e.$ze=b,e.$Ae=f,e.$Be=r,e.$Ce=o,e.$De=s,e.$Ee=n,e.$Fe=i,e.$Ge=a,e.$He=h,e.$Ie=t,e.$Je=v,e.$Ke=c,e.$Le=$,e.$Me=w,e.$Ne=p,e.$Oe=g;const P=typeof Buffer<"u",N=new I.$V(()=>new Uint8Array(256));let A,m;class d{static alloc(y){return P?new d(Buffer.allocUnsafe(y)):new d(new Uint8Array(y))}static wrap(y){return P&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new d(y)}static fromString(y,C){return!(C?.dontUseNodeBuffer||!1)&&P?new d(Buffer.from(y)):(A||(A=new TextEncoder),new d(A.encode(y)))}static fromByteArray(y){const C=d.alloc(y.length);for(let R=0,V=y.length;R<V;R++)C.buffer[R]=y[R];return C}static concat(y,C){if(typeof C>"u"){C=0;for(let U=0,q=y.length;U<q;U++)C+=y[U].byteLength}const R=d.alloc(C);let V=0;for(let U=0,q=y.length;U<q;U++){const M=y[U];R.set(M,V),V+=M.byteLength}return R}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=d.alloc(this.byteLength);return y.set(this),y}toString(){return P?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(y,C){return new d(this.buffer.subarray(y,C))}set(y,C){if(y instanceof d)this.buffer.set(y.buffer,C);else if(y instanceof Uint8Array)this.buffer.set(y,C);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),C);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return u(this.buffer,y)}writeUInt32BE(y,C){b(this.buffer,y,C)}readUInt32LE(y){return f(this.buffer,y)}writeUInt32LE(y,C){r(this.buffer,y,C)}readUInt8(y){return o(this.buffer,y)}writeUInt8(y,C){s(this.buffer,y,C)}indexOf(y,C=0){return k(this.buffer,y instanceof d?y.buffer:y,C)}}e.$ue=d;function k(S,y,C=0){const R=y.byteLength,V=S.byteLength;if(R===0)return 0;if(R===1)return S.indexOf(y[0]);if(R>V-C)return-1;const U=N.value;U.fill(y.length);for(let G=0;G<y.length;G++)U[y[G]]=y.length-G-1;let q=C+y.length-1,M=q,L=-1;for(;q<V;)if(S[q]===y[M]){if(M===0){L=q;break}q--,M--}else q+=Math.max(y.length-M,U[S[q]]),M=y.length-1;return L}function F(S,y){return S[y+0]<<0>>>0|S[y+1]<<8>>>0}function E(S,y,C){S[C+0]=y&255,y=y>>>8,S[C+1]=y&255}function u(S,y){return S[y]*2**24+S[y+1]*2**16+S[y+2]*2**8+S[y+3]}function b(S,y,C){S[C+3]=y,y=y>>>8,S[C+2]=y,y=y>>>8,S[C+1]=y,y=y>>>8,S[C]=y}function f(S,y){return S[y+0]<<0>>>0|S[y+1]<<8>>>0|S[y+2]<<16>>>0|S[y+3]<<24>>>0}function r(S,y,C){S[C+0]=y&255,y=y>>>8,S[C+1]=y&255,y=y>>>8,S[C+2]=y&255,y=y>>>8,S[C+3]=y&255}function o(S,y){return S[y]}function s(S,y,C){S[C]=y}function n(S){return O.$je(S,y=>d.concat(y))}function i(S){return O.$qe(S)}function a(S){return O.$le(S,y=>d.concat(y))}async function h(S){return S.ended?d.concat(S.buffer):d.concat([...S.buffer,await a(S.stream)])}function t(S){return O.$oe(S,y=>d.concat(y))}function v(S){return O.$re(S,{data:y=>typeof y=="string"?d.fromString(y):d.wrap(y)},y=>d.concat(y))}function c(S){return O.$ie(y=>d.concat(y),S)}function $(S,y){return O.$se(S,y,C=>d.concat(C))}function w(S,y){return O.$te(S,y,C=>d.concat(C))}function p(S){let y=0,C=0,R=0;const V=new Uint8Array(Math.floor(S.length/4*3)),U=M=>{switch(C){case 3:V[R++]=y|M,C=0;break;case 2:V[R++]=y|M>>>2,y=M<<6,C=3;break;case 1:V[R++]=y|M>>>4,y=M<<4,C=2;break;default:y=M<<2,C=1}};for(let M=0;M<S.length;M++){const L=S.charCodeAt(M);if(L>=65&&L<=90)U(L-65);else if(L>=97&&L<=122)U(L-97+26);else if(L>=48&&L<=57)U(L-48+52);else if(L===43||L===45)U(62);else if(L===47||L===95)U(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${S[M]}`)}}const q=R;for(;C>0;)U(0);return d.wrap(V).slice(0,q)}const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function g({buffer:S},y=!0,C=!1){const R=C?D:l;let V="";const U=S.byteLength%3;let q=0;for(;q<S.byteLength-U;q+=3){const M=S[q+0],L=S[q+1],G=S[q+2];V+=R[M>>>2],V+=R[(M<<4|L>>>4)&63],V+=R[(L<<2|G>>>6)&63],V+=R[G&63]}if(U===1){const M=S[q+0];V+=R[M>>>2],V+=R[M<<4&63],y&&(V+="==")}else if(U===2){const M=S[q+0],L=S[q+1];V+=R[M>>>2],V+=R[(M<<4|L>>>4)&63],V+=R[L<<2&63],y&&(V+="=")}return V}}),define(Ce[128],Pe([1,0,28,124,15]),function($e,e,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.FuzzyScore=e.$kk=e.$jk=void 0,e.or=N,e.$lk=m,e.$mk=d,e.$nk=E,e.$ok=p,e.$pk=l,e.$qk=R,e.$rk=V,e.$sk=U,e.$tk=q,e.$uk=ee,e.$wk=ve,e.$xk=Y,e.$yk=ce;function N(...le){return function(Ie,Ae){for(let je=0,z=le.length;je<z;je++){const j=le[je](Ie,Ae);if(j)return j}return null}}e.$jk=A.bind(void 0,!1),e.$kk=A.bind(void 0,!0);function A(le,Ie,Ae){if(!Ae||Ae.length<Ie.length)return null;let je;return le?je=P.$mf(Ae,Ie):je=Ae.indexOf(Ie)===0,je?Ie.length>0?[{start:0,end:Ie.length}]:[]:null}function m(le,Ie){const Ae=Ie.toLowerCase().indexOf(le.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+le.length}]}function d(le,Ie){return k(le.toLowerCase(),Ie.toLowerCase(),0,0)}function k(le,Ie,Ae,je){if(Ae===le.length)return[];if(je===Ie.length)return null;if(le[Ae]===Ie[je]){let z=null;return(z=k(le,Ie,Ae+1,je+1))?a({start:je,end:je+1},z):null}return k(le,Ie,Ae,je+1)}function F(le){return 97<=le&&le<=122}function E(le){return 65<=le&&le<=90}function u(le){return 48<=le&&le<=57}function b(le){return le===32||le===9||le===10||le===13}const f=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(le=>f.add(le.charCodeAt(0)));function r(le){return b(le)||f.has(le)}function o(le,Ie){return le===Ie||r(le)&&r(Ie)}const s=new Map;function n(le){if(s.has(le))return s.get(le);let Ie;const Ae=(0,O.$hk)(le);return Ae&&(Ie=Ae),s.set(le,Ie),Ie}function i(le){return F(le)||E(le)||u(le)}function a(le,Ie){return Ie.length===0?Ie=[le]:le.end===Ie[0].start?Ie[0].start=le.start:Ie.unshift(le),Ie}function h(le,Ie){for(let Ae=Ie;Ae<le.length;Ae++){const je=le.charCodeAt(Ae);if(E(je)||u(je)||Ae>0&&!i(le.charCodeAt(Ae-1)))return Ae}return le.length}function t(le,Ie,Ae,je){if(Ae===le.length)return[];if(je===Ie.length)return null;if(le[Ae]!==Ie[je].toLowerCase())return null;{let z=null,j=je+1;for(z=t(le,Ie,Ae+1,je+1);!z&&(j=h(Ie,j))<Ie.length;)z=t(le,Ie,Ae+1,j),j++;return z===null?null:a({start:je,end:je+1},z)}}function v(le){let Ie=0,Ae=0,je=0,z=0,j=0;for(let Fe=0;Fe<le.length;Fe++)j=le.charCodeAt(Fe),E(j)&&Ie++,F(j)&&Ae++,i(j)&&je++,u(j)&&z++;const K=Ie/le.length,H=Ae/le.length,_=je/le.length,re=z/le.length;return{upperPercent:K,lowerPercent:H,alphaPercent:_,numericPercent:re}}function c(le){const{upperPercent:Ie,lowerPercent:Ae}=le;return Ae===0&&Ie>.6}function $(le){const{upperPercent:Ie,lowerPercent:Ae,alphaPercent:je,numericPercent:z}=le;return Ae>.2&&Ie<.8&&je>.6&&z<.2}function w(le){let Ie=0,Ae=0,je=0,z=0;for(let j=0;j<le.length;j++)je=le.charCodeAt(j),E(je)&&Ie++,F(je)&&Ae++,b(je)&&z++;return(Ie===0||Ae===0)&&z===0?le.length<=30:Ie<=5}function p(le,Ie){if(!Ie||(Ie=Ie.trim(),Ie.length===0)||!w(le))return null;Ie.length>60&&(Ie=Ie.substring(0,60));const Ae=v(Ie);if(!$(Ae)){if(!c(Ae))return null;Ie=Ie.toLowerCase()}let je=null,z=0;for(le=le.toLowerCase();z<Ie.length&&(je=t(le,Ie,0,z))===null;)z=h(Ie,z+1);return je}function l(le,Ie,Ae=!1){if(!Ie||Ie.length===0)return null;let je=null,z=0;for(le=le.toLowerCase(),Ie=Ie.toLowerCase();z<Ie.length&&(je=D(le,Ie,0,z,Ae),je===null);)z=g(Ie,z+1);return je}function D(le,Ie,Ae,je,z){let j=0;if(Ae===le.length)return[];if(je===Ie.length)return null;if(!o(le.charCodeAt(Ae),Ie.charCodeAt(je))){const _=n(le.charCodeAt(Ae));if(!_)return null;for(let re=0;re<_.length;re++)if(!o(_[re],Ie.charCodeAt(je+re)))return null;j+=_.length-1}let K=null,H=je+j+1;if(K=D(le,Ie,Ae+1,H,z),!z)for(;!K&&(H=g(Ie,H))<Ie.length;)K=D(le,Ie,Ae+1,H,z),H++;if(!K)return null;if(le.charCodeAt(Ae)!==Ie.charCodeAt(je)){const _=n(le.charCodeAt(Ae));if(!_)return K;for(let re=0;re<_.length;re++)if(_[re]!==Ie.charCodeAt(je+re))return K}return a({start:je,end:je+j+1},K)}function g(le,Ie){for(let Ae=Ie;Ae<le.length;Ae++)if(r(le.charCodeAt(Ae))||Ae>0&&r(le.charCodeAt(Ae-1)))return Ae;return le.length}const S=N(e.$kk,p,m),y=N(e.$kk,p,d),C=new I.$Ec(1e4);function R(le,Ie,Ae=!1){if(typeof le!="string"||typeof Ie!="string")return null;let je=C.get(le);je||(je=new RegExp(P.$7e(le),"i"),C.set(le,je));const z=je.exec(Ie);return z?[{start:z.index,end:z.index+z[0].length}]:Ae?y(le,Ie):S(le,Ie)}function V(le,Ie){const Ae=ve(le,le.toLowerCase(),0,Ie,Ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ae?q(Ae):null}function U(le,Ie,Ae,je,z,j){const K=Math.min(13,le.length);for(;Ae<K;Ae++){const H=ve(le,Ie,Ae,je,z,j,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(H)return H}return[0,j]}function q(le){if(typeof le>"u")return[];const Ie=[],Ae=le[1];for(let je=le.length-1;je>1;je--){const z=le[je]+Ae,j=Ie[Ie.length-1];j&&j.end===z?j.end=z+1:Ie.push({start:z,end:z+1})}return Ie}const M=128;function L(){const le=[],Ie=[];for(let Ae=0;Ae<=M;Ae++)Ie[Ae]=0;for(let Ae=0;Ae<=M;Ae++)le.push(Ie.slice(0));return le}function G(le){const Ie=[];for(let Ae=0;Ae<=le;Ae++)Ie[Ae]=0;return Ie}const ne=G(2*M),he=G(2*M),ye=L(),Re=L(),ge=L(),ue=!1;function te(le,Ie,Ae,je,z){function j(H,_,re=" "){for(;H.length<_;)H=re+H;return H}let K=` |   |${je.split("").map(H=>j(H,3)).join("|")}
`;for(let H=0;H<=Ae;H++)H===0?K+=" |":K+=`${Ie[H-1]}|`,K+=le[H].slice(0,z+1).map(_=>j(_.toString(),3)).join("|")+`
`;return K}function be(le,Ie,Ae,je){le=le.substr(Ie),Ae=Ae.substr(je),console.log(te(Re,le,le.length,Ae,Ae.length)),console.log(te(ge,le,le.length,Ae,Ae.length)),console.log(te(ye,le,le.length,Ae,Ae.length))}function oe(le,Ie){if(Ie<0||Ie>=le.length)return!1;const Ae=le.codePointAt(Ie);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!P.$Ef(Ae)}}function de(le,Ie){if(Ie<0||Ie>=le.length)return!1;switch(le.charCodeAt(Ie)){case 32:case 9:return!0;default:return!1}}function W(le,Ie,Ae){return Ie[le]!==Ae[le]}function ee(le,Ie,Ae,je,z,j,K=!1){for(;Ie<Ae&&z<j;)le[Ie]===je[z]&&(K&&(ne[Ie]=z),Ie+=1),z+=1;return Ie===Ae}var ke;(function(le){le[le.Diag=1]="Diag",le[le.Left=2]="Left",le[le.LeftLeft=3]="LeftLeft"})(ke||(ke={}));var Te;(function(le){le.Default=[-100,0];function Ie(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}le.isDefault=Ie})(Te||(e.FuzzyScore=Te={}));class Se{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ie,Ae){this.firstMatchCanBeWeak=Ie,this.boostFullMatch=Ae}}e.$vk=Se;function ve(le,Ie,Ae,je,z,j,K=Se.default){const H=le.length>M?M:le.length,_=je.length>M?M:je.length;if(Ae>=H||j>=_||H-Ae>_-j||!ee(Ie,Ae,H,z,j,_,!0))return;me(H,_,Ae,j,Ie,z);let re=1,Fe=1,Ve=Ae,Qe=j;const xe=[!1];for(re=1,Ve=Ae;Ve<H;re++,Ve++){const ct=ne[Ve],ft=he[Ve],Ue=Ve+1<H?he[Ve+1]:_;for(Fe=ct-j+1,Qe=ct;Qe<Ue;Fe++,Qe++){let ot=Number.MIN_SAFE_INTEGER,X=!1;Qe<=ft&&(ot=J(le,Ie,Ve,Ae,je,z,Qe,_,j,ye[re-1][Fe-1]===0,xe));let Z=0;ot!==Number.MAX_SAFE_INTEGER&&(X=!0,Z=ot+Re[re-1][Fe-1]);const pe=Qe>ct,qe=pe?Re[re][Fe-1]+(ye[re][Fe-1]>0?-5:0):0,Ze=Qe>ct+1&&ye[re][Fe-1]>0,Me=Ze?Re[re][Fe-2]+(ye[re][Fe-2]>0?-5:0):0;if(Ze&&(!pe||Me>=qe)&&(!X||Me>=Z))Re[re][Fe]=Me,ge[re][Fe]=3,ye[re][Fe]=0;else if(pe&&(!X||qe>=Z))Re[re][Fe]=qe,ge[re][Fe]=2,ye[re][Fe]=0;else if(X)Re[re][Fe]=Z,ge[re][Fe]=1,ye[re][Fe]=ye[re-1][Fe-1]+1;else throw new Error("not possible")}}if(ue&&be(le,Ae,je,j),!xe[0]&&!K.firstMatchCanBeWeak)return;re--,Fe--;const tt=[Re[re][Fe],j];let at=0,it=0;for(;re>=1;){let ct=Fe;do{const ft=ge[re][ct];if(ft===3)ct=ct-2;else if(ft===2)ct=ct-1;else break}while(ct>=1);at>1&&Ie[Ae+re-1]===z[j+Fe-1]&&!W(ct+j-1,je,z)&&at+1>ye[re][ct]&&(ct=Fe),ct===Fe?at++:at=1,it||(it=ct),re--,Fe=ct-1,tt.push(Fe)}_===H&&K.boostFullMatch&&(tt[0]+=2);const nt=it-H;return tt[0]-=nt,tt}function me(le,Ie,Ae,je,z,j){let K=le-1,H=Ie-1;for(;K>=Ae&&H>=je;)z[K]===j[H]&&(he[K]=H,K--),H--}function J(le,Ie,Ae,je,z,j,K,H,_,re,Fe){if(Ie[Ae]!==j[K])return Number.MIN_SAFE_INTEGER;let Ve=1,Qe=!1;return K===Ae-je?Ve=le[Ae]===z[K]?7:5:W(K,z,j)&&(K===0||!W(K-1,z,j))?(Ve=le[Ae]===z[K]?7:5,Qe=!0):oe(j,K)&&(K===0||!oe(j,K-1))?Ve=5:(oe(j,K-1)||de(j,K-1))&&(Ve=5,Qe=!0),Ve>1&&Ae===je&&(Fe[0]=!0),Qe||(Qe=W(K,z,j)||oe(j,K-1)||de(j,K-1)),Ae===je?K>_&&(Ve-=Qe?3:5):re?Ve+=Qe?2:0:Ve+=Qe?0:1,K+1===H&&(Ve-=Qe?3:5),Ve}function Y(le,Ie,Ae,je,z,j,K){return fe(le,Ie,Ae,je,z,j,!0,K)}function ce(le,Ie,Ae,je,z,j,K){return fe(le,Ie,Ae,je,z,j,!1,K)}function fe(le,Ie,Ae,je,z,j,K,H){let _=ve(le,Ie,Ae,je,z,j,H);if(_&&!K)return _;if(le.length>=3){const re=Math.min(7,le.length-1);for(let Fe=Ae+1;Fe<re;Fe++){const Ve=Ne(le,Fe);if(Ve){const Qe=ve(Ve,Ve.toLowerCase(),Ae,je,z,j,H);Qe&&(Qe[0]-=3,(!_||Qe[0]>_[0])&&(_=Qe))}}}return _}function Ne(le,Ie){if(Ie+1>=le.length)return;const Ae=le[Ie],je=le[Ie+1];if(Ae!==je)return le.slice(0,Ie)+je+Ae+le.slice(Ie+2)}}),define(Ce[32],Pe([1,0,15]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(O||(O={})),function(P){const N="error",A="warning",m="warn",d="info",k="ignore";function F(u){return u?I.$lf(N,u)?P.Error:I.$lf(A,u)||I.$lf(m,u)?P.Warning:I.$lf(d,u)?P.Info:P.Ignore:P.Ignore}P.fromValue=F;function E(u){switch(u){case P.Error:return N;case P.Warning:return A;case P.Info:return d;default:return k}}P.toString=E}(O||(O={})),e.default=O}),define(Ce[129],Pe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=void 0,e.$4d=Symbol("MicrotaskDelay")}),define(Ce[51],Pe([1,0,18,15]),function($e,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.$ki=void 0;class P{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const f=b.charCodeAt(0),r=this.b.charCodeAt(this.c);return f-r}value(){return this.b[this.c]}}e.$ki=P;class N{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,O.$ff)(b,this.b,0,b.length,this.c,this.d):(0,O.$hf)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$li=N;class A{constructor(b=!0,f=!0){this.f=b,this.g=f}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let f=b.length-1;f>=0;f--,this.c--){const r=this.b.charCodeAt(f);if(!(r===47||this.f&&r===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,O.$ff)(b,this.b,0,b.length,this.d,this.e):(0,O.$hf)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$mi=A;var m;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(m||(m={}));class d{constructor(b,f){this.f=b,this.g=f,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,O.$gf)(b,this.c.scheme);if(this.d[this.e]===2)return(0,O.$gf)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,O.$ef)(b,this.c.query);if(this.d[this.e]===5)return(0,O.$ef)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ni=d;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var F;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(F||(F={}));class E{static forUris(b=()=>!1,f=()=>!1){return new E(new d(b,f))}static forPaths(b=!1){return new E(new A(void 0,!b))}static forStrings(){return new E(new P)}static forConfigKeys(){return new E(new N)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,f){if(f){const r=f.slice(0);(0,I.$Xb)(r);for(const o of r)this.set(o,b)}else{const r=b.slice(0);(0,I.$Xb)(r);for(const o of r)this.set(o[0],o[1])}}set(b,f){const r=this.b.reset(b);let o;this.c||(this.c=new k,this.c.segment=r.value());const s=[];for(o=this.c;;){const i=r.cmp(o.segment);if(i>0)o.left||(o.left=new k,o.left.segment=r.value()),s.push([-1,o]),o=o.left;else if(i<0)o.right||(o.right=new k,o.right.segment=r.value()),s.push([1,o]),o=o.right;else if(r.hasNext())r.next(),o.mid||(o.mid=new k,o.mid.segment=r.value()),s.push([0,o]),o=o.mid;else break}const n=o.value;o.value=f,o.key=b;for(let i=s.length-1;i>=0;i--){const a=s[i][1];a.updateHeight();const h=a.balanceFactor();if(h<-1||h>1){const t=s[i][0],v=s[i+1][0];if(t===1&&v===1)s[i][1]=a.rotateLeft();else if(t===-1&&v===-1)s[i][1]=a.rotateRight();else if(t===1&&v===-1)a.right=s[i+1][1]=s[i+1][1].rotateRight(),s[i][1]=a.rotateLeft();else if(t===-1&&v===1)a.left=s[i+1][1]=s[i+1][1].rotateLeft(),s[i][1]=a.rotateRight();else throw new Error;if(i>0)switch(s[i-1][0]){case-1:s[i-1][1].left=s[i][1];break;case 1:s[i-1][1].right=s[i][1];break;case 0:s[i-1][1].mid=s[i][1];break}else this.c=s[0][1]}}return n}get(b){return this.d(b)?.value}d(b){const f=this.b.reset(b);let r=this.c;for(;r;){const o=f.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(f.hasNext())f.next(),r=r.mid;else break}return r}has(b){const f=this.d(b);return!(f?.value===void 0&&f?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,f){const r=this.b.reset(b),o=[];let s=this.c;for(;s;){const n=r.cmp(s.segment);if(n>0)o.push([-1,s]),s=s.left;else if(n<0)o.push([1,s]),s=s.right;else if(r.hasNext())r.next(),o.push([0,s]),s=s.mid;else break}if(s){if(f?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const n=this.f(s.right);if(n.key){const{key:i,value:a,segment:h}=n;this.e(n.key,!1),s.key=i,s.value=a,s.segment=h}}else{const n=s.left??s.right;if(o.length>0){const[i,a]=o[o.length-1];switch(i){case-1:a.left=n;break;case 0:a.mid=n;break;case 1:a.right=n;break}}else this.c=n}for(let n=o.length-1;n>=0;n--){const i=o[n][1];i.updateHeight();const a=i.balanceFactor();if(a>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),o[n][1]=i.rotateLeft()):a<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),o[n][1]=i.rotateRight()),n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this.c=o[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const f=this.b.reset(b);let r=this.c,o;for(;r;){const s=f.cmp(r.segment);if(s>0)r=r.left;else if(s<0)r=r.right;else if(f.hasNext())f.next(),o=r.value||o,r=r.mid;else break}return r&&r.value||o}findSuperstr(b){return this.g(b,!1)}g(b,f){const r=this.b.reset(b);let o=this.c;for(;o;){const s=r.cmp(o.segment);if(s>0)o=o.left;else if(s<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else return o.mid?this.h(o.mid):f?o.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[f,r]of this)b(r,f)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const f=[];return this.j(b,f),f[Symbol.iterator]()}j(b,f){b&&(b.left&&this.j(b.left,f),b.value&&f.push([b.key,b.value]),b.mid&&this.j(b.mid,f),b.right&&this.j(b.right,f))}_isBalanced(){const b=f=>{if(!f)return!0;const r=f.balanceFactor();return r<-1||r>1?!1:b(f.left)&&b(f.right)};return b(this.c)}}e.$oi=E}),define(Ce[41],Pe([1,0,91]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Ij=P;var O;(function(A){function m(d){return d&&typeof d=="object"&&typeof d.id=="string"}A.isThemeColor=m})(O||(e.ThemeColor=O={}));function P(A){return{id:A}}var N;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function d(n){const i=m.exec(n.id);if(!i)return d(I.$Hj.error);const[,a,h]=i,t=["codicon","codicon-"+a];return h&&t.push("codicon-modifier-"+h.substring(1)),t}A.asClassNameArray=d;function k(n){return d(n).join(" ")}A.asClassName=k;function F(n){return"."+d(n).join(".")}A.asCSSSelector=F;function E(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||O.isThemeColor(n.color))}A.isThemeIcon=E;const u=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function b(n){const i=u.exec(n);if(!i)return;const[,a]=i;return{id:a}}A.fromString=b;function f(n){return{id:n}}A.fromId=f;function r(n,i){let a=n.id;const h=a.lastIndexOf("~");return h!==-1&&(a=a.substring(0,h)),i&&(a=`${a}~${i}`),{id:a}}A.modify=r;function o(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}A.getModifier=o;function s(n,i){return n.id===i.id&&n.color?.id===i.color?.id}A.isEqual=s})(N||(e.ThemeIcon=N={}))}),define(Ce[130],Pe([1,0,128,15,41]),function($e,e,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=d,e.$Ak=F,e.$Bk=u,e.$Ck=b,e.$Dk=r,e.$Ek=o;const N="$(",A=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${A.source}`,"g");function d(s){return s.replace(m,(n,i)=>i?n:`\\${n}`)}const k=new RegExp(`\\\\${A.source}`,"g");function F(s){return s.replace(k,n=>`\\${n}`)}const E=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function u(s){return s.indexOf(N)===-1?s:s.replace(E,(n,i,a,h)=>a?n:i||h||"")}function b(s){return s?s.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const f=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(s){f.lastIndex=0;let n="";const i=[];let a=0;for(;;){const h=f.lastIndex,t=f.exec(s),v=s.substring(h,t?.index);if(v.length>0){n+=v;for(let c=0;c<v.length;c++)i.push(a)}if(!t)break;a+=t[0].length}return{text:n,iconOffsets:i}}function o(s,n,i=!1){const{text:a,iconOffsets:h}=n;if(!h||h.length===0)return(0,I.$qk)(s,a,i);const t=(0,O.$5e)(a," "),v=a.length-t.length,c=(0,I.$qk)(s,t,i);if(c)for(const $ of c){const w=h[$.start+v]+v;$.start+=w,$.end+=w}return c}}),define(Ce[34],Pe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=void 0,e.$Dg=O;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(P){return I.test(P)}e.$Eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(m){for(let d=0;d<m.length;d++)m[d]=Math.floor(Math.random()*256);return m};const N=new Uint8Array(16),A=[];for(let m=0;m<256;m++)A.push(m.toString(16).padStart(2,"0"));return function(){P(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let d=0,k="";return k+=A[N[d++]],k+=A[N[d++]],k+=A[N[d++]],k+=A[N[d++]],k+="-",k+=A[N[d++]],k+=A[N[d++]],k+="-",k+=A[N[d++]],k+=A[N[d++]],k+="-",k+=A[N[d++]],k+=A[N[d++]],k+="-",k+=A[N[d++]],k+=A[N[d++]],k+=A[N[d++]],k+=A[N[d++]],k+=A[N[d++]],k+=A[N[d++]],k}}()}),define(Ce[131],Pe([1,0,18,39,34]),function($e,e,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lt=e.$Jt=void 0,e.$Ht=N,e.$It=A,e.$Kt=k;function N(E){return{asString:async()=>E,asFile:()=>{},value:typeof E=="string"?E:void 0}}function A(E,u,b){const f={id:(0,P.$Eg)(),name:E,uri:u,data:b};return{asString:async()=>"",asFile:()=>f,value:void 0}}class m{constructor(){this.a=new Map}get size(){let u=0;for(const b of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const b=[...this.a.keys()];return O.Iterable.some(this,([f,r])=>r.asFile())&&b.push("files"),F(d(u),b)}get(u){return this.a.get(this.b(u))?.[0]}append(u,b){const f=this.a.get(u);f?f.push(b):this.a.set(this.b(u),[b])}replace(u,b){this.a.set(this.b(u),[b])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,b]of this.a)for(const f of b)yield[u,f]}b(u){return d(u)}}e.$Jt=m;function d(E){return E.toLowerCase()}function k(E,u){return F(d(E),u.map(d))}function F(E,u){if(E==="*/*")return u.length>0;if(u.includes(E))return!0;const b=E.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!b)return!1;const[f,r,o]=b;return o==="*"?u.some(s=>s.startsWith(r+"/")):!1}e.$Lt=Object.freeze({create:E=>(0,I.$Mb)(E.map(u=>u.toString())).join(`\r
`),split:E=>E.split(`\r
`),parse:E=>e.$Lt.split(E).filter(u=>!u.startsWith("#"))})}),define(Ce[132],Pe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Ot=O;var I;(function(P){P[P.Unknown=0]="Unknown",P[P.Invalid=3]="Invalid",P[P.LF=1]="LF",P[P.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function O(P){let N=0,A=0,m=0,d=0;for(let k=0,F=P.length;k<F;k++){const E=P.charCodeAt(k);E===13?(N===0&&(A=k),N++,k+1<F&&P.charCodeAt(k+1)===10?(d|=2,k++):d|=3,m=k+1):E===10&&(d|=1,N===0&&(A=k),N++,m=k+1)}return N===0&&(A=P.length),[N,A,P.length-m,d]}}),define(Ce[133],Pe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ms=void 0,e.$Ms={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[134],Pe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cu=e.$bu=e.IndentAction=void 0;var I;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class O{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let d=0,k=m.notIn.length;d<k;d++)switch(m.notIn[d]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,d){if(m.getTokenCount()===0)return!0;const k=m.findTokenIndexAtOffset(d-2),F=m.getStandardTokenType(k);return this.isOK(F)}g(m,d){for(let k=m;k<=d;k++){const F=String.fromCharCode(k);if(!this.open.includes(F)&&!this.close.includes(F))return F}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$bu=O;class P{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const d of m)N(this.autoClosingPairsOpenByStart,d.open.charAt(0),d),N(this.autoClosingPairsOpenByEnd,d.open.charAt(d.open.length-1),d),N(this.autoClosingPairsCloseByStart,d.close.charAt(0),d),N(this.autoClosingPairsCloseByEnd,d.close.charAt(d.close.length-1),d),d.close.length===1&&d.open.length===1&&N(this.autoClosingPairsCloseSingleChar,d.close,d)}}e.$cu=P;function N(A,m,d){A.has(m)?A.get(m).push(d):A.set(m,[d])}}),define(Ce[135],Pe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fC=e.NodeColor=e.$eC=void 0,e.$gC=P,e.$hC=N,e.$iC=k,e.$jC=F,e.$kC=E,e.$lC=u,e.$mC=b,e.$nC=f;class I{constructor(o,s){this.piece=o,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$fC)return P(this.right);let o=this;for(;o.parent!==e.$fC&&o.parent.left!==o;)o=o.parent;return o.parent===e.$fC?e.$fC:o.parent}prev(){if(this.left!==e.$fC)return N(this.left);let o=this;for(;o.parent!==e.$fC&&o.parent.right!==o;)o=o.parent;return o.parent===e.$fC?e.$fC:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$eC=I;var O;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(O||(e.NodeColor=O={})),e.$fC=new I(null,0),e.$fC.parent=e.$fC,e.$fC.left=e.$fC,e.$fC.right=e.$fC,e.$fC.color=0;function P(r){for(;r.left!==e.$fC;)r=r.left;return r}function N(r){for(;r.right!==e.$fC;)r=r.right;return r}function A(r){return r===e.$fC?0:r.size_left+r.piece.length+A(r.right)}function m(r){return r===e.$fC?0:r.lf_left+r.piece.lineFeedCnt+m(r.right)}function d(){e.$fC.parent=e.$fC}function k(r,o){const s=o.right;s.size_left+=o.size_left+(o.piece?o.piece.length:0),s.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=s.left,s.left!==e.$fC&&(s.left.parent=o),s.parent=o.parent,o.parent===e.$fC?r.root=s:o.parent.left===o?o.parent.left=s:o.parent.right=s,s.left=o,o.parent=s}function F(r,o){const s=o.left;o.left=s.right,s.right!==e.$fC&&(s.right.parent=o),s.parent=o.parent,o.size_left-=s.size_left+(s.piece?s.piece.length:0),o.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),o.parent===e.$fC?r.root=s:o===o.parent.right?o.parent.right=s:o.parent.left=s,s.right=o,o.parent=s}function E(r,o){let s,n;if(o.left===e.$fC?(n=o,s=n.right):o.right===e.$fC?(n=o,s=n.left):(n=P(o.right),s=n.right),n===r.root){r.root=s,s.color=0,o.detach(),d(),r.root.parent=e.$fC;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=s:n.parent.right=s,n===o?(s.parent=n.parent,f(r,s)):(n.parent===o?s.parent=n:s.parent=n.parent,f(r,s),n.left=o.left,n.right=o.right,n.parent=o.parent,n.color=o.color,o===r.root?r.root=n:o===o.parent.left?o.parent.left=n:o.parent.right=n,n.left!==e.$fC&&(n.left.parent=n),n.right!==e.$fC&&(n.right.parent=n),n.size_left=o.size_left,n.lf_left=o.lf_left,f(r,n)),o.detach(),s.parent.left===s){const h=A(s),t=m(s);if(h!==s.parent.size_left||t!==s.parent.lf_left){const v=h-s.parent.size_left,c=t-s.parent.lf_left;s.parent.size_left=h,s.parent.lf_left=t,b(r,s.parent,v,c)}}if(f(r,s.parent),i){d();return}let a;for(;s!==r.root&&s.color===0;)s===s.parent.left?(a=s.parent.right,a.color===1&&(a.color=0,s.parent.color=1,k(r,s.parent),a=s.parent.right),a.left.color===0&&a.right.color===0?(a.color=1,s=s.parent):(a.right.color===0&&(a.left.color=0,a.color=1,F(r,a),a=s.parent.right),a.color=s.parent.color,s.parent.color=0,a.right.color=0,k(r,s.parent),s=r.root)):(a=s.parent.left,a.color===1&&(a.color=0,s.parent.color=1,F(r,s.parent),a=s.parent.left),a.left.color===0&&a.right.color===0?(a.color=1,s=s.parent):(a.left.color===0&&(a.right.color=0,a.color=1,k(r,a),a=s.parent.left),a.color=s.parent.color,s.parent.color=0,a.left.color=0,F(r,s.parent),s=r.root));s.color=0,d()}function u(r,o){for(f(r,o);o!==r.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const s=o.parent.parent.right;s.color===1?(o.parent.color=0,s.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,k(r,o)),o.parent.color=0,o.parent.parent.color=1,F(r,o.parent.parent))}else{const s=o.parent.parent.left;s.color===1?(o.parent.color=0,s.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,F(r,o)),o.parent.color=0,o.parent.parent.color=1,k(r,o.parent.parent))}r.root.color=0}function b(r,o,s,n){for(;o!==r.root&&o!==e.$fC;)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=n),o=o.parent}function f(r,o){let s=0,n=0;if(o!==r.root){for(;o!==r.root&&o===o.parent.right;)o=o.parent;if(o!==r.root)for(o=o.parent,s=A(o.left)-o.size_left,n=m(o.left)-o.lf_left,o.size_left+=s,o.lf_left+=n;o!==r.root&&(s!==0||n!==0);)o.parent.left===o&&(o.parent.size_left+=s,o.parent.lf_left+=n),o=o.parent}}}),define(Ce[92],Pe([1,0,93,29,94,135,95]),function($e,e,I,O,P,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yC=e.$xC=e.$wC=void 0,e.$uC=F,e.$vC=E;const m=65535;function d(s){let n;return s[s.length-1]<65536?n=new Uint16Array(s.length):n=new Uint32Array(s.length),n.set(s,0),n}class k{constructor(n,i,a,h,t){this.lineStarts=n,this.cr=i,this.lf=a,this.crlf=h,this.isBasicASCII=t}}function F(s,n=!0){const i=[0];let a=1;for(let h=0,t=s.length;h<t;h++){const v=s.charCodeAt(h);v===13?h+1<t&&s.charCodeAt(h+1)===10?(i[a++]=h+2,h++):i[a++]=h+1:v===10&&(i[a++]=h+1)}return n?d(i):i}function E(s,n){s.length=0,s[0]=0;let i=1,a=0,h=0,t=0,v=!0;for(let $=0,w=n.length;$<w;$++){const p=n.charCodeAt($);p===13?$+1<w&&n.charCodeAt($+1)===10?(t++,s[i++]=$+2,$++):(a++,s[i++]=$+1):p===10?(h++,s[i++]=$+1):v&&p!==9&&(p<32||p>126)&&(v=!1)}const c=new k(d(s),a,h,t,v);return s.length=0,c}class u{constructor(n,i,a,h,t){this.bufferIndex=n,this.start=i,this.end=a,this.lineFeedCnt=h,this.length=t}}e.$wC=u;class b{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.$xC=b;class f{constructor(n,i){this.a=[],this.c=n,this.d=i,this.b=0,n.root!==N.$fC&&n.iterate(n.root,a=>(a!==N.$fC&&this.a.push(a.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class r{constructor(n){this.a=n,this.b=[]}get(n){for(let i=this.b.length-1;i>=0;i--){const a=this.b[i];if(a.nodeStartOffset<=n&&a.nodeStartOffset+a.node.piece.length>=n)return a}return null}get2(n){for(let i=this.b.length-1;i>=0;i--){const a=this.b[i];if(a.nodeStartLineNumber&&a.nodeStartLineNumber<n&&a.nodeStartLineNumber+a.node.piece.lineFeedCnt>=n)return a}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let i=!1;const a=this.b;for(let h=0;h<a.length;h++){const t=a[h];if(t.node.parent===null||t.nodeStartOffset>=n){a[h]=null,i=!0;continue}}if(i){const h=[];for(const t of a)t!==null&&h.push(t);this.b=h}}}class o{constructor(n,i,a){this.create(n,i,a)}create(n,i,a){this.a=[new b("",[0])],this.g={line:0,column:0},this.root=N.$fC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=a;let h=null;for(let t=0,v=n.length;t<v;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=F(n[t].buffer));const c=new u(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),h=this.S(h,c)}this.h=new r(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const i=m,a=i-Math.floor(i/3),h=a*2;let t="",v=0;const c=[];if(this.iterate(this.root,$=>{const w=this.R($),p=w.length;if(v<=a||v+p<h)return t+=w,v+=p,!0;const l=t.replace(/\r\n|\r|\n/g,n);return c.push(new b(l,F(l))),t=w,v=p,!0}),v>0){const $=t.replace(/\r\n|\r|\n/g,n);c.push(new b($,F($)))}this.create(c,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new f(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,h=>{if(h===N.$fC)return!0;const t=this.R(h),v=t.length,c=n.G(i),$=n.G(i+v),w=n.getValueInRange2(c,$);return i+=v,t===w})}getOffsetAt(n,i){let a=0,h=this.root;for(;h!==N.$fC;)if(h.left!==N.$fC&&h.lf_left+1>=n)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=n){a+=h.size_left;const t=this.B(h,n-h.lf_left-2);return a+=t+i-1}else n-=h.lf_left+h.piece.lineFeedCnt,a+=h.size_left+h.piece.length,h=h.right;return a}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,a=0;const h=n;for(;i!==N.$fC;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.A(i,n-i.size_left);if(a+=i.lf_left+t.index,t.index===0){const v=this.getOffsetAt(a+1,1),c=h-v;return new I.$bt(a+1,c+1)}return new I.$bt(a+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,a+=i.lf_left+i.piece.lineFeedCnt,i.right===N.$fC){const t=this.getOffsetAt(a+1,1),v=h-n-t;return new I.$bt(a+1,v+1)}else i=i.right;return new I.$bt(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const a=this.H(n.startLineNumber,n.startColumn),h=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(a,h);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const c=n.node,$=this.a[c.piece.bufferIndex].buffer,w=this.u(c.piece.bufferIndex,c.piece.start);return $.substring(w+n.remainder,w+i.remainder)}let a=n.node;const h=this.a[a.piece.bufferIndex].buffer,t=this.u(a.piece.bufferIndex,a.piece.start);let v=h.substring(t+n.remainder,t+a.piece.length);for(a=a.next();a!==N.$fC;){const c=this.a[a.piece.bufferIndex].buffer,$=this.u(a.piece.bufferIndex,a.piece.start);if(a===i.node){v+=c.substring($,$+i.remainder);break}else v+=c.substr($,a.piece.length);a=a.next()}return v}getLinesContent(){const n=[];let i=0,a="",h=!1;return this.iterate(this.root,t=>{if(t===N.$fC)return!0;const v=t.piece;let c=v.length;if(c===0)return!0;const $=this.a[v.bufferIndex].buffer,w=this.a[v.bufferIndex].lineStarts,p=v.start.line,l=v.end.line;let D=w[p]+v.start.column;if(h&&($.charCodeAt(D)===10&&(D++,c--),n[i++]=a,a="",h=!1,c===0))return!0;if(p===l)return!this.f&&$.charCodeAt(D+c-1)===13?(h=!0,a+=$.substr(D,c-1)):a+=$.substr(D,c),!0;a+=this.f?$.substring(D,Math.max(D,w[p+1]-this.e)):$.substring(D,w[p+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=a;for(let g=p+1;g<l;g++)a=this.f?$.substring(w[g],w[g+1]-this.e):$.substring(w[g],w[g+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=a;return!this.f&&$.charCodeAt(w[l]+v.end.column-1)===13?(h=!0,v.end.column===0?i--:a=$.substr(w[l],v.end.column-1)):a=$.substr(w[l],v.end.column),!0}),h&&(n[i++]=a,a=""),n[i++]=a,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const a=this.a[i.piece.bufferIndex],h=this.u(i.piece.bufferIndex,i.piece.start);return a.buffer.charCodeAt(h)}else{const i=this.a[n.node.piece.bufferIndex],h=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(h)}}getLineCharCode(n,i){const a=this.H(n,i+1);return this.l(a)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const i=this.G(n);return this.l(i)}findMatchesInNode(n,i,a,h,t,v,c,$,w,p,l){const D=this.a[n.piece.bufferIndex],g=this.u(n.piece.bufferIndex,n.piece.start),S=this.u(n.piece.bufferIndex,t),y=this.u(n.piece.bufferIndex,v);let C;const R={line:0,column:0};let V,U;i._wordSeparators?(V=D.buffer.substring(S,y),U=q=>q+S,i.reset(0)):(V=D.buffer,U=q=>q,i.reset(S));do if(C=i.next(V),C){if(U(C.index)>=y)return p;this.s(n,U(C.index)-g,R);const q=this.t(n.piece.bufferIndex,t,R),M=R.line===t.line?R.column-t.column+h:R.column+1,L=M+C[0].length;if(l[p++]=(0,A.$qC)(new O.$ct(a+q,M,a+q,L),C,$),U(C.index)+C[0].length>=y||p>=w)return p}while(C);return p}findMatchesLineByLine(n,i,a,h){const t=[];let v=0;const c=new A.$tC(i.wordSeparators,i.regex);let $=this.H(n.startLineNumber,n.startColumn);if($===null)return[];const w=this.H(n.endLineNumber,n.endColumn);if(w===null)return[];let p=this.s($.node,$.remainder);const l=this.s(w.node,w.remainder);if($.node===w.node)return this.findMatchesInNode($.node,c,n.startLineNumber,n.startColumn,p,l,i,a,h,v,t),t;let D=n.startLineNumber,g=$.node;for(;g!==w.node;){const y=this.t(g.piece.bufferIndex,p,g.piece.end);if(y>=1){const R=this.a[g.piece.bufferIndex].lineStarts,V=this.u(g.piece.bufferIndex,g.piece.start),U=R[p.line+y],q=D===n.startLineNumber?n.startColumn:1;if(v=this.findMatchesInNode(g,c,D,q,p,this.s(g,U-V),i,a,h,v,t),v>=h)return t;D+=y}const C=D===n.startLineNumber?n.startColumn-1:0;if(D===n.endLineNumber){const R=this.getLineContent(D).substring(C,n.endColumn-1);return v=this.n(i,c,R,n.endLineNumber,C,v,t,a,h),t}if(v=this.n(i,c,this.getLineContent(D).substr(C),D,C,v,t,a,h),v>=h)return t;D++,$=this.H(D,1),g=$.node,p=this.s($.node,$.remainder)}if(D===n.endLineNumber){const y=D===n.startLineNumber?n.startColumn-1:0,C=this.getLineContent(D).substring(y,n.endColumn-1);return v=this.n(i,c,C,n.endLineNumber,y,v,t,a,h),t}const S=D===n.startLineNumber?n.startColumn:1;return v=this.findMatchesInNode(w.node,c,D,S,p,l,i,a,h,v,t),t}n(n,i,a,h,t,v,c,$,w){const p=n.wordSeparators;if(!$&&n.simpleSearch){const D=n.simpleSearch,g=D.length,S=a.length;let y=-g;for(;(y=a.indexOf(D,y+g))!==-1;)if((!p||(0,A.$sC)(p,a,S,y,g))&&(c[v++]=new P.$wv(new O.$ct(h,y+1+t,h,y+1+g+t),null),v>=w))return v;return v}let l;i.reset(0);do if(l=i.next(a),l&&(c[v++]=(0,A.$qC)(new O.$ct(h,l.index+1+t,h,l.index+1+l[0].length+t),l,$),v>=w))return v;while(l);return v}insert(n,i,a=!1){if(this.f=this.f&&a,this.j.lineNumber=0,this.j.value="",this.root!==N.$fC){const{node:h,remainder:t,nodeStartOffset:v}=this.G(n),c=h.piece,$=c.bufferIndex,w=this.s(h,t);if(h.piece.bufferIndex===0&&c.end.line===this.g.line&&c.end.column===this.g.column&&v+c.length===n&&i.length<m){this.F(h,i),this.y();return}if(v===n)this.o(i,h),this.h.validate(n);else if(v+h.piece.length>n){const p=[];let l=new u(c.bufferIndex,w,c.end,this.t(c.bufferIndex,w,c.end),this.u($,c.end)-this.u($,w));if(this.K()&&this.M(i)&&this.I(h,t)===10){const y={line:l.start.line+1,column:0};l=new u(l.bufferIndex,y,l.end,this.t(l.bufferIndex,y,l.end),l.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(h,t-1)===13){const y=this.s(h,t-1);this.C(h,y),i="\r"+i,h.piece.length===0&&p.push(h)}else this.C(h,w);else this.C(h,w);const D=this.w(i);l.length>0&&this.S(h,l);let g=h;for(let S=0;S<D.length;S++)g=this.S(g,D[S]);this.v(p)}else this.q(i,h)}else{const h=this.w(i);let t=this.T(null,h[0]);for(let v=1;v<h.length;v++)t=this.S(t,h[v])}this.y()}delete(n,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===N.$fC)return;const a=this.G(n),h=this.G(n+i),t=a.node,v=h.node;if(t===v){const D=this.s(t,a.remainder),g=this.s(t,h.remainder);if(a.nodeStartOffset===n){if(i===t.piece.length){const S=t.next();(0,N.$kC)(this,t),this.N(S),this.y();return}this.D(t,g),this.h.validate(n),this.N(t),this.y();return}if(a.nodeStartOffset+t.piece.length===n+i){this.C(t,D),this.O(t),this.y();return}this.E(t,D,g),this.y();return}const c=[],$=this.s(t,a.remainder);this.C(t,$),this.h.validate(n),t.piece.length===0&&c.push(t);const w=this.s(v,h.remainder);this.D(v,w),v.piece.length===0&&c.push(v);const p=t.next();for(let D=p;D!==N.$fC&&D!==v;D=D.next())c.push(D);const l=t.piece.length===0?t.prev():t;this.v(c),this.O(l),this.y()}o(n,i){const a=[];if(this.K()&&this.M(n)&&this.L(i)){const v=i.piece,c={line:v.start.line+1,column:0},$=new u(v.bufferIndex,c,v.end,this.t(v.bufferIndex,c,v.end),v.length-1);i.piece=$,n+=`
`,(0,N.$mC)(this,i,-1,-1),i.piece.length===0&&a.push(i)}const h=this.w(n);let t=this.T(i,h[h.length-1]);for(let v=h.length-2;v>=0;v--)t=this.T(t,h[v]);this.N(t),this.v(a)}q(n,i){this.Q(n,i)&&(n+=`
`);const a=this.w(n),h=this.S(i,a[0]);let t=h;for(let v=1;v<a.length;v++)t=this.S(t,a[v]);this.N(h)}s(n,i,a){const h=n.piece,t=n.piece.bufferIndex,v=this.a[t].lineStarts,$=v[h.start.line]+h.start.column+i;let w=h.start.line,p=h.end.line,l=0,D=0,g=0;for(;w<=p&&(l=w+(p-w)/2|0,g=v[l],l!==p);)if(D=v[l+1],$<g)p=l-1;else if($>=D)w=l+1;else break;return a?(a.line=l,a.column=$-g,null):{line:l,column:$-g}}t(n,i,a){if(a.column===0)return a.line-i.line;const h=this.a[n].lineStarts;if(a.line===h.length-1)return a.line-i.line;const t=h[a.line+1],v=h[a.line]+a.column;if(t>v+1)return a.line-i.line;const c=v-1;return this.a[n].buffer.charCodeAt(c)===13?a.line-i.line+1:a.line-i.line}u(n,i){return this.a[n].lineStarts[i.line]+i.column}v(n){for(let i=0;i<n.length;i++)(0,N.$kC)(this,n[i])}w(n){if(n.length>m){const p=[];for(;n.length>m;){const D=n.charCodeAt(m-1);let g;D===13||D>=55296&&D<=56319?(g=n.substring(0,m-1),n=n.substring(m-1)):(g=n.substring(0,m),n=n.substring(m));const S=F(g);p.push(new u(this.a.length,{line:0,column:0},{line:S.length-1,column:g.length-S[S.length-1]},S.length-1,g.length)),this.a.push(new b(g,S))}const l=F(n);return p.push(new u(this.a.length,{line:0,column:0},{line:l.length-1,column:n.length-l[l.length-1]},l.length-1,n.length)),this.a.push(new b(n,l)),p}let i=this.a[0].buffer.length;const a=F(n,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let p=0;p<a.length;p++)a[p]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let p=0;p<a.length;p++)a[p]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,v=this.a[0].lineStarts.length-1,c=t-this.a[0].lineStarts[v],$={line:v,column:c},w=new u(0,h,$,this.t(0,h,$),t-i);return this.g=$,[w]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,i=0){let a=this.root,h="";const t=this.h.get2(n);if(t){a=t.node;const v=this.B(a,n-t.nodeStartLineNumber-1),c=this.a[a.piece.bufferIndex].buffer,$=this.u(a.piece.bufferIndex,a.piece.start);if(t.nodeStartLineNumber+a.piece.lineFeedCnt===n)h=c.substring($+v,$+a.piece.length);else{const w=this.B(a,n-t.nodeStartLineNumber);return c.substring($+v,$+w-i)}}else{let v=0;const c=n;for(;a!==N.$fC;)if(a.left!==N.$fC&&a.lf_left>=n-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>n-1){const $=this.B(a,n-a.lf_left-2),w=this.B(a,n-a.lf_left-1),p=this.a[a.piece.bufferIndex].buffer,l=this.u(a.piece.bufferIndex,a.piece.start);return v+=a.size_left,this.h.set({node:a,nodeStartOffset:v,nodeStartLineNumber:c-(n-1-a.lf_left)}),p.substring(l+$,l+w-i)}else if(a.lf_left+a.piece.lineFeedCnt===n-1){const $=this.B(a,n-a.lf_left-2),w=this.a[a.piece.bufferIndex].buffer,p=this.u(a.piece.bufferIndex,a.piece.start);h=w.substring(p+$,p+a.piece.length);break}else n-=a.lf_left+a.piece.lineFeedCnt,v+=a.size_left+a.piece.length,a=a.right}for(a=a.next();a!==N.$fC;){const v=this.a[a.piece.bufferIndex].buffer;if(a.piece.lineFeedCnt>0){const c=this.B(a,0),$=this.u(a.piece.bufferIndex,a.piece.start);return h+=v.substring($,$+c-i),h}else{const c=this.u(a.piece.bufferIndex,a.piece.start);h+=v.substr(c,a.piece.length)}a=a.next()}return h}y(){let n=this.root,i=1,a=0;for(;n!==N.$fC;)i+=n.lf_left+n.piece.lineFeedCnt,a+=n.size_left+n.piece.length,n=n.right;this.b=i,this.c=a,this.h.validate(this.c)}A(n,i){const a=n.piece,h=this.s(n,i),t=h.line-a.start.line;if(this.u(a.bufferIndex,a.end)-this.u(a.bufferIndex,a.start)===i){const v=this.t(n.piece.bufferIndex,a.start,h);if(v!==t)return{index:v,remainder:0}}return{index:t,remainder:h.column}}B(n,i){if(i<0)return 0;const a=n.piece,h=this.a[a.bufferIndex].lineStarts,t=a.start.line+i+1;return t>a.end.line?h[a.end.line]+a.end.column-h[a.start.line]-a.start.column:h[t]-h[a.start.line]-a.start.column}C(n,i){const a=n.piece,h=a.lineFeedCnt,t=this.u(a.bufferIndex,a.end),v=i,c=this.u(a.bufferIndex,v),$=this.t(a.bufferIndex,a.start,v),w=$-h,p=c-t,l=a.length+p;n.piece=new u(a.bufferIndex,a.start,v,$,l),(0,N.$mC)(this,n,p,w)}D(n,i){const a=n.piece,h=a.lineFeedCnt,t=this.u(a.bufferIndex,a.start),v=i,c=this.t(a.bufferIndex,v,a.end),$=this.u(a.bufferIndex,v),w=c-h,p=t-$,l=a.length+p;n.piece=new u(a.bufferIndex,v,a.end,c,l),(0,N.$mC)(this,n,p,w)}E(n,i,a){const h=n.piece,t=h.start,v=h.end,c=h.length,$=h.lineFeedCnt,w=i,p=this.t(h.bufferIndex,h.start,w),l=this.u(h.bufferIndex,i)-this.u(h.bufferIndex,t);n.piece=new u(h.bufferIndex,h.start,w,p,l),(0,N.$mC)(this,n,l-c,p-$);const D=new u(h.bufferIndex,a,v,this.t(h.bufferIndex,a,v),this.u(h.bufferIndex,v)-this.u(h.bufferIndex,a)),g=this.S(n,D);this.N(g)}F(n,i){this.Q(i,n)&&(i+=`
`);const a=this.K()&&this.L(i)&&this.M(n),h=this.a[0].buffer.length;this.a[0].buffer+=i;const t=F(i,!1);for(let g=0;g<t.length;g++)t[g]+=h;if(a){const g=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-g}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const v=this.a[0].lineStarts.length-1,c=this.a[0].buffer.length-this.a[0].lineStarts[v],$={line:v,column:c},w=n.piece.length+i.length,p=n.piece.lineFeedCnt,l=this.t(0,n.piece.start,$),D=l-p;n.piece=new u(n.piece.bufferIndex,n.piece.start,$,l,w),this.g=$,(0,N.$mC)(this,n,i.length,D)}G(n){let i=this.root;const a=this.h.get(n);if(a)return{node:a.node,nodeStartOffset:a.nodeStartOffset,remainder:n-a.nodeStartOffset};let h=0;for(;i!==N.$fC;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){h+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:h};return this.h.set(t),t}else n-=i.size_left+i.piece.length,h+=i.size_left+i.piece.length,i=i.right;return null}H(n,i){let a=this.root,h=0;for(;a!==N.$fC;)if(a.left!==N.$fC&&a.lf_left>=n-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>n-1){const t=this.B(a,n-a.lf_left-2),v=this.B(a,n-a.lf_left-1);return h+=a.size_left,{node:a,remainder:Math.min(t+i-1,v),nodeStartOffset:h}}else if(a.lf_left+a.piece.lineFeedCnt===n-1){const t=this.B(a,n-a.lf_left-2);if(t+i-1<=a.piece.length)return{node:a,remainder:t+i-1,nodeStartOffset:h};i-=a.piece.length-t;break}else n-=a.lf_left+a.piece.lineFeedCnt,h+=a.size_left+a.piece.length,a=a.right;for(a=a.next();a!==N.$fC;){if(a.piece.lineFeedCnt>0){const t=this.B(a,0),v=this.J(a);return{node:a,remainder:Math.min(i-1,t),nodeStartOffset:v}}else if(a.piece.length>=i-1){const t=this.J(a);return{node:a,remainder:i-1,nodeStartOffset:t}}else i-=a.piece.length;a=a.next()}return null}I(n,i){if(n.piece.lineFeedCnt<1)return-1;const a=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start)+i;return a.buffer.charCodeAt(h)}J(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===N.$fC||n.piece.lineFeedCnt===0)return!1;const i=n.piece,a=this.a[i.bufferIndex].lineStarts,h=i.start.line,t=a[h]+i.start.column;return h===a.length-1||a[h+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===N.$fC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const i=n.prev();this.M(i)&&this.P(i,n)}}O(n){if(this.K()&&this.M(n)){const i=n.next();this.L(i)&&this.P(n,i)}}P(n,i){const a=[],h=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:h[n.piece.end.line]-h[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const v=n.piece.length-1,c=n.piece.lineFeedCnt-1;n.piece=new u(n.piece.bufferIndex,n.piece.start,t,c,v),(0,N.$mC)(this,n,-1,-1),n.piece.length===0&&a.push(n);const $={line:i.piece.start.line+1,column:0},w=i.piece.length-1,p=this.t(i.piece.bufferIndex,$,i.piece.end);i.piece=new u(i.piece.bufferIndex,$,i.piece.end,p,w),(0,N.$mC)(this,i,-1,-1),i.piece.length===0&&a.push(i);const l=this.w(`\r
`);this.S(n,l[0]);for(let D=0;D<a.length;D++)(0,N.$kC)(this,a[D])}Q(n,i){if(this.K()&&this.M(n)){const a=i.next();if(this.L(a)){if(n+=`
`,a.piece.length===1)(0,N.$kC)(this,a);else{const h=a.piece,t={line:h.start.line+1,column:0},v=h.length-1,c=this.t(h.bufferIndex,t,h.end);a.piece=new u(h.bufferIndex,t,h.end,c,v),(0,N.$mC)(this,a,-1,-1)}return!0}}return!1}iterate(n,i){if(n===N.$fC)return i(N.$fC);const a=this.iterate(n.left,i);return a&&i(n)&&this.iterate(n.right,i)}R(n){if(n===N.$fC)return"";const i=this.a[n.piece.bufferIndex],a=n.piece,h=this.u(a.bufferIndex,a.start),t=this.u(a.bufferIndex,a.end);return i.buffer.substring(h,t)}getPieceContent(n){const i=this.a[n.bufferIndex],a=this.u(n.bufferIndex,n.start),h=this.u(n.bufferIndex,n.end);return i.buffer.substring(a,h)}S(n,i){const a=new N.$eC(i,1);if(a.left=N.$fC,a.right=N.$fC,a.parent=N.$fC,a.size_left=0,a.lf_left=0,this.root===N.$fC)this.root=a,a.color=0;else if(n.right===N.$fC)n.right=a,a.parent=n;else{const t=(0,N.$gC)(n.right);t.left=a,a.parent=t}return(0,N.$lC)(this,a),a}T(n,i){const a=new N.$eC(i,1);if(a.left=N.$fC,a.right=N.$fC,a.parent=N.$fC,a.size_left=0,a.lf_left=0,this.root===N.$fC)this.root=a,a.color=0;else if(n.left===N.$fC)n.left=a,a.parent=n;else{const h=(0,N.$hC)(n.left);h.right=a,a.parent=h}return(0,N.$lC)(this,a),a}U(n){let i="";return this.iterate(n,a=>(i+=this.R(a),!0)),i}}e.$yC=o}),define(Ce[136],Pe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$9=e.$09=void 0;class I{constructor(){this.a=new Map}removeDragOperationTransfer(N){if(N&&this.a.has(N)){const A=this.a.get(N);return this.a.delete(N),A}}addDragOperationTransfer(N,A){this.a.set(N,A)}}e.$09=I;class O{constructor(N){this.identifier=N}}e.$$9=O}),define(Ce[137],Pe([9,10]),function($e,e){return $e.create("vs/base/common/actions",e)}),define(Ce[138],Pe([1,0,5,6,137]),function($e,e,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=void 0,e.$5i=F;class N extends O.$Uc{constructor(u,b="",f="",r=!0,o){super(),this.h=this.B(new I.$7d),this.onDidChange=this.h.event,this.w=!0,this.j=u,this.m=b,this.u=f,this.w=r,this.C=o}get id(){return this.j}get label(){return this.m}set label(u){this.D(u)}D(u){this.m!==u&&(this.m=u,this.h.fire({label:u}))}get tooltip(){return this.n||""}set tooltip(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.h.fire({tooltip:u}))}get class(){return this.u}set class(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.h.fire({class:u}))}get enabled(){return this.w}set enabled(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.h.fire({enabled:u}))}get checked(){return this.z}set checked(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.h.fire({checked:u}))}async run(u,b){this.C&&await this.C(u)}}e.$Zi=N;class A extends O.$Uc{constructor(){super(...arguments),this.f=this.B(new I.$7d),this.onWillRun=this.f.event,this.m=this.B(new I.$7d),this.onDidRun=this.m.event}async run(u,b){if(!u.enabled)return;this.f.fire({action:u});let f;try{await this.u(u,b)}catch(r){f=r}this.m.fire({action:u,error:f})}async u(u,b){await u.run(b)}}e.$1i=A;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let b=[];for(const f of u)f.length&&(b.length?b=[...b,new m,...f]:b=f);return b}static{this.ID="vs.actions.separator"}async run(){}}e.$2i=m;class d{get actions(){return this.a}constructor(u,b,f,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=b,this.class=r,this.a=f}async run(){}}e.$3i=d;class k extends N{static{this.ID="vs.actions.empty"}constructor(){super(k.ID,P.localize(0,null),void 0,!1)}}e.$4i=k;function F(E){return{id:E.id,label:E.label,class:E.class,enabled:E.enabled??!0,checked:E.checked,run:async(...u)=>E.run(...u),tooltip:E.label}}}),define(Ce[139],Pe([9,10]),function($e,e){return $e.create("vs/base/common/date",e)}),define(Ce[140],Pe([1,0,139]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=k,e.$Om=F,e.$Pm=E;const O=60,P=O*60,N=P*24,A=N*7,m=N*30,d=N*365;function k(u,b,f,r){typeof u!="number"&&(u=u.getTime());const o=Math.round((new Date().getTime()-u)/1e3);if(o<-30)return(0,I.localize)(0,null,k(new Date().getTime()+o*1e3,!1));if(!r&&o<30)return(0,I.localize)(1,null);let s;return o<O?(s=o,b?s===1?f?(0,I.localize)(2,null,s):(0,I.localize)(3,null,s):f?(0,I.localize)(4,null,s):(0,I.localize)(5,null,s):s===1?f?(0,I.localize)(6,null,s):(0,I.localize)(7,null,s):f?(0,I.localize)(8,null,s):(0,I.localize)(9,null,s)):o<P?(s=Math.floor(o/O),b?s===1?f?(0,I.localize)(10,null,s):(0,I.localize)(11,null,s):f?(0,I.localize)(12,null,s):(0,I.localize)(13,null,s):s===1?f?(0,I.localize)(14,null,s):(0,I.localize)(15,null,s):f?(0,I.localize)(16,null,s):(0,I.localize)(17,null,s)):o<N?(s=Math.floor(o/P),b?s===1?f?(0,I.localize)(18,null,s):(0,I.localize)(19,null,s):f?(0,I.localize)(20,null,s):(0,I.localize)(21,null,s):s===1?f?(0,I.localize)(22,null,s):(0,I.localize)(23,null,s):f?(0,I.localize)(24,null,s):(0,I.localize)(25,null,s)):o<A?(s=Math.floor(o/N),b?s===1?(0,I.localize)(26,null,s):(0,I.localize)(27,null,s):s===1?(0,I.localize)(28,null,s):(0,I.localize)(29,null,s)):o<m?(s=Math.floor(o/A),b?s===1?f?(0,I.localize)(30,null,s):(0,I.localize)(31,null,s):f?(0,I.localize)(32,null,s):(0,I.localize)(33,null,s):s===1?f?(0,I.localize)(34,null,s):(0,I.localize)(35,null,s):f?(0,I.localize)(36,null,s):(0,I.localize)(37,null,s)):o<d?(s=Math.floor(o/m),b?s===1?f?(0,I.localize)(38,null,s):(0,I.localize)(39,null,s):f?(0,I.localize)(40,null,s):(0,I.localize)(41,null,s):s===1?f?(0,I.localize)(42,null,s):(0,I.localize)(43,null,s):f?(0,I.localize)(44,null,s):(0,I.localize)(45,null,s)):(s=Math.floor(o/d),b?s===1?f?(0,I.localize)(46,null,s):(0,I.localize)(47,null,s):f?(0,I.localize)(48,null,s):(0,I.localize)(49,null,s):s===1?f?(0,I.localize)(50,null,s):(0,I.localize)(51,null,s):f?(0,I.localize)(52,null,s):(0,I.localize)(53,null,s))}function F(u,b){const f=Math.abs(u/1e3);return f<1?b?(0,I.localize)(54,null,u):(0,I.localize)(55,null,u):f<O?b?(0,I.localize)(56,null,Math.round(u)/1e3):(0,I.localize)(57,null,Math.round(u)/1e3):f<P?b?(0,I.localize)(58,null,Math.round(u/(1e3*O))):(0,I.localize)(59,null,Math.round(u/(1e3*O))):f<N?b?(0,I.localize)(60,null,Math.round(u/(1e3*P))):(0,I.localize)(61,null,Math.round(u/(1e3*P))):(0,I.localize)(62,null,Math.round(u/(1e3*N)))}function E(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ce[141],Pe([9,10]),function($e,e){return $e.create("vs/base/common/errorMessage",e)}),define(Ce[42],Pe([1,0,18,16,141]),function($e,e,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6i=d,e.$7i=k,e.$8i=F;function N(E,u){return u&&(E.stack||E.stacktrace)?P.localize(0,null,m(E),A(E.stack)||A(E.stacktrace)):m(E)}function A(E){return Array.isArray(E)?E.join(`
`):E}function m(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?P.localize(1,null,E.message):E.message||P.localize(2,null)}function d(E=null,u=!1){if(!E)return P.localize(3,null);if(Array.isArray(E)){const b=I.$Hb(E),f=d(b[0],u);return b.length>1?P.localize(4,null,f,b.length):f}if(O.$Vf(E))return E;if(E.detail){const b=E.detail;if(b.error)return N(b.error,u);if(b.exception)return N(b.exception,u)}return E.stack?N(E,u):E.message?E.message:P.localize(5,null)}function k(E){const u=E;return u instanceof Error&&Array.isArray(u.actions)}function F(E,u){let b;return typeof E=="string"?b=new Error(E):b=E,b.actions=u,b}}),define(Ce[142],Pe([1,0,40,19]),function($e,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=m,e.$4q=d,e.$5q=k,e.$6q=F,e.$7q=E,e.$8q=u,e.$9q=b,e.$0q=f,e.$$q=r,e.$_q=o,e.$ar=w,e.$br=p,e.$cr=l;const P=new I.$V(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),N=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(D,g,S=!1){const y=D||"",C=g||"",R=P.value.collator.compare(y,C);return P.value.collatorIsNumeric&&R===0&&y!==C?y<C?-1:1:R}function d(D,g){const S=N.value.collator;return D=D||"",g=g||"",a(S,D,g)}function k(D,g){const S=N.value.collator;return D=D||"",g=g||"",c(D,g)||a(S,D,g)}function F(D,g){const S=N.value.collator;return D=D||"",g=g||"",v(D,g)||a(S,D,g)}function E(D,g){return D=D||"",g=g||"",D===g?0:D<g?-1:1}function u(D,g){const[S,y]=n(D),[C,R]=n(g);let V=P.value.collator.compare(y,R);if(V===0){if(P.value.collatorIsNumeric&&y!==R)return y<R?-1:1;if(V=P.value.collator.compare(S,C),P.value.collatorIsNumeric&&V===0&&S!==C)return S<C?-1:1}return V}function b(D,g){D=D||"",g=g||"";const S=i(D),y=i(g),C=N.value.collator,R=A.value.collator;return a(R,S,y)||a(C,D,g)}function f(D,g){D=D||"",g=g||"";const S=i(D),y=i(g),C=N.value.collator,R=A.value.collator;return a(R,S,y)||c(D,g)||a(C,D,g)}function r(D,g){D=D||"",g=g||"";const S=i(D),y=i(g),C=N.value.collator,R=A.value.collator;return a(R,S,y)||v(D,g)||a(C,D,g)}function o(D,g){D=D||"",g=g||"";const S=i(D).toLowerCase(),y=i(g).toLowerCase();return S!==y?S<y?-1:1:D!==g?D<g?-1:1:0}const s=/^(.*?)(\.([^.]*))?$/;function n(D,g=!1){const S=D?s.exec(D):[];let y=[S&&S[1]||"",S&&S[3]||""];return g&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function i(D){const g=D?s.exec(D):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function a(D,g,S){const y=D.compare(g,S);return y!==0?y:g.length!==S.length?g.length<S.length?-1:1:0}function h(D){const g=D.charAt(0);return g.toLocaleUpperCase()!==g}function t(D){const g=D.charAt(0);return g.toLocaleLowerCase()!==g}function v(D,g){return h(D)&&t(g)?-1:t(D)&&h(g)?1:0}function c(D,g){return t(D)&&h(g)?-1:h(D)&&t(g)?1:0}function $(D,g,S=!1){return S||(D=D&&D.toLowerCase(),g=g&&g.toLowerCase()),D===g?0:D<g?-1:1}function w(D,g,S=!1){const y=D.split(O.sep),C=g.split(O.sep),R=y.length-1,V=C.length-1;let U,q;for(let M=0;;M++){if(U=R===M,q=V===M,U&&q)return m(y[M],C[M],S);if(U)return-1;if(q)return 1;const L=$(y[M],C[M],S);if(L!==0)return L}}function p(D,g,S){const y=D.toLowerCase(),C=g.toLowerCase(),R=l(D,g,S);if(R)return R;const V=y.endsWith(S),U=C.endsWith(S);if(V!==U)return V?-1:1;const q=m(y,C);return q!==0?q:y.localeCompare(C)}function l(D,g,S){const y=D.toLowerCase(),C=g.toLowerCase(),R=y.startsWith(S),V=C.startsWith(S);if(R!==V)return R?-1:1;if(R&&V){if(y.length<C.length)return-1;if(y.length>C.length)return 1}return 0}}),define(Ce[46],Pe([1,0,19,21,15,16]),function($e,e,I,O,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=A,e.$cg=m,e.$dg=d,e.$eg=k,e.$fg=F,e.$gg=f,e.$hg=r,e.$ig=o,e.$jg=s,e.$kg=n,e.$lg=i,e.$mg=a,e.$ng=h,e.$og=t,e.$pg=v,e.$qg=w;function A(p){return p===47||p===92}function m(p){return p.replace(/[\\/]/g,I.$hc.sep)}function d(p){return p.indexOf("/")===-1&&(p=m(p)),/^[a-zA-Z]:(\/|$)/.test(p)&&(p="/"+p),p}function k(p,l=I.$hc.sep){if(!p)return"";const D=p.length,g=p.charCodeAt(0);if(A(g)){if(A(p.charCodeAt(1))&&!A(p.charCodeAt(2))){let y=3;const C=y;for(;y<D&&!A(p.charCodeAt(y));y++);if(C!==y&&!A(p.charCodeAt(y+1))){for(y+=1;y<D;y++)if(A(p.charCodeAt(y)))return p.slice(0,y+1).replace(/[\\/]/g,l)}}return l}else if(s(g)&&p.charCodeAt(1)===58)return A(p.charCodeAt(2))?p.slice(0,2)+l:p.slice(0,2);let S=p.indexOf("://");if(S!==-1){for(S+=3;S<D;S++)if(A(p.charCodeAt(S)))return p.slice(0,S+1)}return""}function F(p){if(!O.$i||!p||p.length<5)return!1;let l=p.charCodeAt(0);if(l!==92||(l=p.charCodeAt(1),l!==92))return!1;let D=2;const g=D;for(;D<p.length&&(l=p.charCodeAt(D),l!==92);D++);return!(g===D||(l=p.charCodeAt(D+1),isNaN(l)||l===92))}const E=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(p,l=O.$i){const D=l?E:u;return!(!p||p.length===0||/^\s+$/.test(p)||(D.lastIndex=0,D.test(p))||l&&b.test(p)||p==="."||p===".."||l&&p[p.length-1]==="."||l&&p.length!==p.trim().length||p.length>255)}function r(p,l,D){const g=p===l;return!D||g?g:!p||!l?!1:(0,P.$lf)(p,l)}function o(p,l,D,g=I.sep){if(p===l)return!0;if(!p||!l||l.length>p.length)return!1;if(D){if(!(0,P.$mf)(p,l))return!1;if(l.length===p.length)return!0;let y=l.length;return l.charAt(l.length-1)===g&&y--,p.charAt(y)===g}return l.charAt(l.length-1)!==g&&(l+=g),p.indexOf(l)===0}function s(p){return p>=65&&p<=90||p>=97&&p<=122}function n(p,l){return O.$i&&p.endsWith(":")&&(p+=I.sep),(0,I.$jc)(p)||(p=(0,I.$kc)(l,p)),p=(0,I.$ic)(p),O.$i?(p=(0,P.$6e)(p,I.sep),p.endsWith(":")&&(p+=I.sep)):(p=(0,P.$6e)(p,I.sep),p||(p=I.sep)),p}function i(p){const l=(0,I.$ic)(p);return O.$i?p.length>3?!1:a(l)&&(p.length===2||l.charCodeAt(2)===92):l===I.$hc.sep}function a(p,l=O.$i){return l?s(p.charCodeAt(0))&&p.charCodeAt(1)===58:!1}function h(p,l=O.$i){return a(p,l)?p[0]:void 0}function t(p,l,D){return l.length>p.length?-1:p===l?0:(D&&(p=p.toLowerCase(),l=l.toLowerCase()),p.indexOf(l))}function v(p){const l=p.split(":");let D,g,S;for(const y of l){const C=Number(y);(0,N.$Zf)(C)?g===void 0?g=C:S===void 0&&(S=C):D=D?[D,y].join(":"):y}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:g!==void 0?g:void 0,column:S!==void 0?S:g!==void 0?1:void 0}}const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",$="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function w(p,l,D=8){let g="";for(let y=0;y<D;y++){let C;y===0&&O.$i&&!l&&(D===3||D===4)?C=$:C=c,g+=C.charAt(Math.floor(Math.random()*C.length))}let S;return l?S=`${l}-${g}`:S=g,p?(0,I.$kc)(p,S):S}}),define(Ce[69],Pe([1,0,19]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=void 0,e.$As=N,e.$Bs=A,e.$Cs=m,e.$Ds=k,e.$zs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function N(F){const E=(0,I.$pc)(F),u=O[E.toLowerCase()];return u!==void 0?u:A(F)}function A(F){const E=(0,I.$pc)(F);return P[E.toLowerCase()]}function m(F){for(const E in P)if(P[E]===F)return E}const d=/^(.+)\/(.+?)(;.+)?$/;function k(F,E){const u=d.exec(F);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:E?void 0:F}}),define(Ce[52],Pe([1,0,23,2]),function($e,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=P,e.$Qh=N,e.$Rh=m;function P(d){return JSON.stringify(d,A)}function N(d){let k=JSON.parse(d);return k=m(k),k}function A(d,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:k.flags}:k}function m(d,k=0){if(!d||k>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return O.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 17:return new Date(d.source)}if(d instanceof I.$ue||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let F=0;F<d.length;++F)d[F]=m(d[F],k+1);else for(const F in d)Object.hasOwnProperty.call(d,F)&&(d[F]=m(d[F],k+1))}return d}}),define(Ce[12],Pe([1,0,14,21,15,2,19]),function($e,e,I,O,P,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$vg=e.$ug=e.$tg=e.Schemas=void 0,e.$rg=d,e.$sg=k,e.$wg=E;var m;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatCodeBlock="vscode-chat-code-block",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm",f.codeSetting="code-setting"})(m||(e.Schemas=m={}));function d(f,r){return N.URI.isUri(f)?(0,P.$lf)(f.scheme,r):(0,P.$mf)(f,r+":")}function k(f,...r){return r.some(o=>d(f,o))}e.$tg="vscode-tkn",e.$ug="tkn";class F{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,o){this.f=E(r,o)}getServerRootPath(){return this.f}get g(){return A.$hc.join(this.f,m.vscodeRemoteResource)}set(r,o,s){this.a[r]=o,this.b[r]=s}setConnectionToken(r,o){this.c[r]=o}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(h){return I.$1(h),r}const o=r.authority;let s=this.a[o];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const n=this.b[o],i=this.c[o];let a=`path=${encodeURIComponent(r.path)}`;return typeof i=="string"&&(a+=`&${e.$ug}=${encodeURIComponent(i)}`),N.URI.from({scheme:O.$o?this.d:m.vscodeRemoteResource,authority:`${s}:${n}`,path:this.g,query:a})}}e.$vg=new F;function E(f,r){return A.$hc.join(r??"/",`${f.quality??"oss"}-${f.commit??"dev"}`)}e.$xg="vs/../../extensions",e.$yg="vs/../../node_modules",e.$zg="vs/../../node_modules.asar",e.$Ag="vs/../../node_modules.asar.unpacked",e.$Bg="vscode-app";class u{static{this.a=e.$Bg}asBrowserUri(r){const o=this.b(r,$e);return this.uriToBrowserUri(o)}uriToBrowserUri(r){return r.scheme===m.vscodeRemote?e.$vg.rewrite(r):r.scheme===m.file&&(O.$m||O.$q===`${m.vscodeFileResource}://${u.a}`)?r.with({scheme:m.vscodeFileResource,authority:r.authority||u.a,query:null,fragment:null}):r}asFileUri(r){const o=this.b(r,$e);return this.uriToFileUri(o)}uriToFileUri(r){return r.scheme===m.vscodeFileResource?r.with({scheme:m.file,authority:r.authority!==u.a?r.authority:null,query:null,fragment:null}):r}b(r,o){return N.URI.isUri(r)?r:N.URI.parse(o.toUrl(r))}}e.$Cg=new u;var b;(function(f){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(r.get("3"));const o="vscode-coi";function s(i){let a;typeof i=="string"?a=new URL(i).searchParams:i instanceof URL?a=i.searchParams:N.URI.isUri(i)&&(a=new URL(i.toString(!0)).searchParams);const h=a?.get(o);if(h)return r.get(h)}f.getHeadersFromQuery=s;function n(i,a,h){if(!globalThis.crossOriginIsolated)return;const t=a&&h?"3":h?"2":"1";i instanceof URLSearchParams?i.set(o,t):i[o]=t}f.addSearchParam=n})(b||(e.COI=b={}))}),define(Ce[24],Pe([1,0,46,12,19,21,15,2]),function($e,e,I,O,P,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=void 0,e.$Jg=d,e.$5g=F,e.$6g=u;function d(b){return(0,m.$xc)(b,!0)}class k{constructor(f){this.a=f}compare(f,r,o=!1){return f===r?0:(0,A.$ef)(this.getComparisonKey(f,o),this.getComparisonKey(r,o))}isEqual(f,r,o=!1){return f===r?!0:!f||!r?!1:this.getComparisonKey(f,o)===this.getComparisonKey(r,o)}getComparisonKey(f,r=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,r,o=!1){if(f.scheme===r.scheme){if(f.scheme===O.Schemas.file)return I.$ig(d(f),d(r),this.a(f))&&f.query===r.query&&(o||f.fragment===r.fragment);if((0,e.$1g)(f.authority,r.authority))return I.$ig(f.path,r.path,this.a(f),"/")&&f.query===r.query&&(o||f.fragment===r.fragment)}return!1}joinPath(f,...r){return m.URI.joinPath(f,...r)}basenameOrAuthority(f){return(0,e.$Sg)(f)||f.authority}basename(f){return P.$hc.basename(f.path)}extname(f){return P.$hc.extname(f.path)}dirname(f){if(f.path.length===0)return f;let r;return f.scheme===O.Schemas.file?r=m.URI.file(P.$nc(d(f))).path:(r=P.$hc.dirname(f.path),f.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),r="/")),f.with({path:r})}normalizePath(f){if(!f.path.length)return f;let r;return f.scheme===O.Schemas.file?r=m.URI.file(P.$ic(d(f))).path:r=P.$hc.normalize(f.path),f.with({path:r})}relativePath(f,r){if(f.scheme!==r.scheme||!(0,e.$1g)(f.authority,r.authority))return;if(f.scheme===O.Schemas.file){const n=P.$mc(d(f),d(r));return N.$i?I.$cg(n):n}let o=f.path||"/";const s=r.path||"/";if(this.a(f)){let n=0;for(const i=Math.min(o.length,s.length);n<i&&!(o.charCodeAt(n)!==s.charCodeAt(n)&&o.charAt(n).toLowerCase()!==s.charAt(n).toLowerCase());n++);o=s.substr(0,n)+o.substr(n)}return P.$hc.relative(o,s)}resolvePath(f,r){if(f.scheme===O.Schemas.file){const o=m.URI.file(P.$lc(d(f),r));return f.with({authority:o.authority,path:o.path})}return r=I.$dg(r),f.with({path:P.$hc.resolve(f.path,r)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,r){return f===r||f!==void 0&&r!==void 0&&(0,A.$lf)(f,r)}hasTrailingPathSeparator(f,r=P.sep){if(f.scheme===O.Schemas.file){const o=d(f);return o.length>I.$eg(o).length&&o[o.length-1]===r}else{const o=f.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,r=P.sep){return(0,e.$2g)(f,r)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,r=P.sep){let o=!1;if(f.scheme===O.Schemas.file){const s=d(f);o=s!==void 0&&s.length===I.$eg(s).length&&s[s.length-1]===r}else{r="/";const s=f.path;o=s.length===1&&s.charCodeAt(s.length-1)===47}return!o&&!(0,e.$2g)(f,r)?f.with({path:f.path+"/"}):f}}e.$Kg=k,e.$Lg=new k(()=>!1),e.$Mg=new k(b=>b.scheme===O.Schemas.file?!N.$k:!0),e.$Ng=new k(b=>!0),e.$Og=e.$Lg.isEqual.bind(e.$Lg),e.$Pg=e.$Lg.isEqualOrParent.bind(e.$Lg),e.$Qg=e.$Lg.getComparisonKey.bind(e.$Lg),e.$Rg=e.$Lg.basenameOrAuthority.bind(e.$Lg),e.$Sg=e.$Lg.basename.bind(e.$Lg),e.$Tg=e.$Lg.extname.bind(e.$Lg),e.$Ug=e.$Lg.dirname.bind(e.$Lg),e.$Vg=e.$Lg.joinPath.bind(e.$Lg),e.$Wg=e.$Lg.normalizePath.bind(e.$Lg),e.$Xg=e.$Lg.relativePath.bind(e.$Lg),e.$Yg=e.$Lg.resolvePath.bind(e.$Lg),e.$Zg=e.$Lg.isAbsolutePath.bind(e.$Lg),e.$1g=e.$Lg.isEqualAuthority.bind(e.$Lg),e.$2g=e.$Lg.hasTrailingPathSeparator.bind(e.$Lg),e.$3g=e.$Lg.removeTrailingPathSeparator.bind(e.$Lg),e.$4g=e.$Lg.addTrailingPathSeparator.bind(e.$Lg);function F(b,f){const r=[];for(let o=0;o<b.length;o++){const s=f(b[o]);b.some((n,i)=>i===o?!1:(0,e.$Pg)(s,f(n)))||r.push(b[o])}return r}var E;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function f(r){const o=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(i=>{const[a,h]=i.split(":");a&&h&&o.set(a,h)});const n=r.path.substring(0,r.path.indexOf(";"));return n&&o.set(b.META_DATA_MIME,n),o}b.parseMetaData=f})(E||(e.DataUri=E={}));function u(b,f,r){if(f){let o=b.path;return o&&o[0]!==P.$hc.sep&&(o=P.$hc.sep+o),b.with({scheme:r,authority:f,path:o})}return b.with({scheme:r})}}),define(Ce[11],Pe([1,0,25,14,5,6,24,21,129,40]),function($e,e,I,O,P,N,A,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.Promises=e.$Fh=e.$Eh=e.$Dh=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=void 0,e.$7g=F,e.$8g=E,e.$9g=u,e.$0g=b,e.$$g=f,e.$_g=r,e.$ah=o,e.$bh=s,e.$jh=p,e.$kh=l,e.$lh=D,e.$mh=g,e.$nh=S,e.$Ch=Re,e.$Kh=Se;function F(me){return!!me&&typeof me.then=="function"}function E(me){const J=new I.$ee,Y=me(J.token),ce=new Promise((fe,Ne)=>{const le=J.token.onCancellationRequested(()=>{le.dispose(),Ne(new O.$5)});Promise.resolve(Y).then(Ie=>{le.dispose(),J.dispose(),fe(Ie)},Ie=>{le.dispose(),J.dispose(),Ne(Ie)})});return new class{cancel(){J.cancel(),J.dispose()}then(fe,Ne){return ce.then(fe,Ne)}catch(fe){return this.then(void 0,fe)}finally(fe){return ce.finally(fe)}}}function u(me,J,Y){return new Promise((ce,fe)=>{const Ne=J.onCancellationRequested(()=>{Ne.dispose(),ce(Y)});me.then(ce,fe).finally(()=>Ne.dispose())})}function b(me,J){return new Promise((Y,ce)=>{const fe=J.onCancellationRequested(()=>{fe.dispose(),ce(new O.$5)});me.then(Y,ce).finally(()=>fe.dispose())})}async function f(me){let J=-1;const Y=me.map((ce,fe)=>ce.then(Ne=>(J=fe,Ne)));try{return await Promise.race(Y)}finally{me.forEach((ce,fe)=>{fe!==J&&ce.cancel()})}}function r(me,J,Y){let ce;const fe=setTimeout(()=>{ce?.(void 0),Y?.()},J);return Promise.race([me.finally(()=>clearTimeout(fe)),new Promise(Ne=>ce=Ne)])}function o(me){return new Promise((J,Y)=>{const ce=me();F(ce)?ce.then(J,Y):J(ce)})}function s(){let me,J;return{promise:new Promise((ce,fe)=>{me=ce,J=fe}),resolve:me,reject:J}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=J,!this.b){const Y=()=>{if(this.b=null,this.f)return;const ce=this.queue(this.d);return this.d=null,ce};this.b=new Promise(ce=>{this.a.then(Y,Y).then(ce)})}return new Promise((Y,ce)=>{this.b.then(Y,ce)})}return this.a=J(),new Promise((Y,ce)=>{this.a.then(fe=>{this.a=null,Y(fe)},fe=>{this.a=null,ce(fe)})})}dispose(){this.f=!0}}e.$ch=n;class i{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$dh=i;class a{constructor(){this.a=new Map}queue(J,Y){const fe=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(J)===fe&&this.a.delete(J)});return this.a.set(J,fe),fe}}e.$eh=a;const h=(me,J)=>{let Y=!0;const ce=setTimeout(()=>{Y=!1,J()},me);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(ce),Y=!1}}},t=me=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,me())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class v{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,Y=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((fe,Ne)=>{this.d=fe,this.f=Ne}).then(()=>{if(this.b=null,this.d=null,this.g){const fe=this.g;return this.g=null,fe()}}));const ce=()=>{this.a=null,this.d?.(null)};return this.a=Y===d.$4d?t(ce):h(Y,ce),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$fh=v;class c{constructor(J){this.a=new v(J),this.b=new n}trigger(J,Y){return this.a.trigger(()=>this.b.queue(J),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$gh=c;class ${constructor(){this.a=!1,this.b=new Promise((J,Y)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$hh=$;class w extends ${constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$ih=w;function p(me,J){return J?new Promise((Y,ce)=>{const fe=setTimeout(()=>{Ne.dispose(),Y()},me),Ne=J.onCancellationRequested(()=>{clearTimeout(fe),Ne.dispose(),ce(new O.$5)})}):E(Y=>p(me,Y))}function l(me,J=0,Y){const ce=setTimeout(()=>{me(),Y&&fe.dispose()},J),fe=(0,N.$Sc)(()=>{clearTimeout(ce),Y?.deleteAndLeak(fe)});return Y?.add(fe),fe}function D(me){const J=[];let Y=0;const ce=me.length;function fe(){return Y<ce?me[Y++]():null}function Ne(le){le!=null&&J.push(le);const Ie=fe();return Ie?Ie.then(Ne):Promise.resolve(J)}return Promise.resolve(null).then(Ne)}function g(me,J=ce=>!!ce,Y=null){let ce=0;const fe=me.length,Ne=()=>{if(ce>=fe)return Promise.resolve(Y);const le=me[ce++];return Promise.resolve(le()).then(Ae=>J(Ae)?Promise.resolve(Ae):Ne())};return Ne()}function S(me,J=ce=>!!ce,Y=null){if(me.length===0)return Promise.resolve(Y);let ce=me.length;const fe=()=>{ce=-1;for(const Ne of me)Ne.cancel?.()};return new Promise((Ne,le)=>{for(const Ie of me)Ie.then(Ae=>{--ce>=0&&J(Ae)?(fe(),Ne(Ae)):ce===0&&Ne(Y)}).catch(Ae=>{--ce>=0&&(fe(),le(Ae))})})}class y{constructor(J){this.a=0,this.b=!1,this.f=J,this.g=[],this.d=0,this.h=new P.$7d}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(J){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Y,ce)=>{this.g.push({factory:J,c:Y,e:ce}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const J=this.g.shift();this.d++;const Y=J.factory();Y.then(J.c,J.e),Y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$oh=y;class C extends y{constructor(){super(1)}}e.$ph=C;class R{constructor(){this.a=new ge,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$qh=R;class V{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new be;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueSize(J,Y=A.$Lg){const ce=Y.getComparisonKey(J);return this.a.get(ce)?.size??0}queueFor(J,Y,ce=A.$Lg){const fe=ce.getComparisonKey(J);let Ne=this.a.get(fe);if(!Ne){Ne=new C;const le=this.f++,Ie=P.Event.once(Ne.onDrained)(()=>{Ne?.dispose(),this.a.delete(fe),this.h(),this.d?.deleteAndDispose(le),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new N.$4c),this.d.set(le,Ie),this.a.set(fe,Ne)}return Ne.queue(Y)}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$rh=V;class U{constructor(J,Y){this.a=-1,typeof J=="function"&&typeof Y=="number"&&this.setIfNotSet(J,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},Y)}setIfNotSet(J,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},Y))}}e.$sh=U;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(J,Y,ce=globalThis){this.cancel();const fe=ce.setInterval(()=>{J()},Y);this.d=(0,N.$Sc)(()=>{ce.clearInterval(fe),this.d=void 0})}dispose(){this.cancel()}}e.$th=q;class M{constructor(J,Y){this.b=-1,this.a=J,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$uh=M;class L{constructor(J,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=J,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$vh=L;class G extends M{constructor(J,Y){super(J,Y),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$wh=G;class ne extends N.$Uc{constructor(J,Y){super(),this.g=J,this.h=Y,this.a=[],this.b=this.B(new N.$Vc),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of J)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new M(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$xh=ne,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$zh=(me,J)=>{(0,m.$B)(()=>{if(Y)return;const ce=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ce-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.$zh=(me,J,Y)=>{const ce=me.requestIdleCallback(J,typeof Y=="number"?{timeout:Y}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,me.cancelIdleCallback(ce))}}},e.$yh=me=>(0,e.$zh)(globalThis,me)}();class he{constructor(J,Y){this.g=!1,this.d=()=>{try{this.j=Y()}catch(ce){this.l=ce}finally{this.g=!0}},this.f=(0,e.$zh)(J,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Ah=he;class ye extends he{constructor(J){super(globalThis,J)}}e.$Bh=ye;async function Re(me,J,Y){let ce;for(let fe=0;fe<Y;fe++)try{return await me()}catch(Ne){ce=Ne,await p(J)}throw ce}class ge{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,Y,ce){return this.a={taskId:J,cancel:()=>ce?.(),promise:Y},Y.then(()=>this.d(J),()=>this.d(J)),Y}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{const{promise:Y,resolve:ce,reject:fe}=s();this.b={run:J,promise:Y,promiseResolve:ce,promiseReject:fe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Dh=ge;class ue{constructor(J,Y=()=>Date.now()){this.d=J,this.f=Y,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$Eh=ue;var te;(function(me){me[me.Resolved=0]="Resolved",me[me.Rejected=1]="Rejected"})(te||(te={}));class be{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((J,Y)=>{this.a=J,this.b=Y})}complete(J){return new Promise(Y=>{this.a(J),this.d={outcome:0,value:J},Y()})}error(J){return new Promise(Y=>{this.b(J),this.d={outcome:1,value:J},Y()})}cancel(){return this.error(new O.$5)}}e.$Fh=be;var oe;(function(me){async function J(ce){let fe;const Ne=await Promise.all(ce.map(le=>le.then(Ie=>Ie,Ie=>{fe||(fe=Ie)})));if(typeof fe<"u")throw fe;return Ne}me.settled=J;function Y(ce){return new Promise(async(fe,Ne)=>{try{await ce(fe,Ne)}catch(le){Ne(le)}})}me.withAsyncBody=Y})(oe||(e.Promises=oe={}));class de{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(J){this.a=void 0,this.b=void 0,this.d=!1,this.promise=J.then(Y=>(this.a=Y,this.d=!0,Y),Y=>{throw this.b=Y,this.d=!0,Y})}requireValue(){if(!this.d)throw new O.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Gh=de;class W{constructor(J){this.b=J,this.a=new k.$V(()=>new de(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Hh=W;var ee;(function(me){me[me.Initial=0]="Initial",me[me.DoneOK=1]="DoneOK",me[me.DoneError=2]="DoneError"})(ee||(ee={}));class ke{static fromArray(J){return new ke(Y=>{Y.emitMany(J)})}static fromPromise(J){return new ke(async Y=>{Y.emitMany(await J)})}static fromPromises(J){return new ke(async Y=>{await Promise.all(J.map(async ce=>Y.emitOne(await ce)))})}static merge(J){return new ke(async Y=>{await Promise.all(J.map(async ce=>{for await(const fe of ce)Y.emitOne(fe)}))})}static{this.EMPTY=ke.fromArray([])}constructor(J){this.a=0,this.b=[],this.d=null,this.f=new P.$7d,queueMicrotask(async()=>{const Y={emitOne:ce=>this.g(ce),emitMany:ce=>this.h(ce),reject:ce=>this.k(ce)};try{await Promise.resolve(J(Y)),this.j()}catch(ce){this.k(ce)}finally{Y.emitOne=void 0,Y.emitMany=void 0,Y.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await P.Event.toPromise(this.f.event)}while(!0)}}}static map(J,Y){return new ke(async ce=>{for await(const fe of J)ce.emitOne(Y(fe))})}map(J){return ke.map(this,J)}static filter(J,Y){return new ke(async ce=>{for await(const fe of J)Y(fe)&&ce.emitOne(fe)})}filter(J){return ke.filter(this,J)}static coalesce(J){return ke.filter(J,Y=>!!Y)}coalesce(){return ke.coalesce(this)}static async toPromise(J){const Y=[];for await(const ce of J)Y.push(ce);return Y}toPromise(){return ke.toPromise(this)}g(J){this.a===0&&(this.b.push(J),this.f.fire())}h(J){this.a===0&&(this.b=this.b.concat(J),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(J){this.a===0&&(this.a=2,this.d=J,this.f.fire())}}e.$Ih=ke;class Te extends ke{constructor(J,Y){super(Y),this.l=J}cancel(){this.l.cancel()}}e.$Jh=Te;function Se(me){const J=new I.$ee,Y=me(J.token);return new Te(J,async ce=>{const fe=J.token.onCancellationRequested(()=>{fe.dispose(),J.dispose(),ce.reject(new O.$5)});try{for await(const Ne of Y){if(J.token.isCancellationRequested)return;ce.emitOne(Ne)}fe.dispose(),J.dispose()}catch(Ne){fe.dispose(),J.dispose(),ce.reject(Ne)}})}class ve{constructor(){this.a=new be,this.b=new ke(ce=>{if(J){ce.reject(J);return}return Y&&ce.emitMany(Y),this.d=fe=>ce.reject(fe),this.f=fe=>ce.emitOne(fe),this.a.p});let J,Y;this.f=ce=>{Y||(Y=[]),Y.push(ce)},this.d=ce=>{J||(J=ce)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(J){this.d(J),this.a.complete()}emitOne(J){this.f(J)}}e.$Lh=ve}),define(Ce[35],Pe([1,0,18,11,46,28,19,21,15]),function($e,e,I,O,P,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_j=e.$$j=void 0,e.$0j=k,e.$ak=f,e.$bk=C,e.$ck=R,e.$dk=V,e.$ek=U,e.$fk=q,e.$gk=ne;function k(){return Object.create(null)}e.$$j="**",e.$_j="/";const F="[/\\\\]",E="[^/\\\\]",u=/\//g;function b(he,ye){switch(he){case 0:return"";case 1:return`${E}*?`;default:return`(?:${F}|${E}+${F}${ye?`|${F}${E}+`:""})*?`}}function f(he,ye){if(!he)return[];const Re=[];let ge=!1,ue=!1,te="";for(const be of he){switch(be){case ye:if(!ge&&!ue){Re.push(te),te="";continue}break;case"{":ge=!0;break;case"}":ge=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}te+=be}return te&&Re.push(te),Re}function r(he){if(!he)return"";let ye="";const Re=f(he,e.$_j);if(Re.every(ge=>ge===e.$$j))ye=".*";else{let ge=!1;Re.forEach((ue,te)=>{if(ue===e.$$j){if(ge)return;ye+=b(2,te===Re.length-1)}else{let be=!1,oe="",de=!1,W="";for(const ee of ue){if(ee!=="}"&&be){oe+=ee;continue}if(de&&(ee!=="]"||!W)){let ke;ee==="-"?ke=ee:(ee==="^"||ee==="!")&&!W?ke="^":ee===e.$_j?ke="":ke=(0,d.$Ze)(ee),W+=ke;continue}switch(ee){case"{":be=!0;continue;case"[":de=!0;continue;case"}":{const Te=`(?:${f(oe,",").map(Se=>r(Se)).join("|")})`;ye+=Te,be=!1,oe="";break}case"]":{ye+="["+W+"]",de=!1,W="";break}case"?":ye+=E;continue;case"*":ye+=b(1);continue;default:ye+=(0,d.$Ze)(ee)}}te<Re.length-1&&(Re[te+1]!==e.$$j||te+2<Re.length)&&(ye+=F)}ge=ue===e.$$j})}return ye}const o=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new N.$Ec(1e4),v=function(){return!1},c=function(){return null};function $(he,ye){if(!he)return c;let Re;typeof he!="string"?Re=he.pattern:Re=he,Re=Re.trim();const ge=`${Re}_${!!ye.trimForExclusions}`;let ue=t.get(ge);if(ue)return w(ue,he);let te;return o.test(Re)?ue=l(Re.substr(4),Re):(te=s.exec(p(Re,ye)))?ue=D(te[1],Re):(ye.trimForExclusions?i:n).test(Re)?ue=g(Re,ye):(te=a.exec(p(Re,ye)))?ue=S(te[1].substr(1),Re,!0):(te=h.exec(p(Re,ye)))?ue=S(te[1],Re,!1):ue=y(Re),t.set(ge,ue),w(ue,he)}function w(he,ye){if(typeof ye=="string")return he;const Re=function(ge,ue){return(0,P.$ig)(ge,ye.base,!m.$k)?he((0,d.$5e)(ge.substr(ye.base.length),A.sep),ue):null};return Re.allBasenames=he.allBasenames,Re.allPaths=he.allPaths,Re.basenames=he.basenames,Re.patterns=he.patterns,Re}function p(he,ye){return ye.trimForExclusions&&he.endsWith("/**")?he.substr(0,he.length-2):he}function l(he,ye){return function(Re,ge){return typeof Re=="string"&&Re.endsWith(he)?ye:null}}function D(he,ye){const Re=`/${he}`,ge=`\\${he}`,ue=function(be,oe){return typeof be!="string"?null:oe?oe===he?ye:null:be===he||be.endsWith(Re)||be.endsWith(ge)?ye:null},te=[he];return ue.basenames=te,ue.patterns=[ye],ue.allBasenames=te,ue}function g(he,ye){const Re=G(he.slice(1,-1).split(",").map(oe=>$(oe,ye)).filter(oe=>oe!==c),he),ge=Re.length;if(!ge)return c;if(ge===1)return Re[0];const ue=function(oe,de){for(let W=0,ee=Re.length;W<ee;W++)if(Re[W](oe,de))return he;return null},te=Re.find(oe=>!!oe.allBasenames);te&&(ue.allBasenames=te.allBasenames);const be=Re.reduce((oe,de)=>de.allPaths?oe.concat(de.allPaths):oe,[]);return be.length&&(ue.allPaths=be),ue}function S(he,ye,Re){const ge=A.sep===A.$hc.sep,ue=ge?he:he.replace(u,A.sep),te=A.sep+ue,be=A.$hc.sep+he;let oe;return Re?oe=function(de,W){return typeof de=="string"&&(de===ue||de.endsWith(te)||!ge&&(de===he||de.endsWith(be)))?ye:null}:oe=function(de,W){return typeof de=="string"&&(de===ue||!ge&&de===he)?ye:null},oe.allPaths=[(Re?"*/":"./")+he],oe}function y(he){try{const ye=new RegExp(`^${r(he)}$`);return function(Re){return ye.lastIndex=0,typeof Re=="string"&&ye.test(Re)?he:null}}catch{return c}}function C(he,ye,Re){return!he||typeof ye!="string"?!1:R(he)(ye,void 0,Re)}function R(he,ye={}){if(!he)return v;if(typeof he=="string"||V(he)){const Re=$(he,ye);if(Re===c)return v;const ge=function(ue,te){return!!Re(ue,te)};return Re.allBasenames&&(ge.allBasenames=Re.allBasenames),Re.allPaths&&(ge.allPaths=Re.allPaths),ge}return M(he,ye)}function V(he){const ye=he;return ye?typeof ye.base=="string"&&typeof ye.pattern=="string":!1}function U(he){return he.allBasenames||[]}function q(he){return he.allPaths||[]}function M(he,ye){const Re=G(Object.getOwnPropertyNames(he).map(oe=>L(oe,he[oe],ye)).filter(oe=>oe!==c)),ge=Re.length;if(!ge)return c;if(!Re.some(oe=>!!oe.requiresSiblings)){if(ge===1)return Re[0];const oe=function(ee,ke){let Te;for(let Se=0,ve=Re.length;Se<ve;Se++){const me=Re[Se](ee,ke);if(typeof me=="string")return me;(0,O.$7g)(me)&&(Te||(Te=[]),Te.push(me))}return Te?(async()=>{for(const Se of Te){const ve=await Se;if(typeof ve=="string")return ve}return null})():null},de=Re.find(ee=>!!ee.allBasenames);de&&(oe.allBasenames=de.allBasenames);const W=Re.reduce((ee,ke)=>ke.allPaths?ee.concat(ke.allPaths):ee,[]);return W.length&&(oe.allPaths=W),oe}const ue=function(oe,de,W){let ee,ke;for(let Te=0,Se=Re.length;Te<Se;Te++){const ve=Re[Te];ve.requiresSiblings&&W&&(de||(de=(0,A.$oc)(oe)),ee||(ee=de.substr(0,de.length-(0,A.$pc)(oe).length)));const me=ve(oe,de,ee,W);if(typeof me=="string")return me;(0,O.$7g)(me)&&(ke||(ke=[]),ke.push(me))}return ke?(async()=>{for(const Te of ke){const Se=await Te;if(typeof Se=="string")return Se}return null})():null},te=Re.find(oe=>!!oe.allBasenames);te&&(ue.allBasenames=te.allBasenames);const be=Re.reduce((oe,de)=>de.allPaths?oe.concat(de.allPaths):oe,[]);return be.length&&(ue.allPaths=be),ue}function L(he,ye,Re){if(ye===!1)return c;const ge=$(he,Re);if(ge===c)return c;if(typeof ye=="boolean")return ge;if(ye){const ue=ye.when;if(typeof ue=="string"){const te=(be,oe,de,W)=>{if(!W||!ge(be,oe))return null;const ee=ue.replace("$(basename)",()=>de),ke=W(ee);return(0,O.$7g)(ke)?ke.then(Te=>Te?he:null):ke?he:null};return te.requiresSiblings=!0,te}}return ge}function G(he,ye){const Re=he.filter(oe=>!!oe.basenames);if(Re.length<2)return he;const ge=Re.reduce((oe,de)=>{const W=de.basenames;return W?oe.concat(W):oe},[]);let ue;if(ye){ue=[];for(let oe=0,de=ge.length;oe<de;oe++)ue.push(ye)}else ue=Re.reduce((oe,de)=>{const W=de.patterns;return W?oe.concat(W):oe},[]);const te=function(oe,de){if(typeof oe!="string")return null;if(!de){let ee;for(ee=oe.length;ee>0;ee--){const ke=oe.charCodeAt(ee-1);if(ke===47||ke===92)break}de=oe.substr(ee)}const W=ge.indexOf(de);return W!==-1?ue[W]:null};te.basenames=ge,te.patterns=ue,te.allBasenames=ge;const be=he.filter(oe=>!oe.basenames);return be.push(te),be}function ne(he,ye){return(0,I.$ub)(he,ye,(Re,ge)=>typeof Re=="string"&&typeof ge=="string"?Re===ge:typeof Re!="string"&&typeof ge!="string"?Re.base===ge.base&&Re.pattern===ge.pattern:!1)}}),define(Ce[53],Pe([1,0,14,130,24,15,2]),function($e,e,I,O,P,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.MarkdownStringTextNewlineStyle=void 0,e.$Gk=k,e.$Hk=F,e.$Ik=E,e.$Jk=u,e.$Kk=b,e.$Lk=f,e.$Mk=r,e.$Nk=o;var m;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class d{constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,I.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=u(this.supportThemeIcons?(0,O.$zk)(n):n).replace(/([ \t]+)/g,(a,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${b(i,n)}
`,this}appendLink(n,i,a){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(n),")"),a&&(this.value+=` "${this.c(this.c(a,'"'),")")}"`),this.value+=")",this}c(n,i){const a=new RegExp((0,N.$Ze)(i),"g");return n.replace(a,(h,t)=>n.charAt(t-1)!=="\\"?`\\${h}`:h)}}e.$Fk=d;function k(s){return F(s)?!s.value:Array.isArray(s)?s.every(k):!0}function F(s){return s instanceof d?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}function E(s,n){return s===n?!0:!s||!n?!1:s.value===n.value&&s.isTrusted===n.isTrusted&&s.supportThemeIcons===n.supportThemeIcons&&s.supportHtml===n.supportHtml&&(s.baseUri===n.baseUri||!!s.baseUri&&!!n.baseUri&&(0,P.$Og)(A.URI.from(s.baseUri),A.URI.from(n.baseUri)))}function u(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function b(s,n){const i=s.match(/^`+/gm)?.reduce((h,t)=>h.length>t.length?h:t).length??0,a=i>=3?i+1:3;return[`${"`".repeat(a)}${n}`,s,`${"`".repeat(a)}`].join(`
`)}function f(s){return s.replace(/"/g,"&quot;")}function r(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(s){const n=[],i=s.split("|").map(h=>h.trim());s=i[0];const a=i[1];if(a){const h=/height=(\d+)/.exec(a),t=/width=(\d+)/.exec(a),v=h?h[1]:"",c=t?t[1]:"",$=isFinite(parseInt(c)),w=isFinite(parseInt(v));$&&n.push(`width="${c}"`),w&&n.push(`height="${v}"`)}return{href:s,dimensions:n}}}),define(Ce[96],Pe([1,0,18,46,19,21,24,15]),function($e,e,I,O,P,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gw=d,e.$hw=F,e.$iw=u,e.$jw=b,e.$kw=s,e.$lw=i,e.$mw=a,e.$nw=h,e.$ow=t,e.$pw=v;function d($,w){const{os:p,tildify:l,relative:D}=w;if(D){const y=k($,D,p);if(typeof y=="string")return y}let g=$.fsPath;if(p===1&&!N.$i?g=g.replace(/\//g,"\\"):p!==1&&N.$i&&(g=g.replace(/\\/g,"/")),p!==1&&l?.userHome){const y=l.userHome.fsPath;let C;$.scheme!==l.userHome.scheme&&$.path[0]===P.$hc.sep&&$.path[1]!==P.$hc.sep?C=l.userHome.with({path:$.path}).fsPath:C=g,g=u(C,y,p)}return(p===1?P.$gc:P.$hc).normalize(F(g,p===1))}function k($,w,p){const l=p===1?P.$gc:P.$hc,D=p===3?A.$Lg:A.$Ng,g=w.getWorkspace(),S=(0,I.$Ob)(g.folders);if(!S)return;$.scheme!==S.uri.scheme&&$.path[0]===P.$hc.sep&&$.path[1]!==P.$hc.sep&&($=S.uri.with({path:$.path}));const y=w.getWorkspaceFolder($);if(!y)return;let C;if(D.isEqual(y.uri,$)?C="":C=D.relativePath(y.uri,$)??"",C&&(C=l.normalize(C)),g.folders.length>1&&!w.noPrefix){const R=y.name?y.name:D.basenameOrAuthority(y.uri);C=C?`${R} \u2022 ${C}`:R}return C}function F($,w=N.$i){return(0,O.$mg)($,w)?$.charAt(0).toUpperCase()+$.slice(1):$}let E=Object.create(null);function u($,w,p=N.OS){if(p===1||!$||!w)return $;let l=E.original===w?E.normalized:void 0;l||(l=w,N.$i&&(l=(0,O.$cg)(l)),l=`${(0,m.$6e)(l,P.$hc.sep)}${P.$hc.sep}`,E={original:w,normalized:l});let D=$;return N.$i&&(D=(0,O.$cg)(D)),(p===3?D.startsWith(l):(0,m.$mf)(D,l))?`~/${D.substr(l.length)}`:$}function b($,w){return $.replace(/^~($|\/|\\)/,`${w}$1`)}const f="\u2026",r="\\\\",o="~";function s($,w=P.sep){const p=new Array($.length);let l=!1;for(let D=0;D<$.length;D++){const g=$[D];if(g===""){p[D]=`.${w}`;continue}if(!g){p[D]=g;continue}l=!0;let S="",y=g;y.indexOf(r)===0?(S=y.substr(0,y.indexOf(r)+r.length),y=y.substr(y.indexOf(r)+r.length)):y.indexOf(w)===0?(S=y.substr(0,y.indexOf(w)+w.length),y=y.substr(y.indexOf(w)+w.length)):y.indexOf(o)===0&&(S=y.substr(0,y.indexOf(o)+o.length),y=y.substr(y.indexOf(o)+o.length));const C=y.split(w);for(let R=1;l&&R<=C.length;R++)for(let V=C.length-R;l&&V>=0;V--){l=!1;let U=C.slice(V,V+R).join(w);for(let q=0;!l&&q<$.length;q++)if(q!==D&&$[q]&&$[q].indexOf(U)>-1){const M=V+R===C.length,L=V>0&&$[q].indexOf(w)>-1?w+U:U,G=$[q].endsWith(L);l=!M||G}if(!l){let q="";(C[0].endsWith(":")||S!=="")&&(V===1&&(V=0,R++,U=C[0]+w+U),V>0&&(q=C[0]+w),q=S+q),V>0&&(q=q+f+w),q=q+U,V+R<C.length&&(q=q+w+f),p[D]=q}}l&&(p[D]=g)}return p}var n;(function($){$[$.TEXT=0]="TEXT",$[$.VARIABLE=1]="VARIABLE",$[$.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i($,w=Object.create(null)){const p=[];let l=!1,D="";for(const g of $)if(g==="$"||l&&g==="{")D&&p.push({value:D,type:n.TEXT}),D="",l=!0;else if(g==="}"&&l){const S=w[D];if(typeof S=="string")S.length&&p.push({value:S,type:n.VARIABLE});else if(S){const y=p[p.length-1];(!y||y.type!==n.SEPARATOR)&&p.push({value:S.label,type:n.SEPARATOR})}D="",l=!1}else D+=g;return D&&!l&&p.push({value:D,type:n.TEXT}),p.filter((g,S)=>{if(g.type===n.SEPARATOR){const y=p[S-1],C=p[S+1];return[y,C].every(R=>R&&(R.type===n.VARIABLE||R.type===n.TEXT)&&R.value.length>0)}return!0}).map(g=>g.value).join("")}function a($,w){return N.$j||w?$.replace(/\(&&\w\)|&&/g,"").replace(/&/g,N.$j?"&":"&&"):$.replace(/&&|&/g,p=>p==="&"?"&&":"&")}function h($,w){return N.$j||w?$.replace(/\(&&\w\)|&&/g,""):N.$i?$.replace(/&&|&/g,p=>p==="&"?"&&":"&"):$.replace(/&&/g,"_")}function t($){return $.replace(/&/g,"&&")}function v($){if($.endsWith("]")){const w=$.lastIndexOf(" [",$.length-2);if(w!==-1){const p=c($.substring(0,w)),l=$.substring(w);return{name:p.name+l,parentPath:p.parentPath}}}return c($)}function c($){const w=$.indexOf("/")!==-1?P.$hc:P.$gc,p=w.basename($),l=w.dirname($);return p.length?{name:p,parentPath:l}:{name:l,parentPath:""}}}),define(Ce[143],Pe([1,0,23,2]),function($e,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=void 0,e.$mn=m,e.$nn=k,e.$on=F;function P(E){return E.toJSON()}class N{constructor(u){this.a=u}transformIncoming(u){const b=this.a.transformIncoming(u);return b===u?u:P(O.URI.from(b))}transformOutgoing(u){const b=this.a.transformOutgoing(u);return b===u?u:P(O.URI.from(b))}transformOutgoingURI(u){const b=this.a.transformOutgoing(u);return b===u?u:O.URI.from(b)}transformOutgoingScheme(u){return this.a.transformOutgoingScheme(u)}}e.$kn=N,e.$ln=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function A(E,u,b){if(!E||b>200)return null;if(typeof E=="object"){if(E instanceof O.URI)return u.transformOutgoing(E);for(const f in E)if(Object.hasOwnProperty.call(E,f)){const r=A(E[f],u,b+1);r!==null&&(E[f]=r)}}return null}function m(E,u){const b=A(E,u,0);return b===null?E:b}function d(E,u,b,f){if(!E||f>200)return null;if(typeof E=="object"){if(E.$mid===1)return b?O.URI.revive(u.transformIncoming(E)):u.transformIncoming(E);if(E instanceof I.$ue)return null;for(const r in E)if(Object.hasOwnProperty.call(E,r)){const o=d(E[r],u,b,f+1);o!==null&&(E[r]=o)}}return null}function k(E,u){const b=d(E,u,!1,0);return b===null?E:b}function F(E,u){const b=d(E,u,!0,0);return b===null?E:b}}),define(Ce[144],Pe([1,0,15,21,23]),function($e,e,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=void 0,e.$ut=F,e.$vt=E;let N;function A(){return N||(N=new TextDecoder("UTF-16LE")),N}let m;function d(){return m||(m=new TextDecoder("UTF-16BE")),m}let k;function F(){return k||(k=O.$D()?A():d()),k}function E(f,r,o){const s=new Uint16Array(f.buffer,r,o);return o>0&&(s[0]===65279||s[0]===65534)?u(f,r,o):A().decode(s)}function u(f,r,o){const s=[];let n=0;for(let i=0;i<o;i++){const a=P.$we(f,r);r+=2,s[n++]=String.fromCharCode(a)}return s.join("")}class b{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return F().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const o=this.a-this.d;o<=1&&(o===0||I.$pf(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const o=r.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=r;return}for(let s=0;s<o;s++)this.b[this.d++]=r.charCodeAt(s)}}e.$wt=b}),define(Ce[145],Pe([1,0,23,144]),function($e,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xt=void 0,e.$yt=A;function P(d){return d.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class N{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(k,F,E,u){this.oldPosition=k,this.oldText=F,this.newPosition=E,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(k){return 4+2*k.length}static c(k,F,E){const u=F.length;I.$ze(k,u,E),E+=4;for(let b=0;b<u;b++)I.$xe(k,F.charCodeAt(b),E),E+=2;return E}static d(k,F){const E=I.$ye(k,F);return F+=4,(0,O.$vt)(k,F,E)}writeSize(){return 8+N.a(this.oldText)+N.a(this.newText)}write(k,F){return I.$ze(k,this.oldPosition,F),F+=4,I.$ze(k,this.newPosition,F),F+=4,F=N.c(k,this.oldText,F),F=N.c(k,this.newText,F),F}static read(k,F,E){const u=I.$ye(k,F);F+=4;const b=I.$ye(k,F);F+=4;const f=N.d(k,F);F+=N.a(f);const r=N.d(k,F);return F+=N.a(r),E.push(new N(u,f,b,r)),F}}e.$xt=N;function A(d,k){return d===null||d.length===0?k:new m(d,k).compress()}class m{constructor(k,F){this.a=k,this.c=F,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let k=0,F=0,E=this.n(k),u=this.l(F);for(;k<this.f||F<this.h;){if(E===null){this.k(u),u=this.l(++F);continue}if(u===null){this.m(E),E=this.n(++k);continue}if(u.oldEnd<=E.newPosition){this.k(u),u=this.l(++F);continue}if(E.newEnd<=u.oldPosition){this.m(E),E=this.n(++k);continue}if(u.oldPosition<E.newPosition){const[s,n]=m.r(u,E.newPosition-u.oldPosition);this.k(s),u=n;continue}if(E.newPosition<u.oldPosition){const[s,n]=m.q(E,u.oldPosition-E.newPosition);this.m(s),E=n;continue}let r,o;if(u.oldEnd===E.newEnd)r=E,o=u,E=this.n(++k),u=this.l(++F);else if(u.oldEnd<E.newEnd){const[s,n]=m.q(E,u.oldLength);r=s,o=u,E=n,u=this.l(++F)}else{const[s,n]=m.r(u,E.newLength);r=E,o=s,E=this.n(++k),u=n}this.d[this.e++]=new N(r.oldPosition,r.oldText,o.newPosition,o.newText),this.g+=r.newLength-r.oldLength,this.j+=o.newLength-o.oldLength}const b=m.s(this.d);return m.t(b)}k(k){this.d[this.e++]=m.o(this.g,k),this.j+=k.newLength-k.oldLength}l(k){return k<this.h?this.c[k]:null}m(k){this.d[this.e++]=m.p(this.j,k),this.g+=k.newLength-k.oldLength}n(k){return k<this.f?this.a[k]:null}static o(k,F){return new N(F.oldPosition-k,F.oldText,F.newPosition,F.newText)}static p(k,F){return new N(F.oldPosition,F.oldText,F.newPosition+k,F.newText)}static q(k,F){const E=k.newText.substr(0,F),u=k.newText.substr(F);return[new N(k.oldPosition,k.oldText,k.newPosition,E),new N(k.oldEnd,"",k.newPosition+F,u)]}static r(k,F){const E=k.oldText.substr(0,F),u=k.oldText.substr(F);return[new N(k.oldPosition,E,k.newPosition,k.newText),new N(k.oldPosition+F,u,k.newEnd,"")]}static s(k){if(k.length===0)return k;const F=[];let E=0,u=k[0];for(let b=1;b<k.length;b++){const f=k[b];u.oldEnd===f.oldPosition?u=new N(u.oldPosition,u.oldText+f.oldText,u.newPosition,u.newText+f.newText):(F[E++]=u,u=f)}return F[E++]=u,F}static t(k){if(k.length===0)return k;const F=[];let E=0;for(let u=0;u<k.length;u++){const b=k[u];b.oldText!==b.newText&&(F[E++]=b)}return F}}}),define(Ce[146],Pe([1,0,35,19]),function($e,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vt=P,e.$Wt=N;function P(A,m,d,k,F,E){if(Array.isArray(A)){let u=0;for(const b of A){const f=P(b,m,d,k,F,E);if(f===10)return f;f>u&&(u=f)}return u}else{if(typeof A=="string")return k?A==="*"?5:A===d?10:0:0;if(A){const{language:u,pattern:b,scheme:f,hasAccessToAllModels:r,notebookType:o}=A;if(!k&&!r)return 0;o&&F&&(m=F);let s=0;if(f)if(f===m.scheme)s=10;else if(f==="*")s=5;else return 0;if(u)if(u===d)s=10;else if(u==="*")s=Math.max(s,5);else return 0;if(o)if(o===E)s=10;else if(o==="*"&&E!==void 0)s=Math.max(s,5);else return 0;if(b){let n;if(typeof b=="string"?n=b:n={...b,base:(0,O.$ic)(b.base)},n===m.fsPath||(0,I.$bk)(n,m.fsPath))s=10;else return 0}return s}else return 0}}function N(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(N):!!A.notebookType}}),define(Ce[147],Pe([1,0,5,15,29,94,92,132,145,6]),function($e,e,I,O,P,N,A,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zC=void 0;class F extends k.$Uc{constructor(u,b,f,r,o,s,n){super(),this.m=this.B(new I.$7d),this.onDidChangeContent=this.m.event,this.f=b,this.j=!s,this.g=r,this.h=o,this.c=new A.$yC(u,f,n)}equals(u){return!(u instanceof F)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,b){return this.c.getOffsetAt(u,b)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,b){const f=u+b,r=this.getPositionAt(u),o=this.getPositionAt(f);return new P.$ct(r.lineNumber,r.column,o.lineNumber,o.column)}getValueInRange(u,b=0){if(u.isEmpty())return"";const f=this.n(b);return this.c.getValueInRange(u,f)}getValueLengthInRange(u,b=0){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const f=this.getOffsetAt(u.startLineNumber,u.startColumn),r=this.getOffsetAt(u.endLineNumber,u.endColumn);let o=0;const s=this.n(b),n=this.getEOL();if(s.length!==n.length){const i=s.length-n.length,a=u.endLineNumber-u.startLineNumber;o=i*a}return r-f+o}getCharacterCountInRange(u,b=0){if(this.j){let f=0;const r=u.startLineNumber,o=u.endLineNumber;for(let s=r;s<=o;s++){const n=this.getLineContent(s),i=s===r?u.startColumn-1:0,a=s===o?u.endColumn-1:n.length;for(let h=i;h<a;h++)O.$pf(n.charCodeAt(h))?(f=f+1,h=h+1):f=f+1}return f+=this.n(b).length*(o-r),f}return this.getValueLengthInRange(u,b)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,b){return this.c.getLineCharCode(u,b)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const b=O.$af(this.getLineContent(u));return b===-1?0:b+1}getLineLastNonWhitespaceColumn(u){const b=O.$cf(this.getLineContent(u));return b===-1?0:b+2}n(u){switch(u){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,b,f){let r=this.g,o=this.h,s=this.j,n=!0,i=[];for(let w=0;w<u.length;w++){const p=u[w];n&&p._isTracked&&(n=!1);const l=p.range;if(p.text){let C=!0;s||(C=!O.$Af(p.text),s=C),!r&&C&&(r=O.$zf(p.text)),!o&&C&&(o=O.$Cf(p.text))}let D="",g=0,S=0,y=0;if(p.text){let C;[g,S,y,C]=(0,m.$Ot)(p.text);const R=this.getEOL();C===0||C===(R===`\r
`?2:1)?D=p.text:D=p.text.replace(/\r\n|\r|\n/g,R)}i[w]={sortIndex:w,identifier:p.identifier||null,range:l,rangeOffset:this.getOffsetAt(l.startLineNumber,l.startColumn),rangeLength:this.getValueLengthInRange(l),text:D,eolCount:g,firstLineLength:S,lastLineLength:y,forceMoveMarkers:!!p.forceMoveMarkers,isAutoWhitespaceEdit:p.isAutoWhitespaceEdit||!1}}i.sort(F.u);let a=!1;for(let w=0,p=i.length-1;w<p;w++){const l=i[w].range.getEndPosition(),D=i[w+1].range.getStartPosition();if(D.isBeforeOrEqual(l)){if(D.isBefore(l))throw new Error("Overlapping ranges are not allowed!");a=!0}}n&&(i=this.s(i));const h=f||b?F._getInverseEditRanges(i):[],t=[];if(b)for(let w=0;w<i.length;w++){const p=i[w],l=h[w];if(p.isAutoWhitespaceEdit&&p.range.isEmpty())for(let D=l.startLineNumber;D<=l.endLineNumber;D++){let g="";D===l.startLineNumber&&(g=this.getLineContent(p.range.startLineNumber),O.$af(g)!==-1)||t.push({lineNumber:D,oldContent:g})}}let v=null;if(f){let w=0;v=[];for(let p=0;p<i.length;p++){const l=i[p],D=h[p],g=this.getValueInRange(l.range),S=l.rangeOffset+w;w+=l.text.length-g.length,v[p]={sortIndex:l.sortIndex,identifier:l.identifier,range:D,text:g,textChange:new d.$xt(l.rangeOffset,g,S,l.text)}}a||v.sort((p,l)=>p.sortIndex-l.sortIndex)}this.g=r,this.h=o,this.j=s;const c=this.t(i);let $=null;if(b&&t.length>0){t.sort((w,p)=>p.lineNumber-w.lineNumber),$=[];for(let w=0,p=t.length;w<p;w++){const l=t[w].lineNumber;if(w>0&&t[w-1].lineNumber===l)continue;const D=t[w].oldContent,g=this.getLineContent(l);g.length===0||g===D||O.$af(g)!==-1||$.push(l)}}return this.m.fire(),new N.$Av(v,c,$)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let b=!1;const f=u[0].range,r=u[u.length-1].range,o=new P.$ct(f.startLineNumber,f.startColumn,r.endLineNumber,r.endColumn);let s=f.startLineNumber,n=f.startColumn;const i=[];for(let c=0,$=u.length;c<$;c++){const w=u[c],p=w.range;b=b||w.forceMoveMarkers,i.push(this.getValueInRange(new P.$ct(s,n,p.startLineNumber,p.startColumn))),w.text.length>0&&i.push(w.text),s=p.endLineNumber,n=p.endColumn}const a=i.join(""),[h,t,v]=(0,m.$Ot)(a);return{sortIndex:0,identifier:u[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:a,eolCount:h,firstLineLength:t,lastLineLength:v,forceMoveMarkers:b,isAutoWhitespaceEdit:!1}}t(u){u.sort(F.w);const b=[];for(let f=0;f<u.length;f++){const r=u[f],o=r.range.startLineNumber,s=r.range.startColumn,n=r.range.endLineNumber,i=r.range.endColumn;if(o===n&&s===i&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const a=new P.$ct(o,s,n,i);b.push({range:a,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return b}findMatchesLineByLine(u,b,f,r){return this.c.findMatchesLineByLine(u,b,f,r)}getPieceTree(){return this.c}static _getInverseEditRange(u,b){const f=u.startLineNumber,r=u.startColumn,[o,s,n]=(0,m.$Ot)(b);let i;if(b.length>0){const a=o+1;a===1?i=new P.$ct(f,r,f,r+s):i=new P.$ct(f,r,f+a-1,n+1)}else i=new P.$ct(f,r,f,r);return i}static _getInverseEditRanges(u){const b=[];let f=0,r=0,o=null;for(let s=0,n=u.length;s<n;s++){const i=u[s];let a,h;o?o.range.endLineNumber===i.range.startLineNumber?(a=f,h=r+(i.range.startColumn-o.range.endColumn)):(a=f+(i.range.startLineNumber-o.range.endLineNumber),h=i.range.startColumn):(a=i.range.startLineNumber,h=i.range.startColumn);let t;if(i.text.length>0){const v=i.eolCount+1;v===1?t=new P.$ct(a,h,a,h+i.firstLineLength):t=new P.$ct(a,h,a+v-1,i.lastLineLength+1)}else t=new P.$ct(a,h,a,h);f=t.endLineNumber,r=t.endColumn,b.push(t),o=i}return b}static u(u,b){const f=P.$ct.compareRangesUsingEnds(u.range,b.range);return f===0?u.sortIndex-b.sortIndex:f}static w(u,b){const f=P.$ct.compareRangesUsingEnds(u.range,b.range);return f===0?b.sortIndex-u.sortIndex:-f}}e.$zC=F}),define(Ce[148],Pe([1,0,15,92,147]),function($e,e,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AC=void 0;class N{constructor(d,k,F,E,u,b,f,r,o){this.a=d,this.b=k,this.c=F,this.d=E,this.e=u,this.f=b,this.g=f,this.h=r,this.j=o}k(d){const k=this.c+this.d+this.e,F=this.c+this.e;return k===0?d===1?`
`:`\r
`:F>k/2?`\r
`:`
`}create(d){const k=this.k(d),F=this.a;if(this.j&&(k===`\r
`&&(this.c>0||this.d>0)||k===`
`&&(this.c>0||this.e>0)))for(let u=0,b=F.length;u<b;u++){const f=F[u].buffer.replace(/\r\n|\r|\n/g,k),r=(0,O.$uC)(f);F[u]=new O.$xC(f,r)}const E=new P.$zC(F,this.b,k,this.f,this.g,this.h,this.j);return{textBuffer:E,disposable:E}}getFirstLineText(d){return this.a[0].buffer.substr(0,d).split(/\r\n|\r|\n/)[0]}}class A{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(d){if(d.length===0)return;this.a.length===0&&I.$Jf(d)&&(this.b=I.$If,d=d.substr(1));const k=d.charCodeAt(d.length-1);k===13||k>=55296&&k<=56319?(this.m(d.substr(0,d.length-1),!1),this.c=!0,this.d=k):(this.m(d,!1),this.c=!1,this.d=k)}m(d,k){!k&&d.length===0||(this.c?this.n(String.fromCharCode(this.d)+d):this.n(d))}n(d){const k=(0,O.$vC)(this.e,d);this.a.push(new O.$xC(d,k.lineStarts)),this.f+=k.cr,this.g+=k.lf,this.h+=k.crlf,k.isBasicASCII||(this.l=!1,this.j||(this.j=I.$zf(d)),this.k||(this.k=I.$Cf(d)))}finish(d=!0){return this.o(),new N(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,d)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const d=this.a[this.a.length-1];d.buffer+=String.fromCharCode(this.d);const k=(0,O.$uC)(d.buffer);d.lineStarts=k,this.d===13&&this.f++}}}e.$AC=A}),define(Ce[97],Pe([1,0,23,21]),function($e,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dab=d,e.$Eab=F;var P;(function(E){E[E.Full=1]="Full",E[E.Delta=2]="Delta"})(P||(P={}));function N(E){for(let u=0,b=E.length;u<b;u+=4){const f=E[u+0],r=E[u+1],o=E[u+2],s=E[u+3];E[u+0]=s,E[u+1]=o,E[u+2]=r,E[u+3]=f}}function A(E){const u=new Uint8Array(E.buffer,E.byteOffset,E.length*4);return O.$D()||N(u),I.$ue.wrap(u)}function m(E){const u=E.buffer;if(O.$D()||N(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const b=new Uint8Array(u.byteLength);return b.set(u),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function d(E){const u=new Uint32Array(k(E));let b=0;if(u[b++]=E.id,E.type==="full")u[b++]=1,u[b++]=E.data.length,u.set(E.data,b),b+=E.data.length;else{u[b++]=2,u[b++]=E.deltas.length;for(const f of E.deltas)u[b++]=f.start,u[b++]=f.deleteCount,f.data?(u[b++]=f.data.length,u.set(f.data,b),b+=f.data.length):u[b++]=0}return A(u)}function k(E){let u=0;if(u+=2,E.type==="full")u+=1+E.data.length;else{u+=1,u+=3*E.deltas.length;for(const b of E.deltas)b.data&&(u+=b.data.length)}return u}function F(E){const u=m(E);let b=0;const f=u[b++];if(u[b++]===1){const n=u[b++],i=u.subarray(b,b+n);return b+=n,{id:f,type:"full",data:i}}const o=u[b++],s=[];for(let n=0;n<o;n++){const i=u[b++],a=u[b++],h=u[b++];let t;h>0&&(t=u.subarray(b,b+h),b+=h),s[n]={start:i,deleteCount:a,data:t}}return{id:f,type:"delta",deltas:s}}}),define(Ce[149],Pe([9,10]),function($e,e){return $e.create("vs/editor/common/config/editorOptions",e)}),define(Ce[150],Pe([1,0,18,26,21,133,151,149]),function($e,e,I,O,P,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=o,e.clampedInt=n,e.clampedFloat=a,e.stringSet=v,e.cursorStyleToString=y,e.filterValidationDecorations=fe;var d;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(d||(e.EditorAutoIndentStrategy=d={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(Z){this.c=Z}hasChanged(Z){return this.c[Z]}}e.ConfigurationChangedEvent=k;class F{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=F;class E{constructor(Z,pe,qe,Ze){this.id=Z,this.name=pe,this.defaultValue=qe,this.schema=Ze}applyUpdate(Z,pe){return b(Z,pe)}compute(Z,pe,qe){return qe}}class u{constructor(Z,pe){this.newValue=Z,this.didChange=pe}}e.ApplyUpdateResult=u;function b(X,Z){if(typeof X!="object"||typeof Z!="object"||!X||!Z)return new u(Z,X!==Z);if(Array.isArray(X)||Array.isArray(Z)){const qe=Array.isArray(X)&&Array.isArray(Z)&&I.$ub(X,Z);return new u(Z,!qe)}let pe=!1;for(const qe in Z)if(Z.hasOwnProperty(qe)){const Ze=b(X[qe],Z[qe]);Ze.didChange&&(X[qe]=Ze.newValue,pe=!0)}return new u(X,pe)}class f{constructor(Z){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0}applyUpdate(Z,pe){return b(Z,pe)}validate(Z){return this.defaultValue}}class r{constructor(Z,pe,qe,Ze){this.id=Z,this.name=pe,this.defaultValue=qe,this.schema=Ze}applyUpdate(Z,pe){return b(Z,pe)}validate(Z){return typeof Z>"u"?this.defaultValue:Z}compute(Z,pe,qe){return qe}}function o(X,Z){return typeof X>"u"?Z:X==="false"?!1:!!X}class s extends r{constructor(Z,pe,qe,Ze=void 0){typeof Ze<"u"&&(Ze.type="boolean",Ze.default=qe),super(Z,pe,qe,Ze)}validate(Z){return o(Z,this.defaultValue)}}function n(X,Z,pe,qe){if(typeof X>"u")return Z;let Ze=parseInt(X,10);return isNaN(Ze)?Z:(Ze=Math.max(pe,Ze),Ze=Math.min(qe,Ze),Ze|0)}class i extends r{static clampedInt(Z,pe,qe,Ze){return n(Z,pe,qe,Ze)}constructor(Z,pe,qe,Ze,Me,dt=void 0){typeof dt<"u"&&(dt.type="integer",dt.default=qe,dt.minimum=Ze,dt.maximum=Me),super(Z,pe,qe,dt),this.minimum=Ze,this.maximum=Me}validate(Z){return i.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}function a(X,Z,pe,qe){if(typeof X>"u")return Z;const Ze=h.float(X,Z);return h.clamp(Ze,pe,qe)}class h extends r{static clamp(Z,pe,qe){return Z<pe?pe:Z>qe?qe:Z}static float(Z,pe){if(typeof Z=="number")return Z;if(typeof Z>"u")return pe;const qe=parseFloat(Z);return isNaN(qe)?pe:qe}constructor(Z,pe,qe,Ze,Me){typeof Me<"u"&&(Me.type="number",Me.default=qe),super(Z,pe,qe,Me),this.validationFn=Ze}validate(Z){return this.validationFn(h.float(Z,this.defaultValue))}}class t extends r{static string(Z,pe){return typeof Z!="string"?pe:Z}constructor(Z,pe,qe,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.default=qe),super(Z,pe,qe,Ze)}validate(Z){return t.string(Z,this.defaultValue)}}function v(X,Z,pe,qe){return typeof X!="string"?Z:qe&&X in qe?qe[X]:pe.indexOf(X)===-1?Z:X}class c extends r{constructor(Z,pe,qe,Ze,Me=void 0){typeof Me<"u"&&(Me.type="string",Me.enum=Ze,Me.default=qe),super(Z,pe,qe,Me),this.c=Ze}validate(Z){return v(Z,this.defaultValue,this.c)}}class $ extends E{constructor(Z,pe,qe,Ze,Me,dt,Pt=void 0){typeof Pt<"u"&&(Pt.type="string",Pt.enum=Me,Pt.default=Ze),super(Z,pe,qe,Pt),this.c=Me,this.d=dt}validate(Z){return typeof Z!="string"?this.defaultValue:this.c.indexOf(Z)===-1?this.defaultValue:this.d(Z)}}function w(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends E{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,pe,qe){return qe===0?Z.accessibilitySupport:qe}}class l extends E{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:m.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{insertSpace:o(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function g(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var S;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(S||(e.TextEditorCursorStyle=S={}));function y(X){switch(X){case S.Line:return"line";case S.Block:return"block";case S.Underline:return"underline";case S.LineThin:return"line-thin";case S.BlockOutline:return"block-outline";case S.UnderlineThin:return"underline-thin"}}function C(X){switch(X){case"line":return S.Line;case"block":return S.Block;case"underline":return S.Underline;case"line-thin":return S.LineThin;case"block-outline":return S.BlockOutline;case"underline-thin":return S.UnderlineThin}}class R extends f{constructor(){super(142)}compute(Z,pe,qe){const Ze=["monaco-editor"];return pe.get(39)&&Ze.push(pe.get(39)),Z.extraEditorClassName&&Ze.push(Z.extraEditorClassName),pe.get(74)==="default"?Ze.push("mouse-default"):pe.get(74)==="copy"&&Ze.push("mouse-copy"),pe.get(111)&&Ze.push("showUnused"),pe.get(140)&&Ze.push("showDeprecated"),Ze.join(" ")}}class V extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(Z,pe,qe){return qe&&Z.emptySelectionClipboard}}class U extends E{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:m.localize(16,null),included:P.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:m.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{cursorMoveOnType:o(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":v(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":v(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(pe.loop,this.defaultValue.loop)}}}class q extends E{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",q.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"||Z.length===0?q.OFF:Z==="true"?q.ON:Z:Z?q.ON:q.OFF}}e.EditorFontLigatures=q;class M extends E{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",M.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?M.OFF:Z==="true"?M.TRANSLATE:Z:Z?M.TRANSLATE:M.OFF}compute(Z,pe,qe){return Z.fontInfo.fontVariationSettings}}e.EditorFontVariations=M;class L extends f{constructor(){super(50)}compute(Z,pe,qe){return Z.fontInfo}}class G extends r{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(Z){const pe=h.float(Z,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(pe,6,100)}compute(Z,pe,qe){return Z.fontInfo.fontSize}}class ne extends E{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ne.d,maximum:ne.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ne.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(i.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,ne.d,ne.e))}}class he extends E{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:qe,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:qe,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:qe,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:qe,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:qe,description:m.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{multiple:v(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??v(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??v(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??v(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??v(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??v(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ye extends E{constructor(){const Z={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:Z.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:m.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Z.hidingDelay,description:m.localize(45,null)},"editor.hover.above":{type:"boolean",default:Z.above,description:m.localize(46,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:o(pe.enabled,this.defaultValue.enabled),delay:i.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:o(pe.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o(pe.above,this.defaultValue.above)}}}var Re;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(Re||(e.RenderMinimap=Re={}));class ge extends f{constructor(){super(145)}compute(Z,pe,qe){return ge.computeLayout(pe,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Z){const pe=Z.height/Z.lineHeight,qe=Math.floor(Z.paddingTop/Z.lineHeight);let Ze=Math.floor(Z.paddingBottom/Z.lineHeight);Z.scrollBeyondLastLine&&(Ze=Math.max(Ze,pe-1));const Me=(qe+Z.viewLineCount+Ze)/(Z.pixelRatio*Z.height),dt=Math.floor(Z.viewLineCount/Me);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:qe,extraLinesBeyondLastLine:Ze,desiredRatio:Me,minimapLineCount:dt}}static c(Z,pe){const qe=Z.outerWidth,Ze=Z.outerHeight,Me=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Me*Ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ze};const dt=pe.stableMinimapLayoutInput,Pt=dt&&Z.outerHeight===dt.outerHeight&&Z.lineHeight===dt.lineHeight&&Z.typicalHalfwidthCharacterWidth===dt.typicalHalfwidthCharacterWidth&&Z.pixelRatio===dt.pixelRatio&&Z.scrollBeyondLastLine===dt.scrollBeyondLastLine&&Z.paddingTop===dt.paddingTop&&Z.paddingBottom===dt.paddingBottom&&Z.minimap.enabled===dt.minimap.enabled&&Z.minimap.side===dt.minimap.side&&Z.minimap.size===dt.minimap.size&&Z.minimap.showSlider===dt.minimap.showSlider&&Z.minimap.renderCharacters===dt.minimap.renderCharacters&&Z.minimap.maxColumn===dt.minimap.maxColumn&&Z.minimap.scale===dt.minimap.scale&&Z.verticalScrollbarWidth===dt.verticalScrollbarWidth&&Z.isViewportWrapping===dt.isViewportWrapping,zt=Z.lineHeight,xt=Z.typicalHalfwidthCharacterWidth,Jt=Z.scrollBeyondLastLine,_t=Z.minimap.renderCharacters;let Et=Me>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Qt=Z.minimap.maxColumn,Vt=Z.minimap.size,ai=Z.minimap.side,Ye=Z.verticalScrollbarWidth,ei=Z.viewLineCount,ti=Z.remainingWidth,ht=Z.isViewportWrapping,vt=_t?2:3;let si=Math.floor(Me*Ze);const ii=si/Me;let Ft=!1,mt=!1,Mt=vt*Et,Wt=Et/Me,Zt=1;if(Vt==="fill"||Vt==="fit"){const{typicalViewportLineCount:Rt,extraLinesBeforeFirstLine:Lt,extraLinesBeyondLastLine:ni,desiredRatio:oi,minimapLineCount:qt}=ge.computeContainedMinimapLineCount({viewLineCount:ei,scrollBeyondLastLine:Jt,paddingTop:Z.paddingTop,paddingBottom:Z.paddingBottom,height:Ze,lineHeight:zt,pixelRatio:Me});if(ei/qt>1)Ft=!0,mt=!0,Et=1,Mt=1,Wt=Et/Me;else{let Dt=!1,Ht=Et+1;if(Vt==="fit"){const Ct=Math.ceil((Lt+ei+ni)*Mt);ht&&Pt&&ti<=pe.stableFitRemainingWidth?(Dt=!0,Ht=pe.stableFitMaxMinimapScale):Dt=Ct>si}if(Vt==="fill"||Dt){Ft=!0;const Ct=Et;Mt=Math.min(zt*Me,Math.max(1,Math.floor(1/oi))),ht&&Pt&&ti<=pe.stableFitRemainingWidth&&(Ht=pe.stableFitMaxMinimapScale),Et=Math.min(Ht,Math.max(1,Math.floor(Mt/vt))),Et>Ct&&(Zt=Math.min(2,Et/Ct)),Wt=Et/Me/Zt,si=Math.ceil(Math.max(Rt,Lt+ei+ni)*Mt),ht?(pe.stableMinimapLayoutInput=Z,pe.stableFitRemainingWidth=ti,pe.stableFitMaxMinimapScale=Et):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const Ke=Math.floor(Qt*Wt),Xt=Math.min(Ke,Math.max(0,Math.floor((ti-Ye-2)*Wt/(xt+Wt)))+e.MINIMAP_GUTTER_WIDTH);let jt=Math.floor(Me*Xt);const Ut=jt/Me;jt=Math.floor(jt*Zt);const $t=_t?1:2,Tt=ai==="left"?0:qe-Xt-Ye;return{renderMinimap:$t,minimapLeft:Tt,minimapWidth:Xt,minimapHeightIsEditorHeight:Ft,minimapIsSampling:mt,minimapScale:Et,minimapLineHeight:Mt,minimapCanvasInnerWidth:jt,minimapCanvasInnerHeight:si,minimapCanvasOuterWidth:Ut,minimapCanvasOuterHeight:ii}}static computeLayout(Z,pe){const qe=pe.outerWidth|0,Ze=pe.outerHeight|0,Me=pe.lineHeight|0,dt=pe.lineNumbersDigitCount|0,Pt=pe.typicalHalfwidthCharacterWidth,zt=pe.maxDigitWidth,xt=pe.pixelRatio,Jt=pe.viewLineCount,_t=Z.get(137),Et=_t==="inherit"?Z.get(136):_t,Qt=Et==="inherit"?Z.get(132):Et,Vt=Z.get(135),ai=pe.isDominatedByLongLines,Ye=Z.get(57),ei=Z.get(68).renderType!==0,ti=Z.get(69),ht=Z.get(105),vt=Z.get(84),si=Z.get(73),ii=Z.get(103),Ft=ii.verticalScrollbarSize,mt=ii.verticalHasArrows,Mt=ii.arrowSize,Wt=ii.horizontalScrollbarSize,Zt=Z.get(43),Ke=Z.get(110)!=="never";let Xt=Z.get(66);Zt&&Ke&&(Xt+=16);let jt=0;if(ei){const St=Math.max(dt,ti);jt=Math.round(St*zt)}let Ut=0;Ye&&(Ut=Me*pe.glyphMarginDecorationLaneCount);let $t=0,Tt=$t+Ut,Rt=Tt+jt,Lt=Rt+Xt;const ni=qe-Ut-jt-Xt;let oi=!1,qt=!1,It=-1;Et==="inherit"&&ai?(oi=!0,qt=!0):Qt==="on"||Qt==="bounded"?qt=!0:Qt==="wordWrapColumn"&&(It=Vt);const Dt=ge.c({outerWidth:qe,outerHeight:Ze,lineHeight:Me,typicalHalfwidthCharacterWidth:Pt,pixelRatio:xt,scrollBeyondLastLine:ht,paddingTop:vt.top,paddingBottom:vt.bottom,minimap:si,verticalScrollbarWidth:Ft,viewLineCount:Jt,remainingWidth:ni,isViewportWrapping:qt},pe.memory||new F);Dt.renderMinimap!==0&&Dt.minimapLeft===0&&($t+=Dt.minimapWidth,Tt+=Dt.minimapWidth,Rt+=Dt.minimapWidth,Lt+=Dt.minimapWidth);const Ht=ni-Dt.minimapWidth,Ct=Math.max(1,Math.floor((Ht-Ft-2)/Pt)),wt=mt?Mt:0;return qt&&(It=Math.max(1,Ct),Qt==="bounded"&&(It=Math.min(It,Vt))),{width:qe,height:Ze,glyphMarginLeft:$t,glyphMarginWidth:Ut,glyphMarginDecorationLaneCount:pe.glyphMarginDecorationLaneCount,lineNumbersLeft:Tt,lineNumbersWidth:jt,decorationsLeft:Rt,decorationsWidth:Xt,contentLeft:Lt,contentWidth:Ht,minimap:Dt,viewportColumn:Ct,isWordWrapMinified:oi,isViewportWrapping:qt,wrappingColumn:It,verticalScrollbarWidth:Ft,horizontalScrollbarHeight:Wt,overviewRuler:{top:wt,width:Ft,height:Ze-2*wt,right:0}}}}e.EditorLayoutInfoComputer=ge;class ue extends E{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(47,null),m.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(49,null)}})}validate(Z){return v(Z,"simple",["simple","advanced"])}compute(Z,pe,qe){return pe.get(2)===2?"advanced":qe}}var te;(function(X){X.Off="off",X.OnCode="onCode",X.On="on"})(te||(e.ShowLightbulbIconMode=te={}));class be extends E{constructor(){const Z={enabled:te.OnCode};super(65,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[te.Off,te.OnCode,te.On],default:Z.enabled,enumDescriptions:[m.localize(50,null),m.localize(51,null),m.localize(52,null)],description:m.localize(53,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:v(Z.enabled,this.defaultValue.enabled,[te.Off,te.OnCode,te.On])}}}class oe extends E{constructor(){const Z={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",Z,{"editor.stickyScroll.enabled":{type:"boolean",default:Z.enabled,description:m.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Z.maxLineCount,minimum:1,maximum:20,description:m.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Z.defaultModel,description:m.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Z.scrollWithEditor,description:m.localize(57,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:o(pe.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:v(pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o(pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class de extends E{constructor(){const Z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"string",default:Z.enabled,description:m.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(59,null),m.localize(60,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(61,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:m.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:m.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Z.padding,description:m.localize(65,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:v(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(pe.fontFamily,this.defaultValue.fontFamily),padding:o(pe.padding,this.defaultValue.padding)}}}class W extends E{constructor(){super(66,"lineDecorationsWidth",10)}validate(Z){return typeof Z=="string"&&/^\d+(\.\d+)?ch$/.test(Z)?-parseFloat(Z.substring(0,Z.length-2)):i.clampedInt(Z,this.defaultValue,0,1e3)}compute(Z,pe,qe){return qe<0?i.clampedInt(-qe*Z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):qe}}class ee extends h{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>h.clamp(Z,0,150),{markdownDescription:m.localize(66,null)})}compute(Z,pe,qe){return Z.fontInfo.lineHeight}}class ke extends E{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(73,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:m.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:Z.autohide,description:m.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(69,null),m.localize(70,null),m.localize(71,null)],default:Z.size,description:m.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:m.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:m.localize(74,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:m.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:m.localize(77,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:o(pe.enabled,this.defaultValue.enabled),autohide:o(pe.autohide,this.defaultValue.autohide),size:v(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:v(pe.side,this.defaultValue.side,["right","left"]),showSlider:v(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(pe.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(pe.scale,1,1,3),maxColumn:i.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Te(X){return X==="ctrlCmd"?P.$j?"metaKey":"ctrlKey":"altKey"}class Se extends E{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(79,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{top:i.clampedInt(pe.top,0,0,1e3),bottom:i.clampedInt(pe.bottom,0,0,1e3)}}}class ve extends E{constructor(){const Z={enabled:!0,cycle:!0};super(86,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:m.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:m.localize(81,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:o(pe.enabled,this.defaultValue.enabled),cycle:o(pe.cycle,this.defaultValue.cycle)}}}class me extends f{constructor(){super(143)}compute(Z,pe,qe){return Z.pixelRatio}}class J extends E{constructor(){const Z={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(82,null),m.localize(83,null),m.localize(84,null)]}];super(89,"quickSuggestions",Z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:Z.strings,description:m.localize(85,null)},comments:{anyOf:pe,default:Z.comments,description:m.localize(86,null)},other:{anyOf:pe,default:Z.other,description:m.localize(87,null)}},default:Z,markdownDescription:m.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Z}validate(Z){if(typeof Z=="boolean"){const xt=Z?"on":"off";return{comments:xt,strings:xt,other:xt}}if(!Z||typeof Z!="object")return this.defaultValue;const{other:pe,comments:qe,strings:Ze}=Z,Me=["on","inline","off"];let dt,Pt,zt;return typeof pe=="boolean"?dt=pe?"on":"off":dt=v(pe,this.defaultValue.other,Me),typeof qe=="boolean"?Pt=qe?"on":"off":Pt=v(qe,this.defaultValue.comments,Me),typeof Ze=="boolean"?zt=Ze?"on":"off":zt=v(Ze,this.defaultValue.strings,Me),{other:dt,comments:Pt,strings:zt}}}var Y;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(Y||(e.RenderLineNumbersType=Y={}));class ce extends E{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(89,null),m.localize(90,null),m.localize(91,null),m.localize(92,null)],default:"on",description:m.localize(93,null)})}validate(Z){let pe=this.defaultValue.renderType,qe=this.defaultValue.renderFn;return typeof Z<"u"&&(typeof Z=="function"?(pe=4,qe=Z):Z==="interval"?pe=3:Z==="relative"?pe=2:Z==="on"?pe=1:pe=0),{renderType:pe,renderFn:qe}}}function fe(X){const Z=X.get(98);return Z==="editable"?X.get(91):Z!=="on"}class Ne extends E{constructor(){const Z=[],pe={type:"number",description:m.localize(94,null)};super(102,"rulers",Z,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:m.localize(95,null),format:"color-hex"}}}]},default:Z,description:m.localize(96,null)})}validate(Z){if(Array.isArray(Z)){const pe=[];for(const qe of Z)if(typeof qe=="number")pe.push({column:i.clampedInt(qe,0,0,1e4),color:null});else if(qe&&typeof qe=="object"){const Ze=qe;pe.push({column:i.clampedInt(Ze.column,0,0,1e4),color:Ze.color})}return pe.sort((qe,Ze)=>qe.column-Ze.column),pe}return this.defaultValue}}class le extends E{constructor(){super(92,"readOnlyMessage",void 0)}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:Z}}function Ie(X,Z){if(typeof X!="string")return Z;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ae extends E{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(97,null),m.localize(98,null),m.localize(99,null)],default:"auto",description:m.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(101,null),m.localize(102,null),m.localize(103,null)],default:"auto",description:m.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:m.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:m.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:m.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Z.ignoreHorizontalScrollbarInContentHeight,description:m.localize(108,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z,qe=i.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ze=i.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(pe.vertical,this.defaultValue.vertical),horizontal:Ie(pe.horizontal,this.defaultValue.horizontal),useShadows:o(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:qe,horizontalSliderSize:i.clampedInt(pe.horizontalSliderSize,qe,0,1e3),verticalScrollbarSize:Ze,verticalSliderSize:i.clampedInt(pe.verticalSliderSize,Ze,0,1e3),scrollByPage:o(pe.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o(pe.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class je extends E{constructor(){const Z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",Z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.nonBasicASCII,description:m.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Z.invisibleCharacters,description:m.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Z.ambiguousCharacters,description:m.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeComments,description:m.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeStrings,description:m.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Z.allowedCharacters,description:m.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Z.allowedLocales,description:m.localize(115,null)}})}applyUpdate(Z,pe){let qe=!1;pe.allowedCharacters&&Z&&(O.$Sn(Z.allowedCharacters,pe.allowedCharacters)||(Z={...Z,allowedCharacters:pe.allowedCharacters},qe=!0)),pe.allowedLocales&&Z&&(O.$Sn(Z.allowedLocales,pe.allowedLocales)||(Z={...Z,allowedLocales:pe.allowedLocales},qe=!0));const Ze=super.applyUpdate(Z,pe);return qe?new u(Ze.newValue,!0):Ze}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{nonBasicASCII:_(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:_(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:_(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Z.allowedLocales,this.defaultValue.allowedLocales)}}c(Z,pe){if(typeof Z!="object"||!Z)return pe;const qe={};for(const[Ze,Me]of Object.entries(Z))Me===!0&&(qe[Ze]=!0);return qe}}class z extends E{constructor(){const Z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:m.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(117,null),m.localize(118,null),m.localize(119,null)],description:m.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Z.suppressSuggestions,description:m.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Z.fontFamily,description:m.localize(122,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:o(pe.enabled,this.defaultValue.enabled),mode:v(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:v(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o(pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o(pe.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class j extends E{constructor(){const Z={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",Z,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Z.enabled,description:m.localize(123,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(124,null),m.localize(125,null),m.localize(126,null)],description:m.localize(127,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Z.fontFamily,description:m.localize(128,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:Z.backgroundColoring,description:m.localize(129,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:o(pe.enabled,this.defaultValue.enabled),showToolbar:v(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(pe.fontFamily,this.defaultValue.fontFamily),keepOnBlur:o(pe.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:o(pe.backgroundColoring,this.defaultValue.backgroundColoring)}}}class K extends E{constructor(){const Z={enabled:N.$Ms.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:N.$Ms.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,markdownDescription:m.localize(130,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Z.independentColorPoolPerBracketType,description:m.localize(131,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:o(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends E{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(132,null),m.localize(133,null),m.localize(134,null)],default:Z.bracketPairs,description:m.localize(135,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(136,null),m.localize(137,null),m.localize(138,null)],default:Z.bracketPairsHorizontal,description:m.localize(139,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:m.localize(140,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:m.localize(141,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(142,null),m.localize(143,null),m.localize(144,null)],default:Z.highlightActiveIndentation,description:m.localize(145,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{bracketPairs:_(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:_(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:_(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function _(X,Z,pe){const qe=pe.indexOf(X);return qe===-1?Z:pe[qe]}class re extends E{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(146,null),m.localize(147,null)],default:Z.insertMode,description:m.localize(148,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:m.localize(149,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:m.localize(150,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:m.localize(151,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(152,null),m.localize(153,null),m.localize(154,null),m.localize(155,null)],default:Z.selectionMode,markdownDescription:m.localize(156,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:m.localize(157,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:m.localize(158,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:m.localize(159,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:m.localize(160,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:m.localize(161,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(162,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(163,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(164,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(165,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(166,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(179,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(180,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(181,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(182,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(183,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(184,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(185,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(186,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(187,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(188,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(189,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(190,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(191,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(192,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(193,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{insertMode:v(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:v(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(pe.showIcons,this.defaultValue.showIcons),showStatusBar:o(pe.showStatusBar,this.defaultValue.showStatusBar),preview:o(pe.preview,this.defaultValue.preview),previewMode:v(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(pe.showMethods,this.defaultValue.showMethods),showFunctions:o(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:o(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(pe.showFields,this.defaultValue.showFields),showVariables:o(pe.showVariables,this.defaultValue.showVariables),showClasses:o(pe.showClasses,this.defaultValue.showClasses),showStructs:o(pe.showStructs,this.defaultValue.showStructs),showInterfaces:o(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:o(pe.showModules,this.defaultValue.showModules),showProperties:o(pe.showProperties,this.defaultValue.showProperties),showEvents:o(pe.showEvents,this.defaultValue.showEvents),showOperators:o(pe.showOperators,this.defaultValue.showOperators),showUnits:o(pe.showUnits,this.defaultValue.showUnits),showValues:o(pe.showValues,this.defaultValue.showValues),showConstants:o(pe.showConstants,this.defaultValue.showConstants),showEnums:o(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:o(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(pe.showKeywords,this.defaultValue.showKeywords),showWords:o(pe.showWords,this.defaultValue.showWords),showColors:o(pe.showColors,this.defaultValue.showColors),showFiles:o(pe.showFiles,this.defaultValue.showFiles),showReferences:o(pe.showReferences,this.defaultValue.showReferences),showFolders:o(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:o(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(pe.showSnippets,this.defaultValue.showSnippets),showUsers:o(pe.showUsers,this.defaultValue.showUsers),showIssues:o(pe.showIssues,this.defaultValue.showIssues)}}}class Fe extends E{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(194,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(195,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(Z.selectSubwords,this.defaultValue.selectSubwords)}}}class Ve extends E{constructor(){const Z=[];super(130,"wordSegmenterLocales",Z,{anyOf:[{description:m.localize(196,null),type:"string"},{description:m.localize(197,null),type:"array",items:{type:"string"}}]})}validate(Z){if(typeof Z=="string"&&(Z=[Z]),Array.isArray(Z)){const pe=[];for(const qe of Z)if(typeof qe=="string")try{Intl.Segmenter.supportedLocalesOf(qe).length>0&&pe.push(qe)}catch{}return pe}return this.defaultValue}}var Qe;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(Qe||(e.WrappingIndent=Qe={}));class xe extends E{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(198,null),m.localize(199,null),m.localize(200,null),m.localize(201,null)],description:m.localize(202,null),default:"same"}})}validate(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Z,pe,qe){return pe.get(2)===2?0:qe}}class tt extends f{constructor(){super(146)}compute(Z,pe,qe){const Ze=pe.get(145);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:Ze.isWordWrapMinified,isViewportWrapping:Ze.isViewportWrapping,wrappingColumn:Ze.wrappingColumn}}}class at extends E{constructor(){const Z={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Z.enabled,markdownDescription:m.localize(203,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(204,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(205,null),m.localize(206,null)],default:"afterDrop"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:o(pe.enabled,this.defaultValue.enabled),showDropSelector:v(pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends E{constructor(){const Z={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",Z,{"editor.pasteAs.enabled":{type:"boolean",default:Z.enabled,markdownDescription:m.localize(207,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(208,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(209,null),m.localize(210,null)],default:"afterPaste"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:o(pe.enabled,this.defaultValue.enabled),showPasteSelector:v(pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const nt="Consolas, 'Courier New', monospace",ct="Menlo, Monaco, 'Courier New', monospace",ft="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$j?ct:P.$k?ft:nt,fontWeight:"normal",fontSize:P.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(X){return e.editorOptionsRegistry[X.id]=X,X}var ot;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.ariaRequired=5]="ariaRequired",X[X.autoClosingBrackets=6]="autoClosingBrackets",X[X.autoClosingComments=7]="autoClosingComments",X[X.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",X[X.autoClosingDelete=9]="autoClosingDelete",X[X.autoClosingOvertype=10]="autoClosingOvertype",X[X.autoClosingQuotes=11]="autoClosingQuotes",X[X.autoIndent=12]="autoIndent",X[X.automaticLayout=13]="automaticLayout",X[X.autoSurround=14]="autoSurround",X[X.bracketPairColorization=15]="bracketPairColorization",X[X.guides=16]="guides",X[X.codeLens=17]="codeLens",X[X.codeLensFontFamily=18]="codeLensFontFamily",X[X.codeLensFontSize=19]="codeLensFontSize",X[X.colorDecorators=20]="colorDecorators",X[X.colorDecoratorsLimit=21]="colorDecoratorsLimit",X[X.columnSelection=22]="columnSelection",X[X.comments=23]="comments",X[X.contextmenu=24]="contextmenu",X[X.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",X[X.cursorBlinking=26]="cursorBlinking",X[X.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",X[X.cursorStyle=28]="cursorStyle",X[X.cursorSurroundingLines=29]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",X[X.cursorWidth=31]="cursorWidth",X[X.disableLayerHinting=32]="disableLayerHinting",X[X.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",X[X.domReadOnly=34]="domReadOnly",X[X.dragAndDrop=35]="dragAndDrop",X[X.dropIntoEditor=36]="dropIntoEditor",X[X.emptySelectionClipboard=37]="emptySelectionClipboard",X[X.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",X[X.extraEditorClassName=39]="extraEditorClassName",X[X.fastScrollSensitivity=40]="fastScrollSensitivity",X[X.find=41]="find",X[X.fixedOverflowWidgets=42]="fixedOverflowWidgets",X[X.folding=43]="folding",X[X.foldingStrategy=44]="foldingStrategy",X[X.foldingHighlight=45]="foldingHighlight",X[X.foldingImportsByDefault=46]="foldingImportsByDefault",X[X.foldingMaximumRegions=47]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=49]="fontFamily",X[X.fontInfo=50]="fontInfo",X[X.fontLigatures=51]="fontLigatures",X[X.fontSize=52]="fontSize",X[X.fontWeight=53]="fontWeight",X[X.fontVariations=54]="fontVariations",X[X.formatOnPaste=55]="formatOnPaste",X[X.formatOnType=56]="formatOnType",X[X.glyphMargin=57]="glyphMargin",X[X.gotoLocation=58]="gotoLocation",X[X.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",X[X.hover=60]="hover",X[X.inDiffEditor=61]="inDiffEditor",X[X.inlineSuggest=62]="inlineSuggest",X[X.inlineEdit=63]="inlineEdit",X[X.letterSpacing=64]="letterSpacing",X[X.lightbulb=65]="lightbulb",X[X.lineDecorationsWidth=66]="lineDecorationsWidth",X[X.lineHeight=67]="lineHeight",X[X.lineNumbers=68]="lineNumbers",X[X.lineNumbersMinChars=69]="lineNumbersMinChars",X[X.linkedEditing=70]="linkedEditing",X[X.links=71]="links",X[X.matchBrackets=72]="matchBrackets",X[X.minimap=73]="minimap",X[X.mouseStyle=74]="mouseStyle",X[X.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=76]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",X[X.multiCursorModifier=78]="multiCursorModifier",X[X.multiCursorPaste=79]="multiCursorPaste",X[X.multiCursorLimit=80]="multiCursorLimit",X[X.occurrencesHighlight=81]="occurrencesHighlight",X[X.overviewRulerBorder=82]="overviewRulerBorder",X[X.overviewRulerLanes=83]="overviewRulerLanes",X[X.padding=84]="padding",X[X.pasteAs=85]="pasteAs",X[X.parameterHints=86]="parameterHints",X[X.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",X[X.quickSuggestions=89]="quickSuggestions",X[X.quickSuggestionsDelay=90]="quickSuggestionsDelay",X[X.readOnly=91]="readOnly",X[X.readOnlyMessage=92]="readOnlyMessage",X[X.renameOnType=93]="renameOnType",X[X.renderControlCharacters=94]="renderControlCharacters",X[X.renderFinalNewline=95]="renderFinalNewline",X[X.renderLineHighlight=96]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=98]="renderValidationDecorations",X[X.renderWhitespace=99]="renderWhitespace",X[X.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",X[X.roundedSelection=101]="roundedSelection",X[X.rulers=102]="rulers",X[X.scrollbar=103]="scrollbar",X[X.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=105]="scrollBeyondLastLine",X[X.scrollPredominantAxis=106]="scrollPredominantAxis",X[X.selectionClipboard=107]="selectionClipboard",X[X.selectionHighlight=108]="selectionHighlight",X[X.selectOnLineNumbers=109]="selectOnLineNumbers",X[X.showFoldingControls=110]="showFoldingControls",X[X.showUnused=111]="showUnused",X[X.snippetSuggestions=112]="snippetSuggestions",X[X.smartSelect=113]="smartSelect",X[X.smoothScrolling=114]="smoothScrolling",X[X.stickyScroll=115]="stickyScroll",X[X.stickyTabStops=116]="stickyTabStops",X[X.stopRenderingLineAfter=117]="stopRenderingLineAfter",X[X.suggest=118]="suggest",X[X.suggestFontSize=119]="suggestFontSize",X[X.suggestLineHeight=120]="suggestLineHeight",X[X.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",X[X.suggestSelection=122]="suggestSelection",X[X.tabCompletion=123]="tabCompletion",X[X.tabIndex=124]="tabIndex",X[X.unicodeHighlighting=125]="unicodeHighlighting",X[X.unusualLineTerminators=126]="unusualLineTerminators",X[X.useShadowDOM=127]="useShadowDOM",X[X.useTabStops=128]="useTabStops",X[X.wordBreak=129]="wordBreak",X[X.wordSegmenterLocales=130]="wordSegmenterLocales",X[X.wordSeparators=131]="wordSeparators",X[X.wordWrap=132]="wordWrap",X[X.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=135]="wordWrapColumn",X[X.wordWrapOverride1=136]="wordWrapOverride1",X[X.wordWrapOverride2=137]="wordWrapOverride2",X[X.wrappingIndent=138]="wrappingIndent",X[X.wrappingStrategy=139]="wrappingStrategy",X[X.showDeprecated=140]="showDeprecated",X[X.inlayHints=141]="inlayHints",X[X.editorClassName=142]="editorClassName",X[X.pixelRatio=143]="pixelRatio",X[X.tabFocusMode=144]="tabFocusMode",X[X.layoutInfo=145]="layoutInfo",X[X.wrappingInfo=146]="wrappingInfo",X[X.defaultColorDecorators=147]="defaultColorDecorators",X[X.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",X[X.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(ot||(e.EditorOption=ot={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(211,null)})),acceptSuggestionOnEnter:Ue(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(212,null),""],markdownDescription:m.localize(213,null)})),accessibilitySupport:Ue(new p),accessibilityPageSize:Ue(new i(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(214,null),tags:["accessibility"]})),ariaLabel:Ue(new t(4,"ariaLabel",m.localize(215,null))),ariaRequired:Ue(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ue(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(216,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new c(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(217,null),m.localize(218,null),""],description:m.localize(219,null)})),autoClosingComments:Ue(new c(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(220,null),m.localize(221,null),""],description:m.localize(222,null)})),autoClosingDelete:Ue(new c(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(223,null),""],description:m.localize(224,null)})),autoClosingOvertype:Ue(new c(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(225,null),""],description:m.localize(226,null)})),autoClosingQuotes:Ue(new c(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(227,null),m.localize(228,null),""],description:m.localize(229,null)})),autoIndent:Ue(new $(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],w,{enumDescriptions:[m.localize(230,null),m.localize(231,null),m.localize(232,null),m.localize(233,null),m.localize(234,null)],description:m.localize(235,null)})),automaticLayout:Ue(new s(13,"automaticLayout",!1)),autoSurround:Ue(new c(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(236,null),m.localize(237,null),m.localize(238,null),""],description:m.localize(239,null)})),bracketPairColorization:Ue(new K),bracketPairGuides:Ue(new H),stickyTabStops:Ue(new s(116,"stickyTabStops",!1,{description:m.localize(240,null)})),codeLens:Ue(new s(17,"codeLens",!0,{description:m.localize(241,null)})),codeLensFontFamily:Ue(new t(18,"codeLensFontFamily","",{description:m.localize(242,null)})),codeLensFontSize:Ue(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(243,null)})),colorDecorators:Ue(new s(20,"colorDecorators",!0,{description:m.localize(244,null)})),colorDecoratorActivatedOn:Ue(new c(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(245,null),m.localize(246,null),m.localize(247,null)],description:m.localize(248,null)})),colorDecoratorsLimit:Ue(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(249,null)})),columnSelection:Ue(new s(22,"columnSelection",!1,{description:m.localize(250,null)})),comments:Ue(new l),contextmenu:Ue(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new s(25,"copyWithSyntaxHighlighting",!0,{description:m.localize(251,null)})),cursorBlinking:Ue(new $(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],g,{description:m.localize(252,null)})),cursorSmoothCaretAnimation:Ue(new c(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(253,null),m.localize(254,null),m.localize(255,null)],description:m.localize(256,null)})),cursorStyle:Ue(new $(28,"cursorStyle",S.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:m.localize(257,null)})),cursorSurroundingLines:Ue(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(258,null)})),cursorSurroundingLinesStyle:Ue(new c(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(259,null),m.localize(260,null)],markdownDescription:m.localize(261,null)})),cursorWidth:Ue(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(262,null)})),disableLayerHinting:Ue(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new s(34,"domReadOnly",!1)),dragAndDrop:Ue(new s(35,"dragAndDrop",!0,{description:m.localize(263,null)})),emptySelectionClipboard:Ue(new V),dropIntoEditor:Ue(new at),stickyScroll:Ue(new oe),experimentalWhitespaceRendering:Ue(new c(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(264,null),m.localize(265,null),m.localize(266,null)],description:m.localize(267,null)})),extraEditorClassName:Ue(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ue(new h(40,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:m.localize(268,null)})),find:Ue(new U),fixedOverflowWidgets:Ue(new s(42,"fixedOverflowWidgets",!1)),folding:Ue(new s(43,"folding",!0,{description:m.localize(269,null)})),foldingStrategy:Ue(new c(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(270,null),m.localize(271,null)],description:m.localize(272,null)})),foldingHighlight:Ue(new s(45,"foldingHighlight",!0,{description:m.localize(273,null)})),foldingImportsByDefault:Ue(new s(46,"foldingImportsByDefault",!1,{description:m.localize(274,null)})),foldingMaximumRegions:Ue(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(275,null)})),unfoldOnClickAfterEndOfLine:Ue(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(276,null)})),fontFamily:Ue(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(277,null)})),fontInfo:Ue(new L),fontLigatures2:Ue(new q),fontSize:Ue(new G),fontWeight:Ue(new ne),fontVariations:Ue(new M),formatOnPaste:Ue(new s(55,"formatOnPaste",!1,{description:m.localize(278,null)})),formatOnType:Ue(new s(56,"formatOnType",!1,{description:m.localize(279,null)})),glyphMargin:Ue(new s(57,"glyphMargin",!0,{description:m.localize(280,null)})),gotoLocation:Ue(new he),hideCursorInOverviewRuler:Ue(new s(59,"hideCursorInOverviewRuler",!1,{description:m.localize(281,null)})),hover:Ue(new ye),inDiffEditor:Ue(new s(61,"inDiffEditor",!1)),letterSpacing:Ue(new h(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>h.clamp(X,-5,20),{description:m.localize(282,null)})),lightbulb:Ue(new be),lineDecorationsWidth:Ue(new W),lineHeight:Ue(new ee),lineNumbers:Ue(new ce),lineNumbersMinChars:Ue(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new s(70,"linkedEditing",!1,{description:m.localize(283,null)})),links:Ue(new s(71,"links",!0,{description:m.localize(284,null)})),matchBrackets:Ue(new c(72,"matchBrackets","always",["always","near","never"],{description:m.localize(285,null)})),minimap:Ue(new ke),mouseStyle:Ue(new c(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new h(75,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:m.localize(286,null)})),mouseWheelZoom:Ue(new s(76,"mouseWheelZoom",!1,{markdownDescription:P.$j?m.localize(287,null):m.localize(288,null)})),multiCursorMergeOverlapping:Ue(new s(77,"multiCursorMergeOverlapping",!0,{description:m.localize(289,null)})),multiCursorModifier:Ue(new $(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Te,{markdownEnumDescriptions:[m.localize(290,null),m.localize(291,null)],markdownDescription:m.localize(292,null)})),multiCursorPaste:Ue(new c(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(293,null),m.localize(294,null)],markdownDescription:m.localize(295,null)})),multiCursorLimit:Ue(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(296,null)})),occurrencesHighlight:Ue(new c(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[m.localize(297,null),m.localize(298,null),m.localize(299,null)],markdownDescription:m.localize(300,null)})),overviewRulerBorder:Ue(new s(82,"overviewRulerBorder",!0,{description:m.localize(301,null)})),overviewRulerLanes:Ue(new i(83,"overviewRulerLanes",3,0,3)),padding:Ue(new Se),pasteAs:Ue(new it),parameterHints:Ue(new ve),peekWidgetDefaultFocus:Ue(new c(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(302,null),m.localize(303,null)],description:m.localize(304,null)})),definitionLinkOpensInPeek:Ue(new s(88,"definitionLinkOpensInPeek",!1,{description:m.localize(305,null)})),quickSuggestions:Ue(new J),quickSuggestionsDelay:Ue(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(306,null)})),readOnly:Ue(new s(91,"readOnly",!1)),readOnlyMessage:Ue(new le),renameOnType:Ue(new s(93,"renameOnType",!1,{description:m.localize(307,null),markdownDeprecationMessage:m.localize(308,null)})),renderControlCharacters:Ue(new s(94,"renderControlCharacters",!0,{description:m.localize(309,null),restricted:!0})),renderFinalNewline:Ue(new c(95,"renderFinalNewline",P.$k?"dimmed":"on",["off","on","dimmed"],{description:m.localize(310,null)})),renderLineHighlight:Ue(new c(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(311,null)],description:m.localize(312,null)})),renderLineHighlightOnlyWhenFocus:Ue(new s(97,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(313,null)})),renderValidationDecorations:Ue(new c(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new c(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(314,null),m.localize(315,null),m.localize(316,null),""],description:m.localize(317,null)})),revealHorizontalRightPadding:Ue(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new s(101,"roundedSelection",!0,{description:m.localize(318,null)})),rulers:Ue(new Ne),scrollbar:Ue(new Ae),scrollBeyondLastColumn:Ue(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(319,null)})),scrollBeyondLastLine:Ue(new s(105,"scrollBeyondLastLine",!0,{description:m.localize(320,null)})),scrollPredominantAxis:Ue(new s(106,"scrollPredominantAxis",!0,{description:m.localize(321,null)})),selectionClipboard:Ue(new s(107,"selectionClipboard",!0,{description:m.localize(322,null),included:P.$k})),selectionHighlight:Ue(new s(108,"selectionHighlight",!0,{description:m.localize(323,null)})),selectOnLineNumbers:Ue(new s(109,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new c(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(324,null),m.localize(325,null),m.localize(326,null)],description:m.localize(327,null)})),showUnused:Ue(new s(111,"showUnused",!0,{description:m.localize(328,null)})),showDeprecated:Ue(new s(140,"showDeprecated",!0,{description:m.localize(329,null)})),inlayHints:Ue(new de),snippetSuggestions:Ue(new c(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(330,null),m.localize(331,null),m.localize(332,null),m.localize(333,null)],description:m.localize(334,null)})),smartSelect:Ue(new Fe),smoothScrolling:Ue(new s(114,"smoothScrolling",!1,{description:m.localize(335,null)})),stopRenderingLineAfter:Ue(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new re),inlineSuggest:Ue(new z),inlineEdit:Ue(new j),inlineCompletionsAccessibilityVerbose:Ue(new s(149,"inlineCompletionsAccessibilityVerbose",!1,{description:m.localize(336,null)})),suggestFontSize:Ue(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(337,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(338,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new s(121,"suggestOnTriggerCharacters",!0,{description:m.localize(339,null)})),suggestSelection:Ue(new c(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(340,null),m.localize(341,null),m.localize(342,null)],description:m.localize(343,null)})),tabCompletion:Ue(new c(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(344,null),m.localize(345,null),m.localize(346,null)],description:m.localize(347,null)})),tabIndex:Ue(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new je),unusualLineTerminators:Ue(new c(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(348,null),m.localize(349,null),m.localize(350,null)],description:m.localize(351,null)})),useShadowDOM:Ue(new s(127,"useShadowDOM",!0)),useTabStops:Ue(new s(128,"useTabStops",!0,{description:m.localize(352,null)})),wordBreak:Ue(new c(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(353,null),m.localize(354,null)],description:m.localize(355,null)})),wordSegmenterLocales:Ue(new Ve),wordSeparators:Ue(new t(131,"wordSeparators",A.$Ns,{description:m.localize(356,null)})),wordWrap:Ue(new c(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(357,null),m.localize(358,null),m.localize(359,null),m.localize(360,null)],description:m.localize(361,null)})),wordWrapBreakAfterCharacters:Ue(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(362,null)})),wordWrapOverride1:Ue(new c(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new c(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new R),defaultColorDecorators:Ue(new s(147,"defaultColorDecorators",!1,{markdownDescription:m.localize(363,null)})),pixelRatio:Ue(new me),tabFocusMode:Ue(new s(144,"tabFocusMode",!1,{markdownDescription:m.localize(364,null)})),layoutInfo:Ue(new ge),wrappingInfo:Ue(new tt),wrappingIndent:Ue(new xe),wrappingStrategy:Ue(new ue)}}),define(Ce[152],Pe([9,10]),function($e,e){return $e.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[153],Pe([9,10]),function($e,e){return $e.create("vs/platform/contextkey/common/contextkey",e)}),define(Ce[154],Pe([9,10]),function($e,e){return $e.create("vs/platform/contextkey/common/scanner",e)}),define(Ce[155],Pe([9,10]),function($e,e){return $e.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[156],Pe([9,10]),function($e,e){return $e.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[157],Pe([9,10]),function($e,e){return $e.create("vs/platform/files/common/files",e)}),define(Ce[158],Pe([9,10]),function($e,e){return $e.create("vs/platform/log/common/log",e)}),define(Ce[159],Pe([9,10]),function($e,e){return $e.create("vs/platform/markers/common/markers",e)}),define(Ce[160],Pe([9,10]),function($e,e){return $e.create("vs/platform/theme/common/iconRegistry",e)}),define(Ce[161],Pe([9,10]),function($e,e){return $e.create("vs/platform/workspace/common/workspace",e)}),define(Ce[162],Pe([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Ce[163],Pe([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[164],Pe([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[165],Pe([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ce[166],Pe([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Ce[167],Pe([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostLogService",e)}),define(Ce[168],Pe([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ce[169],Pe([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[170],Pe([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ce[171],Pe([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[172],Pe([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[173],Pe([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ce[174],Pe([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[175],Pe([9,10]),function($e,e){return $e.create("vs/workbench/common/configuration",e)}),define(Ce[176],Pe([9,10]),function($e,e){return $e.create("vs/workbench/common/editor",e)}),define(Ce[177],Pe([9,10]),function($e,e){return $e.create("vs/workbench/common/views",e)}),define(Ce[178],Pe([9,10]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[179],Pe([9,10]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[180],Pe([9,10]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[181],Pe([9,10]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[182],Pe([9,10]),function($e,e){return $e.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[183],Pe([9,10]),function($e,e){return $e.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ce[184],Pe([9,10]),function($e,e){return $e.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[185],Pe([9,10]),function($e,e){return $e.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[186],Pe([1,0,14,154]),function($e,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dj=e.TokenType=void 0;var P;(function(k){k[k.LParen=0]="LParen",k[k.RParen=1]="RParen",k[k.Neg=2]="Neg",k[k.Eq=3]="Eq",k[k.NotEq=4]="NotEq",k[k.Lt=5]="Lt",k[k.LtEq=6]="LtEq",k[k.Gt=7]="Gt",k[k.GtEq=8]="GtEq",k[k.RegexOp=9]="RegexOp",k[k.RegexStr=10]="RegexStr",k[k.True=11]="True",k[k.False=12]="False",k[k.In=13]="In",k[k.Not=14]="Not",k[k.And=15]="And",k[k.Or=16]="Or",k[k.Str=17]="Str",k[k.QuotedStr=18]="QuotedStr",k[k.Error=19]="Error",k[k.EOF=20]="EOF"})(P||(e.TokenType=P={}));function N(...k){switch(k.length){case 1:return(0,O.localize)(0,null,k[0]);case 2:return(0,O.localize)(1,null,k[0],k[1]);case 3:return(0,O.localize)(2,null,k[0],k[1],k[2]);default:return}}const A=(0,O.localize)(3,null),m=(0,O.localize)(4,null);class d{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(F){switch(F.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return F.isTripleEq?"===":"==";case 4:return F.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return F.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return F.lexeme;case 18:return F.lexeme;case 19:return F.lexeme;case 20:return"EOF";default:throw(0,I.$8)(`unhandled token type: ${JSON.stringify(F)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(F=>F.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(F){return this.c=F,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(N("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(N("&&"));break;case 124:this.h(124)?this.k(16):this.l(N("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(F){return this.r()||this.c.charCodeAt(this.e)!==F?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(F){this.f.push({type:F,offset:this.d})}l(F){const E=this.d,u=this.c.substring(this.d,this.e),b={type:19,offset:this.d,lexeme:u};this.g.push({offset:E,lexeme:u,additionalInfo:F}),this.f.push(b)}n(){this.m.lastIndex=this.d;const F=this.m.exec(this.c);if(F){this.e=this.d+F[0].length;const E=this.c.substring(this.d,this.e),u=d.b.get(E);u?this.k(u):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let F=this.e,E=!1,u=!1;for(;;){if(F>=this.c.length){this.e=F,this.l(m);return}const f=this.c.charCodeAt(F);if(E)E=!1;else if(f===47&&!u){F++;break}else f===91?u=!0:f===92?E=!0:f===93&&(u=!1);F++}for(;F<this.c.length&&d.a.has(this.c.charCodeAt(F));)F++;this.e=F;const b=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}e.$dj=d}),define(Ce[187],Pe([1,0,24,32,156,301]),function($e,e,I,O,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=d,e.$tp=k,e.$up=F,e.$vp=E,e.$wp=u,e.$xp=b,e.$yp=f;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function d(s){return s=s.trim(),s==="*"||A.test(s)}function k(s){if(!d(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=s.match(A);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function F(s){if(!s)return null;const n=s.majorBase,i=s.majorMustEqual,a=s.minorBase;let h=s.minorMustEqual;const t=s.patchBase;let v=s.patchMustEqual;s.hasCaret&&(n===0||(h=!1),v=!1);let c=0;if(s.preRelease){const $=m.exec(s.preRelease);if($){const[,w,p,l]=$;c=Date.UTC(Number(w),Number(p)-1,Number(l))}}return{majorBase:n,majorMustEqual:i,minorBase:a,minorMustEqual:h,patchBase:t,patchMustEqual:v,isMinimum:s.hasGreaterEquals,notBefore:c}}function E(s,n,i){let a;typeof s=="string"?a=F(k(s)):a=s;let h;n instanceof Date?h=n.getTime():typeof n=="string"&&(h=new Date(n).getTime());let t;if(typeof i=="string"?t=F(k(i)):t=i,!a||!t)return!1;const v=a.majorBase,c=a.minorBase,$=a.patchBase;let w=t.majorBase,p=t.minorBase,l=t.patchBase;const D=t.notBefore;let g=t.majorMustEqual,S=t.minorMustEqual,y=t.patchMustEqual;return t.isMinimum?v>w?!0:v<w?!1:c>p?!0:c<p||h&&h<D?!1:$>=l:(v===1&&w===0&&(!g||!S||!y)&&(w=1,p=0,l=0,g=!0,S=!1,y=!1),v<w?!1:v>w?!g:c<p?!1:c>p?!S:$<l?!1:$>l?!y:!(h&&h<D))}function u(s,n,i,a,h){const t=[];if(typeof a.publisher<"u"&&typeof a.publisher!="string")return t.push([O.default.Error,P.localize(0,null)]),t;if(typeof a.name!="string")return t.push([O.default.Error,P.localize(1,null,"name")]),t;if(typeof a.version!="string")return t.push([O.default.Error,P.localize(2,null,"version")]),t;if(!a.engines)return t.push([O.default.Error,P.localize(3,null,"engines")]),t;if(typeof a.engines.vscode!="string")return t.push([O.default.Error,P.localize(4,null,"engines.vscode")]),t;if(typeof a.extensionDependencies<"u"&&!o(a.extensionDependencies))return t.push([O.default.Error,P.localize(5,null,"extensionDependencies")]),t;if(typeof a.activationEvents<"u"){if(!o(a.activationEvents))return t.push([O.default.Error,P.localize(6,null,"activationEvents")]),t;if(typeof a.main>"u"&&typeof a.browser>"u")return t.push([O.default.Error,P.localize(7,null,"activationEvents","main","browser")]),t}if(typeof a.extensionKind<"u"&&typeof a.main>"u"&&t.push([O.default.Warning,P.localize(8,null,"extensionKind")]),typeof a.main<"u"){if(typeof a.main!="string")return t.push([O.default.Error,P.localize(9,null,"main")]),t;{const $=(0,I.$Vg)(i,a.main);(0,I.$Pg)($,i)||t.push([O.default.Warning,P.localize(10,null,$.path,i.path)])}}if(typeof a.browser<"u"){if(typeof a.browser!="string")return t.push([O.default.Error,P.localize(11,null,"browser")]),t;{const $=(0,I.$Vg)(i,a.browser);(0,I.$Pg)($,i)||t.push([O.default.Warning,P.localize(12,null,$.path,i.path)])}}if(!N.valid(a.version))return t.push([O.default.Error,P.localize(13,null)]),t;const v=[];if(!b(s,n,a,h,v))for(const $ of v)t.push([O.default.Error,$]);return t}function b(s,n,i,a,h){return a||typeof i.main>"u"&&typeof i.browser>"u"?!0:r(s,n,i.engines.vscode,h)}function f(s,n,i){return s==="*"||r(n,i,s)}function r(s,n,i,a=[]){const h=F(k(i));if(!h)return a.push(P.localize(14,null,i)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return a.push(P.localize(15,null,i)),!1}else if(!h.majorMustEqual)return a.push(P.localize(16,null,i)),!1;return E(s,n,h)?!0:(a.push(P.localize(17,null,s,i)),!1)}function o(s){if(!Array.isArray(s))return!1;for(let n=0,i=s.length;n<i;n++)if(typeof s[n]!="string")return!1;return!0}}),define(Ce[70],Pe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=void 0;class I{constructor(P,N=[],A=!1){this.ctor=P,this.staticArguments=N,this.supportsDelayedInstantiation=A}}e.$fi=I}),define(Ce[54],Pe([1,0,70]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$gs=N,e.$hs=A;const O=[];var P;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function N(m,d,k){d instanceof I.$fi||(d=new I.$fi(d,[],!!k)),O.push([m,d])}function A(){return O}}),define(Ce[188],Pe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=void 0;class I{constructor(N,A){this.key=N,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$Wq=I;class O{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const A of this.a.values())A.outgoing.size===0&&N.push(A);return N}insertEdge(N,A){const m=this.lookupOrInsertNode(N),d=this.lookupOrInsertNode(A);m.outgoing.set(d.key,d),d.incoming.set(m.key,m)}removeNode(N){const A=this.b(N);this.a.delete(A);for(const m of this.a.values())m.outgoing.delete(A),m.incoming.delete(A)}lookupOrInsertNode(N){const A=this.b(N);let m=this.a.get(A);return m||(m=new I(A,N),this.a.set(A,m)),m}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[A,m]of this.a)N.push(`${A}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,A]of this.a){const m=new Set([N]),d=this.c(A,m);if(d)return d}}c(N,A){for(const[m,d]of N.outgoing){if(A.has(m))return[...A,m].join(" -> ");A.add(m);const k=this.c(d,A);if(k)return k;A.delete(m)}}}e.$Xq=O}),define(Ce[3],Pe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e._util=void 0,e.$ii=P,e.$ji=N;var I;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function m(d){return d[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=m})(I||(e._util=I={})),e.$hi=P("instantiationService");function O(A,m,d){m[I.DI_TARGET]===m?m[I.DI_DEPENDENCIES].push({id:A,index:d}):(m[I.DI_DEPENDENCIES]=[{id:A,index:d}],m[I.DI_TARGET]=m)}function P(A){if(I.serviceIds.has(A))return I.serviceIds.get(A);const m=function(d,k,F){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(m,d,F)};return m.toString=()=>A,I.serviceIds.set(A,m),m}function N(A){return A}}),define(Ce[47],Pe([1,0,16,2,3]),function($e,e,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Oi=void 0,e.$Pi=N,e.$Qi=A,e.$Ri=d,e.$Si=k,e.$Ti=F,e.$Ui=E,e.$Vi=u,e.$Wi=f,e.$Xi=r,e.$Yi=o,e.$Oi=(0,P.$ii)("configurationService");function N(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof O.URI)}function A(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof O.URI)}var m;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function d(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function k(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}function F(s,n){const i=Object.create(null);for(const a in s)E(i,a,s[a],n);return i}function E(s,n,i,a){const h=n.split("."),t=h.pop();let v=s;for(let c=0;c<h.length;c++){const $=h[c];let w=v[$];switch(typeof w){case"undefined":w=v[$]=Object.create(null);break;case"object":break;default:a(`Ignoring ${n} as ${h.slice(0,c+1).join(".")} is ${JSON.stringify(w)}`);return}v=w}if(typeof v=="object"&&v!==null)try{v[t]=i}catch{a(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(v)}`)}else a(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(v)}`)}function u(s,n){const i=n.split(".");b(s,i)}function b(s,n){const i=n.shift();if(n.length===0){delete s[i];return}if(Object.keys(s).indexOf(i)!==-1){const a=s[i];typeof a=="object"&&!Array.isArray(a)&&(b(a,n),Object.keys(a).length===0&&delete s[i])}}function f(s,n,i){function a(v,c){let $=v;for(const w of c){if(typeof $!="object"||$===null)return;$=$[w]}return $}const h=n.split("."),t=a(s,h);return typeof t>"u"?i:t}function r(s,n,i){Object.keys(n).forEach(a=>{a!=="__proto__"&&(a in s?I.$Xf(s[a])&&I.$Xf(n[a])?r(s[a],n[a],i):i&&(s[a]=n[a]):s[a]=n[a])})}function o(s){return s.replace(/[\[\]]/g,"")}}),define(Ce[33],Pe([1,0,21,15,186,3,153,14]),function($e,e,I,O,P,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$gj=e.$fj=e.ContextKeyExprType=void 0,e.$ej=k,e.$hj=v,e.$ij=c,e.$Bj=te;const d=new Map;d.set("false",!1),d.set("true",!0),d.set("isMac",I.$j),d.set("isLinux",I.$k),d.set("isWindows",I.$i),d.set("isWeb",I.$o),d.set("isMacNative",I.$j&&!I.$o),d.set("isEdge",I.$H),d.set("isFirefox",I.$F),d.set("isChrome",I.$E),d.set("isSafari",I.$G);function k(de,W){if(d.get(de)!==void 0)throw(0,m.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");d.set(de,W)}const F=Object.prototype.hasOwnProperty;var E;(function(de){de[de.False=0]="False",de[de.True=1]="True",de[de.Defined=2]="Defined",de[de.Not=3]="Not",de[de.Equals=4]="Equals",de[de.NotEquals=5]="NotEquals",de[de.And=6]="And",de[de.Regex=7]="Regex",de[de.NotRegex=8]="NotRegex",de[de.Or=9]="Or",de[de.In=10]="In",de[de.NotIn=11]="NotIn",de[de.Greater=12]="Greater",de[de.GreaterEquals=13]="GreaterEquals",de[de.Smaller=14]="Smaller",de[de.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const u={regexParsingWithErrorRecovery:!0},b=(0,A.localize)(0,null),f=(0,A.localize)(1,null),r=(0,A.localize)(2,null),o=(0,A.localize)(3,null),s=(0,A.localize)(4,null),n=(0,A.localize)(5,null),i=(0,A.localize)(6,null),a=(0,A.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(W=u){this.k=W,this.d=new P.$dj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(W){if(W===""){this.h.push({message:b,offset:0,lexeme:"",additionalInfo:f});return}this.f=this.d.reset(W).scan(),this.g=0,this.h=[];try{const ee=this.l();if(!this.E()){const ke=this.D(),Te=ke.type===17?n:void 0;throw this.h.push({message:s,offset:ke.offset,lexeme:P.$dj.getLexeme(ke),additionalInfo:Te}),h.c}return ee}catch(ee){if(ee!==h.c)throw ee;return}}l(){return this.m()}m(){const W=[this.o()];for(;this.y(16);){const ee=this.o();W.push(ee)}return W.length===1?W[0]:t.or(...W)}o(){const W=[this.s()];for(;this.y(15);){const ee=this.s();W.push(ee)}return W.length===1?W[0]:t.and(...W)}s(){if(this.y(2)){const W=this.D();switch(W.type){case 11:return this.z(),w.INSTANCE;case 12:return this.z(),p.INSTANCE;case 0:{this.z();const ee=this.l();return this.A(1,o),ee?.negate()}case 17:return this.z(),C.create(W.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",W)}}return this.t()}t(){const W=this.D();switch(W.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ee=this.l();return this.A(1,o),ee}case 17:{const ee=W.lexeme;if(this.z(),this.y(9)){const Te=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Te.type!==10)throw this.B("REGEX",Te);const Se=Te.lexeme,ve=Se.lastIndexOf("/"),me=ve===Se.length-1?void 0:this.w(Se.substring(ve+1));let J;try{J=new RegExp(Se.substring(1,ve),me)}catch{throw this.B("REGEX",Te)}return L.create(ee,J)}switch(Te.type){case 10:case 19:{const Se=[Te.lexeme];this.z();let ve=this.D(),me=0;for(let Ne=0;Ne<Te.lexeme.length;Ne++)Te.lexeme.charCodeAt(Ne)===40?me++:Te.lexeme.charCodeAt(Ne)===41&&me--;for(;!this.E()&&ve.type!==15&&ve.type!==16;){switch(ve.type){case 0:me++;break;case 1:me--;break;case 10:case 18:for(let Ne=0;Ne<ve.lexeme.length;Ne++)ve.lexeme.charCodeAt(Ne)===40?me++:Te.lexeme.charCodeAt(Ne)===41&&me--}if(me<0)break;Se.push(P.$dj.getLexeme(ve)),this.z(),ve=this.D()}const J=Se.join(""),Y=J.lastIndexOf("/"),ce=Y===J.length-1?void 0:this.w(J.substring(Y+1));let fe;try{fe=new RegExp(J.substring(1,Y),ce)}catch{throw this.B("REGEX",Te)}return t.regex(ee,fe)}case 18:{const Se=Te.lexeme;this.z();let ve=null;if(!(0,O.$Ue)(Se)){const me=Se.indexOf("/"),J=Se.lastIndexOf("/");if(me!==J&&me>=0){const Y=Se.slice(me+1,J),ce=Se[J+1]==="i"?"i":"";try{ve=new RegExp(Y,ce)}catch{throw this.B("REGEX",Te)}}}if(ve===null)throw this.B("REGEX",Te);return L.create(ee,ve)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,r);const Te=this.u();return t.notIn(ee,Te)}switch(this.D().type){case 3:{this.z();const Te=this.u();if(this.x().type===18)return t.equals(ee,Te);switch(Te){case"true":return t.has(ee);case"false":return t.not(ee);default:return t.equals(ee,Te)}}case 4:{this.z();const Te=this.u();if(this.x().type===18)return t.notEquals(ee,Te);switch(Te){case"true":return t.not(ee);case"false":return t.has(ee);default:return t.notEquals(ee,Te)}}case 5:return this.z(),q.create(ee,this.u());case 6:return this.z(),M.create(ee,this.u());case 7:return this.z(),V.create(ee,this.u());case 8:return this.z(),U.create(ee,this.u());case 13:return this.z(),t.in(ee,this.u());default:return t.has(ee)}}case 20:throw this.h.push({message:i,offset:W.offset,lexeme:"",additionalInfo:a}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const W=this.D();switch(W.type){case 17:case 18:return this.z(),W.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(W){return W.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(W){return this.C(W)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(W,ee){if(this.C(W))return this.z();throw this.B(ee,this.D())}B(W,ee,ke){const Te=(0,A.localize)(8,null,W,P.$dj.getLexeme(ee)),Se=ee.offset,ve=P.$dj.getLexeme(ee);return this.h.push({message:Te,offset:Se,lexeme:ve,additionalInfo:ke}),h.c}C(W){return this.D().type===W}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$fj=h;class t{static false(){return w.INSTANCE}static true(){return p.INSTANCE}static has(W){return l.create(W)}static equals(W,ee){return D.create(W,ee)}static notEquals(W,ee){return y.create(W,ee)}static regex(W,ee){return L.create(W,ee)}static in(W,ee){return g.create(W,ee)}static notIn(W,ee){return S.create(W,ee)}static not(W){return C.create(W)}static and(...W){return he.create(W,null,!0)}static or(...W){return ye.create(W,null,!0)}static greater(W,ee){return V.create(W,ee)}static greaterEquals(W,ee){return U.create(W,ee)}static smaller(W,ee){return q.create(W,ee)}static smallerEquals(W,ee){return M.create(W,ee)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this.c.parse(W)}}e.$gj=t;function v(de){const W=new h({regexParsingWithErrorRecovery:!1});return de.map(ee=>(W.parse(ee),W.lexingErrors.length>0?W.lexingErrors.map(ke=>({errorMessage:ke.additionalInfo?(0,A.localize)(9,null,ke.additionalInfo):(0,A.localize)(10,null),offset:ke.offset,length:ke.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(ke=>({errorMessage:ke.additionalInfo?`${ke.message}. ${ke.additionalInfo}`:ke.message,offset:ke.offset,length:ke.lexeme.length})):[]))}function c(de,W){const ee=de?de.substituteConstants():void 0,ke=W?W.substituteConstants():void 0;return!ee&&!ke?!0:!ee||!ke?!1:ee.equals(ke)}function $(de,W){return de.cmp(W)}class w{static{this.INSTANCE=new w}constructor(){this.type=0}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return p.INSTANCE}}e.$jj=w;class p{static{this.INSTANCE=new p}constructor(){this.type=1}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return w.INSTANCE}}e.$kj=p;class l{static create(W,ee=null){const ke=d.get(W);return typeof ke=="boolean"?ke?p.INSTANCE:w.INSTANCE:new l(W,ee)}constructor(W,ee){this.key=W,this.c=ee,this.type=2}cmp(W){return W.type!==this.type?this.type-W.type:ge(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=d.get(this.key);return typeof W=="boolean"?W?p.INSTANCE:w.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$lj=l;class D{static create(W,ee,ke=null){if(typeof ee=="boolean")return ee?l.create(W,ke):C.create(W,ke);const Te=d.get(W);return typeof Te=="boolean"?ee===(Te?"true":"false")?p.INSTANCE:w.INSTANCE:new D(W,ee,ke)}constructor(W,ee,ke){this.c=W,this.d=ee,this.f=ke,this.type=4}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=d.get(this.c);if(typeof W=="boolean"){const ee=W?"true":"false";return this.d===ee?p.INSTANCE:w.INSTANCE}return this}evaluate(W){return W.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(W){return W.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$mj=D;class g{static create(W,ee){return new g(W,ee)}constructor(W,ee){this.d=W,this.f=ee,this.type=10,this.c=null}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.d,this.f,W.d,W.f)}equals(W){return W.type===this.type?this.d===W.d&&this.f===W.f:!1}substituteConstants(){return this}evaluate(W){const ee=W.getValue(this.f),ke=W.getValue(this.d);return Array.isArray(ee)?ee.includes(ke):typeof ke=="string"&&typeof ee=="object"&&ee!==null?F.call(ee,ke):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(W){return W.mapIn(this.d,this.f)}negate(){return this.c||(this.c=S.create(this.d,this.f)),this.c}}e.$nj=g;class S{static create(W,ee){return new S(W,ee)}constructor(W,ee){this.d=W,this.f=ee,this.type=11,this.c=g.create(W,ee)}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(W){return W.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$oj=S;class y{static create(W,ee,ke=null){if(typeof ee=="boolean")return ee?C.create(W,ke):l.create(W,ke);const Te=d.get(W);return typeof Te=="boolean"?ee===(Te?"true":"false")?w.INSTANCE:p.INSTANCE:new y(W,ee,ke)}constructor(W,ee,ke){this.c=W,this.d=ee,this.f=ke,this.type=5}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=d.get(this.c);if(typeof W=="boolean"){const ee=W?"true":"false";return this.d===ee?w.INSTANCE:p.INSTANCE}return this}evaluate(W){return W.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(W){return W.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$pj=y;class C{static create(W,ee=null){const ke=d.get(W);return typeof ke=="boolean"?ke?w.INSTANCE:p.INSTANCE:new C(W,ee)}constructor(W,ee){this.c=W,this.d=ee,this.type=3}cmp(W){return W.type!==this.type?this.type-W.type:ge(this.c,W.c)}equals(W){return W.type===this.type?this.c===W.c:!1}substituteConstants(){const W=d.get(this.c);return typeof W=="boolean"?W?w.INSTANCE:p.INSTANCE:this}evaluate(W){return!W.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(W){return W.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$qj=C;function R(de,W){if(typeof de=="string"){const ee=parseFloat(de);isNaN(ee)||(de=ee)}return typeof de=="string"||typeof de=="number"?W(de):w.INSTANCE}class V{static create(W,ee,ke=null){return R(ee,Te=>new V(W,Te,ke))}constructor(W,ee,ke){this.c=W,this.d=ee,this.f=ke,this.type=12}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$rj=V;class U{static create(W,ee,ke=null){return R(ee,Te=>new U(W,Te,ke))}constructor(W,ee,ke){this.c=W,this.d=ee,this.f=ke,this.type=13}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$sj=U;class q{static create(W,ee,ke=null){return R(ee,Te=>new q(W,Te,ke))}constructor(W,ee,ke){this.c=W,this.d=ee,this.f=ke,this.type=14}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$tj=q;class M{static create(W,ee,ke=null){return R(ee,Te=>new M(W,Te,ke))}constructor(W,ee,ke){this.c=W,this.d=ee,this.f=ke,this.type=15}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$uj=M;class L{static create(W,ee){return new L(W,ee)}constructor(W,ee){this.d=W,this.f=ee,this.type=7,this.c=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.d<W.d)return-1;if(this.d>W.d)return 1;const ee=this.f?this.f.source:"",ke=W.f?W.f.source:"";return ee<ke?-1:ee>ke?1:0}equals(W){if(W.type===this.type){const ee=this.f?this.f.source:"",ke=W.f?W.f.source:"";return this.d===W.d&&ee===ke}return!1}substituteConstants(){return this}evaluate(W){const ee=W.getValue(this.d);return this.f?this.f.test(ee):!1}serialize(){const W=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${W}`}keys(){return[this.d]}map(W){return W.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=G.create(this)),this.c}}e.$vj=L;class G{static create(W){return new G(W)}constructor(W){this.c=W,this.type=8}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(W){return new G(this.c.map(W))}negate(){return this.c}}e.$wj=G;function ne(de){let W=null;for(let ee=0,ke=de.length;ee<ke;ee++){const Te=de[ee].substituteConstants();if(de[ee]!==Te&&W===null){W=[];for(let Se=0;Se<ee;Se++)W[Se]=de[Se]}W!==null&&(W[ee]=Te)}return W===null?de:W}class he{static create(W,ee,ke){return he.d(W,ee,ke)}constructor(W,ee){this.expr=W,this.c=ee,this.type=6}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let ee=0,ke=this.expr.length;ee<ke;ee++){const Te=$(this.expr[ee],W.expr[ee]);if(Te!==0)return Te}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let ee=0,ke=this.expr.length;ee<ke;ee++)if(!this.expr[ee].equals(W.expr[ee]))return!1;return!0}return!1}substituteConstants(){const W=ne(this.expr);return W===this.expr?this:he.create(W,this.c,!1)}evaluate(W){for(let ee=0,ke=this.expr.length;ee<ke;ee++)if(!this.expr[ee].evaluate(W))return!1;return!0}static d(W,ee,ke){const Te=[];let Se=!1;for(const ve of W)if(ve){if(ve.type===1){Se=!0;continue}if(ve.type===0)return w.INSTANCE;if(ve.type===6){Te.push(...ve.expr);continue}Te.push(ve)}if(Te.length===0&&Se)return p.INSTANCE;if(Te.length!==0){if(Te.length===1)return Te[0];Te.sort($);for(let ve=1;ve<Te.length;ve++)Te[ve-1].equals(Te[ve])&&(Te.splice(ve,1),ve--);if(Te.length===1)return Te[0];for(;Te.length>1;){const ve=Te[Te.length-1];if(ve.type!==9)break;Te.pop();const me=Te.pop(),J=Te.length===0,Y=ye.create(ve.expr.map(ce=>he.create([ce,me],null,ke)),null,J);Y&&(Te.push(Y),Te.sort($))}if(Te.length===1)return Te[0];if(ke){for(let ve=0;ve<Te.length;ve++)for(let me=ve+1;me<Te.length;me++)if(Te[ve].negate().equals(Te[me]))return w.INSTANCE;if(Te.length===1)return Te[0]}return new he(Te,ee)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const ee of this.expr)W.push(...ee.keys());return W}map(W){return new he(this.expr.map(ee=>ee.map(W)),null)}negate(){if(!this.c){const W=[];for(const ee of this.expr)W.push(ee.negate());this.c=ye.create(W,this,!0)}return this.c}}e.$xj=he;class ye{static create(W,ee,ke){return ye.d(W,ee,ke)}constructor(W,ee){this.expr=W,this.c=ee,this.type=9}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let ee=0,ke=this.expr.length;ee<ke;ee++){const Te=$(this.expr[ee],W.expr[ee]);if(Te!==0)return Te}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let ee=0,ke=this.expr.length;ee<ke;ee++)if(!this.expr[ee].equals(W.expr[ee]))return!1;return!0}return!1}substituteConstants(){const W=ne(this.expr);return W===this.expr?this:ye.create(W,this.c,!1)}evaluate(W){for(let ee=0,ke=this.expr.length;ee<ke;ee++)if(this.expr[ee].evaluate(W))return!0;return!1}static d(W,ee,ke){let Te=[],Se=!1;if(W){for(let ve=0,me=W.length;ve<me;ve++){const J=W[ve];if(J){if(J.type===0){Se=!0;continue}if(J.type===1)return p.INSTANCE;if(J.type===9){Te=Te.concat(J.expr);continue}Te.push(J)}}if(Te.length===0&&Se)return w.INSTANCE;Te.sort($)}if(Te.length!==0){if(Te.length===1)return Te[0];for(let ve=1;ve<Te.length;ve++)Te[ve-1].equals(Te[ve])&&(Te.splice(ve,1),ve--);if(Te.length===1)return Te[0];if(ke){for(let ve=0;ve<Te.length;ve++)for(let me=ve+1;me<Te.length;me++)if(Te[ve].negate().equals(Te[me]))return p.INSTANCE;if(Te.length===1)return Te[0]}return new ye(Te,ee)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const ee of this.expr)W.push(...ee.keys());return W}map(W){return new ye(this.expr.map(ee=>ee.map(W)),null)}negate(){if(!this.c){const W=[];for(const ee of this.expr)W.push(ee.negate());for(;W.length>1;){const ee=W.shift(),ke=W.shift(),Te=[];for(const Se of oe(ee))for(const ve of oe(ke))Te.push(he.create([Se,ve],null,!1));W.unshift(ye.create(Te,null,!1))}this.c=ye.create(W,this,!0)}return this.c}}e.$yj=ye;class Re extends l{static{this.d=[]}static all(){return Re.d.values()}constructor(W,ee,ke){super(W,null),this.f=ee,typeof ke=="object"?Re.d.push({...ke,key:W}):ke!==!0&&Re.d.push({key:W,description:ke,type:ee!=null?typeof ee:void 0})}bindTo(W){return W.createKey(this.key,this.f)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return D.create(this.key,W)}notEqualsTo(W){return y.create(this.key,W)}}e.$zj=Re,e.$Aj=(0,N.$ii)("contextKeyService");function ge(de,W){return de<W?-1:de>W?1:0}function ue(de,W,ee,ke){return de<ee?-1:de>ee?1:W<ke?-1:W>ke?1:0}function te(de,W){if(de.type===0||W.type===1)return!0;if(de.type===9)return W.type===9?be(de.expr,W.expr):!1;if(W.type===9){for(const ee of W.expr)if(te(de,ee))return!0;return!1}if(de.type===6){if(W.type===6)return be(W.expr,de.expr);for(const ee of de.expr)if(te(ee,W))return!0;return!1}return de.equals(W)}function be(de,W){let ee=0,ke=0;for(;ee<de.length&&ke<W.length;){const Te=de[ee].cmp(W[ke]);if(Te<0)return!1;Te===0&&ee++,ke++}return ee===de.length}function oe(de){return de.type===9?de.expr:[de]}}),define(Ce[189],Pe([1,0,3]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=void 0,e.$pi=(0,I.$ii)("environmentService"),e.$qi=(0,I.$ji)(e.$pi)}),define(Ce[98],Pe([1,0,155,3]),function($e,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.ExtensionGalleryErrorCode=e.$So=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Ro=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=void 0,e.$Lo=P,e.$Mo=N,e.$No=A,e.$Oo=m,e.$Po=d,e.$Qo=k,e.$Fo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Go=new RegExp(e.$Fo),e.$Ho="__web_extension",e.$Io="skipWalkthrough",e.$Jo="extensionsSync",e.$Ko="dependecyOrPackExtensionInstall";function P(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function N(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function A(i,a){switch(i){case 3:return a==="x64"?"win32-x64":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function m(i,a){return a==="web"&&!i.includes("web")}function d(i,a,h){return m(a,h)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===h}function k(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var F;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(F||(e.SortBy=F={}));var E;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(E||(e.SortOrder=E={}));var u;(function(i){i.Install="install",i.Uninstall="uninstall"})(u||(e.StatisticType=u={}));var b;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$Ro=(0,O.$ii)("extensionGalleryService");var f;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Unknown="Unknown",i.Internal="Internal"})(f||(e.ExtensionManagementErrorCode=f={}));var r;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(r||(e.ExtensionSignaturetErrorCode=r={}));class o extends Error{constructor(a,h){super(a),this.code=h,this.name=h}}e.$So=o;var s;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed"})(s||(e.ExtensionGalleryErrorCode=s={}));class n extends Error{constructor(a,h){super(a),this.code=h,this.name=h}}e.$To=n,e.$Uo=(0,O.$ii)("extensionManagementService"),e.$Vo="extensionsIdentifiers/disabled",e.$Wo="extensionsIdentifiers/enabled",e.$Xo=(0,O.$ii)("IGlobalExtensionEnablementService"),e.$Yo=(0,O.$ii)("IExtensionTipsService"),e.$Zo=(0,I.localize2)(0,"Extensions"),e.$1o=(0,I.localize2)(1,"Preferences")}),define(Ce[43],Pe([1,0,51,19,15,16,2,157,3,21,12,40]),function($e,e,I,O,P,N,A,m,d,k,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$hl=e.FileKind=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.FileOperationResult=e.$_k=e.$$k=e.$0k=e.$8k=e.FileChangeType=e.$7k=e.FileOperation=e.$1k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Ok=void 0,e.$Pk=u,e.$Qk=r,e.$Rk=s,e.$Sk=n,e.$Tk=i,e.$Uk=a,e.$Vk=h,e.$Wk=t,e.$Xk=v,e.$Yk=c,e.$Zk=$,e.$2k=l,e.$3k=D,e.$4k=g,e.$5k=S,e.$6k=y,e.$9k=q,e.$il=ye,e.$jl=Re,e.$ll=ue,e.$Ok=(0,d.$ii)("fileService");function u(te){return te.create===!0}var b;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(b||(e.FileType=b={}));var f;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(f||(e.FilePermission=f={}));function r(te){const be=te;return!!be&&typeof be.onDidChange=="function"}var o;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function s(te){return!!(te.capabilities&2)}function n(te){return!!(te.capabilities&8)}function i(te){return!!(te.capabilities&131072)}function a(te){return!!(te.capabilities&4)}function h(te){return!!(te.capabilities&16)}function t(te){return s(te)?!!(te.capabilities&16384):!1}function v(te){return s(te)?!!(te.capabilities&32768):!1}function c(te){return!!(te.capabilities&65536)}function $(te){return!!(te.capabilities&2048)}var w;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(w||(e.FileSystemProviderErrorCode=w={}));class p extends Error{static create(be,oe){const de=new p(be.toString(),oe);return g(de,oe),de}constructor(be,oe){super(be),this.code=oe}}e.$1k=p;function l(te,be){return p.create(te,be)}function D(te){return te||l((0,m.localize)(0,null),w.Unknown)}function g(te,be){return te.name=be?`${be} (FileSystemError)`:"FileSystemError",te}function S(te){if(!te)return w.Unknown;if(te instanceof p)return te.code;const be=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!be)return w.Unknown;switch(be[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}function y(te){if(te instanceof M)return te.fileOperationResult;switch(S(te)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 9;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileTooLarge:return 7;default:return 10}}var C;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class R{constructor(be,oe,de){this.resource=be,this.operation=oe,this.target=de}isOperation(be){return this.operation===be}}e.$7k=R;var V;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(V||(e.FileChangeType=V={}));class U{static{this.a=null}constructor(be,oe){this.c=oe,this.b=void 0,this.d=new E.$V(()=>{const de=I.$oi.forUris(()=>this.c);return de.fill(this.rawAdded.map(W=>[W,!0])),de}),this.f=new E.$V(()=>{const de=I.$oi.forUris(()=>this.c);return de.fill(this.rawUpdated.map(W=>[W,!0])),de}),this.g=new E.$V(()=>{const de=I.$oi.forUris(()=>this.c);return de.fill(this.rawDeleted.map(W=>[W,!0])),de}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const de of be){switch(de.type){case 1:this.rawAdded.push(de.resource);break;case 0:this.rawUpdated.push(de.resource);break;case 2:this.rawDeleted.push(de.resource);break}this.b!==U.a&&(typeof de.cId=="number"?this.b===void 0?this.b=de.cId:this.b!==de.cId&&(this.b=U.a):this.b!==void 0&&(this.b=U.a))}}contains(be,...oe){return this.h(be,{includeChildren:!1},...oe)}affects(be,...oe){return this.h(be,{includeChildren:!0},...oe)}h(be,oe,...de){if(!be)return!1;const W=de.length>0;return!!((!W||de.includes(1))&&(this.d.value.get(be)||oe.includeChildren&&this.d.value.findSuperstr(be))||(!W||de.includes(0))&&(this.f.value.get(be)||oe.includeChildren&&this.f.value.findSuperstr(be))||(!W||de.includes(2))&&(this.g.value.findSubstr(be)||oe.includeChildren&&this.g.value.findSuperstr(be)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(be){return this.b===be}hasCorrelation(){return typeof this.b=="number"}}e.$8k=U;function q(te,be,oe){return!te||!be||te===be||be.length>te.length?!1:(be.charAt(be.length-1)!==O.sep&&(be+=O.sep),oe?(0,P.$mf)(te,be):te.indexOf(be)===0)}class M extends Error{constructor(be,oe,de){super(be),this.fileOperationResult=oe,this.options=de}}e.$0k=M;class L extends M{constructor(be,oe,de,W){super(be,oe,W),this.fileOperationResult=oe,this.size=de}}e.$$k=L;class G extends M{constructor(be,oe,de){super(be,2,de),this.stat=oe}}e.$_k=G;var ne;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ne||(e.FileOperationResult=ne={})),e.$al={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$bl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$cl="files.associations",e.$dl="files.exclude",e.$el="files.readonlyInclude",e.$fl="files.readonlyExclude",e.$gl="files.readonlyFromPermissions";var he;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(he||(e.FileKind=he={})),e.$hl="";function ye(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function Re(te,be){if(!be.hasProvider(A.URI.from({scheme:te.scheme})))return new Promise(oe=>{const de=be.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===te.scheme&&W.added&&(de.dispose(),oe())})})}class ge{static{this.KB=1024}static{this.MB=ge.KB*ge.KB}static{this.GB=ge.MB*ge.KB}static{this.TB=ge.GB*ge.KB}static formatSize(be){return(0,N.$Zf)(be)||(be=0),be<ge.KB?(0,m.localize)(1,null,be.toFixed(0)):be<ge.MB?(0,m.localize)(2,null,(be/ge.KB).toFixed(2)):be<ge.GB?(0,m.localize)(3,null,(be/ge.MB).toFixed(2)):be<ge.TB?(0,m.localize)(4,null,(be/ge.GB).toFixed(2)):(0,m.localize)(5,null,(be/ge.TB).toFixed(2))}}e.$kl=ge;function ue(te){const be=typeof te=="string"||te?.scheme===F.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===F.Schemas.file?1024*ge.MB:be?10*ge.MB:k.$o?50*ge.MB:1024*ge.MB}}),define(Ce[71],Pe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=void 0;class I{constructor(...P){this.a=new Map;for(const[N,A]of P)this.set(N,A)}set(P,N){const A=this.a.get(P);return this.a.set(P,N),A}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$gi=I}),define(Ce[190],Pe([1,0,11,14,6,70,188,3,71,191]),function($e,e,I,O,P,N,A,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=void 0;const F=!1;class E extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class u{constructor(o=new d.$gi,s=!1,n,i=F){this.f=o,this.g=s,this.h=n,this.i=i,this.o=new Set,this.f.set(m.$hi,this),this._globalGraph=i?n?._globalGraph??new A.$Xq(a=>a):void 0}createChild(o){return new u(o,this.g,this,this.i)}invokeFunction(o,...s){const n=f.traceInvocation(this.i,o);let i=!1;try{return o({get:h=>{if(i)throw(0,O.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(h,n);if(!t)throw new Error(`[invokeFunction] unknown service '${h}'`);return t}},...s)}finally{i=!0,n.stop()}}createInstance(o,...s){let n,i;return o instanceof N.$fi?(n=f.traceCreation(this.i,o.ctor),i=this.j(o.ctor,o.staticArguments.concat(s),n)):(n=f.traceCreation(this.i,o),i=this.j(o,s,n)),n.stop(),i}j(o,s=[],n){const i=m._util.getServiceDependencies(o).sort((t,v)=>t.index-v.index),a=[];for(const t of i){const v=this.m(t.id,n);v||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),a.push(v)}const h=i.length>0?i[0].index:s.length;if(s.length!==h){console.trace(`[createInstance] First service dependency of ${o.name} at position ${h+1} conflicts with ${s.length} static arguments`);const t=h-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,h)}return Reflect.construct(o,s.concat(a))}k(o,s){if(this.f.get(o)instanceof N.$fi)this.f.set(o,s);else if(this.h)this.h.k(o,s);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const s=this.f.get(o);return!s&&this.h?this.h.l(o):s}m(o,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const n=this.l(o);return n instanceof N.$fi?this.q(o,n,s.branch(o,!0)):(s.branch(o,!1),n)}q(o,s,n){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,s,n)}finally{this.o.delete(o)}}r(o,s,n){const i=new A.$Xq(t=>t.id.toString());let a=0;const h=[{id:o,desc:s,_trace:n}];for(;h.length;){const t=h.pop();if(i.lookupOrInsertNode(t),a++>1e3)throw new E(i);for(const v of m._util.getServiceDependencies(t.desc.ctor)){const c=this.l(v.id);if(c||this.u(`[createInstance] ${o} depends on ${v.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(v.id)),c instanceof N.$fi){const $={id:v.id,desc:c,_trace:t._trace.branch(v.id,!0)};i.insertEdge(t,$),h.push($)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new E(i);break}for(const{data:v}of t){if(this.l(v.id)instanceof N.$fi){const $=this.s(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this.k(v.id,$)}i.removeNode(v)}}return this.l(o)}s(o,s,n=[],i,a){if(this.f.get(o)instanceof N.$fi)return this.t(o,s,n,i,a);if(this.h)return this.h.s(o,s,n,i,a);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}t(o,s,n=[],i,a){if(i){const h=new u(void 0,this.g,this,this.i);h.c=String(o);const t=new Map,v=new I.$Bh(()=>{const c=h.j(s,n,a);for(const[$,w]of t){const p=c[$];if(typeof p=="function")for(const l of w)l.disposable=p.apply(c,l.listener)}return t.clear(),c});return new Proxy(Object.create(null),{get(c,$){if(!v.isInitialized&&typeof $=="string"&&($.startsWith("onDid")||$.startsWith("onWill"))){let l=t.get($);return l||(l=new k.$5c,t.set($,l)),(g,S,y)=>{if(v.isInitialized)return v.value[$](g,S,y);{const C={listener:[g,S,y],disposable:void 0},R=l.push(C);return(0,P.$Sc)(()=>{R(),C.disposable?.dispose()})}}}if($ in c)return c[$];const w=v.value;let p=w[$];return typeof p!="function"||(p=p.bind(w),c[$]=p),p},set(c,$,w){return v.value[$]=w,!0},getPrototypeOf(c){return s.prototype}})}else return this.j(s,n,a)}u(o,s){if(s&&console.warn(o),this.g)throw new Error(o)}}e.$Yq=u;var b;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(b||(b={}));class f{static{this.all=new Set}static{this.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,s){return o?new f(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(o,s){return o?new f(1,s.name):f.c}static{this.f=0}constructor(o,s){this.type=o,this.name=s,this.g=Date.now(),this.h=[]}branch(o,s){const n=new f(3,o.toString());return this.h.push([o,s,n]),n}stop(){const o=Date.now()-this.g;f.f+=o;let s=!1;function n(a,h){const t=[],v=new Array(a+1).join("	");for(const[c,$,w]of h.h)if($&&w){s=!0,t.push(`${v}CREATES -> ${c}`);const p=n(a+1,w);p&&t.push(p)}else t.push(`${v}uses -> ${c}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(o>2||s)&&f.all.add(i.join(`
`))}}e.$Zq=f}),define(Ce[13],Pe([1,0,158,42,5,99,6,28,21,24,16,2,33,3]),function($e,e,I,O,P,N,A,m,d,k,F,E,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Rj=e.LogLevel=e.$Pj=e.$Oj=void 0,e.$Qj=r,e.log=s,e.$3j=l,e.$4j=D,e.$5j=g,e.$6j=S,e.$Oj=(0,b.$ii)("logService"),e.$Pj=(0,b.$ii)("loggerService");function f(){return new Date().toISOString()}function r(y){return(0,F.$Zf)(y)}var o;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$Rj=o.Info;function s(y,C,R){switch(C){case o.Trace:y.trace(R);break;case o.Debug:y.debug(R);break;case o.Info:y.info(R);break;case o.Warning:y.warn(R);break;case o.Error:y.error(R);break;case o.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function n(y,C=!1){let R="";for(let V=0;V<y.length;V++){let U=y[V];if(U instanceof Error&&(U=(0,O.$6i)(U,C)),typeof U=="object")try{U=JSON.stringify(U)}catch{}R+=(V>0?" ":"")+U}return R}class i extends A.$Uc{constructor(){super(...arguments),this.b=e.$Rj,this.c=this.B(new P.$7d),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==o.Off&&this.b<=C}}e.$Tj=i;class a extends i{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...R){this.f(o.Trace)&&this.g(o.Trace,n([C,...R],!0))}debug(C,...R){this.f(o.Debug)&&this.g(o.Debug,n([C,...R]))}info(C,...R){this.f(o.Info)&&this.g(o.Info,n([C,...R]))}warn(C,...R){this.f(o.Warning)&&this.g(o.Warning,n([C,...R]))}error(C,...R){if(this.f(o.Error))if(C instanceof Error){const V=Array.prototype.slice.call(arguments);V[0]=C.stack,this.g(o.Error,n(V))}else this.g(o.Error,n([C,...R]))}flush(){}}e.$Uj=a;class h extends i{constructor(C=e.$Rj){super(),this.setLevel(C),this.g=!d.$i}trace(C,...R){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,C,...R):console.log(`[main ${f()}]`,C,...R))}debug(C,...R){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,C,...R):console.log(`[main ${f()}]`,C,...R))}info(C,...R){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,C,...R):console.log(`[main ${f()}]`,C,...R))}warn(C,...R){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,C,...R):console.warn(`[main ${f()}]`,C,...R))}error(C,...R){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,C,...R):console.error(`[main ${f()}]`,C,...R))}flush(){}}e.$Vj=h;class t extends i{constructor(C=e.$Rj,R=!0){super(),this.g=R,this.setLevel(C)}trace(C,...R){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...R):console.log(C,...R))}debug(C,...R){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...R):console.log(C,...R))}info(C,...R){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...R):console.log(C,...R))}warn(C,...R){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...R):console.log(C,...R))}error(C,...R){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...R):console.error(C,...R))}flush(){}}e.$Wj=t;class v extends i{constructor(C,R=e.$Rj){super(),this.g=C,this.setLevel(R)}trace(C,...R){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(C),...R])}debug(C,...R){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(C),...R])}info(C,...R){this.f(o.Info)&&this.g.log(o.Info,[this.h(C),...R])}warn(C,...R){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(C),...R])}error(C,...R){this.f(o.Error)&&this.g.log(o.Error,[this.h(C),...R])}h(C){return typeof C=="string"?C:(0,O.$6i)(C,this.f(o.Trace))}flush(){}}e.$Xj=v;class c extends i{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const R of this.g)R.setLevel(C);super.setLevel(C)}trace(C,...R){for(const V of this.g)V.trace(C,...R)}debug(C,...R){for(const V of this.g)V.debug(C,...R)}info(C,...R){for(const V of this.g)V.info(C,...R)}warn(C,...R){for(const V of this.g)V.warn(C,...R)}error(C,...R){for(const V of this.g)V.error(C,...R)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$Yj=c;class $ extends A.$Uc{constructor(C,R,V){if(super(),this.h=C,this.j=R,this.b=new m.$Bc,this.c=this.B(new P.$7d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$7d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$7d),this.onDidChangeVisibility=this.g.event,V)for(const U of V)this.b.set(U.resource,{logger:void 0,info:U})}m(C){return(0,F.$Vf)(C)?[...this.b.values()].find(R=>R.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,R){const V=this.n(C),U=(0,F.$Vf)(C)?C:R?.id??(0,N.$9i)(V.toString()).toString(16);let q=this.b.get(V)?.logger;const M=R?.logLevel==="always"?o.Trace:R?.logLevel;q||(q=this.s(V,M??this.getLogLevel(V)??this.h,{...R,id:U}));const L={logger:q,info:{resource:V,id:U,logLevel:M,name:R?.name,hidden:R?.hidden,extensionId:R?.extensionId,when:R?.when}};return this.registerLogger(L.info),this.b.set(V,L),q}n(C){return(0,F.$Vf)(C)?(0,k.$Vg)(this.j,`${C}.log`):C}setLogLevel(C,R){if(E.URI.isUri(C)){const V=C,U=R,q=this.b.get(V);q&&U!==q.info.logLevel&&(q.info.logLevel=U===this.h?void 0:U,q.logger?.setLevel(U),this.b.set(q.info.resource,q),this.f.fire([V,U]))}else{this.h=C;for(const[V,U]of this.b.entries())this.b.get(V)?.info.logLevel===void 0&&U.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,R){const V=this.m(C);V&&R!==!V.info.hidden&&(V.info.hidden=!R,this.b.set(V.info.resource,V),this.g.fire([V.info.resource,R]))}getLogLevel(C){let R;return C&&(R=this.b.get(C)?.info.logLevel),R??this.h}registerLogger(C){const R=this.b.get(C.resource);R?R.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const R=this.b.get(C);R&&(R.logger&&R.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[R.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Zj=$;class w{constructor(){this.onDidChangeLogLevel=new P.$7d().event}setLevel(C){}getLevel(){return o.Info}trace(C,...R){}debug(C,...R){}info(C,...R){}warn(C,...R){}error(C,...R){}critical(C,...R){}dispose(){}flush(){}}e.$1j=w;class p extends w{}e.$2j=p;function l(y){if(y.verbose)return o.Trace;if(typeof y.logLevel=="string"){const C=S(y.logLevel.toLowerCase());if(C!==void 0)return C}return e.$Rj}function D(y){switch(y){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function g(y){switch(y){case o.Trace:return{original:"Trace",value:I.localize(0,null)};case o.Debug:return{original:"Debug",value:I.localize(1,null)};case o.Info:return{original:"Info",value:I.localize(2,null)};case o.Warning:return{original:"Warning",value:I.localize(3,null)};case o.Error:return{original:"Error",value:I.localize(4,null)};case o.Off:return{original:"Off",value:I.localize(5,null)}}}function S(y){switch(y){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$7j=new u.$zj("logLevel",D(o.Info))}),define(Ce[192],Pe([1,0,6,13]),function($e,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4P=void 0;class P extends I.$Uc{constructor(A,m=[]){super(),this.a=new O.$Yj([A,...m]),this.B(A.onDidChangeLogLevel(d=>this.setLevel(d)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...m){this.a.trace(A,...m)}debug(A,...m){this.a.debug(A,...m)}info(A,...m){this.a.info(A,...m)}warn(A,...m){this.a.warn(A,...m)}error(A,...m){this.a.error(A,...m)}flush(){this.a.flush()}}e.$4P=P}),define(Ce[100],Pe([1,0,32,159,3]),function($e,e,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var N;(function(d){d[d.Unnecessary=1]="Unnecessary",d[d.Deprecated=2]="Deprecated"})(N||(e.MarkerTag=N={}));var A;(function(d){d[d.Hint=1]="Hint",d[d.Info=2]="Info",d[d.Warning=4]="Warning",d[d.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(d){function k(f,r){return r-f}d.compare=k;const F=Object.create(null);F[d.Error]=(0,O.localize)(0,null),F[d.Warning]=(0,O.localize)(1,null),F[d.Info]=(0,O.localize)(2,null);function E(f){return F[f]||""}d.toString=E;function u(f){switch(f){case I.default.Error:return d.Error;case I.default.Warning:return d.Warning;case I.default.Info:return d.Info;case I.default.Ignore:return d.Hint}}d.fromSeverity=u;function b(f){switch(f){case d.Error:return I.default.Error;case d.Warning:return I.default.Warning;case d.Info:return I.default.Info;case d.Hint:return I.default.Ignore}}d.toSeverity=b}(A||(e.MarkerSeverity=A={}));var m;(function(d){const k="";function F(u){return E(u,!0)}d.makeKey=F;function E(u,b){const f=[k];return u.source?f.push(u.source.replace("\xA6","\\\xA6")):f.push(k),u.code?typeof u.code=="string"?f.push(u.code.replace("\xA6","\\\xA6")):f.push(u.code.value.replace("\xA6","\\\xA6")):f.push(k),u.severity!==void 0&&u.severity!==null?f.push(A.toString(u.severity)):f.push(k),u.message&&b?f.push(u.message.replace("\xA6","\\\xA6")):f.push(k),u.startLineNumber!==void 0&&u.startLineNumber!==null?f.push(u.startLineNumber.toString()):f.push(k),u.startColumn!==void 0&&u.startColumn!==null?f.push(u.startColumn.toString()):f.push(k),u.endLineNumber!==void 0&&u.endLineNumber!==null?f.push(u.endLineNumber.toString()):f.push(k),u.endColumn!==void 0&&u.endColumn!==null?f.push(u.endColumn.toString()):f.push(k),f.push(k),f.join("\xA6")}d.makeKeyOptionalMessage=E})(m||(e.IMarkerData=m={})),e.$Ut=(0,P.$ii)("markerService")}),define(Ce[193],Pe([1,0,5,32,3]),function($e,e,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ov=e.$Nv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Lv=e.Severity=void 0,e.$Mv=m,e.Severity=O.default,e.$Lv=(0,P.$ii)("notificationService");var N;(function(E){E[E.DEFAULT=0]="DEFAULT",E[E.SILENT=1]="SILENT",E[E.URGENT=2]="URGENT"})(N||(e.NotificationPriority=N={}));var A;(function(E){E[E.WORKSPACE=0]="WORKSPACE",E[E.PROFILE=1]="PROFILE",E[E.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function m(E){if(E){const u=E;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var d;(function(E){E[E.OFF=0]="OFF",E[E.ERROR=1]="ERROR"})(d||(e.NotificationsFilter=d={}));class k{constructor(){this.progress=new F,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$Nv=k;class F{infinite(){}done(){}total(u){}worked(u){}}e.$Ov=F}),define(Ce[194],Pe([1,0,3]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=e.$8j=void 0,e.$8j=(0,I.$ii)("productService"),e.$9j="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function($e,e,I,O){var P=arguments.length,N=P<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,I):O,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate($e,e,I,O);else for(var m=$e.length-1;m>=0;m--)(A=$e[m])&&(N=(P<3?A(N):P>3?A(e,I,N):A(e,I))||N);return P>3&&N&&Object.defineProperty(e,I,N),N},We=this&&this.__param||function($e,e){return function(I,O){e(I,O,$e)}};define(Ce[101],Pe([1,0,11,25,6,3]),function($e,e,I,O,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vv=e.$Uv=e.$Tv=e.$Sv=e.$Rv=e.$Qv=e.ProgressLocation=e.$Pv=void 0,e.$Pv=(0,N.$ii)("progressService");var A;(function(E){E[E.Explorer=1]="Explorer",E[E.Scm=3]="Scm",E[E.Extensions=5]="Extensions",E[E.Window=10]="Window",E[E.Notification=15]="Notification",E[E.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$Qv=Object.freeze({total(){},worked(){},done(){}});class m{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$Rv=m;class d{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const b=this.d;this.d=()=>{b?.(),u()}}):Promise.resolve()}}e.$Sv=d;let k=class extends P.$Uc{constructor(u,b){super(),this.a=new I.$Fh,b.withProgress(u,f=>(this.b=f,this.c&&f.report(this.c),this.a.p)),this.B((0,P.$Sc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$Tv=k,e.$Tv=k=Je([We(1,e.$Pv)],k);class F extends P.$Uc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new P.$Tc)}start(u){this.stop();const b=++this.a,f=new O.$ee;return this.f=setTimeout(()=>{b===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,P.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Sc)(()=>f.cancel())),this.b.add((0,P.$Sc)(()=>this.c?this.c.done():void 0)),{id:b,token:f.token,stop:()=>this.h(b),isCurrent:()=>this.a===b}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$Uv=F,e.$Vv=(0,N.$ii)("editorProgressService")}),define(Ce[30],Pe([1,0,55,16]),function($e,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=void 0;class P{constructor(){this.a=new Map}add(A,m){I.ok(O.$Vf(A)),I.ok(O.$Xf(m)),I.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,m)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$1n=new P}),define(Ce[72],Pe([1,0,5,30]),function($e,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=void 0,e.$2n={JSONContribution:"base.contributions.json"};function P(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class N{constructor(){this.b=new I.$7d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(d,k){this.a[P(d)]=k,this.b.fire(d)}notifySchemaChanged(d){this.b.fire(d)}getSchemaContributions(){return{schemas:this.a}}}const A=new N;O.$1n.add(e.$2n.JSONContribution,A)}),define(Ce[56],Pe([1,0,18,5,16,152,47,72,30]),function($e,e,I,O,P,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.ConfigurationScope=e.$6n=e.EditPresentationTypes=void 0,e.$eo=r,e.$fo=o,e.$go=s,e.$ho=i,e.$io=a;var k;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(k||(e.EditPresentationTypes=k={})),e.$6n={Configuration:"base.contributions.configuration"};var F;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(F||(e.ConfigurationScope=F={})),e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n={properties:{},patternProperties:{}},e.$$n={properties:{},patternProperties:{}},e.$_n={properties:{},patternProperties:{}},e.$ao="vscode://schemas/settings/resourceLanguage",e.$bo="vscode://schemas/settings/configurationDefaults";const E=d.$1n.as(m.$2n.JSONContribution);class u{constructor(){this.h=new Set,this.i=new O.$7d,this.onDidSchemaChange=this.i.event,this.j=new O.$7d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$ao,this.g),this.v()}registerConfiguration(t,v=!0){this.registerConfigurations([t],v)}registerConfigurations(t,v=!0){const c=new Set;this.n(t,v,c),E.registerSchema(e.$ao,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(t){const v=new Set;this.o(t,v),E.registerSchema(e.$ao,this.g),this.i.fire(),this.j.fire({properties:v})}updateConfigurations({add:t,remove:v}){const c=new Set;this.o(v,c),this.n(t,!1,c),E.registerSchema(e.$ao,this.g),this.i.fire(),this.j.fire({properties:c})}registerDefaultConfigurations(t){const v=new Set;this.k(t,v),this.i.fire(),this.j.fire({properties:v,defaultsOverrides:!0})}k(t,v){const c=[];for(const{overrides:$,source:w}of t)for(const p in $)if(v.add(p),e.$do.test(p)){const l=this.a.get(p),D=l?.valuesSources??new Map;if(w)for(const C of Object.keys($[p]))D.set(C,w);const g={...l?.value||{},...$[p]};this.a.set(p,{source:w,value:g,valuesSources:D});const S=(0,A.$Yi)(p),y={type:"object",default:g,description:N.localize(1,null,S),$ref:e.$ao,defaultDefaultValue:g,source:P.$Vf(w)?void 0:w,defaultValueSource:w};c.push(...r(p)),this.d[p]=y,this.b.properties[p]=y}else{this.a.set(p,{value:$[p],source:w});const l=this.d[p];l&&(this.w(p,l),this.r(p,l))}this.m(c)}deregisterDefaultConfigurations(t){const v=new Set;this.l(t,v),this.i.fire(),this.j.fire({properties:v,defaultsOverrides:!0})}l(t,v){for(const{overrides:c,source:$}of t)for(const w in c){const p=this.a.get(w),l=P.$Vf($)?$:$?.id,D=P.$Vf(p?.source)?p?.source:p?.source?.id;if(l===D)if(v.add(w),this.a.delete(w),e.$do.test(w))delete this.d[w],delete this.b.properties[w];else{const g=this.d[w];g&&(this.w(w,g),this.r(w,g))}}this.u()}deltaConfiguration(t){let v=!1;const c=new Set;t.removedDefaults&&(this.l(t.removedDefaults,c),v=!0),t.addedDefaults&&(this.k(t.addedDefaults,c),v=!0),t.removedConfigurations&&this.o(t.removedConfigurations,c),t.addedConfigurations&&this.n(t.addedConfigurations,!1,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:v})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const v of t)this.h.add(v);this.u()}n(t,v,c){t.forEach($=>{this.p($,v,$.extensionInfo,$.restrictedProperties,void 0,c),this.c.push($),this.q($)})}o(t,v){const c=$=>{if($.properties)for(const w in $.properties){v.add(w);const p=this.d[w];p?.policy?.name&&this.e.delete(p.policy.name),delete this.d[w],this.s(w,$.properties[w])}$.allOf?.forEach(w=>c(w))};for(const $ of t){c($);const w=this.c.indexOf($);w!==-1&&this.c.splice(w,1)}}p(t,v=!0,c,$,w=3,p){w=P.$5f(t.scope)?w:t.scope;const l=t.properties;if(l)for(const g in l){const S=l[g];if(v&&i(g,S)){delete l[g];continue}if(S.source=c,S.defaultDefaultValue=l[g].default,this.w(g,S),e.$do.test(g)?S.scope=void 0:(S.scope=P.$5f(S.scope)?w:S.scope,S.restricted=P.$5f(S.restricted)?!!$?.includes(g):S.restricted),l[g].hasOwnProperty("included")&&!l[g].included){this.f[g]=l[g],delete l[g];continue}else this.d[g]=l[g],l[g].policy?.name&&this.e.set(l[g].policy.name,g);!l[g].deprecationMessage&&l[g].markdownDeprecationMessage&&(l[g].deprecationMessage=l[g].markdownDeprecationMessage),p.add(g)}const D=t.allOf;if(D)for(const g of D)this.p(g,v,c,$,w,p)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const v=c=>{const $=c.properties;if($)for(const p in $)this.r(p,$[p]);c.allOf?.forEach(v)};v(t)}r(t,v){switch(e.$7n.properties[t]=v,v.scope){case 1:e.$8n.properties[t]=v;break;case 2:e.$9n.properties[t]=v;break;case 6:e.$0n.properties[t]=v;break;case 3:e.$$n.properties[t]=v;break;case 4:e.$_n.properties[t]=v;break;case 5:e.$_n.properties[t]=v,this.g.properties[t]=v;break}}s(t,v){switch(delete e.$7n.properties[t],v.scope){case 1:delete e.$8n.properties[t];break;case 2:delete e.$9n.properties[t];break;case 6:delete e.$0n.properties[t];break;case 3:delete e.$$n.properties[t];break;case 4:case 5:delete e.$_n.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const v=`[${t}]`,c={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.$ao};this.w(v,c),e.$7n.properties[v]=c,e.$8n.properties[v]=c,e.$9n.properties[v]=c,e.$0n.properties[v]=c,e.$$n.properties[v]=c,e.$_n.properties[v]=c}}v(){const t={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.$ao};e.$7n.patternProperties[e.$co]=t,e.$8n.patternProperties[e.$co]=t,e.$9n.patternProperties[e.$co]=t,e.$0n.patternProperties[e.$co]=t,e.$$n.patternProperties[e.$co]=t,e.$_n.patternProperties[e.$co]=t,this.i.fire()}w(t,v){const c=this.a.get(t);let $=c?.value,w=c?.source;P.$3f($)&&($=v.defaultDefaultValue,w=void 0),P.$3f($)&&($=s(v.type)),v.default=$,v.defaultValueSource=w}}const b="\\[([^\\]]+)\\]",f=new RegExp(b,"g");e.$co=`^(${b})+$`,e.$do=new RegExp(e.$co);function r(h){const t=[];if(e.$do.test(h)){let v=f.exec(h);for(;v?.length;){const c=v[1].trim();c&&t.push(c),v=f.exec(h)}}return(0,I.$Mb)(t)}function o(h){return h.reduce((t,v)=>`${t}[${v}]`,"")}function s(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new u;d.$1n.add(e.$6n.Configuration,n);function i(h,t){return h.trim()?e.$do.test(h)?N.localize(7,null,h):n.getConfigurationProperties()[h]!==void 0?N.localize(8,null,h):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?N.localize(9,null,h,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:N.localize(6,null)}function a(){const h=[],t=n.getConfigurationProperties();for(const v of Object.keys(t))h.push([v,t[v].scope]);return h.push(["launch",4]),h.push(["task",4]),h}}),define(Ce[195],Pe([1,0,18,5,122,6,28,26,16,2,47,56,30]),function($e,e,I,O,P,N,A,m,d,k,F,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$mo=e.$lo=e.$ko=e.$jo=void 0,e.$no=i;function b(v){return Object.isFrozen(v)?v:m.$Pn(v)}class f{constructor(c={},$=[],w=[],p){this.b=c,this.c=$,this.d=w,this.raw=p,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const c=this.raw.map($=>{if($ instanceof f)return $;const w=new r("");return w.parseRaw($),w.configurationModel});this.f=c.reduce(($,w)=>w===$?w:$.merge(w),c[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(c){return c?(0,F.$Wi)(this.contents,c):this.contents}inspect(c,$){const w=this;return{get value(){return b(w.rawConfiguration.getValue(c))},get override(){return $?b(w.rawConfiguration.getOverrideValue(c,$)):void 0},get merged(){return b($?w.rawConfiguration.override($).getValue(c):w.rawConfiguration.getValue(c))},get overrides(){const p=[];for(const{contents:l,identifiers:D,keys:g}of w.rawConfiguration.overrides){const S=new f(l,g).getValue(c);S!==void 0&&p.push({identifiers:D,value:S})}return p.length?b(p):void 0}}}getOverrideValue(c,$){const w=this.i($);return w?c?(0,F.$Wi)(w,c):w:void 0}getKeysForOverrideIdentifier(c){const $=[];for(const w of this.overrides)w.identifiers.includes(c)&&$.push(...w.keys);return I.$Mb($)}getAllOverrideIdentifiers(){const c=[];for(const $ of this.overrides)c.push(...$.identifiers);return I.$Mb(c)}override(c){let $=this.a.get(c);return $||($=this.g(c),this.a.set(c,$)),$}merge(...c){const $=m.$On(this.contents),w=m.$On(this.overrides),p=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const D of c)if(l.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h($,D.contents);for(const g of D.overrides){const[S]=w.filter(y=>I.$ub(y.identifiers,g.identifiers));S?(this.h(S.contents,g.contents),S.keys.push(...g.keys),S.keys=I.$Mb(S.keys)):w.push(m.$On(g))}for(const g of D.keys)p.indexOf(g)===-1&&p.push(g)}return new f($,p,w,l.every(D=>D instanceof f)?void 0:l)}g(c){const $=this.i(c);if(!$||typeof $!="object"||!Object.keys($).length)return this;const w={};for(const p of I.$Mb([...Object.keys(this.contents),...Object.keys($)])){let l=this.contents[p];const D=$[p];D&&(typeof l=="object"&&typeof D=="object"?(l=m.$On(l),this.h(l,D)):l=D),w[p]=l}return new f(w,this.keys,this.overrides)}h(c,$){for(const w of Object.keys($)){if(w in c&&d.$Xf(c[w])&&d.$Xf($[w])){this.h(c[w],$[w]);continue}c[w]=m.$On($[w])}}i(c){let $=null,w=null;const p=l=>{l&&(w?this.h(w,l):w=m.$On(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===c?$=l.contents:l.identifiers.includes(c)&&p(l.contents);return p($),w}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(c,$){this.j(c,$,!0)}setValue(c,$){this.j(c,$,!1)}removeValue(c){const $=this.keys.indexOf(c);$!==-1&&(this.keys.splice($,1),(0,F.$Vi)(this.contents,c),E.$do.test(c)&&this.overrides.splice(this.overrides.findIndex(w=>I.$ub(w.identifiers,(0,E.$eo)(c))),1))}j(c,$,w){(0,F.$Ui)(this.contents,c,$,p=>console.error(p)),w=w||this.keys.indexOf(c)===-1,w&&this.keys.push(c),E.$do.test(c)&&this.overrides.push({identifiers:(0,E.$eo)(c),keys:Object.keys(this.contents[c]),contents:(0,F.$Ti)(this.contents[c],p=>console.error(p))})}}e.$jo=f;class r{constructor(c){this.f=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new f}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(c,$){if(!d.$5f(c)){const w=this.g(c);this.parseRaw(w,$)}}reparse(c){this.a&&this.parseRaw(this.a,c)}parseRaw(c,$){this.a=c;const{contents:w,keys:p,overrides:l,restricted:D,hasExcludedProperties:g}=this.h(c,$);this.b=new f(w,p,l,g?[c]:void 0),this.c=D||[]}g(c){let $={},w=null,p=[];const l=[],D=[];function g(y){Array.isArray(p)?p.push(y):w!==null&&(p[w]=y)}const S={onObjectBegin:()=>{const y={};g(y),l.push(p),p=y,w=null},onObjectProperty:y=>{w=y},onObjectEnd:()=>{p=l.pop()},onArrayBegin:()=>{const y=[];g(y),l.push(p),p=y,w=null},onArrayEnd:()=>{p=l.pop()},onLiteralValue:g,onError:(y,C,R)=>{D.push({error:y,offset:C,length:R})}};if(c)try{P.$Cn(c,S),$=p[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return $}h(c,$){const w=u.$1n.as(E.$6n.Configuration).getConfigurationProperties(),p=this.i(c,w,!0,$);c=p.raw;const l=(0,F.$Ti)(c,S=>console.error(`Conflict in settings file ${this.f}: ${S}`)),D=Object.keys(c),g=this.j(c,S=>console.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:l,keys:D,overrides:g,restricted:p.restricted,hasExcludedProperties:p.hasExcludedProperties}}i(c,$,w,p){let l=!1;if(!p?.scopes&&!p?.skipRestricted&&!p?.exclude?.length)return{raw:c,restricted:[],hasExcludedProperties:l};const D={},g=[];for(const S in c)if(E.$do.test(S)&&w){const y=this.i(c[S],$,!1,p);D[S]=y.raw,l=l||y.hasExcludedProperties,g.push(...y.restricted)}else{const y=$[S],C=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&g.push(S),!p.exclude?.includes(S)&&(p.include?.includes(S)||(C===void 0||p.scopes===void 0||p.scopes.includes(C))&&!(p.skipRestricted&&y?.restricted))?D[S]=c[S]:l=!0}return{raw:D,restricted:g,hasExcludedProperties:l}}j(c,$){const w=[];for(const p of Object.keys(c))if(E.$do.test(p)){const l={};for(const D in c[p])l[D]=c[p][D];w.push({identifiers:(0,E.$eo)(p),keys:Object.keys(l),contents:(0,F.$Ti)(l,$)})}return w}}e.$ko=r;class o extends N.$Uc{constructor(c,$,w,p){super(),this.c=c,this.f=$,this.g=p,this.b=this.B(new O.$7d),this.onDidChange=this.b.event,this.a=new r(this.c.toString()),this.B(this.g.watch(w.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&w.isEqual(l.resource,c)))(()=>this.b.fire()))}async loadConfiguration(){try{const c=await this.g.readFile(this.c);return this.a.parse(c.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new f}}reparse(c){return c&&(this.f=c),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$lo=o;class s{constructor(c,$,w,p,l,D,g,S,y,C,R,V,U){this.a=c,this.b=$,this.c=w,this.overrideIdentifiers=p,this.d=l,this.f=D,this.g=g,this.h=S,this.i=y,this.j=C,this.k=R,this.l=V,this.m=U}get value(){return b(this.c)}n(c){return c?.value!==void 0||c?.override!==void 0||c?.overrides!==void 0?c:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(c,$,w,p,l=new f,D=new f,g=new A.$Bc,S=new f,y=new A.$Bc){this.c=c,this.d=$,this.f=w,this.g=p,this.h=l,this.i=D,this.j=g,this.l=S,this.m=y,this.a=null,this.b=new A.$Bc,this.n=null}getValue(c,$,w){return this.p(c,$,w).getValue(c)}updateValue(c,$,w={}){let p;w.resource?(p=this.m.get(w.resource),p||(p=new f,this.m.set(w.resource,p))):p=this.l,$===void 0?p.removeValue(c):p.setValue(c,$),w.resource||(this.a=null)}inspect(c,$,w){const p=this.p(c,$,w),l=this.t($.resource,w),D=$.resource?this.m.get($.resource)||this.l:this.l,g=new Set;for(const S of p.overrides)for(const y of S.identifiers)p.getOverrideValue(c,y)!==void 0&&g.add(y);return new s(c,$,p.getValue(c),g.size?[...g]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,w?this.i:void 0,l||void 0,D)}keys(c){const $=this.t(void 0,c);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:$?$.keys.slice(0):[]}}updateDefaultConfiguration(c){this.c=c,this.a=null,this.b.clear()}updatePolicyConfiguration(c){this.d=c}updateApplicationConfiguration(c){this.f=c,this.a=null,this.b.clear()}updateLocalUserConfiguration(c){this.g=c,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(c){this.h=c,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(c){this.i=c,this.a=null,this.b.clear()}updateFolderConfiguration(c,$){this.j.set(c,$),this.b.delete(c)}deleteFolderConfiguration(c){this.folderConfigurations.delete(c),this.b.delete(c)}compareAndUpdateDefaultConfiguration(c,$){const w=[];if(!$){const{added:p,updated:l,removed:D}=h(this.c,c);$=[...p,...l,...D]}for(const p of $)for(const l of(0,E.$eo)(p)){const D=this.c.getKeysForOverrideIdentifier(l),g=c.getKeysForOverrideIdentifier(l),S=[...g.filter(y=>D.indexOf(y)===-1),...D.filter(y=>g.indexOf(y)===-1),...D.filter(y=>!m.$Sn(this.c.override(l).getValue(y),c.override(l).getValue(y)))];w.push([l,S])}return this.updateDefaultConfiguration(c),{keys:$,overrides:w}}compareAndUpdatePolicyConfiguration(c){const{added:$,updated:w,removed:p}=h(this.d,c),l=[...$,...w,...p];return l.length&&this.updatePolicyConfiguration(c),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:$,updated:w,removed:p,overrides:l}=h(this.applicationConfiguration,c),D=[...$,...w,...p];return D.length&&this.updateApplicationConfiguration(c),{keys:D,overrides:l}}compareAndUpdateLocalUserConfiguration(c){const{added:$,updated:w,removed:p,overrides:l}=h(this.localUserConfiguration,c),D=[...$,...w,...p];return D.length&&this.updateLocalUserConfiguration(c),{keys:D,overrides:l}}compareAndUpdateRemoteUserConfiguration(c){const{added:$,updated:w,removed:p,overrides:l}=h(this.remoteUserConfiguration,c),D=[...$,...w,...p];return D.length&&this.updateRemoteUserConfiguration(c),{keys:D,overrides:l}}compareAndUpdateWorkspaceConfiguration(c){const{added:$,updated:w,removed:p,overrides:l}=h(this.workspaceConfiguration,c),D=[...$,...w,...p];return D.length&&this.updateWorkspaceConfiguration(c),{keys:D,overrides:l}}compareAndUpdateFolderConfiguration(c,$){const w=this.folderConfigurations.get(c),{added:p,updated:l,removed:D,overrides:g}=h(w,$),S=[...p,...l,...D];return(S.length||!w)&&this.updateFolderConfiguration(c,$),{keys:S,overrides:g}}compareAndDeleteFolderConfiguration(c){const $=this.folderConfigurations.get(c);if(!$)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:w,updated:p,removed:l,overrides:D}=h($,void 0);return{keys:[...w,...p,...l],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(c,$,w){let p=this.q($,w);return $.overrideIdentifier&&(p=p.override($.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(c)!==void 0&&(p=p.merge(this.d)),p}q({resource:c},$){let w=this.r();if($&&c){const p=$.getFolder(c);p&&(w=this.s(p.uri)||w);const l=this.m.get(c);l&&(w=w.merge(l))}return w}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(c){let $=this.b.get(c);if(!$){const w=this.r(),p=this.j.get(c);p?($=w.merge(p),this.b.set(c,$)):$=w}return $}t(c,$){if($&&c){const w=$.getFolder(c);if(w)return this.j.get(w.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((c,$)=>{const{contents:w,overrides:p,keys:l}=this.j.get($);return c.push([$,{contents:w,overrides:p,keys:l}]),c},[])}}allKeys(){const c=new Set;return this.c.keys.forEach($=>c.add($)),this.userConfiguration.keys.forEach($=>c.add($)),this.i.keys.forEach($=>c.add($)),this.j.forEach($=>$.keys.forEach(w=>c.add(w))),[...c.values()]}u(){const c=new Set;return this.c.getAllOverrideIdentifiers().forEach($=>c.add($)),this.userConfiguration.getAllOverrideIdentifiers().forEach($=>c.add($)),this.i.getAllOverrideIdentifiers().forEach($=>c.add($)),this.j.forEach($=>$.getAllOverrideIdentifiers().forEach(w=>c.add(w))),[...c.values()]}v(c){const $=new Set;return this.c.getKeysForOverrideIdentifier(c).forEach(w=>$.add(w)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(w=>$.add(w)),this.i.getKeysForOverrideIdentifier(c).forEach(w=>$.add(w)),this.j.forEach(w=>w.getKeysForOverrideIdentifier(c).forEach(p=>$.add(p))),[...$.values()]}static parse(c){const $=this.w(c.defaults),w=this.w(c.policy),p=this.w(c.application),l=this.w(c.user),D=this.w(c.workspace),g=c.folders.reduce((S,y)=>(S.set(k.URI.revive(y[0]),this.w(y[1])),S),new A.$Bc);return new n($,w,p,l,new f,D,g,new f,new A.$Bc)}static w(c){return new f(c.contents,c.keys,c.overrides)}}e.$mo=n;function i(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const c=new Set,$=new Map;for(const p of v)p.keys.forEach(l=>c.add(l)),p.overrides.forEach(([l,D])=>{const g=(0,A.$yc)($,l,new Set);D.forEach(S=>g.add(S))});const w=[];return $.forEach((p,l)=>w.push([l,[...p.values()]])),{keys:[...c.values()],overrides:w}}class a{constructor(c,$,w,p){this.change=c,this.f=$,this.g=w,this.h=p,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const l of c.keys)this.affectedKeys.add(l);for(const[,l]of c.overrides)for(const D of l)this.affectedKeys.add(D);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(c,$){const w=this.a+c,p=this.d.indexOf(w);if(p<0)return!1;const l=p+w.length;if(l>=this.d.length)return!1;const D=this.d.charCodeAt(l);if(D!==this.b&&D!==this.c)return!1;if($){const g=this.previousConfiguration?this.previousConfiguration.getValue(c,$,this.f?.workspace):void 0,S=this.g.getValue(c,$,this.h);return!m.$Sn(g,S)}return!0}}e.$oo=a;function h(v,c){const{added:$,removed:w,updated:p}=t(c?.rawConfiguration,v?.rawConfiguration),l=[],D=v?.getAllOverrideIdentifiers()||[],g=c?.getAllOverrideIdentifiers()||[];if(c){const S=g.filter(y=>!D.includes(y));for(const y of S)l.push([y,c.getKeysForOverrideIdentifier(y)])}if(v){const S=D.filter(y=>!g.includes(y));for(const y of S)l.push([y,v.getKeysForOverrideIdentifier(y)])}if(c&&v){for(const S of D)if(g.includes(S)){const y=t({contents:v.getOverrideValue(void 0,S)||{},keys:v.getKeysForOverrideIdentifier(S)},{contents:c.getOverrideValue(void 0,S)||{},keys:c.getKeysForOverrideIdentifier(S)});l.push([S,[...y.added,...y.removed,...y.updated]])}}return{added:$,removed:w,updated:p,overrides:l}}function t(v,c){const $=v?c?v.keys.filter(l=>c.keys.indexOf(l)===-1):[...v.keys]:[],w=c?v?c.keys.filter(l=>v.keys.indexOf(l)===-1):[...c.keys]:[],p=[];if(v&&c){for(const l of c.keys)if(v.keys.indexOf(l)!==-1){const D=(0,F.$Wi)(c.contents,l),g=(0,F.$Wi)(v.contents,l);m.$Sn(D,g)||p.push(l)}}return{added:$,removed:w,updated:p}}}),define(Ce[102],Pe([1,0,14,3]),function($e,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=e.RemoteAuthorityResolverErrorCode=e.$vl=e.$ul=e.RemoteConnectionType=e.$tl=void 0,e.$xl=k,e.$tl=(0,O.$ii)("remoteAuthorityResolverService");var P;(function(F){F[F.WebSocket=0]="WebSocket",F[F.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class N{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.$ul=N;class A{constructor(E,u){this.host=E,this.port=u,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$vl=A;var m;(function(F){F.Unknown="Unknown",F.NotAvailable="NotAvailable",F.TemporarilyNotAvailable="TemporarilyNotAvailable",F.NoResolverFound="NoResolverFound",F.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class d extends I.$bb{static isNotAvailable(E){return E instanceof d&&E._code===m.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof d&&E._code===m.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof d&&E._code===m.NoResolverFound}static isInvalidAuthority(E){return E instanceof d&&E._code===m.InvalidAuthority}static isHandled(E){return E instanceof d&&E.isHandled}constructor(E,u=m.Unknown,b){super(E),this._message=E,this._code=u,this._detail=b,this.isHandled=u===m.NotAvailable&&b===!0,Object.setPrototypeOf(this,d.prototype)}}e.$wl=d;function k(F){const E=F.indexOf("+");return E===-1?F:F.substring(0,E)}}),define(Ce[57],Pe([1,0,12]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=O,e.$um=P,e.$vm=N,e.$wm=A;function O(d){return d.scheme===I.Schemas.vscodeRemote?d.authority:void 0}function P(d){if(!d)return;const k=d.indexOf("+");return k<0?d:d.substr(0,k)}function N(d){const{host:k,port:F}=m(d);if(typeof F>"u")throw new Error(`Invalid remote authority: ${d}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:k,port:F}}function A(d,k){let{host:F,port:E}=m(d);return typeof E>"u"&&(E=k),{host:F,port:E}}function m(d){const k=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(k)return{host:k[1],port:parseInt(k[2],10)};const F=d.match(/^(\[[0-9a-z:]+\])$/);if(F)return{host:F[1],port:void 0};const E=d.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:d,port:void 0}}}),define(Ce[20],Pe([1,0,15,3,57]),function($e,e,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Km=e.$Fm=e.$Em=e.$Dm=e.TargetPlatform=e.ExtensionType=e.$Cm=e.$Am=e.$zm=e.$ym=e.$xm=void 0,e.$Bm=N,e.$Gm=E,e.$Hm=u,e.$Im=b,e.$Jm=f,e.$xm="extensions.user.cache",e.$ym="extensions.builtin.cache",e.$zm="undefined_publisher",e.$Am=["ui","workspace","web"];function N(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.$Cm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(A||(e.ExtensionType=A={}));var m;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class d{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,s){if(typeof o>"u"||o===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof o=="string"||typeof s=="string"){const n=typeof o=="string"?o:o.value,i=typeof s=="string"?s:s.value;return I.$lf(n,i)}return o._lower===s._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$Dm=d;class k{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const s of o)this.add(s)}add(o){this.c.add(d.toKey(o))}delete(o){return this.c.delete(d.toKey(o))}has(o){return this.c.has(d.toKey(o))}}e.$Em=k;class F{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(d.toKey(o))}get(o){return this.c.get(d.toKey(o))}has(o){return this.c.has(d.toKey(o))}set(o,s){this.c.set(d.toKey(o),s)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Fm=F;function E(r){return u(r)}function u(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}function b(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}function f(r,o){if(o){const s=`onResolveRemoteAuthority:${(0,P.$um)(o)}`;return!!r.activationEvents?.includes(s)}return!1}e.$Km=(0,O.$ii)("IBuiltinExtensionsScannerService")}),define(Ce[103],Pe([1,0,14,20]),function($e,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NF=e.$MF=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(A,m){this.a.set(A,m)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const m=Object.create(null);for(const d of A){const k=this.readActivationEvents(d);k.length>0&&(m[O.$Dm.toKey(d.identifier)]=k)}return m}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const m=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let d=0;d<m.length;d++)m[d]==="onUri"&&(m[d]=`onUri:${O.$Dm.toKey(A.identifier)}`);if(!A.contributes)return m;for(const d in A.contributes){const k=this.a.get(d);if(!k)continue;const F=A.contributes[d],E=Array.isArray(F)?F:[F];try{k(E,m)}catch(u){(0,I.$1)(u)}}return m}}e.$MF=P,e.$NF=new P}),define(Ce[196],Pe([1,0,21,73,34]),function($e,e,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=A,e.$3o=m;function N(d){if(I.$u===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}function A(d,k,F,E,u,b,f,r,o){const s=Object.create(null);s["common.machineId"]=b,s["common.sqmId"]=f,s.sessionID=(0,P.$Eg)()+Date.now(),s.commitHash=E,s.version=u,s["common.platformVersion"]=(d||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,I.$h)(I.$u),s["common.nodePlatform"]=O.$ec,s["common.nodeArch"]=F,s["common.product"]=o||"desktop",r&&(s["common.msftInternal"]=r);let n=0;const i=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),I.$l&&(s["common.snap"]="true");const a=N(k);return a&&(s["common.platformDetail"]=a),s}function m(d){const k=O.env.USERDNSDOMAIN;if(!k)return!1;const F=k.toLowerCase();return d.some(E=>F===E)}}),define(Ce[197],Pe([1,0,3]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=void 0,e.$Nl=(0,I.$ii)("telemetryService"),e.$Ol=(0,I.$ii)("customEndpointTelemetryService"),e.$Pl="telemetry.currentSessionDate",e.$Ql="telemetry.firstSessionDate",e.$Rl="telemetry.lastSessionDate",e.$Sl="telemetry.machineId",e.$Tl="telemetry.sqmId",e.$Ul="telemetry",e.$Vl="telemetry.telemetryLevel",e.$Wl="telemetry.enableCrashReporter",e.$Xl="telemetry.enableTelemetry";var O;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var P;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Ce[58],Pe([1,0,26,16,57,196,197]),function($e,e,I,O,P,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=void 0,e.$$o=F,e.$_o=E,e.$ap=u,e.$bp=b,e.$cp=r,e.$dp=s,e.$ep=n,e.$fp=h;class m{constructor(v){this.value=v,this.isTrustedTelemetryValue=!0}}e.$4o=m;class d{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$5o=d,e.$6o=new d;class k{async publicLog(v,c,$){}async publicLogError(v,c,$){}}e.$7o=k,e.$8o="telemetry",e.$9o="extensionTelemetryLog",e.$0o={log:()=>null,flush:()=>Promise.resolve(null)};function F(t,v){return!v.isBuilt&&!v.disableTelemetry?!0:!(v.disableTelemetry||!t.enableTelemetry)}function E(t,v){return v.extensionTestsLocationURI?!0:!(v.isBuilt||v.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function u(t){const v=t.getValue(A.$Vl),c=t.getValue(A.$Wl);if(t.getValue(A.$Xl)===!1||c===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function b(t){const v={},c={},$={};o(t,$);for(let w in $){w=w.length>150?w.substr(w.length-149):w;const p=$[w];typeof p=="number"?c[w]=p:typeof p=="boolean"?c[w]=p?1:0:typeof p=="string"?(p.length>8192&&console.warn(`Telemetry property: ${w} has been trimmed to 8192, the original length is ${p.length}`),v[w]=p.substring(0,8191)):typeof p<"u"&&p!==null&&(v[w]=p)}return{properties:v,measurements:c}}const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(t){if(!t)return"none";const v=(0,P.$um)(t);return f.has(v)?v:"other"}function o(t,v,c=0,$){if(t)for(const w of Object.getOwnPropertyNames(t)){const p=t[w],l=$?$+w:w;Array.isArray(p)?v[l]=(0,I.$Tn)(p):p instanceof Date?v[l]=p.toISOString():(0,O.$Xf)(p)?c<2?o(p,v,c+1,l+"."):v[l]=(0,I.$Tn)(p):v[l]=p}}function s(t,v){const c=t.msftInternalDomains||[],$=v.getValue("telemetry.internalTesting");return(0,N.$3o)(c)||$}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,v){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let c=t;const $=[];for(const D of v)for(;;){const g=D.exec(t);if(!g)break;$.push([g.index,D.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(c="";;){const D=p.exec(t);if(!D)break;const g=$.some(([S,y])=>D.index<y&&S<p.lastIndex);!w.test(D[0])&&!g&&(c+=t.substring(l,D.index)+"<REDACTED: user-file-path>",l=p.lastIndex)}return l<t.length&&(c+=t.substr(l)),c}function a(t){if(!t)return t;const v=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of v)if(c.regex.test(t))return`<REDACTED: ${c.label}>`;return t}function h(t,v){return(0,I.$Qn)(t,c=>{if(c instanceof m||Object.hasOwnProperty.call(c,"isTrustedTelemetryValue"))return c.value;if(typeof c=="string"){let $=c.replaceAll("%20"," ");$=i($,v);for(const w of v)$=$.replace(w,"");return $=a($),$}})}}),define(Ce[198],Pe([1,0,15,98,20,21,2,14,73,58]),function($e,e,I,O,P,N,A,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$hp=void 0,e.$gp=F,e.$ip=f,e.$jp=r,e.$kp=o,e.$lp=s,e.$mp=n,e.$np=i,e.$op=a,e.$qp=h,e.$rp=v;function F(c,$){return c.uuid&&$.uuid?c.uuid===$.uuid:c.id===$.id?!0:(0,I.$gf)(c.id,$.id)===0}const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create($){const w=$.manifest?$.manifest.version:$.version,p=$.manifest?$.targetPlatform:$.properties.targetPlatform;return new u($.identifier,w,p)}static parse($){const w=E.exec($);return w&&w[1]&&w[2]?new u({id:w[1]},w[2],w[4]||void 0):null}constructor($,w,p="undefined"){this.version=w,this.targetPlatform=p,this.id=$.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals($){return $ instanceof u?F(this,$)&&this.version===$.version&&this.targetPlatform===$.targetPlatform:!1}}e.$hp=u;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(c){const $=b.exec(c);return $&&$[1]?[o($[1]),$[2]]:[o(c),void 0]}function r(c,$){return`${c}.${$}`}function o(c){return c.toLowerCase()}function s(c,$){return o(r(c??P.$zm,$))}function n(c,$){const w=[],p=l=>{for(const D of w)if(D.some(g=>F($(g),$(l))))return D;return null};for(const l of c){const D=p(l);D?D.push(l):w.push([l])}return w}function i(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}function a(c){return{id:new k.$4o(c.identifier.id),name:new k.$4o(c.name),galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.$pp=new P.$Dm("pprice.better-merge");function h(c,$){const w=[],p=$.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const l=p.shift();if(l&&w.every(D=>!F(D.identifier,{id:l}))){const D=c.filter(g=>F(g.identifier,{id:l}));D.length===1&&(w.push(D[0]),p.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}async function t(c,$){if(!N.$k)return!1;let w;try{w=(await c.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{w=(await c.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){$.debug("Error while getting the os-release file.",(0,m.$0)(l))}}return!!w&&(w.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function v(c,$){const w=await t(c,$),p=(0,O.$No)(w?"alpine":N.$u,d.$fc);return $.debug("ComputeTargetPlatform:",p),p}}),define(Ce[199],Pe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7r=I,e.$8r=O,e.$9r=P,e.$0r=N,e.$$r=A,e.$_r=m;function I(d){return[...d.entries()]}function O(d){return d?[...d.entries()]:[]}function P(d){return new Map(d)}function N(d){return new Map(d??[])}function A(d){return Array.from(d.entries()).map(k=>[k[0],I(k[1].map),O(k[1].descriptionMap)])}function m(d){return new Map(d.map(k=>[k[0],{map:P(k[1]),descriptionMap:N(k[2])}]))}}),define(Ce[200],Pe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zub=void 0;class I{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,N,A=5){const m=N(d=>{const k=typeof d=="string"?d:d.data;let F=this.a.get(P);if(F){F.data.push(k);return}const E=setTimeout(()=>this.flushBuffer(P),A);F={data:[k],timeoutId:E,dispose:()=>{clearTimeout(E),this.flushBuffer(P),m.dispose()}},this.a.set(P,F)});return m}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const N=this.a.get(P);N&&(this.a.delete(P),this.b(P,N.data.join("")))}}e.$zub=I}),define(Ce[201],Pe([1,0,11,91,302,41,5,16,2,160,72,30]),function($e,e,I,O,P,N,A,m,d,k,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2w=e.$1w=e.$Zw=e.$Yw=e.$Xw=e.$Ww=e.IconFontDefinition=e.IconContribution=e.$Tw=void 0,e.$Uw=o,e.$Vw=s,e.$Tw={IconContribution:"base.contributions.icons"};var u;(function(h){function t(v,c){let $=v.defaults;for(;N.ThemeIcon.isThemeIcon($);){const w=r.getIcon($.id);if(!w)return;$=w.defaults}return $}h.getDefinition=t})(u||(e.IconContribution=u={}));var b;(function(h){function t(c){return{weight:c.weight,style:c.style,src:c.src.map($=>({format:$.format,location:$.location.toString()}))}}h.toJSONObject=t;function v(c){const $=w=>(0,m.$Vf)(w)?w:void 0;if(c&&Array.isArray(c.src)&&c.src.every(w=>(0,m.$Vf)(w.format)&&(0,m.$Vf)(w.location)))return{weight:$(c.weight),style:$(c.style),src:c.src.map(w=>({format:w.format,location:d.URI.parse(w.location)}))}}h.fromJSONObject=v})(b||(e.IconFontDefinition=b={}));class f{constructor(){this.a=new A.$7d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,k.localize)(0,null)},fontCharacter:{type:"string",description:(0,k.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${N.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,v,c,$){const w=this.b[t];if(w){if(c&&!w.description){w.description=c,this.d.properties[t].markdownDescription=`${c} $(${t})`;const D=this.e.enum.indexOf(t);D!==-1&&(this.e.enumDescriptions[D]=c),this.a.fire()}return w}const p={id:t,description:c,defaults:v,deprecationMessage:$};this.b[t]=p;const l={$ref:"#/definitions/icons"};return $&&(l.deprecationMessage=$),c&&(l.markdownDescription=`${c}: $(${t})`),this.d.properties[t]=l,this.e.enum.push(t),this.e.enumDescriptions.push(c||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const v=this.e.enum.indexOf(t);v!==-1&&(this.e.enum.splice(v,1),this.e.enumDescriptions.splice(v,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,v){const c=this.f[t];return c||(this.f[t]=v,this.a.fire(),v)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(w,p)=>w.id.localeCompare(p.id),v=w=>{for(;N.ThemeIcon.isThemeIcon(w.defaults);)w=this.b[w.defaults.id];return`codicon codicon-${w?w.id:""}`},c=[];c.push("| preview     | identifier                        | default codicon ID                | description"),c.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const $=Object.keys(this.b).map(w=>this.b[w]);for(const w of $.filter(p=>!!p.description).sort(t))c.push(`|<i class="${v(w)}"></i>|${w.id}|${N.ThemeIcon.isThemeIcon(w.defaults)?w.defaults.id:w.id}|${w.description||""}|`);c.push("| preview     | identifier                        "),c.push("| ----------- | --------------------------------- |");for(const w of $.filter(p=>!N.ThemeIcon.isThemeIcon(p.defaults)).sort(t))c.push(`|<i class="${v(w)}"></i>|${w.id}|`);return c.join(`
`)}}const r=new f;E.$1n.add(e.$Tw.IconContribution,r);function o(h,t,v,c){return r.registerIcon(h,t,v,c)}function s(){return r}function n(){const h=(0,P.$Dj)();for(const t in h){const v="\\"+h[t].toString(16);r.registerIcon(t,{fontCharacter:v})}}n(),e.$Ww="vscode://schemas/icons";const i=E.$1n.as(F.$2n.JSONContribution);i.registerSchema(e.$Ww,r.getIconSchema());const a=new I.$uh(()=>i.notifySchemaChanged(e.$Ww),200);r.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.$Xw=o("widget-close",O.$Hj.close,(0,k.localize)(2,null)),e.$Yw=o("goto-previous-location",O.$Hj.arrowUp,(0,k.localize)(3,null)),e.$Zw=o("goto-next-location",O.$Hj.arrowDown,(0,k.localize)(4,null)),e.$1w=N.ThemeIcon.modify(O.$Hj.sync,"spin"),e.$2w=N.ThemeIcon.modify(O.$Hj.loading,"spin")}),define(Ce[202],Pe([1,0,5,2,47,3,13]),function($e,e,I,O,P,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8v=e.$7v=e.$4v=e.$2v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Xv=e.$Wv=void 0,e.$Yv=k,e.$Zv=E,e.$1v=u,e.$3v=b,e.$5v=f,e.$6v=r,e.$Wv=(0,N.$ii)("tunnelService"),e.$Xv=(0,N.$ii)("sharedTunnelsService");var m;(function(n){n.Http="http",n.Https="https"})(m||(e.TunnelProtocol=m={}));var d;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(d||(e.TunnelPrivacyId=d={}));function k(n){return!!n.forwardPort}var F;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(F||(e.ProvidedOnAutoForward=F={}));function E(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function u(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const a of i){const h=a.split("=")[1];if(/^https?:/.exec(h)){const t=E(O.URI.parse(h));if(t)return t}}}e.$2v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(n){return e.$2v.indexOf(n)>=0}e.$4v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function f(n){return e.$4v.indexOf(n)>=0}function r(n,i,a,h){if(a===1)return!1;if(a===2&&f(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class o{constructor(i,a,h){this.remoteAddress=i,this.localAddress=a,this.b=h,this.a=new I.$7d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$7v=o;let s=class{constructor(i,a){this.k=i,this.l=a,this.a=new I.$7d,this.onTunnelOpened=this.a.event,this.b=new I.$7d,this.onTunnelClosed=this.b.event,this.c=new I.$7d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],a=Array.from(this.e.values());for(const h of a){const t=Array.from(h.values());for(const v of t){const c=await v.value;c&&typeof c!="string"&&i.push(c)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:a}of i.values())await a.then(h=>typeof h!="string"?h?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,a,h,t,v){this.q(i,a,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:a,localAddress:h,privacy:t,protocol:v,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,a){(f(i)||b(i))&&(i=e.$2v[0]);const h=this.s(i,a);if(h)return++h.refcount,h.value}openTunnel(i,a,h,t,v,c=!1,$,w){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${h} on local port ${v}.`);const p=this.f??i;if(!p)return;if(a||(a="localhost"),t||(t=this.m),this.f&&this.j.has(h)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const l=this.t(p,a,h,t,v,c,$,w);return l?l.then(D=>{if(D){if(typeof D=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(a,h),D}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(a,h);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const g=this.o(D);return(D.tunnelRemoteHost!==a||D.tunnelRemotePort!==h)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),$&&D.privacy!==$&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(g),g}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const a=this.e.get(i.tunnelRemoteHost);if(a){const h=a.get(i.tunnelRemotePort);h&&(h.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,h))}}}}async p(i,a,h){if(h.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${a}.`);const t=h.value.then(async v=>{v&&typeof v!="string"&&(await v.dispose(!0),this.b.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(a),t}}async closeTunnel(i,a){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${a} `);const h=this.e.get(i);if(h&&h.has(a)){const t=h.get(a);t.refcount=0,await this.p(i,a,t)}}q(i,a,h){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(a,{refcount:1,value:h})}async r(i,a){const h=this.e.get(i);if(h){const t=h.get(a),v=t?await t.value:void 0;(!v||typeof v=="string")&&h.delete(a),h.size===0&&this.e.delete(i)}}s(i,a){const h=[i];b(i)?(h.push(...e.$2v),h.push(...e.$4v)):f(i)&&h.push(...e.$4v);const t=h.map(v=>this.e.get(v));for(const v of t){const c=v?.get(a);if(c)return c}}canTunnel(i){return!!E(i)}u(i,a,h,t,v,c,$){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${h} on local port ${t}.`);const w=h;this.j.add(w);const p=t===void 0?h:t,l={elevationRequired:v?this.isPortPrivileged(p):!1},D={remoteAddress:{host:a,port:h},localAddressPort:t,privacy:c,public:c?c!==d.Private:void 0,protocol:$},g=i.forwardPort(D,l);return g?(this.q(a,h,g),g.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(w)})):this.j.delete(w),g}};e.$8v=s,e.$8v=s=Je([We(0,A.$Oj),We(1,P.$Oi)],s)}),define(Ce[203],Pe([1,0,3]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$9v=void 0,e.$9v=(0,I.$ii)("editSessionIdentityService");var O;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(O||(e.EditSessionIdentityMatch=O={}))}),define(Ce[204],Pe([1,0,12]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TL=O,e.$UL=P,e.$VL=N,e.$WL=A,e.$XL=m;function O(d){return d.scheme!==I.Schemas.file&&d.scheme!==I.Schemas.vscodeRemote}function P(d){if(d.folders.length)return d.folders.every(k=>O(k.uri))?d.folders[0].uri:void 0;if(d.configuration&&O(d.configuration))return d.configuration}function N(d){return P(d)?.scheme}function A(d){return P(d)?.authority}function m(d){return P(d)!==void 0}}),define(Ce[48],Pe([1,0,161,19,51,24,2,3,12]),function($e,e,I,O,P,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Ci=e.$Bi=e.WorkbenchState=e.$vi=e.$ui=e.$ri=void 0,e.$si=k,e.$ti=F,e.$wi=E,e.$xi=u,e.$yi=b,e.$zi=r,e.$Ai=o,e.$Di=i,e.$Ii=a,e.$Ji=h,e.$Li=t,e.$Mi=v,e.$Ni=c,e.$ri=(0,m.$ii)("contextService");function k($){const w=$;return typeof w?.id=="string"&&A.URI.isUri(w.uri)}function F($){return typeof $?.id=="string"&&!k($)&&!u($)}e.$ui={id:"ext-dev"},e.$vi={id:"empty-window"};function E($,w){if(typeof $=="string"||typeof $>"u")return typeof $=="string"?{id:(0,O.$oc)($)}:w?e.$ui:e.$vi;const p=$;return p.configuration?{id:p.id,configPath:p.configuration}:p.folders.length===1?{id:p.id,uri:p.folders[0].uri}:{id:p.id}}function u($){const w=$;return typeof w?.id=="string"&&A.URI.isUri(w.configPath)}function b($){const w=$;if(w?.uri)return{id:w.id,uri:A.URI.revive(w.uri)};const p=$;if(p?.configPath)return{id:p.id,configPath:A.URI.revive(p.configPath)};if($?.id)return{id:$.id}}var f;(function($){$[$.EMPTY=1]="EMPTY",$[$.FOLDER=2]="FOLDER",$[$.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function r($){const w=$;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}function o($){const w=$;return!!(w&&typeof w=="object"&&A.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}class s{constructor(w,p,l,D,g){this.h=w,this.j=l,this.k=D,this.l=g,this.c=P.$oi.forUris(this.l,()=>!0),this.folders=p}update(w){this.h=w.id,this.k=w.configuration,this.j=w.transient,this.l=w.l,this.folders=w.folders}get folders(){return this.g}set folders(w){this.g=w,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(w){this.k=w}getFolder(w){return w&&this.c.findSubstr(w)||null}n(){this.c=P.$oi.forUris(this.l,()=>!0);for(const w of this.folders)this.c.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Bi=s;class n{constructor(w,p){this.raw=p,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,N.$Vg)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ci=n;function i($){return new n({uri:$,index:0,name:(0,N.$Rg)($)},{uri:$.toString()})}e.$Ei="code-workspace",e.$Fi=`.${e.$Ei}`,e.$Gi=[{name:(0,I.localize)(0,null),extensions:[e.$Ei]}],e.$Hi="workspace.json";function a($,w){return N.$Mg.isEqualOrParent($,w.untitledWorkspacesHome)}function h($){let w;return A.URI.isUri($)?w=$:w=$.configuration,w?.scheme===d.Schemas.tmp}e.$Ki="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t($){return $.id===e.$Ki}function v($,w){return!a($,w)&&!h($)}function c($){return(typeof $=="string"?(0,O.$pc)($):(0,N.$Tg)($))===e.$Fi}}),define(Ce[74],Pe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xic=void 0;class I{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const N=this.c++;return this.b.set(N,P),this.e(),N}get(P,N){return this.b.has(P)?this.b.get(P)[N]:void 0}delete(P){this.b.delete(P),this.e()}e(){I.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Xic=I}),define(Ce[44],Pe([1,0,12,24,3]),function($e,e,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ic=e.$3ic=void 0;class N{constructor(){this.a=new Set(Object.keys(I.Schemas)),this.b=new Map,this.extUri=new O.$Kg(m=>{const d=this.b.get(m.scheme);return!(d===void 0||d&1024)})}$acceptProviderInfos(m,d){d===null?this.b.delete(m.scheme):this.b.set(m.scheme,d)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$3ic=N,e.$4ic=(0,P.$ii)("IExtHostFileSystemInfo")}),define(Ce[27],Pe([1,0,3]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VO=void 0,e.$VO=(0,I.$ii)("IExtHostInitDataService")}),define(Ce[205],Pe([1,0,167,13,192,27]),function($e,e,I,O,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0kc=void 0;let A=class extends P.$4P{constructor(d,k,F){const E=F.remote.isRemote?"remoteexthost":d?"workerexthost":"exthost",u=F.remote.isRemote?(0,I.localize)(0,null):d?(0,I.localize)(1,null):(0,I.localize)(2,null);super(k.createLogger(E,{name:u}))}};e.$0kc=A,e.$0kc=A=Je([We(1,O.$Pj),We(2,N.$VO)],A)}),define(Ce[206],Pe([1,0,11]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mjc=e.$Ljc=void 0;class O{constructor(A,m,d){this.h=new Map,this.a=A,this.b=m,this.c=d,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new I.$uh(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const F of k.values())F.complete()}catch(F){for(const E of k.values())E.error(F)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,m){let d=this.f[A];return typeof d>"u"&&(d=m),d}update(A,m){this.f[A]=m;const d=this.h.get(A);if(d!==void 0)return d.p;const k=new I.$Fh;return this.h.set(A,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.$Ljc=O;class P extends O{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,m){super(A.identifier.value,!0,m),this.j=A}}e.$Mjc=P}),define(Ce[207],Pe([1,0,5,2]),function($e,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zkc=void 0;class P{constructor(A){this.c=A,this.a=new I.$7d,this.onDidSaveNotebookDocument=this.a.event,this.b=new I.$7d,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,m,d,k){const E=this.c.getNotebookDocument(O.URI.revive(A)).acceptModelChanged(m.value,d,k);this.b.fire(E)}$acceptDirtyStateChanged(A,m){this.c.getNotebookDocument(O.URI.revive(A)).acceptDirty(m)}$acceptModelSaved(A){const m=this.c.getNotebookDocument(O.URI.revive(A));this.a.fire(m.apiNotebook)}}e.$zkc=P}),define(Ce[17],Pe([1,0,3]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GO=e.$FO=void 0,e.$FO=(0,I.$ii)("IExtHostRpcService");class O{constructor(N){this.getProxy=N.getProxy.bind(N),this.set=N.set.bind(N),this.dispose=N.dispose.bind(N),this.assertRegistered=N.assertRegistered.bind(N),this.drain=N.drain.bind(N)}}e.$GO=O}),define(Ce[208],Pe([1,0,20,5]),function($e,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tjc=void 0;class P{#e;constructor(A,m){this.b=new O.$7d,this.onDidChange=this.b.event,this.a=I.$Dm.toKey(A.identifier),this.#e=m,this.#e.onDidChangePassword(d=>{d.extensionId===this.a&&this.b.fire({key:d.key})})}get(A){return this.#e.get(this.a,A)}store(A,m){return this.#e.store(this.a,A,m)}delete(A){return this.#e.delete(this.a,A)}}e.$Tjc=P}),define(Ce[59],Pe([1,0,3]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kjc=e.$jjc=void 0,e.$jjc=(0,I.$ii)("IURITransformerService");class O{constructor(N){N?(this.transformIncoming=N.transformIncoming.bind(N),this.transformOutgoing=N.transformOutgoing.bind(N),this.transformOutgoingURI=N.transformOutgoingURI.bind(N),this.transformOutgoingScheme=N.transformOutgoingScheme.bind(N)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$kjc=O}),define(Ce[209],Pe([1,0,23]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Snb=P,e.$Tnb=A;class O{constructor(){this.buffers=[]}add(d){let k=this.buffers.indexOf(d);return k<0&&(k=this.buffers.length,this.buffers.push(d)),k}}function P(m,d){if(d.serializeBuffersForPostMessage){const k=new O,E=JSON.stringify(m,(b,f)=>{if(f instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:k.add(f)};if(ArrayBuffer.isView(f)){const r=N(f);if(r)return{$$vscode_array_buffer_reference$$:!0,index:k.add(f.buffer),view:{type:r,byteLength:f.byteLength,byteOffset:f.byteOffset}}}return f}),u=k.buffers.map(b=>{const f=new Uint8Array(b);return I.$ue.wrap(f)});return{message:E,buffers:u}}else return{message:JSON.stringify(m),buffers:[]}}function N(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(m,d){const k=d.map(u=>{const b=new ArrayBuffer(u.byteLength);return new Uint8Array(b).set(u.buffer),b}),F=d.length?(u,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const f=b,{index:r}=f,o=k[r];if(f.view)switch(f.view.type){case 1:return new Int8Array(o,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return b}:void 0;return{message:JSON.parse(m,F),arrayBuffers:k}}}),define(Ce[104],Pe([1,0,176,16,2,6,3,30,43,12,42,138,32]),function($e,e,I,O,P,N,A,m,d,k,F,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$oF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$fF=e.EditorInputCapabilities=e.$eF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$8E=e.$7E=e.$6E=e.$5E=e.$4E=void 0,e.$9E=r,e.$0E=o,e.$$E=s,e.$_E=n,e.$aF=i,e.$bF=a,e.$cF=h,e.$dF=t,e.$gF=l,e.$hF=g,e.$iF=S,e.$jF=y,e.$kF=C,e.$lF=R,e.$mF=V,e.$nF=ne,e.$pF=Re,e.$qF=ue,e.$rF=te,e.$sF=be,e.$4E={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$5E={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.$6E="workbench.editor.sidebysideEditor",e.$7E="workbench.editors.textDiffEditor",e.$8E="workbench.editors.binaryResourceDiffEditor";var b;(function(oe){oe[oe.PROGRAMMATIC=1]="PROGRAMMATIC",oe[oe.USER=2]="USER",oe[oe.EDIT=3]="EDIT",oe[oe.NAVIGATION=4]="NAVIGATION",oe[oe.JUMP=5]="JUMP"})(b||(e.EditorPaneSelectionChangeReason=b={}));var f;(function(oe){oe[oe.IDENTICAL=1]="IDENTICAL",oe[oe.SIMILAR=2]="SIMILAR",oe[oe.DIFFERENT=3]="DIFFERENT"})(f||(e.EditorPaneSelectionCompareResult=f={}));function r(oe){const de=oe;return!!de&&typeof de.getSelection=="function"&&!!de.onDidChangeSelection}function o(oe,de,W){for(const ee of W.visibleEditorPanes)if(ee.group.id===de&&oe.matches(ee.input))return ee.getViewState()}function s(oe){if(l(oe))return!1;const de=oe;return P.URI.isUri(de?.resource)}function n(oe){if(l(oe))return!1;const de=oe;return de?.original!==void 0&&de.modified!==void 0}function i(oe){if(l(oe))return!1;const de=oe;return!de||de.resources&&!Array.isArray(de.resources)?!1:!!de.resources||!!de.multiDiffSource}function a(oe){if(l(oe)||n(oe))return!1;const de=oe;return de?.primary!==void 0&&de.secondary!==void 0}function h(oe){if(l(oe))return!1;const de=oe;return de?de.resource===void 0||de.resource.scheme===k.Schemas.untitled||de.forceUntitled===!0:!1}function t(oe){if(l(oe))return!1;const de=oe;return P.URI.isUri(de?.base?.resource)&&P.URI.isUri(de?.input1?.resource)&&P.URI.isUri(de?.input2?.resource)&&P.URI.isUri(de?.result?.resource)}var v;(function(oe){oe[oe.SHORT=0]="SHORT",oe[oe.MEDIUM=1]="MEDIUM",oe[oe.LONG=2]="LONG"})(v||(e.Verbosity=v={}));var c;(function(oe){oe[oe.EXPLICIT=1]="EXPLICIT",oe[oe.AUTO=2]="AUTO",oe[oe.FOCUS_CHANGE=3]="FOCUS_CHANGE",oe[oe.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c||(e.SaveReason=c={}));class ${constructor(){this.a=new Map}registerSource(de,W){let ee=this.a.get(de);return ee||(ee={source:de,label:W},this.a.set(de,ee)),ee.source}getSourceLabel(de){return this.a.get(de)?.label??de}}e.$eF=new $;var w;(function(oe){oe[oe.None=0]="None",oe[oe.Readonly=2]="Readonly",oe[oe.Untitled=4]="Untitled",oe[oe.Singleton=8]="Singleton",oe[oe.RequiresTrust=16]="RequiresTrust",oe[oe.CanSplitInGroup=32]="CanSplitInGroup",oe[oe.ForceDescription=64]="ForceDescription",oe[oe.CanDropIntoEditor=128]="CanDropIntoEditor",oe[oe.MultipleEditors=256]="MultipleEditors",oe[oe.Scratchpad=512]="Scratchpad"})(w||(e.EditorInputCapabilities=w={}));class p extends N.$Uc{}e.$fF=p;function l(oe){return oe instanceof p}function D(oe){const de=oe;return P.URI.isUri(de?.preferredResource)}function g(oe){const de=oe;return l(de?.primary)&&l(de?.secondary)}function S(oe){const de=oe;return l(de?.modified)&&l(de?.original)}function y(oe,de,W,ee,ke){return be(ee,[(0,E.$5i)({id:"workbench.action.openLargeFile",label:(0,I.localize)(2,null),run:()=>{const Te={...W,limits:{size:Number.MAX_VALUE}};oe.openEditor(de,Te)}}),(0,E.$5i)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,I.localize)(3,null),run:()=>ke.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function C(oe){return l(oe?.editor)}function R(oe){const de=oe;return C(oe)&&de?.group!==void 0}function V(oe){const de=oe;return typeof de?.groupId=="number"&&l(de.editor)}var U;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.REPLACE=1]="REPLACE",oe[oe.MOVE=2]="MOVE",oe[oe.UNPIN=3]="UNPIN"})(U||(e.EditorCloseContext=U={}));var q;(function(oe){oe[oe.GROUP_ACTIVE=0]="GROUP_ACTIVE",oe[oe.GROUP_INDEX=1]="GROUP_INDEX",oe[oe.GROUP_LABEL=2]="GROUP_LABEL",oe[oe.GROUP_LOCKED=3]="GROUP_LOCKED",oe[oe.EDITOR_OPEN=4]="EDITOR_OPEN",oe[oe.EDITOR_CLOSE=5]="EDITOR_CLOSE",oe[oe.EDITOR_MOVE=6]="EDITOR_MOVE",oe[oe.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",oe[oe.EDITOR_LABEL=8]="EDITOR_LABEL",oe[oe.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",oe[oe.EDITOR_PIN=10]="EDITOR_PIN",oe[oe.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",oe[oe.EDITOR_STICKY=12]="EDITOR_STICKY",oe[oe.EDITOR_DIRTY=13]="EDITOR_DIRTY",oe[oe.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(q||(e.GroupModelChangeKind=q={}));var M;(function(oe){oe[oe.PRIMARY=1]="PRIMARY",oe[oe.SECONDARY=2]="SECONDARY",oe[oe.BOTH=3]="BOTH",oe[oe.ANY=4]="ANY"})(M||(e.SideBySideEditor=M={}));class L{getOriginalUri(de,W){if(!de)return;if(t(de))return e.$oF.getOriginalUri(de.result,W);if(W?.supportSideBySide){const{primary:ke,secondary:Te}=this.a(de);if(ke&&Te){if(W?.supportSideBySide===M.BOTH)return{primary:this.getOriginalUri(ke,{filterByScheme:W.filterByScheme}),secondary:this.getOriginalUri(Te,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===M.ANY)return this.getOriginalUri(ke,{filterByScheme:W.filterByScheme})??this.getOriginalUri(Te,{filterByScheme:W.filterByScheme});de=W.supportSideBySide===M.PRIMARY?ke:Te}}if(n(de)||i(de)||a(de)||t(de))return;const ee=D(de)?de.preferredResource:de.resource;return!ee||!W||!W.filterByScheme?ee:this.b(ee,W.filterByScheme)}a(de){return g(de)||a(de)?{primary:de.primary,secondary:de.secondary}:S(de)||n(de)?{primary:de.modified,secondary:de.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(de,W){if(!de)return;if(t(de))return e.$oF.getCanonicalUri(de.result,W);if(W?.supportSideBySide){const{primary:ke,secondary:Te}=this.a(de);if(ke&&Te){if(W?.supportSideBySide===M.BOTH)return{primary:this.getCanonicalUri(ke,{filterByScheme:W.filterByScheme}),secondary:this.getCanonicalUri(Te,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===M.ANY)return this.getCanonicalUri(ke,{filterByScheme:W.filterByScheme})??this.getCanonicalUri(Te,{filterByScheme:W.filterByScheme});de=W.supportSideBySide===M.PRIMARY?ke:Te}}if(n(de)||i(de)||a(de)||t(de))return;const ee=de.resource;return!ee||!W||!W.filterByScheme?ee:this.b(ee,W.filterByScheme)}b(de,W){if(Array.isArray(W)){if(W.some(ee=>de.scheme===ee))return de}else if(W===de.scheme)return de}}var G;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.KEYBOARD=1]="KEYBOARD",oe[oe.MOUSE=2]="MOUSE"})(G||(e.EditorCloseMethod=G={}));function ne(oe,de,W,ee){if(!oe.isSticky(de))return!1;switch(ee.preventPinnedEditorClose){case"keyboardAndMouse":return W===G.MOUSE||W===G.KEYBOARD;case"mouse":return W===G.MOUSE;case"keyboard":return W===G.KEYBOARD}return!1}e.$oF=new L;var he;(function(oe){oe[oe.LEFT=0]="LEFT",oe[oe.RIGHT=1]="RIGHT"})(he||(e.CloseDirection=he={}));class ye{constructor(){this.c=new Map,this.d=new Map}start(de){const W=this.a=de.get(A.$hi);for(const[ee,ke]of this.c)this.e(ee,ke,W);this.c.clear()}e(de,W,ee){const ke=ee.createInstance(W);this.d.set(de,ke)}registerFileEditorFactory(de){if(this.b)throw new Error("Can only register one file editor factory.");this.b=de}getFileEditorFactory(){return(0,O.$7f)(this.b)}registerEditorSerializer(de,W){if(this.c.has(de)||this.d.has(de))throw new Error(`A editor serializer with type ID '${de}' was already registered.`);return this.a?this.e(de,W,this.a):this.c.set(de,W),(0,N.$Sc)(()=>{this.c.delete(de),this.d.delete(de)})}getEditorSerializer(de){return this.d.get(typeof de=="string"?de:de.typeId)}}m.$1n.add(e.$4E.EditorFactory,new ye);async function Re(oe,de,W){return!oe||!oe.length?[]:await Promise.all(oe.map(async ee=>{const ke=P.URI.revive(ee.fileUri);if(!ke){W.info("Cannot resolve the path because it is not valid.",ee);return}if(!await de.canHandleResource(ke)){W.info("Cannot resolve the path because it cannot be handled",ee);return}let Se=ee.exists,ve=ee.type;if(typeof Se!="boolean"||typeof ve!="number")try{ve=(await de.stat(ke)).isDirectory?d.FileType.Directory:d.FileType.Unknown,Se=!0}catch(J){W.error(J),Se=!1}if(!Se&&ee.openOnlyIfExists){W.info("Cannot resolve the path because it does not exist",ee);return}if(ve===d.FileType.Directory){W.info("Cannot resolve the path because it is a directory",ee);return}const me={...ee.options,pinned:!0};return Se?{resource:ke,options:me}:{resource:ke,options:me,forceUntitled:!0}}))}var ge;(function(oe){oe[oe.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",oe[oe.SEQUENTIAL=1]="SEQUENTIAL"})(ge||(e.EditorsOrder=ge={}));function ue(oe){const de=oe;if(!de)return!1;const W=de;if(W.modified)return ue(W.modified);const ee=de;return!!(ee.contributionsState&&ee.viewState&&Array.isArray(ee.cursorState))}function te(oe){return(0,F.$7i)(oe)}function be(oe,de,W){const ee=(0,F.$8i)(oe,de);return ee.forceMessage=W?.forceMessage,ee.forceSeverity=W?.forceSeverity,ee.allowDialog=W?.allowDialog,ee}}),define(Ce[210],Pe([1,0,5,177,3,6,28,30,18,26,91,201]),function($e,e,I,O,P,N,A,m,d,k,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AF=e.$zF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$yF=e.ViewContentGroups=e.$wF=e.ViewContainerLocation=e.Extensions=e.$vF=e.$uF=e.$tF=void 0,e.$xF=f,e.$tF="views",e.$uF=(0,O.localize)(0,null),e.$vF=(0,E.$Uw)("default-view-icon",F.$Hj.window,(0,O.localize)(1,null));var u;(function(v){v.ViewContainersRegistry="workbench.registry.view.containers",v.ViewsRegistry="workbench.registry.view"})(u||(e.Extensions=u={}));var b;(function(v){v[v.Sidebar=0]="Sidebar",v[v.Panel=1]="Panel",v[v.AuxiliaryBar=2]="AuxiliaryBar"})(b||(e.ViewContainerLocation=b={})),e.$wF=[0,1,2];function f(v){switch(v){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class r extends N.$Uc{constructor(){super(...arguments),this.c=this.B(new I.$7d),this.onDidRegister=this.c.event,this.f=this.B(new I.$7d),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,d.$Rb)([...this.g.values()])}registerViewContainer(c,$,w){const p=this.get(c.id);if(p)return p;const l=c;return l.openCommandActionDescriptor=w?.doNotRegisterOpenCommand?void 0:l.openCommandActionDescriptor??{id:l.id},(0,A.$yc)(this.g,$,[]).push(l),w?.isDefault&&this.h.push(l),this.c.fire({viewContainer:l,viewContainerLocation:$}),l}deregisterViewContainer(c){for(const $ of this.g.keys()){const w=this.g.get($),p=w?.indexOf(c);if(p!==-1){w?.splice(p,1),w.length===0&&this.g.delete($),this.f.fire({viewContainer:c,viewContainerLocation:$});return}}}get(c){return this.all.filter($=>$.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter($=>this.getViewContainers($).filter(w=>w?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find($=>this.getViewContainerLocation($)===c)}}m.$1n.add(u.ViewContainersRegistry,new r);var o;(function(v){v.Open="2_open",v.Debug="4_debug",v.SCM="5_scm",v.More="9_more"})(o||(e.ViewContentGroups=o={}));function s(v,c){const $=v.group??o.More,w=c.group??o.More;return $!==w?$.localeCompare(w):(v.order??5)-(c.order??5)}class n extends N.$Uc{constructor(){super(...arguments),this.c=this.B(new I.$7d),this.onViewsRegistered=this.c.event,this.f=this.B(new I.$7d),this.onViewsDeregistered=this.f.event,this.g=this.B(new I.$7d),this.onDidChangeContainer=this.g.event,this.h=this.B(new I.$7d),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Hc}registerViews(c,$){this.registerViews2([{views:c,viewContainer:$}])}registerViews2(c){c.forEach(({views:$,viewContainer:w})=>this.r($,w)),this.c.fire(c)}deregisterViews(c,$){const w=this.s(c,$);w.length&&this.f.fire({views:w,viewContainer:$})}moveViews(c,$){for(const w of this.m.keys())if(w!==$){const p=this.s(c,w);p.length&&(this.r(p,$),this.g.fire({views:p,from:w,to:$}))}}getViews(c){return this.m.get(c)||[]}getView(c){for(const $ of this.j){const w=(this.m.get($)||[]).filter(p=>p.id===c)[0];if(w)return w}return null}getViewContainer(c){for(const $ of this.j)if((this.m.get($)||[]).filter(p=>p.id===c)[0])return $;return null}registerViewWelcomeContent(c,$){return this.n.add(c,$),this.h.fire(c),(0,N.$Sc)(()=>{this.n.delete(c,$),this.h.fire(c)})}registerViewWelcomeContent2(c,$){const w=new Map;for(const[p,l]of $)this.n.add(c,l),w.set(p,(0,N.$Sc)(()=>{this.n.delete(c,l),this.h.fire(c)}));return this.h.fire(c),w}getViewWelcomeContent(c){const $=[];return this.n.forEach(c,w=>$.push(w)),$.sort(s)}r(c,$){let w=this.m.get($);w||(w=[],this.m.set($,w),this.j.push($));for(const p of c){if(this.getView(p.id)!==null)throw new Error((0,O.localize)(2,null,p.id));w.push(p)}}s(c,$){const w=this.m.get($);if(!w)return[];const p=[],l=[];for(const D of w)c.includes(D)?p.push(D):l.push(D);return p.length&&(l.length?this.m.set($,l):(this.m.delete($),this.j.splice(this.j.indexOf($),1))),p}}m.$1n.add(u.ViewsRegistry,new n),e.$yF=(0,P.$ii)("viewDescriptorService");var i;(function(v){v[v.Default=0]="Default",v[v.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var a;(function(v){v[v.None=0]="None",v[v.Collapsed=1]="Collapsed",v[v.Expanded=2]="Expanded"})(a||(e.TreeItemCollapsibleState=a={}));class h{constructor(c,$){this.c=!1,this.d=!1,(0,k.$Rn)(this,c),this.d=!!$,this.resolve=async w=>{if($&&!this.c){const p=await $(w);p&&(this.tooltip=this.tooltip??p.tooltip,this.command=this.command??p.command)}w.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$zF=h;class t extends Error{constructor(c){super((0,O.localize)(3,null,c)),this.name="NoTreeViewError"}static is(c){return c.name==="NoTreeViewError"}}e.$AF=t}),define(Ce[211],Pe([1,0,3]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EF=void 0,e.$EF=(0,I.$ii)("IChatContributionService")}),define(Ce[212],Pe([1,0,18,5,39,6,33,3,211]),function($e,e,I,O,P,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BG=e.$AG=e.$zG=e.ChatAgentLocation=void 0;var k;(function(u){u[u.Panel=1]="Panel",u[u.Terminal=2]="Terminal",u[u.Notebook=3]="Notebook"})(k||(e.ChatAgentLocation=k={})),function(u){function b(f){switch(f){case"panel":return u.Panel;case"terminal":return u.Terminal;case"notebook":return u.Notebook}return u.Panel}u.fromRaw=b}(k||(e.ChatAgentLocation=k={})),e.$zG=(0,m.$ii)("chatAgentService");let F=class extends N.$Uc{static{this.AGENT_LEADER="@"}constructor(b,f){super(),this.g=b,this.h=f,this.b=new Map,this.f=this.B(new O.$7d),this.onDidChangeAgents=this.f.event}dispose(){super.dispose(),this.b.clear()}registerAgent(b,f){if(this.b.has(b))throw new Error(`Already registered an agent with id ${b}`);const r=this.getAgent(b);if(!r)throw new Error(`Unknown agent: ${b}`);const o={data:r,impl:f};return this.b.set(b,o),this.f.fire(new E(r,f)),(0,N.$Sc)(()=>{this.b.delete(b)&&this.f.fire(void 0)})}registerDynamicAgent(b,f){const r={data:b,impl:f};return this.b.set(b.id,r),this.f.fire(new E(b,f)),(0,N.$Sc)(()=>{this.b.delete(b.id)&&this.f.fire(void 0)})}updateAgent(b,f){const r=this.b.get(b);if(!r?.impl)throw new Error(`No activated agent with id ${b} registered`);r.data.metadata={...r.data.metadata,...f},this.f.fire(new E(r.data,r.impl))}getDefaultAgent(){return this.getActivatedAgents().find(b=>!!b.isDefault)}getSecondaryAgent(){return P.Iterable.find(this.b.values(),b=>!!b.data.metadata.isSecondary)?.data}getRegisteredAgents(){const b=this;return this.g.registeredParticipants.map(f=>({extensionId:f.extensionId,id:f.name,metadata:{description:f.description},isDefault:f.isDefault,defaultImplicitVariables:f.defaultImplicitVariables,locations:(0,I.$Lb)(f.locations)?f.locations.map(k.fromRaw):[k.Panel],get slashCommands(){return(f.commands??[]).filter(o=>!o.when||b.h.contextMatchesRules(A.$gj.deserialize(o.when)))}}))}getAgents(){const b=this.getRegisteredAgents(),f=Array.from(this.b.values()).map(o=>o.data),r=[...b,...f];return(0,I.$Mb)(r,o=>o.id)}getActivatedAgents(){return Array.from(this.b.values()).filter(b=>!!b.impl).map(b=>new E(b.data,b.impl))}getAgent(b){return this.getAgents().find(f=>f.id===b)}async invokeAgent(b,f,r,o,s){const n=this.b.get(b);if(!n?.impl)throw new Error(`No activated agent with id ${b}`);return await n.impl.invoke(f,r,o,s)}async getFollowups(b,f,r,o,s){const n=this.b.get(b);if(!n?.impl)throw new Error(`No activated agent with id ${b}`);return n.impl?.provideFollowups?n.impl.provideFollowups(f,r,o,s):[]}};e.$AG=F,e.$AG=F=Je([We(0,d.$EF),We(1,A.$Aj)],F);class E{constructor(b,f){this.b=b,this.d=f}get id(){return this.b.id}get extensionId(){return this.b.extensionId}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(b,f,r,o){return this.d.invoke(b,f,r,o)}async provideFollowups(b,f,r,o){return this.d.provideFollowups?this.d.provideFollowups(b,f,r,o):[]}provideWelcomeMessage(b){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(b)}provideSampleQuestions(b){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(b)}}e.$BG=E}),define(Ce[213],Pe([1,0,2,29,3]),function($e,e,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LF=e.$KF=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$IF=N,e.$JF=A;function N(k){return!!k&&typeof k=="object"&&"uri"in k&&k.uri instanceof I.URI&&"version"in k&&typeof k.version=="number"&&"ranges"in k&&Array.isArray(k.ranges)&&k.ranges.every(O.$ct.isIRange)}function A(k){return!!k&&typeof k=="object"&&"documents"in k&&Array.isArray(k.documents)&&k.documents.every(N)}var m;(function(k){k[k.Down=0]="Down",k[k.Up=1]="Up"})(m||(e.InteractiveSessionVoteDirection=m={}));var d;(function(k){k[k.Action=1]="Action",k[k.Toolbar=2]="Toolbar"})(d||(e.ChatCopyKind=d={})),e.$KF=(0,P.$ii)("IChatService"),e.$LF="accessibility.voice.keywordActivation"}),define(Ce[214],Pe([1,0,5,11,178]),function($e,e,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mob=void 0;class N{constructor(){this.f=new Map,this.m=[],this.n=new I.$7d,this.o=new I.$7d,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(m){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=m}onEvent(m){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=m}onRequest(m){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.u("response",m)}sendRequest(m,d,k,F){const E={command:m};if(d&&Object.keys(d).length>0&&(E.arguments=d),this.u("request",E),typeof F=="number"){const u=setTimeout(()=>{clearTimeout(u);const b=this.f.get(E.seq);if(b){this.f.delete(E.seq);const f={type:"response",seq:0,request_seq:E.seq,success:!1,command:m,message:(0,P.localize)(0,null,F,m)};b(f)}},F)}return k&&this.f.set(E.seq,k),E.seq}acceptMessage(m){this.k?this.k(m):(this.m.push(m),this.m.length===1&&this.s())}q(m,d){return m.type!=="event"||d.type!=="event"}async s(){let m;for(;this.m.length;){if((!m||this.q(this.m[0],m))&&await(0,O.$jh)(0),m=this.m.shift(),!m)return;switch(m.type){case"event":this.j?.(m);break;case"request":this.g?.(m);break;case"response":{const d=m,k=this.f.get(d.request_seq);k&&(this.f.delete(d.request_seq),k(d));break}}}}u(m,d){d.type=m,d.seq=this.d++,this.sendMessage(d)}async w(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((d,k)=>m.set(k,d)),await(0,O.$jh)(500),m.forEach((d,k)=>{d({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$mob=N}),define(Ce[215],Pe([1,0,2,179,33,3]),function($e,e,I,O,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$PI=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$OI=e.MemoryRangeType=e.State=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=void 0,e.$NI=d,e.$CH="workbench.view.debug",e.$DH="workbench.debug.variablesView",e.$EH="workbench.debug.watchExpressionsView",e.$FH="workbench.debug.callStackView",e.$GH="workbench.debug.loadedScriptsView",e.$HH="workbench.debug.breakPointsView",e.$IH="workbench.debug.disassemblyView",e.$JH="workbench.panel.repl",e.$KH="workbench.panel.repl.view",e.$LH=new P.$zj("debugType",void 0,{type:"string",description:O.localize(0,null)}),e.$MH=new P.$zj("debugConfigurationType",void 0,{type:"string",description:O.localize(1,null)}),e.$NH=new P.$zj("debugState","inactive",{type:"string",description:O.localize(2,null)}),e.$OH="debugUx",e.$PH=new P.$zj(e.$OH,"default",{type:"string",description:O.localize(3,null)}),e.$QH=new P.$zj("hasDebugged",!1,{type:"boolean",description:O.localize(4,null)}),e.$RH=new P.$zj("inDebugMode",!1,{type:"boolean",description:O.localize(5,null)}),e.$SH=new P.$zj("inDebugRepl",!1,{type:"boolean",description:O.localize(6,null)}),e.$TH=new P.$zj("breakpointWidgetVisible",!1,{type:"boolean",description:O.localize(7,null)}),e.$UH=new P.$zj("inBreakpointWidget",!1,{type:"boolean",description:O.localize(8,null)}),e.$VH=new P.$zj("breakpointsFocused",!0,{type:"boolean",description:O.localize(9,null)}),e.$WH=new P.$zj("watchExpressionsFocused",!0,{type:"boolean",description:O.localize(10,null)}),e.$XH=new P.$zj("watchExpressionsExist",!1,{type:"boolean",description:O.localize(11,null)}),e.$YH=new P.$zj("variablesFocused",!0,{type:"boolean",description:O.localize(12,null)}),e.$ZH=new P.$zj("expressionSelected",!1,{type:"boolean",description:O.localize(13,null)}),e.$1H=new P.$zj("breakpointInputFocused",!1,{type:"boolean",description:O.localize(14,null)}),e.$2H=new P.$zj("callStackItemType",void 0,{type:"string",description:O.localize(15,null)}),e.$3H=new P.$zj("callStackSessionIsAttach",!1,{type:"boolean",description:O.localize(16,null)}),e.$4H=new P.$zj("callStackItemStopped",!1,{type:"boolean",description:O.localize(17,null)}),e.$5H=new P.$zj("callStackSessionHasOneThread",!1,{type:"boolean",description:O.localize(18,null)}),e.$6H=new P.$zj("watchItemType",void 0,{type:"string",description:O.localize(19,null)}),e.$7H=new P.$zj("canViewMemory",void 0,{type:"boolean",description:O.localize(20,null)}),e.$8H=new P.$zj("breakpointItemType",void 0,{type:"string",description:O.localize(21,null)}),e.$9H=new P.$zj("breakpointItemBytes",void 0,{type:"boolean",description:O.localize(22,null)}),e.$0H=new P.$zj("breakpointHasModes",!1,{type:"boolean",description:O.localize(23,null)}),e.$$H=new P.$zj("breakpointSupportsCondition",!1,{type:"boolean",description:O.localize(24,null)}),e.$_H=new P.$zj("loadedScriptsSupported",!1,{type:"boolean",description:O.localize(25,null)}),e.$aI=new P.$zj("loadedScriptsItemType",void 0,{type:"string",description:O.localize(26,null)}),e.$bI=new P.$zj("focusedSessionIsAttach",!1,{type:"boolean",description:O.localize(27,null)}),e.$cI=new P.$zj("focusedSessionIsNoDebug",!1,{type:"boolean",description:O.localize(28,null)}),e.$dI=new P.$zj("stepBackSupported",!1,{type:"boolean",description:O.localize(29,null)}),e.$eI=new P.$zj("restartFrameSupported",!1,{type:"boolean",description:O.localize(30,null)}),e.$fI=new P.$zj("stackFrameSupportsRestart",!1,{type:"boolean",description:O.localize(31,null)}),e.$gI=new P.$zj("jumpToCursorSupported",!1,{type:"boolean",description:O.localize(32,null)}),e.$hI=new P.$zj("stepIntoTargetsSupported",!1,{type:"boolean",description:O.localize(33,null)}),e.$iI=new P.$zj("breakpointsExist",!1,{type:"boolean",description:O.localize(34,null)}),e.$jI=new P.$zj("debuggersAvailable",!1,{type:"boolean",description:O.localize(35,null)}),e.$kI=new P.$zj("debugExtensionAvailable",!0,{type:"boolean",description:O.localize(36,null)}),e.$lI=new P.$zj("debugProtocolVariableMenuContext",void 0,{type:"string",description:O.localize(37,null)}),e.$mI=new P.$zj("debugSetVariableSupported",!1,{type:"boolean",description:O.localize(38,null)}),e.$nI=new P.$zj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:O.localize(39,null)}),e.$oI=new P.$zj("debugSetExpressionSupported",!1,{type:"boolean",description:O.localize(40,null)}),e.$pI=new P.$zj("breakWhenValueChangesSupported",!1,{type:"boolean",description:O.localize(41,null)}),e.$qI=new P.$zj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:O.localize(42,null)}),e.$rI=new P.$zj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:O.localize(43,null)}),e.$sI=new P.$zj("terminateDebuggeeSupported",!1,{type:"boolean",description:O.localize(44,null)}),e.$tI=new P.$zj("suspendDebuggeeSupported",!1,{type:"boolean",description:O.localize(45,null)}),e.$uI=new P.$zj("variableEvaluateNamePresent",!1,{type:"boolean",description:O.localize(46,null)}),e.$vI=new P.$zj("variableIsReadonly",!1,{type:"boolean",description:O.localize(47,null)}),e.$wI=new P.$zj("variableValue",!1,{type:"string",description:O.localize(48,null)}),e.$xI=new P.$zj("variableType",!1,{type:"string",description:O.localize(49,null)}),e.$yI=new P.$zj("variableName",!1,{type:"string",description:O.localize(50,null)}),e.$zI=new P.$zj("variableLanguage",!1,{type:"string",description:O.localize(51,null)}),e.$AI=new P.$zj("variableExtensionId",!1,{type:"string",description:O.localize(52,null)}),e.$BI=new P.$zj("exceptionWidgetVisible",!1,{type:"boolean",description:O.localize(53,null)}),e.$CI=new P.$zj("multiSessionRepl",!1,{type:"boolean",description:O.localize(54,null)}),e.$DI=new P.$zj("multiSessionDebug",!1,{type:"boolean",description:O.localize(55,null)}),e.$EI=new P.$zj("disassembleRequestSupported",!1,{type:"boolean",description:O.localize(56,null)}),e.$FI=new P.$zj("disassemblyViewFocus",!1,{type:"boolean",description:O.localize(57,null)}),e.$GI=new P.$zj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:O.localize(58,null)}),e.$HI=new P.$zj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:O.localize(59,null)});const A=n=>O.localize(60,null,n);e.$II=A,e.$JI="editor.contrib.debug",e.$KI="editor.contrib.breakpoint",e.$LI="debug",e.$MI={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:O.localize(61,null)};var m;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(m||(e.State=m={}));function d(n){switch(n){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var k;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$OI="vscode-debug-memory";var F;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(F||(e.DataBreakpointSetType=F={}));var E;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(E||(e.DebugConfigurationProviderTriggerKind=E={}));var u;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(u||(e.DebuggerString=u={})),e.$PI=(0,N.$ii)("debugService");var b;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(b||(e.BreakpointWidgetContext=b={}));var f;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(f||(e.DebugVisualizationType=f={}));var r;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(r||(e.DebugTreeItemCollapsibleState=r={}));var o;(function(n){n.deserialize=i=>i,n.serialize=i=>i})(o||(e.IDebugVisualizationTreeItem=o={}));var s;(function(n){n.deserialize=i=>({id:i.id,name:i.name,iconPath:i.iconPath&&{light:I.URI.revive(i.iconPath.light),dark:I.URI.revive(i.iconPath.dark)},iconClass:i.iconClass,visualization:i.visualization}),n.serialize=i=>i})(s||(e.IDebugVisualization=s={}))}),define(Ce[216],Pe([1,0,15,2,19,26,12,29,25,18]),function($e,e,I,O,P,N,A,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QG=void 0,e.$EG=E,e.$FG=u,e.$GG=b,e.$HG=f,e.$IG=r,e.$JG=o,e.$KG=s,e.$LG=i,e.$MG=t,e.$NG=v,e.$OG=$,e.$PG=p;const F=/{([^}]+)}/g;function E(D,g,S){return D.replace(F,function(y,C){return g&&C.length>0&&C[0]!=="_"?y:S&&S.hasOwnProperty(C)?S[C]:y})}function u(D){const g={};for(const S of Object.keys(D))S.startsWith("!")||(g[S]=D[S]);return g}function b(D){return D.configuration.request==="attach"&&!f(D)&&(!D.parentSession||b(D.parentSession))}function f(D){let g=D.configuration.type;if(g)return g==="vslsShare"&&(g=D.configuration.adapterProxy.configuration.type),(0,I.$lf)(g,"extensionhost")||(0,I.$lf)(g,"pwa-extensionhost")?D:D.parentSession?f(D.parentSession):void 0}function r(D){return D.type&&(D.label||D.program||D.runtime)}function o(D,g,S){let y,C=0;const R=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let V=null;for(;V=R.exec(D);){const U=V.index+1,q=U+V[0].length;if(U<=g&&q>=S){y=V[0],C=U;break}}if(y){const U=/\w+/g;let q=null;for(;(q=U.exec(y))&&!(q.index+1+C+q[0].length>=S););q&&(y=y.substring(0,U.lastIndex))}return y?{start:C,end:C+y.length-1}:{start:0,end:0}}async function s(D,g,S,y){if(D.evaluatableExpressionProvider.has(g)){const C=D.evaluatableExpressionProvider.ordered(g),R=(0,k.$Hb)(await Promise.all(C.map(async V=>{try{return await V.provideEvaluatableExpression(g,S,y??d.CancellationToken.None)}catch{return}})));if(R.length>0){let V=R[0].expression;const U=R[0].range;return V||(V=g.getLineContent(S.lineNumber).substring(U.startColumn-1,U.endColumn-1)),{range:U,matchingExpression:V}}}else{const C=g.getLineContent(S.lineNumber),{start:R,end:V}=o(C,S.column,S.column),U=C.substring(R-1,V);return{matchingExpression:U,range:new m.$ct(S.lineNumber,R,S.lineNumber,R+U.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(D){return!!(D&&D.match(n))}function a(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(i(D.path))return O.URI.parse(D.path);if((0,P.$jc)(D.path))return O.URI.file(D.path)}return D.path}function h(D){if(typeof D.path=="object"){const g=O.URI.revive(D.path);if(g)return g.scheme===A.Schemas.file?g.fsPath:g.toString()}return D.path}function t(D,g){const S=g?a:h,y=(0,N.$On)(D);return c(y,(C,R)=>{C&&R&&(R.path=S(R))}),y}function v(D,g){const S=g?a:h,y=(0,N.$On)(D);return c(y,(C,R)=>{!C&&R&&(R.path=S(R))}),y}function c(D,g){switch(D.type){case"event":{const S=D;switch(S.event){case"output":g(!1,S.body.source);break;case"loadedSource":g(!1,S.body.source);break;case"breakpoint":g(!1,S.body.breakpoint.source);break;default:break}break}case"request":{const S=D;switch(S.command){case"setBreakpoints":g(!0,S.arguments.source);break;case"breakpointLocations":g(!0,S.arguments.source);break;case"source":g(!0,S.arguments.source);break;case"gotoTargets":g(!0,S.arguments.source);break;case"launchVSCode":S.arguments.args.forEach(y=>g(!1,y));break;default:break}break}case"response":{const S=D;if(S.success&&S.body)switch(S.command){case"stackTrace":S.body.stackFrames.forEach(y=>g(!1,y.source));break;case"loadedSources":S.body.sources.forEach(y=>g(!1,y));break;case"scopes":S.body.scopes.forEach(y=>g(!1,y.source));break;case"setFunctionBreakpoints":S.body.breakpoints.forEach(y=>g(!1,y.source));break;case"setBreakpoints":S.body.breakpoints.forEach(y=>g(!1,y.source));break;case"disassemble":S.body?.instructions.forEach(C=>g(!1,C.location));break;default:break}break}}}function $(D){return D.filter(g=>!g.presentation?.hidden).sort((g,S)=>g.presentation?S.presentation?g.presentation.group?S.presentation.group?g.presentation.group!==S.presentation.group?g.presentation.group.localeCompare(S.presentation.group):w(g.presentation.order,S.presentation.order):-1:S.presentation.group?1:w(g.presentation.order,S.presentation.order):-1:S.presentation?1:0)}function w(D,g){return typeof D!="number"?typeof g!="number"?0:1:typeof g!="number"?-1:D-g}async function p(D,g){const S=D.getValue("debug.saveBeforeStart",{overrideIdentifier:g.activeTextEditorLanguageId});if(S!=="none"&&(await g.saveAll(),S==="allEditorsInActiveGroup")){const y=g.activeEditorPane;y&&y.input.resource?.scheme===A.Schemas.untitled&&await g.save({editor:y.input,groupId:y.group.id})}await D.reloadConfiguration()}const l=(D,g)=>!D||!g?D===g:D.name===g.name&&D.path===g.path&&D.sourceReference===g.sourceReference;e.$QG=l}),define(Ce[217],Pe([1,0,3]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3J=e.CellExecutionUpdateType=void 0;var O;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(O||(e.CellExecutionUpdateType=O={})),e.$3J=(0,I.$ii)("INotebookExecutionService")}),define(Ce[218],Pe([1,0,3]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yhb=e.$xhb=e.ProxyKernelState=e.$whb=void 0,e.$whb=100;var O;(function(P){P[P.Disconnected=1]="Disconnected",P[P.Connected=2]="Connected",P[P.Initializing=3]="Initializing"})(O||(e.ProxyKernelState=O={})),e.$xhb=(0,I.$ii)("INotebookKernelService"),e.$yhb=(0,I.$ii)("INotebookKernelHistoryService")}),define(Ce[219],Pe([1,0,6,29,148,95]),function($e,e,I,O,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tUb=void 0;class A extends I.$Uc{constructor(d,k,F){super(),this._source=d,this.b=k,this.c=F,this.a=void 0}f(d){const k=d.getLineCount();return new O.$ct(1,1,k,this.g(d,k))}g(d,k){if(k<1||k>d.getLineCount())throw new Error("Illegal value for lineNumber");return d.getLineLength(k)+1}get inputTextBuffer(){if(!this.b){const d=new P.$AC;d.acceptChunk(this._source);const k=d.finish(!0),{textBuffer:F,disposable:E}=k.create(1);this.b=F,this.B(E)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(d=>{const k=new P.$AC;k.acceptChunk(d);const F=k.finish(!0),{textBuffer:E,disposable:u}=F.create(1);return this.B(u),E})),this.a}findInInputs(d){const F=new N.$oC(d,!1,!1,null).parseSearchRequest();if(!F)return[];const E=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(E,F,!0,5e3)}findInOutputs(d){const F=new N.$oC(d,!1,!1,null).parseSearchRequest();return F?this.outputTextBuffers.map(E=>{const u=E.findMatchesLineByLine(this.f(E),F,!0,5e3);if(u.length!==0)return{textBuffer:E,matches:u}}).filter(E=>!!E):[]}}e.$tUb=A}),define(Ce[49],Pe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9K=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(N){N.Delimiter="\0"})(I||(e.TestIdPathParts=I={}));var O;(function(N){N[N.IsSame=0]="IsSame",N[N.Disconnected=1]="Disconnected",N[N.IsChild=2]="IsChild",N[N.IsParent=3]="IsParent"})(O||(e.TestPosition=O={}));class P{static fromExtHostTestItem(A,m,d=A.parent){if(A._isRoot)return new P([m]);const k=[A.id];for(let F=d;F&&F.id!==m;F=F.parent)k.push(F.id);return k.push(m),new P(k.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const m=A.indexOf("\0");return m===-1?A:A.slice(0,m)}static fromString(A){return new P(A.split("\0"))}static join(A,m){return new P([...A.path,m])}static joinToString(A,m){return A.toString()+"\0"+m}static parentId(A){const m=A.lastIndexOf("\0");return m===-1?void 0:A.slice(0,m)}static localId(A){const m=A.lastIndexOf("\0");return m===-1?A:A.slice(m+1)}static isChild(A,m){return m.startsWith(A)&&m[A.length]==="\0"}static compare(A,m){return A===m?0:P.isChild(A,m)?2:P.isChild(m,A)?3:1}constructor(A,m=A.length){if(this.path=A,this.d=m,A.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new P(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new P(this.path,A)}compare(A){if(typeof A=="string")return P.compare(this.toString(),A);for(let m=0;m<A.d&&m<this.d;m++)if(A.path[m]!==this.path[m])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$9K=P}),define(Ce[60],Pe([1,0,2,93,29,49]),function($e,e,I,O,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$eL=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$dL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$cL=e.$bL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$aL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$_K=e.$$K=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$0K=e.TestResultState=void 0;var A;(function(M){M[M.Unset=0]="Unset",M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.$0K={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var m;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})(m||(e.ExtTestRunProfileKind=m={}));var d;(function(M){M[M.Run=2]="Run",M[M.Debug=4]="Debug",M[M.Coverage=8]="Coverage",M[M.HasNonDefaultProfile=16]="HasNonDefaultProfile",M[M.HasConfigurable=32]="HasConfigurable",M[M.SupportsContinuousRun=64]="SupportsContinuousRun"})(d||(e.TestRunProfileBitset=d={})),e.$$K=[2,4,8,16,32,64];const k=M=>"runId"in M;e.$_K=k;var F;(function(M){M.serialize=L=>({range:L.range.toJSON(),uri:L.uri.toJSON()}),M.deserialize=(L,G)=>({range:P.$ct.lift(G.range),uri:L.asCanonicalUri(I.URI.revive(G.uri))})})(F||(e.IRichLocation=F={}));var E;(function(M){M[M.Error=0]="Error",M[M.Output=1]="Output"})(E||(e.TestMessageType=E={}));var u;(function(M){M.serialize=L=>({message:L.message,type:0,expected:L.expected,actual:L.actual,contextValue:L.contextValue,location:L.location&&F.serialize(L.location)}),M.deserialize=(L,G)=>({message:G.message,type:0,expected:G.expected,actual:G.actual,contextValue:G.contextValue,location:G.location&&F.deserialize(L,G.location)})})(u||(e.ITestErrorMessage=u={}));const b=(M,L)=>`${L?"s":"e"}${M}`;e.$aL=b;var f;(function(M){M.serialize=L=>({message:L.message,type:1,offset:L.offset,length:L.length,location:L.location&&F.serialize(L.location)}),M.deserialize=(L,G)=>({message:G.message,type:1,offset:G.offset,length:G.length,location:G.location&&F.deserialize(L,G.location)})})(f||(e.ITestOutputMessage=f={}));var r;(function(M){M.serialize=L=>L.type===0?u.serialize(L):f.serialize(L),M.deserialize=(L,G)=>G.type===0?u.deserialize(L,G):f.deserialize(L,G)})(r||(e.ITestMessage=r={}));var o;(function(M){M.serializeWithoutMessages=L=>({state:L.state,duration:L.duration,messages:[]}),M.serialize=L=>({state:L.state,duration:L.duration,messages:L.messages.map(r.serialize)}),M.deserialize=(L,G)=>({state:G.state,duration:G.duration,messages:G.messages.map(ne=>r.deserialize(L,ne))})})(o||(e.ITestTaskState=o={}));const s="\0",n=(M,L)=>M+s+L;e.$bL=n;const i=M=>{const L=M.indexOf(s);return{ctrlId:M.slice(0,L),tagId:M.slice(L+1)}};e.$cL=i;var a;(function(M){M.serialize=L=>({extId:L.extId,label:L.label,tags:L.tags,busy:L.busy,children:void 0,uri:L.uri?.toJSON(),range:L.range?.toJSON()||null,description:L.description,error:L.error,sortText:L.sortText}),M.deserialize=(L,G)=>({extId:G.extId,label:G.label,tags:G.tags,busy:G.busy,children:void 0,uri:G.uri?L.asCanonicalUri(I.URI.revive(G.uri)):void 0,range:G.range?P.$ct.lift(G.range):null,description:G.description,error:G.error,sortText:G.sortText})})(a||(e.ITestItem=a={}));var h;(function(M){M[M.NotExpandable=0]="NotExpandable",M[M.Expandable=1]="Expandable",M[M.BusyExpanding=2]="BusyExpanding",M[M.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var t;(function(M){M.serialize=L=>({expand:L.expand,item:a.serialize(L.item)}),M.deserialize=(L,G)=>({controllerId:N.$9K.root(G.item.extId),expand:G.expand,item:a.deserialize(L,G.item)})})(t||(e.InternalTestItem=t={}));var v;(function(M){M.serialize=L=>{let G;return L.item&&(G={},L.item.label!==void 0&&(G.label=L.item.label),L.item.tags!==void 0&&(G.tags=L.item.tags),L.item.busy!==void 0&&(G.busy=L.item.busy),L.item.uri!==void 0&&(G.uri=L.item.uri?.toJSON()),L.item.range!==void 0&&(G.range=L.item.range?.toJSON()),L.item.description!==void 0&&(G.description=L.item.description),L.item.error!==void 0&&(G.error=L.item.error),L.item.sortText!==void 0&&(G.sortText=L.item.sortText)),{extId:L.extId,expand:L.expand,item:G}},M.deserialize=L=>{let G;return L.item&&(G={},L.item.label!==void 0&&(G.label=L.item.label),L.item.tags!==void 0&&(G.tags=L.item.tags),L.item.busy!==void 0&&(G.busy=L.item.busy),L.item.range!==void 0&&(G.range=L.item.range?P.$ct.lift(L.item.range):null),L.item.description!==void 0&&(G.description=L.item.description),L.item.error!==void 0&&(G.error=L.item.error),L.item.sortText!==void 0&&(G.sortText=L.item.sortText)),{extId:L.extId,expand:L.expand,item:G}}})(v||(e.ITestItemUpdate=v={}));const c=(M,L)=>{L.expand!==void 0&&(M.expand=L.expand),L.item!==void 0&&(M.item=M.item?Object.assign(M.item,L.item):L.item)};e.$dL=c;var $;(function(M){M.serializeWithoutMessages=L=>({...t.serialize(L),ownComputedState:L.ownComputedState,computedState:L.computedState,tasks:L.tasks.map(o.serializeWithoutMessages)}),M.serialize=L=>({...t.serialize(L),ownComputedState:L.ownComputedState,computedState:L.computedState,tasks:L.tasks.map(o.serialize)}),M.deserialize=(L,G)=>({...t.deserialize(L,G),ownComputedState:G.ownComputedState,computedState:G.computedState,tasks:G.tasks.map(ne=>o.deserialize(L,ne)),retired:!0})})($||(e.TestResultItem=$={}));var w;(function(M){M.empty=()=>({covered:0,total:0}),M.sum=(L,G)=>{L.covered+=G.covered,L.total+=G.total}})(w||(e.ICoveredCount=w={}));var p;(function(M){M.serialize=L=>({id:L.id,statement:L.statement,branch:L.branch,declaration:L.declaration,uri:L.uri.toJSON()}),M.deserialize=(L,G)=>({id:G.id,statement:G.statement,branch:G.branch,declaration:G.declaration,uri:L.asCanonicalUri(I.URI.revive(G.uri))})})(p||(e.IFileCoverage=p={}));function l(M){return{...M,location:M.location?.toJSON()}}function D(M){return M.location=M.location?O.$bt.isIPosition(M.location)?O.$bt.lift(M.location):P.$ct.lift(M.location):void 0,M}e.$eL=3;var g;(function(M){M[M.Declaration=0]="Declaration",M[M.Statement=1]="Statement",M[M.Branch=2]="Branch"})(g||(e.DetailType=g={}));var S;(function(M){M.serialize=L=>L.type===0?C.serialize(L):R.serialize(L),M.deserialize=L=>L.type===0?C.deserialize(L):R.deserialize(L)})(S||(e.CoverageDetails=S={}));var y;(function(M){M.serialize=l,M.deserialize=D})(y||(e.IBranchCoverage=y={}));var C;(function(M){M.serialize=l,M.deserialize=D})(C||(e.IDeclarationCoverage=C={}));var R;(function(M){M.serialize=L=>({...l(L),branches:L.branches?.map(y.serialize)}),M.deserialize=L=>({...D(L),branches:L.branches?.map(y.deserialize)})})(R||(e.IStatementCoverage=R={}));var V;(function(M){M[M.Add=0]="Add",M[M.Update=1]="Update",M[M.DocumentSynced=2]="DocumentSynced",M[M.Remove=3]="Remove",M[M.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",M[M.Retire=5]="Retire",M[M.AddTag=6]="AddTag",M[M.RemoveTag=7]="RemoveTag"})(V||(e.TestDiffOpType=V={}));var U;(function(M){M.deserialize=(L,G)=>G.op===0?{op:G.op,item:t.deserialize(L,G.item)}:G.op===1?{op:G.op,item:v.deserialize(G.item)}:G.op===2?{op:G.op,uri:L.asCanonicalUri(I.URI.revive(G.uri)),docv:G.docv}:G,M.serialize=L=>L.op===0?{op:L.op,item:t.serialize(L.item)}:L.op===1?{op:L.op,item:v.serialize(L.item)}:L})(U||(e.TestsDiffOp=U={}));class q{constructor(L){this.l=L,this.f=new Map,this.g=new Map,this.h=new Set,this.j=0,this.k=0,this.tags=this.f}apply(L){const G=this.w();for(const ne of L)switch(ne.op){case 0:this.o(t.deserialize(this.l,ne.item),G);break;case 1:this.p(v.deserialize(ne.item),G);break;case 3:this.q(ne.itemId,G);break;case 5:this.v(ne.itemId);break;case 4:this.updatePendingRoots(ne.amount);break;case 6:this.f.set(ne.tag.id,ne.tag);break;case 7:this.f.delete(ne.id);break}G.complete?.()}o(L,G){const ne=N.$9K.parentId(L.item.extId)?.toString();let he;if(!ne)he=this.x(L),this.h.add(he),this.g.set(L.item.extId,he);else if(this.g.has(ne)){const ye=this.g.get(ne);ye.children.add(L.item.extId),he=this.x(L,ye),this.g.set(L.item.extId,he)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(L)}`);return}return G.add?.(he),L.expand===2&&this.j++,he}p(L,G){const ne=this.g.get(L.extId);if(ne)return L.expand!==void 0&&(ne.expand===2&&this.j--,L.expand===2&&this.j++),(0,e.$dL)(ne,L),G.update?.(ne),ne}q(L,G){const ne=this.g.get(L);if(!ne)return;const he=N.$9K.parentId(ne.item.extId)?.toString();he?this.g.get(he).children.delete(ne.item.extId):this.h.delete(ne);const ye=[[L]];for(;ye.length;)for(const Re of ye.pop()){const ge=this.g.get(Re);ge&&(ye.push(ge.children),this.g.delete(Re),G.remove?.(ge,ge!==ne),ge.expand===2&&this.j--)}}v(L){}updatePendingRoots(L){this.k+=L}w(){return{}}}e.$fL=q}),define(Ce[75],Pe([1,0,11,5,6,55,60,49]),function($e,e,I,O,P,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zO=e.$yO=e.$xO=e.$wO=e.$vO=e.TestItemEventOp=void 0;var d;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(d||(e.TestItemEventOp=d={}));const k=(n,i)=>n===i,E=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:k,label:k,description:k,error:k,sortText:k,tags:(n,i)=>!(n.length!==i.length||n.some(a=>!i.includes(a)))}),u=(n,i)=>{let a;for(const[h,t]of E)t(n[h],i[h])||(a?a[h]=i[h]:a={[h]:i[h]});return a};class b extends P.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new I.$uh(()=>this.flushDiff(),200)),this.g=this.B(new O.$7d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const a of this.tree.values())this.J(a)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const a of this.m)if(a.op===2&&a.uri===i.uri){a.docv=i.docv;return}break}case 1:{const a=this.m[this.m.length-1];if(a){if(a.op===1&&a.item.extId===i.item.extId){(0,A.$dL)(a.item,i.item);return}if(a.op===0&&a.item.item.extId===i.item.extId){(0,A.$dL)(a.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,a){const h=this.tree.get(i);if(h){if((h.expandLevels===void 0||a>h.expandLevels)&&(h.expandLevels=a),h.expand===1){const t=this.M(h);return t.isOpen()?this.L(h,a-1):t.wait().then(()=>this.L(h,a-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.L(h,a-1)):this.L(h,a-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,a){switch(a.op){case 3:this.O(m.$9K.joinToString(i.fullId,a.id));break;case 0:this.z(a.item,i);break;case 5:for(const h of a.ops)this.w(i,h);break;case 1:this.C(a.new,a.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:a.update}});break;case 6:this.y(i.actual.uri);break;default:(0,N.$0c)(a)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,a){const h=m.$9K.fromExtHostTestItem(i,this.root.id,a?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==a?.actual&&this.s.getChildren(t.parent).delete(i.id);let v=this.tree.get(h.toString());if(!v){v={fullId:h,actual:i,expandLevels:a?.expandLevels?a.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(v.fullId.toString(),v),this.G(i,a),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:v.expand,item:this.s.toITestItem(i)}}),this.I(i,v,a);return}if(v.actual===i){this.H(i,v,a);return}if(v.actual.uri?.toString()!==i.uri?.toString())return this.O(h.toString()),this.z(i,a);const c=this.s.getChildren(v.actual),$=v.actual,w=u(this.s.toITestItem($),this.s.toITestItem(i));this.s.getApiFor($).listener=void 0,v.actual=i,v.expand=0,w&&(w.hasOwnProperty("tags")&&(this.C(i.tags,$.tags,h.toString()),delete w.tags),this.w(v,{op:4,update:w})),this.I(i,v,a);for(const[p,l]of c)this.s.getChildren(i).get(l.id)||this.O(m.$9K.joinToString(h,l.id));this.y(v.actual.uri)}C(i,a,h){const t=new Set(a.map(v=>v.id));for(const v of i)t.delete(v.id)||this.D(v);this.pushDiff({op:1,item:{extId:h,item:{tags:i.map(v=>(0,A.$bL)(this.s.controllerId,v.id))}}}),t.forEach(this.F,this)}D(i){const a=this.j.get(i.id);a?a.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$bL)(this.s.controllerId,i.id)}}))}F(i){const a=this.j.get(i);a&&!--a.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,A.$bL)(this.s.controllerId,i)}))}G(i,a){this.s.getApiFor(i).parent=a&&a.actual!==this.root?a.actual:void 0}H(i,a,h){this.G(i,h);const t=this.s.getApiFor(i);t.parent=h?.actual,t.listener=v=>this.w(a,v),this.J(a)}I(i,a,h){this.H(i,a,h);for(const[t,v]of this.s.getChildren(i))this.z(v,a)}J(i){let a;this.h?i.resolveBarrier?a=i.resolveBarrier.isOpen()?3:2:a=i.actual.canResolveChildren?1:0:a=0,a!==i.expand&&(i.expand=a,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:a}}),a===1&&i.expandLevels!==void 0&&this.M(i))}L(i,a){if(a<0)return;const h=[];for(const[t,v]of this.s.getChildren(i.actual)){const c=this.expand(m.$9K.joinToString(i.fullId,v.id),a);(0,I.$7g)(c)&&h.push(c)}if(h.length)return Promise.all(h).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const v=new I.$hh;return v.open(),v}i.expand=2,this.N(i);const a=i.resolveBarrier=new I.$hh,h=v=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,v)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(v){h(v)}return(0,I.$7g)(t)?t.catch(h).then(()=>{a.open(),this.J(i)}):(a.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const a=this.tree.get(i);if(!a)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const h=[a];for(;h.length;){const t=h.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const v of t.actual.tags)this.F(v.id);this.tree.delete(t.fullId.toString());for(const[v,c]of this.s.getChildren(t.actual))h.push(this.tree.get(m.$9K.joinToString(t.fullId,c.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$vO=b;class f extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$wO=f;class r extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$xO=r;class o extends Error{constructor(i,a,h){super(`TestItem with ID "${i}" is from controller "${a}" and cannot be added as a child of an item from controller "${h}".`)}}e.$yO=o;const s=(n,i,a)=>{let h=new Map;return{get size(){return h.size},forEach(t,v){for(const c of h.values())t.call(v,c,this)},[Symbol.iterator](){return h.entries()},replace(t){const v=new Map,c=new Set(h.keys()),$={op:5,ops:[]};for(const w of t){if(!(w instanceof a))throw new r(w.id);const p=i(w).controllerId;if(p!==n.controllerId)throw new o(w.id,p,n.controllerId);if(v.has(w.id))throw new f(w.id);v.set(w.id,w),c.delete(w.id),$.ops.push({op:0,item:w})}for(const w of c.keys())$.ops.push({op:3,id:w});n.listener?.($),h=v},add(t){if(!(t instanceof a))throw new r(t.id);h.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){h.delete(t)&&n.listener?.({op:3,id:t})},get(t){return h.get(t)},toJSON(){return Array.from(h.values())}}};e.$zO=s}),define(Ce[105],Pe([1,0,75]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BO=e.$AO=void 0;const O=new WeakMap,P=(A,m)=>{const d={controllerId:m};return O.set(A,d),d};e.$AO=P;const N=A=>{const m=O.get(A);if(!m)throw new I.$xO(A?.id||"<unknown>");return m};e.$BO=N}),define(Ce[76],Pe([1,0,12,2]),function($e,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7yb=e.$6yb=e.$5yb=void 0,e.$8yb=P,e.$9yb=A,e.$5yb="vscode-cdn.net",e.$6yb=`vscode-resource.${e.$5yb}`,e.$7yb=`'self' https://*.${e.$5yb}`;function P(m,d){return m.scheme===I.Schemas.http||m.scheme===I.Schemas.https?m:(d&&d.authority&&d.isRemote&&m.scheme===I.Schemas.file&&(m=O.URI.from({scheme:I.Schemas.vscodeRemote,authority:d.authority,path:m.path})),O.URI.from({scheme:I.Schemas.https,authority:`${m.scheme}+${N(m.authority)}.${e.$6yb}`,path:m.path,fragment:m.fragment,query:m.query}))}function N(m){return m.replace(/./g,d=>{const k=d.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?d:"-"+k.toString(16).padStart(4,"0")})}function A(m){return m.replace(/-([0-9a-f]{4})/g,(d,k)=>String.fromCharCode(parseInt(k,16)))}}),define(Ce[220],Pe([1,0,5,6,76]),function($e,e,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hjc=void 0;class N{constructor(m,d,k){this.d=m,this.e=d,this.f=k,this.a=0,this.b=new O.$Tc,this.c=new Map,this.b.add(d.onDidChangeVisibleTextEditors(()=>{const F=d.getVisibleTextEditors();for(const E of this.c.values())F.indexOf(E.editor)<0&&E.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,d,k,F,E){let u;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===m){u=i;break}if(!u)throw new Error("not a visible editor");const b=this,f=this.a++,r=new I.$7d,o=new I.$7d,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,P.$8yb)(i,b.f)}get cspSource(){return P.$7yb}set options(i){this.b=i,b.d.$setOptions(f,i)}get options(){return this.b}set html(i){this.a=i,b.d.$setHtml(f,i)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(i){return b.d.$postMessage(f,i)}},n=new class{constructor(){this.editor=m,this.line=d,this.height=k,this.webview=s,this.onDidDispose=o.event}dispose(){b.c.has(f)&&(b.c.delete(f),b.d.$disposeEditorInset(f),o.fire(),o.dispose(),r.dispose())}};return this.d.$createEditorInset(f,u.id,u.value.document.uri,d+1,k,F||{},E.identifier,E.extensionLocation),this.c.set(f,{editor:m,inset:n,onDidReceiveMessage:r}),n}$onDidDispose(m){const d=this.c.get(m);d&&d.inset.dispose()}$onDidReceiveMessage(m,d){this.c.get(m)?.onDidReceiveMessage.fire(d)}}e.$hjc=N}),define(Ce[106],Pe([1,0,3]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oL=e.$nL=e.$mL=void 0,e.$mL="__",e.$nL=(0,I.$ii)("IAuthenticationService"),e.$oL=(0,I.$ii)("IAuthenticationExtensionsService")}),define(Ce[221],Pe([1,0,3]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sP=e.VariableKind=e.$rP=void 0,e.$rP=(0,I.$ii)("configurationResolverService");var O;(function(N){N.Unknown="unknown",N.Env="env",N.Config="config",N.Command="command",N.Input="input",N.ExtensionInstallFolder="extensionInstallFolder",N.WorkspaceFolder="workspaceFolder",N.Cwd="cwd",N.WorkspaceFolderBasename="workspaceFolderBasename",N.UserHome="userHome",N.LineNumber="lineNumber",N.SelectedText="selectedText",N.File="file",N.FileWorkspaceFolder="fileWorkspaceFolder",N.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",N.RelativeFile="relativeFile",N.RelativeFileDirname="relativeFileDirname",N.FileDirname="fileDirname",N.FileExtname="fileExtname",N.FileBasename="fileBasename",N.FileBasenameNoExtension="fileBasenameNoExtension",N.FileDirnameBasename="fileDirnameBasename",N.ExecPath="execPath",N.ExecInstallFolder="execInstallFolder",N.PathSeparator="pathSeparator",N.PathSeparatorAlias="/"})(O||(e.VariableKind=O={}));class P extends Error{constructor(A,m){super(m),this.variable=A}}e.$sP=P}),define(Ce[222],Pe([1,0,19,73,16,26,21,96,182,221,15]),function($e,e,I,O,P,N,A,m,d,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HP=void 0;class E{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(b,f,r,o){this.h=new Map,this.a=b,this.b=f,this.g=r,o&&(this.c=o.then(s=>this.i(s)))}i(b){if(A.$i){const f=Object.create(null);return Object.keys(b).forEach(r=>{f[r.toLowerCase()]=b[r]}),f}return b}resolveWithEnvironment(b,f,r){return this.l({env:this.i(b),userHome:void 0},f?f.uri:void 0,r)}async resolveAsync(b,f){const r={env:await this.c,userHome:await this.g};return this.l(r,b?b.uri:void 0,f)}async j(b,f,r,o){const s=N.$On(f);A.$i&&s.windows?Object.keys(s.windows).forEach(i=>s[i]=s.windows[i]):A.$j&&s.osx?Object.keys(s.osx).forEach(i=>s[i]=s.osx[i]):A.$k&&s.linux&&Object.keys(s.linux).forEach(i=>s[i]=s.linux[i]),delete s.windows,delete s.osx,delete s.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,b?b.uri:void 0,s,r,o)}async resolveAnyAsync(b,f,r){return this.j(b,f,r)}async resolveAnyMap(b,f,r){const o=new Map;return{newConfig:await this.j(b,f,r,o),resolvedVariables:o}}resolveWithInteractionReplace(b,f,r,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,f,r,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,f){if(this.h.has(b))throw new Error("Variable "+b+" is contributed twice.");this.h.set(b,f)}async l(b,f,r,o,s){if(P.$Vf(r))return this.m(b,f,r,o,s);if(Array.isArray(r))return Promise.all(r.map(n=>this.l(b,f,n,o,s)));if(P.$Xf(r)){const n=Object.create(null),i=await Promise.all(Object.keys(r).map(async a=>[await this.m(b,f,a,o,s),await this.l(b,f,r[a],o,s)]));for(const[a,h]of i)n[a]=h;return n}return r}m(b,f,r,o,s){return(0,F.$df)(r,E.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(E.VARIABLE_LHS))return n;let a=await this.o(b,n,i,f,o);return s?.set(i,a),a!==n&&P.$Vf(a)&&a.match(E.VARIABLE_REGEXP)&&(a=await this.m(b,f,a,o,s)),a})}n(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async o(b,f,r,o,s){let n;const i=r.split(":");i.length>1&&(r=i[0],n=i[1]);const a=v=>{const c=this.a.getFilePath();if(c)return(0,m.$hw)(c);throw new k.$sP(v,(0,d.localize)(0,null,f))},h=v=>{const c=a(v);if(this.a.getWorkspaceFolderPathForFile){const $=this.a.getWorkspaceFolderPathForFile();if($)return(0,m.$hw)($)}throw new k.$sP(v,(0,d.localize)(1,null,f,I.$oc(c)))},t=v=>{if(n){const c=this.a.getFolderUri(n);if(c)return c;throw new k.$sP(v,(0,d.localize)(2,null,f,n))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new k.$sP(v,(0,d.localize)(3,null,f)):new k.$sP(v,(0,d.localize)(4,null,f))};switch(r){case"env":if(n){if(b.env){const v=b.env[A.$i?n.toLowerCase():n];if(P.$Vf(v))return v}return""}throw new k.$sP(k.VariableKind.Env,(0,d.localize)(5,null,f));case"config":if(n){const v=this.a.getConfigurationValue(o,n);if(P.$5f(v))throw new k.$sP(k.VariableKind.Config,(0,d.localize)(6,null,f,n));if(P.$Xf(v))throw new k.$sP(k.VariableKind.Config,(0,d.localize)(7,null,f,n));return v}throw new k.$sP(k.VariableKind.Config,(0,d.localize)(8,null,f));case"command":return this.p(k.VariableKind.Command,f,n,s,"command");case"input":return this.p(k.VariableKind.Input,f,n,s,"input");case"extensionInstallFolder":if(n){const v=await this.a.getExtension(n);if(!v)throw new k.$sP(k.VariableKind.ExtensionInstallFolder,(0,d.localize)(9,null,f,n));return this.n(v.extensionLocation)}throw new k.$sP(k.VariableKind.ExtensionInstallFolder,(0,d.localize)(10,null,f));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,m.$hw)(this.n(t(k.VariableKind.WorkspaceFolder)));case"cwd":return o||n?(0,m.$hw)(this.n(t(k.VariableKind.Cwd))):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$hw)(I.$oc(this.n(t(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new k.$sP(k.VariableKind.UserHome,(0,d.localize)(11,null,f))}case"lineNumber":{const v=this.a.getLineNumber();if(v)return v;throw new k.$sP(k.VariableKind.LineNumber,(0,d.localize)(12,null,f))}case"selectedText":{const v=this.a.getSelectedText();if(v)return v;throw new k.$sP(k.VariableKind.SelectedText,(0,d.localize)(13,null,f))}case"file":return a(k.VariableKind.File);case"fileWorkspaceFolder":return h(k.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return I.$oc(h(k.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||n?I.$mc(this.n(t(k.VariableKind.RelativeFile)),a(k.VariableKind.RelativeFile)):a(k.VariableKind.RelativeFile);case"relativeFileDirname":{const v=I.$nc(a(k.VariableKind.RelativeFileDirname));if(o||n){const c=I.$mc(this.n(t(k.VariableKind.RelativeFileDirname)),v);return c.length===0?".":c}return v}case"fileDirname":return I.$nc(a(k.VariableKind.FileDirname));case"fileExtname":return I.$pc(a(k.VariableKind.FileExtname));case"fileBasename":return I.$oc(a(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const v=I.$oc(a(k.VariableKind.FileBasenameNoExtension));return v.slice(0,v.length-I.$pc(v).length)}case"fileDirnameBasename":return I.$oc(I.$nc(a(k.VariableKind.FileDirnameBasename)));case"execPath":{const v=this.a.getExecPath();return v||f}case"execInstallFolder":{const v=this.a.getAppRoot();return v||f}case"pathSeparator":case"/":return I.sep;default:try{const v=n?`${r}:${n}`:r;return this.p(k.VariableKind.Unknown,f,v,s,void 0)}catch{return f}}}}p(b,f,r,o,s){if(r&&o){const n=s===void 0?o[r]:o[s+":"+r];if(typeof n=="string")return n;throw new k.$sP(b,(0,d.localize)(14,null,f))}return f}}e.$HP=E}),define(Ce[107],Pe([1,0,3,104]),function($e,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$wD=void 0,e.$xD=k,e.$yD=u,e.$zD=b,e.$wD=(0,I.$ii)("editorGroupsService");var P;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var N;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(N||(e.GroupOrientation=N={}));var A;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var m;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EXPAND=1]="EXPAND",f[f.EVEN=2]="EVEN"})(m||(e.GroupsArrangement=m={}));var d;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(d||(e.MergeGroupMode=d={}));function k(f){const r=f;return(0,O.$gF)(r?.editor)&&(0,O.$gF)(r?.replacement)}var F;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(F||(e.GroupsOrder=F={}));var E;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(E||(e.OpenEditorContext=E={}));function u(f){const r=f;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function b(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Ce[223],Pe([1,0,3,107]),function($e,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DD=e.$CD=e.$BD=e.$AD=void 0,e.$ED=P,e.$AD=(0,I.$ii)("editorService"),e.$BD=-1,e.$CD=-2,e.$DD=-3;function P(N){const A=N;return typeof N=="number"||(0,O.$yD)(A)}}),define(Ce[224],Pe([1,0,3,189]),function($e,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HL=void 0,e.$HL=(0,I.$ji)(O.$pi)}),define(Ce[108],Pe([1,0,20,5,19,6,11]),function($e,e,I,O,P,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W0b=e.$V0b=e.$U0b=e.$T0b=e.$S0b=void 0;class m{constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.$S0b=m;class d{static isHostExtension(n,i,a){if(i.getExtensionDescription(n))return!1;const h=a.getExtensionDescription(n);return h?!!((h.main||h.browser)&&h.api==="none"):!1}constructor(n,i){this.j=n,this.c=new O.$7d,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(r),this.f=new I.$Fm,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const i=this.j.readActivationEvents(n);for(const a of i)this.h.has(a)||this.h.set(a,[]),this.h.get(a).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,i){this.e=o(this.e,i),this.e=this.e.concat(n);const a=d.l(this.e);return this.e=o(this.e,a.map(h=>h.identifier)),this.k(),this.d++,this.c.fire(void 0),new m(this.d,a)}static l(n){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(c){this.d.has(c)||(this.d.add(c),this.e.push(c))}addArc(c,$){this.addNode(c),this.addNode($),this.c.has(c)?this.c.get(c).push($):this.c.set(c,[$])}getArcs(c){return this.c.has(c)?this.c.get(c):[]}hasOnlyGoodArcs(c,$){const w=i.getArcs(c);for(let p=0;p<w.length;p++)if(!$.has(w[p]))return!1;return!0}getNodes(){return this.e}},a=new I.$Fm;for(const c of n)if(a.set(c.identifier,c),c.extensionDependencies)for(const $ of c.extensionDependencies)i.addArc(I.$Dm.toKey(c.identifier),I.$Dm.toKey($));const h=new Set;i.getNodes().filter(c=>i.getArcs(c).length===0).forEach(c=>h.add(c));const t=i.getNodes().filter(c=>!h.has(c));let v;do{v=!1;for(let c=0;c<t.length;c++){const $=t[c];i.hasOnlyGoodArcs($,h)&&(t.splice(c,1),c--,h.add($),v=!0)}}while(v);return t.map(c=>a.get(c))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this.h.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new k(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this.f.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this.g)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$T0b=d;class k{constructor(n,i){this.versionId=n,this.extensions=i}}e.$U0b=k;class F{constructor(n){this.d=new b,this.c=new d(n,[])}async acquireLock(n){const i=await this.d.acquire(n);return new E(this,i)}deltaExtensions(n,i,a){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,a)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this.c.getExtensionDescriptionByIdOrUUID(n,i)}}e.$V0b=F;class E extends N.$Uc{constructor(n,i){super(),this.f=n,this.c=!1,this.B(i)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$W0b=E;class u{constructor(n){this.name=n;const i=(0,A.$bh)();this.promise=i.promise,this.c=i.resolve}resolve(n){this.c(n)}}class b{constructor(){this.c=[],this.d=!1}async acquire(n){const i=new u(n);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let i=!0;const a=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),h=()=>{i&&(clearTimeout(a),i=!1,this.d=!1,this.e())};n.resolve((0,N.$Sc)(h))}}var f;(function(s){s[s.Builtin=0]="Builtin",s[s.User=1]="User",s[s.Dev=2]="Dev"})(f||(f={}));function r(s,n){const i=s.isBuiltin?0:s.isUnderDevelopment?2:1,a=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==a)return i-a;const h=P.$hc.basename(s.extensionLocation.path),t=P.$hc.basename(n.extensionLocation.path);return h<t?-1:h>t?1:0}function o(s,n){const i=new I.$Em(n);return s.filter(a=>!i.has(a.identifier))}}),define(Ce[77],Pe([1,0,23]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Lm=A,e.$Mm=m;var O;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(O||(e.UIKind=O={}));var P;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var N;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(N||(e.MessageType=N={}));function A(k){const F=I.$ue.alloc(1);switch(k){case 0:F.writeUInt8(1,0);break;case 1:F.writeUInt8(2,0);break;case 2:F.writeUInt8(3,0);break}return F}function m(k,F){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return F===0;case 2:return F===1;case 3:return F===2;default:return!1}}var d;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(d||(e.NativeLogMarkers=d={}))}),define(Ce[61],Pe([1,0,3,5,13,27,77,57,58,26,2,6,170]),function($e,e,I,O,P,N,A,m,d,k,F,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZO=e.$XO=e.$WO=void 0,e.$YO=r;let b=class extends E.$Uc{constructor(s,n){super(),this.s=s,this.t=n,this.a=this.B(new O.$7d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new O.$7d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=F.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:d.$9o,name:(0,u.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(i=>{(0,P.$Qj)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===P.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,n,i){const a=this.getTelemetryDetails(),h=new f(n,i,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(s,n,i){this.f=s,this.g=n,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const n=Object.create(null);switch(n["common.extname"]=`${s.publisher}.${s.name}`,n["common.extversion"]=s.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=r(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:n["common.uikind"]="web";break;case A.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,m.$um)((0,d.$cp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const n=this.getTelemetryDetails();this.r.forEach((i,a)=>{const h=i.filter(t=>!t.isDisposed);h.length===0?this.r.delete(a):this.r.set(a,h)}),this.r.forEach(i=>{for(const a of i)a.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,n){const a=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!a)return this.r.delete(s.value),!1;let h=!1;for(const t of a)t.ignoreUnhandledExtHostErrors||(t.logError(n),h=!0);return h}};e.$WO=b,e.$WO=b=Je([We(0,N.$VO),We(1,P.$Pj)],b);class f{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,n,i,a,h,t,v){this.g=i,this.h=a,this.i=h,this.j=t,this.a=new O.$7d,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:v.isUsageEnabled,isErrorsEnabled:v.isErrorsEnabled}}updateTelemetryEnablements(s,n){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let n="properties"in s?s.properties??{}:s;return n=(0,d.$fp)(n,[]),this.c&&(n=(0,k.$Rn)(n,this.c)),this.b||(n=(0,k.$Rn)(n,this.j)),"properties"in s?s.properties=n:s=n,s}k(s,n){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(s,n),this.h.trace(s,n))}logUsage(s,n){this.d.isUsageEnabled&&this.k(s,n)}logError(s,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,n);else{const i={name:s.name,message:s.message,stack:s.stack,cause:s.cause},a=(0,d.$fp)(i,[]),h=new Error(a.message,{cause:a.cause});h.stack=a.stack,h.name=a.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(h,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const s=this,n={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$XO=f;function r(o){const s=Date.now()-new Date(o).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$ZO=(0,I.$ii)("IExtHostTelemetry")}),define(Ce[22],Pe([1,0,5,2,198,103,20,3]),function($e,e,I,O,P,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bG=e.ActivationKind=e.$$F=e.$0F=e.$7F=e.ExtensionHostStartup=e.$6F=e.$5F=e.$4F=e.$3F=void 0,e.$8F=u,e.$9F=b,e.$_F=s,e.$aG=n,e.$3F=Object.freeze({identifier:new A.$Dm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:O.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$4F="extensions.webWorker",e.$5F=(0,m.$ii)("extensionService");class d{constructor(h){this.dependency=h}}e.$6F=d;var k;(function(a){a[a.EagerAutoStart=1]="EagerAutoStart",a[a.EagerManualStart=2]="EagerManualStart",a[a.Lazy=3]="Lazy"})(k||(e.ExtensionHostStartup=k={}));class F{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,t,v){this.c=h,this.d=t.slice(0),this.e=v.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:N.$NF.createActivationEventsMap(this.d)}}set(h,t,v){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const c=[],$=[],w=[],p=[],l=E(this.d),D=E(t),g=(V,U)=>V.extensionLocation.toString()===U.extensionLocation.toString()||V.isBuiltin===U.isBuiltin||V.isUserBuiltin===U.isUserBuiltin||V.isUnderDevelopment===U.isUnderDevelopment;for(const V of this.d){const U=D.get(V.identifier);if(!U){c.push(V.identifier),l.delete(V.identifier);continue}if(!g(V,U)){c.push(V.identifier),l.delete(V.identifier);continue}}for(const V of t){const U=l.get(V.identifier);if(!U){$.push(V);continue}if(!g(U,V)){c.push(U.identifier),l.delete(U.identifier);continue}}const S=new A.$Em(this.e),y=new A.$Em(v);for(const V of this.e)y.has(V)||w.push(V);for(const V of v)S.has(V)||p.push(V);const C=N.$NF.createActivationEventsMap($),R={versionId:h,toRemove:c,toAdd:$,addActivationEvents:C,myToRemove:w,myToAdd:p};return this.delta(R),R}delta(h){if(this.c>=h.versionId)return null;const{toRemove:t,toAdd:v,myToRemove:c,myToAdd:$}=h,w=new A.$Em(t),p=new A.$Em(c);for(let l=0;l<this.d.length;l++)w.has(this.d[l].identifier)&&(this.d.splice(l,1),l--);for(let l=0;l<this.e.length;l++)p.has(this.e[l])&&(this.e.splice(l,1),l--);for(const l of v)this.d.push(l);for(const l of $)this.e.push(l);return this.f=null,h}containsExtension(h){for(const t of this.e)if(A.$Dm.equals(t,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const v=N.$NF.readActivationEvents(t);for(const c of v)h.add(c)}return h}}e.$7F=F;function E(a){const h=new A.$Fm;for(const t of a)h.set(t.identifier,t);return h}function u(a,h){return a.enabledApiProposals?a.enabledApiProposals.includes(h):!1}function b(a,h){if(!u(a,h))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}class f{constructor(h,t,v,c){this.codeLoadingTime=h,this.activateCallTime=t,this.activateResolvedTime=v,this.activationReason=c}}e.$0F=f;class r{constructor(h,t){this.description=h,this.value=t}}e.$$F=r;var o;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function s(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,P.$lp)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}function n(a,h){return{identifier:new A.$Dm((0,P.$jp)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!h,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform}}class i{constructor(){this.onDidRegisterExtensions=I.Event.None,this.onDidChangeExtensionsStatus=I.Event.None,this.onDidChangeExtensions=I.Event.None,this.onWillActivateByEvent=I.Event.None,this.onDidChangeResponsiveChange=I.Event.None,this.onWillStop=I.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,t){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$bG=i}),define(Ce[225],Pe([1,0,14,108,20,22,13,11]),function($e,e,I,O,P,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ijc=e.$Hjc=e.$Gjc=e.$Fjc=e.$Ejc=e.$Djc=void 0;class d{static{this.NONE=new d(!1,-1,-1,-1)}constructor(s,n,i,a){this.startup=s,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=a}}e.$Djc=d;class k{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,n){return s===-1||n===-1?-1:n-s}build(){return new d(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Ejc=k;class F{constructor(s,n,i,a,h,t){this.activationFailed=s,this.activationFailedError=n,this.activationTimes=i,this.module=a,this.exports=h,this.subscriptions=t}}e.$Fjc=F;class E extends F{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Gjc=E;class u extends F{constructor(){super(!1,null,d.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Hjc=u;class b extends F{constructor(s){super(!0,s,d.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let f=class{constructor(s,n,i,a){this.g=a,this.a=s,this.b=n,this.c=i,this.d=new P.$Fm,this.f=Object.create(null)}dispose(){for(const[s,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const s=[];for(const[n,i]of this.d)s.push(i.wait());await Promise.all(s)}isActivated(s){const n=this.d.get(s);return!!(n&&n.value)}getActivatedExtension(s){const n=this.d.get(s);if(!n||!n.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return n.value}async activateByEvent(s,n){if(this.f[s])return;const i=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(i.map(a=>({id:a.identifier,reason:{startup:n,extensionId:a.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,n){const i=this.a.getExtensionDescription(s);if(!i)throw new Error(`Extension '${s}' is not known`);return this.h([{id:i.identifier,reason:n}])}async h(s){const n=s.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(n.map(i=>i.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const n=this.a.getExtensionDescription(s.id);if(!n){const h=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new b(h));return this.c.onExtensionActivationError(s.id,h,new N.$6F(s.id.value)),t}const i=[],a=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const h of a){if(this.m(h))continue;const t=this.d.get(h);if(t){i.push(t);continue}if(this.l(h)){i.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:s.reason}));continue}const v=this.a.getExtensionDescription(h);if(v){if(!v.main&&!v.browser)continue;i.push(this.j({id:v.identifier,reason:s.reason}));continue}const c=n.displayName||n.identifier.value,$=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${h}'`),w=this.k(s,n.displayName,[],new b($));return this.c.onExtensionActivationError(n.identifier,$,new N.$6F(h)),w}return this.k(s,n.displayName,i,null)}k(s,n,i,a){const h=new r(s.id,n,s.reason,i,a,this.c,this.g);return this.d.set(s.id,h),h}l(s){return O.$T0b.isHostExtension(s,this.a,this.b)}m(s){const n=this.b.getExtensionDescription(s);return n?!n.main&&!n.browser:!1}};e.$Ijc=f,e.$Ijc=f=Je([We(3,A.$Oj)],f);let r=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,n,i,a,h,t,v){this.c=s,this.d=n,this.f=i,this.g=a,this.h=h,this.j=t,this.k=v,this.a=new m.$hh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const n=this.g[s];if(n.value&&!n.value.activationFailed){this.g.splice(s,1),s--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this.h=new b(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const n=new Error;if(s&&s.name&&(n.name=s.name),s&&s.message?n.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(n.stack=s.stack),this.h=new b(n),this.b&&I.$4(s))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};r=Je([We(6,A.$Oj)],r)}),define(Ce[226],Pe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[227],Pe([1,0,184,14,32,98,72,30,20,226,194,103]),function($e,e,I,O,P,N,A,m,d,k,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=void 0;const u=m.$1n.as(A.$2n.JSONContribution);class b{constructor(h,t,v){this.a=h,this.b=t,this.c=v}d(h,t){this.a({type:h,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(P.default.Error,h)}warn(h){this.d(P.default.Warning,h)}info(h){this.d(P.default.Info,h)}}e.$WF=b;class f{static a(h){const t=new d.$Em;for(let v=0,c=h.length;v<c;v++)t.add(h[v].description.identifier);return t}static compute(h,t){if(!h||!h.length)return new f(t,[]);if(!t||!t.length)return new f([],h);const v=this.a(h),c=this.a(t),$=t.filter(p=>!v.has(p.description.identifier)),w=h.filter(p=>!c.has(p.description.identifier));return new f($,w)}constructor(h,t){this.added=h,this.removed=t}}e.$XF=f;class r{constructor(h,t){this.name=h,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=f.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,O.$1)(h)}}}e.$YF=r;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[I.localize(0,null),I.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$ZF={properties:{engines:{type:"object",description:I.localize(2,null),properties:{vscode:{type:"string",description:I.localize(3,null),default:"^1.22.0"}}},publisher:{description:I.localize(4,null),type:"string"},displayName:{description:I.localize(5,null),type:"string"},categories:{description:I.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:d.$Cm},{type:"string",const:"Languages",deprecationMessage:I.localize(7,null)}]}},galleryBanner:{type:"object",description:I.localize(8,null),properties:{color:{description:I.localize(9,null),type:"string"},theme:{description:I.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:I.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:I.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:I.localize(13,null)},enabledApiProposals:{markdownDescription:I.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:I.localize(15,null),type:"string",enum:["none"],enumDescriptions:[I.localize(16,null)]},activationEvents:{description:I.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:I.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:I.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:I.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:I.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:I.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:I.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:I.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:I.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:I.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:I.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:I.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:I.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:I.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:I.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:I.localize(32,null)},{label:"onUri",body:"onUri",description:I.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:I.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:I.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:I.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:I.localize(37,null)},{label:"onRenderer",description:I.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:I.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:I.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:I.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:I.localize(42,null)},{label:"*",description:I.localize(43,null),body:"*"}]}},badges:{type:"array",description:I.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:I.localize(45,null)},href:{type:"string",description:I.localize(46,null)},description:{type:"string",description:I.localize(47,null)}}}},markdown:{type:"string",description:I.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:I.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:I.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$Fo}},extensionPack:{description:I.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$Fo}},extensionKind:{description:I.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:I.localize(53,null)},{body:["workspace"],description:I.localize(54,null)},{body:["ui","workspace"],description:I.localize(55,null)},{body:["workspace","ui"],description:I.localize(56,null)},{body:[],description:I.localize(57,null)}]},capabilities:{description:I.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:I.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:I.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(61,null),I.localize(62,null),I.localize(63,null)]},description:{type:"string",markdownDescription:I.localize(64,null)}}},untrustedWorkspaces:{description:I.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:I.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(67,null),I.localize(68,null),I.localize(69,null)]},restrictedConfigurations:{description:I.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:I.localize(71,null)}}}}},sponsor:{description:I.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:I.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:I.localize(74,null),type:"string"},"vscode:uninstall":{description:I.localize(75,null),type:"string"}}},icon:{type:"string",description:I.localize(76,null)},l10n:{type:"string",description:I.localize(77,null)},pricing:{type:"string",markdownDescription:I.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const t=new r(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,t),h.activationEventsGenerator&&E.$NF.register(h.extensionPoint,h.activationEventsGenerator),e.$ZF.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,u.registerSchema(s,e.$ZF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$1F=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};m.$1n.add(i.ExtensionsRegistry,new n),e.$2F=m.$1n.as(i.ExtensionsRegistry),u.registerSchema(s,e.$ZF),u.registerSchema(F.$9j,{properties:{extensionEnabledApiProposals:{description:I.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Ce[228],Pe([1,0,180,16,26,227,33,5]),function($e,e,I,O,P,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rH=void 0;const d={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:I.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:I.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:I.localize(2,null),default:""}}};var k;(function(u){function b(f,r,o){if(!f)return;const s=O.$Vf(f.type)?f.type:void 0;if(!s||s.length===0){o.error(I.localize(3,null));return}const n=[];if(Array.isArray(f.required))for(const i of f.required)O.$Vf(i)&&n.push(i);return{extensionId:r.value,taskType:s,required:n,properties:f.properties?P.$On(f.properties):{},when:f.when?A.$gj.deserialize(f.when):void 0}}u.from=b})(k||(k={}));const F=N.$2F.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,b)=>{for(const f of u)f.type&&b.push(`onTaskType:${f.type}`)},jsonSchema:{description:I.localize(4,null),type:"array",items:d}});class E{constructor(){this.d=new m.$7d,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,f)=>{F.setHandler((r,o)=>{this.c=void 0;try{for(const s of o.removed){const n=s.value;for(const i of n)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const s of o.added){const n=s.value;for(const i of n){const a=k.from(i,s.description.identifier,s.collector);a&&(this.a[a.taskType]=a)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const f of this.all()){const r={type:"object",additionalProperties:!1};f.required.length>0&&(r.required=f.required.slice(0)),f.properties!==void 0?r.properties=P.$On(f.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[f.taskType]},b.push(r)}this.c={oneOf:b}}return this.c}}e.$rH=new E}),define(Ce[229],Pe([1,0,181,16,24,26,33,228]),function($e,e,I,O,P,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$BH=e.JsonSchemaVersion=e.ExecutionEngine=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$vH=e.ShellQuoting=e.$uH=e.$tH=e.$sH=void 0,e.$sH="settings",e.$tH=new A.$zj("taskRunning",!1,I.localize(0,null)),e.$uH=I.localize2(2,"Tasks");var d;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(d||(e.ShellQuoting=d={})),e.$vH="$customized",function(M){function L(G){if(!G)return M.Strong;switch(G.toLowerCase()){case"escape":return M.Escape;case"strong":return M.Strong;case"weak":return M.Weak;default:return M.Strong}}M.from=L}(d||(e.ShellQuoting=d={}));var k;(function(M){M.defaults={cwd:"${workspaceFolder}"}})(k||(e.CommandOptions=k={}));var F;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(F||(e.RevealKind=F={})),function(M){function L(G){switch(G.toLowerCase()){case"always":return M.Always;case"silent":return M.Silent;case"never":return M.Never;default:return M.Always}}M.fromString=L}(F||(e.RevealKind=F={}));var E;(function(M){M[M.Never=1]="Never",M[M.OnProblem=2]="OnProblem",M[M.Always=3]="Always"})(E||(e.RevealProblemKind=E={})),function(M){function L(G){switch(G.toLowerCase()){case"always":return M.Always;case"never":return M.Never;case"onproblem":return M.OnProblem;default:return M.OnProblem}}M.fromString=L}(E||(e.RevealProblemKind=E={}));var u;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(u||(e.PanelKind=u={})),function(M){function L(G){switch(G.toLowerCase()){case"shared":return M.Shared;case"dedicated":return M.Dedicated;case"new":return M.New;default:return M.Shared}}M.fromString=L}(u||(e.PanelKind=u={}));var b;(function(M){M.defaults={echo:!0,reveal:F.Always,revealProblems:E.Never,focus:!1,panel:u.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var f;(function(M){M[M.Shell=1]="Shell",M[M.Process=2]="Process",M[M.CustomExecution=3]="CustomExecution"})(f||(e.RuntimeType=f={})),function(M){function L(ne){switch(ne.toLowerCase()){case"shell":return M.Shell;case"process":return M.Process;case"customExecution":return M.CustomExecution;default:return M.Process}}M.fromString=L;function G(ne){switch(ne){case M.Shell:return"shell";case M.Process:return"process";case M.CustomExecution:return"customExecution";default:return"process"}}M.toString=G}(f||(e.RuntimeType=f={}));var r;(function(M){function L(G){return O.$Vf(G)?G:G.value}M.value=L})(r||(e.CommandString=r={}));var o;(function(M){M.Clean={_id:"clean",isDefault:!1},M.Build={_id:"build",isDefault:!1},M.Rebuild={_id:"rebuild",isDefault:!1},M.Test={_id:"test",isDefault:!1};function L(ne){return ne===M.Clean._id||ne===M.Build._id||ne===M.Rebuild._id||ne===M.Test._id}M.is=L;function G(ne){if(ne!==void 0)return O.$Vf(ne)?L(ne)?{_id:ne,isDefault:!1}:void 0:ne}M.from=G})(o||(e.TaskGroup=o={}));var s;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var n;(function(M){M.Workspace="workspace",M.Extension="extension",M.InMemory="inMemory",M.WorkspaceFile="workspaceFile",M.User="user";function L(G){switch(G){case M.User:return 2;case M.WorkspaceFile:return 5;default:return 6}}M.toConfigurationTarget=L})(n||(e.TaskSourceKind=n={}));var i;(function(M){M.parallel="parallel",M.sequence="sequence"})(i||(e.DependsOrder=i={}));var a;(function(M){M[M.default=1]="default",M[M.folderOpen=2]="folderOpen"})(a||(e.RunOnOptions=a={}));var h;(function(M){M.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class t{constructor(L,G,ne,he,ye,Re){this._label="",this._id=L,G&&(this._label=G),ne&&(this.type=ne),this.runOptions=he,this.configurationProperties=ye,this._source=Re}getDefinition(L){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const L={folder:this.d(),id:this._id};return JSON.stringify(L)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(L,G=!1){if(L===void 0)return!1;if(O.$Vf(L))return L===this._label||L===this.configurationProperties.identifier||G&&L===this._id;const ne=this.getDefinition(!0);return ne!==void 0&&ne._key===L._key}getQualifiedLabel(){const L=this.getWorkspaceFolder();return L?`${this._label} (${L.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(L){this.c===void 0&&(this.c=[]),L&&(this.c=this.c.concat(L))}get taskLoadMessages(){return this.c}}e.$wH=t;class v extends t{constructor(L,G,ne,he,ye,Re,ge,ue){super(L,ne,void 0,ge,ue,G),this.command={},this._source=G,this.hasDefinedMatchers=Re,ye&&(this.command=ye)}clone(){return new v(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(L=!1){if(L&&this._source.customizes!==void 0)return this._source.customizes;{let G;switch(this.command?this.command.runtime:void 0){case f.Shell:G="shell";break;case f.Process:G="process";break;case f.CustomExecution:G="customExecution";break;case void 0:G="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:G,_key:this._id,id:this._id}}}static is(L){return L instanceof v}getMapKey(){const L=this._source.config.workspaceFolder;return L?`${L.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$sH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const L=this.d();if(!L)return;let G=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(G+=this._source.kind);const ne={type:e.$vH,folder:L,id:G};return JSON.stringify(ne)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$Sg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(L){return new v(L._id,L._source,L._label,L.type,L.command,L.hasDefinedMatchers,L.runOptions,L.configurationProperties)}}e.$xH=v;class c extends t{constructor(L,G,ne,he,ye,Re,ge){super(L,ne,he,Re,ge,G),this._source=G,this.configures=ye}static is(L){return L instanceof c}f(L){return L}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$Sg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$sH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const L=this.d();if(!L)return;let G=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(G+=this._source.kind);const ne={type:e.$vH,folder:L,id:G};return JSON.stringify(ne)}}e.$yH=c;class $ extends t{constructor(L,G,ne,he,ye,Re,ge,ue,te){super(L,ne,he,ue,te,G),this.defines=ye,this.hasDefinedMatchers=ge,this.command=Re,this.icon=te.icon,this.hide=te.hide}clone(){return new $(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(L){return L instanceof $}getMapKey(){const L=this._source.workspaceFolder;return L?`${this._source.scope.toString()}|${L.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const L={type:"contributed",scope:this._source.scope,id:this._id};return L.folder=this.d(),JSON.stringify(L)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(L){return new $(L._id,L._source,L._label,L.type,L.defines,L.command,L.hasDefinedMatchers,L.runOptions,L.configurationProperties)}}e.$zH=$;class w extends t{constructor(L,G,ne,he,ye,Re){super(L,ne,he,ye,Re,G),this._source=G}clone(){return new w(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(L){return L instanceof w}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(L){return new w(L._id,L._source,L._label,L.type,L.runOptions,L.configurationProperties)}}e.$AH=w;var p;(function(M){M[M.Process=1]="Process",M[M.Terminal=2]="Terminal"})(p||(e.ExecutionEngine=p={})),function(M){M._default=M.Terminal}(p||(e.ExecutionEngine=p={}));var l;(function(M){M[M.V0_1_0=1]="V0_1_0",M[M.V2_0_0=2]="V2_0_0"})(l||(e.JsonSchemaVersion=l={}));class D{constructor(L){this.c=new Map;for(let G=0;G<L.length;G++)this.c.set(L[G].uri.toString(),G)}compare(L,G){const ne=L.getWorkspaceFolder(),he=G.getWorkspaceFolder();if(ne&&he){let ye=this.c.get(ne.uri.toString());ye=ye===void 0?0:ye+1;let Re=this.c.get(he.uri.toString());return Re=Re===void 0?0:Re+1,ye===Re?L._label.localeCompare(G._label):ye-Re}else return!ne&&he?-1:ne&&!he?1:0}}e.$BH=D;var g;(function(M){M.DependsOnStarted="dependsOnStarted",M.AcquiredInput="acquiredInput",M.Start="start",M.ProcessStarted="processStarted",M.Active="active",M.Inactive="inactive",M.Changed="changed",M.Terminated="terminated",M.ProcessEnded="processEnded",M.End="end"})(g||(e.TaskEventKind=g={}));var S;(function(M){M.SingleRun="singleRun",M.Background="background"})(S||(e.TaskRunType=S={}));var y;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.FolderOpen=2]="FolderOpen",M[M.ConfigurationChange=3]="ConfigurationChange",M[M.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var C;(function(M){function L(ue){return{taskId:ue._id,taskName:ue.configurationProperties.name,runType:ue.configurationProperties.isBackground?"background":"singleRun",group:ue.configurationProperties.group,__task:ue}}function G(ue,te,be){return{...L(ue),kind:"start",terminalId:te,resolvedVariables:be}}M.start=G;function ne(ue,te,be){return{...L(ue),kind:"processStarted",terminalId:te,processId:be}}M.processStarted=ne;function he(ue,te,be){return{...L(ue),kind:"processEnded",terminalId:te,exitCode:be}}M.processEnded=he;function ye(ue,te,be){return{...L(ue),kind:"terminated",exitReason:be,terminalId:te}}M.terminated=ye;function Re(ue,te,be){return{...L(te),kind:ue,terminalId:be}}M.general=Re;function ge(){return{kind:"changed"}}M.changed=ge})(C||(e.TaskEvent=C={}));var R;(function(M){function L(ne){const he=Object.keys(ne).sort();let ye="";for(const Re of he){let ge=ne[Re];ge instanceof Object?ge=L(ge):typeof ge=="string"&&(ge=ge.replace(/,/g,",,")),ye+=Re+","+ge+","}return ye}function G(ne){const ye={_key:L(ne),type:ne.taskType};return Object.assign(ye,ne),ye}M.create=G})(R||(e.KeyedTaskIdentifier=R={}));var V;(function(M){M.AutoDetect="task.autoDetect",M.SaveBeforeRun="task.saveBeforeRun",M.ShowDecorations="task.showDecorations",M.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",M.SlowProviderWarning="task.slowProviderWarning",M.QuickOpenHistory="task.quickOpen.history",M.QuickOpenDetail="task.quickOpen.detail",M.QuickOpenSkip="task.quickOpen.skip",M.QuickOpenShowAll="task.quickOpen.showAll",M.AllowAutomaticTasks="task.allowAutomaticTasks",M.Reconnection="task.reconnection",M.VerboseLogging="task.verboseLogging"})(V||(e.TaskSettingId=V={}));var U;(function(M){M.Tasks="tasks",M.SuppressTaskName="tasks.suppressTaskName",M.Windows="tasks.windows",M.Osx="tasks.osx",M.Linux="tasks.linux",M.ShowOutput="tasks.showOutput",M.IsShellCommand="tasks.isShellCommand",M.ServiceTestSetting="tasks.service.testSetting"})(U||(e.TasksSchemaProperties=U={}));var q;(function(M){function L(G,ne){const he=m.$rH.get(G.type);if(he===void 0){const ue=N.$On(G);return delete ue._key,R.create(ue)}const ye=Object.create(null);ye.type=he.taskType;const Re=new Set;he.required.forEach(ue=>Re.add(ue));const ge=he.properties;for(const ue of Object.keys(ge)){const te=G[ue];if(te!=null)ye[ue]=te;else if(Re.has(ue)){const be=ge[ue];if(be.default!==void 0)ye[ue]=N.$On(be.default);else switch(be.type){case"boolean":ye[ue]=!1;break;case"number":case"integer":ye[ue]=0;break;case"string":ye[ue]="";break;default:ne.error(I.localize(1,null,JSON.stringify(G,void 0,0),ue));return}}}return R.create(ye)}M.createTaskIdentifier=L})(q||(e.TaskDefinition=q={}))}),define(Ce[230],Pe([1,0,14]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y0b=e.$X0b=void 0;class O{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,m)=>{this.b=A,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,I.$1)(A))}then(A,m){return this.j().then(A,m)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$X0b=O;class P extends O{constructor(){super(),this.h=!0,this.i=new I.$5}}e.$Y0b=P}),define(Ce[50],Pe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ew=e.$bw=void 0,e.$cw=P,e.$dw=N;class I{static{this.count=0}constructor(d){this._proxyIdentifierBrand=void 0,this.sid=d,this.nid=++I.count}}e.$bw=I;const O=[];function P(m){const d=new I(m);return O[d.nid]=d,d}function N(m){return O[m].sid}class A{constructor(d){this.value=d}}e.$ew=A}),define(Ce[4],Pe([1,0,50]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lM=e.$kM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$jM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var O;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(O||(e.TextEditorRevealType=O={}));var P;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(P||(e.TabInputKind=P={}));var N;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(N||(e.TabModelOperationKind=N={}));var A;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var m;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var d;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(d||(e.CellOutputKind=d={}));var k;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(k||(e.NotebookEditorRevealType=k={}));var F;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output"})(F||(e.CandidatePortSource=F={}));class E{static{this.a=0}static mixin(o){return o._id=E.a++,o}}e.$jM=E;var u;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var b;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(b||(e.ISuggestResultDtoField=b={}));var f;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(f||(e.ExtHostTestingResource=f={})),e.$kM={MainThreadAuthentication:(0,I.$cw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.$cw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,I.$cw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,I.$cw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,I.$cw)("MainThreadChatVariables"),MainThreadClipboard:(0,I.$cw)("MainThreadClipboard"),MainThreadCommands:(0,I.$cw)("MainThreadCommands"),MainThreadComments:(0,I.$cw)("MainThreadComments"),MainThreadConfiguration:(0,I.$cw)("MainThreadConfiguration"),MainThreadConsole:(0,I.$cw)("MainThreadConsole"),MainThreadDebugService:(0,I.$cw)("MainThreadDebugService"),MainThreadDecorations:(0,I.$cw)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.$cw)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.$cw)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.$cw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.$cw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.$cw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.$cw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.$cw)("MainThreadEditorTabs"),MainThreadErrors:(0,I.$cw)("MainThreadErrors"),MainThreadTreeViews:(0,I.$cw)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.$cw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,I.$cw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.$cw)("MainThreadLanguages"),MainThreadLogger:(0,I.$cw)("MainThreadLogger"),MainThreadMessageService:(0,I.$cw)("MainThreadMessageService"),MainThreadOutputService:(0,I.$cw)("MainThreadOutputService"),MainThreadProgress:(0,I.$cw)("MainThreadProgress"),MainThreadQuickDiff:(0,I.$cw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,I.$cw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.$cw)("MainThreadStatusBar"),MainThreadSecretState:(0,I.$cw)("MainThreadSecretState"),MainThreadStorage:(0,I.$cw)("MainThreadStorage"),MainThreadSpeech:(0,I.$cw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,I.$cw)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.$cw)("MainThreadTerminalService"),MainThreadWebviews:(0,I.$cw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.$cw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.$cw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.$cw)("MainThreadCustomEditors"),MainThreadUrls:(0,I.$cw)("MainThreadUrls"),MainThreadUriOpeners:(0,I.$cw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,I.$cw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,I.$cw)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.$cw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,I.$cw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,I.$cw)("MainThreadExtensionService"),MainThreadSCM:(0,I.$cw)("MainThreadSCM"),MainThreadSearch:(0,I.$cw)("MainThreadSearch"),MainThreadShare:(0,I.$cw)("MainThreadShare"),MainThreadTask:(0,I.$cw)("MainThreadTask"),MainThreadWindow:(0,I.$cw)("MainThreadWindow"),MainThreadLabelService:(0,I.$cw)("MainThreadLabelService"),MainThreadNotebook:(0,I.$cw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.$cw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.$cw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.$cw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.$cw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.$cw)("MainThreadInteractive"),MainThreadChat:(0,I.$cw)("MainThreadChat"),MainThreadInlineChat:(0,I.$cw)("MainThreadInlineChatShape"),MainThreadTheming:(0,I.$cw)("MainThreadTheming"),MainThreadTunnelService:(0,I.$cw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,I.$cw)("MainThreadManagedSockets"),MainThreadTimeline:(0,I.$cw)("MainThreadTimeline"),MainThreadTesting:(0,I.$cw)("MainThreadTesting"),MainThreadLocalization:(0,I.$cw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,I.$cw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,I.$cw)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,I.$cw)("MainThreadIssueReporter")},e.$lM={ExtHostCommands:(0,I.$cw)("ExtHostCommands"),ExtHostConfiguration:(0,I.$cw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.$cw)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.$cw)("ExtHostDebugService"),ExtHostDecorations:(0,I.$cw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.$cw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.$cw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.$cw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.$cw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.$cw)("ExtHostEditors"),ExtHostTreeViews:(0,I.$cw)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.$cw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.$cw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.$cw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.$cw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.$cw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.$cw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,I.$cw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,I.$cw)("ExtHostStatusBar"),ExtHostShare:(0,I.$cw)("ExtHostShare"),ExtHostExtensionService:(0,I.$cw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.$cw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.$cw)("ExtHostTerminalService"),ExtHostSCM:(0,I.$cw)("ExtHostSCM"),ExtHostSearch:(0,I.$cw)("ExtHostSearch"),ExtHostTask:(0,I.$cw)("ExtHostTask"),ExtHostWorkspace:(0,I.$cw)("ExtHostWorkspace"),ExtHostWindow:(0,I.$cw)("ExtHostWindow"),ExtHostWebviews:(0,I.$cw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.$cw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.$cw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.$cw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.$cw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.$cw)("ExtHostEditorTabs"),ExtHostProgress:(0,I.$cw)("ExtHostProgress"),ExtHostComments:(0,I.$cw)("ExtHostComments"),ExtHostSecretState:(0,I.$cw)("ExtHostSecretState"),ExtHostStorage:(0,I.$cw)("ExtHostStorage"),ExtHostUrls:(0,I.$cw)("ExtHostUrls"),ExtHostUriOpeners:(0,I.$cw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,I.$cw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,I.$cw)("ExtHostOutputService"),ExtHostLabelService:(0,I.$cw)("ExtHostLabelService"),ExtHostNotebook:(0,I.$cw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.$cw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.$cw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.$cw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.$cw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,I.$cw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,I.$cw)("ExtHostInteractive"),ExtHostInlineChat:(0,I.$cw)("ExtHostInlineChatShape"),ExtHostChat:(0,I.$cw)("ExtHostChat"),ExtHostChatAgents2:(0,I.$cw)("ExtHostChatAgents"),ExtHostChatVariables:(0,I.$cw)("ExtHostChatVariables"),ExtHostChatProvider:(0,I.$cw)("ExtHostChatProvider"),ExtHostSpeech:(0,I.$cw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,I.$cw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,I.$cw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,I.$cw)("ExtHostTheming"),ExtHostTunnelService:(0,I.$cw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,I.$cw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,I.$cw)("ExtHostAuthentication"),ExtHostTimeline:(0,I.$cw)("ExtHostTimeline"),ExtHostTesting:(0,I.$cw)("ExtHostTesting"),ExtHostTelemetry:(0,I.$cw)("ExtHostTelemetry"),ExtHostLocalization:(0,I.$cw)("ExtHostLocalization"),ExtHostIssueReporter:(0,I.$cw)("ExtHostIssueReporter")}}),define(Ce[78],Pe([1,0,3,13,4,17]),function($e,e,I,O,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ic=e.$1ic=e.$Zic=void 0,e.$Zic=(0,I.$ii)("IExtHostApiDeprecationService");let A=class{constructor(d,k){this.c=k,this.a=new Set,this.b=d.getProxy(P.$kM.MainThreadTelemetry)}report(d,k,F){const E=this.d(d,k);this.a.has(E)||(this.a.add(E),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${d}' is deprecated. ${F}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:d}))}d(d,k){return`${d}-${k.identifier.value}`}};e.$1ic=A,e.$1ic=A=Je([We(0,N.$FO),We(1,O.$Oj)],A),e.$2ic=Object.freeze(new class{report(m,d,k){}})}),define(Ce[231],Pe([1,0,39,6,4]),function($e,e,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ajc=void 0;class N{static{this.a=0}constructor(d,k){this.extension=d,this.provider=k,this.handle=N.a++}}class A{static{this.a=0}constructor(d){this.b=new Map,this.c=new Map,this.d=d.getProxy(P.$kM.MainThreadChat)}registerChatProvider(d,k,F){const E=new N(d,F);return this.b.set(E.handle,E),this.d.$registerChatProvider(E.handle,k),(0,O.$Sc)(()=>{this.d.$unregisterChatProvider(E.handle),this.b.delete(E.handle)})}transferChatSession(d,k){const F=I.Iterable.find(this.c.keys(),E=>this.c.get(E)===d)??0;typeof F=="number"&&this.d.$transferChatSession(F,k)}async $prepareChat(d,k){const F=this.b.get(d);if(!F)return;const E=await F.provider.prepareSession(k);if(!E)return;const u=A.a++;return this.c.set(u,E),{id:u}}$releaseSession(d){this.c.delete(d)}}e.$ajc=A}),define(Ce[232],Pe([1,0,4]),function($e,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fjc=void 0;class O{constructor(N){const A=N.getProxy(I.$kM.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(m){return A.$writeText(m)}})}}e.$fjc=O}),define(Ce[233],Pe([1,0,26,4,27,17]),function($e,e,I,O,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9kc=void 0;let A=class{constructor(F,E){this.a=F.getProxy(O.$kM.MainThreadConsole),this.b=E.consoleForward.includeStack,this.c=E.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(F,E){const u=this,b=console[F];Object.defineProperty(console,F,{set:()=>{},get:()=>function(){u.e(F,E,b,arguments)}})}e(F,E,u,b){this.a.$logExtensionHostMessage({type:"__$console",severity:E,arguments:d(b,this.b)}),this.c&&this.f(F,u,b)}};e.$9kc=A,e.$9kc=A=Je([We(0,N.$FO),We(1,P.$VO)],A);const m=1e5;function d(k,F){const E=[];if(k.length)for(let u=0;u<k.length;u++){let b=k[u];if(typeof b>"u")b="undefined";else if(b instanceof Error){const f=b;f.stack?b=f.stack:b=f.toString()}E.push(b)}if(F){const u=new Error().stack;u&&E.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,I.$Tn)(E);return u.length>m?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Ce[234],Pe([1,0,2,4,22]),function($e,e,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$akc=void 0;class N{constructor(m){this.a=m.getProxy(O.$kM.MainThreadDialogs)}showOpenDialog(m,d){return d?.allowUIResources&&(0,P.$9F)(m,"showLocal"),this.a.$showOpenDialog(d).then(k=>k?k.map(F=>I.URI.revive(F)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(d=>d?I.URI.revive(d):void 0)}}e.$akc=N}),define(Ce[235],Pe([1,0,6,4]),function($e,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vkc=void 0;class P{constructor(A){this.b=0,this.a=A.getProxy(O.$kM.MainThreadLabelService)}$registerResourceLabelFormatter(A){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,A),(0,I.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$vkc=P}),define(Ce[79],Pe([1,0,21,15,2,3,13,4,27,17]),function($e,e,I,O,P,N,A,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vjc=e.$Ujc=void 0;let F=class{constructor(u,b,f){this.f=f,this.d=new Map,this.a=b.getProxy(m.$kM.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===I.$g}getMessage(u,b){const{message:f,args:r,comment:o}=b;if(this.c)return(0,O.$We)(f,r??{});let s=f;o&&o.length>0&&(s+=`/${Array.isArray(o)?o.join(""):o}`);const n=this.d.get(u)?.contents[s];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,O.$We)(n??f,r??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let b;const f=await this.g(u);if(!f){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(f),o=JSON.parse(r);b=u.isBuiltin?o.contents?.bundle:o}catch(r){this.f.error(`Failed to load translations for ${u.identifier.value} from ${f}: ${r.message}`);return}b&&this.d.set(u.identifier.value,{contents:b,uri:f})}async g(u){if(u.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return P.URI.revive(b)}return u.l10n?P.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Ujc=F,e.$Ujc=F=Je([We(0,d.$VO),We(1,k.$FO),We(2,A.$Oj)],F),e.$Vjc=(0,N.$ii)("IExtHostLocalizationService")}),define(Ce[236],Pe([1,0,13,4,27,17,2,52]),function($e,e,I,O,P,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8kc=void 0;let d=class extends I.$Zj{constructor(E,u){super(u.logLevel,u.logsLocation,u.loggers.map(b=>(0,m.$Rh)(b))),this.r=E.getProxy(O.$kM.MainThreadLogger)}$setLogLevel(E,u){u?this.setLogLevel(A.URI.revive(u),E):this.setLogLevel(E)}setVisibility(E,u){super.setVisibility(E,u),this.r.$setVisibility(E,u)}s(E,u,b){return new k(this.r,E,u,b)}};e.$8kc=d,e.$8kc=d=Je([We(0,N.$FO),We(1,P.$VO)],d);class k extends I.$Uj{constructor(E,u,b,f){super(f?.logLevel==="always"),this.r=E,this.s=u,this.m=!1,this.n=[],this.setLevel(b),this.r.$createLogger(u,f).then(()=>{this.u(this.n),this.m=!0})}g(E,u){const b=[[E,u]];this.m?this.u(b):this.n.push(...b)}u(E){this.r.$log(this.s,E)}flush(){this.r.$flush(this.s)}}}),define(Ce[80],Pe([1,0,4,3,6,17,23]),function($e,e,I,O,P,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xjc=e.$Wjc=void 0,e.$Wjc=(0,O.$ii)("IExtHostManagedSockets");let m=class{constructor(E){this.b=0,this.c=null,this.d=new Map,this.a=E.getProxy(I.$kM.MainThreadManagedSockets)}setFactory(E,u){for(const b of this.d.values())b.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new d(E,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(E){if(!this.c||this.c.socketFactoryId!==E)throw new Error(`No socket factory with id ${E}`);const u=++this.b,b=await this.c.makeConnection(),f=new P.$Tc;return this.d.set(u,new k(u,b,f)),f.add((0,P.$Sc)(()=>this.d.delete(u))),f.add(b.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),f.dispose()})),f.add(b.onDidClose(r=>{this.a.$onDidManagedSocketClose(u,r?.stack??r?.message),f.dispose()})),f.add(b.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(u,A.$ue.wrap(r)))),u}$remoteSocketWrite(E,u){this.d.get(E)?.actual.send(u.buffer)}$remoteSocketEnd(E){const u=this.d.get(E);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(E){await this.d.get(E)?.actual.drain?.()}};e.$Xjc=m,e.$Xjc=m=Je([We(0,N.$FO)],m);class d{constructor(E,u){this.socketFactoryId=E,this.makeConnection=u}}class k extends P.$Uc{constructor(E,u,b){super(),this.socketId=E,this.actual=u,this.B(b)}}}),define(Ce[237],Pe([1,0,4,13,22]),function($e,e,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xkc=void 0;function N(m){return m&&m.title}let A=class{constructor(d,k){this.b=k,this.a=d.getProxy(I.$kM.MainThreadMessageService)}showMessage(d,k,F,E,u){const b={source:{identifier:d.identifier,label:d.displayName||d.name}};let f;typeof E=="string"||N(E)?f=[E,...u]:(b.modal=E?.modal,b.useCustom=E?.useCustom,b.detail=E?.detail,f=u),b.useCustom&&(0,P.$9F)(d,"resolvers");const r=[];let o=!1;for(let s=0;s<f.length;s++){const n=f[s];if(typeof n=="string")r.push({title:n,handle:s,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:a}=n;r.push({title:i,isCloseAffordance:!!a,handle:s}),a&&(o?this.b.warn(`[${d.identifier}] Only one message item can have 'isCloseAffordance':`,n):o=!0)}else this.b.warn(`[${d.identifier}] Invalid message item:`,n)}return this.a.$showMessage(k,F,b,r).then(s=>{if(typeof s=="number")return f[s]})}};e.$xkc=A,e.$xkc=A=Je([We(1,O.$Oj)],A)}),define(Ce[238],Pe([1,0,6,16,2,22,4]),function($e,e,I,O,P,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gkc=void 0;class m{constructor(k){this.b=new Map,this.a=k.getProxy(A.$kM.MainThreadProfileContentHandlers)}registerProfileContentHandler(k,F,E){if((0,N.$9F)(k,"profileContentHandlers"),this.b.has(F))throw new Error(`Handler with id '${F}' already registered`);return this.b.set(F,E),this.a.$registerProfileContentHandler(F,E.name,E.description,k.identifier.value),(0,I.$Sc)(()=>{this.b.delete(F),this.a.$unregisterProfileContentHandler(F)})}async $saveProfile(k,F,E,u){const b=this.b.get(k);if(!b)throw new Error(`Unknown handler with id: ${k}`);return b.saveProfile(F,E,u)}async $readProfile(k,F,E){const u=this.b.get(k);if(!u)throw new Error(`Unknown handler with id: ${k}`);return u.readProfile((0,O.$Vf)(F)?F:P.URI.revive(F),E)}}e.$Gkc=m}),define(Ce[81],Pe([1,0,4,5,3]),function($e,e,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sjc=e.$Rjc=void 0;class N{constructor(m){this.b=new O.$7d,this.onDidChangePassword=this.b.event,this.a=m.getProxy(I.$kM.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,d){return this.a.$getPassword(m,d)}store(m,d,k){return this.a.$setPassword(m,d,k)}delete(m,d){return this.a.$deletePassword(m,d)}}e.$Rjc=N,e.$Sjc=(0,P.$ii)("IExtHostSecretState")}),define(Ce[239],Pe([1,0,25,6,4]),function($e,e,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nkc=void 0;class N{static{this.a=1}constructor(m){this.c=new Map,this.d=new Map,this.b=m.getProxy(P.$kM.MainThreadSpeech)}async $createSpeechToTextSession(m,d,k){const F=this.c.get(m);if(!F)return;const E=new O.$Tc,u=new I.$ee;this.d.set(d,u);const b=E.add(F.provideSpeechToTextSession(u.token,k?{language:k}:void 0));E.add(b.onDidChange(f=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(d,f)})),E.add(u.token.onCancellationRequested(()=>E.dispose()))}async $cancelSpeechToTextSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}async $createKeywordRecognitionSession(m,d){const k=this.c.get(m);if(!k)return;const F=new O.$Tc,E=new I.$ee;this.d.set(d,E);const u=F.add(k.provideKeywordRecognitionSession(E.token));F.add(u.onDidChange(b=>{E.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(d,b)})),F.add(E.token.onCancellationRequested(()=>F.dispose()))}async $cancelKeywordRecognitionSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}registerProvider(m,d,k){const F=N.a++;return this.c.set(F,k),this.b.$registerProvider(F,d,{extension:m,displayName:m.value}),(0,O.$Sc)(()=>{this.b.$unregisterProvider(F),this.c.delete(F)})}}e.$Nkc=N}),define(Ce[82],Pe([1,0,4,5,3]),function($e,e,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kjc=e.$Jjc=void 0;class N{constructor(m,d){this.c=d,this.b=new O.$7d,this.onDidChangeStorage=this.b.event,this.a=m.getProxy(I.$kM.MainThreadStorage)}registerExtensionStorageKeysToSync(m,d){this.a.$registerExtensionStorageKeysToSync(m,d)}async initializeExtensionStorage(m,d,k){const F=await this.a.$initializeExtensionStorage(m,d);let E;return F&&(E=this.d(m,d,F)),E||k}setValue(m,d,k){return this.a.$setValue(m,d,k)}$acceptValue(m,d,k){const F=this.d(m,d,k);F&&this.b.fire({shared:m,key:d,value:F})}d(m,d,k){try{return JSON.parse(k)}catch(F){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${d}, global: ${m}): ${F}`)}}}e.$Jjc=N,e.$Kjc=(0,P.$ii)("IExtHostStorage")}),define(Ce[240],Pe([1,0,6,12,2,4]),function($e,e,I,O,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2kc=void 0;class A{static{this.a=new Set([O.Schemas.http,O.Schemas.https])}constructor(d){this.c=new Map,this.b=d.getProxy(N.$kM.MainThreadUriOpeners)}registerExternalUriOpener(d,k,F,E){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const u=E.schemes.find(b=>!A.a.has(b));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(k,F),this.b.$registerUriOpener(k,E.schemes,d,E.label),(0,I.$Sc)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri(d,k,F){const E=this.c.get(d);if(!E)throw new Error(`Unknown opener with id: ${d}`);const u=P.URI.revive(k);return E.canOpenExternalUri(u,F)}async $openUri(d,k,F){const E=this.c.get(d);if(!E)throw new Error(`Unknown opener id: '${d}'`);return E.openExternalUri(P.URI.revive(k.resolvedUri),{sourceUri:P.URI.revive(k.sourceUri)},F)}}e.$2kc=A}),define(Ce[241],Pe([1,0,4,2,6,14,20]),function($e,e,I,O,P,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3kc=void 0;class m{static{this.a=0}constructor(k){this.c=new A.$Em,this.d=new Map,this.b=k.getProxy(I.$kM.MainThreadUrls)}registerUriHandler(k,F){const E=k.identifier;if(this.c.has(E))throw new Error(`Protocol handler already registered for extension ${E}`);const u=m.a++;return this.c.add(E),this.d.set(u,F),this.b.$registerUriHandler(u,E,k.displayName||k.name),(0,P.$Sc)(()=>{this.c.delete(E),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(k,F){const E=this.d.get(k);if(!E)return Promise.resolve(void 0);try{E.handleUri(O.URI.revive(F))}catch(u){(0,N.$1)(u)}return Promise.resolve(void 0)}async createAppUri(k){return O.URI.revive(await this.b.$createAppUri(k))}}e.$3kc=m}),define(Ce[62],Pe([1,0,5,6,12,26,2,187,209,76,4]),function($e,e,I,O,P,N,A,m,d,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wjc=e.$ujc=void 0,e.$vjc=u,e.$xjc=r,e.$yjc=o;class E{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(a,h,t,v,c,$,w){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new I.$7d,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new I.$7d,this._onDidDispose=this.#h.event,this.#e=a,this.#t=h,this.#o=t,this.#n=v,this.#s=c,this.#r=$,this.#l=u($),this.#d=b($),this.#i=w}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(a){return this.#u=!0,(0,k.$8yb)(a,this.#n)}get cspSource(){const a=this.#r.extensionLocation;if(a.scheme===P.Schemas.https||a.scheme===P.Schemas.http){let h=a.toString();return h.endsWith("/")||(h+="/"),h+" "+k.$7yb}return k.$7yb}get html(){return this.a(),this.#a}set html(a){this.a(),this.#a!==a&&(this.#a=a,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(a)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(a)))}get options(){return this.a(),this.#o}set options(a){this.a(),N.$Sn(this.#o,a)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,a)),this.#o=a}async postMessage(a){if(this.#c)return!1;const h=(0,d.$Snb)(a,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(a){if(!this.#d)return a;const h=this.#r.extensionLocation?.scheme===P.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return a.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(v,c,$,w,p,l)=>{const D=A.URI.from({scheme:w||"file",path:decodeURIComponent(p)}),g=(0,k.$8yb)(D,{isRemote:h,authority:t}).toString();return`${c}${g}${l}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(v,c,$,w,p,l)=>{const D=A.URI.from({scheme:w||"file",path:decodeURIComponent(p)}),g=(0,k.$8yb)(D,{isRemote:h,authority:t}).toString();return`${c}${g}${l}`})}}e.$ujc=E;function u(i){try{const a=(0,m.$up)((0,m.$tp)(i.engines.vscode));return!!a&&a.majorBase>=1&&a.minorBase>=57}catch{return!1}}function b(i){try{const a=(0,m.$up)((0,m.$tp)(i.engines.vscode));return a?a.majorBase<1||a.majorBase===1&&a.minorBase<60:!1}catch{return!1}}class f extends O.$Uc{constructor(a,h,t,v,c){super(),this.c=h,this.f=t,this.g=v,this.h=c,this.b=new Map,this.a=a.getProxy(F.$kM.MainThreadWebviews)}dispose(){super.dispose();for(const a of this.b.values())a.dispose();this.b.clear()}$onMessage(a,h,t){const v=this.j(a);if(v){const{message:c}=(0,d.$Tnb)(h,t.value);v._onMessageEmitter.fire(c)}}$onMissingCsp(a,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(a,h,t){const v=new E(a,this.a,s(h),this.c,this.f,t,this.h);this.b.set(a,v);const c=v._onDidDispose(()=>{c.dispose(),this.deleteWebview(a)});return v}deleteWebview(a){this.b.delete(a)}j(a){return this.b.get(a)}}e.$wjc=f;function r(i){return{id:i.identifier,location:i.extensionLocation}}function o(i,a,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||n(i,a)}}function s(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(a=>A.URI.from(a))}}function n(i,a){return[...(a?.getWorkspaceFolders()||[]).map(h=>h.uri),i.extensionLocation]}}),define(Ce[109],Pe([1,0,5,4,2,12,15,3,17,22]),function($e,e,I,O,P,N,A,m,d,k){"use strict";var F;Object.defineProperty(e,"__esModule",{value:!0}),e.$6kc=e.$5kc=void 0;let E=class{static{F=this}static{this.a={focused:!0,active:!0}}getState(b){const f=this.d;return{get focused(){return f.focused},get active(){return(0,k.$9F)(b,"windowActivity"),f.active}}}constructor(b){this.c=new I.$7d,this.onDidChangeWindowState=this.c.event,this.d=F.a,this.b=b.getProxy(O.$kM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:f,isActive:r})=>{this.onDidChangeWindowProperty("focused",f),this.onDidChangeWindowProperty("active",r)})}$onDidChangeWindowFocus(b){this.onDidChangeWindowProperty("focused",b)}$onDidChangeWindowActive(b){this.onDidChangeWindowProperty("active",b)}onDidChangeWindowProperty(b,f){f!==this.d[b]&&(this.d={...this.d,[b]:f},this.c.fire(this.d))}openUri(b,f){let r;if(typeof b=="string"){r=b;try{b=P.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,A.$Ue)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===N.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this.b.$openUri(b,r,f)}async asExternalUri(b,f){if((0,A.$Ue)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const r=await this.b.$asExternalUri(b,f);return P.URI.from(r)}};e.$5kc=E,e.$5kc=E=F=Je([We(0,d.$FO)],E),e.$6kc=(0,m.$ii)("IExtHostWindow")}),define(Ce[242],Pe([1,0,233,27,17]),function($e,e,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$enc=void 0;let N=class extends I.$9kc{constructor(m,d){super(m,d)}f(m,d,k){d.apply(console,k)}};e.$enc=N,e.$enc=N=Je([We(0,P.$FO),We(1,O.$VO)],N)}),define(Ce[243],Pe([1,0,11,23,25,14,5,6,143,230,50]),function($e,e,I,O,P,N,A,m,d,k,F){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$20b=e.ResponsiveState=e.RequestInitiator=void 0,e.$Z0b=o,e.$10b=s;function u(y,C){try{return JSON.stringify(y,C)}catch{return"null"}}const b="$$ref$$",f={[b]:-1};class r{constructor(C,R){this.jsonString=C,this.referencedBuffers=R}}function o(y,C=null,R=!1){const V=[];return{jsonString:(R?u:JSON.stringify)(y,(q,M)=>{if(typeof M>"u")return f;if(typeof M=="object"){if(M instanceof O.$ue){const L=V.push(M)-1;return{[b]:L}}if(C)return C(q,M)}return M}),referencedBuffers:V}}function s(y,C,R){return JSON.parse(y,(V,U)=>{if(U){const q=U[b];if(typeof q=="number")return C[q];if(R&&U.$mid===1)return R.transformIncoming(U)}return U})}function n(y,C){return JSON.stringify(y,C)}function i(y){return y?(C,R)=>R&&R.$mid===1?y.transformOutgoing(R):R:null}var a;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(a||(e.RequestInitiator=a={}));var h;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const t=()=>{},v=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class $ extends m.$Uc{static{E=v}static{this.a=3*1e3}constructor(C,R=null,V=null){super(),this[E]=!0,this.b=this.B(new A.$7d),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=R,this.g=V,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let U=0,q=F.$bw.count;U<q;U++)this.m[U]=null,this.s[U]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new I.$uh(()=>this.H(),1e3)),this.c.onMessage(U=>this.L(U))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const R=this.w[C];delete this.w[C],R.resolveErr(N.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+$.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+$.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,d.$nn)(C,this.g):C}getProxy(C){const{nid:R,sid:V}=C;return this.s[R]||(this.s[R]=this.J(R,V)),this.s[R]}J(C,R){const V={get:(U,q)=>(typeof q=="string"&&!U[q]&&q.charCodeAt(0)===36&&(U[q]=(...M)=>this.U(C,q,M)),q===c?R:U[q])};return new Proxy(Object.create(null),V)}set(C,R){return this.m[C.nid]=R,R}assertRegistered(C){for(let R=0,V=C.length;R<V;R++){const U=C[R];if(!this.m[U.nid])throw new Error(`Missing proxy instance ${U.sid}`)}}L(C){if(this.j)return;const R=C.byteLength,V=p.read(C,0),U=V.readUInt8(),q=V.readUInt32();switch(U){case 1:case 2:{let{rpcId:M,method:L,args:G}=D.deserializeRequestJSONArgs(V);this.g&&(G=(0,d.$nn)(G,this.g)),this.M(R,q,M,L,G,U===2);break}case 3:case 4:{let{rpcId:M,method:L,args:G}=D.deserializeRequestMixedArgs(V);this.g&&(G=(0,d.$nn)(G,this.g)),this.M(R,q,M,L,G,U===4);break}case 5:{this.f?.logIncoming(R,q,0,"ack"),this.G(q);break}case 6:{this.N(R,q);break}case 7:{this.O(R,q,void 0);break}case 9:{let M=D.deserializeReplyOKJSON(V);this.g&&(M=(0,d.$nn)(M,this.g)),this.O(R,q,M);break}case 10:{const M=D.deserializeReplyOKJSONWithBuffers(V,this.g);this.O(R,q,M);break}case 8:{const M=D.deserializeReplyOKVSBuffer(V);this.O(R,q,M);break}case 11:{let M=D.deserializeReplyErrError(V);this.g&&(M=(0,d.$nn)(M,this.g)),this.P(R,q,M);break}case 12:{this.P(R,q,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,R,V,U,q,M){this.f?.logIncoming(C,R,1,`receiveRequest ${(0,F.$dw)(V)}.${U}(`,q);const L=String(R);let G,ne;if(M){const ye=new P.$ee;q.push(ye.token),G=this.Q(V,U,q),ne=()=>ye.cancel()}else G=this.Q(V,U,q),ne=t;this.u[L]=ne;const he=D.serializeAcknowledged(R);this.f?.logOutgoing(he.byteLength,R,1,"ack"),this.c.send(he),G.then(ye=>{delete this.u[L];const Re=D.serializeReplyOK(R,ye,this.h);this.f?.logOutgoing(Re.byteLength,R,1,"reply:",ye),this.c.send(Re)},ye=>{delete this.u[L];const Re=D.serializeReplyErr(R,ye);this.f?.logOutgoing(Re.byteLength,R,1,"replyErr:",ye),this.c.send(Re)})}N(C,R){this.f?.logIncoming(C,R,1,"receiveCancel");const V=String(R);this.u[V]?.()}O(C,R,V){this.f?.logIncoming(C,R,0,"receiveReply:",V);const U=String(R);if(!this.w.hasOwnProperty(U))return;const q=this.w[U];delete this.w[U],q.resolveOk(V)}P(C,R,V){this.f?.logIncoming(C,R,0,"receiveReplyErr:",V);const U=String(R);if(!this.w.hasOwnProperty(U))return;const q=this.w[U];delete this.w[U];let M;V&&(V.$isError?(M=new Error,M.name=V.name,M.message=V.message,M.stack=V.stack):M=V),q.resolveErr(M)}Q(C,R,V){try{return Promise.resolve(this.S(C,R,V))}catch(U){return Promise.reject(U)}}S(C,R,V){const U=this.m[C];if(!U)throw new Error("Unknown actor "+(0,F.$dw)(C));const q=U[R];if(typeof q!="function")throw new Error("Unknown method "+R+" on actor "+(0,F.$dw)(C));return q.apply(U,V)}U(C,R,V){if(this.j)return new k.$Y0b;let U=null;if(V.length>0&&P.CancellationToken.isCancellationToken(V[V.length-1])&&(U=V.pop()),U&&U.isCancellationRequested)return Promise.reject(N.$6());const q=D.serializeRequestArguments(V,this.h),M=++this.t,L=String(M),G=new k.$X0b,ne=new m.$Tc;U&&ne.add(U.onCancellationRequested(()=>{const ye=D.serializeCancel(M);this.f?.logOutgoing(ye.byteLength,M,0,"cancel"),this.c.send(D.serializeCancel(M))})),this.w[L]=new w(G,ne),this.F(M);const he=D.serializeRequest(M,C,R,q,!!U);return this.f?.logOutgoing(he.byteLength,M,0,`request: ${(0,F.$dw)(C)}.${R}(`,V),this.c.send(he),G}}e.$20b=$;class w{constructor(C,R){this.a=C,this.b=R}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class p{static alloc(C,R,V){const U=new p(O.$ue.alloc(V+1+4),0);return U.writeUInt8(C),U.writeUInt32(R),U}static read(C,R){return new p(C,R)}get buffer(){return this.a}constructor(C,R){this.a=C,this.b=R}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const V=this.a.slice(this.b,this.b+C).toString();return this.b+=C,V}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+C).toString();return this.b+=C,V}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const R=this.a.slice(this.b,this.b+C);return this.b+=C,R}static sizeMixedArray(C){let R=0;R+=1;for(let V=0,U=C.length;V<U;V++){const q=C[V];switch(R+=1,q.type){case 1:R+=this.sizeLongString(q.value);break;case 2:R+=this.sizeVSBuffer(q.value);break;case 3:R+=this.sizeUInt32,R+=this.sizeLongString(q.value);for(let M=0;M<q.buffers.length;++M)R+=this.sizeVSBuffer(q.buffers[M]);break;case 4:break}}return R}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let R=0,V=C.length;R<V;R++){const U=C[R];switch(U.type){case 1:this.writeUInt8(1),this.writeLongString(U.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(U.value);break;case 3:this.writeUInt8(3),this.writeUInt32(U.buffers.length),this.writeLongString(U.value);for(let q=0;q<U.buffers.length;++q)this.writeBuffer(U.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const R=new Array(C);for(let V=0;V<C;V++)switch(this.readUInt8()){case 1:R[V]=this.readLongString();break;case 2:R[V]=this.readVSBuffer();break;case 3:{const q=this.readUInt32(),M=this.readLongString(),L=[];for(let G=0;G<q;++G)L.push(this.readVSBuffer());R[V]=new F.$ew(s(M,L,null));break}case 4:R[V]=void 0;break}return R}}var l;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(l||(l={}));class D{static a(C){for(let R=0,V=C.length;R<V;R++)if(C[R]instanceof O.$ue||C[R]instanceof F.$ew||typeof C[R]>"u")return!0;return!1}static serializeRequestArguments(C,R){if(this.a(C)){const V=[];for(let U=0,q=C.length;U<q;U++){const M=C[U];if(M instanceof O.$ue)V[U]={type:2,value:M};else if(typeof M>"u")V[U]={type:4};else if(M instanceof F.$ew){const{jsonString:L,referencedBuffers:G}=o(M.value,R);V[U]={type:3,value:O.$ue.fromString(L),buffers:G}}else V[U]={type:1,value:O.$ue.fromString(n(M,R))}}return{type:1,args:V}}return{type:0,args:n(C,R)}}static serializeRequest(C,R,V,U,q){switch(U.type){case 0:return this.b(C,R,V,U.args,q);case 1:return this.c(C,R,V,U.args,q)}}static b(C,R,V,U,q){const M=O.$ue.fromString(V),L=O.$ue.fromString(U);let G=0;G+=p.sizeUInt8(),G+=p.sizeShortString(M),G+=p.sizeLongString(L);const ne=p.alloc(q?2:1,C,G);return ne.writeUInt8(R),ne.writeShortString(M),ne.writeLongString(L),ne.buffer}static deserializeRequestJSONArgs(C){const R=C.readUInt8(),V=C.readShortString(),U=C.readLongString();return{rpcId:R,method:V,args:JSON.parse(U)}}static c(C,R,V,U,q){const M=O.$ue.fromString(V);let L=0;L+=p.sizeUInt8(),L+=p.sizeShortString(M),L+=p.sizeMixedArray(U);const G=p.alloc(q?4:3,C,L);return G.writeUInt8(R),G.writeShortString(M),G.writeMixedArray(U),G.buffer}static deserializeRequestMixedArgs(C){const R=C.readUInt8(),V=C.readShortString(),U=C.readMixedArray(),q=new Array(U.length);for(let M=0,L=U.length;M<L;M++){const G=U[M];typeof G=="string"?q[M]=JSON.parse(G):q[M]=G}return{rpcId:R,method:V,args:q}}static serializeAcknowledged(C){return p.alloc(5,C,0).buffer}static serializeCancel(C){return p.alloc(6,C,0).buffer}static serializeReplyOK(C,R,V){if(typeof R>"u")return this.d(C);if(R instanceof O.$ue)return this.e(C,R);if(R instanceof F.$ew){const{jsonString:U,referencedBuffers:q}=o(R.value,V,!0);return this.g(C,U,q)}else return this.f(C,u(R,V))}static d(C){return p.alloc(7,C,0).buffer}static e(C,R){let V=0;V+=p.sizeVSBuffer(R);const U=p.alloc(8,C,V);return U.writeVSBuffer(R),U.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,R){const V=O.$ue.fromString(R);let U=0;U+=p.sizeLongString(V);const q=p.alloc(9,C,U);return q.writeLongString(V),q.buffer}static g(C,R,V){const U=O.$ue.fromString(R);let q=0;q+=p.sizeUInt32,q+=p.sizeLongString(U);for(const L of V)q+=p.sizeVSBuffer(L);const M=p.alloc(10,C,q);M.writeUInt32(V.length),M.writeLongString(U);for(const L of V)M.writeBuffer(L);return M.buffer}static deserializeReplyOKJSON(C){const R=C.readLongString();return JSON.parse(R)}static deserializeReplyOKJSONWithBuffers(C,R){const V=C.readUInt32(),U=C.readLongString(),q=[];for(let M=0;M<V;++M)q.push(C.readVSBuffer());return new F.$ew(s(U,q,R))}static serializeReplyErr(C,R){const V=R?u(N.$3(R),null):void 0;if(typeof V!="string")return this.h(C);const U=O.$ue.fromString(V);let q=0;q+=p.sizeLongString(U);const M=p.alloc(11,C,q);return M.writeLongString(U),M.buffer}static deserializeReplyErrError(C){const R=C.readLongString();return JSON.parse(R)}static h(C){return p.alloc(12,C,0).buffer}}var g;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(g||(g={}));var S;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(S||(S={}))}),define(Ce[244],Pe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gnc=void 0;const I=function(N){const A=m=>{globalThis.removeEventListener("message",A);const d=m.data;Object.defineProperties(globalThis,{postMessage:{value(k,F){d.postMessage(k,F)}},onmessage:{get(){return d.onmessage},set(k){d.onmessage=k}}}),d.addEventListener("message",k=>{globalThis.dispatchEvent(new MessageEvent("message",{data:k.data,ports:k.ports?[...k.ports]:void 0}))}),d.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(N)};globalThis.addEventListener("message",A)}.toString();class O extends EventTarget{constructor(N,A,m){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const d=`((${I})('${A}'))`,k=new Blob([d],{type:"application/javascript"}),F=URL.createObjectURL(k),E=new MessageChannel,u=F,b={type:"_newWorker",id:u,port:E.port2,url:F,options:m};N(b,[E.port2]),this.postMessage=E.port1.postMessage.bind(E.port1),this.terminate=()=>{N({type:"_terminateWorker",id:u}),URL.revokeObjectURL(F),E.port1.close(),E.port2.close()},Object.defineProperties(this,{onmessage:{get(){return E.port1.onmessage},set(f){E.port1.onmessage=f}},onmessageerror:{get(){return E.port1.onmessageerror},set(f){E.port1.onmessageerror=f}}}),E.port1.addEventListener("messageerror",f=>{const r=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(r)}),E.port1.addEventListener("message",f=>{const r=new MessageEvent("message",{data:f.data});this.dispatchEvent(r)}),E.port1.start()}}e.$gnc=O}),define(Ce[245],Pe([1,0,23,28,12,54,3]),function($e,e,I,O,P,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2J=e.$YJ=void 0,e.$ZJ=F,e.$1J=E,e.$YJ=(0,A.$ii)("notebookDocumentService");const m=["W","X","Y","Z","a","b","c","d","e","f"],d=new RegExp(`^[${m.join("")}]+`),k=7;function F(b){if(b.scheme!==P.Schemas.vscodeNotebookCell)return;const f=b.fragment.indexOf("s");if(f<0)return;const r=parseInt(b.fragment.substring(0,f).replace(d,""),k),o=(0,I.$Ne)(b.fragment.substring(f+1)).toString();if(!isNaN(r))return{handle:r,notebook:b.with({scheme:o,fragment:null})}}function E(b,f){const r=f.toString(k),s=`${r.length<m.length?m[r.length-1]:"z"}${r}s${(0,I.$Oe)(I.$ue.fromString(b.scheme),!0,!0)}`;return b.with({scheme:P.Schemas.vscodeNotebookCell,fragment:s})}class u{constructor(){this.a=new O.$Bc}getNotebook(f){if(f.scheme===P.Schemas.vscodeNotebookCell){const r=F(f);if(r){const o=this.a.get(r.notebook);if(o)return o}}return this.a.get(f)}addNotebookDocument(f){this.a.set(f.uri,f)}removeNotebookDocument(f){this.a.delete(f.uri)}}e.$2J=u,(0,N.$gs)(e.$YJ,u,1)}),define(Ce[83],Pe([1,0,23,35,39,69,12,19,21,33,245]),function($e,e,I,O,P,N,A,m,d,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jK=e.$gK=e.CellStatusbarAlignment=e.$fK=e.NotebookEditorPriority=e.$cK=e.$bK=e.$_J=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$$J=e.$0J=e.$9J=e.$8J=e.CellKind=e.$7J=e.$6J=e.$5J=void 0,e.$aK=v,e.$dK=$,e.$eK=w,e.$hK=D,e.$iK=S,e.$5J="workbench.editor.notebook",e.$6J="workbench.editor.notebookTextDiffEditor",e.$7J="workbench.editor.interactive";var E;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(E||(e.CellKind=E={})),e.$8J=["application/json","application/javascript","text/html","image/svg+xml",N.$zs.latex,N.$zs.markdown,"image/png","image/jpeg",N.$zs.text],e.$9J=[N.$zs.latex,N.$zs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",N.$zs.text],e.$0J=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$$J="_notAvailable";var u;(function(G){G[G.Running=1]="Running",G[G.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var b;(function(G){G[G.Unconfirmed=1]="Unconfirmed",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(b||(e.NotebookCellExecutionState=b={}));var f;(function(G){G[G.Unconfirmed=1]="Unconfirmed",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(f||(e.NotebookExecutionState=f={}));var r;(function(G){G[G.WithHardKernelDependency=0]="WithHardKernelDependency",G[G.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",G[G.Pure=2]="Pure",G[G.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var o;(function(G){G.Always="always",G.Never="never",G.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var s;(function(G){G[G.ModelChange=1]="ModelChange",G[G.Move=2]="Move",G[G.ChangeCellLanguage=5]="ChangeCellLanguage",G[G.Initialize=6]="Initialize",G[G.ChangeCellMetadata=7]="ChangeCellMetadata",G[G.Output=8]="Output",G[G.OutputItem=9]="OutputItem",G[G.ChangeCellContent=10]="ChangeCellContent",G[G.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",G[G.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",G[G.ChangeCellMime=13]="ChangeCellMime",G[G.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var n;(function(G){G[G.Handle=0]="Handle",G[G.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(G){G[G.Replace=1]="Replace",G[G.Output=2]="Output",G[G.Metadata=3]="Metadata",G[G.CellLanguage=4]="CellLanguage",G[G.DocumentMetadata=5]="DocumentMetadata",G[G.Move=6]="Move",G[G.OutputItems=7]="OutputItems",G[G.PartialMetadata=8]="PartialMetadata",G[G.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var a;(function(G){G.scheme=A.Schemas.vscodeNotebookCell;function ne(te,be){return(0,F.$1J)(te,be)}G.generate=ne;function he(te){return(0,F.$ZJ)(te)}G.parse=he;function ye(te,be){return te.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${be??""},${te.scheme!==A.Schemas.file?te.scheme:""}`})}G.generateCellOutputUri=ye;function Re(te){if(te.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const be=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(te.fragment);if(!be)return;const oe=be[1]&&be[1]!==""?be[1]:void 0,de=be[2];return{outputId:oe,notebook:te.with({scheme:de||A.Schemas.file,fragment:null})}}G.parseCellOutputUri=Re;function ge(te,be,oe){return G.generate(te,be).with({scheme:oe})}G.generateCellPropertyUri=ge;function ue(te,be){if(te.scheme===be)return G.parse(te.with({scheme:G.scheme}))}G.parseCellPropertyUri=ue})(a||(e.CellUri=a={}));const h=G=>d.$i?G.replace(/\//g,"\\"):G;class t{constructor(ne=[],he=e.$8J){this.e=he,this.d=[...new Set(ne)].map(ye=>({pattern:ye,matches:O.$ck(h(ye))}))}sort(ne){const he=new Map(P.Iterable.map(ne,Re=>[Re,h(Re)]));let ye=[];for(const{matches:Re}of this.d)for(const[ge,ue]of he)if(Re(ue)){ye.push(ge),he.delete(ge);break}return he.size&&(ye=ye.concat([...he.keys()].sort((Re,ge)=>this.e.indexOf(Re)-this.e.indexOf(ge)))),ye}prioritize(ne,he){const ye=this.f(ne);if(ye===-1){this.d.unshift({pattern:ne,matches:O.$ck(h(ne))});return}const Re=new Set(he.map(ue=>this.f(ue,ye)));Re.delete(-1);const ge=Array.from(Re).sort();this.d.splice(ye+1,0,...ge.map(ue=>this.d[ue]));for(let ue=ge.length-1;ue>=0;ue--)this.d.splice(ge[ue],1)}toArray(){return this.d.map(ne=>ne.pattern)}f(ne,he=this.d.length){const ye=h(ne);for(let Re=0;Re<he;Re++)if(this.d[Re].matches(ye))return Re;return-1}}e.$_J=t;function v(G,ne,he,ye=(Re,ge)=>Re===ge){const Re=[];function ge(be,oe,de){if(oe===0&&de.length===0)return;const W=Re[Re.length-1];W&&W.start+W.deleteCount===be?(W.deleteCount+=oe,W.toInsert.push(...de)):Re.push({start:be,deleteCount:oe,toInsert:de})}let ue=0,te=0;for(;;){if(ue===G.length){ge(ue,0,ne.slice(te));break}if(te===ne.length){ge(ue,G.length-ue,[]);break}const be=G[ue],oe=ne[te];if(ye(be,oe)){ue+=1,te+=1;continue}he(oe)?(ge(ue,1,[]),ue+=1):(ge(ue,0,[oe]),te+=1)}return Re}e.$bK=new k.$zj("notebookEditorCursorAtBoundary","none"),e.$cK=new k.$zj("notebookEditorCursorAtLineBoundary","none");var c;(function(G){G.default="default",G.option="option"})(c||(e.NotebookEditorPriority=c={}));function $(G){const ne=G;return!!((typeof ne.include=="string"||O.$dk(ne.include))&&(typeof ne.exclude=="string"||O.$dk(ne.exclude)))}function w(G,ne,he){if(Array.isArray(G.viewType)&&G.viewType.indexOf(ne)>=0||G.viewType===ne)return!0;if(G.filenamePattern){const ye=$(G.filenamePattern)?G.filenamePattern.include:G.filenamePattern,Re=$(G.filenamePattern)?G.filenamePattern.exclude:void 0;if(O.$bk(ye,(0,m.$oc)(he.fsPath).toLowerCase()))return!(Re&&O.$bk(Re,(0,m.$oc)(he.fsPath).toLowerCase()))}return!1}e.$fK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose"};var p;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(p||(e.CellStatusbarAlignment=p={}));class l{static{this.d="notebook/"}static create(ne){return`${l.d}${ne}`}static parse(ne){if(ne.startsWith(l.d))return ne.substring(l.d.length)}}e.$gK=l;function D(G){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(G)}const g=new TextDecoder;function S(G){const ne=[];let he=!1;for(const ue of G)(ne.length===0||he)&&(ne.push(ue),he=!0);let ye=R(ne);const Re=I.$ue.concat(ne.map(ue=>I.$ue.wrap(ue))),ge=L(Re);return ye=ye||ge.byteLength!==Re.byteLength,{data:ge,didCompression:ye}}e.$jK="\x1B[A";const y=e.$jK.split("").map(G=>G.charCodeAt(0)),C=10;function R(G){let ne=!1;return G.forEach((he,ye)=>{if(ye===0||he.length<e.$jK.length)return;const Re=G[ye-1],ge=he.subarray(0,e.$jK.length);if(ge[0]===y[0]&&ge[1]===y[1]&&ge[2]===y[2]){const ue=Re.lastIndexOf(C);if(ue===-1)return;ne=!0,G[ye-1]=Re.subarray(0,ue),G[ye]=he.subarray(e.$jK.length)}}),ne}function V(G){let ne=G;do G=ne,ne=G.replace(/[^\n]\x08/gm,"");while(ne.length<G.length);return G}function U(G){for(G=G.replace(/\r+\n/gm,`
`);G.search(/\r[^$]/g)>-1;){const ne=G.match(/^(.*)\r+/m)[1];let he=G.match(/\r+(.*)$/m)[1];he=he+ne.slice(he.length,ne.length),G=G.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,he)}return G}const q=8,M=13;function L(G){return!G.buffer.includes(q)&&!G.buffer.includes(M)?G:I.$ue.fromString(U(V(g.decode(G.buffer))))}}),define(Ce[7],Pe([1,0,18,14,53,28,69,15,16,2,34,20,43,102,83]),function($e,e,I,O,P,N,A,m,d,k,F,E,u,b,f){"use strict";var r,o,s,n,i,a,h,t,v,c,$,w,p,l,D,g,S;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$tO=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$sO=e.$rO=e.$qO=e.$pO=e.ChatLocation=e.$oO=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$gO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$fO=e.$eO=e.$dO=e.$cO=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$6N=e.$5N=e.$4N=e.$3N=e.$2N=e.$1N=e.$ZN=e.$YN=e.TestRunProfileKind=e.TestResultState=e.$XN=e.$WN=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$VN=e.NotebookVariablesRequestKind=e.$UN=e.$TN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$SN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$RN=e.$QN=e.$PN=e.$ON=e.$NN=e.ColorThemeKind=e.$MN=e.$LN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$KN=e.$JN=e.DebugConsoleMode=e.$IN=e.$HN=e.$GN=e.$FN=e.$EN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$DN=e.$CN=e.FileChangeType=e.$BN=e.NewSymbolNameTag=e.$AN=e.$zN=e.$yN=e.$xN=e.InlineCompletionTriggerKind=e.$wN=e.$vN=e.$uN=e.$tN=e.$sN=e.$rN=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.$kN=e.ConfigurationTarget=e.$jN=e.$iN=e.$hN=e.$gN=e.DocumentPasteTriggerKind=e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$_M=e.ViewBadge=e.ProgressLocation=e.$$M=e.$0M=e.TaskScope=e.ShellQuoting=e.$9M=e.$8M=e.$7M=e.TaskPanelKind=e.TaskRevealKind=e.$6M=e.TerminalLocation=e.$5M=e.$4M=e.$3M=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$2M=e.$1M=e.$ZM=e.$YM=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$WM=e.$VM=e.$UM=e.$TM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$SM=e.$RM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$QM=e.$PM=e.$OM=e.$NM=e.$MM=e.LanguageStatusSeverity=e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.CodeActionTriggerKind=e.$FM=e.$EM=e.SymbolTag=e.SymbolKind=e.$DM=e.$CM=e.DocumentHighlightKind=e.$BM=e.$AM=e.$zM=e.$yM=e.DiagnosticSeverity=e.DiagnosticTag=e.$xM=e.$wM=e.FileEditType=e.$vM=e.$uM=e.$tM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$XM=dt,e.$lN=Q;function y(B){return Object.assign(B,{apply:function(...ie){if(ie.length===0)return Reflect.construct(B,[]);{const De=ie.length===1?[]:ie[1];return Reflect.construct(B,De,ie[0].constructor)}},call:function(...ie){if(ie.length===0)return Reflect.construct(B,[]);{const[De,...Ge]=ie;return Reflect.construct(B,Ge,De.constructor)}}})}var C;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(C||(e.TerminalOutputAnchor=C={}));var R;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(R||(e.TerminalQuickFixType=R={}));let V=r=class{static from(...T){let ie=T;return new r(function(){if(ie){for(const De of ie)De&&typeof De.dispose=="function"&&De.dispose();ie=void 0}})}#e;constructor(T){this.#e=T}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$mM=V,e.$mM=V=r=Je([y],V);let U=o=class{static Min(...T){if(T.length===0)throw new TypeError;let ie=T[0];for(let De=1;De<T.length;De++){const Ge=T[De];Ge.isBefore(ie)&&(ie=Ge)}return ie}static Max(...T){if(T.length===0)throw new TypeError;let ie=T[0];for(let De=1;De<T.length;De++){const Ge=T[De];Ge.isAfter(ie)&&(ie=Ge)}return ie}static isPosition(T){if(!T)return!1;if(T instanceof o)return!0;const{line:ie,character:De}=T;return typeof ie=="number"&&typeof De=="number"}static of(T){if(T instanceof o)return T;if(this.isPosition(T))return new o(T.line,T.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(T,ie){if(T<0)throw(0,O.$7)("line must be non-negative");if(ie<0)throw(0,O.$7)("character must be non-negative");this.c=T,this.e=ie}isBefore(T){return this.c<T.c?!0:T.c<this.c?!1:this.e<T.e}isBeforeOrEqual(T){return this.c<T.c?!0:T.c<this.c?!1:this.e<=T.e}isAfter(T){return!this.isBeforeOrEqual(T)}isAfterOrEqual(T){return!this.isBefore(T)}isEqual(T){return this.c===T.c&&this.e===T.e}compareTo(T){return this.c<T.c?-1:this.c>T.line?1:this.e<T.e?-1:this.e>T.e?1:0}translate(T,ie=0){if(T===null||ie===null)throw(0,O.$7)();let De;return typeof T>"u"?De=0:typeof T=="number"?De=T:(De=typeof T.lineDelta=="number"?T.lineDelta:0,ie=typeof T.characterDelta=="number"?T.characterDelta:0),De===0&&ie===0?this:new o(this.line+De,this.character+ie)}with(T,ie=this.character){if(T===null||ie===null)throw(0,O.$7)();let De;return typeof T>"u"?De=this.line:typeof T=="number"?De=T:(De=typeof T.line=="number"?T.line:this.line,ie=typeof T.character=="number"?T.character:this.character),De===this.line&&ie===this.character?this:new o(De,ie)}toJSON(){return{line:this.line,character:this.character}}};e.$nM=U,e.$nM=U=o=Je([y],U);let q=s=class{static isRange(T){return T instanceof s?!0:T?U.isPosition(T.start)&&U.isPosition(T.end):!1}static of(T){if(T instanceof s)return T;if(this.isRange(T))return new s(T.start,T.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(T,ie,De,Ge){let _e,lt;if(typeof T=="number"&&typeof ie=="number"&&typeof De=="number"&&typeof Ge=="number"?(_e=new U(T,ie),lt=new U(De,Ge)):U.isPosition(T)&&U.isPosition(ie)&&(_e=U.of(T),lt=U.of(ie)),!_e||!lt)throw new Error("Invalid arguments");_e.isBefore(lt)?(this.c=_e,this.e=lt):(this.c=lt,this.e=_e)}contains(T){return s.isRange(T)?this.contains(T.start)&&this.contains(T.end):U.isPosition(T)?!(U.of(T).isBefore(this.c)||this.e.isBefore(T)):!1}isEqual(T){return this.c.isEqual(T.c)&&this.e.isEqual(T.e)}intersection(T){const ie=U.Max(T.start,this.c),De=U.Min(T.end,this.e);if(!ie.isAfter(De))return new s(ie,De)}union(T){if(this.contains(T))return this;if(T.contains(this))return T;const ie=U.Min(T.start,this.c),De=U.Max(T.end,this.end);return new s(ie,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(T,ie=this.end){if(T===null||ie===null)throw(0,O.$7)();let De;return T?U.isPosition(T)?De=T:(De=T.start||this.start,ie=T.end||this.end):De=this.start,De.isEqual(this.c)&&ie.isEqual(this.end)?this:new s(De,ie)}toJSON(){return[this.start,this.end]}};e.$oM=q,e.$oM=q=s=Je([y],q);let M=n=class extends q{static isSelection(T){return T instanceof n?!0:T?q.isRange(T)&&U.isPosition(T.anchor)&&U.isPosition(T.active)&&typeof T.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(T,ie,De,Ge){let _e,lt;if(typeof T=="number"&&typeof ie=="number"&&typeof De=="number"&&typeof Ge=="number"?(_e=new U(T,ie),lt=new U(De,Ge)):U.isPosition(T)&&U.isPosition(ie)&&(_e=U.of(T),lt=U.of(ie)),!_e||!lt)throw new Error("Invalid arguments");super(_e,lt),this.f=_e,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$pM=M,e.$pM=M=n=Je([y],M);const L=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,O.$7)("connectionToken")};class G{static isResolvedAuthority(T){return T&&typeof T=="object"&&typeof T.host=="string"&&typeof T.port=="number"&&(T.connectionToken===void 0||typeof T.connectionToken=="string")}constructor(T,ie,De){if(typeof T!="string"||T.length===0)throw(0,O.$7)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,O.$7)("port");typeof De<"u"&&L(De),this.host=T,this.port=Math.round(ie),this.connectionToken=De}}e.$qM=G;class ne{static isManagedResolvedAuthority(T){return T&&typeof T=="object"&&typeof T.makeConnection=="function"&&(T.connectionToken===void 0||typeof T.connectionToken=="string")}constructor(T,ie){this.makeConnection=T,this.connectionToken=ie,typeof ie<"u"&&L(ie)}}e.$rM=ne;class he extends Error{static NotAvailable(T,ie){return new he(T,b.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(T){return new he(T,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(T,ie=b.RemoteAuthorityResolverErrorCode.Unknown,De){super(T),this._message=T,this._code=ie,this._detail=De,Object.setPrototypeOf(this,he.prototype)}}e.$sM=he;var ye;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(ye||(e.EndOfLine=ye={}));var Re;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(Re||(e.EnvironmentVariableMutatorType=Re={}));let ge=i=class{static isTextEdit(T){return T instanceof i?!0:T?q.isRange(T)&&typeof T.newText=="string":!1}static replace(T,ie){return new i(T,ie)}static insert(T,ie){return i.replace(new q(T,T),ie)}static delete(T){return i.replace(T,"")}static setEndOfLine(T){const ie=new i(new q(new U(0,0),new U(0,0)),"");return ie.newEol=T,ie}get range(){return this.c}set range(T){if(T&&!q.isRange(T))throw(0,O.$7)("range");this.c=T}get newText(){return this.e||""}set newText(T){if(T&&typeof T!="string")throw(0,O.$7)("newText");this.e=T}get newEol(){return this.f}set newEol(T){if(T&&typeof T!="number")throw(0,O.$7)("newEol");this.f=T}constructor(T,ie){this.c=T,this.e=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$tM=ge,e.$tM=ge=i=Je([y],ge);let ue=a=class{static isNotebookCellEdit(T){return T instanceof a?!0:T?Le.isNotebookRange(T)&&Array.isArray(T.newCells):!1}static replaceCells(T,ie){return new a(T,ie)}static insertCells(T,ie){return new a(new Le(T,T),ie)}static deleteCells(T){return new a(T,[])}static updateCellMetadata(T,ie){const De=new a(new Le(T,T),[]);return De.newCellMetadata=ie,De}static updateNotebookMetadata(T){const ie=new a(new Le(0,0),[]);return ie.newNotebookMetadata=T,ie}constructor(T,ie){this.range=T,this.newCells=ie}};e.$uM=ue,e.$uM=ue=a=Je([y],ue);class te{static isSnippetTextEdit(T){return T instanceof te?!0:T?q.isRange(T.range)&&de.isSnippetString(T.snippet):!1}static replace(T,ie){return new te(T,ie)}static insert(T,ie){return te.replace(new q(T,T),ie)}constructor(T,ie){this.range=T,this.snippet=ie}}e.$vM=te;var be;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(be||(e.FileEditType=be={}));let oe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(T,ie,De,Ge){this.c.push({_type:1,from:T,to:ie,options:De,metadata:Ge})}createFile(T,ie,De){this.c.push({_type:1,from:void 0,to:T,options:ie,metadata:De})}deleteFile(T,ie,De){this.c.push({_type:1,from:T,to:void 0,options:ie,metadata:De})}e(T,ie,De){this.c.push({_type:3,metadata:De,uri:T,edit:{editType:5,metadata:ie},notebookMetadata:ie})}f(T,ie,De,Ge){const _e=ie.start,lt=ie.end;(_e!==lt||De.length>0)&&this.c.push({_type:5,uri:T,index:_e,count:lt-_e,cells:De,metadata:Ge})}g(T,ie,De,Ge){this.c.push({_type:3,metadata:Ge,uri:T,edit:{editType:3,index:ie,metadata:De}})}replace(T,ie,De,Ge){this.c.push({_type:2,uri:T,edit:new ge(ie,De),metadata:Ge})}insert(T,ie,De,Ge){this.replace(T,new q(ie,ie),De,Ge)}delete(T,ie,De){this.replace(T,ie,"",De)}has(T){return this.c.some(ie=>ie._type===2&&ie.uri.toString()===T.toString())}set(T,ie){if(ie)for(const De of ie){if(!De)continue;let Ge,_e;Array.isArray(De)?(Ge=De[0],_e=De[1]):Ge=De,ue.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(T,Ge.range.start,Ge.newCellMetadata,_e):Ge.newNotebookMetadata?this.e(T,Ge.newNotebookMetadata,_e):this.f(T,Ge.range,Ge.newCells,_e):te.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:T,range:Ge.range,edit:Ge.snippet,metadata:_e}):this.c.push({_type:2,uri:T,edit:Ge,metadata:_e})}else{for(let De=0;De<this.c.length;De++){const Ge=this.c[De];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===T.toString()&&(this.c[De]=void 0);break}}(0,I.$Ib)(this.c)}}get(T){const ie=[];for(const De of this.c)De._type===2&&De.uri.toString()===T.toString()&&ie.push(De.edit);return ie}entries(){const T=new N.$Bc;for(const ie of this.c)if(ie._type===2){let De=T.get(ie.uri);De||(De=[ie.uri,[]],T.set(ie.uri,De)),De[1].push(ie.edit)}return[...T.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$wM=oe,e.$wM=oe=Je([y],oe);let de=h=class{static isSnippetString(T){return T instanceof h?!0:T?typeof T.value=="string":!1}static c(T){return T.replace(/\$|}|\\/g,"\\$&")}constructor(T){this.e=1,this.value=T||""}appendText(T){return this.value+=h.c(T),this}appendTabstop(T=this.e++){return this.value+="$",this.value+=T,this}appendPlaceholder(T,ie=this.e++){if(typeof T=="function"){const De=new h;De.e=this.e,T(De),this.e=De.e,T=De.value}else T=h.c(T);return this.value+="${",this.value+=ie,this.value+=":",this.value+=T,this.value+="}",this}appendChoice(T,ie=this.e++){const De=T.map(Ge=>Ge.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(T,ie){if(typeof ie=="function"){const De=new h;De.e=this.e,ie(De),this.e=De.e,ie=De.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=T,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};e.$xM=de,e.$xM=de=h=Je([y],de);var W;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(W||(e.DiagnosticTag=W={}));var ee;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(ee||(e.DiagnosticSeverity=ee={}));let ke=t=class{static isLocation(T){return T instanceof t?!0:T?q.isRange(T.range)&&k.URI.isUri(T.uri):!1}constructor(T,ie){if(this.uri=T,ie)if(q.isRange(ie))this.range=q.of(ie);else if(U.isPosition(ie))this.range=new q(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$yM=ke,e.$yM=ke=t=Je([y],ke);let Te=class{static is(T){return T?typeof T.message=="string"&&T.location&&q.isRange(T.location.range)&&k.URI.isUri(T.location.uri):!1}constructor(T,ie){this.location=T,this.message=ie}static isEqual(T,ie){return T===ie?!0:!T||!ie?!1:T.message===ie.message&&T.location.range.isEqual(ie.location.range)&&T.location.uri.toString()===ie.location.uri.toString()}};e.$zM=Te,e.$zM=Te=Je([y],Te);let Se=class{constructor(T,ie,De=ee.Error){if(!q.isRange(T))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=T,this.message=ie,this.severity=De}toJSON(){return{severity:ee[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(T,ie){return T===ie?!0:!T||!ie?!1:T.message===ie.message&&T.severity===ie.severity&&T.code===ie.code&&T.severity===ie.severity&&T.source===ie.source&&T.range.isEqual(ie.range)&&(0,I.$ub)(T.tags,ie.tags)&&(0,I.$ub)(T.relatedInformation,ie.relatedInformation,Te.isEqual)}};e.$AM=Se,e.$AM=Se=Je([y],Se);let ve=class{constructor(T,ie){if(!T)throw new Error("Illegal argument, contents must be defined");Array.isArray(T)?this.contents=T:this.contents=[T],this.range=ie}};e.$BM=ve,e.$BM=ve=Je([y],ve);var me;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(me||(e.DocumentHighlightKind=me={}));let J=class{constructor(T,ie=me.Text){this.range=T,this.kind=ie}toJSON(){return{range:this.range,kind:me[this.kind]}}};e.$CM=J,e.$CM=J=Je([y],J);let Y=class{constructor(T,ie){this.uri=T,this.highlights=ie}toJSON(){return{uri:this.uri,highlights:this.highlights.map(T=>T.toJSON())}}};e.$DM=Y,e.$DM=Y=Je([y],Y);var ce;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(ce||(e.SymbolKind=ce={}));var fe;(function(B){B[B.Deprecated=1]="Deprecated"})(fe||(e.SymbolTag=fe={}));let Ne=v=class{static validate(T){if(!T.name)throw new Error("name must not be falsy")}constructor(T,ie,De,Ge,_e){this.name=T,this.kind=ie,this.containerName=_e,typeof De=="string"&&(this.containerName=De),Ge instanceof ke?this.location=Ge:De instanceof q&&(this.location=new ke(Ge,De)),v.validate(this)}toJSON(){return{name:this.name,kind:ce[this.kind],location:this.location,containerName:this.containerName}}};e.$EM=Ne,e.$EM=Ne=v=Je([y],Ne);let le=c=class{static validate(T){if(!T.name)throw new Error("name must not be falsy");if(!T.range.contains(T.selectionRange))throw new Error("selectionRange must be contained in fullRange");T.children?.forEach(c.validate)}constructor(T,ie,De,Ge,_e){this.name=T,this.detail=ie,this.kind=De,this.range=Ge,this.selectionRange=_e,this.children=[],c.validate(this)}};e.$FM=le,e.$FM=le=c=Je([y],le);var Ie;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Ie||(e.CodeActionTriggerKind=Ie={}));let Ae=class{constructor(T,ie){this.title=T,this.kind=ie}};e.$GM=Ae,e.$GM=Ae=Je([y],Ae);let je=class{static{$=this}static{this.c="."}constructor(T){this.value=T}append(T){return new $(this.value?this.value+$.c+T:T)}intersects(T){return this.contains(T)||T.contains(this)}contains(T){return this.value===T.value||T.value.startsWith(this.value+$.c)}};e.$HM=je,e.$HM=je=$=Je([y],je),je.Empty=new je(""),je.QuickFix=je.Empty.append("quickfix"),je.Refactor=je.Empty.append("refactor"),je.RefactorExtract=je.Refactor.append("extract"),je.RefactorInline=je.Refactor.append("inline"),je.RefactorMove=je.Refactor.append("move"),je.RefactorRewrite=je.Refactor.append("rewrite"),je.Source=je.Empty.append("source"),je.SourceOrganizeImports=je.Source.append("organizeImports"),je.SourceFixAll=je.Source.append("fixAll"),je.Notebook=je.Empty.append("notebook");let z=class{constructor(T,ie){if(this.range=T,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$IM=z,e.$IM=z=Je([y],z);class j{constructor(T,ie,De,Ge,_e,lt){this.kind=T,this.name=ie,this.detail=De,this.uri=Ge,this.range=_e,this.selectionRange=lt}}e.$JM=j;class K{constructor(T,ie){this.fromRanges=ie,this.from=T}}e.$KM=K;class H{constructor(T,ie){this.fromRanges=ie,this.to=T}}e.$LM=H;var _;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(_||(e.LanguageStatusSeverity=_={}));let re=class{constructor(T,ie){this.range=T,this.command=ie}get isResolved(){return!!this.command}};e.$MM=re,e.$MM=re=Je([y],re);let Fe=w=class{#e;static isMarkdownString(T){return T instanceof w?!0:T&&T.appendCodeblock&&T.appendMarkdown&&T.appendText&&T.value!==void 0}constructor(T,ie=!1){this.#e=new P.$Fk(T,{supportThemeIcons:ie})}get value(){return this.#e.value}set value(T){this.#e.value=T}get isTrusted(){return this.#e.isTrusted}set isTrusted(T){this.#e.isTrusted=T}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(T){this.#e.supportThemeIcons=T}get supportHtml(){return this.#e.supportHtml}set supportHtml(T){this.#e.supportHtml=T}get baseUri(){return this.#e.baseUri}set baseUri(T){this.#e.baseUri=T}appendText(T){return this.#e.appendText(T),this}appendMarkdown(T){return this.#e.appendMarkdown(T),this}appendCodeblock(T,ie){return this.#e.appendCodeblock(ie??"",T),this}};e.$NM=Fe,e.$NM=Fe=w=Je([y],Fe);let Ve=class{constructor(T,ie){this.label=T,this.documentation=ie}};e.$OM=Ve,e.$OM=Ve=Je([y],Ve);let Qe=class{constructor(T,ie){this.label=T,this.documentation=ie,this.parameters=[]}};e.$PM=Qe,e.$PM=Qe=Je([y],Qe);let xe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$QM=xe,e.$QM=xe=Je([y],xe);var tt;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(tt||(e.SignatureHelpTriggerKind=tt={}));var at;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(at||(e.InlayHintKind=at={}));let it=class{constructor(T){this.value=T}};e.$RM=it,e.$RM=it=Je([y],it);let nt=class{constructor(T,ie,De){this.position=T,this.label=ie,this.kind=De}};e.$SM=nt,e.$SM=nt=Je([y],nt);var ct;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ct||(e.CompletionTriggerKind=ct={}));var ft;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(ft||(e.CompletionItemKind=ft={}));var Ue;(function(B){B[B.Deprecated=1]="Deprecated"})(Ue||(e.CompletionItemTag=Ue={}));let ot=class{constructor(T,ie){this.label=T,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&ft[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$TM=ot,e.$TM=ot=Je([y],ot);let X=class{constructor(T=[],ie=!1){this.items=T,this.isIncomplete=ie}};e.$UM=X,e.$UM=X=Je([y],X);let Z=class{constructor(T,ie,De){this.insertText=T,this.range=ie,this.command=De}};e.$VM=Z,e.$VM=Z=Je([y],Z);let pe=class{constructor(T){this.commands=void 0,this.suppressSuggestions=void 0,this.items=T}};e.$WM=pe,e.$WM=pe=Je([y],pe);var qe;(function(B){B[B.Unknown=0]="Unknown",B[B.Word=1]="Word",B[B.Line=2]="Line",B[B.Suggest=3]="Suggest"})(qe||(e.PartialAcceptTriggerKind=qe={}));var Ze;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(Ze||(e.ViewColumn=Ze={}));var Me;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Me||(e.StatusBarAlignment=Me={}));function dt(B,T){return`${E.$Dm.toKey(B)}.${T}`}var Pt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var zt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(zt||(e.TextDocumentSaveReason=zt={}));var xt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(xt||(e.TextEditorRevealType=xt={}));var Jt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Jt||(e.TextEditorSelectionChangeKind=Jt={}));var _t;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(_t||(e.TextDocumentChangeReason=_t={}));var Et;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Et||(e.DecorationRangeBehavior=Et={})),function(B){function T(ie){switch(ie){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=T}(Jt||(e.TextEditorSelectionChangeKind=Jt={}));var Qt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Qt||(e.SyntaxTokenType=Qt={})),function(B){function T(ie){switch(ie){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=T}(Qt||(e.SyntaxTokenType=Qt={}));let Vt=class{constructor(T,ie){if(ie&&!k.URI.isUri(ie))throw(0,O.$7)("target");if(!q.isRange(T)||T.isEmpty)throw(0,O.$7)("range");this.range=T,this.target=ie}};e.$YM=Vt,e.$YM=Vt=Je([y],Vt);let ai=class{constructor(T,ie,De,Ge){this.red=T,this.green=ie,this.blue=De,this.alpha=Ge}};e.$ZM=ai,e.$ZM=ai=Je([y],ai);let Ye=class{constructor(T,ie){if(ie&&!(ie instanceof ai))throw(0,O.$7)("color");if(!q.isRange(T)||T.isEmpty)throw(0,O.$7)("range");this.range=T,this.color=ie}};e.$1M=Ye,e.$1M=Ye=Je([y],Ye);let ei=class{constructor(T){if(!T||typeof T!="string")throw(0,O.$7)("label");this.label=T}};e.$2M=ei,e.$2M=ei=Je([y],ei);var ti;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(ti||(e.ColorFormat=ti={}));var ht;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(ht||(e.SourceControlInputBoxValidationType=ht={}));var vt;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(vt||(e.TerminalExitReason=vt={}));class si{constructor(T,ie,De){if(this.startIndex=T,this.length=ie,this.tooltip=De,typeof T!="number"||T<0)throw(0,O.$7)("startIndex");if(typeof ie!="number"||ie<1)throw(0,O.$7)("length");if(De!==void 0&&typeof De!="string")throw(0,O.$7)("tooltip")}}e.$3M=si;class ii{constructor(T){this.uri=T}}e.$4M=ii;class Ft{constructor(T){this.terminalCommand=T}}e.$5M=Ft;var mt;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(mt||(e.TerminalLocation=mt={}));class Mt{constructor(T){if(this.options=T,typeof T!="object")throw(0,O.$7)("options")}}e.$6M=Mt;var Wt;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Wt||(e.TaskRevealKind=Wt={}));var Zt;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(Zt||(e.TaskPanelKind=Zt={}));let Ke=class{static{p=this}static{this.Clean=new p("clean","Clean")}static{this.Build=new p("build","Build")}static{this.Rebuild=new p("rebuild","Rebuild")}static{this.Test=new p("test","Test")}static from(T){switch(T){case"clean":return p.Clean;case"build":return p.Build;case"rebuild":return p.Rebuild;case"test":return p.Test;default:return}}constructor(T,ie){if(this.label=ie,typeof T!="string"||typeof ie!="string")throw(0,O.$7)("name");this.c=T}get id(){return this.c}};e.$7M=Ke,e.$7M=Ke=p=Je([y],Ke);function Xt(B){let T="";for(let ie=0;ie<B.length;ie++)T+=B[ie].replace(/,/g,",,")+",";return T}let jt=class{constructor(T,ie,De){if(typeof T!="string")throw(0,O.$7)("process");this.e=[],this.c=T,ie!==void 0&&(Array.isArray(ie)?(this.e=ie,this.f=De):this.f=ie)}get process(){return this.c}set process(T){if(typeof T!="string")throw(0,O.$7)("process");this.c=T}get args(){return this.e}set args(T){Array.isArray(T)||(T=[]),this.e=T}get options(){return this.f}set options(T){this.f=T}computeId(){const T=[];if(T.push("process"),this.c!==void 0&&T.push(this.c),this.e&&this.e.length>0)for(const ie of this.e)T.push(ie);return Xt(T)}};e.$8M=jt,e.$8M=jt=Je([y],jt);let Ut=class{constructor(T,ie,De){if(this.f=[],Array.isArray(ie)){if(!T)throw(0,O.$7)("command can't be undefined or null");if(typeof T!="string"&&typeof T.value!="string")throw(0,O.$7)("command");this.e=T,this.f=ie,this.g=De}else{if(typeof T!="string")throw(0,O.$7)("commandLine");this.c=T,this.g=ie}}get commandLine(){return this.c}set commandLine(T){if(typeof T!="string")throw(0,O.$7)("commandLine");this.c=T}get command(){return this.e?this.e:""}set command(T){if(typeof T!="string"&&typeof T.value!="string")throw(0,O.$7)("command");this.e=T}get args(){return this.f}set args(T){this.f=T||[]}get options(){return this.g}set options(T){this.g=T}computeId(){const T=[];if(T.push("shell"),this.c!==void 0&&T.push(this.c),this.e!==void 0&&T.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ie of this.f)T.push(typeof ie=="string"?ie:ie.value);return Xt(T)}};e.$9M=Ut,e.$9M=Ut=Je([y],Ut);var $t;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})($t||(e.ShellQuoting=$t={}));var Tt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Tt||(e.TaskScope=Tt={}));class Rt{constructor(T){this.c=T}computeId(){return"customExecution"+(0,F.$Eg)()}set callback(T){this.c=T}get callback(){return this.c}}e.$0M=Rt;let Lt=class{static{l=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(T,ie,De,Ge,_e,lt){this.k=!1,this.l=this.definition=T;let gt;typeof ie=="string"?(this.o=this.name=ie,this.w=this.source=De,this.execution=Ge,gt=_e,this.k=!0):ie===Tt.Global||ie===Tt.Workspace?(this.target=ie,this.o=this.name=De,this.w=this.source=Ge,this.execution=_e,gt=lt):(this.target=ie,this.o=this.name=De,this.w=this.source=Ge,this.execution=_e,gt=lt),typeof gt=="string"?(this.r=[gt],this.t=!0):Array.isArray(gt)?(this.r=gt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(T){this.j=T}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof jt?this.l={type:l.e,id:this.q.computeId()}:this.q instanceof Ut?this.l={type:l.f,id:this.q.computeId()}:this.q instanceof Rt?this.l={type:l.c,id:this.q.computeId()}:this.l={type:l.g,id:(0,F.$Eg)()}}get definition(){return this.l}set definition(T){if(T==null)throw(0,O.$7)("Kind can't be undefined or null");this.B(),this.l=T}get scope(){return this.m}set target(T){this.B(),this.m=T}get name(){return this.o}set name(T){if(typeof T!="string")throw(0,O.$7)("name");this.B(),this.o=T}get execution(){return this.q}set execution(T){T===null&&(T=void 0),this.B(),this.q=T;const ie=this.l.type;(l.g===ie||l.e===ie||l.f===ie||l.c===ie)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(T){if(Array.isArray(T))this.B(),this.r=T,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(T){T!==!0&&T!==!1&&(T=!1),this.B(),this.u=T}get source(){return this.w}set source(T){if(typeof T!="string"||T.length===0)throw(0,O.$7)("source must be a string of length > 0");this.B(),this.w=T}get group(){return this.x}set group(T){T===null&&(T=void 0),this.B(),this.x=T}get detail(){return this.A}set detail(T){T===null&&(T=void 0),this.A=T}get presentationOptions(){return this.y}set presentationOptions(T){T==null&&(T=Object.create(null)),this.B(),this.y=T}get runOptions(){return this.z}set runOptions(T){T==null&&(T=Object.create(null)),this.B(),this.z=T}};e.$$M=Lt,e.$$M=Lt=l=Je([y],Lt);var ni;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(ni||(e.ProgressLocation=ni={}));var oi;(function(B){function T(ie){const De=ie;return(0,d.$Zf)(De.value)?De.tooltip&&!(0,d.$Vf)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}B.isViewBadge=T})(oi||(e.ViewBadge=oi={}));let qt=D=class{static isTreeItem(T,ie){const De=T;if(De.checkboxState!==void 0){const Ge=(0,d.$Zf)(De.checkboxState)?De.checkboxState:(0,d.$Xf)(De.checkboxState)&&(0,d.$Zf)(De.checkboxState.state)?De.checkboxState.state:void 0,_e=!(0,d.$Zf)(De.checkboxState)&&(0,d.$Xf)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==Dt.Checked&&Ge!==Dt.Unchecked||_e!==void 0&&!(0,d.$Vf)(_e))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(T instanceof D)return!0;if(De.label!==void 0&&!(0,d.$Vf)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,d.$Vf)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,d.$Vf)(De.iconPath)&&!k.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,d.$Vf)(De.iconPath.id))){const Ge=De.iconPath;if(!Ge||!(0,d.$Vf)(Ge.light)&&!k.URI.isUri(Ge.light)&&!(0,d.$Vf)(Ge.dark)&&!k.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,d.$Vf)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!k.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,d.$Vf)(De.tooltip)&&!(De.tooltip instanceof Fe)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<It.None&&De.collapsibleState>It.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,d.$Vf)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(T,ie=It.None){this.collapsibleState=ie,k.URI.isUri(T)?this.resourceUri=T:this.label=T}};e.$_M=qt,e.$_M=qt=D=Je([y],qt);var It;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(It||(e.TreeItemCollapsibleState=It={}));var Dt;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Dt||(e.TreeItemCheckboxState=Dt={}));let Ht=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(T){this.value=T}};e.$aN=Ht,e.$aN=Ht=Je([y],Ht);class Ct extends Ht{}e.$bN=Ct;class wt extends Ct{#e;constructor(T){super(""),this.#e=T}asFile(){return this.#e}}e.$cN=wt;class St{constructor(T,ie,De,Ge){this.name=T,this.uri=ie,this._itemId=De,this.c=Ge}data(){return this.c()}}e.$dN=St;let kt=class{#e=new Map;constructor(T){for(const[ie,De]of T??[]){const Ge=this.#e.get(this.#t(ie));Ge?Ge.push(De):this.#e.set(this.#t(ie),[De])}}get(T){return this.#e.get(this.#t(T))?.[0]}set(T,ie){this.#e.set(this.#t(T),[ie])}forEach(T,ie){for(const[De,Ge]of this.#e)for(const _e of Ge)T.call(ie,_e,De,this)}*[Symbol.iterator](){for(const[T,ie]of this.#e)for(const De of ie)yield[T,De]}#t(T){return T.toLowerCase()}};e.$eN=kt,e.$eN=kt=Je([y],kt);let ui=class{constructor(T,ie,De){this.insertText=T,this.title=ie,this.kind=De}};e.$fN=ui,e.$fN=ui=Je([y],ui);var ri;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(ri||(e.DocumentPasteTriggerKind=ri={}));class li{static{this.c="."}constructor(T){this.value=T}append(...T){return new li((this.value?[this.value,...T]:T).join(li.c))}intersects(T){return this.contains(T)||T.contains(this)}contains(T){return this.value===T.value||T.value.startsWith(this.value+li.c)}}e.$gN=li,li.Empty=new li("");let di=class{constructor(T,ie,De){this.title=ie,this.insertText=T,this.kind=De}};e.$hN=di,e.$hN=di=Je([y],di);let Yt=class{constructor(T,ie){this.id=T,this.color=ie}static isThemeIcon(T){return typeof T.id!="string"?(console.log("INVALID ThemeIcon, invalid id",T.id),!1):!0}};e.$iN=Yt,e.$iN=Yt=Je([y],Yt),Yt.File=new Yt("file"),Yt.Folder=new Yt("folder");let At=class{constructor(T){this.id=T}};e.$jN=At,e.$jN=At=Je([y],At);var we;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(we||(e.ConfigurationTarget=we={}));let Oe=class{get base(){return this.c}set base(T){this.c=T,this.e=k.URI.file(T)}get baseUri(){return this.e}set baseUri(T){this.e=T,this.c=T.fsPath}constructor(T,ie){if(typeof T!="string"&&(!T||!k.URI.isUri(T)&&!k.URI.isUri(T.uri)))throw(0,O.$7)("base");if(typeof ie!="string")throw(0,O.$7)("pattern");typeof T=="string"?this.baseUri=k.URI.file(T):k.URI.isUri(T)?this.baseUri=T:this.baseUri=T.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$kN=Oe,e.$kN=Oe=Je([y],Oe);const se=new WeakMap;function Q(B,T){se.set(B,T)}let Ee=class{constructor(T,ie,De,Ge,_e){this.enabled=typeof T=="boolean"?T:!0,typeof ie=="string"&&(this.condition=ie),typeof De=="string"&&(this.hitCondition=De),typeof Ge=="string"&&(this.logMessage=Ge),typeof _e=="string"&&(this.mode=_e)}get id(){return this.c||(this.c=se.get(this)??(0,F.$Eg)()),this.c}};e.$mN=Ee,e.$mN=Ee=Je([y],Ee);let Be=class extends Ee{constructor(T,ie,De,Ge,_e,lt){if(super(ie,De,Ge,_e,lt),T===null)throw(0,O.$7)("location");this.location=T}};e.$nN=Be,e.$nN=Be=Je([y],Be);let Xe=class extends Ee{constructor(T,ie,De,Ge,_e,lt){super(ie,De,Ge,_e,lt),this.functionName=T}};e.$oN=Xe,e.$oN=Xe=Je([y],Xe);let He=class extends Ee{constructor(T,ie,De,Ge,_e,lt,gt,Gt){if(super(Ge,_e,lt,gt,Gt),!ie)throw(0,O.$7)("dataId");this.label=T,this.dataId=ie,this.canPersist=De}};e.$pN=He,e.$pN=He=Je([y],He);let rt=class{constructor(T,ie,De){this.command=T,this.args=ie||[],this.options=De}};e.$qN=rt,e.$qN=rt=Je([y],rt);let yt=class{constructor(T,ie){this.port=T,this.host=ie}};e.$rN=yt,e.$rN=yt=Je([y],yt);let Kt=class{constructor(T){this.path=T}};e.$sN=Kt,e.$sN=Kt=Je([y],Kt);let Bt=class{constructor(T){this.implementation=T}};e.$tN=Bt,e.$tN=Bt=Je([y],Bt);class Ot{constructor(T,ie,De){this.session=T,this.threadId=ie,this.frameId=De}}e.$uN=Ot;class ut{constructor(T,ie){this.session=T,this.threadId=ie}}e.$vN=ut;let Ci=class{constructor(T,ie){this.range=T,this.expression=ie}};e.$wN=Ci,e.$wN=Ci=Je([y],Ci);var gi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(gi||(e.InlineCompletionTriggerKind=gi={}));let $i=class{constructor(T,ie){this.range=T,this.text=ie}};e.$xN=$i,e.$xN=$i=Je([y],$i);let wi=class{constructor(T,ie,De=!0){this.range=T,this.variableName=ie,this.caseSensitiveLookup=De}};e.$yN=wi,e.$yN=wi=Je([y],wi);let Pi=class{constructor(T,ie){this.range=T,this.expression=ie}};e.$zN=Pi,e.$zN=Pi=Je([y],Pi);let Mi=class{constructor(T,ie){this.frameId=T,this.stoppedLocation=ie}};e.$AN=Mi,e.$AN=Mi=Je([y],Mi);var Vi;(function(B){B[B.AIGenerated=1]="AIGenerated"})(Vi||(e.NewSymbolNameTag=Vi={}));class Wi{constructor(T,ie){this.newSymbolName=T,this.tags=ie}}e.$BN=Wi;var qi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(qi||(e.FileChangeType=qi={}));let yi=g=class extends Error{static FileExists(T){return new g(T,u.FileSystemProviderErrorCode.FileExists,g.FileExists)}static FileNotFound(T){return new g(T,u.FileSystemProviderErrorCode.FileNotFound,g.FileNotFound)}static FileNotADirectory(T){return new g(T,u.FileSystemProviderErrorCode.FileNotADirectory,g.FileNotADirectory)}static FileIsADirectory(T){return new g(T,u.FileSystemProviderErrorCode.FileIsADirectory,g.FileIsADirectory)}static NoPermissions(T){return new g(T,u.FileSystemProviderErrorCode.NoPermissions,g.NoPermissions)}static Unavailable(T){return new g(T,u.FileSystemProviderErrorCode.Unavailable,g.Unavailable)}constructor(T,ie=u.FileSystemProviderErrorCode.Unknown,De){super(k.URI.isUri(T)?T.toString(!0):T),this.code=De?.name??"Unknown",(0,u.$4k)(this,ie),Object.setPrototypeOf(this,g.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$CN=yi,e.$CN=yi=g=Je([y],yi);let Ri=class{constructor(T,ie,De){this.start=T,this.end=ie,this.kind=De}};e.$DN=Ri,e.$DN=Ri=Je([y],Ri);var ki;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(ki||(e.FoldingRangeKind=ki={}));var Ei;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Ei||(e.CommentThreadCollapsibleState=Ei={}));var Hi;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Hi||(e.CommentMode=Hi={}));var Ki;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Ki||(e.CommentState=Ki={}));var vi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(vi||(e.CommentThreadState=vi={}));var Gi;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(Gi||(e.CommentThreadApplicability=Gi={}));class gn{constructor(T,ie=[]){this.tokenTypes=T,this.tokenModifiers=ie}}e.$EN=gn;function mn(B){return typeof B>"u"||(0,d.$Wf)(B)}class Ai{constructor(T){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,T){this.m=!0;for(let ie=0,De=T.tokenTypes.length;ie<De;ie++)this.k.set(T.tokenTypes[ie],ie);for(let ie=0,De=T.tokenModifiers.length;ie<De;ie++)this.l.set(T.tokenModifiers[ie],ie)}}push(T,ie,De,Ge,_e){if(typeof T=="number"&&typeof ie=="number"&&typeof De=="number"&&typeof Ge=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.q(T,ie,De,Ge,_e);if(q.isRange(T)&&typeof ie=="string"&&mn(De))return this.o(T,ie,De);throw(0,O.$7)()}o(T,ie,De){if(!this.m)throw new Error("Legend must be provided in constructor");if(T.start.line!==T.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ie))throw new Error("`tokenType` is not in the provided legend");const Ge=T.start.line,_e=T.start.character,lt=T.end.character-T.start.character,gt=this.k.get(ie);let Gt=0;if(De)for(const hi of De){if(!this.l.has(hi))throw new Error("`tokenModifier` is not in the provided legend");const fi=this.l.get(hi);Gt|=1<<fi>>>0}this.q(Ge,_e,lt,gt,Gt)}q(T,ie,De,Ge,_e){if(this.f&&(T<this.c||T===this.c&&ie<this.e)){this.f=!1;const Gt=this.g.length/5|0;let hi=0,fi=0;for(let mi=0;mi<Gt;mi++){let pi=this.g[5*mi],Ui=this.g[5*mi+1];pi===0?(pi=hi,Ui+=fi):pi+=hi,this.g[5*mi]=pi,this.g[5*mi+1]=Ui,hi=pi,fi=Ui}}let lt=T,gt=ie;this.f&&this.j>0&&(lt-=this.c,lt===0&&(gt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=gt,this.g[this.j++]=De,this.g[this.j++]=Ge,this.g[this.j++]=_e,this.c=T,this.e=ie}static r(T){const ie=[],De=T.length/5|0;for(let gt=0;gt<De;gt++)ie[gt]=gt;ie.sort((gt,Gt)=>{const hi=T[5*gt],fi=T[5*Gt];if(hi===fi){const mi=T[5*gt+1],pi=T[5*Gt+1];return mi-pi}return hi-fi});const Ge=new Uint32Array(T.length);let _e=0,lt=0;for(let gt=0;gt<De;gt++){const Gt=5*ie[gt],hi=T[Gt+0],fi=T[Gt+1],mi=T[Gt+2],pi=T[Gt+3],Ui=T[Gt+4],Fn=hi-_e,sr=Fn===0?fi-lt:fi,Bi=5*gt;Ge[Bi+0]=Fn,Ge[Bi+1]=sr,Ge[Bi+2]=mi,Ge[Bi+3]=pi,Ge[Bi+4]=Ui,_e=hi,lt=fi}return Ge}build(T){return this.f?new Oi(new Uint32Array(this.g),T):new Oi(Ai.r(this.g),T)}}e.$FN=Ai;class Oi{constructor(T,ie){this.resultId=ie,this.data=T}}e.$GN=Oi;class Ji{constructor(T,ie,De){this.start=T,this.deleteCount=ie,this.data=De}}e.$HN=Ji;class Qi{constructor(T,ie){this.resultId=ie,this.edits=T}}e.$IN=Qi;var Zi;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Zi||(e.DebugConsoleMode=Zi={}));class Xi{constructor(T){this.name=T}}e.$JN=Xi;let Di=class{static{this.Back={iconPath:new Yt("arrow-left")}}constructor(){}};e.$KN=Di,e.$KN=Di=Je([y],Di);var Yi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Yi||(e.QuickPickItemKind=Yi={}));var xi;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(xi||(e.InputBoxValidationSeverity=xi={}));var _i;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(_i||(e.ExtensionKind=_i={}));class $n{static validate(T){if(typeof T.badge=="string"){let ie=(0,m.$vf)(T.badge,0);if(ie<T.badge.length&&(ie+=(0,m.$vf)(T.badge,ie)),T.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}else if(T.badge&&!Yt.isThemeIcon(T.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!T.color&&!T.badge&&!T.tooltip)throw new Error("The decoration is empty");return!0}constructor(T,ie,De){this.badge=T,this.tooltip=ie,this.color=De}}e.$LN=$n;let bi=class{constructor(T){this.kind=T}};e.$MN=bi,e.$MN=bi=Je([y],bi);var Fi;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Fi||(e.ColorThemeKind=Fi={}));class Le{static isNotebookRange(T){return T instanceof Le?!0:T?typeof T.start=="number"&&typeof T.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(T,ie){if(T<0)throw(0,O.$7)("start must be positive");if(ie<0)throw(0,O.$7)("end must be positive");T<=ie?(this.c=T,this.e=ie):(this.c=ie,this.e=T)}with(T){let ie=this.c,De=this.e;return T.start!==void 0&&(ie=T.start),T.end!==void 0&&(De=T.end),ie===this.c&&De===this.e?this:new Le(ie,De)}}e.$NN=Le;class ci{static validate(T){if(typeof T.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof T.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof T.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(T){return Array.isArray(T)&&T.every(ie=>ci.isNotebookCellData(ie))}static isNotebookCellData(T){return!0}constructor(T,ie,De,Ge,_e,lt,gt){this.kind=T,this.value=ie,this.languageId=De,this.mime=Ge,this.outputs=_e??[],this.metadata=lt,this.executionSummary=gt,ci.validate(this)}}e.$ON=ci;class en{constructor(T){this.cells=T}}e.$PN=en;class et{static isNotebookCellOutputItem(T){return T instanceof et?!0:T?typeof T.mime=="string"&&T.data instanceof Uint8Array:!1}static error(T){const ie={name:T.name,message:T.message,stack:T.stack};return et.json(ie,"application/vnd.code.notebook.error")}static stdout(T){return et.text(T,"application/vnd.code.notebook.stdout")}static stderr(T){return et.text(T,"application/vnd.code.notebook.stderr")}static bytes(T,ie="application/octet-stream"){return new et(T,ie)}static#e=new TextEncoder;static text(T,ie=A.$zs.text){const De=et.#e.encode(String(T));return new et(De,ie)}static json(T,ie="text/x-json"){const De=JSON.stringify(T,void 0,"	");return et.text(De,ie)}constructor(T,ie){this.data=T,this.mime=ie;const De=(0,A.$Ds)(ie,!0);if(!De)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$QN=et;class pt{static isNotebookCellOutput(T){return T instanceof pt?!0:!T||typeof T!="object"?!1:typeof T.id=="string"&&Array.isArray(T.items)}static ensureUniqueMimeTypes(T,ie=!1){const De=new Set,Ge=new Set;for(let _e=0;_e<T.length;_e++){const lt=T[_e],gt=(0,A.$Ds)(lt.mime);if(!De.has(gt)||(0,f.$hK)(gt)){De.add(gt);continue}Ge.add(_e),ie&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ge.size===0?T:T.filter((_e,lt)=>!Ge.has(lt))}constructor(T,ie,De){this.items=pt.ensureUniqueMimeTypes(T,!0),typeof ie=="string"?(this.id=ie,this.metadata=De):(this.id=(0,F.$Eg)(),this.metadata=ie??De)}}e.$RN=pt;var tn;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var Ni;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Ni||(e.NotebookCellStatusBarAlignment=Ni={}));var rn;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(rn||(e.NotebookEditorRevealType=rn={}));class Si{constructor(T,ie){this.text=T,this.alignment=ie}}e.$SN=Si;var sn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(sn||(e.NotebookControllerAffinity=sn={}));var on;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(on||(e.NotebookControllerAffinity2=on={}));class pn{constructor(T,ie=[]){this.uri=T,this.provides=(0,I.$3b)(ie)}}e.$TN=pn;class an{constructor(T){this.label=T}}e.$UN=an;var cn;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(cn||(e.NotebookVariablesRequestKind=cn={}));let Ti=class{constructor(T,ie){this.label=T,this.timestamp=ie}};e.$VN=Ti,e.$VN=Ti=Je([y],Ti);var un;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(un||(e.ExtensionMode=un={}));var ln;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(ln||(e.ExtensionRuntime=ln={}));var hn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(hn||(e.StandardTokenType=hn={}));class vn{constructor(T,ie){this.ranges=T,this.wordPattern=ie}}e.$WN=vn;class bn{constructor(T){this.c=T}get autoForwardAction(){return this.c}}e.$XN=bn;var dn;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(dn||(e.TestResultState=dn={}));var fn;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(fn||(e.TestRunProfileKind=fn={}));let Li=class{constructor(T=void 0,ie=void 0,De=void 0,Ge=!1){this.include=T,this.exclude=ie,this.profile=De,this.continuous=Ge}};e.$YN=Li,e.$YN=Li=Je([y],Li);let ji=S=class{static diff(T,ie,De){const Ge=new S(T);return Ge.expectedOutput=ie,Ge.actualOutput=De,Ge}constructor(T){this.message=T}};e.$ZN=ji,e.$ZN=ji=S=Je([y],ji);let x=class{constructor(T){this.id=T}};e.$1N=x,e.$1N=x=Je([y],x);class ae{constructor(T,ie){this.covered=T,this.total=ie}}e.$2N=ae;const ze=B=>{if(B&&B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`)};class st{static fromDetails(T,ie){const De=new ae(0,0),Ge=new ae(0,0),_e=new ae(0,0);for(const gt of ie)if("branches"in gt){De.total+=1,De.covered+=gt.executed?1:0;for(const Gt of gt.branches)Ge.total+=1,Ge.covered+=Gt.executed?1:0}else _e.total+=1,_e.covered+=gt.executed?1:0;const lt=new st(T,De,Ge.total>0?Ge:void 0,_e.total>0?_e:void 0);return lt.detailedCoverage=ie,lt}constructor(T,ie,De,Ge){this.uri=T,this.statementCoverage=ie,this.branchCoverage=De,this.declarationCoverage=Ge,ze(ie),ze(De),ze(Ge)}}e.$3N=st;class bt{get executionCount(){return+this.executed}set executionCount(T){this.executed=T}constructor(T,ie,De=[]){this.executed=T,this.location=ie,this.branches=De}}e.$4N=bt;class Nt{get executionCount(){return+this.executed}set executionCount(T){this.executed=T}constructor(T,ie,De){this.executed=T,this.location=ie,this.label=De}}e.$5N=Nt;class zi{get executionCount(){return+this.executed}set executionCount(T){this.executed=T}constructor(T,ie,De){this.name=T,this.executed=ie,this.location=De}}e.$6N=zi;var wn;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(wn||(e.ExternalUriOpenerPriority=wn={}));var yn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(yn||(e.WorkspaceTrustState=yn={}));var kn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(kn||(e.PortAutoForwardAction=kn={}));class Nn{constructor(T,ie,De,Ge,_e,lt){this.kind=T,this.name=ie,this.detail=De,this.uri=Ge,this.range=_e,this.selectionRange=lt}}e.$7N=Nn;class Tn{constructor(T){this.uri=T}}e.$8N=Tn;class Ln{constructor(T,ie){this.original=T,this.modified=ie}}e.$9N=Ln;class jn{constructor(T,ie,De,Ge){this.base=T,this.input1=ie,this.input2=De,this.result=Ge}}e.$0N=jn;class zn{constructor(T,ie){this.uri=T,this.viewType=ie}}e.$$N=zn;class Un{constructor(T){this.viewType=T}}e.$_N=Un;class Bn{constructor(T,ie){this.uri=T,this.notebookType=ie}}e.$aO=Bn;class Vn{constructor(T,ie,De){this.original=T,this.modified=ie,this.notebookType=De}}e.$bO=Vn;class Wn{constructor(){}}e.$cO=Wn;class qn{constructor(T,ie){this.uri=T,this.inputBoxUri=ie}}e.$dO=qn;class Hn{constructor(T){this.providerId=T}}e.$eO=Hn;class Kn{constructor(T){this.textDiffs=T}}e.$fO=Kn;var En;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(En||(e.InteractiveSessionVoteDirection=En={}));var Dn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(Dn||(e.ChatCopyKind=Dn={}));var Sn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(Sn||(e.ChatVariableLevel=Sn={}));class Gn{constructor(T,ie){this.label=T,this.values=ie}}e.$gO=Gn;var In;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(In||(e.InteractiveEditorResponseFeedbackKind=In={}));var Cn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(Cn||(e.ChatResultFeedbackKind=Cn={}));class Jn{constructor(T){this.value=typeof T=="string"?new Fe(T):T}}e.$hO=Jn;class Qn{constructor(T,ie){this.value=T,this.baseUri=ie}}e.$iO=Qn;class Zn{constructor(T,ie){this.value=T,this.title=ie}}e.$jO=Zn;class Xn{constructor(T){this.value=T}}e.$kO=Xn;class Yn{constructor(T){this.value=T}}e.$lO=Yn;class xn{constructor(T){this.value=T}}e.$mO=xn;class _n{constructor(T,ie,De,Ge){this.prompt=T,this.command=ie,this.variables=De,this.participant=Ge}}e.$nO=_n;class er{constructor(T,ie,De,Ge){this.response=T,this.result=ie,this.participant=De,this.command=Ge}}e.$oO=er;var Pn;(function(B){B[B.Panel=1]="Panel",B[B.Terminal=2]="Terminal",B[B.Notebook=3]="Notebook"})(Pn||(e.ChatLocation=Pn={}));class tr{constructor(T){this.content=T}}e.$pO=tr;class ir{constructor(T,ie){this.content=T,this.name=ie}}e.$qO=ir;class nr{constructor(T){this.content=T}}e.$rO=nr;class Ii extends Error{static NotFound(T){return new Ii(T,Ii.NotFound.name)}static NoPermissions(T){return new Ii(T,Ii.NoPermissions.name)}constructor(T,ie,De){super(T,{cause:De}),this.name="LanguageModelError",this.code=ie??""}}e.$sO=Ii;var Mn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Mn||(e.RelatedInformationType=Mn={}));var Rn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped"})(Rn||(e.SpeechToTextStatus=Rn={}));var An;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(An||(e.KeywordRecognitionStatus=An={}));class rr{constructor(T,ie){this.text=T,this.range=ie}}e.$tO=rr;var On;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(On||(e.InlineEditTriggerKind=On={}))}),define(Ce[246],Pe([1,0,4,7]),function($e,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yic=void 0;class P{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(I.$kM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,m,d){if(this.a.size===0)throw new Error("No related information providers registered");const k=this.a.get(A);if(!k)throw new Error("related information provider not found");return await k.provideRelatedInformation(m,d)??[]}getRelatedInformation(A,m,d){return this.c.$getAiRelatedInformation(m,d)}registerRelatedInformationProvider(A,m,d){const k=this.b;return this.b++,this.a.set(k,d),this.c.$registerAiRelatedInformationProvider(k,m),new O.$mM(()=>{this.c.$unregisterAiRelatedInformationProvider(k),this.a.delete(k)})}}e.$Yic=P}),define(Ce[84],Pe([1,0,5,4,7,20,106,3,17]),function($e,e,I,O,P,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ic=e.$0ic=void 0,e.$0ic=(0,m.$ii)("IExtHostAuthentication");let k=class{constructor(u){this.b=new Map,this.c=new I.$7d,this.onDidChangeSessions=this.c.event,this.d=new F,this.f=new F,this.a=u.getProxy(O.$kM.MainThreadAuthentication)}async getSession(u,b,f,r={}){const o=N.$Dm.toKey(u.identifier),s=[...f].sort().join(" ");return await this.d.getOrCreate(`${o} ${b} ${s}`,async()=>{await this.a.$ensureProvider(b);const n=u.displayName||u.name;return this.a.$getSession(b,f,o,n,r)})}async getSessions(u,b,f){const r=N.$Dm.toKey(u.identifier),o=[...f].sort().join(" ");return await this.f.getOrCreate(`${r} ${o}`,async()=>{await this.a.$ensureProvider(b);const s=u.displayName||u.name;return this.a.$getSessions(b,f,r,s)})}async removeSession(u,b){const f=this.b.get(u);return f?f.provider.removeSession(b):this.a.$removeSession(u,b)}registerAuthenticationProvider(u,b,f,r){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:b,provider:f,options:r??{supportsMultipleAccounts:!1}});const o=f.onDidChangeSessions(s=>this.a.$sendDidChangeSessions(u,s));return this.a.$registerAuthenticationProvider(u,b,r?.supportsMultipleAccounts??!1),new P.$mM(()=>{o.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}$createSession(u,b,f){const r=this.b.get(u);if(r)return Promise.resolve(r.provider.createSession(b,f));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$removeSession(u,b){const f=this.b.get(u);if(f)return Promise.resolve(f.provider.removeSession(b));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$getSessions(u,b){const f=this.b.get(u);if(f)return Promise.resolve(f.provider.getSessions(b));throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,b){return u.startsWith(A.$mL)||this.c.fire({provider:{id:u,label:b}}),Promise.resolve()}};e.$$ic=k,e.$$ic=k=Je([We(0,d.$FO)],k);class F{constructor(){this.a=new Map}getOrCreate(u,b){const f=this.a.get(u);if(f)return f;const r=b().finally(()=>this.a.delete(u));return this.a.set(u,r),r}}}),define(Ce[110],Pe([1,0,2,4,7,3,17,13,18,15,19,22]),function($e,e,I,O,P,N,A,m,d,k,F,E){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$_jc=e.$$jc=void 0;let b=class{static{u=this}static{this.c=0}static{this.d=250}constructor(r,o){this.h=o,this.f=new Map,this.g=r.getProxy(O.$kM.MainThreadDecorations)}registerFileDecorationProvider(r,o){const s=u.c++;this.f.set(s,{provider:r,extensionDescription:o}),this.g.$registerDecorationProvider(s,o.identifier.value);const n=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(s,null);return}const a=(0,d.$3b)(i);if(a.length<=u.d){this.g.$onDidChange(s,a);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,a.length);const h=a.map(c=>({uri:c,rank:(0,k.$1e)(c.path,"/")})),t=(0,d.$zb)(h,(c,$)=>c.rank-$.rank||(0,k.$ef)(c.uri.path,$.uri.path)),v=[];e:for(const c of t){let $;for(const w of c){const p=(0,F.$nc)(w.uri.path);if($!==p&&($=p,v.push(w.uri)>=u.d))break e}}this.g.$onDidChange(s,v)});return new P.$mM(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(r,o,s){if(!this.f.has(r))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:a}=this.f.get(r);return await Promise.all(o.map(async h=>{try{const{uri:t,id:v}=h,c=await Promise.resolve(i.provideFileDecoration(I.URI.revive(t),s));if(!c)return;try{P.$LN.validate(c),c.badge&&typeof c.badge!="string"&&(0,E.$9F)(a,"codiconDecoration"),n[v]=[c.propagate,c.tooltip,c.badge,c.color]}catch($){this.h.warn(`INVALID decoration from extension '${a.identifier.value}': ${$}`)}}catch(t){this.h.error(t)}})),n}};e.$$jc=b,e.$$jc=b=u=Je([We(0,A.$FO),We(1,m.$Oj)],b),e.$_jc=(0,N.$ii)("IExtHostDecorations")}),define(Ce[247],Pe([1,0,14,2,7,4,12,25,15]),function($e,e,I,O,P,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bkc=void 0;class k{static{this.a=0}constructor(E,u,b){this.d=u,this.e=b,this.b=new Map,this.c=E.getProxy(N.$kM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(E,u){if(Object.keys(A.Schemas).indexOf(E)>=0)throw new Error(`scheme '${E}' already registered`);const b=k.a++;this.b.set(b,u),this.c.$registerTextContentProvider(b,E);let f;if(typeof u.onDidChange=="function"){let r;f=u.onDidChange(async o=>{if(o.scheme!==E){this.e.warn(`Provider for scheme '${E}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;r&&await r;const s=this.$provideTextDocumentContent(b,o).then(async n=>{if(!n&&typeof n!="string")return;const i=this.d.getDocument(o);if(!i)return;const a=(0,d.$$e)(n);if(!i.equalLines(a))return this.c.$onVirtualDocumentChange(o,n)}).catch(I.$1).finally(()=>{r===s&&(r=void 0)});r=s})}return new P.$mM(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(E,u){const b=this.b.get(E);return b?Promise.resolve(b.provideTextDocumentContent(O.URI.revive(u),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$bkc=k}),define(Ce[111],Pe([1,0,55,12,15,303,151,7,18]),function($e,e,I,O,P,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JO=e.$IO=void 0,e.$HO=F;const k=new Map;function F(f,r){r?k.set(f,r):k.delete(f)}function E(f){return k.get(f)}class u extends N.$Hv{constructor(r,o,s,n,i,a,h){super(o,s,n,i),this.c=r,this.m=a,this.q=h,this.b=!1}dispose(){(0,I.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,d.$ub)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===O.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(o){return o?r.s(o):r.getText()},get eol(){return r.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(o){return r.t(o)},offsetAt(o){return r.u(o)},positionAt(o){return r.v(o)},validateRange(o){return r.w(o)},validatePosition(o){return r.x(o)},getWordRangeAtPosition(o,s){return r.y(o,s)}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,I.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,I.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const o=this.w(r);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const s=this.g,n=o.start.line,i=o.end.line,a=[];a.push(this.f[n].substring(o.start.character));for(let h=n+1;h<i;h++)a.push(this.f[h]);return a.push(this.f[i].substring(0,o.end.character)),a.join(s)}t(r){let o;if(r instanceof m.$nM?o=r.line:typeof r=="number"&&(o=r),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new b(o,this.f[o],o===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const o=this.j.getIndexOf(r),s=this.f[o.index].length;return new m.$nM(o.index,Math.min(o.remainder,s))}w(r){if(!(r instanceof m.$oM))throw new Error("Invalid argument");const o=this.x(r.start),s=this.x(r.end);return o===r.start&&s===r.end?r:new m.$oM(o.line,o.character,s.line,s.character)}x(r){if(!(r instanceof m.$nM))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:o,character:s}=r,n=!1;if(o<0)o=0,s=0,n=!0;else if(o>=this.f.length)o=this.f.length-1,s=this.f[o].length,n=!0;else{const i=this.f[o].length;s<0?(s=0,n=!0):s>i&&(s=i,n=!0)}return n?new m.$nM(o,s):r}y(r,o){const s=this.x(r);if(!o)o=E(this.m);else if((0,P.$0e)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const n=(0,A.$Rs)(s.character+1,(0,A.$Ps)(o),this.f[s.line],0);if(n)return new m.$oM(s.line,n.startColumn-1,s.line,n.endColumn-1)}}e.$IO=u;class b{constructor(r,o,s){this.a=r,this.b=o,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$oM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$oM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$JO=b}),define(Ce[248],Pe([1,0,4,7]),function($e,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dkc=void 0;class P{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(I.$kM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,m,d){if(this.a.size===0)throw new Error("No embedding vector providers registered");const k=this.a.get(A);if(!k)throw new Error("Embedding vector provider not found");const F=await k.provideEmbeddingVector(m,d);if(!F)throw new Error("Embedding vector provider returned undefined");return F}registerEmbeddingVectorProvider(A,m,d){const k=this.b;return this.b++,this.a.set(k,d),this.c.$registerAiEmbeddingVectorProvider(m,k),new O.$mM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(k),this.a.delete(k)})}}e.$dkc=P}),define(Ce[63],Pe([1,0,4,43,7,23,3,17,44,6,11,24,12]),function($e,e,I,O,P,N,A,m,d,k,F,E,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$rjc=e.$qjc=void 0;let f=b=class{constructor(o,s){this.b=new Map,this.c=new F.$rh,this.a=o.getProxy(I.$kM.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let a;const h=n.b.get(i.scheme);return h?(await n.a.$ensureActivation(i.scheme),a=await h.impl.stat(i)):a=await n.a.$stat(i),{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions===O.FilePermission.Readonly?1:void 0}}catch(a){b.e(a)}},async readDirectory(i){try{const a=n.b.get(i.scheme);return a?(await n.a.$ensureActivation(i.scheme),(await a.impl.readDirectory(i)).slice()):await n.a.$readdir(i)}catch(a){return b.e(a)}},async createDirectory(i){try{const a=n.b.get(i.scheme);return a&&!a.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(a.impl,a.extUri,i)):await n.a.$mkdir(i)}catch(a){return b.e(a)}},async readFile(i){try{const a=n.b.get(i.scheme);return a?(await n.a.$ensureActivation(i.scheme),(await a.impl.readFile(i)).slice()):(await n.a.$readFile(i)).buffer}catch(a){return b.e(a)}},async writeFile(i,a){try{const h=n.b.get(i.scheme);return h&&!h.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(h.impl,h.extUri,h.extUri.dirname(i)),await n.c.queueFor(i,()=>Promise.resolve(h.impl.writeFile(i,a,{create:!0,overwrite:!0})))):await n.a.$writeFile(i,N.$ue.wrap(a))}catch(h){return b.e(h)}},async delete(i,a){try{const h=n.b.get(i.scheme);return h&&!h.isReadonly&&!a?.useTrash?(await n.a.$ensureActivation(i.scheme),await h.impl.delete(i,{recursive:!1,...a})):await n.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...a})}catch(h){return b.e(h)}},async rename(i,a,h){try{return await n.a.$rename(i,a,{overwrite:!1,...h})}catch(t){return b.e(t)}},async copy(i,a,h){try{return await n.a.$copy(i,a,{overwrite:!1,...h})}catch(t){return b.e(t)}},isWritableFileSystem(i){const a=s.getCapabilities(i);if(typeof a=="number")return!(a&2048)}})}async d(o,s,n){const i=[];for(;!s.isEqual(n,s.dirname(n));)try{if(!((await o.stat(n)).type&O.FileType.Directory))throw P.$CN.FileExists(`Unable to create folder '${n.scheme===u.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(a){if(O.$5k(a)!==O.FileSystemProviderErrorCode.FileNotFound)throw a;i.push(s.basename(n)),n=s.dirname(n)}for(let a=i.length-1;a>=0;a--){n=s.joinPath(n,i[a]);try{await o.createDirectory(n)}catch(h){if(O.$5k(h)!==O.FileSystemProviderErrorCode.FileExists)throw h}}}static e(o){if(o instanceof P.$CN)throw o;if(o instanceof O.$1k)switch(o.code){case O.FileSystemProviderErrorCode.FileExists:throw P.$CN.FileExists(o.message);case O.FileSystemProviderErrorCode.FileNotFound:throw P.$CN.FileNotFound(o.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw P.$CN.FileNotADirectory(o.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw P.$CN.FileIsADirectory(o.message);case O.FileSystemProviderErrorCode.NoPermissions:throw P.$CN.NoPermissions(o.message);case O.FileSystemProviderErrorCode.Unavailable:throw P.$CN.Unavailable(o.message);default:throw new P.$CN(o.message,o.name)}if(!(o instanceof Error))throw new P.$CN(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw P.$CN.Unavailable(o.message);switch(o.name){case O.FileSystemProviderErrorCode.FileExists:throw P.$CN.FileExists(o.message);case O.FileSystemProviderErrorCode.FileNotFound:throw P.$CN.FileNotFound(o.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw P.$CN.FileNotADirectory(o.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw P.$CN.FileIsADirectory(o.message);case O.FileSystemProviderErrorCode.NoPermissions:throw P.$CN.NoPermissions(o.message);case O.FileSystemProviderErrorCode.Unavailable:throw P.$CN.Unavailable(o.message);default:throw new P.$CN(o.message,o.name)}}addFileSystemProvider(o,s,n){return this.b.set(o,{impl:s,extUri:n?.isCaseSensitive?E.$Lg:E.$Ng,isReadonly:!!n?.isReadonly}),(0,k.$Sc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??E.$Lg}};e.$qjc=f,e.$qjc=f=b=Je([We(0,m.$FO),We(1,d.$4ic)],f),e.$rjc=(0,A.$ii)("IExtHostConsumerFileSystem")}),define(Ce[249],Pe([1,0,4,7]),function($e,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ukc=void 0;class P{constructor(A){this.a=new Map,this.b=new Map,this.c=A.getProxy(I.$kM.MainThreadIssueReporter)}async $getIssueReporterUri(A,m){if(this.a.size===0)throw new Error("No issue request handlers registered");const d=this.a.get(A);if(!d)throw new Error("Issue request handler not found");const k=await d.handleIssueUrlRequest();if(!k)throw new Error("Issue request handler returned no result");return k}async $getIssueReporterData(A,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const d=this.b.get(A);if(!d)throw new Error("Issue data provider not found");const k=await d.provideIssueData(m);if(!k)throw new Error("Issue data provider returned no result");return k}async $getIssueReporterTemplate(A,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const d=this.b.get(A);if(!d)throw new Error("Issue data provider not found");const k=await d.provideIssueTemplate(m);if(!k)throw new Error("Issue template provider returned no result");return k}registerIssueUriRequestHandler(A,m){const d=A.identifier.value;return this.a.set(d,m),this.c.$registerIssueUriRequestHandler(d),new O.$mM(()=>{this.c.$unregisterIssueUriRequestHandler(d),this.a.delete(d)})}registerIssueDataProvider(A,m){const d=A.identifier.value;return this.b.set(d,m),this.c.$registerIssueDataProvider(d),new O.$mM(()=>{this.c.$unregisterIssueDataProvider(d),this.b.delete(d)})}}e.$ukc=P}),define(Ce[85],Pe([1,0,3,27,13,63,2]),function($e,e,I,O,P,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tjc=e.$sjc=void 0,e.$sjc=(0,I.$ii)("IExtensionStoragePaths");let m=class{constructor(k,F,E){this.d=F,this.f=E,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(k){return A.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,F=await this.g(k);try{return await this.f.value.stat(F),this.d.trace("[ExtHostStorage] storage dir already exists",F),F}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",F),await this.f.value.createDirectory(F),await this.f.value.writeFile(A.URI.joinPath(F,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),F}catch(E){this.d.error("[ExtHostStorage]",E);return}}workspaceValue(k){if(this.c)return A.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return A.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$tjc=m,e.$tjc=m=Je([We(0,O.$VO),We(1,P.$Oj),We(2,N.$rjc)],m)}),define(Ce[250],Pe([1,0,7,17,5]),function($e,e,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xkc=void 0;let N=class{constructor(m){this.a=new I.$MN(I.ColorThemeKind.Dark),this.b=new P.$7d}get activeColorTheme(){return this.a}$onColorThemeChange(m){let d;switch(m){case"light":d=I.ColorThemeKind.Light;break;case"hcDark":d=I.ColorThemeKind.HighContrast;break;case"hcLight":d=I.ColorThemeKind.HighContrastLight;break;default:d=I.ColorThemeKind.Dark}this.a=new I.$MN(d),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Xkc=N,e.$Xkc=N=Je([We(0,O.$FO)],N)}),define(Ce[86],Pe([1,0,25,5,6,173,3,13,202,4,27,17,7]),function($e,e,I,O,P,N,A,m,d,k,F,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HBb=e.$GBb=e.TunnelDtoConverter=void 0;class b extends d.$7v{}var f;(function(o){function s(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?d.TunnelPrivacyId.Public:d.TunnelPrivacyId.Private),protocol:i.protocol}}o.fromApiTunnel=s;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==d.TunnelPrivacyId.ConstantPrivate&&i.privacy!==d.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}o.fromServiceTunnel=n})(f||(e.TunnelDtoConverter=f={})),e.$GBb=(0,A.$ii)("IExtHostTunnelService");let r=class extends P.$Uc{constructor(s,n,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new O.$7d,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(k.$kM.MainThreadTunnelService)}async openTunnel(s,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this.a.$openTunnel(n,s.displayName);if(i){const a=new b(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(a),a}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,n){s.portRange===void 0&&s.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:s,provider:n}),this.a.$registerPortsAttributesProvider(s,i),new u.$mM(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(s,n,i,a,h){const t=[];for(const c of s){const $=this.r.get(c);if(!$)return[];t.push(...await Promise.all(n.map(async w=>{let p;try{p=await $.provider.providePortAttributes({port:w,pid:i,commandLine:a},h)}catch{p=await $.provider.providePortAttributes(w,i,a,h)}return{providedAttributes:p,port:w}})))}const v=t.filter(c=>!!c.providedAttributes);return v.length>0?v.map(c=>({autoForwardAction:c.providedAttributes.autoForwardAction,port:c.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(a,h)=>await s.provideTunnel(a,h,I.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,P.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,n){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const i=s.tunnelFactory??(n?this.w(n):void 0);if(i){this.b=i;let a=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&a.length===0&&(a=[{id:"private",label:N.localize(0,null),themeIcon:"lock"},{id:"public",label:N.localize(1,null),themeIcon:"eye"}]);const h=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:a,protocol:!0}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,P.$Sc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,n){if(this.g.has(s.host)){const i=this.g.get(s.host);i.has(s.port)&&(n&&i.get(s.port).disposeListener.dispose(),await i.get(s.port).tunnel.dispose(),i.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(s,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const a=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),a===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const h=this.B(a.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(a.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:a,disposeListener:h}),f.fromApiTunnel(a)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(s){const n=await Promise.all(s.map(a=>this.f(a.host,a.port,a.detail??""))),i=s.filter((a,h)=>n[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(a=>a.port).join(", ")} to ${i.map(a=>a.port).join(", ")}`),i}};e.$HBb=r,e.$HBb=r=Je([We(0,E.$FO),We(1,F.$VO),We(2,m.$Oj)],r)}),define(Ce[8],Pe([1,0,18,23,131,251,53,28,123,52,69,26,126,24,16,2,29,87,100,105,104,212,83,49,60,223,22,7]),function($e,e,I,O,P,N,A,m,d,k,F,E,u,b,f,r,o,s,n,i,a,h,t,v,c,$,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$CO=G,e.$DO=he,e.$EO=ye;var l;(function(we){function Oe(Q){const{selectionStartLineNumber:Ee,selectionStartColumn:Be,positionLineNumber:Xe,positionColumn:He}=Q,rt=new p.$nM(Ee-1,Be-1),yt=new p.$nM(Xe-1,He-1);return new p.$pM(rt,yt)}we.to=Oe;function se(Q){const{anchor:Ee,active:Be}=Q;return{selectionStartLineNumber:Ee.line+1,selectionStartColumn:Ee.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}we.from=se})(l||(e.Selection=l={}));var D;(function(we){function Oe(Q){if(!Q)return;const{start:Ee,end:Be}=Q;return{startLineNumber:Ee.line+1,startColumn:Ee.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}we.from=Oe;function se(Q){if(!Q)return;const{startLineNumber:Ee,startColumn:Be,endLineNumber:Xe,endColumn:He}=Q;return new p.$oM(Ee-1,Be-1,Xe-1,He-1)}we.to=se})(D||(e.Range=D={}));var g;(function(we){function Oe(Q){return{uri:Q.uri,range:D.from(Q.range)}}we.from=Oe;function se(Q){return new p.$yM(r.URI.revive(Q.uri),D.to(Q.range))}we.to=se})(g||(e.Location=g={}));var S;(function(we){function Oe(se){switch(se){case 1:return p.StandardTokenType.Comment;case 0:return p.StandardTokenType.Other;case 3:return p.StandardTokenType.RegEx;case 2:return p.StandardTokenType.String}}we.to=Oe})(S||(e.TokenType=S={}));var y;(function(we){function Oe(Q){return new p.$nM(Q.lineNumber-1,Q.column-1)}we.to=Oe;function se(Q){return{lineNumber:Q.line+1,column:Q.character+1}}we.from=se})(y||(e.Position=y={}));var C;(function(we){function Oe(Ee,Be,Xe){return(0,I.$Hb)((0,I.$3b)(Ee).map(He=>se(He,Be,Xe)))}we.from=Oe;function se(Ee,Be,Xe){if(typeof Ee=="string")return{$serialized:!0,language:Ee,isBuiltin:Xe?.isBuiltin};if(Ee)return{$serialized:!0,language:Ee.language,scheme:Q(Ee.scheme,Be),pattern:pe.from(Ee.pattern)??void 0,exclusive:Ee.exclusive,notebookType:Ee.notebookType,isBuiltin:Xe?.isBuiltin}}function Q(Ee,Be){return Be&&typeof Ee=="string"?Be.transformOutgoingScheme(Ee):Ee}})(C||(e.DocumentSelector=C={}));var R;(function(we){function Oe(Q){switch(Q){case p.DiagnosticTag.Unnecessary:return 1;case p.DiagnosticTag.Deprecated:return 2}}we.from=Oe;function se(Q){switch(Q){case 1:return p.DiagnosticTag.Unnecessary;case 2:return p.DiagnosticTag.Deprecated;default:return}}we.to=se})(R||(e.DiagnosticTag=R={}));var V;(function(we){function Oe(Q){let Ee;return Q.code&&((0,f.$Vf)(Q.code)||(0,f.$Zf)(Q.code)?Ee=String(Q.code):Ee={value:String(Q.code.value),target:Q.code.target}),{...D.from(Q.range),message:Q.message,source:Q.source,code:Ee,severity:q.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(U.from),tags:Array.isArray(Q.tags)?(0,I.$Hb)(Q.tags.map(R.from)):void 0}}we.from=Oe;function se(Q){const Ee=new p.$AM(D.to(Q),Q.message,q.to(Q.severity));return Ee.source=Q.source,Ee.code=(0,f.$Vf)(Q.code)?Q.code:Q.code?.value,Ee.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(U.to),Ee.tags=Q.tags&&(0,I.$Hb)(Q.tags.map(R.to)),Ee}we.to=se})(V||(e.Diagnostic=V={}));var U;(function(we){function Oe(Q){return{...D.from(Q.location.range),message:Q.message,resource:Q.location.uri}}we.from=Oe;function se(Q){return new p.$zM(new p.$yM(Q.resource,D.to(Q)),Q.message)}we.to=se})(U||(e.DiagnosticRelatedInformation=U={}));var q;(function(we){function Oe(Q){switch(Q){case p.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case p.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case p.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case p.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}we.from=Oe;function se(Q){switch(Q){case n.MarkerSeverity.Info:return p.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return p.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return p.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return p.DiagnosticSeverity.Hint;default:return p.DiagnosticSeverity.Error}}we.to=se})(q||(e.DiagnosticSeverity=q={}));var M;(function(we){function Oe(Q){return typeof Q=="number"&&Q>=p.ViewColumn.One?Q-1:Q===p.ViewColumn.Beside?$.$CD:$.$BD}we.from=Oe;function se(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=se})(M||(e.ViewColumn=M={}));function L(we){return typeof we.range<"u"}function G(we){return we.length===0?!0:!!L(we[0])}var ne;(function(we){function Oe(He){return He.map(we.from)}we.fromMany=Oe;function se(He){return He&&typeof He=="object"&&typeof He.language=="string"&&typeof He.value=="string"}function Q(He){let rt;if(se(He)){const{language:Ot,value:ut}=He;rt={value:"```"+Ot+`
`+ut+"\n```\n"}}else p.$NM.isMarkdownString(He)?rt={value:He.value,isTrusted:He.isTrusted,supportThemeIcons:He.supportThemeIcons,supportHtml:He.supportHtml,baseUri:He.baseUri}:typeof He=="string"?rt={value:He}:rt={value:""};const yt=Object.create(null);rt.uris=yt;const Kt=Ot=>{try{let ut=r.URI.parse(Ot,!0);ut=ut.with({query:Ee(ut.query,yt)}),yt[Ot]=ut}catch{}return""},Bt=new d.marked.Renderer;return Bt.link=Kt,Bt.image=Ot=>typeof Ot=="string"?Kt(A.$Nk(Ot).href):"",(0,d.marked)(rt.value,{renderer:Bt}),rt}we.from=Q;function Ee(He,rt){if(!He)return He;let yt;try{yt=(0,k.$Qh)(He)}catch{}if(!yt)return He;let Kt=!1;return yt=(0,E.$Qn)(yt,Bt=>{if(r.URI.isUri(Bt)){const Ot=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[Ot]=Bt,Kt=!0,Ot}else return}),Kt?JSON.stringify(yt):He}function Be(He){const rt=new p.$NM(He.value,He.supportThemeIcons);return rt.isTrusted=He.isTrusted,rt.supportHtml=He.supportHtml,rt.baseUri=He.baseUri?r.URI.from(He.baseUri):void 0,rt}we.to=Be;function Xe(He){if(He)return typeof He=="string"?He:we.from(He)}we.fromStrict=Xe})(ne||(e.MarkdownString=ne={}));function he(we){return G(we)?we.map(Oe=>({range:D.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?ne.fromMany(Oe.hoverMessage):Oe.hoverMessage?ne.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):we.map(Oe=>({range:D.from(Oe)}))}function ye(we){return typeof we>"u"?we:typeof we=="string"?r.URI.file(we):we}var Re;(function(we){function Oe(se){return typeof se>"u"?se:{contentText:se.contentText,contentIconPath:se.contentIconPath?ye(se.contentIconPath):void 0,border:se.border,borderColor:se.borderColor,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,color:se.color,backgroundColor:se.backgroundColor,margin:se.margin,width:se.width,height:se.height}}we.from=Oe})(Re||(e.ThemableDecorationAttachmentRenderOptions=Re={}));var ge;(function(we){function Oe(se){return typeof se>"u"?se:{backgroundColor:se.backgroundColor,outline:se.outline,outlineColor:se.outlineColor,outlineStyle:se.outlineStyle,outlineWidth:se.outlineWidth,border:se.border,borderColor:se.borderColor,borderRadius:se.borderRadius,borderSpacing:se.borderSpacing,borderStyle:se.borderStyle,borderWidth:se.borderWidth,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,cursor:se.cursor,color:se.color,opacity:se.opacity,letterSpacing:se.letterSpacing,gutterIconPath:se.gutterIconPath?ye(se.gutterIconPath):void 0,gutterIconSize:se.gutterIconSize,overviewRulerColor:se.overviewRulerColor,before:se.before?Re.from(se.before):void 0,after:se.after?Re.from(se.after):void 0}}we.from=Oe})(ge||(e.ThemableDecorationRenderOptions=ge={}));var ue;(function(we){function Oe(se){if(typeof se>"u")return se;switch(se){case p.DecorationRangeBehavior.OpenOpen:return 0;case p.DecorationRangeBehavior.ClosedClosed:return 1;case p.DecorationRangeBehavior.OpenClosed:return 2;case p.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=Oe})(ue||(e.DecorationRangeBehavior=ue={}));var te;(function(we){function Oe(se){return{isWholeLine:se.isWholeLine,rangeBehavior:se.rangeBehavior?ue.from(se.rangeBehavior):void 0,overviewRulerLane:se.overviewRulerLane,light:se.light?ge.from(se.light):void 0,dark:se.dark?ge.from(se.dark):void 0,backgroundColor:se.backgroundColor,outline:se.outline,outlineColor:se.outlineColor,outlineStyle:se.outlineStyle,outlineWidth:se.outlineWidth,border:se.border,borderColor:se.borderColor,borderRadius:se.borderRadius,borderSpacing:se.borderSpacing,borderStyle:se.borderStyle,borderWidth:se.borderWidth,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,cursor:se.cursor,color:se.color,opacity:se.opacity,letterSpacing:se.letterSpacing,gutterIconPath:se.gutterIconPath?ye(se.gutterIconPath):void 0,gutterIconSize:se.gutterIconSize,overviewRulerColor:se.overviewRulerColor,before:se.before?Re.from(se.before):void 0,after:se.after?Re.from(se.after):void 0}}we.from=Oe})(te||(e.DecorationRenderOptions=te={}));var be;(function(we){function Oe(Q){return{text:Q.newText,eol:Q.newEol&&ft.from(Q.newEol),range:D.from(Q.range)}}we.from=Oe;function se(Q){const Ee=new p.$tM(D.to(Q.range),Q.text);return Ee.newEol=typeof Q.eol>"u"?void 0:ft.to(Q.eol),Ee}we.to=se})(be||(e.TextEdit=be={}));var oe;(function(we){function Oe(Q,Ee){const Be={edits:[]};if(Q instanceof p.$wM){const Xe=new m.$Cc;for(const He of Q._allEntries())He._type===1&&r.URI.isUri(He.to)&&He.from===void 0&&Xe.add(He.to);for(const He of Q._allEntries())if(He._type===1){let rt;He.options?.contents&&(ArrayBuffer.isView(He.options.contents)?rt={type:"base64",value:(0,O.$Oe)(O.$ue.wrap(He.options.contents))}:rt={type:"dataTransferItem",id:He.options.contents._itemId}),Be.edits.push({oldResource:He.from,newResource:He.to,options:{...He.options,contents:rt},metadata:He.metadata})}else He._type===2?Be.edits.push({resource:He.uri,textEdit:be.from(He.edit),versionId:Xe.has(He.uri)?void 0:Ee?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===6?Be.edits.push({resource:He.uri,textEdit:{range:D.from(He.range),text:He.edit.value,insertAsSnippet:!0},versionId:Xe.has(He.uri)?void 0:Ee?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===3?Be.edits.push({metadata:He.metadata,resource:He.uri,cellEdit:He.edit,notebookMetadata:He.notebookMetadata,notebookVersionId:Ee?.getNotebookDocumentVersion(He.uri)}):He._type===5&&Be.edits.push({metadata:He.metadata,resource:He.uri,notebookVersionId:Ee?.getNotebookDocumentVersion(He.uri),cellEdit:{editType:1,index:He.index,count:He.count,cells:He.cells.map(Jt.from)}})}return Be}we.from=Oe;function se(Q){const Ee=new p.$wM,Be=new m.$Bc;for(const Xe of Q.edits)if(Xe.textEdit){const He=Xe,rt=r.URI.revive(He.resource),yt=D.to(He.textEdit.range),Kt=He.textEdit.text,Bt=He.textEdit.insertAsSnippet;let Ot;Bt?Ot=p.$vM.replace(yt,new p.$xM(Kt)):Ot=p.$tM.replace(yt,Kt);const ut=Be.get(rt);ut?ut.push(Ot):Be.set(rt,[Ot])}else Ee.renameFile(r.URI.revive(Xe.oldResource),r.URI.revive(Xe.newResource),Xe.options);for(const[Xe,He]of Be)Ee.set(Xe,He);return Ee}we.to=se})(oe||(e.WorkspaceEdit=oe={}));var de;(function(we){const Oe=Object.create(null);Oe[p.SymbolKind.File]=0,Oe[p.SymbolKind.Module]=1,Oe[p.SymbolKind.Namespace]=2,Oe[p.SymbolKind.Package]=3,Oe[p.SymbolKind.Class]=4,Oe[p.SymbolKind.Method]=5,Oe[p.SymbolKind.Property]=6,Oe[p.SymbolKind.Field]=7,Oe[p.SymbolKind.Constructor]=8,Oe[p.SymbolKind.Enum]=9,Oe[p.SymbolKind.Interface]=10,Oe[p.SymbolKind.Function]=11,Oe[p.SymbolKind.Variable]=12,Oe[p.SymbolKind.Constant]=13,Oe[p.SymbolKind.String]=14,Oe[p.SymbolKind.Number]=15,Oe[p.SymbolKind.Boolean]=16,Oe[p.SymbolKind.Array]=17,Oe[p.SymbolKind.Object]=18,Oe[p.SymbolKind.Key]=19,Oe[p.SymbolKind.Null]=20,Oe[p.SymbolKind.EnumMember]=21,Oe[p.SymbolKind.Struct]=22,Oe[p.SymbolKind.Event]=23,Oe[p.SymbolKind.Operator]=24,Oe[p.SymbolKind.TypeParameter]=25;function se(Ee){return typeof Oe[Ee]=="number"?Oe[Ee]:6}we.from=se;function Q(Ee){for(const Be in Oe)if(Oe[Be]===Ee)return Number(Be);return p.SymbolKind.Property}we.to=Q})(de||(e.SymbolKind=de={}));var W;(function(we){function Oe(Q){switch(Q){case p.SymbolTag.Deprecated:return 1}}we.from=Oe;function se(Q){switch(Q){case 1:return p.SymbolTag.Deprecated}}we.to=se})(W||(e.SymbolTag=W={}));var ee;(function(we){function Oe(Q){return{name:Q.name,kind:de.from(Q.kind),tags:Q.tags&&Q.tags.map(W.from),containerName:Q.containerName,location:me.from(Q.location)}}we.from=Oe;function se(Q){const Ee=new p.$EM(Q.name,de.to(Q.kind),Q.containerName,me.to(Q.location));return Ee.tags=Q.tags&&Q.tags.map(W.to),Ee}we.to=se})(ee||(e.WorkspaceSymbol=ee={}));var ke;(function(we){function Oe(Q){const Ee={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:D.from(Q.range),selectionRange:D.from(Q.selectionRange),kind:de.from(Q.kind),tags:Q.tags?.map(W.from)??[]};return Q.children&&(Ee.children=Q.children.map(Oe)),Ee}we.from=Oe;function se(Q){const Ee=new p.$FM(Q.name,Q.detail,de.to(Q.kind),D.to(Q.range),D.to(Q.selectionRange));return(0,I.$Lb)(Q.tags)&&(Ee.tags=Q.tags.map(W.to)),Q.children&&(Ee.children=Q.children.map(se)),Ee}we.to=se})(ke||(e.DocumentSymbol=ke={}));var Te;(function(we){function Oe(Q){const Ee=new p.$JM(de.to(Q.kind),Q.name,Q.detail||"",r.URI.revive(Q.uri),D.to(Q.range),D.to(Q.selectionRange));return Ee._sessionId=Q._sessionId,Ee._itemId=Q._itemId,Ee}we.to=Oe;function se(Q,Ee,Be){if(Ee=Ee??Q._sessionId,Be=Be??Q._itemId,Ee===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:Be,name:Q.name,detail:Q.detail,kind:de.from(Q.kind),uri:Q.uri,range:D.from(Q.range),selectionRange:D.from(Q.selectionRange),tags:Q.tags?.map(W.from)}}we.from=se})(Te||(e.CallHierarchyItem=Te={}));var Se;(function(we){function Oe(se){return new p.$KM(Te.to(se.from),se.fromRanges.map(Q=>D.to(Q)))}we.to=Oe})(Se||(e.CallHierarchyIncomingCall=Se={}));var ve;(function(we){function Oe(se){return new p.$LM(Te.to(se.to),se.fromRanges.map(Q=>D.to(Q)))}we.to=Oe})(ve||(e.CallHierarchyOutgoingCall=ve={}));var me;(function(we){function Oe(Q){return{range:Q.range&&D.from(Q.range),uri:Q.uri}}we.from=Oe;function se(Q){return new p.$yM(r.URI.revive(Q.uri),D.to(Q.range))}we.to=se})(me||(e.location=me={}));var J;(function(we){function Oe(Q){const Ee=Q,Be=Q;return{originSelectionRange:Ee.originSelectionRange?D.from(Ee.originSelectionRange):void 0,uri:Ee.targetUri?Ee.targetUri:Be.uri,range:D.from(Ee.targetRange?Ee.targetRange:Be.range),targetSelectionRange:Ee.targetSelectionRange?D.from(Ee.targetSelectionRange):void 0}}we.from=Oe;function se(Q){return{targetUri:r.URI.revive(Q.uri),targetRange:D.to(Q.range),targetSelectionRange:Q.targetSelectionRange?D.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?D.to(Q.originSelectionRange):void 0}}we.to=se})(J||(e.DefinitionLink=J={}));var Y;(function(we){function Oe(Q){return{range:D.from(Q.range),contents:ne.fromMany(Q.contents)}}we.from=Oe;function se(Q){return new p.$BM(Q.contents.map(ne.to),D.to(Q.range))}we.to=se})(Y||(e.Hover=Y={}));var ce;(function(we){function Oe(Q){return{range:D.from(Q.range),expression:Q.expression}}we.from=Oe;function se(Q){return new p.$wN(D.to(Q.range),Q.expression)}we.to=se})(ce||(e.EvaluatableExpression=ce={}));var fe;(function(we){function Oe(Q){if(Q instanceof p.$xN)return{type:"text",range:D.from(Q.range),text:Q.text};if(Q instanceof p.$yN)return{type:"variable",range:D.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof p.$zN)return{type:"expression",range:D.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}we.from=Oe;function se(Q){switch(Q.type){case"text":return{range:D.to(Q.range),text:Q.text};case"variable":return{range:D.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:D.to(Q.range),expression:Q.expression}}}we.to=se})(fe||(e.InlineValue=fe={}));var Ne;(function(we){function Oe(Q){return{frameId:Q.frameId,stoppedLocation:D.from(Q.stoppedLocation)}}we.from=Oe;function se(Q){return new p.$AN(Q.frameId,D.to(Q.stoppedLocation))}we.to=se})(Ne||(e.InlineValueContext=Ne={}));var le;(function(we){function Oe(Q){return{range:D.from(Q.range),kind:Q.kind}}we.from=Oe;function se(Q){return new p.$CM(D.to(Q.range),Q.kind)}we.to=se})(le||(e.DocumentHighlight=le={}));var Ie;(function(we){function Oe(Q){return{uri:Q.uri,highlights:Q.highlights.map(le.from)}}we.from=Oe;function se(Q){return new p.$DM(r.URI.revive(Q.uri),Q.highlights.map(le.to))}we.to=se})(Ie||(e.MultiDocumentHighlight=Ie={}));var Ae;(function(we){function Oe(se){switch(se){case 1:return p.CompletionTriggerKind.TriggerCharacter;case 2:return p.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return p.CompletionTriggerKind.Invoke}}we.to=Oe})(Ae||(e.CompletionTriggerKind=Ae={}));var je;(function(we){function Oe(se){return{triggerKind:Ae.to(se.triggerKind),triggerCharacter:se.triggerCharacter}}we.to=Oe})(je||(e.CompletionContext=je={}));var z;(function(we){function Oe(Q){switch(Q){case p.CompletionItemTag.Deprecated:return 1}}we.from=Oe;function se(Q){switch(Q){case 1:return p.CompletionItemTag.Deprecated}}we.to=se})(z||(e.CompletionItemTag=z={}));var j;(function(we){const Oe=new Map([[p.CompletionItemKind.Method,0],[p.CompletionItemKind.Function,1],[p.CompletionItemKind.Constructor,2],[p.CompletionItemKind.Field,3],[p.CompletionItemKind.Variable,4],[p.CompletionItemKind.Class,5],[p.CompletionItemKind.Interface,7],[p.CompletionItemKind.Struct,6],[p.CompletionItemKind.Module,8],[p.CompletionItemKind.Property,9],[p.CompletionItemKind.Unit,12],[p.CompletionItemKind.Value,13],[p.CompletionItemKind.Constant,14],[p.CompletionItemKind.Enum,15],[p.CompletionItemKind.EnumMember,16],[p.CompletionItemKind.Keyword,17],[p.CompletionItemKind.Snippet,27],[p.CompletionItemKind.Text,18],[p.CompletionItemKind.Color,19],[p.CompletionItemKind.File,20],[p.CompletionItemKind.Reference,21],[p.CompletionItemKind.Folder,23],[p.CompletionItemKind.Event,10],[p.CompletionItemKind.Operator,11],[p.CompletionItemKind.TypeParameter,24],[p.CompletionItemKind.Issue,26],[p.CompletionItemKind.User,25]]);function se(Be){return Oe.get(Be)??9}we.from=se;const Q=new Map([[0,p.CompletionItemKind.Method],[1,p.CompletionItemKind.Function],[2,p.CompletionItemKind.Constructor],[3,p.CompletionItemKind.Field],[4,p.CompletionItemKind.Variable],[5,p.CompletionItemKind.Class],[7,p.CompletionItemKind.Interface],[6,p.CompletionItemKind.Struct],[8,p.CompletionItemKind.Module],[9,p.CompletionItemKind.Property],[12,p.CompletionItemKind.Unit],[13,p.CompletionItemKind.Value],[14,p.CompletionItemKind.Constant],[15,p.CompletionItemKind.Enum],[16,p.CompletionItemKind.EnumMember],[17,p.CompletionItemKind.Keyword],[27,p.CompletionItemKind.Snippet],[18,p.CompletionItemKind.Text],[19,p.CompletionItemKind.Color],[20,p.CompletionItemKind.File],[21,p.CompletionItemKind.Reference],[23,p.CompletionItemKind.Folder],[10,p.CompletionItemKind.Event],[11,p.CompletionItemKind.Operator],[24,p.CompletionItemKind.TypeParameter],[25,p.CompletionItemKind.User],[26,p.CompletionItemKind.Issue]]);function Ee(Be){return Q.get(Be)??p.CompletionItemKind.Property}we.to=Ee})(j||(e.CompletionItemKind=j={}));var K;(function(we){function Oe(se,Q){const Ee=new p.$TM(se.label);return Ee.insertText=se.insertText,Ee.kind=j.to(se.kind),Ee.tags=se.tags?.map(z.to),Ee.detail=se.detail,Ee.documentation=A.$Hk(se.documentation)?ne.to(se.documentation):se.documentation,Ee.sortText=se.sortText,Ee.filterText=se.filterText,Ee.preselect=se.preselect,Ee.commitCharacters=se.commitCharacters,o.$ct.isIRange(se.range)?Ee.range=D.to(se.range):typeof se.range=="object"&&(Ee.range={inserting:D.to(se.range.insert),replacing:D.to(se.range.replace)}),Ee.keepWhitespace=typeof se.insertTextRules>"u"?!1:!!(se.insertTextRules&1),typeof se.insertTextRules<"u"&&se.insertTextRules&4?Ee.insertText=new p.$xM(se.insertText):(Ee.insertText=se.insertText,Ee.textEdit=Ee.range instanceof p.$oM?new p.$tM(Ee.range,Ee.insertText):void 0),se.additionalTextEdits&&se.additionalTextEdits.length>0&&(Ee.additionalTextEdits=se.additionalTextEdits.map(Be=>be.to(Be))),Ee.command=Q&&se.command?Q.fromInternal(se.command):void 0,Ee}we.to=Oe})(K||(e.CompletionItem=K={}));var H;(function(we){function Oe(Q){if(typeof Q.label!="string"&&!Array.isArray(Q.label))throw new TypeError("Invalid label");return{label:Q.label,documentation:ne.fromStrict(Q.documentation)}}we.from=Oe;function se(Q){return{label:Q.label,documentation:A.$Hk(Q.documentation)?ne.to(Q.documentation):Q.documentation}}we.to=se})(H||(e.ParameterInformation=H={}));var _;(function(we){function Oe(Q){return{label:Q.label,documentation:ne.fromStrict(Q.documentation),parameters:Array.isArray(Q.parameters)?Q.parameters.map(H.from):[],activeParameter:Q.activeParameter}}we.from=Oe;function se(Q){return{label:Q.label,documentation:A.$Hk(Q.documentation)?ne.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(H.to):[],activeParameter:Q.activeParameter}}we.to=se})(_||(e.SignatureInformation=_={}));var re;(function(we){function Oe(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(_.from):[]}}we.from=Oe;function se(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(_.to):[]}}we.to=se})(re||(e.SignatureHelp=re={}));var Fe;(function(we){function Oe(se,Q){const Ee=new p.$SM(y.to(Q.position),typeof Q.label=="string"?Q.label:Q.label.map(Ve.to.bind(void 0,se)),Q.kind&&Qe.to(Q.kind));return Ee.textEdits=Q.textEdits&&Q.textEdits.map(be.to),Ee.tooltip=A.$Hk(Q.tooltip)?ne.to(Q.tooltip):Q.tooltip,Ee.paddingLeft=Q.paddingLeft,Ee.paddingRight=Q.paddingRight,Ee}we.to=Oe})(Fe||(e.InlayHint=Fe={}));var Ve;(function(we){function Oe(se,Q){const Ee=new p.$RM(Q.label);return Ee.tooltip=A.$Hk(Q.tooltip)?ne.to(Q.tooltip):Q.tooltip,s.Command.is(Q.command)&&(Ee.command=se.fromInternal(Q.command)),Q.location&&(Ee.location=me.to(Q.location)),Ee}we.to=Oe})(Ve||(e.InlayHintLabelPart=Ve={}));var Qe;(function(we){function Oe(Q){return Q}we.from=Oe;function se(Q){return Q}we.to=se})(Qe||(e.InlayHintKind=Qe={}));var xe;(function(we){function Oe(Q){return{range:D.from(Q.range),url:Q.target,tooltip:Q.tooltip}}we.from=Oe;function se(Q){let Ee;if(Q.url)try{Ee=typeof Q.url=="string"?r.URI.parse(Q.url,!0):r.URI.revive(Q.url)}catch{}return new p.$YM(D.to(Q.range),Ee)}we.to=se})(xe||(e.DocumentLink=xe={}));var tt;(function(we){function Oe(Q){const Ee=new p.$2M(Q.label);return Q.textEdit&&(Ee.textEdit=be.to(Q.textEdit)),Q.additionalTextEdits&&(Ee.additionalTextEdits=Q.additionalTextEdits.map(Be=>be.to(Be))),Ee}we.to=Oe;function se(Q){return{label:Q.label,textEdit:Q.textEdit?be.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(Ee=>be.from(Ee)):void 0}}we.from=se})(tt||(e.ColorPresentation=tt={}));var at;(function(we){function Oe(Q){return new p.$ZM(Q[0],Q[1],Q[2],Q[3])}we.to=Oe;function se(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}we.from=se})(at||(e.Color=at={}));var it;(function(we){function Oe(Q){return{range:D.from(Q.range)}}we.from=Oe;function se(Q){return new p.$IM(D.to(Q.range))}we.to=se})(it||(e.SelectionRange=it={}));var nt;(function(we){function Oe(se){switch(se){case 2:return p.TextDocumentSaveReason.AfterDelay;case 1:return p.TextDocumentSaveReason.Manual;case 3:case 4:return p.TextDocumentSaveReason.FocusOut}}we.to=Oe})(nt||(e.TextDocumentSaveReason=nt={}));var ct;(function(we){function Oe(Q){switch(Q){case p.TextEditorLineNumbersStyle.Off:return 0;case p.TextEditorLineNumbersStyle.Relative:return 2;case p.TextEditorLineNumbersStyle.Interval:return 3;case p.TextEditorLineNumbersStyle.On:default:return 1}}we.from=Oe;function se(Q){switch(Q){case 0:return p.TextEditorLineNumbersStyle.Off;case 2:return p.TextEditorLineNumbersStyle.Relative;case 3:return p.TextEditorLineNumbersStyle.Interval;case 1:default:return p.TextEditorLineNumbersStyle.On}}we.to=se})(ct||(e.TextEditorLineNumbersStyle=ct={}));var ft;(function(we){function Oe(Q){if(Q===p.EndOfLine.CRLF)return 1;if(Q===p.EndOfLine.LF)return 0}we.from=Oe;function se(Q){if(Q===1)return p.EndOfLine.CRLF;if(Q===0)return p.EndOfLine.LF}we.to=se})(ft||(e.EndOfLine=ft={}));var Ue;(function(we){function Oe(se){if(typeof se=="object")return se.viewId;switch(se){case p.ProgressLocation.SourceControl:return 3;case p.ProgressLocation.Window:return 10;case p.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=Oe})(Ue||(e.ProgressLocation=Ue={}));var ot;(function(we){function Oe(Q){const Ee={start:Q.start+1,end:Q.end+1};return Q.kind&&(Ee.kind=X.from(Q.kind)),Ee}we.from=Oe;function se(Q){const Ee={start:Q.start-1,end:Q.end-1};return Q.kind&&(Ee.kind=X.to(Q.kind)),Ee}we.to=se})(ot||(e.FoldingRange=ot={}));var X;(function(we){function Oe(Q){if(Q)switch(Q){case p.FoldingRangeKind.Comment:return s.$7t.Comment;case p.FoldingRangeKind.Imports:return s.$7t.Imports;case p.FoldingRangeKind.Region:return s.$7t.Region}}we.from=Oe;function se(Q){if(Q)switch(Q.value){case s.$7t.Comment.value:return p.FoldingRangeKind.Comment;case s.$7t.Imports.value:return p.FoldingRangeKind.Imports;case s.$7t.Region.value:return p.FoldingRangeKind.Region}}we.to=se})(X||(e.FoldingRangeKind=X={}));var Z;(function(we){function Oe(se){if(se)return{pinned:typeof se.preview=="boolean"?!se.preview:void 0,inactive:se.background,preserveFocus:se.preserveFocus,selection:typeof se.selection=="object"?D.from(se.selection):void 0,override:typeof se.override=="boolean"?a.$5E.id:void 0}}we.from=Oe})(Z||(e.TextEditorOpenOptions=Z={}));var pe;(function(we){function Oe(Be){return Be instanceof p.$kN?Be.toJSON():typeof Be=="string"?Be:se(Be)||Q(Be)?new p.$kN(Be.baseUri??Be.base,Be.pattern).toJSON():Be}we.from=Oe;function se(Be){const Xe=Be;return Xe?r.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function Q(Be){const Xe=Be;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Ee(Be){return typeof Be=="string"?Be:new p.$kN(r.URI.revive(Be.baseUri),Be.pattern)}we.to=Ee})(pe||(e.GlobPattern=pe={}));var qe;(function(we){function Oe(se){if(se){if(Array.isArray(se))return se.map(Oe);if(typeof se=="string")return se;{const Q=se;return{language:Q.language,scheme:Q.scheme,pattern:pe.from(Q.pattern),exclusive:Q.exclusive,notebookType:Q.notebookType}}}else return}we.from=Oe})(qe||(e.LanguageSelector=qe={}));var Ze;(function(we){function Oe(Q){return!!Q&&typeof Q=="object"&&"documents"in Q&&Array.isArray(Q.documents)&&Q.documents.every(Ee=>Array.isArray(Ee)&&Ee.every(Be=>Be&&typeof Be=="object"&&"uri"in Be&&r.URI.isUri(Be.uri)&&"version"in Be&&typeof Be.version=="number"&&"ranges"in Be&&Array.isArray(Be.ranges)&&Be.ranges.every(Xe=>Xe instanceof p.$oM)))}we.is=Oe;function se(Q){return{documents:Q.documents.map(Ee=>Ee.map(Be=>({uri:r.URI.from(Be.uri),version:Be.version,ranges:Be.ranges.map(Xe=>D.from(Xe))})))}}we.from=se})(Ze||(e.MappedEditsContext=Ze={}));var Me;(function(we){function Oe(Q){return{start:Q.start,end:Q.end}}we.from=Oe;function se(Q){return new p.$NN(Q.start,Q.end)}we.to=se})(Me||(e.NotebookRange=Me={}));var dt;(function(we){function Oe(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}we.to=Oe;function se(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}we.from=se})(dt||(e.NotebookCellExecutionSummary=dt={}));var Pt;(function(we){function Oe(se){if(se===t.NotebookCellExecutionState.Unconfirmed)return p.NotebookCellExecutionState.Pending;if(se===t.NotebookCellExecutionState.Pending)return;if(se===t.NotebookCellExecutionState.Executing)return p.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${se}`)}we.to=Oe})(Pt||(e.NotebookCellExecutionState=Pt={}));var zt;(function(we){function Oe(Q){switch(Q){case p.NotebookCellKind.Markup:return t.CellKind.Markup;case p.NotebookCellKind.Code:default:return t.CellKind.Code}}we.from=Oe;function se(Q){switch(Q){case t.CellKind.Markup:return p.NotebookCellKind.Markup;case t.CellKind.Code:default:return p.NotebookCellKind.Code}}we.to=se})(zt||(e.NotebookCellKind=zt={}));var xt;(function(we){function Oe(Q){const Ee={metadata:Q.metadata??Object.create(null),cells:[]};for(const Be of Q.cells)p.$ON.validate(Be),Ee.cells.push(Jt.from(Be));return Ee}we.from=Oe;function se(Q){const Ee=new p.$PN(Q.cells.map(Jt.to));return(0,f.$9f)(Q.metadata)||(Ee.metadata=Q.metadata),Ee}we.to=se})(xt||(e.NotebookData=xt={}));var Jt;(function(we){function Oe(Q){return{cellKind:zt.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:dt.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(Et.from):[]}}we.from=Oe;function se(Q){return new p.$ON(zt.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(Et.to):void 0,Q.metadata,Q.internalMetadata?dt.to(Q.internalMetadata):void 0)}we.to=se})(Jt||(e.NotebookCellData=Jt={}));var _t;(function(we){function Oe(Q){return{mime:Q.mime,valueBytes:O.$ue.wrap(Q.data)}}we.from=Oe;function se(Q){return new p.$QN(Q.valueBytes.buffer,Q.mime)}we.to=se})(_t||(e.NotebookCellOutputItem=_t={}));var Et;(function(we){function Oe(Q){return{outputId:Q.id,items:Q.items.map(_t.from),metadata:Q.metadata}}we.from=Oe;function se(Q){const Ee=Q.items.map(_t.to);return new p.$RN(Ee,Q.outputId,Q.metadata)}we.to=se})(Et||(e.NotebookCellOutput=Et={}));var Qt;(function(we){function Oe(Ee){return Q(Ee)?{include:pe.from(Ee.include)??void 0,exclude:pe.from(Ee.exclude)??void 0}:pe.from(Ee)??void 0}we.from=Oe;function se(Ee){return Q(Ee)?{include:pe.to(Ee.include),exclude:pe.to(Ee.exclude)}:pe.to(Ee)}we.to=se;function Q(Ee){const Be=Ee;return Be?!(0,f.$5f)(Be.include)&&!(0,f.$5f)(Be.exclude):!1}})(Qt||(e.NotebookExclusiveDocumentPattern=Qt={}));var Vt;(function(we){function Oe(se,Q,Ee){const Be=typeof se.command=="string"?{title:"",command:se.command}:se.command;return{alignment:se.alignment===p.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(Be,Ee),text:se.text,tooltip:se.tooltip,accessibilityInformation:se.accessibilityInformation,priority:se.priority}}we.from=Oe})(Vt||(e.NotebookStatusBarItem=Vt={}));var ai;(function(we){function Oe(se,Q,Ee){const Be=typeof se.command=="string"?{title:"",command:se.command}:se.command;return{command:Q.toInternal(Be,Ee),label:se.label,description:se.description,detail:se.detail,documentation:se.documentation}}we.from=Oe})(ai||(e.NotebookKernelSourceAction=ai={}));var Ye;(function(we){function Oe(se){return{transientOutputs:se?.transientOutputs??!1,transientCellMetadata:se?.transientCellMetadata??{},transientDocumentMetadata:se?.transientDocumentMetadata??{},cellContentMetadata:se?.cellContentMetadata??{}}}we.from=Oe})(Ye||(e.NotebookDocumentContentOptions=Ye={}));var ei;(function(we){function Oe(Q){return{uri:Q.uri,provides:Q.provides}}we.from=Oe;function se(Q){return new p.$TN(r.URI.revive(Q.uri),Q.provides)}we.to=se})(ei||(e.NotebookRendererScript=ei={}));var ti;(function(we){function Oe(Q){return{message:ne.fromStrict(Q.message)||"",type:0,expected:Q.expectedOutput,actual:Q.actualOutput,contextValue:Q.contextValue,location:Q.location&&{range:D.from(Q.location.range),uri:Q.location.uri}}}we.from=Oe;function se(Q){const Ee=new p.$ZN(typeof Q.message=="string"?Q.message:ne.to(Q.message));return Ee.actualOutput=Q.actual,Ee.expectedOutput=Q.expected,Ee.contextValue=Q.contextValue,Ee.location=Q.location?me.to(Q.location):void 0,Ee}we.to=se})(ti||(e.TestMessage=ti={}));var ht;(function(we){we.namespace=c.$bL,we.denamespace=c.$cL})(ht||(e.TestTag=ht={}));var vt;(function(we){function Oe(Q){const Ee=(0,i.$BO)(Q).controllerId;return{extId:v.$9K.fromExtHostTestItem(Q,Ee).toString(),label:Q.label,uri:r.URI.revive(Q.uri),busy:Q.busy,tags:Q.tags.map(Be=>ht.namespace(Ee,Be.id)),range:o.$ct.lift(D.from(Q.range)),description:Q.description||null,sortText:Q.sortText||null,error:Q.error&&ne.fromStrict(Q.error)||null}}we.from=Oe;function se(Q){return{parent:void 0,error:void 0,id:v.$9K.fromString(Q.extId).localId,label:Q.label,uri:r.URI.revive(Q.uri),tags:(Q.tags||[]).map(Ee=>{const{tagId:Be}=ht.denamespace(Ee);return new p.$1N(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:D.to(Q.range||void 0),canResolveChildren:!1,busy:Q.busy,description:Q.description||void 0,sortText:Q.sortText||void 0}}we.toPlain=se})(vt||(e.TestItem=vt={})),function(we){function Oe(Q){return{id:Q.id}}we.from=Oe;function se(Q){return new p.$1N(Q.id)}we.to=se}(ht||(e.TestTag=ht={}));var si;(function(we){const Oe=(Q,Ee)=>{const Be=Q.value;if(!Be)return;const Xe={...vt.toPlain(Be.item),parent:Ee,taskStates:Be.tasks.map(He=>({state:He.state,duration:He.duration,messages:He.messages.filter(rt=>rt.type===0).map(ti.to)})),children:[]};if(Q.children)for(const He of Q.children.values()){const rt=Oe(He,Xe);rt&&Xe.children.push(rt)}return Xe};function se(Q){const Ee=new u.$uO;for(const He of Q.items)Ee.insert(v.$9K.fromString(He.item.extId).path,He);const Be=[Ee.nodes],Xe=[];for(;Be.length;)for(const He of Be.pop())He.value?Xe.push(He):He.children&&Be.push(He.children.values());return{completedAt:Q.completedAt,results:Xe.map(He=>Oe(He)).filter(f.$4f)}}we.to=se})(si||(e.TestResults=si={}));var ii;(function(we){function Oe(Be){return{covered:Be.covered,total:Be.total}}function se(Be){return"line"in Be?y.from(Be):D.from(Be)}function Q(Be){return"branches"in Be?{count:Be.executed,location:se(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Xe=>({count:Xe.executed,location:Xe.location&&se(Xe.location),label:Xe.label})):void 0}:{type:0,name:Be.name,count:Be.executed,location:se(Be.location)}}we.fromDetails=Q;function Ee(Be,Xe){return{id:Be,uri:Xe.uri,statement:Oe(Xe.statementCoverage),branch:Xe.branchCoverage&&Oe(Xe.branchCoverage),declaration:Xe.declarationCoverage&&Oe(Xe.declarationCoverage)}}we.fromFile=Ee})(ii||(e.TestCoverage=ii={}));var Ft;(function(we){function Oe(se){switch(se){case 1:return p.CodeActionTriggerKind.Invoke;case 2:return p.CodeActionTriggerKind.Automatic}}we.to=Oe})(Ft||(e.CodeActionTriggerKind=Ft={}));var mt;(function(we){function Oe(Q){const Ee=new p.$7N(de.to(Q.kind),Q.name,Q.detail||"",r.URI.revive(Q.uri),D.to(Q.range),D.to(Q.selectionRange));return Ee._sessionId=Q._sessionId,Ee._itemId=Q._itemId,Ee}we.to=Oe;function se(Q,Ee,Be){if(Ee=Ee??Q._sessionId,Be=Be??Q._itemId,Ee===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:Be,kind:de.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:D.from(Q.range),selectionRange:D.from(Q.selectionRange),tags:Q.tags?.map(W.from)}}we.from=se})(mt||(e.TypeHierarchyItem=mt={}));var Mt;(function(we){function Oe(se){if(se)return{value:se.value,tooltip:se.tooltip}}we.from=Oe})(Mt||(e.ViewBadge=Mt={}));var Wt;(function(we){function Oe(Be,Xe,He){const rt=Xe.fileData;return rt?new p.$cN(new p.$dN(rt.name,r.URI.revive(rt.uri),rt.id,(0,N.$db)(()=>He(rt.id)))):Be===F.$zs.uriList&&Xe.uriListData?new p.$bN(Ee(Xe.uriListData)):new p.$bN(Xe.asString)}we.to=Oe;async function se(Be,Xe){const He=await Xe.asString();if(Be===F.$zs.uriList)return{asString:He,fileData:void 0,uriListData:Q(He)};const rt=Xe.asFile();return{asString:He,fileData:rt?{name:rt.name,uri:rt.uri,id:rt._itemId??rt.id}:void 0}}we.from=se;function Q(Be){return P.$Lt.split(Be).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return r.URI.parse(Xe)}catch{}return Xe})}function Ee(Be){return P.$Lt.create(Be.map(Xe=>typeof Xe=="string"?Xe:r.URI.revive(Xe)))}})(Wt||(e.DataTransferItem=Wt={}));var Zt;(function(we){function Oe(Q,Ee){const Be=Q.items.map(([Xe,He])=>[Xe,Wt.to(Xe,He,Ee)]);return new p.$eN(Be)}we.toDataTransfer=Oe;async function se(Q){const Ee={items:[]},Be=[];for(const[Xe,He]of Q)Be.push((async()=>{Ee.items.push([Xe,await Wt.from(Xe,He)])})());return await Promise.all(Be),Ee}we.from=se})(Zt||(e.DataTransfer=Zt={}));var Ke;(function(we){function Oe(Q,Ee){return{kind:"reply",agentId:Q.participant??Ee?.agentId??"",subCommand:Q.command??Ee?.command,message:Q.prompt,title:Q.label}}we.from=Oe;function se(Q){return{prompt:Q.message,label:Q.title,participant:Q.agentId,command:Q.subCommand}}we.to=se})(Ke||(e.ChatFollowup=Ke={}));var Xt;(function(we){function Oe(se){return"commandId"in se?{kind:"command",title:se.title??"",commandId:se.commandId??"",when:se.when??"",args:se.args}:{kind:"reply",message:se.message,title:se.title,tooltip:se.tooltip}}we.from=Oe})(Xt||(e.ChatInlineFollowup=Xt={}));var jt;(function(we){function Oe(Q){switch(Q.role){case 0:return new p.$pO(Q.content);case 1:return new p.$qO(Q.content);case 2:return new p.$rO(Q.content)}}we.to=Oe;function se(Q){if(Q instanceof p.$pO)return{role:0,content:Q.content};if(Q instanceof p.$qO)return{role:1,content:Q.content};if(Q instanceof p.$rO)return{role:2,content:Q.content};throw new Error("Invalid LanguageModelMessage")}we.from=se})(jt||(e.LanguageModelMessage=jt={}));var Ut;(function(we){function Oe(Ee){const Be={};for(const Xe of Object.keys(Ee))Be[Xe]=Ee[Xe].map(we.to);return Be}we.objectTo=Oe;function se(Ee){return{level:$t.to(Ee.level),kind:Ee.kind,value:(0,r.$wc)(Ee.value)?r.URI.revive(Ee.value):Ee.value,description:Ee.description}}we.to=se;function Q(Ee){return{level:$t.from(Ee.level),kind:Ee.kind,value:Ee.value,description:Ee.description}}we.from=Q})(Ut||(e.ChatVariable=Ut={}));var $t;(function(we){function Oe(Q){switch(Q){case"short":return p.ChatVariableLevel.Short;case"medium":return p.ChatVariableLevel.Medium;case"full":default:return p.ChatVariableLevel.Full}}we.to=Oe;function se(Q){switch(Q){case p.ChatVariableLevel.Short:return"short";case p.ChatVariableLevel.Medium:return"medium";case p.ChatVariableLevel.Full:default:return"full"}}we.from=se})($t||(e.ChatVariableLevel=$t={}));var Tt;(function(we){function Oe(se){switch(se){case 1:return p.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return p.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return p.InteractiveEditorResponseFeedbackKind.Undone;case 3:return p.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return p.InteractiveEditorResponseFeedbackKind.Bug}}we.to=Oe})(Tt||(e.InteractiveEditorResponseFeedbackKind=Tt={}));var Rt;(function(we){function Oe(Q){return{kind:"markdownContent",content:ne.from(Q.value)}}we.to=Oe;function se(Q){return new p.$hO(ne.to(Q.content))}we.from=se})(Rt||(e.ChatResponseMarkdownPart=Rt={}));var Lt;(function(we){function Oe(Q){const{value:Ee,baseUri:Be}=Q;function Xe(He,rt){return He.map(yt=>{const Kt=r.URI.joinPath(rt,yt.name);return{label:yt.name,uri:Kt,children:yt.children&&Xe(yt.children,Kt)}})}return{kind:"treeData",treeData:{label:(0,b.$Sg)(Be),uri:Be,children:Xe(Ee,Be)}}}we.to=Oe;function se(Q){const Ee=(0,k.$Rh)(Q.treeData);function Be(rt){return rt.map(yt=>({name:yt.label,children:yt.children&&Be(yt.children)}))}const Xe=Ee.uri,He=Ee.children?Be(Ee.children):[];return new p.$iO(He,Xe)}we.from=se})(Lt||(e.ChatResponseFilesPart=Lt={}));var ni;(function(we){function Oe(Q){return{kind:"inlineReference",name:Q.title,inlineReference:r.URI.isUri(Q.value)?Q.value:g.from(Q.value)}}we.to=Oe;function se(Q){const Ee=(0,k.$Rh)(Q);return new p.$jO(r.URI.isUri(Ee.inlineReference)?Ee.inlineReference:g.to(Ee.inlineReference),Q.name)}we.from=se})(ni||(e.ChatResponseAnchorPart=ni={}));var oi;(function(we){function Oe(Q){return{kind:"progressMessage",content:ne.from(Q.value)}}we.to=Oe;function se(Q){return new p.$kO(Q.content.value)}we.from=se})(oi||(e.ChatResponseProgressPart=oi={}));var qt;(function(we){function Oe(Q,Ee,Be){return{kind:"command",command:Ee.toInternal(Q.value,Be)??{command:Q.value.command,title:Q.value.title}}}we.to=Oe;function se(Q,Ee){return new p.$lO(Ee.fromInternal(Q.command)??{command:Q.command.id,title:Q.command.title})}we.from=se})(qt||(e.ChatResponseCommandButtonPart=qt={}));var It;(function(we){function Oe(Q){return{kind:"reference",reference:r.URI.isUri(Q.value)?Q.value:g.from(Q.value)}}we.to=Oe;function se(Q){const Ee=(0,k.$Rh)(Q);return new p.$mO(r.URI.isUri(Ee.reference)?Ee.reference:g.to(Ee.reference))}we.from=se})(It||(e.ChatResponseReferencePart=It={}));var Dt;(function(we){function Oe(Ee){return Ee instanceof p.$hO?Rt.to(Ee):Ee instanceof p.$jO?ni.to(Ee):Ee instanceof p.$mO?It.to(Ee):Ee instanceof p.$kO?oi.to(Ee):Ee instanceof p.$iO?Lt.to(Ee):{kind:"content",content:""}}we.to=Oe;function se(Ee,Be){switch(Ee.kind){case"reference":return It.from(Ee);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return Q(Ee,Be)}}we.from=se;function Q(Ee,Be){switch(Ee.kind){case"markdownContent":return Rt.from(Ee);case"inlineReference":return ni.from(Ee);case"progressMessage":return;case"treeData":return Lt.from(Ee);case"command":return qt.from(Ee,Be)}}we.fromContent=Q})(Dt||(e.ChatResponsePart=Dt={}));var Ht;(function(we){function Oe(Ee,Be){return"markdownContent"in Be?((0,w.$9F)(Ee,"chatParticipantAdditions"),{content:ne.from(Be.markdownContent),kind:"markdownContent"}):"content"in Be?"vulnerabilities"in Be&&Be.vulnerabilities?((0,w.$9F)(Ee,"chatParticipantAdditions"),{content:Be.content,vulnerabilities:Be.vulnerabilities,kind:"vulnerability"}):typeof Be.content=="string"?{content:Be.content,kind:"content"}:((0,w.$9F)(Ee,"chatParticipantAdditions"),{content:ne.from(Be.content),kind:"markdownContent"}):"documents"in Be?{documents:Be.documents.map(Xe=>({uri:Xe.uri,version:Xe.version,ranges:Xe.ranges.map(He=>D.from(He))})),kind:"usedContext"}:"reference"in Be?{reference:"uri"in Be.reference?{uri:Be.reference.uri,range:D.from(Be.reference.range)}:Be.reference,kind:"reference"}:"inlineReference"in Be?{inlineReference:"uri"in Be.inlineReference?{uri:Be.inlineReference.uri,range:D.from(Be.inlineReference.range)}:Be.inlineReference,name:Be.title,kind:"inlineReference"}:"participant"in Be?((0,w.$9F)(Ee,"chatParticipantAdditions"),{agentName:Be.participant,command:Be.command,kind:"agentDetection"}):"message"in Be?{content:ne.from(Be.message),kind:"progressMessage"}:void 0}we.from=Oe;function se(Ee){switch(Ee.kind){case"markdownContent":case"inlineReference":case"treeData":return we.to(Ee);case"content":return{content:Ee.content};case"usedContext":return{documents:Ee.documents.map(Be=>({uri:r.URI.revive(Be.uri),version:Be.version,ranges:Be.ranges.map(Xe=>D.to(Xe))}))};case"reference":return{reference:(0,r.$wc)(Ee.reference)?r.URI.revive(Ee.reference):g.to(Ee.reference)};case"agentDetection":return;case"progressMessage":return{message:Ee.content.value};case"vulnerability":return{content:Ee.content,vulnerabilities:Ee.vulnerabilities};default:return}}we.to=se;function Q(Ee,Be){switch(Ee.kind){case"markdownContent":return{content:Ee.content.value};case"inlineReference":return{inlineReference:(0,r.$wc)(Ee.inlineReference)?r.URI.revive(Ee.inlineReference):g.to(Ee.inlineReference),title:Ee.name};case"command":return{command:Be.fromInternal(Ee.command)??{command:Ee.command.id,title:Ee.command.title}};default:return}}we.toProgressContent=Q})(Ht||(e.ChatResponseProgress=Ht={}));var Ct;(function(we){function Oe(se){return{prompt:se.message,command:se.command,variables:se.variables.variables.map(St.to),location:wt.to(se.location)}}we.to=Oe})(Ct||(e.ChatAgentRequest=Ct={}));var wt;(function(we){function Oe(se){switch(se){case h.ChatAgentLocation.Notebook:return p.ChatLocation.Notebook;case h.ChatAgentLocation.Terminal:return p.ChatLocation.Terminal;case h.ChatAgentLocation.Panel:return p.ChatLocation.Panel}}we.to=Oe})(wt||(e.ChatLocation=wt={}));var St;(function(we){function Oe(se){return{name:se.name,range:se.range&&[se.range.start,se.range.endExclusive],values:se.values.map(Ut.to)}}we.to=Oe})(St||(e.ChatAgentResolvedVariable=St={}));var kt;(function(we){function Oe(se){return{label:se.label,values:se.values.map(Ut.from),insertText:se.insertText,detail:se.detail,documentation:se.documentation}}we.from=Oe})(kt||(e.ChatAgentCompletionItem=kt={}));var ui;(function(we){function Oe(se){return{errorDetails:se.errorDetails,metadata:se.metadata}}we.to=Oe})(ui||(e.ChatAgentResult=ui={}));var ri;(function(we){function Oe(se,Q,Ee){if(Q.action.kind==="vote")return;const Be=ui.to(se);return Q.action.kind==="command"?{action:{kind:"command",commandButton:Ht.toProgressContent(Q.action.commandButton,Ee)},result:Be}:Q.action.kind==="followUp"?{action:{kind:"followUp",followup:Ke.to(Q.action.followup)},result:Be}:{action:Q.action,result:Be}}we.to=Oe})(ri||(e.ChatAgentUserActionEvent=ri={}));var li;(function(we){function Oe(se,Q,Ee){return"terminalCommand"in se?{terminalCommand:se.terminalCommand,shouldExecute:se.shouldExecute}:"uri"in se?{uri:se.uri}:Q.toInternal(se,Ee)}we.from=Oe})(li||(e.TerminalQuickFix=li={}));var di;(function(we){function Oe(se){return{kind:Yt.to(se.kind)}}we.to=Oe})(di||(e.PartialAcceptInfo=di={}));var Yt;(function(we){function Oe(se){switch(se){case 0:return p.PartialAcceptTriggerKind.Word;case 1:return p.PartialAcceptTriggerKind.Line;case 2:return p.PartialAcceptTriggerKind.Suggest;default:return p.PartialAcceptTriggerKind.Unknown}}we.to=Oe})(Yt||(e.PartialAcceptTriggerKind=Yt={}));var At;(function(we){function Oe(se,Q){return{id:Q,label:se.label,description:se.description,canEdit:se.canEdit,collapsibleState:se.collapsibleState||0,contextValue:se.contextValue}}we.from=Oe})(At||(e.DebugTreeItem=At={}))}),define(Ce[252],Pe([1,0,4,17,8]),function($e,e,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ic=void 0;let N=class{constructor(m,d){this.a=m.getProxy(I.$kM.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>d.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,d,k){const F=P.WorkspaceEdit.from(m,this.b);return this.a.$tryApplyWorkspaceEdit(F,void 0,k?.isRefactoring??!1)}};e.$_ic=N,e.$_ic=N=Je([We(0,O.$FO)],N)}),define(Ce[253],Pe([1,0,18,11,42,5,39,6,64,16,2,162,20,4,8,7,213,22]),function($e,e,I,O,P,N,A,m,d,k,F,E,u,b,f,r,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bjc=void 0;class n{constructor(t,v,c,$,w,p){this.i=t,this.j=v,this.k=c,this.l=$,this.m=w,this.n=p,this.b=d.$3d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let v=function($){if(t.c){const w=new Error("Response stream has been closed");throw Error.captureStackTrace(w,$),w}};const t=this;this.b.reset();const c=$=>{typeof this.d>"u"&&"content"in $&&(this.d=this.b.elapsed()),this.k.$handleProgressChunk(this.j.requestId,$)};this.g={markdown($){v(this.markdown);const w=new r.$hO($),p=f.ChatResponseMarkdownPart.to(w);return c(p),this},filetree($,w){v(this.filetree);const p=new r.$iO($,w),l=f.ChatResponseFilesPart.to(p);return c(l),this},anchor($,w){v(this.anchor);const p=new r.$jO($,w),l=f.ChatResponseAnchorPart.to(p);return c(l),this},button($){v(this.anchor);const w=new r.$lO($),p=f.ChatResponseCommandButtonPart.to(w,t.m,t.n);return c(p),this},progress($){v(this.progress);const w=new r.$kO($),p=f.ChatResponseProgressPart.to(w);return c(p),this},reference($){v(this.reference);const w=new r.$mO($),p=f.ChatResponseReferencePart.to(w);return c(p),this},push($){v(this.push);const w=f.ChatResponsePart.to($);return c(w),this},report($){if(v(this.report),"placeholder"in $&&"resolvedContent"in $)return;const w=f.ChatResponseProgress.from(t.i,$);if(!w){t.l.error("Unknown progress type: "+JSON.stringify($));return}return c(w),this}}}return this.g}}class i{static{this.b=0}constructor(t,v,c){this.i=v,this.j=c,this.c=new Map,this.g=new m.$4c,this.d=t.getProxy(b.$kM.MainThreadChatAgents2)}createChatAgent(t,v,c){const $=i.b++,w=new a(t,v,this.d,$,c);return this.c.set($,w),this.d.$registerAgent($,t.identifier,v,{},(0,s.$8F)(t,"chatParticipantAdditions")),w.apiAgent}async $invokeAgent(t,v,c,$){const w=this.c.get(t);if(!w)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let p=this.g.get(v.sessionId);p||(p=new m.$Tc,this.g.set(v.sessionId,p));const l=new n(w.extension,v,this.d,this.i,this.j.converter,p);try{const D=await this.k(v.agentId,c),g=w.invoke(f.ChatAgentRequest.to(v),{history:D},l.apiObject,$);return await(0,O.$9g)(Promise.resolve(g).then(S=>{if(S?.metadata)try{JSON.stringify(S.metadata)}catch(y){const C=`result.metadata MUST be JSON.stringify-able. Got error: ${y.message}`;return this.i.error(`[${w.extension.identifier.value}] [@${w.id}] ${C}`,w.extension),{errorDetails:{message:C},timings:l.timings}}return{errorDetails:S?.errorDetails,timings:l.timings,metadata:S?.metadata}}),$)}catch(D){return this.i.error(D,w.extension),{errorDetails:{message:(0,E.localize)(0,null,(0,P.$6i)(D)),responseIsIncomplete:!0}}}finally{l.close()}}async k(t,v){const c=[];for(const $ of v.history){const w=f.ChatAgentResult.to($.result),p=t===$.request.agentId?w:{...w,metadata:void 0};c.push(new r.$nO($.request.message,$.request.command,$.request.variables.variables.map(f.ChatAgentResolvedVariable.to),{extensionId:"",name:$.request.agentId}));const l=(0,I.$Hb)($.response.map(D=>f.ChatResponsePart.fromContent(D,this.j.converter)));c.push(new r.$oO(l,p,{extensionId:"",name:$.request.agentId},$.request.command))}return c}$releaseSession(t){this.g.deleteAndDispose(t)}async $provideFollowups(t,v,c,$,w){const p=this.c.get(v);if(!p)return Promise.resolve([]);const l=await this.k(p.id,$),D=f.ChatAgentResult.to(c);return(await p.provideFollowups(D,{history:l},w)).filter(g=>{const S=!g.participant||A.Iterable.some(this.c.values(),y=>y.id===g.participant&&u.$Dm.equals(y.extension.identifier,p.extension.identifier));return S||this.i.warn(`[@${p.id}] ChatFollowup refers to an unknown participant: ${g.participant}`),S}).map(g=>f.ChatFollowup.from(g,t))}$acceptFeedback(t,v,c,$){const w=this.c.get(t);if(!w)return;const p=f.ChatAgentResult.to(v);let l;switch(c){case o.InteractiveSessionVoteDirection.Down:l=r.ChatResultFeedbackKind.Unhelpful;break;case o.InteractiveSessionVoteDirection.Up:l=r.ChatResultFeedbackKind.Helpful;break}w.acceptFeedback(Object.freeze($?{result:p,kind:l,reportIssue:$}:{result:p,kind:l}))}$acceptAction(t,v,c){const $=this.c.get(t);if(!$||c.action.kind==="vote")return;const w=f.ChatAgentUserActionEvent.to(v,c,this.j.converter);w&&$.acceptAction(Object.freeze(w))}async $invokeCompletionProvider(t,v,c){const $=this.c.get(t);return $?(await $.invokeCompletionProvider(v,c)).map(f.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,v){const c=this.c.get(t);if(c)return await c.provideWelcomeMessage(v)}async $provideSampleQuestions(t,v){const c=this.c.get(t);if(c)return(await c.provideSampleQuestions(v)).map($=>f.ChatFollowup.from($,void 0))}}e.$bjc=i;class a{constructor(t,v,c,$,w){this.extension=t,this.id=v,this.x=c,this.y=$,this.z=w,this.o=new N.$7d,this.p=new N.$7d}acceptFeedback(t){this.o.fire(t)}acceptAction(t){this.p.fire(t)}async invokeCompletionProvider(t,v){return this.s?await this.s.provider.provideCompletionItems(t,v)??[]:[]}async provideFollowups(t,v,c){if(!this.b)return[];const $=await this.b.provideFollowups(t,v,c);return $?$.filter(w=>!(w&&"commandId"in w)).filter(w=>!(w&&"message"in w)):[]}async provideWelcomeMessage(t){if(!this.t)return[];const v=await this.t.provideWelcomeMessage(t);return v?v.map(c=>typeof c=="string"?c:f.MarkdownString.from(c)):[]}async provideSampleQuestions(t){if(!this.t||!this.t.provideSampleQuestions)return[];const v=await this.t.provideSampleQuestions(t);return v||[]}get apiAgent(){let t=!1,v=!1;const c=()=>{t||v||(v=!0,queueMicrotask(()=>{this.x.$updateAgent(this.y,{description:this.c,fullName:this.d,icon:this.g?this.g instanceof F.URI?this.g:"light"in this.g?this.g.light:void 0:void 0,iconDark:this.g&&"dark"in this.g?this.g.dark:void 0,themeIcon:this.g instanceof r.$iN?this.g:void 0,hasFollowups:this.b!==void 0,isSecondary:this.n,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:f.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:f.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:f.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.q,isSticky:this.u,requester:this.w}),v=!1}))},$=this;return{get name(){return $.id},get description(){return $.c??""},set description(w){$.c=w,c()},get fullName(){return(0,s.$9F)($.extension,"defaultChatParticipant"),$.d??$.extension.displayName??$.extension.name},set fullName(w){(0,s.$9F)($.extension,"defaultChatParticipant"),$.d=w,c()},get iconPath(){return $.g},set iconPath(w){$.g=w,c()},get requestHandler(){return $.z},set requestHandler(w){(0,k.$6f)(typeof w=="function","Invalid request handler"),$.z=w},get followupProvider(){return $.b},set followupProvider(w){$.b=w,c()},get isDefault(){return(0,s.$9F)($.extension,"defaultChatParticipant"),$.i},set isDefault(w){(0,s.$9F)($.extension,"defaultChatParticipant"),$.i=w,c()},get helpTextPrefix(){return(0,s.$9F)($.extension,"defaultChatParticipant"),$.j},set helpTextPrefix(w){(0,s.$9F)($.extension,"defaultChatParticipant"),$.j=w,c()},get helpTextVariablesPrefix(){return(0,s.$9F)($.extension,"defaultChatParticipant"),$.k},set helpTextVariablesPrefix(w){(0,s.$9F)($.extension,"defaultChatParticipant"),$.k=w,c()},get helpTextPostfix(){return(0,s.$9F)($.extension,"defaultChatParticipant"),$.l},set helpTextPostfix(w){(0,s.$9F)($.extension,"defaultChatParticipant"),$.l=w,c()},get isSecondary(){return(0,s.$9F)($.extension,"defaultChatParticipant"),$.n},set isSecondary(w){(0,s.$9F)($.extension,"defaultChatParticipant"),$.n=w,c()},get sampleRequest(){return $.m},set sampleRequest(w){$.m=w,c()},get supportIssueReporting(){return(0,s.$9F)($.extension,"chatParticipantAdditions"),$.q},set supportIssueReporting(w){(0,s.$9F)($.extension,"chatParticipantAdditions"),$.q=w,c()},get onDidReceiveFeedback(){return $.o.event},set participantVariableProvider(w){if((0,s.$9F)($.extension,"chatParticipantAdditions"),$.s=w,w){if(!w.triggerCharacters.length)throw new Error("triggerCharacters are required");$.x.$registerAgentCompletionsProvider($.y,w.triggerCharacters)}else $.x.$unregisterAgentCompletionsProvider($.y)},get participantVariableProvider(){return(0,s.$9F)($.extension,"chatParticipantAdditions"),$.s},set welcomeMessageProvider(w){(0,s.$9F)($.extension,"defaultChatParticipant"),$.t=w,c()},get welcomeMessageProvider(){return(0,s.$9F)($.extension,"defaultChatParticipant"),$.t},onDidPerformAction:(0,s.$8F)(this.extension,"chatParticipantAdditions")?this.p.event:void 0,get isSticky(){return $.u},set isSticky(w){$.u=w,c()},set requester(w){$.w=w,c()},get requester(){return $.w},dispose(){t=!0,$.b=void 0,$.o.dispose(),$.x.$unregisterAgent($.y)}}}invoke(t,v,c,$){return this.z(t,v,c,$)}}}),define(Ce[254],Pe([1,0,14,6,4,8,7,22]),function($e,e,I,O,P,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ejc=void 0;class d{static{this.a=0}constructor(E){this.b=new Map,this.c=E.getProxy(P.$kM.MainThreadChatVariables)}async $resolveVariable(E,u,b,f){const r=this.b.get(E);if(r)try{if(r.resolver.resolve2){(0,m.$9F)(r.extension,"chatParticipantAdditions");const o=new k(u,this.c),s=await r.resolver.resolve2(r.data.name,{prompt:b},o.apiObject,f);if(s)return s.map(N.ChatVariable.from)}else{const o=await r.resolver.resolve(r.data.name,{prompt:b},f);if(o)return o.map(N.ChatVariable.from)}}catch(o){(0,I.$2)(o)}}registerVariableResolver(E,u,b,f){const r=d.a++;return this.b.set(r,{extension:E,data:{name:u,description:b},resolver:f}),this.c.$registerVariable(r,{name:u,description:b}),(0,O.$Sc)(()=>{this.b.delete(r),this.c.$unregisterVariable(r)})}}e.$ejc=d;class k{constructor(E,u){this.c=E,this.d=u,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let u=function(f){if(E.a){const r=new Error("Response stream has been closed");throw Error.captureStackTrace(r,f),r}};const E=this,b=f=>{this.d.$handleProgressChunk(this.c,f)};this.b={progress(f){u(this.progress);const r=new A.$kO(f),o=N.ChatResponseProgressPart.to(r);return b(o),this},reference(f){u(this.reference);const r=new A.$mO(f),o=N.ChatResponseReferencePart.to(r);return b(o),this},push(f){u(this.push);const r=N.ChatResponsePart.to(f);return b(r),this}}}return this.b}}}),define(Ce[255],Pe([1,0,11,68,5,6,2,87,20,8,7,4,22]),function($e,e,I,O,P,N,A,m,d,k,F,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ijc=b;function b(f,r,o){const s=f.getProxy(E.$kM.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new d.$Fm,r.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const D=this.b.get(l.handle);return D?D.value:l}else if(l&&l.$mid===7){const D=l,g=this.b.get(D.commentControlHandle);if(!g)return D;const S=g.getCommentThread(D.commentThreadHandle);return S?S.value:D}else if(l&&(l.$mid===9||l.$mid===8)){const D=this.b.get(l.thread.commentControlHandle);if(!D)return l;const g=D.getCommentThread(l.thread.commentThreadHandle);return g?l.$mid===8?g.value:{thread:g.value,text:l.text}:l}else if(l&&l.$mid===10){const D=this.b.get(l.thread.commentControlHandle);if(!D)return l;const g=D.getCommentThread(l.thread.commentThreadHandle);if(!g)return l;const S=l.commentUniqueId,y=g.getCommentByUniqueId(S);return y||l}else if(l&&l.$mid===11){const D=this.b.get(l.thread.commentControlHandle);if(!D)return l;const g=D.getCommentThread(l.thread.commentThreadHandle);if(!g)return l;const S=l.text,y=l.commentUniqueId,C=g.getCommentByUniqueId(y);return C?(typeof C.body=="string"?C.body=S:C.body=new F.$NM(S),C):l}return l}})}createCommentController(l,D,g){const S=n.a++,y=new a(l,S,D,g);this.b.set(y.handle,y);const C=this.c.get(l.identifier)||[];return C.push(y),this.c.set(l.identifier,C),y.value}async $createCommentThreadTemplate(l,D,g){const S=this.b.get(l);S&&S.$createCommentThreadTemplate(D,g)}async $setActiveComment(l,D){const g=this.b.get(l);g&&g.$setActiveComment(D??void 0)}async $updateCommentThreadTemplate(l,D,g){const S=this.b.get(l);S&&S.$updateCommentThreadTemplate(D,g)}$deleteCommentThread(l,D){this.b.get(l)?.$deleteCommentThread(D)}async $provideCommentingRanges(l,D,g){const S=this.b.get(l);if(!S||!S.commentingRangeProvider)return Promise.resolve(void 0);const y=await o.ensureDocumentData(A.URI.revive(D));return(0,I.$ah)(async()=>{const C=await S.commentingRangeProvider.provideCommentingRanges(y.document,g);let R;return Array.isArray(C)?R={ranges:C,fileComments:!1}:C?R={ranges:C.ranges||[],fileComments:C.fileComments||!1}:R=C??void 0,R}).then(C=>{let R;return C&&(R={ranges:C.ranges.map(V=>k.Range.from(V)),fileComments:C.fileComments}),R})}$toggleReaction(l,D,g,S,y){const C=this.b.get(l);return!C||!C.reactionHandler?Promise.resolve(void 0):(0,I.$ah)(()=>{const R=C.getCommentThread(D);if(R){const V=R.getCommentByUniqueId(S.uniqueIdInThread);if(C!==void 0&&V&&C.reactionHandler)return C.reactionHandler(V,v(y))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){(l===void 0!=(this.p===void 0)||!l||!this.p||!l.isEqual(this.p))&&(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return this.h}set state(l){this.h=l,typeof l=="object"?((0,u.$9F)(this.extensionDescription,"commentThreadApplicability"),this.b.state=l.resolved,this.b.applicability=l.applicability):this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,D,g,S,y,C,R,V){this.m=D,this.n=g,this.o=S,this.p=y,this.q=C,this.extensionDescription=R,this.r=V,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$7d,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new N.$Vc,this.l.value=new N.$Tc,this.n===void 0&&(this.n=`${l}.${this.handle}`),s.$createCommentThread(D,this.handle,this.n,this.o,k.Range.from(this.p),R.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=C,this.i.push({dispose:()=>{s.$deleteCommentThread(D,this.handle)}});const U=this;this.value={get uri(){return U.uri},get range(){return U.range},set range(q){U.range=q},get comments(){return U.comments},set comments(q){U.comments=q},get collapsibleState(){return U.collapsibleState},set collapsibleState(q){U.collapsibleState=q},get canReply(){return U.canReply},set canReply(q){U.canReply=q},get contextValue(){return U.contextValue},set contextValue(q){U.contextValue=q},get label(){return U.label},set label(q){U.label=q},get state(){return U.state},set state(q){U.state=q},dispose:()=>{U.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new N.$Tc);const l=g=>Object.prototype.hasOwnProperty.call(this.b,g),D={};l("range")&&(D.range=k.Range.from(this.p)),l("label")&&(D.label=this.label),l("contextValue")&&(D.contextValue=this.contextValue??null),l("comments")&&(D.comments=this.q.map(g=>h(this,g,this.k,this.extensionDescription))),l("collapsibleState")&&(D.collapseState=c(this.g)),l("canReply")&&(D.canReply=this.canReply),l("state")&&(D.state=$(this.h)),l("applicability")&&(D.applicability=w(this.h)),l("isTemplate")&&(D.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,D)}getCommentByUniqueId(l){for(const D of this.k){const g=D[0],S=D[1];if(l===S)return g}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}Je([(0,O.$Nh)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class a{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,l?.resourceHints&&(0,u.$9F)(this.h,"commentingRangeHint"),s.$updateCommentingRanges(this.handle,l?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,u.$9F)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,u.$9F)(this.h,"activeComment"),this.f}constructor(l,D,g,S){this.h=l,this.i=D,this.j=g,this.k=S,this.a=new Map,s.$registerCommentController(this.handle,g,S,this.h.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(C){y.options=C},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(C){y.commentingRangeProvider=C},get reactionHandler(){return y.reactionHandler},set reactionHandler(C){y.reactionHandler=C},get activeCommentThread(){return y.activeCommentThread},createCommentThread(C,R,V){return y.createCommentThread(C,R,V).value},dispose:()=>{y.dispose()}}),this.g=[],this.g.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(l,D,g){D===void 0&&(0,u.$9F)(this.h,"fileComments");const S=new i(this.id,this.handle,void 0,l,D,g,this.h,!1);return this.a.set(S.handle,S),S}$setActiveComment(l){if(!l){this.e=void 0,this.f=void 0;return}const D=this.a.get(l.commentThreadHandle);D&&(this.e=l.uniqueIdInThread?D.getCommentByUniqueId(l.uniqueIdInThread):void 0,this.f=D)}$createCommentThreadTemplate(l,D){const g=new i(this.id,this.handle,void 0,A.URI.revive(l),k.Range.to(D),[],this.h,!0);return g.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(g.handle,g),g}$updateCommentThreadTemplate(l,D){const g=this.a.get(l);g&&(g.range=k.Range.to(D))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.g.forEach(l=>l.dispose())}}function h(p,l,D,g){let S=D.get(l);return S||(S=++p.commentHandle,D.set(l,S)),l.state!==void 0&&(0,u.$9F)(g,"commentsDraftState"),l.reactions?.some(y=>y.reactors!==void 0)&&(0,u.$9F)(g,"commentReactor"),{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:S,body:typeof l.body=="string"?l.body:k.MarkdownString.from(l.body),userName:l.author.name,userIconPath:l.author.iconPath,label:l.label,commentReactions:l.reactions?l.reactions.map(y=>t(y)):void 0,state:l.state,timestamp:l.timestamp?.toJSON()}}function t(p){return{label:p.label,iconPath:p.iconPath?k.$EO(p.iconPath):void 0,count:p.count,hasReacted:p.authorHasReacted,reactors:p.reactors&&p.reactors.length>0&&typeof p.reactors[0]!="string"?p.reactors.map(l=>l.name):p.reactors}}function v(p){return{label:p.label||"",count:p.count||0,iconPath:p.iconPath?A.URI.revive(p.iconPath):"",authorHasReacted:p.hasReacted||!1,reactors:p.reactors?.map(l=>({name:l}))}}function c(p){if(p!==void 0)switch(p){case F.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case F.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function $(p){let l;if(typeof p=="object"?l=p.resolved:l=p,l!==void 0)switch(l){case F.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case F.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}function w(p){let l;if(typeof p=="object"&&(l=p.applicability),l!==void 0)switch(l){case F.CommentThreadApplicability.Current:return m.CommentThreadApplicability.Current;case F.CommentThreadApplicability.Outdated:return m.CommentThreadApplicability.Outdated}return m.CommentThreadApplicability.Current}return new n}}),define(Ce[256],Pe([1,0,25,99,6,12,24,2,8,62,74,4,7]),function($e,e,I,O,P,N,A,m,d,k,F,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ajc=void 0;class b{constructor(v,c){this.document=v,this.b=c,this.a=1,this.c=new F.$Xic("custom documents")}addEdit(v){return this.c.add([v])}async undo(v,c){await this.f(v).undo(),c||this.disposeBackup()}async redo(v,c){await this.f(v).redo(),c||this.disposeBackup()}disposeEdits(v){for(const c of v)this.c.delete(c)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const v=h(this.document.uri)+this.a++;return(0,A.$Vg)(this.b,v)}updateBackup(v){this.d?.delete(),this.d=v}disposeBackup(){this.d?.delete(),this.d=void 0}f(v){const c=this.c.get(v,0);if(!c)throw new Error("No edit found");return c}}class f{constructor(){this.a=new Map}get(v,c){return this.a.get(this.b(v,c))}add(v,c,$){const w=this.b(v,c.uri);if(this.a.has(w))throw new Error(`Document already exists for viewType:${v} resource:${c.uri}`);const p=new b(c,$);return this.a.set(w,p),p}delete(v,c){const $=this.b(v,c.uri);this.a.delete($)}b(v,c){return`${v}@@@${c}`}}var r;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(r||(r={}));class o{constructor(){this.a=new Map}addTextProvider(v,c,$){return this.b(0,v,c,$)}addCustomProvider(v,c,$){return this.b(1,v,c,$)}get(v){return this.a.get(v)}b(v,c,$,w){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,{type:v,extension:$,provider:w}),new u.$mM(()=>this.a.delete(c))}}class s{constructor(v,c,$,w,p){this.d=c,this.f=$,this.g=w,this.h=p,this.b=new o,this.c=new f,this.a=v.getProxy(E.$kM.MainThreadCustomEditors)}registerCustomEditorProvider(v,c,$,w){const p=new P.$Tc;return i($)?(p.add(this.b.addTextProvider(c,v,$)),this.a.$registerTextEditorProvider((0,k.$xjc)(v),c,w.webviewOptions||{},{supportsMove:!!$.moveCustomTextEditor},(0,k.$vjc)(v))):(p.add(this.b.addCustomProvider(c,v,$)),n($)&&p.add($.onDidChangeCustomDocument(l=>{const D=this.i(c,l.document.uri);if(a(l)){const g=D.addEdit(l);this.a.$onDidEdit(l.document.uri,c,g,l.label)}else this.a.$onContentChange(l.document.uri,c)})),this.a.$registerCustomEditorProvider((0,k.$xjc)(v),c,w.webviewOptions||{},!!w.supportsMultipleEditorsPerDocument,(0,k.$vjc)(v))),u.$mM.from(p,new u.$mM(()=>{this.a.$unregisterEditorProvider(c)}))}async $createCustomDocument(v,c,$,w,p){const l=this.b.get(c);if(!l)throw new Error(`No provider found for '${c}'`);if(l.type!==1)throw new Error(`Invalid provide type for '${c}'`);const D=m.URI.revive(v),g=await l.provider.openCustomDocument(D,{backupId:$,untitledDocumentData:w?.buffer},p);let S;return n(l.provider)&&this.f&&(S=this.f.workspaceValue(l.extension)??this.f.globalValue(l.extension)),this.c.add(c,g,S),{editable:n(l.provider)}}async $disposeCustomDocument(v,c){const $=this.b.get(c);if(!$)throw new Error(`No provider found for '${c}'`);if($.type!==1)throw new Error(`Invalid provider type for '${c}'`);const w=m.URI.revive(v),{document:p}=this.i(c,w);this.c.delete(c,p),p.dispose()}async $resolveCustomEditor(v,c,$,w,p,l){const D=this.b.get($);if(!D)throw new Error(`No provider found for '${$}'`);const g=d.ViewColumn.to(p),S=this.g.createNewWebview(c,w.contentOptions,D.extension),y=this.h.createNewWebviewPanel(c,$,w.title,g,w.options,S,w.active),C=m.URI.revive(v);switch(D.type){case 1:{const{document:R}=this.i($,C);return D.provider.resolveCustomEditor(R,y,l)}case 0:{const R=this.d.getDocument(C);return D.provider.resolveCustomTextEditor(R,y,l)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(v,c,$){this.i(c,v).disposeEdits($)}async $onMoveCustomEditor(v,c,$){const w=this.b.get($);if(!w)throw new Error(`No provider found for '${$}'`);if(!w.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${$}'`);const p=this.h.getWebviewPanel(v);if(!p)throw new Error("No webview found");const l=m.URI.revive(c),D=this.d.getDocument(l);await w.provider.moveCustomTextEditor(D,p,I.CancellationToken.None)}async $undo(v,c,$,w){return this.i(c,v).undo($,w)}async $redo(v,c,$,w){return this.i(c,v).redo($,w)}async $revert(v,c,$){const w=this.i(c,v);await this.j(c).revertCustomDocument(w.document,$),w.disposeBackup()}async $onSave(v,c,$){const w=this.i(c,v);await this.j(c).saveCustomDocument(w.document,$),w.disposeBackup()}async $onSaveAs(v,c,$,w){const p=this.i(c,v);return this.j(c).saveCustomDocumentAs(p.document,m.URI.revive($),w)}async $backup(v,c,$){const w=this.i(c,v),l=await this.j(c).backupCustomDocument(w.document,{destination:w.getNewBackupUri()},$);return w.updateBackup(l),l.id}i(v,c){const $=this.c.get(v,m.URI.revive(c));if(!$)throw new Error("No custom document found");return $}j(v){const $=this.b.get(v)?.provider;if(!$||!n($))throw new Error("Custom document is not editable");return $}}e.$Ajc=s;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function a(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function h(t){const v=t.scheme===N.Schemas.file||t.scheme===N.Schemas.untitled?t.fsPath:t.toString();return(0,O.$9i)(v)+""}}),define(Ce[257],Pe([1,0,163,100,2,4,7,8,5,13,28,44]),function($e,e,I,O,P,N,A,m,d,k,F,E){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$6ic=e.$5ic=void 0;class b{#e;#t;#i;constructor(o,s,n,i,a,h,t,v){this.d=o,this.e=s,this.f=n,this.g=i,this.h=a,this.c=!1,this.f=Math.max(i,n),this.#i=new F.$Bc(c=>h.getComparisonKey(c)),this.#e=t,this.#t=v}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,s){if(!o){this.clear();return}this.j();let n=[];if(P.URI.isUri(o)){if(!s){this.delete(o);return}this.#i.set(o,s.slice()),n=[o]}else if(Array.isArray(o)){n=[];let h;o=[...o].sort(b.k);for(const t of o){const[v,c]=t;if((!h||v.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=v,n.push(v),this.#i.set(v,[])),c)this.#i.get(v)?.push(...c);else{const $=this.#i.get(v);$&&($.length=0)}}}if(this.#t.fire(n),!this.#e)return;const i=[];let a=0;for(const h of n){let t=[];const v=this.#i.get(h);if(v)if(v.length>this.g){t=[];const c=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let $=0;$<4;$++)for(const w of v)if(w.severity===c[$]&&t.push({...m.Diagnostic.from(w),modelVersionId:this.h(h)})===this.g)break e;t.push({severity:O.MarkerSeverity.Info,message:(0,I.localize)(0,null,v.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=v.map(c=>({...m.Diagnostic.from(c),modelVersionId:this.h(h)}));if(i.push([h,t]),a+=t.length,a>this.f)break}this.#e.$changeMany(this.e,i)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,s){this.j();for(const[n,i]of this)o.call(s,n,i,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const s=this.#i.get(o);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,s){return o[0].toString()<s[0].toString()?-1:o[0].toString()>s[0].toString()?1:0}}e.$5ic=b;let f=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(o){const s=new F.$Bc;for(const n of o)s.set(n,n);return{uris:Object.freeze(Array.from(s.values()))}}constructor(o,s,n,i){this.j=s,this.k=n,this.l=i,this.g=new Map,this.h=new d.$$d({merge:a=>a.flat(),delay:50}),this.onDidChangeDiagnostics=d.Event.map(this.h.event,u._mapper),this.f=o.getProxy(N.$kM.MainThreadDiagnostics)}createDiagnosticCollection(o,s){const{g:n,f:i,h:a,j:h,k:t,l:v}=this,c=new class{$changeMany(p,l){i.$changeMany(p,l),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,p,l.length===0?"CLEARING":l)}$clear(p){i.$clear(p),h.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,p)}dispose(){i.dispose()}};let $;if(!s)s="_generated_diagnostic_collection_name_#"+u.c++,$=s;else if(!n.has(s))$=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do $=s+u.c++;while(n.has($))}return new class extends b{constructor(){super(s,$,u.e,u.d,p=>v.getDocument(p)?.version,t.extUri,c,a),n.set($,this)}dispose(){super.dispose(),n.delete($)}}}getDiagnostics(o){if(o)return this.m(o);{const s=new Map,n=[];for(const i of this.g.values())i.forEach((a,h)=>{let t=s.get(a.toString());typeof t>"u"&&(t=n.length,s.set(a.toString(),t),n.push([a,[]])),n[t][1]=n[t][1].concat(...h)});return n}}m(o){let s=[];for(const n of this.g.values())n.has(o)&&(s=s.concat(n.get(o)));return s}$acceptMarkersChange(o){if(!this.n){const s="_generated_mirror",n=new b(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(s,n),this.n=n}for(const[s,n]of o)this.n.set(P.URI.revive(s),n.map(m.Diagnostic.to))}};e.$6ic=f,e.$6ic=f=u=Je([We(1,k.$Oj),We(2,E.$4ic)],f)}),define(Ce[258],Pe([1,0,2,14,7,8,191]),function($e,e,I,O,P,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ckc=void 0;class m{constructor(k,F,E,u={timeout:1500,errors:3}){this.c=k,this.d=F,this.f=E,this.g=u,this.a=new A.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(F,E,u)=>{const f={dispose:this.a.push([F,E,k])};return Array.isArray(u)&&u.push(f),f}}async $participateInSave(k,F){const E=I.URI.revive(k);let u=!1;const b=setTimeout(()=>u=!0,this.g.timeout),f=[];try{for(const r of[...this.a]){if(u)break;const o=this.d.getDocument(E),s=await this.h(r,{document:o,reason:N.TextDocumentSaveReason.to(F)});f.push(s)}}finally{clearTimeout(b)}return f}h([k,F,E],u){const b=this.b.get(k);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(E,k,F,u).then(()=>!0,f=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' threw ERROR`),this.c.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const r=this.b.get(k);this.b.set(k,r?r+1:1),typeof r=="number"&&r>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,F,E,u){const b=[],f=Date.now(),{document:r,reason:o}=u,{version:s}=r,n=Object.freeze({document:r,reason:o,waitUntil(i){if(Object.isFrozen(b))throw(0,O.$8)("waitUntil can not be called async");b.push(Promise.resolve(i))}});try{F.apply(E,[n])}catch(i){return Promise.reject(i)}return Object.freeze(b),new Promise((i,a)=>{const h=setTimeout(()=>a(new Error("timeout")),this.g.timeout);return Promise.all(b).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(h),i(t)}).catch(t=>{clearTimeout(h),a(t)})}).then(i=>{const a={edits:[]};for(const h of i)if(Array.isArray(h)&&h.every(t=>t instanceof P.$tM))for(const{newText:t,newEol:v,range:c}of h)a.edits.push({resource:r.uri,versionId:void 0,textEdit:{range:c&&N.Range.from(c),text:t,eol:v&&N.EndOfLine.from(v)}});if(a.edits.length!==0)return s===r.version?this.f.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.$ckc=m}),define(Ce[259],Pe([1,0,5,6,2,4,111,8,16,26,7]),function($e,e,I,O,P,N,A,m,d,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ic=void 0;class E{constructor(b,f){this.a=new I.$7d,this.b=new I.$7d,this.c=new I.$7d,this.d=new I.$7d,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new O.$Tc,this.h=new Map,this.f=b.getProxy(N.$kM.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(r=>{for(const o of r)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const o of r)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(b){if(!b)return;const f=this.g.getDocument(b);if(f)return f}getDocument(b){const f=this.getDocumentData(b);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return f.document}ensureDocumentData(b){const f=this.g.getDocument(b);if(f)return Promise.resolve(f);let r=this.h.get(b.toString());return r||(r=this.f.$tryOpenDocument(b).then(o=>{this.h.delete(b.toString());const s=P.URI.revive(o);return(0,d.$7f)(this.g.getDocument(s))},o=>(this.h.delete(b.toString()),Promise.reject(o))),this.h.set(b.toString(),r)),r}createDocumentData(b){return this.f.$tryCreateDocument(b).then(f=>P.URI.revive(f))}$acceptModelLanguageChanged(b,f){const r=P.URI.revive(b),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(f),this.a.fire(o.document)}$acceptModelSaved(b){const f=P.URI.revive(b),r=this.g.getDocument(f);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(b,f){const r=P.URI.revive(b),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(f),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,f,r){const o=P.URI.revive(b),s=this.g.getDocument(o);if(!s)throw new Error("unknown document");s._acceptIsDirty(r),s.onEvents(f);let n;f.isUndoing?n=F.TextDocumentChangeReason.Undo:f.isRedoing&&(n=F.TextDocumentChangeReason.Redo),this.c.fire((0,k.$Pn)({document:s.document,contentChanges:f.changes.map(i=>({range:m.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(b,f){(0,A.$HO)(b,f)}}e.$7ic=E}),define(Ce[65],Pe([1,0,260,5,16,2,3,4,17,8,7]),function($e,e,I,O,P,N,A,m,d,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cjc=e.$Bjc=void 0,e.$Bjc=(0,A.$ii)("IExtHostEditorTabs");class E{constructor(o,s,n){this.e=n,this.d=s,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new F.$8N(N.URI.revive(this.b.input.uri));case 2:return new F.$9N(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified));case 3:return new F.$0N(N.URI.revive(this.b.input.base),N.URI.revive(this.b.input.input1),N.URI.revive(this.b.input.input2),N.URI.revive(this.b.input.result));case 6:return new F.$$N(N.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new F.$_N(this.b.input.viewType);case 4:return new F.$aO(N.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new F.$bO(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new F.$cO;case 9:return new F.$dO(N.URI.revive(this.b.input.uri),N.URI.revive(this.b.input.inputBoxUri));case 10:return new F.$eO(this.b.input.providerId);case 11:return new F.$fO(this.b.input.diffEditors.map(o=>new F.$9N(N.URI.revive(o.original),N.URI.revive(o.modified))));default:return}}}class u{constructor(o,s){this.c=[],this.d="",this.b=o,this.e=s;for(const n of o.tabs)n.isActive&&(this.d=n.id),this.c.push(new E(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,s={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return k.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(n=>n.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(n=>n.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const n=new E(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,n),o.tabDto.isActive&&(this.d=n.tabId),n}else if(o.kind===1){const n=this.c.splice(o.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(o.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,n),n}const s=this.c.find(n=>n.tabId===o.tabDto.id);if(!s)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(o.tabDto),s}activeTabId(){return this.d}}let b=class{constructor(o){this.b=new O.$7d,this.c=new O.$7d,this.e=[],this.a=o.getProxy(m.$kM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,s={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(n=>n.apiObject))},get activeTabGroup(){const n=o.d;return(0,P.$7f)(o.e.find(a=>a.groupId===n)?.apiObject)},close:async(n,i)=>{const a=Array.isArray(n)?n:[n];return a.length?f(a[0])?this.j(a,i):this.i(a,i):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(o){const s=new Set(this.e.map(c=>c.groupId)),n=new Set(o.map(c=>c.groupId)),i=(0,I.$L)(s,n),a=this.e.filter(c=>i.removed.includes(c.groupId)).map(c=>c.apiObject),h=[],t=[];this.e=o.map(c=>{const $=new u(c,()=>this.d);return i.added.includes($.groupId)?h.push($.apiObject):t.push($.apiObject),$});const v=(0,P.$7f)(o.find(c=>c.isActive===!0)?.groupId);v!==void 0&&this.d!==v&&(this.d=v),this.c.fire(Object.freeze({opened:h,closed:a,changed:t}))}$acceptTabGroupUpdate(o){const s=this.e.find(n=>n.groupId===o.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const s=this.e.find(i=>i.groupId===o.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const n=s.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(o){for(const s of this.e)for(const n of s.tabs)if(n.apiObject===o)return n}h(o){return this.e.find(s=>s.apiObject===o)}async i(o,s){const n=[];for(const i of o){const a=this.g(i);if(!a)throw new Error("Tab close: Invalid tab not found!");n.push(a.tabId)}return this.a.$closeTab(n,s)}async j(o,s){const n=[];for(const i of o){const a=this.h(i);if(!a)throw new Error("Group close: Invalid group not found!");n.push(a.groupId)}return this.a.$closeGroup(n,s)}};e.$Cjc=b,e.$Cjc=b=Je([We(0,d.$FO)],b);function f(r){return r.tabs!==void 0}}),define(Ce[261],Pe([1,0,2,4,6,7,8,304,15,23,22,53]),function($e,e,I,O,P,N,A,m,d,k,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ekc=void 0;class u{constructor(){this.a=[]}add(r){this.b=void 0,this.a.push(r)}delete(r){const o=this.a.indexOf(r);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const r=this.a.sort(),o=[];let s,n,i=14,a=14;for(const h of r){let t=s?(0,d.$nf)(s,h):0;for(t===0?n=1:n=a;t<h.length;t++)t+1===h.length?(i=a,a=9):a+=1,o.push([n,h.toUpperCase().charCodeAt(t),a]),o.push([n,h.toLowerCase().charCodeAt(t),a]),n=a;s=h,a=i}o.push([9,58,10]),o.push([10,47,12]),this.b=new m.$n2(o)}}provideDocumentLinks(r){this.c();const o=[],s=m.$o2.computeLinks({getLineContent(n){return r.lineAt(n-1).text},getLineCount(){return r.lineCount}},this.b);for(const n of s){const i=A.DocumentLink.to(n);i.target&&o.push(i)}return o}}class b{constructor(r,o){this.i=o,this.b=new u,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=r.getProxy(O.$kM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(r,o,s,n={}){if(b.j(s),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(r,"*",this.b));const i=this.h++;this.b.add(o),this.d.add(o),this.c.set(i,s);let a=2;n.isCaseSensitive&&(a+=1024),n.isReadonly&&(a+=2048),typeof s.copy=="function"&&(a+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,F.$9F)(r,"fsChunks"),a+=4);let h;n.isReadonly&&(0,E.$Hk)(n.isReadonly)&&n.isReadonly.value!==""&&(h={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(i,o,a,h).catch(v=>{console.error(`FAILED to register filesystem provider of ${r.identifier.value}-extension for the scheme ${o}`),console.error(v)});const t=s.onDidChangeFile(v=>{const c=[];for(const $ of v){const{uri:w,type:p}=$;if(w.scheme!==o)continue;let l;switch(p){case N.FileChangeType.Changed:l=0;break;case N.FileChangeType.Created:l=1;break;case N.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:w,type:l})}this.a.$onFileSystemChange(i,c)});return(0,P.$Sc)(()=>{t.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(r){if(!r)throw new Error("MISSING provider");if(typeof r.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof r.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof r.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof r.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof r.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof r.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof r.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof r.rename!="function")throw new Error("Provider does NOT implement rename")}static k(r){const{type:o,ctime:s,mtime:n,size:i,permissions:a}=r;return{type:o,ctime:s,mtime:n,size:i,permissions:a}}$stat(r,o){return Promise.resolve(this.l(r).stat(I.URI.revive(o))).then(s=>b.k(s))}$readdir(r,o){return Promise.resolve(this.l(r).readDirectory(I.URI.revive(o)))}$readFile(r,o){return Promise.resolve(this.l(r).readFile(I.URI.revive(o))).then(s=>k.$ue.wrap(s))}$writeFile(r,o,s,n){return Promise.resolve(this.l(r).writeFile(I.URI.revive(o),s.buffer,n))}$delete(r,o,s){return Promise.resolve(this.l(r).delete(I.URI.revive(o),s))}$rename(r,o,s,n){return Promise.resolve(this.l(r).rename(I.URI.revive(o),I.URI.revive(s),n))}$copy(r,o,s,n){const i=this.l(r);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(I.URI.revive(o),I.URI.revive(s),n))}$mkdir(r,o){return Promise.resolve(this.l(r).createDirectory(I.URI.revive(o)))}$watch(r,o,s,n){const i=this.l(r).watch(I.URI.revive(s),n);this.f.set(o,i)}$unwatch(r,o){const s=this.f.get(o);s&&(s.dispose(),this.f.delete(o))}$open(r,o,s){const n=this.l(r);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(I.URI.revive(o),s))}$close(r,o){const s=this.l(r);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(o))}$read(r,o,s,n){const i=this.l(r);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const a=k.$ue.alloc(n);return Promise.resolve(i.read(o,s,a.buffer,0,n)).then(h=>a.slice(0,h))}$write(r,o,s,n){const i=this.l(r);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(o,s,n.buffer,0,n.byteLength))}l(r){const o=this.c.get(r);if(!o){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return o}}e.$ekc=b}),define(Ce[262],Pe([1,0,5,35,2,4,8,7,40]),function($e,e,I,O,P,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fkc=void 0;class k{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(b,f,r,o,s,n){this.a=Math.random(),this.b=new I.$7d,this.c=new I.$7d,this.d=new I.$7d,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const i=(0,O.$ck)(s),a=typeof s=="string",h=n?.correlate,t=o(v=>{if(!(typeof v.session=="number"&&v.session!==this.a)&&!(h&&typeof v.session>"u")){if(!n?.ignoreCreateEvents)for(const c of v.created){const $=P.URI.revive(c);i($.fsPath)&&(!a||f.getWorkspaceFolder($))&&this.b.fire($)}if(!n?.ignoreChangeEvents)for(const c of v.changed){const $=P.URI.revive(c);i($.fsPath)&&(!a||f.getWorkspaceFolder($))&&this.c.fire($)}if(!n?.ignoreDeleteEvents)for(const c of v.deleted){const $=P.URI.revive(c);i($.fsPath)&&(!a||f.getWorkspaceFolder($))&&this.d.fire($)}}});this.g=m.$mM.from(this.i(b,r,s,n,n?.correlate),this.b,this.c,this.d,t)}i(b,f,r,o,s){const n=m.$mM.from();if(typeof r=="string")return n;const i=b.getProxy(N.$kM.MainThreadFileSystemEventService);let a=!1;return(r.pattern.includes(O.$$j)||r.pattern.includes(O.$_j))&&(a=!0),i.$watch(f.identifier.value,this.a,r.baseUri,{recursive:a,excludes:o?.excludes??[]},!!s),m.$mM.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class F{constructor(b){this.a=b,this.session=this.a.session,this.b=new d.$V(()=>this.a.created.map(P.URI.revive)),this.c=new d.$V(()=>this.a.changed.map(P.URI.revive)),this.d=new d.$V(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class E{constructor(b,f,r){this.j=b,this.k=f,this.l=r,this.a=new I.$7d,this.b=new I.$7d,this.c=new I.$7d,this.d=new I.$7d,this.g=new I.$9d,this.h=new I.$9d,this.i=new I.$9d,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(b,f,r,o){return new k(this.j,b,f,this.a.event,A.GlobPattern.from(r),o)}$onFileEvent(b){this.a.fire(new F(b))}$onDidRunFileOperation(b,f){switch(b){case 2:this.b.fire(Object.freeze({files:f.map(r=>({oldUri:P.URI.revive(r.source),newUri:P.URI.revive(r.target)}))}));break;case 1:this.d.fire(Object.freeze({files:f.map(r=>P.URI.revive(r.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:f.map(r=>P.URI.revive(r.target))}));break;default:}}getOnWillRenameFileEvent(b){return this.m(b,this.g)}getOnWillCreateFileEvent(b){return this.m(b,this.h)}getOnWillDeleteFileEvent(b){return this.m(b,this.i)}m(b,f){return(r,o,s)=>{const n=function(a){r.call(o,a)};return n.extension=b,f.event(n,void 0,s)}}async $onWillRunFileOperation(b,f,r,o){switch(b){case 2:return await this.n(this.g,{files:f.map(s=>({oldUri:P.URI.revive(s.source),newUri:P.URI.revive(s.target)}))},r,o);case 1:return await this.n(this.i,{files:f.map(s=>P.URI.revive(s.target))},r,o);case 0:case 3:return await this.n(this.h,{files:f.map(s=>P.URI.revive(s.target))},r,o)}}async n(b,f,r,o){const s=new Set,n=[];if(await b.fireAsync(f,o,async(a,h)=>{const t=Date.now(),v=await Promise.resolve(a);v instanceof m.$wM&&(n.push([h.extension,v]),s.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-t>r&&this.k.warn("SLOW file-participant",h.extension.identifier)}),o.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,a]of n){const{edits:h}=A.WorkspaceEdit.from(a,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(h)}return{edit:i,extensionNames:Array.from(s)}}}e.$fkc=E}),define(Ce[263],Pe([1,0,18,11,25,14,90,6,26,64,15,16,2,29,305,87,97,165,20,8,7,22,74,4]),function($e,e,I,O,P,N,A,m,d,k,F,E,u,b,f,r,o,s,n,i,a,h,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ic=void 0;class c{constructor(z,j){this.d=z,this.e=j}async provideDocumentSymbols(z,j){const K=this.d.getDocument(z),H=await this.e.provideDocumentSymbols(K,j);if(!(0,I.$Kb)(H))return H[0]instanceof a.$FM?H.map(i.DocumentSymbol.from):c.f(H)}static f(z){z=z.slice(0).sort((H,_)=>{let re=H.location.range.start.compareTo(_.location.range.start);return re===0&&(re=_.location.range.end.compareTo(H.location.range.end)),re});const j=[],K=[];for(const H of z){const _={name:H.name||"!!MISSING: name!!",kind:i.SymbolKind.from(H.kind),tags:H.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:i.Range.from(H.location.range),selectionRange:i.Range.from(H.location.range),children:[]};for(;;){if(K.length===0){K.push(_),j.push(_);break}const re=K[K.length-1];if(b.$ct.containsRange(re.range,_.range)&&!b.$ct.equalsRange(re.range,_.range)){re.children?.push(_),K.push(_);break}K.pop()}}return j}}class ${constructor(z,j,K,H,_,re){this.f=z,this.g=j,this.h=K,this.j=H,this.k=_,this.l=re,this.d=new t.$Xic("CodeLens"),this.e=new Map}async provideCodeLenses(z,j){const K=this.f.getDocument(z),H=await this.h.provideCodeLenses(K,j);if(!H||j.isCancellationRequested)return;const _=this.d.add(H),re=new m.$Tc;this.e.set(_,re);const Fe={cacheId:_,lenses:[]};for(let Ve=0;Ve<H.length;Ve++)Fe.lenses.push({cacheId:[_,Ve],range:i.Range.from(H[Ve].range),command:this.g.toInternal(H[Ve].command,re)});return Fe}async resolveCodeLens(z,j){const K=z.cacheId&&this.d.get(...z.cacheId);if(!K)return;let H;if(typeof this.h.resolveCodeLens!="function"||K.isResolved?H=K:H=await this.h.resolveCodeLens(K,j),H||(H=K),j.isCancellationRequested)return;const _=z.cacheId&&this.e.get(z.cacheId[0]);if(_){if(!H.command){const re=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,re),this.l.error(re);return}return z.command=this.g.toInternal(H.command,_),z}}releaseCodeLenses(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}}function w(je){return Array.isArray(je)?je.map(i.DefinitionLink.from):je?[i.DefinitionLink.from(je)]:[]}class p{constructor(z,j){this.d=z,this.e=j}async provideDefinition(z,j,K){const H=this.d.getDocument(z),_=i.Position.to(j),re=await this.e.provideDefinition(H,_,K);return w(re)}}class l{constructor(z,j){this.d=z,this.e=j}async provideDeclaration(z,j,K){const H=this.d.getDocument(z),_=i.Position.to(j),re=await this.e.provideDeclaration(H,_,K);return w(re)}}class D{constructor(z,j){this.d=z,this.e=j}async provideImplementation(z,j,K){const H=this.d.getDocument(z),_=i.Position.to(j),re=await this.e.provideImplementation(H,_,K);return w(re)}}class g{constructor(z,j){this.d=z,this.e=j}async provideTypeDefinition(z,j,K){const H=this.d.getDocument(z),_=i.Position.to(j),re=await this.e.provideTypeDefinition(H,_,K);return w(re)}}class S{constructor(z,j){this.d=z,this.e=j}async provideHover(z,j,K){const H=this.d.getDocument(z),_=i.Position.to(j),re=await this.e.provideHover(H,_,K);if(!(!re||(0,I.$Kb)(re.contents)))return re.range||(re.range=H.getWordRangeAtPosition(_)),re.range||(re.range=new a.$oM(_,_)),i.Hover.from(re)}}class y{constructor(z,j){this.d=z,this.e=j}async provideEvaluatableExpression(z,j,K){const H=this.d.getDocument(z),_=i.Position.to(j),re=await this.e.provideEvaluatableExpression(H,_,K);if(re)return i.EvaluatableExpression.from(re)}}class C{constructor(z,j){this.d=z,this.e=j}async provideInlineValues(z,j,K,H){const _=this.d.getDocument(z),re=await this.e.provideInlineValues(_,i.Range.to(j),i.InlineValueContext.to(K),H);if(Array.isArray(re))return re.map(Fe=>i.InlineValue.from(Fe))}}class R{constructor(z,j){this.d=z,this.e=j}async provideDocumentHighlights(z,j,K){const H=this.d.getDocument(z),_=i.Position.to(j),re=await this.e.provideDocumentHighlights(H,_,K);if(Array.isArray(re))return re.map(i.DocumentHighlight.from)}}class V{constructor(z,j){this.d=z,this.e=j}async provideMultiDocumentHighlights(z,j,K,H){const _=this.d.getDocument(z),re=K.map(Qe=>this.d.getDocument(Qe)),Fe=i.Position.to(j),Ve=await this.e.provideMultiDocumentHighlights(_,Fe,re,H);if(Array.isArray(Ve))return Ve.map(i.MultiDocumentHighlight.from)}}class U{constructor(z,j){this.d=z,this.e=j}async provideLinkedEditingRanges(z,j,K){const H=this.d.getDocument(z),_=i.Position.to(j),re=await this.e.provideLinkedEditingRanges(H,_,K);if(re&&Array.isArray(re.ranges))return{ranges:(0,I.$Hb)(re.ranges.map(i.Range.from)),wordPattern:re.wordPattern}}}class q{constructor(z,j){this.d=z,this.e=j}async provideReferences(z,j,K,H){const _=this.d.getDocument(z),re=i.Position.to(j),Fe=await this.e.provideReferences(_,re,K,H);if(Array.isArray(Fe))return Fe.map(i.location.from)}}class M{static{this.d=1e3}constructor(z,j,K,H,_,re,Fe){this.g=z,this.h=j,this.j=K,this.k=H,this.l=_,this.m=re,this.n=Fe,this.e=new t.$Xic("CodeAction"),this.f=new Map}async provideCodeActions(z,j,K,H){const _=this.g.getDocument(z),re=f.$et.isISelection(j)?i.Selection.to(j):i.Range.to(j),Fe=[];for(const it of this.j.getDiagnostics(z))if(re.intersection(it.range)&&Fe.push(it)>M.d)break;const Ve={diagnostics:Fe,only:K.only?new a.$HM(K.only):void 0,triggerKind:i.CodeActionTriggerKind.to(K.trigger)},Qe=await this.k.provideCodeActions(_,re,Ve,H);if(!(0,I.$Lb)(Qe)||H.isCancellationRequested)return;const xe=this.e.add(Qe),tt=new m.$Tc;this.f.set(xe,tt);const at=[];for(let it=0;it<Qe.length;it++){const nt=Qe[it];if(nt)if(M.o(nt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),at.push({_isSynthetic:!0,title:nt.title,command:this.h.toInternal(nt,tt)});else{Ve.only&&(nt.kind?Ve.only.contains(nt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action is of kind '${nt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ct=nt.ranges??[];at.push({cacheId:[xe,it],title:nt.title,command:nt.command&&this.h.toInternal(nt.command,tt),diagnostics:nt.diagnostics&&nt.diagnostics.map(i.Diagnostic.from),edit:nt.edit&&i.WorkspaceEdit.from(nt.edit,void 0),kind:nt.kind&&nt.kind.value,isPreferred:nt.isPreferred,isAI:(0,h.$8F)(this.m,"codeActionAI")?nt.isAI:!1,ranges:(0,h.$8F)(this.m,"codeActionRanges")?(0,I.$Hb)(ct.map(i.Range.from)):void 0,disabled:nt.disabled?.reason})}}return{cacheId:xe,actions:at}}async resolveCodeAction(z,j){const[K,H]=z,_=this.e.get(K,H);if(!_||M.o(_))return{};if(!this.k.resolveCodeAction)return{};const re=await this.k.resolveCodeAction(_,j)??_;let Fe;re.edit&&(Fe=i.WorkspaceEdit.from(re.edit,void 0));let Ve;if(re.command){const Qe=this.f.get(K);Qe&&(Ve=this.h.toInternal(re.command,Qe))}return{edit:Fe,command:Ve}}releaseCodeActions(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}static o(z){return typeof z.command=="string"&&typeof z.title=="string"}}class L{constructor(z,j,K,H,_){this.e=z,this.f=j,this.g=K,this.h=H,this.j=_,this.d=new t.$Xic("DocumentPasteEdit")}async prepareDocumentPaste(z,j,K,H){if(!this.g.prepareDocumentPaste)return;const _=this.f.getDocument(z),re=j.map(Qe=>i.Range.to(Qe)),Fe=i.DataTransfer.toDataTransfer(K,()=>{throw new N.$$});if(await this.g.prepareDocumentPaste(_,re,Fe,H),H.isCancellationRequested)return;const Ve=Array.from(Fe).filter(([,Qe])=>!(Qe instanceof a.$bN));return i.DataTransfer.from(Ve)}async providePasteEdits(z,j,K,H,_,re){if(!this.g.provideDocumentPasteEdits)return[];const Fe=this.f.getDocument(j),Ve=K.map(at=>i.Range.to(at)),Qe=i.DataTransfer.toDataTransfer(H,async at=>(await this.e.$resolvePasteFileData(this.h,z,at)).buffer),xe=await this.g.provideDocumentPasteEdits(Fe,Ve,Qe,{only:_.only?new a.$gN(_.only):void 0,triggerKind:_.triggerKind},re);if(!xe||re.isCancellationRequested)return[];const tt=this.d.add(xe);return xe.map((at,it)=>({_cacheId:[tt,it],title:at.title??(0,s.localize)(0,null,this.j.displayName||this.j.name),kind:at.kind,yieldTo:at.yieldTo?.map(nt=>nt.value),insertText:typeof at.insertText=="string"?at.insertText:{snippet:at.insertText.value},additionalEdit:at.additionalEdit?i.WorkspaceEdit.from(at.additionalEdit,void 0):void 0}))}async resolvePasteEdit(z,j){const[K,H]=z,_=this.d.get(K,H);if(!_||!this.g.resolveDocumentPasteEdit)return{};const re=await this.g.resolveDocumentPasteEdit(_,j)??_;return{additionalEdit:re.additionalEdit?i.WorkspaceEdit.from(re.additionalEdit,void 0):void 0}}releasePasteEdits(z){this.d.delete(z)}}class G{constructor(z,j){this.d=z,this.e=j}async provideDocumentFormattingEdits(z,j,K){const H=this.d.getDocument(z),_=await this.e.provideDocumentFormattingEdits(H,j,K);if(Array.isArray(_))return _.map(i.TextEdit.from)}}class ne{constructor(z,j){this.d=z,this.e=j}async provideDocumentRangeFormattingEdits(z,j,K,H){const _=this.d.getDocument(z),re=i.Range.to(j),Fe=await this.e.provideDocumentRangeFormattingEdits(_,re,K,H);if(Array.isArray(Fe))return Fe.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(z,j,K,H){(0,E.$6f)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const _=this.d.getDocument(z),re=j.map(i.Range.to),Fe=await this.e.provideDocumentRangesFormattingEdits(_,re,K,H);if(Array.isArray(Fe))return Fe.map(i.TextEdit.from)}}class he{constructor(z,j){this.d=z,this.e=j,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,j,K,H,_){const re=this.d.getDocument(z),Fe=i.Position.to(j),Ve=await this.e.provideOnTypeFormattingEdits(re,Fe,K,H,_);if(Array.isArray(Ve))return Ve.map(i.TextEdit.from)}}class ye{constructor(z,j){this.e=z,this.f=j,this.d=new t.$Xic("WorkspaceSymbols")}async provideWorkspaceSymbols(z,j){const K=await this.e.provideWorkspaceSymbols(z,j);if(!(0,I.$Lb)(K))return{symbols:[]};const H=this.d.add(K),_={cacheId:H,symbols:[]};for(let re=0;re<K.length;re++){const Fe=K[re];if(!Fe||!Fe.name){this.f.warn("INVALID SymbolInformation",Fe);continue}_.symbols.push({...i.WorkspaceSymbol.from(Fe),cacheId:[H,re]})}return _}async resolveWorkspaceSymbol(z,j){if(typeof this.e.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const K=this.d.get(...z.cacheId);if(K){const H=await this.e.resolveWorkspaceSymbol(K,j);return H&&(0,d.$Rn)(z,i.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(z){this.d.delete(z)}}class Re{static supportsResolving(z){return typeof z.prepareRename=="function"}constructor(z,j,K){this.d=z,this.e=j,this.f=K}async provideRenameEdits(z,j,K,H){const _=this.d.getDocument(z),re=i.Position.to(j);try{const Fe=await this.e.provideRenameEdits(_,re,K,H);return Fe?i.WorkspaceEdit.from(Fe):void 0}catch(Fe){const Ve=Re.g(Fe);return Ve?{rejectReason:Ve,edits:void 0}:Promise.reject(Fe)}}async resolveRenameLocation(z,j,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(z),_=i.Position.to(j);try{const re=await this.e.prepareRename(H,_,K);let Fe,Ve;if(a.$oM.isRange(re)?(Fe=re,Ve=H.getText(re)):(0,E.$Xf)(re)&&(Fe=re.range,Ve=re.placeholder),!Fe||!Ve)return;if(Fe.start.line>_.line||Fe.end.line<_.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Fe),text:Ve}}catch(re){const Fe=Re.g(re);return Fe?{rejectReason:Fe,range:void 0,text:void 0}:Promise.reject(re)}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ge{constructor(z,j,K){this.d=z,this.e=j,this.f=K}async provideNewSymbolNames(z,j,K){const H=this.d.getDocument(z),_=i.Range.to(j);try{const re=await this.e.provideNewSymbolNames(H,_,K);return re?re.map(Fe=>typeof Fe=="string"?{newSymbolName:Fe}:{newSymbolName:Fe.newSymbolName,tags:Fe.tags}):void 0}catch(re){this.f.error(ge.g(re)??JSON.stringify(re,null,"	"));return}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ue{constructor(z,j){this.resultId=z,this.tokens=j}}class te{constructor(z,j){this.f=z,this.g=j,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(z,j,K){const H=this.f.getDocument(z),_=j!==0?this.d.get(j):null;let re=typeof _?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,_.resultId,K):await this.g.provideDocumentSemanticTokens(H,K);return _&&this.d.delete(j),re?(re=te.h(re),this.o(te.n(_,re),re)):null}async releaseDocumentSemanticColoring(z){this.d.delete(z)}static h(z){return te.j(z)?te.k(z)?z:new a.$GN(new Uint32Array(z.data),z.resultId):te.l(z)?te.m(z)?z:new a.$IN(z.edits.map(j=>new a.$HN(j.start,j.deleteCount,j.data?new Uint32Array(j.data):j.data)),z.resultId):z}static j(z){return z&&!!z.data}static k(z){return z.data instanceof Uint32Array}static l(z){return z&&Array.isArray(z.edits)}static m(z){for(const j of z.edits)if(!(j.data instanceof Uint32Array))return!1;return!0}static n(z,j){if(!te.j(j)||!z||!z.tokens)return j;const K=z.tokens,H=K.length,_=j.data,re=_.length;let Fe=0;const Ve=Math.min(H,re);for(;Fe<Ve&&K[Fe]===_[Fe];)Fe++;if(Fe===H&&Fe===re)return new a.$IN([],j.resultId);let Qe=0;const xe=Ve-Fe;for(;Qe<xe&&K[H-Qe-1]===_[re-Qe-1];)Qe++;return new a.$IN([{start:Fe,deleteCount:H-Fe-Qe,data:_.subarray(Fe,re-Qe)}],j.resultId)}o(z,j){if(te.j(z)){const K=this.e++;return this.d.set(K,new ue(z.resultId,z.data)),(0,o.$Dab)({id:K,type:"full",data:z.data})}if(te.l(z)){const K=this.e++;return te.j(j)?this.d.set(K,new ue(j.resultId,j.data)):this.d.set(K,new ue(z.resultId)),(0,o.$Dab)({id:K,type:"delta",deltas:(z.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class be{constructor(z,j){this.d=z,this.e=j}async provideDocumentRangeSemanticTokens(z,j,K){const H=this.d.getDocument(z),_=await this.e.provideDocumentRangeSemanticTokens(H,i.Range.to(j),K);return _?this.f(_):null}f(z){return(0,o.$Dab)({id:0,type:"full",data:z.data})}}class oe{static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}constructor(z,j,K,H,_){this.f=z,this.g=j,this.h=K,this.j=H,this.k=_,this.d=new t.$Xic("CompletionItem"),this.e=new Map}async provideCompletionItems(z,j,K,H){const _=this.f.getDocument(z),re=i.Position.to(j),Fe=_.getWordRangeAtPosition(re)||new a.$oM(re,re),Ve=Fe.with({end:re}),Qe=new k.$3d,xe=await this.h.provideCompletionItems(_,re,H,i.CompletionContext.to(K));if(!xe||H.isCancellationRequested)return;const tt=Array.isArray(xe)?new a.$UM(xe):xe,at=oe.supportsResolving(this.h)?this.d.add(tt.items):this.d.add([]),it=new m.$Tc;this.e.set(at,it);const nt=[],ct={x:at,b:nt,a:{replace:i.Range.from(Fe),insert:i.Range.from(Ve)},c:tt.isIncomplete||void 0,d:Qe.elapsed()};for(let ft=0;ft<tt.items.length;ft++){const Ue=tt.items[ft],ot=this.l(Ue,[at,ft],Ve,Fe);nt.push(ot)}return ct}async resolveCompletionItem(z,j){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...z);if(!K)return;const H=this.l(K,z),_=await this.h.resolveCompletionItem(K,j);if(!_)return;const re=this.l(_,z);return(H.h!==re.h||H.i!==re.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==re.n||H.o!==re.o||!(0,d.$Sn)(H.p,re.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:re.d,c:re.c,l:re.l,h:re.h,i:re.i,n:re.n,o:re.o,p:re.p}}releaseCompletionItems(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,j,K,H){const _=this.e.get(j[0]);if(!_)throw Error("DisposableStore is missing...");const re=this.g.toInternal(z.command,_),Fe={x:j,a:z.label,b:z.kind!==void 0?i.CompletionItemKind.from(z.kind):void 0,m:z.tags&&z.tags.map(i.CompletionItemTag.from),c:z.detail,d:typeof z.documentation>"u"?void 0:i.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters?.join(""),l:z.additionalTextEdits&&z.additionalTextEdits.map(i.TextEdit.from),n:re?.$ident,o:re?.id,p:re?.$ident?void 0:re?.arguments};z.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Fe.h=z.textEdit.newText):typeof z.insertText=="string"?Fe.h=z.insertText:z.insertText instanceof a.$xM&&(Fe.h=z.insertText.value,Fe.i|=4);let Ve;return z.textEdit?Ve=z.textEdit.range:z.range&&(Ve=z.range),a.$oM.isRange(Ve)?Fe.j=i.Range.from(Ve):Ve&&(!K?.isEqual(Ve.inserting)||!H?.isEqual(Ve.replacing))&&(Fe.j={insert:i.Range.from(Ve.inserting),replace:i.Range.from(Ve.replacing)}),Fe}}class de{async provideInlineCompletions(z,j,K,H){}disposeCompletions(z){}handleDidShowCompletionItem(z,j,K){}handlePartialAccept(z,j,K,H){}}class W extends de{constructor(z,j,K,H){super(),this.f=z,this.g=j,this.h=K,this.j=H,this.d=new ke,this.e=(0,h.$8F)(this.f,"inlineCompletionsAdditions"),this.k={[r.InlineCompletionTriggerKind.Automatic]:a.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:a.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,h.$8F)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(z,j,K,H){const _=this.g.getDocument(z),re=i.Position.to(j),Fe=await this.h.provideInlineCompletionItems(_,re,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:i.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},H);if(!Fe||H.isCancellationRequested)return;const Ve=Array.isArray(Fe)?Fe:Fe.items,Qe=this.e?Array.isArray(Fe)?[]:Fe.commands||[]:[],xe=this.e&&!Array.isArray(Fe)?Fe.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:Ve}),items:Ve.map((it,nt)=>{let ct;it.command&&(tt||(tt=new m.$Tc),ct=this.j.toInternal(it.command,tt));const ft=it.insertText;return{insertText:typeof ft=="string"?ft:{snippet:ft.value},filterText:it.filterText,range:it.range?i.Range.from(it.range):void 0,command:ct,idx:nt,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:Qe.map(it=>(tt||(tt=new m.$Tc),this.j.toInternal(it,tt))),suppressSuggestions:!1,enableForwardStability:xe}}disposeCompletions(z){this.d.disposeReferenceId(z)?.dispose()}handleDidShowCompletionItem(z,j,K){const H=this.d.get(z)?.items[j];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,K)}handlePartialAccept(z,j,K,H){const _=this.d.get(z)?.items[j];_&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(_,K),this.h.handleDidPartiallyAcceptCompletionItem(_,i.PartialAcceptInfo.to(H)))}}class ee{async provideInlineEdits(z,j,K){const H=this.f.getDocument(z),_=await this.g.provideInlineEdit(H,{triggerKind:this.e[j.triggerKind]},K);if(!_||K.isCancellationRequested)return;let re;const Fe=this.d.createReferenceId({dispose(){re?.dispose()},item:_});let Ve;_.accepted&&(re||(re=new m.$Tc),Ve=this.h.toInternal(_.accepted,re));let Qe;return _.rejected&&(re||(re=new m.$Tc),Qe=this.h.toInternal(_.rejected,re)),{pid:Fe,text:_.text,range:i.Range.from(_.range),accepted:Ve,rejected:Qe}}disposeEdit(z){this.d.disposeReferenceId(z)?.dispose()}constructor(z,j,K,H){this.f=j,this.g=K,this.h=H,this.d=new ke,this.e={[r.InlineEditTriggerKind.Automatic]:a.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:a.InlineEditTriggerKind.Invoke}}}class ke{constructor(){this.d=new Map,this.e=1}createReferenceId(z){const j=this.e++;return this.d.set(j,z),j}disposeReferenceId(z){const j=this.d.get(z);return this.d.delete(z),j}get(z){return this.d.get(z)}}class Te{constructor(z,j){this.e=z,this.f=j,this.d=new t.$Xic("SignatureHelp")}async provideSignatureHelp(z,j,K,H){const _=this.e.getDocument(z),re=i.Position.to(j),Fe=this.g(K),Ve=await this.f.provideSignatureHelp(_,re,H,Fe);if(Ve){const Qe=this.d.add([Ve]);return{...i.SignatureHelp.from(Ve),id:Qe}}}g(z){let j;if(z.activeSignatureHelp){const K=i.SignatureHelp.to(z.activeSignatureHelp),H=this.d.get(z.activeSignatureHelp.id,0);H?(j=H,j.activeSignature=K.activeSignature,j.activeParameter=K.activeParameter):j=K}return{...z,activeSignatureHelp:j}}releaseSignatureHelp(z){this.d.delete(z)}}class Se{constructor(z,j,K,H,_){this.f=z,this.g=j,this.h=K,this.j=H,this.k=_,this.d=new t.$Xic("InlayHints"),this.e=new Map}async provideInlayHints(z,j,K){const H=this.f.getDocument(z),_=i.Range.to(j),re=await this.h.provideInlayHints(H,_,K);if(!Array.isArray(re)||re.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(j)}`);return}if(K.isCancellationRequested)return;const Fe=this.d.add(re);this.e.set(Fe,new m.$Tc);const Ve={hints:[],cacheId:Fe};for(let Qe=0;Qe<re.length;Qe++)this.l(re[Qe],_)&&Ve.hints.push(this.m(re[Qe],[Fe,Qe]));return this.j.trace(`[InlayHints] ${Ve.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(j)}`),Ve}async resolveInlayHint(z,j){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...z);if(!K)return;const H=await this.h.resolveInlayHint(K,j);if(H&&this.l(H))return this.m(H,z)}releaseHints(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,j){return z.label.length===0||Array.isArray(z.label)&&z.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(j&&!j.contains(z.position))}m(z,j){const K=this.e.get(j[0]);if(!K)throw Error("DisposableStore is missing...");const H={label:"",cacheId:j,tooltip:i.MarkdownString.fromStrict(z.tooltip),position:i.Position.from(z.position),textEdits:z.textEdits&&z.textEdits.map(i.TextEdit.from),kind:z.kind&&i.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};if(typeof z.label=="string")H.label=z.label;else{const _=[];H.label=_;for(const re of z.label){if(!re.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Fe={label:re.value,tooltip:i.MarkdownString.fromStrict(re.tooltip)};a.$yM.isLocation(re.location)&&(Fe.location=i.location.from(re.location)),re.command&&(Fe.command=this.g.toInternal(re.command,K)),_.push(Fe)}}return H}}class ve{constructor(z,j){this.e=z,this.f=j,this.d=new t.$Xic("DocumentLink")}async provideLinks(z,j){const K=this.e.getDocument(z),H=await this.f.provideDocumentLinks(K,j);if(!(!Array.isArray(H)||H.length===0)&&!j.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter(ve.g).map(i.DocumentLink.from)};{const _=this.d.add(H),re={links:[],cacheId:_};for(let Fe=0;Fe<H.length;Fe++){if(!ve.g(H[Fe]))continue;const Ve=i.DocumentLink.from(H[Fe]);Ve.cacheId=[_,Fe],re.links.push(Ve)}return re}}}static g(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,j){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...z);if(!K)return;const H=await this.f.resolveDocumentLink(K,j);if(!(!H||!ve.g(H)))return i.DocumentLink.from(H)}releaseLinks(z){this.d.delete(z)}}class me{constructor(z,j){this.d=z,this.e=j}async provideColors(z,j){const K=this.d.getDocument(z),H=await this.e.provideDocumentColors(K,j);return Array.isArray(H)?H.map(re=>({color:i.Color.from(re.color),range:i.Range.from(re.range)})):[]}async provideColorPresentations(z,j,K){const H=this.d.getDocument(z),_=i.Range.to(j.range),re=i.Color.to(j.color),Fe=await this.e.provideColorPresentations(re,{document:H,range:_},K);if(Array.isArray(Fe))return Fe.map(i.ColorPresentation.from)}}class J{constructor(z,j){this.d=z,this.e=j}async provideFoldingRanges(z,j,K){const H=this.d.getDocument(z),_=await this.e.provideFoldingRanges(H,j,K);if(Array.isArray(_))return _.map(i.FoldingRange.from)}}class Y{constructor(z,j,K){this.d=z,this.e=j,this.f=K}async provideSelectionRanges(z,j,K){const H=this.d.getDocument(z),_=j.map(i.Position.to),re=await this.e.provideSelectionRanges(H,_,K);if(!(0,I.$Lb)(re))return[];if(re.length!==_.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Fe=[];for(let Ve=0;Ve<_.length;Ve++){const Qe=[];Fe.push(Qe);let xe=_[Ve],tt=re[Ve];for(;;){if(!tt.range.contains(xe))throw new Error("INVALID selection range, must contain the previous range");if(Qe.push(i.SelectionRange.from(tt)),!tt.parent)break;xe=tt.range,tt=tt.parent}}return Fe}}class ce{constructor(z,j){this.f=z,this.g=j,this.d=new A.$KO(""),this.e=new Map}async prepareSession(z,j,K){const H=this.f.getDocument(z),_=i.Position.to(j),re=await this.g.prepareCallHierarchy(H,_,K);if(!re)return;const Fe=this.d.nextId();return this.e.set(Fe,new Map),Array.isArray(re)?re.map(Ve=>this.h(Fe,Ve)):[this.h(Fe,re)]}async provideCallsTo(z,j,K){const H=this.j(z,j);if(!H)throw new Error("missing call hierarchy item");const _=await this.g.provideCallHierarchyIncomingCalls(H,K);if(_)return _.map(re=>({from:this.h(z,re.from),fromRanges:re.fromRanges.map(Fe=>i.Range.from(Fe))}))}async provideCallsFrom(z,j,K){const H=this.j(z,j);if(!H)throw new Error("missing call hierarchy item");const _=await this.g.provideCallHierarchyOutgoingCalls(H,K);if(_)return _.map(re=>({to:this.h(z,re.to),fromRanges:re.fromRanges.map(Fe=>i.Range.from(Fe))}))}releaseSession(z){this.e.delete(z)}h(z,j){const K=this.e.get(z),H=i.CallHierarchyItem.from(j,z,K.size.toString(36));return K.set(H._itemId,j),H}j(z,j){return this.e.get(z)?.get(j)}}class fe{constructor(z,j){this.f=z,this.g=j,this.d=new A.$KO(""),this.e=new Map}async prepareSession(z,j,K){const H=this.f.getDocument(z),_=i.Position.to(j),re=await this.g.prepareTypeHierarchy(H,_,K);if(!re)return;const Fe=this.d.nextId();return this.e.set(Fe,new Map),Array.isArray(re)?re.map(Ve=>this.h(Fe,Ve)):[this.h(Fe,re)]}async provideSupertypes(z,j,K){const H=this.j(z,j);if(!H)throw new Error("missing type hierarchy item");const _=await this.g.provideTypeHierarchySupertypes(H,K);if(_)return _.map(re=>this.h(z,re))}async provideSubtypes(z,j,K){const H=this.j(z,j);if(!H)throw new Error("missing type hierarchy item");const _=await this.g.provideTypeHierarchySubtypes(H,K);if(_)return _.map(re=>this.h(z,re))}releaseSession(z){this.e.delete(z)}h(z,j){const K=this.e.get(z),H=i.TypeHierarchyItem.from(j,z,K.size.toString(36));return K.set(H._itemId,j),H}j(z,j){return this.e.get(z)?.get(j)}}class Ne{constructor(z,j,K,H,_){this.d=z,this.e=j,this.f=K,this.g=H,this.h=_}async provideDocumentOnDropEdits(z,j,K,H,_){const re=this.e.getDocument(j),Fe=i.Position.to(K),Ve=i.DataTransfer.toDataTransfer(H,async xe=>(await this.d.$resolveDocumentOnDropFileData(this.g,z,xe)).buffer),Qe=await this.f.provideDocumentDropEdits(re,Fe,Ve,_);if(Qe)return(0,I.$3b)(Qe).map(xe=>({title:xe.title??(0,s.localize)(1,null,this.h.displayName||this.h.name),kind:xe.kind?.value,yieldTo:xe.yieldTo?.map(tt=>tt.value),insertText:typeof xe.insertText=="string"?xe.insertText:{snippet:xe.insertText.value},additionalEdit:xe.additionalEdit?i.WorkspaceEdit.from(xe.additionalEdit,void 0):void 0}))}}class le{constructor(z,j){this.d=z,this.e=j}async provideMappedEdits(z,j,K,H){const _=u.URI.revive(z),re=this.d.getDocument(_),Fe=K.documents.map(xe=>xe.map(tt=>({uri:u.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(at=>i.Range.to(at))}))),Ve={documents:Fe,selections:Fe[0]?.[0]?.ranges??[]},Qe=await this.e.provideMappedEdits(re,j,Ve,H);return Qe?i.WorkspaceEdit.from(Qe):null}}class Ie{constructor(z,j){this.adapter=z,this.extension=j}}class Ae{static{this.d=0}constructor(z,j,K,H,_,re,Fe,Ve){this.g=j,this.h=K,this.j=H,this.k=_,this.l=re,this.m=Fe,this.n=Ve,this.f=new Map,this.e=z.getProxy(v.$kM.MainThreadLanguageFeatures)}o(z,j){return i.DocumentSelector.from(z,this.g,j)}p(z){return new a.$mM(()=>{this.f.delete(z),this.e.$unregister(z)})}q(){return Ae.d++}async s(z,j,K,H,_,re=!1){const Fe=this.f.get(z);if(!Fe||!(Fe.adapter instanceof j))return H;const Ve=Date.now();re||this.l.trace(`[${Fe.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const Qe=K(Fe.adapter,Fe.extension);return Promise.resolve(Qe).catch(xe=>{(0,N.$4)(xe)||(this.l.error(`[${Fe.extension.identifier.value}] provider FAILED`),this.l.error(xe),this.n.onExtensionError(Fe.extension.identifier,xe))}).finally(()=>{re||this.l.trace(`[${Fe.extension.identifier.value}] provider DONE after ${Date.now()-Ve}ms`)}),P.CancellationToken.isCancellationToken(_)?(0,O.$0g)(Qe,_):Qe}t(z,j){const K=this.q();return this.f.set(K,new Ie(z,j)),K}static u(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,j,K,H){const _=this.t(new c(this.h,K),z),re=H&&H.label||Ae.u(z);return this.e.$registerDocumentSymbolProvider(_,this.o(j,z),re),this.p(_)}$provideDocumentSymbols(z,j,K){return this.s(z,c,H=>H.provideDocumentSymbols(u.URI.revive(j),K),void 0,K)}registerCodeLensProvider(z,j,K){const H=this.q(),_=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new Ie(new $(this.h,this.j.converter,K,z,this.n,this.l),z)),this.e.$registerCodeLensSupport(H,this.o(j,z),_);let re=this.p(H);if(_!==void 0){const Fe=K.onDidChangeCodeLenses(Ve=>this.e.$emitCodeLensEvent(_));re=a.$mM.from(re,Fe)}return re}$provideCodeLenses(z,j,K){return this.s(z,$,H=>H.provideCodeLenses(u.URI.revive(j),K),void 0,K)}$resolveCodeLens(z,j,K){return this.s(z,$,H=>H.resolveCodeLens(j,K),void 0,void 0)}$releaseCodeLenses(z,j){this.s(z,$,K=>Promise.resolve(K.releaseCodeLenses(j)),void 0,void 0)}registerDefinitionProvider(z,j,K){const H=this.t(new p(this.h,K),z);return this.e.$registerDefinitionSupport(H,this.o(j,z)),this.p(H)}$provideDefinition(z,j,K,H){return this.s(z,p,_=>_.provideDefinition(u.URI.revive(j),K,H),[],H)}registerDeclarationProvider(z,j,K){const H=this.t(new l(this.h,K),z);return this.e.$registerDeclarationSupport(H,this.o(j,z)),this.p(H)}$provideDeclaration(z,j,K,H){return this.s(z,l,_=>_.provideDeclaration(u.URI.revive(j),K,H),[],H)}registerImplementationProvider(z,j,K){const H=this.t(new D(this.h,K),z);return this.e.$registerImplementationSupport(H,this.o(j,z)),this.p(H)}$provideImplementation(z,j,K,H){return this.s(z,D,_=>_.provideImplementation(u.URI.revive(j),K,H),[],H)}registerTypeDefinitionProvider(z,j,K){const H=this.t(new g(this.h,K),z);return this.e.$registerTypeDefinitionSupport(H,this.o(j,z)),this.p(H)}$provideTypeDefinition(z,j,K,H){return this.s(z,g,_=>_.provideTypeDefinition(u.URI.revive(j),K,H),[],H)}registerHoverProvider(z,j,K,H){const _=this.t(new S(this.h,K),z);return this.e.$registerHoverProvider(_,this.o(j,z)),this.p(_)}$provideHover(z,j,K,H){return this.s(z,S,_=>_.provideHover(u.URI.revive(j),K,H),void 0,H)}registerEvaluatableExpressionProvider(z,j,K,H){const _=this.t(new y(this.h,K),z);return this.e.$registerEvaluatableExpressionProvider(_,this.o(j,z)),this.p(_)}$provideEvaluatableExpression(z,j,K,H){return this.s(z,y,_=>_.provideEvaluatableExpression(u.URI.revive(j),K,H),void 0,H)}registerInlineValuesProvider(z,j,K,H){const _=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,re=this.t(new C(this.h,K),z);this.e.$registerInlineValuesProvider(re,this.o(j,z),_);let Fe=this.p(re);if(_!==void 0){const Ve=K.onDidChangeInlineValues(Qe=>this.e.$emitInlineValuesEvent(_));Fe=a.$mM.from(Fe,Ve)}return Fe}$provideInlineValues(z,j,K,H,_){return this.s(z,C,re=>re.provideInlineValues(u.URI.revive(j),K,H,_),void 0,_)}registerDocumentHighlightProvider(z,j,K){const H=this.t(new R(this.h,K),z);return this.e.$registerDocumentHighlightProvider(H,this.o(j,z)),this.p(H)}registerMultiDocumentHighlightProvider(z,j,K){const H=this.t(new V(this.h,K),z);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(j,z)),this.p(H)}$provideDocumentHighlights(z,j,K,H){return this.s(z,R,_=>_.provideDocumentHighlights(u.URI.revive(j),K,H),void 0,H)}$provideMultiDocumentHighlights(z,j,K,H,_){return this.s(z,V,re=>re.provideMultiDocumentHighlights(u.URI.revive(j),K,H.map(Fe=>u.URI.revive(Fe)),_),void 0,_)}registerLinkedEditingRangeProvider(z,j,K){const H=this.t(new U(this.h,K),z);return this.e.$registerLinkedEditingRangeProvider(H,this.o(j,z)),this.p(H)}$provideLinkedEditingRanges(z,j,K,H){return this.s(z,U,async _=>{const re=await _.provideLinkedEditingRanges(u.URI.revive(j),K,H);if(re)return{ranges:re.ranges,wordPattern:re.wordPattern?Ae.w(re.wordPattern):void 0}},void 0,H)}registerReferenceProvider(z,j,K){const H=this.t(new q(this.h,K),z);return this.e.$registerReferenceSupport(H,this.o(j,z)),this.p(H)}$provideReferences(z,j,K,H,_){return this.s(z,q,re=>re.provideReferences(u.URI.revive(j),K,H,_),void 0,_)}registerCodeActionProvider(z,j,K,H){const _=new m.$Tc,re=this.t(new M(this.h,this.j.converter,this.k,K,this.l,z,this.m),z);return this.e.$registerQuickFixSupport(re,this.o(j,z),{providedKinds:H?.providedCodeActionKinds?.map(Fe=>Fe.value),documentation:H?.documentation?.map(Fe=>({kind:Fe.kind.value,command:this.j.converter.toInternal(Fe.command,_)}))},Ae.u(z),!!K.resolveCodeAction),_.add(this.p(re)),_}$provideCodeActions(z,j,K,H,_){return this.s(z,M,re=>re.provideCodeActions(u.URI.revive(j),K,H,_),void 0,_)}$resolveCodeAction(z,j,K){return this.s(z,M,H=>H.resolveCodeAction(j,K),{},void 0)}$releaseCodeActions(z,j){this.s(z,M,K=>Promise.resolve(K.releaseCodeActions(j)),void 0,void 0)}registerDocumentFormattingEditProvider(z,j,K){const H=this.t(new G(this.h,K),z);return this.e.$registerDocumentFormattingSupport(H,this.o(j,z),z.identifier,z.displayName||z.name),this.p(H)}$provideDocumentFormattingEdits(z,j,K,H){return this.s(z,G,_=>_.provideDocumentFormattingEdits(u.URI.revive(j),K,H),void 0,H)}registerDocumentRangeFormattingEditProvider(z,j,K){const H=typeof K.provideDocumentRangesFormattingEdits=="function",_=this.t(new ne(this.h,K),z);return this.e.$registerRangeFormattingSupport(_,this.o(j,z),z.identifier,z.displayName||z.name,H),this.p(_)}$provideDocumentRangeFormattingEdits(z,j,K,H,_){return this.s(z,ne,re=>re.provideDocumentRangeFormattingEdits(u.URI.revive(j),K,H,_),void 0,_)}$provideDocumentRangesFormattingEdits(z,j,K,H,_){return this.s(z,ne,re=>re.provideDocumentRangesFormattingEdits(u.URI.revive(j),K,H,_),void 0,_)}registerOnTypeFormattingEditProvider(z,j,K,H){const _=this.t(new he(this.h,K),z);return this.e.$registerOnTypeFormattingSupport(_,this.o(j,z),H,z.identifier),this.p(_)}$provideOnTypeFormattingEdits(z,j,K,H,_,re){return this.s(z,he,Fe=>Fe.provideOnTypeFormattingEdits(u.URI.revive(j),K,H,_,re),void 0,re)}registerWorkspaceSymbolProvider(z,j){const K=this.t(new ye(j,this.l),z);return this.e.$registerNavigateTypeSupport(K,typeof j.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(z,j,K){return this.s(z,ye,H=>H.provideWorkspaceSymbols(j,K),{symbols:[]},K)}$resolveWorkspaceSymbol(z,j,K){return this.s(z,ye,H=>H.resolveWorkspaceSymbol(j,K),void 0,void 0)}$releaseWorkspaceSymbols(z,j){this.s(z,ye,K=>K.releaseWorkspaceSymbols(j),void 0,void 0)}registerRenameProvider(z,j,K){const H=this.t(new Re(this.h,K,this.l),z);return this.e.$registerRenameSupport(H,this.o(j,z),Re.supportsResolving(K)),this.p(H)}$provideRenameEdits(z,j,K,H,_){return this.s(z,Re,re=>re.provideRenameEdits(u.URI.revive(j),K,H,_),void 0,_)}$resolveRenameLocation(z,j,K,H){return this.s(z,Re,_=>_.resolveRenameLocation(u.URI.revive(j),K,H),void 0,H)}registerNewSymbolNamesProvider(z,j,K){const H=this.t(new ge(this.h,K,this.l),z);return this.e.$registerNewSymbolNamesProvider(H,this.o(j,z)),this.p(H)}$provideNewSymbolNames(z,j,K,H){return this.s(z,ge,_=>_.provideNewSymbolNames(u.URI.revive(j),K,H),void 0,H)}registerDocumentSemanticTokensProvider(z,j,K,H){const _=this.t(new te(this.h,K),z),re=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(_,this.o(j,z),H,re);let Fe=this.p(_);if(re){const Ve=K.onDidChangeSemanticTokens(Qe=>this.e.$emitDocumentSemanticTokensEvent(re));Fe=a.$mM.from(Fe,Ve)}return Fe}$provideDocumentSemanticTokens(z,j,K,H){return this.s(z,te,_=>_.provideDocumentSemanticTokens(u.URI.revive(j),K,H),null,H)}$releaseDocumentSemanticTokens(z,j){this.s(z,te,K=>K.releaseDocumentSemanticColoring(j),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,j,K,H){const _=this.t(new be(this.h,K),z);return this.e.$registerDocumentRangeSemanticTokensProvider(_,this.o(j,z),H),this.p(_)}$provideDocumentRangeSemanticTokens(z,j,K,H){return this.s(z,be,_=>_.provideDocumentRangeSemanticTokens(u.URI.revive(j),K,H),null,H)}registerCompletionItemProvider(z,j,K,H){const _=this.t(new oe(this.h,this.j.converter,K,this.m,z),z);return this.e.$registerCompletionsProvider(_,this.o(j,z),H,oe.supportsResolving(K),z.identifier),this.p(_)}$provideCompletionItems(z,j,K,H,_){return this.s(z,oe,re=>re.provideCompletionItems(u.URI.revive(j),K,H,_),void 0,_)}$resolveCompletionItem(z,j,K){return this.s(z,oe,H=>H.resolveCompletionItem(j,K),void 0,K)}$releaseCompletionItems(z,j){this.s(z,oe,K=>K.releaseCompletionItems(j),void 0,void 0)}registerInlineCompletionsProvider(z,j,K,H){const _=new W(z,this.h,K,this.j.converter),re=this.t(_,z);return this.e.$registerInlineCompletionsSupport(re,this.o(j,z),_.supportsHandleEvents,n.$Dm.toKey(z.identifier.value),H?.yieldTo?.map(Fe=>n.$Dm.toKey(Fe))||[]),this.p(re)}$provideInlineCompletions(z,j,K,H,_){return this.s(z,de,re=>re.provideInlineCompletions(u.URI.revive(j),K,H,_),void 0,_)}$handleInlineCompletionDidShow(z,j,K,H){this.s(z,de,async _=>{_.handleDidShowCompletionItem(j,K,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(z,j,K,H,_){this.s(z,de,async re=>{re.handlePartialAccept(j,K,H,_)},void 0,void 0)}$freeInlineCompletionsList(z,j){this.s(z,de,async K=>{K.disposeCompletions(j)},void 0,void 0)}registerInlineEditProvider(z,j,K){const H=new ee(z,this.h,K,this.j.converter),_=this.t(H,z);return this.e.$registerInlineEditProvider(_,this.o(j,z),z.identifier),this.p(_)}$provideInlineEdit(z,j,K,H){return this.s(z,ee,_=>_.provideInlineEdits(u.URI.revive(j),K,H),void 0,H)}$freeInlineEdit(z,j){this.s(z,ee,async K=>{K.disposeEdit(j)},void 0,void 0)}registerSignatureHelpProvider(z,j,K,H){const _=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,re=this.t(new Te(this.h,K),z);return this.e.$registerSignatureHelpProvider(re,this.o(j,z),_),this.p(re)}$provideSignatureHelp(z,j,K,H,_){return this.s(z,Te,re=>re.provideSignatureHelp(u.URI.revive(j),K,H,_),void 0,_)}$releaseSignatureHelp(z,j){this.s(z,Te,K=>K.releaseSignatureHelp(j),void 0,void 0)}registerInlayHintsProvider(z,j,K){const H=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,_=this.t(new Se(this.h,this.j.converter,K,this.l,z),z);this.e.$registerInlayHintsProvider(_,this.o(j,z),typeof K.resolveInlayHint=="function",H,Ae.u(z));let re=this.p(_);if(H!==void 0){const Fe=K.onDidChangeInlayHints(Ve=>this.e.$emitInlayHintsEvent(H));re=a.$mM.from(re,Fe)}return re}$provideInlayHints(z,j,K,H){return this.s(z,Se,_=>_.provideInlayHints(u.URI.revive(j),K,H),void 0,H)}$resolveInlayHint(z,j,K){return this.s(z,Se,H=>H.resolveInlayHint(j,K),void 0,K)}$releaseInlayHints(z,j){this.s(z,Se,K=>K.releaseHints(j),void 0,void 0)}registerDocumentLinkProvider(z,j,K){const H=this.t(new ve(this.h,K),z);return this.e.$registerDocumentLinkProvider(H,this.o(j,z),typeof K.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(z,j,K){return this.s(z,ve,H=>H.provideLinks(u.URI.revive(j),K),void 0,K,j.scheme==="output")}$resolveDocumentLink(z,j,K){return this.s(z,ve,H=>H.resolveLink(j,K),void 0,void 0,!0)}$releaseDocumentLinks(z,j){this.s(z,ve,K=>K.releaseLinks(j),void 0,void 0,!0)}registerColorProvider(z,j,K){const H=this.t(new me(this.h,K),z);return this.e.$registerDocumentColorProvider(H,this.o(j,z)),this.p(H)}$provideDocumentColors(z,j,K){return this.s(z,me,H=>H.provideColors(u.URI.revive(j),K),[],K)}$provideColorPresentations(z,j,K,H){return this.s(z,me,_=>_.provideColorPresentations(u.URI.revive(j),K,H),void 0,H)}registerFoldingRangeProvider(z,j,K){const H=this.q(),_=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new Ie(new J(this.h,K),z)),this.e.$registerFoldingRangeProvider(H,this.o(j,z),z.identifier,_);let re=this.p(H);if(_!==void 0){const Fe=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(_));re=a.$mM.from(re,Fe)}return re}$provideFoldingRanges(z,j,K,H){return this.s(z,J,_=>_.provideFoldingRanges(u.URI.revive(j),K,H),void 0,H)}registerSelectionRangeProvider(z,j,K){const H=this.t(new Y(this.h,K,this.l),z);return this.e.$registerSelectionRangeProvider(H,this.o(j,z)),this.p(H)}$provideSelectionRanges(z,j,K,H){return this.s(z,Y,_=>_.provideSelectionRanges(u.URI.revive(j),K,H),[],H)}registerCallHierarchyProvider(z,j,K){const H=this.t(new ce(this.h,K),z);return this.e.$registerCallHierarchyProvider(H,this.o(j,z)),this.p(H)}$prepareCallHierarchy(z,j,K,H){return this.s(z,ce,_=>Promise.resolve(_.prepareSession(u.URI.revive(j),K,H)),void 0,H)}$provideCallHierarchyIncomingCalls(z,j,K,H){return this.s(z,ce,_=>_.provideCallsTo(j,K,H),void 0,H)}$provideCallHierarchyOutgoingCalls(z,j,K,H){return this.s(z,ce,_=>_.provideCallsFrom(j,K,H),void 0,H)}$releaseCallHierarchy(z,j){this.s(z,ce,K=>Promise.resolve(K.releaseSession(j)),void 0,void 0)}registerTypeHierarchyProvider(z,j,K){const H=this.t(new fe(this.h,K),z);return this.e.$registerTypeHierarchyProvider(H,this.o(j,z)),this.p(H)}$prepareTypeHierarchy(z,j,K,H){return this.s(z,fe,_=>Promise.resolve(_.prepareSession(u.URI.revive(j),K,H)),void 0,H)}$provideTypeHierarchySupertypes(z,j,K,H){return this.s(z,fe,_=>_.provideSupertypes(j,K,H),void 0,H)}$provideTypeHierarchySubtypes(z,j,K,H){return this.s(z,fe,_=>_.provideSubtypes(j,K,H),void 0,H)}$releaseTypeHierarchy(z,j){this.s(z,fe,K=>Promise.resolve(K.releaseSession(j)),void 0,void 0)}registerDocumentOnDropEditProvider(z,j,K,H){const _=this.q();return this.f.set(_,new Ie(new Ne(this.e,this.h,K,_,z),z)),this.e.$registerDocumentOnDropEditProvider(_,this.o(j,z),(0,h.$8F)(z,"dropMetadata")?H:void 0),this.p(_)}$provideDocumentOnDropEdits(z,j,K,H,_,re){return this.s(z,Ne,Fe=>Promise.resolve(Fe.provideDocumentOnDropEdits(j,u.URI.revive(K),H,_,re)),void 0,void 0)}registerMappedEditsProvider(z,j,K){const H=this.t(new le(this.h,K),z);return this.e.$registerMappedEditsProvider(H,this.o(j,z)),this.p(H)}$provideMappedEdits(z,j,K,H,_){return this.s(z,le,re=>Promise.resolve(re.provideMappedEdits(j,K,H,_)),null,_)}registerDocumentPasteEditProvider(z,j,K,H){const _=this.q();return this.f.set(_,new Ie(new L(this.e,this.h,K,_,z),z)),this.e.$registerPasteEditProvider(_,this.o(j,z),{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,supportsResolve:!!K.resolveDocumentPasteEdit,providedPasteEditKinds:H.providedPasteEditKinds?.map(re=>re.value),copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(_)}$prepareDocumentPaste(z,j,K,H,_){return this.s(z,L,re=>re.prepareDocumentPaste(u.URI.revive(j),K,H,_),void 0,_)}$providePasteEdits(z,j,K,H,_,re,Fe){return this.s(z,L,Ve=>Ve.providePasteEdits(j,u.URI.revive(K),H,_,re,Fe),void 0,Fe)}$resolvePasteEdit(z,j,K){return this.s(z,L,H=>H.resolvePasteEdit(j,K),{},void 0)}$releasePasteEdits(z,j){this.s(z,L,K=>Promise.resolve(K.releasePasteEdits(j)),void 0,void 0)}static w(z){return{pattern:z.source,flags:z.flags}}static y(z){return{decreaseIndentPattern:Ae.w(z.decreaseIndentPattern),increaseIndentPattern:Ae.w(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Ae.w(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Ae.w(z.unIndentedLinePattern):void 0}}static z(z){return{beforeText:Ae.w(z.beforeText),afterText:z.afterText?Ae.w(z.afterText):void 0,previousLineText:z.previousLineText?Ae.w(z.previousLineText):void 0,action:z.action}}static B(z){return z.map(Ae.z)}static C(z){return{open:z.open,close:z.close,notIn:z.notIn?z.notIn.map(j=>a.SyntaxTokenType.toString(j)):void 0}}static D(z){return z.map(Ae.C)}setLanguageConfiguration(z,j,K){const{wordPattern:H}=K;if(H&&(0,F.$0e)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(j,H):this.h.setWordDefinitionFor(j,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const _=this.q(),re={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?Ae.w(K.wordPattern):void 0,indentationRules:K.indentationRules?Ae.y(K.indentationRules):void 0,onEnterRules:K.onEnterRules?Ae.B(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs?Ae.D(K.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(_,j,re),this.p(_)}$setWordDefinitions(z){for(const j of z)this.h.setWordDefinitionFor(j.languageId,new RegExp(j.regexSource,j.regexFlags))}}e.$8ic=Ae}),define(Ce[88],Pe([1,0,6,4,8,7,101,20,11,5,166,106,14,3,17,84,13]),function($e,e,I,O,P,N,A,m,d,k,F,E,u,b,f,r,o){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$djc=e.$cjc=void 0,e.$cjc=(0,b.$ii)("IExtHostLanguageModels");class n{constructor(t,v){this.option=t,this.stream=new d.$Lh,this.stream=v??new d.$Lh}}class i{constructor(){this.a=new Map,this.b=new d.$Lh,this.c=!1,this.d=!1;const t=this;this.apiObject={stream:t.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,t]of this.a)yield t.stream;else yield this.b}handleFragment(t){if(this.c)return;this.d=!0;let v=this.a.get(t.index);v||(this.a.size===0?v=new n(t.index,this.b):v=new n(t.index),this.a.set(t.index,v)),v.stream.emitOne(t.part)}get isStreaming(){return this.d}reject(t){this.c=!0;for(const v of this.f())v.reject(t)}resolve(){this.c=!0;for(const t of this.f())t.resolve()}}let a=class{static{s=this}static{this.a=1}constructor(t,v,c){this.j=v,this.k=c,this.c=new k.$7d,this.d=new k.$7d,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new m.$Fm,this.i=new Map,this.o=new Set,this.b=t.getProxy(O.$kM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(t,v,c,$){const w=s.a++;this.f.set(w,{extension:t.identifier,provider:c,languageModelId:v});let p;return $.auth&&(p={providerLabel:t.displayName||t.name,accountLabel:typeof $.auth=="object"?$.auth.label:void 0}),this.b.$registerLanguageModelProvider(w,v,{extension:t.identifier,identifier:v,model:$.name??"",auth:p}),(0,I.$Sc)(()=>{this.f.delete(w),this.b.$unregisterProvider(w)})}async $provideLanguageModelResponse(t,v,c,$,w,p){const l=this.f.get(t);if(!l)return;const D=new A.$Rv(async g=>{if(p.isCancellationRequested){this.j.warn(`[CHAT](${l.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(v,{index:g.index,part:g.part})});return l.provider.provideLanguageModelResponse2($.map(P.LanguageModelMessage.to),w,m.$Dm.toKey(c),D,p)}$updateLanguageModels(t){const v=[],c=[];if(t.added)for(const $ of t.added)this.g.set($.identifier,$),v.push($.model);if(t.removed)for(const $ of t.removed){this.g.delete($),c.push($);for(const[w,p]of this.i)p.languageModelId===$&&(p.res.reject(new u.$5),this.i.delete(w))}this.d.fire(Object.freeze({added:Object.freeze(v),removed:Object.freeze(c)})),t.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(t){const v=new Array;for(const{from:c,to:$,enabled:w}of t){const p=this.h.get(c)??new m.$Em;if(p.has($)!==w){w?p.add($):p.delete($),this.h.set(c,p);const D={from:c,to:$};v.push(D),this.c.fire(D)}}}async sendChatRequest(t,v,c,$,w){const p=t.identifier,l=await this.b.$prepareChatAccess(p,v,$.justification);if(!l||!this.g.has(v))throw N.$sO.NotFound(`Language model '${v}' is unknown.`);if(this.m(p,l)&&(!await this.l(t,{identifier:l.extension,displayName:l.auth.providerLabel},$.justification,$.silent)||!this.h.get(p)?.has(l.extension)))throw N.$sO.NoPermissions(`Language model '${v}' cannot be used by '${p.value}'.`);const D=Math.random()*1e6|0,g=this.b.$fetchResponse(p,v,D,c.map(P.LanguageModelMessage.from),$.modelOptions??{},w),S=new d.$hh,y=new i;this.i.set(D,{languageModelId:v,res:y});let C;if(g.catch(R=>{S.isOpen()?y.reject(R):C=R}).finally(()=>{this.i.delete(D),y.resolve(),S.open()}),await S.wait(),C)throw new N.$sO(`Language model '${v}' errored, check cause for more details`,"Unknown",C);return y.apiObject}async $handleResponseFragment(t,v){const c=this.i.get(t);c&&c.res.handleFragment(v)}async l(t,v,c,$){const w=E.$mL+v.identifier.value;if(await this.k.getSession(t,w,[],{silent:!0}))return this.$updateModelAccesslist([{from:t.identifier,to:v.identifier,enabled:!0}]),!0;if($)return!1;try{const l=c?(0,F.localize)(0,null,v.displayName,c):(0,F.localize)(1,null,v.displayName);return await this.k.getSession(t,w,[],{forceNewSession:{detail:l}}),this.$updateModelAccesslist([{from:t.identifier,to:v.identifier,enabled:!0}]),!0}catch{return!1}}m(t,v){return!!v.auth&&!m.$Dm.equals(v.extension,t)}async n(t){for(const v of this.o)try{await this.l(v,{identifier:t.extension,displayName:""},void 0,!0)}catch(c){this.j.error("Fake Auth request failed"),this.j.error(c)}}createLanguageModelAccessInformation(t){this.o.add(t);const v=this,c=k.Event.signal(k.Event.filter(this.c.event,w=>m.$Dm.equals(w.from,t.identifier))),$=k.Event.signal(this.d.event);return{get onDidChange(){return k.Event.any(c,$)},canSendRequest(w){const p=v.g.get(w);if(!p)return;if(!v.m(t.identifier,p))return!0;const l=v.h.get(t.identifier);if(l)return l.has(p.extension)}}}};e.$djc=a,e.$djc=a=s=Je([We(0,f.$FO),We(1,o.$Oj),We(2,r.$0ic)],a)}),define(Ce[264],Pe([1,0,4,8,7,32,11,6,22]),function($e,e,I,O,P,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wkc=void 0;class k{constructor(E,u,b,f){this.c=u,this.d=b,this.e=f,this.b=[],this.f=0,this.g=new Set,this.a=E.getProxy(I.$kM.MainThreadLanguages)}$acceptLanguageIds(E){this.b=E}async getLanguages(){return this.b.slice(0)}async changeLanguage(E,u){await this.a.$changeLanguage(E,u);const b=this.c.getDocumentData(E);if(!b)throw new Error(`document '${E.toString()}' NOT found`);return b.document}async tokenAtPosition(E,u){const b=E.version,f=O.Position.from(u),r=await this.a.$tokensAtPosition(E.uri,f),o={type:P.StandardTokenType.Other,range:E.getWordRangeAtPosition(u)??new P.$oM(u.line,u.character,u.line,u.character)};if(!r)return o;const s={range:O.Range.to(r.range),type:O.TokenType.to(r.type)};return!s.range.contains(u)||b!==E.version?o:s}createLanguageStatusItem(E,u,b){const f=this.f++,r=this.a,o=this.g,s=`${E.identifier.value}/${u}`;if(o.has(s))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);o.add(s);const n={selector:b,id:u,name:E.displayName??E.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const a=new m.$Tc,h=()=>{if(i?.dispose(),!o.has(s)){console.warn(`LanguageStatusItem (${u}) from ${E.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,A.$kh)(()=>{a.clear(),this.a.$setLanguageStatus(f,{id:s,name:n.name??E.displayName??E.name,source:E.displayName??E.name,selector:O.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===P.LanguageStatusSeverity.Error?N.default.Error:n.severity===P.LanguageStatusSeverity.Warning?N.default.Warning:N.default.Info,command:n.command&&this.d.toInternal(n.command,a),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){a.dispose(),i?.dispose(),r.$removeLanguageStatus(f),o.delete(s)},get id(){return n.id},get name(){return n.name},set name(v){n.name=v,h()},get selector(){return n.selector},set selector(v){n.selector=v,h()},get text(){return n.text},set text(v){n.text=v,h()},set text2(v){(0,d.$9F)(E,"languageStatusText"),n.text=v,h()},get text2(){return(0,d.$9F)(E,"languageStatusText"),n.text},get detail(){return n.detail},set detail(v){n.detail=v,h()},get severity(){return n.severity},set severity(v){n.severity=v,h()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(v){n.accessibilityInformation=v,h()},get command(){return n.command},set command(v){n.command=v,h()},get busy(){return n.busy},set busy(v){n.busy=v,h()}};return h(),t}}e.$wkc=k}),define(Ce[265],Pe([1,0,12,2,8,7,83]),function($e,e,I,O,P,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ikc=e.$hkc=void 0;class m{constructor(E,u,b,f){this.start=E,this.deletedCount=u,this.deletedItems=b,this.items=f}asApiEvent(){return{range:new N.$NN(this.start,this.start+this.deletedCount),addedCells:this.items.map(E=>E.apiCell),removedCells:this.deletedItems}}}class d{static asModelAddData(E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1}}constructor(E,u,b){this.notebook=E,this.h=u,this.j=b,this.handle=b.handle,this.uri=O.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(P.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const E=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return E.notebook.getCellIndex(E)},notebook:E.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return E.g},set mime(f){E.g=f},get outputs(){return E.a.slice(0)},get metadata(){return E.b},get executionSummary(){return E.d}};this.f=Object.freeze(b)}return this.f}setOutputs(E){this.a=E.map(P.NotebookCellOutput.to)}setOutputItems(E,u,b){const f=b.map(P.NotebookCellOutputItem.to),r=this.a.find(o=>o.id===E);if(r&&(u||(r.items.length=0),r.items.push(...f),r.items.length>1&&r.items.every(o=>A.$hK(o.mime)))){const o=new Map,s=[];r.items.forEach(n=>{let i;o.has(n.mime)?i=o.get(n.mime):(i=[],o.set(n.mime,i),s.push(n.mime)),i.push(n.data)}),r.items.length=0,s.forEach(n=>{const i=A.$iK(o.get(n));r.items.push({mime:n,data:i.data.buffer})})}}setMetadata(E){this.b=Object.freeze(E)}setInternalMetadata(E){this.e=E,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(E))}setMime(E){}}e.$hkc=d;class k{static{this.a=0}constructor(E,u,b,f,r){this.k=E,this.l=u,this.m=b,this.uri=f,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const E=this,u={get uri(){return E.uri},get version(){return E.g},get notebookType(){return E.d},get isDirty(){return E.h},get isUntitled(){return E.uri.scheme===I.Schemas.untitled},get isClosed(){return E.j},get metadata(){return E.f},get cellCount(){return E.b.length},cellAt(b){return b=E.n(b),E.b[b].apiCell},getCells(b){return(b?E.p(b):E.b).map(r=>r.apiCell)},save(){return E.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(E){E.metadata&&(this.f=Object.freeze({...this.f,...E.metadata}))}acceptDirty(E){this.h=E}acceptModelChanged(E,u,b){this.g=E.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:b});const f={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},r=[];for(const s of E.rawEvents)s.kind===A.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,f.contentChanges):s.kind===A.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,f.contentChanges):s.kind===A.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),r.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===A.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),r.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),r.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===A.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),r.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),r.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const o=new Map;for(let s=0;s<r.length;s++){const n=r[s],i=o.get(n.cell);if(i===void 0){const a=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});o.set(n.cell,a-1)}else f.cellChanges[i]={...f.cellChanges[i],...n}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}n(E){return E=E|0,E<0?0:E>=this.b.length?this.b.length-1:E}o(E){let u=E.start|0,b=E.end|0;return u<0&&(u=0),b>this.b.length&&(b=this.b.length),E.with({start:u,end:b})}p(E){E=this.o(E);const u=[];for(let b=E.start;b<E.end;b++)u.push(this.b[b]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(E,u,b){if(this.j)return;const f=[],r=[],o=[];if(E.reverse().forEach(s=>{const i=s[2].map(t=>{const v=new d(this,this.l,t);return u||r.push(d.asModelAddData(t)),v}),a=new m(s[0],s[1],[],i),h=this.b.splice(s[0],s[1],...i);for(const t of h)o.push(t.uri),a.deletedItems.push(t.apiCell);f.push(a)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:o}),b)for(const s of f)b.push(s.asApiEvent())}s(E,u,b,f){const r=this.b.splice(E,u);this.b.splice(b,0,...r);const o=[new m(E,u,r.map(s=>s.apiCell),[]),new m(b,0,[],r)];for(const s of o)f.push(s.asApiEvent())}t(E,u){this.b[E].setOutputs(u)}u(E,u,b,f){this.b[E].setOutputItems(u,b,f)}v(E,u){const b=this.b[E];b.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(b.uri,u)}w(E,u){const b=this.b[E];b.apiCell.mime=u}x(E,u){this.b[E].setMetadata(u)}y(E,u){this.b[E].setInternalMetadata(u)}getCellFromApiCell(E){return this.b.find(u=>u.apiCell===E)}getCellFromIndex(E){return this.b[E]}getCell(E){return this.b.find(u=>u.handle===E)}getCellIndex(E){return this.b.indexOf(E)}}e.$ikc=k}),define(Ce[266],Pe([1,0,5,2,8,7]),function($e,e,I,O,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ykc=void 0;class A{constructor(d,k,F,E={timeout:1500,errors:3}){this.b=d,this.c=k,this.d=F,this.f=E,this.a=new I.$9d}dispose(){}getOnWillSaveNotebookDocumentEvent(d){return(k,F,E)=>{const u=function(f){k.call(F,f)};return u.extension=d,this.a.event(u,void 0,E)}}async $participateInSave(d,k,F){const E=O.URI.revive(d),u=this.c.getNotebookDocument(E);if(!u)throw new Error("Unable to resolve notebook document");const b=[];if(await this.a.fireAsync({notebook:u.apiNotebook,reason:P.TextDocumentSaveReason.to(k)},F,async(r,o)=>{const s=Date.now(),n=await await Promise.resolve(r);Date.now()-s>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!F.isCancellationRequested&&n&&(n instanceof N.$wM?b.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),F.isCancellationRequested)return!1;if(b.length===0)return!0;const f={edits:[]};for(const r of b){const{edits:o}=P.WorkspaceEdit.from(r);f.edits=f.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(f)}}e.$ykc=A}),define(Ce[112],Pe([1,0,14,8,7]),function($e,e,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jkc=void 0;class N{static{this.apiEditorsToExtHost=new WeakMap}constructor(m,d,k,F,E,u){this.id=m,this.f=d,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=E,this.b=F,this.c=u}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(d){this.selections=[d]},get selections(){return m.a},set selections(d){if(!Array.isArray(d)||!d.every(P.$NN.isNotebookRange))throw(0,I.$7)("selections");m.a=d,m.g(d)},get visibleRanges(){return m.b},revealRange(d,k){m.f.$tryRevealRange(m.id,O.NotebookRange.from(d),k??P.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},N.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(O.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$jkc=N}),define(Ce[267],Pe([1,0,5,13,8]),function($e,e,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Akc=void 0;let N=class{constructor(m,d){this.c=m,this.d=d,this.a=new I.$7d,this.b=new I.$7d,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(m,d){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",m,d);const k=this.d.getEditorById(m);d.visibleRanges&&k._acceptVisibleRanges(d.visibleRanges.ranges.map(P.NotebookRange.to)),d.selections&&k._acceptSelections(d.selections.selections.map(P.NotebookRange.to)),d.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),d.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(m){for(const d in m)this.d.getEditorById(d)._acceptViewColumn(P.ViewColumn.to(m[d]))}};e.$Akc=N,e.$Akc=N=Je([We(0,O.$Oj)],N)}),define(Ce[268],Pe([1,0,5,4,112]),function($e,e,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dkc=void 0;class N{constructor(m,d){this.c=d,this.a=new Map,this.b=m.getProxy(O.$kM.MainThreadNotebookRenderers)}$postRendererMessage(m,d,k){const F=this.c.getEditorById(m);this.a.get(d)?.fire({editor:F.apiEditor,message:k})}createRendererMessaging(m,d){if(!m.contributes?.notebookRenderer?.some(F=>F.id===d))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${d})`);return{onDidReceiveMessage:(F,E,u)=>this.d(d).event(F,E,u),postMessage:(F,E)=>{P.$jkc.apiEditorsToExtHost.has(F)&&([F,E]=[E,F]);const u=E&&P.$jkc.apiEditorsToExtHost.get(E);return this.b.$postMessage(u?.id,d,F)}}}d(m){let d=this.a.get(m);return d||(d=new I.$7d({onDidRemoveLastListener:()=>{d?.dispose(),this.a.delete(m)}}),this.a.set(m,d),d)}}e.$Dkc=N}),define(Ce[269],Pe([1,0,8,101,25,68,14]),function($e,e,I,O,P,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hkc=void 0;class m{constructor(E){this.b=0,this.c=new Map,this.a=E}async withProgress(E,u,b){const f=this.b++,{title:r,location:o,cancellable:s}=u,n={label:E.displayName||E.name,id:E.identifier.value};return this.a.$startProgress(f,{location:I.ProgressLocation.from(o),title:r,source:n,cancellable:s},E.isUnderDevelopment?void 0:E.identifier.value).catch(A.$2),this.d(f,b,!!s)}d(E,u,b){let f;b&&(f=new P.$ee,this.c.set(E,f));const r=s=>{this.a.$progressEnd(s),this.c.delete(s),f?.dispose()};let o;try{o=u(new k(this.a,E),b&&f?f.token:P.CancellationToken.None)}catch(s){throw r(E),s}return o.then(s=>r(E),s=>r(E)),o}$acceptProgressCanceled(E){const u=this.c.get(E);u&&(u.cancel(),this.c.delete(E))}}e.$Hkc=m;function d(F,E){return F.message=E.message,typeof E.increment=="number"&&(typeof F.increment=="number"?F.increment+=E.increment:F.increment=E.increment),F}class k extends O.$Rv{constructor(E,u){super(b=>this.throttledReport(b)),this.c=E,this.d=u}throttledReport(E){this.c.$progressReport(this.d,E)}}Je([(0,N.$Oh)(100,(F,E)=>d(F,E),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(Ce[270],Pe([1,0,2,4,11,8]),function($e,e,I,O,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ikc=void 0;class A{static{this.a=0}constructor(d,k){this.d=k,this.c=new Map,this.b=d.getProxy(O.$kM.MainThreadQuickDiff)}$provideOriginalResource(d,k,F){const E=I.URI.revive(k),u=this.c.get(d);return u?(0,P.$ah)(()=>u.provideOriginalResource(E,F)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(d,k,F,E){const u=A.a++;return this.c.set(u,k),this.b.$registerQuickDiffProvider(u,N.DocumentSelector.from(d,this.d),F,E),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$Ikc=A}),define(Ce[271],Pe([1,0,25,5,6,4,2,7,14,18,32,41,22,8]),function($e,e,I,O,P,N,A,m,d,k,F,E,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jkc=f;function f(r,o,s){const n=r.getProxy(N.$kM.MainThreadQuickOpen);class i{constructor(l,D){this.e=new Map,this.f=0,this.a=l,this.b=D}showQuickPick(l,D,g,S=I.CancellationToken.None){this.c=void 0;const y=Promise.resolve(D),C=++this.f,R=n.$show(C,{title:g?.title,placeHolder:g?.placeHolder,matchOnDescription:g?.matchOnDescription,matchOnDetail:g?.matchOnDetail,ignoreFocusLost:g?.ignoreFocusOut,canPickMany:g?.canPickMany},S),V={},U=R.then(()=>V);return Promise.race([U,y]).then(q=>{if(q===V)return;const M=(0,u.$8F)(l,"quickPickItemTooltip");return y.then(L=>{const G=[];for(let ne=0;ne<L.length;ne++){const he=L[ne];if(typeof he=="string")G.push({label:he,handle:ne});else if(he.kind===m.QuickPickItemKind.Separator)G.push({type:"separator",label:he.label});else{he.tooltip&&!M&&console.warn(`Extension '${l.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${l.identifier.value}`);const ye=he.iconPath?c(he.iconPath):void 0;G.push({label:he.label,iconPath:ye?.iconPath,iconClass:ye?.iconClass,description:he.description,detail:he.detail,picked:he.picked,alwaysShow:he.alwaysShow,tooltip:M?b.MarkdownString.fromStrict(he.tooltip):void 0,handle:ne})}}return g&&typeof g.onDidSelectItem=="function"&&(this.c=ne=>{g.onDidSelectItem(L[ne])}),n.$setItems(C,G),R.then(ne=>{if(typeof ne=="number")return L[ne];if(Array.isArray(ne))return ne.map(he=>L[he])})})}).then(void 0,q=>{if(!(0,d.$4)(q))return n.$setError(C,q),Promise.reject(q)})}$onItemSelected(l){this.c?.(l)}showInput(l,D=I.CancellationToken.None){return this.d=l?.validateInput,n.$input(l,typeof this.d=="function",D).then(void 0,g=>{if(!(0,d.$4)(g))return Promise.reject(g)})}async $validateInput(l){if(!this.d)return;const D=await this.d(l);if(!D||typeof D=="string")return D;let g;switch(D.severity){case m.InputBoxValidationSeverity.Info:g=F.default.Info;break;case m.InputBoxValidationSeverity.Warning:g=F.default.Warning;break;case m.InputBoxValidationSeverity.Error:g=F.default.Error;break;default:g=D.message?F.default.Error:F.default.Ignore;break}return{content:D.message,severity:g}}async showWorkspaceFolderPick(l,D=I.CancellationToken.None){const g=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!g)return;const S=await this.a.getWorkspaceFolders2();if(S)return S.find(y=>y.uri.toString()===g.uri.toString())}createQuickPick(l){const D=new $(l,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(l){const D=new w(l,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(l,D){this.e.get(l)?._fireDidChangeValue(D)}$onDidAccept(l){this.e.get(l)?._fireDidAccept()}$onDidChangeActive(l,D){const g=this.e.get(l);g instanceof $&&g._fireDidChangeActive(D)}$onDidChangeSelection(l,D){const g=this.e.get(l);g instanceof $&&g._fireDidChangeSelection(D)}$onDidTriggerButton(l,D){this.e.get(l)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(l,D,g){const S=this.e.get(l);S instanceof $&&S._fireDidTriggerItemButton(D,g)}$onDidHide(l){this.e.get(l)?._fireDidHide()}}class a{static{this.a=1}constructor(l,D){this.x=l,this.y=D,this._id=$.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new O.$7d,this.q=new O.$7d,this.r=new O.$7d,this.s=new O.$7d,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(l){this.b=l,this.z({title:l})}get step(){return this.c}set step(l){this.c=l,this.z({step:l})}get totalSteps(){return this.d}set totalSteps(l){this.d=l,this.z({totalSteps:l})}get enabled(){return this.g}set enabled(l){this.g=l,this.z({enabled:l})}get busy(){return this.j}set busy(l){this.j=l,this.z({busy:l})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(l){this.k=l,this.z({ignoreFocusOut:l})}get value(){return this.l}set value(l){this.l=l,this.z({value:l})}get placeholder(){return this.m}set placeholder(l){this.m=l,this.z({placeholder:l})}get buttons(){return this.n}set buttons(l){this.n=l.slice(),this.o.clear(),l.forEach((D,g)=>{const S=D===m.$KN.Back?-1:g;this.o.set(S,D)}),this.z({buttons:l.map((D,g)=>({...c(D.iconPath),tooltip:D.tooltip,handle:D===m.$KN.Back?-1:g}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(l){this.l=l,this.q.fire(l)}_fireDidTriggerButton(l){const D=this.o.get(l);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(l){if(!this.v){for(const D of Object.keys(l)){const g=l[D];this.u[D]=g===void 0?null:g}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function h(p){if(p instanceof m.$iN)return{id:p.id};const l=v(p),D=t(p);return{dark:typeof l=="string"?A.URI.file(l):l,light:typeof D=="string"?A.URI.file(D):D}}function t(p){return typeof p=="object"&&"light"in p?p.light:p}function v(p){return typeof p=="object"&&"dark"in p?p.dark:p}function c(p){const l=h(p);let D,g;return"id"in l?g=E.ThemeIcon.asClassName(l):D=l,{iconPath:D,iconClass:g}}class $ extends a{constructor(l,D){super(l.identifier,D),this.O=l,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new O.$7d,this.L=[],this.M=new O.$7d,this.N=new O.$7d,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(l){this.B=l.slice(),this.C.clear(),this.D.clear(),l.forEach((S,y)=>{this.C.set(y,S),this.D.set(S,y)});const D=(0,u.$8F)(this.O,"quickPickItemTooltip"),g=[];for(let S=0;S<l.length;S++){const y=l[S];if(y.kind===m.QuickPickItemKind.Separator)g.push({type:"separator",label:y.label});else{y.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=y.iconPath?c(y.iconPath):void 0;g.push({handle:S,label:y.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:D?b.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((R,V)=>({...c(R.iconPath),tooltip:R.tooltip,handle:V}))})}}this.z({items:g})}get canSelectMany(){return this.E}set canSelectMany(l){this.E=l,this.z({canSelectMany:l})}get matchOnDescription(){return this.F}set matchOnDescription(l){this.F=l,this.z({matchOnDescription:l})}get matchOnDetail(){return this.G}set matchOnDetail(l){this.G=l,this.z({matchOnDetail:l})}get sortByLabel(){return this.H}set sortByLabel(l){this.H=l,this.z({sortByLabel:l})}get keepScrollPosition(){return this.I}set keepScrollPosition(l){this.I=l,this.z({keepScrollPosition:l})}get activeItems(){return this.J}set activeItems(l){this.J=l.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(l){this.L=l.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(l){const D=(0,k.$Hb)(l.map(g=>this.C.get(g)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(l){const D=(0,k.$Hb)(l.map(g=>this.C.get(g)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(l,D){const g=this.C.get(l);if(!g||!g.buttons||!g.buttons.length)return;const S=g.buttons[D];S&&this.N.fire({button:S,item:g})}}class w extends a{constructor(l,D){super(l.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(l){this.B=l,this.z({password:l})}get prompt(){return this.C}set prompt(l){this.C=l,this.z({prompt:l})}get valueSelection(){return this.D}set valueSelection(l){this.D=l,this.z({valueSelection:l})}get validationMessage(){return this.E}set validationMessage(l){this.E=l,l?typeof l=="string"?this.z({validationMessage:l,severity:F.default.Error}):this.z({validationMessage:l.message,severity:l.severity??F.default.Error}):this.z({validationMessage:void 0,severity:F.default.Ignore})}}return new i(o,s)}}),define(Ce[272],Pe([1,0,2,5,68,6,11,4,18,142,13,20,41,8,22,12,21]),function($e,e,I,O,P,N,A,m,d,k,F,E,u,b,f,r,o){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lkc=e.$Kkc=void 0;function n(C){return C instanceof I.URI}function i(C,R){return C.scheme===r.Schemas.file&&R.scheme===r.Schemas.file&&o.$k?C.toString()===R.toString():C.toString().toLowerCase()===R.toString().toLowerCase()}function a(C){if(C)return typeof C.iconPath=="string"?I.URI.file(C.iconPath):I.URI.isUri(C.iconPath)||u.ThemeIcon.isThemeIcon(C.iconPath)?C.iconPath:void 0}function h(C){if(C.icon){if(I.URI.isUri(C.icon))return C.icon;if(u.ThemeIcon.isThemeIcon(C.icon))return C.icon;{const R=C.icon;return{light:R.light,dark:R.dark}}}else return}function t(C,R){if(!C.iconPath&&!R.iconPath)return 0;if(C.iconPath){if(!R.iconPath)return 1}else return-1;const V=typeof C.iconPath=="string"?C.iconPath:I.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id,U=typeof R.iconPath=="string"?R.iconPath:I.URI.isUri(R.iconPath)?R.iconPath.fsPath:R.iconPath.id;return(0,k.$ar)(V,U)}function v(C,R){let V=0;if(C.strikeThrough!==R.strikeThrough)return C.strikeThrough?1:-1;if(C.faded!==R.faded)return C.faded?1:-1;if(C.tooltip!==R.tooltip)return(C.tooltip||"").localeCompare(R.tooltip||"");if(V=t(C,R),V!==0)return V;if(C.light&&R.light)V=t(C.light,R.light);else{if(C.light)return 1;if(R.light)return-1}if(V!==0)return V;if(C.dark&&R.dark)V=t(C.dark,R.dark);else{if(C.dark)return 1;if(R.dark)return-1}return V}function c(C,R){if(C.command!==R.command)return C.command<R.command?-1:1;if(C.title!==R.title)return C.title<R.title?-1:1;if(C.tooltip!==R.tooltip){if(C.tooltip!==void 0&&R.tooltip!==void 0)return C.tooltip<R.tooltip?-1:1;if(C.tooltip!==void 0)return 1;if(R.tooltip!==void 0)return-1}if(C.arguments===R.arguments)return 0;if(C.arguments)if(R.arguments){if(C.arguments.length!==R.arguments.length)return C.arguments.length-R.arguments.length}else return 1;else return-1;for(let V=0;V<C.arguments.length;V++){const U=C.arguments[V],q=R.arguments[V];if(U!==q&&!(n(U)&&n(q)&&i(U,q)))return U<q?-1:1}return 0}function $(C,R){let V=(0,k.$ar)(C.resourceUri.fsPath,R.resourceUri.fsPath,!0);if(V!==0)return V;if(C.command&&R.command)V=c(C.command,R.command);else{if(C.command)return 1;if(R.command)return-1}if(V!==0)return V;if(C.decorations&&R.decorations)V=v(C.decorations,R.decorations);else{if(C.decorations)return 1;if(R.decorations)return-1}if(C.multiFileDiffEditorModifiedUri&&R.multiFileDiffEditorModifiedUri)V=(0,k.$ar)(C.multiFileDiffEditorModifiedUri.fsPath,R.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(C.multiFileDiffEditorModifiedUri)return 1;if(R.multiFileDiffEditorModifiedUri)return-1}if(C.multiDiffEditorOriginalUri&&R.multiDiffEditorOriginalUri)V=(0,k.$ar)(C.multiDiffEditorOriginalUri.fsPath,R.multiDiffEditorOriginalUri.fsPath,!0);else{if(C.multiDiffEditorOriginalUri)return 1;if(R.multiDiffEditorOriginalUri)return-1}return V}function w(C,R){for(let V=0;V<C.length;V++)if(C[V]!==R[V])return!1;return!0}function p(C,R){return C.command===R.command&&C.title===R.title&&C.tooltip===R.tooltip&&(C.arguments&&R.arguments?w(C.arguments,R.arguments):C.arguments===R.arguments)}function l(C,R){return(0,d.$ub)(C,R,p)}class D{#e;#t;get value(){return this.d}set value(R){R=R??"",this.#e.$setInputBoxValue(this.l,R),this.n(R)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(R){this.#e.$setInputBoxPlaceholder(this.l,R),this.f=R}get validateInput(){return(0,f.$9F)(this.k,"scmValidation"),this.g}set validateInput(R){if((0,f.$9F)(this.k,"scmValidation"),R&&typeof R!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=R,this.#e.$setValidationProviderIsEnabled(this.l,!!R)}get enabled(){return this.h}set enabled(R){R=!!R,this.h!==R&&(this.h=R,this.#e.$setInputBoxEnablement(this.l,R))}get visible(){return this.j}set visible(R){R=!!R,this.j!==R&&(this.j=R,this.#e.$setInputBoxVisibility(this.l,R))}get document(){return(0,f.$9F)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(R,V,U,q,M){this.k=R,this.l=q,this.m=M,this.d="",this.e=new O.$7d,this.f="",this.h=!0,this.j=!0,this.#t=V,this.#e=U}showValidationMessage(R,V){(0,f.$9F)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,R,V)}$onInputBoxValueChange(R){this.n(R)}n(R){this.d=R,this.e.fire(R)}}e.$Kkc=D;class g{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(R){this.v=R,this.q.$updateGroupLabel(this.t,this.handle,R)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(R){this.p=R,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(R){this.f=[...R],this.k.fire()}constructor(R,V,U,q,M,L,G){this.q=R,this.s=V,this.t=U,this.u=q,this.v=M,this.multiDiffEditorEnableViewChanges=L,this.w=G,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new O.$7d,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new O.$7d,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=g.d++}getResourceState(R){return this.g.get(R)}$executeResourceCommand(R,V){const U=this.h.get(R);return U?(0,A.$ah)(()=>this.s.executeCommand(U.command,...U.arguments||[],V)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const R=[...this.f].sort($),U=(0,d.$Db)(this.o,R,$).map(L=>{const G=L.toInsert.map(ne=>{const he=this.e++;this.g.set(he,ne);const ye=ne.resourceUri;let Re;if(ne.command)if(ne.command.command==="vscode.open"||ne.command.command==="vscode.diff"||ne.command.command==="vscode.changes"){const me=new N.$Tc;Re=this.s.converter.toInternal(ne.command,me),this.j.set(he,me)}else this.h.set(he,ne.command);const ge=(0,f.$8F)(this.w,"scmMultiDiffEditor"),ue=ge?ne.multiDiffEditorOriginalUri:void 0,te=ge?ne.multiFileDiffEditorModifiedUri:void 0,be=a(ne.decorations),oe=ne.decorations&&a(ne.decorations.light)||be,de=ne.decorations&&a(ne.decorations.dark)||be,W=[oe,de],ee=ne.decorations&&ne.decorations.tooltip||"",ke=ne.decorations&&!!ne.decorations.strikeThrough,Te=ne.decorations&&!!ne.decorations.faded,Se=ne.contextValue||"";return{rawResource:[he,ye,W,ee,ke,Te,Se,Re,ue,te],handle:he}});return{start:L.start,deleteCount:L.deleteCount,toInsert:G}}),q=U.map(({start:L,deleteCount:G,toInsert:ne})=>[L,G,ne.map(he=>he.rawResource)]),M=U.reverse();for(const{start:L,deleteCount:G,toInsert:ne}of M){const he=ne.map(Re=>Re.handle),ye=this.n.splice(L,G,...he);for(const Re of ye)this.g.delete(Re),this.h.delete(Re),this.j.get(Re)?.dispose(),this.j.delete(Re)}return this.o=R,q}dispose(){this.l=!0,this.m.fire()}}class S{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(R){this.g!==R&&(this.g=R,this.#e.$updateSourceControl(this.w,{count:R}))}get quickDiffProvider(){return this.h}set quickDiffProvider(R){this.h=R;let V;(0,f.$8F)(this.x,"quickDiffProvider")&&(V=R?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!R,quickDiffLabel:V})}get historyProvider(){return(0,f.$9F)(this.x,"scmHistoryProvider"),this.j}set historyProvider(R){(0,f.$9F)(this.x,"scmHistoryProvider"),this.j=R,this.k.value=new N.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!R}),R&&this.k.value.add(R.onDidChangeCurrentHistoryItemGroup(()=>{this.l=R?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(R){R!==this.m&&(this.m=R,this.#e.$updateSourceControl(this.w,{commitTemplate:R}))}get acceptInputCommand(){return this.o}set acceptInputCommand(R){this.n.value=new N.$Tc,this.o=R;const V=this.y.converter.toInternal(R,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:V})}get actionButton(){return(0,f.$9F)(this.x,"scmActionButton"),this.q}set actionButton(R){(0,f.$9F)(this.x,"scmActionButton"),this.p.value=new N.$Tc,this.q=R;const V=R!==void 0?{command:this.y.converter.toInternal(R.command,this.p.value),secondaryCommands:R.secondaryCommands?.map(U=>U.map(q=>this.y.converter.toInternal(q,this.p.value))),description:R.description,enabled:R.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:V??null})}get statusBarCommands(){return this.t}set statusBarCommands(R){if(this.t&&R&&l(this.t,R))return;this.s.value=new N.$Tc,this.t=R;const V=(R||[]).map(U=>this.y.converter.toInternal(U,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:V})}get selected(){return this.u}constructor(R,V,U,q,M,L,G){this.x=R,this.y=q,this.z=M,this.A=L,this.B=G,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new N.$Vc,this.m=void 0,this.n=new N.$Vc,this.o=void 0,this.p=new N.$Vc,this.s=new N.$Vc,this.t=void 0,this.u=!1,this.v=new O.$7d,this.onDidChangeSelection=this.v.event,this.w=S.d++,this.C=new Map,this.D=new Set,this.#e=U;const ne=I.URI.from({scheme:r.Schemas.vscodeSourceControl,path:`${M}/scm${this.w}/input`,query:G?`rootUri=${encodeURIComponent(G.toString())}`:void 0});this.f=new D(R,V,this.#e,this.w,ne),this.#e.$registerSourceControl(this.w,M,L,G,ne)}createResourceGroup(R,V,U){const q=(0,f.$8F)(this.x,"scmMultiDiffEditor")&&U?.multiDiffEditorEnableViewChanges===!0,M=new g(this.#e,this.y,this.w,R,V,q,this.x),L=O.Event.once(M.onDidDispose)(()=>this.C.delete(M));return this.C.set(M,L),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const R=[],V=[];for(const[U,q]of this.C){q.dispose();const M=U.onDidUpdateResourceStates(()=>{this.D.add(U),this.eventuallyUpdateResourceStates()});O.Event.once(U.onDidDispose)(()=>{this.D.delete(U),M.dispose(),this.e.delete(U.handle),this.#e.$unregisterGroup(this.w,U.handle)}),R.push([U.handle,U.id,U.label,U.features,U.multiDiffEditorEnableViewChanges]);const L=U._takeResourceStateSnapshot();L.length>0&&V.push([U.handle,L]),this.e.set(U.handle,U)}this.#e.$registerGroups(this.w,R,V),this.C.clear()}eventuallyUpdateResourceStates(){const R=[];this.D.forEach(V=>{const U=V._takeResourceStateSnapshot();U.length!==0&&R.push([V.handle,U])}),R.length>0&&this.#e.$spliceResourceStates(this.w,R),this.D.clear()}getResourceGroup(R){return this.e.get(R)}setSelectionState(R){this.u=R,this.v.fire(R)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(R=>R.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,P.$Nh)(100)],S.prototype,"eventuallyAddResourceGroups",null),Je([(0,P.$Nh)(100)],S.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{s=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(R,V,U,q){this.l=V,this.m=U,this.n=q,this.g=new Map,this.h=new E.$Fm,this.j=new O.$7d,this.e=R.getProxy(m.$kM.MainThreadSCM),this.f=R.getProxy(m.$kM.MainThreadTelemetry),V.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const L=this.g.get(M.sourceControlHandle);if(!L)return M;const G=L.getResourceGroup(M.groupHandle);return G?G.getResourceState(M.handle):M}else if(M&&M.$mid===4){const L=this.g.get(M.sourceControlHandle);return L?L.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const L=this.g.get(M.handle);return L||M}return M}})}createSourceControl(R,V,U,q){this.n.trace("ExtHostSCM#createSourceControl",R.identifier.value,V,U,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:R.identifier.value});const M=s.d++,L=new S(R,this.m,this.e,this.l,V,U,q);this.g.set(M,L);const G=this.h.get(R.identifier)||[];return G.push(L),this.h.set(R.identifier,G),L}getLastInputBox(R){this.n.trace("ExtHostSCM#getLastInputBox",R.identifier.value);const V=this.h.get(R.identifier),U=V&&V[V.length-1];return U&&U.inputBox}$provideOriginalResource(R,V,U){const q=I.URI.revive(V);this.n.trace("ExtHostSCM#$provideOriginalResource",R,q.toString());const M=this.g.get(R);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$ah)(()=>M.quickDiffProvider.provideOriginalResource(q,U)).then(L=>L||null)}$onInputBoxValueChange(R,V){this.n.trace("ExtHostSCM#$onInputBoxValueChange",R);const U=this.g.get(R);return U&&U.inputBox.$onInputBoxValueChange(V),Promise.resolve(void 0)}$executeResourceCommand(R,V,U,q){this.n.trace("ExtHostSCM#$executeResourceCommand",R,V,U);const M=this.g.get(R);if(!M)return Promise.resolve(void 0);const L=M.getResourceGroup(V);return L?L.$executeResourceCommand(U,q):Promise.resolve(void 0)}$validateInput(R,V,U){this.n.trace("ExtHostSCM#$validateInput",R);const q=this.g.get(R);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,A.$ah)(()=>q.inputBox.validateInput(V,U)).then(M=>{if(!M)return Promise.resolve(void 0);const L=b.MarkdownString.fromStrict(M.message);return L?Promise.resolve([L,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(R){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",R),R!==void 0&&this.g.get(R)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=R,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(R,V,U,q){return await this.g.get(R)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(V,U,q)??void 0}async $provideHistoryItems(R,V,U,q){return(await this.g.get(R)?.historyProvider?.provideHistoryItems(V,U,q))?.map(G=>({...G,icon:h(G)}))??void 0}async $provideHistoryItemSummary(R,V,U,q){const M=this.g.get(R)?.historyProvider;if(typeof M?.provideHistoryItemSummary!="function")return;const L=await M.provideHistoryItemSummary(V,U,q);return L?{...L,icon:h(L)}:void 0}async $provideHistoryItemChanges(R,V,U,q){return await this.g.get(R)?.historyProvider?.provideHistoryItemChanges(V,U,q)??void 0}};e.$Lkc=y,e.$Lkc=y=s=Je([We(3,F.$Oj)],y)}),define(Ce[273],Pe([1,0,4,8,2]),function($e,e,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mkc=void 0;class N{static{this.a=0}constructor(m,d){this.d=d,this.c=new Map,this.b=m.getProxy(I.$kM.MainThreadShare)}async $provideShare(m,d,k){return await this.c.get(m)?.provideShare({selection:O.Range.to(d.selection),resourceUri:P.URI.revive(d.resourceUri)},k)??void 0}registerShareProvider(m,d){const k=N.a++;return this.c.set(k,d),this.b.$registerShareProvider(k,O.DocumentSelector.from(m,this.d),d.id,d.label,d.priority),{dispose:()=>{this.b.$unregisterShareProvider(k),this.c.delete(k)}}}}e.$Mkc=N}),define(Ce[274],Pe([1,0,7,4,169,6,8,16]),function($e,e,I,O,P,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pkc=e.$Okc=void 0;class d{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new I.$jN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new I.$jN("statusBarItem.warningForeground")]])}#e;#t;constructor(u,b,f,r,o,s=I.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new N.$Tc,this.#e=u,this.#t=b,o&&r){this.c=(0,I.$XM)(r.identifier,o);const i=f.get(this.c);i&&(s=i.alignLeft?I.StatusBarAlignment.Left:I.StatusBarAlignment.Right,n=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(d.a++);this.e=r,this.f=o,this.g=s,this.h=this.u(n)}u(u){if((0,m.$Zf)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!d.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new N.$Tc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let b;this.m?b=this.m:b=(0,P.localize)(0,null,this.e.displayName||this.e.name);let f=this.n;this.o&&(f=d.b.get(this.o.id));const r=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,b,this.k,r,this.r?.internal,f,this.o,this.g===I.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Okc=d;class k{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",I.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const b={message:u};return this.b.unshift(b),this.c(),new I.$mM(()=>{const f=this.b.indexOf(b);f>=0&&(this.b.splice(f,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class F{constructor(u,b){this.e=new Map,this.a=u.getProxy(O.$kM.MainThreadStatusBar),this.b=b,this.c=new k(this)}$acceptStaticEntries(u){for(const b of u)this.e.set(b.entryId,b)}createStatusBarEntry(u,b,f,r){return new d(this.a,this.b,this.e,u,b,f,r)}setStatusBarMessage(u,b){const f=this.c.setMessage(u);let r;return typeof b=="number"?r=setTimeout(()=>f.dispose(),b):typeof b<"u"&&b.then(()=>f.dispose(),()=>f.dispose()),new I.$mM(()=>{f.dispose(),clearTimeout(r)})}}e.$Pkc=F}),define(Ce[113],Pe([1,0,29,105,49,75,60,8,2]),function($e,e,I,O,P,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UO=e.$TO=e.$SO=e.$RO=void 0;const k=(i,a,h,t)=>{let v=a;return{enumerable:!0,configurable:!1,get(){return v},set(c){if(!h(v,c)){const $=v;v=c,i.listener?.(t(c,$))}}}},F=(i,a)=>i===a,E={range:(i,a)=>i===a?!0:!i||!a?!1:i.isEqual(a),label:F,description:F,sortText:F,busy:F,error:F,canResolveChildren:F,tags:(i,a)=>!(i.length!==a.length||i.some(h=>!a.find(t=>h.id===t.id)))},u=i=>a=>({op:4,update:i(a)}),b=(i,a)=>({range:(()=>{let h;const t=u(v=>({range:I.$ct.lift(m.Range.from(v))}));return{enumerable:!0,configurable:!1,get(){return h},set(v){i.listener?.({op:6}),E.range(h,v)||(h=v,i.listener?.(t(v)))}}})(),label:k(i,a,E.label,u(h=>({label:h}))),description:k(i,void 0,E.description,u(h=>({description:h}))),sortText:k(i,void 0,E.sortText,u(h=>({sortText:h}))),canResolveChildren:k(i,!1,E.canResolveChildren,h=>({op:2,state:h})),busy:k(i,!1,E.busy,u(h=>({busy:h}))),error:k(i,void 0,E.error,u(h=>({error:m.MarkdownString.fromStrict(h)||null}))),tags:k(i,[],E.tags,(h,t)=>({op:1,new:h.map(m.TestTag.from),old:t.map(m.TestTag.from)}))}),f=i=>{const a=P.$9K.fromString(i.extId),h=new o(a.controllerId,a.localId,i.label,d.URI.revive(i.uri)||void 0);return h.range=m.Range.to(i.range||void 0),h.description=i.description||void 0,h.sortText=i.sortText||void 0,h.tags=i.tags.map(t=>m.TestTag.to({id:(0,A.$cL)(t).tagId})),h},r=i=>{let a;for(const h of i.tests){const t=f(h.item);(0,O.$BO)(t).parent=a,a=t}return a};e.$RO=r;class o{constructor(a,h,t,v){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const c=(0,O.$AO)(this,a);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:v,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return c.parent instanceof s?void 0:c.parent}},children:{value:(0,N.$zO)(c,O.$BO,o),enumerable:!0,writable:!1},...b(c,t)})}}e.$SO=o;class s extends o{constructor(a,h){super(a,a,h,void 0),this._isRoot=!0}}e.$TO=s;class n extends N.$vO{constructor(a,h,t){super({controllerId:a,getDocumentVersion:v=>v&&t.getDocument(v)?.version,getApiFor:O.$BO,getChildren:v=>v.children,root:new s(a,h),toITestItem:m.TestItem.from})}}e.$UO=n}),define(Ce[31],Pe([1,0,16,7,8,26,4,18,13,52,29,93,2,6,3,17,113,23,50,42,64,58,61,34]),function($e,e,I,O,P,N,A,m,d,k,F,E,u,b,f,r,o,s,n,i,a,h,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6O=e.$5O=e.$4O=e.$3O=e.$2O=e.$1O=void 0;let c=class{#e;#t;#i;constructor(g,S,y){this.b=new Map,this.c=new Map,this.#e=g.getProxy(A.$kM.MainThreadCommands),this.d=S,this.#i=y,this.#t=g.getProxy(A.$kM.MainThreadTelemetry),this.converter=new $(this,C=>{const R=this.c.get(C);return R?.result===p.Void?R:void 0},S),this.f=[{processArgument(C){return(0,k.$Rh)(C)}},{processArgument(C){return(0,N.$Qn)(C,function(R){if(F.$ct.isIRange(R))return P.Range.to(R);if(E.$bt.isIPosition(R))return P.Position.to(R);if(F.$ct.isIRange(R.range)&&u.URI.isUri(R.uri))return P.location.to(R);if(R instanceof s.$ue)return R.buffer.buffer;if(!Array.isArray(R))return R})}}]}registerArgumentProcessor(g){this.f.push(g)}registerApiCommand(g){const S=this.registerCommand(!1,g.id,async(...y)=>{const C=g.args.map((V,U)=>{if(!V.validate(y[U]))throw new Error(`Invalid argument '${V.name}' when running '${g.id}', received: ${typeof y[U]=="object"?JSON.stringify(y[U],null,"	"):y[U]} `);return V.convert(y[U])}),R=await this.executeCommand(g.internalId,...C);return g.result.convert(R,y,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this.c.set(g.id,g),new O.$mM(()=>{S.dispose(),this.c.delete(g.id)})}registerCommand(g,S,y,C,R,V){if(this.d.trace("ExtHostCommands#registerCommand",S),!S.trim().length)throw new Error("invalid id");if(this.b.has(S))throw new Error(`command '${S}' already exists`);return this.b.set(S,{callback:y,thisArg:C,metadata:R,extension:V}),g&&this.#e.$registerCommand(S),new O.$mM(()=>{this.b.delete(S)&&g&&this.#e.$unregisterCommand(S)})}executeCommand(g,...S){return this.d.trace("ExtHostCommands#executeCommand",g),this.g(g,S,!0)}async g(g,S,y){if(this.b.has(g))return this.#e.$fireCommandActivationEvent(g),this.h(g,S,!1);{let C=!1;const R=(0,N.$Qn)(S,function(V){if(V instanceof O.$nM)return P.Position.from(V);if(V instanceof O.$oM)return P.Range.from(V);if(V instanceof O.$yM)return P.location.from(V);if(O.$NN.isNotebookRange(V))return P.NotebookRange.from(V);if(V instanceof ArrayBuffer)return C=!0,s.$ue.wrap(new Uint8Array(V));if(V instanceof Uint8Array)return C=!0,s.$ue.wrap(V);if(V instanceof s.$ue)return C=!0,V;if(!Array.isArray(V))return V});try{const V=await this.#e.$executeCommand(g,C?new n.$ew(R):R,y);return(0,k.$Rh)(V)}catch(V){if(V instanceof Error&&V.message==="$executeCommand:retry")return this.g(g,S,!1);throw V}}}async h(g,S,y){const C=this.b.get(g);if(!C)throw new Error("Unknown command");const{callback:R,thisArg:V,metadata:U}=C;if(U?.args)for(let M=0;M<U.args.length;M++)try{(0,I.$ag)(S[M],U.args[M].constraint)}catch{throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${U.args[M].name}' - ${U.args[M].description}`)}const q=a.$3d.create();try{return await R.apply(V,S)}catch(M){if(g===this.converter.delegatingCommandId){const L=this.converter.getActualCommand(...S);L&&(g=L.command)}if(this.d.error(M,g,C.extension?.identifier),!y)throw M;if(C.extension?.identifier){const L=this.#i.onExtensionError(C.extension.identifier,M);this.d.trace("forwarded error to extension?",L,C.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$6i)(M)),this.id=g,this.source=C.extension?.displayName??C.extension?.name}}}finally{this.j(C,g,q.elapsed())}}j(g,S,y){g.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:g.extension.identifier.value,id:new h.$4o(S),duration:y})}$executeContributedCommand(g,...S){this.d.trace("ExtHostCommands#$executeContributedCommand",g);const y=this.b.get(g);return y?(S=S.map(C=>this.f.reduce((R,V)=>V.processArgument(R,y.extension?.identifier),C)),this.h(g,S,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this.d.trace("ExtHostCommands#getCommands",g),this.#e.$getCommands().then(S=>(g&&(S=S.filter(y=>y[0]!=="_")),S))}$getContributedCommandMetadata(){const g=Object.create(null);for(const[S,y]of this.b){const{metadata:C}=y;C&&(g[S]=C)}return Promise.resolve(g)}};e.$1O=c,e.$1O=c=Je([We(0,r.$FO),We(1,d.$Oj),We(2,t.$ZO)],c),e.$2O=(0,f.$ii)("IExtHostCommands");class ${constructor(g,S,y){this.d=g,this.f=S,this.g=y,this.delegatingCommandId=`__vsc${(0,v.$Eg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(g,S){if(!g)return;const y={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return y;const C=this.f(g.command);if(C)y.id=C.internalId,y.arguments=C.args.map((R,V)=>R.convert(g.arguments&&g.arguments[V]));else if((0,m.$Lb)(g.arguments)){const R=`${g.command} /${++this.c}`;this.b.set(R,g),S.add((0,b.$Sc)(()=>{this.b.delete(R),this.g.trace("CommandsConverter#DISPOSE",R)})),y.$ident=R,y.id=this.delegatingCommandId,y.arguments=[R],this.g.trace("CommandsConverter#CREATE",g.command,R)}return y}fromInternal(g){return typeof g.$ident=="string"?this.b.get(g.$ident):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this.b.get(g[0])}h(...g){const S=this.getActualCommand(...g);return this.g.trace("CommandsConverter#EXECUTE",g[0],S?S.command:"MISSING"),S?this.d.executeCommand(S.command,...S.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${g[0]}`)}}e.$3O=$;class w{static{this.Uri=new w("uri","Uri of a text document",g=>u.URI.isUri(g),g=>g)}static{this.Position=new w("position","A position in a text document",g=>O.$nM.isPosition(g),P.Position.from)}static{this.Range=new w("range","A range in a text document",g=>O.$oM.isRange(g),P.Range.from)}static{this.Selection=new w("selection","A selection in a text document",g=>O.$pM.isSelection(g),P.Selection.from)}static{this.Number=new w("number","",g=>typeof g=="number",g=>g)}static{this.String=new w("string","",g=>typeof g=="string",g=>g)}static{this.StringArray=w.Arr(w.String)}static Arr(g){return new w(`${g.name}_array`,`Array of ${g.name}, ${g.description}`,S=>Array.isArray(S)&&S.every(y=>g.validate(y)),S=>S.map(y=>g.convert(y)))}static{this.CallHierarchyItem=new w("item","A call hierarchy item",g=>g instanceof O.$JM,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new w("item","A type hierarchy item",g=>g instanceof O.$7N,P.TypeHierarchyItem.from)}static{this.TestItem=new w("testItem","A VS Code TestItem",g=>g instanceof o.$SO,P.TestItem.from)}constructor(g,S,y,C){this.name=g,this.description=S,this.validate=y,this.convert=C}optional(){return new w(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,S){return new w(g??this.name,S??this.description,this.validate,this.convert)}}e.$4O=w;class p{static{this.Void=new p("no result",g=>g)}constructor(g,S){this.description=g,this.convert=S}}e.$5O=p;class l{constructor(g,S,y,C,R){this.id=g,this.internalId=S,this.description=y,this.args=C,this.result=R}}e.$6O=l}),define(Ce[275],Pe([1,0,18,12,2,87,97,33,31,8,7]),function($e,e,I,O,P,N,A,m,d,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ic=void 0;const E=[new d.$6O("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[d.$4O.Uri,d.$4O.Position],new d.$5O("A promise that resolves to an array of DocumentHighlight-instances.",b(k.DocumentHighlight.to))),new d.$6O("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[d.$4O.Uri],new d.$5O("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,o)=>{if((0,I.$Kb)(r))return;class s extends F.$EM{static to(i){const a=new s(i.name,k.SymbolKind.to(i.kind),i.containerName||"",new F.$yM(o[0],k.Range.to(i.range)));return a.detail=i.detail,a.range=a.location.range,a.selectionRange=k.Range.to(i.selectionRange),a.children=i.children?i.children.map(s.to):[],a}}return r.map(s.to)})),new d.$6O("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[d.$4O.Uri,new d.$4O("options","Formatting options",r=>!0,r=>r)],new d.$5O("A promise that resolves to an array of TextEdits.",b(k.TextEdit.to))),new d.$6O("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[d.$4O.Uri,d.$4O.Range,new d.$4O("options","Formatting options",r=>!0,r=>r)],new d.$5O("A promise that resolves to an array of TextEdits.",b(k.TextEdit.to))),new d.$6O("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[d.$4O.Uri,d.$4O.Position,new d.$4O("ch","Trigger character",r=>typeof r=="string",r=>r),new d.$4O("options","Formatting options",r=>!0,r=>r)],new d.$5O("A promise that resolves to an array of TextEdits.",b(k.TextEdit.to))),new d.$6O("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[d.$4O.Uri,d.$4O.Position],new d.$5O("A promise that resolves to an array of Location or LocationLink instances.",f)),new d.$6O("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[d.$4O.Uri,d.$4O.Position],new d.$5O("A promise that resolves to an array of Location or LocationLink instances.",f)),new d.$6O("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[d.$4O.Uri,d.$4O.Position],new d.$5O("A promise that resolves to an array of Location or LocationLink instances.",f)),new d.$6O("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[d.$4O.Uri,d.$4O.Position],new d.$5O("A promise that resolves to an array of Location or LocationLink instances.",f)),new d.$6O("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[d.$4O.Uri,d.$4O.Position],new d.$5O("A promise that resolves to an array of Location-instances.",b(k.location.to))),new d.$6O("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[d.$4O.Uri,d.$4O.Position],new d.$5O("A promise that resolves to an array of Hover-instances.",b(k.Hover.to))),new d.$6O("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[d.$4O.Uri,new d.$4O("position","A position in a text document",r=>Array.isArray(r)&&r.every(o=>F.$nM.isPosition(o)),r=>r.map(k.Position.from))],new d.$5O("A promise that resolves to an array of ranges.",r=>r.map(o=>{let s;for(const n of o.reverse())s=new F.$IM(k.Range.to(n),s);return s}))),new d.$6O("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[d.$4O.String.with("query","Search string")],new d.$5O("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(k.WorkspaceSymbol.to))),new d.$6O("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[d.$4O.Uri,d.$4O.Position],new d.$5O("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(k.CallHierarchyItem.to))),new d.$6O("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[d.$4O.CallHierarchyItem],new d.$5O("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(k.CallHierarchyIncomingCall.to))),new d.$6O("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[d.$4O.CallHierarchyItem],new d.$5O("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(k.CallHierarchyOutgoingCall.to))),new d.$6O("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[d.$4O.Uri,d.$4O.Position],new d.$5O("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:k.Range.to(r.range),placeholder:r.text}})),new d.$6O("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[d.$4O.Uri,d.$4O.Position,d.$4O.String.with("newName","The new symbol name")],new d.$5O("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return k.WorkspaceEdit.to(r)}})),new d.$6O("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[d.$4O.Uri,d.$4O.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new d.$5O("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(k.DocumentLink.to))),new d.$6O("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[d.$4O.Uri],new d.$5O("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new F.$EN(r.tokenTypes,r.tokenModifiers)})),new d.$6O("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[d.$4O.Uri],new d.$5O("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,A.$Eab)(r);if(o.type==="full")return new F.$GN(o.data,void 0)})),new d.$6O("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[d.$4O.Uri,d.$4O.Range.optional()],new d.$5O("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new F.$EN(r.tokenTypes,r.tokenModifiers)})),new d.$6O("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[d.$4O.Uri,d.$4O.Range],new d.$5O("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,A.$Eab)(r);if(o.type==="full")return new F.$GN(o.data,void 0)})),new d.$6O("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[d.$4O.Uri,d.$4O.Position,d.$4O.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),d.$4O.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new d.$5O("A promise that resolves to a CompletionList-instance.",(r,o,s)=>{if(!r)return new F.$UM([]);const n=r.suggestions.map(i=>k.CompletionItem.to(i,s));return new F.$UM(n,r.incomplete)})),new d.$6O("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[d.$4O.Uri,d.$4O.Position,d.$4O.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new d.$5O("A promise that resolves to SignatureHelp.",r=>{if(r)return k.SignatureHelp.to(r)})),new d.$6O("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[d.$4O.Uri,d.$4O.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new d.$5O("A promise that resolves to an array of CodeLens-instances.",(r,o,s)=>b(n=>new F.$MM(k.Range.to(n.range),n.command&&s.fromInternal(n.command)))(r))),new d.$6O("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[d.$4O.Uri,new d.$4O("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>F.$oM.isRange(r),r=>F.$pM.isSelection(r)?k.Selection.from(r):k.Range.from(r)),d.$4O.String.with("kind","Code action kind to return code actions for").optional(),d.$4O.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new d.$5O("A promise that resolves to an array of Command-instances.",(r,o,s)=>b(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(n.command)}else{const i=new F.$GM(n.title,n.kind?new F.$HM(n.kind):void 0);return n.edit&&(i.edit=k.WorkspaceEdit.to(n.edit)),n.command&&(i.command=s.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(r))),new d.$6O("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[d.$4O.Uri],new d.$5O("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(o=>new F.$1M(k.Range.to(o.range),k.Color.to(o.color))):[])),new d.$6O("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new d.$4O("color","The color to show and insert",r=>r instanceof F.$ZM,k.Color.from),new d.$4O("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:k.Range.from(r.range)}))],new d.$5O("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(k.ColorPresentation.to):[])),new d.$6O("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[d.$4O.Uri,d.$4O.Range],new d.$5O("A promise that resolves to an array of Inlay objects",(r,o,s)=>r.map(k.InlayHint.to.bind(void 0,s)))),new d.$6O("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[d.$4O.Uri],new d.$5O("A promise that resolves to an array of FoldingRange objects",(r,o)=>{if(r)return r.map(k.FoldingRange.to)})),new d.$6O("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new d.$5O("A promise that resolves to an array of NotebookContentProvider static info objects.",b(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(o=>k.NotebookExclusiveDocumentPattern.to(o))})))),new d.$6O("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[d.$4O.Uri,d.$4O.Range,new d.$4O("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof F.$oM,r=>k.InlineValueContext.from(r))],new d.$5O("A promise that resolves to an array of InlineValue objects",r=>r.map(k.InlineValue.to))),new d.$6O("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new d.$4O("uriOrString","Uri-instance or string (only http/https)",r=>P.URI.isUri(r)||typeof r=="string"&&(0,O.$sg)(r,O.Schemas.http,O.Schemas.https),r=>r),new d.$4O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[k.ViewColumn.from(r),void 0]:[k.ViewColumn.from(r.viewColumn),k.TextEditorOpenOptions.from(r)])).optional(),d.$4O.String.with("label","").optional()],d.$5O.Void),new d.$6O("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[d.$4O.Uri.with("resource","Resource to open"),d.$4O.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new d.$4O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[k.ViewColumn.from(r),void 0]:[k.ViewColumn.from(r.viewColumn),k.TextEditorOpenOptions.from(r)])).optional()],d.$5O.Void),new d.$6O("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[d.$4O.Uri.with("left","Left-hand side resource of the diff editor"),d.$4O.Uri.with("right","Right-hand side resource of the diff editor"),d.$4O.String.with("title","Human readable title for the diff editor").optional(),new d.$4O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[k.ViewColumn.from(r.viewColumn),k.TextEditorOpenOptions.from(r)]).optional()],d.$5O.Void),new d.$6O("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[d.$4O.String.with("title","Human readable title for the changes editor"),new d.$4O("resourceList","List of resources to compare",r=>{for(const o of r){if(o.length!==3)return!1;const[s,n,i]=o;if(!P.URI.isUri(s)||!P.URI.isUri(n)&&n!==void 0&&n!==null||!P.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},r=>r)],d.$5O.Void),new d.$6O("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[d.$4O.Uri,d.$4O.Position],new d.$5O("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(k.TypeHierarchyItem.to))),new d.$6O("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[d.$4O.TypeHierarchyItem],new d.$5O("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(k.TypeHierarchyItem.to))),new d.$6O("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[d.$4O.TypeHierarchyItem],new d.$5O("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(k.TypeHierarchyItem.to))),new d.$6O("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[d.$4O.TestItem],d.$5O.Void),new d.$6O("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[d.$4O.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],d.$5O.Void),new d.$6O("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[d.$4O.String.with("name","The context key name"),new d.$4O("value","The context key value",()=>!0,r=>r)],d.$5O.Void),new d.$6O("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[d.$4O.Uri,d.$4O.StringArray,new d.$4O("MappedEditsContext","Mapped Edits Context",r=>k.MappedEditsContext.is(r),r=>k.MappedEditsContext.from(r))],new d.$5O("A promise that resolves to a workspace edit or null",r=>r?k.WorkspaceEdit.to(r):null))];class u{static register(o){E.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",m.$hj)}}e.$9ic=u;function b(r){return o=>{if(Array.isArray(o))return o.map(r)}}function f(r){if(!Array.isArray(r))return;const o=[];for(const s of r)N.$3t(s)?o.push(k.DefinitionLink.to(s)):o.push(k.location.to(s));return o}}),define(Ce[276],Pe([1,0,11,6,2,4,31,8,7]),function($e,e,I,O,P,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gkc=void 0;class k{static{this.a=0}constructor(b,f){this.extension=b,this.provider=f,this.handle=k.a++}}class F{constructor(b){this.session=b,this.responses=[]}}class E{static{this.a=0}constructor(b,f,r,o){this.f=r,this.g=o,this.b=new Map,this.d=new Map,this.e=b.getProxy(N.$kM.MainThreadInlineChat),f.registerApiCommand(new A.$6O("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new A.$4O("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?m.Range.from(s.initialRange):void 0,initialSelection:d.$pM.isSelection(s.initialSelection)?m.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?m.Position.from(s.position):void 0}})],A.$5O.Void))}registerProvider(b,f,r){const o=new k(b,f);return this.b.set(o.handle,o),this.e.$registerInteractiveEditorProvider(o.handle,r?.label??b.displayName??b.name,b.identifier.value,typeof f.handleInteractiveEditorResponseFeedback=="function",typeof f.provideFollowups=="function",r?.supportReportIssue??!1),(0,O.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(o.handle),this.b.delete(o.handle)})}async $prepareSession(b,f,r,o){const s=this.b.get(b);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(P.URI.revive(f)),i=m.Selection.to(r),a=await s.provider.prepareInteractiveEditorSession({document:n,selection:i},o);if(!a)return;if(a.wholeRange&&!a.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=E.a++;return this.d.set(h,new F(a)),{id:h,placeholder:a.placeholder,input:a.input,slashCommands:a.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:m.Range.from(a.wholeRange),message:a.message}}async $provideResponse(b,f,r,o){const s=this.b.get(b);if(!s)return;const n=this.d.get(f.id);if(!n)return;const i={prompt:r.prompt,selection:m.Selection.to(r.selection),wholeRange:m.Range.to(r.wholeRange),attempt:r.attempt,live:r.live,previewDocument:this.f.getDocument(P.URI.revive(r.previewDocument)),withIntentDetection:r.withIntentDetection};let a=!1;const h={report:async D=>{if(!r.live&&D.edits?.length)throw new Error("Progress reporting is only supported for live sessions");a||o.isCancellationRequested||await this.e.$handleProgressChunk(r.requestId,{message:D.message,edits:D.edits?.map(m.TextEdit.from),editsShouldBeInstant:D.editsShouldBeInstant,slashCommand:D.slashCommand?.command,markdownFragment:d.$NM.isMarkdownString(D.content)?D.content.value:D.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(n.session,i,h,o));let v;try{v=await(0,I.$9g)(t,o)}finally{a=!0}if(!v)return;const c=n.responses.push(v)-1,$={wholeRange:m.Range.from(v.wholeRange),placeholder:v.placeholder};if(!E.h(v))return{...$,id:c,type:"editorEdit",message:m.MarkdownString.from(v.contents),edits:[]};const{edits:w,contents:p}=v,l=p!==void 0?m.MarkdownString.from(p):void 0;return w instanceof d.$wM?{...$,id:c,type:"bulkEdit",edits:m.WorkspaceEdit.from(w),message:l}:{...$,id:c,type:"editorEdit",edits:w.map(m.TextEdit.from),message:l}}async $provideFollowups(b,f,r,o){const s=this.b.get(b),n=this.d.get(f),i=n?.responses[r];if(s&&i&&s.provider.provideFollowups){const a=Promise.resolve(s.provider.provideFollowups(n.session,i,o));return(await(0,I.$9g)(a,o))?.map(m.ChatInlineFollowup.from)}}$handleFeedback(b,f,r,o){const s=this.b.get(b),n=this.d.get(f),i=n?.responses[r];if(s&&i){const a=m.InteractiveEditorResponseFeedbackKind.to(o);s.provider.handleInteractiveEditorResponseFeedback?.(n.session,i,a)}}$releaseSession(b,f){}static h(b){return typeof b=="object"&&typeof b.edits=="object"}}e.$gkc=E}),define(Ce[277],Pe([1,0,2,31]),function($e,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tkc=void 0;class P{constructor(A,m,d,k,F){this.a=m,this.b=d,this.c=k;const E=new O.$6O("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new O.$4O("showOptions","Show Options",u=>!0,u=>u),new O.$4O("resource","Interactive resource Uri",u=>!0,u=>u),new O.$4O("controllerId","Notebook controller Id",u=>!0,u=>u),new O.$4O("title","Interactive editor title",u=>!0,u=>u)],new O.$5O("Notebook and input URI",u=>{if(F.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const b=this.a.getEditorById(u.notebookEditorId);return F.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:I.URI.revive(u.notebookUri),inputUri:I.URI.revive(u.inputUri),notebookEditor:b.apiEditor}}return F.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:I.URI.revive(u.notebookUri),inputUri:I.URI.revive(u.inputUri)}}));this.c.registerApiCommand(E)}$willAddInteractiveDocument(A,m,d,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:d,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$tkc=P}),define(Ce[278],Pe([1,0,18,11,25,5,6,28,2,20,13,4,31,8,7,76,217,22,50,218]),function($e,e,I,O,P,N,A,m,d,k,F,E,u,b,f,r,o,s,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bkc=void 0,e.$Ckc=w;let a=class{constructor(l,D,g,S,y){this.m=D,this.n=g,this.o=S,this.q=y,this.b=new m.$Bc,this.c=new m.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new N.$7d,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=l.getProxy(E.$kM.MainThreadNotebookKernels);const C=new u.$6O("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$4O("options","Select kernel options",V=>!0,V=>{if(V&&"notebookEditor"in V&&"id"in V){const U=this.n.getIdByEditor(V.notebookEditor);return{id:V.id,extension:V.extension,notebookEditorId:U}}else if(V&&"notebookEditor"in V){const U=this.n.getIdByEditor(V.notebookEditor);if(U===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${V.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:U}}return V})],u.$5O.Void),R=new u.$6O("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$4O.Uri],new u.$5O("A promise that resolves to an array of variables",(V,U)=>V.map(q=>({name:q.name,value:q.value,type:q.type,editable:!1}))));this.o.registerApiCommand(C),this.o.registerApiCommand(R)}createNotebookController(l,D,g,S,y,C){for(const be of this.j.values())if(be.controller.id===D&&k.$Dm.equals(l.identifier,be.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const R=this.k++,V=this;this.q.trace(`NotebookController[${R}], CREATED by ${l.identifier.value}, ${D}`);const U=()=>console.warn(`NO execute handler from notebook controller '${G.id}' of extension: '${l.identifier}'`);let q=!1;const M=new N.$7d,L=new N.$7d,G={id:w(l.identifier,D),notebookType:g,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:S||l.identifier.value,preloads:C?C.map(b.NotebookRendererScript.from):[]};let ne=y??U,he,ye;this.a.$addKernel(R,G).catch(be=>{console.log(be),q=!0});let Re=0;const ge=()=>{if(q)return;const be=++Re;Promise.resolve().then(()=>{be===Re&&this.a.$updateKernel(R,G)})},ue=new m.$Bc,te={get id(){return D},get notebookType(){return G.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return G.label},set label(be){G.label=be??l.displayName??l.name,ge()},get detail(){return G.detail??""},set detail(be){G.detail=be,ge()},get description(){return G.description??""},set description(be){G.description=be,ge()},get supportedLanguages(){return G.supportedLanguages},set supportedLanguages(be){G.supportedLanguages=be,ge()},get supportsExecutionOrder(){return G.supportsExecutionOrder??!1},set supportsExecutionOrder(be){G.supportsExecutionOrder=be,ge()},get rendererScripts(){return G.preloads?G.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return ne},set executeHandler(be){ne=be??U},get interruptHandler(){return he},set interruptHandler(be){he=be,G.supportsInterrupt=!!be,ge()},set variableProvider(be){(0,s.$9F)(l,"notebookVariableProvider"),ye=be,G.hasVariableProvider=!!be,be?.onDidChangeVariables(oe=>V.a.$variablesUpdated(oe.uri)),ge()},get variableProvider(){return ye},createNotebookCellExecution(be){if(q)throw new Error("notebook controller is DISPOSED");if(!ue.has(be.notebook.uri))throw V.q.trace(`NotebookController[${R}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(oe=>oe.toString())),new Error(`notebook controller is NOT associated to notebook: ${be.notebook.uri.toString()}`);return V._createNotebookCellExecution(be,w(l.identifier,this.id))},createNotebookExecution(be){if((0,s.$9F)(l,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!ue.has(be.uri))throw V.q.trace(`NotebookController[${R}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(oe=>oe.toString())),new Error(`notebook controller is NOT associated to notebook: ${be.uri.toString()}`);return V._createNotebookExecution(be,w(l.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${R}], DISPOSED`),q=!0,this.j.delete(R),M.dispose(),L.dispose(),this.a.$removeKernel(R))},updateNotebookAffinity(be,oe){oe===f.NotebookControllerAffinity2.Hidden&&(0,s.$9F)(l,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(R,be.uri,oe)},onDidReceiveMessage:L.event,postMessage(be,oe){return(0,s.$9F)(l,"notebookMessaging"),V.a.$postMessage(R,oe&&V.n.getIdByEditor(oe),be)},asWebviewUri(be){return(0,s.$9F)(l,"notebookMessaging"),(0,r.$8yb)(be,V.m.remote)}};return this.j.set(R,{extensionId:l.identifier,controller:te,onDidReceiveMessage:L,onDidChangeSelection:M,associatedNotebooks:ue}),te}getIdByController(l){for(const[D,g]of this.j)if(g.controller===l)return w(g.extensionId,l.id);return null}createNotebookControllerDetectionTask(l,D){const g=this.g++,S=this;this.q.trace(`NotebookControllerDetectionTask[${g}], CREATED by ${l.identifier.value}`),this.a.$addKernelDetectionTask(g,D);const y={dispose:()=>{this.f.delete(g),S.a.$removeKernelDetectionTask(g)}};return this.f.set(g,y),y}registerKernelSourceActionProvider(l,D,g){const S=this.i++,y=typeof g.onDidChangeNotebookKernelSourceActions=="function"?S:void 0,C=this;this.h.set(S,g),this.q.trace(`NotebookKernelSourceActionProvider[${S}], CREATED by ${l.identifier.value}`),this.a.$addKernelSourceActionProvider(S,S,D);let R;return y!==void 0&&(R=g.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(S),C.a.$removeKernelSourceActionProvider(S,S),R?.dispose()}}}async $provideKernelSourceActions(l,D){const g=this.h.get(l);if(g){const S=new A.$Tc;return(await g.provideNotebookKernelSourceActions(D)??[]).map(C=>b.NotebookKernelSourceAction.from(C,this.o.converter,S))}return[]}$acceptNotebookAssociation(l,D,g){const S=this.j.get(l);if(S){const y=this.n.getNotebookDocument(d.URI.revive(D));g?S.associatedNotebooks.set(y.uri,!0):S.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${l}] ASSOCIATE notebook`,y.uri.toString(),g),S.onDidChangeSelection.fire({selected:g,notebook:y.apiNotebook})}}async $executeCells(l,D,g){const S=this.j.get(l);if(!S)return;const y=this.n.getNotebookDocument(d.URI.revive(D)),C=[];for(const R of g){const V=y.getCell(R);V&&C.push(V.apiCell)}try{this.q.trace(`NotebookController[${l}] EXECUTE cells`,y.uri.toString(),C.length),await S.controller.executeHandler.call(S.controller,C,y.apiNotebook,S.controller)}catch(R){this.q.error(`NotebookController[${l}] execute cells FAILED`,R),console.error(R)}}async $cancelCells(l,D,g){const S=this.j.get(l);if(!S)return;const y=this.n.getNotebookDocument(d.URI.revive(D));if(S.controller.interruptHandler)await S.controller.interruptHandler.call(S.controller,y.apiNotebook);else for(const C of g){const R=y.getCell(C);R&&this.b.get(R.uri)?.cancel()}if(S.controller.interruptHandler){const C=this.c.get(y.uri);g.length&&Array.isArray(C)&&C.length&&C.forEach(R=>R.dispose())}}async $provideVariables(l,D,g,S,y,C,R){const V=this.j.get(l);if(!V)return;const U=this.n.getNotebookDocument(d.URI.revive(g)),q=V.controller.variableProvider;if(!q)return;let M;if(S!==void 0){if(M=this.s[S],!M)return}else this.s={};const L=y==="named"?f.NotebookVariablesRequestKind.Named:f.NotebookVariablesRequestKind.Indexed,G=q.provideVariables(U.apiNotebook,M,L,C,R);let ne=0;for await(const he of G){if(R.isCancellationRequested)return;const ye={id:this.r++,name:he.variable.name,value:he.variable.value,type:he.variable.type,language:he.variable.language,expression:he.variable.expression,hasNamedChildren:he.hasNamedChildren,indexedChildrenCount:he.indexedChildrenCount,extensionId:V.extensionId.value};if(this.s[ye.id]=he.variable,this.a.$receiveVariable(D,ye),ne++>=i.$whb)return}}$acceptKernelMessageFromRenderer(l,D,g){const S=this.j.get(l);if(!S)return;const y=this.n.getEditorById(D);S.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:g}))}$cellExecutionChanged(l,D,g){const y=this.n.getNotebookDocument(d.URI.revive(l)).getCell(D);if(y){const C=g?b.NotebookCellExecutionState.to(g):f.NotebookCellExecutionState.Idle;C!==void 0&&this.l.fire({cell:y.apiCell,state:C})}}_createNotebookCellExecution(l,D){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const S=this.n.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!S)throw new Error("invalid cell");if(this.b.has(S.uri))throw new Error(`duplicate execution for ${S.uri}`);const y=new t(D,S,this.a);this.b.set(S.uri,y);const C=y.onDidChangeState(()=>{y.state===h.Resolved&&(y.dispose(),C.dispose(),this.b.delete(S.uri))});return y.asApiObject()}_createNotebookExecution(l,D){const g=this.n.getNotebookDocument(l.uri),S=l.getCells().find(R=>{const V=g.getCellFromApiCell(R);return V&&this.b.has(V.uri)});if(S)throw new Error(`duplicate cell execution for ${S.document.uri}`);if(this.c.has(g.uri))throw new Error(`duplicate notebook execution for ${g.uri}`);const y=new c(D,g,this.a),C=y.onDidChangeState(()=>{y.state===v.Resolved&&(y.dispose(),C.dispose(),this.c.delete(g.uri))});return this.c.set(g.uri,[y,C]),y.asApiObject()}};e.$Bkc=a,e.$Bkc=a=Je([We(4,F.$Oj)],a);var h;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(h||(h={}));class t extends A.$Uc{static{this.a=0}get state(){return this.f}constructor(l,D,g){super(),this.m=D,this.n=g,this.b=t.a++,this.c=new N.$7d,this.onDidChangeState=this.c.event,this.f=h.Init,this.g=this.B(new P.$ee),this.h=new $(10,S=>this.s(S)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,l,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(l){await this.h.addItem(l)}async s(l){const D=Array.isArray(l)?l:[l];return this.n.$updateExecution(this.b,new n.$ew(D))}t(){if(this.f===h.Init)throw new Error("Must call start before modifying cell output");if(this.f===h.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(l){let D=this.m;if(l&&(D=this.m.notebook.getCellFromApiCell(l)),!D)throw new Error("INVALID cell");return D.handle}y(l){return l.map(D=>{const g=f.$RN.ensureUniqueMimeTypes(D.items,!0);return g===D.items?b.NotebookCellOutput.from(D):b.NotebookCellOutput.from({items:g,id:D.id,metadata:D.metadata})})}async z(l,D,g){const S=this.w(D),y=this.y((0,I.$3b)(l));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:S,append:g,outputs:y})}async C(l,D,g){return l=f.$RN.ensureUniqueMimeTypes((0,I.$3b)(l),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:l.map(b.NotebookCellOutputItem.from),outputId:D.id,append:g})}asApiObject(){const l=this;return Object.freeze({get token(){return l.g.token},get cell(){return l.m.apiCell},get executionOrder(){return l.j},set executionOrder(g){l.j=g,l.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:l.j}])},start(g){if(l.f===h.Resolved||l.f===h.Started)throw new Error("Cannot call start again");l.f=h.Started,l.c.fire(),l.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:g})},end(g,S,y){if(l.f===h.Resolved)throw new Error("Cannot call resolve twice");l.f=h.Resolved,l.c.fire(),l.h.flush();const C=y?{message:y.message,stack:y.stack,location:y?.location?{startLineNumber:y.location.start.line,startColumn:y.location.start.character,endLineNumber:y.location.end.line,endColumn:y.location.end.character}:void 0,uri:y.uri}:void 0;l.n.$completeExecution(l.b,new n.$ew({runEndTime:S,lastRunSuccess:g,error:C}))},clearOutput(g){return l.t(),l.z([],g,!1)},appendOutput(g,S){return l.t(),l.z(g,S,!0)},replaceOutput(g,S){return l.t(),l.z(g,S,!1)},appendOutputItems(g,S){return l.t(),l.C(g,S,!0)},replaceOutputItems(g,S){return l.t(),l.C(g,S,!1)}})}}var v;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(v||(v={}));class c extends A.$Uc{static{this.a=0}get state(){return this.f}constructor(l,D,g){super(),this.h=D,this.j=g,this.b=c.a++,this.c=new N.$7d,this.onDidChangeState=this.c.event,this.f=v.Init,this.g=this.B(new P.$ee),this.j.$createNotebookExecution(this.b,l,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===v.Resolved||this.f===v.Started)throw new Error("Cannot call start again");this.f=v.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===v.Resolved)throw new Error("Cannot call resolve twice");this.f=v.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class ${constructor(l,D){this.f=l,this.g=D,this.a=[],this.b=Date.now()}addItem(l){return this.a.push(l),this.c||(this.c=new O.$Fh,this.b=Date.now(),(0,O.$jh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const l=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>l.complete())}}function w(p,l){return`${p.value}/${l}`}}),define(Ce[66],Pe([1,0,5,4,3,2,17,6,7,171,14,199,25,34,200,41,11,8,31]),function($e,e,I,O,P,N,A,m,d,k,F,E,u,b,f,r,o,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qjc=e.$Pjc=e.$Ojc=e.$Njc=void 0,e.$Njc=(0,P.$ii)("IExtHostTerminalService");class i{constructor(g,S,y,C){this.l=g,this._id=S,this.m=y,this.n=C,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(V=>this.f=V);const R=this;this.value={get name(){return R.n||""},get processId(){return R.b},get creationOptions(){return R.m},get exitStatus(){return R.h},get state(){return R.j},get selection(){return R.k},sendText(V,U=!0){R.q(),R.l.$sendText(R._id,V,U)},show(V){R.q(),R.l.$show(R._id,V)},hide(){R.q(),R.l.$hide(R._id)},dispose(){R.a||(R.a=!0,R.l.$dispose(R._id))},get dimensions(){if(!(R.d===void 0||R.g===void 0))return{columns:R.d,rows:R.g}}}}async create(g,S){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:g.name,shellPath:g.shellPath??void 0,shellArgs:g.shellArgs??void 0,cwd:g.cwd??S?.cwd??void 0,env:g.env??void 0,icon:w(g.iconPath)??void 0,color:r.ThemeColor.isThemeColor(g.color)?g.color.id:void 0,initialText:g.message??void 0,strictEnv:g.strictEnv??void 0,hideFromUser:g.hideFromUser??void 0,forceShellIntegration:S?.forceShellIntegration??void 0,isFeatureTerminal:S?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:S?.useShellEnvironment??void 0,location:S?.location||this.o(g.location,S?.resolvedExtHostIdentifier),isTransient:g.isTransient??void 0})}async createExtensionTerminal(g,S,y,C,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:C,color:r.ThemeColor.isThemeColor(R)?R.id:void 0,location:S?.location||this.o(g,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(g,S){return typeof g=="object"?"parentTerminal"in g&&g.parentTerminal&&S?{parentTerminal:S}:"viewColumn"in g?{viewColumn:s.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus}:void 0:g}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(g){this.n=g}setExitStatus(g,S){this.h=Object.freeze({code:g,reason:S})}setDimensions(g,S){return g===this.d&&S===this.g||g===0||S===0?!1:(this.d=g,this.g=S,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(g){this.k=g}_setProcessId(g){this.f?(this.f(g),this.f=void 0):this.b.then(S=>{S!==g&&(this.b=Promise.resolve(g))})}}e.$Ojc=i;class a{get onProcessReady(){return this.b.event}constructor(g){this.g=g,this.id=0,this.shouldPersist=!1,this.a=new I.$7d,this.onProcessData=this.a.event,this.b=new I.$7d,this.d=new I.$7d,this.onDidChangeProperty=this.d.event,this.f=new I.$7d,this.onProcessExit=this.f.event}refreshProperty(g){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${g}`)}updateProperty(g,S){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${g}, value: ${S}`)}async start(){}shutdown(){this.g.close()}input(g){this.g.handleInput?.(g)}resize(g,S){this.g.setDimensions?.({columns:g,rows:S})}clearBuffer(){}async processBinary(g){}acknowledgeDataEvent(g){}async setUnicodeVersion(g){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(g){this.g.onDidWrite(S=>this.a.fire(S)),this.g.onDidClose?.((S=void 0)=>{this.f.fire(S===void 0?void 0:S)}),this.g.onDidOverrideDimensions?.(S=>{S&&this.d.fire({type:"overrideDimensions",value:{cols:S.columns,rows:S.rows}})}),this.g.onDidChangeName?.(S=>{this.d.fire({type:"title",value:S})}),this.g.open(g||void 0),g&&this.g.setDimensions?.(g),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,t=class extends m.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(g=>g.value)}constructor(g,S,y){super(),this.Q=S,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new m.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new I.$7d,this.onDidCloseTerminal=this.H.event,this.I=new I.$7d,this.onDidOpenTerminal=this.I.event,this.J=new I.$7d,this.onDidChangeActiveTerminal=this.J.event,this.L=new I.$7d,this.onDidChangeTerminalDimensions=this.L.event,this.M=new I.$7d,this.onDidChangeTerminalState=this.M.event,this.N=new I.$7d,this.onDidChangeShell=this.N.event,this.O=new I.$7d({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new I.$7d({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(O.$kM.MainThreadTerminalService),this.y=new f.$zub(this.a.$sendProcessData),this.a.$registerProcessSupport(g),this.Q.registerArgumentProcessor({processArgument:C=>{const R=V=>{const U=V;return this.W(U.instanceId)?.value};switch(C?.$mid){case 15:return R(C);default:{if(Array.isArray(C))for(let V=0;V<C.length&&C[V].$mid===15;V++)C[V]=R(C[V]);return C}}}}),this.B({dispose:()=>{for(const[C,R]of this.g)R.shutdown(!0)}})}getDefaultShell(g){return(g?this.u:this.s)?.path||""}getDefaultShellArgs(g){return(g?this.u:this.s)?.args||[]}createExtensionTerminal(g,S){const y=new i(this.a,(0,b.$Eg)(),g,g.name),C=new a(g.pty);return y.createExtensionTerminal(g.location,S,this.R(g,S).resolvedExtHostIdentifier,w(g.iconPath),p(g.color)).then(R=>{const V=this.S(R,C);this.h[R]=V}),this.f.push(y),y.value}R(g,S){if(S=S||{},g.location&&typeof g.location=="object"&&"parentTerminal"in g.location){const y=g.location.parentTerminal;if(y){const C=this.f.find(R=>R.value===y);C&&(S.resolvedExtHostIdentifier=C._id)}}else g.location&&typeof g.location!="object"?S.location=g.location:S.location&&typeof S.location=="object"&&"splitActiveTerminal"in S.location&&(S.location={splitActiveTerminal:!0});return S}attachPtyToTerminal(g,S){if(!this.W(g))throw new Error(`Cannot resolve terminal with id ${g} for virtual process`);const C=new a(S),R=this.S(g,C);this.h[g]=R}async $acceptActiveTerminalChanged(g){const S=this.b;if(g===null){this.b=void 0,S!==this.b&&this.J.fire(this.b);return}const y=this.W(g);y&&(this.b=y,S!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(g,S){const y=this.W(g);y&&this.O.fire({terminal:y.value,data:S})}async $acceptTerminalDimensions(g,S,y){const C=this.W(g);C&&C.setDimensions(S,y)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(g,S){const y=this.W(g);y&&this.P.fire({terminal:y.value,...S})}async $acceptTerminalMaximumDimensions(g,S,y){this.g.get(g)?.resize(S,y)}async $acceptTerminalTitleChange(g,S){const y=this.W(g);y&&(y.name=S)}async $acceptTerminalClosed(g,S,y){const C=this.Y(this.f,g);if(C!==null){const R=this.f.splice(C,1)[0];R.setExitStatus(S,y),this.H.fire(R.value)}}$acceptTerminalOpened(g,S,y,C){if(S){const U=this.Y(this.f,S);if(U!==null){this.f[U]._id=g,this.I.fire(this.terminals[U]),this.f[U].isOpen=!0;return}}const R={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:N.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},V=new i(this.a,g,R,y);this.f.push(V),this.I.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(g,S){this.W(g)?._setProcessId(S)}async $startExtensionTerminal(g,S){const y=this.W(g);if(!y)return{message:(0,k.localize)(0,null,g)};y.isOpen||await new Promise(R=>{const V=this.onDidOpenTerminal(async U=>{U===y.value&&(V.dispose(),R())})});const C=this.g.get(g);C?C.startSendingEvents(S):this.j[g]={initialDimensions:S}}S(g,S){const y=new m.$Tc;y.add(S.onProcessReady(R=>this.a.$sendProcessReady(g,R.pid,R.cwd,R.windowsPty))),y.add(S.onDidChangeProperty(R=>this.a.$sendProcessProperty(g,R))),this.y.startBuffering(g,S.onProcessData),y.add(S.onProcessExit(R=>this.U(g,R))),this.g.set(g,S);const C=this.j[g];return C&&S instanceof a&&(S.startSendingEvents(C.initialDimensions),delete this.j[g]),y}$acceptProcessAckDataEvent(g,S){this.g.get(g)?.acknowledgeDataEvent(S)}$acceptProcessInput(g,S){this.g.get(g)?.input(S)}$acceptTerminalInteraction(g){const S=this.W(g);S?.setInteractedWith()&&this.M.fire(S.value)}$acceptTerminalSelection(g,S){this.W(g)?.setSelection(S)}$acceptProcessResize(g,S,y){try{this.g.get(g)?.resize(S,y)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(g,S){this.g.get(g)?.shutdown(S)}$acceptProcessRequestInitialCwd(g){this.g.get(g)?.getInitialCwd().then(S=>this.a.$sendProcessProperty(g,{type:"initialCwd",value:S}))}$acceptProcessRequestCwd(g){this.g.get(g)?.getCwd().then(S=>this.a.$sendProcessProperty(g,{type:"cwd",value:S}))}$acceptProcessRequestLatency(g){return Promise.resolve(g)}registerLinkProvider(g){return this.z.add(g),this.z.size===1&&this.a.$startLinkProvider(),new d.$mM(()=>{this.z.delete(g),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(g,S,y){if(this.C.has(S))throw new Error(`Terminal profile provider "${S}" already registered`);return this.C.set(S,y),this.a.$registerProfileProvider(S,g.identifier.value),new d.$mM(()=>{this.C.delete(S),this.a.$unregisterProfileProvider(S)})}registerTerminalQuickFixProvider(g,S,y){if(this.D.has(g))throw new Error(`Terminal quick fix provider "${g}" is already registered`);return this.D.set(g,y),this.a.$registerQuickFixProvider(g,S),new d.$mM(()=>{this.D.delete(g),this.a.$unregisterQuickFixProvider(g)})}async $provideTerminalQuickFixes(g,S){const y=new u.$ee().token;if(y.isCancellationRequested)return;const C=this.D.get(g);if(!C)return;const R=await C.provideTerminalQuickFixes(S,y);if(R===null||Array.isArray(R)&&R.length===0)return;const V=new m.$Tc;if(this.w.value=V,!Array.isArray(R))return R?s.TerminalQuickFix.from(R,this.Q.converter,V):void 0;const U=[];for(const q of R){const M=s.TerminalQuickFix.from(q,this.Q.converter,V);M&&U.push(M)}return U}async $createContributedProfileTerminal(g,S){const y=new u.$ee().token;let C=await this.C.get(g)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${g}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,S);return}this.createTerminalFromOptions(C.options,S)}}async $provideLinks(g,S){const y=this.W(g);if(!y)return[];this.F.delete(g),this.G.get(g)?.dispose(!0);const R=new u.$ee;this.G.set(g,R);const V=[],U={terminal:y.value,line:S},q=[];for(const G of this.z)q.push(o.Promises.withAsyncBody(async ne=>{R.token.onCancellationRequested(()=>ne({provider:G,links:[]}));const he=await G.provideTerminalLinks(U,R.token)||[];R.token.isCancellationRequested||ne({provider:G,links:he})}));const M=await Promise.all(q);if(R.token.isCancellationRequested)return[];const L=new Map;for(const G of M)G&&G.links.length>0&&V.push(...G.links.map(ne=>{const he={id:h++,startIndex:ne.startIndex,length:ne.length,label:ne.tooltip};return L.set(he.id,{provider:G.provider,link:ne}),he}));return this.F.set(g,L),V}$activateLink(g,S){const y=this.F.get(g)?.get(S);y&&y.provider.handleTerminalLink(y.link)}U(g,S){this.y.stopBuffering(g),this.g.delete(g),delete this.j[g];const y=this.h[g];y&&(y.dispose(),delete this.h[g]),this.a.$sendProcessExit(g,S)}W(g){return this.X(this.f,g)}X(g,S){const y=this.Y(g,S);return y!==null?g[y]:null}Y(g,S){const y=g.findIndex(C=>C._id===S);return y===-1?null:y}getEnvironmentVariableCollection(g){let S=this.n.get(g.identifier.value);return S||(S=new v,this.$(g.identifier.value,S)),S.getScopedEnvironmentVariableCollection(void 0)}Z(g,S){const y=(0,E.$7r)(S.map),C=(0,E.$8r)(S.descriptionMap);this.a.$setEnvironmentVariableCollection(g,S.persistent,y.length===0?void 0:y,C)}$initEnvironmentVariableCollections(g){g.forEach(S=>{const y=S[0],C=new v(S[1]);this.$(y,C)})}$acceptDefaultProfile(g,S){const y=this.s;this.s=g,this.u=S,y?.path!==g.path&&this.N.fire(g.path)}$(g,S){this.n.set(g,S),S.onDidChangeCollection(()=>{this.Z(g,S)})}};e.$Pjc=t,e.$Pjc=t=Je([We(1,n.$2O),We(2,A.$FO)],t);class v{get persistent(){return this.b}set persistent(g){this.b=g,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(g){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new I.$7d,this.map=new Map(g)}getScopedEnvironmentVariableCollection(g){const S=this.h(g);let y=this.a.get(S);return y||(y=new c(this,g),this.a.set(S,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(g,S,y,C){this.f(g,{value:S,type:d.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:C})}append(g,S,y,C){this.f(g,{value:S,type:d.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:C})}prepend(g,S,y,C){this.f(g,{value:S,type:d.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:C})}f(g,S){if(S.options&&S.options.applyAtProcessCreation===!1&&!S.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(g,S.scope),C=this.map.get(y),R=S.options?{applyAtProcessCreation:S.options.applyAtProcessCreation??!1,applyAtShellIntegration:S.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==S.value||C.type!==S.type||C.options?.applyAtProcessCreation!==R.applyAtProcessCreation||C.options?.applyAtShellIntegration!==R.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==S.scope?.workspaceFolder?.index){const V=this.g(g,S.scope),U={variable:g,...S,options:R};this.map.set(V,U),this.d.fire()}}get(g,S){const y=this.g(g,S),C=this.map.get(y);return C?l(C):void 0}g(g,S){const y=this.h(S);return y.length?`${g}:::${y}`:g}h(g){return this.j(g?.workspaceFolder)??""}j(g){return g?g.uri.toString():void 0}getVariableMap(g){const S=new Map;for(const[y,C]of this.map)this.h(C.scope)===this.h(g)&&S.set(C.variable,l(C));return S}delete(g,S){const y=this.g(g,S);this.map.delete(y),this.d.fire()}clear(g){if(g?.workspaceFolder){for(const[S,y]of this.map)y.scope?.workspaceFolder?.index===g.workspaceFolder.index&&this.map.delete(S);this.k(g)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(g,S){const y=this.h(S),C=this.descriptionMap.get(y);if(!C||C.description!==g){let R;typeof g=="string"?R=g:R=g?.value.split(`

`)[0];const V={description:R,scope:S};this.descriptionMap.set(y,V),this.d.fire()}}getDescription(g){const S=this.h(g);return this.descriptionMap.get(S)?.description}k(g){const S=this.h(g);this.descriptionMap.delete(S)}}class c{get persistent(){return this.b.persistent}set persistent(g){this.b.persistent=g}get onDidChangeCollection(){return this.a&&this.a.event}constructor(g,S){this.b=g,this.d=S,this.a=new I.$7d}getScoped(g){return this.b.getScopedEnvironmentVariableCollection(g)}replace(g,S,y){this.b.replace(g,S,y,this.d)}append(g,S,y){this.b.append(g,S,y,this.d)}prepend(g,S,y){this.b.prepend(g,S,y,this.d)}get(g){return this.b.get(g,this.d)}forEach(g,S){this.b.getVariableMap(this.d).forEach((y,C)=>g.call(S,C,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(g){this.b.delete(g,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(g){this.b.setDescription(g,this.d)}get description(){return this.b.getDescription(this.d)}}let $=class extends t{constructor(g,S){super(!1,g,S)}createTerminal(g,S,y){throw new F.$_}createTerminalFromOptions(g,S){throw new F.$_}};e.$Qjc=$,e.$Qjc=$=Je([We(0,n.$2O),We(1,A.$FO)],$);function w(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function p(D){return r.ThemeColor.isThemeColor(D)?D:void 0}function l(D){const g={...D};return delete g.scope,g.options=g.options??void 0,delete g.variable,g}}),define(Ce[279],Pe([1,0,11,23,25,5,251,99,6,16,34,13,4,17,113,8,7,49,75,60,22]),function($e,e,I,O,P,N,A,m,d,k,F,E,u,b,f,r,o,s,n,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wkc=e.$Vkc=e.$Ukc=e.$Tkc=void 0;let h=class extends d.$Uc{constructor(V,U,q,M){super(),this.w=M,this.f=this.B(new N.$7d),this.g=new Map,this.s=this.B(new N.$7d),this.onResultsChanged=this.f.event,this.results=[],this.h=V.getProxy(u.$kM.MainThreadTesting),this.m=new g(this.h),this.j=new $(this.h,U),q.registerArgumentProcessor({processArgument:L=>{switch(L?.$mid){case 16:{const G=L,ne=G.tests[G.tests.length-1].item.extId;return this.g.get(s.$9K.root(ne))?.collection.tree.get(ne)?.actual??(0,f.$RO)(L)}case 18:{const{test:G,message:ne}=L,he=G.item.extId;return{test:this.g.get(s.$9K.root(he))?.collection.tree.get(he)?.actual??(0,f.$RO)({$mid:16,tests:[G]}),message:r.TestMessage.to(ne)}}default:return L}}}),q.registerCommand(!1,"testing.getExplorerSelection",async()=>{const L=await q.executeCommand("_testing.getExplorerSelection"),G=ne=>{const he=this.g.get(s.$9K.root(ne));if(he)return s.$9K.isRoot(ne)?he.controller:he.collection.tree.get(ne)?.actual};return{include:L?.include.map(G).filter(k.$4f)||[],exclude:L?.exclude.map(G).filter(k.$4f)||[]}})}createTestController(V,U,q,M){if(this.g.has(U))throw new Error(`Attempt to insert a duplicate controller with ID "${U}"`);const L=new d.$Tc,G=L.add(new f.$UO(U,q,this.w));G.root.label=q;const ne=new Map,he=new Set,ye=this.h,Re={items:G.root.children,get label(){return q},set label(ue){q=ue,G.root.label=ue,ye.$updateController(U,{label:q})},get refreshHandler(){return M},set refreshHandler(ue){M=ue,ye.$updateController(U,{canRefresh:!!ue})},get id(){return U},createRunProfile:(ue,te,be,oe,de,W)=>{let ee=(0,m.$9i)(ue);for(;ne.has(ee);)ee++;return new y(this.h,ne,he,this.s.event,U,ee,ue,te,be,oe,de,W)},createTestItem(ue,te,be){return new f.$SO(U,ue,te,be)},createTestRun:(ue,te,be=!0)=>this.j.createTestRun(V,U,G,ue,te,be),invalidateTestResults:ue=>{if(ue===void 0)this.h.$markTestRetired(void 0);else{const te=ue instanceof Array?ue:[ue];this.h.$markTestRetired(te.map(be=>s.$9K.fromExtHostTestItem(be,U).toString()))}},set resolveHandler(ue){G.resolveHandler=ue},get resolveHandler(){return G.resolveHandler},dispose:()=>{L.dispose()}};ye.$registerTestController(U,q,!!M),L.add((0,d.$Sc)(()=>ye.$unregisterTestController(U)));const ge={controller:Re,collection:G,profiles:ne,extension:V,activeProfiles:he};return this.g.set(U,ge),L.add((0,d.$Sc)(()=>this.g.delete(U))),L.add(G.onDidGenerateDiff(ue=>ye.$publishDiff(U,ue.map(i.TestsDiffOp.serialize)))),Re}createTestObserver(){return this.m.checkout()}async runTests(V,U=P.CancellationToken.None){const q=w(V);if(!q)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const M=this.g.get(q.controllerId);if(!M)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:V.include?.map(L=>s.$9K.fromExtHostTestItem(L,M.collection.root.id).toString())??[M.collection.root.id],profileGroup:C[q.kind],profileId:q.profileId,controllerId:q.controllerId}],exclude:V.exclude?.map(L=>L.id)},U)}$syncTests(){for(const{collection:V}of this.g.values())V.flushDiff();return Promise.resolve()}async $getCoverageDetails(V,U){return(await this.j.getCoverageDetails(V,U))?.map(r.TestCoverage.fromDetails)}async $disposeRun(V){this.j.disposeTestRun(V)}$configureRunProfile(V,U){this.g.get(V)?.profiles.get(U)?.configureHandler?.()}$setDefaultRunProfiles(V){const U=new Map;for(const[q,M]of Object.entries(V)){const L=this.g.get(q);if(!L)continue;const G=new Map,ne=M.filter(ye=>!L.activeProfiles.has(ye)),he=[...L.activeProfiles].filter(ye=>!M.includes(ye));for(const ye of ne)G.set(ye,!0),L.activeProfiles.add(ye);for(const ye of he)G.set(ye,!1),L.activeProfiles.delete(ye);G.size&&U.set(q,G)}this.s.fire(U)}async $refreshTests(V,U){await this.g.get(V)?.controller.refreshHandler?.(U)}$publishTestResults(V){this.results=Object.freeze(V.map(r.TestResults.to).concat(this.results).sort((U,q)=>q.completedAt-U.completedAt).slice(0,32)),this.f.fire()}async $expandTest(V,U){const q=this.g.get(s.$9K.fromString(V).controllerId)?.collection;q&&(await q.expand(V,U<0?1/0:U),q.flushDiff())}$acceptDiff(V){this.m.applyDiff(V.map(U=>i.TestsDiffOp.deserialize({asCanonicalUri:q=>q},U)))}async $runControllerTests(V,U){return Promise.all(V.map(q=>this.y(q,!1,U)))}async $startContinuousRun(V,U){const q=new P.$ee(U),M=await Promise.all(V.map(L=>this.y(L,!0,q.token)));return!U.isCancellationRequested&&!M.some(L=>L.error)&&await new Promise(L=>U.onCancellationRequested(L)),q.dispose(!0),M}async y(V,U,q){const M=this.g.get(V.controllerId);if(!M)return{};const{collection:L,profiles:G,extension:ne}=M,he=G.get(V.profileId);if(!he)return{};const ye=V.testIds.map(te=>L.tree.get(te)).filter(k.$4f),Re=V.excludeExtIds.map(te=>M.collection.tree.get(te)).filter(k.$4f).filter(te=>ye.some(be=>be.fullId.compare(te.fullId)===2));if(!ye.length)return{};const ge=new o.$YN(ye.some(te=>te.actual instanceof f.$TO)?void 0:ye.map(te=>te.actual),Re.map(te=>te.actual),he,U),ue=(0,i.$_K)(V)&&this.j.prepareForMainThreadTestRun(ge,p.fromInternal(V,M.collection),ne,he,q);try{return await he.runHandler(ge,q),{}}catch(te){return{error:String(te)}}finally{ue&&ue.hasRunningTasks&&!q.isCancellationRequested&&await N.Event.toPromise(ue.onEnd)}}$cancelExtensionTestRun(V){V===void 0?this.j.cancelAllRuns():this.j.cancelRunById(V)}};e.$Tkc=h,e.$Tkc=h=Je([We(0,b.$FO),We(1,E.$Oj)],h);const t=1e4;var v;(function(R){R[R.Running=0]="Running",R[R.Cancelling=1]="Cancelling",R[R.Ended=2]="Ended"})(v||(v={}));class c extends d.$Uc{get hasRunningTasks(){return this.g>0}get id(){return this.z.id}constructor(V,U,q,M,L,G){super(),this.z=V,this.C=U,this.D=q,this.F=M,this.G=L,this.f=0,this.g=0,this.h=new Map,this.j=new Set,this.s=this.B(new N.$7d),this.y=new Map,this.onEnd=this.s.event,this.m=this.B(new P.$ee(G));const ne=this.B(new I.$uh(()=>this.H(),t));this.B(this.m.token.onCancellationRequested(()=>ne.schedule()));const he=new N.$7d;this.w=he.event,this.B((0,d.$Sc)(()=>{he.fire(),he.dispose()}))}cancel(){this.f===0?(this.m.cancel(),this.f=1):this.f===1&&this.H()}getCoverageDetails(V,U){const[,q,M]=s.$9K.fromString(V).path,L=this.y.get(M);if(!L)return[];if(L.backCompatResolve)return L.backCompatResolve(U);const G=this.h.get(q);if(!G)throw new Error("unreachable: run task was not found");return this.G?.loadDetailedCoverage?.(G.run,L.coverage,U)??[]}createRun(V){const U=this.z.id,q=this.z.controllerId,M=(0,F.$Eg)(),L=this.D,G=ue=>(te,...be)=>{if(ye){this.F.warn(`Setting the state of test "${te.id}" is a no-op after the run ends.`);return}this.z.isIncluded(te)&&(this.J(te),ue(te,...be))},ne=(ue,te)=>{const be=te instanceof Array?te.map(r.TestMessage.from):[r.TestMessage.from(te)];if(ue.uri&&ue.range){const oe={range:r.Range.from(ue.range),uri:ue.uri};for(const de of be)de.location=de.location||oe}this.C.$appendTestMessagesInRun(U,M,s.$9K.fromExtHostTestItem(ue,q).toString(),be)},he=(ue,te)=>{const be=ue.uri.toString(),oe=new s.$9K([U,M,be]).toString();this.y.set(be,{coverage:ue,backCompatResolve:te}),this.C.$appendCoverage(U,M,r.TestCoverage.fromFile(oe,ue))};let ye=!1,Re;const ge={isPersisted:this.z.isPersisted,token:this.m.token,name:V,onDidDispose:this.w,get coverageProvider(){return Re},set coverageProvider(ue){(0,a.$9F)(L,"testCoverage"),Re=ue,ue&&Promise.resolve(ue.provideFileCoverage(P.CancellationToken.None)).then(te=>{te?.forEach(be=>he(be,ue.resolveFileCoverage&&(async oe=>(await ue.resolveFileCoverage(be,oe)||be).detailedCoverage)))})},addCoverage:ue=>{(0,a.$9F)(L,"testCoverage"),he(ue)},enqueued:G(ue=>{this.C.$updateTestStateInRun(U,M,s.$9K.fromExtHostTestItem(ue,q).toString(),1)}),skipped:G(ue=>{this.C.$updateTestStateInRun(U,M,s.$9K.fromExtHostTestItem(ue,q).toString(),5)}),started:G(ue=>{this.C.$updateTestStateInRun(U,M,s.$9K.fromExtHostTestItem(ue,q).toString(),2)}),errored:G((ue,te,be)=>{ne(ue,te),this.C.$updateTestStateInRun(U,M,s.$9K.fromExtHostTestItem(ue,q).toString(),6,be)}),failed:G((ue,te,be)=>{ne(ue,te),this.C.$updateTestStateInRun(U,M,s.$9K.fromExtHostTestItem(ue,q).toString(),4,be)}),passed:G((ue,te)=>{this.C.$updateTestStateInRun(U,M,s.$9K.fromExtHostTestItem(ue,this.z.controllerId).toString(),3,te)}),appendOutput:(ue,te,be)=>{ye||(be&&(this.z.isIncluded(be)?this.J(be):be=void 0),this.C.$appendOutputToRun(U,M,O.$ue.fromString(ue),te&&r.location.from(te),be&&s.$9K.fromExtHostTestItem(be,q).toString()))},end:()=>{ye||(ye=!0,this.C.$finishedTestRunTask(U,M),--this.g||this.I())}};return this.g++,this.h.set(M,{run:ge}),this.C.$startedTestRunTask(U,{id:M,name:V,running:!0}),ge}H(){for(const{run:V}of this.h.values())V.end()}I(){this.f!==2&&(this.f=2,this.s.fire())}J(V){if(!(V instanceof f.$SO))throw new n.$xO(V.id);if(this.j.has(s.$9K.fromExtHostTestItem(V,this.z.controllerId).toString()))return;const U=[],q=this.z.colllection.root;for(;;){const M=r.TestItem.from(V);if(U.unshift(M),this.j.has(M.extId)||(this.j.add(M.extId),V===q))break;V=V.parent||q}this.C.$addTestsToRun(this.z.controllerId,this.z.id,U)}dispose(){this.I(),super.dispose()}}class ${get trackers(){return this.f.values()}constructor(V,U){this.h=V,this.j=U,this.f=new Map,this.g=new Map}getCoverageDetails(V,U){const q=s.$9K.root(V);return this.g.get(q)?.getCoverageDetails(V,U)||[]}disposeTestRun(V){this.g.get(V)?.dispose(),this.g.delete(V);for(const[U,{id:q}]of this.f)q===V&&this.f.delete(U)}prepareForMainThreadTestRun(V,U,q,M,L){return this.k(V,U,q,M,L)}cancelRunById(V){this.g.get(V)?.cancel()}cancelAllRuns(){for(const V of this.f.values())V.cancel()}createTestRun(V,U,q,M,L,G){const ne=this.f.get(M);if(ne)return ne.createRun(L);const he=p.fromPublic(U,q,M,G),ye=w(M);this.h.$startedExtensionTestRun({controllerId:U,continuous:!!M.continuous,profile:ye&&{group:C[ye.kind],id:ye.profileId},exclude:M.exclude?.map(ge=>s.$9K.fromExtHostTestItem(ge,q.root.id).toString())??[],id:he.id,include:M.include?.map(ge=>s.$9K.fromExtHostTestItem(ge,q.root.id).toString())??[q.root.id],persist:G});const Re=this.k(M,he,V,M.profile);return N.Event.once(Re.onEnd)(()=>{this.h.$finishedExtensionTestRun(he.id)}),Re.createRun(L)}k(V,U,q,M,L){const G=new c(U,this.h,q,this.j,M,L);return this.f.set(V,G),this.g.set(G.id,G),G}}e.$Ukc=$;const w=R=>{if(R.profile){if(!(R.profile instanceof y))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return R.profile}};class p{static fromPublic(V,U,q,M){return new p(V,(0,F.$Eg)(),q.include?.map(L=>s.$9K.fromExtHostTestItem(L,V).toString())??[V],q.exclude?.map(L=>s.$9K.fromExtHostTestItem(L,V).toString())??[],M,U)}static fromInternal(V,U){return new p(V.controllerId,V.runId,V.testIds,V.excludeExtIds,!0,U)}constructor(V,U,q,M,L,G){this.controllerId=V,this.id=U,this.isPersisted=L,this.colllection=G,this.f=q.map(ne=>ne+"\0"),this.g=M.map(ne=>ne+"\0")}isIncluded(V){const U=s.$9K.fromExtHostTestItem(V,this.controllerId).toString()+"\0";for(const q of this.g)if(U===q||U.startsWith(q))return!1;for(const q of this.f)if(U===q||U.startsWith(q))return!0;return!1}}e.$Vkc=p;class l{get isEmpty(){return this.f.size===0&&this.h.size===0&&this.g.size===0}constructor(V){this.k=V,this.f=new Set,this.g=new Set,this.h=new Set,this.j=new Set}add(V){this.f.add(V)}update(V){Object.assign(V.revived,r.TestItem.toPlain(V.item)),this.f.has(V)||this.g.add(V)}remove(V){if(this.f.has(V)){this.f.delete(V);return}this.g.delete(V);const U=s.$9K.parentId(V.item.extId);if(U&&this.j.has(U.toString())){this.j.add(V.item.extId);return}this.h.add(V)}getChangeEvent(){const{f:V,g:U,h:q}=this;return{get added(){return[...V].map(M=>M.revived)},get updated(){return[...U].map(M=>M.revived)},get removed(){return[...q].map(M=>M.revived)}}}complete(){this.isEmpty||this.k.fire(this.getChangeEvent())}}class D extends i.$fL{constructor(){super(...arguments),this.s=new N.$7d,this.onDidChangeTests=this.s.event}get rootTests(){return this.h}getMirroredTestDataById(V){return this.g.get(V)}getMirroredTestDataByReference(V){return this.g.get(V.id)}x(V,U){return{...V,revived:r.TestItem.toPlain(V.item),depth:U?U.depth+1:0,children:new Set}}w(){return new l(this.s)}}class g{constructor(V){this.g=V}checkout(){this.f||(this.f=this.h());const V=this.f;return V.observers++,{onDidChangeTest:V.tests.onDidChangeTests,get tests(){return[...V.tests.rootTests].map(U=>U.revived)},dispose:(0,A.$db)(()=>{--V.observers===0&&(this.g.$unsubscribeFromDiffs(),this.f=void 0)})}}getMirroredTestDataByReference(V){return this.f?.tests.getMirroredTestDataByReference(V)}applyDiff(V){this.f?.tests.apply(V)}h(){const V=new D({asCanonicalUri:U=>U});return this.g.$subscribeToDiffs(),{observers:0,tests:V}}}const S=(R,V,U,q)=>{U?Object.assign(U,q):V.$updateTestRunConfig(R.controllerId,R.profileId,q)};class y{#e;#t;#i;#n;#s;get label(){return this.g}set label(V){V!==this.g&&(this.g=V,S(this,this.#e,this.#n,{label:V}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(V){V!==this.h&&(this.h=V,S(this,this.#e,this.#n,{supportsContinuousRun:V}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(V){V!==this.isDefault&&(V?this.#t.add(this.profileId):this.#t.delete(this.profileId),S(this,this.#e,this.#n,{isDefault:V}))}get tag(){return this._tag}set tag(V){V?.id!==this._tag?.id&&(this._tag=V,S(this,this.#e,this.#n,{tag:V?r.TestTag.namespace(this.controllerId,V.id):null}))}get configureHandler(){return this.f}set configureHandler(V){V!==this.f&&(this.f=V,S(this,this.#e,this.#n,{hasConfigurationHandler:!!V}))}get onDidChangeDefault(){return N.Event.chain(this.#i,V=>V.map(U=>U.get(this.controllerId)?.get(this.profileId)).filter(k.$4f))}constructor(V,U,q,M,L,G,ne,he,ye,Re=!1,ge=void 0,ue=!1){this.controllerId=L,this.profileId=G,this.g=ne,this.kind=he,this.runHandler=ye,this._tag=ge,this.h=ue,this.#e=V,this.#s=U,this.#t=q,this.#i=M,U.set(G,this);const te=C[he];if(typeof te!="number")throw new Error(`Unknown TestRunProfile.group ${he}`);Re&&q.add(G),this.#n={profileId:G,controllerId:L,tag:ge?r.TestTag.namespace(this.controllerId,ge.id):null,label:ne,group:te,isDefault:Re,hasConfigurationHandler:!1,supportsContinuousRun:ue},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Wkc=y;const C={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Ce[114],Pe([1,0,55,14,90,8,7]),function($e,e,I,O,P,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OO=e.$NO=e.$MO=void 0;class m{static{this.c=new P.$KO("TextEditorDecorationType")}constructor(u,b,f){const r=m.c.nextId();u.$registerTextEditorDecorationType(b.identifier,r,N.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:r,dispose(){u.$removeTextEditorDecorationType(r)}})}}e.$MO=m;class d{constructor(u,b){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,b){this.k();let f=null;if(u instanceof A.$nM)f=new A.$oM(u,u);else if(u instanceof A.$oM)f=u;else throw new Error("Unrecognized location");this.l(f,b,!1)}insert(u,b){this.k(),this.l(new A.$oM(u,u),b,!0)}delete(u){this.k();let b=null;if(u instanceof A.$oM)b=u;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(u,b,f){const r=this.c.validateRange(u);this.g.push({range:r,text:b,forceMoveMarkers:f})}setEndOfLine(u){if(this.k(),u!==A.EndOfLine.LF&&u!==A.EndOfLine.CRLF)throw(0,O.$7)("endOfLine");this.h=u}}class k{constructor(u,b,f,r){this.c=u,this.d=b,this._accept(f),this.e=r;const o=this;this.value={get tabSize(){return o.f},set tabSize(s){o.n(s)},get indentSize(){return o.g},set indentSize(s){o.p(s)},get insertSpaces(){return o.j},set insertSpaces(s){o.s(s)},get cursorStyle(){return o.k},set cursorStyle(s){o.t(s)},get lineNumbers(){return o.l},set lineNumbers(s){o.u(s)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=N.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const b=Math.floor(u);return b>0?b:null}if(typeof u=="string"){const b=parseInt(u,10);return isNaN(b)?null:b>0?b:null}return null}n(u){const b=this.m(u);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const b=Math.floor(u);return b>0?b:null}if(typeof u=="string"){const b=parseInt(u,10);return isNaN(b)?null:b>0?b:null}return null}p(u){const b=this.o(u);if(b!==null){if(typeof b=="number"){if(this.h===b)return;this.g=b,this.h=b}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const b=this.q(u);if(typeof b=="boolean"){if(this.j===b)return;this.j=b}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:N.TextEditorLineNumbersStyle.from(u)})))}assign(u){const b={};let f=!1;if(typeof u.tabSize<"u"){const r=this.m(u.tabSize);r==="auto"?(f=!0,b.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,f=!0,b.tabSize=r)}if(typeof u.indentSize<"u"){const r=this.o(u.indentSize);r==="tabSize"?(f=!0,b.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,f=!0,b.indentSize=r)}if(typeof u.insertSpaces<"u"){const r=this.q(u.insertSpaces);r==="auto"?(f=!0,b.insertSpaces=r):this.j!==r&&(this.j=r,f=!0,b.insertSpaces=r)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,f=!0,b.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,f=!0,b.lineNumbers=N.TextEditorLineNumbersStyle.from(u.lineNumbers)),f&&this.v("setOptions",this.c.$trySetOptions(this.d,b))}v(u,b){b.catch(f=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(f)})}}e.$NO=k;class F{constructor(u,b,f,r,o,s,n,i){this.id=u,this.j=b,this.k=f,this.g=!1,this.h=new Set,this.c=o,this.d=new k(this.j,this.id,s,f),this.e=n,this.f=i;const a=this;this.value=Object.freeze({get document(){return r.value},set document(h){throw new O.$9("document")},get selection(){return a.c&&a.c[0]},set selection(h){if(!(h instanceof A.$pM))throw(0,O.$7)("selection");a.c=[h],a.l()},get selections(){return a.c},set selections(h){if(!Array.isArray(h)||h.some(t=>!(t instanceof A.$pM)))throw(0,O.$7)("selections");a.c=h,a.l()},get visibleRanges(){return a.e},set visibleRanges(h){throw new O.$9("visibleRanges")},get options(){return a.d.value},set options(h){a.g||a.d.assign(h)},get viewColumn(){return a.f},set viewColumn(h){throw new O.$9("viewColumn")},edit(h,t={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const v=new d(r.value,t);return h(v),a.m(v)},insertSnippet(h,t,v={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!t||Array.isArray(t)&&t.length===0)c=a.c.map($=>N.Range.from($));else if(t instanceof A.$nM){const{lineNumber:$,column:w}=N.Position.from(t);c=[{startLineNumber:$,startColumn:w,endLineNumber:$,endColumn:w}]}else if(t instanceof A.$oM)c=[N.Range.from(t)];else{c=[];for(const $ of t)if($ instanceof A.$oM)c.push(N.Range.from($));else{const{lineNumber:w,column:p}=N.Position.from($);c.push({startLineNumber:w,startColumn:p,endLineNumber:w,endColumn:p})}}return b.$tryInsertSnippet(u,r.value.version,h.value,c,v)},setDecorations(h,t){const v=t.length===0;v&&!a.h.has(h.key)||(v?a.h.delete(h.key):a.h.add(h.key),a.n(()=>{if(N.$CO(t))return b.$trySetDecorations(u,h.key,N.$DO(t));{const c=new Array(4*t.length);for(let $=0,w=t.length;$<w;$++){const p=t[$];c[4*$]=p.start.line+1,c[4*$+1]=p.start.character+1,c[4*$+2]=p.end.line+1,c[4*$+3]=p.end.character+1}return b.$trySetDecorationsFast(u,h.key,c)}}))},revealRange(h,t){a.n(()=>b.$tryRevealRange(u,N.Range.from(h),t||A.TextEditorRevealType.Default))},show(h){b.$tryShowEditor(u,N.ViewColumn.from(h))},hide(){b.$tryHideEditor(u)}})}dispose(){(0,I.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,I.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,I.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,I.ok)(!this.g),this.f=u}_acceptSelections(u){(0,I.ok)(!this.g),this.c=u}async l(){const u=this.c.map(N.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const b=u.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const f=b.edits.map(o=>o.range);f.sort((o,s)=>o.end.line===s.end.line?o.end.character===s.end.character?o.start.line===s.start.line?o.start.character-s.start.character:o.start.line-s.start.line:o.end.character-s.end.character:o.end.line-s.end.line);for(let o=0,s=f.length-1;o<s;o++){const n=f[o].end;if(f[o+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=b.edits.map(o=>({range:N.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,r,{setEndOfLine:typeof b.setEndOfLine=="number"?N.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.$OO=F}),define(Ce[67],Pe([1,0,55,5,6,2,3,4,111,17,114,8,13,28,12,39,40]),function($e,e,I,O,P,N,A,m,d,k,F,E,u,b,f,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QO=e.$PO=void 0;class s{constructor(a){this.value=a,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(a,h){this.h=a,this.i=h,this.a=null,this.b=new Map,this.c=new b.$Bc,this.d=new O.$7d,this.e=new O.$7d,this.f=new O.$7d,this.g=new O.$7d,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const h=[],t=[],v=[];if(a.removedDocuments)for(const c of a.removedDocuments){const $=N.URI.revive(c),w=this.c.get($);w?.unref()&&(this.c.delete($),h.push(w.value))}if(a.addedDocuments)for(const c of a.addedDocuments){const $=N.URI.revive(c.uri);let w=this.c.get($);if(w&&$.scheme!==f.Schemas.vscodeNotebookCell&&$.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${$} already exists!'`);w||(w=new s(new d.$IO(this.h.getProxy(m.$kM.MainThreadDocuments),$,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty)),this.c.set($,w),t.push(w.value)),w.ref()}if(a.removedEditors)for(const c of a.removedEditors){const $=this.b.get(c);this.b.delete(c),$&&v.push($)}if(a.addedEditors)for(const c of a.addedEditors){const $=N.URI.revive(c.documentUri);I.ok(this.c.has($),`document '${$}' does not exist`),I.ok(!this.b.has(c.id),`editor '${c.id}' already exists!`);const w=this.c.get($).value,p=new F.$OO(c.id,this.h.getProxy(m.$kM.MainThreadTextEditors),this.i,new o.$V(()=>w.document),c.selections.map(E.Selection.to),c.options,c.visibleRanges.map(l=>E.Range.to(l)),typeof c.editorPosition=="number"?E.ViewColumn.to(c.editorPosition):void 0);this.b.set(c.id,p)}a.newActiveEditor!==void 0&&(I.ok(a.newActiveEditor===null||this.b.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this.a=a.newActiveEditor),(0,P.$Pc)(h),(0,P.$Pc)(v),a.removedDocuments&&this.e.fire(h),a.addedDocuments&&this.d.fire(t),(a.removedEditors||a.addedEditors)&&this.f.fire(this.allEditors().map(c=>c.value)),a.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(a){return this.c.get(a)?.value}allDocuments(){return r.Iterable.map(this.c.values(),a=>a.value)}getEditor(a){return this.b.get(a)}activeEditor(a){if(!this.a)return;const h=this.b.get(this.a);return a?h:h?.value}allEditors(){return[...this.b.values()]}};e.$PO=n,e.$PO=n=Je([We(0,k.$FO),We(1,u.$Oj)],n),e.$QO=(0,A.$ii)("IExtHostDocumentsAndEditors")}),define(Ce[280],Pe([1,0,18,5,4,114,8,7]),function($e,e,I,O,P,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gjc=void 0;class d{constructor(F,E){this.i=E,this.a=new O.$7d,this.b=new O.$7d,this.c=new O.$7d,this.d=new O.$7d,this.f=new O.$7d,this.g=new O.$7d,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=F.getProxy(P.$kM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(u=>this.g.fire(u)),this.i.onDidChangeActiveTextEditor(u=>this.f.fire(u))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(F){const E=this.i.allEditors();return F?E:E.map(u=>u.value)}async showTextDocument(F,E,u){let b;typeof E=="number"?b={position:A.ViewColumn.from(E),preserveFocus:u}:typeof E=="object"?b={position:A.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selection:typeof E.selection=="object"?A.Range.from(E.selection):void 0,pinned:typeof E.preview=="boolean"?!E.preview:void 0}:b={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(F.uri,b),r=f&&this.i.getEditor(f);if(r)return r.value;throw f?new Error(`Could NOT open editor for "${F.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${F.uri.toString()}".`)}createTextEditorDecorationType(F,E){return new N.$MO(this.h,F,E).value}$acceptEditorPropertiesChanged(F,E){const u=this.i.getEditor(F);if(!u)throw new Error("unknown text editor");if(E.options&&u._acceptOptions(E.options),E.selections){const b=E.selections.selections.map(A.Selection.to);u._acceptSelections(b)}if(E.visibleRanges){const b=I.$Hb(E.visibleRanges.map(A.Range.to));u._acceptVisibleRanges(b)}if(E.options&&this.b.fire({textEditor:u.value,options:{...E.options,lineNumbers:A.TextEditorLineNumbersStyle.to(E.options.lineNumbers)}}),E.selections){const b=m.TextEditorSelectionChangeKind.fromValue(E.selections.source),f=E.selections.selections.map(A.Selection.to);this.a.fire({textEditor:u.value,selections:f,kind:b})}if(E.visibleRanges){const b=I.$Hb(E.visibleRanges.map(A.Range.to));this.c.fire({textEditor:u.value,visibleRanges:b})}}$acceptEditorPositionData(F){for(const E in F){const u=this.i.getEditor(E);if(!u)throw new Error("Unknown text editor");const b=A.ViewColumn.to(F[E]);u.value.viewColumn!==b&&(u._acceptViewColumn(b),this.d.fire({textEditor:u.value,viewColumn:b}))}}getDiffInformation(F){return Promise.resolve(this.h.$getDiffInformation(F))}}e.$gjc=d}),define(Ce[281],Pe([1,0,2,3,4,6,7,8,20,16]),function($e,e,I,O,P,N,A,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zkc=e.$Ykc=void 0,e.$Ykc=(0,O.$ii)("IExtHostTimeline");class F{constructor(b,f){this.b=new Map,this.c=new Map,this.a=b.getProxy(P.$kM.MainThreadTimeline),f.registerArgumentProcessor({processArgument:(r,o)=>{if(r&&r.$mid===12)if(this.b.get(r.source)&&d.$Dm.equals(o,this.b.get(r.source)?.extension)){const s=r.uri===void 0?void 0:I.URI.revive(r.uri);return this.c.get(r.source)?.get(E(s))?.get(r.handle)}else return;return r}})}async $getTimeline(b,f,r,o){return this.b.get(b)?.provider.provideTimeline(I.URI.revive(f),r,o)}registerTimelineProvider(b,f,r,o){const s=new N.$Tc,n=this.d(f.id,o,s).bind(this);let i;f.onDidChange&&(i=f.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:f.id}),this));const a=this.c;return this.f({...f,scheme:b,onDidChange:void 0,async provideTimeline(h,t,v){t?.resetCache&&(s.clear(),a.get(f.id)?.clear());const c=await f.provideTimeline(h,t,v);if(c==null)return;const $=n(h,t);return{...c,source:f.id,items:c.items.map($)}},dispose(){for(const h of a.values())h.get(f.id)?.clear();i?.dispose(),s.dispose()}},r)}d(b,f,r){return(o,s)=>{let n;if(s?.cacheResults){let i=this.c.get(b);i===void 0&&(i=new Map,this.c.set(b,i));const a=E(o);n=i.get(a),n===void 0&&(n=new Map,i.set(a,n))}return i=>{const{iconPath:a,...h}=i,t=`${b}|${i.id??i.timestamp}`;n?.set(t,i);let v,c,$;i.iconPath&&(a instanceof A.$iN?$={id:a.id,color:a.color}:I.URI.isUri(a)?(v=a,c=a):{light:v,dark:c}=a);let w;return A.$NM.isMarkdownString(h.tooltip)?w=m.MarkdownString.from(h.tooltip):(0,k.$Vf)(h.tooltip)?w=h.tooltip:A.$NM.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=m.MarkdownString.from(h.detail)):(0,k.$Vf)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=h.detail),{...h,id:h.id??void 0,handle:t,source:b,command:i.command?f.toInternal(i.command,r):void 0,icon:v,iconDark:c,themeIcon:$,tooltip:w,accessibilityInformation:i.accessibilityInformation}}}}f(b,f){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:f}),(0,N.$Sc)(()=>{for(const o of this.c.values())o.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.$Zkc=F;function E(u){return u?.toString()}}),define(Ce[282],Pe([1,0,172,24,2,5,6,210,11,7,16,18,8,53,25,136,22]),function($e,e,I,O,P,N,A,m,d,k,F,E,u,b,f,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1kc=void 0;function s(a,h){if((0,F.$Vf)(a))return{label:a};if(a&&typeof a=="object"&&typeof a.label=="string"){let t;return Array.isArray(a.highlights)&&(t=a.highlights.filter(v=>v.length===2&&typeof v[0]=="number"&&typeof v[1]=="number"),t=t.length?t:void 0),{label:a.label,highlights:t}}}class n extends A.$Uc{constructor(h,t,v){super(),this.f=h,this.g=t,this.h=v,this.a=new Map,this.b=new r.$09;function c($){return $&&$.$treeViewId&&($.$treeItemHandle||$.$selectedTreeItems||$.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:$=>c($)?this.r($):Array.isArray($)&&$.length>0?$.map(w=>c(w)?this.r(w):w):$})}registerTreeDataProvider(h,t,v){const c=this.createTreeView(h,{treeDataProvider:t},v);return{dispose:()=>c.dispose()}}createTreeView(h,t,v){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=t.dragAndDropController?.dropMimeTypes??[],$=t.dragAndDropController?.dragMimeTypes??[],w=!!t.dragAndDropController?.handleDrag,p=!!t.dragAndDropController?.handleDrop,l=this.m(h,t,v),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:c,dragMimeTypes:$,hasHandleDrag:w,hasHandleDrop:p,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},g=this.f.$registerTreeViewDataProvider(h,D),S={get onDidCollapseElement(){return l.onDidCollapseElement},get onDidExpandElement(){return l.onDidExpandElement},get selection(){return l.selectedElements},get onDidChangeSelection(){return l.onDidChangeSelection},get activeItem(){return(0,o.$9F)(v,"treeViewActiveItem"),l.focusedElement},get onDidChangeActiveItem(){return(0,o.$9F)(v,"treeViewActiveItem"),l.onDidChangeActiveItem},get visible(){return l.visible},get onDidChangeVisibility(){return l.onDidChangeVisibility},get onDidChangeCheckboxState(){return l.onDidChangeCheckboxState},get message(){return l.message},set message(y){(0,b.$Hk)(y)&&(0,o.$9F)(v,"treeViewMarkdownMessage"),l.message=y},get title(){return l.title},set title(y){l.title=y},get description(){return l.description},set description(y){l.description=y},get badge(){return l.badge},set badge(y){y!==void 0&&k.ViewBadge.isViewBadge(y)?l.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(l.badge=void 0)},reveal:(y,C)=>l.reveal(y,C),dispose:async()=>{await g,this.a.delete(h),l.dispose()}};return this.B(S),S}$getChildren(h,t){const v=this.a.get(h);return v?v.getChildren(t):Promise.reject(new m.$AF(h))}async $handleDrop(h,t,v,c,$,w,p,l){const D=this.a.get(h);if(!D)return Promise.reject(new m.$AF(h));const g=u.DataTransfer.toDataTransfer(v,async S=>(await this.f.$resolveDropFileData(h,t,S)).buffer);return p===h&&l&&await this.j(g,D,l,$,w),D.onDrop(g,c,$)}async j(h,t,v,c,$){const w=this.b.removeDragOperationTransfer($);if(w)(await w)?.forEach((p,l)=>{p&&h.set(l,p)});else if($&&t.handleDrag){const p=t.handleDrag(v,h,c);this.b.addDragOperationTransfer($,p),await p}return h}async $handleDrag(h,t,v,c){const $=this.a.get(h);if(!$)return Promise.reject(new m.$AF(h));const w=await this.j(new k.$eN,$,t,c,v);if(!(!w||c.isCancellationRequested))return u.DataTransfer.from(w)}async $hasResolve(h){const t=this.a.get(h);if(!t)throw new m.$AF(h);return t.hasResolve}$resolve(h,t,v){const c=this.a.get(h);if(!c)throw new m.$AF(h);return c.resolveTreeItem(t,v)}$setExpanded(h,t,v){const c=this.a.get(h);if(!c)throw new m.$AF(h);c.setExpanded(t,v)}$setSelectionAndFocus(h,t,v){const c=this.a.get(h);if(!c)throw new m.$AF(h);c.setSelectionAndFocus(t,v)}$setVisible(h,t){const v=this.a.get(h);if(!v){if(!t)return;throw new m.$AF(h)}v.setVisible(t)}$changeCheckboxState(h,t){const v=this.a.get(h);if(!v)throw new m.$AF(h);v.setCheckboxState(t)}m(h,t,v){const c=this.B(new i(h,t,this.f,this.g.converter,this.h,v));return this.a.set(h,c),c}r(h){const t=this.a.get(h.$treeViewId);return t&&"$treeItemHandle"in h?t.getExtensionElement(h.$treeItemHandle):t&&"$focusedTreeItem"in h&&h.$focusedTreeItem?t.focusedElement:null}}e.$1kc=n;class i extends A.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,F.$5f)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,t,v,c,$,w){if(super(),this.I=h,this.J=v,this.L=c,this.M=$,this.N=w,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new N.$7d),this.onDidExpandElement=this.u.event,this.w=this.B(new N.$7d),this.onDidCollapseElement=this.w.event,this.y=this.B(new N.$7d),this.onDidChangeSelection=this.y.event,this.z=this.B(new N.$7d),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new N.$7d),this.onDidChangeVisibility=this.C.event,this.D=this.B(new N.$7d),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new N.$7d),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new f.$ee,w.contributes&&w.contributes.views)for(const g in w.contributes.views)for(const S of w.contributes.views[g])S.id===h&&(this.P=S.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(g=>this.F.fire({message:!1,element:g})));let p,l;const D=N.Event.debounce(this.F.event,(g,S)=>(g||(g={message:!1,elements:[]}),S.element!==!1&&(p||(p=new Promise(y=>l=y),this.G=this.G.then(()=>p)),Array.isArray(S.element)?g.elements.push(...S.element):g.elements.push(S.element)),S.message&&(g.message=!0),g),200,!0);this.B(D(({message:g,elements:S})=>{S.length&&(this.H=this.H.then(()=>{const y=l;return p=null,this.$(S).then(()=>y())})),g&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const t=h?this.getExtensionElement(h):void 0;if(h&&!t)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let v=this.X(h);return v||(v=await this.Y(t)),v?v.map(c=>c.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,t){t=t||{select:!0,focus:!1};const v=(0,F.$5f)(t.select)?!0:t.select,c=(0,F.$5f)(t.focus)?!1:t.focus,$=(0,F.$5f)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(w=>this.W(h,w[w.length-1]).then(p=>this.J.$reveal(this.I,{item:p.item,parentChain:w.map(l=>l.item)},{select:v,focus:c,expand:$})),w=>this.M.error(w)):this.J.$reveal(this.I,void 0,{select:v,focus:c,expand:$})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=u.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,t){const v=this.getExtensionElement(h);v&&(t?this.u.fire(Object.freeze({element:v})):this.w.fire(Object.freeze({element:v})))}setSelectionAndFocus(h,t){const v=!(0,E.$ub)(this.s,h);this.s=h;const c=this.t!==t;this.t=t,v&&this.y.fire(Object.freeze({selection:this.selectedElements})),c&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const t=(await Promise.all(h.map(async v=>{const c=this.getExtensionElement(v.treeItemHandle);return c?{extensionItem:c,treeItem:await this.f.getTreeItem(c),newState:v.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(v=>v!==void 0);t.forEach(v=>{v.treeItem.checkboxState=v.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(v=>[v.extensionItem,v.newState])})}async handleDrag(h,t,v){const c=[];for(const $ of h){const w=this.getExtensionElement($);w&&c.push(w)}if(!(!this.g?.handleDrag||c.length===0))return await this.g.handleDrag(c,t,v),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,t,v){const c=t?this.getExtensionElement(t):void 0;if(!(!c&&t||!this.g?.handleDrop))return(0,d.$ah)(()=>this.g?.handleDrop?this.g.handleDrop(c,h,v):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,t){if(!this.f.resolveTreeItem)return;const v=this.j.get(h);if(v){const c=this.m.get(v);if(c){const $=await this.f.resolveTreeItem(c.extensionItem,v,t)??c.extensionItem;return this.hb($),c.item.tooltip=this.eb($.tooltip),c.item.command=this.fb(c.disposableStore,$.command),c.item}}}S(h){return this.U(h).then(t=>t?this.S(t).then(v=>this.W(t,v[v.length-1]).then(c=>(v.push(c),v))):Promise.resolve([]))}U(h){const t=this.m.get(h);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,d.$ah)(()=>this.f.getParent(h))}W(h,t){const v=this.m.get(h);return v?Promise.resolve(v):(0,d.$ah)(()=>this.f.getTreeItem(h)).then(c=>this.kb(h,c,t,!0)).then(c=>this.getChildren(t?t.item.handle:void 0).then(()=>{const $=this.getExtensionElement(c);if($){const w=this.m.get($);if(w)return Promise.resolve(w)}throw new Error(`Cannot resolve tree item for element ${c} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let t;if(typeof h=="string"){const v=this.getExtensionElement(h);t=v?this.m.get(v):void 0}else t=h;return t&&t.children||void 0}return this.h}async Y(h){this.rb(h);const t=new f.$ee(this.Z.token);try{const v=h?this.m.get(h):void 0,c=await this.f.getChildren(h);if(t.token.isCancellationRequested)return;const $=(0,E.$Hb)(c||[]),w=await Promise.all((0,E.$Hb)($).map(l=>this.f.getTreeItem(l)));if(t.token.isCancellationRequested)return;const p=w.map((l,D)=>l?this.db($[D],l,v):null);return(0,E.$Hb)(p)}finally{t.dispose()}}$(h){if(h.some(v=>!v))return this.Z.dispose(!0),this.Z=new f.$ee,this.tb(),this.J.$refresh(this.I);{const v=this.ab(h);if(v.length)return this.bb(v)}return Promise.resolve(void 0)}ab(h){const t=new Set,v=h.map($=>this.m.get($));for(const $ of v)if($&&!t.has($.item.handle)){let w=$;for(;w&&w.parent&&v.findIndex(p=>w&&w.parent&&p&&p.item.handle===w.parent.item.handle)===-1;){const p=this.j.get(w.parent.item.handle);w=p?this.m.get(p):void 0}w&&!w.parent&&t.add($.item.handle)}const c=[];return t.forEach($=>{const w=this.j.get($);if(w){const p=this.m.get(w);p&&(!p.parent||!t.has(p.parent.item.handle))&&c.push($)}}),c}bb(h){const t={};return Promise.all(h.map(v=>this.cb(v).then(c=>{c&&(t[v]=c.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(h){const t=this.getExtensionElement(h);if(t){const v=this.m.get(t);if(v)return this.rb(t),(0,d.$ah)(()=>this.f.getTreeItem(t)).then(c=>{if(c){const $=this.ib(t,c,v.parent);return this.pb(t,$,v,v.parent),v.dispose(),$}return null})}return Promise.resolve(null)}db(h,t,v){const c=this.ib(h,t,v);if(t.id&&this.j.has(c.item.handle))throw new Error((0,I.localize)(0,null,t.id));return this.ob(h,c),this.qb(c,v),c}eb(h){return k.$NM.isMarkdownString(h)?u.MarkdownString.from(h):h}fb(h,t){return t?{...this.L.toInternal(t,h),originalId:t.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let t,v,c;return typeof h.checkboxState=="number"?t=h.checkboxState:(t=h.checkboxState.state,v=h.checkboxState.tooltip,c=h.checkboxState.accessibilityInformation),{isChecked:t===k.TreeItemCheckboxState.Checked,tooltip:v,accessibilityInformation:c}}hb(h){if(!k.$_M.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,t,v){this.hb(t);const c=this.B(new A.$Tc),$=this.kb(h,t,v),w=this.lb(t);return{item:{handle:$,parentHandle:v?v.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(c,t.command),contextValue:t.contextValue,icon:w,iconDark:this.mb(t)||w,themeIcon:this.jb(t),collapsibleState:(0,F.$5f)(t.collapsibleState)?k.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:v,children:void 0,disposableStore:c,dispose(){c.dispose()}}}jb(h){return h.iconPath instanceof k.$iN?h.iconPath:void 0}kb(h,{id:t,label:v,resourceUri:c},$,w){if(t)return`${i.b}/${t}`;const p=s(v,this.N),l=$?$.item.handle:i.a;let D=p?p.label:c?(0,O.$Sg)(c):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const g=this.m.has(h)?this.m.get(h).item.handle:void 0,S=this.X($)||[];let y,C=0;do{if(y=`${l}/${C}:${D}`,w||!this.j.has(y)||g===y)break;C++}while(C<=S.length);return y}lb(h){if(h.iconPath&&!(h.iconPath instanceof k.$iN))return typeof h.iconPath=="string"||P.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof k.$iN)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return P.URI.isUri(h)?h:P.URI.file(h)}ob(h,t){this.j.set(t.item.handle,h),this.m.set(h,t)}pb(h,t,v,c){this.j.delete(t.item.handle),this.m.delete(h),t.item.handle!==v.item.handle&&this.j.delete(v.item.handle),this.ob(h,t);const $=this.X(c)||[],w=$.filter(p=>p.item.handle===v.item.handle)[0];w&&$.splice($.indexOf(w),1,t)}qb(h,t){t?(t.children||(t.children=[]),t.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const t=this.m.get(h);if(t){if(t.children)for(const v of t.children){const c=this.j.get(v.item.handle);c&&this.sb(c)}t.children=void 0}}else this.tb()}sb(h){const t=this.m.get(h);if(t){if(t.children)for(const v of t.children){const c=this.j.get(v.item.handle);c&&this.sb(c)}this.m.delete(h),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ce[283],Pe([1,0,5,6,2,34,8,62,4,7]),function($e,e,I,O,P,N,A,m,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zjc=void 0;class F extends O.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(f,r,o,s){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new I.$7d),this.onDidDispose=this.#d.event,this.#h=this.B(new I.$7d),this.onDidChangeViewState=this.#h.event,this.#e=f,this.#t=r,this.#n=o,this.#i=s.viewType,this.#s=s.panelOptions,this.#o=s.viewColumn,this.#r=s.title,this.#u=s.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(f){this.c(),this.#r!==f&&(this.#r=f,this.#t.$setTitle(this.#e,f))}get iconPath(){return this.c(),this.#a}set iconPath(f){this.c(),this.#a!==f&&(this.#a=f,this.#t.$setIconPath(this.#e,P.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(f){this.#l||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(this.#u=f.active,this.#c=f.visible,this.#o=f.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(f,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof f>"u"?void 0:A.ViewColumn.from(f),preserveFocus:!!r})}c(){if(this.#l)throw new Error("Webview is disposed")}}class E extends O.$Uc{static c(){return(0,N.$Eg)()}constructor(f,r,o){super(),this.j=r,this.m=o,this.g=new Map,this.h=new Map,this.f=f.getProxy(d.$kM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(f=>f.dispose()),this.g.clear()}createWebviewPanel(f,r,o,s,n={}){const i=typeof s=="object"?s.viewColumn:s,a={viewColumn:A.ViewColumn.from(i),preserveFocus:typeof s=="object"&&!!s.preserveFocus},h=(0,m.$vjc)(f),t=E.c();this.f.$createWebviewPanel((0,m.$xjc)(f),t,r,{title:o,panelOptions:u(n),webviewOptions:(0,m.$yjc)(f,this.m,n),serializeBuffersForPostMessage:h},a);const v=this.j.createNewWebview(t,n,f);return this.createNewWebviewPanel(t,r,o,i,n,v,!0)}$onDidChangeWebviewPanelViewStates(f){const r=Object.keys(f);r.sort((o,s)=>{const n=f[o],i=f[s];return n.active?1:i.active?-1:+n.visible-+i.visible});for(const o of r){const s=this.getWebviewPanel(o);if(!s)continue;const n=f[o];s._updateViewState({active:n.active,visible:n.visible,viewColumn:A.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this.g.delete(f),this.j.deleteWebview(f)}registerWebviewPanelSerializer(f,r,o){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:o,extension:f}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,m.$vjc)(f)}),new k.$mM(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(f,r,o,s){const n=this.h.get(r);if(!n)throw new Error(`No serializer found for '${r}'`);const{serializer:i,extension:a}=n,h=this.j.createNewWebview(f,o.webviewOptions,a),t=this.createNewWebviewPanel(f,r,o.title,s,o.panelOptions,h,o.active);await i.deserializeWebviewPanel(t,o.state)}createNewWebviewPanel(f,r,o,s,n,i,a){const h=new F(f,this.f,i,{viewType:r,title:o,viewColumn:s,panelOptions:n,active:a});return this.g.set(f,h),h}getWebviewPanel(f){return this.g.get(f)}}e.$zjc=E;function u(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}}),define(Ce[284],Pe([1,0,5,6,62,8,4,7]),function($e,e,I,O,P,N,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4kc=void 0;class d extends O.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(E,u,b,f,r,o){super(),this.#s=!1,this.#u=this.B(new I.$7d),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new I.$7d),this.onDidDispose=this.#l.event,this.#i=b,this.#a=f,this.#e=E,this.#t=u,this.#n=r,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(E){this.a(),this.#a!==E&&(this.#a=E,this.#t.$setWebviewViewTitle(this.#e,E))}get description(){return this.a(),this.#o}set description(E){this.a(),this.#o!==E&&(this.#o=E,this.#t.$setWebviewViewDescription(this.#e,E))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(E){E===this.#r||this.#s||(this.#r=E,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(E){this.a(),!(E?.value===this.#c?.value&&E?.tooltip===this.#c?.tooltip)&&(this.#c=N.ViewBadge.from(E),this.#t.$setWebviewViewBadge(this.#e,E))}show(E){this.a(),this.#t.$show(this.#e,!!E)}a(){if(this.#s)throw new Error("Webview is disposed")}}class k{constructor(E,u){this.d=u,this.b=new Map,this.c=new Map,this.a=E.getProxy(A.$kM.MainThreadWebviewViews)}registerWebviewViewProvider(E,u,b,f){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:b,extension:E}),this.a.$registerWebviewViewProvider((0,P.$xjc)(E),u,{retainContextWhenHidden:f?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$vjc)(E)}),new m.$mM(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(E,u,b,f,r){const o=this.b.get(u);if(!o)throw new Error(`No view provider found for '${u}'`);const{provider:s,extension:n}=o,i=this.d.createNewWebview(E,{},n),a=new d(E,this.a,u,b,i,!0);this.c.set(E,a),await s.resolveWebviewView(a,{state:f},r)}async $onDidChangeWebviewViewVisibility(E,u){this.e(E)._setVisible(u)}async $disposeWebviewView(E){const u=this.e(E);this.c.delete(E),u.dispose(),this.d.deleteWebview(E)}e(E){const u=this.c.get(E);if(!u)throw new Error("No webview found");return u}}e.$4kc=k}),define(Ce[285],Pe([1,0,5,30,33,3]),function($e,e,I,O,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GL=e.$FL=e.OutputChannelUpdateMode=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=void 0,e.$sL="text/x-code-output",e.$tL="output",e.$uL="Log",e.$vL="text/x-code-log-output",e.$wL="log",e.$xL="workbench.panel.output",e.$yL=new P.$zj("inOutput",!1),e.$zL=new P.$zj("activeLogOutput",!1),e.$AL=new P.$zj("activeLogOutput.levelSettable",!1),e.$BL=new P.$zj("activeLogOutput.level",""),e.$CL=new P.$zj("activeLogOutput.levelIsDefault",!1),e.$DL=new P.$zj("outputView.scrollLock",!1),e.$EL=(0,N.$ii)("outputService");var A;(function(d){d[d.Append=1]="Append",d[d.Replace=2]="Replace",d[d.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$FL={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new I.$7d,this.onDidRegisterChannel=this.b.event,this.c=new I.$7d,this.onDidRemoveChannel=this.c.event}registerChannel(k){this.a.has(k.id)||(this.a.set(k.id,k),this.b.fire(k.id))}getChannels(){const k=[];return this.a.forEach(F=>k.push(F)),k}getChannel(k){return this.a.get(k)}removeChannel(k){this.a.delete(k),this.c.fire(k)}}O.$1n.add(e.$FL.OutputChannels,new m),e.$GL=new P.$zj("activeOutputChannel","")}),define(Ce[115],Pe([1,0,4,3,17,20,13,285,63,27,44,140,23,16,43,5,6]),function($e,e,I,O,P,N,A,m,d,k,F,E,u,b,f,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fkc=e.$Ekc=void 0;class s extends A.$Uj{get disposed(){return this.n}constructor(h,t,v,c,$){super(),this.id=h,this.name=t,this.r=v,this.s=c,this.extension=$,this.m=0,this.n=!1,this.visible=!1,this.setLevel(v.getLevel()),this.B(v.onDidChangeLogLevel(w=>this.setLevel(w)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Clear,h)}replace(h){const t=this.m;this.info(h),this.s.$update(this.id,m.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(h,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:t))}hide(){this.s.$close(this.id)}g(h,t){this.m+=u.$ue.fromString(t).byteLength,(0,A.log)(this.r,h,t),this.visible&&(this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends s{appendLine(h){this.append(h)}}let i=class{constructor(h,t,v,c,$,w){this.i=t,this.j=v,this.k=c,this.l=$,this.m=w,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(I.$kM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,E.$Pm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[t,v]of this.g)v.visible=t===this.h}createOutputChannel(h,t,v){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const c=typeof t=="object"&&t.log,$=(0,b.$Vf)(t)?t:void 0;if((0,b.$Vf)($)&&!$.trim())throw new Error("illegal argument `languageId`. must not be empty");let w;const p=this.i.environment.extensionLogLevel?.find(([D])=>N.$Dm.equals(v.identifier,D))?.[1];p&&(w=(0,A.$6j)(p));const l=c?this.o(h,w,v):this.n(h,$,v);return l.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),c?this.r(h,w??this.m.getLevel(),l):this.q(h,l)}async n(h,t,v){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const c=await this.c,$=this.k.extUri.joinPath(c,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),w=this.l.createLogger($,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),p=await this.a.$register(h,$,t,v.identifier.value);return new s(p,h,w,this.a,v)}async o(h,t,v){const c=await this.p(v),$=h.replace(/[\\/:\*\?"<>\|]/g,""),w=this.k.extUri.joinPath(c,`${$}.log`),p=`${v.identifier.value}.${$}`,l=this.l.createLogger(w,{id:p,name:h,logLevel:t,extensionId:v.identifier.value});return new n(p,h,l,this.a,v)}p(h){let t=this.d.get(h.identifier.value);if(!t){const v=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(v)}catch(c){if((0,f.$5k)(c)!==f.FileSystemProviderErrorCode.FileExists)throw c}return v})())}return t}q(h,t){let v=!1;const c=()=>{if(v)throw new Error("Channel has been closed")};return{get name(){return h},append($){c(),t.then(w=>w.append($))},appendLine($){c(),t.then(w=>w.appendLine($))},clear(){c(),t.then($=>$.clear())},replace($){c(),t.then(w=>w.replace($))},show($,w){c(),t.then(p=>p.show($,w))},hide(){c(),t.then($=>$.hide())},dispose(){v=!0,t.then($=>$.dispose())}}}r(h,t,v){const c=new o.$Tc,$=()=>{if(c.isDisposed)throw new Error("Channel has been closed")},w=c.add(new r.$7d);function p(l){t=l,w.fire(l)}return v.then(l=>{c.add(l),l.logLevel!==t&&p(l.logLevel),c.add(l.onDidChangeLogLevel(D=>p(D)))}),{...this.q(h,v),get logLevel(){return t},onDidChangeLogLevel:w.event,trace(l,...D){$(),v.then(g=>g.trace(l,...D))},debug(l,...D){$(),v.then(g=>g.debug(l,...D))},info(l,...D){$(),v.then(g=>g.info(l,...D))},warn(l,...D){$(),v.then(g=>g.warn(l,...D))},error(l,...D){$(),v.then(g=>g.error(l,...D))},dispose(){c.dispose()}}}};e.$Ekc=i,e.$Ekc=i=Je([We(0,P.$FO),We(1,k.$VO),We(2,d.$rjc),We(3,F.$4ic),We(4,A.$Pj),We(5,A.$Oj)],i),e.$Fkc=(0,O.$ii)("IExtHostOutputService")}),define(Ce[116],Pe([1,0,3,11]),function($e,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=void 0,e.$5m=(0,I.$ii)("remoteAgentService"),e.$6m=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let N=1/0;for(let m=0;m<this.maxSampleCount;m++){const d=await P.getRoundTripTime();if(d===void 0)return;N=Math.min(N,d/2),await(0,O.$jh)(this.sampleDelay)}this.average.push(N),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(N):A=this.initial.reduce((m,d)=>m+d,0)/this.initial.length,this.lastMeasurement={initial:A,current:N,average:this.average.reduce((m,d)=>m+d,0)/this.average.length,high:typeof A>"u"?!1:N>this.highLatencyMaxThreshold||N>this.highLatencyMinThreshold&&N>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ce[286],Pe([1,0,175,56,30,48,47,6,5,116,21,26,11]),function($e,e,I,O,P,N,A,m,d,k,F,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=void 0,e.$XI=Object.freeze({id:"application",order:100,title:(0,I.localize)(0,null),type:"object"}),e.$YI=Object.freeze({id:"workbench",order:7,title:(0,I.localize)(1,null),type:"object"}),e.$ZI=Object.freeze({id:"security",scope:1,title:(0,I.localize)(2,null),type:"object",order:7}),e.$1I=Object.freeze({id:"problems",title:(0,I.localize)(3,null),type:"object",order:101}),e.$2I={ConfigurationMigration:"base.contributions.configuration.migration"};class b{constructor(){this.migrations=[],this.a=new d.$7d,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const f=new b;P.$1n.add(e.$2I.ConfigurationMigration,f);let r=class extends m.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async a=>{for(const h of a.added)await this.f(h,f.migrations)})),this.c(f.migrations),this.B(f.onDidRegisterConfigurationMigration(a=>this.c(a)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(a=>this.g(a,n?.uri))])}async g(n,i){const a=this.a.inspect(n.key,{resource:i}),h=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,v]of h){const c=a[t];if(!c)continue;const $=[];if(c.value!==void 0){const w=await this.h(n,t,c.value,i,void 0);for(const p of w??[])$.push([p,[]])}for(const{identifiers:w,value:p}of c.overrides??[])if(p!==void 0){const l=await this.h(n,t,p,i,w);for(const D of l??[])$.push([D,w])}$.length&&await Promise.allSettled($.map(async([[w,p],l])=>this.a.updateValue(w,p.value,{resource:i,overrideIdentifiers:l},v)))}}async h(n,i,a,h,t){const v=$=>{const p=this.a.inspect($,{resource:h})[i];if(p)return t?p.overrides?.find(({identifiers:l})=>(0,E.$Sn)(l,t))?.value:p.value},c=await n.migrateFn(a,v);return Array.isArray(c)?c:[[n.key,c]]}};e.$3I=r,e.$3I=r=Je([We(0,A.$Oi),We(1,N.$ri)],r);let o=class extends m.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new u.$Fh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!F.$i&&(await this.b.getEnvironment())?.os!==1)return;P.$1n.as(O.$6n.Configuration).registerConfiguration({...e.$ZI,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,I.localize)(4,null)},default:[],markdownDescription:(0,I.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,I.localize)(6,null),scope:2}}})}};e.$4I=o,e.$4I=o=Je([We(0,k.$5m)],o)}),define(Ce[287],Pe([1,0,35,12,19,24,183,286,56,3,30]),function($e,e,I,O,P,N,A,m,d,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$yfb=e.$xfb=void 0,e.$zfb=r,e.$Afb=o,e.$xfb=(0,k.$ii)("editorResolverService"),e.$yfb="workbench.editorAssociations";const E=F.$1n.as(d.$6n.Configuration),u={...m.$YI,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};E.registerConfiguration(u);var b;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(b||(e.RegisteredEditorPriority=b={}));var f;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(f||(e.ResolvedStatus=f={}));function r(s){switch(s){case b.exclusive:return 5;case b.default:return 4;case b.builtin:return 3;case b.option:default:return 1}}function o(s,n){if(new Set([O.Schemas.extension,O.Schemas.webviewPanel,O.Schemas.vscodeWorkspaceTrust,O.Schemas.vscodeSettings]).has(n.scheme))return!1;const h=typeof s=="string"&&s.indexOf(P.$hc.sep)>=0?`${n.scheme}:${n.path}`:(0,N.$Sg)(n);return I.$bk(typeof s=="string"?s.toLowerCase():s,h.toLowerCase())}}),define(Ce[288],Pe([1,0,46,12,19,21,24,2,3,204,48,224,116]),function($e,e,I,O,P,N,A,m,d,k,F,E,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$ZL=e.$YL=void 0,e.$YL=(0,d.$ii)("pathService");let f=b=class{constructor(o,s,n,i){this.d=o,this.e=s,this.f=n,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||N.OS)(),this.b=(async()=>{const a=await this.e.getEnvironment();return this.c=a?.userHome??o})()}hasValidBasename(o,s,n){return typeof s=="string"||typeof s>"u"?this.a.then(i=>this.h(o,i,s)):this.h(o,s,n)}h(o,s,n){return o.scheme===O.Schemas.file||o.scheme===O.Schemas.vscodeRemote?(0,I.$gg)(n??(0,A.$Sg)(o),s===1):!0}get defaultUriScheme(){return b.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,s){if(o.remoteAuthority)return O.Schemas.vscodeRemote;const n=(0,k.$VL)(s.getWorkspace());if(n)return n;const i=s.getWorkspace().folders[0];if(i)return i.uri.scheme;const a=s.getWorkspace().configuration;return a?a.scheme:O.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?P.$gc:P.$hc)}async fileURI(o){let s="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const i=o.indexOf("/",2);i===-1?(s=o.substring(2),o="/"):(s=o.substring(2,i),o=o.substring(i)||"/")}return m.URI.from({scheme:O.Schemas.file,authority:s,path:o,query:"",fragment:""})}};e.$ZL=f,e.$ZL=f=b=Je([We(1,u.$5m),We(2,E.$HL),We(3,F.$ri)],f)}),define(Ce[117],Pe([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$sK=e.$rK=void 0;class I{constructor(A,m){this.line=A,this.character=m}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,m){return new I(0,0)}with(A){return new I(0,0)}}e.$rK=I;class O{constructor(A,m,d,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new I(A,m),this.end=new I(d,k)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new O(0,0,0,0)}with(A){return new O(0,0,0,0)}}e.$sK=O;var P;(function(N){N[N.Information=1]="Information",N[N.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}))}),define(Ce[45],Pe([1,0,18,35,26,46,15,3,19,14,117,11]),function($e,e,I,O,P,N,A,m,d,k,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RK=e.$PK=e.$IK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$FK=e.$EK=e.$DK=e.$CK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.TextSearchCompleteMessageType=void 0,e.$zK=s,e.$AK=n,e.$BK=i,e.$GK=l,e.$HK=D,e.$JK=y,e.$KK=C,e.$LK=R,e.$MK=V,e.$NK=U,e.$OK=q,e.$QK=L,e.$SK=he,e.$TK=ye,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return F.TextSearchCompleteMessageType}}),e.$tK="workbench.view.search",e.$uK="workbench.panel.search",e.$vK="workbench.view.search",e.$wK="search-result",e.$xK="search.exclude";const u="\u27EA ",b=" characters skipped \u27EB",f=(u.length+b.length+5)*2;e.$yK=(0,m.$ii)("searchService");var r;(function(ge){ge[ge.file=0]="file",ge[ge.text=1]="text",ge[ge.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var o;(function(ge){ge[ge.File=1]="File",ge[ge.Text=2]="Text",ge[ge.aiText=3]="aiText"})(o||(e.QueryType=o={}));function s(ge){return!!ge.preview}function n(ge){return!!ge.resource}function i(ge){return!!ge.message}var a;(function(ge){ge[ge.Normal=0]="Normal",ge[ge.NewSearchStarted=1]="NewSearchStarted"})(a||(e.SearchCompletionExitCode=a={}));class h{constructor(ue){this.resource=ue,this.results=[]}}e.$CK=h;class t{constructor(ue,te,be,oe){this.ranges=te,this.webviewIndex=oe;const de=Array.isArray(te)?te:[te];if(be&&be.matchLines===1&&v(de)){ue=(0,A.$Of)(ue,be.matchLines);let W="",ee=0,ke=0;const Te=Math.floor(be.charsPerLine/5),Se=[];for(const ve of de){const me=Math.max(ve.startColumn-Te,0),J=ve.startColumn+be.charsPerLine;if(me>ke+Te+f){const Y=u+(me-ke)+b;W+=Y+ue.slice(me,J),ee+=me-(ke+Y.length)}else W+=ue.slice(ke,J);Se.push(new $(0,ve.startColumn-ee,ve.endColumn-ee)),ke=J}this.preview={text:W,matches:Array.isArray(this.ranges)?Se:Se[0]}}else{const W=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber;this.preview={text:ue,matches:(0,I.$2b)(te,ee=>new c(ee.startLineNumber-W,ee.startColumn,ee.endLineNumber-W,ee.endColumn))}}}}e.$DK=t;function v(ge){const ue=ge[0].startLineNumber;for(const te of ge)if(te.startLineNumber!==ue||te.endLineNumber!==ue)return!1;return!0}class c{constructor(ue,te,be,oe){this.startLineNumber=ue,this.startColumn=te,this.endLineNumber=be,this.endColumn=oe}}e.$EK=c;class $ extends c{constructor(ue,te,be){super(ue,te,ue,be)}}e.$FK=$;var w;(function(ge){ge.List="list",ge.Tree="tree"})(w||(e.ViewMode=w={}));var p;(function(ge){ge.Default="default",ge.FileNames="fileNames",ge.Type="type",ge.Modified="modified",ge.CountDescending="countDescending",ge.CountAscending="countAscending"})(p||(e.SearchSortOrder=p={}));function l(ge,ue=!0){const te=ge&&ge.files&&ge.files.exclude,be=ue&&ge&&ge.search&&ge.search.exclude;if(!te&&!be)return;if(!te||!be)return te||be;let oe=Object.create(null);return oe=P.$Rn(oe,P.$On(te)),oe=P.$Rn(oe,P.$On(be),!0),oe}function D(ge,ue){return ge.excludePattern&&O.$bk(ge.excludePattern,ue)?!1:ge.includePattern||ge.usingSearchPaths?ge.includePattern&&O.$bk(ge.includePattern,ue)?!0:ge.usingSearchPaths?!!ge.folderQueries&&ge.folderQueries.some(te=>{const be=te.folder.fsPath;if(N.$ig(ue,be)){const oe=d.$mc(be,ue);return!te.includePattern||!!O.$bk(te.includePattern,oe)}else return!1}):!1:!0}var g;(function(ge){ge[ge.unknownEncoding=1]="unknownEncoding",ge[ge.regexParseError=2]="regexParseError",ge[ge.globParseError=3]="globParseError",ge[ge.invalidLiteral=4]="invalidLiteral",ge[ge.rgProcessError=5]="rgProcessError",ge[ge.other=6]="other",ge[ge.canceled=7]="canceled"})(g||(e.SearchErrorCode=g={}));class S extends Error{constructor(ue,te){super(ue),this.code=te}}e.$IK=S;function y(ge){const ue=ge.message;if((0,k.$4)(ge))return new S(ue,g.canceled);try{const te=JSON.parse(ue);return new S(te.message,te.code)}catch{return new S(ue,g.other)}}function C(ge){const ue={message:ge.message,code:ge.code};return new Error(JSON.stringify(ue))}function R(ge){return ge.type==="error"?!0:ge.type==="success"}function V(ge){return ge.type==="success"}function U(ge){return!!ge.path}function q(ge,ue,te=!0){const be=ge.searchPath?ge.searchPath:ge.relativePath;return te?(0,A.$Lf)(be,ue):O.$bk(ue,be)}class M{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$PK=M;function L(ge,ue){const te={...ge||{},...ue||{}};return Object.keys(te).filter(be=>{const oe=te[be];return typeof oe=="boolean"&&oe})}class G{constructor(ue,te){this.c=null,this.a={...ue.excludePattern||{},...te.excludePattern||{}},this.b=O.$ck(this.a);let be=ue.includePattern;te.includePattern&&(be?be={...be,...te.includePattern}:be=te.includePattern),be&&(this.c=O.$ck(be))}matchesExcludesSync(ue,te,be){return!!(this.b&&this.b(ue,te,be))}includedInQuerySync(ue,te,be){return!(this.b&&this.b(ue,te,be)||this.c&&!this.c(ue,te,be))}includedInQuery(ue,te,be){const oe=this.b(ue,te,be),de=()=>this.c?!!this.c(ue,te,be):!0;return(0,E.$7g)(oe)?oe.then(W=>W?!1:de()):de()}hasSiblingExcludeClauses(){return ne(this.a)}}e.$RK=G;function ne(ge){for(const ue in ge)if(typeof ge[ue]!="boolean")return!0;return!1}function he(ge){if(!ge)return;let ue;return te=>(ue||(ue=(ge()||Promise.resolve([])).then(be=>be?Re(be):{})),ue.then(be=>!!be[te]))}function ye(ge){if(!ge)return;let ue;return te=>{if(!ue){const be=ge();ue=be?Re(be):{}}return!!ue[te]}}function Re(ge){const ue={};for(const te of ge)ue[te]=!0;return ue}}),define(Ce[36],Pe([1,0,18,11,25,5,6,51,12,125,24,15,2,174,3,13,193,48,44,27,17,8,7,59,45,4,52]),function($e,e,I,O,P,N,A,m,d,k,F,E,u,b,f,r,o,s,n,i,a,h,t,v,c,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mjc=e.$ljc=void 0;function p(V,U,q){return new F.$Kg(M=>S(M,q)).isEqual(V,U)}function l(V,U,q){return p(V.uri,U.uri,q)?0:(0,E.$ef)(V.uri.toString(),U.uri.toString())}function D(V,U,q){return V.index!==U.index?V.index<U.index?-1:1:p(V.uri,U.uri,q)?(0,E.$ef)(V.name,U.name):(0,E.$ef)(V.uri.toString(),U.uri.toString())}function g(V,U,q,M){const L=V.slice(0).sort((ne,he)=>q(ne,he,M)),G=U.slice(0).sort((ne,he)=>q(ne,he,M));return(0,I.$Eb)(L,G,(ne,he)=>q(ne,he,M))}function S(V,U){const q=U.getCapabilities(V.scheme);return!(q&&q&1024)}class y extends s.$Bi{static toExtHostWorkspace(U,q,M,L){if(!U)return{workspace:null,added:[],removed:[]};const{id:G,name:ne,folders:he,configuration:ye,transient:Re,isUntitled:ge}=U,ue=[],te=q;q?he.forEach((W,ee)=>{const ke=u.URI.revive(W.uri),Te=y.o(M||q,ke,L);Te?(Te.name=W.name,Te.index=W.index,ue.push(Te)):ue.push({uri:ke,name:W.name,index:ee})}):ue.push(...he.map(({uri:W,name:ee,index:ke})=>({uri:u.URI.revive(W),name:ee,index:ke}))),ue.sort((W,ee)=>W.index<ee.index?-1:1);const be=new y(G,ne,ue,!!Re,ye?u.URI.revive(ye):null,!!ge,W=>S(W,L)),{added:oe,removed:de}=g(te?te.workspaceFolders:[],be.workspaceFolders,l,L);return{workspace:be,added:oe,removed:de}}static o(U,q,M){for(let L=0;L<U.folders.length;L++){const G=U.workspaceFolders[L];if(p(G.uri,q,M))return G}}constructor(U,q,M,L,G,ne,he){super(U,M.map(ye=>new s.$Ci(ye)),L,G,he),this.t=q,this.u=ne,this.q=[],this.s=m.$oi.forUris(he),M.forEach(ye=>{this.q.push(ye),this.s.set(ye.uri,ye)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(U,q){return q&&this.s.get(U)&&(U=(0,F.$Ug)(U)),this.s.findSubstr(U)}resolveWorkspaceFolder(U){return this.s.get(U)}}let C=class{constructor(U,q,M,L,G){this.c=new N.$7d,this.onDidChangeWorkspace=this.c.event,this.g=new N.$7d,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new N.$9d,this.C=new Map,this.h=L,this.s=M,this.t=G,this.j=new k.$pm,this.k=new O.$hh,this.o=U.getProxy($.$kM.MainThreadWorkspace),this.q=U.getProxy($.$kM.MainThreadMessageService);const ne=q.workspace;this.l=ne?new y(ne.id,ne.name,[],!!ne.transient,ne.configuration?u.URI.revive(ne.configuration):null,!!ne.isUntitled,he=>S(he,M)):void 0}$initializeWorkspace(U,q){this.v=q,this.$acceptWorkspaceData(U),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:d.Schemas.untitled,path:(0,F.$Sg)((0,F.$Ug)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(U,q,M,...L){const G=[];if(Array.isArray(L)&&L.forEach(ge=>{u.URI.isUri(ge.uri)&&!G.some(ue=>p(ue.uri,ge.uri,this.s))&&G.push({uri:ge.uri,name:ge.name||(0,F.$Rg)(ge.uri)})}),this.n||[q,M].some(ge=>typeof ge!="number"||ge<0)||M===0&&G.length===0)return!1;const ne=this.x?this.x.workspaceFolders:[];if(q+M>ne.length)return!1;const he=ne.slice(0);he.splice(q,M,...G.map(ge=>({uri:ge.uri,name:ge.name||(0,F.$Rg)(ge.uri),index:void 0})));for(let ge=0;ge<he.length;ge++){const ue=he[ge];if(he.some((te,be)=>be!==ge&&p(ue.uri,te.uri,this.s)))return!1}he.forEach((ge,ue)=>ge.index=ue);const{added:ye,removed:Re}=g(ne,he,D,this.s);if(ye.length===0&&Re.length===0)return!1;if(this.o){const ge=U.displayName||U.name;this.o.$updateWorkspaceFolders(ge,q,M,G).then(void 0,ue=>{this.n=void 0;const te={source:{identifier:U.identifier,label:U.displayName||U.name}};this.q.$showMessage(o.Severity.Error,(0,b.localize)(0,null,ge,ue.toString()),te,[])})}return this.y(he),!0}getWorkspaceFolder(U,q){if(this.x)return this.x.getWorkspaceFolder(U,q)}async getWorkspaceFolder2(U,q){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(U,q)}async resolveWorkspaceFolder(U){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(U)}getPath(){if(!this.x)return;const{folders:U}=this.x;if(U.length!==0)return U[0].uri.fsPath}getRelativePath(U,q){let M,L="";if(typeof U=="string"?(M=u.URI.file(U),L=U):typeof U<"u"&&(M=U,L=U.fsPath),!M)return L;const G=this.getWorkspaceFolder(M,!0);if(!G)return L;typeof q>"u"&&this.x&&(q=this.x.folders.length>1);let ne=(0,F.$Xg)(G.uri,M);return q&&G.name&&(ne=`${G.name}/${ne}`),ne}y(U){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:U,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(U){const{workspace:q,added:M,removed:L}=y.toExtHostWorkspace(U,this.l,this.n,this.s);this.l=q||void 0,this.n=void 0,this.c.fire(Object.freeze({added:M,removed:L}))}findFiles(U,q,M,L,G=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${L.value}, entryPoint: findFiles`);let ne="",he=!0;return q===null?he=!1:q!==void 0&&(typeof q=="string"?ne=q:ne=q.pattern),this.z(U,void 0,{exclude:ne,maxResults:M,useDefaultExcludes:he,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},G)}findFiles2(U,q={},M,L=P.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${M.value}, entryPoint: findFiles2`),this.z(void 0,U,q,L)}async z(U,q,M,L=P.CancellationToken.None){if(L&&L.isCancellationRequested)return Promise.resolve([]);const G=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,ne={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof M.useDefaultSearchExcludes=="boolean"?!M.useDefaultSearchExcludes:!1,maxResults:M.maxResults,excludePattern:G,shouldGlobSearch:typeof M.fuzzy=="boolean"?!M.fuzzy:!0,_reason:"startFileSearch"};let he;if(U){const{includePattern:ye,folder:Re}=R(h.GlobPattern.from(U));he=Re,ne.includePattern=ye}else{const{includePattern:ye,folder:Re}=R(h.GlobPattern.from(q));he=Re,ne.filePattern=ye}return this.o.$startFileSearch(he??null,ne,L).then(ye=>Array.isArray(ye)?ye.map(Re=>u.URI.revive(Re)):[])}async findTextInFiles(U,q,M,L,G=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${L.value}, entryPoint: findTextInFiles`);const ne=this.j.getNext(),he=typeof q.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:q.previewOptions,{includePattern:ye,folder:Re}=R(h.GlobPattern.from(q.include)),ge=typeof q.exclude=="string"?q.exclude:q.exclude?q.exclude.pattern:void 0,ue={ignoreSymlinks:typeof q.followSymlinks=="boolean"?!q.followSymlinks:void 0,disregardIgnoreFiles:typeof q.useIgnoreFiles=="boolean"?!q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof q.useGlobalIgnoreFiles=="boolean"?!q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof q.useParentIgnoreFiles=="boolean"?!q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof q.useDefaultExcludes=="boolean"?!q.useDefaultExcludes:!0,fileEncoding:q.encoding,maxResults:q.maxResults,previewOptions:he,afterContext:q.afterContext,beforeContext:q.beforeContext,includePattern:ye,excludePattern:ge},te=!1;if(this.u[ne]=be=>{if(te)return;const oe=u.URI.revive(be.resource);be.results.forEach(de=>{const W=(0,w.$Rh)(de);(0,c.$zK)(W)?M({uri:oe,preview:{text:W.preview.text,matches:(0,I.$2b)(W.preview.matches,ee=>new t.$oM(ee.startLineNumber,ee.startColumn,ee.endLineNumber,ee.endColumn))},ranges:(0,I.$2b)(W.ranges,ee=>new t.$oM(ee.startLineNumber,ee.startColumn,ee.endLineNumber,ee.endColumn))}):M({uri:oe,text:W.text,lineNumber:W.lineNumber})})},G.isCancellationRequested)return{};try{const be=await this.o.$startTextSearch(U,Re??null,ue,ne,G);return delete this.u[ne],be||{}}catch(be){throw delete this.u[ne],be}}$handleTextSearchResult(U,q){this.u[q]?.(U)}async save(U){const q=await this.o.$save(U,{saveAs:!1});return u.URI.revive(q)}async saveAs(U){const q=await this.o.$save(U,{saveAs:!0});return u.URI.revive(q)}saveAll(U){return this.o.$saveAll(U)}resolveProxy(U){return this.o.$resolveProxy(U)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(U){return this.o.$requestWorkspaceTrust(U)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(U,q){if(this.w.has(U))throw new Error(`A provider has already been registered for scheme ${U}`);this.w.set(U,q);const M=this.t.transformOutgoingScheme(U),L=this.A++;return this.o.$registerEditSessionIdentityProvider(L,M),(0,A.$Sc)(()=>{this.w.delete(U),this.o.$unregisterEditSessionIdentityProvider(L)})}async $getEditSessionIdentifier(U,q){this.h.info("Getting edit session identifier for workspaceFolder",U);const M=await this.resolveWorkspaceFolder(u.URI.revive(U));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const L=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!L),!L)return;const G=await L.provideEditSessionIdentity(M,q);if(this.h.info("Provider returned edit session identifier: ",G),!!G)return G}async $provideEditSessionIdentityMatch(U,q,M,L){this.h.info("Getting edit session identifier for workspaceFolder",U);const G=await this.resolveWorkspaceFolder(u.URI.revive(U));if(!G){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",G);const ne=this.w.get(G.uri.scheme);if(this.h.info(`Provider for scheme ${G.uri.scheme} is defined: `,!!ne),!ne)return;const he=await ne.provideEditSessionIdentityMatch?.(q,M,L);if(this.h.info("Provider returned edit session identifier match result: ",he),!!he)return he}getOnWillCreateEditSessionIdentityEvent(U){return(q,M,L)=>{const G=function(he){q.call(M,he)};return G.extension=U,this.B.event(G,void 0,L)}}async $onWillCreateEditSessionIdentity(U,q,M){const L=await this.resolveWorkspaceFolder(u.URI.revive(U));if(L===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:L},q,async(G,ne)=>{const he=Date.now();await Promise.resolve(G),Date.now()-he>M&&this.h.warn("SLOW edit session create-participant",ne.extension.identifier)}),q.isCancellationRequested}registerCanonicalUriProvider(U,q){if(this.C.has(U))throw new Error(`A provider has already been registered for scheme ${U}`);this.C.set(U,q);const M=this.t.transformOutgoingScheme(U),L=this.A++;return this.o.$registerCanonicalUriProvider(L,M),(0,A.$Sc)(()=>{this.C.delete(U),this.o.$unregisterCanonicalUriProvider(L)})}async provideCanonicalUri(U,q,M){const L=this.C.get(U.scheme);if(!L)return;const G=await L.provideCanonicalUri?.(u.URI.revive(U),q,M);if(G)return G}async $provideCanonicalUri(U,q,M){return this.provideCanonicalUri(u.URI.revive(U),{targetScheme:q},M)}};e.$ljc=C,e.$ljc=C=Je([We(0,a.$FO),We(1,i.$VO),We(2,n.$4ic),We(3,r.$Oj),We(4,v.$jjc)],C),e.$mjc=(0,f.$ii)("IExtHostWorkspace");function R(V){let U,q;return V&&(typeof V=="string"?U=V:(U=V.pattern,q=u.URI.revive(V.baseUri))),{includePattern:U,folder:q}}}),define(Ce[37],Pe([1,0,26,5,36,4,7,195,56,16,11,3,17,13,2]),function($e,e,I,O,P,N,A,m,d,k,F,E,u,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pjc=e.$ojc=e.$njc=void 0;function r(v,c){if(c){const $=c.split(".");let w=v;for(let p=0;w&&p<$.length;p++)w=w[$[p]];return w}}function o(v){return v instanceof f.URI}function s(v){return v&&v.uri instanceof f.URI&&v.languageId&&typeof v.languageId=="string"}function n(v){return v&&!v.uri&&v.languageId&&typeof v.languageId=="string"}function i(v){return v&&v.uri instanceof f.URI&&(!v.name||typeof v.name=="string")&&(!v.index||typeof v.index=="number")}function a(v){if(o(v))return{resource:v};if(s(v))return{resource:v.uri,overrideIdentifier:v.languageId};if(n(v))return{overrideIdentifier:v.languageId};if(i(v))return{resource:v.uri};if(v===null)return{resource:null}}let h=class{constructor(c,$,w){this.a=c.getProxy(N.$kM.MainThreadConfiguration),this.c=$,this.b=w,this.d=new F.$hh,this.e=null}getConfigProvider(){return this.d.wait().then(c=>this.e)}$initializeConfiguration(c){this.e=new t(this.a,this.c,c,this.b),this.d.open()}$acceptConfigurationChanged(c,$){this.getConfigProvider().then(w=>w.$acceptConfigurationChanged(c,$))}};e.$njc=h,e.$njc=h=Je([We(0,u.$FO),We(1,P.$mjc),We(2,b.$Oj)],h);class t{constructor(c,$,w,p){this.a=new O.$7d,this.b=c,this.f=p,this.c=$,this.e=m.$mo.parse(w),this.d=this.k(w.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(c,$){const w={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$mo.parse(c),this.d=this.k(c.configurationScopes),this.a.fire(this.j($,w))}getConfiguration(c,$,w){const p=a($)||{},l=this.g(c?r(this.e.getValue(void 0,p,this.c.workspace),c):this.e.getValue(void 0,p,this.c.workspace));c&&this.h(c,p,w?.identifier);function D(S){if(S==null)return null;if(typeof S=="boolean")return S?2:5;switch(S){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const g={has(S){return typeof r(l,S)<"u"},get:(S,y)=>{this.h(c?`${c}.${S}`:S,p,w?.identifier);let C=r(l,S);if(typeof C>"u")C=y;else{let R;const V=(U,q)=>{if((0,k.$Xf)(U)){let M;const L=()=>{R=R||(0,I.$On)(l),M=M||r(R,q)};return new Proxy(U,{get:(G,ne)=>{if(typeof ne=="string"&&ne.toLowerCase()==="tojson")return L(),()=>M;if(R)return M=M||r(R,q),M[ne];const he=G[ne];return typeof ne=="string"?V(he,`${q}.${ne}`):he},set:(G,ne,he)=>(L(),M&&(M[ne]=he),!0),deleteProperty:(G,ne)=>(L(),M&&delete M[ne],!0),defineProperty:(G,ne,he)=>(L(),M&&Object.defineProperty(M,ne,he),!0)})}return Array.isArray(U)?(0,I.$On)(U):U};C=V(C,S)}return C},update:(S,y,C,R)=>{S=c?`${c}.${S}`:S;const V=D(C);return y!==void 0?this.b.$updateConfigurationOption(V,S,y,p,R):this.b.$removeConfigurationOption(V,S,p,R)},inspect:S=>{S=c?`${c}.${S}`:S;const y=this.e.inspect(S,p,this.c.workspace);if(y)return{key:S,defaultValue:(0,I.$On)(y.policy?.value??y.default?.value),globalValue:(0,I.$On)(y.user?.value??y.application?.value),workspaceValue:(0,I.$On)(y.workspace?.value),workspaceFolderValue:(0,I.$On)(y.workspaceFolder?.value),defaultLanguageValue:(0,I.$On)(y.default?.override),globalLanguageValue:(0,I.$On)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,I.$On)(y.workspace?.override),workspaceFolderLanguageValue:(0,I.$On)(y.workspaceFolder?.override),languageIds:(0,I.$On)(y.overrideIdentifiers)}}};return typeof l=="object"&&(0,I.$Rn)(g,l,!1),Object.freeze(g)}g(c){const $=w=>(0,k.$Xf)(w)?new Proxy(w,{get:(p,l)=>$(p[l]),set:(p,l,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(l)}' of object`)},deleteProperty:(p,l)=>{throw new Error(`TypeError: Cannot delete read only property '${String(l)}' of object`)},defineProperty:(p,l)=>{throw new Error(`TypeError: Cannot define property '${String(l)}' for a readonly object`)},setPrototypeOf:p=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):w;return $(c)}h(c,$,w){const p=d.$do.test(c)?4:this.d.get(c),l=w?`[${w.value}] `:"";if(p===4){typeof $?.resource>"u"&&this.f.warn(`${l}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(p===3){$?.resource&&this.f.warn(`${l}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(c,$){const w=new m.$oo(c,$,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(p,l)=>w.affectsConfiguration(p,a(l))})}k(c){return c.reduce(($,w)=>($.set(w[0],w[1]),$),new Map)}}e.$ojc=t,e.$pjc=(0,E.$ii)("IExtHostConfiguration")}),define(Ce[118],Pe([1,0,2,11,5,4,7,36,67,37,25,66,17,27,3,12,21,13,78,229,14]),function($e,e,I,O,P,N,A,m,d,k,F,E,u,b,f,r,o,s,n,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Skc=e.$Rkc=e.$Qkc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(V){function U(M){if(M!=null)return M}V.from=U;function q(M){if(M!=null)return M}V.to=q})(h||(h={}));var t;(function(V){function U(M){if(M!=null)return M}V.from=U;function q(M){if(M!=null)return M}V.to=q})(t||(t={}));var v;(function(V){function U(M){if(M!=null)return M}V.from=U;function q(M){if(M!=null)return M}V.to=q})(v||(v={}));var c;(function(V){function U(L){if(L){const G=L;return G&&!!G.process}else return!1}V.is=U;function q(L){if(L==null)return;const G={process:L.process,args:L.args};return L.options&&(G.options=v.from(L.options)),G}V.from=q;function M(L){if(L!=null)return new A.$8M(L.process,L.args,L.options)}V.to=M})(c||(c={}));var $;(function(V){function U(M){if(M!=null)return M}V.from=U;function q(M){if(M!=null)return M}V.to=q})($||($={}));var w;(function(V){function U(L){if(L){const G=L;return G&&(!!G.commandLine||!!G.command)}else return!1}V.is=U;function q(L){if(L==null)return;const G={};return L.commandLine!==void 0?G.commandLine=L.commandLine:(G.command=L.command,G.args=L.args),L.options&&(G.options=$.from(L.options)),G}V.from=q;function M(L){if(!(L==null||L.command===void 0&&L.commandLine===void 0))return L.commandLine?new A.$9M(L.commandLine,L.options):new A.$9M(L.command,L.args?L.args:[],L.options)}V.to=M})(w||(w={}));var p;(function(V){function U(L){if(L){const G=L;return G&&G.customExecution==="customExecution"}else return!1}V.is=U;function q(L){return{customExecution:"customExecution"}}V.from=q;function M(L,G){return G.get(L)}V.to=M})(p||(e.CustomExecutionDTO=p={}));var l;(function(V){function U(q,M){let L;return q.scope!==void 0&&typeof q.scope!="number"?L=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===A.TaskScope.Workspace&&M&&M.workspaceFile?L=M.workspaceFile:L=i.$sH),{id:q._id,workspaceFolder:L}}V.from=U})(l||(e.TaskHandleDTO=l={}));var D;(function(V){function U(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}V.from=U})(D||(D={}));var g;(function(V){function U(L,G){if(L==null)return[];const ne=[];for(const he of L){const ye=q(he,G);ye&&ne.push(ye)}return ne}V.fromMany=U;function q(L,G){if(L==null)return;let ne;L.execution instanceof A.$8M?ne=c.from(L.execution):L.execution instanceof A.$9M?ne=w.from(L.execution):L.execution&&L.execution instanceof A.$0M&&(ne=p.from(L.execution));const he=h.from(L.definition);let ye;return L.scope?typeof L.scope=="number"?ye=L.scope:ye=L.scope.uri:ye=A.TaskScope.Workspace,!he||!ye?void 0:{_id:L._id,definition:he,name:L.name,source:{extensionId:G.identifier.value,label:L.source,scope:ye},execution:ne,isBackground:L.isBackground,group:D.from(L.group),presentationOptions:t.from(L.presentationOptions),problemMatchers:L.problemMatchers,hasDefinedMatchers:L.hasDefinedMatchers,runOptions:L.runOptions?L.runOptions:{reevaluateOnRerun:!0},detail:L.detail}}V.from=q;async function M(L,G,ne){if(L==null)return;let he;c.is(L.execution)?he=c.to(L.execution):w.is(L.execution)?he=w.to(L.execution):p.is(L.execution)&&(he=p.to(L._id,ne));const ye=h.to(L.definition);let Re;if(L.source&&(L.source.scope!==void 0?typeof L.source.scope=="number"?Re=L.source.scope:Re=await G.resolveWorkspaceFolder(I.URI.revive(L.source.scope)):Re=A.TaskScope.Workspace),!ye||!Re)return;const ge=new A.$$M(ye,Re,L.name,L.source.label,he,L.problemMatchers);return L.isBackground!==void 0&&(ge.isBackground=L.isBackground),L.group!==void 0&&(ge.group=A.$7M.from(L.group._id),ge.group&&L.group.isDefault&&(ge.group=new A.$7M(ge.group.id,ge.group.label),L.group.isDefault===!0&&(ge.group.isDefault=L.group.isDefault))),L.presentationOptions&&(ge.presentationOptions=t.to(L.presentationOptions)),L._id&&(ge._id=L._id),L.detail&&(ge.detail=L.detail),ge}V.to=M})(g||(e.TaskDTO=g={}));var S;(function(V){function U(M){return M}V.from=U;function q(M){if(M)return Object.assign(Object.create(null),M)}V.to=q})(S||(S={}));class y{#e;constructor(U,q,M){this._id=q,this.a=M,this.#e=U}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}let C=class{constructor(U,q,M,L,G,ne,he,ye){this.q=new P.$7d,this.r=new P.$7d,this.s=new P.$7d,this.u=new P.$7d,this.a=U.getProxy(N.$kM.MainThreadTask),this.b=M,this.c=L,this.d=G,this.e=ne,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=he,this.g=ye,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(U,q,M){if(!M)return new A.$mM(()=>{});const L=this.x();return this.j.set(L,{type:q,provider:M,extension:U}),this.a.$registerTaskProvider(L,q),new A.$mM(()=>{this.j.delete(L),this.a.$unregisterTaskProvider(L)})}registerTaskSystem(U,q){this.a.$registerTaskSystem(U,q)}fetchTasks(U){return this.a.$fetchTasks(S.from(U)).then(async q=>{const M=[];for(const L of q){const G=await g.to(L,this.b,this.m);G&&M.push(G)}return M})}get taskExecutions(){const U=[];return this.k.forEach(q=>U.push(q)),U}terminateTask(U){if(!(U instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(U._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(U,q,M){const L=this.m.get(U.id);L&&(this.o.set(U.id,L),this.e.attachPtyToTerminal(q,await L.callback(M))),this.p=U.id,this.q.fire({execution:await this.z(U)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(U){if(!this.l.has(U.id))return;const q=await this.z(U);this.l.delete(U.id),this.k.delete(U.id),this.B(U),this.r.fire({execution:q})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(U){const q=await this.z(U.id);this.s.fire({execution:q,processId:U.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(U){const q=await this.z(U.id);this.u.fire({execution:q,exitCode:U.exitCode})}$provideTasks(U,q){const M=this.j.get(U);if(!M)return Promise.reject(new Error("no handler found"));const L=[],G=(0,O.$ah)(()=>M.provider.provideTasks(F.CancellationToken.None)).then(ne=>this.v(q,L,M,ne));return new Promise(ne=>{G.then(he=>{Promise.all(L).then(()=>{ne(he)})})})}async $resolveTask(U,q){const M=this.j.get(U);if(!M)return Promise.reject(new Error("no handler found"));if(q.definition.type!==M.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${M.type}].`);const L=await g.to(q,this.b,this.m);if(!L)throw new Error("Unexpected: Task cannot be resolved.");const G=await M.provider.resolveTask(L,F.CancellationToken.None);if(!G)return;this.A(G,M);const ne=g.from(G,M.extension);if(!ne)throw new Error("Unexpected: Task cannot be resolved.");if(G.definition!==L.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(ne.execution)&&await this.y(ne,G,!0),await this.w(ne)}x(){return this.h++}async y(U,q,M){const L=await this.a.$createTaskId(U);!M&&!this.m.has(L)&&(this.n.add(L),this.o.set(L,q.execution)),this.m.set(L,q.execution)}async z(U,q){if(typeof U=="string"){const G=this.l.get(U);if(!G)throw new a.$bb("Unexpected: The specified task is missing an execution");return G}const M=this.l.get(U.id);if(M)return M;let L;return q?L=Promise.resolve(new y(this,U.id,q)):L=g.to(U.task,this.b,this.m).then(G=>{if(!G)throw new a.$bb("Unexpected: Task does not exist.");return new y(this,U.id,G)}),this.l.set(U.id,L),L.then(G=>(this.k.set(U.id,G),G))}A(U,q){U._deprecated&&this.g.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}B(U){this.o.get(U.id)&&this.o.delete(U.id),this.n.has(U.id)&&this.p!==U.id&&(this.m.delete(U.id),this.n.delete(U.id));const M=this.n.values();let L=M.next();for(;!L.done;)!this.o.has(L.value)&&this.p!==L.value&&(this.m.delete(L.value),this.n.delete(L.value)),L=M.next()}};e.$Qkc=C,e.$Qkc=C=Je([We(0,u.$FO),We(1,b.$VO),We(2,m.$mjc),We(3,d.$QO),We(4,k.$pjc),We(5,E.$Njc),We(6,s.$Oj),We(7,n.$Zic)],C);let R=class extends C{constructor(U,q,M,L,G,ne,he,ye){super(U,q,M,L,G,ne,he,ye),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:o.$h(0)})}async executeTask(U,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const M=g.from(q,U);if(M===void 0)throw new Error("Task is not valid");if(p.is(M.execution))await this.y(M,q,!1);else throw new a.$_;const L=await this.z(await this.a.$getTaskExecution(M),q);return this.a.$executeTask(M).catch(G=>{throw new Error(G)}),L}v(U,q,M,L){const G=[];if(L)for(const ne of L){if(this.A(ne,M),!ne.definition||!U[ne.definition.type]){const ye=ne.source?ne.source:"No task source";this.f.warn(`The task [${ye}, ${ne.name}] uses an undefined task type. The task will be ignored in the future.`)}const he=g.from(ne,M.extension);he&&p.is(he.execution)?(G.push(he),q.push(this.y(he,ne,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:G,extension:M.extension}}async w(U){if(p.is(U.execution))return U;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(U,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,q,M){}};e.$Rkc=R,e.$Rkc=R=Je([We(0,u.$FO),We(1,b.$VO),We(2,m.$mjc),We(3,d.$QO),We(4,k.$pjc),We(5,E.$Njc),We(6,s.$Oj),We(7,n.$Zic)],R),e.$Skc=(0,f.$ii)("IExtHostTask")}),define(Ce[289],Pe([1,0,45,29]),function($e,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1K=void 0,e.$ZK=P,e.$2K=N;function P(A){return"cellResults"in A}e.$1K="rawCell#";function N(A,m){let d=-1;const k=[];let F=[];return A.forEach(u=>{u.range.startLineNumber!==d&&F.length>0&&(k.push([...F]),F=[]),F.push(u),d=u.range.endLineNumber}),F.length>0&&k.push([...F]),k.map(u=>{const b=[],f=u[0].range.startLineNumber,r=u[u.length-1].range.endLineNumber;for(let o=f;o<=r;o++)b.push(m.getLineContent(o));return new I.$DK(b.join(`
`)+`
`,u.map(o=>new O.$ct(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Ce[290],Pe([1,0,168,23,5,6,28,15,16,2,43,74,4,31,8,7,50,265,112,26,12,219,289,287]),function($e,e,I,O,P,N,A,m,d,k,F,E,u,b,f,r,o,s,n,i,a,h,t,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$skc=void 0;class c{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(w=>w.apiEditor)}constructor(w,p,l,D,g,S){this.q=l,this.r=D,this.s=g,this.t=S,this.f=new Map,this.g=new A.$Bc,this.h=new Map,this.j=new P.$7d,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$7d,this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$7d,this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$7d,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new E.$Xic("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=w.getProxy(u.$kM.MainThreadNotebook),this.c=w.getProxy(u.$kM.MainThreadNotebookDocuments),this.d=w.getProxy(u.$kM.MainThreadNotebookEditors),this.i=p.converter,p.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const C=y.notebookEditor?.notebookUri,R=y.cell.handle,U=this.g.get(C)?.getCell(R);if(U)return U.apiCell}if(y&&y.$mid===14){const C=y.uri,R=this.g.get(C);if(R)return R.apiNotebook}return y}}),c.B(p)}getEditorById(w){const p=this.h.get(w);if(!p)throw new Error(`unknown text editor: ${w}. known editors: ${[...this.h.keys()]} `);return p}getIdByEditor(w){for(const[p,l]of this.h)if(l.apiEditor===w)return p}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(w,p){const l=this.g.get(w);if(!l&&!p)throw new Error(`NO notebook document for '${w}'`);return l}static u(w,p){if(!p)return;const l=p.filenamePattern.map(D=>f.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(p.filenamePattern&&!l){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:w.identifier,providerDisplayName:w.displayName||w.name,displayName:p.displayName,filenamePattern:l,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(w,p,l){const D=c.a++,g=typeof l.onDidChangeCellStatusBarItems=="function"?c.a++:void 0;this.f.set(D,l),this.b.$registerNotebookCellStatusBarItemProvider(D,g,p);let S;return g!==void 0&&(S=l.onDidChangeCellStatusBarItems(y=>this.b.$emitCellStatusBarEvent(g))),new r.$mM(()=>{this.f.delete(D),this.b.$unregisterNotebookCellStatusBarItemProvider(D,g),S?.dispose()})}async createNotebookDocument(w){const p=await this.c.$tryCreateNotebook({viewType:w.viewType,content:w.content&&f.NotebookData.from(w.content)});return k.URI.revive(p)}async openNotebookDocument(w){const p=this.g.get(w);if(p)return p.apiNotebook;const l=await this.c.$tryOpenNotebook(w),D=this.g.get(k.URI.revive(l));return(0,d.$7f)(D?.apiNotebook)}async showNotebookDocument(w,p){k.URI.isUri(w)&&(w=await this.openNotebookDocument(w));let l;typeof p=="object"?l={position:f.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(f.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:l={preserveFocus:!1};const D=await this.d.$tryShowNotebookDocument(w.uri,w.notebookType,l),g=D&&this.h.get(D)?.apiEditor;if(g)return g;throw D?new Error(`Could NOT open editor for "${w.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${w.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(w,p,l,D){const g=this.f.get(w),S=k.URI.revive(p),y=this.g.get(S);if(!y||!g)return;const C=y.getCellFromIndex(l);if(!C)return;const R=await g.provideCellStatusBarItems(C.apiCell,D);if(!R)return;const V=new N.$Tc,U=this.p.add([V]),M=(Array.isArray(R)?R:[R]).map(L=>f.NotebookStatusBarItem.from(L,this.i,V));return{cacheId:U,items:M}}$releaseNotebookCellStatusBarItems(w){this.p.delete(w)}registerNotebookSerializer(w,p,l,D,g){if((0,m.$Ue)(p))throw new Error("viewType cannot be empty or just whitespace");const S=this.w++;return this.x.set(S,{viewType:p,serializer:l,options:D}),this.b.$registerNotebookSerializer(S,{id:w.identifier,location:w.extensionLocation},p,f.NotebookDocumentContentOptions.from(D),c.u(w,g)),(0,N.$Sc)(()=>{this.b.$unregisterNotebookSerializer(S)})}async $dataToNotebook(w,p,l){const D=this.x.get(w);if(!D)throw new Error("NO serializer found");const g=await D.serializer.deserializeNotebook(p.buffer,l);return new o.$ew(f.NotebookData.from(g))}async $notebookToData(w,p,l){const D=this.x.get(w);if(!D)throw new Error("NO serializer found");const g=await D.serializer.serializeNotebook(f.NotebookData.to(p.value),l);return O.$ue.wrap(g)}async $saveNotebook(w,p,l,D,g){const S=k.URI.revive(p),y=this.x.get(w);if(!y)throw new Error("NO serializer found");const C=this.g.get(S);if(!C)throw new Error("Document NOT found");if(C.versionId!==l)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(S.scheme))throw new F.$0k((0,I.localize)(0,null,this.z(S)),6);await this.y(S,D);const R={metadata:(0,i.$Wn)(C.apiNotebook.metadata,L=>!(y.options?.transientDocumentMetadata??{})[L]),cells:[]};for(const L of C.apiNotebook.getCells()){const G=new r.$ON(L.kind,L.document.getText(),L.document.languageId,L.mime,y.options?.transientOutputs?[]:[...L.outputs],L.metadata,L.executionSummary);G.metadata=(0,i.$Wn)(L.metadata,ne=>!(y.options?.transientCellMetadata??{})[ne]),R.cells.push(G)}const V=await y.serializer.serializeNotebook(R,g);await this.s.value.writeFile(S,V);const U=this.s.getFileSystemProviderExtUri(S.scheme),q=await this.s.value.stat(S);return{name:U.basename(S),isFile:(q.type&F.FileType.File)!==0,isDirectory:(q.type&F.FileType.Directory)!==0,isSymbolicLink:(q.type&F.FileType.SymbolicLink)!==0,mtime:q.mtime,ctime:q.ctime,size:q.size,readonly:!!((q.permissions??0)&F.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(S.scheme),locked:!!((q.permissions??0)&F.FilePermission.Locked),etag:F.$il({mtime:q.mtime,size:q.size}),children:void 0}}async $searchInNotebooks(w,p,l,D,g){const S=this.x.get(w)?.serializer;if(!S)return{limitHit:!1,results:[]};const y=new A.$Cc;await(async(q,M,L)=>{await Promise.all(q.map(async G=>await Promise.all(G.filenamePatterns.map(ne=>{const he={_reason:L._reason,folderQueries:L.folderQueries,includePattern:L.includePattern,excludePattern:L.excludePattern,maxResults:L.maxResults,type:1,filePattern:ne};return this.t.doInternalFileSearchWithCustomCallback(he,M,ye=>{ye.forEach(Re=>{y.has(Re)||D.some(ue=>G.isFromSettings&&!ue.isFromSettings?!1:ue.filenamePatterns.some(te=>(0,v.$Afb)(te,Re)))||y.add(Re)})}).catch(ye=>{if(ye.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ye})}))))})(l,g,p);const R=new A.$Bc;let V=!1;const U=Array.from(y).map(async q=>{const M=[];try{if(g.isCancellationRequested)return;if(p.maxResults&&[...R.values()].reduce((he,ye)=>he+ye.cellResults.length,0)>p.maxResults){V=!0;return}const L=[],G=this.g.get(q);if(G)G.apiNotebook.getCells().forEach(ye=>L.push({input:ye.document.getText(),outputs:ye.outputs.flatMap(Re=>Re.items.map(ge=>ge.data.toString()))}));else{const he=await this.s.value.readFile(q),ye=O.$ue.fromString(he.toString()),Re=await S.deserializeNotebook(ye.buffer,g);if(g.isCancellationRequested)return;f.NotebookData.from(Re).cells.forEach(ue=>L.push({input:ue.source,outputs:ue.outputs.flatMap(te=>te.items.map(be=>be.valueBytes.toString()))}))}if(g.isCancellationRequested)return;L.forEach((he,ye)=>{const Re=p.contentPattern.pattern,ge=new h.$tUb(he.input,void 0,he.outputs),ue=ge.findInInputs(Re),te=ge.findInOutputs(Re),be=te.flatMap(oe=>(0,t.$2K)(oe.matches,oe.textBuffer)).map((oe,de)=>(oe.webviewIndex=de,oe));if(ue.length>0||te.length>0){const oe={index:ye,contentResults:(0,t.$2K)(ue,ge.inputTextBuffer),webviewResults:be};M.push(oe)}});const ne={resource:q,cellResults:M};R.set(q,ne);return}catch{return}});return await Promise.all(U),{limitHit:V,results:[...R.values()]}}async y(w,p){const l=await this.s.value.stat(w);if(typeof p?.mtime=="number"&&typeof p.etag=="string"&&p.etag!==F.$hl&&typeof l.mtime=="number"&&typeof l.size=="number"&&p.mtime<l.mtime&&p.etag!==F.$il({mtime:p.mtime,size:l.size}))throw new F.$0k((0,I.localize)(1,null),3,p)}z(w){return w.scheme===a.Schemas.file?w.fsPath:w.toString()}A(w,p,l){if(this.h.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const D=new n.$jkc(p,this.d,w,l.visibleRanges.map(f.NotebookRange.to),l.selections.map(f.NotebookRange.to),typeof l.viewColumn=="number"?f.ViewColumn.to(l.viewColumn):void 0);this.h.set(p,D)}$acceptDocumentAndEditorsDelta(w){if(w.value.removedDocuments)for(const l of w.value.removedDocuments){const D=k.URI.revive(l),g=this.g.get(D);g&&(g.dispose(),this.g.delete(D),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:g.apiNotebook.getCells().map(S=>S.document.uri)}),this.n.fire(g.apiNotebook));for(const S of this.h.values())S.notebookData.uri.toString()===D.toString()&&this.h.delete(S.id)}if(w.value.addedDocuments){const l=[];for(const D of w.value.addedDocuments){const g=k.URI.revive(D.uri);if(this.g.has(g))throw new Error(`adding EXISTING notebook ${g} `);const S=new s.$ikc(this.c,this.q,this.r,g,D);l.push(...D.cells.map(y=>s.$hkc.asModelAddData(y))),this.g.get(g)?.dispose(),this.g.set(g,S),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:l}),this.m.fire(S.apiNotebook)}}if(w.value.addedEditors)for(const l of w.value.addedEditors){if(this.h.has(l.id))return;const D=k.URI.revive(l.documentUri),g=this.g.get(D);g&&this.A(g,l.id,l)}const p=[];if(w.value.removedEditors)for(const l of w.value.removedEditors){const D=this.h.get(l);D&&(this.h.delete(l),this.k?.id===D.id&&(this.k=void 0),p.push(D))}if(w.value.visibleEditors){this.l=w.value.visibleEditors.map(D=>this.h.get(D)).filter(D=>!!D);const l=new Set;this.l.forEach(D=>l.add(D.id));for(const D of this.h.values()){const g=l.has(D.id);D._acceptVisibility(g)}this.l=[...this.h.values()].map(D=>D).filter(D=>D.visible),this.o.fire(this.visibleNotebookEditors)}w.value.newActiveEditor===null?this.k=void 0:w.value.newActiveEditor&&(this.h.get(w.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${w.value.newActiveEditor}`),this.k=this.h.get(w.value.newActiveEditor)),w.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(w){const p=b.$4O.String.with("notebookType","A notebook type"),l=new b.$6O("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[p,new b.$4O("data","Bytes to convert to data",g=>g instanceof Uint8Array,g=>O.$ue.wrap(g))],new b.$5O("Notebook Data",g=>f.NotebookData.to(g.value))),D=new b.$6O("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[p,new b.$4O("NotebookData","Notebook data to convert to bytes",g=>!0,g=>new o.$ew(f.NotebookData.from(g)))],new b.$5O("Bytes",g=>g.buffer));w.registerApiCommand(l),w.registerApiCommand(D)}}e.$skc=c}),define(Ce[291],Pe([1,0,19,25,42,35,24,64,45]),function($e,e,I,O,P,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kkc=void 0;class k{constructor(u,b,f){this.k=u,this.l=b,this.o=f,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&N.$ck(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&N.$ck(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const b=this.k.folderQueries||[];return new Promise((f,r)=>{const o=s=>{this.f++,u(s)};if(this.g)return f({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const n=s.toString(),i=I.$oc(n);this.j&&this.j(n,i)||this.v(o,{base:s,basename:i})}),Promise.all(b.map(s=>this.p(s,o))).then(s=>{f({limitHit:this.e,stats:s[0]||void 0})},s=>{r(new Error((0,P.$6i)(s)))})})}async p(u,b){const f=new O.$ee,r=this.q(u),o=this.r(),s=new d.$RK(this.k,u),n=!s.hasSiblingExcludeClauses();let i;try{this.h.add(f),i=m.$3d.create();const a=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,f.token),h=i.elapsed(),t=m.$3d.create();return this.g&&!this.e||(a&&a.forEach(v=>{const c=I.$hc.relative(u.folder.path,v.path);if(n){const $=I.$oc(v.path);this.v(b,{base:u.folder,relativePath:c,basename:$});return}this.s(o,u.folder,c,b)}),this.g&&!this.e)?null:(this.u(o,s,b),{providerTime:h,postProcessTime:t.elapsed()})}finally{f.dispose(),this.h.delete(f)}}q(u){const b=(0,d.$QK)(this.k.includePattern,u.includePattern),f=(0,d.$QK)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:f,includes:b,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},b,f,r){if(f===this.a){const s=I.$oc(this.a);this.v(r,{base:b,relativePath:this.a,basename:s})}function o(s){const n=I.$oc(s),i=I.$nc(s);let a=u[i];a||(a=u[i]=[],o(i)),a.push({base:b,relativePath:s,basename:n})}o(f)}u({rootEntries:u,pathToEntries:b},f,r){const o=this,s=this.a;function n(i){const a=(0,d.$TK)(()=>i.map(h=>h.basename));for(let h=0,t=i.length;h<t;h++){const v=i[h],{relativePath:c,basename:$}=v;if(f.matchesExcludesSync(c,$,s!==$?a:void 0))continue;const w=b[c];if(w)n(w);else{if(c===s)continue;o.v(r,v)}if(o.e)break}}n(u)}v(u,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(b))}}class F{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,b,f,r){const o=this.c(u.cacheKey),s=new k(u,b,o&&o.token);let n=0;const i=a=>{n+=a.length,f(a.map(h=>this.d(h)))};return this.e(s,F.a,i,r).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:a.stats}}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new O.$ee),this.b.get(u)}d(u){return u.relativePath?{resource:A.$Vg(u.base,u.relativePath)}:{resource:u.base}}e(u,b,f,r){const o=r.onCancellationRequested(()=>{u.cancel()}),s=i=>{i&&(n.push(i),b>0&&n.length>=b&&(f(n),n=[]))};let n=[];return u.search(s).then(i=>(n.length&&f(n),o.dispose(),i),i=>(n.length&&f(n),o.dispose(),Promise.reject(i)))}}e.$kkc=F}),define(Ce[292],Pe([1,0,18,260,35,96,28,12,19,24,15,16,2,95,185,47,13,48,107,288,45]),function($e,e,I,O,P,N,A,m,d,k,F,E,u,b,f,r,o,s,n,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1L=void 0,e.$2L=D;let h=class{constructor(S,y,C,R,V){this.a=S,this.b=y,this.c=C,this.d=R,this.e=V}text(S,y,C={}){S=this.f(S,C);const R=this.a.getValue(),V=y&&y.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(y?.map(s.$Di),C),type:2,contentPattern:S,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:R.search.usePCRE2||V||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(S,y){const C=this.a.getValue();S.isRegExp&&(S.pattern=S.pattern.replace(/\r?\n/g,"\\n"));const R={...S,wordSeparators:C.editor.wordSeparators};return this.j(S,y)&&(R.isCaseSensitive=!0),this.k(S)&&(R.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(R.notebookInfo||(R.notebookInfo={}),R.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(R.notebookInfo||(R.notebookInfo={}),R.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(R.notebookInfo||(R.notebookInfo={}),R.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(R.notebookInfo||(R.notebookInfo={}),R.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),R}file(S,y={}){return{...this.h(S,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey,shouldGlobMatchFilePattern:y.shouldGlobSearch}}g(S,y){return S?(S=Array.isArray(S)?S.map(w):w(S),y?this.parseSearchPaths(S):{pattern:v(...Array.isArray(S)?S:[S])}):{}}h(S=[],y={}){const C=this.g(y.includePattern,y.expandPatterns),R=this.g(y.excludePattern,y.expandPatterns),V=S.length>1,U=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(L=>this.q(L,y,R)):S.map(L=>this.r(L,y,R,V))).filter(L=>!!L),q={_reason:y._reason,folderQueries:U,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:R.pattern,includePattern:C.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const L=I.$Hb(I.$Rb(this.c.groups.map(he=>he.editors.map(ye=>ye.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(L));const G=L.filter(he=>(0,a.$HK)(q,he.fsPath)),ne=this.i(G);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ne)),{...q,...ne}}const M=y.extraFileResources&&y.extraFileResources.filter(L=>(0,a.$HK)(q,L.fsPath));return q.extraFileResources=M&&M.length?M:void 0,q}i(S){const y=[],C=new A.$Bc,R={};let V=!1;return S.forEach(U=>{if(U.scheme===m.Schemas.walkThrough)return;if((0,k.$Zg)(U)){const M=this.b.getWorkspaceFolder(U)?.uri??U.with({path:d.$nc(U.fsPath)});let L=C.get(M);L||(V=!0,L={folder:M,includePattern:{}},y.push(L),C.set(M,L));const G=d.$mc(M.fsPath,U.fsPath);(0,E.$7f)(L.includePattern)[G.replace(/\\/g,"/")]=!0}else U.fsPath&&(V=!0,R[U.fsPath]=!0)}),{folderQueries:y,includePattern:R,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}j(S,y){if(y.isSmartCase){if(S.isRegExp){if(F.$Mf(S.pattern,!0))return!0}else if(F.$Mf(S.pattern))return!0}return!!S.isCaseSensitive}k(S){return S.isMultiline||S.isRegExp&&(0,b.$pC)(S.pattern)||S.pattern.indexOf(`
`)>=0?!0:!!S.isMultiline}parseSearchPaths(S){const y=ne=>d.$jc(ne)||/^\.\.?([\/\\]|$)/.test(ne),R=(Array.isArray(S)?S:c(S)).map(ne=>{const he=this.e.resolvedUserHome;return he?(0,N.$jw)(ne,he.scheme===m.Schemas.file?he.fsPath:he.path):ne}),V=O.$K(R,ne=>y(ne)?"searchPaths":"exprSegments"),U=(V.exprSegments||[]).map(ne=>F.$6e(ne,"/")).map(ne=>F.$6e(ne,"\\")).map(ne=>(ne[0]==="."&&(ne="*"+ne),$(ne))),q={},M=this.m(V.searchPaths||[]);M&&M.length&&(q.searchPaths=M);const L=I.$Rb(U),G=v(...L);return G&&(q.pattern=G),q}l(S,y){return y.disregardExcludeSettings?void 0:(0,a.$GK)(S,!y.disregardSearchExcludeSettings)}m(S){if(!S||!S.length)return[];const y=S.flatMap(R=>{let{pathPortion:V,globPortion:U}=t(R);return U&&(U=p(U)),this.n(V).flatMap(M=>this.o(M,U))}),C=new Map;return y.forEach(R=>{const V=R.searchPath.toString(),U=C.get(V);U?R.pattern&&(U.pattern=U.pattern||{},U.pattern[R.pattern]=!0):C.set(V,{searchPath:R.searchPath,pattern:R.pattern?v(R.pattern):void 0})}),Array.from(C.values())}n(S){if(d.$jc(S)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==m.Schemas.file?[{searchPath:y[0].uri.with({path:S})}]:[{searchPath:u.URI.file(d.$ic(S))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(S=w(S),S.startsWith("../")||S===".."){const R=d.$hc.resolve(y.path,S);return[{searchPath:y.with({path:R})}]}const C=p(S);return[{searchPath:y,pattern:C}]}else{if(S==="./"||S===".\\")return[];{const y=S.replace(/^\.[\/\\]/,""),R=this.b.getWorkspace().folders.map(V=>{const U=y.match(new RegExp(`^${F.$Ze(V.name)}(?:/(.*)|$)`));return U?{match:U,folder:V}:null}).filter(E.$4f);if(R.length)return R.map(V=>{const U=V.match[1];return{searchPath:V.folder.uri,pattern:U&&p(U)}});{const V=S.match(/\.[\/\\](.+)[\/\\]?/),U=V?V[1]:S,q=f.localize(0,null,U);throw new Error(q)}}}}o(S,y){const C=S.pattern&&y?`${S.pattern}/${y}`:S.pattern||y,R=[{searchPath:S.searchPath,pattern:C}];return C&&!C.endsWith("**")&&R.push({searchPath:S.searchPath,pattern:C+"/**"}),R}q(S,y,C){const R=this.r((0,s.$Di)(S.searchPath),y,C,!1);return R?{...R,includePattern:S.pattern}:null}r(S,y,C,R){let V;const U=u.URI.isUri(S)?S:S.uri;if(C.searchPaths){const ne=C.searchPaths.filter(he=>(0,k.$Og)(he.searchPath,U))[0];if(ne&&!ne.pattern)return null;ne&&(V=ne.pattern)}const q=this.a.getValue({resource:U}),L={...this.l(q,y)||{},...V||{}},G=u.URI.isUri(S)?(0,k.$Sg)(S):S.name;return{folder:U,folderName:R?G:void 0,excludePattern:Object.keys(L).length>0?L:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!q.search.followSymlinks}}};e.$1L=h,e.$1L=h=Je([We(0,r.$Oi),We(1,s.$ri),We(2,n.$wD),We(3,o.$Oj),We(4,i.$YL)],h);function t(g){const S=g.match(/[\*\{\}\(\)\[\]\?]/);if(S){const y=S.index,C=g.substr(0,y).match(/[/|\\][^/\\]*$/);if(C){let R=g.substr(0,C.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:g.substr((C.index||0)+1)}}}return{pathPortion:g}}function v(...g){return g.length?g.reduce((S,y)=>(S[y]=!0,S),Object.create(null)):void 0}function c(g){return P.$ak(g,",").map(S=>S.trim()).filter(S=>!!S.length)}function $(g){return[`**/${g}/**`,`**/${g}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function w(g){return g.replace(/\\/g,"/")}function p(g){return w(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(g){return g.replace(/([?*[\]])/g,"[$1]")}function D(g,S){g=I.$Mb(g,R=>R.toString());const y=[],C=S.getWorkspace();return g&&g.forEach(R=>{let V;if(S.getWorkbenchState()===2)V=(0,k.$Xg)(C.folders[0].uri,R),V&&V!=="."&&(V="./"+V);else{const U=S.getWorkspaceFolder(R);if(U){const q=U.name;if(C.folders.filter(L=>L.name===q).length===1){const L=(0,k.$Xg)(U.uri,R);L===""?V=`./${U.name}`:V=`./${U.name}/${L}`}else V=R.fsPath}}V&&y.push(l(V))}),y}}),define(Ce[293],Pe([1,0,24,2,25,14,3,292,45,48,11]),function($e,e,I,O,P,N,A,m,d,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fvb=u,e.$gvb=r;const E=7e3;function u(o,s){const n=s.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],a=[];for(const w of n)if(/^workspaceContains:/.test(w)){const p=w.substr(18);p.indexOf("*")>=0||p.indexOf("?")>=0||o.forceUsingSearch?a.push(p):i.push(p)}if(i.length===0&&a.length===0)return Promise.resolve(void 0);const{promise:h,resolve:t}=(0,F.$bh)(),v=w=>t({activationEvent:w}),c=Promise.all(i.map(w=>b(o,w,v))).then(()=>{}),$=f(o,s.identifier,a,v);return Promise.all([c,$]).then(()=>{t(void 0)}),h}async function b(o,s,n){for(const i of o.folders)if(await o.exists(I.$Vg(O.URI.revive(i),s))){n(`workspaceContains:${s}`);return}}async function f(o,s,n,i){if(n.length===0)return Promise.resolve(void 0);const a=new P.$ee,h=o.checkExists(o.folders,n,a.token),t=setTimeout(async()=>{a.cancel(),o.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},E);let v=!1;try{v=await h}catch(c){N.$4(c)||N.$1(c)}a.dispose(),clearTimeout(t),v&&i(`workspaceContains:${n.join(",")}`)}function r(o,s,n,i){const a=o.get(A.$hi),h=o.get(d.$yK),v=a.createInstance(m.$1L).file(s.map(c=>(0,k.$Di)(O.URI.revive(c))),{_reason:"checkExists",includePattern:n,exists:!0});return h.fileSearch(v,i).then(c=>!!c.limitHit,c=>N.$4(c)?!1:Promise.reject(c))}}),define(Ce[38],Pe([1,0,164,19,89,24,11,6,51,2,13,4,37,225,82,36,22,108,14,20,23,206,7,102,3,27,85,17,71,86,66,88,5,293,81,208,12,79,64,21,80]),function($e,e,I,O,P,N,A,m,d,k,F,E,u,b,f,r,o,s,n,i,a,h,t,v,c,$,w,p,l,D,g,S,y,C,R,V,U,q,M,L,G){"use strict";var ne;Object.defineProperty(e,"__esModule",{value:!0}),e.$3jc=e.$2jc=e.$1jc=e.$Zjc=e.$Yjc=void 0,e.$Yjc=(0,c.$ii)("IHostUtils");let he=ne=class extends m.$Uc{constructor(W,ee,ke,Te,Se,ve,me,J,Y,ce,fe,Ne,le){super(),this.Y=Ne,this.Z=le,this.a=this.B(new y.$7d),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=ee,this.g=ke,this.f=me,this.j=Te,this.m=Se,this.s=ve,this.t=Y,this.u=ce,this.w=fe,this.y=this.g.getProxy(E.$kM.MainThreadWorkspace),this.z=this.g.getProxy(E.$kM.MainThreadTelemetry),this.C=this.g.getProxy(E.$kM.MainThreadExtensionService),this.D=new A.$hh,this.F=new A.$hh,this.G=new A.$hh,this.H=new A.$hh,this.I=new oe(this.f.extensions.activationEvents),this.L=new s.$T0b(this.I,this.f.extensions.allExtensions);const Ie=new i.$Em(this.f.extensions.myExtensions);this.J=new s.$T0b(this.I,te(this.L,Ie)),L.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ge(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ge(this.J)}`)),this.M=new f.$Jjc(this.g,this.s),this.N=new R.$Rjc(this.g),this.O=J,this.h=W.createChild(new l.$gi([f.$Kjc,this.M],[R.$Sjc,this.N])),this.P=this.B(new b.$Ijc(this.J,this.L,{onExtensionActivationError:(Ae,je,z)=>{this.C.$onExtensionActivationError(Ae,n.$3(je),z)},actualActivateExtension:async(Ae,je)=>{if(s.$T0b.isHostExtension(Ae,this.J,this.L))return await this.C.$activateExtension(Ae,je),new b.$Hjc;const z=this.J.getExtensionDescription(Ae);return this.fb(z,je)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(W){n.$1(W)}}async $(){this.O.onWillDeactivateAll();let W=[];try{W=this.J.getAllExtensionDescriptions().map(Se=>Se.identifier).filter(Se=>this.isActivated(Se)).map(Se=>this.eb(Se))}catch{}await Promise.all(W)}terminate(W,ee=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${W}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Te=>{this.s.error(Te)}),this.g.dispose();const ke=this.$();Promise.race([(0,A.$jh)(5e3),ke]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${ee}`):this.s.info(`Extension host exiting with code ${ee}`),this.s.flush(),this.s.dispose(),this.c.exit(ee)})}isActivated(W){return this.G.isOpen()?this.P.isActivated(W):!1}async getExtension(W){const ee=await this.C.$getExtension(W);return ee&&{...ee,identifier:new i.$Dm(ee.identifier.value),extensionLocation:k.URI.revive(ee.extensionLocation)}}ab(W,ee){return this.P.activateByEvent(W,ee)}bb(W,ee){return this.P.activateById(W,ee)}activateByIdWithErrors(W,ee){return this.bb(W,ee).then(()=>{const ke=this.P.getActivatedExtension(W);if(ke.activationFailed)return Promise.reject(ke.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(W=>this.J)}getExtensionExports(W){if(this.G.isOpen())return this.P.getActivatedExtension(W).exports;try{return this.P.getActivatedExtension(W).exports}catch{return null}}async cb(W){if(W.scheme===U.Schemas.file&&this.c.fsRealpath){const ee=W.fsPath;this.R.has(ee)||this.R.set(ee,this.c.fsRealpath(ee));const ke=await this.R.get(ee);return k.URI.file(ke)}return W}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(W=>new be(W))),this.Q}async db(W){const ee=d.$oi.forUris(ke=>N.$Mg.ignorePathCasing(ke));return await Promise.all(W.map(async ke=>{if(this.wb(ke)){const Te=await this.cb(ke.extensionLocation);ee.set(Te,ke)}})),ee}eb(W){let ee=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(W))return ee;const ke=this.P.getActivatedExtension(W);if(!ke)return ee;try{typeof ke.module.deactivate=="function"&&(ee=Promise.resolve(ke.module.deactivate()).then(void 0,Te=>(this.s.error(Te),Promise.resolve(void 0))))}catch(Te){this.s.error(`An error occurred when deactivating the extension '${W.value}':`),this.s.error(Te)}try{(0,m.$Pc)(ke.subscriptions)}catch(Te){this.s.error(`An error occurred when deactivating the subscriptions for extension '${W.value}':`),this.s.error(Te)}return ee}async fb(W,ee){return this.f.remote.isRemote?this.C.$onWillActivateExtension(W.identifier):await this.C.$onWillActivateExtension(W.identifier),this.hb(W,ee).then(ke=>{const Te=ke.activationTimes;return this.C.$onDidActivateExtension(W.identifier,Te.codeLoadingTime,Te.activateCallTime,Te.activateResolvedTime,ee),this.gb(W,ee,"success",Te),ke},ke=>{throw this.gb(W,ee,"failure"),ke})}gb(W,ee,ke,Te){const Se=Re(W,ee);this.z.$publicLog2("extensionActivationTimes",{...Se,...Te||{},outcome:ke})}hb(W,ee){const ke=Re(W,ee);this.z.$publicLog2("activatePlugin",ke);const Te=this.wb(W);if(!Te)return Promise.resolve(new b.$Gjc(b.$Djc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${W.identifier.value}, startup: ${ee.startup}, activationEvent: '${ee.activationEvent}'${W.identifier.value!==ee.extensionId.value?`, root cause: ${ee.extensionId.value}`:""}`),this.s.flush();const Se=new b.$Ejc(ee.startup);return Promise.all([this.xb(W,(0,N.$Vg)(W.extensionLocation,Te),Se),this.ib(W)]).then(ve=>(P.mark(`code/extHost/willActivateExtension/${W.identifier.value}`),ne.jb(this.s,W.identifier,ve[0],ve[1],Se))).then(ve=>(P.mark(`code/extHost/didActivateExtension/${W.identifier.value}`),ve))}ib(W){const ee=this.Z.createLanguageModelAccessInformation(W),ke=new h.$Mjc(W,this.M),Te=new h.$Ljc(W.identifier.value,!1,this.M),Se=new V.$Tjc(W,this.N),ve=W.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,me=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${W.identifier.value}`),Promise.all([ke.whenReady,Te.whenReady,this.O.whenReady]).then(()=>{const J=this;let Y,ce;const fe=(0,o.$8F)(W,"ipc")?this.f.messagePorts?.get(i.$Dm.toKey(W.identifier)):void 0;return Object.freeze({globalState:ke,workspaceState:Te,secrets:Se,subscriptions:[],get languageModelAccessInformation(){return ee},get extensionUri(){return W.extensionLocation},get extensionPath(){return W.extensionLocation.fsPath},asAbsolutePath(Ne){return O.$kc(W.extensionLocation.fsPath,Ne)},get storagePath(){return J.O.workspaceValue(W)?.fsPath},get globalStoragePath(){return J.O.globalValue(W).fsPath},get logPath(){return O.$kc(J.f.logsLocation.fsPath,W.identifier.value)},get logUri(){return k.URI.joinPath(J.f.logsLocation,W.identifier.value)},get storageUri(){return J.O.workspaceValue(W)},get globalStorageUri(){return J.O.globalValue(W)},get extensionMode(){return ve},get extension(){return Y===void 0&&(Y=new ue(J,W.identifier,W,me,!1)),Y},get extensionRuntime(){return(0,o.$9F)(W,"extensionRuntime"),J.extensionRuntime},get environmentVariableCollection(){return J.u.getEnvironmentVariableCollection(W)},get messagePassingProtocol(){if(!ce){if(!fe)return;const Ne=y.Event.buffer(y.Event.fromDOMEventEmitter(fe,"message",le=>le.data));fe.start(),ce={onDidReceiveMessage:Ne,postMessage:fe.postMessage.bind(fe)}}return ce}})})}static jb(W,ee,ke,Te,Se){return ke=ke||{activate:void 0,deactivate:void 0},this.kb(W,ee,ke,Te,Se).then(ve=>new b.$Fjc(!1,null,Se.build(),ke,ve,Te.subscriptions))}static kb(W,ee,ke,Te,Se){if(typeof ke.activate=="function")try{Se.activateCallStart(),W.trace(`ExtensionService#_callActivateOptional ${ee.value}`);const ve=typeof global=="object"?global:self,me=ke.activate.apply(ve,[Te]);return Se.activateCallStop(),Se.activateResolveStart(),Promise.resolve(me).then(J=>(Se.activateResolveStop(),J))}catch(ve){return Promise.reject(ve)}else return Promise.resolve(ke)}lb(W,ee){this.bb(W.identifier,{startup:!1,extensionId:W.identifier,activationEvent:ee}).then(void 0,ke=>{this.s.error(ke)})}mb(W,ee=0){const Te=Date.now();(0,L.$B)(()=>{for(let Se=ee;Se<W.length;Se+=1){const ve=W[Se];for(const me of ve.activationEvents??[])if(me==="onStartupFinished")if(Date.now()-Te>50){this.mb(W,Se);break}else this.lb(ve,me)}})}nb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(W=>{const ee=W.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ke=this.J.getAllExtensionDescriptions();if(ee)this.mb(ke);else for(const Te of ke)if(Te.activationEvents)for(const Se of Te.activationEvents)Se==="onStartupFinished"&&this.lb(Te,Se)})}ob(){const W=this.ab("*",!0).then(void 0,ve=>{this.s.error(ve)});this.B(this.j.onDidChangeWorkspace(ve=>this.pb(ve.added)));const ee=this.j.workspace?this.j.workspace.folders:[],ke=this.pb(ee),Te=this.rb(),Se=Promise.all([Te,W,ke]).then(()=>{});return Promise.race([Se,(0,A.$jh)(1e4)]).then(()=>{this.nb()}),Se}pb(W){return W.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(ee=>this.qb(W,ee))).then(()=>{})}async qb(W,ee){if(this.isActivated(ee.identifier))return;const ke=!this.f.remote.isRemote&&!!this.f.remote.authority,Te={logService:this.s,folders:W.map(ve=>ve.uri),forceUsingSearch:ke||!this.c.fsExists,exists:ve=>this.c.fsExists(ve.fsPath),checkExists:(ve,me,J)=>this.y.$checkExists(ve,me,J)},Se=await(0,C.$fvb)(Te,ee);if(Se)return this.bb(ee.identifier,{startup:!0,extensionId:ee.identifier,activationEvent:Se.activationEvent}).then(void 0,ve=>this.s.error(ve))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(W){throw console.error(W),W}}async sb(){const{extensionDevelopmentLocationURI:W,extensionTestsLocationURI:ee}=this.f.environment;if(!W||!ee)throw new Error(I.localize(0,null));const ke=await this.xb(null,ee,new b.$Ejc(!1));if(!ke||typeof ke.run!="function")throw new Error(I.localize(1,null,ee.toString()));return new Promise((Te,Se)=>{const ve=(Y,ce)=>{Y?(L.$t&&this.s.error("Test runner called back with error",Y),Se(Y)):(L.$t&&(ce?this.s.info(`Test runner called back with ${ce} failures.`):this.s.info("Test runner called back with successful outcome.")),Te(typeof ce=="number"&&ce>0?1:0))},me=(0,N.$Jg)(ee),J=ke.run(me,ve);J&&J.then&&J.then(()=>{L.$t&&this.s.info("Test runner finished successfully."),Te(0)}).catch(Y=>{L.$t&&this.s.error("Test runner finished with error",Y),Se(Y instanceof Error&&Y.stack?Y.stack:String(Y))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$jh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(W,ee){return this.S[W]=ee,(0,m.$Sc)(()=>{delete this.S[W]})}async getRemoteExecServer(W){const{resolver:ee}=await this.ub(W);return ee?.resolveExecServer?.(W,{resolveAttempt:0})}async ub(W){const ee=W.indexOf("+");if(ee===-1)throw new t.$sM("Not an authority that can be resolved!",v.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ke=W.substr(0,ee);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${ke}`,!1),{authorityPrefix:ke,resolver:this.S[ke]}}async $resolveAuthority(W,ee){const ke=M.$3d.create(!1),Te=()=>`[resolveAuthority(${(0,v.$xl)(W)},${ee})][${ke.elapsed()}ms] `,Se=j=>this.s.info(`${Te()}${j}`),ve=j=>this.s.warn(`${Te()}${j}`),me=(j,K=void 0)=>this.s.error(`${Te()}${j}`,K),J=j=>{if(j instanceof t.$sM)return{type:"error",error:{code:j._code,message:j._message,detail:j._detail}};throw j},Y=async j=>{Se(`activating resolver for ${j}...`);const{resolver:K,authorityPrefix:H}=await this.ub(j);if(!K)throw me(`no resolver for ${H}`),new t.$sM(`No remote extension installed to resolve ${H}.`,v.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:K,authorityPrefix:H,remoteAuthority:j}},ce=W.split(/@|%40/g).reverse();Se(`activating remote resolvers ${ce.join(" -> ")}`);let fe;try{fe=await Promise.all(ce.map(Y)).catch(async j=>{if(!(j instanceof t.$sM)||j._code!==v.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw j;return ve(`resolving nested authorities failed: ${j.message}`),[await Y(W)]})}catch(j){return J(j)}const Ne=new A.$th;Ne.cancelAndSet(()=>Se("waiting..."),1e3);let le,Ie;for(const[j,{authorityPrefix:K,resolver:H,remoteAuthority:_}]of fe.entries())try{if(j===fe.length-1)Se("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${K}`),le=await H.resolve(_,{resolveAttempt:ee,execServer:Ie}),P.mark(`code/extHost/didResolveAuthorityOK/${K}`),Se("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,t.$rM.isManagedResolvedAuthority(le)?le:void 0));else{if(Se(`invoking resolveExecServer() for ${_}`),P.mark(`code/extHost/willResolveExecServer/${K}`),Ie=await H.resolveExecServer?.(_,{resolveAttempt:ee,execServer:Ie}),!Ie)throw new t.$sM(`Exec server was not available for ${_}`,v.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${K}`)}}catch(re){return P.mark(`code/extHost/didResolveAuthorityError/${K}`),me("returned an error",re),Ne.dispose(),J(re)}Ne.dispose();const Ae={environmentTunnels:le.environmentTunnels,features:le.tunnelFeatures?{elevation:le.tunnelFeatures.elevation,privacyOptions:le.tunnelFeatures.privacyOptions,protocol:le.tunnelFeatures.protocol===void 0?!0:le.tunnelFeatures.protocol}:void 0},je={extensionHostEnv:le.extensionHostEnv,isTrusted:le.isTrusted,authenticationSession:le.authenticationSessionForInitializingExtensions?{id:le.authenticationSessionForInitializingExtensions.id,providerId:le.authenticationSessionForInitializingExtensions.providerId}:void 0};Se(`returned ${t.$rM.isManagedResolvedAuthority(le)?"managed authority":`${le.host}:${le.port}`}`);let z;if(t.$rM.isManagedResolvedAuthority(le)){const j=ee;this.Y.setFactory(j,le.makeConnection),z={authority:W,connectTo:new v.$ul(j),connectionToken:le.connectionToken}}else z={authority:W,connectTo:new v.$vl(le.host,le.port),connectionToken:le.connectionToken};return{type:"ok",value:{authority:z,options:je,tunnelInformation:Ae}}}async $getCanonicalURI(W,ee){this.s.info(`$getCanonicalURI invoked for authority (${(0,v.$xl)(W)})`);const{resolver:ke}=await this.ub(W);if(!ke)return null;const Te=k.URI.revive(ee);if(typeof ke.getCanonicalURI>"u")return Te;const Se=await(0,A.$ah)(()=>ke.getCanonicalURI(Te));return Se||Te}async $startExtensionHost(W){W.toAdd.forEach(ve=>ve.extensionLocation=k.URI.revive(ve.extensionLocation));const{globalRegistry:ee,myExtensions:ke}=ye(this.I,this.L,this.J,W),Te=await this.db(ke);return(await this.getExtensionPathIndex()).setSearchTree(Te),this.L.set(ee.getAllExtensionDescriptions()),this.J.set(ke),L.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ge(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ge(this.J)}`)),this.tb()}$activateByEvent(W,ee){return ee===1?this.D.wait().then(ke=>this.ab(W,!1)):this.G.wait().then(ke=>this.ab(W,!1))}async $activate(W,ee){return await this.G.wait(),this.J.getExtensionDescription(W)?(await this.bb(W,ee),!0):!1}async $deltaExtensions(W){W.toAdd.forEach(ve=>ve.extensionLocation=k.URI.revive(ve.extensionLocation));const{globalRegistry:ee,myExtensions:ke}=ye(this.I,this.L,this.J,W),Te=await this.db(ke);return(await this.getExtensionPathIndex()).setSearchTree(Te),this.L.set(ee.getAllExtensionDescriptions()),this.J.set(ke),L.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ge(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ge(this.J)}`)),Promise.resolve(void 0)}async $test_latency(W){return W}async $test_up(W){return W.byteLength}async $test_down(W){const ee=a.$ue.alloc(W),ke=Math.random()%256;for(let Te=0;Te<W;Te++)ee.writeUInt8(ke,Te);return ee}async $updateRemoteConnectionData(W){this.X=W,this.a.fire()}};e.$Zjc=he,e.$Zjc=he=ne=Je([We(0,c.$hi),We(1,e.$Yjc),We(2,p.$FO),We(3,r.$mjc),We(4,u.$pjc),We(5,F.$Oj),We(6,$.$VO),We(7,w.$sjc),We(8,D.$GBb),We(9,g.$Njc),We(10,q.$Vjc),We(11,G.$Wjc),We(12,S.$cjc)],he);function ye(de,W,ee,ke){de.addActivationEvents(ke.addActivationEvents);const Te=new s.$T0b(de,W.getAllExtensionDescriptions());Te.deltaExtensions(ke.toAdd,ke.toRemove);const Se=new i.$Em(ee.getAllExtensionDescriptions().map(me=>me.identifier));for(const me of ke.myToRemove)Se.delete(me);for(const me of ke.myToAdd)Se.add(me);const ve=te(Te,Se);return{globalRegistry:Te,myExtensions:ve}}function Re(de,W){return{id:de.identifier.value,name:de.name,extensionVersion:de.version,publisherDisplayName:de.publisher,activationEvents:de.activationEvents?de.activationEvents.join(","):null,isBuiltin:de.isBuiltin,reason:W.activationEvent,reasonId:W.extensionId.value}}function ge(de){return de.getAllExtensionDescriptions().map(W=>W.identifier.value).join(",")}e.$1jc=(0,c.$ii)("IExtHostExtensionService");class ue{#e;#t;#i;constructor(W,ee,ke,Te,Se){this.#e=W,this.#t=ee,this.#i=ke.identifier,this.id=ke.identifier.value,this.extensionUri=ke.extensionLocation,this.extensionPath=O.$ic((0,N.$Jg)(ke.extensionLocation)),this.packageJSON=ke,this.extensionKind=Te,this.isFromDifferentExtensionHost=Se}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$2jc=ue;function te(de,W){return de.getAllExtensionDescriptions().filter(ee=>W.has(ee.identifier))}class be{constructor(W){this.a=W}setSearchTree(W){this.a=W}findSubstr(W){return this.a.findSubstr(W)}forEach(W){return this.a.forEach(W)}}e.$3jc=be;class oe{constructor(W){this.a=new i.$Fm,this.addActivationEvents(W)}readActivationEvents(W){return this.a.get(W.identifier)??[]}addActivationEvents(W){for(const ee of Object.keys(W))this.a.set(ee,W[ee])}}}),define(Ce[294],Pe([1,0,89,2,4,37,22,20,17,27,3,38,13,15]),function($e,e,I,O,P,N,A,m,d,k,F,E,u,b){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$$kc=void 0;let r=class{constructor(a,h,t,v,c,$,w){this.c=a,this.d=h,this.e=t,this.f=v,this.g=c,this.h=$,this.i=w,this.a=new Map,this.b=[]}async install(){this.j(),I.mark("code/extHost/willWaitForConfig");const a=await this.f.getConfigProvider();I.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new s(this.c,h,this.d,a,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,h,this.h.environment.appUriScheme))}register(a){if("nodeModuleName"in a)if(Array.isArray(a.nodeModuleName))for(const h of a.nodeModuleName)this.a.set(h,a);else this.a.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this.b.push(h=>a.alternativeModuleName(h))}};e.$$kc=r,e.$$kc=r=Je([We(2,F.$hi),We(3,N.$pjc),We(4,E.$1jc),We(5,k.$VO),We(6,u.$Oj)],r);let o=class{static{f=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(a){if(a.environment.appRoot&&f.a.size){const h=(0,b.$Ze)(this.c(a.environment.appRoot.fsPath)),t="[a-z0-9_.-]",v=`@${t}+\\/${t}+|${t}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${c}\\/)(${v})(.*)$`,"i")}}alternativeModuleName(a){if(!this.b)return;const h=this.b.exec(this.c(a));if(!h)return;const[,t,v,c]=h,$=f.a.get(v);if($!==void 0)return console.warn(`${v} as been renamed to ${$}, please update your imports`),t+$+c}c(a){return a.replace(/\\/g,"/")}};o=f=Je([We(0,k.$VO)],o);class s{constructor(a,h,t,v,c){this.c=a,this.d=h,this.e=t,this.f=v,this.g=c,this.nodeModuleName="vscode",this.a=new m.$Fm}load(a,h){const t=this.d.findSubstr(h);if(t){let v=this.a.get(t.identifier);return v||(v=this.c(t,this.e,this.f),this.a.set(t.identifier,v)),v}if(!this.b){let v="";this.d.forEach((c,$)=>v+=`	${$} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${v}`),this.b=this.c(A.$3F,this.e,this.f)}return this.b}}let n=class{constructor(a,h,t){this.e=a,this.f=h,this.nodeModuleName=["open","opn"],this.d=t.getProxy(P.$kM.MainThreadTelemetry);const v=t.getProxy(P.$kM.MainThreadWindow);this.c=(c,$)=>{const w=O.URI.parse(c);return $?this.g(c,$):w.scheme==="http"||w.scheme==="https"?v.$openUri(w,c,{allowTunneling:!0}):w.scheme==="mailto"||w.scheme===this.f?v.$openUri(w,c,{}):this.g(c,$)}}load(a,h,t){const v=this.e.findSubstr(h);return v&&(this.a=v.identifier.value,this.h()),this.b=t(a),this.c}g(a,h){return this.i(),this.b(a,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([We(2,d.$FO)],n)}),define(Ce[119],Pe([1,0,40,6,19,73,3,67,65,38,7,36,222,37]),function($e,e,I,O,P,N,A,m,d,k,F,E,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5jc=e.$4jc=void 0,e.$4jc=(0,A.$ii)("IExtHostVariableResolverProvider");class f extends u.$HP{constructor(s,n,i,a,h,t,v){function c(){if(i){const $=i.activeEditor();if($)return $.document.uri;const w=a.tabGroups.all.find(p=>p.isActive)?.activeTab;if(w!==void 0){if(w.input instanceof F.$9N||w.input instanceof F.$bO)return w.input.modified;if(w.input instanceof F.$8N||w.input instanceof F.$aO||w.input instanceof F.$$N)return w.input.uri}}}super({getFolderUri:$=>{const w=t.folders.filter(p=>p.name===$);if(w&&w.length>0)return w[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:($,w)=>h.getConfiguration(void 0,$).get(w),getAppRoot:()=>N.cwd(),getExecPath:()=>N.env.VSCODE_EXEC_PATH,getFilePath:()=>{const $=c();if($)return P.$ic($.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const $=c();if($){const w=n.getWorkspaceFolder($);if(w)return P.$ic(w.uri.fsPath)}}},getSelectedText:()=>{if(i){const $=i.activeEditor();if($&&!$.selection.isEmpty)return $.document.getText($.selection)}},getLineNumber:()=>{if(i){const $=i.activeEditor();if($)return String($.selection.end.line+1)}},getExtension:$=>s.getExtension($)},void 0,v?Promise.resolve(v):void 0,Promise.resolve(N.env))}}let r=class extends O.$Uc{constructor(s,n,i,a,h){super(),this.b=s,this.c=n,this.g=i,this.h=a,this.j=h,this.a=new I.$V(async()=>{const t=await this.h.getConfigProvider(),c={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async $=>{c.folders=await this.c.getWorkspaceFolders2()||[]})),new f(this.b,this.c,this.g,this.j,t,c,this.m())})}getResolver(){return this.a.value}m(){}};e.$5jc=r,e.$5jc=r=Je([We(0,k.$1jc),We(1,E.$mjc),We(2,m.$QO),We(3,b.$pjc),We(4,d.$Bjc)],r)}),define(Ce[120],Pe([1,0,11,5,2,20,3,4,65,38,17,7,36,214,216,37,119,6,41,31,8]),function($e,e,I,O,P,N,A,m,d,k,F,E,u,b,f,r,o,s,n,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0jc=e.$9jc=e.$8jc=e.$7jc=e.$6jc=void 0,e.$6jc=(0,A.$ii)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(l,D,g,S,y,C,R){this.N=D,this.O=g,this.P=S,this.Q=y,this.R=C,this.S=R,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new O.$7d,this.o=new O.$7d,this.q=new O.$7d,this.w=new O.$7d,this.l=l.getProxy(m.$kM.MainThreadDebugService),this.A=new O.$7d,this.C=new O.$7d,this.y=new v(this.l),this.z=new Map,this.O.getExtensionRegistry().then(V=>{V.onDidChange(U=>{this.V(V)}),this.V(V)})}async $getVisualizerTreeItem(l,D){const g=this.W(D);if(!g)return;const S=await this.H.get(l)?.getTreeItem?.(g);return S?this.U(l,S):void 0}registerDebugVisualizationTree(l,D,g){const S=N.$Dm.toKey(l.identifier),y=this.jb(S,D);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.H.set(y,g),this.l.$registerDebugVisualizerTree(y,!!g.editItem),(0,s.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(y),this.H.delete(D)})}async $getVisualizerTreeItemChildren(l,D){const g=this.J.get(D)?.item;return g?(await this.H.get(l)?.getChildren?.(g))?.map(y=>this.U(l,y))||[]:[]}async $editVisualizerTreeItem(l,D){const g=this.J.get(l);if(!g)return;const S=await this.H.get(g.provider)?.editItem?.(g.item,D);return this.U(g.provider,S||g.item)}$disposeVisualizedTree(l){const D=this.J.get(l);if(!D)return;const g=[D.children];for(const S of g)if(S)for(const y of S)g.push(this.J.get(y)?.children),this.J.delete(y)}U(l,D){let g=this.I.get(D);return g||(g=this.F++,this.I.set(D,g),this.J.set(g,{provider:l,item:D})),a.DebugTreeItem.from(D,g)}asDebugSourceUri(l,D){const g=l;if(typeof g.sourceReference=="number"&&g.sourceReference>0){let S=`debug:${encodeURIComponent(g.path||"")}`,y="?";return D&&(S+=`${y}session=${encodeURIComponent(D.id)}`,y="&"),S+=`${y}ref=${g.sourceReference}`,P.URI.parse(S)}else{if(g.path)return P.URI.file(g.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(l){const D=[];for(const g of l.getAllExtensionDescriptions())if(g.contributes){const S=g.contributes.debuggers;if(S&&S.length>0)for(const y of S)(0,f.$IG)(y)&&D.push(y.type)}this.l.$registerDebugTypes(D)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const l=[];return this.z.forEach(D=>l.push(D)),l}async $resolveDebugVisualizer(l,D){const g=this.L.get(l);if(!g)throw new Error(`No debug visualizer found with id '${l}'`);let{v:S,provider:y,extensionId:C}=g;if(S.visualization||(S=await y.resolveDebugVisualization?.(S,D)||S,g.v=S),!S.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${y}'`);return this.kb(C,S.visualization)}async $executeDebugVisualizerCommand(l){const D=this.L.get(l);if(!D)throw new Error(`No debug visualizer found with id '${l}'`);const g=D.v.visualization;g&&"command"in g&&this.S.executeCommand(g.command,...g.arguments||[])}W(l){const D=this.m.get(l.sessionId);return D&&{session:D.api,variable:l.variable,containerId:l.containerId,frameId:l.frameId,threadId:l.threadId}}async $provideDebugVisualizers(l,D,g,S){const y=this.W(g),C=this.jb(l,D),R=this.G.get(C);if(!y||!R)return[];const V=await R.provideDebugVisualization(y,S);return V?V.map(U=>{const q=++this.M;this.L.set(q,{v:U,provider:R,extensionId:l});const M=U.iconPath?this.lb(U.iconPath):void 0;return{id:q,name:U.name,iconClass:M?.iconClass,iconPath:M?.iconPath,visualization:this.kb(l,U.visualization)}}):[]}$disposeDebugVisualizers(l){for(const D of l)this.L.delete(D)}registerDebugVisualizationProvider(l,D,g){if(!l.contributes?.debugVisualizers?.some(C=>C.id===D))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${D})`);const S=N.$Dm.toKey(l.identifier),y=this.jb(S,D);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.G.set(y,g),this.l.$registerDebugVisualizer(S,D),(0,s.$Sc)(()=>{this.l.$unregisterDebugVisualizer(S,D),this.G.delete(D)})}addBreakpoints(l){const D=l.filter(y=>{const C=y.id;return this.z.has(C)?!1:(this.z.set(C,y),!0)});this.gb(D,[],[]);const g=[],S=new Map;for(const y of D)if(y instanceof E.$nN){let C=S.get(y.location.uri.toString());C||(C={type:"sourceMulti",uri:y.location.uri,lines:[]},S.set(y.location.uri.toString(),C),g.push(C)),C.lines.push({id:y.id,enabled:y.enabled,condition:y.condition,hitCondition:y.hitCondition,logMessage:y.logMessage,line:y.location.range.start.line,character:y.location.range.start.character,mode:y.mode})}else y instanceof E.$oN&&g.push({type:"function",id:y.id,enabled:y.enabled,hitCondition:y.hitCondition,logMessage:y.logMessage,condition:y.condition,functionName:y.functionName,mode:y.mode});return this.l.$registerBreakpoints(g)}removeBreakpoints(l){const D=l.filter(C=>this.z.delete(C.id));this.gb([],D,[]);const g=D.filter(C=>C instanceof E.$nN).map(C=>C.id),S=D.filter(C=>C instanceof E.$oN).map(C=>C.id),y=D.filter(C=>C instanceof E.$pN).map(C=>C.id);return this.l.$unregisterBreakpoints(g,S,y)}startDebugging(l,D,g){return this.l.$startDebugging(l?l.uri:void 0,D,{parentSessionID:g.parentSession?g.parentSession.id:void 0,lifecycleManagedByParent:g.lifecycleManagedByParent,repl:g.consoleMode===E.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:g.noDebug,compact:g.compact,suppressSaveBeforeStart:g.suppressSaveBeforeStart,suppressDebugStatusbar:g.suppressDebugStatusbar??g.debugUI?.simple,suppressDebugToolbar:g.suppressDebugToolbar??g.debugUI?.simple,suppressDebugView:g.suppressDebugView??g.debugUI?.simple})}stopDebugging(l){return this.l.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,D,g){if(!D)return new E.$mM(()=>{});const S=this.d++;return this.f.push({type:l,handle:S,provider:D}),this.l.$registerDebugConfigurationProvider(l,g,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,S),new E.$mM(()=>{this.f=this.f.filter(y=>y.provider!==D),this.l.$unregisterDebugConfigurationProvider(S)})}registerDebugAdapterDescriptorFactory(l,D,g){if(!g)return new E.$mM(()=>{});if(!this.cb(l,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.$(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const S=this.g++;return this.h.push({type:D,handle:S,factory:g}),this.l.$registerDebugAdapterDescriptorFactory(D,S),new E.$mM(()=>{this.h=this.h.filter(y=>y.factory!==g),this.l.$unregisterDebugAdapterDescriptorFactory(S)})}registerDebugAdapterTrackerFactory(l,D){if(!D)return new E.$mM(()=>{});const g=this.j++;return this.k.push({type:l,handle:g,factory:D}),new E.$mM(()=>{this.k=this.k.filter(S=>S.factory!==D)})}async $runInTerminal(l,D){return Promise.resolve(void 0)}async $substituteVariables(l,D){let g;const S=await this.ib(l);return S&&(g={uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(g,D)}X(l,D){if(l.type==="implementation")return new $(l.implementation)}Y(){}async $startDASession(l,D){const g=this,S=await this.hb(D);return this.eb(this.$(S.type),S).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}' (extension might have failed to activate)`);const C=this.Z(y),R=this.X(C,S);if(!R)throw new Error(`Couldn't create a debug adapter for type '${S.type}'.`);const V=R;return this.D.set(l,V),this.db(S).then(U=>(U&&this.E.set(l,U),V.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const M=q,L={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const G=await this.K.sign(M.arguments.value);L.body={signature:G},V.sendResponse(L)}else throw new Error("no signer")}catch(G){L.success=!1,L.message=G.message,V.sendResponse(L)}}else U&&U.onDidSendMessage&&U.onDidSendMessage(q),q=(0,f.$NG)(q,!0),g.l.$acceptDAMessage(l,q)}),V.onError(q=>{U&&U.onError&&U.onError(q),this.l.$acceptDAError(l,q.name,q.message,q.stack)}),V.onExit(q=>{U&&U.onExit&&U.onExit(q??void 0,void 0),this.l.$acceptDAExit(l,q??void 0,void 0)}),U&&U.onWillStartSession&&U.onWillStartSession(),V.startSession()))})}$sendDAMessage(l,D){D=(0,f.$MG)(D,!1);const g=this.E.get(l);g&&g.onWillReceiveMessage&&g.onWillReceiveMessage(D),this.D.get(l)?.sendMessage(D)}$stopDASession(l){const D=this.E.get(l);this.E.delete(l),D&&D.onWillStopSession&&D.onWillStopSession();const g=this.D.get(l);return this.D.delete(l),g?g.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const D=[],g=[],S=[];if(l.added)for(const y of l.added){const C=y.id;if(C&&!this.z.has(C)){let R;if(y.type==="function")R=new E.$oN(y.functionName,y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode);else if(y.type==="data")R=new E.$pN(y.label,y.dataId,y.canPersist,y.enabled,y.hitCondition,y.condition,y.logMessage,y.mode);else{const V=P.URI.revive(y.uri);R=new E.$nN(new E.$yM(V,new E.$nM(y.line,y.character)),y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode)}(0,E.$lN)(R,C),this.z.set(C,R),D.push(R)}}if(l.removed)for(const y of l.removed){const C=this.z.get(y);C&&(this.z.delete(y),g.push(C))}if(l.changed){for(const y of l.changed)if(y.id){const C=this.z.get(y.id);if(C){if(C instanceof E.$oN&&y.type==="function"){const R=C;R.enabled=y.enabled,R.condition=y.condition,R.hitCondition=y.hitCondition,R.logMessage=y.logMessage,R.functionName=y.functionName}else if(C instanceof E.$nN&&y.type==="source"){const R=C;R.enabled=y.enabled,R.condition=y.condition,R.hitCondition=y.hitCondition,R.logMessage=y.logMessage,R.location=new E.$yM(P.URI.revive(y.uri),new E.$nM(y.line,y.character))}S.push(C)}}}this.gb(D,g,S)}async $acceptStackFrameFocus(l){let D;if(l){const g=await this.hb(l.sessionId);l.kind==="thread"?D=new E.$vN(g.api,l.threadId):D=new E.$uN(g.api,l.threadId,l.frameId)}this.B=D,this.C.fire(this.B)}$provideDebugConfigurations(l,D,g){return(0,I.$ah)(async()=>{const S=this.bb(l);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const y=await this.ib(D);return S.provideDebugConfigurations(y,g)}).then(S=>{if(!S)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return S})}$resolveDebugConfiguration(l,D,g,S){return(0,I.$ah)(async()=>{const y=this.bb(l);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.ib(D);return y.resolveDebugConfiguration(C,g,S)})}$resolveDebugConfigurationWithSubstitutedVariables(l,D,g,S){return(0,I.$ah)(async()=>{const y=this.bb(l);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.ib(D);return y.resolveDebugConfigurationWithSubstitutedVariables(C,g,S)})}async $provideDebugAdapter(l,D){const g=this.ab(l);if(!g)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const S=await this.hb(D);return this.eb(g,S).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}'`);return this.Z(y)})}async $acceptDebugSessionStarted(l){const D=await this.hb(l);this.n.fire(D.api)}async $acceptDebugSessionTerminated(l){const D=await this.hb(l);D&&(this.o.fire(D.api),this.m.delete(D.id))}async $acceptDebugSessionActiveChanged(l){this.u=l?await this.hb(l):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(l,D){(await this.hb(l))?._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(l,D){const S={session:(await this.hb(l)).api,event:D.event,body:D.body};this.w.fire(S)}Z(l){if(l instanceof E.$qN)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof E.$rN)return{type:"server",port:l.port,host:l.host};if(l instanceof E.$sN)return{type:"pipeServer",path:l.path};if(l instanceof E.$tN)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}$(l){const D=this.h.filter(g=>g.type===l);if(D.length>0)return D[0].factory}ab(l){const D=this.h.filter(g=>g.handle===l);if(D.length>0)return D[0].factory}bb(l){const D=this.f.filter(g=>g.handle===l);if(D.length>0)return D[0].provider}cb(l,D){if(l.contributes){const g=l.contributes.debuggers;if(g&&g.length>0){for(const S of g)if(S.label&&S.type&&S.type===D)return!0}}return!1}db(l){const g=l.configuration.type,S=this.k.filter(y=>y.type===g||y.type==="*").map(y=>(0,I.$ah)(()=>y.factory.createDebugAdapterTracker(l.api)).then(C=>C,C=>null));return Promise.race([Promise.all(S).then(y=>{const C=y.filter(R=>!!R);if(C.length>0)return new c(C)}),new Promise(y=>setTimeout(()=>y(void 0),1e3))]).catch(y=>{})}async eb(l,D){const g=D.configuration.debugServer;if(typeof g=="number")return Promise.resolve(new E.$rN(g));if(l){const y=await this.O.getExtensionRegistry();return(0,I.$ah)(()=>l.createDebugAdapterDescriptor(D.api,this.fb(D,y))).then(C=>{if(C)return C})}const S=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(D,S))}fb(l,D){}gb(l,D,g){(l.length>0||D.length>0||g.length>0)&&this.A.fire(Object.freeze({added:l,removed:D,changed:g}))}async hb(l){if(l)if(typeof l=="string"){const D=this.m.get(l);if(D)return D}else{let D=this.m.get(l.id);if(!D){const g=await this.ib(l.folderUri),S=l.parent?this.m.get(l.parent):void 0;D=new t(this.l,l.id,l.type,l.name,g,l.configuration,S?.api),this.m.set(D.id,D),this.l.$sessionCached(D.id)}return D}throw new Error("cannot find session")}ib(l){if(l){const D=P.URI.revive(l);return this.N.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}jb(l,D){return`${l}\0${D}`}kb(l,D){if(D){if("title"in D&&"command"in D)return{type:0};if("treeId"in D)return{type:1,id:`${l}\0${D.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(l){const D=this.mb(l);let g,S;return"id"in D?S=n.ThemeIcon.asClassName(D):g=D,{iconPath:g,iconClass:S}}mb(l){if(l instanceof E.$iN)return{id:l.id};const D=typeof l=="object"&&"dark"in l?l.dark:l,g=typeof l=="object"&&"light"in l?l.light:l;return{dark:typeof D=="string"?P.URI.file(D):D,light:typeof g=="string"?P.URI.file(g):g}}};e.$7jc=h,e.$7jc=h=Je([We(0,F.$FO),We(1,u.$mjc),We(2,k.$1jc),We(3,r.$pjc),We(4,d.$Bjc),We(5,o.$4jc),We(6,i.$2O)],h);class t{constructor(l,D,g,S,y,C,R){this.f=l,this.g=D,this.h=g,this.j=S,this.k=y,this.l=C,this.m=R}get api(){const l=this;return this.d??=Object.freeze({id:l.g,type:l.h,get name(){return l.j},set name(D){l.j=D,l.f.$setDebugSessionName(l.g,D)},parentSession:l.m,workspaceFolder:l.k,configuration:l.l,customRequest(D,g){return l.f.$customDebugAdapterRequest(l.g,D,g)},getDebugProtocolBreakpoint(D){return l.f.$getDebugProtocolBreakpoint(l.g,D.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(l){this.j=l}get configuration(){return this.l}}e.$8jc=t;class v{constructor(l){this.value=Object.freeze({append(D){l.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.$9jc=v;class c{constructor(l){this.d=l}onWillStartSession(){this.d.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.d.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.d.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(l):void 0)}onWillStopSession(){this.d.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.d.forEach(D=>D.onError?D.onError(l):void 0)}onExit(l,D){this.d.forEach(g=>g.onExit?g.onExit(l,D):void 0)}}class $ extends b.$mob{constructor(l){super(),this.h=l,l.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.h.handleMessage(l)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let w=class extends h{constructor(l,D,g,S,y,C,R){super(l,D,g,S,y,C,R)}};e.$0jc=w,e.$0jc=w=Je([We(0,F.$FO),We(1,u.$mjc),We(2,k.$1jc),We(3,r.$pjc),We(4,d.$Bjc),We(5,o.$4jc),We(6,i.$2O)],w)}),define(Ce[295],Pe([1,0,14,89,2,4,243,13,54,71,27,190,17,59,38,61]),function($e,e,I,O,P,N,A,m,d,k,F,E,u,b,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$alc=e.$_kc=void 0;class o{static async installEarlyHandler(i){Error.stackTraceLimit=100;const a=i.get(m.$Oj),t=i.get(u.$FO).getProxy(N.$kM.MainThreadErrors);I.setUnexpectedErrorHandler(v=>{a.error(v);const c=I.$3(v);t.$onUnexpectedError(c)})}static async installFullHandler(i){const a=i.get(m.$Oj),h=i.get(u.$FO),t=i.get(f.$1jc),v=i.get(r.$ZO),c=h.getProxy(N.$kM.MainThreadExtensionService),$=h.getProxy(N.$kM.MainThreadErrors),w=await t.getExtensionPathIndex(),p=new WeakMap;function l(S,y){if(p.has(S))return p.get(S).stack;let C="",R,V;for(const q of y)C+=`
	at ${q.toString()}`,V=q.getFileName(),!R&&V&&(R=w.findSubstr(P.URI.file(V)));const U=`${S.name||"Error"}: ${S.message||""}${C}`;return p.set(S,{extensionIdentifier:R?.identifier,stack:U}),U}const D=Symbol("prepareStackTrace wrapped");let g=l;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return g},set(S){if(S===l||!S||S[D]){g=S||l;return}g=function(y,C){return l(y,C),S.call(Error,y,C)},Object.assign(g,{[D]:!0})}}),I.setUnexpectedErrorHandler(S=>{a.error(S);const y=I.$3(S),C=p.get(S);if(!C?.extensionIdentifier){$.$onUnexpectedError(y);return}c.$onExtensionRuntimeError(C.extensionIdentifier,y);const R=v.onExtensionError(C.extensionIdentifier,S);a.trace("forwarded error to extension?",R,C)})}}e.$_kc=o;class s{constructor(i,a,h,t,v){this.a=h,this.b=new A.$20b(i,null,t),a=s.e(a,this.b);const c=new k.$gi(...(0,d.$hs)());c.set(F.$VO,{_serviceBrand:void 0,...a,messagePorts:v}),c.set(u.$FO,new u.$GO(this.b)),c.set(b.$jjc,new b.$kjc(t)),c.set(f.$Yjc,h);const $=new E.$Yq(c,!0);$.invokeFunction(o.installEarlyHandler),this.d=$.invokeFunction(w=>w.get(m.$Oj)),O.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",a),this.c=$.invokeFunction(w=>w.get(f.$1jc)),this.c.initialize(),$.invokeFunction(o.installFullHandler)}async asBrowserUri(i){const a=this.b.getProxy(N.$kM.MainThreadExtensionService);return P.URI.revive(await a.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,a){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=P.URI.revive(a.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=P.URI.revive(a.transformIncomingURIs(i.environment.appRoot));const h=i.environment.extensionDevelopmentLocationURI;return h&&(i.environment.extensionDevelopmentLocationURI=h.map(t=>P.URI.revive(a.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=P.URI.revive(a.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=P.URI.revive(a.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=P.URI.revive(a.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=P.URI.revive(a.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=P.URI.revive(a.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=P.URI.revive(a.transformIncomingURIs(i.logsLocation)),i.workspace=a.transformIncomingURIs(i.workspace),i}}e.$alc=s}),define(Ce[296],Pe([1,0,18,11,25,42,12,19,24,2,45]),function($e,e,I,O,P,N,A,m,d,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$okc=e.$mkc=e.$lkc=void 0,e.$nkc=r;class E{constructor(n,i,a){this.d=n,this.e=i,this.f=a,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,i){const a=this.g.folderQueries||[],h=new P.$ee(i);return new Promise((t,v)=>{this.a=new b(n);let c=!1;const $=(w,p)=>{if(!c&&!this.b){const l=this.h(w);r(w)&&typeof this.g.maxResults=="number"&&this.c+l>this.g.maxResults&&(this.b=!0,c=!0,h.cancel(),w=this.j(w,this.g.maxResults-this.c));const D=this.h(w);this.c+=D,(D>0||!r(w))&&this.a.add(w,p)}};Promise.all(a.map((w,p)=>this.k(w,l=>$(l,p),h.token))).then(w=>{h.dispose(),this.a.flush();const p=w.some(l=>!!l&&!!l.limitHit);t({limitHit:this.b||p,messages:(0,I.$Rb)(w.map(l=>l?.message?Array.isArray(l.message)?l.message:[l.message]:[])),stats:{type:this.f}})},w=>{h.dispose();const p=(0,N.$6i)(w);v(new Error(p))})})}h(n){return r(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,i){const a=Array.isArray(n.ranges)?n.ranges:[n.ranges],h=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:a.slice(0,i),preview:{matches:h.slice(0,i),text:n.preview.text},uri:n.uri}}async k(n,i,a){const h=new F.$RK(this.g,n),t=[],v={report:w=>{if(!this.l(w))return;const p=n.folder.scheme===A.Schemas.file?(0,F.$SK)(()=>this.e.readdir(d.$Ug(w.uri))):void 0,l=d.$Xg(n.folder,w.uri);if(l){const D=h.includedInQuery(l,m.$oc(l),p);(0,O.$7g)(D)?t.push(D.then(g=>{g&&i(w)})):D&&i(w)}}},c=this.n(n);let $;return this.d.query.type===3?$=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,c,v,a):$=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),c,v,a),t.length&&await Promise.all(t),$}l(n){if(r(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const i=(0,F.$QK)(this.g.includePattern,n.includePattern),a=(0,F.$QK)(this.g.excludePattern,n.excludePattern),h={folder:k.URI.from(n.folder),excludes:a,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(h.usePCRE2=this.g.usePCRE2),h}}e.$lkc=E;function u(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class b{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new o(512,i=>this.g(i))}add(n,i){this.d&&(this.b!==i||!d.$Og(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:n.uri,results:[]}),this.d.results.push(f(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$mkc=b;function f(s){return r(s)?{preview:{matches:(0,I.$2b)(s.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:s.preview.text},ranges:(0,I.$2b)(s.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function r(s){return!!s.preview}class o{static{this.a=4e3}static{this.b=50}constructor(n,i){this.g=n,this.h=i,this.c=0,this.d=[],this.e=0}addItem(n,i){n&&this.j(n,i)}addItems(n,i){n&&this.k(n,i)}j(n,i){this.d.push(n),this.e+=i,this.l()}k(n,i){this.d=this.d.concat(n),this.e+=i,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$okc=o}),define(Ce[121],Pe([1,0,6,4,3,291,17,59,13,2,296]),function($e,e,I,O,P,N,A,m,d,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qkc=e.$pkc=void 0,e.$rkc=u,e.$pkc=(0,P.$ii)("IExtHostSearch");let E=class{constructor(r,o,s){this.n=r,this.o=o,this.q=s,this.c=this.n.getProxy(O.$kM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new N.$kkc}s(r){return this.o.transformOutgoingScheme(r)}registerTextSearchProvider(r,o){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const s=this.d++;return this.e.set(s,o),this.c.$registerTextSearchProvider(s,this.s(r)),(0,I.$Sc)(()=>{this.g.delete(r),this.e.delete(s),this.c.$unregisterProvider(s)})}registerAITextSearchProvider(r,o){if(this.i.has(r))throw new Error(`an AI text search provider for the scheme '${r}'is already registered`);this.i.add(r);const s=this.d++;return this.h.set(s,o),this.c.$registerAITextSearchProvider(s,this.s(r)),(0,I.$Sc)(()=>{this.i.delete(r),this.h.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(r,o){if(this.k.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.k.add(r);const s=this.d++;return this.j.set(s,o),this.c.$registerFileSearchProvider(s,this.s(r)),(0,I.$Sc)(()=>{this.k.delete(r),this.j.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(r,o,s,n){const i=u(s),a=this.j.get(r);if(a)return this.l.fileSearch(i,a,h=>{this.c.$handleFileMatch(r,o,h.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,o,s){return{messages:[]}}$clearCache(r){return this.l.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,o,s,n){const i=this.e.get(r);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${r}`);const a=u(s);return this.t(a,i).search(t=>this.c.$handleTextMatch(r,o,t),n)}$provideAITextSearchResults(r,o,s,n){const i=this.h.get(r);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${r}`);const a=u(s);return this.v(a,i).search(t=>this.c.$handleTextMatch(r,o,t),n)}$enableExtensionHostSearch(){}t(r,o){return new F.$lkc({query:r,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}v(r,o){return new F.$lkc({query:r,provider:o},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"aiTextSearchProvider")}};e.$qkc=E,e.$qkc=E=Je([We(0,A.$FO),We(1,m.$jjc),We(2,d.$Oj)],E);function u(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(b),extraFileResources:f.extraFileResources&&f.extraFileResources.map(r=>k.URI.revive(r))}}function b(f){return{...f,folder:k.URI.revive(f.folder)}}}),define(Ce[297],Pe([1,0,25,14,5,6,12,32,2,150,146,134,94,20,43,13,57,58,203,4,246,275,78,84,252,231,253,88,254,232,220,31,255,37,256,120,110,257,234,247,258,259,67,65,248,38,261,63,262,44,27,276,277,249,235,263,264,79,80,237,290,266,207,267,278,268,115,238,269,270,271,17,272,121,81,273,239,274,82,85,118,61,66,279,280,250,281,282,86,8,7,240,59,241,62,283,284,109,36,215,77,22,117]),function($e,e,I,O,P,N,A,m,d,k,F,E,u,b,f,r,o,s,n,i,a,h,t,v,c,$,w,p,l,D,g,S,y,C,R,V,U,q,M,L,G,ne,he,ye,Re,ge,ue,te,be,oe,de,W,ee,ke,Te,Se,ve,me,J,Y,ce,fe,Ne,le,Ie,Ae,je,z,j,K,H,_,re,Fe,Ve,Qe,xe,tt,at,it,nt,ct,ft,Ue,ot,X,Z,pe,qe,Ze,Me,dt,Pt,zt,xt,Jt,_t,Et,Qt,Vt,ai,Ye,ei){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7kc=ti;function ti(ht){const vt=ht.get(de.$VO),si=ht.get(oe.$4ic),ii=ht.get(te.$rjc),Ft=ht.get(ge.$1jc),mt=ht.get(Qt.$mjc),Mt=ht.get(ct.$ZO),Wt=ht.get(C.$pjc),Zt=ht.get(Pt.$jjc),Ke=ht.get(_.$FO),Xt=ht.get(at.$Kjc),jt=ht.get(it.$sjc),Ut=ht.get(r.$Pj),$t=ht.get(r.$Oj),Tt=ht.get(qe.$GBb),Rt=ht.get(t.$Zic),Lt=ht.get(Et.$6kc),ni=ht.get(Ve.$Sjc),oi=ht.get(ye.$Bjc),qt=ht.get(J.$Wjc),It=ht.get(v.$0ic),Dt=ht.get(p.$cjc);Ke.set(i.$lM.ExtHostFileSystemInfo,si),Ke.set(i.$lM.ExtHostLogLevelServiceShape,Ut),Ke.set(i.$lM.ExtHostWorkspace,mt),Ke.set(i.$lM.ExtHostConfiguration,Wt),Ke.set(i.$lM.ExtHostExtensionService,Ft),Ke.set(i.$lM.ExtHostStorage,Xt),Ke.set(i.$lM.ExtHostTunnelService,Tt),Ke.set(i.$lM.ExtHostWindow,Lt),Ke.set(i.$lM.ExtHostSecretState,ni),Ke.set(i.$lM.ExtHostTelemetry,Mt),Ke.set(i.$lM.ExtHostEditorTabs,oi),Ke.set(i.$lM.ExtHostManagedSockets,qt),Ke.set(i.$lM.ExtHostAuthentication,It),Ke.set(i.$lM.ExtHostChatProvider,Dt);const Ht=Ke.set(i.$lM.ExtHostDecorations,ht.get(U.$_jc)),Ct=Ke.set(i.$lM.ExtHostDocumentsAndEditors,ht.get(he.$QO)),wt=Ke.set(i.$lM.ExtHostCommands,ht.get(S.$2O)),St=Ke.set(i.$lM.ExtHostTerminalService,ht.get(ft.$Njc)),kt=Ke.set(i.$lM.ExtHostDebugService,ht.get(V.$6jc)),ui=Ke.set(i.$lM.ExtHostSearch,ht.get(Fe.$pkc)),ri=Ke.set(i.$lM.ExtHostTask,ht.get(nt.$Skc)),li=Ke.set(i.$lM.ExtHostOutputService,ht.get(je.$Fkc)),di=Ke.set(i.$lM.ExtHostLocalization,ht.get(me.$Vjc)),Yt=Ke.set(i.$lM.ExtHostUrls,new zt.$3kc(Ke)),At=Ke.set(i.$lM.ExtHostDocuments,new ne.$7ic(Ke,Ct)),we=Ke.set(i.$lM.ExtHostDocumentContentProviders,new L.$bkc(Ke,Ct,$t)),Oe=Ke.set(i.$lM.ExtHostDocumentSaveParticipant,new G.$ckc($t,At,Ke.getProxy(i.$kM.MainThreadBulkEdits))),se=Ke.set(i.$lM.ExtHostNotebook,new ce.$skc(Ke,wt,Ct,At,ii,ui)),Q=Ke.set(i.$lM.ExtHostNotebookDocuments,new Ne.$zkc(se)),Ee=Ke.set(i.$lM.ExtHostNotebookEditors,new le.$Akc($t,se)),Be=Ke.set(i.$lM.ExtHostNotebookKernels,new Ie.$Bkc(Ke,vt,se,wt,$t)),Xe=Ke.set(i.$lM.ExtHostNotebookRenderers,new Ae.$Dkc(Ke,se)),He=Ke.set(i.$lM.ExtHostNotebookDocumentSaveParticipant,new fe.$ykc($t,se,Ke.getProxy(i.$kM.MainThreadBulkEdits))),rt=Ke.set(i.$lM.ExtHostEditors,new ot.$gjc(Ke,Ct)),yt=Ke.set(i.$lM.ExtHostTreeViews,new pe.$1kc(Ke.getProxy(i.$kM.MainThreadTreeViews),wt,$t)),Kt=Ke.set(i.$lM.ExtHostEditorInsets,new g.$hjc(Ke.getProxy(i.$kM.MainThreadEditorInsets),rt,vt.remote)),Bt=Ke.set(i.$lM.ExtHostDiagnostics,new q.$6ic(Ke,$t,si,Ct)),Ot=Ke.set(i.$lM.ExtHostLanguages,new ve.$wkc(Ke,At,wt.converter,Zt)),ut=Ke.set(i.$lM.ExtHostLanguageFeatures,new Se.$8ic(Ke,Zt,At,wt,Bt,$t,Rt,Mt)),Ci=Ke.set(i.$lM.ExtHostFileSystem,new ue.$ekc(Ke,ut)),gi=Ke.set(i.$lM.ExtHostFileSystemEventService,new be.$fkc(Ke,$t,Ct)),$i=Ke.set(i.$lM.ExtHostQuickOpen,(0,H.$Jkc)(Ke,mt,wt)),wi=Ke.set(i.$lM.ExtHostSCM,new re.$Lkc(Ke,wt,At,$t)),Pi=Ke.set(i.$lM.ExtHostQuickDiff,new K.$Ikc(Ke,Zt)),Mi=Ke.set(i.$lM.ExtHostShare,new Qe.$Mkc(Ke,Zt)),Vi=Ke.set(i.$lM.ExtHostComments,(0,y.$ijc)(Ke,wt,At)),Wi=Ke.set(i.$lM.ExtHostProgress,new j.$Hkc(Ke.getProxy(i.$kM.MainThreadProgress))),qi=Ke.set(i.$lM.ExtHostLabelService,new Te.$vkc(Ke)),yi=Ke.set(i.$lM.ExtHostTheming,new X.$Xkc(Ke)),Ri=Ke.set(i.$lM.ExtHostTimeline,new Z.$Zkc(Ke,wt)),ki=Ke.set(i.$lM.ExtHostWebviews,new xt.$wjc(Ke,vt.remote,mt,$t,Rt)),Ei=Ke.set(i.$lM.ExtHostWebviewPanels,new Jt.$zjc(Ke,ki,mt)),Hi=Ke.set(i.$lM.ExtHostCustomEditors,new R.$Ajc(Ke,At,jt,ki,Ei)),Ki=Ke.set(i.$lM.ExtHostWebviewViews,new _t.$4kc(Ke,ki)),vi=Ke.set(i.$lM.ExtHostTesting,new Ue.$Tkc(Ke,$t,wt,Ct)),Gi=Ke.set(i.$lM.ExtHostUriOpeners,new dt.$2kc(Ke)),gn=Ke.set(i.$lM.ExtHostProfileContentHandlers,new z.$Gkc(Ke));Ke.set(i.$lM.ExtHostInteractive,new ee.$tkc(Ke,se,Ct,wt,$t));const mn=Ke.set(i.$lM.ExtHostInlineChat,new W.$gkc(Ke,wt,At,$t)),Ai=Ke.set(i.$lM.ExtHostChatAgents2,new w.$bjc(Ke,$t,wt)),Oi=Ke.set(i.$lM.ExtHostChatVariables,new l.$ejc(Ke)),Ji=Ke.set(i.$lM.ExtHostChat,new $.$ajc(Ke)),Qi=Ke.set(i.$lM.ExtHostAiRelatedInformation,new a.$Yic(Ke)),Zi=Ke.set(i.$lM.ExtHostAiEmbeddingVector,new Re.$dkc(Ke)),Xi=Ke.set(i.$lM.ExtHostIssueReporter,new ke.$ukc(Ke)),Di=Ke.set(i.$lM.ExtHostStatusBar,new tt.$Pkc(Ke,wt.converter)),Yi=Ke.set(i.$lM.ExtHostSpeech,new xe.$Nkc(Ke)),xi=Object.values(i.$lM);Ke.assertRegistered(xi);const _i=new c.$_ic(Ke,Ct),$n=new D.$fjc(Ke),bi=new Y.$xkc(Ke,$t),Fi=new M.$akc(Ke);return h.$9ic.register(wt),function(Le,ci,en){function et(x){return(ae,ze,st)=>{const bt=x(Nt=>{try{ae.call(ze,Nt)}catch(zi){O.$2(new Error(`[ExtensionListenerError] Extension '${Le.identifier.value}' FAILED to handle event: ${zi.toString()}`,{cause:zi})),Mt.onExtensionError(Le.identifier,zi)}});return st?.push(bt),bt}}const pt=function(){let x=!Le.isUnderDevelopment;function ae(){x||($t.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),x=!0)}return function ze(st){if(Array.isArray(st))st.forEach(ze);else if(typeof st=="string")ae();else{const bt=st;typeof bt.scheme>"u"&&ae(),typeof bt.exclusive=="boolean"&&(0,Ye.$9F)(Le,"documentFiltersExclusive")}return st}}(),tn={getSession(x,ae,ze){return typeof ze?.forceNewSession=="object"&&ze.forceNewSession.learnMore&&(0,Ye.$9F)(Le,"authLearnMore"),It.getSession(Le,x,ae,ze)},getSessions(x,ae){return(0,Ye.$9F)(Le,"authGetSessions"),It.getSessions(Le,x,ae)},async hasSession(x,ae){return(0,Ye.$9F)(Le,"authSession"),!!await It.getSession(Le,x,ae,{silent:!0})},get onDidChangeSessions(){return et(It.onDidChangeSessions)},registerAuthenticationProvider(x,ae,ze,st){return It.registerAuthenticationProvider(x,ae,ze,st)}},nn={registerCommand(x,ae,ze){return wt.registerCommand(!0,x,ae,ze,void 0,Le)},registerTextEditorCommand(x,ae,ze){return wt.registerCommand(!0,x,(...st)=>{const bt=rt.getActiveTextEditor();if(!bt){$t.warn("Cannot execute "+x+" because there is no active text editor.");return}return bt.edit(Nt=>{ae.apply(ze,[bt,Nt,...st])}).then(Nt=>{Nt||$t.warn("Edits from command "+x+" were not applied.")},Nt=>{$t.warn("An error occurred while running command "+x,Nt)})},void 0,void 0,Le)},registerDiffInformationCommand:(x,ae,ze)=>((0,Ye.$9F)(Le,"diffCommand"),wt.registerCommand(!0,x,async(...st)=>{const bt=Ct.activeEditor(!0);if(!bt){$t.warn("Cannot execute "+x+" because there is no active text editor.");return}const Nt=await rt.getDiffInformation(bt.id);ae.apply(ze,[Nt,...st])},void 0,void 0,Le)),executeCommand(x,...ae){return wt.executeCommand(x,...ae)},getCommands(x=!1){return wt.getCommands(x)}},Ni={get machineId(){return vt.telemetryInfo.machineId},get sessionId(){return vt.telemetryInfo.sessionId},get language(){return vt.environment.appLanguage},get appName(){return vt.environment.appName},get appRoot(){return vt.environment.appRoot?.fsPath??""},get appHost(){return vt.environment.appHost},get uriScheme(){return vt.environment.appUriScheme},get clipboard(){return $n.value},get shell(){return St.getDefaultShell(!1)},get onDidChangeShell(){return et(St.onDidChangeShell)},get isTelemetryEnabled(){return Mt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return et(Mt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ye.$9F)(Le,"telemetry"),Mt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.$9F)(Le,"telemetry"),et(Mt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,ct.$YO)(vt.telemetryInfo.firstSessionDate)},createTelemetryLogger(x,ae){return ct.$XO.validateSender(x),Mt.instantiateLogger(Le,x,ae)},openExternal(x,ae){return Lt.openUri(x,{allowTunneling:!!vt.remote.authority,allowContributedOpeners:ae?.allowContributedOpeners})},async asExternalUri(x){if(x.scheme===vt.environment.appUriScheme)return Yt.createAppUri(x);try{return await Lt.asExternalUri(x,{allowTunneling:!!vt.remote.authority})}catch(ae){if((0,A.$rg)(x,A.Schemas.http)||(0,A.$rg)(x,A.Schemas.https))return x;throw ae}},get remoteName(){return(0,o.$um)(vt.remote.authority)},get remoteAuthority(){return(0,Ye.$9F)(Le,"resolvers"),vt.remote.authority},get uiKind(){return vt.uiKind},get logLevel(){return $t.getLevel()},get onDidChangeLogLevel(){return et($t.onDidChangeLogLevel)},registerIssueUriRequestHandler(x){return(0,Ye.$9F)(Le,"handleIssueUri"),Xi.registerIssueUriRequestHandler(Le,x)},registerIssueDataProvider(x){return(0,Ye.$9F)(Le,"handleIssueUri"),Xi.registerIssueDataProvider(Le,x)},get appQuality(){return(0,Ye.$9F)(Le,"resolvers"),vt.quality},get appCommit(){return(0,Ye.$9F)(Le,"resolvers"),vt.commit}};vt.environment.extensionTestsLocationURI||Object.freeze(Ni);const rn={createTestController(x,ae,ze){return vi.createTestController(Le,x,ae,ze)},createTestObserver(){return(0,Ye.$9F)(Le,"testObserver"),vi.createTestObserver()},runTests(x){return(0,Ye.$9F)(Le,"testObserver"),vi.runTests(x)},get onDidChangeTestResults(){return(0,Ye.$9F)(Le,"testObserver"),et(vi.onResultsChanged)},get testResults(){return(0,Ye.$9F)(Le,"testObserver"),vi.results}},Si=vt.remote.isRemote?Me.ExtensionKind.Workspace:Me.ExtensionKind.UI,sn={getExtension(x,ae){(0,Ye.$8F)(Le,"extensionsAny")||(ae=!1);const ze=ci.mine.getExtensionDescription(x);if(ze)return new ge.$2jc(Ft,Le.identifier,ze,Si,!1);if(ae){const st=ci.all.getExtensionDescription(x);if(st)return new ge.$2jc(Ft,Le.identifier,st,Si,!0)}},get all(){const x=[];for(const ae of ci.mine.getAllExtensionDescriptions())x.push(new ge.$2jc(Ft,Le.identifier,ae,Si,!1));return x},get allAcrossExtensionHosts(){(0,Ye.$9F)(Le,"extensionsAny");const x=new b.$Em(ci.mine.getAllExtensionDescriptions().map(ze=>ze.identifier)),ae=[];for(const ze of ci.all.getAllExtensionDescriptions()){const st=!x.has(ze.identifier);ae.push(new ge.$2jc(Ft,Le.identifier,ze,Si,st))}return ae},get onDidChange(){return(0,Ye.$8F)(Le,"extensionsAny")?et(P.Event.any(ci.mine.onDidChange,ci.all.onDidChange)):et(ci.mine.onDidChange)}},on={createDiagnosticCollection(x){return Bt.createDiagnosticCollection(Le.identifier,x)},get onDidChangeDiagnostics(){return et(Bt.onDidChangeDiagnostics)},getDiagnostics:x=>Bt.getDiagnostics(x),getLanguages(){return Ot.getLanguages()},setTextDocumentLanguage(x,ae){return Ot.changeLanguage(x.uri,ae)},match(x,ae){const ze=Ze.LanguageSelector.from(x);let st;return(0,F.$Wt)(ze)&&(st=se.notebookDocuments.find(bt=>bt.apiNotebook.getCells().find(Nt=>Nt.document===ae))?.apiNotebook),(0,F.$Vt)(ze,ae.uri,ae.languageId,!0,st?.uri,st?.notebookType)},registerCodeActionsProvider(x,ae,ze){return ut.registerCodeActionProvider(Le,pt(x),ae,ze)},registerDocumentPasteEditProvider(x,ae,ze){return(0,Ye.$9F)(Le,"documentPaste"),ut.registerDocumentPasteEditProvider(Le,pt(x),ae,ze)},registerCodeLensProvider(x,ae){return ut.registerCodeLensProvider(Le,pt(x),ae)},registerDefinitionProvider(x,ae){return ut.registerDefinitionProvider(Le,pt(x),ae)},registerDeclarationProvider(x,ae){return ut.registerDeclarationProvider(Le,pt(x),ae)},registerImplementationProvider(x,ae){return ut.registerImplementationProvider(Le,pt(x),ae)},registerTypeDefinitionProvider(x,ae){return ut.registerTypeDefinitionProvider(Le,pt(x),ae)},registerHoverProvider(x,ae){return ut.registerHoverProvider(Le,pt(x),ae,Le.identifier)},registerEvaluatableExpressionProvider(x,ae){return ut.registerEvaluatableExpressionProvider(Le,pt(x),ae,Le.identifier)},registerInlineValuesProvider(x,ae){return ut.registerInlineValuesProvider(Le,pt(x),ae,Le.identifier)},registerDocumentHighlightProvider(x,ae){return ut.registerDocumentHighlightProvider(Le,pt(x),ae)},registerMultiDocumentHighlightProvider(x,ae){return ut.registerMultiDocumentHighlightProvider(Le,pt(x),ae)},registerLinkedEditingRangeProvider(x,ae){return ut.registerLinkedEditingRangeProvider(Le,pt(x),ae)},registerReferenceProvider(x,ae){return ut.registerReferenceProvider(Le,pt(x),ae)},registerRenameProvider(x,ae){return ut.registerRenameProvider(Le,pt(x),ae)},registerNewSymbolNamesProvider(x,ae){return(0,Ye.$9F)(Le,"newSymbolNamesProvider"),ut.registerNewSymbolNamesProvider(Le,pt(x),ae)},registerDocumentSymbolProvider(x,ae,ze){return ut.registerDocumentSymbolProvider(Le,pt(x),ae,ze)},registerWorkspaceSymbolProvider(x){return ut.registerWorkspaceSymbolProvider(Le,x)},registerDocumentFormattingEditProvider(x,ae){return ut.registerDocumentFormattingEditProvider(Le,pt(x),ae)},registerDocumentRangeFormattingEditProvider(x,ae){return ut.registerDocumentRangeFormattingEditProvider(Le,pt(x),ae)},registerOnTypeFormattingEditProvider(x,ae,ze,...st){return ut.registerOnTypeFormattingEditProvider(Le,pt(x),ae,[ze].concat(st))},registerDocumentSemanticTokensProvider(x,ae,ze){return ut.registerDocumentSemanticTokensProvider(Le,pt(x),ae,ze)},registerDocumentRangeSemanticTokensProvider(x,ae,ze){return ut.registerDocumentRangeSemanticTokensProvider(Le,pt(x),ae,ze)},registerSignatureHelpProvider(x,ae,ze,...st){return typeof ze=="object"?ut.registerSignatureHelpProvider(Le,pt(x),ae,ze):ut.registerSignatureHelpProvider(Le,pt(x),ae,typeof ze>"u"?[]:[ze,...st])},registerCompletionItemProvider(x,ae,...ze){return ut.registerCompletionItemProvider(Le,pt(x),ae,ze)},registerInlineCompletionItemProvider(x,ae,ze){return ae.handleDidShowCompletionItem&&(0,Ye.$9F)(Le,"inlineCompletionsAdditions"),ae.handleDidPartiallyAcceptCompletionItem&&(0,Ye.$9F)(Le,"inlineCompletionsAdditions"),ze&&(0,Ye.$9F)(Le,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Le,pt(x),ae,ze)},registerInlineEditProvider(x,ae){return(0,Ye.$9F)(Le,"inlineEdit"),ut.registerInlineEditProvider(Le,pt(x),ae)},registerDocumentLinkProvider(x,ae){return ut.registerDocumentLinkProvider(Le,pt(x),ae)},registerColorProvider(x,ae){return ut.registerColorProvider(Le,pt(x),ae)},registerFoldingRangeProvider(x,ae){return ut.registerFoldingRangeProvider(Le,pt(x),ae)},registerSelectionRangeProvider(x,ae){return ut.registerSelectionRangeProvider(Le,x,ae)},registerCallHierarchyProvider(x,ae){return ut.registerCallHierarchyProvider(Le,x,ae)},registerTypeHierarchyProvider(x,ae){return ut.registerTypeHierarchyProvider(Le,x,ae)},setLanguageConfiguration:(x,ae)=>ut.setLanguageConfiguration(Le,x,ae),getTokenInformationAtPosition(x,ae){return(0,Ye.$9F)(Le,"tokenInformation"),Ot.tokenAtPosition(x,ae)},registerInlayHintsProvider(x,ae){return ut.registerInlayHintsProvider(Le,x,ae)},createLanguageStatusItem(x,ae){return Ot.createLanguageStatusItem(Le,x,ae)},registerDocumentDropEditProvider(x,ae,ze){return ut.registerDocumentOnDropEditProvider(Le,x,ae,(0,Ye.$8F)(Le,"dropMetadata")?ze:void 0)}},pn={get activeTextEditor(){return rt.getActiveTextEditor()},get visibleTextEditors(){return rt.getVisibleTextEditors()},get activeTerminal(){return St.activeTerminal},get terminals(){return St.terminals},async showTextDocument(x,ae,ze){d.URI.isUri(x)&&x.scheme===A.Schemas.vscodeRemote&&!x.authority&&Rt.report("workspace.showTextDocument",Le,"A URI of 'vscode-remote' scheme requires an authority.");const st=await(d.URI.isUri(x)?Promise.resolve(an.openTextDocument(x)):Promise.resolve(x));return rt.showTextDocument(st,ae,ze)},createTextEditorDecorationType(x){return rt.createTextEditorDecorationType(Le,x)},onDidChangeActiveTextEditor(x,ae,ze){return et(rt.onDidChangeActiveTextEditor)(x,ae,ze)},onDidChangeVisibleTextEditors(x,ae,ze){return et(rt.onDidChangeVisibleTextEditors)(x,ae,ze)},onDidChangeTextEditorSelection(x,ae,ze){return et(rt.onDidChangeTextEditorSelection)(x,ae,ze)},onDidChangeTextEditorOptions(x,ae,ze){return et(rt.onDidChangeTextEditorOptions)(x,ae,ze)},onDidChangeTextEditorVisibleRanges(x,ae,ze){return et(rt.onDidChangeTextEditorVisibleRanges)(x,ae,ze)},onDidChangeTextEditorViewColumn(x,ae,ze){return et(rt.onDidChangeTextEditorViewColumn)(x,ae,ze)},onDidCloseTerminal(x,ae,ze){return et(St.onDidCloseTerminal)(x,ae,ze)},onDidOpenTerminal(x,ae,ze){return et(St.onDidOpenTerminal)(x,ae,ze)},onDidChangeActiveTerminal(x,ae,ze){return et(St.onDidChangeActiveTerminal)(x,ae,ze)},onDidChangeTerminalDimensions(x,ae,ze){return(0,Ye.$9F)(Le,"terminalDimensions"),et(St.onDidChangeTerminalDimensions)(x,ae,ze)},onDidChangeTerminalState(x,ae,ze){return et(St.onDidChangeTerminalState)(x,ae,ze)},onDidWriteTerminalData(x,ae,ze){return(0,Ye.$9F)(Le,"terminalDataWriteEvent"),et(St.onDidWriteTerminalData)(x,ae,ze)},onDidExecuteTerminalCommand(x,ae,ze){return(0,Ye.$9F)(Le,"terminalExecuteCommandEvent"),et(St.onDidExecuteTerminalCommand)(x,ae,ze)},get state(){return Lt.getState(Le)},onDidChangeWindowState(x,ae,ze){return et(Lt.onDidChangeWindowState)(x,ae,ze)},showInformationMessage(x,...ae){return bi.showMessage(Le,m.default.Info,x,ae[0],ae.slice(1))},showWarningMessage(x,...ae){return bi.showMessage(Le,m.default.Warning,x,ae[0],ae.slice(1))},showErrorMessage(x,...ae){return bi.showMessage(Le,m.default.Error,x,ae[0],ae.slice(1))},showQuickPick(x,ae,ze){return $i.showQuickPick(Le,x,ae,ze)},showWorkspaceFolderPick(x){return $i.showWorkspaceFolderPick(x)},showInputBox(x,ae){return $i.showInput(x,ae)},showOpenDialog(x){return Fi.showOpenDialog(Le,x)},showSaveDialog(x){return Fi.showSaveDialog(x)},createStatusBarItem(x,ae,ze){let st,bt,Nt;return typeof x=="string"?(st=x,bt=ae,Nt=ze):(bt=x,Nt=ae),Di.createStatusBarEntry(Le,st,bt,Nt)},setStatusBarMessage(x,ae){return Di.setStatusBarMessage(x,ae)},withScmProgress(x){return Rt.report("window.withScmProgress",Le,"Use 'withProgress' instead."),Wi.withProgress(Le,{location:Me.ProgressLocation.SourceControl},(ae,ze)=>x({report(st){}}))},withProgress(x,ae){return Wi.withProgress(Le,x,ae)},createOutputChannel(x,ae){return li.createOutputChannel(x,ae,Le)},createWebviewPanel(x,ae,ze,st){return Ei.createWebviewPanel(Le,x,ae,ze,st)},createWebviewTextEditorInset(x,ae,ze,st){return(0,Ye.$9F)(Le,"editorInsets"),Kt.createWebviewEditorInset(x,ae,ze,st,Le)},createTerminal(x,ae,ze){return typeof x=="object"?"pty"in x?St.createExtensionTerminal(x):St.createTerminalFromOptions(x):St.createTerminal(x,ae,ze)},registerTerminalLinkProvider(x){return St.registerLinkProvider(x)},registerTerminalProfileProvider(x,ae){return St.registerProfileProvider(Le,x,ae)},registerTerminalQuickFixProvider(x,ae){return(0,Ye.$9F)(Le,"terminalQuickFixProvider"),St.registerTerminalQuickFixProvider(x,Le.identifier.value,ae)},registerTreeDataProvider(x,ae){return yt.registerTreeDataProvider(x,ae,Le)},createTreeView(x,ae){return yt.createTreeView(x,ae,Le)},registerWebviewPanelSerializer:(x,ae)=>Ei.registerWebviewPanelSerializer(Le,x,ae),registerCustomEditorProvider:(x,ae,ze={})=>Hi.registerCustomEditorProvider(Le,x,ae,ze),registerFileDecorationProvider(x){return Ht.registerFileDecorationProvider(x,Le)},registerUriHandler(x){return Yt.registerUriHandler(Le,x)},createQuickPick(){return $i.createQuickPick(Le)},createInputBox(){return $i.createInputBox(Le)},get activeColorTheme(){return yi.activeColorTheme},onDidChangeActiveColorTheme(x,ae,ze){return et(yi.onDidChangeActiveColorTheme)(x,ae,ze)},registerWebviewViewProvider(x,ae,ze){return Ki.registerWebviewViewProvider(Le,x,ae,ze?.webviewOptions)},get activeNotebookEditor(){return se.activeNotebookEditor},onDidChangeActiveNotebookEditor(x,ae,ze){return et(se.onDidChangeActiveNotebookEditor)(x,ae,ze)},get visibleNotebookEditors(){return se.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return et(se.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(x,ae,ze){return et(Ee.onDidChangeNotebookEditorSelection)(x,ae,ze)},onDidChangeNotebookEditorVisibleRanges(x,ae,ze){return et(Ee.onDidChangeNotebookEditorVisibleRanges)(x,ae,ze)},showNotebookDocument(x,ae){return se.showNotebookDocument(x,ae)},registerExternalUriOpener(x,ae,ze){return(0,Ye.$9F)(Le,"externalUriOpener"),Gi.registerExternalUriOpener(Le.identifier,x,ae,ze)},registerProfileContentHandler(x,ae){return(0,Ye.$9F)(Le,"profileContentHandlers"),gn.registerProfileContentHandler(Le,x,ae)},registerQuickDiffProvider(x,ae,ze,st){return(0,Ye.$9F)(Le,"quickDiffProvider"),Pi.registerQuickDiffProvider(pt(x),ae,ze,st)},get tabGroups(){return oi.tabGroups},registerShareProvider(x,ae){return(0,Ye.$9F)(Le,"shareProvider"),Mi.registerShareProvider(pt(x),ae)}},an={get rootPath(){return Rt.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(x){throw new O.$9("rootPath")},getWorkspaceFolder(x){return mt.getWorkspaceFolder(x)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(x){throw new O.$9("name")},get workspaceFile(){return mt.workspaceFile},set workspaceFile(x){throw new O.$9("workspaceFile")},updateWorkspaceFolders:(x,ae,...ze)=>mt.updateWorkspaceFolders(Le,x,ae||0,...ze),onDidChangeWorkspaceFolders:function(x,ae,ze){return et(mt.onDidChangeWorkspace)(x,ae,ze)},asRelativePath:(x,ae)=>mt.getRelativePath(x,ae),findFiles:(x,ae,ze,st)=>mt.findFiles(x,ae,ze,Le.identifier,st),findFiles2:(x,ae,ze)=>((0,Ye.$9F)(Le,"findFiles2"),mt.findFiles2(x,ae,Le.identifier,ze)),findTextInFiles:(x,ae,ze,st)=>{(0,Ye.$9F)(Le,"findTextInFiles");let bt,Nt;return typeof ae=="object"?(bt=ae,Nt=ze):(bt={},Nt=ae,st=ze),mt.findTextInFiles(x,bt||{},Nt,Le.identifier,st)},save:x=>mt.save(x),saveAs:x=>mt.saveAs(x),saveAll:x=>mt.saveAll(x),applyEdit(x,ae){return _i.applyWorkspaceEdit(x,Le,ae)},createFileSystemWatcher:(x,ae,ze,st)=>{let bt;return typeof ae=="boolean"?bt={ignoreCreateEvents:!!ae,ignoreChangeEvents:!!ze,ignoreDeleteEvents:!!st,correlate:!1}:ae&&((0,Ye.$9F)(Le,"createFileSystemWatcher"),bt={...ae,correlate:!0}),gi.createFileSystemWatcher(mt,Le,x,bt)},get textDocuments(){return At.getAllDocumentData().map(x=>x.document)},set textDocuments(x){throw new O.$9("textDocuments")},openTextDocument(x){let ae;const ze=x;if(typeof x=="string")ae=Promise.resolve(d.URI.file(x));else if(d.URI.isUri(x))ae=Promise.resolve(x);else if(!ze||typeof ze=="object")ae=At.createDocumentData(ze);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ae.then(st=>(st.scheme===A.Schemas.vscodeRemote&&!st.authority&&Rt.report("workspace.openTextDocument",Le,"A URI of 'vscode-remote' scheme requires an authority."),At.ensureDocumentData(st).then(bt=>bt.document)))},onDidOpenTextDocument:(x,ae,ze)=>et(At.onDidAddDocument)(x,ae,ze),onDidCloseTextDocument:(x,ae,ze)=>et(At.onDidRemoveDocument)(x,ae,ze),onDidChangeTextDocument:(x,ae,ze)=>et(At.onDidChangeDocument)(x,ae,ze),onDidSaveTextDocument:(x,ae,ze)=>et(At.onDidSaveDocument)(x,ae,ze),onWillSaveTextDocument:(x,ae,ze)=>et(Oe.getOnWillSaveTextDocumentEvent(Le))(x,ae,ze),get notebookDocuments(){return se.notebookDocuments.map(x=>x.apiNotebook)},async openNotebookDocument(x,ae){let ze;if(d.URI.isUri(x))ze=x,await se.openNotebookDocument(x);else if(typeof x=="string")ze=d.URI.revive(await se.createNotebookDocument({viewType:x,content:ae}));else throw new Error("Invalid arguments");return se.getNotebookDocument(ze).apiNotebook},onDidSaveNotebookDocument(x,ae,ze){return et(Q.onDidSaveNotebookDocument)(x,ae,ze)},onDidChangeNotebookDocument(x,ae,ze){return et(Q.onDidChangeNotebookDocument)(x,ae,ze)},onWillSaveNotebookDocument(x,ae,ze){return et(He.getOnWillSaveNotebookDocumentEvent(Le))(x,ae,ze)},get onDidOpenNotebookDocument(){return et(se.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return et(se.onDidCloseNotebookDocument)},registerNotebookSerializer(x,ae,ze,st){return se.registerNotebookSerializer(Le,x,ae,ze,(0,Ye.$8F)(Le,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(x,ae,ze)=>et(en.onDidChangeConfiguration)(x,ae,ze),getConfiguration(x,ae){return ae=arguments.length===1?void 0:ae,en.getConfiguration(x,ae,Le)},registerTextDocumentContentProvider(x,ae){return we.registerTextDocumentContentProvider(x,ae)},registerTaskProvider:(x,ae)=>(Rt.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),ri.registerTaskProvider(Le,x,ae)),registerFileSystemProvider(x,ae,ze){return(0,N.$Rc)(Ci.registerFileSystemProvider(Le,x,ae,ze),ii.addFileSystemProvider(x,ae,ze))},get fs(){return ii.value},registerFileSearchProvider:(x,ae)=>((0,Ye.$9F)(Le,"fileSearchProvider"),ui.registerFileSearchProvider(x,ae)),registerTextSearchProvider:(x,ae)=>((0,Ye.$9F)(Le,"textSearchProvider"),ui.registerTextSearchProvider(x,ae)),registerAITextSearchProvider:(x,ae)=>((0,Ye.$9F)(Le,"aiTextSearchProvider"),(0,Ye.$9F)(Le,"textSearchProvider"),ui.registerAITextSearchProvider(x,ae)),registerRemoteAuthorityResolver:(x,ae)=>((0,Ye.$9F)(Le,"resolvers"),Ft.registerRemoteAuthorityResolver(x,ae)),registerResourceLabelFormatter:x=>((0,Ye.$9F)(Le,"resolvers"),qi.$registerResourceLabelFormatter(x)),getRemoteExecServer:x=>((0,Ye.$9F)(Le,"resolvers"),Ft.getRemoteExecServer(x)),onDidCreateFiles:(x,ae,ze)=>et(gi.onDidCreateFile)(x,ae,ze),onDidDeleteFiles:(x,ae,ze)=>et(gi.onDidDeleteFile)(x,ae,ze),onDidRenameFiles:(x,ae,ze)=>et(gi.onDidRenameFile)(x,ae,ze),onWillCreateFiles:(x,ae,ze)=>et(gi.getOnWillCreateFileEvent(Le))(x,ae,ze),onWillDeleteFiles:(x,ae,ze)=>et(gi.getOnWillDeleteFileEvent(Le))(x,ae,ze),onWillRenameFiles:(x,ae,ze)=>et(gi.getOnWillRenameFileEvent(Le))(x,ae,ze),openTunnel:x=>((0,Ye.$9F)(Le,"tunnels"),Tt.openTunnel(Le,x).then(ae=>{if(!ae)throw new Error("cannot open tunnel");return ae})),get tunnels(){return(0,Ye.$9F)(Le,"tunnels"),Tt.getTunnels()},onDidChangeTunnels:(x,ae,ze)=>((0,Ye.$9F)(Le,"tunnels"),et(Tt.onDidChangeTunnels)(x,ae,ze)),registerPortAttributesProvider:(x,ae)=>((0,Ye.$9F)(Le,"portsAttributes"),Tt.registerPortsAttributesProvider(x,ae)),registerTunnelProvider:(x,ae)=>((0,Ye.$9F)(Le,"tunnelFactory"),Tt.registerTunnelProvider(x,ae)),registerTimelineProvider:(x,ae)=>((0,Ye.$9F)(Le,"timeline"),Ri.registerTimelineProvider(x,ae,Le.identifier,wt.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:x=>((0,Ye.$9F)(Le,"workspaceTrust"),mt.requestWorkspaceTrust(x)),onDidGrantWorkspaceTrust:(x,ae,ze)=>et(mt.onDidGrantWorkspaceTrust)(x,ae,ze),registerEditSessionIdentityProvider:(x,ae)=>((0,Ye.$9F)(Le,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(x,ae)),onWillCreateEditSessionIdentity:(x,ae,ze)=>((0,Ye.$9F)(Le,"editSessionIdentityProvider"),et(mt.getOnWillCreateEditSessionIdentityEvent(Le))(x,ae,ze)),registerCanonicalUriProvider:(x,ae)=>((0,Ye.$9F)(Le,"canonicalUriProvider"),mt.registerCanonicalUriProvider(x,ae)),getCanonicalUri:(x,ae,ze)=>((0,Ye.$9F)(Le,"canonicalUriProvider"),mt.provideCanonicalUri(x,ae,ze))},cn={get inputBox(){return Rt.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),wi.getLastInputBox(Le)},createSourceControl(x,ae,ze){return wi.createSourceControl(Le,x,ae,ze)}},Ti={createCommentController(x,ae){return Vi.createCommentController(Le,x,ae)}},un={get activeDebugSession(){return kt.activeDebugSession},get activeDebugConsole(){return kt.activeDebugConsole},get breakpoints(){return kt.breakpoints},get activeStackItem(){if((0,Ye.$8F)(Le,"debugFocus"))return kt.activeStackItem},registerDebugVisualizationProvider(x,ae){return(0,Ye.$9F)(Le,"debugVisualization"),kt.registerDebugVisualizationProvider(Le,x,ae)},registerDebugVisualizationTreeProvider(x,ae){return(0,Ye.$9F)(Le,"debugVisualization"),kt.registerDebugVisualizationTree(Le,x,ae)},onDidStartDebugSession(x,ae,ze){return et(kt.onDidStartDebugSession)(x,ae,ze)},onDidTerminateDebugSession(x,ae,ze){return et(kt.onDidTerminateDebugSession)(x,ae,ze)},onDidChangeActiveDebugSession(x,ae,ze){return et(kt.onDidChangeActiveDebugSession)(x,ae,ze)},onDidReceiveDebugSessionCustomEvent(x,ae,ze){return et(kt.onDidReceiveDebugSessionCustomEvent)(x,ae,ze)},onDidChangeBreakpoints(x,ae,ze){return et(kt.onDidChangeBreakpoints)(x,ae,ze)},onDidChangeActiveStackItem(x,ae,ze){return(0,Ye.$9F)(Le,"debugFocus"),et(kt.onDidChangeActiveStackItem)(x,ae,ze)},registerDebugConfigurationProvider(x,ae,ze){return kt.registerDebugConfigurationProvider(x,ae,ze||Vt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(x,ae){return kt.registerDebugAdapterDescriptorFactory(Le,x,ae)},registerDebugAdapterTrackerFactory(x,ae){return kt.registerDebugAdapterTrackerFactory(x,ae)},startDebugging(x,ae,ze){return!ze||typeof ze=="object"&&"configuration"in ze?kt.startDebugging(x,ae,{parentSession:ze}):kt.startDebugging(x,ae,ze||{})},stopDebugging(x){return kt.stopDebugging(x)},addBreakpoints(x){return kt.addBreakpoints(x)},removeBreakpoints(x){return kt.removeBreakpoints(x)},asDebugSourceUri(x,ae){return kt.asDebugSourceUri(x,ae)}},ln={registerTaskProvider:(x,ae)=>ri.registerTaskProvider(Le,x,ae),fetchTasks:x=>ri.fetchTasks(x),executeTask:x=>ri.executeTask(Le,x),get taskExecutions(){return ri.taskExecutions},onDidStartTask:(x,ae,ze)=>et(ri.onDidStartTask)(x,ae,ze),onDidEndTask:(x,ae,ze)=>et(ri.onDidEndTask)(x,ae,ze),onDidStartTaskProcess:(x,ae,ze)=>et(ri.onDidStartTaskProcess)(x,ae,ze),onDidEndTaskProcess:(x,ae,ze)=>et(ri.onDidEndTaskProcess)(x,ae,ze)},hn={createNotebookController(x,ae,ze,st,bt){return Be.createNotebookController(Le,x,ae,ze,st,(0,Ye.$8F)(Le,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(x,ae)=>se.registerNotebookCellStatusBarItemProvider(Le,x,ae),createRendererMessaging(x){return Xe.createRendererMessaging(Le,x)},createNotebookControllerDetectionTask(x){return(0,Ye.$9F)(Le,"notebookKernelSource"),Be.createNotebookControllerDetectionTask(Le,x)},registerKernelSourceActionProvider(x,ae){return(0,Ye.$9F)(Le,"notebookKernelSource"),Be.registerKernelSourceActionProvider(Le,x,ae)},onDidChangeNotebookCellExecutionState(x,ae,ze){return(0,Ye.$9F)(Le,"notebookCellExecutionState"),et(Be.onDidChangeNotebookCellExecutionState)(x,ae,ze)}},vn={t(...x){if(typeof x[0]=="string"){const ae=x.shift(),ze=!x||typeof x[0]!="object"?x:x[0];return di.getMessage(Le.identifier.value,{message:ae,args:ze})}return di.getMessage(Le.identifier.value,x[0])},get bundle(){return di.getBundle(Le.identifier.value)},get uri(){return di.getBundleUri(Le.identifier.value)}},bn={_version:1,registerInteractiveEditorSessionProvider(x,ae){return(0,Ye.$9F)(Le,"interactive"),mn.registerProvider(Le,x,ae)},registerInteractiveSessionProvider(x,ae){return(0,Ye.$9F)(Le,"interactive"),Ji.registerChatProvider(Le,x,ae)},transferChatSession(x,ae){return(0,Ye.$9F)(Le,"interactive"),Ji.transferChatSession(x,ae)}},dn={getRelatedInformation(x,ae){return(0,Ye.$9F)(Le,"aiRelatedInformation"),Qi.getRelatedInformation(Le,x,ae)},registerRelatedInformationProvider(x,ae){return(0,Ye.$9F)(Le,"aiRelatedInformation"),Qi.registerRelatedInformationProvider(Le,x,ae)},registerEmbeddingVectorProvider(x,ae){return(0,Ye.$9F)(Le,"aiRelatedInformation"),Zi.registerEmbeddingVectorProvider(Le,x,ae)}},fn={registerChatResponseProvider(x,ae,ze){return(0,Ye.$9F)(Le,"chatProvider"),Dt.registerLanguageModel(Le,x,ae,ze)},registerChatVariableResolver(x,ae,ze){return(0,Ye.$9F)(Le,"chatVariableResolver"),Oi.registerVariableResolver(Le,x,ae,ze)},registerMappedEditsProvider(x,ae){return(0,Ye.$9F)(Le,"mappedEditsProvider"),ut.registerMappedEditsProvider(Le,x,ae)},createChatParticipant(x,ae){return(0,Ye.$9F)(Le,"chatParticipant"),Ai.createChatAgent(Le,x,ae)}},Li={get languageModels(){return(0,Ye.$9F)(Le,"languageModels"),Dt.getLanguageModelIds()},onDidChangeLanguageModels:(x,ae,ze)=>((0,Ye.$9F)(Le,"languageModels"),Dt.onDidChangeProviders(x,ae,ze)),sendChatRequest(x,ae,ze,st){return(0,Ye.$9F)(Le,"languageModels"),Dt.sendChatRequest(Le,x,ae,ze,st)}},ji={registerSpeechProvider(x,ae){return(0,Ye.$9F)(Le,"speech"),Yi.registerProvider(Le.identifier,x,ae)}};return{version:vt.version,ai:dn,authentication:tn,commands:nn,comments:Ti,chat:fn,debug:un,env:Ni,extensions:sn,interactive:bn,l10n:vn,languages:on,lm:Li,notebooks:hn,scm:cn,speech:ji,tasks:ln,tests:rn,window:pn,workspace:an,Breakpoint:Me.$mN,TerminalOutputAnchor:Me.TerminalOutputAnchor,ChatResultFeedbackKind:Me.ChatResultFeedbackKind,ChatVariableLevel:Me.ChatVariableLevel,ChatCompletionItem:Me.$gO,CallHierarchyIncomingCall:Me.$KM,CallHierarchyItem:Me.$JM,CallHierarchyOutgoingCall:Me.$LM,CancellationError:O.$5,CancellationTokenSource:I.$ee,CandidatePortSource:i.CandidatePortSource,CodeAction:Me.$GM,CodeActionKind:Me.$HM,CodeActionTriggerKind:Me.CodeActionTriggerKind,CodeLens:Me.$MM,Color:Me.$ZM,ColorInformation:Me.$1M,ColorPresentation:Me.$2M,ColorThemeKind:Me.ColorThemeKind,CommentMode:Me.CommentMode,CommentState:Me.CommentState,CommentThreadCollapsibleState:Me.CommentThreadCollapsibleState,CommentThreadState:Me.CommentThreadState,CommentThreadApplicability:Me.CommentThreadApplicability,CompletionItem:Me.$TM,CompletionItemKind:Me.CompletionItemKind,CompletionItemTag:Me.CompletionItemTag,CompletionList:Me.$UM,CompletionTriggerKind:Me.CompletionTriggerKind,ConfigurationTarget:Me.ConfigurationTarget,CustomExecution:Me.$0M,DebugAdapterExecutable:Me.$qN,DebugAdapterInlineImplementation:Me.$tN,DebugAdapterNamedPipeServer:Me.$sN,DebugAdapterServer:Me.$rN,DebugConfigurationProviderTriggerKind:Vt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Me.DebugConsoleMode,DebugVisualization:Me.$JN,DecorationRangeBehavior:Me.DecorationRangeBehavior,Diagnostic:Me.$AM,DiagnosticRelatedInformation:Me.$zM,DiagnosticSeverity:Me.DiagnosticSeverity,DiagnosticTag:Me.DiagnosticTag,Disposable:Me.$mM,DocumentHighlight:Me.$CM,DocumentHighlightKind:Me.DocumentHighlightKind,MultiDocumentHighlight:Me.$DM,DocumentLink:Me.$YM,DocumentSymbol:Me.$FM,EndOfLine:Me.EndOfLine,EnvironmentVariableMutatorType:Me.EnvironmentVariableMutatorType,EvaluatableExpression:Me.$wN,InlineValueText:Me.$xN,InlineValueVariableLookup:Me.$yN,InlineValueEvaluatableExpression:Me.$zN,InlineCompletionTriggerKind:Me.InlineCompletionTriggerKind,EventEmitter:P.$7d,ExtensionKind:Me.ExtensionKind,ExtensionMode:Me.ExtensionMode,ExternalUriOpenerPriority:Me.ExternalUriOpenerPriority,FileChangeType:Me.FileChangeType,FileDecoration:Me.$LN,FileDecoration2:Me.$LN,FileSystemError:Me.$CN,FileType:f.FileType,FilePermission:f.FilePermission,FoldingRange:Me.$DN,FoldingRangeKind:Me.FoldingRangeKind,FunctionBreakpoint:Me.$oN,InlineCompletionItem:Me.$VM,InlineCompletionList:Me.$WM,Hover:Me.$BM,IndentAction:E.IndentAction,Location:Me.$yM,MarkdownString:Me.$NM,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:Me.$OM,PortAutoForwardAction:Me.PortAutoForwardAction,Position:Me.$nM,ProcessExecution:Me.$8M,ProgressLocation:Me.ProgressLocation,QuickInputButtons:Me.$KN,Range:Me.$oM,RelativePattern:Me.$kN,Selection:Me.$pM,SelectionRange:Me.$IM,SemanticTokens:Me.$GN,SemanticTokensBuilder:Me.$FN,SemanticTokensEdit:Me.$HN,SemanticTokensEdits:Me.$IN,SemanticTokensLegend:Me.$EN,ShellExecution:Me.$9M,ShellQuoting:Me.ShellQuoting,SignatureHelp:Me.$QM,SignatureHelpTriggerKind:Me.SignatureHelpTriggerKind,SignatureInformation:Me.$PM,SnippetString:Me.$xM,SourceBreakpoint:Me.$nN,StandardTokenType:Me.StandardTokenType,StatusBarAlignment:Me.StatusBarAlignment,SymbolInformation:Me.$EM,SymbolKind:Me.SymbolKind,SymbolTag:Me.SymbolTag,Task:Me.$$M,TaskGroup:Me.$7M,TaskPanelKind:Me.TaskPanelKind,TaskRevealKind:Me.TaskRevealKind,TaskScope:Me.TaskScope,TerminalLink:Me.$3M,TerminalQuickFixTerminalCommand:Me.$5M,TerminalQuickFixOpener:Me.$4M,TerminalLocation:Me.TerminalLocation,TerminalProfile:Me.$6M,TerminalExitReason:Me.TerminalExitReason,TextDocumentSaveReason:Me.TextDocumentSaveReason,TextEdit:Me.$tM,SnippetTextEdit:Me.$vM,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:Me.TextEditorLineNumbersStyle,TextEditorRevealType:Me.TextEditorRevealType,TextEditorSelectionChangeKind:Me.TextEditorSelectionChangeKind,SyntaxTokenType:Me.SyntaxTokenType,TextDocumentChangeReason:Me.TextDocumentChangeReason,ThemeColor:Me.$jN,ThemeIcon:Me.$iN,TreeItem:Me.$_M,TreeItemCheckboxState:Me.TreeItemCheckboxState,TreeItemCollapsibleState:Me.TreeItemCollapsibleState,TypeHierarchyItem:Me.$7N,UIKind:ai.UIKind,Uri:d.URI,ViewColumn:Me.ViewColumn,WorkspaceEdit:Me.$wM,DocumentPasteTriggerKind:Me.DocumentPasteTriggerKind,DocumentDropEdit:Me.$fN,DocumentPasteEditKind:Me.$gN,DocumentPasteEdit:Me.$hN,InlayHint:Me.$SM,InlayHintLabelPart:Me.$RM,InlayHintKind:Me.InlayHintKind,RemoteAuthorityResolverError:Me.$sM,ResolvedAuthority:Me.$qM,ManagedResolvedAuthority:Me.$rM,SourceControlInputBoxValidationType:Me.SourceControlInputBoxValidationType,ExtensionRuntime:Me.ExtensionRuntime,TimelineItem:Me.$VN,NotebookRange:Me.$NN,NotebookCellKind:Me.NotebookCellKind,NotebookCellExecutionState:Me.NotebookCellExecutionState,NotebookCellData:Me.$ON,NotebookData:Me.$PN,NotebookRendererScript:Me.$TN,NotebookCellStatusBarAlignment:Me.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Me.NotebookEditorRevealType,NotebookCellOutput:Me.$RN,NotebookCellOutputItem:Me.$QN,NotebookCellStatusBarItem:Me.$SN,NotebookControllerAffinity:Me.NotebookControllerAffinity,NotebookControllerAffinity2:Me.NotebookControllerAffinity2,NotebookEdit:Me.$uM,NotebookKernelSourceAction:Me.$UN,NotebookVariablesRequestKind:Me.NotebookVariablesRequestKind,PortAttributes:Me.$XN,LinkedEditingRanges:Me.$WN,TestResultState:Me.TestResultState,TestRunRequest:Me.$YN,TestMessage:Me.$ZN,TestTag:Me.$1N,TestRunProfileKind:Me.TestRunProfileKind,TextSearchCompleteMessageType:ei.TextSearchCompleteMessageType,DataTransfer:Me.$eN,DataTransferItem:Me.$aN,CoveredCount:Me.$2N,FileCoverage:Me.$3N,StatementCoverage:Me.$4N,BranchCoverage:Me.$5N,DeclarationCoverage:Me.$6N,FunctionCoverage:Me.$6N,WorkspaceTrustState:Me.WorkspaceTrustState,LanguageStatusSeverity:Me.LanguageStatusSeverity,QuickPickItemKind:Me.QuickPickItemKind,InputBoxValidationSeverity:Me.InputBoxValidationSeverity,TabInputText:Me.$8N,TabInputTextDiff:Me.$9N,TabInputTextMerge:Me.$0N,TabInputCustom:Me.$$N,TabInputNotebook:Me.$aO,TabInputNotebookDiff:Me.$bO,TabInputWebview:Me.$_N,TabInputTerminal:Me.$cO,TabInputInteractiveWindow:Me.$dO,TabInputChat:Me.$eO,TabInputTextMultiDiff:Me.$fO,TelemetryTrustedValue:s.$4o,LogLevel:r.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Me.InteractiveSessionVoteDirection,ChatCopyKind:Me.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Me.InteractiveEditorResponseFeedbackKind,StackFrame:Me.$uN,Thread:Me.$vN,RelatedInformationType:Me.RelatedInformationType,SpeechToTextStatus:Me.SpeechToTextStatus,PartialAcceptTriggerKind:Me.PartialAcceptTriggerKind,KeywordRecognitionStatus:Me.KeywordRecognitionStatus,ChatResponseMarkdownPart:Me.$hO,ChatResponseFileTreePart:Me.$iO,ChatResponseAnchorPart:Me.$jO,ChatResponseProgressPart:Me.$kO,ChatResponseReferencePart:Me.$mO,ChatResponseCommandButtonPart:Me.$lO,ChatRequestTurn:Me.$nO,ChatResponseTurn:Me.$oO,ChatLocation:Me.ChatLocation,LanguageModelChatSystemMessage:Me.$pO,LanguageModelChatUserMessage:Me.$qO,LanguageModelChatAssistantMessage:Me.$rO,LanguageModelSystemMessage:Me.$pO,LanguageModelUserMessage:Me.$qO,LanguageModelAssistantMessage:Me.$rO,LanguageModelError:Me.$sO,NewSymbolName:Me.$BN,NewSymbolNameTag:Me.NewSymbolNameTag,InlineEdit:Me.$tO,InlineEditTriggerKind:Me.InlineEditTriggerKind}}}}),define(Ce[298],Pe([1,0,54,115,36,110,37,31,67,66,118,120,121,82,86,78,109,63,44,81,61,65,236,13,119,79,80,84,88]),function($e,e,I,O,P,N,A,m,d,k,F,E,u,b,f,r,o,s,n,i,a,h,t,v,c,$,w,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$gs)($.$Vjc,$.$Ujc,1),(0,I.$gs)(v.$Pj,t.$8kc,1),(0,I.$gs)(r.$Zic,r.$1ic,1),(0,I.$gs)(m.$2O,m.$1O,0),(0,I.$gs)(p.$0ic,p.$$ic,0),(0,I.$gs)(l.$cjc,l.$djc,0),(0,I.$gs)(A.$pjc,A.$njc,0),(0,I.$gs)(s.$rjc,s.$qjc,0),(0,I.$gs)(E.$6jc,E.$0jc,0),(0,I.$gs)(N.$_jc,N.$$jc,0),(0,I.$gs)(d.$QO,d.$PO,0),(0,I.$gs)(w.$Wjc,w.$Xjc,0),(0,I.$gs)(n.$4ic,n.$3ic,0),(0,I.$gs)(O.$Fkc,O.$Ekc,1),(0,I.$gs)(u.$pkc,u.$qkc,0),(0,I.$gs)(b.$Kjc,b.$Jjc,0),(0,I.$gs)(F.$Skc,F.$Rkc,0),(0,I.$gs)(k.$Njc,k.$Qjc,0),(0,I.$gs)(f.$GBb,f.$HBb,0),(0,I.$gs)(o.$6kc,o.$5kc,0),(0,I.$gs)(P.$mjc,P.$ljc,0),(0,I.$gs)(i.$Sjc,i.$Rjc,0),(0,I.$gs)(a.$ZO,a.$WO,0),(0,I.$gs)(h.$Bjc,h.$Cjc,0),(0,I.$gs)(c.$4jc,c.$5jc,0)}),define(Ce[299],Pe([1,0,297,38,2,294,7,11,242]),function($e,e,I,O,P,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fnc=void 0;class k extends N.$$kc{j(){}getModule(b,f){for(const r of this.b){const o=r(b);if(o){b=o;break}}if(this.a.has(b))return this.a.get(b).load(b,f,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class F extends O.$Zjc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(d.$enc);const b=this.h.invokeFunction(I.$7kc);this.r=this.h.createInstance(k,b,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(b){return b.browser}async xb(b,f,r){f=f.with({path:E(f.path,".js")});const o=b?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const s=P.URI.revive(await this.C.$asBrowserUri(f)),n=await fetch(s.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),n.status!==200)throw new Error(n.statusText);const i=await n.text(),a=`${f.toString(!0)}#vscode-extension`,h=`${i}
//# sourceURL=${a}`;let t;try{t=new Function("module","exports","require",h)}catch(w){throw console.error(o?`Loading code for extension ${o} failed: ${w.message}`:`Loading code failed: ${w.message}`),console.error(`${f.toString(!0)}${typeof w.line=="number"?` line ${w.line}`:""}${typeof w.column=="number"?` column ${w.column}`:""}`),console.error(w),w}b&&await this.w.initializeLocalizedMessages(b);const v={},c={exports:v},$=w=>{const p=this.r.getModule(w,f);if(p===void 0)throw new Error(`Cannot load module '${w}'`);return p};try{return r.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),t(c,v,$),c.exports!==v?c.exports:v}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),r.codeLoadingStop()}}async $setRemoteEnvironment(b){}async Bb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const f=Date.now()+b;for(;Date.now()<f&&!("__jsDebugIsReady"in globalThis);)await(0,m.$jh)(10)}}e.$fnc=F;function E(u,b){return u.endsWith(b)?u:u+b}}),define(Ce[300],Pe([1,0,70,54,13,38,205,85,299]),function($e,e,I,O,P,N,A,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,O.$gs)(P.$Oj,new I.$fi(A.$0kc,[!0],!0)),(0,O.$gs)(N.$1jc,d.$fnc,0),(0,O.$gs)(m.$sjc,m.$tjc,0)}),define(Ce[306],Pe([1,0,23,5,77,295,244,19,89,12,2,298,300]),function($e,e,I,O,P,N,A,m,d,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=h;const E=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(t){return/^(file|vscode-remote):/i.test(t)}const f=fetch.bind(self);function r(t){self.fetch=async function(v,c){return v instanceof Request||b(String(v))&&(v=(await t(F.URI.parse(String(v)))).toString(!0)),f(v,c)},self.XMLHttpRequest=class extends XMLHttpRequest{open(v,c,$,w,p){(async()=>(b(c.toString())&&(c=(await t(F.URI.parse(c.toString()))).toString(!0)),super.open(v,c,$??!0,w,p)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(v,c){if(/^file:/i.test(v.toString()))v=k.$Cg.uriToBrowserUri(F.URI.parse(v.toString())).toString(!0);else if(/^vscode-remote:/i.test(v.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const w=`(${function(g){function S(R){return typeof R=="string"||R instanceof URL?String(R).replace(/^file:\/\//i,"vscode-file://vscode-app"):R}const y=fetch.bind(self);self.fetch=function(R,V){return R instanceof Request?y(R,V):y(S(R),V)},self.XMLHttpRequest=class extends XMLHttpRequest{open(R,V,U,q,M){return super.open(R,S(V),U??!0,q,M)}};const C=importScripts.bind(self);self.importScripts=(...R)=>{C(...R.map(S))},C(g)}.toString()}('${v}'))`;c=c||{},c.name=`${name} -> ${c.name||m.$oc(v.toString())}`;const p=new Blob([w],{type:"application/javascript"}),l=URL.createObjectURL(p);return new t(l,c)}}else self.Worker=class extends A.$gnc{constructor(t,v){super(u,t,{name:m.$oc(t.toString()),...v})}};const o=new class{constructor(){this.pid=void 0}exit(t){E()}};class s{constructor(){const v=new MessageChannel,c=new O.$7d;let $=!1;u(v.port2,[v.port2]),v.port1.onmessage=w=>{const{data:p}=w;if(!(p instanceof ArrayBuffer)){console.warn("UNKNOWN data received",p);return}const l=I.$ue.wrap(new Uint8Array(p,0,p.byteLength));if((0,P.$Mm)(l,2)){$=!0,i("received terminate message from renderer");return}c.fire(l)},this.protocol={onMessage:c.event,send:w=>{if(!$){const p=w.buffer.buffer.slice(w.buffer.byteOffset,w.buffer.byteOffset+w.buffer.byteLength);v.port1.postMessage(p,[p])}}}}}function n(t){return new Promise(v=>{const c=t.onMessage($=>{c.dispose();const w=JSON.parse($.toString());t.send((0,P.$Lm)(0)),v({protocol:t,initData:w})});t.send((0,P.$Lm)(1))})}let i=t=>E();function a(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function h(){d.mark("code/extHost/willConnectToRenderer");const t=new s;return{onmessage(v){a(v)&&n(t.protocol).then(c=>{d.mark("code/extHost/didWaitForInitData");const $=new N.$alc(c.protocol,c.initData,o,null,v.data);r(w=>$.asBrowserUri(w)),i=w=>$.terminate(w)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/9ccb0fa738a2f7a1c5328800c9fe18f4dd5b4f8a/core/vs/workbench/api/worker/extensionHostWorker.js.map
